	Short instructions how to run CSC's single processor benchmark
	--------------------------------------------------------------

			CSC_SUITE 2 B (June/1994)



(1) uncompress & untar the file "csc_suite2.tar.Z":

	zcat csc_suite2.tar.Z | tar xf -

(2) Go to root directory:

	cd csc_suite2

(3) Edit files "make.flags" & "build_script".
    Check timers and their "makefile" under "lib/src"

(4) Create new makefiles:

	build_make all

(5) Create run scripts:

	build_script all

(6) Create executables:

	make clean
	make

(7) Run programs:

	run all

	  or individual program

	run RIEMANN

	  and/or specify RUNPATH 

	run -p RUNPATH all
	run -p RUNPATH RIEMANN GRSOS

(8) Collect your results to "logs/`hostname`_$$.log" with

	collect_timings

(9) Check result files "<program>/<program>.out" against
    reference ones "<program>/results/<program>.out".

(10) Fax or e-mail "logs/`hostname`_$$.log" to Sami.Saarinen@csc.fi


Note also that:

- You can get usage of all command scripts (except "collect_timings")
  by typing command name without arguments.

- Source files are always under "<program>/src". So are the programwise
  makefiles. To make individual program, do following steps:

	cd <program>/src
	make
	cd ../..

- Upon execution (the "run" script), all files under "<program>/"
  (except "src/"-directory), are copied to "$TMPDIR". If the run path 
  is given explicitely, then it will be used for run.

- "collect_timings" calculates all the necessary and important
  information CSC, including so called CSCMARKs. Be sure
  that you give these to us!

- result should be verifiable at any time

Note also that you are NOT allowed to modify codes except for
portability. Thus, all optimization must be achieved through
the compiler flags.

Contact-information (only technical questions concerning benchmark):

			Sami Saarinen
			Center for Scietific Computing (CSC)
			P.O.Box 405
			Tietotie 6
			FIN-02101 Espoo
			Finland
			e-mail: Sami.Saarinen@csc.fi  or sbs@csc.fi
			Phone: INT + 358 - 0 - 457 2713
			Fax:   INT + 358 - 0 - 457 2302

      SUBROUTINE ROTAT(COORD,I,J,IX,RIJ,DEL1,IDX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /DERIVS/ DS(16),DG(22),DR(100),TDX(3),TDY(3),TDZ(3)
      COMMON /EXTRA/  G(22),TX(3),TY(3),TZ(3)
      DIMENSION COORD(3,25)
      XD=COORD(1,I)-COORD(1,J)
      YD=COORD(2,I)-COORD(2,J)
      ZD=COORD(3,I)-COORD(3,J)
      RXY=SQRT(XD*XD+YD*YD)
      RYZ=SQRT(YD*YD+ZD*ZD)
      RZX=SQRT(ZD*ZD+XD*XD)
      DO 10 IJK=1,3
         TX(IJK)=0.0D0
         TY(IJK)=0.0D0
         TZ(IJK)=0.0D0
         TDX(IJK)=0.0D0
         TDY(IJK)=0.0D0
         TDZ(IJK)=0.0D0
   10 CONTINUE
      IF(RXY.LT.1.0D-4) THEN
C   MOLECULAR Z AXIS IS PARALLEL TO DIATOMIC Z AXIS
         TX(3)=1.0D0
         IF(ZD.LT.0.0D0) TX(3)=-1.0D0
         TY(2)=1.0D0
         TZ(1)=TX(3)
         IF(IDX.EQ.1) RETURN
         IF(IX.EQ.1) TDX(1)=1.0D0/RIJ
         IF(IX.EQ.2) TDX(2)=1.0D0/RIJ
         IF(IX.EQ.1) TDZ(3)=-1.0D0/RIJ
         IF(IX.EQ.2) TDY(3)=-TX(3)/RIJ
      ELSEIF(RYZ.LT.1.0D-4) THEN
C   MOLECULAR X AXIS IS PARALLEL TO DIATOMIC Z AXIS
         TX(1)=1.0D0
         IF(XD.LT.0.0D0) TX(1)=-1.0D0
         TY(2)=TX(1)
         TZ(3)=1.0D0
         IF(IDX.EQ.1) RETURN
         IF(IX.EQ.2) TDX(2)=1.0D0/RIJ
         IF(IX.EQ.3) TDX(3)=1.0D0/RIJ
         IF(IX.EQ.2) TDY(1)=-1.0D0/RIJ
         IF(IX.EQ.3) TDZ(1)=-TX(1)/RIJ
      ELSEIF(RZX.LT.1.0D-4) THEN
C   MOLECULAR Y AXIS IS PARALLEL TO DIATOMIC Z AXIS
         TX(2)=1.0D0
         IF(YD.LT.0.0D0) TX(2)=-1.0D0
         TY(1)=-TX(2)
         TZ(3)=1.0D0
         IF(IDX.EQ.1) RETURN
         IF(IX.EQ.1) TDX(1)=1.0D0/RIJ
         IF(IX.EQ.3) TDX(3)=1.0D0/RIJ
         IF(IX.EQ.1) TDY(2)=1.0D0/RIJ
         IF(IX.EQ.3) TDZ(2)=-TX(2)/RIJ
      ELSE
         TX(1)=XD/RIJ
         TX(2)=YD/RIJ
         TX(3)=ZD/RIJ
         TZ(3)=RXY/RIJ
         TY(1)=-TX(2)*SIGN(+1.0D0,TX(1))/TZ(3)
         TY(2)=ABS(TX(1)/TZ(3))
         TY(3)=0.0D0
         TZ(1)=-TX(1)*TX(3)/TZ(3)
         TZ(2)=-TX(2)*TX(3)/TZ(3)
         IF(IDX.EQ.1) RETURN
         TERM=DEL1/(RIJ*RIJ)
         IF(IX.EQ.1)THEN
            TDX(1)=1.0D0/RIJ-TX(1)*TERM
            TDX(2)=-TX(2)*TERM
            TDX(3)=-TX(3)*TERM
            TDZ(3)=TX(1)/RXY-TZ(3)*TERM
         ELSEIF(IX.EQ.2) THEN
            TDX(1)=-TX(1)*TERM
            TDX(2)=1.0D0/RIJ-TX(2)*TERM
            TDX(3)=-TX(3)*TERM
            TDZ(3)=TX(2)/RXY-TZ(3)*TERM
         ELSEIF(IX.EQ.3)THEN
            TDX(1)=-TX(1)*TERM
            TDX(2)=-TX(2)*TERM
            TDX(3)=1.0D0/RIJ-TX(3)*TERM
            TDZ(3)=-TZ(3)*TERM
         ENDIF
         TDY(1)=-TDX(2)/TZ(3)+TX(2)*TDZ(3)/TZ(3)**2
         IF(TX(1).LT.0.0D0) TDY(1)=-TDY(1)
         TDY(2)=TDX(1)/TZ(3)-TX(1)*TDZ(3)/TZ(3)**2
         IF(TX(1).LT.0.0D0) TDY(2)=-TDY(2)
         TDY(3)=0.0D0
         TDZ(1)=-TX(3)*TDX(1)/TZ(3)-TX(1)*TDX(3)/TZ(3)
     1 +TX(1)*TX(3)*TDZ(3)/TZ(3)**2
         TDZ(2)=-TX(3)*TDX(2)/TZ(3)-TX(2)*TDX(3)/TZ(3)
     1 +TX(2)*TX(3)*TDZ(3)/TZ(3)**2
      ENDIF
      RETURN
      END

C----------------------------------------------------------------------
C
C  TELL
C
C  WRITE RESULTS
C
C----------------------------------------------------------------------
      SUBROUTINE TELL (D1,D2)
      INTEGER D1,D2
C
C  THE DATA ARE IN COMMON OUT  
C
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)
      REAL
     .    PLANET(3,MAXOBJ),      
     .    OLDPL(2,MAXOBJ)    
      INTEGER
     .    TODAY
      REAL
     .    OUTBUF(MAXDAY,3,MAXOBJ)      
C
      COMMON /OUT/ OUTBUF, PLANET, OLDPL, TODAY
C
C
      INTEGER I,DAY,ND,Y,M,D,WD,K
      CHARACTER*10 NAME(10)
      DATA NAME /'SUN       ',
     .           '          ',
     .           'MERCURY   ',
     .           'VENUS     ',
     .           'MARS      ',
     .           'JUPITER   ',
     .           'SATURN    ',
     .           'URANUS    ',
     .           'NEPTUNE   ',
     .           'PLUTO     ' /
C
      ND=D2-D1
      DO 11 I=1,7,2
         WRITE(*,'('' '',A10)') NAME(I)
         DO 10 DAY=D1,D2,1000
            K=DAY-D1+1
            CALL GREGOR(DAY,Y,M,D,WD)
            WRITE(*,'('' '',I2,''.'',I2,''.'',I4,
     .                '' R.A. = '',F8.3,''  DEC = '',F8.3,
     .                ''  DIST = '',F8.3)')
     .           D,M,Y,     
     .           OUTBUF(K,1,I),OUTBUF(K,2,I),OUTBUF(K,3,I)
 10      CONTINUE
 11   CONTINUE
      RETURN
      END

      SUBROUTINE LOCMIN(M,X,N,P,SSQ,ALF,EFS,ITRAP,ESCF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /NLLSQI/ NCOUNT
      COMMON /KEYWRD/ CONTRL
      DIMENSION X(*), P(*), EFS(*)
      DIMENSION CONST(MAXPAR), XSTOR(MAXPAR), GSTOR(MAXPAR)
      DIMENSION PHI(3),VT(3)
      INTEGER LEFT,RIGHT,CENTER
      CHARACTER*80 KEYWRD, CONTRL
      LOGICAL FIRST, DEBUG, LOWER
      DATA CONST/MAXPAR*1.D0/, FIRST /.TRUE./
************************************************************************
*
*    LOCMIN IS CALLED BY NLLSQ ONLY. IT IS A LINE-SEARCH PROCEDURE FOR
*    LOCATING A MINIMUM IN THE FUNCTION SPACE OF COMPFG.  SEE NLLSQ
*    FOR MORE DETAILS
*
************************************************************************
      IF(FIRST) THEN
         FIRST=.FALSE.
         XMAXM=1.D9
         SCALE=1.D0
         KEYWRD=CONTRL
C
C THE ABOVE LINE IS TO TRY TO PREVENT OVERFLOW IN NLLSQ
C
         EPS=1.D-5
         DEBUG=(INDEX(KEYWRD,'LINMIN') .NE. 0)
         TEE=1.D-2
         YMAXST=0.005D0
         XCRIT=0.0002D0
         MXCNT2=30
         IPRINT=0
         IF(DEBUG)IPRINT=-1
      ENDIF
      XMAXM=1.D-11
      DO 10 I=1,N
   10 XMAXM=MAX(XMAXM,ABS(P(I)))
      XMINM=XMAXM*SCALE
      XMAXM=YMAXST/XMAXM/SCALE
      FIN = SSQ
      LOWER = .FALSE.
      T=ALF
      PHI(1) = SSQ
      VT(1) = 0.0D0
      VT(2) = T/4.0D0
      IF(VT(2).GT.XMAXM) VT(2)=XMAXM
      T = VT(2)
      DO 20 I=1,N
   20 X(I) = X(I)+T*P(I)*CONST(I)*SCALE
      CALL COMPFG(X,.TRUE.,ESCF,.TRUE.,EFS,.TRUE.)
      PHI(2)=DOT(EFS,EFS,N)
      CALL EXCHNG(PHI(2),SQSTOR,ENERGY,ESTOR,X,XSTOR,T,ALFS,N)
      DO 30 I=1,M
   30 GSTOR(I)=EFS(I)
      IF (PHI(1) .LE. PHI(2)) THEN
         VT(3) = -VT(2)
         LEFT = 3
         CENTER = 1
         RIGHT = 2
      ELSE
         VT(3)=2.0D0*VT(2)
         LEFT = 1
         CENTER = 2
         RIGHT = 3
      ENDIF
      TLAST = VT(3)
      T = TLAST-T
      DO 40 I=1,N
   40 X(I) = X(I)+T*P(I)*CONST(I)*SCALE
      FLAST=PHI(2)
      CALL COMPFG(X,.TRUE.,ESCF,.TRUE.,EFS,.TRUE.)
      F=DOT(EFS,EFS,N)
      IF(F.LT.SQSTOR) CALL EXCHNG(F,SQSTOR,ENERGY,ESTOR,X,
     1XSTOR,T,ALFS,N)
      DO 50 I=1,M
   50 GSTOR(I)=EFS(I)
      IF(F.LT.FIN) LOWER = .TRUE.
      NCOUNT = NCOUNT+2
      PHI(3) = F
      IF (IPRINT) 60,70,70
   60 WRITE (6,310) VT(1),PHI(1),VT(2),PHI(2),VT(3),PHI(3)
   70 MXCT=MXCNT2
      DO 250 ICTR=3,MXCT
         XMAXM=XMAXM*3.D0
         ALPHA = VT(2) - VT(3)
         BETA = VT(3) - VT(1)
         GAMMA = VT(1)-VT(2)
         IF(ALPHA.EQ.0.D0)ALPHA=1.D-20
         IF(BETA.EQ.0.D0)BETA=1.D-20
         IF(GAMMA.EQ.0.D0)GAMMA=1.D-20
         ABG =-(PHI(1)*ALPHA+PHI(2)*BETA+PHI(3)*GAMMA)/ALPHA
         ABG=ABG/BETA
         ABG=ABG/GAMMA
         ALPHA=ABG
         BETA = ((PHI(1)-PHI(2))/GAMMA)-ALPHA*(VT(1)+VT(2))
         IF (ALPHA)  80,80,110
   80    IF (PHI(RIGHT) .GT. PHI(LEFT))  GO TO 90
         T = 3.0D0*VT(RIGHT)-2.0D0*VT(CENTER)
         GO TO 100
   90    T = 3.0D0*VT(LEFT)-2.0D0*VT(CENTER)
  100    S=T-TLAST
         T=S+TLAST
         GO TO 150
  110    T = -BETA/(2.0D0*ALPHA)
         S=T-TLAST
         IF (S) 120,260,130
  120    AMDIS=VT(LEFT)-TLAST-XMAXM
         GO TO 140
  130    AMDIS=VT(RIGHT)-TLAST+XMAXM
  140    IF(ABS(S).GT.ABS(AMDIS)) S=AMDIS
         T=S+TLAST
  150    CONTINUE
         IF(ICTR.GT.3.AND.ABS(S*XMINM).LT.XCRIT) THEN
            IF( DEBUG )
     1    WRITE(6,'('' EXIT DUE TO SMALL PROJECTED STEP'')')
            GO TO 260
         ENDIF
         T=S+TLAST
         DO 160 I=1,N
  160    X(I) = X(I)+S*P(I)*CONST(I)*SCALE
         FLAST=F
         CALL COMPFG(X,.TRUE.,ESCF,.TRUE.,EFS,.TRUE.)
         F=DOT(EFS,EFS,N)
         IF(F.LT.SQSTOR) CALL EXCHNG(F,SQSTOR,ENERGY,ESTOR,X,XSTOR,
     1T,ALFS,N)
         DO 170 I=1,M
  170    GSTOR(I)=EFS(I)
         IF(F.LT.FIN) LOWER = .TRUE.
         NCOUNT = NCOUNT+1
         IF (IPRINT) 180,190,190
  180    WRITE (6,320) VT(LEFT),PHI(LEFT),VT(CENTER),PHI(CENTER),
     1  VT(RIGHT),PHI(RIGHT),T,F
  190    CONTINUE
C
C    TEST FOR EXCITED STATES AND POTHOLES
C
         ITRAP=0
         IF(ABS(VT(CENTER)).GT.1.D-10) GOTO 200
         IF(ABS(T)/(ABS(VT(LEFT))+1.D-15).GT.0.3333) GOTO 200
         IF(2.5D0*F-PHI(RIGHT)-PHI(LEFT).LT.0.5D0*PHI(CENTER)) GOTO 200
C
C   WE ARE STUCK ON A FALSE MINIMUM
C
         ITRAP=1
         GOTO 260
  200    CONTINUE
*
* NOW FOR THE MAIN STOPPING TESTS.  LOCMIN WILL STOP IF:-
*     THE ERROR FUNCTION HAS BEEN REDUCED, AND
*     THE RATE OF DROP OF THE ERROR FUNCTION IS LESS THAN 0.5% PER STEP
*     AND
*     (A) THE RATIO OF THE PROPOSED STEP TO THE TOTAL STEP IS LESS THAN
*         EPS,   OR
*     (B) THE LAST DROP IN ERROR FUNCTION WAS LESS THAN 5%OFTHETOTALDROP
*         DURING THIS CALL TO LOCMIN.
*
         IF(DEBUG)WRITE(6,'('' F/FLAST'',F13.6)')F/FLAST
         IF( LOWER  .AND. F/FLAST .GT. 0.995D0) THEN
            IF((ABS(T-TLAST).LE.EPS*ABS(T+TLAST)+TEE)) THEN
               IF( DEBUG )
     1       WRITE(6,'('' EXIT AS STEP IS ABSOLUTELY SMALL '')')
               GO TO 260
            ENDIF
            SUM=MIN(ABS(F-PHI(1)),ABS(F-PHI(2)),ABS(F-PHI(3)))
            SUM2=(FIN-SQSTOR)*0.05D0
            IF(SUM .LT. SUM2) THEN
               IF( DEBUG )
     1        WRITE(6,'('' EXIT DUE TO HAVING REACHED BOTTOM'')')
               GOTO 260
            ENDIF
         ENDIF
         TLAST = T
         IF ((T .GT. VT(RIGHT)) .OR. (T .GT. VT(CENTER) .AND. F .LT.
     1  PHI(CENTER)) .OR. (T .GT. VT(LEFT) .AND. T .LT. VT(CENTER) .AND.
     2  F .GT. PHI(CENTER)))  GO TO 210
         VT(RIGHT) = T
         PHI(RIGHT) = F
         GO TO 220
  210    VT(LEFT) = T
         PHI(LEFT) = F
  220    IF (VT(CENTER) .LT. VT(RIGHT))  GO TO 230
         I = CENTER
         CENTER = RIGHT
         RIGHT = I
  230    IF (VT(LEFT) .LT. VT(CENTER))  GO TO 240
         I = LEFT
         LEFT = CENTER
         CENTER = I
  240    IF (VT(CENTER) .LT. VT(RIGHT))  GO TO 250
         I = CENTER
         CENTER = RIGHT
         RIGHT = I
  250 CONTINUE
  260 CONTINUE
      CALL EXCHNG(SQSTOR,F,ESTOR,ENERGY,XSTOR,X,ALFS,T,N)
      DO 270 I=1,M
  270 EFS(I)=GSTOR(I)
      SSQ=(F)
      ALF=T
      IF (T) 280,300,300
  280 T = -T
      DO 290 I=1,N
  290 P(I) = -P(I)
  300 CONTINUE
      ALF=T
      RETURN
  310 FORMAT(' ---LOCMIN'/5X,'LEFT   ...',2F19.6/5X,'CENTER ...',
     1  2F19.6/5X,'RIGHT  ...',2F19.6/' ')
  320 FORMAT(5X,'LEFT   ...',2F19.6/5X,'CENTER ...',2F19.6/5X,
     1  'RIGHT  ...',2F19.6/5X,'NEW    ...',2F19.6/' ')
      END

      SUBROUTINE ECHECK(A,ZK,YK,N,EIGV)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),ZK(N),YK(N)
      EXTERNAL DOTVEC
C     
      CALL MATVEC(A,ZK,N,YK)
      CALL ADDVEC(YK,ZK,N,-EIGV,YK)
      VECLEN=DSQRT(DOTVEC(YK,YK,N))
      WRITE(6,*)'**ECHECK:  RESIDUAL VECTOR LENGTH=',VECLEN
      WRITE(6,*)
      END

      SUBROUTINE STEPFX(JDIM,KDIM,Q,S,PRESS,SNDSP,XY,XYJ,DS,
     *                    COEF2,COEF4,UU,CC,WORK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION S(JDIM,KDIM,4),XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION DS(JDIM,KDIM)
C
      DIMENSION COEF2(JDIM,KDIM),COEF4(JDIM,KDIM)
      DIMENSION UU(JDIM,KDIM),CC(JDIM,KDIM)
C
      DIMENSION WORK(JDIM,KDIM,10)
C
C  NOTE : D USED FOR VECTORIZATION
C
      DTD   = DT * THETAD /(1. + PHIDT)
      HD    = 0.5*DTD
C  
C  XI DIRECTION
C
C  FILL MATRIX FOR INVERSION FOR DIAGONAL IN XI
C
C  SET SWITCHES FOR EIGENVALUES
C
C  DO FIRST TWO AT THE SAME TIME SINCE THEY HAVE THE SAME COEFFICIENTS
C
         DO 300 N = 2,4
            IF ( N .EQ. 2) SN = 0.
            IF ( N .EQ. 3) SN = 1.
            IF ( N .EQ. 4) SN = -1.
C
         DO 210 J = JLOW,JUP
         JP1 = JPLUS(J)
         JM1 = JMINU (J)
         JP2 = JPLUS(JP1)
         JM2 = JMINU (JM1)
            DO 212 K = KLOW,KUP
            C2M = COEF2(JM1,K)*DTD
            C4M = COEF4(JM1,K)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1) =  XYJ(JM2,K)*C4M
            WORK(J,K,2) = -(C2M + 3.*C4M + C4)*XYJ(JM1,K)
            WORK(J,K,3) = XYJ(J,K)*(C2M+3.*C4M+C2+3.*C4)
            WORK(J,K,4) = -(C2 + 3.*C4 + C4M)*XYJ(JP1,K)
            WORK(J,K,5) = XYJ(JP2,K)*C4
212         CONTINUE
210       CONTINUE
C
            IF(.NOT.PERIDC  )THEN
         J = JLOW
         JP1 = JPLUS(J)
         JM1 = JMINU (J)
         JP2 = JPLUS(JP1)
            DO 220 K = KLOW,KUP
            C2M = COEF2(JM1,K)*DTD
            C4M = COEF4(JM1,K)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1) =  0.
            WORK(J,K,2) = -(C2M + C4M + C4)*XYJ(JM1,K)
            WORK(J,K,3) = XYJ(J,K)*(C2M+2.*C4M+C2+3.*C4)
            WORK(J,K,4) = -(C2 + 3.*C4 + C4M)*XYJ(JP1,K)
            WORK(J,K,5) = XYJ(JP2,K)*C4
220         CONTINUE
C
         J = JUP
         JP1 = JPLUS(J)
         JM1 = JMINU (J)
         JM2 = JMINU (JM1)
            DO 222 K = KLOW,KUP
            C2M = COEF2(JM1,K)*DTD
            C4M = COEF4(JM1,K)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1) =  XYJ(JM2,K)*C4M
            WORK(J,K,2) = -(C2M + 3.*C4M + C4)*XYJ(JM1,K)
            WORK(J,K,3) = XYJ(J,K)*(C2M+3.*C4M+C2+2.*C4)
            WORK(J,K,4) = -(C2 + C4 + C4M)*XYJ(JP1,K)
            WORK(J,K,5) = 0.
222         CONTINUE
C
            ENDIF
C
C   ADD IN FLUX JACOBIANS AND VARIABLE DT AND IDENTITY
C
         DO 230 J = JLOW,JUP
         JP1 = JPLUS(J)
         JM1 = JMINU (J)
            DO 232 K = KLOW,KUP
            WORK(J,K,2) = WORK(J,K,2) - (UU(JM1,K)+SN*CC(JM1,K))*HD
            WORK(J,K,4) = WORK(J,K,4) + (UU(JP1,K)+SN*CC(JP1,K))*HD
            WORK(J,K,1) = WORK(J,K,1)*DS(J,K)
            WORK(J,K,2) = WORK(J,K,2)*DS(J,K)
            WORK(J,K,3) = WORK(J,K,3)*DS(J,K)
            WORK(J,K,4) = WORK(J,K,4)*DS(J,K)
            WORK(J,K,5) = WORK(J,K,5)*DS(J,K)
            WORK(J,K,3) = WORK(J,K,3) + 1.
232         CONTINUE
230       CONTINUE
C
C  FOR N = 1 AND 2 DO BOTH TOGETHER
C   INVERT ON FIRST TWO S ELEMENTS
C
          IF(N.EQ.2)THEN
C
        IF(.NOT.PERIDC  )THEN
        CALL XPENT2(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       S(1,1,1),JLOW,JUP,KLOW,KUP)
C
               ELSE
C              PERIDC  
        CALL XPENP2(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       WORK(1,1,9),WORK(1,1,10),S(1,1,1),JLOW,JUP,KLOW,KUP)
               ENDIF
C
            ELSE
C
C  N = 3 OR 4
C
               IF(.NOT.PERIDC  )THEN
        CALL XPENTA(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       S(1,1,N),JLOW,JUP,KLOW,KUP)
               ELSE
C              PERIDC  
        CALL XPENTP(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       WORK(1,1,9),WORK(1,1,10),S(1,1,N),JLOW,JUP,KLOW,KUP)
               ENDIF
C
        ENDIF
C
300       CONTINUE
C
C  END XI DIRECTION
C
        RETURN
        END

      SUBROUTINE COPY (N, A, B)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   ARRAY COPY ROUTINE
C
      DIMENSION A(N), B(N)
      DO 100 I = 1, N
        B(I) = A(I)
100   CONTINUE
      RETURN
      END

      SUBROUTINE L2NAVI (ELK,ELF,GEOM,VISCOS,DENSIT,DT,ITVELO,EPS,NODEL,
     + 		ITTEMP,GRAVX,GRAVY,HEXPCO,REFTEM)
      DOUBLE PRECISION ELK(*),ITTEMP(*),ITVELO(*),ELF(*),GEOM(*)
      DOUBLE PRECISION VISCOS,DENSIT,DT,EPS,GRAVX,GRAVY,HEXPCO,REFTEM
      INTEGER NODEL
      DOUBLE PRECISION ZERO,PII2
      INTEGER DOFNOD, MNODEL, DOFEL, MDOFEL, NS, DIM, MQP
      PARAMETER ( DOFNOD=2, MDOFEL=16, MNODEL=8, MQP=4 )
      PARAMETER (NS=4,DIM=2,ZERO=0.D0,PII2=2.D0*3.141592653589793D0)
      DOUBLE PRECISION BTB(MDOFEL*MDOFEL), B(NS*MDOFEL)
      DOUBLE PRECISION GDER(DIM,MNODEL), SFUN(MNODEL)
      DOUBLE PRECISION FUN(DIM,MDOFEL),BT(MDOFEL*NS)
      DOUBLE PRECISION BFOR(DIM), JAC(DIM,DIM), JACIN(DIM,DIM)
      DOUBLE PRECISION BFUN(MDOFEL)
      DOUBLE PRECISION LDER(DIM,MNODEL),XK(DIM),SFUN2(MDOFEL*MDOFEL),
     +     SFUMU(2*MDOFEL),SFUMUT(MDOFEL*2),UZZERO(2*MDOFEL),
     +     SFUNR(MNODEL)
      DOUBLE PRECISION WG(MQP), XI(MQP), ETA(MQP)
      DOUBLE PRECISION DIVDIV(MDOFEL*MDOFEL), DIV(MDOFEL)

      DOUBLE PRECISION VGRAD(MNODEL), MVGRAD(DIM,MDOFEL)
      DOUBLE PRECISION VELO(DIM), SFVGR(MDOFEL*MDOFEL)
      DOUBLE PRECISION DETK, AMUL,ELM(MDOFEL,MDOFEL)
      DOUBLE PRECISION PDER(MDOFEL),PDERIN(MDOFEL),PRES(MDOFEL*MDOFEL),
     +     PFUN(MDOFEL),PFUNI(MDOFEL),MEASEL,g(8)
      INTEGER I,J,K,IND,NQP
      DOFEL = NODEL*DOFNOD
      CALL VFILL (DOFEL*DOFEL,ELK,ZERO)
      CALL VFILL (DOFEL*DOFEL,ELM,ZERO)
      CALL VFILL (DOFEL,ELF,ZERO)

      CALL GAUSQ4 (WG,XI,ETA,NQP)

      DO 100 K=1,NQP
         CALL SQUAD8 (SFUN,LDER,XI(K),ETA(K))
         CALL MXM (SFUN,1,GEOM,NODEL,XK,DIM)
         CALL MXM (LDER,DIM,GEOM,NODEL,JAC,DIM)
         CALL INV2X2 (JAC,JACIN,DETK)
 
         CALL MXM (JACIN,DIM,LDER,DIM,GDER,NODEL)
         CALL B2STOK (B,GDER,SFUMU,SFUN,SFUN,NODEL)
         CALL MATRAN (B,BT,NS,DOFEL)
         CALL MATRAN (SFUMU,SFUMUT,DIM,DOFEL)
         CALL MXM (BT,DOFEL,B,NS,BTB,DOFEL)
         CALL MXM (SFUMUT,DOFEL,SFUMU,DIM,SFUN2,DOFEL)

         AMUL = WG(K)*DETK*XK(1)


         DO 10 I=1,DOFEL*DOFEL
            ELK(I) = ELK(I) + DT*VISCOS*AMUL*BTB(I)
 10      CONTINUE                 


         CALL SAXPY (DOFEL*DOFEL,AMUL*DENSIT,SFUN2,1,ELK,1)
         CALL SAXPY (DOFEL*DOFEL,AMUL*DENSIT,SFUN2,1,ELM,1)


                  
         BFOR(1) = ZERO
         BFOR(2) = ZERO-DENSIT*GRAVY

         DO 400 I=1,NODEL
            BFOR(1) = BFOR(1)+DENSIT*GRAVX*
     +           (HEXPCO*(ITTEMP(I)-REFTEM))*SFUN(I)
            BFOR(2) = BFOR(2)+DENSIT*GRAVY*
     +           (HEXPCO*(ITTEMP(I)-REFTEM))*SFUN(I)
 400     CONTINUE

         CALL VFILL (DOFEL*DIM,FUN,ZERO)
         DO 80 I=1,NODEL
            FUN(1,I) = SFUN(I)
            FUN(2,I+NODEL) = SFUN(I)
 80      CONTINUE     

         IF (BFOR(1).NE.0.D0.OR.BFOR(2).NE.0.D0) THEN
            CALL MXM (FUN,DOFEL,BFOR,DIM,BFUN,1)
            CALL SAXPY (DOFEL,DT*AMUL,BFUN,1,ELF,1)
         END IF


         AMUL=VISCOS*DT*WG(K)*DETK/XK(1)
         CALL VFILL(2*MDOFEL,UZZERO,ZERO)

         CALL B2STOK (B,GDER,SFUMU,SFUN,UZZERO,NODEL)
         CALL MATRAN (SFUMU,SFUMUT,DIM,DOFEL)
         CALL MXM (SFUMUT,DOFEL,SFUMU,DIM,SFUN2,DOFEL)
         CALL SAXPY (DOFEL*DOFEL,AMUL,SFUN2,1,ELK,1)

 100  CONTINUE


      DO 111 I=1,DOFEL
         DO 112 J=1,DOFEL
            ELF(I)=ELF(I)+ELM(I,J)*ITVELO(J) 
 112     CONTINUE
 111  CONTINUE                 


      
      CALL GAUSQ4 (WG,XI,ETA,NQP)

      DO 200 K=1,NQP
         CALL SQUAD8(SFUN,LDER,XI(K),ETA(K))
         CALL MXM (SFUN,1,GEOM,NODEL,XK,DIM)
         CALL MXM (LDER,DIM,GEOM,NODEL,JAC,DIM)
         CALL INV2X2 (JAC,JACIN,DETK)
         CALL MXM (JACIN,DIM,LDER,DIM,DIV,NODEL)

         CALL SAXPY (NODEL,1.D0/XK(1),SFUN,1,DIV(1),2)

         AMUL = DT*WG(1)*DETK*XK(1)/EPS

         CALL MXM (DIV,DOFEL,DIV,1,DIVDIV,DOFEL)
         CALL SAXPY (DOFEL*DOFEL,AMUL,DIVDIV,1,ELK,1)
 200  CONTINUE

      RETURN
      END

      SUBROUTINE EMIT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  EMIT NEW VORTICES TO SATISFY BOUNDARY CONDITION.
C  FINISH COMPUTING PRESSURE, FORCES, ETC.
C
C   11/28/84  D H BAILEY  MODIFIED FOR NAS KERNEL TEST
C
      PARAMETER (NW=100, NB=5, NVM=1500)
      COMPLEX Z, WALL, ZCR, REFPT,  EXPWKL, EXPMWK, FORCE,
     & UUPSTR, DUM3, EXPZ, EXPMZ, ZZ
      COMMON /ARRAYS/ NWALL(NB), IALIGN,
     $     WALL(NW,NB), RMATRX(NW*NB,NW*NB),
     $ ZCR(NW,NB), Z(NVM), GAMMA(NVM), REFPT(NB), RHS(NW*NB),
     $ FORCE(NB), RMOM(NB), CP(NW,NB), DPDS(NW,NB), EXPZ(NVM),
     $ EXPMZ(NVM), PSI(NW), PS(NVM)
C
      DATA  PERIOD/3./, SIG2/3./, U0/4./, MATDIM/500/, DELT/1./,
     $  CHORD/5./, PI/3.141592653589793/, UUPSTR/(3., 4.)/
C
C  STORE EXP(Z(I)) AND EXP(-Z(I)) TO REDUCE WORK IN INNER LOOP 4.
C
      NV = 1000
      PIDP = PI / PERIOD
C
      DO 2 I = 1, NV
        EXPZ(I) = EXP (Z(I) * PIDP)
        EXPMZ(I) = 1. / EXPZ(I)
2     CONTINUE
C
      I0 = 0
      CUPST = REAL(UUPSTR) ** 2 + AIMAG(UUPSTR) ** 2
C
      DO 5 L = 1, NB
        DO 6 K = 1, NWALL(L)
          EXPWKL = EXP (WALL(K,L) * PIDP)
          EXPMWK = 1. / EXPWKL
          SPS = 0.
          DO 4 I = 1, NV
            DUM3 = EXPZ(I) * EXPMWK - EXPWKL * EXPMZ(I)
            PS(I) = GAMMA(I) * LOG (REAL(DUM3) ** 2 +
     &              AIMAG(DUM3) ** 2 + SIG2)
            SPS = SPS + PS(I)
4         CONTINUE
          PSI(K) = AIMAG(WALL(K,L) * 
     &             CONJG (UUPSTR + CMPLX (0.0D0, U0)))
     &             - SPS * 0.25 / PI
6       CONTINUE
C
C  COMPUTE RIGHT-HAND SIDE.
C
        DO 8 K = 1, NWALL(L)
          RHS(I0+K) = PSI(K) - PSI(1)
8       CONTINUE
        I0 = I0 + NWALL(L)
5     CONTINUE
C
C  SOLVE SYSTEM
C
      DO 10 I = 1, MATDIM
        DO 10 J = I+1, MATDIM
          RHS(J) = RHS(J) - RMATRX(J,I) * RHS(I)
10    CONTINUE
      DO 11 I = MATDIM, 1, -1
        RHS(I) = RMATRX(I,I) * RHS(I)
        DO 11 J = 1, I-1
          RHS(J) = RHS(J) - RMATRX(J,I) * RHS(I)
11    CONTINUE
C
C  CREATE NEW VORTICES.
C
      NOLLD = NV
      I0 = 0
      DO 7 L = 1, NB
        DO 3 K = 1, NWALL(L)
C
C  PUT THE NEW VORTEX AT THE END OF THE ARRAY.
C
          NV = NV+1
          Z(NV) = ZCR(K,L)
          GAMMA(NV) = RHS(I0+K)
C
C  RECORD THE GAIN OF LINEAR AND ANGULAR MOMENTUM
C
          FORCE(L) = FORCE(L) + GAMMA(NV) * Z(NV)
          RMOM(L) = RMOM(L) + GAMMA(NV) * (REAL (Z(NV) - REFPT(L)) ** 2
     &              + AIMAG (Z(NV) - REFPT(L)) ** 2)
          DPDS(K,L) = DPDS(K,L) - GAMMA(NV)
3       CONTINUE
C
C  FILTER AND INTEGRATE PRESSURE GRADIENT TO GET PRESSURE
C
        CP(1,L) = 0.
        CPM = -1E50
        DO 9 K = 2, NWALL(L)
          CP(K,L) = CP(K-1,L) + (3. * (DPDS(K,L) + DPDS(K-1,L))
     &              + DPDS(1+MOD(K,NWALL(L)), L)
     &              + DPDS(1+MOD(K+NWALL(L)-3, NWALL(L)), L))
     &              / (4. * DELT * CUPST)
          CPM = MAX (CPM, CP(K,L))
9       CONTINUE
C
C  NORMALIZE PRESSURE
C
        DO 12 K = 1, NWALL(L)
          CP(K,L) = CP(K,L) - CPM
12      CONTINUE
C
C  FINISH COMPUTING FORCE AND MOMENT,  AS TIME RATE OF CHANGE OF LINEAR
C  AND ANGULAR MOMENTUM
C
        FORCE(L) = FORCE(L) * 
     $       CMPLX (0.0D0, 2.0D0 / (DELT * CHORD * CUPST))
        RMOM(L) = RMOM(L) * 2. / (DELT * CHORD ** 2 * CUPST)
C
        I0=I0+NWALL(L)
7     CONTINUE
C
      RETURN
      END

      SUBROUTINE NUCHAR(LINE,VALUE,NVALUE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
************************************************************************
*
*   NUCHAR  DETERMINS AND RETURNS THE REAL VALUES OF ALL NUMBERS
*           FOUND IN 'LINE'. ALL CONNECTED SUBSTRINGS ARE ASSUMED
*           TO CONTAIN NUMBERS
*   ON ENTRY LINE    = CHARACTER STRING
*   ON EXIT  VALUE   = ARRAY OF NVALUE REAL VALUES
*
************************************************************************
      DIMENSION VALUE(40),ISTART(40)
      CHARACTER*80 LINE
      CHARACTER*1 TAB,COMMA,SPACE
      LOGICAL LEADSP
      DATA COMMA,SPACE/',',' '/
      TAB=CHAR(9)
*
* CLEAN OUT TABS AND COMMAS
*
      DO 10 I=1,80
   10 IF(LINE(I:I).EQ.TAB.OR.LINE(I:I).EQ.COMMA)LINE(I:I)=SPACE
*
* FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
*     BY A CHARACTER
*
      LEADSP=.TRUE.
      NVALUE=0
      DO 20 I=1,80
         IF (LEADSP.AND.LINE(I:I).NE.SPACE) THEN
            NVALUE=NVALUE+1
            ISTART(NVALUE)=I
         ENDIF
         LEADSP=(LINE(I:I).EQ.SPACE)
   20 CONTINUE
*
* FILL NUMBER ARRAY
*
      DO 30 I=1,NVALUE
         VALUE(I)=READA(LINE,ISTART(I))
   30 CONTINUE
      RETURN
      END

      SUBROUTINE ECOORD (NELE,GEOM,IGEOM,ELTOP,IELTOP,COORD,ICOORD)
      INTEGER NELE, IGEOM, IELTOP, ELTOP(IELTOP,*), ICOORD
      DOUBLE PRECISION GEOM(IGEOM,*), COORD(ICOORD,*)
      INTEGER J, NODE

      DO 100 J=1,ELTOP(2,NELE)  
         NODE = ELTOP(2+J,NELE)
         GEOM(J,1) = COORD(1,NODE)
         GEOM(J,2) = COORD(2,NODE)
100   CONTINUE
      RETURN
      END

C     *****************
      SUBROUTINE ACCEPT(NVH,NVL,IACPT,WK4,WK3,WK2,WK1)
C     *****************

      DOUBLE PRECISION WK1(NVH,18), WK2(NVH,18),
     >                 WK3(NVH,18), WK4(NVH,18)

C     ACCEPT NEW LINK IF EXP(-S) > RANDOM NUMBER[0-1]

      DO 10 IVL = 1,NVL
      IF( WK4(IVL,1) .GT. WK2(IVL,1) ) THEN
          DO 20 ISM = 1,18
          WK1(IVL,ISM) = WK3(IVL,ISM)
   20     CONTINUE
          IACPT = IACPT + 1
      ENDIF
   10 CONTINUE
C
      END

C     ****************
      SUBROUTINE HYP3D(
C     ****************
     >                 NX,NY,NZ,NT,
     >                 NXYZH,NXYTH,NXZTH,NYZTH,
     >                 NXE,NXYE,NXYZE,
     >                 GX,GY,GZ,GT,
     >                 LX,LY,LZ,LT,
     >                 FX,FY,FZ,FT )
C
C
      INTEGER        GX(NYZTH,2,4),GY(NXZTH,2,4),
     >               GZ(NXYTH,2,4),GT(NXYZH,2,4)
C
      INTEGER        LX(2,4),LY(2,4),
     >               LZ(2,4),LT(2,4)
C
C
      INTEGER        FX(4),FY(4),FZ(4),FT(4)
C
C
C     3-D HYPERPLANES X=NX+1; X=2; X=1; X=NX+2
C     3-D HYPERPLANES Y=NY+1; Y=2; Y=1; Y=NY+2
C     3-D HYPERPLANES Z=NZ+1; Z=2; Z=1; Z=NZ+2
C     3-D HYPERPLANES T=NT+1; T=2; T=1; T=NT+2
C
C
      DO 10 L = 1,4
C
C
C     **********
      CALL HYPPL(
C     **********
     >           NXE,NXYE,NXYZE,
     >           GX(1,1,L),LX(1,L),NYZTH,
     >           FX(L),2,2,2,FX(L),NY+1,NZ+1,NT+1 )
C
C
C     **********
      CALL HYPPL(
C     **********
     >           NXE,NXYE,NXYZE,
     >           GY(1,1,L),LY(1,L),NXZTH,
     >           2,FY(L),2,2,NX+1,FY(L),NZ+1,NT+1 )
C
C
C     **********
      CALL HYPPL(
C     **********
     >           NXE,NXYE,NXYZE,
     >           GZ(1,1,L),LZ(1,L),NXYTH,
     >           2,2,FZ(L),2,NX+1,NY+1,FZ(L),NT+1 )
C
C
C     **********
      CALL HYPPL(
C     **********
     >           NXE,NXYE,NXYZE,
     >           GT(1,1,L),LT(1,L),NXYZH,
     >           2,2,2,FT(L),NX+1,NY+1,NZ+1,FT(L) )
C
C
   10 CONTINUE
C
C
      RETURN
      END

      SUBROUTINE POWSAV(HESS, GRAD, XPARAM, PMAT, ILOOP, BMAT, IPOW)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION HESS(MAXPAR,*),GRAD(*),BMAT(MAXPAR,*),IPOW(9),
     1 XPARAM(*), PMAT(*)
**********************************************************************
*
* POWSAV STORES AND RESTORES DATA USED IN THE SIGMA GEOMETRY
*        OPTIMISATION.
*
*  ON INPUT HESS   = HESSIAN MATRIX, PARTIAL OR WHOLE.
*           GRAD   = GRADIENTS.
*           XPARAM = CURRENT STATE OF PARAMETERS.
*           ILOOP  = INDEX OF HESSIAN, OR FLAG OF POINT REACHED SO-FAR.
*           BMAT   = "B" MATRIX!
*           IPOW   = INDICES AND FLAGS.
*           IPOW(9)= 0 FOR RESTORE, 1 FOR DUMP
*
**********************************************************************
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, DUMY(MAXPAR)
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                     LOCDEP(MAXPAR)
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /LOCVAR/ LOCVAR(2,MAXPAR)
      COMMON /KEYWRD/ KEYWRD
      COMMON /VALVAR/ VALVAR(MAXPAR),NUMVAR
      DIMENSION IEL1(3),QQ(3), COORD(3,NUMATM)
      CHARACTER ELEMNT*2, KEYWRD*80,KOMENT*80, TITLE*80
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /ALPARM/ ALPARM(3,MAXPAR),X0, X1, X2, JLOOP
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
CDEP
      OPEN(UNIT=9,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=9,FILE='FOR009',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 9
      OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 10
      IR=9
      IF(IPOW(9) .NE. 0) THEN
         IF(IPOW(9) .EQ. 1) THEN
            WRITE(6,'(//10X,''- - - - - - - TIME UP - - - - - - -'',//)'
     1)
            WRITE(6,'(//10X,'' - THE CALCULATION IS BEING DUMPED TO DISK
     1'',/10X,''   RESTART IT USING THE KEY-WORD "RESTART"'')')
            FUNCT1=SQRT(DOT(GRAD,GRAD,NVAR))
            WRITE(6,'(//10X,''CURRENT VALUE OF GRADIENT NORM =''
     1  ,F12.6)')FUNCT1
            DO 10 I=1,NVAR
               K=LOC(1,I)
               L=LOC(2,I)
   10       GEO(L,K)=XPARAM(I)
            WRITE(6,'(/10X,''CURRENT VALUE OF GEOMETRY'',/)')
            DEGREE=57.29577951D0
            IF(NA(1) .EQ. 99) THEN
C
C  CONVERT FROM CARTESIAN COORDINATES TO INTERNAL
C
               DO 20 I=1,NATOMS
                  DO 20 J=1,3
   20          COORD(J,I)=GEO(J,I)
               CALL XYZINT(COORD,NUMAT,NA,NB,NC,1.D0,GEO)
            ENDIF
            GEO(2,1)=0.D0
            GEO(3,1)=0.D0
            GEO(1,1)=0.D0
            GEO(2,2)=0.D0
            GEO(3,2)=0.D0
            GEO(3,3)=0.D0
            IVAR=1
            NA(1)=0
            WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
            DO 50 I=1,NATOMS
               DO 30 J=1,3
   30          IEL1(J)=0
   40          CONTINUE
               IF(LOC(1,IVAR).EQ.I) THEN
                  IEL1(LOC(2,IVAR))=1
                  IVAR=IVAR+1
                  GOTO 40
               ENDIF
               IF(I.LT.4) THEN
                  IEL1(3)=0
                  IF(I.LT.3) THEN
                     IEL1(2)=0
                     IF(I.LT.2) THEN
                        IEL1(1)=0
                     ENDIF
                  ENDIF
               ENDIF
               IF(I.EQ.LATOM)IEL1(LPARAM)=-1
               QQ(1)=GEO(1,I)
               QQ(2)=GEO(2,I)*DEGREE
               QQ(3)=GEO(3,I)*DEGREE
   50       WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3)')
     1    ELEMNT(LABELS(I)),(QQ(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I)
            I=0
            X=0.D0
            WRITE(6,'(I4,3(F12.6,I3),I4,2I3)')
     1    I,X,I,X,I,X,I,I,I,I
            IF(NDEP.NE.0)THEN
               DO 60 I=1,NDEP
   60          WRITE(6,'(3(I4,'',''))')LOCPAR(I),IDEPFN(I),LOCDEP(I)
               WRITE(6,*)
            ENDIF
         ENDIF
         WRITE(IR)IPOW,ILOOP
         WRITE(IR)(XPARAM(I),I=1,NVAR)
         WRITE(IR)(  GRAD(I),I=1,NVAR)
         WRITE(IR)((HESS(J,I),J=1,NVAR),I=1,NVAR)
         WRITE(IR)((BMAT(J,I),J=1,NVAR),I=1,NVAR)
         LINEAR=(NVAR*(NVAR+1))/2
         WRITE(IR)(PMAT(I),I=1,LINEAR)
         LINEAR=(NORBS*(NORBS+1))/2
         WRITE(10)(PA(I),I=1,LINEAR)
         IF(NALPHA.NE.0)WRITE(10)(PB(I),I=1,LINEAR)
         IF(LATOM .NE. 0) THEN
            WRITE(IR)((ALPARM(J,I),J=1,3),I=1,NVAR)
            WRITE(IR)JLOOP,X0, X1, X2
         ENDIF
         CLOSE (9)
         CLOSE (10)
         RETURN
      ELSE
         WRITE(6,'(//10X,'' RESTORING DATA FROM DISK''/)')
         READ(IR)IPOW,ILOOP
         READ(IR)(XPARAM(I),I=1,NVAR)
         READ(IR)(  GRAD(I),I=1,NVAR)
         READ(IR)((HESS(J,I),J=1,NVAR),I=1,NVAR)
         READ(IR)((BMAT(J,I),J=1,NVAR),I=1,NVAR)
         FUNCT1=SQRT(DOT(GRAD,GRAD,NVAR))
         WRITE(6,'(10X,''FUNCTION ='',F13.6//)')FUNCT1
         LINEAR=(NVAR*(NVAR+1))/2
         READ(IR)(PMAT(I),I=1,LINEAR)
         LINEAR=(NORBS*(NORBS+1))/2
         READ(10)(PA(I),I=1,LINEAR)
         IF(NALPHA.NE.0)READ(10)(PB(I),I=1,LINEAR)
         IF(LATOM.NE.0) THEN
            READ(IR)((ALPARM(J,I),J=1,3),I=1,NVAR)
            READ(IR)JLOOP,X0, X1, X2
            ILOOP=ILOOP+1
         ENDIF
         ILOOP=ILOOP+1
         RETURN
      ENDIF
      END

      SUBROUTINE POWSQ(XPARAM, NVAR, FUNCT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(*)
      COMMON /MESAGE/ IFLEPO,ISCF
**********************************************************************
*
*   POWSQ OPTIMIZES THE GEOMETRY BY MINIMISING THE GRADIENT NORM.
*         THUS BOTH GROUND AND TRANSITION STATE GEOMETRIES CAN BE
*         CALCULATED. IT IS ROUGHLY EQUIVALENT TO FLEPO, FLEPO MINIMIZES
*         THE ENERGY, POWSQ MINIMIZES THE GRADIENT NORM.
*
*  ON ENTRY XPARAM = VALUES OF PARAMETERS TO BE OPTIMIZED.
*           NVAR   = NUMBER OF PARAMETERS TO BE OPTIMIZED.
*
*  ON EXIT  XPARAM = OPTIMIZED PARAMETERS.
*           FUNCT  = HEAT OF FORMATION IN KCALS.
*
**********************************************************************
C        *****  ROUTINE PERFORMS  A LEAST SQUARES MINIMIZATION  *****
C        *****  OF A FUNCTION WHICH IS A SUM OF SQUARES.        *****
C        *****  INITIALLY WRITTEN BY J.W. MCIVER JR. AT SUNY/   *****
C        *****  BUFFALO, SUMMER 1971.  REWRITTEN AND MODIFIED   *****
C        *****  BY A.K. AT SUNY BUFFALO AND THE UNIVERSITY OF   *****
C        *****  TEXAS.  DECEMBER 1973                           *****
C
      COMMON /GEOVAR/ NDUM,LOC(2,MAXPAR), IDUMY, XARAM(MAXPAR)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /LAST  / LAST
      COMMON /KEYWRD/ KEYWRD
      COMMON /TIMEMP/ TIME0
      COMMON /NUMSCF/ NSCF
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1                 LOCDEP(MAXPAR)
      COMMON /GRADNT/ GRAD(MAXPAR),GNFINA
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /NUMCAL/ NUMCAL
      COMMON /SIGMA1/ GNEXT, AMIN, ANEXT
      COMMON /SIGMA2/ GNEXT1(MAXPAR), GMIN1(MAXPAR)
      COMMON /NLLCOM/ HESS(MAXPAR,MAXPAR),BMAT(MAXPAR,MAXPAR),
     1PMAT(MAXPAR*MAXPAR)
      COMMON /SCRACH/ PVEC
      DIMENSION IPOW(9), SIG(MAXPAR),
     1          E1(MAXPAR), E2(MAXPAR),
     2          P(MAXPAR), WORK(MAXPAR),
     3          PVEC(MAXPAR*MAXPAR), EIG(MAXPAR), Q(MAXPAR)
      DIMENSION ISWAP(3)
      LOGICAL DEBUG, RESTRT, TIMES, OKC, OKF, ROUGH, SCF1, RESFIL
      CHARACTER*80 KEYWRD
      CHARACTER SPACE*1, CHDOT*1, ZERO*1, NINE*1, CH*1
      DATA SPACE,CHDOT,ZERO,NINE /' ','.','0','9'/
      DATA  ICALCN /0/, ISWAP /2,3,1/
      IF(ICALCN.NE.NUMCAL) THEN
         ICALCN=NUMCAL
         RESTRT=(INDEX(KEYWRD,'RESTART') .NE. 0)
         SCF1=(INDEX(KEYWRD,'1SCF') .NE. 0)
         ROUGH=.FALSE.
         TIME1=ZECOND()
         TIME2=TIME1
         ICYC=0
         TIMES=(INDEX(KEYWRD,'TIME') .NE. 0)
         TOTIME=MAXTIM
         I=INDEX(KEYWRD,' T=')
         IF(I.NE.0) THEN
            TIM=READA(KEYWRD,I)
            DO 10 J=I+3,80
               CH=KEYWRD(J+1:J+1)
               IF( CH .EQ.' ') THEN
                  CH=KEYWRD(J:J)
                  IF( CH .EQ. 'M') TIM=TIM*60
                  IF( CH .EQ. 'H') TIM=TIM*3600
                  IF( CH .EQ. 'D') TIM=TIM*86400
                  GOTO 20
               ENDIF
   10       CONTINUE
   20       TOTIME=TIM
            WRITE(6,'(//10X,'' TIME FOR THIS STEP ='',F10.2,
     1'' SECONDS'')')TOTIME
         ENDIF
         TLEFT=TOTIME
         TLAST=TOTIME
         TDUMP=MAXDMP
         I=INDEX(KEYWRD,' DUMP')
         IF(I.NE.0) THEN
            TDUMP=READA(KEYWRD,I)
            DO 30 J=I+7,80
               CH=KEYWRD(J:J)
               IF( CH .NE. CHDOT .AND. (CH .LT. ZERO .OR. CH .GT. NINE))
     1 THEN
                  IF( CH .EQ. 'M') TDUMP=TDUMP*60
                  GOTO 40
               ENDIF
   30       CONTINUE
   40       CONTINUE
         ENDIF
         RESFIL=.FALSE.
         STEP=0.02D0
         LAST=0
         ILOOP=1
         NAT3=NUMAT*3
         XINC=0.00529167D0
         RHO2=1.D-4
         TOL2=4.D-1
         IF(INDEX(KEYWRD,'PREC') .NE. 0) TOL2=1.D-2
         IF(INDEX(KEYWRD,'GNORM') .NE. 0) THEN
            TOL2=READA(KEYWRD,INDEX(KEYWRD,'GNORM'))
            IF(TOL2.LT.0.001.AND.INDEX(KEYWRD,'LET').EQ.0)THEN
               WRITE(6,'(/,A)')'  GNORM HAS BEEN SET TOO LOW, RESET TO 0
     1.001'
               TOL2=0.001D0
            ENDIF
         ENDIF
         DEBUG = (INDEX(KEYWRD,'POWSQ') .NE. 0)
         IF(RESTRT) THEN
C
C   RESTORE STORED DATA
C
            IPOW(9)=0
            CALL POWSAV(HESS,GMIN1,XPARAM,PMAT,ILOOP,BMAT,IPOW)
            NSCF=IPOW(8)
            DO 50 I=1,NVAR
               GRAD(I)=GMIN1(I)
   50       GNEXT1(I)=GMIN1(I)
            WRITE(6,'('' XPARAM'',6F10.6)')(XPARAM(I),I=1,NVAR)
            IF(ILOOP .GT. 0) THEN
C#               ILOOP=ILOOP+1
               WRITE(6,'(//10X,'' RESTARTING AT POINT'',I3)')ILOOP
            ELSE
               WRITE(6,'(//10X,''RESTARTING IN OPTIMISATION'',
     1         '' ROUTINES'')')
            ENDIF
         ENDIF
*
*   DEFINITIONS:   NVAR   = NUMBER OF GEOMETRIC VARIABLES = 3*NUMAT-6
*
      ENDIF
      NVAR=ABS(NVAR)
      IF(DEBUG) THEN
         WRITE(6,'('' XPARAM'')')
         WRITE(6,'(5(2I3,F10.4))')(LOC(1,I),LOC(2,I),XPARAM(I),I=1,NVAR)
      ENDIF
      IF( .NOT. RESTRT) THEN
         DO 60 I=1,NVAR
   60    GRAD(I)=0.D0
         CALL COMPFG(XPARAM, .TRUE., FUNCT, .TRUE., GRAD, .TRUE.)
      ENDIF
      IF(DEBUG) THEN
         WRITE(6,'('' STARTING GRADIENTS'')')
         WRITE(6,'(3X,8F9.4)')(GRAD(I),I=1,NVAR)
      ENDIF
      GMIN=SQRT(DOT(GRAD,GRAD,NVAR))
      GLAST=GMIN
      DO 70 I=1,NVAR
         GNEXT1(I)=GRAD(I)
         GMIN1(I)=GNEXT1(I)
   70 CONTINUE
C
C    NOW TO CALCULATE THE HESSIAN MATRIX.
C
      IF(ILOOP.LT.0) GOTO 180
C
C   CHECK THAT HESSIAN HAS NOT ALREADY BEEN CALCULATED.
C
      ILPR=ILOOP
      DO 90 ILOOP=ILPR,NVAR
         TIME1=ZECOND()
         XPARAM(ILOOP)=XPARAM(ILOOP) + XINC
         CALL COMPFG(XPARAM, .TRUE., FUNCT, .TRUE., GRAD, .TRUE.)
         IF(SCF1) GOTO 430
         IF(DEBUG)WRITE(6,'(I3,12(8F9.4,/3X))')
     1    ILOOP,(GRAD(IF),IF=1,NVAR)
         GRAD(ILOOP)=GRAD(ILOOP)+1.D-5
         XPARAM(ILOOP)=XPARAM(ILOOP) - XINC
         DO 80 J=1,NVAR
   80    HESS(ILOOP,J)=-(GRAD(J)-GNEXT1(J))/XINC
         TIME2=ZECOND()
         TSTEP=TIME2-TIME1
         IF(TIMES)WRITE(6,'('' TIME FOR STEP:'',F8.2,'' LEFT'',F8.2)')
     1    TSTEP, TLEFT
         IF(TLAST-TLEFT.GT.TDUMP)THEN
            TLAST=TLEFT
            RESFIL=.TRUE.
            IPOW(9)=2
            I=ILOOP
            IPOW(8)=NSCF
            CALL POWSAV(HESS,GMIN1,XPARAM,PMAT,I,BMAT,IPOW)
         ENDIF
         IF( TLEFT .LT. TSTEP*2.D0) THEN
C
C  STORE RESULTS TO DATE.
C
            IPOW(9)=1
            I=ILOOP
            IPOW(8)=NSCF
            CALL POWSAV(HESS,GMIN1,XPARAM,PMAT,I,BMAT,IPOW)
            CALL WRAPUP()
         ENDIF
   90 CONTINUE
C        *****  SCALE -HESSIAN- MATRIX                           *****
      IF( DEBUG) THEN
         WRITE(6,'(//10X,''UN-NORMALIZED HESSIAN MATRIX'')')
         DO 100 I=1,NVAR
  100    WRITE(6,'(8F10.4)')(HESS(J,I),J=1,NVAR)
      ENDIF
      DO 120 I=1,NVAR
         SUM = 0.0D0
         DO 110 J=1,NVAR
  110    SUM = SUM+HESS(I,J)**2
  120 WORK(I) = 1.0D0/SQRT(SUM)
      DO 130 I=1,NVAR
         DO 130 J=1,NVAR
  130 HESS(I,J) = HESS(I,J)*WORK(I)
      IF( DEBUG) THEN
         WRITE(6,'(//10X,''HESSIAN MATRIX'')')
         DO 140 I=1,NVAR
  140    WRITE(6,'(8F10.4)')(HESS(J,I),J=1,NVAR)
      ENDIF
C        *****  INITIALIZE B MATIRX                        *****
      DO 160 I=1,NVAR
         DO 150 J=1,NVAR
  150    BMAT(I,J) = 0.0D0
  160 BMAT(I,I) = WORK(I)*2.D0
************************************************************************
*
*  THIS IS THE START OF THE BIG LOOP TO OPTIMIZE THE GEOMETRY
*
************************************************************************
      ILOOP=-99
      TSTEP=TSTEP*4
  170 CONTINUE
      IF(TLAST-TLEFT.GT.TDUMP)THEN
         TLAST=TLEFT
         RESFIL=.TRUE.
         IPOW(9)=2
         I=ILOOP
         IPOW(8)=NSCF
         CALL POWSAV(HESS,GMIN1,XPARAM,PMAT,I,BMAT,IPOW)
      ENDIF
      IF( TLEFT .LT. TSTEP*2.D0) THEN
C
C  STORE RESULTS TO DATE.
C
         IPOW(9)=1
         I=ILOOP
         IPOW(8)=NSCF
         CALL POWSAV(HESS,GMIN1,XPARAM,PMAT,I,BMAT,IPOW)
         CALL WRAPUP()
      ENDIF
  180 CONTINUE
C        *****  FORM-A- DAGGER-A- IN PA SLONG WITH -P-     *****
      IJ=0
      DO 200 J=1,NVAR
         DO 200 I=1,J
            IJ=IJ+1
            SUM = 0.0D0
            DO 190 K=1,NVAR
  190       SUM = SUM + HESS(I,K)*HESS(J,K)
  200 PMAT(IJ) = SUM
      DO 220 I=1,NVAR
         SUM = 0.0D0
         DO 210 K=1,NVAR
  210    SUM = SUM-HESS(I,K)*GMIN1(K)
  220 P(I) = -SUM
      L=0
      IF(DEBUG) THEN
         WRITE(6,'(/10X,''P MATRIX IN POWSQ'')')
         CALL VECPRT(PMAT,NVAR)
      ENDIF
      CALL HQRII(PMAT,NVAR,NVAR,EIG,PVEC)
C        *****  CHECK FOR ZERO EIGENVALUE                  *****
C#      WRITE(6,'(''  EIGS IN POWSQ:'')')
C#      WRITE(6,'(6F13.8)')(EIG(I),I=1,NVAR)
      IF(EIG(1).LT.RHO2) GO TO 280
      INDC = 2
C        *****  IF MATRIX IS NOT SINGULAR FORM INVERSE     *****
C        *****  BY BACK TRANSFORMING THE EIGENVECTORS      *****
      IJ=0
      DO 240 I=1,NVAR
         DO 240 J=1,I
            IJ=IJ+1
            SUM = 0.0D0
            DO 230 K=1,NVAR
  230       SUM = SUM+PVEC((K-1)*NVAR+J)*PVEC((K-1)*NVAR+I)/EIG(K)
  240 PMAT(IJ) = SUM
C        *****  FIND -Q- VECTOR                            *****
      L=0
      IL=L+1
      L=IL+I-1
      DO 270 I=1,NVAR
         SUM = 0.0D0
         DO 250 K=1,I
            IK=(I*(I-1))/2+K
  250    SUM = SUM+PMAT(IK)*P(K)
         IP1=I+1
         DO 260 K=IP1,NVAR
            IK=(K*(K-1))/2+I
  260    SUM=SUM+PMAT(IK)*P(K)
  270 Q(I) = SUM
      GO TO 300
  280 CONTINUE
C        *****  TAKE  -Q- VECTOR AS EIGENVECTOR OF ZERO     *****
C        *****  EIGENVALUE                                 *****
      DO 290 I=1,NVAR
  290 Q(I) = PVEC(I)
  300 CONTINUE
C        *****  FIND SEARCH DIRECTION                      *****
      DO 310 I=1,NVAR
         SIG(I) = 0.0D0
         DO 310 J=1,NVAR
  310 SIG(I) = SIG(I) + Q(J)*BMAT(I,J)
C        *****  DO A ONE DIMENSIONAL SEARCH                *****
      IF (DEBUG) THEN
         WRITE(6,'('' SEARCH VECTOR'')')
         WRITE(6,'(8F10.5)')(SIG(I),I=1,NVAR)
      ENDIF
      CALL SEARCH(XPARAM, ALPHA, SIG, NVAR, GMIN, OKC, OKF, FUNCT)
      IF( NVAR .EQ. 1) GOTO 430
C
C  FIRST WE ATTEMPT TO OPTIMIZE GEOMETRY USING SEARCH.
C  IF THIS DOES NOT WORK, THEN SWITCH TO LINMIN, WHICH ALWAYS WORKS,
C  BUT IS TWICE AS SLOW AS SEARCH.
C
      ROUGH=  (   .NOT.  OKF)
      RMX = 0.0D0
      DO 320 K=1,NVAR
         RT = ABS(GMIN1(K))
         IF(RT.GT.RMX)RMX = RT
  320 CONTINUE
      IF(RMX.LT.TOL2) GO TO 430
C        *****  TWO STEP ESTIMATION OF DERIVATIVES         *****
      DO 330 K=1,NVAR
  330 E1(K) = (GMIN1(K)-GNEXT1(K))/(AMIN-ANEXT)
      RMU = DOT(E1,GMIN1,NVAR)/DOT(GMIN1,GMIN1,NVAR)
      DO 340 K=1,NVAR
  340 E2(K) = E1(K) - RMU*GMIN1(K)
C        *****  SCALE -E2- AND -SIG-                       *****
      SK = 1.0D0/SQRT(DOT(E2,E2,NVAR))
      DO 350 K=1,NVAR
  350 SIG(K) = SK*SIG(K)
      DO 360 K=1,NVAR
  360 E2(K) = SK*E2(K)
C        *****  FIND INDEX OF REPLACEMENT DIRECTION        *****
      PMAX = -1.0D+20
      DO 370 I=1,NVAR
         IF(ABS(P(I)*Q(I)).LE.PMAX) GO TO 370
         PMAX = ABS(P(I)*Q(I))
         ID = I
  370 CONTINUE
C        *****  REPLACE APPROPRIATE DIRECTION AND DERIVATIVE ***
      DO 380 K=1,NVAR
  380 HESS(ID,K) = -E2(K)
C        *****  REPLACE STARTING POINT                     *****
      DO 390 K=1,NVAR
  390 BMAT(K,ID) = SIG(K)/0.529167D0
      DO 400 K=1,NVAR
  400 GNEXT1(K) = GMIN1(K)
      GLAST = GMIN
      INDC = 1
      TIME1=TIME2
      TIME2=ZECOND()
      TLEFT=TOTIME-TIME2+TIME0
      TSTEP=TIME2-TIME1
      ICYC=ICYC+1
      IF(RESFIL)THEN
         WRITE(6,410)TLEFT,GMIN,FUNCT
  410    FORMAT('  RESTART FILE WRITTEN,  TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G14.7)
         RESFIL=.FALSE.
      ELSE
         WRITE(6,420)ICYC,TSTEP,TLEFT,GMIN,FUNCT
  420    FORMAT(' CYCLE:',I5,' TIME:',F6.1,' TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G14.7)
      ENDIF
      IF(TIMES)WRITE(6,'('' TIME FOR STEP:'',F8.2,'' LEFT'',F8.2)')
     1TSTEP, TLEFT
      GO TO 170
  430 CONTINUE
      DO 440 I=1,NVAR
  440 GRAD(I)=0.D0
      LAST=1
      CALL COMPFG(XPARAM, .TRUE., FUNCT, .TRUE., GRAD, .TRUE.)
      DO 450 I=1,NVAR
  450 GRAD(I)=GMIN1(I)
      GNFINA=SQRT(DOT(GRAD,GRAD,NVAR))
      IFLEPO=11
      RETURN
      END

C
C                   SUB-SPACE ROTATION
C
C        FOR VAX ONLY   -->  USE SUBROTC.FOR FOR CRAY
C
C======================================================================
C     FORM A SUBSPACE HAMILTONIAN MATRIX USING THE ORTHOGONAL FILLED
C     BANDS AS BASIS FUNCTIONS. THE ELEMENTS OF THIS MATRIX ARE SIMPLY
C     THE LAGRANGE MULTIPLIERS FOR ORTHONORMALITY. THE EIGENVECTORS OF 
C     THIS SMALL MATRIX WILL GIVE THE LINEAR COMBINATIONS OF THE TRIAL
C     VECTORS WHICH ARE EIGENVECTORS IN THEIR SUBSPACE. 
C
C     THIS SIMILARITY TRANSFORMATION CHANGES NEITHER THE ENERGY NOR 
C     THE DENSITY OF THE SYSTEM. THE PROCESS NOT ONLY SOLVES ANY 
C     PROBLEMS ASSOCIATED WITH BAND ORDERING, BUT ALSO GUARANTEES THAT
C     ANY SUBSEQUENT CHANGE TO ONE BANDWHICH LOWERS ITS ENERGY WILL BE
C     ORTHOGONAL TO ALL OF THE OTHER BANDS.
C     (TETER, ET AL. PHYS. REV. B40, p12261)        X. WENG 27-FEB-90
C======================================================================
      SUBROUTINE SUBROT(NBANDS,NKPTS,NPLWV,MPLWV, NRPLWV,NINDPW,
     &      NPLWKP,CV, CPTWFP,CPTWFL,VOLC,CELEN,
     &      VNL, NGPTAR, DATAKE,CPTOWR,CPTNWR, CWORK, CGRA,
     &      NKP, HR, HI, AUX, FV1, FV2, FV3, CH0, NSPEC, NIONS, 
     &      NIONSP, PSCALE, 
     &      DNLKG, CPHSGR,VGNL, CELFRC, CWRK20,
     &      CWRK21, CWRK22, CWRK23, IVPTYP, IVPTYN,IPRINT,NLPOT,
     &      NGX,NGY,NGZ,NRGRPT,NRLPPI,CPHGRD,NRLNL,NIONST,MXRLNL,
     &      IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,CESAVE)
      IMPLICIT COMPLEX (C)
      DIMENSION NINDPW(*)
      DIMENSION CV(*)
      DIMENSION CPTWFP(*)
      DIMENSION CPTWFL(*)
      DIMENSION CELEN(*)
      DIMENSION NGPTAR(*)
      DIMENSION DATAKE(*)
      DIMENSION NIONSP(*)
C=======================================================================
C
C                      DIMENSION STATEMENTS
C
C CPTACC(MPLWV) = THE PRODUCT OF THE TOTAL POTENTIAL AND THE REAL SPACE
C          WAVEFUNCTION, THIS IS THEN FOURIER TRANSFORMED TO RECIPROCAL
C          SPACE
C
C CWORK(MPLWV) = A WORK ARRAY USED IN THE FOURIER TRANSFORM
C=======================================================================
      DIMENSION CPTOWR(*)
      DIMENSION CPTNWR(*)
      DIMENSION CWORK(*)
      DIMENSION CGRA(*)
C=======================================================================
C DIMENSION FOR SUBROUTINE ROTATION (WENG, 27-FEB-90)
C=======================================================================
      DIMENSION HR(NBANDS,NBANDS),HI(NBANDS,NBANDS),AUX(NBANDS),
     &     FV1(NBANDS),FV2(NBANDS),FV3(NBANDS),CH0(NBANDS,NBANDS)
C=======================================================================
C DIMENSION STATEMENTS FOR THE NON-LOCAL CALCULATION
C=======================================================================
      DIMENSION PSCALE(0:2,NSPEC)
      DIMENSION DNLKG(NRPLWV,0:3,NKPTS)
      DIMENSION IVPTYN(NSPEC)
      DIMENSION CPHSGR(NRPLWV,NIONS,NSPEC)
      DIMENSION VGNL(NRPLWV,0:2,NSPEC)
      DIMENSION CELFRC(NRPLWV)
      DIMENSION CWRK20(NIONS),CWRK21(3,NIONS)
      DIMENSION CWRK22(NIONS),CWRK23(3,3,NIONS)
C=====================================================================
C REAL SPACE NON-LOCAL                                                
C=====================================================================
      DIMENSION NRLPPI(NIONST),CPHGRD(NRGRPT,NIONST)                  
      DIMENSION NRLNL(NSPEC),IRLNL(MXRLNL,NSPEC),PRLSCA(MXRLNL,NSPEC) 
      DIMENSION VRLGRD(NRGRPT,MXRLSH,NIONST),NADGRD(NRGRPT,NIONST)    
      DIMENSION VNL(NBANDS,NKPTS)                                     
      DIMENSION CESAVE(NIONST,36)
C
      RINPLW=1.0/NPLWV
C======================================================================
C
C BECAUSE H(IB,JB) MUST BE HERMITIAN, WE ONLY NEED TO CALCULATE 
C H(IB,JB) FOR JB.GE.IB
C
C======================================================================
C 1. CALCULATE H*PSI
C======================================================================
      DO 10 IB=1,NBANDS
      NINDW=NRPLWV*(IB-1)
      NINDKE=0
      DO 15 M=1,MPLWV
      CPTOWR(M)=(0.0,0.0)
      CPTNWR(M)=(0.0,0.0)
      CWORK(M)=(0.0,0.0)
  15  CONTINUE
      DO 20  M=1,NPLWKP
      CPTOWR(NINDPW(M))=CPTWFP(M+NINDW)
  20  CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
      CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)
      IF(IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN
C=======================================================================
C CALL THE ROUTINE THAT CALCULATES THE PRODUCT OF THE NON-LOCAL
C POTENTIAL AND THE WAVEFUNCTION IN REAL SPACE
C=======================================================================
      CALL VSINL(VOLC,NGX,NGY,NGZ,MPLWV,NRPLWV,
     &   NRGRPT,NIONSP,NRLPPI,NSPEC,CWORK,CPTOWR,CPTNWR,   
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &   CESAVE)                      
      ENDIF                                                             
C=======================================================================
C CALCULATE (WAVEFUNCTION*POTENTIAL) AND FFT IT INTO RECIPROCAL SPACE
C=======================================================================
      DO 25 NNN=1,NPLWV
      CPTNWR(NNN)=(CPTNWR(NNN)+CV(NNN)*CPTOWR(NNN))*RINPLW
  25  CONTINUE
      CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C=======================================================================
C ADDED THE KINETIC ENERGY TERM IN RECIPROCAL SPACE
C=======================================================================
      DO 30 M=1,NPLWKP
      CGRA(M)=CPTNWR(NINDPW(M))+CPTWFP(M+NINDW)*DATAKE(1+(7*(M-1)))
  30  CONTINUE
C=======================================================================
C 2. PSI(DAGGER) H PSI
C=======================================================================
      DO 40 JB=IB,NBANDS
      NINKI=NRPLWV*(JB-1)
      CHD=(0.0,0.0)
      DO 45 KL=1,NPLWKP
      CHD = CHD + CONJG(CPTWFP(KL+NINKI))*CGRA(KL)
  45  CONTINUE
      HR(IB,JB)=REAL(CHD)
      HI(IB,JB)=AIMAG(CHD)
  40  CONTINUE      
  10  CONTINUE 
C=========================================================================
C 3. THE CONTRIBUTION TO THE HAMILTONIAN FROM THE NON-LOCAL PARTS
C    OF PSEUDOPOTENTAIL
C=========================================================================
      IF(IVPTYP.EQ.0 .OR. NLPOT.EQ.1) GOTO 70
      DO 50 IB=1,NBANDS
      CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NKP),VOLC, 
     &            PSCALE, CPTWFP,CWRK20,CWRK21,CWRK22,CWRK23,
     &            CPHSGR, VGNL, CELFRC, CPTWFL,CGRA,IB,IVPTYN)
      DO 55 JB=IB,NBANDS
      NNINDW=(JB-1)*NRPLWV
      CVNL=(0.0,0.0)
      DO 60 M=1,NPLWKP
  60  CVNL=CVNL+ CONJG(CPTWFP(M+NNINDW))*CELFRC(M)
      HR(IB,JB) = HR(IB,JB) + REAL(CVNL)
      HI(IB,JB) = HI(IB,JB) + AIMAG(CVNL)
  55  CONTINUE
  50  CONTINUE
C=======================================================================
C 4. NOW OBTAIN THE LOWER PART OF H(IB,IB)
C=======================================================================
  70  CONTINUE
      DO 71 IB=1,NBANDS
      DO 71 JB=1,IB
      HR(IB,JB)= HR(JB,IB)
      HI(IB,JB)=-HI(JB,IB)
  71  CONTINUE
C=======================================================================
C WRITE OUT THE HAMILTONIAN
C=======================================================================
      IF(IPRINT.LT.2) GOTO 74
      WRITE(*,*)' '
      WRITE(*,*)' ------- THE HAMILTONIAN BEFORE DIAGONALISATION ------'
      WRITE(*,*)'  THE UPPER TRIANGLE IS THE  R E A L  PART'
      WRITE(*,*)'  THE LOWER TRIANGLE IS THE IMAGINARY PART'
      DO 72 I=1,NBANDS
      IF(I.EQ.1) THEN
      WRITE(*,73)                    (HR(I,J), J=I,NBANDS)
      GOTO 72
      END IF
      WRITE(*,73) (HI(I,J),J=1,I-1), (HR(I,J), J=I,NBANDS)
  72  CONTINUE
  73  FORMAT(1X,10F11.5)
  74  CONTINUE
C=======================================================================
C DIAGONALISE H(I,J)     
C THE WAVE FUNCTIONS ARE ROTATED, SO THEY ARE EIGEN STATES
C=======================================================================
      CALL ROT(NBANDS,NRPLWV,CPTWFP,NINDPW,CWORK, NPLWV,NPLWKP,NGPTAR,
     &         MPLWV,HR,HI,AUX, FV1,FV2,FV3,NKP,NKPTS, CH0)
C=======================================================================
C UPDATE CELEN = THE KINETIC ENERGY OF EACH BAND
C=======================================================================
      DO 80 NN=1,NBANDS
      CSUM=(0.0,0.0)
      NINDW=NRPLWV*(NN-1)
      DO 85 M=1,NPLWKP
      CSUM=CSUM
     &    +DATAKE(1+7*(M-1))*CPTWFP(M+NINDW)*CONJG(CPTWFP(M+NINDW))
  85  CONTINUE
      CELEN(NN+(NKP-1)*NBANDS)=CSUM     
      IF(IPRINT.GE.2) WRITE(*,*)' AFTER ROT, CELEN=', CSUM
  80  CONTINUE
C=======================================================================
C UPDATE VNL
C=======================================================================
      IF(IVPTYP.EQ.0) GOTO 99
      DO 90 NB=1,NBANDS
      NINDW=(NB-1)*NRPLWV
      IF (NLPOT.EQ.0) THEN
      CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NKP),
     &     VOLC, PSCALE, CPTWFP,CWRK20,CWRK21,CWRK22,CWRK23,
     &     CPHSGR, VGNL, CELFRC, CPTWFL,CGRA,NB,IVPTYN)
      CVNL=(0.0,0.0)
      DO 95 M=1,NPLWKP
  95  CVNL=CVNL+ CONJG(CPTWFP(M+NINDW))*CELFRC(M)
      VNL(NB,NKP)=REAL(CVNL)
      ELSE
      DO 91 M=1,MPLWV
      CPTOWR(M)=(0.0,0.0)                                             
      CPTNWR(M)=(0.0,0.0)
      CWORK(M)=(0.0,0.0)                                              
  91  CONTINUE
      DO 92  M=1,NPLWKP                                                 
      CPTOWR(NINDPW(M))=CPTWFP(M+NINDW)
  92  CONTINUE                                                          
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
      CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)                                 
C=======================================================================
C CALL ROUTINE TO CALCULATE NON-LOCAL ENERGY IN REAL SPACE
C=======================================================================
      CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NB,NKP,MPLWV,NRPLWV,             
     &   NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK,CPTOWR,
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,  
     &   CESAVE)                      
      END IF
  90  CONTINUE
C
  99  CONTINUE
      IF(IPRINT.GE.1)WRITE(*,*)' RETURN FROM SUBROT (SUBSPACE ROTATION)'
      RETURN
      END
C
C
C=======================================================================
      SUBROUTINE ROT(NBANDS,NRPLWV,CPTWFP,NINDPW,CWORK, NPLWV,NPLWKP,
     &  NGPTAR,MPLWV,HR,HI,AUX,FV1,FV2,FV3,NKP,NKPTS, CH0)
C=======================================================================
C     This routine performs sub-space diagonalisation of the occupied
C     states of the hamiltonian, by unitary matrix.
C
C     27-Feb-90 X. Weng (based on Qteish's version)
C     28-Feb-90 eigenvectors HR and HI normalised.
C     28-Feb-90 (HR,-HI)*CPTWFP part corrected.
C     28-Feb-90 Tested on Si 8-atom unit cell. 
C     04-MAR-90 Further tested
C
      IMPLICIT COMPLEX (C)
      DIMENSION CPTWFP(NRPLWV*NBANDS)
      DIMENSION NGPTAR(3)
      DIMENSION NINDPW(NRPLWV,NKPTS)
      DIMENSION HR(NBANDS,NBANDS),HI(NBANDS,NBANDS),AUX(NBANDS),
     &          FV1(NBANDS),FV2(NBANDS),FV3(NBANDS)
      DIMENSION CWORK(NRPLWV)
      DIMENSION CH0(NBANDS,NBANDS)
C=======================================================================
C     ITEST=1, FOR TEST 
C          =0, REGULAR USE
C=======================================================================
      ITEST=0
      IF(ITEST.EQ.1) THEN
        WRITE(*,*)'>>> THE INPUT H MATRIX'
        DO 5 J=1,NBANDS
        DO 6 I=1,NBANDS
        CH0(I,J)=CMPLX(HR(I,J), HI(I,J))
6       CONTINUE
        WRITE(*,102) (CH0(I,J), I=1,NBANDS)
5       CONTINUE
102     FORMAT(1X, 10F8.2 )
      END IF
C=======================================================================
C CHNAG SOLVES THE EIGENVALUE PROBLEM USING NAG ROUTINES.
C=======================================================================
      CALL CHNAG(NBANDS,NBANDS,HR,HI,AUX,FV1,FV2,FV3,IERR)
      IF(ITEST.EQ.1)WRITE(*,*)'IN ROT: EIGENVALUES FROM DIAGONALISATION'
      IF(ITEST.EQ.1)WRITE(*,100) (AUX(I), I=1, NBANDS)
100   FORMAT(2X,5F15.6)  
      AUXSUM=0.0
      DO 10 J=1, NBANDS
      AUXSUM=AUXSUM+AUX(J)
10    CONTINUE
      IF(ITEST.EQ.1) WRITE(*,*)'   SUM OF EIGENVALUES =:', AUXSUM
C=======================================================================
C     FIND NORM OF BANDS, and the Unitary matrix CUNIT
C
C                         /  VECTOR 1........\
C                         |  ................|
C       CUNIT =(HR, HI) = |  VECTOR J .......|      CUNIT(DAGGAR)*CUNIT=I
C                         |  ................|
C                         \  VECTOR NBANDS ../
C
C       THE EIGENVECTORS SHOULD BE NORMALISED BY NAG ROUTINE
C
C=======================================================================
      IF(ITEST.NE.1) GOTO 200
        DO 40 J = 1,NBANDS
        ANORM=0.0
        DO 50 I = 1,NBANDS
        ANORM = ANORM + HR(I, J)*HR(I, J) + HI(I, J)*HI(I, J)         
50      CONTINUE
        WRITE(*,150) J, AUX(J), ANORM
150     FORMAT(/,' BAND=', I2,'   EIGENVALUE=',F13.6,'  NORM=',F13.6,/)
        WRITE(*,102) (HR(I,J), HI(I,J), I=1,NBANDS)
40      CONTINUE 
C=======================================================================
C     BELOW IS FOR TESTING THE SUBROUTINE
C
C     TEST ON THE SIMILARITY TRANSFORM  U (DAGGAR) H0 U = H1
C=======================================================================
      WRITE(*,*)' BELOW IS THE DIAGNOLISED H1 = U(DAGGAR) H U'
      DO 95 J=1,NBANDS
C
C     FOR JTH ROW OF H1: CWORK(I), I=1,NBANDS
C
      DO 96 I=1,NBANDS
      CWORK(I)=(0.0,0.0)
      DO 97 K=1,NBANDS
      DO 98 L=1,NBANDS
      CWORK(I) = CWORK(I)
     1 + CMPLX(HR(K,I),-HI(K,I)) * CH0(K,L) *CMPLX(HR(L,J), HI(L,J))
98    CONTINUE
97    CONTINUE
96    CONTINUE
      WRITE(*,102) (CWORK(I), I=1,NBANDS)
95    CONTINUE
C
 200  CONTINUE 
C======================================================================
C
C     FOR ITH VECTOR, JTH COMPONENT
C
C                    ______
C                    \        +                        I=1,NPLWKP
C     NEW PSI(J,I) =  >      U (J,K) *OLD PSI(K,I)     J=1,NBANDS
C                    /_____
C                   
C                  K=1,NBANDS
C  
C     WE FIND NEW PSI(I,J), J FIRST 
C
C======================================================================
      DO 60 I=1,NPLWKP
      DO 70 J=1,NBANDS
      CWORK(J)=CMPLX(0.0,0.0)
      DO 70 K=1,NBANDS
      IOFK=NRPLWV*(K-1)+I
      CWORK(J) = CWORK(J) + CMPLX(HR(K,J),-HI(K,J)) * CPTWFP(IOFK)
70    CONTINUE  
      DO 80 K=1,NBANDS
      IOFK=NRPLWV*(K-1)+I
      CPTWFP(IOFK) = CWORK(K)
80    CONTINUE     
60    CONTINUE
C
C     THE NORM OF WAVEFUNCTION BEFORE AND AFTER, SHOULD BE THE SAME
C
      IF(ITEST.EQ.1) THEN
         DO 310 J=1,NBANDS
         CNORM=CMPLX(0.0,0.0)
         NINJ=NRPLWV*(J-1)
         DO 312 I=1,NPLWKP
312      CNORM=CNORM+CPTWFP(NINJ+I)*CONJG(CPTWFP(NINJ+I))
310      WRITE(*,*)' NORM FOR NEW PSI', J, CNORM
         END IF
C     
      RETURN
      END
C=====================================================================
      SUBROUTINE CHNAG(NM,N,A,B,E,FV1,FV2,FV3,IERR)  
C
      DIMENSION A(NM,NM),B(NM,NM),FV1(NM),FV2(NM),FV3(NM),E(NM)
      EXTERNAL X02AJE, F01BCE, F02AYE
C
C     F01BCE: reduction by similarity transfrmaions
C             complex Hermitian matrix to real tridigonal form
C
C     F02AYE: complex Hermitian matrix, all eigenvalues and vectors
C             tridigonal form by F01BCE, QL algorithm
C
C     The eigenvector corresponding to the eigenvalue E(J) is 
C     CMPLX( HR(I,J), HI(I,J)), J=1,N
C
C     TO BE LINKED WITH NAGSP/LIB
C
C=====================================================================
C     REDUCE TO TRIDIAGONAL FORM
C     TOL NO LONGER NEEDED
C=====================================================================
      TOL = 0.0
      CALL F01BCE(N,TOL,A,NM,B,NM,E,FV1,FV2,FV3)
C=====================================================================
C     EIGENVALUES AND EIGENVECTORS OF ORIGINAL MATRIX
C     EPS=MACHINE PRECISION
C=====================================================================
      EPS = X02AJE()
      CALL F02AYE(N,EPS,E,FV1,A,NM,B,NM,IERR)
      RETURN
      END

      SUBROUTINE INV2X2 (A,AINV,DET)
      DOUBLE PRECISION A(2,2), AINV(2,2), DET
      DET = A(1,1)*A(2,2) - A(1,2)*A(2,1)
      AINV(1,1) =  A(2,2)/DET
      AINV(1,2) = -A(1,2)/DET
      AINV(2,1) = -A(2,1)/DET
      AINV(2,2) =  A(1,1)/DET
      RETURN
      END

      SUBROUTINE DRC(STARTV, STARTK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION STARTV(*), STARTK(*)
************************************************************************
*                                                                      *
*    DRC IS DESIGNED TO FOLLOW A REACTION PATH FROM THE TRANSITION     *
*    STATE.  TWO MODES ARE SUPPORTED, FIRST: GAS PHASE:- AS THE SYSTEM *
*    MOVES FROM THE T/S THE MOMENTUM OF THE ATOMS IS STORED AND THE    *
*    POSITION OF THE ATOMS IS RELATED TO THE OLD POSITION BY (A) THE   *
*    CURRENT VELOCITY OF THE ATOM, AND (B) THE FORCES ACTING ON THAT   *
*    ATOM.  THE SECOND MODE IS CONDENSED PHASE, IN WHICH THE ATOMS MOVE*
*    IN RESPONSE TO THE FORCES ACTING ON THEM. I.E. INFINITELY DAMPED  *
*                                                                      *
************************************************************************
      INCLUDE 'mopac.inc'
      COMMON /KEYWRD/ KEYWRD
      COMMON /DENSTY/ P(MPACK),PA(MPACK),PB(MPACK)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /GEOVAR/ NVAR, LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,XRACT
      COMMON /DRCCOM/ MCOPRT(2,MAXPAR), NCOPRT, PRTMAX
      CHARACTER KEYWRD*80
      CHARACTER SPACE*1, CHDOT*1, ZERO*1, NINE*1, CH*1
      DIMENSION VELREF(MAXPAR), VELO0(MAXPAR), VELO1(MAXPAR),
     1VELO2(MAXPAR), VELO3(MAXPAR), GERROR(MAXPAR),
     2COORD(3,NUMATM), GROLD2(MAXPAR),
     3GROLD(MAXPAR), PAROLD(MAXPAR), GEOREF(3,NUMATM),
     4 SQRTMS(MAXPAR)
      LOGICAL INT, ADDK, LETOT, LET, VELRED,PRTMAX, IRCDRC
      DATA VELO0/MAXPAR*0.D0/, INT/.TRUE./
      DATA SPACE,CHDOT,ZERO,NINE /' ','.','0','9'/
      DATA ADDK/.TRUE./
      CLOSE (5)
      TNOW=ZECOND()
      OLDTIM=ZECOND()
      DELOLD=10.D0
      GTOT=0.D0
CDEP
      OPEN(UNIT=7,STATUS='UNKNOWN')
      IF(INDEX(KEYWRD,' PREC').NE.0)THEN
         ACCU=0.5D0
      ELSE
         ACCU=1.D0
      ENDIF
      LPOINT=0
      VELRED=(INDEX(KEYWRD,'VELOC').NE.0)
C
C     PRINT OUT INITIAL VELOCITIES
C
C#      WRITE(6,'(A)')' INITIAL VELOCITY IN DRC'
C#      WRITE(6,'(3F13.5)')(STARTV(I),I=1,NUMAT*3)
      LET=(INDEX(KEYWRD,' GEO-OK').NE.0)
      IF(INDEX(KEYWRD,' SYMME').NE.0)THEN
         WRITE(6,*)'  SYMMETRY SPECIFIED, BUT CANNOT BE USED IN DRC'
         NDEP=0
      ENDIF
C
C      CONVERT TO CARTESIAN COORDINATES, IF NOT ALREADY DONE.
C
      IF(INDEX(KEYWRD,' XYZ').EQ.0)THEN
         NA(1)=0
         CALL GMETRY(GEO,COORD)
         L=0
         DO 20 I=1,NUMAT
            LABELS(I)=NAT(I)
            SUM=SQRT(ATMASS(NAT(I)))
            DO 10 J=1,3
               L=L+1
               SQRTMS(L)=SUM
               GEO(J,I)=COORD(J,I)
   10       COORD(J,I)=0.D0
   20    CONTINUE
         NA(1)=99
      ENDIF
C
C  TRANSFER COORDINATES TO XPARAM AND LOC
C
      IF(INDEX(KEYWRD,' DRC').NE.0)THEN
         PRTMAX=(LOC(1,1).EQ.1)
         IF(PRTMAX)THEN
            J=1
         ELSE
            J=0
         ENDIF
         NVAR=NVAR-J
         DO 30 I=1,NVAR
            MCOPRT(1,I)=LOC(1,I+J)
   30    MCOPRT(2,I)=LOC(2,I+J)
         IF(LOC(1,1).EQ.0)NVAR=0
         NCOPRT=NVAR
      ELSE
         NCOPRT=0
      ENDIF
      L=0
      DO 40 I=1,NUMAT
         DO 40 J=1,3
            L=L+1
            LOC(1,L)=I
            LOC(2,L)=J
            GEOREF(J,I)=GEO(J,I)
   40 XPARAM(L)=GEO(J,I)
      NVAR=NUMAT*3
C
C DETERMINE DAMPING FACTOR
C
      IRCDRC=(INDEX(KEYWRD,'IRC=').NE.0)
      IF(INDEX(KEYWRD,'DRC=').NE.0) THEN
         HALF=READA(KEYWRD,INDEX(KEYWRD,'DRC='))
         WRITE(6,'(//10X,'' DAMPING FACTOR FOR KINETIC ENERGY ='',F12.6)
     1')HALF
      ELSEIF (INDEX(KEYWRD,'DRC').EQ.0) THEN
         HALF=0.D0
      ELSE
         HALF=1.D6
      ENDIF
      LETOT=(.NOT.IRCDRC.AND.HALF.LT.1.D0)
      HALF=SIGN(MAX(0.000001D0,ABS(HALF)),HALF)
C
C DETERMINE EXCESS KINETIC ENERGY
C
      IF(INDEX(KEYWRD,'KINE').NE.0) THEN
         ADDONK=READA(KEYWRD,INDEX(KEYWRD,'KINE'))
         WRITE(6,
     +   '(//10X,'' EXCESS KINETIC ENERGY ENTERED INTO SYSTEM ='',
     +   F12.6)')ADDONK
      ELSE
         ADDONK=0.D0
      ENDIF
C
C   LOOP OVER TIME-INTERVALS OF DELTAT SECOND
C
      DELTAT=1.D-16
      QUADR=1.D0
      TOTIME=0.D0
      ONCE=0.D0
      ETOT=0.D0
      ESCF=0.D0
      CONST=1.D0
      I=INDEX(KEYWRD,' T=')
      IF(I.NE.0) THEN
         TIM=READA(KEYWRD,I)
         DO 50 J=I+3,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TIM=TIM*60
               IF( CH .EQ. 'H') TIM=TIM*3600
               IF( CH .EQ. 'D') TIM=TIM*86400
               GOTO 60
            ENDIF
   50    CONTINUE
C             4 SECONDS TO LOAD IN EXECUTABLE!
   60    TLEFT=TIM-4
      ELSE
         TLEFT=3596
      ENDIF
      IF( INDEX(KEYWRD,'REST').NE.0.AND.INDEX(KEYWRD,'IRC=').EQ.0)THEN
C
C  RESTART FROM A PREVIOUS RUN
C
CDEP
         OPEN(UNIT=9,STATUS='UNKNOWN',FORM='FORMATTED')
C-old         OPEN(UNIT=9,FILE='FOR009',STATUS='UNKNOWN',FORM='FORMATTED')
C-old         REWIND 9
         OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old         OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old         REWIND 10
         READ(9,'(A)')ALPHA
         READ(9,'(3F19.13)')(XPARAM(I),I=1,NVAR)
         READ(9,'(A)')ALPHA
         READ(9,'(3F19.3)')(VELO0(I),I=1,NVAR)
         READ(9,'(A)')ALPHA
         READ(9,*)(GRAD(I),I=1,NVAR)
         READ(9,*)(GROLD(I),I=1,NVAR)
         READ(9,*)(GROLD2(I),I=1,NVAR)
         READ(9,*)ETOT,ESCF,EKIN,DELOLD,DELTAT,DLOLD2,ILOOP,
     1GNORM,LETOT,ELOST1,GTOT
         WRITE(6,'(//10X,''CALCULATION RESTARTED, CURRENT'',
     1'' KINETIC ENERGY='',F10.5,//)')EKIN
         GOTO 110
      ELSE
         ILOOP=1
         IF(INDEX(KEYWRD,'IRC=').NE.0.OR.VELRED)THEN
            IF(INDEX(KEYWRD,'IRC=').NE.0)THEN
               K=READA(KEYWRD,INDEX(KEYWRD,'IRC='))
            ELSE
               K=1
            ENDIF
            IF(K.LT.0)THEN
               K=-K
               ONE=-1.D0
            ELSE
               ONE=1.D0
            ENDIF
            KL=(K-1)*NVAR
            SUMM=0.D0
            VELO1(1)=0
            VELO1(2)=0
            VELO1(3)=0
            SUMMAS=0.D0
            I=0
            DO 70 II=1,NUMAT
               AMS=ATMASS(II)
               SUMMAS=SUMMAS+AMS
               DO 70 I1=1,3
                  I=I+1
                  VELO0(I)=STARTV(KL+I)*ONE
                  VELREF(I)=VELO0(I)
                  VELO1(I1)=VELO1(I1)+VELO0(I)*AMS
   70       CONTINUE
            DO 80 I=1,3
   80       VELO1(I)=-VELO1(I)/SUMMAS
            I=0
            DO 90 II=1,NUMAT
               AMS=ATMASS(II)
               DO 90 I1=1,3
                  I=I+1
                  IF(ADDONK.GT.1.D-5.OR..NOT.VELRED)VELO0(I)=VELO0(I)+VE
     1LO1(I1)
   90       SUMM=SUMM+VELO0(I)**2*AMS
            IF(ADDONK.LT.1.D-5.AND.VELRED)ADDONK=0.5D0*SUMM/4.184D10
            IF(ADDONK.LT.1.D-5.AND..NOT.VELRED)THEN
               IF(ABS(HALF).GT.1.D-3.AND.STARTK(K).GT.105.D0)THEN
                  WRITE(6,'(A,F10.3,A,/,A)')' BY DEFAULT, ONE QUANTUM OF
     1 ENERGY,'//' EQUIVALENT TO',STARTK(K),' CM(-1)',
     2' WILL BE USED TO START THE DRC'
C
C    2.8585086D-3 CONVERTS CM(-1) INTO KCAL/MOLE
C
                  ADDONK=STARTK(K)*2.8585086D-3
                  WRITE(6,'(A,F7.2,A)')' THIS REPRESENTS AN ENERGY OF',A
     1DDONK,' KCALS/MOLE'
               ELSEIF(ABS(HALF).GT.1.D-3)THEN
                  WRITE(6,'(A,F7.2,A)')' THE VIBRATIONAL FREQUENCY (',ST
     1ARTK(K),' IS TOO SMALL FOR ONE QUANTUM TO BE USED'
                  WRITE(6,'(A)')
     1' INSTEAD 0.3KCAL/MOLE WILL BE USED TO START THE IRC'
                  ADDONK=0.3D0
               ELSE
                  ADDONK=0.3D0
               ENDIF
            ENDIF
C
C   AT THIS POINT ADDONK IS IN KCAL/MOLE
C   NORMALIZE SO THAT TOTAL K.E. = ONE QUANTUM (DEFAULT) (DRC ONLY)
C                              OR 0.3KCAL/MOLE (IRC ONLY)
C                              OR ADDONK IF KINETIC=NN SUPPLIED
C
            SUMM=SQRT(ADDONK/(0.5D0*SUMM/4.184D10))
            ADDK=.FALSE.
            IF(SUMM.GT.1.D-10)THEN
               DO  100 I=1,NVAR
  100          VELO0(I)=VELO0(I)*SUMM
            ENDIF
         ENDIF
      ENDIF
  110 CONTINUE
      IUPPER=ILOOP+4999
      ILP=ILOOP
      ONE=0.D0
      IF(INDEX(KEYWRD,'REST').NE.0.AND.INDEX(KEYWRD,'IRC=').EQ.0)
     1ONE=1.D0
      DO 190 ILOOP=ILP,IUPPER
C
C  MOVEMENT OF ATOMS WILL BE PROPORTIONAL TO THE AVERAGE VELOCITIES
C  OF THE ATOMS BEFORE AND AFTER TIME INTERVAL
C
C
C  RAPID CHANGE IN GRADIENT IMPLIES SMALL STEP SIZE FOR DELTAT
C
C   KINETIC ENERGY = 1/2 * M * V * V
C                  = 0.5 / (4.184D10) * M * V * V
C   NEW VELOCITY = OLD VELOCITY + GRADIENT * TIME / MASS
C                = KCAL/ANGSTROM*SECOND/(ATOMIC WEIGHT)
C                =4.184*10**10(ERGS)*10**8(PER CM)*DELTAT(SECONDS)
C   NEW POSITION = OLD POSITION - AVERAGE VELOCITY * TIME INTERVAL
C
C
C   ESTABLISH REFERENCE TOTAL ENERGY
C
         ERROR=(ETOT-(EKIN+ESCF))
         IF(ILOOP.GT.2)THEN
            QUADR = 1.D0+ERROR/(EKIN*CONST+0.001D0)*0.5D0
            QUADR = MIN(1.3D0,MAX(0.8D0,QUADR))
         ELSE
            QUADR=1.D0
         ENDIF
         IF((LET.OR.EKIN.GT.0.2).AND.ADDK)THEN
C
C   DUMP IN EXCESS KINETIC ENERGY
C
            ETOT=ETOT+ADDONK
            ADDK=.FALSE.
            ADDONK=0.D0
         ENDIF
         EKOLD=EKIN
C
C  CALCULATE THE DURATION OF THE NEXT STEP.
C  STEP SIZE IS THAT REQUIRED TO PRODUCE A CONSTANT CHANGE IN GEOMETRY
C
C
C  IF DAMPING IS USED, CALCULATE THE NEW TOTAL ENERGY AND
C  THE RATIO FOR REDUCING THE KINETIC ENERGY
C
         CONST=MAX(1.D-36,0.5D0**(DELTAT*1.D15/HALF))
         CONST=SQRT(CONST)
         VELVEC=0.D0
         EKIN=0.D0
         DELTA1=DELOLD+DLOLD2
         ELOST=0.D0
         DO 120 I=1,NVAR
C
C   CALCULATE COMPONENTS OF VELOCITY AS
C   V = V(0) + V'*T + V"*T*T
C   WE NEED ALL THREE TERMS, V(0), V' AND V"
C
            VELO1(I) = 1.D0/ATMASS(LOC(1,I))*GRAD(I)
            IF(ILOOP.GT.3) THEN
               VELO3(I) = 2.D0/ATMASS(LOC(1,I))*
     1(DELTA1*(GROLD(I)-GRAD(I))-DELOLD*(GROLD2(I)-GRAD(I)))/
     2(DELTA1*(DELOLD**2*1.D30)-DELOLD*(DELTA1**2*1.D30))
               VELO2(I)=1.D0/ATMASS(LOC(1,I))*
     1(GRAD(I)-GROLD(I)-0.5D0*VELO3(I)*(1.D30*DELOLD**2))/(DELOLD*1.D15)
            ELSE
               VELO2(I) = 1.D0/ATMASS(LOC(1,I))*
     1                 (GRAD(I)-GROLD(I))/(1.D15*DELOLD)
               VELO3(I)=0.D0
            ENDIF
C
C  MOVE ATOMS THROUGH DISTANCE EQUAL TO VELOCITY * DELTA-TIME, NOTE
C  VELOCITY CHANGES FROM START TO FINISH, THEREFORE AVERAGE.
C
            PAROLD(I)=XPARAM(I)
            XPARAM(I)=XPARAM(I)
     1             -1.D8*(DELTAT*VELO0(I)*ONE
     2             +0.5D0*DELTAT**2*VELO1(I)
     3             +0.16666D0*(DELTAT**2*1.D15)*DELTAT*VELO2(I)
     4             +0.0416666D0*DELTAT**2*(1.D30*DELTAT**2)*VELO3(I))
C
C   CORRECT ERRORS DUE TO CUBIC COMPONENTS IN ENERGY GRADIENT,
C   ALSO TO ADD ON EXCESS ENERGY, IF NECESSARY.
C
            VELVEC=VELVEC+VELO0(I)**2
C
C   MODIFY VELOCITY IN LIGHT OF CURRENT ENERGY GRADIENTS.
C
C   VELOCITY = OLD VELOCITY + (DELTA-T / ATOMIC MASS) * CURRENT GRADIENT
C                           + 1/2 *(DELTA-T * DELTA-T /ATOMIC MASS) *
C                             (SLOPE OF GRADIENT)
C              SLOPE OF GRADIENT = (GRAD(I)-GROLD(I))/DELOLD
C
C
C   THIS EXPRESSION IS ACCURATE TO SECOND ORDER IN TIME.
C
            VELO0(I) = VELO0(I) + DELTAT*VELO1(I) + 0.5D0*DELTAT**2*VELO
     12(I)*1.D15           + 0.166666D0*DELTAT*(1.D30*DELTAT**2)*VELO3(
     2I)
            IF(LET.OR.GNORM.GT.3.D0)THEN
               LET=.TRUE.
               ELOST=ELOST+VELO0(I)**2*ATMASS(LOC(1,I))*(1-CONST**2)
               VELO0(I)=VELO0(I)*CONST*QUADR
            ENDIF
C
C  CALCULATE KINETIC ENERGY (IN 2*ERGS AT THIS POINT)
C
            EKIN=EKIN+VELO0(I)**2*ATMASS(LOC(1,I))
  120    CONTINUE
         ONE=1.D0
         IF(LET.OR.GNORM.GT.3.D0)THEN
            IF(.NOT.LETOT)THEN
               ETOT=ESCF+ADDONK
               ADDONK=0.D0
               ELOST1=0.D0
               ELOST=0.D0
            ENDIF
            LETOT=.TRUE.
         ENDIF
C
C  CONVERT ENERGY INTO KCAL/MOLE
C
         EKIN=0.5*EKIN/4.184D10
         IF(LETOT.AND.ABS(HALF).GT.0.00001D0)
     1ETOT=ETOT-EKIN/CONST**2+EKIN
         ELOST1=ELOST1+0.5D0*ELOST/4.184D10
C
C STORE OLD GRADIENTS FOR DELTA - VELOCITY CALCULATION
C
         DO 130 I=1,NVAR
            GROLD2(I)=GROLD(I)
            GROLD(I)=GRAD(I)
  130    GRAD(I)=0.D0
C
C   CALCULATE ENERGY AND GRADIENTS
C
         SCFOLD=ESCF
         CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,GRAD,.TRUE.)
         IF(ILOOP.GT.2)THEN
            GNORM=0.D0
            DO 150 I=1,NVAR,3
               SUM=SQRT(DOT(GRAD(I),GRAD(I),3)/
     1(DOT(VELO0(I),VELO0(I),3)+1.D-20))
               DO 140 J=I,I+2
  140          GERROR(J)=GERROR(J)+GRAD(J)+VELO0(J)*SUM
  150       CONTINUE
            GNORM=SQRT(DOT(GERROR,GERROR,NVAR))
            GTOT=GNORM
         ENDIF
         GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
C
C   CONVERT GRADIENTS INTO ERGS/CM
C
         DO 160 I=1,NVAR
  160    GRAD(I)=GRAD(I)*4.184D18
C
C   SPECIAL TREATMENT FOR FIRST POINT - SET "OLD" GRADIENTS EQUAL TO
C   CURRENT GRADIENTS.
C
         IF(ILOOP.EQ.1) THEN
            DO 170 I=1,NVAR
  170       GROLD(I)=GRAD(I)
         ENDIF
         DLOLD2=DELOLD
         DELOLD=DELTAT
         SUM=0.D0
         DO 180 I=1,NVAR
  180    SUM=SUM + ((GRAD(I)-GROLD(I))/4.184D18)**2
         IF(ABS(HALF).LT.0.001D0)THEN
            DELTAT= DELTAT*
     1MIN(2.D0, (5.D-5*ACCU/(ABS(ESCF+ELOST1-ETOLD)+1.D-20)))**0.25D0
            ETOLD=ESCF+ELOST1
            IF(ILOOP.GT.5.AND.SCFOLD-ESCF.LT.-1.D-3 .OR.
     1      ILOOP.GT.30.AND.SCFOLD-ESCF.LT.0.D0)  THEN
               WRITE(6,'(//,'' IRC CALCULATION COMPLETE '')')
               CALL WRAPUP()
            ENDIF
         ELSE
            DELTAT= DELTAT*MIN(1.05D0, 10.D0*ACCU/(SUM+1.D-4))
************************************************************************
*
*         TESTING CODE - REMOVE BEFORE FINAL VERSION ASSEMBLED
C#          (ILOOP/400)*400.EQ.ILOOP)DELTAT=-DELTAT
*
************************************************************************
         ENDIF
         DELTAT=MAX(1.D-16,DELTAT)
         IF(ABS(HALF).LT.0.00001D0)THEN
            CALL PRTDRC(ESCF,DELTAT,XPARAM,GEOREF,
     1ELOST1,GTOT,ETOT,VELO0,NVAR)
         ELSE
            CALL PRTDRC(ESCF,DELTAT,XPARAM,GEOREF,
     1           EKIN,ELOST,ETOT,VELO0,NVAR)
         ENDIF
         TNOW=ZECOND()
         TCYCLE=TNOW-OLDTIM
         OLDTIM=TNOW
         TLEFT=TLEFT-TCYCLE
         IF (ILOOP.EQ.IUPPER.OR.TLEFT.LT.3*TCYCLE) THEN
            IF( INDEX(KEYWRD,'REST')+INDEX(KEYWRD,'ISOT').NE.0)
     +           CLOSE (9)
CDEP
            OPEN(UNIT=9,STATUS='UNKNOWN',FORM='FORMATTED')
C-old            OPEN(UNIT=9,FILE='FOR009',STATUS='NEW',FORM='FORMATTED')
C-old            REWIND 9
            OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old            OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',
C-old     +           FORM='UNFORMATTED')
C-old            REWIND 10
            WRITE(9,'(A)')' CARTESIAN GEOMETRY PARAMETERS IN ANGSTROMS'
            WRITE(9,'(3F19.13)')(XPARAM(I),I=1,NVAR)
            WRITE(9,'(A)')
     +           ' VELOCITY FOR EACH CARTESIAN COORDINATE, IN CM/SEC'
            WRITE(9,'(3F19.3)')(VELO0(I),I=1,NVAR)
            WRITE(9,'(A)')
     +           ' FIRST, SECOND, AND THIRD-ORDER GRADIENTS, ETC'
            WRITE(9,*)(GRAD(I),I=1,NVAR)
            WRITE(9,*)(GROLD(I),I=1,NVAR)
            WRITE(9,*)(GROLD2(I),I=1,NVAR)
            I=ILOOP+1
            WRITE(9,*)ETOT,ESCF,EKIN,DELOLD,DELTAT,DLOLD2,I,
     1           GNORM,LETOT,ELOST1,GTOT
            ESCF=-1.D9
            CALL PRTDRC(ESCF,DELTAT,XPARAM,GEOREF,
     1EKIN,ELOST,ETOT,VELO0,NVAR)
            LINEAR=(NORBS*(NORBS+1))/2
            WRITE(10)(PA(I),I=1,LINEAR)
            IF(NALPHA.NE.0)WRITE(10)(PB(I),I=1,LINEAR)
            WRITE(6,'(//10X,'' RUNNING OUT OF TIME, RESTART FILE WRITTEN
     1'')')
            CALL WRAPUP()
         ENDIF
  190 CONTINUE
      END

      SUBROUTINE SQUAD4 (SFUN,LDER,XI,ETA)
      DOUBLE PRECISION SFUN(4), LDER(2,4), XI, ETA
      DOUBLE PRECISION ONE, FOUR
      PARAMETER (ONE=1.D0, FOUR=4.D0)
      SFUN(1) = (ONE-XI)*(ONE-ETA)/FOUR
      SFUN(2) = (ONE+XI)*(ONE-ETA)/FOUR
      SFUN(3) = (ONE+XI)*(ONE+ETA)/FOUR
      SFUN(4) = (ONE-XI)*(ONE+ETA)/FOUR
      LDER(1,1) = (ETA-ONE)/FOUR
      LDER(2,1) = (XI-ONE)/FOUR
      LDER(1,2) = (-ETA+ONE)/FOUR
      LDER(2,2) = (-XI-ONE)/FOUR
      LDER(1,3) = (ETA+ONE)/FOUR
      LDER(2,3) = (XI+ONE)/FOUR
      LDER(1,4) = (-ETA-ONE)/FOUR
      LDER(2,4) = (-XI+ONE)/FOUR
      RETURN
      END

      SUBROUTINE FORSAV(TIME,DELDIP,IPT,N3,FMATRX, COORD,NVAR,REFH,
     1                  EVECS,JSTART,FCONST)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION FMATRX(*), DELDIP(3,*), COORD(*), EVECS(*), FCONST(*)
************************************************************************
*
*  FORSAV SAVES AND RESTORES DATA USED IN THE FORCE CALCULATION.
*
* ON INPUT TIME = TOTAL TIME ELAPSED SINCE THE START OF THE CALCULATION.
*          IPT  = LINE OF FORCE MATRIX REACHED, IF IN WRITE MODE,
*               = 0 IF IN READ MODE.
*        FMATRX = FORCE MATRIX
************************************************************************
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
CDEP
      OPEN(UNIT=9,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=9,FILE='FOR009',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 9
      OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 10
      IR=9
      IW=9
      IF( IPT .EQ. 0 ) THEN
C
C   READ IN FORCE DATA
C
         READ(IR,END=20,ERR=20)TIME,IPT,REFH
         LINEAR=(NVAR*(NVAR+1))/2
         READ(IR)(COORD(I),I=1,NVAR)
         READ(IR,END=10,ERR=10)(FMATRX(I),I=1,LINEAR)
         READ(IR)((DELDIP(J,I),J=1,3),I=1,IPT)
         N33=NVAR*NVAR
         READ(IR)(EVECS(I),I=1,N33)
         READ(IR)JSTART,(FCONST(I),I=1,NVAR)
         RETURN
      ELSE
C
C    WRITE FORCE DATA
C
         REWIND IW
         IF(TIME.GT.1.D6)TIME=TIME-1.D6
         WRITE(IW)TIME,IPT,REFH
         LINEAR=(NVAR*(NVAR+1))/2
         WRITE(IW)(COORD(I),I=1,NVAR)
         WRITE(IW)(FMATRX(I),I=1,LINEAR)
         WRITE(IW)((DELDIP(J,I),J=1,3),I=1,IPT)
         N33=NVAR*NVAR
         WRITE(IR)(EVECS(I),I=1,N33)
         WRITE(IR)JSTART,(FCONST(I),I=1,NVAR)
         LINEAR=(NORBS*(NORBS+1))/2
         WRITE(10)(PA(I),I=1,LINEAR)
         IF(NALPHA.NE.0)WRITE(10)(PB(I),I=1,LINEAR)
         CLOSE(9)
         CLOSE(10)
      ENDIF
      RETURN
   10 WRITE(6,'(''INSUFFICIENT DATA ON DISK FILES FOR A FORCE '',
     1''CALCULATION'',/10X,''RESTART. PERHAPS THIS STARTED OF AS A '',
     2''FORCE CALCULATION '')')
      WRITE(6,'(10X,''BUT THE GEOMETRY HAD TO BE OPTIMIZED FIRST, '',
     1''IN WHICH CASE '',/10X,''REMOVE THE KEY-WORD "FORCE".'')')
      CALL WRAPUP()
   20 WRITE(6,'(//10X,''NO RESTART FILE EXISTS!'')')
      CALL WRAPUP()
      END

      SUBROUTINE EXCHNG (A,B,C,D,X,Y,T,Q,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(*), Y(*)
C********************************************************************
C
C THE CONTENTS OF A, C, T, AND X ARE STORED IN B, D, Q, AND Y!
C
C   THIS IS A DEDICATED ROUTINE, IT IS CALLED BY LINMIN AND LOCMIN ONLY.
C
C********************************************************************
      B=A
      D=C
      Q=T
      DO 10 I=1,N
         Y(I)=X(I)
   10 CONTINUE
      RETURN
C
      END

                      REAL FUNCTION RKRN (DS)                                  
C ======================================================================       
C                   FUNCTION SUBROUTINE RKRN                                    
C                                                                               
C  THIS SUBROUTINE INITIALIZES THE RANDOM NUMBER INSEED VECTOR                  
C  AND UPDATES DSEED EVERY TIME ITS CALLED .                                    
C                                                                               
C  IT IS IDENTICAL TO IMSL'S GGUBFS EXCEPT WHERE SO STATED . JK, TAN 88         
C                                                                               
C* THIS IS A CRAY XM-P VERSION WITH MAXIMUM INTEGER 2**46 - 1                   
C ----------------------------------------------------------------------        
C                                                                               
      REAL*8  DS, D2                                                              
C                                                                               
C --- WITH THIS CHOICE OF DS RKRN [0,1] ----------                              
C     DATA             D2/70368744177663./                                      
C                                                                               
C --- WITH THIS CHOICE OF DS RKRN [0,1) ----------                              
      SAVE D2
      DATA             D2/2147483647.D0/                                      
C                                                                               
          DS  = DMOD(16807.D0 * DS, D2)                                            
          RKRN= DS/D2                                                           
C                                                                               
      RETURN                                                                    
      END                                                                       

      SUBROUTINE ROSYM4 (A1,A2,A3,B1,B2,B3,ISY,NC,IB,V,R,RB,
     +  NPLWV,NG1,NG2,NG3,ROINP,ROSYMM,LPCTX,LPCTY,LPCTZ,
     +  LPCTXI,LPCTYI,LPCTZI,IPRINT)
      IMPLICIT COMPLEX (C)
C
C     WRITTEN ON JANUARY 2ND, 1980 - FROM ROSYM1.
C     LOOKUP OF G-VECTORS MODIFIED 19-MAY-82 BY OHN.
C     ROTATION MATRICES MODIFIED 02-MAR-84 BY OHN.
C
C SYMMETRIZATION OF (FOURIER COMPONENTS OF) CHARGE DENSITY
C BY POINT-GROUP SYMMETRY OPERATIONS
C SUBROUTINES NEEDED: LOOKUP
C ROSYMM(G)=(1/NC)*SUM( EXP(I*G*V(R(J)))*ROINP(R(J)**(-1)*G) )
C WHERE THE SUM RUNS OVER ALL NC POINT-GROUP ROTATIONS R.
C
C INPUT DATA:
C      A1....B3 ... ELEMENTARY TRANSLATIONS OF THE DIRECT
C               AND RECIPROCAL LATTICES
C      NPLWV ...NG1*NG2*NG3
C      NG1,...IGLIST ... SEE THE SUBROUTINE RLV4
C               INPUT DATA WHICH MAY BE OBTAINED FROM SBRT. GROUP1:
C      ISY .... CODE INDICATING WHETHER THE SPACE GROUP OF CRYSTAL
C               IS SYMMORPHIC OR NONSYMMORPHIC
C               ISY=0 MEANS NONSYMMORPHIC GROUP
C               ISY=1 MEANS SYMMORPHIC GROUP
C      NC ..... TOTAL NUMBER OF ELEMENTS IN THE POINT GROUP OF THE
C               CRYSTAL
C      IB ..... LIST OF THE ROTATIONS CONSTITUTING THE POINT GROUP
C               OF THE CRYSTAL. THE NUMBERING IS THAT DEFINED IN
C               WORLTON AND WARREN, I.E. THE ONE MATERIALIZED IN THE
C               ARRAY R (SEE BELOW)
C               ONLY THE FIRST NC ELEMENTS OF THE ARRAY IB ARE
C               MEANINGFUL
C      V ...... NONPRIMITIVE TRANSLATIONS (IN THE CASE OF NONSYMMOR-
C               PHIC GROUPS). V(I,N) IS THE I-TH COMPONENT
C               OF THE TRANSLATION CONNECTED WITH THE N-TH ELEMENT
C               OF THE POINT GROUP (I.E. WITH THE ROTATION
C               NUMBER IB(N) ).
C               ATTENTION: V(I) HAVE TO BE GIVEN IN THE
C               BASIS A1,A2,A3 AND NOT AS CARTESIAN COMPONENTS.
C               (I.E. ONE CAN USE THE OUTPUT OF THE
C               SUBROUTINE GROUP1 WITHOUT ANY MODIFICATION.)
C      R ...... LIST OF THE 3 X 3 ROTATION MATRICES
C               (XYZ REPRESENTATION OF THE O(H) OR D(6)H GROUPS)
C               ALL 48 OR 24 MATRICES ARE LISTED.
C      ROINP .. ARRAY WITH ELEMENTS RO(G) CORRESPONDING TO
C               G-VECTORS LISTED IN THE IGLIST.
C               THIS IS THE ARRAY TO BE SYMMETRIZED. (IN NORMAL
C               CASES, IT WILL BE OBTAINED AS WEIGHTED SUM OF
C               RO(WVK,G) (SBRT. RO5) OVER A SET OF SPECIAL
C               POINTS WVK.)
C      ROSYMM . WORK ARRAY
C
C OUTPUT DATA:
C      ROINP .. THE SYMMETRIZED ARRAY
C      ROSYMM . EQUAL TO ROINP ON EXIT
C
      DIMENSION A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),IB(48),V(3,48)
      DIMENSION RB(48,3,3),SUM(3,3),IGL(3,48),R(49,3,3)
      DIMENSION LPCTX(NG1),LPCTY(NG2),LPCTZ(NG3)
      DIMENSION LPCTXI(-NG1/2:NG1/2),LPCTYI(-NG2/2:NG2/2)
      DIMENSION LPCTZI(-NG3/2:NG3/2)
      COMPLEX ROINP(NPLWV),ROSYMM(NPLWV),CROSUM
C
C.....PHYSICAL AND MATHEMATICAL CONSTANTS
      DOUBLE PRECISION PI
C
      DATA INITLZ /0/
      SAVE INITLZ
           PI   = 3.141592654D0
C-----------------------------------------------------------------------
C
      INIPRN = 0
      IF (INITLZ .NE. 0) GOTO 50
      INIPRN = 1
C
C     INITIALIZATION:
C
C     CHECK THAT THE FIRST SYMMETRY OPERATION IN THE LIST IS IDENTITY
      IF (IB(1) .NE. 1) THEN
        WRITE (*,*) '*** ERROR *** ROSYM4'
        WRITE (*,99 ) (IB(I),I=1,NC)
        CALL EXIT
      ENDIF
C
C     EXPRESS THE ROTATION MATRICES IN THE BASIS B1,B2,B3:
C     (ACTUALLY, RB CONTAINS R**(-1) IN THIS BASIS;
C     R**(-1) IS JUST R(TRANSPOSE), BUT NOT SO FOR RB !!!).
C
      DO 40 N = 1 , NC
        IC = IB(N)
        DO 10 I = 1 , 3
          DO 10 J = 1 , 3
            SUM(I,J) = 0.0
10      CONTINUE
        DO 20 I = 1 , 3
          DO 20 J = 1 , 3
            SUM(1,1) = SUM(1,1) + A1(I) * R(IC,J,I) * B1(J)
            SUM(2,1) = SUM(2,1) + A2(I) * R(IC,J,I) * B1(J)
            SUM(3,1) = SUM(3,1) + A3(I) * R(IC,J,I) * B1(J)
            SUM(1,2) = SUM(1,2) + A1(I) * R(IC,J,I) * B2(J)
            SUM(2,2) = SUM(2,2) + A2(I) * R(IC,J,I) * B2(J)
            SUM(3,2) = SUM(3,2) + A3(I) * R(IC,J,I) * B2(J)
            SUM(1,3) = SUM(1,3) + A1(I) * R(IC,J,I) * B3(J)
            SUM(2,3) = SUM(2,3) + A2(I) * R(IC,J,I) * B3(J)
            SUM(3,3) = SUM(3,3) + A3(I) * R(IC,J,I) * B3(J)
20      CONTINUE
        DO 30 I = 1 , 3
          DO 30 J = 1 , 3
            RB(N,I,J) = SUM(I,J)
30      CONTINUE
        IF (IPRINT.GE.3) WRITE (*,550) N,IC,
     &                  ((SUM(I,J),J=1,3),I=1,3)
40    CONTINUE
C
      DO 90 I = 1 , NG1
         IG1 = LPCTX(I)
         LPCTXI(IG1) = I
 90   CONTINUE
C
      DO 91 I = 1 , NG2
         IG2 = LPCTY(I)
         LPCTYI(IG2) = I
 91   CONTINUE
C
      DO 92 I = 1 , NG3
         IG3 = LPCTZ(I)
         LPCTZI(IG3) = I
 92   CONTINUE
C
      INITLZ = 1
C-----------------------------------------------------------------------
      IF (IPRINT.GE.1) THEN
        WRITE (*,*) '  A VECTORS IN ROSYM...'
        WRITE (*,1112) (A1(I),I=1,3)
        WRITE (*,1112) (A2(I),I=1,3)
        WRITE (*,1112) (A3(I),I=1,3)
        WRITE (*,*) '  B VECTORS IN ROSYM...'
        WRITE (*,1112) (B1(I),I=1,3)
        WRITE (*,1112) (B2(I),I=1,3)
        WRITE (*,1112) (B3(I),I=1,3)
      END IF
C
50    IF (NC .EQ. 1) THEN
        RETURN
      ELSE IF (NC .LT. 1 .OR. NC .GT. 48) THEN
        WRITE(*,*) '***ERROR*** ROSYM4'
        WRITE(*,*) 'NC = ',NC,' IS NOT ALLOWED'
        CALL EXIT
      ENDIF
C
C==================================================================
C  LOOP OVER G-VECTORS
C==================================================================
      INDEX = 0
C
      DO 100 K = 1 , NG3
        IG3 = LPCTZ(K)
        DO 100 J = 1 , NG2
          IG2 = LPCTY(J)
          DO 100 I = 1 , NG1
            IG1 = LPCTX(I)
            INDEX = INDEX + 1
            CROSUM = (0.0,0.0)
C
            DO 70 N = 2 , NC
              NN = N
C==================================================================
C   APPLICATION OF R**(-1) TO G (SEE NOTE ABOVE)
C==================================================================
              IGL1 = NINT( RB(N,1,1) * IG1 + RB(N,1,2) * IG2 + 
     &                     RB(N,1,3) * IG3 )
              IGL2 = NINT( RB(N,2,1) * IG1 + RB(N,2,2) * IG2 + 
     &                     RB(N,2,3) * IG3 )
              IGL3 = NINT( RB(N,3,1) * IG1 + RB(N,3,2) * IG2 + 
     &                     RB(N,3,3) * IG3 )
              IF (IGL1.GT.NG1/2 .OR. IGL1.LT.-NG1/2 .OR.
     &            IGL2.GT.NG2/2 .OR. IGL2.LT.-NG2/2 .OR.
     &            IGL3.GT.NG3/2 .OR. IGL3.LT.-NG3/2) GO TO 199
C
              IF (IGL1.EQ.-NG1/2) IGL1 = NG1 / 2
              IF (IGL2.EQ.-NG2/2) IGL2 = NG2 / 2
              IF (IGL3.EQ.-NG3/2) IGL3 = NG3 / 2
C
              IPLACE =  LPCTXI(IGL1) + NG1 * ( LPCTYI(IGL2) - 1 ) 
     +                  + NG1 * NG2 * ( LPCTZI(IGL3) - 1 )
              IF (ISY .EQ. 0) THEN
C==================================================================
C  NONSYMMORPHIC GROUP - SIGN OF ARG IS DIFFERENT FROM THAT IN
C  RICHARD NEEDS'S PROGRAM!
C==================================================================     
C        ARG = -2.0 * PI * ( IG1*V(1,N) + IG2*V(2,N) + IG3*V(3,N) )
C
                ARG = 2.0 * PI * ( IG1 * V(1,N) + IG2 * V(2,N) + 
     &                             IG3 * V(3,N) )
                CROSUM = CROSUM + 
     &                   ROINP(IPLACE) * CMPLX ( COS(ARG),SIN(ARG) )
              ELSE
C==================================================================
C  SYMMORPHIC GROUP
C==================================================================
                CROSUM = CROSUM + ROINP(IPLACE)
              ENDIF
C
 70         CONTINUE
C==================================================================
            ROSYMM(INDEX) = ROINP(INDEX) + CROSUM
            IF (IPRINT.GE.2) THEN
              CDUM = ROSYMM(INDEX) / FLOAT(NC)
              IF (ABS(CDUM).GT.0.1 .OR. ABS(ROINP(INDEX)).GT.0.1) 
     &           WRITE (*,661) INDEX,IG1,IG2,IG3,ROINP(INDEX),CDUM
            END IF
            GO TO 100
C
199         ROSYMM(INDEX) = (0.0,0.0)
            IF (IPRINT.GE.2.AND.INIPRN.EQ.1) 
     &      WRITE (*,1113) IG1,IG2,IG3,IGL1,IGL2,IGL3,NN
100   CONTINUE
C
      DO 110 I = 1 , NPLWV
        ROSYMM(I) = ROSYMM(I) / FLOAT(NC)
        ROINP(I)  = ROSYMM(I)
110   CONTINUE
C
1111  FORMAT(5X,2(3I5,5X))
1112  FORMAT(5X,3F15.6)
1113  FORMAT(' IG:',3I4,' IMAGE OUT OF GRID:',3I4,' N=',I2)
661   FORMAT(1X,I5,1X,3I2,1X,2E11.4,2X,2E11.4)
 550  FORMAT(1X,'N,IC=',2I3/3(3F8.4))
99    FORMAT (' THERE IS SOMETHING WRONG WITH THE LIST OF '/
     +  'SYMMETRY OPERATIONS OF THE POINT GROUP, IB:'/4(/1X,12I3))
      RETURN
      END

      SUBROUTINE MFILL (N1,N2,M,VAL)
      INTEGER N1,N2
      DOUBLE PRECISION M(N1,*), VAL
      INTEGER I,J
      DO 10 I=1,N1
         DO 10 J=1,N2
            M(I,J) = VAL
 10   CONTINUE
      RETURN
      END

      SUBROUTINE MATNUL (A,NROWA,NCOLA)
      INTEGER NROWA, NCOLA
      DOUBLE PRECISION A(NROWA*NCOLA)
      INTEGER I
      DO 100 I=1,NROWA*NCOLA
         A(I) = 0.D0
 100  CONTINUE
      RETURN
      END

      DOUBLE PRECISION FUNCTION DOT(X,Y,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(*), Y(*)
************************************************************************
*
*   DOT FORMS THE SCALAR PRODUCT OF TWO VECTORS.
*
*   ON INPUT     X   =    FIRST VECTOR, OF LENGTH N.
*                Y   =    SECOND VECTOR, OF LENGTH N.
*
*   ON RETURN    DOT =    DOT PRODUCT OF X AND Y.
*
************************************************************************
      DOT = 0.0D0
      DO 10 I=1,N
   10 DOT = DOT + X(I)*Y(I)
      RETURN
      END

      SUBROUTINE EIGENV(A,ZK,YK,NN,CTOL,MAXIT,ICOUNT,ESHIFT,EIGV)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(NN,NN),ZK(NN),YK(NN)      
      EXTERNAL DOTVEC
C.. ITERATE
      EIGVAL=ESHIFT
      NITER=0
 100  CONTINUE
      EIGLAM=EIGVAL
      NITER=NITER+1
      IF (NITER.GT.MAXIT) STOP '**EIGENV: TOO MANY ITERATIONS'
      RECIP=1/DSQRT(DOTVEC(ZK,ZK,NN))
      DO 300 I=1,NN
C*    YK(I)=ZK(I)*RECIP
         ZK(I)=ZK(I)*RECIP
         YK(I)=ZK(I)
 300  CONTINUE
      CALL DECOM3(2,A,ZK,NN)
C*    CALL MATVEC(A,YK,NN,ZK)
      EIGNEW=DOTVEC(YK,ZK,NN)
      EIGVAL=ESHIFT+1/EIGNEW
C*    EIGVAL=EIGNEW
      WRITE(6,1000) NITER,EIGVAL,EIGNEW,DABS(ZK(1))
 1000 FORMAT(1X,I5,': ',1P,G13.5,' - ',G13.5,' CONTROL VALUE: ',G13.5)
      C=DABS(1.-EIGLAM/EIGVAL)
      IF (C.GT.CTOL) GOTO 100
 200  CONTINUE            
      WRITE(6,1010) ICOUNT,EIGVAL,NITER
 1010 FORMAT(
     +     2X,'>>> ',I5,'. EIGENVALUE=',1P,G20.10,', ITERATIONS=',I5/)
      EIGV=EIGVAL
      RETURN
      END

C     ****************
      SUBROUTINE MKTBL(NVH,ORDEXP,SIGMA,TBL,WK1,WK2,WK3,WK4)
C     ****************
C
C
      DOUBLE PRECISION TBL(NVH,2,18),
     >                 WK1(NVH,18),WK2(NVH,18),WK3(NVH,18),WK4(NVH,18),
     >                 RGAUSS(8),
     >                 DRAND,
     >                 SQRT3I,TWO,ONE,HALF,ZERO,SIX,
     >                 SIGMA,FAKUL
C
      INTEGER          ORDEXP
C
      PARAMETER( SQRT3I = 0.57735026918962576E0 )
      PARAMETER( TWO    = 2.E0                  )
      PARAMETER( ONE    = 1.E0                  )
      PARAMETER( HALF   = 0.5E0                 )
      PARAMETER( ZERO   = 0.E0                  )
      PARAMETER( SIX    = 6.0E0                 )
C
C
C     LOOP OVER THE TABLE SIZE
C
C
      DO 10 I=1,NVH
C
C
C     GENERATING EIGHT GAUSSIAN RANDOM NUMBERS WITH VARIANCE SIGMA;
C     THE FACTOR ONE HALF APPEARS BY THE REPRESENTATION OF THE SU3
C     MATRICES
C
C
      DO 20 J=1,8
C
      RGAUSS(J) = - SIX
C
      DO 30 IDU=1,12
      RGAUSS(J) = RGAUSS(J) + DRAND(0)
   30 CONTINUE
C
      RGAUSS(J) = RGAUSS(J) * SIGMA * HALF
C
   20 CONTINUE
C
      WK1(I, 1) =   RGAUSS(3) + RGAUSS(8) * SQRT3I
      WK1(I, 2) =   RGAUSS(1)
      WK1(I, 3) =   RGAUSS(4)
      WK1(I, 4) =   RGAUSS(1)
      WK1(I, 5) = - RGAUSS(3) + RGAUSS(8) * SQRT3I
      WK1(I, 6) =   RGAUSS(6)
      WK1(I, 7) =   RGAUSS(4)
      WK1(I, 8) =   RGAUSS(6)
      WK1(I, 9) = -             RGAUSS(8) * SQRT3I * TWO
      WK1(I,10) =   ZERO
      WK1(I,11) =   RGAUSS(2)
      WK1(I,12) =   RGAUSS(5)
      WK1(I,13) = - RGAUSS(2)
      WK1(I,14) =   ZERO
      WK1(I,15) =   RGAUSS(7)
      WK1(I,16) = - RGAUSS(5)
      WK1(I,17) = - RGAUSS(7)
      WK1(I,18) =   ZERO
C
   10 CONTINUE
C
C
C     EXPANDING THE EXPONENTIAL FUNCTION TO ORDER ORDEXP
C
C
C     INITIALIZATION
C
C
      DO 40 IC=1,18
      DO 40 I =1,NVH
      WK2(I,IC) = WK1(I,IC)
   40 CONTINUE
C
      DO 50 I=1,NVH
C
      WK4(I, 1) = ONE
      WK4(I, 2) = ZERO
      WK4(I, 3) = ZERO
      WK4(I, 4) = ZERO
      WK4(I, 5) = ONE
      WK4(I, 6) = ZERO
      WK4(I, 7) = ZERO
      WK4(I, 8) = ZERO
      WK4(I, 9) = ONE
      WK4(I,10) = ZERO
      WK4(I,11) = ZERO
      WK4(I,12) = ZERO
      WK4(I,13) = ZERO
      WK4(I,14) = ZERO
      WK4(I,15) = ZERO
      WK4(I,16) = ZERO
      WK4(I,17) = ZERO
      WK4(I,18) = ZERO
C
   50 CONTINUE
C
      IPM = 1
C
C
C     ********
      CALL ADD(NVH,NVH,IPM,WK4,WK4,WK1)
C     ********
C
C
      DO 60 IO = 2,ORDEXP
C
      IPM = 1
C
C
C     ********
      CALL PRO(NVH,NVH,IPM,WK3,WK2,WK1)
C     ********
C
C
      FAKUL = ONE / DBLE( IO )
C
      DO 70 IC=1,18
      DO 70 I =1,NVH
      WK2(I,IC) = WK3(I,IC) * FAKUL
   70 CONTINUE
C
      IPM = MOD(IO,4)
      IF( IPM .EQ. 0 ) IPM = 4
C
C
C     ********
      CALL ADD(NVH,NVH,IPM,WK4,WK4,WK2)
C     ********
C
C
   60 CONTINUE
C
C
C     RENORMILIZATION OF WK4
C
C
C     ***********
      CALL RENORM( NVH, WK4 )
C     ***********
C
C
C     FILL UP THE LOWER HALF OF TBL WITH WK4
C
C
      DO 90 ISM =1,18
      DO 90 ILP=1,NVH
      TBL(ILP,1,ISM) = WK4(ILP,ISM)
   90 CONTINUE
C
      DO 110 ILP = 1,NVH
C
      TBL(ILP,2, 1) =   WK4(ILP, 1)
      TBL(ILP,2, 2) =   WK4(ILP, 4)
      TBL(ILP,2, 3) =   WK4(ILP, 7)
      TBL(ILP,2, 4) =   WK4(ILP, 2)
      TBL(ILP,2, 5) =   WK4(ILP, 5)
      TBL(ILP,2, 6) =   WK4(ILP, 8)
      TBL(ILP,2, 7) =   WK4(ILP, 3)
      TBL(ILP,2, 8) =   WK4(ILP, 6)
      TBL(ILP,2, 9) =   WK4(ILP, 9)
C
      TBL(ILP,2,10) = - WK4(ILP,10)
      TBL(ILP,2,11) = - WK4(ILP,13)
      TBL(ILP,2,12) = - WK4(ILP,16)
      TBL(ILP,2,13) = - WK4(ILP,11)
      TBL(ILP,2,14) = - WK4(ILP,14)
      TBL(ILP,2,15) = - WK4(ILP,17)
      TBL(ILP,2,16) = - WK4(ILP,12)
      TBL(ILP,2,17) = - WK4(ILP,15)
      TBL(ILP,2,18) = - WK4(ILP,18)
C
 110  CONTINUE
C
C
      RETURN
      END
C
C

C----------------------------------------------------------------------
C
C  A N T I B
C
C  THIS FAR WE HAVE COMPUTED THE ORBIT OF THE BARYCENTRE OF
C  THE EARTH-MOON SYSTEM; NOW MOVE THE ORIGIN TO THE CENTRE OF THE EARTH
C  AE S.E1 (1982), NOTE 6
C
C----------------------------------------------------------------------
      SUBROUTINE ANTIB(X,Y,Z,T)
      REAL
     .    X,Y,Z,T
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C 
C
      REAL
     .    L,JC
C
      JC=T/36525.0E+0 
      L=AMOD (270+481268*JC,360.0E+0) * DTORAD
      X=X-0.0000312*COS(L)
      Y=Y-0.0000312*SIN(L)
      Z=Z
      RETURN
      END

      FUNCTION HELECT(N,P,H,F)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(*), H(*), F(*)
C***********************************************************************
C
C    SUBROUTINE CALCULATES THE ELECTRONIC ENERGY OF THE SYSTEM IN EV.
C
C    ON ENTRY N = NUMBER OF ATOMIC ORBITALS.
C             P = DENSITY MATRIX, PACKED, LOWER TRIANGLE.
C             H = ONE-ELECTRON MATRIX, PACKED, LOWER TRIANGLE.
C             F = TWO-ELECTRON MATRIX, PACKED, LOWER TRIANGLE.
C    ON EXIT
C        HELECT = ELECTRONIC ENERGY.
C
C    NO ARGUMENTS ARE CHANGED.
C
C***********************************************************************
      ED=0.0D00
      EE=0.0D00
      K=0
      NN=N+1
      DO 20 I=2,NN
         K=K+1
         JJ=I-1
         ED=ED+P(K)*(H(K)+F(K))
         IF (I.EQ.NN) GO TO 20
         DO 10 J=1,JJ
            K=K+1
   10    EE=EE+P(K)*(H(K)+F(K))
   20 CONTINUE
      EE=EE+.5D00*ED
      HELECT=EE
      RETURN
C
      END

      SUBROUTINE PRESS (GEOM,QLOK,XK,EPS,PRES,NODEL)
      DOUBLE PRECISION GEOM(*), QLOK(*), XK(*), EPS, PRES
      INTEGER DIM, NODEL, DOFEL, I, MNODEL, MDOF
      PARAMETER (DIM=2, MNODEL=8, MDOF=2*MNODEL)
      DOUBLE PRECISION SFUN(MNODEL), LDER(DIM,MNODEL), GDER(DIM,MNODEL)
      DOUBLE PRECISION JAC(DIM,DIM), JACIN(DIM,DIM), DIV(MDOF)
      DOUBLE PRECISION XI, ETA, DETK, SDOT
      DOFEL=2*NODEL

      XI = 0.D0
      ETA = 0.D0
      IF(NODEL.EQ.4) THEN
      ELSE
         print *,'NODEL IN PRESS'
         STOP
      ENDIF
      CALL MXM (SFUN,1,GEOM,NODEL,XK,DIM)
      CALL MXM (LDER,DIM,GEOM,NODEL,JAC,DIM)
      CALL INV2X2 (JAC,JACIN,DETK)
      CALL MXM (JACIN,DIM,LDER,DIM,GDER,NODEL)
      DO 100 I=1,NODEL
         DIV(2*I-1) = GDER(1,I)
         DIV(2*I)   = GDER(2,I)
 100  CONTINUE
      PRES = SDOT (DOFEL,QLOK,1,DIV,1)
      PRES = -PRES/EPS
      RETURN
      END

      DOUBLE PRECISION FUNCTION SPDOT (N,X,INDEX,Y)
      INTEGER N, INDEX(*)
      DOUBLE PRECISION X(*), Y(*)
      INTEGER I, II
      SPDOT = 0.0D0
      DO 100 I=1,N
         II = INDEX(I)
         SPDOT = SPDOT + X(II)*Y(I)
 100  CONTINUE
      RETURN
      END

      SUBROUTINE CONVEL (NODEL,XVELO,YVELO,UPREV,STEER)
      INTEGER NODEL,STEER(*)
      DOUBLE PRECISION XVELO(*),YVELO(*),UPREV(*)
      INTEGER I

      DO 10 I=1,NODEL
        XVELO(I)=UPREV(2*STEER(I)-1)
        YVELO(I)=UPREV(2*STEER(I))
10    CONTINUE
      RETURN
      END

C--------------------------------------------------------------------------
C
C   I N T I N I
C
C   INITIALIZE CONSTANT TABLES NEEDED FOR INTEGRATION
C
C----------------------------------------------------------------------
      SUBROUTINE INTINI
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C 
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)
      REAL
     .    EPOCH,
     .    SBINC(0:ORDER,0:ORDER),
     .    DD(0:ORDER),
     .    KK(-MMM:MMM,-MMM:MMM),
     .    MASS(MAXOBJ),
     .    COORD(3,MAXOBJ),
     .    VELOC(3,MAXOBJ),
     .    XDIFF(3,MAXOBJ),       
     .    ACCEL(-MMM:MMM,3,MAXOBJ,0:1),
     .    ADIFF(maxobj,0:ORDER,3),  
     .    DISTNC(MAXOBJ,MAXOBJ)        
      INTEGER SWAP
C
      COMMON /INTTAB/    SBINC,DD,KK,
     .                   COORD,VELOC,MASS,
     .                   XDIFF,ACCEL,ADIFF,DISTNC,SWAP,
     .                   EPOCH
C
C  LOCAL VARIABLES
C
      INTEGER I,J,K 
      REAL
     .    SUM,
     .    C(-1:ORDER,0:MMM),
     .    CC(0:ORDER),
     .    R(0:ORDER,-MMM:MMM),
     .    FAC(0:ORDER),
     .    EE(0:ORDER)
C
C FACTORIALS OF 0..ORDER 
C
      FAC(0)=1 
      DO 10 I=1,ORDER     
         FAC(I)=I*FAC(I-1) 
 10   CONTINUE
C
C SIGNED BINOMIAL COEFFICIENTS
C
      DO 21 I=0,ORDER
        DO 20 J=0,I
           SBINC(I,J)=FAC(I)/FAC(J)/FAC(I-J)
           IF (MOD(J,2) .EQ. 1) SBINC(I,J)=-SBINC(I,J)
 20      CONTINUE 
 21   CONTINUE
C
C DD
C
      DD(0)=1 
      DO 31 I=1,ORDER
        SUM=0.0
        DO 30 J=0,I-1
           SUM=SUM-DD(J)/(I+1-J)
 30     CONTINUE
        DD(I)=SUM
 31   CONTINUE 
C
C CC
C
      DO 41 I=0,ORDER
        SUM=0.0 
        DO 40 K=0,I
           SUM=SUM+DD(K)*DD(I-K)
 40     CONTINUE
        CC(I)=SUM 
 41   CONTINUE 
C
C DD 
C
      DO 50 I=1,ORDER 
         DD(I)=DD(I)*(1-I)
 50   CONTINUE
C
C  EE
C
      DO 61 I=0,ORDER
         SUM=0.0
         DO 60 K=2,I+2
            SUM=SUM+CC(I+2-K)/K
 60      CONTINUE
         EE(I)=SUM 
 61   CONTINUE
C
C  C
C
      DO 70 I=0,MMM
         C(2*I+1,I)=1.0
 70   CONTINUE
      DO 72 J=1,ORDER
         DO 71 I=J/2 +1,MMM
            C(J,I)=C(J-2,I-1)-I*I*C(J,I-1) 
 71      CONTINUE
 72   CONTINUE
C
C  R
C
      DO 81 I=-MMM,MMM
         R(2*MMM,I)=1.0
         DO 80 J=2*MMM,1,-1
            R(J-1,I)=C(J,MMM)+I*R(J,I) 
 80      CONTINUE
 81   CONTINUE
C
C  KK
C
      DO 92 I=1,MMM
         DO 91 J=-MMM,MMM
            SUM=0.0 
            DO 90 K=2*MMM,0,-1
               SUM=(SUM+R(K,J)/(K+2)/(K+1))*I 
 90         CONTINUE
            KK(I,J)=SUM*I/FAC(MMM+J)/FAC(MMM-J)
            IF (MOD(MMM-J,2) .EQ. 1) KK(I,J)=-KK(I,J)
            KK(-I,-J)=KK(I,J)
 91      CONTINUE
 92   CONTINUE
C
      RETURN 
      END

C     ****************
      SUBROUTINE HYPPL(
C     ****************
     >                 NXE,NXYE,NXYZE,
     >                 GL,LL,NVL,ID1,ID2,ID3,ID4,IU1,IU2,IU3,IU4 )
C
C
C     GENERATION OF INDEX LISTS FOR GATHERING LINK VARAIABLES OF
C     EVEN OR ODD LATTICE POINTS
C
C
      INTEGER GL(NVL,2),LL(2)
C
C
C     DEFINITION OF STATEMENT FUNCTION LPA (LATTICE POINT ADDRESS):
C
C
      LPA(IX,IY,IZ,IT) = IX + ( IY - 1 ) * NXE + ( IZ - 1 ) * NXYE  +
     >                                           ( IT - 1 ) * NXYZE
C
C
      LPE = 0
      LPO = 0
C
      DO 10 L = ID4,IU4
      DO 10 K = ID3,IU3
      DO 10 J = ID2,IU2
      DO 10 I = ID1,IU1
C
      IS = I + J + K + L
      IC = IS / 2
      IC = IC * 2
C
      IF( IS .EQ. IC ) THEN
          LPE = LPE + 1
          GL(LPE,1) = LPA(I,J,K,L)
      ELSE
          LPO = LPO + 1
          GL(LPO,2) = LPA(I,J,K,L)
      ENDIF
C
   10 CONTINUE
C
      LL(1) = LPE
      LL(2) = LPO
C
C
      RETURN
      END

      INTEGER FUNCTION ISAMAX (N,X,INCX)
      INTEGER N, INCX
      DOUBLE PRECISION X(*)
      DOUBLE PRECISION SMAX
      INTEGER I, IX
      ISAMAX = 0
      SMAX = 0.0D0
      IX = 1
      DO 100 I=1,N
         IF(ABS(X(IX)).GT.SMAX) THEN
            ISAMAX = IX
            SMAX = ABS(X(IX))
         ENDIF
         IX = IX + INCX
 100  CONTINUE
      RETURN
      END

      SUBROUTINE BICONG(JDIM,KDIM,NX,NY,J1,J2,DY,THICK1,TOP,RIGHT,ALEFT
     +                   ,X,Y)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM)
      COMMON/WORKSP/CLUS(MAXJ), WORK2(MAXJ,91)
C
C
C      J      REFERS TO THE X ( STREAMWISE ) DIRECTION
C      K      REFERS TO THE Y DIRECTION
C
C
C POINTS IN X DIRECTION
      NJ = NX
C POINTS IN Y DIRECTION
      NK = NY
C
C THICKNESS OF AIRFOIL ( 10% PARABOLIC BICONVEX )
      THICK = THICK1
C
C      BELOW, REGION IS [ -X1, X2 ] X [ 0, Y1 ]
C      AND AIRFOIL IS [ 0, 1] ON THE X AXIS
C -X1 IS LEFT BOUNDARY OF REGION
      X1 = -ALEFT
C X2 IS LENGTH OF REGION TO THE RIGHT OF THE AIRFOIL
      X2 = RIGHT - 1.
C TOP OF GRID, NUMBER OF CHORD LENGTHS PERP. TO 
C STREAMWISE DIRECTION
      Y1 = TOP
C
C        DEFINES THE FINE MESH
C
      NJM1=NJ-1
      NKM1=NK-1
      NJM2=NJ-2
      NKM2=NK-2
C
C     NUMBER OF POINTS ON AIRFOIL
C
      JBODY=J2-J1+1
      PI=3.141592654
C
C     PUT THE POINTS ON THE AIRFOIL
C
      DANG=PI/JBODY
C
      TWOTH=2.*THICK
      DO 1 J=J1,J2
      XI=J-J1+.5
C THIS USES COS ON [ 0, PI ]
      DEV=COS(XI*DANG)
C      X(J,1)=.5*(1.-DEV)
CJB
CJB      THIS ONE GIVES A LOT OF STRETCHING
CJB            X(1,J)=.5*(1.-DEV)
CJB
C        THIS GIVES LESS STRETCHING
              X( J, 1) = .5 * ( .5*(1.-DEV) + XI/JBODY )
C
    1 CONTINUE
CJB
CJB    PUT THE POINTS BEFORE THE AIRFOIL
CJB
      DX = X(J1,1)
      CALL CLUSTR(JDIM,ALEFT,0.,DX,J1,CLUS)
       DO 2 I = 2,J1
       JJ = J1 - I + 1
       X(JJ,1) = -CLUS(I)
2      CONTINUE       
CJB
CJB   PUT THE POINTS AFTER THE AIRFOIL
CJB
      DX = 1. - X(J2,1)
      NI = NJ-J2+1
      XMM = RIGHT - 1.0
      CALL CLUSTR(JDIM,XMM,0.,DX,NI,CLUS)
       DO 3 J = J2+1,NJ 
       I = J - J2 + 1
       X(J,1) = 1.0 + CLUS(I)
3      CONTINUE       
C
      DO 7 J=1,NJ
      XJ=X(J,1)
      DO 7 K=2,NK
      X(J,K)=XJ
    7 CONTINUE
CJB
CJB   PUT THE POINTS ABOVE THE AIRFOIL
CJB
      CALL CLUSTR(JDIM,TOP,0.,DY,NY,CLUS)
       DO 5 K = 1,NY
       Y(1,K) = CLUS(K)
5      CONTINUE       
       DO 6 K = 1,NY
       DO 6 J = 2,NX
       Y(J,K) = Y(1,K)
6      CONTINUE
C
      RETURN
      END

      SUBROUTINE XIDIF(JDIM,KDIM,X,Y,XY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION XY(JDIM,KDIM,4)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM)
C
C
C  XY4 =XXI,XY3 = YXI
C
      DO 11 K=KBEGIN,KEND
         DO 10 J=JLOW,JUP
            JP1 = JPLUS(J)
            JM1 = JMINU (J)
            XY(J,K,4) = ( X(JP1,K) - X(JM1,K))*.5
            XY(J,K,3) = ( Y(JP1,K) - Y(JM1,K))*.5
10       CONTINUE
C
          IF(.NOT.PERIDC  )THEN
            J = JBEGIN
            XY(J,K,4) = .5*( -3.*X(J,K) +4.*X(J+1,K) - X(J+2,K))
            XY(J,K,3) = .5*( -3.*Y(J,K) +4.*Y(J+1,K) - Y(J+2,K))
            J = JEND
            XY(J,K,4) = ( 3.*X(J,K) -4.*X(J-1,K) + X(J-2,K))*.5
            XY(J,K,3) = ( 3.*Y(J,K) -4.*Y(J-1,K) + Y(J-2,K))*.5
          ENDIF
C
   11 CONTINUE
C
        RETURN
        END

      SUBROUTINE B2STOK (B,GDER,SF8X2,SFUN1,SFUN2,NODEL)
      INTEGER NODEL
      DOUBLE PRECISION B(4,2*NODEL),GDER(2,NODEL),SF8X2(2,2*NODEL),
     +     SFUN1(*),SFUN2(*)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.D0)
      INTEGER DOFEL, J, JJ
      DOFEL = 2*NODEL
      CALL VFILL (4*DOFEL,B,ZERO)
      CALL VFILL (2*DOFEL,SF8X2,ZERO)

      DO 100 J=1,NODEL
         JJ = 2*J - 1
         B(1,JJ)   = GDER(1,J)
         B(2,JJ)   = GDER(2,J)
         B(3,JJ+1) = GDER(1,J)
         B(4,JJ+1) = GDER(2,J)

         SF8X2(1,JJ)=SFUN1(J)
         SF8X2(2,JJ+1)=SFUN2(J)

100   CONTINUE     
      RETURN
      END

      SUBROUTINE VPENTA
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C    ROUTINE TO INVERT 3 PENTADIAGONALS SIMULTANEOUSLY
C
C   12/05/84  D H BAILEY   MODIFIED FOR NAS KERNEL TEST
C
      PARAMETER (NJA=128, NJB=128, JL=1, JU=128, KL=1, KU=128)
      COMMON /ARRAYS/ A(NJA,NJB), B(NJA,NJB), C(NJA,NJB), D(NJA,NJB),
     $ E(NJA,NJB), F(NJA,NJB,3), X(NJA,NJB), Y(NJA,NJB), FX(NJA,NJB,3)
C
C	! START FORWARD GENERATION PROCESS AND SWEEP
C
      J = JL
      DO 1 K = KL,KU
        RLD = C(J,K)
        RLDI = 1./RLD
        F(J,K,1) = F(J,K,1)*RLDI
        F(J,K,2) = F(J,K,2)*RLDI
        F(J,K,3) = F(J,K,3)*RLDI
        X(J,K) = D(J,K)*RLDI
        Y(J,K) = E(J,K)*RLDI
1     CONTINUE
C
      J = JL+1
      DO 2 K = KL,KU
        RLD1 = B(J,K)
        RLD = C(J,K) - RLD1*X(J-1,K)
        RLDI = 1./RLD
        F(J,K,1) = (F(J,K,1) - RLD1*F(J-1,K,1))*RLDI
        F(J,K,2) = (F(J,K,2) - RLD1*F(J-1,K,2))*RLDI
        F(J,K,3) = (F(J,K,3) - RLD1*F(J-1,K,3))*RLDI
        X(J,K) = (D(J,K) - RLD1*Y(J-1,K))*RLDI
        Y(J,K) = E(J,K)*RLDI
2     CONTINUE
C
      DO 3 J = JL+2,JU-2
        DO 11 K = KL,KU
          RLD2 = A(J,K)
          RLD1 = B(J,K) - RLD2*X(J-2,K)
          RLD = C(J,K) - (RLD2*Y(J-2,K) + RLD1*X(J-1,K))
          RLDI = 1./RLD
          F(J,K,1) = (F(J,K,1) - RLD2*F(J-2,K,1) - RLD1*F(J-1,K,1))*RLDI
          F(J,K,2) = (F(J,K,2) - RLD2*F(J-2,K,2) - RLD1*F(J-1,K,2))*RLDI
          F(J,K,3) = (F(J,K,3) - RLD2*F(J-2,K,3) - RLD1*F(J-1,K,3))*RLDI
          X(J,K) = (D(J,K) - RLD1*Y(J-1,K))*RLDI
          Y(J,K) = E(J,K)*RLDI
11      CONTINUE
3     CONTINUE
C
      J = JU-1
      DO 12 K = KL,KU
        RLD2 = A(J,K)
        RLD1 = B(J,K) - RLD2*X(J-2,K)
        RLD = C(J,K) - (RLD2*Y(J-2,K) + RLD1*X(J-1,K))
        RLDI = 1./RLD
        F(J,K,1) = (F(J,K,1) - RLD2*F(J-2,K,1) - RLD1*F(J-1,K,1))*RLDI
        F(J,K,2) = (F(J,K,2) - RLD2*F(J-2,K,2) - RLD1*F(J-1,K,2))*RLDI
        F(J,K,3) = (F(J,K,3) - RLD2*F(J-2,K,3) - RLD1*F(J-1,K,3))*RLDI
        X(J,K) = (D(J,K) - RLD1*Y(J-1,K))*RLDI
12    CONTINUE
C
      J = JU
      DO 13 K = KL,KU
        RLD2 = A(J,K)
        RLD1 = B(J,K) - RLD2*X(J-2,K)
        RLD = C(J,K) - (RLD2*Y(J-2,K) + RLD1*X(J-1,K))
        RLDI = 1./RLD
        F(J,K,1) = (F(J,K,1) - RLD2*F(J-2,K,1) - RLD1*F(J-1,K,1))*RLDI
        F(J,K,2) = (F(J,K,2) - RLD2*F(J-2,K,2) - RLD1*F(J-1,K,2))*RLDI
        F(J,K,3) = (F(J,K,3) - RLD2*F(J-2,K,3) - RLD1*F(J-1,K,3))*RLDI
13    CONTINUE
C
C        !  BACK SWEEP SOLUTION
C
      DO 14 K = KL,KU
        F(JU,K,1) = F(JU,K,1)
        F(JU,K,2) = F(JU,K,2)
        F(JU,K,3) = F(JU,K,3)
        F(JU-1,K,1) = F(JU-1,K,1) - X(JU-1,K)*F(JU,K,1)
        F(JU-1,K,2) = F(JU-1,K,2) - X(JU-1,K)*F(JU,K,2)
        F(JU-1,K,3) = F(JU-1,K,3) - X(JU-1,K)*F(JU,K,3)
14    CONTINUE
C
      DO 4 J = 2,JU-JL
        JX = JU-J
        DO 15 K = KL,KU
          F(JX,K,1) = F(JX,K,1) - X(JX,K)*F(JX+1,K,1) -
     *                Y(JX,K)*F(JX+2,K,1)
          F(JX,K,2) = F(JX,K,2) - X(JX,K)*F(JX+1,K,2) -
     *                Y(JX,K)*F(JX+2,K,2)
          F(JX,K,3) = F(JX,K,3) - X(JX,K)*F(JX+1,K,3) -
     *                Y(JX,K)*F(JX+2,K,3)
15      CONTINUE
4     CONTINUE
C
      RETURN
      END

      SUBROUTINE EPSETA(EPS,ETA)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     COMPUTE AND RETURN ETA, THE SMALLEST REPRESENTABLE NUMBER,
C     AND EPS IS THE SMALLEST NUMBER FOR WHICH 1+EPS.NE.1.
C
C
      ETA = 1.D0
   10 IF((ETA/2.D0).EQ.0.D0) GOTO 20
      IF(ETA.LT.1.D-38) GOTO 20
      ETA = ETA / 2.D0
      GOTO 10
   20 EPS = 1.D0
   30 IF((1.D0+(EPS/2.D0)).EQ.1.D0) GOTO 40
      IF(EPS.LT.1.D-17) GOTO 40
      EPS = EPS / 2.D0
      GOTO 30
   40 RETURN
      END

      SUBROUTINE L2DFCV (ELK,ELM,ELF,GEOM,NODEL,KSW,RO,CP,A,TELEM,DT)
      DOUBLE PRECISION ELK(*),ELF(*),ELM(*),GEOM(*)
      INTEGER NODEL, KSW
      DOUBLE PRECISION RO,CP,TELEM(*),DT
      DOUBLE PRECISION ZERO,PII2
      PARAMETER (ZERO = 0.D0, PII2 = 2.D0*3.141592653589793D0)
      INTEGER DIM, DOFNOD, MNODEL, MNQP, MDOFEL
      PARAMETER (DIM = 2, DOFNOD = 1)
      PARAMETER (MNODEL = 16, MNQP = 9, MDOFEL = MNODEL*DOFNOD)
      DOUBLE PRECISION BTAB(MDOFEL*MDOFEL), B(DIM*MDOFEL)
      DOUBLE PRECISION A(DIM*DIM), BT(MDOFEL*DIM), AB(DIM*MDOFEL) 
      DOUBLE PRECISION JAC(DIM,DIM), JACIN(DIM,DIM)
      DOUBLE PRECISION SFUN(MNODEL), LDER(DIM*MNODEL)
      DOUBLE PRECISION SFUN2(MNODEL*MNODEL),XK(DIM)
      DOUBLE PRECISION WG(MNQP), XI(MNQP), ETA(MNQP)
      DOUBLE PRECISION DETK, AMUL, FXK
      DOUBLE PRECISION VELO(DIM),SFUGR(MDOFEL*MDOFEL),
     +                 VGRAD(MDOFEL)
      INTEGER DOFEL, NQP, I, K

      DOFEL = DOFNOD*NODEL
      CALL GAUSQ4(WG,XI,ETA,NQP)
      CALL VFILL (DOFEL*DOFEL,ELK,ZERO)
      CALL VFILL (DOFEL*DOFEL,ELM,ZERO)
      CALL VFILL (DOFEL,ELF,ZERO)

      DO 100 K=1,NQP
         CALL SQUAD8(SFUN,LDER,XI(K),ETA(K))
         CALL MXM (SFUN,1,GEOM,NODEL,XK,DIM)
         CALL MXM (LDER,DIM,GEOM,NODEL,JAC,DIM)
         CALL INV2X2 (JAC,JACIN,DETK)
         CALL MXM (JACIN,DIM,LDER,DIM,B,NODEL)

         CALL MATRAN (B,BT,DIM,DOFEL)
         CALL MXM (A,DIM,B,DIM,AB,DOFEL)
         CALL MXM (BT,DOFEL,AB,DIM,BTAB,DOFEL)
         CALL MXM (SFUN,DOFEL,SFUN,1,SFUN2,DOFEL)
         IF (KSW.EQ.1) THEN
            AMUL = WG(K)*DETK
         ELSE
            AMUL = WG(K)*PII2*XK(1)*DETK
         ENDIF


         CALL SAXPY (DOFEL*DOFEL,AMUL*DT,BTAB,1,ELK,1)


         CALL SAXPY (DOFEL*DOFEL,AMUL*RO*CP,SFUN2,1,ELM,1)



         FXK=0.0D0
         DO 500 I=1,NODEL
            FXK=FXK+TELEM(I)*SFUN(I)
 500     CONTINUE

         IF (DABS(FXK).GT.ZERO)
     &      CALL SAXPY (DOFEL,RO*CP*AMUL*FXK,SFUN,1,ELF,1)


 100  CONTINUE

      RETURN
      END

      FUNCTION DIAGI(IALPHA,IBETA,EIGA,XY,NMOS)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XY(NMECI,NMECI,NMECI,NMECI), EIGA(NMECI),
     1IALPHA(NMOS), IBETA(NMOS)
************************************************************************
*
*  CALCULATES THE ENERGY OF A MICROSTATE DEFINED BY IALPHA AND IBETA
*
************************************************************************
      X=0.0D0
      DO 20 I=1,NMOS
         IF (IALPHA(I).NE.0)THEN
            X=X+EIGA(I)
            DO 10  J=1,NMOS
               X=X+((XY(I,I,J,J)-XY(I,J,I,J))*IALPHA(J)*0.5D0 +
     1        (XY(I,I,J,J)            )*IBETA(J))
   10       CONTINUE
         ENDIF
   20 CONTINUE
      DO 40 I=1,NMOS
         IF (IBETA(I).NE.0) THEN
            X=X+EIGA(I)
            DO 30 J=1,I
   30       X=X+(XY(I,I,J,J)-XY(I,J,I,J))*IBETA(J)
         ENDIF
   40 CONTINUE
      DIAGI=X
      RETURN
      END

      SUBROUTINE UPDATE(IPARAM, IELMNT, PARAM, MODE,KFN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
************************************************************************
*
*  UPDATE UPDATES THE COMMON BLOCKS WHICH HOLD ALL THE PARAMETERS FOR
*         RUNNING MNDO.
*         IPARAM REFERS TO THE TYPE OF PARAMETER,
*         IELMNT REFERS TO THE ELEMENT,
*         PARAM IS THE VALUE OF THE PARAMETER, AND
*         IF MODE = 1 THEN A COMMON BLOCK IS UPDATED,
*         IF MODE = 2 THEN A DATUM IS EXTRACTED FROM THE COMMON BLOCK.
*
************************************************************************
      COMMON /MNDO/  USSM(107), UPPM(107), UDDM(107), ZSM(107),ZPM(107),
     1ZDM(107), BETASM(107), BETAPM(107), BETADM(107), ALPM(107),
     2EISOLM(107), DDM(107), QQM(107), AMM(107), ADM(107), AQM(107)
     3,GSSM(107),GSPM(107),GPPM(107),GP2M(107),HSPM(107), POLVOM(107)
      COMMON /EXPONT/ ZS(107),ZP(107),ZD(107)
     1       /NATORB/ NATORB(107)
     2       /BETAS / BETAS(107),BETAP(107),BETAD(107)
     3       /VSIPS / VS(107),VP(107),VD(107)
     4       /ONELEC/ USS(107),UPP(107),UDD(107)
     5       /MULTIP/ DD(107),QQ(107),AM(107),AD(107),AQ(107)
     6       /TWOELE/ GSS(107),GSP(107),GPP(107),GP2(107),HSP(107)
     7                ,GSD(107),GPD(107),GDD(107)
     8       /ALPHA / ALP(107)
     9       /IDEAS / GUESS1(107,10), GUESS2(107,10), GUESS3(107,10)
      COMMON /GAUSS / FN1(107),FN2(107)
      GOTO
     1(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,
     2190,200,210,220,230,240,250),IPARAM
   10 USS (IELMNT)=PARAM
      USSM(IELMNT)=PARAM
      RETURN
   20 UPP (IELMNT)=PARAM
      UPPM(IELMNT)=PARAM
      RETURN
   30 UDD (IELMNT)=PARAM
      UDDM(IELMNT)=PARAM
      RETURN
   40 ZS (IELMNT)=PARAM
      ZSM(IELMNT)=PARAM
      RETURN
   50 ZP (IELMNT)=PARAM
      ZPM(IELMNT)=PARAM
      RETURN
   60 ZD (IELMNT)=PARAM
      ZDM(IELMNT)=PARAM
      RETURN
   70 BETAS (IELMNT)=PARAM
      BETASM(IELMNT)=PARAM
      RETURN
   80 BETAP (IELMNT)=PARAM
      BETAPM(IELMNT)=PARAM
      RETURN
   90 BETAD (IELMNT)=PARAM
      BETADM(IELMNT)=PARAM
      RETURN
  100 GSS (IELMNT)=PARAM
      GSSM(IELMNT)=PARAM
      RETURN
  110 GSP (IELMNT)=PARAM
      GSPM(IELMNT)=PARAM
      RETURN
  120 GPP (IELMNT)=PARAM
      GPPM(IELMNT)=PARAM
      RETURN
  130 GP2 (IELMNT)=PARAM
      GP2M(IELMNT)=PARAM
      RETURN
  140 HSP (IELMNT)=PARAM
      HSPM(IELMNT)=PARAM
      RETURN
  150 RETURN
  160 RETURN
  170 RETURN
  180 ALP (IELMNT)=PARAM
      ALPM(IELMNT)=PARAM
      RETURN
  190 RETURN
  200 RETURN
  210 RETURN
  220 GUESS1(IELMNT,KFN)=PARAM
      RETURN
  230 GUESS2(IELMNT,KFN)=PARAM
      RETURN
  240 GUESS3(IELMNT,KFN)=PARAM
      RETURN
  250 NATORB(IELMNT)=PARAM
      I=INT(PARAM+0.5)
      IF(I.NE.9.AND.I.NE.4.AND.I.NE.1)THEN
         WRITE(6,'(///10X,'' UNACCEPTABLE VALUE FOR NO. OF ORBITALS'',
     1'' ON ATOM'')')
         CALL WRAPUP()
      ENDIF
      END

C-------------------------------------------------------------------
C
C   I  N  T  E  G 
C 
C   INTEGRATE EQUATIONS OF MOTION FROM  EPOCH TO D2.
C   THE INTEGRATION STEP IS H DAYS; 
C   D1 AND D2 GIVES THE INTERVAL FOR WHICH THE RESULTS ARE WRITTEN OUT.
C 
C----------------------------------------------------------------------
      SUBROUTINE  INTEG (D1,H,D2,OUTP, INTEGS)
      INTEGER
     .    D1, 
     .    D2, 
     .    INTEGS 
      REAL
     .    H,     
     .    OUTP   
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C 
C 
C
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)

      real tmppow(maxobj,maxobj)
      REAL
     .    EPOCH,
     .    SBINC(0:ORDER,0:ORDER), 
     .    DD(0:ORDER),
     .    KK(-MMM:MMM,-MMM:MMM),
     .    MASS(MAXOBJ),
     .    COORD(3,MAXOBJ),
     .    VELOC(3,MAXOBJ),
     .    XDIFF(3,MAXOBJ),       
     .    ACCEL(-MMM:MMM,3,MAXOBJ,0:1),
     .    ADIFF(MAXOBJ,0:ORDER,3),  
     .    DISTNC(MAXOBJ,MAXOBJ)        
      INTEGER SWAP
C
      COMMON /INTTAB/    SBINC,DD,KK,
     .                   COORD,VELOC,MASS,
     .                   XDIFF,ACCEL,ADIFF,DISTNC,SWAP,
     .                   EPOCH
C
C  OUTPUT
C
      REAL
     .    PLANET(3,MAXOBJ),      
     .    OLDPL(2,MAXOBJ)    
      INTEGER
     .    TODAY
      REAL
     .    OUTBUF(MAXDAY,3,MAXOBJ)      
C
      COMMON /OUT/ OUTBUF, PLANET, OLDPL, TODAY
C
C
      INTEGER
     .    I,J,K,NU,P,COUNT,INDX
      REAL
     .    SUM,X0,X1,X2,
     .    CLOCK,ETIME,
     .    OTIME
C
      TODAY=1
      P=MMM
      COUNT=0 
      ETIME=D2+H/4.0E+0
      OTIME=D1
      CLOCK=EPOCH+(MMM+1)*H
C
C  INTEGRATION LOOP BEGINS HERE
C
 10   CONTINUE
         DO 23 NU=0,ORDER-1
            DO 22 K=1,3
               DO 21 I=1,MAXOBJ
                        adiff(i,nu,k) = 0.0
                  DO 20 J=0,NU
                     IF (P-J .GE. -MMM) THEN
                        INDX= P-J
                     ELSE
                        INDX= P-J+ORDER
                     ENDIF 
                     adiff(i,nu,k)=
     +                    adiff(i,nu,k)+sbinc(nu,j)*accel(indx,k,i,swap)
 20               CONTINUE
 21            CONTINUE
 22         CONTINUE
 23      CONTINUE
C
C
         DO 32 K=1,3
            DO 31 I=1,MAXOBJ
               SUM=0.0
               DO 30 J=0,ORDER-1
                  SUM=SUM+DD(J)*ADIFF(i,J,K) 
 30            CONTINUE
               XDIFF(K,I)=XDIFF(K,I)+H*H*SUM
               COORD(K,I)=COORD(K,I)+XDIFF(K,I)
 31         CONTINUE
 32      CONTINUE   
C
C  CHECK IF IT IS TIME TO STORE RESULTS
C
         IF (CLOCK .GE. OTIME) THEN
            CALL DOUT (CLOCK)
            OTIME=OTIME+OUTP  
         ENDIF  
C
         DO 41 I=1,MAXOBJ
            DO 40 J=I+1,MAXOBJ
               X0=COORD(1,I)-COORD(1,J)
               X1=COORD(2,I)-COORD(2,J)
               X2=COORD(3,I)-COORD(3,J)
               DISTNC(I,J)=SQRT(X0*X0+X1*X1+X2*X2)
               DISTNC(J,I)=DISTNC(I,J)
 40         CONTINUE
 41      CONTINUE
C
         do i = 1, maxobj
            do j = i, maxobj
               tmppow(i,j) = distnc(i,j) ** 3
               tmppow(j,i) = tmppow(i,j)
            end do
         end do
C
         IF (P .EQ. MMM) THEN
            P= -MMM
         ELSE
            P= P+1
         ENDIF 
         COUNT=COUNT+1 
C
C 
         DO 52 K=1,3
            DO 51 I=1,MAXOBJ
               SUM=0.0 
               DO 50 J=1,MAXOBJ
                  IF (J .NE. I .AND. MASS(J) .NE. 0.0) THEN
                      tmp = 1.0/tmppow(i,j)
                      SUM=SUM+tmp*(COORD(K,J)-COORD(K,I))* MASS(J)
                  ENDIF
 50            CONTINUE
               ACCEL(P,K,I,SWAP)=GRAVIT*SUM
 51         CONTINUE
 52      CONTINUE
         CLOCK=CLOCK+H
      IF (CLOCK .LE. ETIME) GOTO 10
C
C  READY
C
      INTEGS=COUNT 
      RETURN
      END 

      SUBROUTINE SPPTRD (ITEXT,IHG,IHC,ISY,LI,NC,IB,V,F0,R,
     +NAT,NDIM9,NDIM10,NUMKPT,IQ1,IQ2,IQ3,WVK0,LWGHT,WVLIST,
     +A1,A2,A3,B1,B2,B3)
C
C     READ A SET OF SPECIAL POINTS FROM FILE IN290
C
      INTEGER ITEXT(80),F0(48,NDIM9),IB(48),LWGHT(NDIM10)
      DIMENSION V(3,48),R(49,3,3),WVK0(3),WVLIST(3,NDIM10)
      DIMENSION A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),XKAPA(3)
C
C.....COMMON BLOCK FOR KEEPING TRACK OF POSSIBLE WARNINGS
C     MACHINE TYPE
      COMMON /MACH1/ MACTYP
      COMMON /MACH2/ MACHIN(0:10)
      CHARACTER*7  MACHIN
      DATA INIT /0/
C.....FILES
          IN290 = 3
          IOUT  = 6
C-----------------------------------------------------------------------
      IF (INIT .NE. 0) GOTO 2300
      INIT = 1
C
C     READING FROM FILE WITH GROUP THEORY AND SPECIAL POINTS
C     (FIRST CALL: READ SYMMETRY INFORMATION)
C
      NUMKPT = 0
      READ (IN290,*,ERR=1000,END=1000)
     + NPRGR,IDAY,MONTH,IYEAR,IVERSN,IDUMMY
      MACTYP = IDUMMY
      WRITE (IOUT,100) NPRGR,IVERSN,MACHIN(MACTYP),IDAY,MONTH,IYEAR
100   FORMAT(' READING SPECIAL POINTS GENERATED BY K',I3,
     +' (VER.',I3,') ON ',A7,' COMPUTER'/
     +' DATE:  ',I2,'-TH OF ',I2,',19',I2)
C
      READ (IN290,180) (ITEXT(J),J=1,79)
180   FORMAT(1X,79A1)
      WRITE (IOUT,180) (ITEXT(J),J=1,79)
      READ (IN290,*) IDUMMY
      IRECTP = IDUMMY
      WRITE(IOUT,*) ' IRECTP ', IRECTP
      READ (IN290,*) IDUMMY
      NAT1 = IDUMMY
      WRITE(IOUT,*) ' NAT1 ', NAT1
      READ (IN290,*) A1,A2,A3,B1,B2,B3
      WRITE(IOUT,981) ' A1 ', (A1(I),I=1,3)
      WRITE(IOUT,981) ' A2 ', (A2(I),I=1,3)
      WRITE(IOUT,981) ' A3 ', (A3(I),I=1,3)
      WRITE(IOUT,981) ' B1 ', (B1(I),I=1,3)
      WRITE(IOUT,981) ' B2 ', (B2(I),I=1,3)
      WRITE(IOUT,981) ' B3 ', (B3(I),I=1,3)
981   FORMAT(1X,A4,3F10.6)
      DO 240 K=1,NAT1
C       DUMMY INPUT:
        READ (IN290,*) ITYPE,XKAPA
        WRITE(IOUT,982) ITYPE,XKAPA
240     CONTINUE
982   FORMAT(1X,I4,3F10.6)
C WE DO NOT CHECK WHETHER ALL THIS INFORMATION AGREES WITH
C THE ONE READ PREVIOUSLY, BECAUSE MOST OF IT (NAT1,XKAPA,TY)
C CAN VERY WELL BE DIFFERENT IF SOME "GHOST-ATOMS" WERE
C INTRODUCED. IF SO, WE ISSUE A REMINDER:
      IF (NAT .NE. NAT1) WRITE (IOUT,250) NAT - NAT1
250   FORMAT ('0SUBROUTINE SPPTRD - REMINDER: THE LAST ',I3,
     +' SITES IN THE ABOVE LISTS'/' ARE OCCUPIED BY GHOST ATOMS')
C     GROUP-THEORETICAL INFORMATION
      READ (IN290,980) IHG,IHC,ISY,LI,NC,(IB(J),J=1,48)
980   FORMAT (1X,5I5,4(/12I3))
C      WRITE (*,980) IHG,IHC,ISY,LI,NC,(IB(J),J=1,48)
C     FORMAT (1X,5I5/(12I3))
      READ (IN290,*) ((V(J,I),J=1,3),I=1,48)
C      write (*,'(3f10.6)') ((V(J,I),J=1,3),I=1,48)
      READ (IN290,'(1X,9I4)') ((F0(I,J),J=1,NAT),I=1,48)
C      write (*,'(1X,9I4)') ((F0(I,J),J=1,NAT),I=1,48)
      READ (IN290,*) (((R(K,I,J),J=1,3),I=1,3),K=1,49)
C      write (*,'(3f10.6)') (((R(K,I,J),J=1,3),I=1,3),K=1,49)
C-----------------------------------------------------------------------
C
C     READING ONE SET OF SPECIAL POINTS
C
2300  READ (IN290,*,ERR=1000,END=1000) IRECTP
C     CHECK THAT WE REALLY HAVE A RECORD WITH SPECIAL POINTS:
      IF (IRECTP .NE. 2) GOTO 2320
      READ (IN290,*) N
      IF (N .GT. NDIM10) GOTO 2340
      NUMKPT = N
      READ (IN290,*) IDUM1,IDUM2,IDUM3,WVK0
      IQ1 = IDUM1
      IQ2 = IDUM2
      IQ3 = IDUM3
      DO 2350 I=1,NUMKPT
        READ (IN290,*) IDUMMY, (WVLIST(J,I),J=1,3)
        LWGHT(I) = IDUMMY
2350    CONTINUE
1040    FORMAT (1X,I5,1X,3E14.6)
      WRITE (IOUT,2360) NUMKPT,IQ1,IQ2,IQ3,WVK0
2360  FORMAT(I4,' SPECIAL POINTS READ, IQ1,2,3 =',3I3,'; WVK0 =',3F8.3)
C
      RETURN
C-----------------------------------------------------------------------
C
C     ERROR MESSAGES
C
1000  WRITE (IOUT,*) 'SUBROUTINE SPPTRD *** WARNING ***'
      WRITE (IOUT,*) 'ERROR READING SPECIAL POINTS FILE, UNIT=',IN290
      WRITE (IOUT,*) 'FILE CLOSED - EXECUTION CONTINUES'
      CLOSE (UNIT = IN290 , STATUS = 'KEEP')
      RETURN
C
2320  WRITE (IOUT,*) 'SUBROUTINE SPPTRD - WARNING:'
      WRITE (IOUT,2310) IRECTP
2310  FORMAT (' RECORD WE ARE ATTEMPTING TO READ FROM THE SPECIAL-POINTS
     + FILE'/' IS NOT A RECORD WITH SPECIAL POINTS BUT DATAOF',
     +' RECORD-TYPE  IRECTP =',I3/
     +' K207 CONTINUES WITH THE PREVIOUS SET OF SPECIAL POINTS')
      IWARN = 2
      RETURN
C
2340  WRITE (IOUT,*) 'SUBROUTINE SPPTRD - WARNING:'
      WRITE (IOUT,2330) N,NDIM10
2330  FORMAT (1X,I4,' SPECIAL POINTS IN THIS RECORD CANNOT BE ',
     +'ACCOMMODATED'/' INTO THE LIST WHICH ONLY WAS DIMENSIONED',
     +I4,' IN K207'/
     +' K207 CONTINUES WITH THE PREVIOUS SET OF SPECIAL POINTS')
      IWARN = 2
      RETURN
C
      END

      SUBROUTINE DELMOL(COORD,I,J,NI,NJ,IA,ID,JA,JD,IX,RIJ,TOMB,ISP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION COORD(3,25)
      COMMON /DERIVS/ DS(16),DG(22),DR(100),TDX(3),TDY(3),TDZ(3)
      COMMON /EXTRA/  G(22),TX(3),TY(3),TZ(3)
      IF(NI.GT.1.OR.NJ.GT.1) CALL ROTAT(COORD,I,J,IX,RIJ,TOMB,2)
      IB=MAX(IA,ID)
      JB=MAX(JA,JD)
      DO 10 K=IA,IB
         KK=K-IA
         DO 10 L=K,IB
            LL=L-IA
            DO 10 M=JA,JB
               MM=M-JA
               DO 10 N=M,JB
                  NN=N-JA
                  ISP=ISP+1
                  IF(NN.EQ.0)THEN
                     IF(LL.EQ.0) THEN
C   (SS/SS)
                        DR(ISP)=DG(1)
                     ELSEIF(KK.EQ.0) THEN
C   (SP/SS)
                        DR(ISP)=DG(2)*TX(LL)+G(2)*TDX(LL)
                     ELSE
C   (PP/SS)
                        DR(ISP)=DG(3)*TX(KK)*TX(LL)
     1       +G(3)*(TDX(KK)*TX(LL)+TX(KK)*TDX(LL))
     2       +DG(4)*(TY(KK)*TY(LL)+TZ(KK)*TZ(LL))
     3       +G(4)*(TDY(KK)*TY(LL)+TY(KK)*TDY(LL)
     4             +TDZ(KK)*TZ(LL)+TZ(KK)*TDZ(LL))
                     ENDIF
                  ELSEIF(MM.EQ.0) THEN
                     IF(LL.EQ.0) THEN
C   (SS/SP)
                        DR(ISP)=DG(5)*TX(NN)+G(5)*TDX(NN)
                     ELSEIF(KK.EQ.0) THEN
C   (SP/SP)
                        DR(ISP)=DG(6)*TX(LL)*TX(NN)
     1       +G(6)*(TDX(LL)*TX(NN)+TX(LL)*TDX(NN))
     2       +DG(7)*(TY(LL)*TY(NN)+TZ(LL)*TZ(NN))
     3       +G(7)*(TDY(LL)*TY(NN)+TY(LL)*TDY(NN)
     4             +TDZ(LL)*TZ(NN)+TZ(LL)*TDZ(NN))
                     ELSE
C   (PP/SP)
                        DR(ISP)=DG(8)*TX(KK)*TX(LL)*TX(NN)
     1       +G(8)*(TDX(KK)*TX(LL)*TX(NN)+TX(KK)*TDX(LL)*TX(NN)
     2             +TX(KK)*TX(LL)*TDX(NN))
     3       +DG(9)*(TY(KK)*TY(LL)+TZ(KK)*TZ(LL))*TX(NN)
     4       +G(9)*((TDY(KK)*TY(LL)+TY(KK)*TDY(LL)
     5              +TDZ(KK)*TZ(LL)+TZ(KK)*TDZ(LL))*TX(NN)
     6             +(TY(KK)*TY(LL)+TZ(KK)*TZ(LL))*TDX(NN))
     7       +DG(10)*(TX(KK)*(TY(LL)*TY(NN)+TZ(LL)*TZ(NN))
     8               +TX(LL)*(TY(KK)*TY(NN)+TZ(KK)*TZ(NN)))
     9       +G(10)*(TDX(KK)*(TY(LL)*TY(NN)+TZ(LL)*TZ(NN))
     1              +TDX(LL)*(TY(KK)*TY(NN)+TZ(KK)*TZ(NN))
     2              +TX(KK)*(TDY(LL)*TY(NN)+TY(LL)*TDY(NN)
     3                      +TDZ(LL)*TZ(NN)+TZ(LL)*TDZ(NN))
     4              +TX(LL)*(TDY(KK)*TY(NN)+TY(KK)*TDY(NN)
     5                      +TDZ(KK)*TZ(NN)+TZ(KK)*TDZ(NN)))
                     ENDIF
                  ELSEIF(LL.EQ.0) THEN
C   (SS/PP)
                     DR(ISP)=DG(11)*TX(MM)*TX(NN)
     1       +G(11)*(TDX(MM)*TX(NN)+TX(MM)*TDX(NN))
     2       +DG(12)*(TY(MM)*TY(NN)+TZ(MM)*TZ(NN))
     3       +G(12)*(TDY(MM)*TY(NN)+TY(MM)*TDY(NN)
     4              +TDZ(MM)*TZ(NN)+TZ(MM)*TDZ(NN))
                  ELSEIF(KK.EQ.0) THEN
C   (SP/PP)
                     DR(ISP)=DG(13)*TX(LL)*TX(MM)*TX(NN)
     1       +G(13)*(TDX(LL)*TX(MM)*TX(NN)+TX(LL)*TDX(MM)*TX(NN)
     2              +TX(LL)*TX(MM)*TDX(NN))
     3       +DG(14)*TX(LL)*(TY(MM)*TY(NN)+TZ(MM)*TZ(NN))
     4       +G(14)*(TDX(LL)*(TY(MM)*TY(NN)+TZ(MM)*TZ(NN))
     5              +TX(LL)*(TDY(MM)*TY(NN)+TY(MM)*TDY(NN)
     6                      +TDZ(MM)*TZ(NN)+TZ(MM)*TDZ(NN)))
     7       +DG(15)*(TY(LL)*(TY(MM)*TX(NN)+TY(NN)*TX(MM))
     8               +TZ(LL)*(TZ(MM)*TX(NN)+TZ(NN)*TX(MM)))
     9       +G(15)*(TDY(LL)*(TY(MM)*TX(NN)+TY(NN)*TX(MM))
     1              +TDZ(LL)*(TZ(MM)*TX(NN)+TZ(NN)*TX(MM))
     2              +TY(LL)*(TDY(MM)*TX(NN)+TY(MM)*TDX(NN)
     3                      +TDY(NN)*TX(MM)+TY(NN)*TDX(MM))
     4              +TZ(LL)*(TDZ(MM)*TX(NN)+TZ(MM)*TDX(NN)
     5                      +TDZ(NN)*TX(MM)+TZ(NN)*TDX(MM)))
                  ELSE
C   (PP/PP)
                     DR(ISP)=DG(16)*TX(KK)*TX(LL)*TX(MM)*TX(NN)
     1       +G(16)*(TDX(KK)*TX(LL)*TX(MM)*TX(NN)
     2              +TX(KK)*TDX(LL)*TX(MM)*TX(NN)
     3              +TX(KK)*TX(LL)*TDX(MM)*TX(NN)
     4              +TX(KK)*TX(LL)*TX(MM)*TDX(NN))
     5       +DG(17)*(TY(KK)*TY(LL)+TZ(KK)*TZ(LL))*TX(MM)*TX(NN)
     6       +G(17)*((TDY(KK)*TY(LL)+TY(KK)*TDY(LL)
     7               +TDZ(KK)*TZ(LL)+TZ(KK)*TDZ(LL))*TX(MM)*TX(NN)
     8              +(TY(KK)*TY(LL)+TZ(KK)*TZ(LL))
     9              *(TDX(MM)*TX(NN)+TX(MM)*TDX(NN)))
     1       +DG(18)*TX(KK)*TX(LL)*(TY(MM)*TY(NN)+TZ(MM)*TZ(NN))
     2       +G(18)*((TDX(KK)*TX(LL)+TX(KK)*TDX(LL))
     3                 *(TY(MM)*TY(NN)+TZ(MM)*TZ(NN))
     4              +TX(KK)*TX(LL)*(TDY(MM)*TY(NN)+TY(MM)*TDY(NN)
     5                             +TDZ(MM)*TZ(NN)+TZ(MM)*TDZ(NN)))
                     DR(ISP)=DR(ISP)
     1       +DG(19)*(TY(KK)*TY(LL)*TY(MM)*TY(NN)
     2                  +TZ(KK)*TZ(LL)*TZ(MM)*TZ(NN))
     3       +G(19)*(TDY(KK)*TY(LL)*TY(MM)*TY(NN)
     4                 +TY(KK)*TDY(LL)*TY(MM)*TY(NN)
     5                 +TY(KK)*TY(LL)*TDY(MM)*TY(NN)
     6                 +TY(KK)*TY(LL)*TY(MM)*TDY(NN)
     7                 +TDZ(KK)*TZ(LL)*TZ(MM)*TZ(NN)
     8                 +TZ(KK)*TDZ(LL)*TZ(MM)*TZ(NN)
     9                 +TZ(KK)*TZ(LL)*TDZ(MM)*TZ(NN)
     1                 +TZ(KK)*TZ(LL)*TZ(MM)*TDZ(NN))
     2       +DG(20)*(TX(KK)*(TX(MM)*(TY(LL)*TY(NN)+TZ(LL)*TZ(NN))
     3                          +TX(NN)*(TY(LL)*TY(MM)+TZ(LL)*TZ(MM)))
     4                  +TX(LL)*(TX(MM)*(TY(KK)*TY(NN)+TZ(KK)*TZ(NN))
     5                          +TX(NN)*(TY(KK)*TY(MM)+TZ(KK)*TZ(MM))))
C      TO AVOID COMPILER DIFFICULTIES THIS IS DIVIDED
                     TEMP1=         TDX(KK)*(TX(MM)*(TY(LL)*TY(NN)+TZ(LL
     1)*TZ(NN))                          +TX(NN)*(TY(LL)*TY(MM)+TZ(LL)*T
     2Z(MM)))                 +TDX(LL)*(TX(MM)*(TY(KK)*TY(NN)+TZ(KK)*TZ(
     3NN))                          +TX(NN)*(TY(KK)*TY(MM)+TZ(KK)*TZ(MM)
     4))                 +TX(KK)*(TDX(MM)*(TY(LL)*TY(NN)+TZ(LL)*TZ(NN))
     5                         +TDX(NN)*(TY(LL)*TY(MM)+TZ(LL)*TZ(MM)))
     6                 +TX(LL)*(TDX(MM)*(TY(KK)*TY(NN)+TZ(KK)*TZ(NN))
     7                         +TDX(NN)*(TY(KK)*TY(MM)+TZ(KK)*TZ(MM)))
                     TEMP2=            TX(KK)*(TX(MM)*(TDY(LL)*TY(NN)+TY
     1(LL)*TDY(NN)                                 +TDZ(LL)*TZ(NN)+TZ(LL
     2)*TDZ(NN))                         +TX(NN)*(TDY(LL)*TY(MM)+TY(LL)*
     3TDY(MM)                                 +TDZ(LL)*TZ(MM)+TZ(LL)*TDZ
     4(MM)))                 +TX(LL)*(TX(MM)*(TDY(KK)*TY(NN)+TY(KK)*TDY(
     5NN)                                 +TDZ(KK)*TZ(NN)+TZ(KK)*TDZ(NN)
     6)                         +TX(NN)*(TDY(KK)*TY(MM)+TY(KK)*TDY(MM)
     7                                 +TDZ(KK)*TZ(MM)+TZ(KK)*TDZ(MM)))
                     DR(ISP)=DR(ISP)+G(20)*(TEMP1+TEMP2)
                     DR(ISP)=DR(ISP)
     1       +DG(21)*(TY(KK)*TY(LL)*TZ(MM)*TZ(NN)
     2                 +TZ(KK)*TZ(LL)*TY(MM)*TY(NN))
     3       +G(21)*(TDY(KK)*TY(LL)*TZ(MM)*TZ(NN)
     4                 +TY(KK)*TDY(LL)*TZ(MM)*TZ(NN)
     5                 +TY(KK)*TY(LL)*TDZ(MM)*TZ(NN)
     6                 +TY(KK)*TY(LL)*TZ(MM)*TDZ(NN)
     7                 +TDZ(KK)*TZ(LL)*TY(MM)*TY(NN)
     8                 +TZ(KK)*TDZ(LL)*TY(MM)*TY(NN)
     9                 +TZ(KK)*TZ(LL)*TDY(MM)*TY(NN)
     1                 +TZ(KK)*TZ(LL)*TY(MM)*TDY(NN))
                     DR(ISP)=DR(ISP)
     1       +DG(22)*(TY(KK)*TZ(LL)+TZ(KK)*TY(LL))
     2                 *(TY(MM)*TZ(NN)+TZ(MM)*TY(NN))
     3       +G(22)*((TDY(KK)*TZ(LL)+TY(KK)*TDZ(LL)
     4                  +TDZ(KK)*TY(LL)+TZ(KK)*TDY(LL))
     5                 *(TY(MM)*TZ(NN)+TZ(MM)*TY(NN))
     6                 +(TY(KK)*TZ(LL)+TZ(KK)*TY(LL))
     7                 *(TDY(MM)*TZ(NN)+TY(MM)*TDZ(NN)
     8                  +TDZ(MM)*TY(NN)+TZ(MM)*TDY(NN)))
                  ENDIF
   10 CONTINUE
      RETURN
      END

C***********************************************************************
C***********************************************************************
      SUBROUTINE WFINRN(NRPLWV,NBANDS,NKPTS,DATAKE,NBANOC,CPTWFP,
     &     NPLWKP,PLWVEN,NFIND,CELEN,NGX, NGY, NGZ, 
     &     LPCTX, LPCTY, LPCTZ, NINDPW, RECC, CPTDUM,CCTDUM)
C=======================================================================
C
C """"""""""""""""""""""""" SUBROUTINE WFINIT """"""""""""""""""""""""""
C
C THIS SUBROUTINES INITIALISES THE WAVEFUNCTIONS FOR THE MOLECULAR
C DYNAMICS BY FILLING THE BANDS AT EACH K POINT WITH THE LOWEST ENERGY
C PLANE WAVE BASIS STATES. IF THE SYSTEM HAS HIGH SYMMETRY THIS METHOD
C MAY NOT BE APPROPRIATE BECAUSE THE LOWEST ENERGY PLANE WAVES MAY NOT
C SPAN THE LOWEST BANDS.
C
C=======================================================================
      IMPLICIT COMPLEX (C)
      EXTERNAL RANF
      DIMENSION DATAKE(*)
      DIMENSION CPTWFP(*),CPTDUM(*),CCTDUM(*)
      DIMENSION CELEN(*)
      DIMENSION LPCTX(*), LPCTY(*), LPCTZ(*), NINDPW(*), RECC(3,3)
C=======================================================================
C
C                       DIMENSION STATEMENTS
C
C PLWVEN = THE ENERGIES OF THE LOWEST KINETIC ENERGY PLANE WAVE BASIS
C          STATES
C NFIND = THE INDICES OF THE LOWEST ENERGY PLANE WAVE BASIS STATES
C=======================================================================
      DIMENSION PLWVEN(*)
      DIMENSION NFIND(*)
      DATA HSQDTM /3.810033/
      DATA ISEED /-1/
C=======================================================================
C INITIALISE THE ENERGIES OF THE BASIS STATES TO A LARGE VALUE SO THAT
C LOWER ENERGY BASIS STATES WILL BE FOUND
C=======================================================================
      WRITE (*,*) 'WELCOME TO WFINIT-RANDOM'
      NBASE = NBANDS * 3
      DO 2010 MM = 1,NBASE
        PLWVEN(MM) = 10000.0
 2010 CONTINUE
C=======================================================================
C RUN THROUGH THE SET OF PLANE WAVE BASIS STATES AT THE PRESENT K POINT
C AND FIND THE ENERGY .
C=======================================================================
      DO 2100 NNN = 1,NPLWKP
        NINDX = 1 + ( 7 * (NNN - 1) )
C======================================================================
C IF THE ENERGY OF THIS BASIS STATES IS HIGHER THAN THE BANDS LOWEST 
C ENERGIES FOUND SO FAR MOVE ONTO THE NEXT BASIS STATES
C======================================================================
        IF (DATAKE(NINDX).GT.PLWVEN(NBASE)) GOTO 2108
C======================================================================
C OTHERWISE RUN THROUGH ALL PLANE WAVE BASIS FROM WHICH THE INITIALIZED
C WAVEFUNCTION IS BEING GENERATED
C=====================================================================
        DO 2110 M = 1,NBASE
          IF (PLWVEN(M).GT.DATAKE(NINDX)) GO TO 2200
 2110   CONTINUE
        GO TO 2108
 2200   NSWAP = M
C=======================================================================
C PUT THIS BASIS STATE AT ITS RIGHTFULL PLACE AMONGST THE LOWEST ENERGY
C PLANE WAVE BASIS STATES AND MOVE THE HIGHER ENERGY COMPONENTS UP
C ONE POSITION
C======================================================================
        DO 2109 M = NBASE,NSWAP+1,-1
          IF (M.GT.NBASE) GO TO 2109
          PLWVEN(M) = PLWVEN(M-1)
          NFIND(M) = NFIND(M-1)
 2109   CONTINUE
        PLWVEN(NSWAP) = DATAKE(NINDX)
        NFIND(NSWAP) = NNN
 2108   CONTINUE
 2100 CONTINUE
C======================================================================
C     The plane waves which are to be included in the initial
C     wave functions. Find their GX, GY, GZ 
C======================================================================
C
      DO 2450 NN = 1, NBASE
        M = NINDPW(NFIND(NN))
        IGX = LPCTX((M-1)       - ( (M-1) /   NGX     ) * NGX + 1)
        IGY = LPCTY((M-1) / NGX - ( (M-1) / (NGX*NGY) ) * NGY + 1)
        IGZ = LPCTZ((M-1) / (NGX * NGY)                       + 1)
C        WRITE (*,2502) IGX, IGY, IGZ, PLWVEN(NN)
 2450 CONTINUE
 2502 FORMAT(1X,'  INITIAL WAVEFUNCTION INCLUDES: G =', 3I4, F15.6)
C=======================================================================
C FROM THE INDICES OF THE LOWEST ENERGY BASIS STATES INITIALISE THE
C WAVEFUNCTIONS
C=======================================================================
C
C      RANDOM INTIALISATION IS ADDED HERE
C
C-----------------------------------------------------------------------
C
C
      DO 2500 NN = 1,NBANDS
        NINDX = NRPLWV*(NN-1)
        DO 2500 NN1 = 1,NBASE
          IF (PLWVEN(NN1).EQ.0.0) THEN
            PLWVEN(NN1) = 1.0
          ENDIF
          CPTWFP(NFIND(NN1)+NINDX) = (0.5,0.0) *
     &                    RANF(ISEED) / (PLWVEN(NN1)**2)
2500  CONTINUE
C======================================================================
C
C     NORMALIZE THE FIRST BAND IN ORDER TO ORTHOGONAL THE HIGHER BANDS
C
C======================================================================
      DO 2600 NN = 1,NBANDS
        NINDW = NRPLWV * ( NN - 1 )
        DO 2601 M = 1,NPLWKP
          CPTDUM(M) = CPTWFP(M+NINDW)
2601    CONTINUE
        DO 2602 M = 1,NPLWKP
          CCTDUM(M) = CONJG(CPTDUM(M))
2602    CONTINUE
        CWFMAG = (0.0,0.0)
        DO 2603 M = 1,NPLWKP
          CWFMAG = CWFMAG + CCTDUM(M) * CPTDUM(M)
2603    CONTINUE
        WFMAG = REAL(CWFMAG)
        IF (WFMAG.GT.0) GO TO 2605
        WRITE (6,2604) NN,M
        STOP
2605  CONTINUE
        WFMINV = 1.0 / SQRT(WFMAG)
        DO 2606 M = 1,NPLWKP
          CPTDUM(M) = WFMINV * CPTDUM(M)
          CCTDUM(M) = CONJG(CPTDUM(M))
2606    CONTINUE
        DO 2607 M = 1,NPLWKP
          CPTWFP(M+NINDW) = CPTDUM(M)
2607    CONTINUE
C======================================================================
C
C     NOW ORTHOGONALIZE THE WAVEFUNCTION OF ALL THE HIGHER BAND TO THE
C     PRESENT NORMALIZED WAVEFUNCTION
C
C======================================================================
        DO 2608 MM = NN+1,NBANDS
          NINDX = NRPLWV * ( MM - 1 )
          CSCPD = (0.0,0.0)
          DO 2609 M = 1,NPLWKP
            CSCPD = CSCPD + CCTDUM(M) * CPTWFP(M+NINDX)
2609      CONTINUE
          DO 2610 M = 1,NPLWKP
            CPTWFP(M+NINDX) = CPTWFP(M+NINDX) - CSCPD * CPTDUM(M)
2610      CONTINUE
2608    CONTINUE
2600  CONTINUE
2604  FORMAT(1X,'WAVEFUNCTION LINEARLY DEPENDENT',2I5)
C======================================================================
C
C      We now calculate the kinetic energy of each band
C
C======================================================================
      DO 2800 NN = 1,NBANDS 
        NINDX = NRPLWV * ( NN - 1 )
        CELEN(NN) = (0.0,0.0)
        DO 2810 M = 1,NPLWKP
          CELEN(NN) = CELEN(NN) +
     &    DATAKE(1+7*(M-1)) * CPTWFP(M+NINDX) * CONJG(CPTWFP(M+NINDX))
 2810   CONTINUE
C        WRITE(*,*)'  KINETIC ENERGY IS: ', CELEN(NN)
 2800 CONTINUE
      RETURN
      END


      FUNCTION RANF(IDUM)
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.0/M)
      DIMENSION IR(97)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IDUM=MOD(IC-IDUM,M)
        DO 11 J=1,97
           IDUM=MOD(IA*IDUM+IC,M)
           IR(J)=IDUM
  11    CONTINUE
        IDUM=MOD(IA*IDUM+IC,M)
        IY=IDUM
      ENDIF
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1) THEN
      PRINT *,' RANF: J=',J
      STOP
      ENDIF
      IY=IR(J)
      RANF=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
      RETURN
      END

      SUBROUTINE MATPRT(A,N)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N)             
      CHARACTER FMT*17
      SAVE FMT
      DATA FMT/'(1P,(1X,10E13.5))'/
C     12345678901234567
c-old      NN=MIN(N,10)
      NN=MIN(N,6)
      WRITE(UNIT=FMT(9:10),FMT='(I2)') NN
C1000 FORMAT(1P,(1X,<NN>E13.5))            
      WRITE(6,FMT=FMT) ((A(I,J),J=1,NN),I=1,NN)
      END

      SUBROUTINE MATRAN (A,AT,NROWA,NCOLA)
      INTEGER NROWA, NCOLA
      DOUBLE PRECISION A(NROWA,NCOLA), AT(NCOLA,NROWA)
      INTEGER I, J
      DO 110 I=1,NROWA
         DO 100 J=1,NCOLA
            AT(J,I) = A(I,J)
100      CONTINUE
110   CONTINUE
      RETURN
      END

      FUNCTION CAPCOR(NAT,NFIRST,NLAST,NUMAT,P,H)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(*), H(*), NFIRST(NUMAT), NLAST(NUMAT), NAT(NUMAT)
******************************************************************
*
*    CORRECTION TO ELECTRONIC ENERGY DUE TO CAPPED BONDS
*
******************************************************************
      SUM=0.D0
      DO 40 I=1,NUMAT
         NI=NAT(I)
         IL=NFIRST(I)
         IU=NLAST(I)
         IF(NI.EQ.102) THEN
C
C   DO ENTIRE ROW - NO NEED TO CHECK FURTHER.
C
            J=(NLAST(I)*(NLAST(I)+1))/2
            II=IU-1
            DO 10 K=1,II
               J=J-1
   10       SUM=SUM+P(J)*H(J)
         ELSE
            DO 30 J=1,I
               JL=NFIRST(J)
               IF(NAT(J).EQ.102)THEN
                  DO  20 K=IL,IU
                     KK=(K*(K-1))/2+JL
   20             SUM=SUM+P(KK)*H(KK)
               ENDIF
   30       CONTINUE
         ENDIF
   40 CONTINUE
C
C   DOUBLE SUM SINCE WE ONLY CALCULATED LOWER HALF, AND CAPCOR
C   WILL APPEAR IN 1/2*P(H+F).  ONLY H PART OF F WILL BE USED.
      CAPCOR=-SUM*2.D0
      RETURN
      END

      SUBROUTINE ASMBTE(A,ALOK,MLOK,F,FLOK,MXNOD,STEER,NODEL,
     +                IDIAG)

      INTEGER MXNOD,NODEL,IDIAG,STEER(*)
      DOUBLE PRECISION A(MXNOD,*),F(*),ALOK(NODEL,*),MLOK(NODEL,*),
     +     FLOK(*)
      INTEGER INDI,INDJ,I,J

        DO 10 I=1,NODEL
          DO 20 J=1,NODEL
            INDI=STEER(I)
            INDJ=STEER(J)
            INDJ=IDIAG+INDJ-INDI
            A(INDI,INDJ)=A(INDI,INDJ)+ALOK(I,J)
            A(INDI,INDJ)=A(INDI,INDJ)+MLOK(I,J)
 20      CONTINUE
         F(STEER(I))=F(STEER(I))+FLOK(I)
 10   CONTINUE

      RETURN
      END

      SUBROUTINE FORCE
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      PARAMETER (MAXPA2=MAXPAR**2)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR),IDUMY,DUMY(MAXPAR)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                     LOCDEP(MAXPAR)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /FMATRX/ FMATRX(MAXHES)
      COMMON /KEYWRD/ KEYWRD
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      PARAMETER (IPADD=2*MORB2+2*MAXORB-MAXPAR-MAXPA2)
      COMMON /VECTOR/ CNORML(MAXPA2),FREQ(MAXPAR),DUMMY(IPADD)
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /LAST  / LAST
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /COORD / COORD(3,NUMATM)
***********************************************************************
*
*   FORCE CALCULATES THE FORCE CONSTANTS FOR THE MOLECULE, AND THE
*         VIBRATIONAL FREQUENCIES.  ISOTOPIC SUBSTITUTION IS ALLOWED.
*
***********************************************************************
      COMMON /EULER / TVEC(3,3), ID
      COMMON /SCRACH/ STORE(MAXPAR**2)
      DIMENSION XPARAM(MAXPAR), GR(3,NUMATM),
     1DELDIP(3,MAXPAR), TRDIP(3,MAXPAR),LOCOLD(2,MAXPAR)
     2,REDMAS(MAXPAR), SHIFT(6), DIPT(MAXPAR), TRAVEL(MAXPAR)
     3, ROT(3,3)
      CHARACTER KEYWRD*80, KEYS(80)*1, ELEMNT*2
      LOGICAL RESTRT, LINEAR, DEBUG, BARTEL, PRNT, LARGE
      EQUIVALENCE (GRAD(1), GR(1,1)), (KEYWRD,KEYS(1))
C
C TEST GEOMETRY TO SEE IF IT IS OPTIMIZED
      TIME2=-1.D9
      CALL GMETRY(GEO,COORD)
      NVAOLD=NVAR
      DO 10 I=1,NVAR
         LOCOLD(1,I)=LOC(1,I)
   10 LOCOLD(2,I)=LOC(2,I)
      NVAR=0
      NUMAT=0
      IF(LABELS(1) .NE. 99) NUMAT=1
      DO 30 I=2,NATOMS
         IF(LABELS(I).EQ.99.OR.LABELS(I).EQ.107) GOTO 30
         NUMAT=NUMAT+1
         IF(I.EQ.2)ILIM=1
         IF(I.EQ.3)ILIM=2
         IF(I.GT.3)ILIM=3
         DO 20 J=1,ILIM
            NVAR=NVAR+1
            LOC(1,NVAR)=I
            LOC(2,NVAR)=J
   20    XPARAM(NVAR)=GEO(J,I)
   30 CONTINUE
C
C   IF A RESTART, THEN TSCF AND TDER WILL BE FAULTY, THEREFORE SET TO -1
C
      TSCF=-1.D0
      TDER=-1.D0
      PRNT=(INDEX(KEYWRD,'RC=') .EQ. 0)
      DEBUG=(INDEX(KEYWRD,'DFORCE') .NE. 0)
      LARGE=(INDEX(KEYWRD,'LARGE') .NE. 0)
      BARTEL=(INDEX(KEYWRD,'NLLSQ') .NE. 0)
      RESTRT=(INDEX(KEYWRD,'RESTART') .NE. 0)
      TIME1=ZECOND()
      IF (RESTRT) THEN
C
C   CHECK TO SEE IF CALCULATION IS IN NLLSQ OR FORCE.
C
         IF(BARTEL)GOTO 50
C
C   CALCULATION IS IN FORCE
C
         GOTO 70
      ENDIF
      CALL COMPFG( XPARAM, .TRUE., ESCF, .TRUE., GRAD, .FALSE.)
      IF(PRNT)WRITE(6,'(//10X,''HEAT OF FORMATION ='',F12.6,
     1'' KCALS/MOLE'')')ESCF
      TIME2=ZECOND()
      TSCF=TIME2-TIME1
      CALL COMPFG( XPARAM, .TRUE., ESCF1, .FALSE., GRAD, .TRUE.)
      TIME3=ZECOND()
      TDER=TIME3-TIME2
      IF(PRNT)WRITE(6,'(//10X,''INTERNAL COORDINATE DERIVATIVES'',//3X,
     1''ATOM  AT. NO.'',2X,''BOND'',9X,''ANGLE'',8X,''DIHEDRAL'',/)')
      L=0
      IU=0
      DO 40 I=1,NATOMS
         IF(LABELS(I).EQ.99) GOTO 40
         L=L+1
         IL=IU+1
         IF(I .EQ. 1) IU=IL-1
         IF(I .EQ. 2) IU=IL
         IF(I .EQ. 3) IU=IL+1
         IF(I .GT. 3) IU=IL+2
         IF(PRNT)WRITE(6,'(I6,4X,A2,F13.6,2F10.6)')
     1L,ELEMNT(LABELS(I)),(GRAD(J),J=IL,IU)
   40 CONTINUE
C   TEST SUM OF GRADIENTS
      GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
      IF(PRNT)WRITE(6,'(//10X,''GRADIENT NORM ='',F10.5)') GNORM
      IF(GNORM.LT.10.D0) GOTO 60
      IF(INDEX(KEYWRD,' LET ') .NE. 0) THEN
         WRITE(6,'(///1X,''** GRADIENT IS VERY LARGE, BUT SINCE "LET"'',
     1'' IS USED, CALCULATION WILL CONTINUE'')')
         GOTO 70
      ENDIF
      WRITE(6,'(///1X,''** GRADIENT IS TOO LARGE TO ALLOW '',
     1    ''FORCE MATRIX TO BE CALCULATED, (LIMIT=10) **'',//)')
   50 CONTINUE
      WRITE(6,'(//10X,'' GEOMETRY WILL BE OPTIMIZED FIRST'')')
      IF(BARTEL) THEN
         WRITE(6,'(15X,''USING NLLSQ'')')
         CALL NLLSQ(XPARAM,NVAR)
      ELSE
         WRITE(6,'(15X,''USING FLEPO'')')
         CALL FLEPO(XPARAM,NVAR,ESCF)
      ENDIF
      CALL COMPFG( XPARAM, .TRUE., ESCF, .TRUE., GRAD, .TRUE.)
      CALL VWRITE(TIME1,ESCF)
      WRITE(6,'(//10X,''GRADIENT NORM ='',F10.7)') GNORM
      CALL GMETRY(GEO,COORD)
   60 CONTINUE
C
C NOW TO CALCULATE THE FORCE MATRIX
C
C CHECK OUT SYMMETRY
   70 CONTINUE
C
C   NEED TO ENSURE THAT XYZINT WILL WORK CORRECTLY BEFORE CALL
C   TO DRC.
C
      L=0
      DO 80 I=1,NATOMS
         IF(LABELS(I).NE.99)THEN
            L=L+1
            LABELS(L)=LABELS(I)
         ENDIF
   80 CONTINUE
      NATOMS=NUMAT
      CALL XYZINT(COORD,NUMAT,NA,NB,NC,1.D0,GEO)
      CALL GMETRY(GEO,COORD)
      IF(INDEX(KEYWRD,'THERMO').NE.0 .AND.GNORM.GT.1.D0) THEN
         WRITE(6,'(//30X,''**** WARNING ****'',//
     110X,'' GRADIENT IS VERY LARGE FOR A THERMO CALCULATION'',/
     210X,'' RESULTS ARE LIKELY TO BE INACCURATE IF THERE ARE'')')
         WRITE(6,'(10X,'' ANY LOW-LYING VIBRATIONS (LESS THAN ABOUT ''
     1,''400CM-1)'')')
         WRITE(6,'(10X,'' GRADIENT NORM SHOULD BE LESS THAN ABOUT '',
     1''0.2 FOR THERMO'',/10X,'' TO GIVE ACCURATE RESULTS'')')
      ENDIF
      IF(TSCF.GT.0.D0) THEN
         WRITE(6,'(//10X,''TIME FOR SCF CALCULATION ='',F8.2)')TSCF
         WRITE(6,'(//10X,''TIME FOR DERIVATIVES     ='',F8.2)')TDER
      ENDIF
      IF(NDEP.GT.0) THEN
         WRITE(6,'(//10X,''SYMMETRY WAS SPECIFIED, BUT '',
     1''CANNOT BE USED HERE'')')
         NDEP=0
      ENDIF
      IF(PRNT)CALL AXIS(COORD,NUMAT,A,B,C,WTMOL,2,ROT)
      NVIB=3*NUMAT-6
      IF(ABS(C).LT.1.D-20)NVIB=NVIB+1
      IF(ID.NE.0)NVIB=3*NUMAT-3
      IF(PRNT) THEN
         WRITE(6,'(/9X,''ORIENTATION OF MOLECULE IN FORCE CALCULATION'')
     1')
         WRITE(6,'(/,4X,''NO.'',7X,''ATOM'',9X,''X'',
     19X,''Y'',9X,''Z'',/)')
      ENDIF
      L=0
      DO 90 I=1,NATOMS
         IF(LABELS(I) .EQ. 99) GOTO 90
         L=L+1
         IF(PRNT)WRITE(6,'(I6,7X,I3,4X,3F10.4)')
     1    L,LABELS(I),(COORD(J,L),J=1,3)
   90 CONTINUE
      CALL FMAT(FMATRX, NVIB, TSCF, TDER, DELDIP,ESCF)
C
C   THE FORCE MATRIX IS PRINTED AS AN ATOM-ATOM MATRIX RATHER THAN
C   AS A 3N*3N MATRIX, AS THE 3N MATRIX IS VERY CONFUSING!
C
      IJ=0
      IU=0
      DO 120 I=1,NUMAT
         IL=IU+1
         IU=IL+2
         IM1=I-1
         JU=0
         DO 110 J=1,IM1
            JL=JU+1
            JU=JL+2
            SUM=0.D0
            DO 100 II=IL,IU
               DO 100 JJ=JL,JU
  100       SUM=SUM+FMATRX((II*(II-1))/2+JJ)**2
            IJ=IJ+1
  110    STORE(IJ)=SQRT(SUM)
         IJ=IJ+1
  120 STORE(IJ)=SQRT(
     1FMATRX(((IL+0)*(IL+1))/2)**2+
     2FMATRX(((IL+1)*(IL+2))/2)**2+
     3FMATRX(((IL+2)*(IL+3))/2)**2+2.D0*(
     4FMATRX(((IL+1)*(IL+2))/2-1)**2+
     5FMATRX(((IL+2)*(IL+3))/2-2)**2+
     6FMATRX(((IL+2)*(IL+3))/2-1)**2))
      IF(DEBUG) THEN
         WRITE(6,'(//10X,'' FULL FORCE MATRIX, INVOKED BY "DFORCE"'')')
         I=-NVAR
         CALL VECPRT(FMATRX,I)
      ENDIF
      IF(PRNT)THEN
         WRITE(6,'(//10X,'' FORCE MATRIX IN MILLIDYNES/ANGSTROM'')')
         CALL VECPRT(STORE,NUMAT)
      ENDIF
      L=(NVAR*(NVAR+1))/2
      DO 130 I=1,L
  130 STORE(I)=FMATRX(I)
      IF(PRNT) CALL AXIS(COORD,NUMAT,A,B,C,SUM,0,ROT)
      IF(PRNT)WRITE(6,'(//10X,''HEAT OF FORMATION ='',F12.6,
     1'' KCALS/MOLE'')')ESCF
      IF(LARGE)THEN
         CALL FRAME(STORE,NUMAT,0, SHIFT)
         CALL RSP(STORE,NVAR,NVAR,FREQ,CNORML)
         DO 140 I=NVIB+1,NVAR
            J=(FREQ(I)+50.D0)*0.01D0
  140    FREQ(I)=FREQ(I)-J*100
         IF(PRNT)THEN
            WRITE(6,'(//10X,''TRIVIAL VIBRATIONS, SHOULD BE ZERO'')')
            WRITE(6,'(/, F9.4,''=TX'',F9.4,''=TY'',F9.4,''=TZ'',
     1             F9.4,''=RX'',F9.4,''=RY'',F9.4,''=RZ'')')
     2(FREQ(I),I=NVIB+1,NVAR)
            WRITE(6,'(//10X,''FORCE CONSTANTS IN MILLIDYNES/ANGSTROM''
     1,'' (= 10**5 DYNES/CM)'',/)')
            WRITE(6,'(8F10.5)')(FREQ(I),I=1,NVIB)
C CONVERT TO WEIGHTED FMAT
            WRITE(6,'(//10X,'' ASSOCIATED EIGENVECTORS'')')
            I=-NVAR
            CALL MATOUT(CNORML,FREQ,NVIB,I,NVAR)
         ENDIF
      ENDIF
      CALL FREQCY(FMATRX,FREQ,CNORML,REDMAS,TRAVEL,.TRUE.)
C
C  CALCULATE ZERO POINT ENERGY
C
C
C  THESE CONSTANTS TAKEN FROM HANDBOOK OF CHEMISTRY AND PHYSICS 62ND ED.
C   N AVOGADRO'S NUMBER = 6.022045*10**23
C   H PLANCK'S CONSTANT = 6.626176*10**(-34)JHZ
C   C SPEED OF LIGHT    = 2.99792458*10**10 CM/SEC
C   CONST=0.5*N*H*C/(1000*4.184)
      CONST=1.4295718D-3
      SUM=0.D0
      DO 150 I=1,NVAR
  150 SUM=SUM+FREQ(I)
      SUM=SUM*CONST
      IF(PRNT)
     1WRITE(6,'(//10X,'' ZERO POINT ENERGY''
     2, F12.3,'' KILOCALORIES PER MOLE'')')SUM
      SUMM=0.D0
      DO 200 I=1,NVAR
         SUM1=1.D-20
         DO 160 J=1,NVAR
  160    SUM1=SUM1+CNORML(J+(I-1)*NVAR)**2
         SUM1=1.D0/SQRT(SUM1)
         DO 170 K=1,3
  170    GRAD(K)=0.D0
         DO 190 K=1,3
            SUM=0.D0
            DO 180 J=1,NVAR
  180       SUM=SUM+CNORML(J+(I-1)*NVAR)*DELDIP(K,J)
            SUMM=SUMM+ABS(SUM)
  190    TRDIP(K,I)=SUM*SUM1
         DIPT(I)=SQRT(TRDIP(1,I)**2+TRDIP(2,I)**2+TRDIP(3,I)**2)
  200 CONTINUE
      IF(PRNT)THEN
         WRITE(6,'(//3X,'' THE LAST'',I2,'' VIBRATIONS ARE THE'',
     1'' TRANSLATION AND ROTATION MODES'')')NVAR-NVIB
         WRITE(6,'(3X,'' THE FIRST THREE OF THESE BEING TRANSLATIONS'',
     1'' IN X, Y, AND Z, RESPECTIVELY'')')
      ENDIF
      IF(PRNT.AND.LARGE)THEN
         WRITE(6,'(//10X,'' FREQUENCIES, REDUCED MASSES AND '',
     1''VIBRATIONAL DIPOLES''/)')
         NTO6=NVAR/6
         NREM6=NVAR-NTO6*6
         IINC1=-5
         IF (NTO6.LT.1) GO TO 220
         DO 210 I=1,NTO6
            WRITE (6,'(/)')
            IINC1=IINC1+6
            IINC2=IINC1+5
            WRITE (6,'(3X,''I'',10I10)') (J,J=IINC1,IINC2)
            WRITE (6,'('' FREQ(I)'',6F10.4,/)') (FREQ(J),J=IINC1,IINC2)
            WRITE (6,'('' MASS(I)'',6F10.5,/)') (REDMAS(J),J=IINC1,IINC2
     1)
            WRITE (6,'('' DIPX(I)'',6F10.5)') (TRDIP(1,J),J=IINC1,IINC2)
            WRITE (6,'('' DIPY(I)'',6F10.5)') (TRDIP(2,J),J=IINC1,IINC2)
            WRITE (6,'('' DIPZ(I)'',6F10.5,/)') (TRDIP(3,J),J=IINC1,IINC
     12)
            WRITE (6,'('' DIPT(I)'',6F10.5)')
     1   (DIPT(J),J=IINC1,IINC2)
  210    CONTINUE
  220    CONTINUE
         IF (NREM6.LT.1) GO TO 230
         WRITE (6,'(/)')
         IINC1=IINC1+6
         IINC2=IINC1+(NREM6-1)
         WRITE (6,'(3X,''I'',10I10)') (J,J=IINC1,IINC2)
         WRITE (6,'('' FREQ(I)'',6F10.4)') (FREQ(J),J=IINC1,IINC2)
         WRITE (6,'(/,'' MASS(I)'',6F10.5)') (REDMAS(J),J=IINC1,IINC2)
         WRITE (6,'(/,'' DIPX(I)'',6F10.5)') (TRDIP(1,J),J=IINC1,IINC2)
         WRITE (6,'('' DIPY(I)'',6F10.5)') (TRDIP(2,J),J=IINC1,IINC2)
         WRITE (6,'('' DIPZ(I)'',6F10.5)') (TRDIP(3,J),J=IINC1,IINC2)
         WRITE (6,'(/,'' DIPT(I)'',6F10.5)')
     1   (DIPT(J),J=IINC1,IINC2)
  230    CONTINUE
      ENDIF
      WRITE(6,'(//10X,'' NORMAL COORDINATE ANALYSIS'')')
      I=-NVAR
      CALL MATOUT(CNORML,FREQ,NVAR,I,NVAR)
C
C   CARRY OUT IRC IF REQUESTED.
C
      IF(INDEX(KEYWRD,'IRC')+INDEX(KEYWRD,'DRC').NE.0)THEN
         DO 240 I=1,NVAR
            LOC(1,I)=0
  240    LOC(2,I)=0
         NVAR=NVAOLD
         DO 250 I=1,NVAR
            LOC(1,I)=LOCOLD(1,I)
  250    LOC(2,I)=LOCOLD(2,I)
         CALL XYZINT(COORD,NUMAT,NA,NB,NC,1.D0,GEO)
         LAST=1
         CALL DRC(CNORML,FREQ)
         CALL WRAPUP()
      ENDIF
      CALL FREQCY(FMATRX,FREQ,CNORML,DELDIP,DELDIP,.FALSE.)
      WRITE(6,'(//10X,'' MASS-WEIGHTED COORDINATE ANALYSIS'')')
      CALL MATOUT(CNORML,FREQ,NVAR,I,NVAR)
      CALL ANAVIB(COORD,FREQ,DIPT,NVAR,CNORML,STORE,
     1FMATRX,TRAVEL,REDMAS)
      IF(INDEX(KEYWRD,'THERMO').NE.0) THEN
         CALL GMETRY(GEO,COORD)
         I=INDEX(KEYWRD,' ROT')
         IF(I.NE.0) THEN
            SYM=READA(KEYWRD,I)
         ELSE
            SYM=1
         ENDIF
         LINEAR=(ABS(A*B*C) .LT. 1.D-10)
         I=INDEX(KEYWRD,' TRANS')
C
C   "I" IS GOING TO MARK THE BEGINNING OF THE GENUINE VIBRATIONS.
C
         IF(I.NE.0)THEN
            I=INDEX(KEYWRD,' TRANS=')
            IF(I.NE.0)THEN
               I=1+READA(KEYWRD,I)
               J=NVIB-I+1
               WRITE(6,'(//1X,''THE LOWEST'',I3,'' VIBRATIONS ARE NOT'',
     1/,'' TO BE USED IN THE THERMO CALCULATION'')')I-1
            ELSE
               WRITE(6,'(//10X,''SYSTEM IS A TRANSITION STATE'')')
               I=2
               J=NVIB-1
            ENDIF
         ELSE
            WRITE(6,'(//10X,''SYSTEM IS A GROUND STATE'')')
            I=1
            J=NVIB
         ENDIF
         CALL THERMO(A,B,C,LINEAR,SYM,WTMOL,FREQ(I),J,ESCF)
      ENDIF
      RETURN
      END

C     *****************
      SUBROUTINE STAPLE(
C     *****************
     >                  NVH,NVL,NVE,ICC,I,
     >                  SHT,GCB,LINKS,
     >                  WK1,WK2,WK3,WK4 )
C
C
      DOUBLE PRECISION  LINKS(NVE,18,4),
     >                  WK1(NVH,18),WK2(NVH,18),WK3(NVH,18),WK4(NVH,18),
     >                  ZERO,RTIME,TSTART,TEND
C
C
      COMMON / PERF / RTIME(15),IPRO
C
C
      INTEGER    GCB(NVH,2)
C
      INTEGER    SHT(4)
C
C
      PARAMETER( ZERO = 0.D0 )
C
C
C     INITIALIZE PLAQUETTE SUM TO ZERO
C
C
      DO 10 ISM = 1,18
      DO 10 IVL = 1,NVL
      WK4(IVL,ISM) = ZERO
   10 CONTINUE
C
C
      DO 20 J = 1,4
C
C
      IF( J .EQ. I ) GOTO 20
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK1,NVE,LINKS(1,1,J),GCB(1,ICC),SHT(I) )
C     ***********
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK2,NVE,LINKS(1,1,I),GCB(1,ICC),SHT(J) )
C     ***********
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,2,WK3,WK1,WK2)
C     ********
      CALL TIMER(TEND)
      RTIME(8) = RTIME(8) + TEND - TSTART
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK2,NVE,LINKS(1,1,J),GCB(1,ICC),0 )
C     ***********
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,2,WK1,WK3,WK2)
C     ********
      CALL TIMER(TEND)
      RTIME(8) = RTIME(8) + TEND - TSTART
C
C
      DO 30 ISM = 1,18
      DO 30 IVL = 1,NVL
      WK4(IVL,ISM) = WK4(IVL,ISM) + WK1(IVL,ISM)
   30 CONTINUE
C
C
C     ***********
      CALL GATHER(NVH,NVL,WK1,NVE,LINKS(1,1,J),GCB(1,ICC),SHT(I)-SHT(J))
C     ***********
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK2,NVE,LINKS(1,1,I),GCB(1,ICC),-SHT(J) )
C     ***********
C
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,3,WK3,WK1,WK2)
C     ********
      CALL TIMER(TEND)
      RTIME(8) = RTIME(8) + TEND - TSTART
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK2,NVE,LINKS(1,1,J),GCB(1,ICC),-SHT(J) )
C     ***********
C
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,1,WK1,WK3,WK2)
C     ********
      CALL TIMER(TEND)
      RTIME(8) = RTIME(8) + TEND - TSTART
C
C
      DO 40 ISM = 1,18
      DO 40 IVL = 1,NVL
      WK4(IVL,ISM) = WK4(IVL,ISM) + WK1(IVL,ISM)
   40 CONTINUE
C
C
   20 CONTINUE
C
C
      END

      SUBROUTINE GETSCR(IUN,A,N,M)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,M)
c--   version 3
      REWIND IUN
      DO 100 J=1,M
         READ(IUN) (A(I,J),I=1,N)
 100  CONTINUE 
c--      do 100 j=1,m
c--         do 110 i=1,n
c--            a(i,j)=atmp(i,j)
c-- 110     continue
c-- 100  continue
      END

      SUBROUTINE MXMTST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   FLOATING-POINT MATRIX MULTIPLY TEST
C
      PARAMETER (L=256, M=128, N=64, F7=78125., T30=1073741824.)
      COMMON /ARRAYS/ A(L,M), S1, B(M,N), S2, C(L,N)
      DATA IT/100/, ANS/35.2026179738722/
C
C   INITIALIZATION
C
C   THE ARRAYS A AND B ARE FILLED WITH PSEUDO-RANDOM  (0., 1.)  DATA
C   USING A RANDOM NUMBER GENERATOR BASED ON THE RECURSION
C           X(N+1) = 5**7 * X(N)  (MOD 2**30)
C   THIS RECURSION WILL GENERATE 2**28 (APPROX. 268 MILLION) NUMBERS
C   BEFORE REPEATING.  FOR THIS SCHEME TO WORK PROPERLY, THE HARDWARE
C   MULTIPLY OPERATION MUST BE CORRECT TO 47 BITS OF PRECISION.
C   THIS SAME SCHEME IS USED TO INITIALIZE DATA ARRAYS FOR ALL TESTS.
C
      T = F7 / T30
      DO 100 J = 1, M
        DO 100 I = 1, L
          T = MOD (F7 * T, 1.0D0)
          A(I,J) = T
100   CONTINUE
      DO 110 J = 1, N
        DO 110 I = 1, M
          T = MOD (F7 * T, 1.0D0)
          B(I,J) = T
110   CONTINUE
      TM = CPTIME ()
C
C   TIMING TEST
C
      DO 120 II = 1, IT
        CALL MXM (A, B, C, L, M, N)
120   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((C(19,19) - ANS) / ANS)
      FP = 2. * IT * L * M * N
C
      RETURN
      END

      SUBROUTINE MATVEC(A,B,N,AB)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N),AB(N)
C     
      DO 100 I=1,N
         AB(I)=0.
 100  CONTINUE
C     
      DO 200 J=1,N
         BJ=B(J)
         DO 210 I=1,N
            AB(I)=AB(I)+A(I,J)*BJ
 210     CONTINUE
 200  CONTINUE
      END       

      SUBROUTINE DIAG(FAO,VECTOR,NOCC,EIG,MDIM,N)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION FAO(*),VECTOR(MDIM,*),EIG(*),WS(MAXORB)
C***********************************************************************
C
C   "FAST" DIAGONALISATION PROCEDURE.
C
C    ON INPUT FAO CONTAINS THE LOWER HALF TRIANGLE OF THE MATRIX TO BE
C                         DIAGONALISED, PACKED.
C             VECTOR  CONTAINS THE OLD EIGENVECTORS ON INPUT, THE NEW
C             VECTORS ON EXITING.
C             NOCC = NUMBER OF OCCUPIED MOLECULAR ORBITALS.
C             EIG  = EIGENVALUES FROM AN EXACT DIAGONALISATION
C             MDIM = DECLARED SIZE OF MATRIX "C".
C             N = NUMBER OF ATOMIC ORBITALS IN BASIS SET
C
C  DIAG IS A PSEUDO-DIAGONALISATION PROCEDURE, IN THAT THE VECTORS THAT
C       ARE GENERATED BY IT ARE MORE NEARLY ABLE TO BLOCK-DIAGONALISE
C       THE FOCK MATRIX OVER MOLECULAR ORBITALS THAN THE STARTING
C       VECTORS. IT MUST BE CONSIDERED PSEUDO FOR SEVERAL REASONS:
C       (A) IT DOES NOT GENERATE EIGENVECTORS - THE SECULAR DETERMINANT
C           IS NOT DIAGONALISED, ONLY THE OCCUPIED-VIRTUAL INTERSECTION.
C       (B) MANY SMALL ELEMENTS IN THE SEC.DET. ARE IGNORED AS BEING TOO
C           SMALL COMPARED WITH THE LARGEST ELEMENT.
C       (C) WHEN ELEMENTS ARE ELIMINATED BY ROTATION, THE REST OF THE
C           SEC. DET. IS ASSUMED NOT TO CHANGE, I.E. ELEMENTS CREATED
C           ARE IGNORED.
C       (D) THE ROTATION REQUIRED TO ELIMINATE THOSE ELEMENTS CONSIDERED
C           SIGNIFICANT IS APPROXIMATED TO USING THE EIGENVALUES OF THE
C           EXACT DIAGONALISATION THROUGHOUT THE REST OF THE ITERATIVE
C           PROCEDURE.
C
C  (NOTE:- IN AN ITERATIVE PROCEDURE ALL THE APPROXIMATIONS PRESENT IN
C          DIAG BECOME VALID AT SELF-CONSISTENCY, SELF-CONSISTENCY IS
C          NOT SLOWED DOWN BY USE OF THESE APPROXIMATIONS)
C
C    REFERENCE:
C             "FAST SEMIEMPIRICAL CALCULATIONS",
C             STEWART. J.J.P., CSASZAR, P., PULAY, P., J. COMP. CHEM.,
C             3, 227, (1982)
C
C***********************************************************************
      COMMON /SCRACH/ FMO(MORB2), XDUMY(MAXPAR**2-MORB2)
C             FMO  IS A WORK-SPACE OF SIZE (N-NOCC)*NOCC, IT WILL HOLD
C                  THE FOCK MOLECULAR ORBITAL INTERACTION MATRIX.
C
C  FIRST, CONSTRUCT THAT PART OF A SECULAR DETERMINANT OVER MOLECULAR
C  ORBITALS WHICH CONNECTS THE OCCUPIED AND VIRTUAL SETS.
C
C***********************************************************************
C
      LOGICAL FIRST
      DATA FIRST /.TRUE./
      IF(FIRST)THEN
         FIRST=.FALSE.
C
C   EPS IS THE SMALLEST NUMBER WHICH, WHEN ADDED TO 1.D0, IS NOT
C   EQUAL TO 1.D0
         CALL EPSETA(EPS,ETA)
C
C   INCREASE EPS TO ALLOW FOR A LOT OF ROUND-OFF
C
         BIGEPS=10.D0*SQRT(EPS)
      ENDIF
      TINY=0.D0
      LUMO=NOCC+1
      IJ=0
      DO 60 I=LUMO,N
         KK=0
         DO 30 J=1,N
            SUM=0.D0
            DO 10 K=1,J
               KK=KK+1
   10       SUM=SUM+FAO(KK)*VECTOR(K,I)
            IF(J.EQ.N) GOTO 30
            J1=J+1
            K2=KK
            DO 20 K=J1,N
               K2=K2+K-1
   20       SUM=SUM+FAO(K2)*VECTOR(K,I)
   30    WS(J)=SUM
         DO 50 J=1,NOCC
            IJ=IJ+1
            SUM=0.D0
            DO 40 K=1,N
   40       SUM=SUM+WS(K)*VECTOR(K,J)
            IF(TINY.LT.ABS(SUM)) TINY=ABS(SUM)
   50    FMO(IJ)=SUM
   60 CONTINUE
      TINY=0.04D0*TINY
C***********************************************************************
C
C   NOW DO A CRUDE 2 BY 2 ROTATION TO "ELIMINATE" SIGNIFICANT ELEMENTS
C
C***********************************************************************
      IJ=0
      DO 90 I=LUMO,N
         DO 80 J=1,NOCC
            IJ=IJ+1
            IF(ABS(FMO(IJ)).LT.TINY) GOTO 80
C
C      BEGIN 2 X 2 ROTATIONS
C
            A=EIG(J)
            B=EIG(I)
            C=FMO(IJ)
            D=A-B
C
C    USE BIGEPS TO DETERMINE WHETHER TO DO A 2 BY 2 ROTATION
C
            IF(ABS(C/D).LT.BIGEPS) GOTO 80
C
C  AT THIS POINT WE KNOW THAT 
               E=SIGN(SQRT(4.D0*C*C+D*D),D)
               ALPHA=SQRT(0.5D0*(1.D0+D/E))
               BETA=-SIGN(SQRT(1.D0-ALPHA*ALPHA),C)
C
C      ROTATION OF PSEUDO-EIGENVECTORS
C
            DO 70 M=1,N
               A=VECTOR(M,J)
               B=VECTOR(M,I)
               VECTOR(M,J)=ALPHA*A+BETA*B
               VECTOR(M,I)=ALPHA*B-BETA*A
   70       CONTINUE
   80    CONTINUE
   90 CONTINUE
      RETURN
      END

      SUBROUTINE DEPVAR (A,I,W,L)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(3,*)
C***********************************************************************
C
C  IN SUBROUTINE HADDON WHEN M, THE SYMMETRY OPERATION, IS 18 DEPVAR IS
C  CALLED. DEPVAR SHOULD THEN CONTAIN A USER-WRITTEN SYMMETRY OPERATION.
C  SEE HADDON TO GET THE IDEA ON HOW TO WRITE DEPVAR.
C
C ON INPUT:
C           A = ARRAY OF INTERNAL COORDINATES
C           I = ADDRESS OF REFERENCE ATOM
C ON OUTPUT:
C           L = 1 (IF A BOND-LENGTH IS THE DEPENDENT FUNCTION)
C             = 2 (IF AN ANGLE IS THE DEPENDENT FUNCTION)
C             = 3 (IF A DIHEDRAL ANGLE IS THE DEPENDENT FUNCTION)
C           W = VALUE OF THE FUNCTION
C
C  NOTE:  IT IS THE WRITER'S RESPONSIBILITY TO MAKE CERTAIN THAT THE
C         SUBROUTINE DOES NOT CONTAIN ANY ERRORS!
C***********************************************************************
      COMMON /KEYWRD/ KEYWRD
      CHARACTER*80 KEYWRD
      LOGICAL FIRST
      DATA FIRST/.TRUE./
      IF (FIRST) THEN
         FIRST=.FALSE.
         FACT=READA(KEYWRD,INDEX(KEYWRD,'DEPVAR'))
         WRITE(6,'(''  UNIT CELL LENGTH ='',F14.7,
     1'' TIMES BOND LENGTH'')')FACT
      ENDIF
      W=A(1,I)*FACT
      L=1
      RETURN
      END

      SUBROUTINE CFFT2D2 (IS, M, M1, N, X, W, IP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   PERFORMS COMPLEX RADIX 2 FFTS ON THE SECOND DIMENSION OF THE 2-D ARRAY X
C   D H BAILEY  11/15/84
C
      COMPLEX X(M1,N), W(N), CT, CX
      INTEGER IP(2,N)
      DATA PI/3.141592653589793/
C
C   IF  IS = 0  THEN INITIALIZE ONLY
C
      N2 = N / 2
      IF (IS .EQ. 0)  THEN
        DO 100 I = 1, N2
          T = 2. * PI * (I-1) / N
          W(I) = CMPLX (COS (T), SIN (T))
100     CONTINUE
        RETURN
      ENDIF
C
C   PEFORM FORWARD OR BACKWARD FFTS ACCORDING TO  IS = 1 OR -1
C
      DO 110 I = 1, N
        IP(1,I) = I
110   CONTINUE
      L = 1
      I1 = 1
C
120   I2 = 3 - I1
      DO 130 J = L, N2, L
        CX = W(J-L+1)
        IF (IS .LT. 0)  CX = CONJG (CX)
        DO 130 I = J-L+1, J
          II = IP(I1,I)
          IP(I2,I+J-L) = II
          IM = IP(I1,I+N2)
          IP(I2,I+J) = IM
          DO 130 K = 1, M
            CT = X(K,II) - X(K,IM)
            X(K,II) = X(K,II) + X(K,IM)
            X(K,IM) = CT * CX
130   CONTINUE
      L = 2 * L
      I1 = I2
      IF (L .LE. N2)  GOTO 120
C
      DO 150 I = 1, N
        II = IP(I1,I)
        IF (II .GT. I)  THEN
          DO 140 K = 1, M
            CT = X(K,I)
            X(K,I) = X(K,II)
            X(K,II) = CT
140       CONTINUE
        ENDIF
150   CONTINUE
C
      RETURN
      END

      SUBROUTINE EIGVAL(IX,IY,JDIM,KDIM,Q,PRESS,SNDSP,XYJ,XY,TMET,
     *                   UU,CC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  IX = 1  IY = 2 FOR XI   DIRECTION  METRICS
C  IX = 3  IY = 4 FOR ETA  DIRECTION  METRICS
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4)
      DIMENSION TMET(JDIM,KDIM),XYJ(JDIM,KDIM)
C
      DIMENSION UU(JDIM,KDIM),CC(JDIM,KDIM)
C
C   COMPUTE SPECTRAL RADIUS SCALING
C
      DO 100 K=KBEGIN,KEND
      DO 100 J=JBEGIN,JEND
C        RI IS J/RHO
         RI = 1./Q(J,K,1)
         U = Q(J,K,2)*RI
         V = Q(J,K,3)*RI
C
C  NOTE: TIME METRICS PUT IN (SLOPPY BUT THEY WORK)
C
         UU(J,K) = TMET(J,K) + U*XY(J,K,IX)+V*XY(J,K,IY)
         CC(J,K) = SNDSP(J,K)*SQRT(XY(J,K,IX)**2+XY(J,K,IY)**2)
C
  100 CONTINUE
C
                RETURN
                END

C----------------------------------------------------------------------
C
C   D O U T
C
C   COMPUTE EQUATORIAL COORDINATES FROM THE RECTANGULAR BARYCENTRIC
C   COORDINATES
C
C----------------------------------------------------------------------
      SUBROUTINE DOUT (T)
      REAL T 
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C
C  DATA IS COLLECTED FROM THE GLOBAL VARIABLES
C
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)
      REAL
     .    EPOCH,
     .    SBINC(0:ORDER,0:ORDER),
     .    DD(0:ORDER),
     .    KK(-MMM:MMM,-MMM:MMM),
     .    MASS(MAXOBJ),
     .    COORD(3,MAXOBJ),
     .    VELOC(3,MAXOBJ),
     .    XDIFF(3,MAXOBJ),      
     .    ACCEL(-MMM:MMM,3,MAXOBJ,0:1),
     .    ADIFF(maxobj,0:ORDER,3),  
     .    DISTNC(MAXOBJ,MAXOBJ)        
      INTEGER SWAP
      COMMON /INTTAB/    SBINC,DD,KK,
     .                   COORD,VELOC,MASS,
     .                   XDIFF,ACCEL,ADIFF,DISTNC,SWAP,
     .                   EPOCH
C
C  COMMON OUT IS USED TO STORE OUTPUT 
C
      REAL
     .    PLANET(3,MAXOBJ),      
     .    OLDPL(2,MAXOBJ)    
      INTEGER
     .    TODAY
      REAL
     .    OUTBUF(MAXDAY,3,MAXOBJ)      
C
      COMMON /OUT/ OUTBUF, PLANET, OLDPL, TODAY
C
C
      INTEGER I  
      REAL
     .    JD, CX, CY, CZ, XX, YY, ZZ
C
C  COMPUTE  PRECESSED HELIOCENTRIC COORDINATES
C
      JD = T + 2415020.0E+0
      DO 10 I=1,MAXOBJ
         CX=COORD(1,I)-COORD(1,1)   
         CY=COORD(2,I)-COORD(2,1)
         CZ=COORD(3,I)-COORD(3,1)
         CALL PRECES(2433282.423E+0, JD, CX,CY,CZ, XX,YY,ZZ)
         PLANET(1,I)=XX
         PLANET(2,I)=YY
         PLANET(3,I)=ZZ
 10   CONTINUE
C
C  CONVERT HELIOCENTRIC COORDINATES TO EQUATORIAL
C 
      CALL EQC (T)
      RETURN
      END

C     ****************
      SUBROUTINE CHKIN(
C     ****************
     >                 NS,NT,NW1,
     >                 START,IAVG,IAVGDD,SEED,ITEMAX,
     >                 METHIT,ITBLUP,ORDEXP,BETA,SIGMA)
C
C
      INTEGER  SEED,START,ORDEXP
C
C
      DOUBLE PRECISION     BETA,SIGMA,
     >                     ZERO
C
C
      PARAMETER( ZERO = 0.D0 )
C
C
      IF( NS .LT. 2 .OR. NT .LT. 2 ) THEN
          WRITE(NW1,2000)
          STOP
      ENDIF
C
      NSC = NS  / 2
      NSC = NSC * 2
      NTC = NT  / 2
      NTC = NTC * 2
C
      IF( NSC .NE. NS .OR. NTC .NE. NT ) THEN
          WRITE(NW1,2010)
          STOP
      ENDIF
C
      IF( START. NE. 1 .AND. START .NE. 0 ) THEN
          WRITE(NW1,2050)
          STOP
      ENDIF
C
      IF( IAVG .LT. 1 ) THEN
          WRITE(NW1,2060)
          STOP
      ENDIF
C
      IF( IAVGDD .LT. 0 ) THEN
          WRITE(NW1,2070)
          STOP
      ENDIF
C
      IF( ITEMAX .LT. 0 ) THEN
          WRITE(NW1,2080)
          STOP
      ENDIF
C
      IF( METHIT .LT. 0 ) THEN
          WRITE(NW1,2090)
          STOP
      ENDIF
C
      IF( ITBLUP .LT. 0 ) THEN
          WRITE(NW1,2100)
          STOP
      ENDIF
C
      IF( ORDEXP .LT. 1 ) THEN
          WRITE(NW1,2100)
          STOP
      ENDIF
C
      IF( BETA .LE. ZERO ) THEN
          WRITE(NW1,2110)
          STOP
      ENDIF
C
      IF( SIGMA .LE. ZERO ) THEN
          WRITE(NW1,2120)
          STOP
      ENDIF
C
C
 2000 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE LINEAR LATTICE SIZE MUST BE GREATER THAN ONE,' /
     >       1X,'IN SPATIAL AND TEMPORAL DIMENSION'                 )
 2010 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE NUMBER OF LATTICE POINTS MUST BE EVEN,'        /
     >       1X,'IN SPATIAL AND TEMPORAL DIMENSION'                 )
 2020 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE NUMBER OF PROCESSES MUST BE GREATER THAN ZERO,'/
     >       1X,'IN EACH DIMENSION'                                 )
 2030 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE NUMBER OF PROCESSES MUST NOT BE GREATER THAN'  /
     >       1X,'THE NUMBER OF LATTICE POINTS FOR EACH DIMENSION'   )
 2040 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'PROVIDE THAT THE SUBLATTICE OF EACH PROCESS HAS'   /
     >       1X,'AT MOST ONE DIMENSION WITH A SINGLE LATTICE POINT' )
 2050 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'CHOOSE 0 FOR A DISORDERED START CONFIGURATION,'    /
     >       1X,'1 FOR AN ORDERED START CONFIGURATION'              )
 2060 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE MODUL FOR TAKING AVERAGES MUST BE GREATER THEN'/
     >       1X,'ONE'                                               )
 2070 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE NUMBER OF INITIALLY DISCARDED ITERATIONS'      /
     >       1X,'MUST NOT BE NEGATIVE'                              )
 2080 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE TOTAL NUMBER OF ITERATIONS MUST NOT BE'        /
     >       1X,'NEGATIVE'                                          )
 2090 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE NUMBER OF METROPOLIS-HITS MUST NOT BE NEGATIVE')
 2100 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE ORDER OF THE TAYLOR SERIES EXPANSION OF THE'   /
     >       1X,'OF THE EXPONENTIAL FUNCTION MUST BE GREATER THAN'  /
     >       1X,'ZERO'                                              )
 2110 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE BARE COUPLING CONSTANT MUST BE GREATER THEN'   /
     >       1X,'ZERO'                                              )
 2120 FORMAT(1X,'INPUT ERROR:'                                      /
     >       1X,'THE STANDARD DEVIATION FOR GAUSSIAN DISTRIBUTED'   /
     >       1X,'RANDOM NUMBERS MUST BE GREATER THAN ZERO'          )
C
C
      RETURN
      END

      SUBROUTINE STRSYM(NC,IB,R,SIGSYM)
C
C     APPLY POINT GROUP OPERATIONS TO THE STRESS TENSOR CALCULATED BY
C     SUMMING OVER SPECIAL POINTS.
C     WRITTEN 14-OCT-82 BY OLE HOLM NIELSEN
C     INPUT: SEE SUBROUTINE ROSYM2.
C     STRESS ..... THE STRESS TO BE SYMMETRIZED. ON RETURN STRESS
C                 CONTAINS THE CORRECT STRESS TENSOR.
C
      INTEGER IB(48)
      REAL R(49,3,3),STRESS(3,3),WORK(3,3),SIGSYM(6)
         STRESS(1,1)=SIGSYM(1)
         STRESS(2,2)=SIGSYM(2)
         STRESS(3,3)=SIGSYM(3)
         STRESS(1,2)=SIGSYM(6)
         STRESS(1,3)=SIGSYM(5)
         STRESS(2,1)=SIGSYM(6)
         STRESS(2,3)=SIGSYM(4)
         STRESS(3,1)=SIGSYM(5)
         STRESS(3,2)=SIGSYM(4)
C-----------------------------------------------------------------------
      DO 100 I = 1,3
        DO 100 J = 1,3
C       DIVIDE BY THE NUMBER OF GROUP OPERATIONS
          WORK(I,J) = STRESS(I,J)/FLOAT(NC)
100   CONTINUE
C
      DO 190 I = 1,3
        DO 190 J = 1,3
          STRESS(I,J) = 0.0
C       SUM OVER ROTATIONS
          DO 190 IROT = 1,NC
C         NOTE THAT FROM K290, THE ARRAYS F0 AND V ARE ARRANGED
C         DIFFERENTLY FROM THE ROTATION MATRICES.
            IC = IB(IROT)
            DO 190 K1 = 1,3
              DO 190 K2 = 1,3
                STRESS(I,J) = STRESS(I,J) + 
     &                     R(IC,I,K1) * R(IC,J,K2) * WORK(K1,K2)
190   CONTINUE
      SIGSYM(1)=STRESS(1,1)
      SIGSYM(2)=STRESS(2,2)
      SIGSYM(3)=STRESS(3,3)
      SIGSYM(4)=STRESS(2,3)
      SIGSYM(5)=STRESS(1,3)
      SIGSYM(6)=STRESS(1,2)
      RETURN
      END

      SUBROUTINE ANALYT(PSUM,PALPHA,PBETA,COORD,NAT,JJA,JJD,
     1IIA,IID,NORB,ENG,KREP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION COORD(3,*),ENG(3), PSUM(*), PALPHA(*), PBETA(*),NAT(*)
************************************************************************
*                                                                      *
*         CALCULATION OF ANALYTICAL DERIVATIVES                        *
*                                                                      *
************************************************************************
C
C COMMON BLOCKS 'OWNED' BY REST OF PROGRAM.
C
      COMMON /CORE  / CORE(107)
     1       /BETAS / BETAS(107),BETAP(107),BETAD(107)
     2       /EXPONT/ ZS(107),ZP(107),ZD(107)
     3       /ALPHA / ALPA(107)
      COMMON /TWOEL3/ F03(107)
      COMMON /NATORB/ NATORB(107)
      COMMON /ALPHA3/ ALP3(153)
      COMMON /IDEAS / FN1(107,10),FN2(107,10),FN3(107,10)
      COMMON /WMATRX/ W(N2ELEC)
      COMMON /NATYPE/ NZTYPE(107),MTYPE(30),LTYPE
      COMMON /BETA3 / BETA3(153)
      COMMON /VSIPS / VS(107),VP(107),VD(107)
      COMMON /KEYWRD/ KEYWRD
C
C COMMON BLOCKS 'OWNED' BY ANT
C
      COMMON /DERIVS/ DS(16),DG(22),DR(100),TDX(3),TDY(3),TDZ(3)
      COMMON /EXTRA/  G(22), TXYZ(9)
C
C ON RETURN, ENG HOLDS ANALYTICAL DERIVATIVES
C
      COMMON /FORCE3/ IDMY(5),I3N,IX
      DIMENSION EAA(3),EAB(3),ENUC(3), BI(4), BJ(4)
      CHARACTER*80 KEYWRD
      LOGICAL FIRST, AM1, MINDO3
      DATA FIRST/.TRUE./
      IF( FIRST ) THEN
         AM1=(INDEX(KEYWRD,'AM1')+INDEX(KEYWRD,'PM3').NE.0)
         MINDO3=(INDEX(KEYWRD,'MINDO').NE.0)
         FIRST=.FALSE.
      ENDIF
      A0=0.529167D0
      JD=JJD-JJA+1
      JA=1
      ID=IID-IIA+1+JD
      IA=JD+1
      DO 10 J=1,3
         EAA(J)=0.0D0
         EAB(J)=0.0D0
         ENUC(J)=0.0D0
         ENG(J)=0.0D0
   10 CONTINUE
      I=2
      NI=NAT(I)
      ISTART=NZTYPE(NI)*4-3
      J=1
      NJ=NAT(J)
      JSTART=NZTYPE(NJ)*4-3
      R2=(COORD(1,I)-COORD(1,J))**2+(COORD(2,I)-COORD(2,J))**2
     1   + (COORD(3,I)-COORD(3,J))**2
      RIJ=SQRT(R2)
      R0=RIJ/A0
      RR=R2/(A0*A0)
      DO 150 IX=1,3
         DEL1=COORD(IX,I)-COORD(IX,J)
         TERMAA=0.0D0
         TERMAB=0.0D0
         ISP=0
         IOL=0
C   THE FIRST DERIVATIVES OF OVERLAP INTEGRALS
         DO 30 K=IA,ID
            KA=K-IA
            KG=ISTART+KA
            DO 30 L=JA,JD
               LA=L-JA
               LG=JSTART+LA
               IOL=IOL+1
               DS(IOL)=0.0D0
               IF(KA.EQ.0.AND.LA.EQ.0) THEN
C   (S/S) TERM
                  IF(ABS(DEL1).LE.1.0D-6) GO TO 30
                  IS=1
               ELSEIF(KA.EQ.0.AND.LA.GT.0) THEN
C   (S/P) TERM
                  IS=3
                  IF(IX.EQ.LA) GO TO 20
                  IF(ABS(DEL1).LE.1.0D-6) GO TO 30
                  IS=2
                  DEL2=COORD(LA,I)-COORD(LA,J)
               ELSEIF(KA.GT.0.AND.LA.EQ.0) THEN
C   (P/S) TERM
                  IS=5
                  IF(IX.EQ.KA) GO TO 20
                  IF(ABS(DEL1).LE.1.0D-6) GO TO 30
                  IS=4
                  DEL2=COORD(KA,I)-COORD(KA,J)
               ELSE
C   (P/P) TERM
                  IF(KA.EQ.LA) THEN
C    P/P
                     IS=9
                     IF(IX.EQ.KA) GO TO 20
                     IF(ABS(DEL1).LE.1.0D-6) GO TO 30
C    P'/P'
                     IS=8
                     DEL2=COORD(KA,I)-COORD(KA,J)
                  ELSEIF(IX.NE.KA.AND.IX.NE.LA) THEN
C    P'/P"
                     IF(ABS(DEL1).LE.1.0D-6) GO TO 30
                     IS=7
                     DEL2=COORD(KA,I)-COORD(KA,J)
                     DEL3=COORD(LA,I)-COORD(LA,J)
                  ELSE
C    P/P' OR P'/P
                     DEL2=COORD(KA+LA-IX,I)-COORD(KA+LA-IX,J)
                     IS=6
                  ENDIF
               ENDIF
C
C        CALCULATE OVERLAP DERIVATIVES, STORE RESULTS IN DS
C
   20          CALL DERS(KG,LG,RR,DEL1,DEL2,DEL3,IS,IOL)
   30    CONTINUE
         IF(.NOT.MINDO3.AND.IX.EQ.1) READ (2) (G(I22),I22=1,22)
         IF(.NOT.MINDO3) CALL DELRI(DG,NI,NJ,R0,DEL1)
         CALL DELMOL(COORD,I,J,NI,NJ,IA,ID,JA,JD,IX,RIJ,DEL1,ISP)
C
C   THE FIRST DERIVATIVE OF NUCLEAR REPULSION TERM
         IF(MINDO3)THEN
            II=MAX(NI,NJ)
            NBOND=(II*(II-1))/2+NI+NJ-II
            ALPHA=0
            IF(NBOND.LT.154)THEN
               ALPHA=ALP3(NBOND)
            ELSE
            ALPH1=100
            ALPH2=100
               IF(NATORB(NI).EQ.0)ALPH1=ALPA(NI)
               IF(NATORB(NJ).EQ.0)ALPH2=ALPA(NJ)
            ENDIF
            C2=(7.1995D0/F03(NI)+7.1995D0/F03(NJ))**2
            C1=DEL1/RIJ*CORE(NI)*CORE(NJ)*14.399D0
            C3=DEL1/RIJ*ABS(CORE(NI)*CORE(NJ))*14.399D0
            IF(NBOND.EQ.22.OR.NBOND.EQ.29)THEN
               TERMNC=-C1*ALPHA*(1.D0/RIJ**2 - RIJ*(RIJ**2+C2)**(-1.5D0)
     1 +  1.D0/RIJ - 1.D0/SQRT(RIJ**2+C2)) * EXP(-RIJ) -
     2C1*RIJ*(RIJ**2+C2)**(-1.5D0)
            ELSEIF (RIJ.LT.1.D0.AND.NATORB(NI)*NATORB(NJ).EQ.0) THEN
               TERMNC=0.D0
            ELSEIF(NBOND.GE.154) THEN
C
C  SPECIAL CASE INVOLVING SPARKLES
C
            EXP1=EXP(-MIN(ALPH1*RIJ,20.D0))
            EXP2=EXP(-MIN(ALPH2*RIJ,20.D0))
            PART1=-C3*(1.D0/RIJ**2 - RIJ*(RIJ**2+C2)**(-1.5D0))
     +*(EXP1+EXP2)
            PART2=-C3*(1.D0/RIJ -1.D0/SQRT(RIJ**2+C2))
     +*(ALPH1*EXP1 + ALPH2*EXP2)
            PART3=-C1*RIJ*(RIJ**2+C2)**(-1.5D0)
               TERMNC=PART1+PART2+PART3
C#            WRITE(6,'(4F13.6)')PART1,PART2,PART3,TERMNC
            ELSE
              TERMNC=-C1*(1.D0/RIJ**2 - RIJ*(RIJ**2+C2)**(-1.5D0) +
     1ALPHA/RIJ - ALPHA/SQRT(RIJ**2+C2)) * EXP(-ALPHA*RIJ) -
     2C1*RIJ*(RIJ**2+C2)**(-1.5D0)
            ENDIF
            DR1=DEL1/RIJ*14.399D0*RIJ*(RIJ**2+C2)**(-1.5D0)
         ELSE
C
C      CORE-CORE TERMS, MNDO AND AM1
C
C
C  SPECIAL TREATMENT FOR N-H AND O-H TERMS
C
            IF(RIJ.LT.1.D0.AND.NATORB(NI)*NATORB(NJ).EQ.0)THEN
               TERMNC=0.D0
               GOTO 50
            ENDIF
            C1=CORE(NI)*CORE(NJ)
            IF(NI.EQ.1.AND.(NJ.EQ.7.OR.NJ.EQ.8)) THEN
               F3=1.0D0+EXP(-ALPA(1)*RIJ)+RIJ*EXP(-ALPA(NJ)*RIJ)
               DD=(DG(1)*F3-G(1)*(DEL1/RIJ)*(ALPA(1)*EXP(-ALPA(1)*RIJ)
     1 +(ALPA(NJ)*RIJ-1.0D0)*EXP(-ALPA(NJ)*RIJ)))*C1
            ELSEIF((NI.EQ.7.OR.NI.EQ.8).AND.NJ.EQ.1) THEN
               F3=1.0D0+EXP(-ALPA(1)*RIJ)+RIJ*EXP(-ALPA(NI)*RIJ)
               DD=(DG(1)*F3-G(1)*(DEL1/RIJ)*(ALPA(1)*EXP(-ALPA(1)*RIJ)
     1 +(ALPA(NI)*RIJ-1.0D0)*EXP(-ALPA(NI)*RIJ)))*C1
         ELSE
C#            ELSEIF(NATORB(NI)+NATORB(NJ).EQ.0) THEN
C
C  SPECIAL CASE OF TWO SPARKLES
C
               PART1=DG(1)*C1
               PART2=-(G(1)*(DEL1/RIJ)*(ALPA(NI)*EXP(-ALPA(NI)*RI
     1J) +ALPA(NJ)*EXP(-ALPA(NJ)*RIJ)))*ABS(C1)
             PART3=DG(1)*(EXP(-ALPA(NI)*RIJ)+EXP(-ALPA(NJ)*RIJ))*ABS(C1)
            DD=PART1+PART2+PART3
C#            WRITE(6,'(4F13.6)')PART1,PART2,PART3,DD
C#            ELSE
C
C   THE GENERAL CASE
C
C#               F3=1.0D0+EXP(-ALPA(NI)*RIJ)+EXP(-ALPA(NJ)*RIJ)
C#               DD=(DG(1)*F3-G(1)*(DEL1/RIJ)*(ALPA(NI)*EXP(-ALPA(NI)*RI
C#     1J) +ALPA(NJ)*EXP(-ALPA(NJ)*RIJ)))*C1
            ENDIF
            TERMNC=DD
         ENDIF
C
C   ****   START OF THE AM1 SPECIFIC DERIVATIVE CODE   ***
C
C      ANALYT=-A*(1/(R*R)+2.D0*B*(R-C)/R)*EXP(-B*(R-C)**2)
C
C    ANALYTICAL DERIVATIVES
C
         IF( AM1 )THEN
            ANAM1=0.D0
            DO 40 IG=1,10
               IF(ABS(FN1(NI,IG)).GT.0.D0)
     1ANAM1=ANAM1+FN1(NI,IG)*
     2(1.D0/(RIJ*RIJ)+2.D0*FN2(NI,IG)*(RIJ-FN3(NI,IG))/RIJ)*
     3EXP(MAX(-30.D0,-FN2(NI,IG)*(RIJ-FN3(NI,IG))**2))
               IF(ABS(FN1(NJ,IG)).GT.0.D0)
     1ANAM1=ANAM1+FN1(NJ,IG)*
     2(1.D0/(RIJ*RIJ)+2.D0*FN2(NJ,IG)*(RIJ-FN3(NJ,IG))/RIJ)*
     3EXP(MAX(-30.D0,-FN2(NJ,IG)*(RIJ-FN3(NJ,IG))**2))
   40       CONTINUE
            ANAM1=ANAM1*CORE(NI)*CORE(NJ)
            TERMNC=TERMNC-ANAM1*DEL1/RIJ
         ENDIF
C
C   ****   END OF THE AM1 SPECIFIC DERIVATIVE CODE   ***
C
   50    CONTINUE
C
C   COMBINE TOGETHER THE OVERLAP DERIVATIVE PARTS
C
         IF(MINDO3)THEN
            II=MAX(NI,NJ)
            NBOND=(II*(II-1))/2+NI+NJ-II
            IF(NBOND.GT.153)GOTO 60
            BI(1)=BETA3(NBOND)*VS(NI)*2.D0
            BI(2)=BETA3(NBOND)*VP(NI)*2.D0
            BI(3)=BI(2)
            BI(4)=BI(2)
            BJ(1)=BETA3(NBOND)*VS(NJ)*2.D0
            BJ(2)=BETA3(NBOND)*VP(NJ)*2.D0
            BJ(3)=BJ(2)
            BJ(4)=BJ(2)
   60       CONTINUE
         ELSE
            BI(1)=BETAS(NI)
            BI(2)=BETAP(NI)
            BI(3)=BI(2)
            BI(4)=BI(2)
            BJ(1)=BETAS(NJ)
            BJ(2)=BETAP(NJ)
            BJ(3)=BJ(2)
            BJ(4)=BJ(2)
         ENDIF
C
C       CODE COMMON TO MINDO/3, MNDO, AND AM1
C
         IOL=0
         DO 70 K=IA,ID
            DO 70 L=JA,JD
               LK=L+K*(K-1)/2
               TERMK=BI(K-IA+1)
               TERML=BJ(L-JA+1)
               IOL=IOL+1
               TERMAB=TERMAB+(TERMK+TERML)
     1*PSUM(LK)*DS(IOL)
   70    CONTINUE
         IF(MINDO3)THEN
C
C        FIRST, CORE-ELECTRON ATTRACTION DERIVATIVES (MINDO/3)
C
C          ATOM CORE I AFFECTING A.O.S ON J
            DO 80 M=JA,JD
               MN=(M*(M+1))/2
   80       TERMAB=TERMAB+CORE(NI)*PSUM(MN)*DR1
C          ATOM CORE J AFFECTING A.O.S ON I
            DO 90 M=IA,ID
               MN=(M*(M+1))/2
   90       TERMAB=TERMAB+CORE(NJ)*PSUM(MN)*DR1
C
C   NOW FOR COULOMB AND EXCHANGE TERMS (MINDO/3)
C
            DO 100 I1=IA,ID
               II=(I1*(I1+1))/2
               DO 100 J1=JA,JD
                  JJ=(J1*(J1+1))/2
                  IJ=J1+(I1*(I1-1))/2
C
C           COULOMB TERM
C
                  TERMAA=TERMAA-PSUM(II)*DR1*PSUM(JJ)
C
C           EXCHANGE TERM
C
                  TERMAA=TERMAA+(PALPHA(IJ)*PALPHA(IJ)+PBETA(IJ)*PBETA(I
     1J))*DR1
  100       CONTINUE
         ELSE
C
C        FIRST, CORE-ELECTRON ATTRACTION DERIVATIVES (MNDO AND AM1)
C
C          ATOM CORE I AFFECTING A.O.S ON J
            ISP=0
            DO 110 M=JA,JD
               BB=1.D0
               DO 110 N=M,JD
                  MN=M+N*(N-1)/2
                  ISP=ISP+1
                  TERMAB=TERMAB-BB*CORE(NI)*PSUM(MN)*DR(ISP)
  110       BB=2.D0
C          ATOM CORE J AFFECTING A.O.S ON I
            K=MAX(JD-JA+1,1)
            K=(K*(K+1))/2
            ISP=-K+1
            DO 120 M=IA,ID
               BB=1.D0
               DO 120 N=M,ID
                  MN=M+N*(N-1)/2
                  ISP=ISP+K
                  TERMAB=TERMAB-BB*CORE(NJ)*PSUM(MN)*DR(ISP)
  120       BB=2.D0
            ISP=0
C
C   NOW FOR COULOMB AND EXCHANGE TERMS (MNDO AND AM1)
C
            DO 140 K=IA,ID
               AA=1.D0
               KK=(K*(K-1))/2
               DO 140 L=K,ID
                  LL=(L*(L-1))/2
                  DO 130 M=JA,JD
                     BB=1.D0
                     DO 130 N=M,JD
                        ISP=ISP+1
                        KL=K+LL
                        MN=M+N*(N-1)/2
C
C    COULOMB TERM
C
                        TERMAA=TERMAA+AA*BB*PSUM(KL)*PSUM(MN)*DR(ISP)
                        MK=M+KK
                        NK=N+KK
                        ML=M+LL
                        NL=N+LL
C
C    EXCHANGE TERM
C
                        TERMAA= TERMAA-0.5D0*AA*BB*(PALPHA(M
     1K)*PALPHA(NL)+PALPHA(NK)*PALPHA(ML)+PBETA(MK)*PBETA(NL)+PBETA(NK)*
     2PBETA(ML))*DR(ISP)
  130             BB=2.D0
  140       AA=2.D0
C           END OF MNDO AND AM1 SPECIFIC CODE
         ENDIF
         EAA(IX)=EAA(IX)+TERMAA
         EAB(IX)=EAB(IX)+TERMAB
         ENUC(IX)=ENUC(IX)+TERMNC
  150 CONTINUE
C#            WRITE(6,*)EAA,EAB,ENUC,NAT(1),NAT(2)
  160 CONTINUE
  170 CONTINUE
      DO 180 J=1,3
         ENG(J)=EAA(J)+EAB(J)+ENUC(J)
         ENG(J) = -ENG(J)*2.D0*23.061D0
  180 CONTINUE
      RETURN
      END

      SUBROUTINE PATHS
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /GEOVAR/ NVAR, LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /KEYWRD/ KEYWRD
      COMMON /TIMEMP/ TIME0
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /ALPARM/ ALPARM(3,MAXPAR),X0, X1, X2, ILOOP
************************************************************************
*
*   PATH FOLLOWS A REACTION COORDINATE.   THE REACTION COORDINATE IS ON
*        ATOM LATOM, AND IS A DISTANCE IF LPARAM=1,
*                           AN ANGLE   IF LPARAM=2,
*                           AN DIHEDRALIF LPARAM=3.
*
************************************************************************
      DIMENSION GD(MAXPAR),XLAST(MAXPAR),MDFP(20),XDFP(20)
      CHARACTER*80 KEYWRD
      CHARACTER*10 TYPE(3)
      DATA TYPE / 'ANGSTROMS ','DEGREES   ','DEGREES   '/
      ILOOP=1
      IF(INDEX(KEYWRD,'RESTAR') .NE. 0) THEN
         MDFP(9)=0
         CALL DFPSAV(TOTIME,XPARAM,GD,XLAST,FUNCT1,MDFP,XDFP)
         WRITE(6,'(//10X,'' RESTARTING AT POINT'',I3)')ILOOP
      ENDIF
      IF(ILOOP.GT.1) GOTO 10
      WRITE(6,'(''  ABOUT TO ENTER FLEPO FROM PATH'')')
      TIME0=ZECOND()
      CALL FLEPO(XPARAM,NVAR,FUNCT)
      WRITE(6,'(''  OPTIMIZED VALUES OF PARAMETERS, INITIAL POINT'')')
      CALL VWRITE(TIME0,FUNCT)
      TIME0=ZECOND()
   10 CONTINUE
      IF(ILOOP.GT.2) GOTO 40
      GEO(LPARAM,LATOM)=REACT(2)
      IF(ILOOP.EQ.1) THEN
         X0=REACT(1)
         X1=X0
         X2=REACT(2)
         IF(X2.LT. -100.D0) CALL WRAPUP()
         DO 20 I=1,NVAR
            ALPARM(2,I)=XPARAM(I)
   20    ALPARM(1,I)=XPARAM(I)
         ILOOP=2
      ENDIF
      CALL FLEPO(XPARAM,NVAR,FUNCT)
      RNORD=REACT(2)
      IF(LPARAM.GT.1) RNORD=RNORD*57.29577951D0
      WRITE(6,'(1X,16(''*****'')//17X,''REACTION COORDINATE = ''
     1,F12.4,2X,A10,19X//1X,16(''*****''))')RNORD,TYPE(LPARAM)
      CALL VWRITE(TIME0,FUNCT)
      TIME0=ZECOND()
      DO 30 I=1,NVAR
   30 ALPARM(3,I)=XPARAM(I)
C
C   NOW FOR THE MAIN INTERPOLATION ROUTE
C
      IF(ILOOP.EQ.2)ILOOP=3
   40 CONTINUE
      LPR=ILOOP
      DO 110 ILOOP = LPR,100
C
         IF(REACT(ILOOP).LT. -100.D0) CALL WRAPUP()
C
         RNORD=REACT(ILOOP)
         IF(LPARAM.GT.1) RNORD=RNORD*57.29577951D0
         WRITE(6,'(1X,16(''*****'')//19X,''REACTION COORDINATE = ''
     1,F12.4,2X,A10,19X//1X,16(''*****''))')RNORD,TYPE(LPARAM)
C
         X3=REACT(ILOOP)
         C3=(X0**2-X1**2)*(X1-X2)-(X1**2-X2**2)*(X0-X1)
C      WRITE(6,'(''   C3:'',F13.7)')C3
         IF (ABS(C3) .LT. 1.D-8) THEN
C
C    WE USE A LINEAR INTERPOLATION
C
            CC1=0.D0
            CC2=0.D0
         ELSE
C    WE DO A QUADRATIC INTERPOLATION
C
            CC1=(X1-X2)/C3
            CC2=(X0-X1)/C3
         ENDIF
         CB1=1.D0/(X1-X2)
         CB2=(X1**2-X2**2)*CB1
C
C    NOW TO CALCULATE THE INTERPOLATED COORDINATES
C
         DO 50 I=1,NVAR
            DELF0=ALPARM(1,I)-ALPARM(2,I)
            DELF1=ALPARM(2,I)-ALPARM(3,I)
            ACONST = CC1*DELF0-CC2*DELF1
            BCONST = CB1*DELF1-ACONST*CB2
            CCONST = ALPARM(3,I) - BCONST*X2 - ACONST*X2**2
            XPARAM(I)=CCONST+BCONST*X3+ACONST*X3**2
            ALPARM(1,I)=ALPARM(2,I)
   50    ALPARM(2,I)=ALPARM(3,I)
C
C   NOW TO CHECK THAT THE GUESSED GEOMETRY IS NOT TOO ABSURD
C
         DO 60 I=1,NVAR
   60    IF(ABS(XPARAM(I)-ALPARM(3,I)) .GT. 0.2) GOTO 70
         GOTO 90
   70    WRITE(6,'('' GEOMETRY TOO UNSTABLE FOR EXTRAPOLATION TO BE USED
     1''/ ,'' - THE LAST GEOMETRY IS BEING USED TO START THE NEXT''
     2,'' CALCULATION'')')
         DO 80 I=1,NVAR
   80    XPARAM(I)=ALPARM(3,I)
   90    CONTINUE
         X0=X1
         X1=X2
         X2=X3
         GEO(LPARAM,LATOM)=REACT(ILOOP)
         CALL FLEPO(XPARAM,NVAR,FUNCT)
         CALL VWRITE(TIME0,FUNCT)
         TIME0=ZECOND()
         DO 100 I=1,NVAR
  100    ALPARM(3,I)=XPARAM(I)
  110 CONTINUE
      END

      SUBROUTINE REFER
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON
     1       /REFS/ ALLREF(107,4)
     2       /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     3                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     4                NCLOSE,NOPEN,NDUMY,FRACT
     5       /KEYWRD/ KEYWRD
      LOGICAL ALLOK, ELEMNS(107), MIXOK, MIX
      CHARACTER*80 KEYWRD, ALLREF
      DATA MIX/.FALSE./
      MIXOK=(INDEX(KEYWRD,'PARASOK').NE.0)
      DO 10 I=1,102
   10 ELEMNS(I)=.FALSE.
      IF(INDEX(KEYWRD,'PM3').NE.0)THEN
         MODE=4
      ELSEIF(INDEX(KEYWRD,'AM1').NE.0)THEN
         MODE=3
      ELSEIF(INDEX(KEYWRD,'MINDO').NE.0)THEN
         MODE=2
      ELSE
         MODE=1
      ENDIF
      ALLREF(99,MODE)=' DUMMY ATOMS ARE USED; THESE DO NOT AFFECT '
     1//'THE CALCULATION'
      ALLREF(100,MODE)=' '
      DO 20 I=1,NUMAT
         J=NAT(I)
   20 ELEMNS(J)=.TRUE.
      ALLOK=.TRUE.
      DO 30 I=1,102
         IF(ELEMNS(I))THEN
            IF(I.LT.99.AND..NOT.MIX.AND.MODE.EQ.3)
     1MIX=(INDEX(ALLREF(I,3),'MNDO').NE.0)
            IF(ALLREF(I,MODE)(1:1).NE.' ')THEN
               WRITE(6,'(A,I3)')' DATA ARE NOT AVAILABLE FOR ELEMENT NO.
     1',I
               ALLOK=.FALSE.
            ELSE
               WRITE(6,'(A)')ALLREF(I,MODE)
            ENDIF
         ENDIF
   30 CONTINUE
      IF(MIX.AND..NOT.MIXOK)THEN
         WRITE(6,40)
     1  'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH ONLY MNDO',
     2  'PARAMETERS ARE AVAILABLE.  SUCH MIXTURES OF METHODS ARE',
     3  'VERY RISKY AND HAVE NOT BEEN FULLY TESTED.  IF YOU FEEL',
     4  'THE RISK IS WORTH WHILE - CHECK THE MANUAL FIRST - THEN',
     5  'SPECIFY "PARASOK" IN THE KEYWORDS'
         CALL WRAPUP()
      ENDIF
      IF(ALLOK)RETURN
      WRITE(6,40)
     1 'SOME ELEMENTS HAVE BEEN SPECIFIED FOR WHICH',
     2 'NO PARAMETERS ARE AVAILABLE.  CALCULATION STOPPED.'
   40 FORMAT(/////10X,A,4(/10X,A))
      CALL WRAPUP()
      END

C
C     We are not interested in CPU-times. We can get them from time-command
C     at the script level. Within program we look for wall clock times only.
C
C     WALTIM is a C-routine, found in times.c -file: waltim_(...)
C
      BLOCK DATA TIIMEX
      implicit none
      include 'timer.inc'
      DATA TSTART /0.0/
      DATA TEND   /0.0/
      DATA INITED /0/
      END
C
      SUBROUTINE INITIM(IDUMMY)
      implicit none
      include 'timer.inc'
      integer IDUMMY
      EXTERNAL WALTIM
      IF (INITED.EQ.0) THEN
         CALL WALTIM(TSTART)
         INITED = 1
      ENDIF
      END
C
      SUBROUTINE SHOTIM(IDUMMY)
      implicit none
      include 'timer.inc'
      integer IDUMMY
      EXTERNAL WALTIM
      IF (INITED.EQ.0) CALL INITIM(IDUMMY)
      CALL WALTIM(TEND)
      WRITE(*,1000) 'Shotim: ',TEND - TSTART,' secs'
 1000 FORMAT(1X,A,F15.4,A)
      END
C
      FUNCTION CPUTIM(IDUMMY)
      implicit none
      include 'timer.inc'
      REAL CPUTIM
      integer IDUMMY
      EXTERNAL WALTIM
      REAL T
      IF (INITED.EQ.0) CALL INITIM(IDUMMY)
      CALL WALTIM(T)
      CPUTIM = T - TSTART
      END
C
      SUBROUTINE TIMER(T)
      implicit none
      include 'timer.inc'
      REAL T
      integer IDUMMY
      EXTERNAL WALTIM
      IF (INITED.EQ.0) CALL INITIM(IDUMMY)
      CALL WALTIM(T)
      END

      SUBROUTINE VPETST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   VPENTA TEST PROGRAM
C
      PARAMETER (NJA=128, NJB=128, JL=1, JU=128, KL=1, KU=128,
     $ F7=78125., T30=1073741824.)
      COMMON /ARRAYS/ A(NJA,NJB), B(NJA,NJB), C(NJA,NJB), D(NJA,NJB),
     $ E(NJA,NJB), F(NJA,NJB,3), X(NJA,NJB), Y(NJA,NJB), FX(NJA,NJB,3)
      DATA IT/400/, ANS/-0.354649411858726/
C
      LF = NJA * NJB * 3
      T = F7 / T30
      DO 100 J = KL, KU
        DO 100 I = JL, JU
          T = MOD (F7 * T, 1.0D0)
          A(I,J) = T
          T = MOD (F7 * T, 1.0D0)
          B(I,J) = T
          T = MOD (F7 * T, 1.0D0)
          C(I,J) = T
          T = MOD (F7 * T, 1.0D0)
          D(I,J) = T
          T = MOD (F7 * T, 1.0D0)
          E(I,J) = T
          DO 100 K = 1, 3
            T = MOD (F7 * T, 1.0D0)
            FX(I,J,K) = T
100   CONTINUE
      TM = CPTIME ()
C
C   TIMING TEST
C
      DO 110 I = 1, IT
        CALL COPY (LF, FX, F)
        CALL VPENTA
110   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((F(19,19,1) - ANS) / ANS)
      FP = IT * KU * (40. * KU - 53.)
C
      RETURN
      END

      SUBROUTINE COEF24(JDIM,KDIM,COEF2X,COEF4X,COEF2Y,COEF4Y,
     +           PCOEF,SPECT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION COEF2X(JDIM,KDIM),COEF4X(JDIM,KDIM)
      DIMENSION COEF2Y(JDIM,KDIM),COEF4Y(JDIM,KDIM)
      DIMENSION PCOEF(JDIM,KDIM),SPECT(JDIM,KDIM)
C
C   COEF2X,Y COMES IN AS COEFX,Y (PRESSURE GRADIANT COEFFICIENT)
C   COEF4X,Y COMES IN AS SPECX,Y (SPECTRAL RADIUS)
C
      DO 1 K = KBEGIN,KEND
      DO 1 J = JBEGIN,JEND
         PCOEF(J,K) = COEF2Y(J,K)
         SPECT(J,K) = COEF4Y(J,K)
1     CONTINUE
C
       EPS4Y = DIS4Y/64.
       EPS2Y = DIS2Y    
C
C  FORM 2ND AND 4TH ORDER DISSIPATION COEFFICIENTS IN Y
C
       DO 10 K = KBEGIN,KUP
       DO 10 J = JLOW,JUP
C
         FIL = SPECT(J,K+1) + SPECT(J,K)
         C2 = PCOEF(J,K)*FIL*EPS2Y
         C4 = EPS4Y*FIL
         C4 = C4 - MIN(C4,C2)
C-old         C4 = C4 - AMIN1(C4,C2)
         COEF2Y(J,K) = C2
         COEF4Y(J,K) = C4
10       CONTINUE

C
C
      DO 2 K = KBEGIN,KEND
      DO 2 J = JBEGIN,JEND
         PCOEF(J,K) = COEF2X(J,K)
         SPECT(J,K) = COEF4X(J,K)
2     CONTINUE
C
       EPS4X = DIS4X/64.
       EPS2X = DIS2X    
C
C  FORM 2ND AND 4TH ORDER DISSIPATION COEFFICIENTS IN Y
C
       DO 20 J = JBEGIN,JUP
       JPL = JPLUS(J)
       DO 20 K = KLOW,KUP
C
         FIL = SPECT(JPL,K) + SPECT(J,K)
         C2 = PCOEF(J,K)*FIL*EPS2X
         C4 = EPS4X*FIL
         C4 = C4 - MIN(C4,C2)
C-old         C4 = C4 - AMIN1(C4,C2)
         COEF2X(J,K) = C2
         COEF4X(J,K) = C4
20       CONTINUE

         RETURN
         END

C     ****************
      SUBROUTINE METRO(
C     ****************
     >                 NVH,NVL,NV,
     >                 METHIT,IACPT,BETA,
     >                 TBL,
     >                 WK1,WK2,WK3,WK4,WK5,
     >                 IRAND)
C
C
      DOUBLE PRECISION WK1(NVH,18),WK2(NVH,18),WK3(NVH,18),
     >                 WK4(NVH,18),WK5(NVH,18),
     >                 TBL(NV ,18),
     >                 BETA,INV3,RTIME,TSTART,TEND
C
      INTEGER          IRAND(NVH)
C
      PARAMETER( INV3 = 1.D0 / 3.D0 )
C
C
      COMMON / PERF / RTIME(15),IPRO
C
C
C     LOOP OVER NUMBER OF METROPOLIS HITS
C
C
      DO 10 ITH = 1,METHIT
C
C
C     SELECTING NVH RANDOM SU3 MATRICES FROM A TABLE
C
C
C     RANDOM GATHER OPERATION ON TBL
C
C
      CALL TIMER(TSTART)
C     ***********
      CALL RGTBL(NVH,NVL,WK2,NV,TBL,IRAND)
C     ***********
      CALL TIMER(TEND)
      RTIME(13) = RTIME(13) + TEND - TSTART
C
C
C     CALCULATE NEW LINK VARIABLES
C
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,1,WK3,WK2,WK1)
C     ********
      CALL TIMER(TEND)
      RTIME(9) = RTIME(9) + TEND - TSTART
C
C
C     CALCULATE LINK DIFFERENCES U(NEW) - U(OLD)
C
C
      CALL TIMER(TSTART)
C     ********
      CALL ADD(NVH,NVL,2,WK2,WK3,WK1)
C     ********
      CALL TIMER(TEND)
      RTIME(10) = RTIME(10) + TEND - TSTART
C
C
C     CALCULATE PLAQUETTE DIFFERENCES [ U(NEW) - U(OLD) ] * UUU
C
C
      CALL TIMER(TSTART)
C     ********
      CALL PRO(NVH,NVL,1,WK5,WK2,WK4)
C     ********
      CALL TIMER(TEND)
      RTIME(9) = RTIME(9) + TEND - TSTART
C
C
C     CALCULATE - DS = 1/3 * BETA * RETR { [ U(NEW) - U(OLD) ] * UUU }
C
C
      CALL TIMER(TSTART)
      DO 20 IVL = 1,NVL
      WK5(IVL,1) = (  WK5(IVL,1) + WK5(IVL,5) + WK5(IVL,9) )
     >             * ( BETA * INV3 )
   20 CONTINUE
      CALL TIMER(TEND)
      RTIME(14) = RTIME(14) + TEND - TSTART
C
C
C     CALCULATE EXP(-DS)
C
C
      CALL TIMER(TSTART)
      DO 30 IVL = 1,NVL
      WK5(IVL,1) = EXP( WK5(IVL,1) )
   30 CONTINUE
      CALL TIMER(TEND)
      RTIME(11) = RTIME(11) + TEND - TSTART
C
C
C     METROPOLIS TEST
C
C
      CALL TIMER(TSTART)
C     ***********
      CALL VDRAND(NVL,WK2)
C     ***********
      CALL TIMER(TEND)
      RTIME(12) = RTIME(12) + TEND - TSTART
C
C
      CALL TIMER(TSTART)
C     ***********
      CALL ACCEPT(NVH,NVL,IACPT,WK5,WK3,WK2,WK1)
C     ***********
      CALL TIMER(TEND)
      RTIME(15) = RTIME(15) + TEND - TSTART
C
C
   10 CONTINUE
C
C
      END

      SUBROUTINE MULT(C,S,VECS,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION C(N,*), S(N,*), VECS(N,*)
***********************************************************************
*
*   MULT IS USED IN THE MULLIKEN ANALYSIS ONLY. IT PERFORMS THE
*        OPERATION:-
*                                   VECS=BACK-TRANSFORMED EIGENVECTORS
*        VECS  =  C*S               C   =UN-BACK-TRANSFORMED VECTORS
*                                   S   =1/SQRT(OVERLAP MATRIX)
*
***********************************************************************
      DO 20 I=1,N
         DO 20 J=1,N
            SUM=0
            DO 10 K=1,N
   10       SUM=SUM+C(K,I)*S(J,K)
   20 VECS(J,I)=SUM
      RETURN
      END

      SUBROUTINE MESAGE(CHMESS,INDX,ISW)
C     
C..    A SUBROUTINE TO PRINT MESSAGE WHEN CPU_TIMER HAS BEEN
C     SWITCHED ON OR OFF
C     
      CHARACTER*20 CHMESS  
      WRITE(6,1000) CHMESS
 1000 FORMAT(/50X,'---> ',A20/)
      IF (ISW.EQ.1) CALL INITIM(INDX)
      IF (ISW.EQ.0) CALL SHOTIM(INDX)
      END

      DOUBLE PRECISION FUNCTION INTX(X1,Y1,X2,Y2,X3,Y3,X4,Y4)
      DOUBLE PRECISION X1,Y1,X2,Y2,X3,Y3,X4,Y4
      DOUBLE PRECISION K1,K2

      K1=(Y2-Y1)/(X2-X1)
      K2=(Y4-Y3)/(X4-X3)
      INTX=(K1*X1-K2*X3+Y3-Y1)/(K1-K2)
      RETURN
      END

      SUBROUTINE GEOUT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
**********************************************************************
*
*   GEOUT PRINTS THE CURRENT GEOMETRY.  IT CAN BE CALLED ANY TIME,
*         FROM ANY POINT IN THE PROGRAM AND DOES NOT AFFECT ANYTHING.
*
**********************************************************************
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR),IDUMY,XPARAM(MAXPAR)
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /ELEMTS/ ELEMNT(107)
      DIMENSION COORD(3,NUMATM)
      CHARACTER Q(3)*1, ELEMNT*2
      LOGICAL CART
C
C *** OUTPUT THE PARAMETER DATA.
C
      CART=.FALSE.
      IF(NA(1).NE.0) THEN
         CART=.TRUE.
         CALL XYZINT(GEO,NATOMS,NA,NB,NC,1.D0,COORD)
         NA(1)=99
      ELSE
         DO 10 I=1,NATOMS
            DO 10 J=1,3
   10    COORD(J,I)=GEO(J,I)
      ENDIF
      DEGREE=57.29577951D00
      WRITE (6,20)
   20 FORMAT (/4X,'ATOM',3X,'CHEMICAL',2X,'BOND LENGTH',4X,'BOND ANGLE'
     1,4X ,' TWIST ANGLE',/3X,'NUMBER',2X,'SYMBOL', 4X,'(ANGSTROMS)',5
     2X,'(DEGREES)',5X,' (DEGREES)',/4X,'(I)',18X,'NA:I',10X,'NB:NA:I',5
     3X,' NC:NB:NA:I',5X,'NA',3X,'NB',3X,'NC',/)
      N=1
      IA=LOC(1,1)
      DO 50 I=1,NATOMS
         DO 30 J=1,3
            Q(J)=' '
            IF (IA.NE.I) GO TO 30
            IF (J.NE.LOC(2,N)) GO TO 30
            Q(J)='*'
            N=N+1
            IA=LOC(1,N)
   30    CONTINUE
         W = COORD(2,I) * DEGREE
         X = COORD(3,I) * DEGREE
         IF (LATOM.NE.I) GO TO 40
         J=LPARAM
         Q(J)='+ '
   40    CONTINUE
         IF(LABELS(I).NE.0)THEN
            IF(I.GT.3)THEN
               WRITE (6,'(3X,I4 ,5X,A2,F16.5,1X,A1,F15.5,1X,A1,F12.5,1X,
     1A1,I5,2I5)') I,ELEMNT(LABELS(I)),COORD(1,I),Q(1),W,Q(2),X,Q(3),NA(
     2I),NB(I),NC(I)
            ELSEIF(I.EQ.3)THEN
               WRITE (6,'(''      3'',5X,A2,F16.5,1X,A1,F15.5,1X,A1,14X,
     12I5)') ELEMNT(LABELS(3)),COORD(1,3),Q(1),W,Q(2),NA(3),NB(3)
            ELSEIF(I.EQ.2)THEN
               WRITE (6,'(''      2'',5X,A2,F16.5,1X,A1,31X,I5)')
     1 ELEMNT(LABELS(2)),COORD(1,2),Q(1),NA(2)
            ELSE
               WRITE (6,'(''      1'',5X,A2)') ELEMNT(LABELS(1))
            ENDIF
         ENDIF
   50 CONTINUE
      RETURN
      END

C=======================================================================
C FILE: EWALTR.FOR
C
C HISTORY: 23/2/90: COPIED FROM FEWALD.FOR
C                   FEWALD() CHANGED TO EWALTR()
C                   EWSIF CHANGED TO SIGEW
C                   STATZD DELETED TOGETHER WITH ITS ASSOCIATED CODE
C                   NIONS CHANGED TO 4
C                   TRICLINIC GEOMETRY
C          25/2/90: OFF-DIAGONAL ELEMENTS IN STRESS TENSOR
C           8/3/90: SIGN OF STRESS-CONTRIB. CHANGED
C          24/4/90: SCALE IS MULTIPLIED BY 1.5 CHOSEN FOR BEST
C                     CONVERGENCE
C           6/5/90: CONDITIONED PRINTING OUT OF PARAMETERS
C
C          19/7/90: ELECT is changed to a more accuarate value
C
C         14/10/90: PARAMETER STATEMENT IS REMOVED. MATRICES ARE 
C                   FIRST DECLARED IN THE MAIN PROGRAM.
C=======================================================================
      SUBROUTINE EWALTR(POSION,EWIFC,EWRLEN,EWRCSS,EWRLSS,EWRCSI,
     &    DIRC,RECC,VOLC,SIGEW,TEWEN,NIONST,ICHARC,NIONCH,NICHSQ,
     &    CPHFX,CPHFY,CPHFZ,IPRINT,
     &    NIONS,NEWPTS,MAXCX,MAXCY,MAXCZ,MAXGPX,MAXGPY,MAXGPZ,NGPTS,
     &    RFORCE,CFORCE,FORCEG,FORSIG,ENERG)
C=======================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE EWALTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE EWALD ENERGY DUE TO COULOMB ENERGY
C BETWEEN THE IONS AND THE NEUTRALISING BACKGROUND. THE COULOMB FORCES
C ON THE IONS DUE TO COULOMB INTERACTION WITH THE OTHER IONS AND THE
C STRESS ON THE UNIT CELL THAT IS RELATED TO THE CHANGE IN THE EWALD
C ENERGY ON CHANGING THE SIZE OF THE CELL
C          
C                         -G**2
C                     (-  -----)              2G  G
C           PI   --  e    4 eta [ --     iGR][  i  j    G**2         ]
C Sigma  = ----  >  ----------  [ >  Z  e   ][ -----  ( ---- ) - &   ]
C      ij  2eta  --   G**2      [ --  I     ][ G**2    4 eta      ij ]
C               G<>0( ----- )     I
C                     4 eta
C
C                                             D  D !
C                1    1/2 --            1/2    i  j!
C         + Vol ---eta    >   Z Z H'(eta   D)------!
C                2        --   I J            D**2 !
C                        I,J,l                     !D=R -R +l <>0
C                                                      J  I
C
C             PI  [ --    ]2
C         + ----- [ >  Z  ]  &
C           2 eta [ --  I ]   ij
C                   I
C=======================================================================
C THE EWALD METHOD OF PERFORMING COULOMB SUMS OVER A LATTICE IS
C EXPLAINED IN MANY TEXTS, ONE IS 'DYNAMICAL THEORY OF CRYSTAL LATTICES'
C BY BORN AND HUANG. THE ONLY THING TO BE CAREFUL ABOUT IS THAT IN A
C TOTAL ENERGY CALCULATION THE EWALD ENERGY INCLUDES THE ENERGY OF
C INTERACTION BETWEEN THE IONS AND A NEUTRALISING BACKGROUND.
C THE EWALD METHOD WORKS BY WRITING THE COULOMB ENERGY AS A SUM OF A
C REAL SPACE PART (WHICH IS SUMMED OVER ALL SPACE) AND A RECIPROCAL
C SPACE PART (WHICH IS SUMMED OVER ALL THE RECIPROCAL LATTICE POINTS).
C THIS PART OF THE METHOD IS EXACT AND DOESN'T REDUCE THE AMOUNT OF
C WORK NEEDED TO PERFORM THE SUMMATION. HOWEVER, THE REAL SPACE
C CONTRIBUTIONS FALL OFF RAPIDLY WITH INCREASING DISTANCE SO THAT ONLY
C A FINITE NUMBER OF UNIT CELLS NEED TO BE INCLUDED IN THE SUM AND THE
C RECIPROCAL SPACE CONTRIBUTIONS FALL OFF RAPIDLY WITH THE MAGNITUDE OF
C THE RECIPROCAL LATTICE VECTOR SO THAT ONLY A FINITE NUMBER OF
C RECIPROCAL LATTICE POINTS NEED TO BE INCLUDED IN THE RECIPROCAL SPACE
C SUM
C A VARIABLE (SCALE IN THIS PROGRAM) DETERMINES HOW RAPIDLY THE EWALD
C SUMS FALL OFF WITH INCREASING DISTANCE IN REAL AND RECIPROCAL SPACE.
C THE NUMBER OF REAL SPACE CELLS SUMMED OVER IS DETERMINED BY MAXCX,Y,Z
C AND THE NUMBER OF RECIPROCAL SPACE CELLS BY MAXGPX,Y,Z. THE VALUE OF
C SCALE SHOULD BE CHOSEN TO MINIMISE THE TOTAL NUMBER OF OPERATIONS
C NEEDED TO COMPUTE THE COULOMB LATTICE SUMS.
C=======================================================================
C RATHER THAN COMPUTE THE VALUES OF THE EWALD INTEGRALS THIS PROGRAM
C INTERPOLATES THE VALUES OF THE INTEGRALS FROM A SET OF DATA ARRAYS
C EWRLEN,EWRCSS,EWRLSS AND EWRCSI
C=======================================================================
      IMPLICIT COMPLEX (C)
C=======================================================================
C
C             TERMS IN THE PARAMETER STATEMENT
C
C MAXCX,MAXCY,MAXCZ = THE NUMBER OF CELLS IN EACH DIRECTION FROM THE
C CENTRAL CELL INCLUDED IN THE EVALUATION OF THE REAL SPACE EWALD SUMS
C THE VALUES OF THESE PARAMETERS SHOULD BE CHOSEN SO THAT
C MAXCX(Y,Z)*SQRT(PI)*SIZEX(Y,Z)/MIN(SIZEX,SIZEY,SIZEZ) ARE ALL GREATER
C THAN 3, (THE LARGER THE VALUE THE CLOSER TO THE CORRECT COULOMB SUM)
C MAXGPX,MAXGPY,MAXGPZ = THE NUMBER OF RECIPROCAL LATTICE POINTS IN EACH
C DIRECTION FROM G=0 INCLUDED IN THE EVALUATION OF THE RECIPROCAL SPACE
C EWALD SUMS. THE VALUES OF THESE PARAMETERS SHOULD BE CHOSEN SO THAT
C NGPTX(Y,Z)*MIN(SIZEX,SIZEY,SIZEZ)/(SQRT(PI)*SIZEX(Y,X) ARE ALL GREATER
C THAN 3, (THE LARGER THE VALUE THE CLOSER TO THE CORRECT COULOMB SUM)
C ARGMRE IS THE ARGUMENT CORRESPONDING TO THE LAST ELEMENT IN THE REAL
C SPACE EWALD INTEGRAL DATA ARRAYS
C ARGMRC IS THE ARGUMENT CORRESPONDING TO THE LAST ELEMENT IN THE
C RECIPROCAL SPACE EWALD INTEGRAL DATA ARRAYS
C NEWPTS IS THE NUMBER OF VALUES IN THE EWALD INTEGRAL DATA ARRAYS
C=======================================================================
C      PARAMETER(MAXCX=4,MAXCY=4,MAXCZ=2,NIONS=32,
C     &   NCELLX=(2*MAXCX)+1,NCELLY=(2*MAXCY)+1,NCELLZ=(2*MAXCZ)+1,
C     &   NCELLS=NCELLX*NCELLY*NCELLZ,
C     &   MAXGPX=4,MAXGPY=4,MAXGPZ=6,
C     &   NGPTX=(2*MAXGPX)+1,NGPTY=(2*MAXGPY)+1,NGPTZ=(2*MAXGPZ)+1,
C     &   NGPTS=NGPTX*NGPTY*NGPTZ,
C     &   NEWPTS=1000,ARGMRE=4.0,ARGMRC=4.0)
C
C
      DIMENSION POSION(3,*)
      DIMENSION EWIFC(3,*)
      DIMENSION ICHARC(*)
      DIMENSION EWRLEN(*),EWRCSS(*),EWRLSS(*),EWRCSI(*)
      DIMENSION DIRC(3,*)
      DIMENSION RECC(3,*)
      DIMENSION SIGEW(*)
      DIMENSION CPHFX(*),CPHFY(*),CPHFZ(*)
C=======================================================================
C
C                  DIMENSION STATEMENTS
C
C RFORCE(L,A,B) = THE CONTRIBUTION TO THE TOTAL COULOMB FORCE IN THE 'L'
C        DIRECTION ON ION A FROM THE PERIODIC ARRAY OF IONS B
C        FROM THE PART OF THE EWALD SUMS PERFORMED IN REAL SPACE
C CFORCE(L,A,B) = THE CONTRIBUTION TO THE TOTAL COULOMB FORCE IN THE 'L'
C        DIRECTION ON ION A FROM THE PERIODIC ARRAY OF IONS B
C        FROM THE PART OF THE EWALD SUMS PERFORMED IN RECIPROCAL SPACE
C FORCEG = THE RECIPROCAL SPACE LATTICE VECTOR MULTIPLIED BY AN EWALD
C        INTEGRAL (USED FOR CALCULATING THE FORCES ON THE IONS)
C FORSIG = THE COMBINATION OF EWALD INTEGRALS AND FUNCTIONS OF THE
C        RECIPROCAL LATTICE VECTOR USED FOR CALCULATING THE FORCES ON
C        THE UNIT CELL
C RSIFOR = THE FORCE ON THE UNIT CELL FROM THE REAL SPACE PARTS OF THE
C        EWALD SUMMATIONS
C CSIFOR = THE FORCE ON THE UNIT CELL FROM THE RECIPROCAL SPACE PARTS OF
C        THE EWALD SUMMATIONS
C ENERG = THE EWALD INTEGRAL USED TO CALCULATE THE CONTRIBUTION TO THE
C        TOTAL ENERGY FROM THE RECIPROCAL SPACE PART OF THE EWALD SUM
C=======================================================================
      DIMENSION RFORCE(3,NIONS,NIONS),CFORCE(3,NIONS,NIONS)
      DIMENSION FORCEG(3,NGPTS),FORSIG(6,NGPTS),RSIFOR(6),CSIFOR(6)
      DIMENSION ENERG(NGPTS)
      DATA   ARGMRE/4.0/,ARGMRC/4.0/
C=======================================================================
C ELECT = (THE CHARGE ON THE ION * THE ELECTRONIC CHARGE)/(4*PI * THE
C          PERMITTIVITY OF FREE SPACE)
C=======================================================================
      DATA ELECT/14.39976868/
      DATA HALF,SIXTH / 0.5,0.166666666667 /
      DATA PI,TPI,CITPI/3.1415926536,6.2831853072,(0.0,6.2831853072)/
C=======================================================================
C=======================================================================
      NCELLX=(2*MAXCX)+1
      NCELLY=(2*MAXCY)+1
      NCELLZ=(2*MAXCZ)+1
      NCELLS=NCELLX*NCELLY*NCELLZ
      NGPTX=(2*MAXGPX)+1
      NGPTY=(2*MAXGPY)+1
      NGPTZ=(2*MAXGPZ)+1
      IF(IPRINT.GT.1) THEN
        WRITE(*,1856) MAXCX,MAXCX,MAXCY,MAXCY,MAXCZ,MAXCZ
        WRITE(*,1857) MAXGPX,MAXGPX,MAXGPY,MAXGPY,MAXGPZ,MAXGPZ
      END IF
 1856 FORMAT(/,1X,'EWALD  R E A L   SPACE CELLS: ',
     &      '(-',I2,',',I2,')x(-',I2,',',I2,')x(-',I2,',',I2,')')
 1857 FORMAT(1X,'EWALD RECIPROCAL SPACE CELLS: ',
     &      '(-',I2,',',I2,')x(-',I2,',',I2,')x(-',I2,',',I2,')')
C
       IF(IPRINT.GE.2)WRITE(*,*)' VOLC=',VOLC
C=======================================================================
C INITIALISE THE VALUES OF THE DATA ARRAYS
C=======================================================================
      DO 5001 N=1,NIONST
        DO 5002 NN=1,NIONST
          DO 5003 M=1,3
            CFORCE(M,NN,N)=(0.0,0.0)
            RFORCE(M,NN,N)=0.0
 5003     CONTINUE
 5002   CONTINUE
 5001 CONTINUE
      DO 5004 N=1,NIONST
        DO 5005 M=1,3
          EWIFC(M,N)=0.0
 5005   CONTINUE
 5004 CONTINUE
      DO 5006 M=1,6
        RSIFOR(M)=0.0
        CSIFOR(M)=(0.0,0.0)
        SIGEW(M)=0.0
 5006 CONTINUE
      TEWEN=0.0
      REWEN=0.0
      CEWEN=(0.0,0.0)
C=======================================================================
C CHOOSE THE VARIABLE 'SCALE' THAT DETERMINES THE RATE OF DECAY OF THE
C REAL AND RECIPROCAL PARTS OF THE EWALD SUMS. THE CHOICE OF SCALE USED
C BELOW IS GOOD FOR SYSTEMS WHERE THE LENGTHS OF THE LATTICE VECTORS
C ARE SIMILAR, FOR ODDER SHAPE SYSTEMS A DIFFERENT CHOICE FOR THE VALUE
C OF SCALE MAY REDUCE THE AMOUNT OF WORK INVOLVED IN CALCULATING THE
C COULOMB LATTICE SUMS. DONT FORGET THAT WHATEVER VALUE IS USED FOR
C SCALE THE VALUES OF MAXCX,Y,Z AND MAXGPX,Y,Z MUST BE SUFFICIENTLY
C LARGE TO OBTAIN THE LEVEL OF CONVERGENCE DESIRED
C=======================================================================
C was as follows
C
C      SIZMIN=SQRT(MIN( (DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2),
C    &                  (DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2),
C    &                  (DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2) ))
C
C      SIZMIN=SQRT( (DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2)
C     &            +(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2)
C     &            +(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2) )/3.0
C
      SIZMIN=    ( (DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2)
     &            *(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2)
     &            *(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2) )**(1./6.)
      SCALE=SQRT(PI)/SIZMIN*1.0
      PIDSCA=PI/SCALE
      IF(IPRINT.GT.1) WRITE(*,*)'EWALD ETA: ', SCALE
C=======================================================================
C     CHECK TO SEE WHETHER THE PARAMETERS MAXCX,..., ARE BIG ENOUGH
C     SUGGESTION WILLBE MADE.		             X.WENG 24-OCT-1990
C=======================================================================
      CALL MCHECK(DIRC,RECC,ARGMRE,ARGMRC,MAXCX,MAXCY,MAXCZ,
     &            MAXGPX,MAXGPY,MAXGPZ,SCALE,PIDSCA,IPRINT)
C=======================================================================
C CALCULATE THE CONTRIBUTION TO THE TOTAL ENERGY, THE FORCES ON THE IONS
C AND THE FORCES ON THE UNIT CELL DUE TO THE REAL SPACE PART OF THE
C EWALD SUMS
C=======================================================================
      DO 5010 NI=1,NIONST
      DO 5011 NNI=NI,NIONST
      ICHSQ=ICHARC(NI)*ICHARC(NNI)
C=======================================================================
C THE ENERGY OF INTERACTION BETWEEN EACH PAIR OF IONS MUST BE DIVIDED
C EQUALLY BETWEEN THE TWO IONS. SINCE THE LOOPS OVER THE IONS GIVE THE
C ENERGY OF INTERATION OF ION NI WITH THE PERIODIC ARRAY OF IONS NNI
C WHERE THE INDEX NNI IS GREATER THAN OR EQUAL TO NI WE INCLUDE HALF
C THE ENERGY IF NI IS EQUAL TO NNI BUT ALL OF OF IT IF NNI IS GREATER
C THAN NI TO ACCOUNT FOR ENERGY DUE TO ION NNI INTERACTING WITH THE
C ARRAY OF IONS NI
C=======================================================================
      DCOUNT=ICHSQ
      IF(NNI.EQ.NI) DCOUNT=DCOUNT/2.0
C=======================================================================
C INITIALISE THE DISTANCES IN THE X,Y,Z DIRECTIONS BETWEEN ION NI AND IO
C NNI IN THE CORNER CELL OF THE BLOCK OF UNIT CELLS INCLUDED IN THE REAL
C SPACE PART OF THE EWALD SUM
C=======================================================================
      A1DIFF=POSION(1,NI)-POSION(1,NNI)+MAXCX
      A2DIFF=POSION(2,NI)-POSION(2,NNI)+MAXCY
      A3DIFF=POSION(3,NI)-POSION(3,NNI)+MAXCZ
      XDIFF=DIRC(1,1)*A1DIFF+DIRC(2,1)*A2DIFF+DIRC(3,1)*A3DIFF
      YDIFF=DIRC(1,2)*A1DIFF+DIRC(2,2)*A2DIFF+DIRC(3,2)*A3DIFF
      ZDIFF=DIRC(1,3)*A1DIFF+DIRC(2,3)*A2DIFF+DIRC(3,3)*A3DIFF
C=======================================================================
C CALCULATE THE REAL SPACE CONTRIBUTION TO THE TOTAL ENERGY ETC BY
C SUMMING THE CONTRIBUTIONS DUE TO ION NI INTERACTING WITH ALL THE
C IONS NNI IN THE BLOCK OF UNIT CELLS RETAINED IN THE REAL SPACE SUM
C=======================================================================
      DO 5100 N=1,NCELLZ
      DO 5101 NN=1,NCELLY
      DO 5102 NNN=1,NCELLX
C=======================================================================
C CONVERT THE DISTANCE BETWEEN THE IONS INTO A DIMENSIONLESS FORM BY
C MULTIPLYING BY 'SCALE'
C=======================================================================
      ARG=SQRT(XDIFF**2+YDIFF**2+ZDIFF**2)*SCALE
C=======================================================================
C CONVERT THE DIMENSIONLESS DISTANCE TO AN ADDRESS IN THE EWALD INTEGRAL
C ARRAYS TO INTERPOLATE THE VALUES OF THE EWALD INTEGRALS, IF THE
C DISTANCE IS OUTSIDE THE RANGE OF VALUES IN THE EWALD INTEGRAL DATA
C ARRAYS MOVE ONTO ION NNI IN THE NEXT UNIT CELL
C=======================================================================
      IF(ARG.GT.3.98) GO TO 5103
      ARG=(ARG*NEWPTS/ARGMRE)+2.0
      NADDR=INT(ARG)
      REM=AMOD(ARG,1.0)
C=======================================================================
C INTERPOLATE THE VALUE OF THE EWALD INTEGRAL USED IN THE REAL SPACE
C PART OF THE EWALD SUMMATION FOR THE FORCES ON THE IONS AND THE UNIT
C CELL
C=======================================================================
      V1=EWRLSS(NADDR-1)
      V2=EWRLSS(NADDR)
      V3=EWRLSS(NADDR+1)
      V4=EWRLSS(NADDR+2)
      T0=V2
      T1=((6.0*V3)-(2.0*V1)-(3.0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.0*V2))*HALF
      T3=(V4-V1+(3.0*(V2-V3)))*SIXTH
      EWRL=(T0+(T1*REM)+(T2*(REM**2))+(T3*(REM**3)))
C=======================================================================
C ADD THE CONTRIBUTION TO THE TOTAL FORCE ON ION NI DUE TO THE PERIODIC
C ARRAY OF IONS NNI FROM ION NNI IN THE PRESENT REAL SPACE CELL
C=======================================================================
      RFORCE(1,NNI,NI)=RFORCE(1,NNI,NI)+XDIFF*EWRL
      RFORCE(2,NNI,NI)=RFORCE(2,NNI,NI)+YDIFF*EWRL
      RFORCE(3,NNI,NI)=RFORCE(3,NNI,NI)+ZDIFF*EWRL
C=======================================================================
C ADD THE CONTRIBUTION TO THE TOTAL FORCE ON THE UNIT CELL DUE TO THE
C COULOMB INTERACTION BETWEEN ION NI AND ION NNI IN THE PRESENT REAL
C SPACE CELL
C=======================================================================
      D1X=DIRC(1,1)*A1DIFF
      D1Y=DIRC(1,2)*A1DIFF
      D1Z=DIRC(1,3)*A1DIFF
      D2X=DIRC(2,1)*A2DIFF
      D2Y=DIRC(2,2)*A2DIFF
      D2Z=DIRC(2,3)*A2DIFF
      D3X=DIRC(3,1)*A3DIFF
      D3Y=DIRC(3,2)*A3DIFF
      D3Z=DIRC(3,3)*A3DIFF
C
      D1=D1X+D2X+D3X
      D2=D1Y+D2Y+D3Y
      D3=D1Z+D2Z+D3Z
C
      RSIFOR(1)=RSIFOR(1)-EWRL*(D1**2)*DCOUNT
      RSIFOR(2)=RSIFOR(2)-EWRL*(D2**2)*DCOUNT
      RSIFOR(3)=RSIFOR(3)-EWRL*(D3**2)*DCOUNT
      RSIFOR(4)=RSIFOR(4)-EWRL*(D2*D3)*DCOUNT
      RSIFOR(5)=RSIFOR(5)-EWRL*(D3*D1)*DCOUNT
      RSIFOR(6)=RSIFOR(6)-EWRL*(D1*D2)*DCOUNT
C=======================================================================
C INTERPOLATE THE VALUE OF THE EWALD INTEGRAL USED IN THE REAL SPACE
C PART OF THE EWALD SUMMATION FOR THE FORCES ON THE IONS AND THE UNIT
C CELL
C=======================================================================
      V1=EWRLEN(NADDR-1)
      V2=EWRLEN(NADDR)
      V3=EWRLEN(NADDR+1)
      V4=EWRLEN(NADDR+2)
      T0=V2
      T1=((6.0*V3)-(2.0*V1)-(3.0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.0*V2))*HALF
      T3=(V4-V1+(3.0*(V2-V3)))*SIXTH
      VALUE=(T0+(T1*REM)+(T2*(REM**2))+(T3*(REM**3)))
C=======================================================================
C ADD THE CONTRIBUTION TO THE TOTAL ENERGY DUE TO THE COULOMB
C INTERACTION BETWEEN ION NI AND ION NNI IN THE PRESENT REAL SPACE CELL
C=======================================================================
      REWEN=REWEN+VALUE*DCOUNT
 5103 CONTINUE
C=======================================================================
C MOVE ONTO ION NNI IN THE NEXT REAL SPACE CELL IN THE A1 DIRECTION
C=======================================================================
      XDIFF=XDIFF-DIRC(1,1)
      YDIFF=YDIFF-DIRC(1,2)
      ZDIFF=ZDIFF-DIRC(1,3)
      A1DIFF=A1DIFF-1.0
 5102 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT ROW OF CELLS IN THE A2 DIRECTION AND BACK TO THE
C FIRST CELL IN THE ROW
C=======================================================================
      XDIFF=XDIFF+DIRC(1,1)*NCELLX-DIRC(2,1)
      YDIFF=YDIFF+DIRC(1,2)*NCELLX-DIRC(2,2)
      ZDIFF=ZDIFF+DIRC(1,3)*NCELLX-DIRC(2,3)
      A1DIFF=A1DIFF+NCELLX
      A2DIFF=A2DIFF-1.0
 5101 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT PLANE OF CELLS IN THE A3 DIRECTION AND BACK TO THE
C FIRST CELL IN THE PLANE
C=======================================================================
      XDIFF=XDIFF+DIRC(2,1)*NCELLY-DIRC(3,1)
      YDIFF=YDIFF+DIRC(2,2)*NCELLY-DIRC(3,2)
      ZDIFF=ZDIFF+DIRC(2,3)*NCELLY-DIRC(3,3)
      A2DIFF=A2DIFF+NCELLY
      A3DIFF=A3DIFF-1.0
 5100 CONTINUE
C=======================================================================
C END OF THE LOOP OVER ION NNI, MOVE ONTO THE NEXT ION
C=======================================================================
 5011 CONTINUE
C=======================================================================
C END OF THE LOOP OVER ION NI, MOVE ONTO THE NEXT ION
C=======================================================================
 5010 CONTINUE
C=======================================================================
C CALCULATE THE SCALING FACTORS THAT WILL BE USED TO CONVERT THE VALUES
C OF THE FORCES AND THE ENERGY CALCULATED ABOVE TO REAL FORCES AND
C ENERGIES. THE FACTORS TAKE ACCOUNT OF THE NUMERICAL CONSTANTS
C INTRODUCED BY THE EWALD SEPARATION OF THE COULOMB LATTICE SUMS, THE
C RESCALING OF ALL OF THE EWALD INTEGRALS ONTO THE RANGE ZERO TO ONE
C AS WELL PUTTING IN THE ELECTROSTATIC CONSTANTS VIA 'ELECT'
C=======================================================================
      RSCALE=(SCALE**3)*4.0*ELECT/SQRT(PI)
      RENSCA=SCALE*2.0*ELECT/SQRT(PI)
C=======================================================================
C
C                      ***********
C NOW MOVE ONTO THE RECIPROCAL SPACE PART OF THE EWALD SUMMATIONS
C                      ***********
C
C=======================================================================
C INITIALISE THE X,Y,Z RECIPROCAL LATTICE VECTORS TO THE RECIPROCAL
C LATTICE POINT AT THE CORNER OF THE GRID USED FOR THE RECIPROCAL SPACE
C CONTRIBUTIONS TO THE EWALD SUMS
C=======================================================================
      G1X=-(RECC(1,1)*MAXGPX)/TPI
      G1Y=-(RECC(1,2)*MAXGPX)/TPI
      G1Z=-(RECC(1,3)*MAXGPX)/TPI
      G2X=-(RECC(2,1)*MAXGPY)/TPI
      G2Y=-(RECC(2,2)*MAXGPY)/TPI
      G2Z=-(RECC(2,3)*MAXGPY)/TPI
      G3X=-(RECC(3,1)*MAXGPZ)/TPI
      G3Y=-(RECC(3,2)*MAXGPZ)/TPI
      G3Z=-(RECC(3,3)*MAXGPZ)/TPI
      GX=G1X+G2X+G3X
      GY=G1Y+G2Y+G3Y
      GZ=G1Z+G2Z+G3Z
C=======================================================================
C CALCULATE THE SCALING FACTORS THAT WILL BE USED TO CALCULATE THE
C FORCES ON THE UNIT CELL. THE FACTORS TAKE ACCOUNT OF THE NUMERICAL
C CONSTANTS INTRODUCED BY THE EWALD SEPARATION OF THE COULOMB LATTICE
C SUMS, THE RESCALING OF ALL OF THE EWALD INTEGRALS ONTO THE RANGE ZERO
C TO ONE AS WELL AS PUTTING IN THE ELECTROSTATIC CONSTANTS VIA 'ELECT'
C=======================================================================
      GSISC1=-4.0*(PI**3)*ELECT/(VOLC*SCALE**4)
      GSISC2=2.0*PI*ELECT/(VOLC*SCALE**2)
C=======================================================================
C NG IS AN INDEX USED TO LABEL THE RECIPROCAL LATTICE VECTORS
C INITIALISE TO ONE
C=======================================================================
      NG=1
C=======================================================================
C INTERPOLATE THE VALUES OF THE RECIPROCAL SPACE EWALD INTEGRALS AT THE
C GRID OF RECIPROCAL LATTICE POINTS AND CALCULATE FUNCTIONS OF THE EWALD
C INTEGRALS AND RECIPROCAL LATTICE VECTORS TO BE USED FOR CALULATING THE
C FORCES ON THE IONS AND THE UNIT CELL AND THE TOTAL ENERGY
C=======================================================================
      DO 5200 N=1,NGPTZ
      DO 5201 NN=1,NGPTY
      DO 5202 NNN=1,NGPTX
C=======================================================================
C CALCULATE THE DIMENSIONLESS LENGTH OF THE RECIPROCAL LATTICE VECTOR
C=======================================================================
      GX=G1X+G2X+G3X
      GY=G1Y+G2Y+G3Y
      GZ=G1Z+G2Z+G3Z
      GARG=SQRT(GX**2+GY**2+GZ**2)*PIDSCA
C=======================================================================
C CONVERT THE DIMENSIONLESS LENGTH TO AN ADDRESS IN THE EWALD INTEGRAL
C ARRAYS TO INTERPOLATE THE VALUES OF THE EWALD INTEGRALS, IF THE
C DISTANCE IS OUTSIDE THE RANGE OF VALUES IN THE EWALD INTEGRAL DATA
C ARRAYS SET THE VALUES OF THE EWALD INTEGRALS TO ZERO
C=======================================================================
      IF(GARG.GT.3.98) THEN
      EWRC=0.0
      EWSI=0.0
      ELSE
      GARG=(GARG*NEWPTS/ARGMRC)+2.0
      NADDR=INT(GARG)
      REM=AMOD(GARG,1.0)
C=======================================================================
C INTERPOLATE THE VALUES OF THE EWALD INTEGRALS USED IN THE RECIPROCAL
C SPACE PART OF THE EWALD SUMMATION
C=======================================================================
      V1=EWRCSS(NADDR-1)
      V2=EWRCSS(NADDR)
      V3=EWRCSS(NADDR+1)
      V4=EWRCSS(NADDR+2)
      T0=V2
      T1=((6.0*V3)-(2.0*V1)-(3.0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.0*V2))*HALF
      T3=(V4-V1+(3.0*(V2-V3)))*SIXTH
      EWRC=(T0+(T1*REM)+(T2*(REM**2))+(T3*(REM**3)))
C
      V1=EWRCSI(NADDR-1)
      V2=EWRCSI(NADDR)
      V3=EWRCSI(NADDR+1)
      V4=EWRCSI(NADDR+2)
      T0=V2
      T1=((6.0*V3)-(2.0*V1)-(3.0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.0*V2))*HALF
      T3=(V4-V1+(3.0*(V2-V3)))*SIXTH
      EWSI=(T0+(T1*REM)+(T2*(REM**2))+(T3*(REM**3)))
      ENDIF
C=======================================================================
C USING THE VALUES OF THE EWALD INTEGRALS FOR THIS RECIPROCAL LATTICE
C VECTOR CALCULATE THE FUNCTIONS OF THE RECIPROCAL LATTICE VECTOR AND
C THE EWALD INTEGRALS USED TO CALCULATE THE FORCES ETC
C=======================================================================
      FORCEG(1,NG)=GX*EWRC
      FORCEG(2,NG)=GY*EWRC
      FORCEG(3,NG)=GZ*EWRC
      G1=GX
      G2=GY
      G3=GZ
      FORSIG(1,NG)=-EWSI*(G1**2)*GSISC1-(EWRC*GSISC2)
      FORSIG(2,NG)=-EWSI*(G2**2)*GSISC1-(EWRC*GSISC2)
      FORSIG(3,NG)=-EWSI*(G3**2)*GSISC1-(EWRC*GSISC2)
      FORSIG(4,NG)=-EWSI*(G2*G3)*GSISC1
      FORSIG(5,NG)=-EWSI*(G3*G1)*GSISC1
      FORSIG(6,NG)=-EWSI*(G1*G2)*GSISC1
      ENERG(NG)=EWRC
C=======================================================================
C INCREASE THE INDEX NG BY ONE FOR THE NEXT RECIPROCAL LATTICE VECTOR
C=======================================================================
      NG=NG+1
C=======================================================================
C MOVE ONTO THE NEXT RECIPROCAL LATTICE POINT IN THE X DIRECTION
C=======================================================================
      G1X=G1X+RECC(1,1)/TPI
      G1Y=G1Y+RECC(1,2)/TPI
      G1Z=G1Z+RECC(1,3)/TPI
 5202 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT ROW OF RECIPROCAL LATTICE VECTORS IN THE Y
C DIRECTION AND BACK TO THE FIRST POINT IN THE ROW
C=======================================================================
      G1X=-(RECC(1,1)*MAXGPX)/TPI
      G1Y=-(RECC(1,2)*MAXGPX)/TPI
      G1Z=-(RECC(1,3)*MAXGPX)/TPI
      G2X=G2X+RECC(2,1)/TPI
      G2Y=G2Y+RECC(2,2)/TPI
      G2Z=G2Z+RECC(2,3)/TPI
 5201 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT PLANE OF RECIPROCAL LATTICE VECTORS IN THE Z
C DIRECTION AND BACK TO THE POINT IN THE CORNER OF THE PLANE
C=======================================================================
      G2X=-(RECC(2,1)*MAXGPY)/TPI
      G2Y=-(RECC(2,2)*MAXGPY)/TPI
      G2Z=-(RECC(2,3)*MAXGPY)/TPI
      G3X=G3X+RECC(3,1)/TPI
      G3Y=G3Y+RECC(3,2)/TPI
      G3Z=G3Z+RECC(3,3)/TPI
 5200 CONTINUE
C=======================================================================
C USING THE FUNCTIONS COMPUTED ABOVE CALCULATE THE FORCES ON THE IONS
C AND ON THE UNIT CELL AND THE CONTRIBUTION TO THE TOTAL ENERGY WHICH
C ARISES FROM THE RECIPROCAL SPACE PART OF THE EWALD SUMMATION
C=======================================================================
C======================================================================
C THE FOLLOWING ARE THE LOOPS TO CALCULATE THE FORCES BETWEEN ALL PAIRS
C OF ATOMS IN THE UNIT CELL AND THE ENERGY
C=======================================================================
      DO 5300 NI=1,NIONST
      DO 5301 NNI=NI,NIONST
      ICHSQ=ICHARC(NI)*ICHARC(NNI)
C=======================================================================
C AS BEFORE, DCOUNT ACCOUNTS FOR THE ENERGY OF INTERACTION BETWEEN PAIRS
C OF IONS FOR THE RESTRICTED SUM NNI GREATER OR EQUAL TO NI
C=======================================================================
      DCOUNT=ICHSQ
      IF(NI.EQ.NNI) DCOUNT=DCOUNT/2.0
C=======================================================================
C CX,Y,ZPHF ARE THE CHANGES IN PHASE FACTORS ON MOVING ONE RECIPROCAL
C LATTICE VECTOR IN THE X,Y,Z DIRECTIONS, RESPECTIVELY
C=======================================================================
      CXPHF=(POSION(1,NI)-POSION(1,NNI))*CITPI
      CYPHF=(POSION(2,NI)-POSION(2,NNI))*CITPI
      CZPHF=(POSION(3,NI)-POSION(3,NNI))*CITPI
C=======================================================================
C INITIALISE THE TOTAL PHASE FACTOR TO THE VALUE FOR THE RECIPROCAL
C LATTICE POINT AT THE CORNER OF THE RECIPROCAL LATTICE GRID AND
C INITIALISE THE RECIPROCAL LATTICE VECTOR INDEX TO ONE
C=======================================================================
      CPHF=-CXPHF*MAXGPX
      DO 5330 N=1,NGPTX
      CPHFX(N)=CEXP(CPHF)
      CPHF=CPHF+CXPHF
 5330 CONTINUE
      CPHF=-CYPHF*MAXGPY
      DO 5331 N=1,NGPTY
      CPHFY(N)=CEXP(CPHF)
      CPHF=CPHF+CYPHF
 5331 CONTINUE
      CPHF=-CZPHF*MAXGPZ
      DO 5332 N=1,NGPTZ
      CPHFZ(N)=CEXP(CPHF)
      CPHF=CPHF+CZPHF
 5332 CONTINUE
      CFPHFZ=-CITPI*MAXGPZ
      NG=1
C=======================================================================
C FOR EACH PAIR OF ATOMS SUM THE FORCES AND THE CONTRIBUTION TO THE
C TOTAL ENERGY OVER THE GRID OF RECIPROCAL LATTICE POINTS
C=======================================================================
      DO 5310 N=1,NGPTZ
      DO 5311 NN=1,NGPTY
      CPHFZY=CPHFY(NN)*CPHFZ(N)
      DO 5312 NNN=1,NGPTX
C=======================================================================
C CALCULATE THE EXPONENTIAL OF THE PHASE FACTOR
C=======================================================================
      CEXPHF=CPHFX(NNN)*CPHFZY
C=======================================================================
C CALCULATE THE CONTRIBUTION TO THE FORCE BETWEEN ION NI AND IONS NNI,
C AND THE FORCE ON THE UNIT CELL DUE TO THE INTERACTION BETWEEN THESE
C IONS FROM THE RECIPROCAL LATTICE PART OF THE EWALD SUM AT THE PRESENT
C K POINT
C=======================================================================
       DO 5320 M=1,3
       CFORCE(M,NNI,NI)=CFORCE(M,NNI,NI)+FORCEG(M,NG)*CEXPHF
       CSIFOR(M)=CSIFOR(M)+(FORSIG(M,NG)*CEXPHF)*DCOUNT
 5320  CONTINUE
       DO 5325 M=4,6
       CSIFOR(M)=CSIFOR(M)+(FORSIG(M,NG)*CEXPHF)*DCOUNT
 5325  CONTINUE
C=======================================================================
C CALCULATE THE CONTRIBUTION TO THE TOTAL ENERGY DUE TO THE INTERACTION
C BETWEEN ION NI AND IONS NNI FROM THE RECIPROCAL SPACE PART OF THE
C EWALD SUM AT THE PRESENT K POINT
C=======================================================================
      CEWEN=CEWEN+(ENERG(NG)*CEXPHF)*DCOUNT
C=======================================================================
C INCREASE THE RECIPROCAL LATTICE POINT INDEX BY ONE AND CHANGE THE
C PHASE FACTOR BY THE PHASE CORRESPONDING TO MOVING ONE RECIPROCAL
C LATTICE VECTOR IN THE X DIRECTION, IE TO THE NEXT RECIPROCAL LATTICE
C POINT IN THE X DIRECTION
C=======================================================================
      NG=NG+1
 5312 CONTINUE
C=======================================================================
C MOVE TO THE NEXT ROW OF RECIPROCAL LATTICE POINTS IN THE Y DIRECTION
C AND THE FIRST RECIPROCAL LATTICE POINT IN THE ROW
C=======================================================================
 5311 CONTINUE
C=======================================================================
C MOVE TO THE NEXT PLANE OF RECIPROCAL LATTICE POINTS IN THE Z DIRECTION
C AND THE RECIPROCAL LATTICE POINT AT THE CORNER OF THE PLANE
C=======================================================================
 5310 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT ION NNI
C=======================================================================
 5301 CONTINUE
C=======================================================================
C MOVE ONTO THE NEXT ION NI
C=======================================================================
 5300 CONTINUE
C=======================================================================
C USE INVERSION THROUGH A POINT MIDWAY BETWEEN ION NI AND NNI TO OBTAIN
C THE FORCES ON ION NNI DUE TO INTERACTION WITH THE PERIODIC ARRAY OF
C IONS NNI. ITS BASICALLY NEWTON'S THIRD LAW BUT SLIGHTLY SUBTLER
C=======================================================================
C     DO 5400 NI=1,NIONST      << was
C
      DO 5400 NI=2,NIONST
      DO 5401 NNI=1,NI-1
      DO 5402 M=1,3
      CFORCE(M,NNI,NI)=-CFORCE(M,NI,NNI)
      RFORCE(M,NNI,NI)=-RFORCE(M,NI,NNI)
 5402 CONTINUE
 5401 CONTINUE
 5400 CONTINUE
C=======================================================================
C CALCULATE THE SCALING FACTORS THAT WILL BE USED TO CONVERT THE VALUES
C OF THE FORCES AND THE ENERGY CALCULATED ABOVE TO REAL FORCES AND
C ENERGIES. THE FACTORS TAKE ACCOUNT OF THE NUMERICAL CONSTANTS
C INTRODUCED BY THE EWALD SEPARATION OF THE COULOMB LATTICE SUMS, THE
C RESCALING OF ALL OF THE EWALD INTEGRALS ONTO THE RANGE ZERO TO ONE
C AS WELL PUTTING IN THE ELECTROSTATIC CONSTANTS VIA 'ELECT'
C=======================================================================
      IF(IPRINT.GE.5)WRITE(*,*)'VOLC,SCALE:', VOLC,SCALE
      GENSCA=2.0*PI*ELECT/(VOLC*SCALE**2)
      GSCALE=((2.0*PI)**2)*ELECT/(VOLC*SCALE**2)
C=======================================================================
C CALCULATE THE TOTAL FORCES ON THE IONS
C=======================================================================
      DO 5410 NI=1,NIONST
      DO 5411 NNI=1,NIONST
      ICHSQ=ICHARC(NI)*ICHARC(NNI)
      DO 5412 M=1,3
      EWIFC(M,NI)=EWIFC(M,NI)
     &+( RFORCE(M,NNI,NI)*RSCALE+AIMAG(CFORCE(M,NNI,NI))*GSCALE )*ICHSQ
 5412 CONTINUE
 5411 CONTINUE
 5410 CONTINUE
C=======================================================================
C CALCULATE THE TOTAL STRESS ON THE UNIT CELL
C=======================================================================
      DUM=NIONCH**2*GENSCA/4.0
      SIGEW(1)=(RSIFOR(1)*RSCALE+REAL(CSIFOR(1))+DUM)/VOLC
      SIGEW(2)=(RSIFOR(2)*RSCALE+REAL(CSIFOR(2))+DUM)/VOLC
      SIGEW(3)=(RSIFOR(3)*RSCALE+REAL(CSIFOR(3))+DUM)/VOLC
      SIGEW(4)=(RSIFOR(4)*RSCALE+REAL(CSIFOR(4))    )/VOLC
      SIGEW(5)=(RSIFOR(5)*RSCALE+REAL(CSIFOR(5))    )/VOLC
      SIGEW(6)=(RSIFOR(6)*RSCALE+REAL(CSIFOR(6))    )/VOLC
C=======================================================================
C CALCULATE THE TOTAL COULOMB ENERGY PER CELL INCLUDING THE ENERGY DUE
C THE INTERACTION BETWEEN THE IONS AND THE UNIFORM NEUTRALISING
C BACKGROUND (GIVEN BY THE FINAL TWO TERMS IN THE SUM BELOW)
C=======================================================================
      TEWEN=RENSCA*REWEN+REAL(CEWEN)*GENSCA-(NIONCH**2*GENSCA/4.0)
     &   -(SCALE*ELECT*NICHSQ/SQRT(PI))
      WRITE(*,*)' '
      RETURN
      END
C
C
C
C
C
C=======================================================================
C     CHECK TO SEE WHETHER THE PARAMETERS MAXCX,..., ARE BIG ENOUGH
C     SUGGESTION WILLBE MADE.		             X.WENG 24-OCT-1990
C=======================================================================
      SUBROUTINE MCHECK(DIRC,RECC,ARGMRE,ARGMRC,MAXCX,MAXCY,MAXCZ,
     &            MAXGPX,MAXGPY,MAXGPZ,SCALE,PIDSCA,IPRINT)
      DIMENSION DIRC(3,*), RECC(3,*)
C
      A1=SQRT(DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2)
      A2=SQRT(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2)
      A3=SQRT(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2)
C
      B1=SQRT(RECC(1,1)**2+RECC(1,2)**2+RECC(1,3)**2)
      B2=SQRT(RECC(2,1)**2+RECC(2,2)**2+RECC(2,3)**2)
      B3=SQRT(RECC(3,1)**2+RECC(3,2)**2+RECC(3,3)**2)
C
      IF(IPRINT.GT.1) THEN
      WRITE(*,5)'THE LENGTH OF UNIT  CELL VECTORS (A):', A1,A2,A3
      WRITE(*,5)'THE LENGTH OF RECIPORCAL VECTORS (A):', B1,B2,B3
    5 FORMAT(1X,A37,1X,3F10.5)
      END IF
C=======================================================================
C     CHECK TO SEE IF MAXCX,MAXCY, MAXCZ ARE LARGE ENOUGH  23-OCT-1990
C=======================================================================
      A=SQRT( ( ARGMRE/SCALE)**2 
     &      + ( ABS(DIRC(1,1))+ABS(DIRC(2,1))+ABS(DIRC(3,1)) )**2
     &      + ( ABS(DIRC(1,2))+ABS(DIRC(2,2))+ABS(DIRC(3,2)) )**2
     &      + ( ABS(DIRC(1,3))+ABS(DIRC(2,3))+ABS(DIRC(3,3)) )**2 )
      MRX=A/A1+1
      MRY=A/A2+1
      MRZ=A/A3+1
      IF( MAXCX.GE.MRX .AND. MAXCY.GE.MRY .AND. MAXCZ.GE.MRZ) THEN
      IF(IPRINT.GT.1) THEN
      WRITE(*,*)'THE CURRENT REAL SPACE SUMMATION IS LARGE ENOUGH'
      WRITE(*,10) MRX, MRY, MRZ
      END IF
      ELSE
      WRITE(*,*)'THE CURRENT REAL SPACE SUMMATION IS TOO SMALL <****'
      WRITE(*,10) MRX, MRY, MRZ
      END IF
   10 FORMAT(' THE MINIMUM EWALD  R E A L   SPACE SUMMATION:',3I4)
C=======================================================================
C     DO THE SAME FOR MAXGPX,MAXGPY, MAXGPZ 
C=======================================================================
      B=SQRT( ( ARGMRC/PIDSCA*(2.0*3.1415926545897)          )**2
     &      + ( ABS(RECC(1,1))+ABS(RECC(2,1))+ABS(RECC(3,1)) )**2
     &      + ( ABS(RECC(1,2))+ABS(RECC(2,2))+ABS(RECC(3,2)) )**2
     &      + ( ABS(RECC(1,3))+ABS(RECC(2,3))+ABS(RECC(3,3)) )**2 )
      MGX=B/B1+1
      MGY=B/B2+1
      MGZ=B/B3+1
      IF( MAXGPX.GE.MGX .AND. MAXGPY.GE.MGY .AND. MAXGPZ.GE.MGZ) THEN
      IF(IPRINT.GT.1) THEN
      WRITE(*,*)'THE CURRENT RECIPROCAL SUMMATION IS LARGE ENOUGH'
      WRITE(*,20) MGX, MGY, MGZ
      END IF
      ELSE
      WRITE(*,*)'THE CURRENT RECIPROCAL SUMMATION IS TOO SMALL <****'
      WRITE(*,20) MGX, MGY, MGZ
      END IF
   20 FORMAT(' THE MINIMUM EWALD RECIPROCAL SPACE SUMMATION:',3I4)
      RETURN
      END

      PROGRAM MOPAC5
C
C         Notice of Public Domain nature of MOPAC
C
C      'This computer program is a work of the United States 
C       Government and as such is not subject to protection by 
C       copyright (17 U.S.C. # 105.)  Any person who fraudulently 
C       places a copyright notice or does any other act contrary 
C       to the provisions of 17 U.S. Code 506(c) shall be subject 
C       to the penalties provided therein.  This notice shall not 
C       be altered or removed from this software and is to be on 
C       all reproductions.'
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /NUMCAL/ NUMCAL
      COMMON /TIMEMP/ TIME0
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      CHARACTER*80 KEYWRD

      CALL INITIM()

C-old      OPEN(UNIT=5,FILE='FOR005',STATUS='OLD',BLANK='ZERO')
C-old      REWIND 5
C-old      OPEN(UNIT=6,FILE='FOR006',STATUS='NEW')
C-old      REWIND 6
      NUMCAL=1
C
      TIME0=ZECOND()
C
C READ AND CHECK INPUT FILE, EXIT IF NECESSARY.
C     WRITE INPUT FILE TO UNIT 6 AS FEEDBACK TO USER
C
   10 CALL VREAD
      IF(INDEX(KEYWRD,'AUTHOR') .NE. 0) THEN
         WRITE(6,'(10X,'' MOPAC - A GENERAL MOLECULAR ORBITAL PACKAGE'',
     1/         ,10X,''   ORIGINAL VERSION WRITTEN IN 1983'')')
         WRITE(6,'(10X,''     BY JAMES J. P. STEWART AT THE'',/
     1         ,10X,''     UNIVERSITY OF TEXAS AT AUSTIN'',/
     2         ,10X,''          AUSTIN, TEXAS, 78712'')')
      ENDIF
C
C INITIALIZE CALCULATION AND WRITE CALCULATION INDEPENDENT INFO
C
      IF(INDEX(KEYWRD,'0SCF') .NE. 0) GOTO 70
      IF(INDEX(KEYWRD,'EXTERNAL') .NE. 0) THEN
         CALL AM1
      ELSE
         CALL MOLDAT
      ENDIF
      IF (INDEX(KEYWRD,' XYZ') .NE. 0.AND.NVAR.NE.0) THEN
C
C   SET ALL OPTIMIZATION FLAGS TO 1.  IT IS POSSIBLE TO SPECIFY " XYZ"
C   AND HAVE 3N-6 FLAGS SET AND STILL NOT HAVE EVERY ATOM MARKED FOR
C   OPTIMIZATION.  THIS CAN HAPPEN IF DUMMY ATOMS ARE PRESENT
C   TO PREVENT THIS, WE EXPLICITELY SET ALL FLAGS.
C
         NVAR=0
         DO 30 I=1,NATOMS
C
C  I DON'T THINK THE FOLLOWING LOGICAL WILL EVER BE TRUE, BUT I'M NOT
C  TAKING IT OUT IN THIS VERSION, JUST IN CASE.
C
            IF(LABELS(I).EQ.99) GOTO 30
            DO 20 J=1,3
               NVAR=NVAR+1
               LOC(1,NVAR)=I
               LOC(2,NVAR)=J
   20       XPARAM(NVAR)=GEO(J,I)
   30    CONTINUE
      ENDIF
      IF (INDEX(KEYWRD,'RESTART').EQ.0)THEN
         IF (INDEX(KEYWRD,'1SCF') .NE. 0) THEN
            IF(LATOM.NE.0)THEN
               WRITE(6,'(//,10X,A)')'1SCF SPECIFIED WITH PATH.  THIS PAI
     1R OF'
               WRITE(6,'(   10X,A)')'OPTIONS IS NOT ALLOWED'
               GOTO 70
            ENDIF
            NVAR=0
            IF(INDEX(KEYWRD,'GRAD').NE.0) THEN
               NVAR=0
               DO 50 I=2,NATOMS
                  IF(LABELS(I).EQ.99) GOTO 50
                  IF(I.EQ.2)ILIM=1
                  IF(I.EQ.3)ILIM=2
                  IF(I.GT.3)ILIM=3
                  DO 40 J=1,ILIM
                     NVAR=NVAR+1
                     LOC(1,NVAR)=I
                     LOC(2,NVAR)=J
   40             XPARAM(NVAR)=GEO(J,I)
   50          CONTINUE
            ENDIF
         ENDIF
      ENDIF
C
C CALCULATE DYNAMIC REACTION COORDINATE.
C
C
      IF(INDEX(KEYWRD,'SADDLE') .NE. 0) THEN
         CALL REACT1(ESCF)
         GOTO 60
      ENDIF
      CLOSE (5)
      IF(INDEX(KEYWRD,'STEP1') .NE. 0) THEN
         CALL GRID
         GOTO 70
      ENDIF
      IF (LATOM .NE. 0) THEN
C
C       DO PATH
C
         CALL PATHS
         GOTO 70
      ENDIF
      IF (INDEX(KEYWRD,'FORCE') + INDEX(KEYWRD,'IRC=') .NE. 0 ) THEN
C
C FORCE CALCULATION IF DESIRED
C
         CALL FORCE
         GOTO 70
      ENDIF
      IF(INDEX(KEYWRD,' DRC') + INDEX(KEYWRD,' IRC') .NE. 0) THEN
C
C   IN THIS CONTEXT, "REACT" HOLDS INITIAL VELOCITY VECTOR COMPONENTS.
C
         CALL DRC(REACT,REACT)
         GOTO 70
      ENDIF
C
      IF(INDEX(KEYWRD,'NLLSQ') .NE. 0) THEN
         CALL NLLSQ(XPARAM, NVAR )
         CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,GRAD,.TRUE.)
         GOTO 60
      ENDIF
C
      IF(INDEX(KEYWRD,'SIGMA') .NE. 0) THEN
         CALL POWSQ(XPARAM, NVAR, ESCF)
         GOTO 60
      ENDIF
C
C ORDINARY GEOMETRY OPTIMISATION
C
      CALL FLEPO(XPARAM, NVAR, ESCF)
   60 CALL VWRITE(TIME0, ESCF)
      IF(INDEX(KEYWRD,'POLAR') .NE. 0) THEN
         CALL POLAR
      ENDIF
   70 TIM=ZECOND()-TIME0
      WRITE(6,'(///,'' TOTAL CPU TIME: '',F16.2,'' SECONDS'')') TIM
      WRITE(6,'(/,'' == MOPAC DONE =='')')
      CALL WRAPUP()
      END

      SUBROUTINE BC(JDIM,KDIM,Q,PRESS,SNDSP,XY,XIT,ETT,XYJ,X,Y,SLOPE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4)
      DIMENSION PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION XIT(JDIM,KDIM),ETT(JDIM,KDIM)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM),SLOPE(JDIM)
      COMMON/INFNTY/RHOINF,UINF,VINF,EINF,PINF
C
      COMMON/WORKSP/F(MAXJ),WORK0(MAXJ,91)
C
C    BICONVEX AIFOIL BC
C
      STRTIT = 12.
      T = ( NUMITE  -1.)/ STRTIT
      IF( T .GT.1.) T = 1.
      SCAL = (10. -15.*T + 6.*T*T) *T**3
C
C  U AND V ON LOWER SURFACE
C    U IS EXTRAPOLATED 
C    V IS SET TO SATISFY TANGENCY
C    A RECTILINEAR MESH IS ASSUMED
C
      DO 25 J = 2,JM
C
C         FIRST ORDER EXTRAPOLATION OF U ( DIVIDE BY RHO/J )
C          U2 = 2. * Q(J,2,2)/Q(J,2,1) - Q(J,3,2)/Q(J,3,1)
C
C         ZERO'TH ORDER EXTRAPOLATION OF U ( DIVIDE BY RHO/J )
          U2 = Q(J,2,2) / Q(J,2,1)
C
C         ZERO'TH ORDER EXTRAPOLATION OF U
          Q(J,1,2)  = U2
C
C         TANGENCY
          Q(J,1,3) = U2 * SLOPE(J) * SCAL
C
C
25    CONTINUE
C
C  SATISFY MOMENTUM RELATION FOR NORMAL PRESSURE DERIVATION
C
      K = 1
      DO 30 J=2,JM
C
C         PRESSURE IS EXTRAPOLATED TO FIRST ORDER INTO F
C
         P2 = GAMI*(Q(J,2,4)-0.5*(Q(J,2,2)**2+Q(J,2,3)**2)/Q(J,2,1))
         P3 = GAMI*(Q(J,3,4)-0.5*(Q(J,3,2)**2+Q(J,3,3)**2)/Q(J,3,1))
         F(J) = (2.*P2*XYJ(J,2)-P3*XYJ(J,3))/XYJ(J,1)
C
C RESCALE Q2 AND Q3 TO NEW DENSITY SUCH THAT WHEN REFORMING PRESSURE
C      FROM Q1 TO Q4, THE NORMAL DERIVATIVE OF PRESSURE IS SATIFIED
C
C         ZERO'TH ORDER EXTRAPOLATION OF RHO
          Q( J, K, 1)  = Q( J, K+1, 1) * XYJ( J, K+1) / XYJ( J, K)
C
C          U EXTRAP ABOVE, THIS PUTS IN RHO ( WITH METRIC JACOBIAN )
          Q(J,K,2) = Q(J,K,2)*Q(J,K,1)
C
C          V SET ABOVE, THIS PUTS IN RHO ( WITH METRIC JACOBIAN )
          Q(J,K,3) = Q(J,K,3)*Q(J,K,1)
C
C          ENERGY
C           RECALCULATE THE ENERGY USING THE NEW RHO, U, V 
C           AND EXTRAPOLATED PRESSURE.
           Q(J,K,4) = F(J)/GAMI +.5*( Q(J,K,2)**2+Q(J,K,3)**2) /Q(J,K,1)
C
   30 CONTINUE
C.....................................................................
C   INFLOW/OUTFLOW BOUNDARIES
C               CHECK FOR SUPERSONIC FREE STREAM
C.....................................................................
C
      IF(FSMACH.GT.1.)GO TO 75
C
C
C  INFLOW BOUNDARY
C
          GI = 1./GAMMA
          GM1I = 1./GAMI
C
         AINF = SQRT(GAMMA*PINF/RHOINF)
         HSTFS = 1./GAMI + 0.5*FSMACH**2
C
      J = 1
      DO 50 K = 2,KM
      SNORM = 1./SQRT(XY(J,K,1)**2+XY(J,K,2)**2)
      XY1H = XY(J,K,1)*SNORM
      XY2H = XY(J,K,2)*SNORM
C
C  EXTRAPOLATE TEMPORARY VARIABLES
C 
      XYJM1 = XYJ(J+1,K)
      RHOEXT = Q(J+1,K,1)*XYJM1 
      RJM1 = 1./Q(J+1,K,1)
      UEXT = Q(J+1,K,2)*RJM1 
      VEXT = Q(J+1,K,3)*RJM1 
      EEXT = Q(J+1,K,4)*XYJM1 
      PEXT = GAMI*(EEXT - 0.5*RHOEXT*(UEXT**2+VEXT**2))
C
C  FIX INCOMING RIEMANN INVARIANT
      RFIX = XY1H*UINF + XY2H*VINF + 2.*AINF*GM1I
      REXT = XY1H*UEXT + XY2H*VEXT - 2.*SQRT(GAMMA*PEXT/RHOEXT)*GM1I
C
C              COMPUTE FLOW VARIABLES BASED ON ABOVE CALC
C
      QN = (RFIX + REXT)*0.5
      CSPE = (RFIX - REXT)*GAMI*0.25
      C2 = CSPE**2
C
           QT = (-XY2H*UINF + XY1H*VINF)
           ENTRO = GAMMA
C
C             COMPUTE FLOW VARIABLES
C
      U = XY1H*QN - XY2H*QT
      V = XY2H*QN + XY1H*QT
      Q(J,K,1) = (C2*ENTRO*GI)**GM1I
      PRES = C2*Q(J,K,1)*GI
C
C              ADD JACOBIAN
C
          RJ = 1./XYJ(J,K)
          Q(J,K,1) = Q(J,K,1)*RJ
          Q(J,K,2) = Q(J,K,1)*U
          Q(J,K,3) = Q(J,K,1)*V
          Q(J,K,4) = PRES*GM1I*RJ + 0.5*Q(J,K,1)*(U**2+V**2)
50    CONTINUE
C
C
C  OUTFLOW BOUNDARY
C
C
      J = JMAX
      DO 55 K = 2,KM
      SNORM = 1./SQRT(XY(J,K,1)**2+XY(J,K,2)**2)
      XY1H = XY(J,K,1)*SNORM
      XY2H = XY(J,K,2)*SNORM
C
C  EXTRAPOLATE TEMPORARY VARIABLES
C 
      XYJM1 = XYJ(J-1,K)
      RHOEXT = Q(J-1,K,1)*XYJM1 
      RJM1 = 1./Q(J-1,K,1)
      UEXT = Q(J-1,K,2)*RJM1 
      VEXT = Q(J-1,K,3)*RJM1 
      EEXT = Q(J-1,K,4)*XYJM1 
      PEXT = GAMI*(EEXT - 0.5*RHOEXT*(UEXT**2+VEXT**2))
C
C  FIX INCOMING RIEMANN INVARIANT
      RFIX = XY1H*UINF + XY2H*VINF - 2.*AINF*GM1I
      REXT = XY1H*UEXT + XY2H*VEXT + 2.*SQRT(GAMMA*PEXT/RHOEXT)*GM1I
C
C              COMPUTE FLOW VARIABLES BASED ON ABOVE CALC
C
      QN = (RFIX + REXT)*0.5
      CSPE = (REXT - RFIX)*GAMI*0.25
      C2 = CSPE**2
C
           QT = (-XY2H*UEXT + XY1H*VEXT)
           ENTRO = RHOEXT**GAMMA/PEXT
C
C             COMPUTE FLOW VARIABLES
C
      U = XY1H*QN - XY2H*QT
      V = XY2H*QN + XY1H*QT
      Q(J,K,1) = (C2*ENTRO*GI)**GM1I
      PRES = C2*Q(J,K,1)*GI
C
C              ADD JACOBIAN
C
          RJ = 1./XYJ(J,K)
          Q(J,K,1) = Q(J,K,1)*RJ
          Q(J,K,2) = Q(J,K,1)*U
          Q(J,K,3) = Q(J,K,1)*V
          Q(J,K,4) = PRES*GM1I*RJ + 0.5*Q(J,K,1)*(U**2+V**2)
55    CONTINUE

      GO TO 100
C
75    CONTINUE
C
C  FOR SUPERSONIC INFLOW  ALL VARIABLES FIXED TO FREE STREAM
C
       J = 1
       DO 80 K = 1,KMAX
       RJJ = 1./XYJ(J,K)
       Q(J,K,1) = RHOINF*RJJ
       Q(J,K,2) = UINF*Q(J,K,1)      
       Q(J,K,3) = VINF*Q(J,K,1)      
       Q(J,K,4) = EINF*RJJ
80     CONTINUE
C
C   FOR SUPERSONIC OUTFLOW EXTRAPOLATE ALL VARIABLES
C  
       J = JMAX
       DO 85 K = 1,KMAX
       RJJ = XYJ(J-1,K)/XYJ(J,K)
       Q(J,K,1) = Q(J-1,K,1)*RJJ
       Q(J,K,2) = Q(J-1,K,2)*RJJ
       Q(J,K,3) = Q(J-1,K,3)*RJJ
       Q(J,K,4) = Q(J-1,K,4)*RJJ
85     CONTINUE
C
100    CONTINUE
C
C  TOP BOUNDARY
C
C        *****   FAR-FIELD STUFF  *****
C
C             TOP BOUNDARY
C
C
         AINF = SQRT(GAMMA*PINF/RHOINF)
         HSTFS = 1./GAMI + 0.5*FSMACH**2
         GM1I  = 1./GAMI
         GI    = 1./GAMMA
         K = KMAX
         IF(FSMACH.LT.1.0)THEN
C
C                         SUBSONIC FREESTREAM
C
      DO 60 J = 2,JM
         UF = UINF
         VF = VINF
         AF2 = GAMI*(HSTFS - .5*(UF**2+VF**2))
         AF = SQRT(AF2)
C
C              CHOOSE A REFERENCE FRAME IN TERMS OF NORMAL AND 
C              TANGENTIAL COMPONENTS
C
C                   METRIC TERMS
C  
      SNORM = 1./SQRT(XY(J,K,3)**2+XY(J,K,4)**2)
      XY3H = XY(J,K,3)*SNORM
      XY4H = XY(J,K,4)*SNORM
C
C                  CHECK FOR INFLOW OR OUTFLOW
C             FOR INFLOW : THREE VARIABLES ARE SPECIFIED  R1 AND  
C                     QT  ( Q_TANGENTIAL)  AND   S~ R**GAMMA/P  (~ENTROPY)
C                     WITH ONE VAR. COMPUTED.  R2
C             FOR OUTFLOW : ONE VARIABLE IS FIXED R1  WITH THREE COMPUTED
C                     R2, QT AND S
C
C             COMPUTE RIEMANN INVARIANTS
C             FIX          R1 = QN - 2.*A/(GAMMA-1)  AT FREE STREAM
C             COMPUTE      R2 = QN + 2.*A/(GAMMA-1)  FROM INTERIOR
C                          EXTRAPOLATION OF FLOW VARIABLES
C
C             GET EXTRAPOLATED VARIABLES
C
      RHOEXT = Q(J,K-1,1)*XYJ(J,K-1)
      RJM1   = 1./Q(J,K-1,1)
      UEXT   = Q(J,K-1,2)*RJM1 
      VEXT   = Q(J,K-1,3)*RJM1 
      EEXT   = Q(J,K-1,4)*XYJ(J,K-1)
      PEXT   = GAMI*(EEXT - 0.5*RHOEXT*(UEXT**2+VEXT**2))
C
C               SET RIEMANN INVARIANTS
C
      R1 = XY3H*UF + XY4H*VF - 2.*AF*GM1I
      R2 = XY3H*UEXT + XY4H*VEXT + 2.*SQRT(GAMMA*PEXT/RHOEXT)*GM1I
C
      QN = (R1 + R2)*0.5
      CSPE = (R2 - R1)*GAMI*0.25
      C2 = CSPE**2
C
C               SET OTHER FIXED OR EXTRAPOLATED VARIABLES
C
           IF(QN .LE. 0.0)THEN
           QT = XY4H*UF - XY3H*VF 
           ENTRO = GAMMA
           ELSE
           QT = XY4H*UEXT - XY3H*VEXT 
           ENTRO = RHOEXT**GAMMA/PEXT
           ENDIF
C
C              COMPUTE FLOW VARIABLES
C
      U = XY3H*QN + XY4H*QT
      V = XY4H*QN - XY3H*QT
C
      Q(J,K,1) = (C2*ENTRO*GI)**GM1I
      PRES = C2*Q(J,K,1)*GI
C
C              ADD JACOBIAN
C
          RJJ = 1./XYJ(J,K)
          Q(J,K,1) = Q(J,K,1)*RJJ
          Q(J,K,2) = Q(J,K,1)*U
          Q(J,K,3) = Q(J,K,1)*V
          Q(J,K,4) = PRES*GM1I*RJJ + 0.5*Q(J,K,1)*(U**2+V**2)
60    CONTINUE
      ELSE
C
C                         SUPERSONIC FREESTREAM
C
      K = KMAX
      DO 70 J = 2,JM
C
C               CHOOSE A REFERENCE FRAME IN TERMS OF NORMAL AND 
C               TANGENTIAL COMPONENTS
C
C
C               METRIC TERMS
C  
C          USE EXTRAPOLATED QN TO DETERMINE INFLOW/OUTFLOW
C
      RHOINV = 1./Q(J,K-1,1)
      U = Q(J,K-1,2)*RHOINV
      V = Q(J,K-1,3)*RHOINV
      SNORM = 1./SQRT(XY(J,K-1,3)**2+XY(J,K-1,4)**2)
      XY3H = XY(J,K-1,3)*SNORM
      XY4H = XY(J,K-1,4)*SNORM
      QN1EXT = XY3H*U + XY4H*V
      RHOINV = 1./Q(J,K-2,1)
      U = Q(J,K-2,2)*RHOINV
      V = Q(J,K-2,3)*RHOINV
      SNORM = 1./SQRT(XY(J,K-2,3)**2+XY(J,K-2,4)**2)
      XY3H = XY(J,K-2,3)*SNORM
      XY4H = XY(J,K-2,4)*SNORM
      QN2EXT = XY3H*U + XY4H*V
      QNEXT = QN1EXT
C
           IF(QNEXT.GT.0.)THEN
           RMET1 = XYJ(J,K-1)/XYJ(J,K)
           RMET2 = XYJ(J,K-2)/XYJ(J,K)
           DO 65 N = 1,4
           Q(J,K,N) = Q(J,K-1,N)*RMET1
65         CONTINUE
           ENDIF
70    CONTINUE
      ENDIF

C
       RETURN
       END

      SUBROUTINE SET (S1,S2,NA,NB,RAB,NBOND,II)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /SETC/ A(7),B(7),SA,SB,FACTOR,ISP,IPS
C***********************************************************************
C
C     SET IS PART OF THE OVERLAP CALCULATION, CALLED BY OVERLP.
C         IT CALLS AINTGS AND BINTGS
C
C***********************************************************************
      IF (NA.GT.NB) GO TO 10
      ISP=1
      IPS=2
      SA=S1
      SB=S2
      GOTO 20
   10 ISP=2
      IPS=1
      SA=S2
      SB=S1
   20 J=II+2
      IF (II.GT.3) J=J-1
      ALPHA=0.5D00*RAB*(SA+SB)
      BETA=0.5D00*RAB*(SB-SA)
      JCALL=J-1
      CALL AINTGS (ALPHA,JCALL)
      CALL BINTGS (BETA,JCALL)
      RETURN
C
      END

      SUBROUTINE NLLSQ(X,N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /KEYWRD/ KEYWRD
      CHARACTER*80 KEYWRD
      DIMENSION X(*)
      COMMON /MESAGE/ IFLEPO,IITER
************************************************************************
*
*  NLLSQ IS A NON-DERIVATIVE, NONLINEAR LEAST-SQUARES MINIMIZER. IT USES
*        BARTEL'S PROCEDURE TO MINIMIZE A FUNCTION WHICH IS A SUM OF
*        SQUARES.
*
*    ON INPUT N    = NUMBER OF UNKNOWNS
*             X    = PARAMETERS OF FUNCTION TO BE MINIMIZED.
*
*    ON EXIT  X    = OPTIMIZED PARAMETERS.
*
*    THE FUNCTION TO BE MINIMIZED IS "COMPFG". COMPFG MUST HAVE THE
*    CALLING SEQUENCE
*                  CALL COMPFG(XPARAM,.TRUE.,ESCF,.TRUE.,EFS,.TRUE.)
*                  SSQ=DOT(EFS,EFS,N)
*    WHERE   EFS  IS A VECTOR WHICH  COMPFG  FILLS WITH THE N INDIVIDUAL
*                 COMPONENTS OF THE ERROR FUNCTION AT THE POINT X
*            SSQ IS THE VALUE OF THE SUM OF THE  EFS  SQUARED.
*    IN THIS FORMULATION OF NLLSQ M AND N ARE THE SAME.
*    THE PRECISE DEFINITIONS OF THESE TWO QUANTITIES IS:
*
*     N = NUMBER OF PARAMETERS TO BE OPTIMIZED.
*     M = NUMBER OF REFERENCE FUNCTIONS. M MUST BE GREATER THEN, OR
*         EQUAL TO, N
************************************************************************
C     Q = ORTHOGONAL MATRIX   (M BY M)
C     R = RIGHT-TRIANGULAR MATRIX   (M BY N)
C     MXCNT(1) = MAX ALLOW OVERALL FUN EVALS
C     MXCNT(2) = MAX ALLOW NO OF FNC EVALS PER LIN SEARCH
C     TOLS1 = RELATIVE TOLERANCE ON X OVERALL
C     TOLS2 = ABSOLUTE TOLERANCE ON X OVERALL
C     TOLS5 = RELATIVE TOLERANCE ON X FOR LINEAR SEARCHES
C     TOLS6 = ABSOLUTE TOLERANCE ON X FOR LINEAR SEARCHES
C     IPRINT = PRINT SWITCH
C     NRST = NUMBER OF CYCLES BETWEEN SIDESTEPS
C     **********
      COMMON /TIMEMP/ TIME0
      COMMON /NLLSQI/ NCOUNT
      COMMON /NUMSCF/ NSCF
      DIMENSION Y(MAXPAR), EFS(MAXPAR), P(MAXPAR)
      COMMON /LAST  / LAST
      COMMON /NLLCOM/DDDUM(6),EFSLST(MAXPAR),Q(MAXPAR,MAXPAR),
     1               R(MAXPAR,MAXPAR),XLAST(MAXPAR),
     2               IIIUM(7),IDUMY(2*MAXPAR*MAXPAR-19-MAXPAR*4)
      LOGICAL MIDDLE, SCF1, RESFIL
      CHARACTER SPACE*1, CHDOT*1, ZERO*1, NINE*1, CH*1
      EQUIVALENCE ( IIIUM(2), ICYC),(IIIUM(3), IRST),
     1(IIIUM(4),JRST),
     2(DDDUM(2),ALF), (DDDUM(3),SSQ),(DDDUM(4), PN)
      DATA SPACE,CHDOT,ZERO,NINE /' ','.','0','9'/
      MIDDLE=(INDEX(KEYWRD,'RESTART') .NE. 0)
      SCF1=(INDEX(KEYWRD,'1SCF') .NE. 0)
      IFLEPO=10
C*
      M=N
C*
      TOL2=4.D-1
      IF(INDEX(KEYWRD,'GNORM') .NE. 0) THEN
         TOL2=READA(KEYWRD,INDEX(KEYWRD,'GNORM'))
         IF(TOL2.LT.0.001D0.AND.INDEX(KEYWRD,'LET').EQ.0)THEN
            WRITE(6,'(/,A)')'  GNORM HAS BEEN SET TOO LOW, RESET TO 0
     1.001'
            TOL2=0.001D0
         ENDIF
      ENDIF
      LAST=0
      MXCYCL=100
      I=INDEX(KEYWRD,'CYCLES')
      IF (I.NE.0) THEN
         MXCYCL=READA(KEYWRD,I)
         WRITE(6,'(/10X,''NUMBER OF CYCLES TO BE RUN ='',I5)')MXCYCL
      ENDIF
      TOLS1=1.D-12
      TOLS2=1.D-10
      TOLS5=1.D-6
      TOLS6=1.D-3
      IPRINT=-1
      NRST=4
      YMAXST=1.D0
      TLEFT=MAXTIM
      I=INDEX(KEYWRD,' T=')
      IF(I.NE.0) THEN
         TIM=READA(KEYWRD,I)
         DO 10 J=I+3,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TIM=TIM*60
               IF( CH .EQ. 'H') TIM=TIM*3600
               IF( CH .EQ. 'D') TIM=TIM*86400
               GOTO 20
            ENDIF
   10    CONTINUE
   20    TLEFT=TIM
      ENDIF
      TLAST=TLEFT
      TDUMP=MAXDMP
      I=INDEX(KEYWRD,' DUMP')
      IF(I.NE.0) THEN
         TDUMP=READA(KEYWRD,I)
         DO 30 J=I+6,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TDUMP=TDUMP*60
               IF( CH .EQ. 'H') TDUMP=TDUMP*3600
               IF( CH .EQ. 'D') TDUMP=TDUMP*86400
               GOTO 40
            ENDIF
   30    CONTINUE
   40    CONTINUE
      ENDIF
      RESFIL=.FALSE.
      TLEFT=TLEFT-ZECOND()+TIME0
C     **********
C     SET UP COUNTERS AND SWITCHES
C     **********
      NTO=N/6
      IFRTL=0
      NREM=N-(NTO*6)
      IREPET=0
      NSST=0
      IF(IXSO.EQ.0) IXSO=N
      NP1 = N+1
      NP2 = N+2
      ICYC = 0
      IRST = 0
      JRST = 1
      EPS =TOLS5
      T = TOLS6
C     **********
C     GET STARTING-POINT FUNCTION VALUE
C     SET UP ESTIMATE OF INITIAL LINE STEP
C     **********
      IF(MIDDLE) THEN
         CALL PARSAV(0,N,M)
         NSCF=IIIUM(1)
         CLOSE(13)
         NCOUNT=IIIUM(5)
         MXCYCL=MXCYCL+ICYC
         DO 50 I=1,N
   50    X(I)=XLAST(I)
         TIME1=ZECOND()
         GOTO 100
      ENDIF
      CALL COMPFG(X,.TRUE.,ESCF,.TRUE.,EFSLST,.TRUE.)
      IF( SCF1 ) GOTO 920
      SSQ=DOT(EFSLST,EFSLST,N)
      NCOUNT = 1
   60 CONTINUE
      DO 80 I=1,M
         DO 70 J=1,N
            R(I,J) = 0.0D0
            IF (I .EQ. J)  R(I,J)=1.0D0
   70    CONTINUE
         DO 80 J=I,M
            Q(I,J) = 0.0D0
            Q(J,I) = 0.0D0
            IF (I .EQ. J)  Q(I,I)=1.0D0
   80 CONTINUE
      TEMP = 0.0D0
      DO 90 I=1,N
   90 TEMP = TEMP+X(I)**2
      ALF = 100.0D0*(EPS*SQRT(TEMP)+T)
C     **********
C     MAIN LOOP
C     **********
      TIME1=ZECOND()
  100 CONTINUE
C     **********
C     UPDATE COUNTERS AND TEST FOR PRINTING THIS CYCLE
C     **********
      IFRTL=IFRTL+1
      ICYC = ICYC+1
      IRST = IRST+1
C     **********
C     SET  PRT,  THE LEVENBERG-MARQUARDT PARAMETER.
C     **********
      PRT = SQRT(SSQ)
C     **********
C     IF A SIDESTEP IS TO BE TAKEN, GO TO 31
C     **********
      IF (IRST .GE. NRST)  GO TO 250
C     **********
C     SOLVE THE SYSTEM    Q*R*P = -EFSLST    IN THE LEAST-SQUARES SENSE
C     **********
      NSST=0
      DO 120 I=1,M
         TEMP = 0.0D0
         DO 110 J=1,M
  110    TEMP = TEMP-Q(J,I)*EFSLST(J)
  120 EFS(I) = TEMP
      DO 130 J=1,N
         JJ = NP1-J
         DO 130 I=1,J
            II = NP2-I
  130 R(II,JJ) = R(I,J)
      DO 200 I=1,N
         I1 = I+1
         Y(I) = PRT
         EFSSS=0.0D0
         IF (I .GE. N)  GO TO 150
         DO 140 J=I1,N
  140    Y(J) = 0.0D0
  150    CONTINUE
         DO 190 J=I,N
            II = NP2-J
            JJ = NP1-J
            IF (ABS(Y(J)) .LT. ABS(R(II,JJ)))  GO TO 160
            TEMP = Y(J)*SQRT(1.0D0+(R(II,JJ)/Y(J))**2)
            GO TO 170
  160       TEMP = R(II,JJ)*SQRT(1.0D0+(Y(J)/R(II,JJ))**2)
  170       CONTINUE
            SIN = R(II,JJ)/TEMP
            COS = Y(J)/TEMP
            R(II,JJ) = TEMP
            TEMP = EFS(J)
            EFS(J)=SIN*TEMP+COS*EFSSS
            EFSSS=SIN*EFSSS-COS*TEMP
            IF (J .GE. N)  GO TO 200
            J1 = J+1
            DO 180 K=J1,N
               JJ = NP1-K
               TEMP = R(II,JJ)
               R(II,JJ) = SIN*TEMP+COS*Y(K)
  180       Y(K) = SIN*Y(K)-COS*TEMP
  190    CONTINUE
  200 CONTINUE
      P(N) = EFS(N)/R(2,1)
      I = N
  210 I = I-1
      IF (I)  240,240,220
  220 TEMP = EFS(I)
      K = I+1
      II = NP2-I
      DO 230 J=K,N
         JJ = NP1-J
  230 TEMP = TEMP-R(II,JJ)*P(J)
      JJ = NP1-I
      P(I) = TEMP/R(II,JJ)
      GO TO 210
  240 CONTINUE
      GO TO 270
C     **********
C     SIDESTEP SECTION
C     **********
  250 JRST = JRST+1
      NSST=NSST+1
      IF(NSST.GE.IXSO) GO TO 710
      IF (JRST .GT. N)  JRST=2
      IRST = 0
C     **********
C     PRODUCTION OF A VECTOR ORTHOGONAL TO THE LAST P-VECTOR
C     **********
      WORK = PN*(ABS(P(1))+PN)
      TEMP = P(JRST)
      P(1) = TEMP*(P(1)+SIGN(PN,P(1)))
      DO 260 I=2,N
  260 P(I) = TEMP*P(I)
      P(JRST) = P(JRST)-WORK
C     **********
C     COMPUTE NORM AND NORM-SQUARE OF THE P-VECTOR
C     **********
  270 PNLAST = PN
      PN=0.D0
      PN2 = 0.0D0
      DO 280 I=1,N
         PN=PN+ABS(P(I))
  280 PN2 = PN2+P(I)**2
      IF(PN.LT.1.D-20) THEN
         WRITE(6,'('' SYSTEM DOES NOT APPEAR TO BE OPTIMIZABLE.'',/
     1,'' THIS CAN HAPPEN IF (A) IT WAS OPTIMIZED TO BEGIN WITH'',/
     2,'' OR                 (B) IT IS NEITHER A GROUND NOR A'',
     3'' TRANSITION STATE'')')
         CALL GEOUT
         CALL WRAPUP()
      ENDIF
      IF(PN2.LT.1.D-20)PN2=1.D-20
      PN = SQRT(PN2)
      IF(ALF.GT.1.D20)ALF=1.D20
      IF(ICYC .GT. 1) THEN
         ALF=ALF*1.D-20*PNLAST/PN
         IF(ALF.GT.1.D10)        ALF=1.D10
         ALF=ALF*1.D20
      ENDIF
      TTMP=ALF*PN
      IF(TTMP.LT.0.0001D0) ALF=0.001D0/PN
C     **********
C     PRINTING SECTION
C     **********
C#      WRITE(6,501)TLEFT,ICYC,SSQ
      DO 290 I=1,N
         EFS(I)=X(I)
  290 CONTINUE
C     **********
C     PERFORM LINE-MINIMIZATION FROM POINT X IN DIRECTION P OR -P
C     **********
      SSQLST = SSQ
      DO 300 I=1,N
         EFS(I)=0.D0
  300 XLAST(I)=X(I)
      CALL LOCMIN(M,X,N,P,SSQ,ALF,EFS,IERR,ESCF)
      IF(SSQLST .LT. SSQ ) THEN
         IF(IERR .EQ. 0)      SSQ=SSQLST
         DO 310 I=1,N
  310    X(I)=XLAST(I)
         IRST=NRST
         PN=PNLAST
         TIME2=TIME1
         TIME1=ZECOND()
         TCYCLE=TIME1-TIME2
         TLEFT=TLEFT-TCYCLE
         IF(TLEFT .GT. TCYCLE*2) GO TO 100
         GOTO 670
      ENDIF
      IREPET=0
C     **********
C     PRODUCE THE VECTOR   R*P
C     **********
      DO 330 I=1,N
         TEMP = 0.0D0
         DO 320 J=I,N
  320    TEMP = TEMP+R(I,J)*P(J)
  330 Y(I) = TEMP
C     **********
C     PRODUCE THE VECTOR ...
C                  Y  =    (EFS-EFSLST-ALF*Q*R*P)/(ALF*(NORMSQUARE(P))
C     COMPUTE NORM OF THIS VECTOR AS WELL
C     **********
      WORK = ALF*PN2
      YN = 0.0D0
      DO 350 I=1,M
         TEMP = 0.0D0
         DO 340 J=1,N
  340    TEMP = TEMP+Q(I,J)*Y(J)
         TEMP = (EFS(I)-EFSLST(I)-ALF*TEMP)
         EFSLST(I) = EFS(I)
         YN = YN+TEMP**2
  350 EFS(I) = TEMP/WORK
      YN = SQRT(YN)/WORK
C     **********
C     THE BROYDEN UPDATE   NEW MATRIX = OLD MATRIX + Y*(P-TRANS)
C     HAS BEEN FORMED.  IT IS NOW NECESSARY TO UPDATE THE  QR DECOMP.
C     FIRST LET    Y = (Q-TRANS)*Y.
C     **********
      DO 370 I=1,M
         TEMP = 0.0D0
         DO 360 J=1,M
  360    TEMP = TEMP+Q(J,I)*EFS(J)
  370 Y(I) = TEMP
C     **********
C     REDUCE THE VECTOR Y TO A MULTIPLE OF THE FIRST UNIT VECTOR USING
C     A HOUSEHOLDER TRANSFORMATION FOR COMPONENTS N+1 THROUGH M AND
C     ELEMENTARY ROTATIONS FOR THE FIRST N+1 COMPONENTS.  APPLY ALL
C     TRANSFORMATIONS TRANSPOSED ON THE RIGHT TO THE MATRIX Q, AND
C     APPLY THE ROTATIONS ON THE LEFT TO THE MATRIX R.
C     THIS GIVES    (Q*(V-TRANS))*((V*R) + (V*Y)*(P-TRANS)),    WHERE
C     V IS THE COMPOSITE OF THE TRANSFORMATIONS.  THE MATRIX
C     ((V*R) + (V*Y)*(P-TRANS))    IS UPPER HESSENBERG.
C     **********
      IF (M .LE. NP1)  GO TO 430
C
C THE NEXT THREE LINES WERE INSERTED TO TRY TO GET ROUND OVERFLOW BUGS.
C
      CONST=1.D-12
      DO 380 I=NP1,M
  380 CONST=MAX(ABS(Y(NP1)),CONST)
      YTAIL = 0.0D0
      DO 390 I=NP1,M
  390 YTAIL = YTAIL+(Y(I)/CONST)**2
      YTAIL = SQRT(YTAIL)*CONST
      BET = (1.0D25/YTAIL)/(YTAIL+ABS(Y(NP1)))
      Y(NP1) = SIGN (YTAIL+ABS(Y(NP1)),Y(NP1))
      DO 420 I=1,M
         TMP = 0.0D0
         DO 400 J=NP1,M
  400    TMP = TMP+Q(I,J)*Y(J)*1.D-25
         TMP = BET*TMP
         DO 410 J=NP1,M
  410    Q(I,J) = Q(I,J)-TMP*Y(J)
  420 CONTINUE
      Y(NP1) = YTAIL
      I = NP1
      GO TO 440
  430 CONTINUE
      I = M
  440 CONTINUE
  450 J = I
      I = I-1
      IF (I)  520,520,460
  460 IF (Y(J))  470,450,470
  470 IF (ABS(Y(I)) .LT. ABS(Y(J)))  GO TO 480
      TEMP = ABS(Y(I))*SQRT(1.0D0+(Y(J)/Y(I))**2)
      GO TO 490
  480 TEMP = ABS(Y(J))*SQRT(1.0D0+(Y(I)/Y(J))**2)
  490 COS = Y(I)/TEMP
      SIN = Y(J)/TEMP
      Y(I) = TEMP
      DO 500 K=1,M
         TEMP = COS*Q(K,I)+SIN*Q(K,J)
         WORK = -SIN*Q(K,I)+COS*Q(K,J)
         Q(K,I) = TEMP
  500 Q(K,J) = WORK
      IF (I .GT. N)  GO TO 450
      R(J,I) = -SIN*R(I,I)
      R(I,I) = COS*R(I,I)
      IF (J .GT. N)  GO TO 450
      DO 510 K=J,N
         TEMP = COS*R(I,K)+SIN*R(J,K)
         WORK = -SIN*R(I,K)+COS*R(J,K)
         R(I,K) = TEMP
  510 R(J,K) = WORK
      GO TO 450
  520 CONTINUE
C     **********
C     REDUCE THE UPPER-HESSENBERG MATRIX TO UPPER-TRIANGULAR FORM
C     USING ELEMENTARY ROTATIONS.  APPLY THE SAME ROTATIONS, TRANSPOSED,
C     ON THE RIGHT TO THE MATRIX  Q.
C     **********
      DO 530 K=1,N
  530 R(1,K) = R(1,K)+YN*P(K)
      JEND = NP1
      IF (M .EQ. N)  JEND=N
      DO 600 J=2,JEND
         I = J-1
         IF (R(J,I))  540,600,540
  540    IF (ABS(R(I,I)) .LT. ABS(R(J,I)))  GO TO 550
         TEMP = ABS(R(I,I))*SQRT(1.0D0+(R(J,I)/R(I,I))**2)
         GO TO 560
  550    TEMP = ABS(R(J,I))*SQRT(1.0D0+(R(I,I)/R(J,I))**2)
  560    COS = R(I,I)/TEMP
         SIN = R(J,I)/TEMP
         R(I,I) = TEMP
         IF (J .GT. N)  GO TO 580
         DO 570 K=J,N
            TEMP = COS*R(I,K)+SIN*R(J,K)
            WORK = -SIN*R(I,K)+COS*R(J,K)
            R(I,K) = TEMP
  570    R(J,K) = WORK
  580    DO 590 K=1,M
            TEMP = COS*Q(K,I)+SIN*Q(K,J)
            WORK = -SIN*Q(K,I)+COS*Q(K,J)
            Q(K,I) = TEMP
  590    Q(K,J) = WORK
  600 CONTINUE
C     **********
C     CHECK THE STOPPING CRITERIA
C     **********
      TEMP = 0.0D0
      DO 610 I=1,N
  610 TEMP = TEMP+X(I)**2
      TOLX = TOLS1*SQRT(TEMP)+TOLS2
      IF (SQRT(ALF*PN2) .LE. TOLX)  GO TO 690
      IF(SSQ.GE.2.D0*N) GO TO 630
      DO 620 I=1,N
C*****
C     The stopping criterion is that no individual gradient be
C         greater than TOL2
C*****
         IF(ABS(EFSLST(I)).GE.TOL2) GO TO 630
  620 CONTINUE
C#      WRITE(6,730) SSQ
      GO TO 700
  630 CONTINUE
      IF (ICYC .GE. MXCYCL)  THEN
         IFLEPO=12
         GOTO 920
      ENDIF
      TIME2=TIME1
      TIME1=ZECOND()
      TCYCLE=TIME1-TIME2
      TLEFT=TLEFT-TCYCLE
      IF(RESFIL)THEN
         WRITE(6,640)TLEFT,SQRT(SSQ),ESCF
  640    FORMAT('  RESTART FILE WRITTEN,  TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G14.7)
         RESFIL=.FALSE.
      ELSE
         WRITE(6,650)ICYC,TCYCLE,TLEFT,SQRT(SSQ),ESCF
  650    FORMAT(' CYCLE:',I5,' TIME:',F6.1,' TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G14.7)
      ENDIF
      IF(TLAST-TLEFT.GT.TDUMP)THEN
         TLAST=TLEFT
         RESFIL=.TRUE.
         DO 660 I=1,N
  660    XLAST(I)=X(I)
         IIIUM(1)=NSCF
         CALL PARSAV(2,N,M)
      ENDIF
      IF(TLEFT .GT. TCYCLE*2) GO TO 100
  670 IIIUM(5)=NCOUNT
      DO 680 I=1,N
  680 XLAST(I)=X(I)
      IIIUM(1)=NSCF
      CALL PARSAV(1,N,M)
      CALL WRAPUP()
  690 WRITE (6,810)  NCOUNT
      GOTO 920
  700 WRITE (6,820)  NCOUNT
      GOTO 920
  710 CONTINUE
      WRITE(6,720) IXSO
  720 FORMAT(1H ,5X,'ATTEMPT TO GO DOWNHILL IS UNSUCCESSFUL AFTER',I5,5X
     1,'ORTHOGONAL SEARCHES')
      GOTO 920
C#  730 FORMAT(1H ,'FINAL GRADIENT =',F15.7)
  740 FORMAT(1H ,3X,'ALF =',E12.4)
  750 FORMAT(1H ,3X,'NCOUNT =',I5)
  760 FORMAT(3X,'TIME LEFT:',F7.1,' CYCLE',I5,3X,'GNORM SQUARED IS'
     1,F13.5)
  770 FORMAT(4(5X,'X(',I2,') = ',E15.8))
  780 FORMAT(4(5X,'P(',I2,') = ',E15.8))
  790 FORMAT(5X,'R-MATRIX DIAGONAL ENTRIES ...')
  800 FORMAT(6E13.3)
  810 FORMAT('0TEST ON X SATISFIED, NUMBER OF FUNCTION CALLS = ',I5)
  820 FORMAT('0TEST ON SSQ SATISFIED, NUMBER OF FUNCTION CALLS = ',I5)
  830 FORMAT(' ///// NEXT CYCLE IS A SIDE-STEP ALONG THE ',I2,
     1  '-TH NORMAL TO P')
  840 FORMAT('0ALLOWED NUMBER OF FUNCTION CALLS EXCEEDED.'/
     1  ' NUMBER OF FUNCTION CALLS WAS ',I5)
  850 FORMAT('  L.-M. PARAMETER = ',E15.7,
     1  '   SUMSQUARES CHANGE = ',E15.7)
  860 FORMAT(1H )
  870 FORMAT(1H )
  880 FORMAT(1H ,3X,'I',7X,I2,9(10X,I2))
  890 FORMAT(1H ,1X,'X(I)',1X,F10.5,2X,9(F10.5,2X))
  900 FORMAT(1H ,1X,'G(I)',1X,F10.5,2X,9(F10.5,2X))
  910 FORMAT(1H ,1X,'P(I)',1X,F10.5,2X,9(F10.5,2X))
  920 LAST=1
      CALL COMPFG(X,.TRUE.,ESCF,.TRUE.,EFSLST,.TRUE.)
      RETURN
      END

      SUBROUTINE PARAM(NW1,NSTEP,NEQUIL,IPRINT,ISCALE,
     $                EQTEMP,DENS,RCUT,DT)

      WRITE(NW1,*)'     NUMBER OF STEPS           ',NSTEP
      WRITE(NW1,*)'     NUMBER OF EQUIL STEPS     ',NEQUIL
      WRITE(NW1,*)'     OUTPUT FREQUENCY          ',IPRINT
      WRITE(NW1,*)'     GLOBAL RESCALE FREQUENCY  ',ISCALE
      WRITE(NW1,*)'     TEMPERATURE               ',EQTEMP
      WRITE(NW1,*)'     DENSITY                   ',DENS
      WRITE(NW1,*)'     POTENTIAL CUTOFF          ',RCUT
      WRITE(NW1,*)'     TIMESTEP                  ',DT

      END

      SUBROUTINE GETGEO(IREAD,LABELS,GEO,LOPT,NA,NB,NC,AMS,NATOMS,INT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION GEO(3,*),NA(*),NB(*),NC(*),AMS(*), LOPT(3,*)
     1,LABELS(*)
      LOGICAL INT
************************************************************************
*
*   GETGEO READS IN THE GEOMETRY. THE ELEMENT IS SPECIFIED BY IT'S
*          CHEMICAL SYMBOL, OR, OPTIONALLY, BY IT'S ATOMIC NUMBER.
*
*  ON INPUT   IREAD  = CHANNEL NUMBER FOR READ, NORMALLY 5
*             AMS    = DEFAULT ATOMIC MASSES.
*
* ON OUTPUT LABELS = ATOMIC NUMBERS OF ALL ATOMS, INCLUDING DUMMIES.
*           GEO    = INTERNAL COORDINATES, IN ANGSTROMS, AND DEGREES.
*           LOPT   = INTEGER ARRAY, A '1' MEANS OPTIMIZE THIS PARAMETER,
*                    '0' MEANS DO NOT OPTIMIZE, AND A '-1' LABELS THE
*                    REACTION COORDINATE.
*           NA     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
*           NB     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
*           NC     = INTEGER ARRAY OF ATOMS (SEE DATA INPUT)
*           ATMASS = ATOMIC MASSES OF ATOMS.
************************************************************************
      COMMON /PATH  / DUMMY,REACT(3,66), DUMM1,DUMM2
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /KEYWRD/ KEYWRD
      DIMENSION ISTART(40), XYZ(3,NUMATM), VALUE(4)
      LOGICAL LEADSP, IRCDRC
      CHARACTER*80 KEYWRD
      CHARACTER ELEMNT(107)*2, LINE*80, SPACE*1, NINE*1,ZERO*1,
     1TAB*1, COMMA*1, STRING*80, ELE*2, TURN*1
      DATA (ELEMNT(I),I=1,107)/'H','HE',
     1 'LI','BE','B','C','N','O','F','NE',
     2 'NA','MG','AL','SI','P','S','CL','AR',
     3 'K','CA','SC','TI','V','CR','MN','FE','CO','NI','CU',
     4 'ZN','GA','GE','AS','SE','BR','KR',
     5 'RB','SR','Y','ZR','NB','MO','TC','RU','RH','PD','AG',
     6 'CD','IN','SN','SB','TE','I','XE',
     7 'CS','BA','LA','CE','PR','ND','PM','SM','EU','GD','TB','DY',
     8 'HO','ER','TM','YB','LU','HF','TA','W','RE','OS','IR','PT',
     9 'AU','HG','TL','PB','BI','PO','AT','RN',
     1 'FR','RA','AC','TH','PA','U','NP','PU','AM','CM','BK','CF','XX',
     2 'FM','MD','CB','++','+','--','-','TV'/
      DATA COMMA,SPACE,NINE,ZERO/',',' ','9','0'/
      TAB=CHAR(9)
      IRCDRC=(INDEX(KEYWRD,'IRC')+INDEX(KEYWRD,'DRC') .NE.0)
      ILOWA = ICHAR('a')
      ILOWZ = ICHAR('z')
      ICAPA = ICHAR('A')
      NATOMS=0
      NUMAT=0
   10 READ(IREAD,'(A)',END=90,ERR=180)LINE
      IF(LINE.EQ.' ') GO TO 90
      NATOMS=NATOMS+1
      IF(NATOMS.GT.NUMATM)THEN
         WRITE(6,'(//10X,''****  MAX. NUMBER OF ATOMS ALLOWED:'',I4)')
     1NUMATM
         CALL WRAPUP()
      ENDIF
*   CLEAN THE INPUT DATA
************************************************************************
      DO 20 I=1,80
         ILINE=ICHAR(LINE(I:I))
         IF(ILINE.GE.ILOWA.AND.ILINE.LE.ILOWZ) THEN
            LINE(I:I)=CHAR(ILINE+ICAPA-ILOWA)
         ENDIF
   20 CONTINUE
************************************************************************
      ICOMMA=ICHAR(COMMA)
      ITAB=ICHAR(TAB)
      DO 30 I=1,80
      KHAR=ICHAR(LINE(I:I))
      IF(KHAR.EQ.ICOMMA.OR.KHAR.EQ.ITAB)LINE(I:I)=SPACE
  30  CONTINUE
*
*   INITIALIZE ISTART TO INTERPRET BLANKS AS ZERO'S
      DO 40 I=1,10
   40 ISTART(I)=80
* FIND INITIAL DIGIT OF ALL NUMBERS, CHECK FOR LEADING SPACES FOLLOWED
*     BY A CHARACTER AND STORE IN ISTART
      LEADSP=.TRUE.
      NVALUE=0
      DO 50 I=1,80
         IF (LEADSP.AND.LINE(I:I).NE.SPACE) THEN
            NVALUE=NVALUE+1
            ISTART(NVALUE)=I
         END IF
         LEADSP=(LINE(I:I).EQ.SPACE)
   50 CONTINUE
*
* ESTABLISH THE ELEMENT'S NAME AND ISOTOPE, CHECK FOR ERRORS OR E.O.DATA
*
      WEIGHT=0.D0
      STRING=LINE(ISTART(1):ISTART(2)-1)
      IF( STRING(1:1) .GE. ZERO .AND. STRING(1:1) .LE. NINE) THEN
*  ATOMIC NUMBER USED: NO ISOTOPE ALLOWED
         LABEL=READA(STRING,1)
         IF (LABEL.EQ.0) GO TO 80
         IF (LABEL.LT.0.OR.LABEL.GT.107) THEN
            WRITE(6,'(''  ILLEGAL ATOMIC NUMBER'')')
            GO TO 190
         END IF
         GO TO 70
      END IF
*  ATOMIC SYMBOL USED
      REAL=ABS(READA(STRING,1))
      IF (REAL.LT.1.D-15) THEN
*   NO ISOTOPE
         ELE=STRING(1:2)
      ELSE
         WEIGHT=REAL
         IF( STRING(2:2) .GE. ZERO .AND. STRING(2:2) .LE. NINE) THEN
            ELE=STRING(1:1)
         ELSE
            ELE=STRING(1:2)
         END IF
      END IF
*   CHECK FOR ERROR IN ATOMIC SYMBOL
      IF(ELE(1:1).EQ.'-'.AND.ELE(2:2).NE.'-')ELE(2:2)=' '
      DO 60 I=1,107
         IF(ELE.EQ.ELEMNT(I)) THEN
            LABEL=I
            GO TO 70
         END IF
   60 CONTINUE
      WRITE(6,'(''  UNRECOGNIZED ELEMENT NAME: ('',A,'')'')')ELE
      GOTO 190
*
* ALL O.K.
*
   70 IF (LABEL.NE.99) NUMAT=NUMAT+1
      IF(WEIGHT.NE.0.D0)THEN
         WRITE(6,'('' FOR ATOM'',I4,''  ISOTOPIC MASS:''
     1    ,F15.5)')NATOMS, WEIGHT
         ATMASS(NUMAT)=WEIGHT
      ELSE
         IF(LABEL .NE. 99)  ATMASS(NUMAT)=AMS(LABEL)
      ENDIF
      LABELS(NATOMS)   =LABEL
      GEO(1,NATOMS)    =READA(LINE,ISTART(2))
      GEO(2,NATOMS)    =READA(LINE,ISTART(4))
      GEO(3,NATOMS)    =READA(LINE,ISTART(6))
      IF(IRCDRC)THEN
         TURN=LINE(ISTART(3):ISTART(3))
         IF(TURN.EQ.'T')THEN
            LOPT(1,NATOMS)=1
            IF(NATOMS.EQ.1)WRITE(6,'(A)')' IN DRC MONITOR POTENTIAL ENER
     1GY'//' TURNING POINTS'
         ELSE
            LOPT(1,NATOMS)=0
         ENDIF
         TURN=LINE(ISTART(5):ISTART(5))
         IF(TURN.EQ.'T')THEN
            LOPT(2,NATOMS)=1
         ELSE
            LOPT(2,NATOMS)=0
         ENDIF
         TURN=LINE(ISTART(7):ISTART(7))
         IF(TURN.EQ.'T')THEN
            LOPT(3,NATOMS)=1
         ELSE
            LOPT(3,NATOMS)=0
         ENDIF
      ELSE
         LOPT(1,NATOMS)   =READA(LINE,ISTART(3))
         LOPT(2,NATOMS)   =READA(LINE,ISTART(5))
         LOPT(3,NATOMS)   =READA(LINE,ISTART(7))
      ENDIF
      NA(NATOMS)       =READA(LINE,ISTART(8))
      NB(NATOMS)       =READA(LINE,ISTART(9))
      NC(NATOMS)       =READA(LINE,ISTART(10))
      GOTO 10
*
* ALL DATA READ IN, CLEAN UP AND RETURN
*
   80 NATOMS=NATOMS-1
   90 NA(2)=1
      IF(NATOMS.GT.3)THEN
         INT=(NA(4).NE.0)
      ELSE
         IF(GEO(2,3).LT.10.AND.NATOMS.EQ.3)
     1WRITE(6,'(//10X,'' WARNING: INTERNAL COORDINATES ARE ASSUMED -'',/
     210X,'' FOR THREE-ATOM SYSTEMS '',//)')
         INT=.TRUE.
      ENDIF
C
C     READ IN VELOCITY VECTOR, IF PRESENT
C
      IF(INDEX(KEYWRD,'VELO').GT.0)THEN
         IF(INT)THEN
            WRITE(6,'(A)')' COORDINATES MUST BE CARTESIAN WHEN VELOCITY
     1VECTOR IS USED.'
            CALL WRAPUP()
         ENDIF
C#      WRITE(6,'(/10X,A)')'INITIAL VELOCITY VECTOR FOR DRC'
         DO 110 I=1,NATOMS
            READ(5,'(A)') LINE
            CALL NUCHAR(LINE,VALUE,NDMY)
            IF(NDMY.NE.3)THEN
               WRITE(6,'(/10X,A)')
     1'  THERE MUST BE EXACTLY THREE VELOCITY DATA PER LINE'
               CALL WRAPUP()
            ENDIF
            DO 100 J=1,3
  100       REACT(J,I+2)=VALUE(J)
C#      WRITE(6,'(2X,A2,2X,3F13.5)')ELEMNT(LABELS(I)),(VALUE(J),J=1,3)
  110    CONTINUE
         DO 120 I=1,3
            DO 120 J=1,2
  120    REACT(I,J)=GEO(I,J+1)-GEO(I,1)
C
C  NOW TO ROTATE VELOCITY VECTOR TO SUIT INTERNAL COORDINATE DEFINITION
C
C
C   ROTATE AROUND THE 1-2 X-AXIS TO AS TO ELIMINATE REACT(3,2)
C   (PUT ATOM 2 IN X-Y PLANE)
         SA=REACT(3,1)/SQRT(REACT(2,1)**2+REACT(3,1)**2+1.D-20)
         CA=SIGN(SQRT(1.D0-SA**2),REACT(2,1))
C#      LABELS(NATOMS+1)=1
C#      LABELS(NATOMS+2)=1
C#      WRITE(6,*)' FIRST ROTATION, ABOUT 1-2 X-AXIS'
         DO 130 I=1,NATOMS+2
            TEMP1= REACT(2,I)*CA+REACT(3,I)*SA
            TEMP2=-REACT(2,I)*SA+REACT(3,I)*CA
            REACT(2,I)=TEMP1
            REACT(3,I)=TEMP2
C#      WRITE(6,'(2X,A2,2X,3F13.5)')ELEMNT(LABELS(I)),(REACT(J,I),J=1,3)
  130    CONTINUE
C   ROTATE AROUND THE 1-2 Z-AXIS TO AS TO ELIMINATE REACT(2,2)
C   (PUT ATOM 2 ON X AXIS)
         CA=REACT(1,1)/SQRT(REACT(2,1)**2+REACT(1,1)**2+1.D-20)
         SA=SIGN(SQRT(1.D0-CA**2),REACT(2,1))
C#      WRITE(6,*)' SECOND ROTATION, ABOUT 1-2 Z-AXIS'
         DO 140 I=1,NATOMS+2
            TEMP1= REACT(1,I)*CA+REACT(2,I)*SA
            TEMP2=-REACT(1,I)*SA+REACT(2,I)*CA
            REACT(1,I)=TEMP1
            REACT(2,I)=TEMP2
C#      WRITE(6,'(2X,A2,2X,3F13.5)')ELEMNT(LABELS(I)),(REACT(J,I),J=1,3)
  140    CONTINUE
C   ROTATE AROUND THE 2-3 X-AXIS TO AS TO ELIMINATE REACT(3,3)
C   (PUT ATOM 3 ON X-Y PLANE)
         SA=REACT(3,2)/SQRT(REACT(2,2)**2+REACT(3,2)**2+1.D-20)
         CA=SIGN(SQRT(1.D0-SA**2),REACT(2,2))
C#      WRITE(6,*)' THIRD ROTATION, ABOUT 2-3 X-AXIS'
         DO 150 I=1,NATOMS+2
            TEMP1= REACT(2,I)*CA+REACT(3,I)*SA
            TEMP2=-REACT(2,I)*SA+REACT(3,I)*CA
            REACT(2,I)=TEMP1
            REACT(3,I)=TEMP2
C#      WRITE(6,'(2X,A2,2X,3F13.5)')ELEMNT(LABELS(I)),(REACT(J,I),J=1,3)
  150    CONTINUE
C
C  STRIP OFF FIRST TWO COORDINATES; THESE WERE THE COORDINATE AXIS
C  DEFINITIONS
C
         DO 160 I=1,NATOMS
            DO 160 J=1,3
  160    REACT(J,I)=REACT(J,I+2)
      ENDIF
      IF(  .NOT. INT ) THEN
         DO 170 I=1,NATOMS
            DO 170 J=1,3
  170    XYZ(J,I)=GEO(J,I)
         DEGREE=90.D0/ASIN(1.D0)
         CALL XYZINT(XYZ,NATOMS,NA,NB,NC,DEGREE,GEO)
         IF(ABS(GEO(2,3)-180.D0).LT.1.D-4.OR.ABS(GEO(2,3)).LT.1.D-4)
     1THEN
            WRITE(6,'(A)')' DUE TO PROGRAM BUG, THE FIRST THREE ATOMS MU
     1ST NOT LIE IN A STRAIGHT LINE.'
            CALL WRAPUP()
         ENDIF
      ELSEIF (.NOT.IRCDRC) THEN
         IF(LOPT(1,1)+LOPT(2,1)+LOPT(3,1)+LOPT(2,2)+LOPT(3,2)+
     1        LOPT(3,3) .GT. 0)THEN
            LOPT(1,1)=0
            LOPT(2,1)=0
            LOPT(3,1)=0
            LOPT(2,2)=0
            LOPT(3,2)=0
            LOPT(3,3)=0
            WRITE(6,
     +'(//10X,'' AN UNOPTIMIZABLE GEOMETRIC PARAMETER HAS'',
     1/10X,'' BEEN MARKED FOR OPTIMIZATION. THIS IS A NON-FATAL '',
     2''ERROR'')')
         ENDIF
      ENDIF
      IF(NA(3).EQ.0) THEN
         NB(3)=1
         NA(3)=2
      ENDIF
      RETURN
* ERROR CONDITIONS
  180 IF(IREAD.EQ.5) THEN
         WRITE(6,'( '' ERROR DURING READ AT ATOM NUMBER '', I3 )')NATOMS
      ELSE
         NATOMS=0
         RETURN
      ENDIF
  190 J=NATOMS-1
      WRITE(6,'('' DATA CURRENTLY READ IN ARE '')')
      DO 200 K=1,J
  200 WRITE(6,210)LABELS(K),(GEO(JJ,K),LOPT(JJ,K),JJ=1,3),
     1NA(K),NB(K),NC(K)
  210 FORMAT(I4,2X,3(F10.5,2X,I2,2X),3(I2,1X))
      CALL WRAPUP()
      END

        SUBROUTINE HTWD(IZ,SMM,SWW,IN,RKK,KDIM)

        INTEGER    KDIM,N

        PARAMETER  (N=10)

        REAL*8     SMX,RHE,RKK
        REAL*8     SMM(N),SWW(N)
        INTEGER    IZ(KDIM,KDIM),I1,I2,IN

        if (IN.gt.N) STOP 'HTWD: N'

        SMX=0.D0
        DO 119 I1=1,KDIM
        DO 119 I2=1,KDIM
        RHE=IZ(I1,I2)
        SMX=SMX+RHE
        SMM(IN)=SMM(IN)+RHE*RKK
        SWW(IN)=SWW(IN)+RHE**2*RKK
119     CONTINUE
        SMX=SMX*RKK
        SWW(IN)=SWW(IN)-SMX**2

        RETURN
        END       

C***********************************************************************
C FILE: FDIRTR.FOR
C
C HISTORY: 23/2/90: COPIED FROM FILE FDIR16.FOR
C                   TRICLINIC GEOMETRY
C          25/2/90: OFF-DIAGONAL ELEMENTS IN STRESS TENSOR
C           8/3/90: SIGN OF STRESS-CONTRIB. CHANGED
C          18/5/90: DIRDAT() FOR USE WITH CONJUGATE GRADIENT
C***********************************************************************
      SUBROUTINE FDIRTR(NGX,NGY,NGZ,NPLWV,RECC,VOLC,CVD,CHDEN,
     &     SIGHA,ENHAC,LPCTX,LPCTY,LPCTZ,DIRDAT)
C=======================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FDIRTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE HARTREE POTENTIAL FROM THE ELECTRONIC
C CHARGE DENSITY CALCULATED IN SUBROUTINE CHSP. THE CORRECTION TO THE
C TOTAL ENERGY DUE TO OVERCOUNTING THE HARTREE ENERGY ON SUMMING THE
C ELECTRONIC EIGENVALUES IS ALSO COMPUTED (HARTREE CONTRIBUTION TO THE
C TOTAL ENERGY = 0.5*SUM (VH(G)*RHO(-G)). THE SUM OF EIGENVALUES GIVES
C SUM (VH(G)*RHO(-G)) WHERE VH(G) IS THE HARTREE POTENTIAL AT WAVEVECTOR
C G AND RHO(G) IS THE CHARGE DENSITY AT WAVEVECTOR G)
C
C                                               G  G
C                   1        --   ! n(G) ! [     Ai Aj            ]
C     Sigma      = --- 4 PI  >    -------- [ 2 --------  - &      ]
C          Ai,Aj    2        --     G**2   [     G**2       Ai,Aj ]
C                           G,G<>0
C
C=======================================================================
      IMPLICIT COMPLEX (C)
      DIMENSION RECC(3,*)
      DIMENSION CVD(*)
      DIMENSION DIRDAT(*)
      DIMENSION CHDEN(*)
      DIMENSION SIGHA(*)
      DIMENSION LPCTX(*),LPCTY(*),LPCTZ(*)
C=======================================================================
C EDEPS = ELECTRON CHARGE DIVIDED BY THE PERMITTIVITY OF FREE SPACE
C=======================================================================
      DATA TPI,EDEPS / 6.28318530718,180.95283 /
      DO 8620 M=1,6
      SIGHA(M)=0.0
 8620 CONTINUE
      ENHAC=0.0
      SCALE=EDEPS/VOLC
C=======================================================================
C CALCULATE THE HARTREE POTENTIAL ON THE GRID OF RECIPROCAL LATTICE
C VECTORS, THE CORRECTION TO THE TOTAL ENERGY AND THE FORCE ON THE UNIT
C CELL
C=======================================================================
      NI=1
      DO 8630 N=1,NGZ
        GZX=RECC(3,1)*LPCTZ(N)
        GZY=RECC(3,2)*LPCTZ(N)
        GZZ=RECC(3,3)*LPCTZ(N)
        DO 8631 NN=1,NGY
          GYX=RECC(2,1)*LPCTY(NN)
          GYY=RECC(2,2)*LPCTY(NN)
          GYZ=RECC(2,3)*LPCTY(NN)
          DO 8632 NNN=1,NGX
            GXX=RECC(1,1)*LPCTX(NNN)
            GXY=RECC(1,2)*LPCTX(NNN)
            GXZ=RECC(1,3)*LPCTX(NNN)
            GISQ=(GXX+GYX+GZX)**2+(GXY+GYY+GZY)**2+(GXZ+GYZ+GZZ)**2
C=======================================================================
C SINCE THE G=0 COULOMB CONTRIBUTIONS TO THE HARTREE, EWALD AND
C ELECTRON-ION ENERGIES ARE INDIVIDUALLY DIVERGENT BUT TOGETHER SUM TO
C ZERO, SET THE HARTREE POTENTIAL AT G=0 TO ZERO.
C=======================================================================
            IF (GISQ.LT.0.001) THEN
              CVD(NI)=(0.0,0.0)
              DIRDAT(NI)=0.0
            ELSE
              GISQ=1.0/GISQ
              CVD(NI)=CHDEN(NI)*GISQ
              DIRDAT(NI)=SCALE*GISQ
              DUM=CHDEN(NI)*CONJG(CHDEN(NI))*GISQ
              ENHAC=ENHAC+DUM
              G1=GXX+GYX+GZX
              G2=GXY+GYY+GZY
              G3=GXZ+GYZ+GZZ
              SIGHA(1)=SIGHA(1)+DUM*(2*(G1**2)*GISQ-1)
              SIGHA(2)=SIGHA(2)+DUM*(2*(G2**2)*GISQ-1)
              SIGHA(3)=SIGHA(3)+DUM*(2*(G3**2)*GISQ-1)
              SIGHA(4)=SIGHA(4)+DUM*(2*(G2*G3)*GISQ)
              SIGHA(5)=SIGHA(5)+DUM*(2*(G3*G1)*GISQ)
              SIGHA(6)=SIGHA(6)+DUM*(2*(G1*G2)*GISQ)
            ENDIF
            NI=NI+1
 8632     CONTINUE
 8631   CONTINUE
 8630 CONTINUE
C=======================================================================
C SCALE THE HARTREE POTENTIAL BY EDEPS DIVIDED BY THE VOLUME OF THE UNIT
C CELL
C=======================================================================
      SCALE=EDEPS/VOLC
      DO 8640 N=1,NPLWV
        CVD(N)=CVD(N)*SCALE
 8640 CONTINUE
C=======================================================================
C SCALE FORCE ON THE UNIT CELL (INCLUDING THE FACTOR OF 1/2 FOR THE
C SELF-ENERGY FORM OF THE HARTREE ENERGY)
C=======================================================================
      SIGHA(1)=SIGHA(1)*SCALE/(VOLC*2)
      SIGHA(2)=SIGHA(2)*SCALE/(VOLC*2)
      SIGHA(3)=SIGHA(3)*SCALE/(VOLC*2)
      SIGHA(4)=SIGHA(4)*SCALE/(VOLC*2)
      SIGHA(5)=SIGHA(5)*SCALE/(VOLC*2)
      SIGHA(6)=SIGHA(6)*SCALE/(VOLC*2)
C=======================================================================
C SCALE THE CORRECTION TO THE TOTAL ENERGY WHICH IS REQUIRED TO TAKE
C ACCOUNT OF OVERCOUNTING THE HARTREE ENERGY IN THE ELECTRON ENERGIES
C=======================================================================
      ENHAC=-ENHAC*SCALE/2
      RETURN
      END

      SUBROUTINE THERMO(A,B,C,LINEAR,SYM,WT,VIBS,NVIBS,ESCF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION VIBS(*)
      LOGICAL LINEAR
      CHARACTER*80 KEYWRD, KOMENT, TITLE, TMPKEY*80
      COMMON /KEYWRD/ KEYWRD
      COMMON /TITLES/ KOMENT,TITLE
C
C
C   THERMO CALCULATES THE VARIOUS THERMODYNAMIC QUANTITIES FOR A
C   SPECIFIED TEMPERATURE GIVEN THE VIBRATIONAL FREQUENCIES, MOMENTS OF
C   INERTIA, MOLECULAR WEIGHT AND SYMMETRY NUMBER.
C
C   REFERENCE: G.HERZBERG MOLECULAR SPECTRA AND MOLECULAR STRUCTURE
C              VOL 2, CHAP. 5
C
C   ----    TABLE OF SYMMETRY NUMBERS    ----
C
C        C1 CI CS     1      D2 D2D D2H  4       C(INF)V   1
C        C2 C2V C2H   2      D3 D3D D3H  6       D(INF)H   2
C        C3 C3V C3H   3      D4 D4D D4H  8       T TD     12
C        C4 C4V C4H   4      D6 D6D D6H  12      OH       24
C        C6 C6V C6H   6      S6          3
C
C
C   PROGRAM LIMITATIONS:  THE EQUATIONS USED ARE APPROPRIATE TO THE
C   HIGH TEMPERATURE LIMIT AND WILL BEGIN TO BE INADEQUATE AT TEMPERA-
C   TURES BELOW ABOUT 100 K.  SECONDLY THIS PROGRAM IS ONLY APPROPRIATE
C   IN THE CASE OF MOLECULES IN WHICH THERE IS NO FREE ROTATION
C
C
C
C
*******************************************************************
*
*  THE FOLLOWING CONSTANTS ARE NOW DEFINED:
*          PI  = CIRCUMFERENCE TO DIAMETER OF A CIRCLE
*          R   = GAS CONSTANT IN CALORIES/MOLE
*          H   = PLANCK'S CONSTANT IN ERG-SECONDS
*          AK  = BOLTZMANN CONSTANT IN ERG/DEGREE
*          AC  = SPEED OF LIGHT IN CM/SEC
*******************************************************************
      DIMENSION TRANGE(300)
      DATA PI /3.14159D0 /
      DATA R/1.98726D0/
      DATA H/6.626D-27/
      DATA AK/1.3807D-16/
      DATA AC/2.99776D+10/
*******************************************************************
      IT1=200
      IT2=400
      ISTEP=10
      TMPKEY=KEYWRD
      I=INDEX(TMPKEY,'THERMO(')
      IF(I.NE.0) THEN
C
C   ERASE ALL TEXT FROM TMPKEY EXCEPT THERMO DATA
C
         TMPKEY(:I)=' '
         TMPKEY(INDEX(TMPKEY,')'):)=' '
         IT1=READA(TMPKEY,I)
         IF(IT1.LT.100) THEN
            WRITE(6,'(//10X,''TEMPERATURE RANGE STARTS TOO LOW,'',
     1'' LOWER BOUND IS RESET TO 30K'')')
            IT1=100
         ENDIF
         I=INDEX(TMPKEY,',')
         IF(I.NE.0) THEN
            TMPKEY(I:I)=' '
            IT2=READA(TMPKEY,I)
            IF(IT2.LT.IT1) THEN
               IT2=IT1+200
               ISTEP=10
               GOTO 10
            ENDIF
            I=INDEX(TMPKEY,',')
            IF(I.NE.0) THEN
               TMPKEY(I:I)=' '
               ISTEP=READA(TMPKEY,I)
               IF(ISTEP.LT.1)ISTEP=1
            ELSE
               ISTEP=(IT2-IT1)/20
               IF(ISTEP.EQ.0)ISTEP=1
               IF(ISTEP.GE.2.AND. ISTEP.LT.5)ISTEP=2
               IF(ISTEP.GE.5.AND. ISTEP.LT.10)ISTEP=5
               IF(ISTEP.GE.10.AND. ISTEP.LT.20)ISTEP=10
               IF(ISTEP.GT.20.AND. ISTEP.LT.50)ISTEP=20
               IF(ISTEP.GT.50.AND. ISTEP.LT.100)ISTEP=50
               IF(ISTEP.GT.100)ISTEP=100
            ENDIF
         ELSE
            IT2=IT1+200
         ENDIF
      ENDIF
   10 CONTINUE
      WRITE(6,'(//,A)')TITLE
      WRITE(6,'(A)')KOMENT
      IF(LINEAR) THEN
         WRITE(6,'(//10X,''MOLECULE IS LINEAR'')')
      ELSE
         WRITE(6,'(//10X,''MOLECULE IS NOT LINEAR'')')
      ENDIF
      WRITE(6,'(/10X,''THERE ARE'',I3,'' GENUINE VIBRATIONS IN THIS '',
     1''SYSTEM'')')NVIBS
      WRITE(6,20)
   20 FORMAT(10X,'THIS THERMODYNAMICS CALCULATION IS LIMITED TO',/
     110X,'MOLECULES WHICH HAVE NO INTERNAL ROTATIONS'//)
      WRITE(6,'(//20X,''CALCULATED THERMODYNAMIC PROPERTIES'')')
      WRITE(6,'(42X,''*'')')
      WRITE(6,'(''   TEMP. (K)   PARTITION FUNCTION   H.O.F.'',
     1''    ENTHALPY   HEAT CAPACITY  ENTROPY'')')
      WRITE(6,'(  ''                                    KCAL/MOL'',
     1''   CAL/MOLE    CAL/K/MOL   CAL/K/MOL'',/)')
      DO 30 I=1,NVIBS
   30 VIBS(I)=ABS(VIBS(I))
      ILIM=1
      DO 40 ITEMP=IT1,IT2,ISTEP
         ILIM=ILIM+1
   40 TRANGE(ILIM)=ITEMP
      TRANGE(1)=298.D0
      DO 80 IR=1,ILIM
         ITEMP=TRANGE(IR)
         T=ITEMP
C   ***   INITIALISE SOME VARIABLES   ***
         C1=H*AC/AK/T
         QV=1.0D0
         HV=0.0D0
         E0=0.0D0
         CPV=0.0D0
         SV1=0.0D0
         SV2=0.0D0
C   ***   CONSTRUCT THE FREQUENCY DEPENDENT PARTS OF PARTITION FUNCTION
         DO 50 I=1,NVIBS
            WI=VIBS(I)
            EWJ=EXP(-WI*C1)
            QV=QV/(1-EWJ)
            HV=HV+WI*EWJ/(1-EWJ)
            E0=E0+WI
            CPV=CPV+WI*WI*EWJ/(1-EWJ)/(1-EWJ)
            SV1=SV1+LOG(1.0D0-EWJ)
   50    SV2=SV2+WI*EWJ/(1-EWJ)
C   ***   FINISH CALCULATION OF VIBRATIONAL PARTS   ***
         HV=HV*R*H*AC/AK
         E0=E0*1.4295D0
         CPV=CPV*R*C1*C1
         SV=SV2*R*C1-R*SV1
C   ***   NOW CALCULATE THE ROTATIONAL PARTS  (FIRST LINEAR MOLECULES
         IF(.NOT.LINEAR) GOTO 60
         QR=1/(C1*A*SYM)
         HR=R*T
         CPR=R
         SR=R*(LOG(T*AK/(H*AC*A*SYM)))+R
         GOTO 70
   60    QR=SQRT(PI/(A*B*C*C1*C1*C1))/SYM
         HR=3.0D0*R*T/2.0D0
         CPR=3.0D0*R/2.0D0
         SR=0.5D0*R*(3.D0*LOG(T*AK/(H*AC))
     1-2.D0*LOG(SYM)+LOG(PI/(A*B*C))+3.D0)
   70    CONTINUE
C   ***   CALCULATE INTERNAL CONTRIBUTIONS   ***
         QINT=QV*QR
         HINT=HV+HR
         CPINT=CPV+CPR
         SINT=SV+SR
C   ***   CONSTRUCT TRANSLATION CONTRIBUTIONS   ***
         QTR=(SQRT(2.D0*PI*WT*T*AK*1.6606D-24)/H)**3
         HTR=5.0D0*R*T/2.0D0
         CPTR=5.0D0*R/2.0D0
         STR=2.2868D0*(5.0D0*LOG10(T)+3.0D0*LOG10(WT))-2.3135D0
C   ***   CONSTRUCT TOTALS   ***
         CPTOT=CPTR+CPINT
         STOT=STR+SINT
         HTOT=HTR+HINT
C   ***   OUTPUT SECTION   ***
         IF(IR.EQ.1)THEN
            H298=HTOT
         ELSE
            WRITE(6,'(/,I7,''  VIB.'',G18.4
     1           ,13X,3F11.5        )')ITEMP,QV,  HV,  CPV,  SV
            WRITE(6,'(7X,''  ROT.'',G13.3
     1           ,16X,3F11.3        )')      QR,  HR,  CPR,  SR
            WRITE(6,'(7X,''  INT.'',G13.3
     1           ,16X,3F11.3        )')      QINT,HINT,CPINT,SINT
            WRITE(6,'(7X,''  TRA.'',G13.3
     1           ,16X,3F11.3)')
     2                                      QTR, HTR, CPTR, STR
            WRITE(6,'(7X,''  TOT.'',13X,F17.3,F11.4,2F11.4)')
     1                     ESCF+(HTOT-H298)/1000.D0,HTOT,CPTOT,STOT
         ENDIF
   80 CONTINUE
      WRITE(6,'(/3X,'' * NOTE: HEATS OF FORMATION ARE RELATIVE TO THE'',
     1/12X,'' ELEMENTS IN THEIR STANDARD STATE AT 298K'')')
      END

      SUBROUTINE MOLVAL(C,NDUMMY,P,NOCC,RHFUHF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION C(NORBS,NORBS), P(*)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      DIMENSION VAL(MAXORB)
      DO 40 I=1,NOCC
         SUM=0.D0
         DO 30 JJ=1,NUMAT
            JL=NFIRST(JJ)
            JU=NLAST(JJ)
            DO 30 J=JL,JU
               DO 30 KK=1,NUMAT
                  IF(KK.EQ.JJ) GOTO 20
                  KL=NFIRST(KK)
                  KU=NLAST(KK)
                  DO 10 K=KL,KU
                     L1=MAX(J,K)
                     L2=J+K-L1
                     L=(L1*(L1-1))/2+L2
                     SUM=SUM+C(J,I)*C(K,I)*P(L)
   10             CONTINUE
   20             CONTINUE
   30    CONTINUE
         VAL(I)=SUM*RHFUHF
   40 CONTINUE
      WRITE(6,'(10F8.4)')(VAL(I),I=1,NOCC)
      END

C***********************************************************************
      SUBROUTINE WFTRI(NGX,NGY,NGZ,NBANDS,NKPTS,NPLWV,
     &                 MPLWV,NRPLWV,NINDPW,NPLWKP,
     &                 WTKPT,CV,CPTWFP,CPTWFL,VOLC,CELEN,NGPTAR,DATAKE,
     &                 CPTOWR,CPTNWR,CWORK,NUNIT,NBANOC, CGRA,
     &                 CORGR,CDIR,COGRPI,CDIRPI,PRECON,
     &                 CHDENR,NPKPT,CDUM,NSPEC,
     &                 NIONS,NIONSP,PSCALE,
     &                 DNLKG,CPHSGR,VGNL,CELFRC,
     &                 CWRK20,CWRK21,CWRK22,CWRK23,VNL,IVPTYP,OCC,
     &                 ENGRSI,ALPHA,CVTRUE,IVPTYN,NLPOT,NRGRPT,NRLPPI,      
     &                 CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,
     &                 NADGRD,MXRLSH,CESAVE)       
C=======================================================================
      IMPLICIT COMPLEX (C)
      DIMENSION NINDPW(*)
      DIMENSION CV(*)
      DIMENSION CPTWFP(*)
      DIMENSION CPTWFL(*)
      DIMENSION CELEN(*)
      DIMENSION NGPTAR(*)
      DIMENSION DATAKE(*)
      DIMENSION CHDENR(*)
      DIMENSION WTKPT(*)
      DIMENSION NIONSP(*)
      DIMENSION OCC(NBANDS,NKPTS)
C=======================================================================
C
C                      DIMENSION STATEMENTS
C
C CWORK(MPLWV) = A WORK ARRAY USED IN THE FOURIER TRANSFORM
C
C SIGKE(6,NKPTS) = THE FORCE ON THE UNIT CELL DUE TO THE CHANGE IN THE
C          KINETIC ENERGY ON CHANGING THE SIZE OF THE CELL FOR EACH
C          K POINT
C
C=======================================================================
      DIMENSION CPTOWR(*)
      DIMENSION CPTNWR(*)
      DIMENSION CWORK(*)
      DIMENSION PRECON(*)
      DIMENSION CGRA(*),CORGR(*),CDIR(*),COGRPI(*),CDIRPI(*)
      DIMENSION CDUM (*)
      DIMENSION CPHSGR(NRPLWV,NIONS,NSPEC),VGNL(NRPLWV,0:2,NSPEC)
      DIMENSION DNLKG(NRPLWV,0:3,NKPTS)
      DIMENSION PSCALE(0:2,NSPEC)
      DIMENSION VNL(NBANDS,NKPTS),CELFRC(NRPLWV)
      DIMENSION CWRK20(NIONS),CWRK21(3,NIONS)
      DIMENSION CWRK22(NIONS),CWRK23(3,3,NIONS)
      DIMENSION CVTRUE(*)
      DIMENSION IVPTYN(*)
      DIMENSION  IRLNL(MXRLNL,NSPEC),PRLSCA(MXRLNL,NSPEC)
      DIMENSION  NRLNL(NSPEC),VRLGRD(NRGRPT,MXRLSH,NIONST)
      DIMENSION  NADGRD(NRGRPT,NIONST),CPHGRD(NRGRPT,NIONST)
      DIMENSION CESAVE(NIONST,20),NRLPPI(NIONST)
C=======================================================================
C     DIMENSION FOR SUBROUTINE ROTATION (WENG, 27-FEB-90)
C=======================================================================
C
      RINPLW = 1.0 / NPLWV
C=======================================================================
C START CONJUGATE GRADIENTS LOOP
C=======================================================================
      DO 2001 NN = 1 , NBANDS
        NINDW = NRPLWV * ( NN - 1 )
C=======================================================================
C CALCULATE THE PRODUCT OF THE POTENTIAL AND THE WAVEFUNCTION IN REAL
C SPACE AND FOURIER TRANSFORM TO RECIPROCAL SPACE
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
        DO 5561 M = 1 , MPLWV
          CPTOWR(M) = (0.0,0.0)
          CPTNWR(M) = (0.0,0.0)
          CWORK(M) = (0.0,0.0)
 5561   CONTINUE
        DO 5562 M = 1 , NRPLWV
          CELFRC(M) = (0.0,0.0)
 5562   CONTINUE
        DO 5510 M = 1 , NPLWKP
          CPTOWR(NINDPW(M)) = CPTWFP(M+NINDW)
 5510   CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
        CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)
        IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN                      
C=====================================================================
C CALL THE ROUTINE THAT CALCULATES THE PRODUCT OF THE NON-LOCAL       
C POTENTIAL AND THE WAVEFUNCTION IN REAL SPACE                        
C THIS PRODUCT IS SAVED IN CWORK AND TRANSFORMED INTO RECIPROCAL SPACE
C TO BE FURTHER SENT INTO CELFRC ARRAY - AS FOR RECIPROCAL SPACE
C VERSION OF NONLOCAL POTENTIALS.
C=====================================================================
          CALL VSINL(VOLC,NGX,NGY,NGZ,MPLWV,NRPLWV,    
     &   NRGRPT,NIONSP,NRLPPI,NSPEC,CWORK,CPTOWR,CPTNWR, 
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &   CESAVE)                                                      
          DO 2002 NNN=1,NPLWV           
             CPTNWR(NNN) = CPTNWR(NNN) * RINPLW                            
 2002     CONTINUE                                                  
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
          DO 5511 M = 1 , NPLWKP               
            CELFRC(M) = CPTNWR(NINDPW(M))
 5511     CONTINUE                             
        END IF                                     
        DO 2005 NNN=1,NPLWV                      
          CPTNWR(NNN)=CVTRUE(NNN)*CPTOWR(NNN)*RINPLW 
 2005   CONTINUE                                 
C=======================================================================
C TRANSFORM THE WAVEFUNCTION*POTENTIAL INTO RECIPROCAL SPACE
C=======================================================================
        CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C=======================================================================
C CALCULATE HAMILTONIAN TIMES PSI - STORED IN CPTWFL
C=======================================================================
        DO 2003 M = 1 , NPLWKP
          CPTWFL(M) = CPTWFP(M+NINDW) * DATAKE(1+(7*(M-1))) +
     &               CPTNWR(NINDPW(M))
 2003   CONTINUE
C=======================================================================
C  FOR NON-LOCAL PSEUDOPOTENTIAL WE ADD THE NON-LOCAL CONTRIBUTION
C  ALSO VNL ARE CALCULATED TO BE USED IN THE MAIN PROGRAM WHILE
C  EVALUATING ENVNL FOR NEW IONIC POSITIONS - OLD ELECTRONIC FUNCTIONS
C=======================================================================
        IF (IVPTYP.NE.0) THEN
          IF (NLPOT.EQ.0)
     &    CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &                VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,CWRK22,
     &                CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,NN,
     &                IVPTYN)
          DO 1102 M = 1 , NPLWKP
            CPTWFL(M) = CPTWFL(M) + CELFRC(M)
 1102     CONTINUE
        END IF
C=======================================================================
C  H * WF FOR THE SCREENED POTENTIAL
C=======================================================================
        DO 2004 NNN = 1 , NPLWV
          CPTNWR(NNN) = CV(NNN) * CPTOWR(NNN) * RINPLW
 2004   CONTINUE
        CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C=======================================================================
C CALCULATE THE GRADIENT
C=======================================================================
        DO 2010 M = 1 , NPLWKP
          CGRA(M) = CPTWFP(M+NINDW) * DATAKE(1+(7*(M-1))) +
     &              CPTNWR(NINDPW(M)) 
 2010   CONTINUE
        IF (IVPTYP.NE.0) THEN
          DO 2011 M = 1 , NPLWKP
            CGRA(M) = CGRA(M) + CELFRC(M)
 2011     CONTINUE
        END IF
C
        DO 2017 M = 1 , NPLWKP
          CORGR(M) = - CGRA(M)
 2017   CONTINUE
C=======================================================================
C ORTHOGONALISE GRADIENT TO ALL BAND VECTOR
C=======================================================================
        DO 2022 NB = 1 , NBANDS
          NINDD = NRPLWV * ( NB - 1 )
          COVERL = (0.0,0.0)
          DO 2023 M = 1 , NPLWKP
            COVERL = COVERL + CORGR(M) * CONJG (CPTWFP(M+NINDD))
 2023     CONTINUE
          DO 2024 M = 1 , NPLWKP
            CORGR(M) = CORGR(M) - COVERL * CPTWFP(M+NINDD)
 2024     CONTINUE
 2022   CONTINUE
C=======================================================================
C PRE-CONDITION THE GRADIENT
C=======================================================================
        NCELIN = NN + NBANDS * ( NPKPT - 1 ) 
        ENKE = REAL ( CELEN(NCELIN) )
        IF (ENKE.LT.1.0) THEN
          ENKEIN = 1.0
        ELSE
          ENKEIN = 1.0 / ENKE
        ENDIF
        DO 2031 M = 1 , NPLWKP
          X = DATAKE(1+7*(M-1)) * ENKEIN
          PCNUM = 27 + ( 18 * X ) + ( 12 * X * X ) + ( 8 * X * X * X )
          PCDEN = PCNUM + ( 16 * X * X * X * X )
          PRECON(M) = PCNUM / PCDEN
          CDUM(M) = CORGR(M) * PRECON(M)
 2031   CONTINUE
C=======================================================================
C ORTHOGONALISE PRECONDITIONED RESIDUAL TO ALL BANDS
C=======================================================================
        DO 2032 NB = 1 , NBANDS
          NINDD = NRPLWV * ( NB - 1 )
          COVERL = 0.0
          DO 2033 M = 1 , NPLWKP
            COVERL = COVERL + CDUM(M) * CONJG (CPTWFP(NINDD+M))
 2033     CONTINUE
          DO 2034 M = 1 , NPLWKP
            CDUM(M) = CDUM(M) - COVERL * CPTWFP(NINDD+M)
2034      CONTINUE
 2032   CONTINUE
C=======================================================================
C AFTER FIRST ITERATION USE CONJUGATE DIRECTIONS
C=======================================================================
        DO 2035 M = 1 , NPLWKP
          CDIR(M) = CDUM(M)
 2035    CONTINUE
C=======================================================================
C FINALLY ORTHOGONALISE SEARCH DIRECTION TO PRESENT BAND AND NORMALISE
C=======================================================================
        COVERL = (0.0,0.0)
        DO 2070 M = 1 , NPLWKP
          COVERL = COVERL + CDIR(M) * CONJG ( CPTWFP(M+NINDW) )
 2070   CONTINUE
        DO 2080 M = 1 , NPLWKP
          CDIR(M) = CDIR(M) - COVERL * CPTWFP(M+NINDW)
 2080   CONTINUE
        ANORM = 0.0
        DO 2090 M = 1 , NPLWKP
          ANORM = ANORM + REAL ( CDIR(M) * CONJG ( CDIR(M) ) )
 2090   CONTINUE
        FNORM = 1.0 / SQRT ( ANORM )
        DO 2095 M = 1 , NPLWKP
          CDIR(M) = CDIR(M) * FNORM
 2095   CONTINUE
C=======================================================================
C STORE THE GRADIENT VECTOR
C=======================================================================
        WRITE (NUNIT) ( CDIR(I) , I = 1 , NRPLWV )
C=======================================================================
C CALCULATE THE CONTRIBUTION TO THE ELECTRONIC GRADIENT TERM
C=======================================================================
        EN1 = 0.0
        DO 2100 M = 1 , NPLWKP
          EN1 = EN1 + REAL ( CDIR(M) * CONJG ( CPTWFL(M) ) )
 2100   CONTINUE
        OCCNN = 2.0 * WTKPT(NPKPT) * OCC(NN,NPKPT)
        ENGRSI = ENGRSI + EN1 * OCCNN
C=======================================================================
C CALCULATE A NEW VECTOR AT A TRIAL DISTANCE ALONG THE SEARCH DIRECTION
C=======================================================================
        ALCOS = COS ( ALPHA )
        ALSIN = SIN ( ALPHA )
        DO 2110 M = 1 , NPLWKP
          CPTWFL(M) = ALCOS * CPTWFP(M+NINDW) + ALSIN * CDIR(M)
 2110   CONTINUE
C=======================================================================
C REPEAT PROCESS OF CALCULATING THE ENERGY BUT WITH THE NEW VECTOR
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
        DO 2112 M = 1 , MPLWV
          CPTNWR(M) = (0.0,0.0)
          CWORK(M)  = (0.0,0.0)
 2112   CONTINUE
        DO 2113 M = 1 , NPLWKP
          CPTNWR(NINDPW(M)) = CPTWFL(M)
 2113   CONTINUE
        NCELIN = NN + NBANDS * ( NPKPT - 1 )
        CELEN(NCELIN) = (0.0,0.0)
        DO 2114 M = 1 , NPLWKP
          CELEN(NCELIN) = CELEN(NCELIN) + DATAKE(1+7*(M-1)) * 
     &                    CPTWFL(M) * CONJG ( CPTWFL(M) )
 2114   CONTINUE
        IF (IVPTYP.NE.0 .AND. NLPOT.EQ.0) THEN
          CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &                VOLC,PSCALE,CPTWFL,CWRK20,CWRK21,CWRK22,
     &                CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,1,
     &                IVPTYN)
          VNL(NN,NPKPT) = 0.0
          DO 1103 M = 1 , NPLWKP
            VNL(NN,NPKPT) = VNL(NN,NPKPT) + 
     &                      REAL ( CONJG (CPTWFL(M)) * CELFRC(M) ) 
 1103     CONTINUE
        END IF
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
        CALL FFT3D(CPTNWR,CWORK,NGPTAR,1)
        DO 3000 M = 1 , NPLWV
          CHDENR(M) = CHDENR(M) + OCCNN *
     &              ( CPTNWR(M) * CONJG ( CPTNWR(M) ) -
     &                CPTOWR(M) * CONJG ( CPTOWR(M) ) ) 
 3000   CONTINUE
C=====================================================================
C CALL ROUTINE TO CALCULATE NON-LOCAL ENERGY IN REAL SPACE            
C=====================================================================
          IF(IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN                       
            CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NN,NPKPT,MPLWV,NRPLWV,   
     &       NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK,CPTNWR,    
     &       CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,   
     &       MXRLSH,CESAVE)                                           
          ENDIF                                                       
C======================================================================
C END LOOPS
C======================================================================
 2001 CONTINUE
      RETURN
      END

      SUBROUTINE ASRHS (RHS,ELF,STEER,DOFEL)
      INTEGER DOFEL, STEER(DOFEL)
      DOUBLE PRECISION RHS(*), ELF(*)
      INTEGER I, K
      DO 100 I=1,DOFEL
         K = STEER(I)
         IF (K.GT.0) RHS(K) = RHS(K) + ELF(I)
100   CONTINUE
      RETURN
      END

C     *****************
      SUBROUTINE VDRAND(NVL,WK1)
C     *****************
C
C
      DOUBLE PRECISION WK1(NVL),
     >                 DRAND
C
C
      DO 10 I = 1,NVL
      WK1(I) = DRAND(0)
   10 CONTINUE
C
C
      RETURN
      END
C
C

      SUBROUTINE DRCOUT(XYZ3,GEO3,VEL3,NVAR,TIME,ESCF3,EKIN3,
     1GTOT3,ETOT3,XTOT3,ILOOP,CHARGE,FRACT,TEXT1,TEXT2,II,JLOOP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      CHARACTER TEXT1*3,TEXT2*2
      DIMENSION XYZ3(3,NVAR), VEL3(3,NVAR), ESCF3(3), EKIN3(3)
      DIMENSION XYZ(3,NUMATM), VEL(3,NUMATM), CHARGE(NUMATM),
     1 GEO3(3,NUMATM), ETOT3(3), GTOT3(3), XTOT3(3)
*************************************************************
*                                                           *
*    DRCOUT PRINTS THE GEOMETRY, ETC. FOR A DRC AT A        *
*    POSITION DETERMINED BY FRACT.                          *
*    ON INPUT XYZ3  = QUADRATIC EXPRESSION FOR THE GEOMETRY *
*             VEL3  = QUADRATIC EXPRESSION FOR THE VELOCITY *
*             ESCF3 = QUADRATIC EXPRESSION FOR THE P.E.     *
*             EKIN3 = QUADRATIC EXPRESSION FOR THE K.E.     *
*                                                           *
*************************************************************
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /GEOVAR/ IIVAR, LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,XRACT
      DIMENSION  IEL1(3), GG(3)
      CHARACTER*80 KEYWRD,KOMENT,TITLE, ALPHA*2, ELEMNT*2
      INTEGER PRTKOM, PRTITL, PRTKEY
      LOGICAL FIRST, LARGE, DRC
      DATA FIRST/.TRUE./
      IF(FIRST)THEN
         IF( INDEX(KEYWRD,'REST').EQ.0.OR.INDEX(KEYWRD,'IRC=').NE.0)THEN
            JLOOP=0
         ENDIF
         FIRST=.FALSE.
         DO 10 I=80,1,-1
   10    IF(KEYWRD(I:I).NE.' ')GOTO 20
         I=1
   20    PRTKEY=I
         DO 30 I=80,1,-1
   30    IF(KOMENT(I:I).NE.' ')GOTO 40
         I=1
   40    PRTKOM=I
         DO 50 I=80,1,-1
   50    IF(TITLE(I:I).NE.' ')GOTO 60
         I=1
   60    PRTITL=I
         DRC=(INDEX(KEYWRD,'DRC').NE.0)
         LARGE=(INDEX(KEYWRD,'LARGE').NE.0)
         IF(DRC) THEN
            WRITE(6,'(//,'' FEMTOSECONDS  POINT  POTENTIAL +''
     1,'' KINETIC  =  TOTAL     ERROR    REF%'')')
         ELSE
            WRITE(6,'(//,''     POINT   POTENTIAL  +  ''
     1,''ENERGY LOST   =   TOTAL      ERROR    REF%'')')
         ENDIF
      ELSE
         IF(DRC) THEN
            WRITE(6,'(//,'' FEMTOSECONDS  POINT  POTENTIAL +''
     1,'' KINETIC  =  TOTAL     ERROR    REF'')')
         ELSE
            WRITE(6,'(//,''     POINT   POTENTIAL  +  ''
     1,''ENERGY LOST   =   TOTAL      ERROR    REF'')')
         ENDIF
      ENDIF
      JLOOP=JLOOP+1
C#      FRACT=0.D0
      ESCF=ESCF3(1)+ESCF3(2)*FRACT+ESCF3(3)*FRACT**2
      EKIN=EKIN3(1)+EKIN3(2)*FRACT+EKIN3(3)*FRACT**2
      ETOT=ETOT3(1)+ETOT3(2)*FRACT+ETOT3(3)*FRACT**2
      GTOT=GTOT3(1)+GTOT3(2)*FRACT+GTOT3(3)*FRACT**2
      XTOT=XTOT3(1)+XTOT3(2)*FRACT+XTOT3(3)*FRACT**2
      IF(II.NE.0)THEN
         IF(DRC) THEN
            WRITE(6,'(F10.3,I8,F12.5,F11.5,F11.5,
     1F10.5,'' '',I5,3X,''%'',A,A,I3)')TIME, ILOOP-2, ESCF, EKIN,
     2 ESCF+EKIN,ESCF+EKIN-ETOT,JLOOP,TEXT1,TEXT2,II
            WRITE(6,'(9X,A,F9.4,A)')' MOVEMENT FROM START =',XTOT,' ANGS
     1TROMS'
         ELSE
            WRITE(6,'(I8,F14.5,F13.5,F17.5,
     1F10.5,'' '',I5,3X,''%'',A,A,I3)') ILOOP-2, ESCF, EKIN,
     2 ESCF+EKIN,ESCF+EKIN-ETOT,JLOOP,TEXT1,TEXT2,II
C#      WRITE(6,'(24X,'' INTEGRATED GRADIENT ERROR ='',G10.3,
C#     1'' KCALS/ANGSTROM'')')GTOT
            WRITE(6,'(9X,A,F9.4,A)')' MOVEMENT FROM START =',XTOT,' ANGS
     1TROMS'
         ENDIF
      ELSE
         IF(DRC) THEN
            WRITE(6,'(F10.3,I8,F12.5,F11.5,F11.5,
     1F10.5,'' '',I5,3X,''%'',A,A,I3)')TIME, ILOOP-2, ESCF, EKIN,
     2 ESCF+EKIN,ESCF+EKIN-ETOT,JLOOP,TEXT1,TEXT2
            WRITE(6,'(9X,A,F9.4,A)')' MOVEMENT FROM START =',XTOT,' ANGS
     1TROMS'
         ELSE
            WRITE(6,'(I8,F14.5,F13.5,F17.5,
     1F10.5,'' '',I5,3X,''%'',A,A,I3)') ILOOP-2, ESCF, EKIN,
     2 ESCF+EKIN,ESCF+EKIN-ETOT,JLOOP,TEXT1,TEXT2
C#      WRITE(6,'(24X,'' INTEGRATED GRADIENT ERROR ='',F10.5,
C#     1'' KCALS/ANGSTROM'')')GTOT
            WRITE(6,'(9X,A,F9.4,A)')' MOVEMENT FROM START =',XTOT,' ANGS
     1TROMS'
         ENDIF
      ENDIF
      NATOMS=NVAR/3
      L=0
      DO 80 I=1,NATOMS
         DO 70 J=1,3
            L=L+1
            VEL(J,I)=VEL3(1,L)+VEL3(2,L)*FRACT+VEL3(3,L)*FRACT**2
   70    XYZ(J,I)=XYZ3(1,L)+XYZ3(2,L)*FRACT+XYZ3(3,L)*FRACT**2
   80 CONTINUE
      IF(LARGE)THEN
         WRITE(6,*)'                CARTESIAN GEOMETRY           '
     1//'VELOCITY (IN CM/SEC)'
         WRITE(6,*)'  ATOM        X          Y          Z'
     1      //'                X          Y          Z'
         DO 90 I=1,NUMAT
            LL=(I-1)*3+1
            LU=LL+2
            WRITE(6,'(I4,3X,A2,3F11.5,2X,3F11.1)')
     1I, ELEMNT(NAT(I)),(XYZ(J,I),J=1,3),(VEL(J,I),J=1,3)
   90    CONTINUE
      ENDIF
      IVAR=1
      NA(1)=0
      L=0
      WRITE(6,'(//10X,''FINAL GEOMETRY OBTAINED'',33X,''CHARGE'')'
     1)
      WRITE(6,'(A)')KEYWRD(:PRTKEY),KOMENT(:PRTKOM),TITLE(:PRTITL)
      LMAX=L
      L=0
      DO 120 I=1,NUMAT
         J=I/26
         ALPHA(1:1)=CHAR(ICHAR('A')+J)
         J=I-J*26
         ALPHA(2:2)=CHAR(ICHAR('A')+J-1)
         DO 100 J=1,3
  100    IEL1(J)=0
  110    CONTINUE
         IF(LOC(1,IVAR).EQ.I) THEN
            IEL1(LOC(2,IVAR))=1
            IVAR=IVAR+1
            GOTO 110
         ENDIF
         IF(I.LT.4) THEN
            IEL1(3)=0
            IF(I.LT.3) THEN
               IEL1(2)=0
               IF(I.LT.2) THEN
                  IEL1(1)=0
               ENDIF
            ENDIF
         ENDIF
         IF(LABELS(I).LT.99)THEN
            L=L+1
            GG(1)=GEO3(1,I*3-2)+GEO3(2,I*3-2)*FRACT+GEO3(3,I*3-2)*FRACT*
     1*2
            GG(2)=GEO3(1,I*3-1)+GEO3(2,I*3-1)*FRACT+GEO3(3,I*3-1)*FRACT*
     1*2
            GG(3)=GEO3(1,I*3  )+GEO3(2,I*3  )*FRACT+GEO3(3,I*3  )*FRACT*
     1*2
            WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3,F13.4,I5,A)')
     1    ELEMNT(LABELS(I)),(GG(K),IEL1(K),K=1,3),
     2    NA(I),NB(I),NC(I),CHARGE(L),JLOOP,ALPHA//'*'
         ELSE
            WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3,13X,I5,A)')
     1    ELEMNT(LABELS(I)),(GG(K),IEL1(K),K=1,3),
     2NA(I),NB(I),NC(I),JLOOP,ALPHA//'%'
         ENDIF
  120 CONTINUE
      NA(1)=99
      RETURN
      END

      SUBROUTINE HMATRX(FREQ,FREQR,XSIIR,FII,H,NDIM,NMODES)
C     
C..THISPROGRAM WILL CALCULATE VALUES FOR COMPLEX TRANSFER FUNCTION MATRIX H
C     
CDEP  
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION FREQR(NMODES),XSIIR(NMODES),FII(NDIM,NMODES)
      DIMENSION H(NDIM,NDIM)
C-old:DEP  --- NOTE: ALL COMPLEX*16 MEANS A 64-BIT REAL AND IMAGINARY PART
C-old      COMPLEX*16 H,RECIP
      COMPLEX H,RECIP
      INTEGER R
C     
      PII2=6.283185307
      OMEGA=PII2*FREQ
C     
      DO 110 K=1,NDIM
         DO 100 J=K,NDIM
            H(J,K)=(0.,0.)
 100     CONTINUE
 110  CONTINUE
C     
      DO 220 R=1,NMODES
         OMEGAR=PII2*FREQR(R)
         RECIP=1/CMPLX(OMEGAR**2-OMEGA**2,
     +        2*OMEGA*OMEGAR*XSIIR(R))
         DO 210 K=1,NDIM
            FIIK=FII(K,R)*RECIP
            DO 200 J=K,NDIM
               H(J,K)=H(J,K)+FII(J,R)*FIIK
 200        CONTINUE
 210     CONTINUE
 220  CONTINUE
C     
      DO 310 J=1,NDIM-1
         DO 300 K=J+1,NDIM
            H(J,K)=H(K,J)
 300     CONTINUE
 310  CONTINUE
C     
      END  

      SUBROUTINE SCALDT(JDIM,KDIM,S,DS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION S(JDIM,KDIM,4),DS(JDIM,KDIM)
C
C
C  SCALE WITH SPATIALLY VARIABLE TIME STEP
C
      DO 10 M = 1,4
      DO 10 K = KBEGIN,KEND
      DO 10 J = JBEGIN,JEND
         S(J,K,M) = S(J,K,M)*DS(J,K)
10    CONTINUE
C
      RETURN
      END

      PROGRAM MD1

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/LJPAR/SIGMA
      COMMON/ATOMS/NATM
      COMMON/CUTOFF/RCUT
      COMMON/TEMPER/EQTEMP
      COMMON/ENERGY/V,K,W
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/CONTRL/NSTEP,NEQUIL,ISAVE
      COMMON/FORCES/FX,FY,FZ
      COMMON/PROCS/NPROSX, NPROSY, NPROSZ

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      INTEGER     NW1

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )
      PARAMETER(NW1 = 6)

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)
      REAL        RCUT, DT, SIGMA
      REAL        VRCUT,DVRCUT,DVRC12
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ
      REAL        DENS, DENLJ, EQTEMP
      REAL        MASS, FREE, PI, TEMP
      REAL        E, V, K, W
      REAL        EN, VN, KN, PRES
      REAL        ACE, ACV, ACK, ACP
      REAL        ACESQ, ACVSQ, ACKSQ, ACPSQ
      REAL        AVE, AVV, AVK, AVP, AVT
      REAL        FLE, FLV, FLK, FLP, FLT

      DOUBLE PRECISION TSTART, TEND, TIME

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ),MX,MY,MZ
      INTEGER     NC,M
      INTEGER     STEP, NSTEP, ISAVE, IPRINT, NORM, NATM
      INTEGER     NEQUIL, ISCALE, NPROSX, NPROSY, NPROSZ

      NATM = 0

      PI = ACOS(-1.)

C    ** READ INPUT DATA **

      WRITE(*,'(1H1,'' **** PROGRAM MDLJ ****                   '')')
      WRITE(*,'('' MOLECULAR DYNAMICS SIMULATION                '')')
      WRITE(*,'('' WITH LINKED LIST                             '')')
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN X DIRECTION    '')')
C      READ (*,*) NPROSX
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN Y DIRECTION    '')')
C      READ (*,*) NPROSY
C      WRITE(*,'('' ENTER NUMBER OF PROCESSORS IN Z DIRECTION    '')')
C      READ (*,*) NPROSZ
C  ENTER NUMBER OF TIME STEPS
      NSTEP = 600
C  ENTER NUMBER OF EQUILIBRATION TIME STEPS
      NEQUIL = 500
C  ENTER NUMBER OF STEPS BETWEEN DATA SAVES
      ISAVE = 2*NSTEP
C  ENTER NUMBER OF STEPS BETWEEN OUTPUT
      IPRINT = 100
C  ENTER THE FOLLOWING IN LENNARD-JONES UNITS
C  ENTER THE TEMPERATURE
      EQTEMP = 0.8
C  ENTER THE DENSITY
      DENS = 0.75
C  ENTER THE POTENTIAL CUTOFF DISTANCE
      RCUT = 2.0**(1.0/6.0)
C  ENTER THE TIMESTEP
      DT = 0.01
C  REDUNDANT VARIABLES ....
      ISCALE = 0
      NPROSX = 1
      NPROSY = 1
      NPROSZ = 1

C    ** WRITE INPUT DATA **
c--      OPEN (NW1,FILE='result')
c--      REWIND(NW1)

C**   READ NUMBER OF FCC SUBLATTICES TO USE IN ALL THREE
C**   COORDINATE DIRECTIONS
C**   AT THIS POINT THE NUMBER OF ATOMS WOULD BE READ FROM A FILE
C**   IF SUBROUTINE INCON OR INCONB WERE BEING USED

      WRITE(*,'('' ENTER NC '')')
      READ(*,*) NC
      WRITE(*,*) 'NC = ',NC

      IF (4*NC*NC*NC.GT.NMAX) STOP ' Too many atoms...'

      CALL FCC(NC)

      WRITE(*,'('' NUMBER OF ATOMS BEING USED '',I8)')NATM

      CALL HEADER(NW1,NPROSX,NPROSY,NPROSZ,NC,NATM)

      CALL PARAM(NW1,NSTEP,NEQUIL,IPRINT,ISCALE,EQTEMP,DENS,RCUT,DT)

C    ** CONVERT INPUT DATA TO PROGRAM UNITS **

      SIGMA  = (DENS/REAL(NATM))**(1.0/3.0)
      RCUT   = RCUT*SIGMA
      M      = INT(1./RCUT)
      MASS   = 1.0
      DENLJ  = DENS
      DENS   = DENS/(SIGMA**3)
      DT     = DT*SIGMA
      FREE   = REAL(3*(NATM-1))

C**   CHECK TO SEE WHETHER SYSTEM CAN BE SIMULATED

      IF (M.LT.1)  STOP 'SYSTEM TOO SMALL FOR ARRAY'

C    ** ZERO ACCUMULATORS **

      ACE    = 0.0
      ACV    = 0.0
      ACK    = 0.0
      ACP    = 0.0

      ACESQ  = 0.0
      ACVSQ  = 0.0
      ACKSQ  = 0.0
      ACPSQ  = 0.0

      FLE    = 0.0
      FLV    = 0.0
      FLK    = 0.0
      FLP    = 0.0
      FLT    = 0.0

C    ** WRITE OUT SOME USEFUL INFORMATION **

      WRITE(*,'('' SIGMA/BOX              =  '',F10.4)')  SIGMA
      WRITE(*,'('' RCUT/BOX               =  '',F10.4)')  RCUT
      WRITE(*,'('' DT                     =  '',F10.4)')  DT


C**   CALL SUBROUTINE TO RECEIVE SIMULATION PARAMETERS FROM MASTER

      CALL INPARS

C**   CALL SUBROUTINE TO RECEIVE CONFIGURATIONAL INFORMATION FROM MASTER
C    ** LOOPS OVER ALL STEPS **

      WRITE(*,'(/'' ** MOLECULAR DYNAMICS BEGINS ** ''/ )')
      WRITE(*,10001)
      WRITE(NW1,'(/'' ** MOLECULAR DYNAMICS BEGINS ** ''/ )')
      WRITE(NW1,10001)

C**   START OF MD CYCLE

      DO 1000 STEP=1,MIN(NSTEP,NEQUIL)
        V = 0
        K = 0
        W = 0
        PRES = 0

C**     CALL SUBROUTINE TO PERFORM FIRST
C**     PART OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

	CALL MOVEA

C**     CALL SUBROUTINE TO CREATE LINKED LIST AND PASS EDGES
C**     BETWEEN PROCESSORS
C**     THIS ROUTINE DOES ALL THE COMMUNICATIONS

	CALL MOVOUT

C**     CALL SUBROUTINE TO CALCULATE FORCES AND POTENTIAL
C**     USING LINKED
C**     SCALAR ROUTINE MORE THAN 95% OF CPU TIME

	CALL FORCE

C**     CALL SUBROUTINE TO PERFORM SECOND PART
C**     OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

	CALL MOVEB

        E    = K+V
        EN   = E/REAL(NATM)
        VN   = V/REAL(NATM)
        KN   = K/REAL(NATM)
        TEMP = 2.0*K/FREE
        PRES = DENS*TEMP+W
        PRES = PRES*SIGMA**3

C       ** OPTIONALLY PRINT INFORMATION **
        IF ( MOD ( STEP, IPRINT ) .EQ. 0 ) THEN
             WRITE(*,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
             WRITE(NW1,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
          ENDIF


C**     IF STILL EQUILIBRATING CALL SUBROUTINE TO SCALE VELOCITIES

	CALL SCALET

1000    CONTINUE

C**   START OF PRODUCTION MD CYCLE ** TIME THIS LOOP **

      CALL TIMER(TSTART)

      DO 2000 STEP=NEQUIL+1,NSTEP

        V = 0
        K = 0
        W = 0
        PRES = 0

C**     CALL SUBROUTINE TO PERFORM FIRST
C**     PART OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

        CALL MOVEA

C**     CALL SUBROUTINE TO CREATE LINKED LIST AND PASS EDGES
C**     BETWEEN PROCESSORS
C**     THIS ROUTINE DOES ALL THE COMMUNICATIONS

        CALL MOVOUT

C**     CALL SUBROUTINE TO CALCULATE FORCES AND POTENTIAL
C**     USING LINKED
C**     SCALAR ROUTINE MORE THAN 95% OF CPU TIME

        CALL FORCE

C**     CALL SUBROUTINE TO PERFORM SECOND PART
C**     OF VELOCITY VERLET INTEGRATION
C**     VECTOR OPERATIONS

        CALL MOVEB

C**     CALL SUBROUTINE TO PASS THERMODYNAMIC VARIABLES TO MASTER

C**     CALCULATE AND ACCUMULATE GLOBAL DATA

        E    = K+V
        EN   = E/REAL(NATM)
        VN   = V/REAL(NATM)
        KN   = K/REAL(NATM)
        TEMP = 2.0*K/FREE
        PRES = DENS*TEMP+W
        PRES = PRES*SIGMA**3

        ACE    = ACE  +EN
        ACV    = ACV  +VN
        ACK    = ACK  +KN
        ACP    = ACP  +PRES
        ACESQ  = ACESQ+EN*EN
        ACVSQ  = ACVSQ+VN*VN
        ACKSQ  = ACKSQ+KN*KN
        ACPSQ  = ACPSQ+PRES*PRES

C       ** OPTIONALLY PRINT INFORMATION **
        IF ( MOD ( STEP, IPRINT ) .EQ. 0 ) THEN
             WRITE(*,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
             WRITE(NW1,'(1X,I8,5(2X,F10.6))')
     :                 STEP, EN, KN, VN, PRES, TEMP
          ENDIF

2000  CONTINUE

      CALL TIMER(TEND)

      TIME = TEND-TSTART

C    *******************************************************************
C    ** ENDS THE LOOP OVER CYCLES                                     **
C    *******************************************************************

      WRITE(*,'(/'' ** MOLECULAR DYNAMICS ENDS  ** ''///)')

C    ** WRITE OUT FINAL AVERAGES **

      NORM = REAL(NSTEP-NEQUIL)
      AVE  = ACE/NORM
      AVK  = ACK/NORM
      AVV  = ACV/NORM
      AVP  = ACP/NORM

      ACESQ = (ACESQ/NORM)-AVE**2
      ACKSQ = (ACKSQ/NORM)-AVK**2
      ACVSQ = (ACVSQ/NORM)-AVV**2
      ACPSQ = (ACPSQ/NORM)-AVP**2

      IF (ACESQ.GT.0.0) FLE = SQRT(ACESQ)
      IF (ACKSQ.GT.0.0) FLK = SQRT(ACKSQ)
      IF (ACVSQ.GT.0.0) FLV = SQRT(ACVSQ)
      IF (ACPSQ.GT.0.0) FLP = SQRT(ACPSQ)

      AVT = AVK/1.5
      FLT = FLK/1.5

      WRITE(*,'('' AVERAGES'',5(2X,F10.5))')
     :             AVE, AVK, AVV, AVP, AVT
      WRITE(*,'('' FLUCTS  '',5(2X,F10.5))')
     :             FLE, FLK, FLV, FLP, FLT

      CALL FLOPS(NW1,NC,NSTEP-NEQUIL,RCUT,TIME)

c--      CLOSE(NW1)

      STOP
10001 FORMAT(/1X,'TIMESTEP  ..ENERGY..  ..KINETIC..',
     :          '  ..POTENT..  .PRESSURE.  ..TEMPER..  ')

      END

      SUBROUTINE GMTRY
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  COMPUTE SOLID-RELATED ARRAYS,  GAUSS ELIMINATE THE MATRIX OF WALL
C  INFLUENCE COEFFICIENTS.
C
C    11/30/84  D H BAILEY    REVISED CODE FOR NAS KERNEL TEST
C
      PARAMETER (NW=100, NB=5)
      COMPLEX WALL, ZCR, PROJ, ZI, Z1, ZZ
      COMMON /ARRAYS/ NWALL(NB), IALIGN,
     $     WALL(NW,NB), RMATRX(NW*NB,NW*NB),
     $ ZCR(NW,NB), PROJ(NW,NB), XMAX(NB)
C
      DATA  ARCL /5./, PI /3.141592653589793/, PERIOD/3./
C
C  COMPUTE ARCLENGTH.
C
      MATDIM = 0
      ARCL = 0.
      YMIN = 1.E+50
      YMAX = -1.E+50
      PIDP = PI / PERIOD
C
      DO 9 L = 1, NB
        MATDIM = MATDIM + NWALL(L)
        DO 9 K = 1,NWALL(L)
          ARCL = ARCL + ABS(WALL(K,L) - WALL(1+MOD(K,NWALL(L)), L))
9     CONTINUE
C
C  COMPUTE CORE RADIUS.
C
      R0 = ARCL / (MATDIM*2.)
      SIGMA = R0 / 2.
C
C  DEFINE CREATION POINTS.
C
      DO 6 L = 1,NB
        DO 5 K = 1,NWALL(L)
          ZZ = WALL(1+MOD(K+NWALL(L)-2,NWALL(L)), L)
     &         - WALL(1+MOD(K,NWALL(L)), L)
          ZCR(K,L) = WALL(K,L) + CMPLX(0.0D0, R0/ABS(ZZ)) * ZZ
5       CONTINUE
C
C  CHECK THAT WALL AND CREATION POINTS ARE NOT CROSSED DUE TO
C  TOO SHARP A CONCAVE KINK OR AN ERROR IN DEFINING THE BODY.
C  ALSO FIND HIGHEST,  LOWEST AND RIGHT-MOST POINT.
C
        XMAX(L) = REAL(ZCR(1,L))
        LS = 0
        DO 6 K = 1,NWALL(L)
          YMIN = MIN (YMIN, DBLE(AIMAG(ZCR(K,L))))
          YMAX = MAX (YMAX, DBLE(AIMAG(ZCR(K,L))))
          XMAX(L) = MAX (XMAX(L), DBLE(REAL(ZCR(K,L))))
          KP = 1 + MOD(K, NWALL(L))
          IF (REAL((ZCR(KP,L) - ZCR(K,L)) *
     &        CONJG(WALL(KP,L) - WALL(K,L))).GT.0.) THEN
            LS = L
            KS = K
          ENDIF
6     CONTINUE
C
C       IF (LS .NE. 0) THEN
C         WRITE (6, 102) LS, KS
C102      FORMAT(" ON BODY NUMBER ", I3, " YOU HAVE TOO SHARP A",
C     &      " KINK NEAR POINT ", I4)
C         STOP
C       ENDIF
C
C  THE "MAIN PERIOD" WILL BE BETWEEN YLIMIT AND YLIMIT + PERIOD.
C
      YLIMIT = (YMIN - PERIOD + YMAX)/2
C
C  PROJECT CREATION POINTS INTO MAIN PERIOD. THIS IS TECHNICAL.
C
      DO 1 L = 1,NB
        DO 1 K = 1,NWALL(L)
          PROJ(K,L) = ZCR(K,L) - CMPLX(0.0D0, PERIOD*
     &           (INT(5. + 
     &  (AIMAG(ZCR(K,L)) - YLIMIT) / PERIOD) - 5.0D0))
1     CONTINUE
C
C   COMPUTE MATRIX.
C
      SIG2 = (2. * PIDP * SIGMA) ** 2
      I0 = 0
      DO 2 L1 = 1,NB
        J0 = 0
        DO 4 L2 = 1,NB
          KRON = 0
          IF (L1 .EQ. L2) KRON = 1
          DO 3 J = 1,NWALL(L2)
            RMATRX(I0+1,J0+J) = KRON
            Z1 = EXP ((WALL(1,L1) - ZCR(J,L2)) * PIDP)
            Z1 = Z1 - 1. / Z1
            DUM = SIG2 + REAL(Z1)**2 + AIMAG(Z1)**2
            DO 3 I = 2,NWALL(L1)
              ZI = EXP ((WALL(I,L1) - ZCR(J,L2)) * PIDP)
              ZZ = ZI - 1. / ZI
              RMATRX(I0+I,J0+J) = -0.25 / PI * LOG (DUM /
     &              (SIG2 + REAL(ZZ) ** 2 + AIMAG(ZZ) ** 2))
3         CONTINUE
          J0 = J0 + NWALL(L2)
4       CONTINUE
        I0 = I0 + NWALL(L1)
2     CONTINUE
C
C  GAUSS ELIMINATION
C
      DO 8 I = 1, MATDIM
        RMATRX(I,I) = 1. / RMATRX(I,I)
        DO 8 J = I+1, MATDIM
          RMATRX(J,I) = RMATRX(J,I) * RMATRX(I,I)
          DO 8 K = I+1, MATDIM
            RMATRX(J,K) = RMATRX(J,K) - RMATRX(J,I) * RMATRX(I,K)
8     CONTINUE
C
      RETURN
      END

      SUBROUTINE GMETRY(GEO,COORD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
     2       /EULER / TVEC(3,3), ID
      COMMON /REACTN/ STEP, GEOA(3,NUMATM), GEOVEC(3,NUMATM),COLCST
      COMMON /GEOOK/ IGEOOK
      DIMENSION GEO(3,*),COORD(3,*)
      CHARACTER *15 NDIMEN(4)
      LOGICAL FIRST, GEOOK
      DATA FIRST/.TRUE./, NDIMEN/' MOLECULE     ',' POLYMER       ',
     1'LAYER STRUCTURE',' SOLID         '/
C***********************************************************************
C
C    GMETRY  COMPUTES COORDINATES FROM BOND-ANGLES AND LENGTHS.
C *** IT IS ADAPTED FROM THE PROGRAM WRITTEN BY M.J.S. DEWAR.
C
C     THREE SEPARATE OPTIONS EXIST WITHIN GMETRY. THESE ARE:
C    (A) IF NA(1) IS EQUAL TO 99 (IMPOSSIBLE UNDER NORMAL CIRCUMSTANCES)
C        THEN GEO IS ASSUMED TO BE IN CARTESIAN RATHER THAN INTERNAL
C        COORDINATES, AND COORD IS THEN SET EQUAL TO GEO.
C    (B) IF STEP IS NON-ZERO (THIS IS THE CASE WHEN "SADDLE" IS USED)
C        THEN GEO IS FIRST MODIFIED BY SHIFTING THE INTERNAL COORDINATES
C        ALONG A RADIUS FROM GEOA TO PLACE GEO AT ADISTANCESTEPFROMGEOA.
C    (C) NORMAL CONVERSION FROM INTERNAL TO CARTESIAN COORDINATESISDONE.
C
C  ON INPUT:
C         GEO    = ARRAY OF INTERNAL COORDINATES.
C         NATOMS = NUMBER OF ATOMS, INCLUDING DUMMIES.
C         NA     = ARRAY OF ATOM LABELS FOR BOND LENGTHS.
C
C  ON OUTPUT:
C         COORD  = ARRAY OF CARTESIAN COORDINATES
C
C***********************************************************************
C                                     OPTION (B)
      GEOOK=(IGEOOK.EQ.99)
      IF(ABS(STEP) .GT. 1.D-4) THEN
         SUM=0.D0
         DO 10 I=1,NATOMS
            DO 10 J=1,3
               GEOVEC(J,I)=GEO(J,I)-GEOA(J,I)
   10    SUM=SUM+GEOVEC(J,I)**2
         SUM=SQRT(SUM)
         ERROR=(SUM-STEP)/SUM
      ELSE
         ERROR=0.D0
      ENDIF
      DO 20 I=1,NATOMS
         DO 20 J=1,3
   20 GEO(J,I)=GEO(J,I)-ERROR*GEOVEC(J,I)
C                                     OPTION (A)
      IF(NA(1).EQ.99) THEN
         DO 30 I=1,3
            DO 30 J=1,NATOMS
   30    COORD(I,J)=GEO(I,J)
         GOTO 110
      ENDIF
C                                     OPTION (C)
      COORD(1,1)=0.0D00
      COORD(2,1)=0.0D00
      COORD(3,1)=0.0D00
      COORD(1,2)=GEO(1,2)
      COORD(2,2)=0.0D00
      COORD(3,2)=0.0D00
      IF(NATOMS.EQ.2) GOTO 110
      CCOS=COS(GEO(2,3))
      IF(NA(3).EQ.1)THEN
         COORD(1,3)=COORD(1,1)+GEO(1,3)*CCOS
      ELSE
         COORD(1,3)=COORD(1,2)-GEO(1,3)*CCOS
      ENDIF
      COORD(2,3)=GEO(1,3)*SIN(GEO(2,3))
      COORD(3,3)=0.0D00
      DO 100 I=4,NATOMS
         COSA=COS(GEO(2,I))
         MB=NB(I)
         MC=NA(I)
         XB=COORD(1,MB)-COORD(1,MC)
         YB=COORD(2,MB)-COORD(2,MC)
         ZB=COORD(3,MB)-COORD(3,MC)
         RBC=1.0D00/SQRT(XB*XB+YB*YB+ZB*ZB)
         IF (ABS(COSA).LT.1.D0-1.D-12) GO TO 40
C
C     ATOMS MC, MB, AND (I) ARE COLLINEAR
C
         RBC=GEO(1,I)*RBC*COSA
         COORD(1,I)=COORD(1,MC)+XB*RBC
         COORD(2,I)=COORD(2,MC)+YB*RBC
         COORD(3,I)=COORD(3,MC)+ZB*RBC
         GO TO 100
C
C     THE ATOMS ARE NOT COLLINEAR
C
   40    MA=NC(I)
         XA=COORD(1,MA)-COORD(1,MC)
         YA=COORD(2,MA)-COORD(2,MC)
         ZA=COORD(3,MA)-COORD(3,MC)
C
C     ROTATE ABOUT THE Z-AXIS TO MAKE YB=0, AND XB POSITIVE.  IF XYB IS
C     TOO SMALL, FIRST ROTATE THE Y-AXIS BY 90 DEGREES.
C
         XYB=SQRT(XB*XB+YB*YB)
         K=-1
         IF (XYB.GT.0.1D00) GO TO 50
         XPA=ZA
         ZA=-XA
         XA=XPA
         XPB=ZB
         ZB=-XB
         XB=XPB
         XYB=SQRT(XB*XB+YB*YB)
         K=+1
C
C     ROTATE ABOUT THE Y-AXIS TO MAKE ZB VANISH
C
   50    COSTH=XB/XYB
         SINTH=YB/XYB
         XPA=XA*COSTH+YA*SINTH
         YPA=YA*COSTH-XA*SINTH
         SINPH=ZB*RBC
         COSPH=SQRT(ABS(1.D00-SINPH*SINPH))
         XQA=XPA*COSPH+ZA*SINPH
         ZQA=ZA*COSPH-XPA*SINPH
C
C     ROTATE ABOUT THE X-AXIS TO MAKE ZA=0, AND YA POSITIVE.
C
         YZA=SQRT(YPA**2+ZQA**2)
         IF(YZA.LT.1.D-4)GOTO 70
         IF(YZA.LT.2.D-2 .AND. .NOT.GEOOK)THEN
            WRITE(6,'(//20X,'' CALCULATION ABANDONED AT THIS POINT'')')
            WRITE(6,'(//10X,'' THREE ATOMS BEING USED TO DEFINE THE'',/
     110X,'' COORDINATES OF A FOURTH ATOM, WHOSE BOND-ANGLE IS'')')
            WRITE(6,'(10X,'' NOT ZERO OR 180 DEGREEES, ARE '',
     1''IN AN ALMOST STRAIGHT'')')
            WRITE(6,'(10X,'' LINE.  THERE IS A HIGH PROBABILITY THAT THE
     1'',/10X,'' COORDINATES OF THE ATOM WILL BE INCORRECT.'')')
            WRITE(6,'(//20X,''THE FAULTY ATOM IS ATOM NUMBER'',I4)')I
            CALL GEOUT
            WRITE(6,'(//20X,''CARTESIAN COORDINATES UP TO FAULTY ATOM'')
     1')
            WRITE(6,'(//5X,''I'',12X,''X'',12X,''Y'',12X,''Z'')')
            DO 60 J=1,I
   60       WRITE(6,'(I6,F16.5,2F13.5)')J,(COORD(K,J),K=1,3)
            WRITE(6,'(//6X,'' ATOMS'',I3,'','',I3,'', AND'',I3,
     1'' ARE WITHIN'',F7.4,'' ANGSTROMS OF A STRAIGHT LINE'')')
     2MC,MB,MA,YZA
            CALL WRAPUP()
         ENDIF
         COSKH=YPA/YZA
         SINKH=ZQA/YZA
         GOTO 80
   70    CONTINUE
C
C   ANGLE TOO SMALL TO BE IMPORTANT
C
         COSKH=1.D0
         SINKH=0.D0
   80    CONTINUE
C
C     COORDINATES :-   A=(XQA,YZA,0),   B=(RBC,0,0),  C=(0,0,0)
C     NONE ARE NEGATIVE.
C     THE COORDINATES OF I ARE EVALUATED IN THE NEW FRAME.
C
         SINA=SIN(GEO(2,I))
         SIND=-SIN(GEO(3,I))
         COSD=COS(GEO(3,I))
         XD=GEO(1,I)*COSA
         YD=GEO(1,I)*SINA*COSD
         ZD=GEO(1,I)*SINA*SIND
C
C     TRANSFORM THE COORDINATES BACK TO THE ORIGINAL SYSTEM.
C
         YPD=YD*COSKH-ZD*SINKH
         ZPD=ZD*COSKH+YD*SINKH
         XPD=XD*COSPH-ZPD*SINPH
         ZQD=ZPD*COSPH+XD*SINPH
         XQD=XPD*COSTH-YPD*SINTH
         YQD=YPD*COSTH+XPD*SINTH
         IF (K.LT.1) GO TO 90
         XRD=-ZQD
         ZQD=XQD
         XQD=XRD
   90    COORD(1,I)=XQD+COORD(1,MC)
         COORD(2,I)=YQD+COORD(2,MC)
         COORD(3,I)=ZQD+COORD(3,MC)
  100 CONTINUE
C
C *** NOW REMOVE THE TRANSLATION VECTORS, IF ANY, FROM THE ARRAY COOR
C
  110 CONTINUE
      K=NATOMS
  120 IF(LABELS(K).NE.107) GOTO 130
      K=K-1
      GOTO 120
  130 K=K+1
      IF(K.GT.NATOMS) GOTO 180
C
C   SYSTEM IS A SOLID, OF DIMENSION NATOMS+1-K
C
      L=0
      DO 140 I=K,NATOMS
         L=L+1
         MC=NA(I)
         DO 140 J=1,3
            TVEC(J,L)=COORD(J,I)-COORD(J,MC)
  140 CONTINUE
      ID=L
      IF (FIRST) THEN
         FIRST=.FALSE.
         WRITE(6,150)NDIMEN(ID+1)
  150    FORMAT(/10X,'    THE SYSTEM IS A ',A15,/)
         IF(ID.EQ.0) GOTO 180
         WRITE(6,160)
         WRITE(6,170)(I,(TVEC(J,I),J=1,3),I=1,ID)
  160    FORMAT(/,'                UNIT CELL TRANSLATION VECTORS',/
     1/,'              X              Y              Z')
  170    FORMAT('    T',I1,' = ',F11.7,'    ',F11.7,'    ',F11.7)
      ENDIF
  180 CONTINUE
      J=0
      DO 200 I=1,NATOMS
         IF (LABELS(I).EQ.99.OR.LABELS(I).EQ.107) GO TO 200
         J=J+1
         DO 190 K=1,3
  190    COORD(K,J)=COORD(K,I)
  200 CONTINUE
      CUTOFF=200.D0
      RETURN
      END

      SUBROUTINE TK(JDIM,KDIM,Q,SNDSP,S,XYJ,XY,IX,IY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  IX = 1, IY = 2  XI  METRICS
C  IX = 3, IY = 4  ETA METRICS
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),S(JDIM,KDIM,4),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
C
      BT = 1./SQRT(2.)
      RGAMI = 1./GAMI
C
C  T  MATRIX MULTIPLY FOR DIAGONAL ALGORITHM
C   K
C
      DO 1 K = KLOW, KUP
       DO 1 J = JLOW,JUP
          RX      = XY(J,K,IX)
          RY      = XY(J,K,IY)
          RRXY    = 1./SQRT(RX**2+RY**2)
          RX      = RX*RRXY
          RY      = RY*RRXY
             RHO    = Q(J,K,1)*XYJ(J,K)
             RHOINV = 1./Q(J,K,1)
             U = Q(J,K,2)*RHOINV
             V = Q(J,K,3)*RHOINV
             ALP0 = RHO*BT/SNDSP(J,K)
                 S1 = S(J,K,1)
                 S2 = S(J,K,2)
                 SA = (S(J,K,3) + S(J,K,4))*ALP0
                 SM = (S(J,K,3) - S(J,K,4))*RHO*BT
                 UV2 = 0.5*(U**2 + V**2)
                 RRX = RHO*RX
                 RRY = RHO*RY
C
                    S(J,K,1) = S1 + SA
                    S(J,K,2) = U*S1 + RRY*S2 + U*SA + RX*SM
                    S(J,K,3) = V*S1 - RRX*S2 + V*SA + RY*SM
                    S(J,K,4) = UV2*S1 + (RRY*U - RRX*V)*S2 + 
     +                         (UV2+SNDSP(J,K)**2*RGAMI)*SA + 
     +                         (RX*U + RY*V)*SM
C
1       CONTINUE
C
          RETURN
          END

      FUNCTION AABBCD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION IOCCA1(NMOS), IOCCB1(NMOS), IOCCA2(NMOS), IOCCB2(NMOS)
***********************************************************************
*
* AABBCD EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
*       BY TWO SETS OF M.O.S. ONE MICROSTATE HAS AN ALPHA ELECTRON
*       IN PSI(I) AND A BETA ELECTRON IN PSI(K) FOR WHICH THE OTHER
*       MICROSTATE HAS AN ALPHA ELECTRON IN PSI(J) AND A BETA ELECTRON
*       IN PSI(L)
*
***********************************************************************
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      COMMON /SPQR/ ISPQR(NMECI*NMECI,NMECI),IS,ILOOP, JLOOP
      DO 10 I=1,NMOS
   10 IF(IOCCA1(I) .NE. IOCCA2(I)) GOTO 20
   20 DO 30 J=I+1,NMOS
   30 IF(IOCCA1(J) .NE. IOCCA2(J)) GOTO 40
   40 DO 50 K=1,NMOS
   50 IF(IOCCB1(K) .NE. IOCCB2(K)) GOTO 60
   60 DO 70 L=K+1,NMOS
   70 IF(IOCCB1(L) .NE. IOCCB2(L)) GOTO 80
   80 IF( I.EQ.K .AND. J.EQ.L .AND. IOCCA1(I).NE.IOCCB1(I)) THEN
         ISPQR(ILOOP,IS)=JLOOP
         IS=IS+1
      ENDIF
      IF(IOCCA1(I) .LT. IOCCA2(I)) THEN
         M=I
         I=J
         J=M
      ENDIF
      IF(IOCCB1(K) .LT. IOCCB2(K)) THEN
         M=K
         K=L
         L=M
      ENDIF
      XR=XY(I,J,K,L)
C#      WRITE(6,'(4I5,F12.6)')I,J,K,L,XR
C
C   NOW UNTANGLE THE MICROSTATES
C
      IJ=1
      IF( I.GT.K .AND. J.GT.L .OR. I.LE.K .AND. J.LE.L)IJ=0
      IF( I.GT.K ) IJ=IJ+IOCCA1(K)+IOCCB1(I)
      IF( J.GT.L ) IJ=IJ+IOCCA2(L)+IOCCB2(J)
      IF(I.GT.K)THEN
         M=I
         I=K
         K=M
      ENDIF
      DO 90 M=I,K
   90 IJ=IJ+IOCCB1(M)+IOCCA1(M)
      IF(J.GT.L)THEN
         M=J
         J=L
         L=M
      ENDIF
      DO 100 M=J,L
  100 IJ=IJ+IOCCB2(M)+IOCCA2(M)
C
C   IJ IN THE PERMUTATION NUMBER, .EQUIV. -1 IF IJ IS ODD.
C
      AABBCD=XR*((-1)**(IJ-(IJ/2)*2))
      RETURN
      END

      SUBROUTINE ASSEMB(A,ALOK,F,FLOK,MXNOD,STEER,NODEL,IDIAG)

      INTEGER MXNOD,NODEL,IDIAG,STEER(*)
      DOUBLE PRECISION A(2*MXNOD,*),F(*),ALOK(*),FLOK(*)
      INTEGER IND,INDI,INDJ,I,J,NLOK
      PARAMETER(NLOK=8)
      DOUBLE PRECISION M(2*NLOK,2*NLOK)

      IND=1
      DO 10 I=1,2*NLOK
         DO 20 J=1,2*NLOK
            M(J,I)=ALOK(IND)
            IND=IND+1
 20      CONTINUE
 10   CONTINUE

        DO 30 I=1,NODEL
          DO 40 J=1,NODEL

            INDI=2*STEER(I)-1
            INDJ=2*STEER(J)-1
            INDJ=IDIAG+INDJ-INDI
            A(INDI,INDJ)=A(INDI,INDJ)+M(2*I-1,2*J-1)

            INDI=2*STEER(I)-1
            INDJ=2*STEER(J)
            INDJ=IDIAG+INDJ-INDI
            A(INDI,INDJ)=A(INDI,INDJ)+M(2*I-1,2*J)

            INDI=2*STEER(I)
            INDJ=2*STEER(J)-1
            INDJ=IDIAG+INDJ-INDI
            A(INDI,INDJ)=A(INDI,INDJ)+M(2*I,2*J-1)

            INDI=2*STEER(I)
            INDJ=2*STEER(J)
            INDJ=IDIAG+INDJ-INDI
            A(INDI,INDJ)=A(INDI,INDJ)+M(2*I,2*J)
            
 40      CONTINUE
         F(2*STEER(I)-1)=F(2*STEER(I)-1)+FLOK(2*I-1)
         F(2*STEER(I))=F(2*STEER(I))+FLOK(2*I)
 30   CONTINUE

      RETURN
      END

      SUBROUTINE ETADIF(JDIM,KDIM,X,Y,XY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION XY(JDIM,KDIM,4)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM)
C
C  XY2 = XETA, XY1 = YETA
C
      DO 21 J=JBEGIN,JEND
         DO 20 K=KLOW,KUP
            XY(J,K,2) = ( X(J,K+1) - X(J,K-1))*.5
            XY(J,K,1) = ( Y(J,K+1) - Y(J,K-1))*.5
20       CONTINUE
         K = KBEGIN
         XY(J,K,2) = ( -3.*X(J,K) +4.*X(J,K+1) - X(J,K+2))*.5
         XY(J,K,1) = ( -3.*Y(J,K) +4.*Y(J,K+1) -Y(J,K+2))*.5
         K = KEND
         XY(J,K,2) = ( 3.*X(J,K) -4.*X(J,K-1) + X(J,K-2))*.5
         XY(J,K,1) = ( 3.*Y(J,K) -4.*Y(J,K-1) + Y(J,K-2))*.5
   21 CONTINUE
C
C
         RETURN
         END

C     **************
      SUBROUTINE PRO(NVH,NVL,IPM,WK3,WK2,WK1)
C     **************
C
C
      DOUBLE PRECISION WK1(NVH,18),WK2(NVH,18),WK3(NVH,18),
     >                 ZERO
C
      PARAMETER( ZERO = 0.E0 )
C
C
C     SU(3) MULTIPLICATION
C
C     1) U * U , ( IPM .EQ. 1 )
C
C        C(I,J) = A(I,L) * B(L,J)
C
C               = [ RE A(I,L) + I IM A(I,L) ] * [ RE B(L,J) + I IM B(L,J) ]
C
C        =>
C
C        RE C(I,J) =   RE A(I,L) * RE B(L,J) - IM A(I,L) * IM B(L,J)
C        IM C(I,J) =   RE A(I,L) * IM B(L,J) + IM A(I,L) * RE B(L,J)
C
C                                                  SUM OVER L=1,2,3
C            _
C     2) U * U , ( IPM .EQ. 2 )
C
C                           *
C        C(I,J) = A(I,L) * B(J,L)
C
C               = [ RE A(I,L) + I IM A(I,L) ] * [ RE B(J,L) - I IM B(J,L) ]
C
C        =>
C
C        RE C(I,J) =   RE A(I,L) * RE B(J,L) + IM A(I,L) * IM B(J,L)
C        IM C(I,J) = - RE A(I,L) * IM B(J,L) + IM A(I,L) * RE B(J,L)
C
C                                                  SUM OVER L=1,2,3
C        _   _
C     3) U * U , ( IPM .EQ. 3 )
C
C                  *        *
C        C(I,J) = A(I,L) * B(J,L)
C
C               = [ RE A(L,I) - I IM A(L,I) ] * [ RE B(L,J) - I IM B(L,J) ]
C
C        =>
C
C        RE C(I,J) =   RE A(L,I) * RE B(L,J) - IM A(L,I) * IM B(L,J)
C        IM C(I,J) = - RE A(L,I) * IM B(L,J) - IM A(L,I) * RE B(L,J)
C
C
C                                                  SUM OVER L=1,2,3
C
C     FOR AN OPTIMIZED VERSION OF THIS PROGRAM, THE LOOP OVER
C     L SHOULD BE  WRITTEN  OUT  EXPLICITLY, IN ORDER TO SAVE
C     LOAD AND STORE OPERATIONS
C
C
      DO 1 ISM = 1,18
      DO 1 IVL = 1,NVL
    1 WK3(IVL,ISM) = ZERO
C
      IF( IPM .EQ. 1 ) THEN
C
          DO 10 I=1,3
          DO 10 J=1,3
          DO 10 L=1,3
C
             DO 2 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)  ) = WK3(IVL,I+3*(J-1)  )
     >     + WK2(IVL,I+3*(L-1)  ) * WK1(IVL,L+3*(J-1)  )
     >     - WK2(IVL,I+3*(L-1)+9) * WK1(IVL,L+3*(J-1)+9)
    2        CONTINUE
C
             DO 3 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)+9) = WK3(IVL,I+3*(J-1)+9)
     >     + WK2(IVL,I+3*(L-1)  ) * WK1(IVL,L+3*(J-1)+9)
     >     + WK2(IVL,I+3*(L-1)+9) * WK1(IVL,L+3*(J-1)  )
    3        CONTINUE
C
   10 CONTINUE
C
      ENDIF
C
      IF( IPM .EQ. 2 ) THEN
C
          DO 20 I=1,3
          DO 20 J=1,3
          DO 20 L=1,3
C
             DO 4 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)  ) = WK3(IVL,I+3*(J-1)  )
     >     + WK2(IVL,I+3*(L-1)  ) * WK1(IVL,J+3*(L-1)  )
     >     + WK2(IVL,I+3*(L-1)+9) * WK1(IVL,J+3*(L-1)+9)
    4        CONTINUE
C
             DO 5 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)+9) = WK3(IVL,I+3*(J-1)+9)
     >     - WK2(IVL,I+3*(L-1)  ) * WK1(IVL,J+3*(L-1)+9)
     >     + WK2(IVL,I+3*(L-1)+9) * WK1(IVL,J+3*(L-1)  )
    5        CONTINUE
C
   20 CONTINUE
C
      ENDIF
C
      IF( IPM .EQ. 3 ) THEN
C
          DO 30 I=1,3
          DO 30 J=1,3
          DO 30 L=1,3
C
             DO 6 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)  ) = WK3(IVL,I+3*(J-1)  )
     >     + WK2(IVL,L+3*(I-1)  ) * WK1(IVL,J+3*(L-1)  )
     >     - WK2(IVL,L+3*(I-1)+9) * WK1(IVL,J+3*(L-1)+9)
    6        CONTINUE
C
             DO 7 IVL = 1,NVL
             WK3(IVL,I+3*(J-1)+9) = WK3(IVL,I+3*(J-1)+9)
     >     - WK2(IVL,L+3*(I-1)  ) * WK1(IVL,J+3*(L-1)+9)
     >     - WK2(IVL,L+3*(I-1)+9) * WK1(IVL,J+3*(L-1)  )
    7        CONTINUE
C
   30 CONTINUE
C
      ENDIF
C
C
      END
C
C

      SUBROUTINE H1ELEC(NI,NJ,XI,XJ,SMAT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XI(3),XJ(3),SMAT(9,9), BI(9), BJ(9)
C***********************************************************************
C
C  H1ELEC FORMS THE ONE-ELECTRON MATRIX BETWEEN TWO ATOMS.
C
C   ON INPUT    NI   = ATOMIC NO. OF FIRST ATOM.
C               NJ   = ATOMIC NO. OF SECOND ATOM.
C               XI   = COORDINATES OF FIRST ATOM.
C               XJ   = COORDINATES OF SECOND ATOM.
C
C   ON OUTPUT   SMAT = MATRIX OF ONE-ELECTRON INTERACTIONS.
C
C***********************************************************************
      COMMON /BETAS / BETAS(107),BETAP(107),BETAD(107)
      COMMON /BETA3 / BETA3(153)
      COMMON /KEYWRD/ KEYWRD
      COMMON /EULER / TVEC(3,3), ID
      COMMON /VSIPS / VS(107),VP(107),VD(107)
      COMMON /NATORB/ NATORB(107)
      COMMON /UCELL / L1L,L2L,L3L,L1U,L2U,L3U
      DIMENSION SBITS(9,9), LIMS(3,2), XJUC(3)
      CHARACTER*80 KEYWRD
      LOGICAL FIRST
      EQUIVALENCE (L1L,LIMS(1,1))
      DATA ITYPE /1/,FIRST/.TRUE./
      IF(NI.EQ.102.OR.NJ.EQ.102)THEN
         IF(SQRT((XI(1)-XJ(1))**2+
     1        (XI(2)-XJ(2))**2+
     2        (XI(3)-XJ(3))**2) .GT.1.8)THEN
            DO 10 I=1,9
               DO 10 J=1,9
   10       SMAT(I,J)=0.D0
            RETURN
         ENDIF
      ENDIF
      IF(ID.EQ.0) THEN
         CALL DIAT(NI,NJ,XI,XJ,SMAT)
      ELSE
         IF(FIRST)THEN
            FIRST=.FALSE.
            DO 20 I=1,ID
               LIMS(I,1)=-1
   20       LIMS(I,2)= 1
            DO 30 I=ID+1,3
               LIMS(I,1)=0
   30       LIMS(I,2)=0
         ENDIF
         DO 40 I=1,9
            DO 40 J=1,9
   40    SMAT(I,J)=0
         DO 70 I=L1L,L1U
            DO 70 J=L2L,L2U
               DO 70 K=L3L,L3U
                  DO 50 L=1,3
   50             XJUC(L)=XJ(L)+TVEC(L,1)*I+TVEC(L,2)*J+TVEC(L,3)*K
                  CALL DIAT(NI,NJ,XI,XJUC,SBITS)
                  DO 60 L=1,9
                     DO 60 M=1,9
   60             SMAT(L,M)=SMAT(L,M)+SBITS(L,M)
   70    CONTINUE
      ENDIF
   80 GOTO (90,100,110) ITYPE
   90 IF(INDEX(KEYWRD,'MINDO') .NE. 0) THEN
         ITYPE=2
      ELSE
         ITYPE=3
      ENDIF
      GOTO 80
  100 CONTINUE
      II=MAX(NI,NJ)
      NBOND=(II*(II-1))/2+NI+NJ-II
      IF(NBOND.GT.153)GOTO 120
      BI(1)=BETA3(NBOND)*VS(NI)
      BI(2)=BETA3(NBOND)*VP(NI)
      BI(3)=BI(2)
      BI(4)=BI(2)
      BJ(1)=BETA3(NBOND)*VS(NJ)
      BJ(2)=BETA3(NBOND)*VP(NJ)
      BJ(3)=BJ(2)
      BJ(4)=BJ(2)
      GOTO 120
  110 CONTINUE
      BI(1)=BETAS(NI)*0.5D0
      BI(2)=BETAP(NI)*0.5D0
      BI(3)=BI(2)
      BI(4)=BI(2)
      BI(5)=BETAD(NI)*0.5D0
      BI(6)=BI(5)
      BI(7)=BI(5)
      BI(8)=BI(5)
      BI(9)=BI(5)
      BJ(1)=BETAS(NJ)*0.5D0
      BJ(2)=BETAP(NJ)*0.5D0
      BJ(3)=BJ(2)
      BJ(4)=BJ(2)
      BJ(5)=BETAD(NJ)*0.5D0
      BJ(6)=BJ(5)
      BJ(7)=BJ(5)
      BJ(8)=BJ(5)
      BJ(9)=BJ(5)
  120 CONTINUE
      NORBI=NATORB(NI)
      NORBJ=NATORB(NJ)
      IF(NORBI.EQ.9.OR.NORBJ.EQ.9) THEN
C
C    IN THE CALCULATION OF THE ONE-ELECTRON TERMS THE GEOMETRIC MEAN
C    OF THE TWO BETA VALUES IS BEING USED IF ONE OF THE ATOMS
C    CONTAINS D-ORBITALS.
         DO 130 J=1,NORBJ
            DO 130 I=1,NORBI
  130    SMAT(I,J)=-2.0D0*SMAT(I,J)*SQRT(BI(I)*BJ(J))
      ELSE
         DO 140 J=1,NORBJ
            DO 140 I=1,NORBI
  140    SMAT(I,J)=SMAT(I,J)*(BI(I)+BJ(J))
      ENDIF
      RETURN
      END

      SUBROUTINE LINMIN(XPARAM,STEP,PVECT,NVAR,FUNCT,OKF,OKC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(NVAR),PVECT(NVAR)
      COMMON /GRAVEC/ COSINE
      COMMON /NUMCAL/ NUMCAL
C*********************************************************************
C
C  LINMIN DOES A LINE MINIMISATION.
C
C  ON INPUT:  XPARAM = STARTING COORDINATE OF SEARCH.
C             STEP   = STEP SIZE FOR INITIATING SEARCH.
C             PVECT  = DIRECTION OF SEARCH.
C             NVAR   = NUMBER OF VARIABLES IN XPARAM.
C             FUNCT  = INITIAL VALUE OF THE FUNCTION TO BE MINIMIZED.
C             ISOK   = NOT IMPORTANT.
C             COSINE = COSINE OF ANGLE OF CURRENT AND PREVIOUS GRADIENT.
C
C  ON OUTPUT: XPARAM = COORDINATE OF MINIMUM OF FUNCTI0N.
C             STEP   = NEW STEP SIZE, USED IN NEXT CALL OF LINMIN.
C             PVECT  = UNCHANGED, OR NEGATED, DEPENDING ON STEP.
C             FUNCT  = FINAL, MINIMUM VALUE OF THE FUNCTION.
C             OKF    = TRUE IF LINMIN IMPROVED FUNCT, FALSE OTHERWISE.
C             OKC    = TRUE IF LINMIN FOUND THE MINIMUM, FALSE OTHERWISE
C
C**********************************************************************
      COMMON /KEYWRD/ KEYWRD
C
C  THE FOLLOWING COMMON IS USED TO FIND OUT IF A NON-VARIATIONALLY
C  OPTIMIZED WAVE-FUNCTION IS BEING USED.
C
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      CHARACTER*80 KEYWRD
      DIMENSION PHI(3), VT(3)
      DIMENSION XSTOR(MAXPAR)
      INTEGER LEFT,RIGHT,CENTER
      LOGICAL PRINT,OKF,OKC, FULSCF, ASKFUL, HALFE
      DATA ICALCN /0/
      IF (ICALCN.NE.NUMCAL) THEN
         HALFE=(INDEX(KEYWRD,'C.I.') .NE. 0 .OR. NCLOSE.NE.NOPEN)
         ASKFUL=(INDEX(KEYWRD,'FULSCF') .NE. 0)
         DROP=0.00002D0
         IF(INDEX(KEYWRD,'PREC') .NE. 0) DROP=DROP*0.01D0
         IF(INDEX(KEYWRD,'GNORM') .NE. 0)
     1DROP=DROP*MIN(READA(KEYWRD,INDEX(KEYWRD,'GNORM')),1.D0)
         XMAXM  = 0.4D0
         I      = 2
         STEP   = 1.D0
         MAXLIN = 15
         XCRIT  = 0.0001D0
         IF(INDEX(KEYWRD,'FORCE') .NE. 0) THEN
            I=3
            XCRIT=0.00001D0
         ENDIF
         ANGLE=0.8D0
         IF(HALFE) ANGLE=-2.D0
         COSINE=99.99D0
C
C  ANGLE IS USED TO DECIDE IF P IS TO BE UPDATED AS CALCULATION
C        PROCEEDS.
C
         YMAXST  = 0.4D0
         EPS=10**(-I)
         TEE=EPS
         PRINT=(INDEX(KEYWRD,'LINMIN') .NE. 0)
         ICALCN=NUMCAL
      ENDIF
      FULSCF=(ASKFUL.OR.COSINE.GT.ANGLE)
      IF(PRINT) WRITE(6,'(''  FULL SCF CALCULATIONS:'',3X,L1)')FULSCF
      XMAXM=0.D0
      DO 10 I=1,NVAR
         PABS=ABS(PVECT(I))
   10 XMAXM=MAX(XMAXM,PABS)
      XMINM=XMAXM
      XMAXM=YMAXST/XMAXM
      FIN=FUNCT
      SSQLST=FUNCT
      IQUIT=0
      PHI(1)=FUNCT
      VT(1)=0.0D00
      VT(2)=STEP/4.0D00
      IF (VT(2).GT.XMAXM) VT(2)=XMAXM
      FMAX=FUNCT
      FMIN=FUNCT
      STEP=VT(2)
      DO 20 I=1,NVAR
   20 XPARAM(I)=XPARAM(I)+STEP*PVECT(I)
      CALL COMPFG(XPARAM, .TRUE., PHI(2),FULSCF,GRAD,.FALSE.)
      IF(PHI(2).GT.FMAX) FMAX=PHI(2)
      IF(PHI(2).LT.FMIN) FMIN=PHI(2)
      CALL EXCHNG (PHI(2),SQSTOR,ENERGY,ESTOR,XPARAM,XSTOR,
     1STEP,ALFS,NVAR)
      IF (PHI(1).LE.PHI(2)) GO TO 30
      GO TO 40
   30 VT(3)=-VT(2)
      LEFT=3
      CENTER=1
      RIGHT=2
      GO TO 50
   40 VT(3)=2.0D00*VT(2)
      LEFT=1
      CENTER=2
      RIGHT=3
   50 STLAST=VT(3)
      STEP=STLAST-STEP
      DO 60 I=1,NVAR
   60 XPARAM(I)=XPARAM(I)+STEP*PVECT(I)
      CALL COMPFG (XPARAM, .TRUE., FUNCT,FULSCF,GRAD,.FALSE.)
      IF(FUNCT.GT.FMAX) FMAX=FUNCT
      IF(FUNCT.LT.FMIN) FMIN=FUNCT
      IF (FUNCT.LT.SQSTOR) CALL EXCHNG (FUNCT,SQSTOR,ENERGY,
     1ESTOR,XPARAM,XSTOR,STEP,ALFS,NVAR)
      IF (FUNCT.LT.FIN) IQUIT=1
      PHI(3)=FUNCT
      IF (PRINT)WRITE (6,230) VT(1),PHI(1),VT(2),PHI(2),VT(3),PHI(3)
      OKC=.TRUE.
      DO 180 ICTR=3,MAXLIN
         ALPHA=VT(2)-VT(3)
         BETA=VT(3)-VT(1)
         GAMMA=VT(1)-VT(2)
         IF(ABS(ALPHA*BETA*GAMMA) .GT. 1.D-20)THEN
            ALPHA=-(PHI(1)*ALPHA+PHI(2)*BETA+PHI(3)*GAMMA)/(ALPHA*BETA*G
     1AMM   A)
         ELSE
            GOTO 190
         ENDIF
         BETA=((PHI(1)-PHI(2))/GAMMA)-ALPHA*(VT(1)+VT(2))
         IF (ALPHA) 70,70,100
   70    IF (PHI(RIGHT).GT.PHI(LEFT)) GO TO 80
         STEP=3.0D00*VT(RIGHT)-2.0D00*VT(CENTER)
         GO TO 90
   80    STEP=3.0D00*VT(LEFT)-2.0D00*VT(CENTER)
   90    S=STEP-STLAST
         IF (ABS(S).GT.XMAXM) S=SIGN(XMAXM,S)*(1+0.01*(XMAXM/S))
         STEP=S+STLAST
         GO TO 110
  100    STEP=-BETA/(2.0D00*ALPHA)
         S=STEP-STLAST
         XXM=2.0D00*XMAXM
         IF (ABS(S).GT.XXM) S=SIGN(XXM,S)*(1+0.01*(XXM/S))
         STEP=S+STLAST
  110    CONTINUE
         IF (ICTR.LE.3) GO TO 120
         AABS=ABS(S*XMINM)
         IF (AABS.LT.XCRIT) GO TO 190
  120    CONTINUE
         DO 130 I=1,NVAR
  130    XPARAM(I)=XPARAM(I)+S*PVECT(I)
         FUNOLD=FUNCT
         CALL COMPFG (XPARAM, .TRUE., FUNCT,FULSCF,GRAD,.FALSE.)
         IF(FUNCT.GT.FMAX) FMAX=FUNCT
         IF(FUNCT.LT.FMIN) FMIN=FUNCT
         IF (FUNCT.LT.SQSTOR) CALL EXCHNG (FUNCT,SQSTOR,ENERGY,ESTOR,
     1   XPARAM,XSTOR,STEP,ALFS,NVAR)
         IF (FUNCT.LT.FIN) IQUIT=1
         IF (PRINT) WRITE (6,240) VT(LEFT),PHI(LEFT),
     1                            VT(CENTER),PHI(CENTER),
     2                            VT(RIGHT),PHI(RIGHT),STEP,FUNCT
C
C TEST TO EXIT FROM LINMIN IF NOT DROPPING IN VALUE OF FUNCTION FAST.
C
         TINY = MAX((SSQLST-FMIN)*0.2D0 , DROP)
         TINY = MIN(TINY,0.5D0)
         IF(PRINT) WRITE(6,'(''  TINY'',F14.9)')TINY
         IF(ABS(FUNOLD-FUNCT) .LT. TINY .AND. IQUIT .EQ. 1) GOTO 190
         IF ((ABS(STEP-STLAST).LE.EPS*ABS(STEP+STLAST)+TEE).
     1   AND.(IQUIT.EQ.1)) GO TO 190
         STLAST=STEP
         IF ((STEP.GT.VT(RIGHT)).OR.(STEP.GT.VT(CENTER)
     1        .AND.FUNCT.LT.PHI(CENTER)).OR.(STEP.GT.VT(LEFT)
     2        .AND.STEP.LT.VT(CENTER).AND.FUNCT.GT.PHI(CENTER)))
     3         GOTO 140
         VT(RIGHT)=STEP
         PHI(RIGHT)=FUNCT
         GO TO 150
  140    VT(LEFT)=STEP
         PHI(LEFT)=FUNCT
  150    IF (VT(CENTER).LT.VT(RIGHT)) GO TO 160
         I=CENTER
         CENTER=RIGHT
         RIGHT=I
  160    IF (VT(LEFT).LT.VT(CENTER)) GO TO 170
         I=LEFT
         LEFT=CENTER
         CENTER=I
  170    IF (VT(CENTER).LT.VT(RIGHT)) GO TO 180
         I=CENTER
         CENTER=RIGHT
         RIGHT=I
  180 CONTINUE
      OKC=.FALSE.
  190 CONTINUE
      CALL EXCHNG (SQSTOR,FUNCT,ESTOR,ENERGY,XSTOR,XPARAM,
     1             ALFS,STEP,NVAR)
      OKF = (FUNCT.LT.SSQLST)
      IF (FUNCT.GE.SSQLST) RETURN
      IF (STEP) 200,220,220
  200 STEP=-STEP
      DO 210 I=1,NVAR
  210 PVECT(I)=-PVECT(I)
  220 CONTINUE
      RETURN
C
  230 FORMAT ( 11H ---QLINMN ,/5X, 'LEFT   ...',F17.8,F17.11/5X,
     1 'CENTER ...',F17.8,F17.11,/5X, 'RIGHT  ...',F17.8,F17.11,/)
  240 FORMAT (5X,'LEFT    ...',F17.8,F17.11,/5X,'CENTER  ...',
     1F17.8,F17.11,/5X,'RIGHT   ...',F17.8,F17.11,/5X,
     2 'NEW     ...',F17.8,F17.11,/)
C
      END

      SUBROUTINE DIHED(XYZ,I,J,K,L,ANGLE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XYZ(3,*)
*********************************************************************
*
*      DIHED CALCULATES THE DIHEDRAL ANGLE BETWEEN ATOMS I, J, K,
*            AND L.  THE CARTESIAN COORDINATES OF THESE ATOMS
*            ARE IN ARRAY XYZ.
*
*     DIHED IS A MODIFIED VERSION OF A SUBROUTINE OF THE SAME NAME
*           WHICH WAS WRITTEN BY DR. W. THEIL IN 1973.
*
*********************************************************************
      XI1=XYZ(1,I)-XYZ(1,K)
      XJ1=XYZ(1,J)-XYZ(1,K)
      XL1=XYZ(1,L)-XYZ(1,K)
      YI1=XYZ(2,I)-XYZ(2,K)
      YJ1=XYZ(2,J)-XYZ(2,K)
      YL1=XYZ(2,L)-XYZ(2,K)
      ZI1=XYZ(3,I)-XYZ(3,K)
      ZJ1=XYZ(3,J)-XYZ(3,K)
      ZL1=XYZ(3,L)-XYZ(3,K)
C      ROTATE AROUND Z AXIS TO PUT KJ ALONG Y AXIS
      DIST= SQRT(XJ1**2+YJ1**2+ZJ1**2)
      COSA=ZJ1/DIST
      IF(COSA.GT.1.0D0) COSA=1.0D0
      IF(COSA.LT.-1.0D0) COSA=-1.0D0
      DDD=1.0D0-COSA**2
      IF(DDD.LE.0.0) GO TO 10
      YXDIST=DIST* SQRT(DDD)
      IF(YXDIST.GT.1.0D-9) GO TO 20
   10 CONTINUE
      XI2=XI1
      XL2=XL1
      YI2=YI1
      YL2=YL1
      COSTH=COSA
      SINTH=0.D0
      GO TO 30
   20 COSPH=YJ1/YXDIST
      SINPH=XJ1/YXDIST
      XI2=XI1*COSPH-YI1*SINPH
      XJ2=XJ1*COSPH-YJ1*SINPH
      XL2=XL1*COSPH-YL1*SINPH
      YI2=XI1*SINPH+YI1*COSPH
      YJ2=XJ1*SINPH+YJ1*COSPH
      YL2=XL1*SINPH+YL1*COSPH
C      ROTATE KJ AROUND THE X AXIS SO KJ LIES ALONG THE Z AXIS
      COSTH=COSA
      SINTH=YJ2/DIST
   30 CONTINUE
      YI3=YI2*COSTH-ZI1*SINTH
      YL3=YL2*COSTH-ZL1*SINTH
      CALL DANG(XL2,YL3,XI2,YI3,ANGLE)
      IF (ANGLE .LT. 0.) ANGLE=4.0D0* ASIN(1.0D00)+ANGLE
      IF (ANGLE .GE. 6.2831853D0 ) ANGLE=0.D0
      RETURN
      END

      SUBROUTINE XYZGEO(XYZ,NUMAT,NA,NB,NC,DEGREE,GEO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XYZ(3,*), NA(*), NB(*), NC(*), GEO(3,*)
***********************************************************************
*
*   XYZGEO CONVERTS COORDINATES FROM CARTESIAN TO INTERNAL.
*
*     ON INPUT XYZ  = ARRAY OF CARTESIAN COORDINATES
*              NUMAT= NUMBER OF ATOMS
*              NA   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
*                     BY DISTANCE
*              NB   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
*                     BY ANGLE
*              NC   = NUMBERS OF ATOM TO WHICH ATOMS ARE RELATED
*                     BY DIHEDRAL
*
*    ON OUTPUT GEO  = INTERNAL COORDINATES IN ANGSTROMS, RADIANS,
*                     AND RADIANS
*
***********************************************************************
      DO 30 I=2,NUMAT
         J=NA(I)
         K=NB(I)
         L=NC(I)
         IF(I.LT.3) GOTO 30
         II=I
         CALL BANGLE(XYZ,II,J,K,GEO(2,I))
         GEO(2,I)=GEO(2,I)*DEGREE
         IF(I.LT.4) GOTO 30
C
C   MAKE SURE DIHEDRAL IS MEANINGLFUL
C
         CALL BANGLE(XYZ,J,K,L,ANGL)
         TOL=0.2617994D0
         IF(ANGL.GT.3.1415926D0-TOL.OR.ANGL.LT.TOL)THEN
C
C  ANGLE IS UNSATISFACTORY, LET'S SEARCH FOR ANOTHER ATOM FOR
C  DEFINING THE DIHEDRAL.
   10       SUM=100.D0
            DO 20 I1=1,II-1
               R=(XYZ(1,I1)-XYZ(1,K))**2+
     1          (XYZ(2,I1)-XYZ(2,K))**2+
     2          (XYZ(3,I1)-XYZ(3,K))**2
               IF(R.LT.SUM.AND.I1.NE.J.AND.I1.NE.K) THEN
                  CALL BANGLE(XYZ,J,K,I1,ANGL)
                  IF(ANGL.LT.3.1415926D0-TOL.AND.ANGL.GT.TOL)THEN
                     SUM=R
                     L=I1
                     NC(II)=L
                  ENDIF
               ENDIF
   20       CONTINUE
            IF(SUM.GT.99.D0.AND.TOL.GT.0.1D0)THEN
C
C ANYTHING WITHIN 5 DEGREES?
C
               TOL=0.087266D0
               GOTO 10
            ENDIF
         ENDIF
         CALL DIHED(XYZ,II,J,K,L,GEO(3,I))
         GEO(3,I)=GEO(3,I)*DEGREE
   30 GEO(1,I)= SQRT((XYZ(1,I)-XYZ(1,J))**2+
     1                   (XYZ(2,I)-XYZ(2,J))**2+
     2                   (XYZ(3,I)-XYZ(3,J))**2)
      GEO(1,1)=0.D0
      GEO(2,1)=0.D0
      GEO(3,1)=0.D0
      GEO(2,2)=0.D0
      GEO(3,2)=0.D0
      GEO(3,3)=0.D0
      RETURN
      END

C***********************************************************************
C FILE FEICTR.FOR
C
C HISTORY: 23/2/90: COPIED FROM FEICGB.FOR
C                   FEIC16 CHANGED TO FEICTR
C                   EISIF TO SIGEI
C                   RECC, VOLC FOR TRICLINIC GEOMETRY
C                   STATZD AND ITS CODE REMOVED
C                   CPHFX-Z REMOVED WHILST UNUSED
C          25/2/90: OFF-DIAGONAL ELEMENTS IN STRESS TENSOR
C           8/3/90: SIGN OF STRESS-CONTRIB. CHANGED
C***********************************************************************
      SUBROUTINE FEICTR(NGX,NGY,NGZ,NPLWV,CSTRF,RECC,VOLC,DVPS, VPS,
     & SIGEI,CHDEN,LPCTX,LPCTY,LPCTZ,NSPEC,CPSCD,NIONSP,POSION,NIONS)
C=======================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FEICTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE STRESS ON THE UNIT CELL WHICH RESULTS
C FROM TO THE CHANGE IN THE ELECTRON-ION ENERGY ON CHANGING THE BASIS OF
C THE CELL
C                                  dv (G)
C                    -- !        [   I                         ]     *
C     Sigma      = - >     S (G) [ ----- G  G   + v (G) &      ] n(G)
C          Ai,Aj     --     I    [  d(G)  Ai Aj    I     Ai,Aj ]
C                    G,I
C
C=======================================================================
      IMPLICIT COMPLEX (C)
      DIMENSION CSTRF(*)
      DIMENSION RECC(3,3)
      DIMENSION DVPS(*)
      DIMENSION VPS(*)
      DIMENSION SIGEI(*)
      DIMENSION CHDEN(*)
      DIMENSION LPCTX(*),LPCTY(*),LPCTZ(*)
      DIMENSION NIONSP(*)
      DIMENSION POSION(3,*)
C=======================================================================
C
C                  DIMENSION STATEMENTS
C
C CSIGEI = USED TO SUM THE FORCE ON THE UNIT CELL, (THE FORCE ON THE
C UNIT CELL IS REAL BUT CONTRIBUTIONS FROM INDIVIDUAL RECIPROCAL LATTICE
C VECTORS WILL BE COMPLEX, THE SUM OVER ALL G VECTORS MAKES THE FORCE
C REAL
C CPSCD = STRUCTURE FACTOR * CHARGE DENSITY * DERIVATIVE OF THE
C PSEUDOPOTENTIAL ON THE GRID OF RECIPROCAL LATTICE VECTORS
C=======================================================================
      DIMENSION CSIGEI(6)
      DIMENSION CPSCD(*)
      DATA TPI,CI / 6.2831853072,(0.0,1.0) /
C=======================================================================
C THERE ARE TWO CONTRIBUTIONS TO THE FORCE ON THE UNIT CELL DUE TO THE
C ELECTRON-ION ENERGY, ONE DUE TO THE TENDENCY TO PUT THE CHARGE DENSITY
C AT THE LARGEST VALUES OF THE PSEUDOPOTENTIAL AND THE OTHER DUE TO THE
C 1/ATOMIC VOLUME DEPENDENCE OF THE ELECTRON-ION ENERGY (WHICH COMES
C FROM THE DEPENDENCE OF THE MAGNITUDE OF THE IONIC POTENTIAL ON THE
C NUMBER DENSITY OF THE IONS)
C=======================================================================
C INITIALISE THE FORCE ON THE UNIT CELL TO ZERO
C=======================================================================
      DO 6500 M=1,6
      CSIGEI(M)=(0.0,0.0)
 6500 CONTINUE
C=======================================================================
C INITIALISE THE ELECTRON-ION ENERGY CPSCV TO ZERO
C=======================================================================
      CPSCV=0.0
      DO 6501 N=1,NPLWV
      CPSCD(N)=(0.0,0.0)
 6501 CONTINUE
C=======================================================================
C CALCULATE THE STRUCTURE FACTOR * CHARGE DENSITY * DERIVATIVE OF THE
C PSEUDOPOTENTIAL ON THE GRID OF RECIPROCAL LATTICE VECTORS AND THE
C TOTAL ELECTRON-ION ENERGY
C=======================================================================
      DO 6511 NSP=1,NSPEC
      NINDX=NPLWV*(NSP-1)
      DO 6510 N=1,NPLWV
      CPSCD(N)=CPSCD(N)+CSTRF(N+NINDX)*CONJG(CHDEN(N))*DVPS(N+NINDX)
      CPSCV=CPSCV+CSTRF(N+NINDX)*CONJG(CHDEN(N))*VPS(N+NINDX)
 6510 CONTINUE
 6511 CONTINUE
C=======================================================================
C CALCULATE THE CONTRIBUTION TO THE FORCE ON THE UNIT CELL DUE TO THE
C CHANGE IN THE ELECTRON-ION ENERGY THAT RESULTS FROM THE CHANGE IN THE
C MAGNITUDE OF THE PSEUDOPOTENTIAL ON THE RECIPROCAL LATTICE GRID AS THE
C SIZE OF THE CELL CHANGES
C=======================================================================
      NG=1
      DO 6520 N=1,NGZ
      GZX=RECC(3,1)*LPCTZ(N)
      GZY=RECC(3,2)*LPCTZ(N)
      GZZ=RECC(3,3)*LPCTZ(N)
      DO 6521 NN=1,NGY
      GYX=RECC(2,1)*LPCTY(NN)
      GYY=RECC(2,2)*LPCTY(NN)
      GYZ=RECC(2,3)*LPCTY(NN)
      DO 6522 NNN=1,NGX
      GXX=RECC(1,1)*LPCTX(NNN)
      GXY=RECC(1,2)*LPCTX(NNN)
      GXZ=RECC(1,3)*LPCTX(NNN) 
      GX=GXX+GYX+GZX
      GY=GXY+GYY+GZY
      GZ=GXZ+GYZ+GZZ
      GMOD=SQRT((GX**2+GY**2+GZ**2))
C=======================================================================
C THE CONTRIBUTION TO THE FORCE ON THE UNIT CELL FROM THE G=0 PART OF
C THE PSEUDOPOTENTIAL HAS BEEN DEALT WITH IN SUBROUTINE FVP16. THE
C FOLLOWING IF STATEMENT IS PRESENT MERELY TO AVOID A DIVIDE BY ZERO
C ERROR AT G=0
C=======================================================================
      IF(GMOD.LT.0.1) GMOD=1.0
      CSIGEI(1)=CSIGEI(1)+CPSCD(NG)*(GX**2)/GMOD
      CSIGEI(2)=CSIGEI(2)+CPSCD(NG)*(GY**2)/GMOD
      CSIGEI(3)=CSIGEI(3)+CPSCD(NG)*(GZ**2)/GMOD
      CSIGEI(4)=CSIGEI(4)+CPSCD(NG)*GY*GZ/GMOD
      CSIGEI(5)=CSIGEI(5)+CPSCD(NG)*GZ*GX/GMOD
      CSIGEI(6)=CSIGEI(6)+CPSCD(NG)*GX*GY/GMOD
      NG=NG+1
 6522 CONTINUE
 6521 CONTINUE
 6520 CONTINUE
C=======================================================================
C SCALE THE FORCES ON THE UNIT CELL BY 1/SIZEX, ETC AND ADD THE
C CONTRIBUTION TO THE TOTAL FORCE FROM THE 1/(UNIT CELL VOLUME)
C DEPENDENCE OF THE ELECTRON-ION ENERGY
C=======================================================================
      SIGEI(1)=-(REAL(CSIGEI(1))+REAL(CPSCV))/VOLC
      SIGEI(2)=-(REAL(CSIGEI(2))+REAL(CPSCV))/VOLC
      SIGEI(3)=-(REAL(CSIGEI(3))+REAL(CPSCV))/VOLC
      SIGEI(4)=-(REAL(CSIGEI(4))            )/VOLC
      SIGEI(5)=-(REAL(CSIGEI(5))            )/VOLC
      SIGEI(6)=-(REAL(CSIGEI(6))            )/VOLC
      RETURN
      END

      SUBROUTINE INITIA(JDIM,KDIM,Q,PRESS,SNDSP,S,XY,XYJ,
     *                  XIT,ETT,DS,X,Y,SLOPE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4)
      DIMENSION PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION S(JDIM,KDIM,4),XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION XIT(JDIM,KDIM),ETT(JDIM,KDIM),DS(JDIM,KDIM)
      DIMENSION X(JDIM,KDIM),Y(JDIM,KDIM),SLOPE(JDIM)
      COMMON/INFNTY/RHOINF,UINF,VINF,EINF,PINF
C
C
C               COMPUTE VARIOUS CONSTANTS
C
      GAMMA = 1.4
      GAMI = GAMMA -1.
      PI = 4.*ATAN(1.0)
C
      COSANG = COS( PI*ALPHA/180.)
      SINANG = SIN(PI*ALPHA/180.)
      RHOINF = 1.
      UINF   = FSMACH*COSANG
      VINF   = FSMACH*SINANG
      EINF   = 1./(GAMMA*GAMI) + .5*FSMACH**2
      PINF   = 1./GAMMA
C
C              GRID CALCULATION
C
      CALL BICONG(JDIM,KDIM,JMAX,KMAX,JTAIL1,JTAIL2,DYM,THICK,
     1 YMAX,XMAX,XMIN,X,Y)
C
C                INITIALIZE TO FREE STREAM
C
C                LOAD FREE STREAM AT ANGLE OF ATTACK ALPHA
C
      DO 32 K=1,KMAX
      DO 32 J=1,JMAX
         Q(J,K,1) = RHOINF
         Q(J,K,2) = RHOINF*UINF
         Q(J,K,3) = RHOINF*VINF
         Q(J,K,4) = EINF
   32 CONTINUE
C
C
C  SET UP VARIABLES, INDECIES, AND COMPUTE METRICS
C
C
C  JTAIL2 = JMAX  FOR PERIDC   MESHES
C
      IF(PERIDC  )JTAIL2 = JMAX
C
C            SET PERIDC   INDEX
C
      JM = JMAX-1
      KM = KMAX-1
      JBEGIN = 1
      JEND = JMAX
      KBEGIN = 1
      KEND = KMAX
      KLOW = 2
      KUP = KM
      DO 10 J = 1, JMAX
         JPLUS(J) = J+1
         JMINU (J) = J-1
10    CONTINUE
C
      IF ( .NOT.PERIDC    ) THEN
         JPLUS(JMAX) = JMAX
         JMINU (1) = 1
         JLOW = 2
         JUP = JMAX-1
      ELSE
         JPLUS(JMAX) = 1
         JMINU (1) = JMAX
         JLOW = 1
         JUP = JMAX
         JTAIL1 = 1
         JTAIL2 = JMAX
      ENDIF
C
      DO 8 K=1,KMAX
      DO 8 J=1,JMAX
         XIT(J,K) = 0.
         ETT(J,K) = 0.
8     CONTINUE
C
C
C                METRIC CALCULATION
C   S USED FOR WORK SPACE HERE
C
      CALL XYMETS(JDIM,KDIM,X,Y,XY,XIT,ETT,XYJ,S)
C
      DO 9 N=1,4
      DO 9 K=1,KMAX
      DO 9 J=1,JMAX
         S(J,K,N) = 0.
9     CONTINUE
C
C               INITIALIZE VARIABLE TIME STEP IF JACDT=1
C
      FACTOR=1.0
      IF(JACDT.EQ.0) FACTOR=0.0
      DO 65 K=1,KMAX
      DO 65 J=1,JMAX
         DS(J,K)=1.0/(1.0+FACTOR*SQRT(XYJ(J,K)))
   65 CONTINUE
C
C
C               SCALE VARIABLES BY JACOBIAN STORED BY XYMETS IN XYJ(J,K)
C
      DO 50 N=1,4
      DO 50 K=1,KMAX
      DO 50 J=1,JMAX
       Q(J,K,N) = Q(J,K,N)/XYJ(J,K)
   50 CONTINUE
C
C
C  AIRFOIL BODY SLOPE
C
C    USED ONLY IF RUNNING THE BICONVEX AIRFOIL
C
      DO 22 J = 1,JMAX
         SLOPE(J) = 0.0
22    CONTINUE
C
      DO 24 J = JTAIL1,JTAIL2
         XPT = X( J, 1)
         DGDX = 2. * THICK * ( 1. - 2. * XPT )
         SLOPE( J) = ATAN( DGDX)
24    CONTINUE
      DO 26 J = 1,JMAX
         WRITE(*, 25) J, SLOPE(J)
  25     FORMAT(1H ,'****J,SLOPE',I5,2X,E20.8)
  26  CONTINUE
C
C   INITIALIZE PRESS,SNDSP
C
      CALL CALCPS(JDIM,KDIM,Q,PRESS,SNDSP)
C
      RETURN
      END

      SUBROUTINE GRADCO(IXY,JDIM,KDIM,PRESS,XYJ,COEF,PRSS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  IXY = 1  FOR XI  DIRECTION
C  IXY = 2  FOR ETA DIRECTION
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION PRESS(JDIM,KDIM),XYJ(JDIM,KDIM)
      DIMENSION COEF(JDIM,KDIM),PRSS(JDIM,KDIM)
C
       IF(IXY.EQ.1)THEN
C
            JEDGE1 = JLOW
            JEDGE2 = JUP
C       
C   COMPUTE PRESSURE GRAD 
C
      DO 1 K = KBEGIN,KEND
      DO 1 J = JBEGIN,JEND
      COEF(J,K) = 0.
      PRSS(J,K) = PRESS(J,K)*XYJ(J,K)
1     CONTINUE
C
C   BYPASS LOGIC IF DIS2X = 0.0
C
      IF(DIS2X.EQ.0.0)RETURN
C
      DO 2 J = JLOW,JUP
      JPL = JPLUS(J)
      JMI = JMINU (J)
      DO 2 K = KLOW,KUP
      R1 = PRSS(JPL,K) -2.* PRSS(J,K) + PRSS(JMI,K)
      R2 = PRSS(JPL,K) +2.* PRSS(J,K) + PRSS(JMI,K)
      COEF(J,K) = ABS( R1/R2 )
2     CONTINUE
C
C   C MESH BC
C
         IF(.NOT.PERIDC  )THEN
         DO 3 K = KLOW,KUP
         COEF(JBEGIN,K) = COEF(JLOW,K)
         COEF(JEND,K) = COEF(JUP,K)
         PRSS(JBEGIN,K) = COEF(JLOW,K)
         PRSS(JEND,K) = COEF(JUP,K)
3        CONTINUE
         ENDIF
C
C  SMOOTH OUT PRESSURE COEFFICIENT
C
      DO 4 J = JEDGE1,JEDGE2
      JPL = JPLUS(J)
      JPLPL = JPLUS(JPL)
      JMI = JMINU (J)
      DO 4 K = KLOW,KUP
      PRSS(J,K) = MAX( COEF(JMI,K),COEF(J,K),COEF(JPL,K)
     *                    ,COEF(JPLPL,K) )
C-old      PRSS(J,K) = AMAX1( COEF(JMI,K),COEF(J,K),COEF(JPL,K)
C-old     *                    ,COEF(JPLPL,K) )
4     CONTINUE
C
      DO 5 J = JLOW,JUP
      JPL = JPLUS(J)
      JMI = JMINU (J)
      DO 5 K = KLOW,KUP
      COEF(J,K) = 0.5*PRSS(J,K) + 0.25*(PRSS(JPL,K)+PRSS(JMI,K))
5     CONTINUE
C
      IF(.NOT.PERIDC  )THEN
C  TURN OFF SECOND ORDER NEAR TRAILING EDGE
C
C   C MESH BC
C
         DO 12 K = KLOW,KUP
         COEF(JBEGIN,K) = COEF(JLOW,K)
         COEF(JEND,K) = COEF(JUP,K)
12       CONTINUE
C
         ENDIF
C
       ELSEIF(IXY .EQ. 2)THEN
C
C
C  GRADIANT COEFFICENT IN ETA DIRECTION
C
      DO 21 K = KBEGIN,KEND
      DO 21 J = JBEGIN,JEND
      COEF(J,K) = 0.
      PRSS(J,K) = PRESS(J,K)*XYJ(J,K)
21    CONTINUE
C
C   BYPASS LOGIC IF DIS2Y = 0.0
C
      IF(DIS2Y.EQ.0.0)RETURN
C
      DO 22 K = KLOW,KUP
      KPL = K+1
      KMI = K-1
      DO 22 J = JLOW,JUP
      R1 = PRSS(J,KPL) -2.* PRSS(J,K) + PRSS(J,KMI)
      R2 = PRSS(J,KPL) +2.* PRSS(J,K) + PRSS(J,KMI)
      COEF(J,K) = ABS( R1/R2 )
22    CONTINUE
C
C   BC
C
         DO 24 J = JLOW,JUP 
         COEF(J,KBEGIN) = COEF(J,KLOW)
         COEF(J,KEND) = COEF(J,KUP)
         PRSS(J,KBEGIN) = COEF(J,KLOW)
         PRSS(J,KEND) = COEF(J,KUP)
24       CONTINUE
C
C  SMOOTH OUT PRESSURE COEFFICIENT
C
      DO 26 K = KLOW,KUP
      KPL = K+1
      KMI = K-1
      DO 26 J = JLOW,JUP
      PRSS(J,K) = MAX( COEF(J,KMI),COEF(J,K),COEF(J,KPL))
C-old      PRSS(J,K) = AMAX1( COEF(J,KMI),COEF(J,K),COEF(J,KPL))
26    CONTINUE
C
      DO 28 K = KLOW,KUP
      KPL = K+1
      KMI = K-1
      DO 28 J = JLOW,JUP
      COEF(J,K) = 0.5*PRSS(J,K) + 0.25*(PRSS(J,KPL)+PRSS(J,KMI))
28    CONTINUE
C
       ENDIF
C
         RETURN
         END

C     ***************
      SUBROUTINE INIT(
C     ***************
     >                NX,NY,NZ,NT,
     >                NXYZH,NXYTH,NXZTH,NYZTH,
     >                NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >                NXE,NXYE,NXYZE,
     >                NVH,NVE,NXYZ,
     >                SEED,START,
     >                LINKS,WK1,
     >                GCB,GTS,LCB,
     >                GX,GY,GZ,GT,
     >                GXY,GXZ,GXT,GYZ,GYT,GZT,
     >                LX,LY,LZ,LT,
     >                LXY,LXZ,LXT,LYZ,LYT,LZT)
C
C
C     SUBROUTINE INIT  GENERATES  THE INITIAL LATTICE CONFIGURATION AND
C     PREPARES INDEX LISTS FOR GATHERING THE TWO DIFFERENT  CHESS BOARD
C     COLOURS . IT ALTHOUGH GENERATES INDEX LISTS FOR  GATHERING  THOSE
C     LINK  VARIABLES  WHICH  HAVE  TO  BE  EXCHANGED WITH NEIGHBOURING
C     PROCESSES   DURING   THE  LINK   UPDATE.   THE  CHOICE  OF  START
C     CONFIGURATION IS CONTROLED BY THE VARIABLE 'START'  ( 1 : ORDERED
C     START, 0 : DISORDERED START ).  THE   RANDOM  NUMBER GENERATOR IS
C     INITIALIZED BY THE VARIABLE 'SEED'.
C
C
C     LATEST REVISION - NOV. 1989; E.KEHL
C
C
      DOUBLE PRECISION     LINKS(NVE,18,4),
     >                     WK1(NVH,18),
     >                     ZERO,ONE
C
C
      INTEGER  GCB(NVH,2),GTS(NXYZ),
     >         LCB(2),
     >         SEED,START
C
      INTEGER  GX(NYZTH,2,4),GY(NXZTH,2,4),
     >         GZ(NXYTH,2,4),GT(NXYZH,2,4)
C
      INTEGER  GXY(NZTH,2,4),GXZ(NYTH,2,4),
     >         GXT(NYZH,2,4),GYZ(NXTH,2,4),
     >           GYT(NXZH,2,4),GZT(NXYH,2,4)
C
      INTEGER  LX(2,4),LY(2,4),
     >         LZ(2,4),LT(2,4)
C
      INTEGER  LXY(2,4),LXZ(2,4),
     >         LXT(2,4),LYZ(2,4),
     >         LYT(2,4),LZT(2,4)
C
      INTEGER  FX(4),FY(4),FZ(4),FT(4)
C
C
      PARAMETER( ZERO = 0.D0 )
      PARAMETER( ONE  = 1.D0 )
C
C
C     DEFINITION OF STATEMENT FUNCTION LPA (LATTICE POINT ADDRESS):
C
C
      LPA(IX,IY,IZ,IT) = IX + ( IY - 1 ) * NXE + ( IZ - 1 ) * NXYE  +
     >                                           ( IT - 1 ) * NXYZE
C
C
C     INITIALIZATION OF THE RANDOM NUMBER GENERATOR
C
C
      CALL VDRSET(SEED)
C
C
C     GENERATION OF INDEX LISTS FOR GATHERING LINK VARAIABLES OF
C     EVEN OR ODD LATTICE POINTS
C
C
C     **********
      CALL HYPPL(
C     **********
     >           NXE,NXYE,NXYZE,
     >           GCB,LCB,NVH,2,2,2,2,NX+1,NY+1,NZ+1,NT+1 )
C
C
C     GENERATION OF AN INDEX LIST FOR GATHERING THE LOWEST T-SLICE
C
C
      ILP = 0
C
      DO 10 K = 2,NZ+1
      DO 10 J = 2,NY+1
      DO 10 I = 2,NX+1
C
      ILP = ILP + 1
      GTS(ILP) = LPA(I,J,K,2)
C
   10 CONTINUE
C
C
C     GENERATION OF INDEX LISTS FOR SENDING (RECEIVING) HYPERPLANES
C
C
      FX(1) = NX + 1
      FX(2) = 2
      FX(3) = 1
      FX(4) = NX + 2
C
      FY(1) = NY + 1
      FY(2) = 2
      FY(3) = 1
      FY(4) = NY + 2
C
      FZ(1) = NZ + 1
      FZ(2) = 2
      FZ(3) = 1
      FZ(4) = NZ + 2
C
      FT(1) = NT + 1
      FT(2) = 2
      FT(3) = 1
      FT(4) = NT + 2
C
C
C     **********
      CALL HYP3D(
C     **********
     >           NX,NY,NZ,NT,
     >           NXYZH,NXYTH,NXZTH,NYZTH,
     >           NXE,NXYE,NXYZE,
     >           GX,GY,GZ,GT,
     >           LX,LY,LZ,LT,
     >           FX,FY,FZ,FT )
C
C
C     **********
      CALL HYP2D(
C     **********
     >           NX,NY,NZ,NT,
     >           NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >           NXE,NXYE,NXYZE,
     >           GXY,GXZ,GXT,GYZ,GYT,GZT,
     >           LXY,LXZ,LXT,LYZ,LYT,LZT,
     >           FX,FY,FZ,FT )
C
C
C     GENERATION OF START CONFIGURATION
C
C
      DO 15 ILD = 1,4
      DO 15 ISM = 1,18
      DO 15 IVL = 1,NVE
   15 LINKS(IVL,ISM,ILD) = ZERO
C
C
      IF( START .EQ. 1 ) THEN
C
C
C         ORDERED START
C
C
          DO 20 ILD = 1,4
          DO 20 L   = 2,NT+1
          DO 20 K   = 2,NZ+1
          DO 20 J   = 2,NY+1
          DO 20 I   = 2,NX+1
C
             LPX = LPA(I,J,K,L)
C
             LINKS(LPX,1,ILD) = ONE
             LINKS(LPX,5,ILD) = ONE
             LINKS(LPX,9,ILD) = ONE
C
  20      CONTINUE
C
      ENDIF
C
      IF( START .EQ. 0 ) THEN
C
C
C         DISORDERED START
C
C
          DO 30 ILD = 1,4
          DO 30 ICC = 1,2
C
C
C            RANDOM CHOICE OF THE FIRST TWO COLUMNS OF WK1
C
C
             DO 40 ISM = 1,6
                CALL VDRAND( NVH,WK1(1,ISM  ) )
                CALL VDRAND( NVH,WK1(1,ISM+9) )
   40        CONTINUE
C
C
C         ***********
          CALL RENORM( NVH,WK1 )
C         ***********
C
C
          NVL = LCB(ICC)
C         ***********
          CALL SCATER( NVE,NVL,LINKS(1,1,ILD),NVH,WK1,GCB(1,ICC),0 )
C         ***********
C
C
   30     CONTINUE
C
      ENDIF
C
C
      RETURN
      END

      SUBROUTINE ITER  (H, W, WJ, WK, EE, FULSCF,RAND)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DOUBLE PRECISION MECI
      DIMENSION H(*), W(*), WJ(*), WK(*)
      COMMON /FOKMAT/ F(MPACK), FB(MPACK)
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /VECTOR/ C(MORB2),EIGS(MAXORB),CBETA(MORB2),EIGB(MAXORB)
      COMMON /GRADNT/ DUMY(MAXPAR),GNORM
      COMMON /LAST  / LAST
      COMMON /MESAGE/ IFLEPO,IITER
      COMMON /ATHEAT/ ATHEAT
      COMMON /ENUCLR/ ENUCLR
      COMMON /CITERM/ XI,XJ,XK
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /NUMCAL/ NUMCAL
      COMMON /TIMEMP/ TIME0
      LOGICAL FULSCF, RAND
      REAL WJ, WK
C***********************************************************************
C
C     ITER GENERATES A SCF FIELD AND RETURNS THE ENERGY IN "ENERGY"
C
C THE MAIN ARRAYS USED IN ITER ARE:
C            P      ONLY EVER CONTAINS THE TOTAL DENSITY MATRIX
C            PA     ONLY EVER CONTAINS THE ALPHA DENSITY MATRIX
C            PB     ONLY EVER CONTAINS THE BETA DENSITY MATRIX
C            C      ONLY EVER CONTAINS THE EIGENVECTORS
C            H      ONLY EVER CONTAINS THE ONE-ELECTRON MATRIX
C            F      STARTS OFF CONTAINING THE ONE-ELECTRON MATRIX,
C                   AND IS USED TO HOLD THE FOCK MATRIX
C            W      ONLY EVER CONTAINS THE TWO-ELECTRON MATRIX
C
C THE MAIN INTEGERS CONSTANTS IN ITER ARE:
C
C            LINEAR SIZE OF PACKED TRIANGLE = NORBS*(NORBS+1)/2
C
C THE MAIN INTEGER VARIABLES ARE
C            NITER  NUMBER OF ITERATIONS EXECUTED
C
C  PRINCIPAL REFERENCES:
C
C   ON MNDO: "GROUND STATES OF MOLECULES. 38. THE MNDO METHOD.
C             APPROXIMATIONS AND PARAMETERS."
C             DEWAR, M.J.S., THIEL,W., J. AM. CHEM. SOC.,99,4899,(1977).
C   ON SHIFT: "THE DYNAMIC 'LEVEL SHIFT' METHOD FOR IMPROVING THE
C             CONVERGENCE OF THE SCF PROCEDURE", A. V. MITIN, J. COMP.
C             CHEM. 9, 107-110 (1988)
C   ON HALF-ELECTRON: "MINDO/3 COMPARISON OF THE GENERALIZED S.C.F.
C             COUPLING OPERATOR AND "HALF-ELECTRON" METHODS FOR
C             CALCULATING THE ENERGIES AND GEOMETRIES OF OPEN SHELL
C             SYSTEMS"
C             DEWAR, M.J.S., OLIVELLA, S., J. CHEM. SOC. FARA. II,
C             75,829,(1979).
C   ON PULAY'S CONVERGER: "CONVERGANCE ACCELERATION OF ITERATIVE
C             SEQUENCES. THE CASE OF SCF ITERATION", PULAY, P.,
C             CHEM. PHYS. LETT, 73, 393, (1980).
C   ON CNVG:  IT ENCORPORATES THE IMPROVED ITERATION SCHEME (IIS) BY
C             PIOTR BADZIAG & FRITZ SOLMS. ACCEPTED FOR PUBLISHING
C             IN COMPUTERS & CHEMISTRY
C   ON PSEUDODIAGONALISATION: "FAST SEMIEMPIRICAL CALCULATIONS",
C             STEWART. J.J.P., CSASZAR, P., PULAY, P., J. COMP. CHEM.,
C             3, 227, (1982)
C
C***********************************************************************
      DIMENSION POLD(MPACK), POLD2(MPACK), POLD3(MAXORB+400)
      DIMENSION PBOLD(MPACK), PBOLD2(MPACK), PBOLD3(MAXORB+400)
************************************************************************
*                                                                      *
*   IF, FOR ANY REASON, ITER FAILS TO GENERATE AN SCF, THEN UNCOMMENT  *
*   ALL LINES THAT BEGIN WITH A ''.  THE EFFECT OF DOING THIS IS TO  *
*   INCREASE THE STORAGE REQUIREMENT BY ABOUT 20% AND TO ALLOW PULAY'S *
*   AND CAMP AND KING'S CONVERGERS TO BE USED.                         *
*                                                                      *
************************************************************************
      DIMENSION  AR1(2*NPULAY), AR2(2*NPULAY), AR3(2*NPULAY),
     1 AR4(2*NPULAY)
      DIMENSION  BR1(2*NPULAY), BR2(2*NPULAY), BR3(2*NPULAY),
     1 BR4(2*NPULAY)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,
     2                NALPHA, NBETA, NCLOSE, NOPEN, NDUMY, FRACT
     3      /MOLORB/ DUMMY(MAXORB),PDIAG(MAXORB)
     4      /KEYWRD/ KEYWRD
     5      /NUMSCF/ NSCF
      CHARACTER KEYWRD*80, ABPRT(3)*5
      LOGICAL PRTFOK,PRTEIG,PRTDEN, DEBUG, PRTENG, TIMES, CI
     1,UHF, NEWDG, SCF1, HALFE, FORCE, PRT1EL,PRTPL, OKNEWD
     2,EXCITD, MINPRT, FRST, BFRST, OKPULY, READY, PRTVEC,
     3CAMKIN, ALLCON, MAKEA, MAKEB, INCITR, CAPPS
      DATA ICALCN/0/, DEBUG/.FALSE./, PRTFOK/.FALSE./
      DATA PRTEIG/.FALSE./,PRTDEN,PRTENG/.FALSE.,.FALSE./
      DATA PRT1EL/.FALSE./
      DATA ABPRT/'     ','ALPHA',' BETA'/
C
C  INITIALIZE
C
      IFILL=0
      IHOMO=MAX(1,NCLOSE+NALPHA)
      IHOMOB=MAX(1,NCLOSE+NBETA)
      EOLD=1.D2
      READY=.FALSE.
      IF (ICALCN.NE.NUMCAL) THEN
         CALL EPSETA(EPS,ETA)
C
C  ULTIMATE SCF CRITERION: HEAT OF FORMATION CONVERGED WITHIN A FACTOR
C  OF 10 OF THE LIMITING PRECISION OF THE COMPUTER
C
         EPS=23.061D0*EPS*2.D0
         SHIFT=0.D0
         ICALCN=NUMCAL
         SHFMAX=20.D0
         LINEAR=(NORBS*(NORBS+1))/2
C
C    DEBUG KEY-WORDS WORKED OUT
C
         DEBUG=( INDEX(KEYWRD,'DEBUG') .NE. 0 )
         MINPRT=(INDEX(KEYWRD,'SADDLE')+
     1      LATOM .EQ.0 .OR. DEBUG)
         PRTEIG=( INDEX(KEYWRD,'EIGS') .NE. 0 )
         PRTENG=( INDEX(KEYWRD,'ENERGY').NE.0 )
         PRTPL =( INDEX(KEYWRD,' PL ')  .NE.0 )
         PRT1EL=( INDEX(KEYWRD,'1ELEC') .NE.0 .AND. DEBUG)
         PRTDEN=( INDEX(KEYWRD,'DENS').NE.0 .AND. DEBUG)
         PRTFOK=( INDEX(KEYWRD,'FOCK') .NE. 0  .AND. DEBUG)
         PRTVEC=( INDEX(KEYWRD,'VECT') .NE. 0  .AND. DEBUG)
         DEBUG=( INDEX(KEYWRD,'ITER') .NE. 0 )
C
C INITIALIZE SOME LOGICALS AND CONSTANTS
C
         NEWDG =.FALSE.
         PL    =1.D0
         BSHIFT=-15.D0
         SHIFT=1.D0
*
* SCFCRT AND PLTEST ARE MACHINE-PRECISION DEPENDENT
*
         SCFCRT=1.D-6
         PLTEST=0.0001D0
         ITRMAX = 200
         NMOS=0
         NCIS=0
         NA2EL=NCLOSE
         NA1EL=NALPHA+NOPEN
         NB2EL=0
         NB1EL=NBETA+NOPEN
C
C  USE KEY-WORDS TO ASSIGN VARIOUS CONSTANTS
C
         IF(INDEX(KEYWRD,'C.I.').NE.0)
     1      NMOS=READA(KEYWRD,INDEX(KEYWRD,'C.I.')+5)
         IF(INDEX(KEYWRD,'MICROS').NE.0)
     1      NCIS=READA(KEYWRD,INDEX(KEYWRD,'MICROS'))
         IF(INDEX(KEYWRD,'FILL').NE.0)
     1      IFILL=-READA(KEYWRD,INDEX(KEYWRD,'FILL'))
         IF(INDEX(KEYWRD,'SHIFT').NE.0)
     1      BSHIFT=-READA(KEYWRD,INDEX(KEYWRD,'SHIFT'))
         IF(BSHIFT.NE.0)TEN=BSHIFT
         IF(INDEX(KEYWRD,'ITRY').NE.0)
     1      ITRMAX=READA(KEYWRD,INDEX(KEYWRD,'ITRY'))
         CAMKIN=(INDEX(KEYWRD,'KING')+INDEX(KEYWRD,'CAMP') .NE. 0)
         CI=(INDEX(KEYWRD,'MICROS')+INDEX(KEYWRD,'C.I.') .NE. 0)
         OKPULY=.FALSE.
         OKPULY=(INDEX(KEYWRD,'PULAY').NE.0)
         UHF=(INDEX(KEYWRD,'UHF') .NE. 0)
         SCF1=(INDEX(KEYWRD,'1SCF') .NE. 0)
         OKNEWD=ABS(BSHIFT) .LT. 0.001D0
         IF(CAMKIN.AND.ABS(BSHIFT).GT.1.D-5) BSHIFT=4.44D0
         EXCITD=(INDEX(KEYWRD,'EXCITED') .NE. 0)
         TIMES=(INDEX(KEYWRD,'TIMES') .NE. 0)
         FORCE=(INDEX(KEYWRD,'FORCE') .NE. 0)
         ALLCON=(OKPULY.OR.CAMKIN)
C
C   SET UP C.I. PARAMETERS
C   NMOS IS NO. OF M.O.S USED IN C.I.
C   NCIS IS CHANGE IN SPIN, OR NUMBER OF STATES
C
         IF(NMOS.EQ.0) NMOS=NOPEN-NCLOSE
         IF(NCIS.EQ.0) THEN
            IF(INDEX(KEYWRD,'TRIPLET')+INDEX(KEYWRD,'QUART').NE.0)NCIS=1
            IF(INDEX(KEYWRD,'QUINTET')+INDEX(KEYWRD,'SEXTE').NE.0)NCIS=2
         ENDIF
C
C   DO WE NEED A CAPPED ATOM CORRECTION?
C
         CAPPS=.FALSE.
         DO 10 I=1,NUMAT
   10    IF(NAT(I).EQ.102)CAPPS=.TRUE.
         IITER=1
         TRANS=0.1D0
         IF(INDEX(KEYWRD,'RESTART')+INDEX(KEYWRD,'OLDENS')
     1      .NE. 0) THEN
            IF(INDEX(KEYWRD,'OLDENS').NE.0)
CDEP
     1   OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old     1   OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
            REWIND 10
            READ(10)(PA(I),I=1,LINEAR)
            IF( UHF) THEN
               READ(10)(PB(I),I=1,LINEAR)
               DO 20 I=1,LINEAR
                  POLD(I)=PA(I)
                  PBOLD(I)=PB(I)
   20          P(I)=PA(I)+PB(I)
            ELSE
               DO 30 I=1,LINEAR
                  PB(I)=PA(I)
                  PBOLD(I)=PA(I)
                  POLD(I)=PA(I)
   30          P(I)=PA(I)*2.D0
            ENDIF
         ELSE
            NSCF=0
            DO 40 I=1,LINEAR
               P(I)=0.D0
               PA(I)=0.D0
   40       PB(I)=0.D0
            W1=NA1EL/(NA1EL+1.D-6+NB1EL)
            W2=1.D0-W1
            IF(W1.LT.1.D-6)W1=0.5D0
            IF(W2.LT.1.D-6)W2=0.5D0
            RANDOM=1.0D0
            IF(UHF.AND.NA1EL.EQ.NB1EL) RANDOM=1.1D0
            DO 50 I=1,NORBS
               J=(I*(I+1))/2
               P(J)=PDIAG(I)
               PA(J)=P(J)*W1*RANDOM
               RANDOM=1.D0/RANDOM
   50       PB(J)=P(J)*W2*RANDOM
            DO 60 I=1,LINEAR
               PBOLD(I)=PB(I)
   60       POLD(I)=PA(I)
         ENDIF
         HALFE=(NOPEN .NE. NCLOSE)
C
C   DETERMINE THE SELF-CONSISTENCY CRITERION
C
         IF( HALFE .OR.  INDEX(KEYWRD,'PREC') .NE. 0)
     3                               SCFCRT=SCFCRT*0.01D0
         IF( INDEX(KEYWRD,'POLAR') + INDEX(KEYWRD,'NLLSQ') +
     2 INDEX(KEYWRD,'SIGMA') .NE. 0) SCFCRT=SCFCRT*0.001D0
         IF(FORCE)                   SCFCRT=SCFCRT*0.0001D0
         SCFCRT=MAX(SCFCRT,1.D-12)
C
C  THE USER CAN STATE THE SCF CRITERION, IF DESIRED.
C
         I=INDEX(KEYWRD,'SCFCRT')
         IF(I.NE.0) THEN
            SCFCRT=READA(KEYWRD,I)
            WRITE(6,'(''  SCF CRITERION ='',G14.4)')SCFCRT
            IF(SCFCRT.LT.1.D-12)
     1 WRITE(6,'(//2X,'' THERE IS A RISK OF INFINITE LOOPING WITH'',
     2'' THE SCFCRT LESS THAN 1.D-12'')')
         ELSE
            IF(DEBUG)WRITE(6,'(''  SCF CRITERION ='',G14.4)')SCFCRT
         ENDIF
         LAST=0
C
C   END OF INITIALIZATION SECTION.
C
      ELSEIF(FORCE)THEN
C
C   RESET THE DENSITY MATRIX IF MECI HAS FORMED AN EXCITED STATE
C   SUM IS NOT USED
C
         SUM=MECI(EIGS,C,CBETA,EIGB, NORBS,NMOS,1,.FALSE.)
      ENDIF
C
C   INITIALIZATION OPERATIONS DONE EVERY TIME ITER IS CALLED
C
      MAKEA=.TRUE.
      MAKEB=.TRUE.
      IF(NEWDG) NEWDG=(ABS(BSHIFT).LT.0.001D0)
      IF(LAST.EQ.1) NEWDG=.FALSE.
      SELCON=SCFCRT*23.061
      IF(PLTEST.LT.SCFCRT) PLTEST=SCFCRT
      IF(NALPHA.NE.NBETA.OR..NOT.UHF)PLTEST=0.001D0
      IF(.NOT. FORCE .AND. .NOT. HALFE) THEN
         IF(GNORM.GT.5.D0) SELCON=SCFCRT*GNORM*0.2D0
         IF(GNORM.GT.200.D0) SELCON=SCFCRT*50.D0
      ENDIF
      IF(DEBUG)WRITE(6,'(''  SELCON, GNORM'',2G16.7)')SELCON,GNORM
      TITER1=ZECOND()
      IF(PRT1EL) THEN
         WRITE(6,'(//10X,''ONE-ELECTRON MATRIX AT ENTRANCE TO ITER'')')
         CALL VECPRT(H,NORBS)
      ENDIF
      IREDY=1
   70 NITER=0
      TIME1=ZECOND()
      FRST=.TRUE.
      IF(CAMKIN) THEN
         MODEA=1
         MODEB=1
      ELSE
         MODEA=0
         MODEB=0
      ENDIF
      BFRST=.TRUE.
**********************************************************************
*                                                                    *
*                                                                    *
*                START THE SCF LOOP HERE                             *
*                                                                    *
*                                                                    *
**********************************************************************
      INCITR=.TRUE.
   80 INCITR=(MODEA.NE.3.AND.MODEB.NE.3)
      IF(INCITR)NITER=NITER+1
      IF(NITER.GT.ITRMAX-10.AND..NOT.ALLCON) THEN
************************************************************************
*                                                                      *
*                   SWITCH ON ALL CONVERGERS                           *
*                                                                      *
************************************************************************
         WRITE(6,'(//,'' ALL CONVERGERS ARE NOW FORCED ON'',/
     1          '' SHIFT=10, PULAY ON, CAMP-KING ON'',/
     2          '' AND ITERATION COUNTER RESET'',//)')
         ALLCON=.TRUE.
         BSHIFT=4.44D0
         IREDY=-4
         EOLD=100.D0
         OKPULY=.TRUE.
         NEWDG=.FALSE.
         CAMKIN=(.NOT.HALFE)
         GOTO 70
      ENDIF
************************************************************************
*                                                                      *
*                        MAKE THE ALPHA FOCK MATRIX                    *
*                                                                      *
************************************************************************
      IF(ABS(SHIFT).GT.1.D-10.AND.BSHIFT .NE. 0.D0) THEN
         L=0
         IF(NITER.GT.1)THEN
            IF(NEWDG.AND..NOT.(HALFE.OR.CAMKIN))THEN
C
C  SHIFT WILL APPLY TO THE VIRTUAL ENERGY LEVELS USED IN THE
C  PSEUDODIAGONALIIZATION. IF DIFF IS -VE, GOOD, THEN LOWER THE
C  HOMO-LUMO GAP BY 0.1EV, OTHERWISE INCREASE IT.
               IF(DIFF.GT.0)THEN
               SHIFT=1.D0
C
C IF THE PSEUDODIAGONALIZATION APPROXIMATION -- THAT THE WAVEFUNCTION
C IS ALMOST STABLE -- IS INVALID, TURN OFF NEWDG
               IF(DIFF.GT.1)NEWDG=.FALSE.
               ELSE
               SHIFT=-0.1D0
               ENDIF
            ELSE
               SHIFT=TEN+EIGS(IHOMO+1)-EIGS(IHOMO)+SHIFT
            ENDIF
            IF(DIFF.GT.0.D0) THEN
               IF(SHIFT.GT.4.D0)SHFMAX=4.5D0
               IF(SHIFT.GT.SHFMAX)SHFMAX=MAX(SHFMAX-0.5D0,0.D0)
            ENDIF
C
C   IF SYSTEM GOES UNSTABLE, LIMIT SHIFT TO THE RANGE -INFINITY - SHFMAX
C   BUT IF SYSTEM IS STABLE, LIMIT SHIFT TO THE RANGE -INFINITY - +20
C
            SHIFT=MAX(-20.D0,MIN(SHFMAX,SHIFT))
            IF(ABS(SHIFT-SHFMAX).LT.1.D-5)SHFMAX=SHFMAX+0.01D0
C
C  THE CAMP-KING AND PULAY CONVERGES NEED A CONSTANT SHIFT.
C  IF THE SHIFT IS ALLOWED TO VARY, THESE CONVERGERS WILL NOT
C  WORK PROPERLY.
C
            IF(OKPULY.OR.ABS(BSHIFT-4.44D0).LT.1.D-5)THEN
            SHIFT=-8.D0
            IF(NEWDG) SHIFT=0
            ENDIF
            IF(UHF)THEN
               IF(NEWDG.AND..NOT.(HALFE.OR.CAMKIN))THEN
                  SHIFTB=TEN-TENOLD
               ELSE
                  SHIFTB=TEN+EIGS(IHOMOB+1)-EIGS(IHOMOB)+SHIFTB
               ENDIF
               IF(DIFF.GT.0.D0)SHIFTB=MIN(4.D0,SHIFTB)
               SHIFTB=MAX(-20.D0,MIN(SHFMAX,SHIFTB))
               IF(OKPULY.OR.ABS(BSHIFT-4.44D0).LT.1.D-5)THEN
               SHIFTB=-8.D0
               IF(NEWDG)SHIFT=0
               ENDIF
C#       WRITE(6,*)'SHIFT:',SHIFT,SHIFTB
               DO 90 I=IHOMOB+1,NORBS
   90          EIGB(I)=EIGB(I)+SHIFTB
            ELSE
C#       WRITE(6,*)'SHIFT:',SHIFT
            ENDIF
         ENDIF
         TENOLD=TEN
         DO 100 I=IHOMO+1,NORBS
  100    EIGS(I)=EIGS(I)+SHIFT
         DO 120 I=1,NORBS
            DO 110 J=1,I
               L=L+1
  110       F(L)=H(L)+SHIFT*PA(L)
  120    F(L)=F(L)-SHIFT
      ELSEIF (RAND.AND.LAST.EQ.0.AND.NITER.LT.2.AND.FULSCF)THEN
         RANDOM=0.001D0
         DO 130 I=1,LINEAR
            RANDOM=-RANDOM
  130    F(I)=H(I)+RANDOM
      ELSE
         DO 140 I=1,LINEAR
  140    F(I)=H(I)
      ENDIF
  150 CALL FOCK2(F,P,PA,W, WJ, WK,NUMAT,NFIRST,NMIDLE,NLAST)
      CALL FOCK1(F,P,PA,PB)
************************************************************************
*                                                                      *
*                        MAKE THE BETA FOCK MATRIX                     *
*                                                                      *
************************************************************************
      IF (UHF) THEN
         IF(SHIFTB .NE. 0.D0) THEN
            L=0
            DO 170 I=1,NORBS
               DO 160 J=1,I
                  L=L+1
  160          FB(L)=H(L)+SHIFTB*PB(L)
  170       FB(L)=FB(L)-SHIFTB
         ELSEIF (RAND.AND.LAST.EQ.0.AND.NITER.LT.2.AND.FULSCF)THEN
            RANDOM=0.001
            DO 180 I=1,LINEAR
               RANDOM=-RANDOM
  180       FB(I)=H(I)+RANDOM
         ELSE
            DO 190 I=1,LINEAR
  190       FB(I)=H(I)
         ENDIF
         CALL FOCK2(FB,P,PB,W, WJ, WK,NUMAT,NFIRST,NMIDLE,NLAST)
         CALL FOCK1(FB,P,PB,PA)
      ENDIF
      IF( .NOT. FULSCF) GOTO 290
      IF(PRTFOK) THEN
         WRITE(6,200)NITER
  200    FORMAT('   FOCK MATRIX ON ITERATION',I3)
         CALL VECPRT (F,NORBS)
      ENDIF
************************************************************************
*                                                                      *
*                        CALCULATE THE ENERGY IN KCAL/MOLE             *
*                                                                      *
************************************************************************
      EE=HELECT(NORBS,PA,H,F)
      IF(UHF)THEN
         EE=EE+HELECT(NORBS,PB,H,FB)
      ELSE
         EE=EE*2.D0
      ENDIF
      IF(CAPPS)EE=EE+CAPCOR(NAT,NFIRST,NLAST,NUMAT,P,H)
      SCORR=SHIFT*(NOPEN-NCLOSE)*23.061D0*0.25D0*(FRACT*(2.D0-FRACT))
      ESCF=(EE+ENUCLR)*23.061D0+ATHEAT+SCORR
      SELLIM=MAX(SELCON,EPS*MAX(ABS(EE),1.D0))
      IF(INCITR)THEN
         DIFF=ESCF-EOLD
         IF(DIFF.GT.0)THEN
            TEN=TEN-1.D0
         ELSE
            TEN=TEN*0.975D0+0.05D0
         ENDIF
C#         WRITE(6,'(2F12.6)')TEN,DIFF
         IF(NITER.GT.4.AND.(PL.EQ.0.D0.OR.PL.LT.PLTEST.AND.
     1   ABS(DIFF/MAX(1.D0,ABS(EE))).LT.SELLIM) .AND. READY) THEN
************************************************************************
*                                                                      *
*          SELF-CONSISTENCY TEST, EXIT MODE FROM ITERATIONS            *
*                                                                      *
************************************************************************
            IF (ABS(SHIFT) .LT. 1.D-10) GOTO 290
            SHIFT=0.D0
            SHIFTB=0.D0
            DO 210 I=1,LINEAR
  210       F(I)=H(I)
            MAKEA=.TRUE.
            MAKEB=.TRUE.
            GOTO 150
         ENDIF
        READY=(IREDY.GT.0.AND.(ABS(DIFF).LT.SELLIM*10.D0.OR.PL.EQ.0.D0))
        IREDY=IREDY+1
      ENDIF
      IF(PRTPL.OR.DEBUG.AND.NITER.GT.ITRMAX-20) THEN
         IF(ABS(ESCF).GT.99999.D0) ESCF=SIGN(9999.D0,ESCF)
         IF(ABS(DIFF).GT.9999.D0)DIFF=0.D0
         IF(INCITR)
     1    WRITE(6,'('' ITERATION'',I3,'' PLS='',2E10.3,'' ENERGY  '',
     2F14.7,'' DELTAE'',F13.7)')NITER,PL,PLB,ESCF,DIFF
      ENDIF
      IF(INCITR)EOLD=ESCF
************************************************************************
*                                                                      *
*                        INVOKE THE CAMP-KING CONVERGER                *
*                                                                      *
************************************************************************
      IF(NITER.GT.2 .AND. CAMKIN .AND. MAKEA)
     1CALL INTERP(NORBS,NA1EL,NORBS-NA1EL, MODEA, ESCF/23.061D0,
     2F, C, AR1, AR2, AR3, AR4, AR1)
      MAKEB=.FALSE.
      IF(MODEA.EQ.3)GOTO 230
      MAKEB=.TRUE.
      IF( NEWDG ) THEN
************************************************************************
*                                                                      *
*                        INVOKE PULAY'S CONVERGER                      *
*                                                                      *
************************************************************************
         IF(OKPULY.AND.MAKEA.AND.IREDY.GT.1)
     1CALL PULAY(F,PA,NORBS,POLD,POLD2,POLD3,JALP,IALP,MPACK,FRST,PL)
************************************************************************
*                                                                      *
*           DIAGONALIZE THE ALPHA OR RHF SECULAR DETERMINANT           *
* WHERE POSSIBLE, USE THE PULAY-STEWART METHOD, OTHERWISE USE BEPPU'S  *
*                                                                      *
************************************************************************
         IF (HALFE.OR.CAMKIN) THEN
            CALL RSP(F,NORBS,NORBS,EIGS,C)
         ELSE
            CALL DIAG (F,C,NA1EL,EIGS,NORBS,NORBS)
         ENDIF
      ELSE
         CALL RSP(F,NORBS,NORBS,EIGS,C)
      ENDIF
      J=1
      IF(PRTVEC) THEN
         J=1
         IF(UHF)J=2
         WRITE(6,'(//10X,A,
     1'' EIGENVECTORS AND EIGENVALUES ON ITERATION'',I3)')
     2   ABPRT(J),NITER
         CALL MATOUT(C,EIGS,NORBS,NORBS,NORBS)
      ELSE
         IF (PRTEIG) WRITE(6,220)ABPRT(J),NITER,(EIGS(I),I=1,NORBS)
      ENDIF
  220 FORMAT(10X,A,'  EIGENVALUES ON ITERATION',I3,/10(6G13.6,/))
  230 IF(IFILL.NE.0)CALL SWAP(C,NORBS,NORBS,NA2EL,IFILL)
************************************************************************
*                                                                      *
*            CALCULATE THE ALPHA OR RHF DENSITY MATRIX                 *
*                                                                      *
************************************************************************
      IF(UHF)THEN
         CALL DENSIT( C,NORBS, NORBS, NA2EL,NA1EL, FRACT, PA, 1)
         IF(MODEA.NE.3.AND..NOT. (NEWDG.AND.OKPULY))
     1    CALL CNVG(PA, POLD, POLD2, NORBS, NITER, PL)
      ELSE
         CALL DENSIT( C,NORBS, NORBS, NA2EL,NA1EL, FRACT, P, 1)
         IF(MODEA.NE.3.AND..NOT. (NEWDG.AND.OKPULY))
     1    CALL CNVG(P, POLD, POLD2, NORBS, NITER, PL)
      ENDIF
************************************************************************
*                                                                      *
*                       UHF-SPECIFIC CODE                              *
*                                                                      *
************************************************************************
      IF( UHF )THEN
************************************************************************
*                                                                      *
*                        INVOKE THE CAMP-KING CONVERGER                *
*                                                                      *
************************************************************************
         IF(NITER.GT.2 .AND. CAMKIN .AND. MAKEB )
     1CALL INTERP(NORBS,NB1EL,NORBS-NB1EL, MODEB, ESCF/23.061D0,
     2FB, CBETA, BR1, BR2, BR3, BR4, BR1)
         MAKEA=.FALSE.
         IF(MODEB.EQ.3) GOTO 240
         MAKEA=.TRUE.
         IF( NEWDG ) THEN
************************************************************************
*                                                                      *
*                        INVOKE PULAY'S CONVERGER                      *
*                                                                      *
************************************************************************
            IF( OKPULY.AND.MAKEB.AND.IREDY.GT.1)
     1CALL PULAY(FB,PB,NORBS,PBOLD,PBOLD2,
     2PBOLD3,JBET,IBET,MPACK,BFRST,PLB)
************************************************************************
*                                                                      *
*           DIAGONALIZE THE ALPHA OR RHF SECULAR DETERMINANT           *
* WHERE POSSIBLE, USE THE PULAY-STEWART METHOD, OTHERWISE USE BEPPU'S  *
*                                                                      *
************************************************************************
            IF (HALFE.OR.CAMKIN) THEN
               CALL RSP(FB,NORBS,NORBS,EIGB,CBETA)
            ELSE
               CALL DIAG (FB,CBETA,NB1EL,EIGB,NORBS,NORBS)
            ENDIF
         ELSE
            CALL RSP(FB,NORBS,NORBS,EIGB,CBETA)
         ENDIF
         IF(PRTVEC) THEN
            WRITE(6,'(//10X,A,'' EIGENVECTORS AND EIGENVALUES ON '',
     1''ITERATION'',I3)')ABPRT(3),NITER
            CALL MATOUT(CBETA,EIGB,NORBS,NORBS,NORBS)
         ELSE
            IF (PRTEIG) WRITE(6,220)ABPRT(3),NITER,(EIGB(I),I=1,NORBS)
         ENDIF
************************************************************************
*                                                                      *
*                CALCULATE THE BETA DENSITY MATRIX                     *
*                                                                      *
************************************************************************
  240    CALL DENSIT( CBETA,NORBS, NORBS, NB2EL, NB1EL, FRACT, PB, 1)
         IF( .NOT. (NEWDG.AND.OKPULY))
     1CALL CNVG(PB, PBOLD, PBOLD2, NORBS, NITER, PLB)
      ENDIF
************************************************************************
*                                                                      *
*                   CALCULATE THE TOTAL DENSITY MATRIX                 *
*                                                                      *
************************************************************************
      IF(UHF) THEN
         DO 250 I=1,LINEAR
  250    P(I)=PA(I)+PB(I)
      ELSE
         DO 260 I=1,LINEAR
            PA(I)=P(I)*0.5D0
  260    PB(I)=PA(I)
      ENDIF
      IF(PRTDEN) THEN
         WRITE(6,'('' DENSITY MATRIX ON ITERATION'',I4)')NITER
         CALL VECPRT (P,NORBS)
      ENDIF
      OKNEWD=(PL.LT.SELLIM .OR. OKNEWD)
      NEWDG=(PL.LT.TRANS .AND. OKNEWD .OR. NEWDG)
      IF(PL.LT.TRANS*0.3333D0)OKNEWD=.TRUE.
      IF (NITER .GE. ITRMAX) THEN
         IF(DIFF.LT.1.D-3.AND.PL.LT.1.D-4.AND..NOT.FORCE)THEN
            WRITE(6,'('' """""""""""""""UNABLE TO ACHIEVE SELF-CONSISTEN
     1CE, JOB CONTINUING'')')
            GOTO 290
         ENDIF
         IF(MINPRT)WRITE (6,270)
  270    FORMAT (//10X,'"""""""""""""UNABLE TO ACHIEVE SELF-CONSISTENCE'
     1,/)
         WRITE (6,280) DIFF,PL
  280    FORMAT (//,10X,'DELTAE= ',E12.4,5X,'DELTAP= ',E12.4,///)
         IFLEPO=9
         IITER=2
         CALL VWRITE (TIME0,ESCF)
         CALL WRAPUP()
      ENDIF
      GO TO 80
**********************************************************************
*                                                                    *
*                                                                    *
*                      END THE SCF LOOP HERE                         *
*                NOW CALCULATE THE ELECTRONIC ENERGY                 *
*                                                                    *
*                                                                    *
**********************************************************************
*          SELF-CONSISTENCE ACHEIVED.
*
  290 EE=HELECT(NORBS,PA,H,F)
      IF(UHF) THEN
         EE=EE+HELECT(NORBS,PB,H,FB)
      ELSE
         EE=EE*2.D0 +
     1SHIFT*(NOPEN-NCLOSE)*23.061D0*0.25D0*(FRACT*(2.D0-FRACT))
      ENDIF
      IF(CAPPS)EE=EE+CAPCOR(NAT,NFIRST,NLAST,NUMAT,P,H)
C
C   NORMALLY THE EIGENVALUES ARE INCORRECT BECAUSE THE
C   PSEUDODIAGONALIZATION HAS BEEN USED.  IF THIS
C   IS THE LAST SCF, THEN DO AN EXACT DIAGONALIZATION
      IF( NSCF.EQ.0 .OR. LAST.EQ.1 .OR. CI .OR. HALFE ) THEN
C
C  PUT F AND FB INTO POLD IN ORDER TO NOT DESTROY F AND FB
C  AND DO EXACT DIAGONALISATIONS
         DO 300 I=1,LINEAR
  300    POLD(I)=F(I)
         CALL RSP(POLD,NORBS,NORBS,EIGS,C)
         IF(UHF) THEN
            DO 310 I=1,LINEAR
  310       POLD(I)=FB(I)
            CALL RSP(POLD,NORBS,NORBS,EIGB,CBETA)
         ENDIF
         DO 320 I=1,LINEAR
  320    POLD(I)=P(I)
         IF(CI.OR.HALFE) THEN
            SUM=MECI(EIGS,C,CBETA,EIGB, NORBS,NMOS,0,.FALSE.)
            EE=EE+SUM
            IF(PRTPL)THEN
               ESCF=(EE+ENUCLR)*23.061 +ATHEAT
               WRITE(6,'(27X,''AFTER MECI, ENERGY  '',F14.7)')ESCF
            ENDIF
         ENDIF
      ENDIF
      NSCF=NSCF+1
      TITER2=ZECOND()
      IF(TIMES) WRITE(6,'('' TIME FOR SCF CALCULATION'',F8.2,
     1''    INTEGRAL'',F8.2)')TITER2-TITER1,TITER2-TIME0
      IF(DEBUG)WRITE(6,'('' NO. OF ITERATIONS ='',I6)')NITER
C            IF(FORCE)  SCFCRT=1.D-5
      IF(ALLCON.AND.ABS(BSHIFT-4.44D0).LT.1.D-7)THEN
         CAMKIN=.FALSE.
         ALLCON=.FALSE.
         NEWDG=.FALSE.
         BSHIFT=-10.D0
         OKPULY=.FALSE.
      ENDIF
      SHIFT=1.D0
      RETURN
C
      END

      SUBROUTINE DIAT(NI,NJ,XI,XJ,DI)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
************************************************************************
*
*   DIAT CALCULATES THE DI-ATOMIC OVERLAP INTEGRALS BETWEEN ATOMS
*        CENTERED AT XI AND XJ.
*
*   ON INPUT NI  = ATOMIC NUMBER OF THE FIRST ATOM.
*            NJ  = ATOMIC NUMBER OF THE SECOND ATOM.
*            XI  = CARTESIAN COORDINATES OF THE FIRST ATOM.
*            XJ  = CARTESIAN COORDINATES OF THE SECOND ATOM.
*
*  ON OUTPUT DI  = DIATOMIC OVERLAP, IN A 9 * 9 MATRIX. LAYOUT OF
*                  ATOMIC ORBITALS IN DI IS
*                  1   2   3   4   5            6     7       8     9
*                  S   PX  PY  PZ  D(X**2-Y**2) D(XZ) D(Z**2) D(YZ)D(XY)
*
*   LIMITATIONS:  IN THIS FORMULATION, NI AND NJ MUST BE LESS THAN 107
*         EXPONENTS ARE ASSUMED TO BE PRESENT IN COMMON BLOCK EXPONT.
*
************************************************************************
      COMMON /KEYWRD/KEYWRD
      CHARACTER*80 KEYWRD
      INTEGER A,PQ2,B,PQ1,AA,BB
      LOGICAL FIRST, ANALYT
      COMMON /EXPONT/ EMUS(107),EMUP(107),EMUD(107)
      DIMENSION DI(9,9),S(3,3,3),UL1(3),UL2(3),C(3,5,5),NPQ(107)
     1          ,XI(3),XJ(3), SLIN(27), IVAL(3,5)
     2, C1(3,5), C2(3,5), C3(3,5), C4(3,5), C5(3,5)
     3, S1(3,3), S2(3,3), S3(3,3)
      EQUIVALENCE(SLIN(1),S(1,1,1))
      EQUIVALENCE (C1(1,1),C(1,1,1)), (C2(1,1),C(1,1,2)),
     1            (C3(1,1),C(1,1,3)), (C4(1,1),C(1,1,4)),
     2            (C5(1,1),C(1,1,5)), (S1(1,1),S(1,1,1)),
     3            (S2(1,1),S(1,1,2)), (S3(1,1),S(1,1,3))
      DATA NPQ/1,0, 2,2,2,2,2,2,2,0, 0,3,3,3,3,3,3,0, 0,4,4,4,4,4,4,4,
     14,4,4,4,4,4,4,4,4,0, 5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5
     2,32*6,15*0,3,5*0/
      DATA IVAL/1,0,9,1,3,8,1,4,7,1,2,6,0,0,5/
      DATA FIRST /.TRUE./
      ANALYT=(INDEX(KEYWRD,'ANALYT').NE.0)
      X1=XI(1)
      X2=XJ(1)
      Y1=XI(2)
      Y2=XJ(2)
      Z1=XI(3)
      Z2=XJ(3)
      PQ1=NPQ(NI)
      PQ2=NPQ(NJ)
      DO 20 I=1,9
         DO 10 J=1,9
            DI(I,J)=0.0D0
   10    CONTINUE
   20 CONTINUE
      CALL COE(X1,Y1,Z1,X2,Y2,Z2,PQ1,PQ2,C,R)
      IF(PQ1.EQ.0.OR.PQ2.EQ.0.OR.R.GE.10.D0) RETURN
      IF(R.LT.0.001)THEN
         RETURN
      ENDIF
      IA=MIN(PQ1,3)
      IB=MIN(PQ2,3)
      A=IA-1
      B=IB-1
      IF(ANALYT)THEN
         CALL GOVER(NI,NJ,XI,XJ,R,DI)
C#      WRITE(6,*)' OVERLAP FROM GOVER'
C#      WRITE(6,'(4F15.10)')SG
         RETURN
      ENDIF
      IF(NI.LT.18.AND.NJ.LT.18) THEN
         CALL DIAT2(NI,EMUS(NI),EMUP(NI),R,NJ,EMUS(NJ),EMUP(NJ),S)
      ELSE
         UL1(1)=EMUS(NI)
         UL2(1)=EMUS(NJ)
         UL1(2)=EMUP(NI)
         UL2(2)=EMUP(NJ)
         UL1(3)=MAX(EMUD(NI),0.3D0)
         UL2(3)=MAX(EMUD(NJ),0.3D0)
         DO 30 I=1,27
   30    SLIN(I)=0.0D0
         NEWK=MIN(A,B)
         NK1=NEWK+1
         DO 40 I=1,IA
            ISS=I
            IB=B+1
            DO 40 J=1,IB
               JSS=J
               DO 40 K=1,NK1
                  IF(K.GT.I.OR.K.GT.J) GOTO 40
                  KSS=K
                  S(I,J,K)=SS(PQ1,PQ2,ISS,JSS,KSS,UL1(I),UL2(J),R,FIRST)
   40    CONTINUE
      ENDIF
      DO 50 I=1,IA
         KMIN=4-I
         KMAX=2+I
         DO 50 J=1,IB
            IF(J.EQ.2)THEN
               AA=-1
               BB=1
            ELSE
               AA=1
               IF(J.EQ.3) THEN
                  BB=-1
               ELSE
                  BB=1
               ENDIF
            ENDIF
            LMIN=4-J
            LMAX=2+J
            DO 50 K=KMIN,KMAX
               DO 50 L=LMIN,LMAX
                  II=IVAL(I,K)
                  JJ=IVAL(J,L)
                  DI(II,JJ)=S1(I,J)*C3(I,K)*C3(J,L)*AA+
     1(C4(I,K)*C4(J,L)+C2(I,K)*C2(J,L))*BB*S2(I,J)+(C5(I,K)*C5(J,L)
     2+C1(I,K)*C1(J,L))*S3(I,J)
   50 CONTINUE
C#      WRITE(6,*)' OVERLAP FROM DIAT2'
C#      DO 12 I=1,4
C#  12  WRITE(6,'(4F15.10)')(DI(J,I),J=1,4)
      RETURN
      END

C----------------------------------------------------------------------
C
C  THIS PROGRAM COMPUTES LUNAR AND PLANETARY EPHEMERIDES.
C  THE LUNAR EPHEMERIS IS COMPUTED AT ONE HOUR INTERVALS,
C  PLANETARY EPHEMERIS AT ONE DAY INTERVALS.
C  THE ORIGINAL PROGRAM STORES THE RESULTS INTO A BINARY FILE.
C  THIS  MODIFIED VERSION WRITES OUT ONLY A SMALL
C  FRACTION OF THE COMPUTED VALUES. THE TIME INTERVAL AND
C  INITIAL COORDINATES ARE GIVEN IN THE PROGRAM;
C  NO INPUT DATA IS NEEDED.
C  ALL WRITE STATEMENTS ARE OF THE FORM  WRITE (*, '(...)') ...
C
C
C  THE ORIGINAL PROGRAM WAS WRITTEN IN BURROUGHS EXTENDED ALGOL,
C  AND LATER CONVERTED TO VAX FORTRAN. 
C  IN THE FOLLOWING PROGRAM ALL NON-STANDARD FEATURES
C  (THERE WERE QUITE A FEW OF THEM) HAVE BEEN CHANGED TO
C  STANDARD FORTRAN77 STRUCTURES; ALSO, ALL GLOBAL ENVIRONMENTS,
C  PREVIOUSLY CONTAINED IN SEPARATE INCLUDE-FILES, HAVE BEEN
C  INSERTED INTO THE SOURCE. THESE MODIFICATIONS HOPEFULLY 
C  EXPLAIN SOME OF THE ODDITIES 
C
C
C----------------------------------------------------------------------
      PROGRAM  EPHEM
      INTEGER DAYNUM
      INTEGER D1,D2,NDAY1,NDAY2
C-old      PARAMETER(NDAY1=2000,NDAY2=6000)
      PARAMETER(NDAY1=1000,NDAY2=10000)
C
C  SET THE TIME INTERVAL
C  THE LUNAR EPHEMERIS IS COMPUTED FOR A PERIOD OF NDAY1
C  BEGINNING IN JANUARY 1, 1983.
C  THE PLANETARY EPHEMERIS IS COMPUTED FOR NDAY2 DAYS
C  TO CHANGE THE REQUIRED CPU-TIME, SIMPLY CHANGE NDAY1 OR NDAY2.
C  IF NDAY2 > 10000 YOU HAVE TO CHANGE ALSO MAXDAY
C  IN THE PARAMETER STATEMENTS IN SOME OTHER MODULES
C
      D1 = DAYNUM (1983,1,1)
C
      CALL INITIM(0)
      CALL INITIM(1)
      CALL INIT
      CALL SHOTIM(1)
      CALL INITIM(2)
      CALL MOON   (D1, D1+NDAY1)
      CALL SHOTIM(2)
      CALL INITIM(3)
      CALL PLANET (D1, D1+NDAY2)
      CALL SHOTIM(3)
      CALL SHOTIM(0)
      STOP
      END

       SUBROUTINE YPENT2(JDIM,KDIM,A,B,C,D,E,X,Y,F,KL,KU,JL,JU)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DOUBLE PRECISION LD,LD1,LD2,LDI
       DIMENSION A(JDIM,KDIM),B(JDIM,KDIM),C(JDIM,KDIM),D(JDIM,KDIM),
     *           E(JDIM,KDIM),X(JDIM,KDIM),Y(JDIM,KDIM),F(JDIM,KDIM,2)
C
C      ! START FORWARD GENERATION PROCESS AND SWEEP
C
        K = KL
        DO 10 J = JL,JU
        LD = C(J,K)
        LDI = 1./LD
        F(J,K,1) = F(J,K,1)*LDI
        F(J,K,2) = F(J,K,2)*LDI
        X(J,K) = D(J,K)*LDI
        Y(J,K) = E(J,K)*LDI
10      CONTINUE
C
        K = KL+1
        DO 20 J = JL,JU
        LD1 = B(J,K)
        LD = C(J,K) - LD1*X(J,K-1)
        LDI = 1./LD
        F(J,K,1) = (F(J,K,1) - LD1*F(J,K-1,1))*LDI
        F(J,K,2) = (F(J,K,2) - LD1*F(J,K-1,2))*LDI
        X(J,K) = (D(J,K) - LD1*Y(J,K-1))*LDI
        Y(J,K) = E(J,K)*LDI
20      CONTINUE
C
            DO 1 K = KL+2,KU-2
                DO 11 J = JL,JU
                LD2 = A(J,K)
                LD1 = B(J,K) - LD2*X(J,K-2)
                LD = C(J,K) - (LD2*Y(J,K-2) + LD1*X(J,K-1))
                LDI = 1./LD
                F(J,K,1) = (F(J,K,1) - LD2*F(J,K-2,1) - 
     *                     LD1*F(J,K-1,1))*LDI
                F(J,K,2) = (F(J,K,2) - LD2*F(J,K-2,2) - 
     *                     LD1*F(J,K-1,2))*LDI
                X(J,K) = (D(J,K) - LD1*Y(J,K-1))*LDI        
                Y(J,K) = E(J,K)*LDI
11              CONTINUE
1            CONTINUE
C
        K = KU-1
        DO 12 J = JL,JU
        LD2 = A(J,K)
        LD1 = B(J,K) - LD2*X(J,K-2)
        LD = C(J,K) - (LD2*Y(J,K-2) + LD1*X(J,K-1))
        LDI = 1./LD
        F(J,K,1) = (F(J,K,1) - LD2*F(J,K-2,1) - LD1*F(J,K-1,1))*LDI
        F(J,K,2) = (F(J,K,2) - LD2*F(J,K-2,2) - LD1*F(J,K-1,2))*LDI
        X(J,K) = (D(J,K) - LD1*Y(J,K-1))*LDI
12      CONTINUE
C
                K = KU
                DO 22 J = JL,JU
                LD2 = A(J,K)
                LD1 = B(J,K) - LD2*X(J,K-2)
                LD = C(J,K) - (LD2*Y(J,K-2) + LD1*X(J,K-1))
                LDI = 1./LD
                F(J,K,1) = (F(J,K,1) - LD2*F(J,K-2,1) - 
     *                     LD1*F(J,K-1,1))*LDI
                F(J,K,2) = (F(J,K,2) - LD2*F(J,K-2,2) - 
     *                      LD1*F(J,K-1,2))*LDI
22              CONTINUE
C
C        !  BACK SWEEP SOLUTION
C
        DO 32 J = JL,JU
        F(J,KU,1) = F(J,KU,1)
        F(J,KU,2) = F(J,KU,2)
        F(J,KU-1,1) = F(J,KU-1,1) - X(J,KU-1)*F(J,KU,1)
        F(J,KU-1,2) = F(J,KU-1,2) - X(J,KU-1)*F(J,KU,2)
32      CONTINUE
C
        DO 2 K = 2,KU-KL
           KX = KU-K
           DO 13 J = JL,JU
           F(J,KX,1) = F(J,KX,1) - X(J,KX)*F(J,KX+1,1) - 
     *                 Y(J,KX)*F(J,KX+2,1)
           F(J,KX,2) = F(J,KX,2) - X(J,KX)*F(J,KX+1,2) - 
     *                 Y(J,KX)*F(J,KX+2,2)
13         CONTINUE
2       CONTINUE
C
        RETURN
        END

      FUNCTION BABBBC(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION IOCCA1(NMOS), IOCCB1(NMOS), IOCCA2(NMOS), IOCCB2(NMOS)
***********************************************************************
*
* BABBBC EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
*       BY ONE BETA ELECTRON. THAT IS, ONE MICROSTATE HAS A BETA
*       ELECTRON IN PSI(I) AND THE OTHER MICROSTATE HAS AN ELECTRON IN
*       PSI(J).
***********************************************************************
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      COMMON /BASEOC/ OCCA(NMECI)
      DO 10 I=1,NMOS
   10 IF(IOCCB1(I).NE.IOCCB2(I)) GOTO 20
   20 IJ=0
      DO 30 J=I+1,NMOS
         IF(IOCCB1(J).NE.IOCCB2(J)) GOTO 40
   30 IJ=IJ+IOCCA1(J)+IOCCB1(J)
   40 IJ=IJ+IOCCA1(J)
C
C   THE UNPAIRED M.O.S ARE I AND J
      SUM=0.D0
      DO 50 K=1,NMOS
   50 SUM=SUM+ (XY(I,J,K,K)-XY(I,K,J,K))*(IOCCB1(K)-OCCA(K)) +
     1          XY(I,J,K,K)             *(IOCCA1(K)-OCCA(K))
      BABBBC=SUM*((-1)**(IJ-(IJ/2)*2))
      RETURN
      END

      DOUBLE PRECISION FUNCTION DIGIT(STRING,ISTART)
C     FORTRAN FUNCTION TO CONVERT NUMERIC FIELD TO DOUBLE PRECISION
C     NUMBER.  THE STRING IS ASSUMED TO BE CLEAN (NO INVALID DIGIT
C     OR CHARACTER COMBINATIONS FROM ISTART TO THE FIRST NONSPACE,
C     NONDIGIT, NONSIGN, AND NONDECIMAL POINT CHARACTER).
C
      CHARACTER STRING*(*)
      DOUBLE PRECISION C1,C2,DECIML
      LOGICAL SIGN
C
C     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
      I0=ICHAR('0')
      I9=ICHAR('9')
      INEG=ICHAR('-')
      IPOS=ICHAR('+')
      IDOT=ICHAR('.')
      ISPC=ICHAR(' ')
C
      C1=0.D0
      C2=0.D0
      SIGN=.TRUE.
      L=LEN(STRING)
C
C     DETERMINE THE CONTRIBUTION TO THE NUMBER GREATER THAN ONE
      IDIG=0
      DO 10 I=ISTART,L
         N=ICHAR(STRING(I:I))
         IF(N.GE.I0.AND.N.LE.I9)THEN
            IDIG=IDIG+1
            C1=C1*1.D1+N-I0
         ELSEIF(N.EQ.INEG.OR.N.EQ.IPOS.OR.N.EQ.ISPC)THEN
            IF(N.EQ.INEG)SIGN=.FALSE.
         ELSEIF(N.EQ.IDOT)THEN
            GOTO 20
         ELSE
            GOTO 40
         ENDIF
   10 CONTINUE
C
C     DETERMINE THE CONTRIBUTION TO THE NUMBER LESS THAN THAN ONE
   20 DECIML=1.D0
      DO 30 J=I+1,L
         N=ICHAR(STRING(J:J))
         IF(N.GE.I0.AND.N.LE.I9)THEN
            DECIML=DECIML/1.D1
            C2=C2+(N-I0)*DECIML
         ELSEIF(N.NE.ISPC)THEN
            GOTO 40
         ENDIF
   30 CONTINUE
C
C     PUT THE PIECES TOGETHER
   40 DIGIT=C1+C2
      IF(.NOT.SIGN)DIGIT=-DIGIT
      RETURN
      END

      SUBROUTINE Y12MCF(N,Z,A,SNR,NN,RNR,NN1,PIVOT,B,HA,IHA, AFLAG,IFLAG
     *,IFAIL)
C
C  SYSTEMS OF LINEAR EQUATIONS ARE SOLVED BY USE OF SPARSE MATRIX TECH-
C  NIQUE AND BY GAUSSIAN ELIMINATION.
C
      IMPLICIT DOUBLE PRECISION(A-B,G,P,T-Y),INTEGER(C,F,H-N,R-S,Z)
      DOUBLE PRECISION A(NN),B(N),PIVOT(N),AFLAG(8)
C
C  INFORMATION WHICH IS NECESSARY TO BEGIN THE ELIMINATION IS STORED.
C
      INTEGER SNR(NN),RNR(NN1),HA(IHA,11), IFLAG(10)
      IFAIL=0
      IF(IFLAG(1).NE.-1)IFAIL=2
      IF(AFLAG(1).LT.1.0D0)AFLAG(1)=1.0005 D0
      IF(AFLAG(3).LT.1.0D+5)AFLAG(3)=1.0D+5
      IF(AFLAG(4).LT.0.0D0)AFLAG(4)=-AFLAG(4)
      IF(IFLAG(2).LT.1)IFAIL=19
      IF(IFLAG(3).LT.0.OR.IFLAG(3).GT.2)IFAIL=20
      IF(IFLAG(5).LT.1.OR.IFLAG(5).GT.3)IFAIL=21
      IF(IFLAG(5).EQ.3)IFAIL=22
      IF(IFAIL.GT.0)GO TO 1110
      SNR(Z+1)=0
      RNR(Z+1)=0
      N8=N+1
      N7=N-1
      U=AFLAG(1)
      GRMIN=AFLAG(4)*AFLAG(6)
C
C  USE THE INFORMATION ABOUT FILL-INS IF IT IS POSSIBLE.
C
      ZZ=Z
      NR=N*N
      IF(IFLAG(4).NE.2)GO TO 100
      IF(IFLAG(10).GT.NN)GO TO 50
      L1=IFLAG(10)
      L5=L1+1
      IF(L5.LE.NN)SNR(L5)=0
      DO 40 I=1,N
      L=N8-I
      L2=HA(L,3)+1
      L3=L2-HA(L,1)
      DO 10 J=1,L3
      SNR(L5-J)=SNR(L2-J)
   10 A(L5-J)=A(L2-J)
      HA(L,3)=L1
      HA(L,1)=L5-L3
      L6=L1-L3
      L5=L5-HA(L,9)
      IF(L5.GT.L6)GO TO 30
      DO 20 J=L5,L6
   20 SNR(J)=0
   30 CONTINUE
   40 L1=L5-1
   50 IF(IFLAG(9).GT.NN1)GO TO 100
      L2=IFLAG(9)
      L5=L2+1
      IF(L5.LE.NN1)RNR(L5)=0
      DO 90 I=1,N
      L=N8-I
      L1=HA(L,6)+1
      L4=L1-HA(L,4)
      DO 60 J=1,L4
   60 RNR(L5-J)=RNR(L1-J)
      HA(L,4)=L5-L4
      HA(L,6)=L2
      L6=L2-L4
      L5=L5-HA(L,10)
      IF(L5.GT.L6)GO TO 80
      DO 70 J=L5,L6
   70 RNR(J)=0
   80 CONTINUE
   90 L2=L5-1
  100 R4=HA(N,3)
      R5=HA(N,6)
      AFLAG(7)=AFLAG(6)
      AFLAG(8)=AFLAG(6)
      DO 110 I=1,N
      PIVOT(I)=0.0 D0
      HA(I,2)=HA(I,1)
  110 HA(I,5)=HA(I,4)
      INDEX=HA(N,8)
C
C  START OF GAUSSIAN ELIMINATION.
C
      SLUT=HA(INDEX,3)-HA(INDEX,2)+1
      DO 950 I=1,N7
      RR3=HA(I,2)
      RR4=HA(I,3)
      C1=HA(I,4)
      CR4=HA(I,6)
      IF(IFLAG(3).EQ.0)GO TO 350
      IF(IFLAG(4).NE.2)GO TO 120
      RROW=HA(I,7)
      RCOLL=HA(I,8)
      GO TO 220
  120 L4=HA(I,8)
      IF(IFLAG(3).EQ.1)GO TO 130
      RROW=L4
      RCOLL=RROW
      RPIVOT=I
      GO TO 170
  130 R=NR
      V=0.0 D0
      INDEX=IFLAG(2)
      DO 160 KK=1,INDEX
      L1=I-1+KK
      IF(L1.GT.N)GO TO 170
      J=HA(L1,8)
      R7=HA(J,2)
      R8=HA(J,3)
      R9=R8-R7
      T=0.0 D0
      DO 140 K=R7,R8
      TD=DABS(A(K))
  140 IF(T.LT.TD)T=TD
      T=T/U
      DO 160 K=R7,R8
      TD=DABS(A(K))
      IF(TD.LT.T)GO TO 150
      R6=SNR(K)
      R3=R9*(HA(R6,6)-HA(R6,5))
      IF(R3.GT.R)GO TO 150
      IF(R3.LT.R)GO TO 151
      IF(V.GE.TD)GO TO 150
  151 V=TD
      RROW=J
      RCOLL=R6
      R=R3
      RPIVOT=L1
  150 CONTINUE
  160 CONTINUE
  170 R3=HA(RCOLL,10)
      HA(RCOLL,10)=HA(I,10)
      HA(I,10)=R3
      R3=HA(RROW,9)
      HA(RROW,9)=HA(I,9)
C
C  REMOVE THE PIVOT ROW OF THE LIST WHERE THE ROWS ARE ORDERED BY
C  INCREASING NUMBERS OF NON-ZERO ELEMENTS.
C
      HA(I,9)=R3
      L1=0
      L=I
      L2=HA(L4,3)-HA(L4,2)+1
  180 L=L+1
      IF(L2.GT.L1)HA(L2,11)=L
      IF(L.GT.N)GO TO 190
      L5=HA(L,8)
      L3=HA(L5,3)-HA(L5,2)+1
      IF(RPIVOT.LT.L)GO TO 190
      HA(L4,7)=L
      HA(L,8)=L4
      L4=L5
      L1=L2
      L2=L3
      L3=N8
      GO TO 180
  190 IF(L2.EQ.L1)GO TO 200
      IF(L3.EQ.L2)GO TO 200
      HA(L2,11)=0
  200 L5=HA(I,7)
      IF(RROW.EQ.I)GO TO 210
      HA(L5,8)=RROW
      HA(RROW,7)=L5
  210 HA(I,7)=RROW
C
C  ROW INTERCHANGES.
C
      HA(I,8)=RCOLL
  220 IF(RROW.EQ.I)GO TO 290
      T=B(RROW)
      B(RROW)=B(I)
      B(I)=T
      DO 250 J=RR3,RR4
      L1=SNR(J)
      R=HA(L1,5)-1
      R10=HA(L1,6)
  240 R=R+1
      IF(RNR(R).NE.I)GO TO 240
      RNR(R)=RNR(R10)
  250 RNR(R10)=RROW
      RR3=HA(RROW,2)
      RR4=HA(RROW,3)
      DO 270 J=RR3,RR4
      L1=SNR(J)
      R=HA(L1,5)-1
  260 R=R+1
      IF(RNR(R).NE.RROW)GO TO 260
  270 RNR(R)=I
      DO 280 J=1,3
      R3=HA(RROW,J)
      HA(RROW,J)=HA(I,J)
C
C  COLUMN INTERCHANGES.
C
  280 HA(I,J)=R3
  290 IF(RCOLL.EQ.I)GO TO 350
      DO 310 J=C1,CR4
      L1=RNR(J)
      R=HA(L1,2)-1
      R10=HA(L1,3)
  300 R=R+1
      IF(SNR(R).NE.I)GO TO 300
      T=A(R10)
      A(R10)=A(R)
      A(R)=T
      SNR(R)=SNR(R10)
  310 SNR(R10)=RCOLL
      C1=HA(RCOLL,4)
      CR4=HA(RCOLL,6)
      DO 330 J=C1,CR4
      L1=RNR(J)
      R=HA(L1,2)-1
  320 R=R+1
      IF(SNR(R).NE.RCOLL)GO TO 320
  330 SNR(R)=I
      DO 340 J=4,6
      R3=HA(RCOLL,J)
      HA(RCOLL,J)=HA(I,J)
C
C END OF THE INTERCHANGES.
C THE ROW ORDERED LIST AND THE COLUMN ORDERED LIST ARE PREPARED TO
C BEGIN STEP I OF THE ELIMINATION.
C
  340 HA(I,J)=R3
  350 R9=RR4-RR3
      DO 360 RR=RR3,RR4
      IF(SNR(RR).EQ.I)GO TO 370
  360 CONTINUE
      IFAIL=9
      GO TO 1110
  370 V=A(RR)
      PIVOT(I)=V
      TD=DABS(V)
      IF(TD.LT.AFLAG(8))AFLAG(8)=TD
      IF(TD.GE.GRMIN)GO TO 380
      IFAIL=3
      GO TO 1110
  380 R2=HA(I,1)
      A(RR)=A(RR3)
      SNR(RR)=SNR(RR3)
      A(RR3)=A(R2)
      SNR(RR3)=SNR(R2)
      SNR(R2)=0
      Z=Z-1
      RR3=RR3+1
      HA(I,2)=RR3
      HA(I,1)=R2+1
      CR3=HA(I,5)
      IF(R9.LE.0)GO TO 431
      DO 430 J=RR3,RR4
      INDEX=SNR(J)
  430 PIVOT(INDEX)=A(J)
  431 R7=CR4-CR3+1
      DO 880 K=1,R7
      R1=RNR(CR3-1+K)
      IF(R1.EQ.I)GO TO 870
      I1=HA(R1,1)
      RR1=HA(R1,2)
      RR2=HA(R1,3)
      L2=RR2-RR1+1
      L=RR1-1
  390 L=L+1
      IF(SNR(L).NE.I)GO TO 390
      T=A(L)/V
      IF(IFLAG(5).EQ.2)GO TO 400
      A(L)=A(I1)
      SNR(L)=SNR(I1)
      SNR(I1)=0
      I1=I1+1
      HA(R1,1)=I1
      Z=Z-1
      GO TO 410
  400 A(L)=A(RR1)
      A(RR1)=T
      R3=SNR(RR1)
      SNR(RR1)=SNR(L)
      SNR(L)=R3
  410 RR1=RR1+1
      HA(R1,2)=RR1
      B(R1)=B(R1)-B(I)*T
      IF(R9.LE.0)GO TO 669
      R=RR1
      IF(R.GT.RR2)GO TO 470
      DO 460 L=R,RR2
      L1=SNR(L)
      TD=PIVOT(L1)
      IF(TD.EQ.0.0D0)GO TO 450
      PIVOT(L1)=0.0 D0
      TD=A(L)-TD*T
      A(L)=TD
      TD1=DABS(TD)
      IF(TD1.GT.AFLAG(7))AFLAG(7)=TD1
C
C  TOO SMALL ELEMENT IS CREATED.REMOVE IT FROM THE LISTS.
C
      IF(TD1.GT.AFLAG(2))GO TO 450
      Z=Z-1
      A(L)=A(RR1)
      SNR(L)=SNR(RR1)
      A(RR1)=A(I1)
      SNR(RR1)=SNR(I1)
      SNR(I1)=0
      RR1=RR1+1
      I1=I1+1
      HA(R1,2)=RR1
      HA(R1,1)=I1
      R3=HA(L1,5)
      R2=R3-1
      L4=HA(L1,4)
      L5=RNR(L4)
      L6=RNR(R3)
  440 R2=R2+1
      IF(RNR(R2).NE.R1)GO TO 440
      RNR(R2)=L6
      RNR(R3)=L5
      RNR(L4)=0
      HA(L1,5)=R3+1
      HA(L1,4)=L4+1
  450 CONTINUE
  460 CONTINUE
  470 CONTINUE
      DO 750 J=1,R9
      R=RR3-1+J
      R2=SNR(R)
      TOL2=PIVOT(R2)
      PIVOT(R2)=A(R)
      IF(TOL2.EQ.0.0D0)GO TO 740
      TOL3=-TOL2*T
      TOL1=DABS(TOL3)
      IF(TOL1.LT.AFLAG(2))GO TO 740
      C2=HA(R2,4)
      CR2=HA(R2,6)
      CR1=HA(R2,5)
      LFR=RR2-I1+2
      LFC=CR2-C2+2
      IF(IFLAG(4).NE.1)GO TO 480
      IF(LFR.GT.HA(R1,9))HA(R1,9)=LFR
      IF(LFC.GT.HA(R2,10))HA(R2,10)=LFC
  480 IF(I1.EQ.1)GO TO 490
      IF(SNR(I1-1).EQ.0)GO TO 600
  490 IF(RR2.EQ.NN)GO TO 500
      IF(SNR(RR2+1).EQ.0)GO TO 580
C
C  COLLECTION IN ROW ORDERED LIST.
C
  500 R10=NN-LFR
      IF(R10.GE.R4)GO TO 560
      IFLAG(6)=IFLAG(6)+1
      DO 520 JJ=1,N
      L1=HA(JJ,3)
      IF(L1.LT.HA(JJ,1))GO TO 510
      HA(JJ,3)=SNR(L1)
      SNR(L1)=-JJ
  510 CONTINUE
  520 CONTINUE
      L3=0
      L4=1
      DO 550 JJ=1,R4
      IF(SNR(JJ).EQ.0)GO TO 540
      L3=L3+1
      IF(SNR(JJ).GT.0)GO TO 530
      L5=-SNR(JJ)
      SNR(JJ)=HA(L5,3)
      HA(L5,3)=L3
      L6=L4+HA(L5,2)-HA(L5,1)
      HA(L5,2)=L6
      HA(L5,1)=L4
      L4=L3+1
  530 A(L3)=A(JJ)
      SNR(L3)=SNR(JJ)
  540 CONTINUE
  550 CONTINUE
      R4=L3
      SNR(L3+1)=0
      RR3=HA(I,2)
      RR4=HA(I,3)
      I1=HA(R1,1)
      RR1=HA(R1,2)
      R=RR3-1+J
      IF(R10.GE.R4)GO TO 560
      IFAIL=5
C
C FILL-IN TAKES PLACE IN THE ROW ORDERED LIST.
C
      GO TO 1110
  560 R8=LFR-1
      RR2=R4+LFR
      IF(R8.LE.0)GO TO 579
      L3=I1-1
      DO 570 LL=1,R8
      L4=R4+LL
      L5=L3+LL
      A(L4)=A(L5)
      SNR(L4)=SNR(L5)
  570 SNR(L5)=0
  579 RR1=R4+RR1-I1+1
      HA(R1,3)=RR2
      HA(R1,2)=RR1
      I1=R4+1
      HA(R1,1)=I1
      L1=RR2
      GO TO 590
  580 RR2=RR2+1
      HA(R1,3)=RR2
      L1=RR2
      IF(RR2.LE.R4)GO TO 610
  590 R4=RR2
      IF(R4.LT.NN)SNR(R4+1)=0
      GO TO 610
  600 RR1=RR1-1
      I1=I1-1
      HA(R1,1)=I1
      HA(R1,2)=RR1
      L1=RR1
      SNR(I1)=SNR(L1)
      A(I1)=A(L1)
  610 A(L1)=TOL3
      SNR(L1)=SNR(R)
      TD=DABS(A(L1))
      IF(TD.GT.AFLAG(7))AFLAG(7)=TD
      Z=Z+1
      IF(IFLAG(8).LT.Z) IFLAG(8)=Z
      IF(C2.EQ.1)GO TO 620
      IF(RNR(C2-1).EQ.0)GO TO 720
  620 IF(CR2.EQ.NN1)GO TO 630
      IF(RNR(CR2+1).EQ.0)GO TO 700
C
C  COLLECTION IN COLUMN ORDERED LIST.
C
  630 R10=NN1-LFC
      IF(R10.GE.R5)GO TO 680
      IFLAG(7)=IFLAG(7)+1
      DO 640 JJ=I,N
      L1=HA(JJ,6)
      HA(JJ,6)=RNR(L1)
  640 RNR(L1)=-JJ
      L3=0
      L4=1
      DO 670 JJ=1,R5
      IF(RNR(JJ).EQ.0)GO TO 660
      L3=L3+1
      IF(RNR(JJ).GT.0)GO TO 650
      L5=-RNR(JJ)
      RNR(JJ)=HA(L5,6)
      HA(L5,6)=L3
      L6=L4+HA(L5,5)-HA(L5,4)
      HA(L5,5)=L6
      HA(L5,4)=L4
      L4=L3+1
  650 RNR(L3)=RNR(JJ)
  660 CONTINUE
  670 CONTINUE
      R5=L3
      RNR(R5+1)=0
      C2=HA(R2,4)
      CR3=HA(I,5)
      CR4=HA(I,6)
      CR1=HA(R2,5)
      IF(R10.GE.R5)GO TO 680
      IFAIL=6
C
C FILL-IN TAKES PLACE IN THE COLUMN ORDERED LIST.
C
      GO TO 1110
  680 R8=LFC-1
      CR2=R5+LFC
      IF(R8.LE.0)GO TO 699
      L3=C2-1
      DO 690 L=1,R8
      L4=R5+L
      L5=L3+L
      RNR(L4)=RNR(L5)
  690 RNR(L5)=0
  699 CR1=R5+CR1-C2+1
      C2=R5+1
      HA(R2,6)=CR2
      HA(R2,4)=C2
      HA(R2,5)=CR1
      R=CR2
      GO TO 710
  700 CR2=CR2+1
      HA(R2,6)=CR2
      R=CR2
      IF(CR2.LE.R5)GO TO 730
  710 R5=CR2
      IF(R5.LT.NN1)RNR(R5+1)=0
      GO TO 730
  720 CR1=CR1-1
      C2=C2-1
      HA(R2,4)=C2
      HA(R2,5)=CR1
      R=CR1
      RNR(C2)=RNR(R)
  730 RNR(R)=R1
  740 CONTINUE
  750 CONTINUE
  669 IF(RR1.LE.RR2)GO TO 760
      IFAIL=7
C
C  UPDATE THE INFORMATION IN THE LIST WHERE THE ROWS ARE ORDERED BY
C  INCREASING NUMBERS OF THE NON-ZERO ELEMENTS.
C
      GO TO 1110
  760 IF(IFLAG(4).EQ.2)GO TO 870
      IF(IFLAG(3).EQ.0)GO TO 870
      L1=RR2-RR1+1
      IF(L1.EQ.L2)GO TO 870
      L6=HA(R1,7)
      L4=HA(L2,11)
      IF(L1.GT.L2)GO TO 820
      IF(L6.GT.L4)GO TO 780
      IF(L4.EQ.N)GO TO 770
      L=HA(L4+1,8)
      L5=HA(L,3)-HA(L,2)+1
      IF(L5.EQ.L2)GO TO 790
  770 HA(L2,11)=0
      GO TO 800
  780 L5=HA(L4,8)
      L3=HA(L6,8)
      HA(L4,8)=L3
      HA(L6,8)=L5
      HA(L5,7)=L6
      HA(L3,7)=L4
      L6=L4
  790 HA(L2,11)=L4+1
  800 IF(L4.EQ.I+1)GO TO 810
      L=HA(L6-1,8)
      L2=HA(L,3)-HA(L,2)+1
      L4=HA(L2,11)
      IF(L1.LT.L2)GO TO 780
  810 IF(L1.NE.L2)HA(L1,11)=L6
      GO TO 870
  820 IF(L6.GT.L4)GO TO 840
      IF(L4.EQ.N)GO TO 830
      L=HA(L4+1,8)
      L5=HA(L,3)-HA(L,2)+1
      IF(L5.EQ.L2)GO TO 840
  830 HA(L2,11)=0
  840 L2=L2+1
      IF(L2.LE.SLUT)GO TO 850
      L3=N
      SLUT=L1
      L2=L1
      GO TO 860
  850 L3=HA(L2,11)-1
      IF(L3.EQ.-1)GO TO 840
      IF(L2.GT.L1)L2=L1
  860 HA(L2,11)=L3
      L4=HA(L3,8)
      L7=HA(L6,8)
      HA(L3,8)=L7
      HA(L6,8)=L4
      HA(L7,7)=L3
      HA(L4,7)=L6
      L6=L3
      IF(L2.LT.L1)GO TO 840
  870 CONTINUE
  880 CONTINUE
      IF(R9.LE.0)GO TO 882
      DO 881 J=RR3,RR4
      INDEX=SNR(J)
  881 PIVOT(INDEX)=0.0 D0
  882 CONTINUE
      CR3=HA(I,4)
      DO 890 J=CR3,CR4
  890 RNR(J)=0
      IF(R9.LE.0)GO TO 930
      L2=HA(I,2)-1
      DO 920 LL=1,R9
      R=SNR(L2+LL)
      R1=HA(R,5)
      R2=HA(R,6)
      IF(R2.GT.R1)GO TO 900
      IFAIL=8
      GO TO 1110
  900 HA(R,5)=R1+1
      R3=R1-1
  910 R3=R3+1
      IF(RNR(R3).NE.I)GO TO 910
      RNR(R3)=RNR(R1)
  920 RNR(R1)=I
  930 AFLAG(5)=AFLAG(7)/AFLAG(6)
      IF(AFLAG(5).LT.AFLAG(3))GO TO 940
      IFAIL=4
      GO TO 1110
  940 CONTINUE
C
C  PREPARATION TO BEGIN THE BACK SUBSTITUTION.
C
  950 CONTINUE
      INDEX=HA(N,2)
      PIVOT(N)=A(INDEX)
      A(INDEX)=0.0 D0
      TD=DABS(PIVOT(N))
      IF(TD.GT.AFLAG(7))AFLAG(7)=TD
      IF(TD.LT.AFLAG(8))AFLAG(8)=TD
      IF(TD.GT.GRMIN)GO TO 960
      IFAIL=3
      GO TO 1110
  960 IF(IFLAG(4).NE.1)GO TO 1060
      IFLAG(10)=HA(N,9)
      IFLAG(9)=HA(N,10)
      DO 990 I=1,N7
      R1=N-I
      IFLAG(10)=IFLAG(10)+HA(R1,9)
      IFLAG(9)=IFLAG(9)+HA(R1,10)
      IF(IFLAG(3).EQ.0)GO TO 980
      DO 970 J=9,10
      R2=HA(R1,J-2)
      R6=HA(R2,J)
      HA(R2,J)=HA(R1,J)
  970 HA(R1,J)=R6
  980 CONTINUE
  990 CONTINUE
1060  CONTINUE
      AFLAG(5)=AFLAG(7)/AFLAG(6)
      IFLAG(1)=-2
 1110 Z=ZZ
      RETURN
      END

      SUBROUTINE MOVOUT

C************************************************************
C**                                                        **
C** PASSES EDGE OF SIMULATION BOX TO NEIGHBOURS AND ADDS   **
C** THOSE PASSED TO IT TO THE ARRAYS OF COORDINATES.       **
C** DURING THIS PROCESS ATOMS THAT HAVE MOVED INTO OTHER   **
C** PROCESSOR'S SIMULATION SPACE ARE PASSED TO THEIR       **
C** NEW HOME PROCESSOR.                                    **
C**                                                        **
C************************************************************

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/ATOMS/NATM
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ

      INTEGER     NMAX, MMX, MMY, MMZ,  NCELL, MAPSIZ

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     NATM, I, J, K, ICELL, NEDGE

C**   ZERO LINKED LIST

      DO 5 ICELL = 1, MX*MY*MZ
        HEAD(ICELL) = 0
 5      CONTINUE

      DO 10 I = 1, NATM
        ICELL = 1+INT((RX(I)*SFX+0.5)*CELLIX)
     &           +INT((RY(I)*SFY+0.5)*CELLIY)*MX
     &           +INT((RZ(I)*SFZ+0.5)*CELLIZ)*MX*MY
        LIST(I) = HEAD(ICELL)
        HEAD(ICELL) = I
 10     CONTINUE

      NEDGE = NMAX+1

C**   CREATE WEST FACE OF BOX

      DO 20 K = 0,MZ-1
        DO 20 I= MX-1,MX*MY-1,MX
          J=HEAD(I+K*MX*MY)
 21       IF (J.EQ.0) GOTO 20
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)-1.0
          RY(NEDGE) = RY(J)
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 21
 20       CONTINUE

C**   CREATE EAST FACE OF BOX

      DO 30 K = 0,MZ-1
        DO 30 I = 2, MX*(MY-1)+2,MX
          J=HEAD(I+K*MX*MY)
 31       IF (J.EQ.0) GOTO 30
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)+1.0
          RY(NEDGE) = RY(J)
          RZ(NEDGE) = RZ(J)
          ICELL = MX+INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &              +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 31
 30       CONTINUE

C**   CREATE SOUTH FACE OF BOX

      DO 100 K = 0,MZ-1
        DO 100 I= MX*(MY-2)+1,MX*(MY-1)
          J=HEAD(I+K*MX*MY)
 101      IF (J.EQ.0) GOTO 100
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)
          RY(NEDGE) = RY(J)-1.0
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 101
 100      CONTINUE

C**   CREATE NORTH FACE OF BOX

      DO 130 K = 0,MZ-1
        DO 130 I = MX+1,2*MX
          J=HEAD(I+K*MX*MY)
 131      IF (J.EQ.0) GOTO 130
          NEDGE = NEDGE-1
          RX(NEDGE) = RX(J)
          RY(NEDGE) = RY(J)+1.0
          RZ(NEDGE) = RZ(J)
          ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)+MX*(MY-1)
     &             +INT((RZ(NEDGE)*SFZ+0.5)*CELLIZ)*MX*MY
          LIST(NEDGE) = HEAD(ICELL)
          HEAD(ICELL) = NEDGE

          J = LIST(J)
          GOTO 131
 130      CONTINUE

C**   CREATE DOWN FACE OF BOX

      DO 220 K = MX*MY*(MZ-2)+1,MX*MY*(MZ-1)
        J=HEAD(K)
 221    IF (J.EQ.0) GOTO 220
        NEDGE = NEDGE-1
        RX(NEDGE) = RX(J)
        RY(NEDGE) = RY(J)
        RZ(NEDGE) = RZ(J)-1.0
        ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &           +INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
        LIST(NEDGE) = HEAD(ICELL)
        HEAD(ICELL) = NEDGE

        J = LIST(J)
        GOTO 221
 220    CONTINUE


C**   CREATE UP FACE OF BOX

      DO 270 K = MX*MY+1,2*MX*MY
        J=HEAD(K)
 271    IF (J.EQ.0) GOTO 270
        NEDGE = NEDGE-1
        RX(NEDGE) = RX(J)
        RY(NEDGE) = RY(J)
        RZ(NEDGE) = RZ(J)+1.0
        ICELL = 1+INT((RX(NEDGE)*SFX+0.5)*CELLIX)
     &           +INT((RY(NEDGE)*SFY+0.5)*CELLIY)*MX
     &           +(MZ-1)*MX*MY
        LIST(NEDGE) = HEAD(ICELL)
        HEAD(ICELL) = NEDGE

        J = LIST(J)
        GOTO 271
 270    CONTINUE

C**   TEST TO SEE IF WE HAVE TOO MANY EDGE ATOMS FOR ARRAYS

      IF (NEDGE.LT.NATM) WRITE(*,*) ' LINKED LIST RECURSIVE '

      RETURN
      END

      SUBROUTINE SEARCH(XPARAM,ALPHA,SIG,NVAR,GMIN,OKC,OKF, FUNCT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(*), SIG(*)
************************************************************************
*
* SEARCH PERFORMS A LINE SEARCH FOR POWSQ. IT MINIMIZES THE NORM OF
*        THE GRADIENT VECTOR IN THE DIRECTION SIG.
*
* ON INPUT  XPARAM = CURRENT POINT IN NVAR DIMENSIONAL SPACE.
*           ALPHA  = STEP SIZE (IN FACT ALPHA IS CALCULATED IN SEARCH).
*           SIG    = SEARCH DIRECTION VECTOR.
*           NVAR   = NUMBER OF PARAMETERS IN SIG (& XPARAM)
*
* ON OUTPUT XPARAM = PARAMETERS OF MINIMUM.
*           ALPHA  = DISTANCE TO MINIMUM.
*           GMIN   = GRADIENT NORM AT MINIMUM.
*           OKC    = EXITED BEFORE COUNTS WERE EXCEEDED (LOGICAL)
*           OKF    = FUNCTION WAS IMPROVED.
************************************************************************
      COMMON /SIGMA1/ GNEXT, AMIN, ANEXT
      COMMON /SIGMA2/  GNEXT1(MAXPAR), GMIN1(MAXPAR)
      COMMON/KEYWRD/ KEYWRD
      DIMENSION GRAD(MAXPAR),XREF(MAXPAR), GREF(MAXPAR), XMIN1(MAXPAR)
      CHARACTER*80 KEYWRD
      LOGICAL FIRST, DEBUG, OKC, OKF, NOPR
      DATA  FIRST /.TRUE./
      IF( FIRST ) THEN
         FIRST = .FALSE.
C
C    TOLG   = CRITERION FOR EXIT BY RELATIVE CHANGE IN GRADIENT.
C
         DEBUG=(INDEX(KEYWRD,'LINMIN') .NE. 0)
         NOPR=( .NOT. DEBUG)
         LOOKS=0
         OKF=.TRUE.
         TINY=0.1D0
         TOLERG=0.02D0
         IF(NVAR .EQ. 1)TIMY=0.D0
         G=100.D0
         XMAXM=2.D0
         ALPHA=0.1D0
      ENDIF
      ANEXT1=0.D0
      DO 10 I=1,NVAR
         GREF(I)  =GMIN1(I)
         GNEXT1(I)=GMIN1(I)
         XMIN1(I) =XPARAM(I)
   10 XREF(I)  =XPARAM(I)
      IF(ABS(ALPHA) .GT. 0.2)ALPHA=SIGN(0.2D0,ALPHA)
      IF(DEBUG) THEN
         WRITE(6,'('' SEARCH DIRECTION VECTOR'')')
         WRITE(6,'(6F12.6)')(SIG(I),I=1,NVAR)
         WRITE(6,'('' INITIAL GRADIENT VECTOR'')')
         WRITE(6,'(6F12.6)')(GMIN1(I),I=1,NVAR)
      ENDIF
      GB=DOT(GMIN1,GREF,NVAR)
      IF(DEBUG) WRITE(6,'('' GRADIENT AT START OF SEARCH:'',F16.6)')
     1SQRT(GB)
      GSTORE=GB
      AMIN=0.D0
      GMINN=1.D9
C
C
      TA=0.D0
      GA=GB
      GB=1.D9
      ITRYS=0
      GOTO 30
   20 SUM=GA/(GA-GB)
      ITRYS=ITRYS+1
      IF(ABS(SUM) .GT. 3.D0) SUM=SIGN(3.D0,SUM)
      ALPHA=(TB-TA)*SUM+TA
C
C         XPARAM IS THE GEOMETRY OF THE PREDICTED MINIMUM ALONG THE LINE
C
   30 CONTINUE
      DO 40 I=1,NVAR
   40 XPARAM(I)=XREF(I)+ALPHA*SIG(I)
C
C         CALCULATE GRADIENT NORM AND GRADIENTS AT THE PREDICTED MINIMUM
C
      IF(ITRYS.EQ.1)THEN
      DO 50 I=1,NVAR
   50 GRAD(I)=0.D0
      ENDIF
      CALL COMPFG (XPARAM, .TRUE., FUNCT, .TRUE., GRAD, .TRUE.)
      LOOKS=LOOKS+1
C
C          G IS THE PROJECTION OF THE GRADIENT ALONG SIG.
C
      G=DOT(GREF,GRAD,NVAR)
      GTOT=SQRT(DOT(GRAD,GRAD,NVAR))
      IF( .NOT. NOPR)
     1WRITE(6,'('' LOOKS'',I3,'' ALPHA ='',F12.6,'' GRADIENT'',F12.3,
     2'' G  ='',F16.6)')
     3LOOKS,ALPHA,SQRT(DOT(GRAD,GRAD,NVAR)),G
      IF(GTOT .LT. GMINN) THEN
         GMINN=GTOT
         IF(ABS(AMIN-ALPHA) .GT.1.D-2) THEN
*
* WE CAN MOVE ANEXT TO A POINT NEAR, BUT NOT TOO NEAR, AMIN, SO THAT THE
* SECOND DERIVATIVESWILLBEREALISTIC(D2E/DX2=(GNEXT1-GMIN1)/(ANEXT-AMIN))
*
            ANEXT=AMIN
            DO 60 I=1,NVAR
   60       GNEXT1(I)=GMIN1(I)
         ENDIF
         AMIN=ALPHA
         DO 70 I=1,NVAR
            IF(GMINN.LT.GMIN) XMIN1(I)=XPARAM(I)
   70    GMIN1(I)=GRAD(I)
         IF(GMIN.GT.GMINN)GMIN=GMINN
      ENDIF
      IF(ITRYS .GT. 8) GOTO 80
      IF (ABS(G/GSTORE).LT.TINY .OR. ABS(G) .LT. TOLERG) GO TO 80
      IF(ABS(G) .LT. MAX(ABS(GA),ABS(GB)) .OR.
     1     GA*GB .GT. 0.D0 .AND. G*GA .LT. 0.D0) THEN
C
C   G IS AN IMPROVEMENT ON GA OR GB.
C
         IF(ABS(GB) .LT. ABS(GA))THEN
            TA=ALPHA
            GA=G
            GO TO 20
         ELSE
            TB=ALPHA
            GB=G
            GO TO 20
         ENDIF
      ELSE
C#         WRITE(6,'(//10X,'' FAILED IN SEARCH, SEARCH CONTINUING'')')
         GOTO 80
      ENDIF
   80 LNSTOP=4
      GMINN=SQRT(DOT(GMIN1,GMIN1,NVAR))
      DO 90 I=1,NVAR
   90 XPARAM(I)=XMIN1(I)
      IF(DEBUG) THEN
         WRITE(6,'('' AT EXIT FROM SEARCH'')')
         WRITE(6,'('' XPARAM'',6F12.6)')(XPARAM(I),I=1,NVAR)
         WRITE(6,'('' GNEXT1'',6F12.6)')(GNEXT1(I),I=1,NVAR)
         WRITE(6,'('' GMIN1 '',6F12.6)')(GMIN1(I),I=1,NVAR)
         WRITE(6,'('' AMIN, ANEXT,GMIN'',4F12.6)')
     1    AMIN,ANEXT,GMIN
      ENDIF
      IF(GMINN.GT.GMIN)THEN
      DO 45 I=1,NVAR
  45  XPARAM(I)=XREF(I)
      ENDIF
      RETURN
C
      END

      SUBROUTINE TIMOUT(NOUT,TIM)
C
C     CONVERT THE TIME FROM SECONDS TO DAYS, HOURS, MINUTES, AND SECONDS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DOUBLE PRECISION MINS, MINPHR
C
C
      DATA HRSPD /24.0D0/, MINPHR /60.0D0/
      DATA SECPD /86400.0D0/, SECPHR /3600.0D0/, SECPMI /60.0D0/
C
      DAYS = TIM / SECPD
      IDAYS = INT(DAYS)
      HOURS = (DAYS - FLOAT(IDAYS)) * HRSPD
      IHOURS = INT(HOURS)
      MINS = (HOURS - FLOAT(IHOURS)) * MINPHR
      IMINS = INT(MINS)
      SECS = (MINS - FLOAT(IMINS)) * SECPMI
C
      IF (IDAYS .GT. 1) THEN
         WRITE (NOUT,10) IDAYS,IHOURS,IMINS,SECS
      ELSE IF (IDAYS .EQ. 1) THEN
         WRITE (NOUT,20) IDAYS,IHOURS,IMINS,SECS
      ELSE IF (IHOURS .GT. 0) THEN
         WRITE (NOUT,30) IHOURS,IMINS,SECS
      ELSE IF (IMINS .GT. 0) THEN
         WRITE (NOUT,40) IMINS,SECS
      ELSE
         WRITE (NOUT,50) SECS
      END IF
C
   10 FORMAT (10X,'COMPUTATION TIME = ',I2,1X,'DAYS',2X,I2,1X,'HOURS',
     1        1X,I2,1X,'MINUTES AND',1X,F7.3,1X,'SECONDS')
   20 FORMAT (10X,'COMPUTATION TIME = ',I2,1X,'DAY',2X,I2,1X,'HOURS',
     1        1X,I2,1X,'MINUTES AND',1X,F7.3,1X,'SECONDS')
   30 FORMAT (10X,'COMPUTATION TIME = ',I2,1X,'HOURS',
     1        1X,I2,1X,'MINUTES AND',1X,F7.3,1X,'SECONDS')
   40 FORMAT (10X,'COMPUTATION TIME = ',I2,1X,'MINUTES AND',
     1        1X,F7.3,1X,'SECONDS')
   50 FORMAT (10X,'COMPUTATION TIME = ',F7.3,1X,'SECONDS')
      END

      SUBROUTINE MXM (A,NA,B,MA,C,MB)
      INTEGER NA, MA, MB
      DOUBLE PRECISION A(NA,MA), B(MA,MB), C(NA,MB)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER I, J, K
      DO 110 I=1,NA
         DO 100 J=1,MB
            C(I,J) = ZERO
 100     CONTINUE
 110  CONTINUE
      DO 140 J=1,MB
         DO 130 K=1,MA
            DO 120 I=1,NA
               C(I,J) = C(I,J) + A(I,K)*B(K,J)
 120        CONTINUE
 130     CONTINUE
 140  CONTINUE
      RETURN
      END

        SUBROUTINE CORR1(IZ,SHR,IN,KDIM,KRC)

        REAL*8         SHH,SCX
        INTEGER        RHE1,RHE2
        REAL*8         SHR(KRC,*)
        INTEGER        IZ(KDIM,KDIM),I,J,KRC,IN

C
C       NORMALIZATION FACTOR SCX
C
        SCX=1.D0/DFLOAT(KDIM*KRC)
                          
        DO 1000 IIII=1,KDIM
        DO 1001 JJJJ=1,KRC

        SHH=0.D0

        DO 100 J=1,KRC
        RHE1=IZ(J,IIII)
        RHE2=IZ(J+JJJJ,IIII)
        RH1=(RHE1-RHE2)**2
        SHH=SHH+RH1*SCX

100     CONTINUE

        SHR(JJJJ,IN)=SHR(JJJJ,IN)+SHH

1001    CONTINUE
1000    CONTINUE

        RETURN
        END

      SUBROUTINE READI(INPUT,A,B,N)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N)
C     
C-old      DO 100 J=1,N
C-old         READ(1,1000) (A(I,J),I=1,N)
C-old 100  CONTINUE          
      ZERO=0.0
      CALL COPVAL(A,N*N,ZERO)
 100  CONTINUE
      READ(INPUT,1000,END=110) 
     +     JCOL,IROW,NTERMS,(A(I,JCOL),I=IROW,IROW+NTERMS-1)
      GOTO 100
 110  CONTINUE
C-old      READ(1,1000) (B(I),I=1,N)
      DO 200 I=1,N
         B(I)=I
 200  CONTINUE
 1000 FORMAT(2I5,I3,5F13.0,:,/(6F13.0))
      END

      DOUBLE PRECISION FUNCTION DRAND (SEED)

C ================================================================
C
C     RANDOM NUMBER GENERATOR    GGL
C     original reference for algorithm
C     P. Lewis, A. Goodman, J. Miller,IBM Sys. J., 2, 136 (1969)
C ================================================================

      INTEGER SEED
      DOUBLE PRECISION   DS, D2, DINIT
      PARAMETER ( DINIT = 667790.0D0 )
      SAVE DS, D2
      DATA               DS/DINIT/
      DATA               D2/2147483647.0D0/

      IF ( SEED .NE. 0 ) DS = SEED
      DS = DMOD(16807.D0*DS,D2)                                            
      DRAND = DS/D2

      RETURN                                                                   
      END

C----------------------------------------------------------------------
C
C   M O O N
C
C   COMPUTE LUNAR EPHEMERIS AT ONE HOUR INTERVALS FOR THE
C   POERIOD D1..D2
C
C----------------------------------------------------------------------
      SUBROUTINE  MOON (D1, D2)
      INTEGER D1, D2
C
      REAL RA, DEC, PARA
      INTEGER HOUR,DAY,Y,M,D,WD
C
C  COMPUTE EPHEMERIS AND WRITE RESULTS AT 1000 DAY INTERVALS
C
      DO 2 DAY=D1,D2
         DO 1 HOUR=0,23
            CALL MOONEF (DAY, HOUR, RA, DEC, PARA)
            IF (MOD(DAY-D1+1,1000) .EQ. 1 .AND. HOUR .EQ. 0) THEN
               CALL GREGOR(DAY,Y,M,D,WD)
               WRITE(*,'('' '',I2,''.'',I2,''.'',I4,
     .                   ''   R.A = '',F8.3,''  DEC = '',F8.3,
     .                   ''  PARALLAX = '',F8.3)')
     .               D,M,Y,RA,DEC,PARA
            ENDIF
 1       CONTINUE
 2    CONTINUE

      WRITE (*,'('' LUNAR EPHEMERIS COMPUTED FOR DN = '',
     .           I5,'' .. '',I5/)')
     .       D1, D2
      RETURN
      END

      SUBROUTINE PUTSHF(A,YK,N,ESHIFT)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),YK(N)     
C     
      CALL COPDIA(A,N,YK)
C     
      ESHIFT=1E+30
      DO 100 I=1,N
         ESHIFT=MIN(YK(I),ESHIFT)
 100  CONTINUE      
C     
      ESHIFT=ESHIFT*(1.+1E-3)
      DO 200 I=1,N
         A(I,I)=A(I,I)-ESHIFT
 200  CONTINUE
C     
      WRITE(6,1000) ESHIFT
 1000 FORMAT(1X,'**PUTSHF: ESHIFT=',1P,G20.10)
      END

       SUBROUTINE XPENTA(JDIM,KDIM,A,B,C,D,E,X,Y,F,JL,JU,KL,KU)
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       DOUBLE PRECISION LD,LD1,LD2,LDI
       DIMENSION A(JDIM,KDIM),B(JDIM,KDIM),C(JDIM,KDIM),D(JDIM,KDIM),
     *           E(JDIM,KDIM),X(JDIM,KDIM),Y(JDIM,KDIM),F(JDIM,KDIM)
C
C      ! START FORWARD GENERATION PROCESS AND SWEEP
C
        J = JL
        DO 1 K = KL,KU
        LD = C(J,K)
        LDI = 1./LD
        F(J,K) = F(J,K)*LDI
        X(J,K) = D(J,K)*LDI
        Y(J,K) = E(J,K)*LDI
1       CONTINUE
C
        J = JL+1
        DO 2 K = KL,KU
        LD1 = B(J,K)
        LD = C(J,K) - LD1*X(J-1,K)
        LDI = 1./LD
        F(J,K) = (F(J,K) - LD1*F(J-1,K))*LDI
        X(J,K) = (D(J,K) - LD1*Y(J-1,K))*LDI
        Y(J,K) = E(J,K)*LDI
2       CONTINUE
C
            DO 3 J = JL+2,JU-2
                DO 11 K = KL,KU
                LD2 = A(J,K)
                LD1 = B(J,K) - LD2*X(J-2,K)
                LD = C(J,K) - (LD2*Y(J-2,K) + LD1*X(J-1,K))
                LDI = 1./LD
                F(J,K) = (F(J,K) - LD2*F(J-2,K) - LD1*F(J-1,K))*LDI
                X(J,K) = (D(J,K) - LD1*Y(J-1,K))*LDI        
                Y(J,K) = E(J,K)*LDI
11              CONTINUE
3            CONTINUE
C
        J = JU-1
        DO 12 K = KL,KU
        LD2 = A(J,K)
        LD1 = B(J,K) - LD2*X(J-2,K)
        LD = C(J,K) - (LD2*Y(J-2,K) + LD1*X(J-1,K))
        LDI = 1./LD
        F(J,K) = (F(J,K) - LD2*F(J-2,K) - LD1*F(J-1,K))*LDI
        X(J,K) = (D(J,K) - LD1*Y(J-1,K))*LDI
12      CONTINUE
C
                J = JU
                DO 13 K = KL,KU
                LD2 = A(J,K)
                LD1 = B(J,K) - LD2*X(J-2,K)
                LD = C(J,K) - (LD2*Y(J-2,K) + LD1*X(J-1,K))
                LDI = 1./LD
                F(J,K) = (F(J,K) - LD2*F(J-2,K) - LD1*F(J-1,K))*LDI
13              CONTINUE
C
C        !  BACK SWEEP SOLUTION
C
        DO 14 K = KL,KU
        F(JU,K) = F(JU,K)
        F(JU-1,K) = F(JU-1,K) - X(JU-1,K)*F(JU,K)
14      CONTINUE
C
        DO 4 J = 2,JU-JL
           JX = JU-J
           DO 15 K = KL,KU
           F(JX,K) = F(JX,K) - X(JX,K)*F(JX+1,K) - Y(JX,K)*F(JX+2,K)
15         CONTINUE
4       CONTINUE
C
        RETURN
        END

      SUBROUTINE STEPFY(JDIM,KDIM,Q,S,PRESS,SNDSP,XY,XYJ,DS,
     *                    COEF2,COEF4,UU,CC,WORK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
      DIMENSION S(JDIM,KDIM,4),XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION DS(JDIM,KDIM)
C
      DIMENSION COEF2(JDIM,KDIM),COEF4(JDIM,KDIM)
      DIMENSION UU(JDIM,KDIM),CC(JDIM,KDIM)
C
      DIMENSION WORK(JDIM,KDIM,10)
C
C
      DTD   = DT * THETAD /(1. + PHIDT)
      HD    = 0.5*DTD
C
C  ETA INVERSION PART OF DIAGONAL SCHEME
C
C  SET EIGENVALUE SWTICHES
C
C  DO N = 1 AND 2 TOGETHER
C
            DO 420 N = 2,4
               IF ( N .EQ. 2) SN = 0.
               IF ( N .EQ. 3) SN = 1.
               IF ( N .EQ. 4) SN = -1.
C
C
C  FILL TRIDIAGONALS
C
          K   = KLOW
          KM1 = K-1
          DO 422 J = JLOW,JUP
            C2M = COEF2(J,KM1)*DTD
            C4M = COEF4(J,KM1)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1) =  0.
            WORK(J,K,2) = -(C2M + C4)*XYJ(J,K-1)
            WORK(J,K,3) = XYJ(J,K)*(C2M+C2+3.*C4)
            WORK(J,K,4) = -(C2 + 3.*C4 )*XYJ(J,K+1)
            WORK(J,K,5) = XYJ(J,K+2)*C4
422       CONTINUE
C
          K   = KUP
          KM1 = K-1
          DO 426 J = JLOW,JUP
            C2M = COEF2(J,KM1)*DTD
            C4M = COEF4(J,KM1)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1) =  XYJ(J,K-2)*C4M
            WORK(J,K,2)  = -(C2M + 3.*C4M + C4)*XYJ(J,K-1)
            WORK(J,K,3)  = XYJ(J,K)*(C2M+3.*C4M+C2+2.*C4)
            WORK(J,K,4)  = -(C2 + C4 + C4M)*XYJ(J,K+1)
            WORK(J,K,5)  = 0.
426       CONTINUE
C
C   FOURTH ORDER IN INTERIOR
C
        DO 428 K = KLOW+1,KUP-1
          KM1 = K-1
          DO 430 J = JLOW,JUP
            C2M = COEF2(J,KM1)*DTD
            C4M = COEF4(J,KM1)*DTD
              C2 = COEF2(J,K)*DTD
              C4 = COEF4(J,K)*DTD
            WORK(J,K,1)  =  XYJ(J,K-2)*C4M
            WORK(J,K,2)  = -(C2M + 3.*C4M + C4)*XYJ(J,K-1)
            WORK(J,K,3)  = XYJ(J,K)*(C2M+3.*C4M+C2+3.*C4)
            WORK(J,K,4)  = -(C2 + 3.*C4 + C4M)*XYJ(J,K+1)
            WORK(J,K,5)  = XYJ(J,K+2)*C4
430       CONTINUE
428     CONTINUE
C
C
C  ADD IN FLUX JACOBIANS, VARIABLE DT AND IDENTITY
C
        DO 435 K = KLOW,KUP
          DO 435 J = JLOW,JUP
          WORK(J,K,2) = WORK(J,K,2) - (UU(J,K-1)+SN*CC(J,K-1))*HD
          WORK(J,K,4) = WORK(J,K,4) + (UU(J,K+1)+SN*CC(J,K+1))*HD
          WORK(J,K,1) = WORK(J,K,1)*DS(J,K)
          WORK(J,K,2) = WORK(J,K,2)*DS(J,K)
          WORK(J,K,3) = WORK(J,K,3)*DS(J,K)
          WORK(J,K,4) = WORK(J,K,4)*DS(J,K)
          WORK(J,K,5) = WORK(J,K,5)*DS(J,K)
          WORK(J,K,3) = WORK(J,K,3) + 1.0
435     CONTINUE
C
C   COMBINE N = 1 AND 2
C    INVERT ON FIRST TWO S ELEMENTS
C
         IF(N.EQ.2)THEN
C
        CALL YPENT2(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       S(1,1,1),KLOW,KUP,JLOW,JUP)
C
        ELSE
C  DO N = 3 AND 4
C
        CALL YPENTA(JDIM,KDIM,WORK(1,1,1),WORK(1,1,2),WORK(1,1,3),
     *       WORK(1,1,4),WORK(1,1,5),WORK(1,1,7),WORK(1,1,8),
     *       S(1,1,N),KLOW,KUP,JLOW,JUP)
C
         ENDIF
C
420         CONTINUE
C
      RETURN
      END

      SUBROUTINE CALCPS(JDIM,KDIM,Q,PRESS,SNDSP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),PRESS(JDIM,KDIM),SNDSP(JDIM,KDIM)
C
C  CALCULATE PRESSURE AND SOUND SPEED AND STORE
C
C  NOTE PRESSURE HAS JACOBIAN
C       SOUND SPEED DOES NOT HAVE JACOBIAN
C       CALL AFTER BC ROUTINE SO THAT BOUNDARY VALUES ARE CORRECT
C
        DO 1 K = KBEGIN,KEND
        DO 1 J = JBEGIN,JEND
C
        PRESS(J,K) = GAMI*(Q(J,K,4) - 
     *               0.5*(Q(J,K,2)**2 + Q(J,K,3)**2)/Q(J,K,1))
        SNDSP(J,K) = SQRT(GAMMA*PRESS(J,K)/Q(J,K,1))
C
1       CONTINUE
C
        RETURN
        END

      Program SIMCZO

      INTEGER          DIM,IDIV,JDIV,IDIM,JDIM,MXNOD,MXELE,NLOK,
     +                 IBMAX
      INTEGER          ICOORD, IELTOP

      PARAMETER       (DIM=2,IDIV=30,JDIV=50,IDIM=2*IDIV+1,
     +                 JDIM=2*JDIV+1,NLOK=8,IBMAX=12*IDIV+7)
      PARAMETER       (MXNOD=IDIM*JDIM,MXELE=IDIV*JDIV)
      PARAMETER       (ICOORD=DIM,IELTOP=10)

      DOUBLE PRECISION ZERO

      PARAMETER ( ZERO=0.0D0 )

      INTEGER  ELTOP(IELTOP,MXELE)
      INTEGER  STEER(10),NODEL 
      INTEGER  NS, J, NODE
      INTEGER  ITYP
      INTEGER  IP,INFILE

      DOUBLE PRECISION COORD(DIM,MXNOD),ELEMCO(DIM,NLOK)
      common /name1/ COORD, ELEMCO

      DOUBLE PRECISION A(2*MXNOD,IBMAX),F(2*MXNOD)
      common /name2/ A, F

      DOUBLE PRECISION ALOK(4*NLOK*NLOK),MLOK(4*NLOK*NLOK),
     +     FLOK(2*NLOK), GEOM(2*NLOK)
      common /name3/ ALOK, MLOK, FLOK, GEOM

      DOUBLE PRECISION U(2*MXNOD),T(MXNOD)

      DOUBLE PRECISION UPREV(2*MXNOD),TPREV(MXNOD),UELEM(2*NLOK),
     +		       TELEM(NLOK),FLOWEL(2*NLOK),FLX(NLOK),FLY(NLOK)
      common /name4/ U, T, UPREV, TPREV, UELEM, 
     +               TELEM, FLOWEL, FLX, FLY

      DOUBLE PRECISION VERR,TERR
      DOUBLE PRECISION EPS

      DOUBLE PRECISION RO,CP,DK(DIM,DIM),DLHEAT,XVEL,YVEL,
     +                 XLEN,YLEN,GRAVX,GRAVY,XP,YP,XO,YO,DT,
     +                 XVELO(NLOK),YVELO(NLOK),TGAMIN,TMELT,TGAMOU,
     +                 VISCOS,HEXPCO,REFTEM,RADCRY,RADCRU,ALFA,AREFT,
     +                 SURTEN,GASDEN,COANG,ASTEF,ALIQ,UEXT,DSIG

      DOUBLE PRECISION RELXM,RELXC,RELYM,RELYC,TIME

      DOUBLE PRECISION SINIT,SHCRU(IDIM),SHLIQ(IDIM),FREEB(IDIM),
     +                 FREEBO(IDIM)

      DOUBLE PRECISION ERRFB,TNOEPS

      INTEGER          KSW,NNODES,NELEMS,NELE,NNODX,NNODXC,NELEYM,
     +                 NELEYC,SIDNUM,ITCOUP,MAXCPL,
     +                 NELEXC,NELEXM,NELEMM,NNODM

      INTEGER          MAXIFB,ILIN1,ILIN2,INDMEL,IND1,IND2

      INTEGER          IBANDV,IDIAGV,LOV,IUPV,
     +                 IBANDT,IDIAGT,LOT,IUPT

      DOUBLE PRECISION ENORM,CONVT
      INTEGER NNN,IND,ITER
      DOUBLE PRECISION XXX,YYY

      OPEN (UNIT=7,FILE='param.dta',STATUS='OLD',ERR=990)
      READ(7,*) CP
      READ(7,*) DK(1,1),DK(1,2)
      READ(7,*) DK(2,1),DK(2,2)
      READ(7,*) 
      READ(7,*) SURTEN
      READ(7,*) GASDEN
      READ(7,*) COANG
      READ(7,*) 
      READ(7,*) HEXPCO
      READ(7,*) REFTEM
      READ(7,*) GRAVX
      READ(7,*) GRAVY
      READ(7,*) 
      READ(7,*) DLHEAT
      READ(7,*) 
      READ(7,*) XVEL
      READ(7,*) YVEL
      READ(7,*) 
      READ(7,*) TGAMIN
      READ(7,*) TMELT
      READ(7,*) TGAMOU
      READ(7,*) ALFA
      READ(7,*) AREFT
      READ(7,*) 
      READ(7,*) RADCRY
      READ(7,*) RADCRU
      READ(7,*) YLEN
      READ(7,*) SINIT
      READ(7,*) 
      READ(7,*) NELEXC,NELEXM
      READ(7,*) RELXC,RELXM
      READ(7,*) 
      READ(7,*) NELEYM,NELEYC
      READ(7,*) RELYM,RELYC
      READ(7,*) 
      READ(7,*) KSW
      READ(7,*) 
      READ(7,*) MAXIFB
      READ(7,*) ERRFB
      READ(7,*) 
      READ(7,*) RO,VISCOS
      READ(7,*)

      READ(7,*) EPS
      READ(7,*) 
      READ(7,*) MAXCPL
      READ(7,*) TNOEPS
      CLOSE(7)


      XLEN=RADCRY+RADCRU


      NNODX=2*NELEXC+1 + 2*NELEXM
      NNODXC=2*NELEXC+1
      NELEMM=(NELEXC+NELEXM)*NELEYM
      NNODM=NNODX*(2*NELEYM+1)-NELEMM


      OPEN (UNIT=8,FILE='initmesh.dat',STATUS='OLD',ERR=990)

      READ(8,*) NNODES,NELEMS
      CALL LENTST (NNODES,MXNOD,'MXNOD','MAIN')
      CALL LENTST (NELEMS,MXELE,'MXELE','MAIN')

      DO 100 NELE=1,NELEMS
         READ(8,*) ITYP,NODEL,(ELTOP(2+J,NELE),J=1,NODEL)
         ELTOP(1,NELE) = ITYP
         ELTOP(2,NELE) = NODEL
 100  CONTINUE

      DO 110 NODE=1,NNODES
         READ (8,*) (COORD(J,NODE),J=1,2)
 110  CONTINUE

      CLOSE(8)
 

      IPAR=NELEXC+NELEXM+1

      IBANDV=12*IPAR+7
      IDIAGV=6*IPAR+5
      LOV=6*IPAR+4
      IUPV=6*IPAR+4


      IBANDT=6*IPAR+3+2
      IDIAGT=3*IPAR+2+1
      LOT=3*IPAR+2
      IUPT=3*IPAR+2


c      WRITE(6,*) 'Initial velocity profile from file velocity.dat'
c      WRITE(6,*) '1 = yes, 0 = no'
c      READ(5,*) IFILE

      IFILE=0

      IF (IFILE .EQ. 1) THEN
         OPEN (UNIT=18,FILE='velocity.dat',STATUS='OLD',ERR=990)
         READ(18,*) NNODES
         DO 10 I=1,NNODES
            READ(18,601) NNN,XXX,YYY,UPREV(2*I-1),UPREV(2*I)
 10      CONTINUE
         CLOSE(18)

         OPEN (UNIT=18,FILE='temp.dat',STATUS='OLD',ERR=990)
         READ(18,*) NNODES
         DO 15 I=1,NNODES
            READ(18,*) TPREV(I)
 15      CONTINUE
         CLOSE(18)

      ELSE
         DO 20 I=1,NNODES
            TPREV(I)=TGAMIN
            UPREV(2*I-1)=0.0D0
            UPREV(2*I)=YVEL
 20      CONTINUE
      ENDIF

****************************************************************************
      ALIQ=TMELT
****************************************************************************


      ITER=1
      TIME=0.0D0

 6000 CONTINUE

      IND=NNODM-NNODX

      DO 120 I=1,NNODX
         SHCRU(I)=COORD(2,I)
         SHLIQ(I)=COORD(2,IND+I)
 120  CONTINUE
      CLOSE(12)

      DO 125 I=1,NNODXC
         FREEB(I)=SHLIQ(I)
 125  CONTINUE

      CALL VFILL (2*MXNOD,U,ZERO)
      CALL VFILL (MXNOD,T,ZERO)


      ITCOUP=1	

      WRITE(6,*) 
     +'Iteration,        time               rel.err. T      Rel.err. U'  

 7000 CONTINUE

      CALL LTIMST(DT,COORD,DIM,UPREV,NELEMS,NNODES,ELTOP,IELTOP,
     +     'DT','MAIN')

      TIME=TIME+DT

********* Calculation of temperatures **********************************

      CALL VFILL (2*MXNOD*IBMAX,A,ZERO)
      CALL VFILL (2*MXNOD,F,ZERO)

      DO 130 NELE=1,NELEMS
         NODEL = ELTOP(2,NELE)
         CALL ECOORD (NELE,GEOM,NODEL,ELTOP,IELTOP,COORD,ICOORD)
         CALL DIRECT (NELE,ELTOP,IELTOP,STEER)
         CALL CONVEL (NODEL,XVELO,YVELO,UPREV,STEER)

         DO 140 I=1,NODEL
            IP=STEER(I)
            XP=COORD(1,IP)
            YP=COORD(2,IP)

            XO=XP
            YO=YP
            
            IF (IP .LE. NNODM) THEN
               CALL MPOINT(XP,YP,XVELO(I),YVELO(I),DT,COORD,DIM,
     +              NNODX,NODEL,NODEL,ELEMCO,FLOWEL,IP,TPREV,
     +              IELTOP,ELTOP,XLEN,INDELE,SHCRU,SHLIQ,
     +              NNODM,NELEMM)
            ELSE
               CALL MPCRYS(XP,YP,XVELO(I),YVELO(I),DT,COORD,DIM,
     +              NODEL,ELEMCO,FLOWEL,IP,TPREV,
     +              IELTOP,ELTOP,INDELE,NNODM,NELEXC,NELE,I)
            ENDIF
            
            TELEM(I)=CONVT(XP,YP,XO,YO,NODEL,ELEMCO,FLOWEL,
     +           INDELE)
            
 140     CONTINUE
         
         CALL L2DFCV (ALOK,MLOK,FLOK,GEOM,NODEL,KSW,RO,CP,
     +        DK,TELEM,DT)
         
         CALL ASMBTE (A,ALOK,MLOK,F,FLOK,2*MXNOD,STEER,NODEL,
     +        IDIAGT)
         
 130  CONTINUE


      DO 150 NELE=NELEMM-NELEXM+1,NELEMM
         NODEL = ELTOP(2,NELE)
         SIDNUM=3
         CALL ECOORD (NELE,GEOM,NODEL,ELTOP,IELTOP,COORD,ICOORD)
         CALL DIRECT (NELE,ELTOP,IELTOP,STEER)
         CALL C2LELL (ALOK,FLOK,SIDNUM,GEOM,NODEL,KSW,ALFA,
     +        AREFT,DT)
         CALL VFILL(4*NLOK*NLOK,MLOK,ZERO)
         CALL ASMBTE (A,ALOK,MLOK,F,FLOK,2*MXNOD,STEER,NODEL,
     +        IDIAGT)
 150  CONTINUE
      
      DO 160 NELE=NELEMM+NELEXC,NELEMS,NELEXC
         NODEL = ELTOP(2,NELE)
         SIDNUM=2
         CALL ECOORD (NELE,GEOM,NODEL,ELTOP,IELTOP,COORD,ICOORD)
         CALL DIRECT (NELE,ELTOP,IELTOP,STEER)
         CALL C2LELL (ALOK,FLOK,SIDNUM,GEOM,NODEL,KSW,ALFA,AREFT,DT)
         CALL VFILL(4*NLOK*NLOK,MLOK,ZERO)
         CALL ASMBTE (A,ALOK,MLOK,F,FLOK,2*MXNOD,STEER,NODEL,
     +                IDIAGT)
 160  CONTINUE


      I=1
      DO 170 NELE=(NELEMM-(NELEXC+NELEXM)+1),(NELEMM-NELEXM)
         NODEL = ELTOP(2,NELE)
         SIDNUM=3
         DSIG=(FREEB(I+2)-FREEB(I))/(COORD(1,I+2)-COORD(1,I))
         ASTEF=1.0D0
         UEXT=RO*DLHEAT*YVEL/DSQRT(1.0D0+DSIG*DSIG)
         CALL ECOORD (NELE,GEOM,NODEL,ELTOP,IELTOP,COORD,ICOORD)
         CALL DIRECT (NELE,ELTOP,IELTOP,STEER)
         CALL C2LELL (ALOK,FLOK,SIDNUM,GEOM,NODEL,KSW,ASTEF,UEXT,DT)
         CALL VFILL(4*NLOK*NLOK,ALOK,ZERO)
         CALL VFILL(4*NLOK*NLOK,MLOK,ZERO)
         CALL ASMBTE (A,ALOK,MLOK,F,FLOK,2*MXNOD,STEER,NODEL,
     +                IDIAGT)
         I=I+2
 170  CONTINUE

      CALL BCONDT(A,F,2*MXNOD,NNODX,NNODXC,NNODES,NNODM,
     +     TGAMIN,TGAMOU,IDIAGT)


      CALL SOLVE(A,T,F,MXNOD,NNODES,LOT,IDIAGT,IUPT)



      CALL NEWIT(TPREV,T,NNODES,TERR)


***************  Calculation of velocities  ***********************************

         CALL VFILL (2*MXNOD*IBMAX,A,ZERO)
         CALL VFILL (2*MXNOD,F,ZERO)

         DO 200 NELE=1,NELEMM
            NODEL = ELTOP(2,NELE)
            CALL ECOORD (NELE,GEOM,NODEL,ELTOP,IELTOP,COORD,ICOORD)
            CALL DIRECT (NELE,ELTOP,IELTOP,STEER)
            DO 230 I=1,NODEL
               IP=STEER(I)
               XP=COORD(1,IP)
               YP=COORD(2,IP)

               XO=XP
               YO=YP

               CALL MPOINT(XP,YP,UPREV(2*IP-1),UPREV(2*IP),DT,COORD,
     +              DIM,NNODX,NODEL,2*NODEL,ELEMCO,FLOWEL,IP,UPREV,
     +              IELTOP,ELTOP,XLEN,INDELE,SHCRU,SHLIQ,
     +              NNODM,NELEMM)

               DO 240 J=1,NODEL
                  FLX(J)=FLOWEL(2*J-1)
                  FLY(J)=FLOWEL(2*J)
 240           CONTINUE
 
               UELEM(2*I-1)=CONVT(XP,YP,XO,YO,NODEL,ELEMCO,FLX,
     +              INDELE)
               UELEM(2*I)=CONVT(XP,YP,XO,YO,NODEL,ELEMCO,FLY,
     +              INDELE)

	       TELEM(I)=TPREV(ELTOP(2+I,NELE))
 230        CONTINUE

            CALL L2NAVI (ALOK,FLOK,GEOM,VISCOS,RO,DT,
     +           UELEM,EPS,NODEL,TELEM,GRAVX,GRAVY,HEXPCO,REFTEM)
            CALL ASSEMB(A,ALOK,F,FLOK,MXNOD,STEER,NODEL,IDIAGV)
 200     CONTINUE

         CALL BCOND(A,F,MXNOD,NNODX,NNODM,IDIAGV,COORD,ICOORD,
     +        XLEN,RADCRY,YVEL)
         CALL SOLVE(A,U,F,MXNOD,2*NNODM,LOV,IDIAGV,IUPV)

         DO 210 I=NNODM+1,NNODES
            U(2*I-1)=0.0D0
            U(2*I)=YVEL
 210     CONTINUE



         CALL NEWIT(UPREV,U,2*NNODES,VERR)

*************** End of calculation of velocities  ****************************

         WRITE(6,17) ITCOUP,TIME,TERR,VERR
 17      FORMAT(I9,3F20.8)

      IF ((VERR .GT. TNOEPS) .AND. (ITCOUP .LT. MAXCPL)) THEN
         ITCOUP=ITCOUP+1
         GOTO 7000
      ENDIF


      ILIN1=1
      ILIN2=1
      INDMEL=3*(NELEXC+NELEXM+1)-1
      IND1=0
      IND2=INDMEL
      DO 300 I=1,NNODXC
         ILIN1=1
         ILIN2=1
 400     IF ((T(I+IND1) .GT. TMELT) .AND. 
     +        (T(I+IND2) .GT. TMELT)) THEN


            IF ( ((I+IND2)+INDMEL) .GT. NNODM) THEN
               IF (ILIN2 .EQ.1) THEN
                  IND2=IND2+NNODX+(NELEXC+1)
                  ILIN2=2
               ELSE
                  IND2=IND2+3*(NELEXC+1)-1
               ENDIF
            ELSE
               IND2=IND2+INDMEL
            ENDIF

            IF ( ((I+IND1)+INDMEL) .GT. NNODM) THEN
               IF (ILIN1 .EQ.1) THEN
                  IND1=IND1+NNODX+(NELEXC+1)
                  ILIN1=2
               ELSE
                  IND1=IND1+3*(NELEXC+1)-1
               ENDIF
            ELSE
               IND1=IND1+INDMEL
            ENDIF

            GOTO 400
         ELSE
            FREEBO(I)=FREEB(I)
            FREEB(I)=(TMELT-T(I+IND2))*(COORD(2,I+IND1)-
     +           COORD(2,I+IND2))/
     +           (T(I+IND1)-T(I+IND2))+COORD(2,I+IND2)
         ENDIF
 300  CONTINUE

      write(6,*) '*** Free boundary iteration'
      write(6,411) freeb(1),freeb(3),freeb(5),freeb(7),freeb(9),
     +     freeb(11),freeb(13),ENORM(FREEB,FREEBO,NNODXC)

 411  format(8f9.5)

      OPEN(11,FILE='velocity.dat',STATUS='UNKNOWN',ERR=991)
      write(11,*) nnodes
      do 610 i=1,nnodes
         write(11,601) i,coord(1,i),coord(2,i),u(2*i-1),u(2*i)
 610  continue
      write(11,*) nelexc,nelexm
      write(11,*) neleyc,neleym
 601  format(i5,5f14.9)
      CLOSE(11)

      OPEN(UNIT=12,FILE='temp.dat',STATUS='UNKNOWN')
      write(12,*) nnodes
      do 529 i=1,nnodes
         write(12,*) t(i)
 529  continue
      CLOSE(12)

      OPEN (UNIT=8,FILE='mesh.dat',STATUS='UNKNOWN',ERR=991)
      write(8,*) nnodes,nelems
      do 509 nele=1,nelems
         write(8,*) (ELTOP(J,NELE),J=1,NODEL+2)
 509  continue
      do 519 i=1,nnodes
         write(8,*) (COORD(J,i),J=1,2)
 519  continue
      CLOSE(8)


      IF ((ITER .LT. MAXIFB) .AND. 
     +     (ENORM(FREEB,FREEBO,NNODXC) .GT. ERRFB)) THEN

         CALL VFILL(DIM*MXNOD,COORD,ZERO)
 
         CALL MESHG(FREEB,COORD,ICOORD,NELEXC,NELEXM,NELEYC,NELEYM,
     +        XLEN,YLEN,RELXC,RELXM,RELYM,RELYC,RO,GASDEN,SURTEN,COANG,
     +        RADCRY,RADCRU)

         ITER=ITER+1
         GOTO 6000
      ENDIF

      GOTO 1000
 990  CONTINUE
      print *,'Error in input files'
      STOP
 991  CONTINUE
      print *,'Error in output files' 
      STOP
 1000 CONTINUE

      END                                 

      SUBROUTINE POLAR
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
C**********************************************************************
C
C   POLAR SETS UP THE CALCULATION OF THE MOLECULAR ELECTRIC RESPONSE
C   PROPERTIES BY FFHPOL.
C
C**********************************************************************
      CHARACTER*2 ELEMNT
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /POLVOL/ POLVOL(107)
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR),IDUMY,XPARAM(MAXPAR)
      COMMON /TIMEMP/ TIME0
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /CORE  / CORE(107)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1                    LOCDEP(MAXPAR)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /LAST  / LAST
      COMMON /COORD / COORD(3,NUMATM)
      COMMON /EULER / TVEC(3,3),IDTVEC
      COMMON /SCRACH/ RXYZ(MPACK),XDUMY(MAXPAR**2-MPACK)
      DIMENSION GRAD(MAXPAR),ROTVEC(3,3),DIPVEC(3),
     1          TEMPV(3,3)
      CHARACTER  KEYWRD*80, TYPE*7, KOMENT*80, TITLE*80
      LOGICAL LET
      TYPE=' MNDO  '
      LET=(INDEX(KEYWRD,'LET').NE.0)
      IF(INDEX(KEYWRD,'MINDO') .NE. 0) TYPE='MINDO/3'
      IF(INDEX(KEYWRD,'AM1') .NE. 0)    TYPE='  AM1  '
      WRITE (6,10)
   10 FORMAT ('1',20('*'),' FINITE-FIELD POLARIZABILITIES ',
     1        20('*'),//)
      CALL GMETRY(GEO,COORD)
C
C  Orient the molecule with the moments of inertia.
C  This is done to ensure a unique, reproduceable set of directions.
C  If LET is specified, the input orientation will be used.
C
      IF (.NOT.LET) THEN
         MASS = 1.0D00
         CALL AXIS (COORD,NUMAT,A,B,C,SUMW,MASS,ROTVEC)
         WRITE (6,20)
   20    FORMAT (/' ROTATION MATRIX FOR ORIENTATION OF MOLECULE:'/)
         DO 40 I = 1,3
            WRITE (6,30) (ROTVEC(I,J),J=1,3)
   30       FORMAT (5X,3F12.6)
   40    CONTINUE
C
C  ROTATE ATOMS
C
         DO 70 I = 1,NUMAT
            DO 60 J = 1,3
               SUM = 0.0D00
               DO 50 K = 1,3
                  SUM = SUM + COORD(K,I)*ROTVEC(K,J)
   50          CONTINUE
               GEO(J,I) = SUM
   60       CONTINUE
   70    CONTINUE
         DO 90 I = 1,NUMAT
            DO 80 J = 1,3
               COORD(J,I) = GEO(J,I)
   80       CONTINUE
   90    CONTINUE
         WRITE(6,'(//10X,''CARTESIAN COORDINATES '',/)')
         WRITE(6,'(4X,''NO.'',7X,''ATOM'',9X,''X'',
     1  9X,''Y'',9X,''Z'',/)')
         L=0
         DO 100 I=1,NUMAT
            IF(NAT(I).EQ.99.OR.NAT(I).EQ.107) GOTO 100
            L=L+1
            WRITE(6,'(I6,8X,A2,4X,3F10.4)')
     1           L,ELEMNT(NAT(I)),(COORD(J,L),J=1,3)
  100    CONTINUE
C
C  IF POLYMER, ROTATE TVEC
C
         IF (IDTVEC.GT.0) THEN
            DO 130 I = 1,IDTVEC
               DO 120 J = 1,3
                  SUM = 0.0D00
                  DO 110 K = 1,3
                     SUM = SUM + TVEC(K,I)*ROTVEC(K,J)
  110             CONTINUE
                  TEMPV(J,I) = SUM
  120          CONTINUE
  130       CONTINUE
            DO 150 I = 1,3
               DO 140 J = 1,IDTVEC
                  TVEC(I,J) = TEMPV(I,J)
  140          CONTINUE
  150       CONTINUE
            WRITE (6,160) ((TVEC(J,I),J=1,3),I=1,IDTVEC)
  160       FORMAT (/' NEW TRANSLATION VECTOR:'/,
     1           ' ',3(3F15.5))
         ENDIF
      ENDIF
C
      LAST=1
      NA(1)=99
C
C  SET UP THE VARIABLES IN XPARAM AND LOC, THESE ARE IN CARTESIAN
C  COORDINATES.
C
      NDEP=0
      NUMAT=0
      SUMX=0.D0
      SUMY=0.D0
      SUMZ=0.D0
      DO 180 I=1,NATOMS
         IF((LABELS(I).NE.99).AND.(LABELS(I).NE.107)) THEN
            NUMAT=NUMAT+1
            LABELS(NUMAT)=LABELS(I)
            SUMX=SUMX+COORD(1,NUMAT)
            SUMY=SUMY+COORD(2,NUMAT)
            SUMZ=SUMZ+COORD(3,NUMAT)
            DO 170 J=1,3
  170       GEO(J,NUMAT)=COORD(J,NUMAT)
         ENDIF
  180 CONTINUE
      SUMX=SUMX/NUMAT
      SUMY=SUMY/NUMAT
      SUMZ=SUMZ/NUMAT
      SUMMAX=0.D0
      ATPOL=0.D0
      DO 190 I=1,NUMAT
         IF (LABELS(I).NE.107) THEN
            ATPOL=ATPOL+POLVOL(LABELS(I))
         ENDIF
         GEO(1,I)=GEO(1,I)-SUMX
         IF(SUMMAX.LT.ABS(GEO(1,I))) SUMMAX=ABS(GEO(1,I))
         GEO(2,I)=GEO(2,I)-SUMY
         IF(SUMMAX.LT.ABS(GEO(2,I))) SUMMAX=ABS(GEO(2,I))
         GEO(3,I)=GEO(3,I)-SUMZ
         IF(SUMMAX.LT.ABS(GEO(3,I))) SUMMAX=ABS(GEO(3,I))
  190 CONTINUE
C
      NVAR=0
      NATOMS = NUMAT
      CALL COMPFG(GEO, .TRUE., HEAT0, .TRUE., GRAD, .FALSE.)
      WRITE (6,200) HEAT0
  200 FORMAT (//' ENERGY OF "REORIENTED" SYSTEM WITHOUT FIELD:',
     1        F20.10)
C
      CALL FFHPOL (HEAT0,ATPOL,DIPVEC)
C
      RETURN
      END

      SUBROUTINE GAUSL3 (WG,XI,NQP)
      DOUBLE PRECISION WG(*), XI(*)
      INTEGER NQP
      DOUBLE PRECISION SQ, W1, W2
      PARAMETER (SQ = 0.7745966692414834D0)
      PARAMETER (W1 = 5.D0/9.D0, W2 = 8.D0/9.D0)
      NQP = 3
      WG(1) = W1
      WG(2) = W2
      WG(3) = W1
      XI(1) = -SQ
      XI(2) = 0.D0
      XI(3) = SQ
      RETURN
      END

C----------------------------------------------------------------------C   
C File : serlph.f                                                      C   
C Created: 08/05/91 IS                                                 C   
C History: See below                                                   C   
C----------------------------------------------------------------------C   
C                                                                       
C   02-JUN-91  PERIODIC BOUNDARY CONDITIONS APPLIED TO IONIC POSITIONS  
C              AND TO RXDIS,RYDIS,RZDIS.   (IS)                         
C
C   15-JUL-91  NODE INDEX REMOVED FROM ALL LOOKUP TABLES; I.E. EACH NODE 
C              STORES ONLY ITS OWN LOOKUP TABLE.   (IS)                  
C
C   10-DEC-91  PERIODIC BOUNDARY CONDITIONS ELIMINATED FROM THE SEARCH
C              OVER REAL-SPACE GRID POINTS. THE OLD VERSION WAS
C              INCORRECT IF RLCORE WAS LARGER THAN HALF THE BOX SIDE.
C              (IS)
C---------------------------------------------------------------------- 
      SUBROUTINE SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,
     &           NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT,NGX,NGY,NGZ)

C                                   
      IMPLICIT REAL*8 (A,B,D-H,O-Z) 
      IMPLICIT COMPLEX*16 (C)       
      LOGICAL WRDIM 
C                                   
C========================================================================
C
C THIS SUBROUTINE SETS UP THE PHASE FACTORS ON THE REAL SPACE
C GRID AROUND EACH ATOM IN PREPARATION FOR CALCULATING H*PSI AND THE
C FORCES ON THE ATOMS - THE ABSOLUTE VALUE OF THE PHASE FACTOR IS
C IRRELEVANT - ONLY THE RELATIVE VALUE BETWEEN GRIDPOINTS MATTERS
C
C========================================================================
      DIMENSION DIRC(3,3),RECC(3,3)
      DIMENSION POSION(3,NIONS,NSPEC),NRLPPI(NIONST)
      DIMENSION CPHGRD(NRGRPT,NIONST)
      DIMENSION NIONSP(NSPEC),RLCORE(NSPEC)
      DIMENSION VKPT(3)
      DIMENSION POSTMP(3)
C                                                                         
      DATA CITPI,TPI / (0.0,6.283185307179),6.283185307179 /
      DATA WRDIM /.FALSE./
C========================================================================
C INITIALISE THE INDEX FOR THE IONS, NPION, CONSTANTS, AND
C START THE LOOP OVER SPECIES OF IONS
C========================================================================
      RLENV1=DSQRT(DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2)
      RLENV2=DSQRT(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2)
      RLENV3=DSQRT(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2)
      RLENG1=DSQRT(RECC(1,1)**2+RECC(1,2)**2+RECC(1,3)**2)
      RLENG2=DSQRT(RECC(2,1)**2+RECC(2,2)**2+RECC(2,3)**2)
      RLENG3=DSQRT(RECC(3,1)**2+RECC(3,2)**2+RECC(3,3)**2)
      NPION=1
      DO 1000 NSP=1,NSPEC
C========================================================================
C START BY DETERMINING THE SIZE OF THE REAL SPACE GRID TO BE SEARCHED
C FOR THIS SPECIES OF ION THE ENSURE THAT ALL THE REAL SPACE POINTS
C WITHIN RLCORE(NSP) ARE SAMPLED - THE TRICK TO THIS PROCESS IS TO GO
C ALONG EACH LATTICE VECTOR UNTIL IT HITS THE PLANE DEFINED BY THE OTHER
C LATTICE VECTORS THAT IS TANGENTIAL TO A SPHERE OF RADIUS RLCORE AND
C THEN ADD HALF A LATTICE VECTOR TO ALLOW FOR THE CENTRE OF THE ION
C BEING UP TO HALF A LATTICE VECTOR FROM THE NEAREST GRID POINT
C
C TPI/RLENV1*RLENG1 IS THE ANGLE BETWEEN THE FIRST LATTICE VECTOR AND THE
C NORMAL TO THE PLANE DEFINED BY THE OTHER LATTICE VECTORS
C USE THIS TO DETERMINE SIZE OF GRID TO BE SEARCHED
C========================================================================
      NUMXPT=INT(5.D-1+RLCORE(NSP)*NGX*RLENV1*RLENG1/(TPI*RLENV1))
      NUMYPT=INT(5.D-1+RLCORE(NSP)*NGY*RLENV2*RLENG2/(TPI*RLENV2))
      NUMZPT=INT(5.D-1+RLCORE(NSP)*NGZ*RLENV3*RLENG3/(TPI*RLENV3))
C========================================================================
C START LOOP OVER THE IONS FOR THIS SPECIES
C========================================================================
      DO 1100 NI=1,NIONSP(NSP)     
C========================================================================
      DO 1101 IM=1,3                                                         
      POSTMP(IM)=MOD(POSION(IM,NI,NSP),1.D0)  
      POSTMP(IM)=POSTMP(IM)-INT(2.D0*POSTMP(IM))
 1101 CONTINUE                                                                  
C========================================================================
C FIRST IDENTIFY THE NEAREST GRID POINT TO THE CURRENT ION
C========================================================================
      NGRPX=1+MOD(INT(5.D-1+NGX*POSTMP(1)),NGX)
      NGRPY=1+MOD(INT(5.D-1+NGY*POSTMP(2)),NGY)
      NGRPZ=1+MOD(INT(5.D-1+NGZ*POSTMP(3)),NGZ)
C========================================================================
C NOW START SEARCH OVER GRID TO FIND POINTS WITHIN RLCORE OF THE ION
C INDAD INDICATES THE NUMBER OF GRID POINTS THAT HAVE BEEN FOUND
C WITHIN RLCORE AND IS USED AS THE ADDRESS INDEX FOR PUTTING THE
C PHASE FACTORS ETC INTO THE DATA ARRAYS
C========================================================================
      INDAD=1
      DO 1200 NZ=-NUMZPT,NUMZPT
      RZDIS=((1.D0*(NGRPZ+NZ-1))/(1.D0*NGZ)) - POSTMP(3)
      RZDIS=MOD(RZDIS,1.D0)
      RZDIS=RZDIS-INT(2.D0*RZDIS)
      DO 1201 NY=-NUMYPT,NUMYPT
      RYDIS=((1.D0*(NGRPY+NY-1))/(1.D0*NGY)) - POSTMP(2)
      RYDIS=MOD(RYDIS,1.D0)
      RYDIS=RYDIS-INT(2.D0*RYDIS)
      DO 1202 NX=-NUMXPT,NUMXPT
      RXDIS=((1.D0*(NGRPX+NX-1))/(1.D0*NGX)) - POSTMP(1)
      RXDIS=MOD(RXDIS,1.D0)
      RXDIS=RXDIS-INT(2.D0*RXDIS)
      XCOR=DIRC(1,1)*RXDIS+DIRC(2,1)*RYDIS+DIRC(3,1)*RZDIS
      YCOR=DIRC(1,2)*RXDIS+DIRC(2,2)*RYDIS+DIRC(3,2)*RZDIS
      ZCOR=DIRC(1,3)*RXDIS+DIRC(2,3)*RYDIS+DIRC(3,3)*RZDIS
      RAD=DSQRT(XCOR**2+YCOR**2+ZCOR**2)
      IF(RAD.LE.RLCORE(NSP)) THEN
      CZPH=EXP(-CITPI*VKPT(3)*((1.D0*(NGRPZ+NZ-1))/(1.D0*NGZ)))
      CYPH=EXP(-CITPI*VKPT(2)*((1.D0*(NGRPY+NY-1))/(1.D0*NGY)))
      CXPH=EXP(-CITPI*VKPT(1)*((1.D0*(NGRPX+NX-1))/(1.D0*NGX)))
      CPHGRD(INDAD,NPION)=CXPH*CYPH*CZPH
C========================================================================
C INCREMENT ADDRESS COUNTER
C========================================================================
      INDAD=INDAD+1
      ENDIF
C========================================================================
C END LOOPS OVER X,Y,Z RESPECTIVELY
C========================================================================
 1202 CONTINUE
 1201 CONTINUE
 1200 CONTINUE
C========================================================================
C CHECK THAT POTENTIAL AND PHASE ARRAYS AGREE ON NUMBER OF GRID POINTS
C========================================================================
      IF(INDAD-1.NE.NRLPPI(NPION)) THEN
      WRITE(*,1500) NPION,INDAD-1,NRLPPI(NPION)
      WRDIM=.TRUE.
 1500 FORMAT(' # POTENTIAL AND PHASE POINTS DISAGREE:',
     &       ' ATOM:',I3,I5,I5)
      ENDIF
C========================================================================
C INCREMENT ION COUNTER BY ONE
C========================================================================
      NPION=NPION+1
C========================================================================
C END ION LOOP
C========================================================================
 1100 CONTINUE
C========================================================================
C END SPECIES LOOP
C========================================================================
 1000 CONTINUE
C========================================================================
C CHECK THAT TOTAL NUMBER OF IONS HAS BEEN CORRECTLY SET
C========================================================================
      IF(NPION-1.GT.NIONST) THEN
      WRITE(*,1600) NPION-1
      WRDIM=.TRUE.
 1600 FORMAT(': WRONG VALUE FOR NIONST, SHOULD BE:',I3)
      ENDIF
      IF(WRDIM) STOP 
      RETURN
      END

      DOUBLE PRECISION FUNCTION ENORM(S0,S,NNODX)
      DOUBLE PRECISION S0(*),S(*),SUM
      INTEGER NNODX,I

      SUM=0.0D0
      DO 10 I=1,NNODX
10      SUM=SUM+DABS((S0(I)-S(I)))**2.0D0
      ENORM=DSQRT(SUM)
      RETURN
      END

      SUBROUTINE BCOND(A,F,MXNOD,NNODX,NNODM,IDIAG,COORD,ICOORD,
     +                 XLEN,RADCRY,YVEL)
      INTEGER MXNOD,NNODX,NNODM,IDIAG,ICOORD
      DOUBLE PRECISION A(2*MXNOD,*),F(*),COORD(ICOORD,*),
     +                 XLEN,RADCRY,YVEL
      DOUBLE PRECISION BIG
      PARAMETER(BIG=1.0D+12)
      INTEGER I,NX


      DO 10 I=1,NNODX
         A(2*I-1,IDIAG)=BIG
         F(2*I-1)=0.0D0
         A(2*I,IDIAG)=BIG
         F(2*I)=BIG*(YVEL*RADCRY**2.0D0/(XLEN**2.0D0))
 10   CONTINUE

      NX=(NNODX-1)/2+1


      DO 20 I=1,NNODM,3*NX-1
         A(2*I-1,IDIAG)=BIG
         F(2*I-1)=0.0D0
 20   CONTINUE

      DO 25 I=NNODX+1,NNODM-NNODX+1,3*NX-1
         A(2*I-1,IDIAG)=BIG
         F(2*I-1)=0.0D0
 25   CONTINUE


      DO 30 I=NNODX,NNODM,3*NX-1
         A(2*I-1,IDIAG)=BIG
         F(2*I-1)=0.0D0
 30   CONTINUE

      DO 35 I=NNODX+NX,NNODM-NNODX,3*NX-1
         A(2*I-1,IDIAG)=BIG
         F(2*I-1)=0.0D0
 35   CONTINUE


      DO 40 I=NNODM-NNODX+1,NNODM


            A(2*I-1,IDIAG)=BIG
            F(2*I-1)=0.0D0


         IF (COORD(1,I) .LT. (RADCRY-1.0D+4/BIG)) THEN
            A(2*I,IDIAG)=BIG
            F(2*I)=BIG*YVEL
         ELSE
            A(2*I,IDIAG)=BIG
            F(2*I)=0.0D0
         ENDIF
 40   CONTINUE

      RETURN
      END

      FUNCTION MECI(EIGS,COEFF,COEFFS,EIGA,N,NMOS,IRESET,FINISH)
***********************************************************************
*
*                 PROGRAM MECI
*
*   A MULTI-ELECTRON CONFIGURATION INTERACTION CALCULATION
*
*   WRITTEN BY JAMES J. P. STEWART, AT THE
*              FRANK J. SEILER RESEARCH LABORATORY
*              USAFA, COLORADO SPRINGS, CO 80840
*
*              1985
*
***********************************************************************
C
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INCLUDE 'mopac.inc'
      DOUBLE PRECISION MECI
C
C   MATRICES FOR SEC.DET., VECTORS, AND EIGENVALUES.
C
      DIMENSION CIMAT(NMECI**4), CONF(NMECI**4),
     1 EIG(NMECI**2), DIAG(2*NMECI**3)
C
C   MATRICES TO HOLD ELECTRON CONFIGURATIONS
C
      DIMENSION MICROA(NMECI,2*NMECI**3), MICROB(NMECI,2*NMECI**3),
     1IOCCA1(NMECI), IOCCA2(NMECI), IOCCB1(NMECI),
     2IOCCB2(NMECI), NALPHA(NMECI**2)
C
C   MATRICES FOR PERMUTATION WORK
C
      DIMENSION NFA(2*NMECI), NPERMA(NMECI,6*NMECI),
     1NPERMB(NMECI,6*NMECI)
C
C   MATRICES FOR ONE AND TWO ELECTRON INTEGRALS, AND M.O.S
C
      DIMENSION EIGA(MAXORB), EIGS(MAXORB), RJKAA(NMECI,NMECI),
     1          RJKAB(NMECI,NMECI), COEFF(N,N),  COEFFS(N,N)
C
C   SPIN MATRICES
C
      DIMENSION SPIN(NMECI**2)
      LOGICAL DEBUG,  LARGE, PRNT, FIRST, LSPIN, LSPIN1, FINISH,
     1 FIRST1, BIGPRT, SING, DOUB, TRIP, QUAR, QUIN, SEXT, LAST1,
     2 PRNT2, FORCE, GEOOK
      CHARACTER KEYWRD*80, TSPIN(7)*8, LINE*80
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,
     2                NDUMMY(2), NCLOSE, NOPEN, NDUMY, FRACT
      COMMON /SPQR/ ISPQR(NMECI**2,NMECI),IS,I,K
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /KEYWRD/ KEYWRD
      COMMON /BASEOC/ OCCA(NMECI)
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      DATA TSPIN/'SINGLET ','DOUBLET ','TRIPLET ','QUARTET ','QUINTET ',
     1'SEXTET  ','SEPTET  '/
      DATA FIRST/.TRUE./, FIRST1/.TRUE./
      IF(FIRST)THEN
         FIRST=.FALSE.
         GEOOK=(INDEX(KEYWRD,'GEO-OK').NE.0)
         FORCE=(INDEX(KEYWRD,'FORCE').NE.0)
         LAST1=(INDEX(KEYWRD,'1SCF').NE.0)
         LSPIN1=(INDEX(KEYWRD,'ESR').NE.0)
         MDIM=NMECI**2
         DEBUG=(INDEX(KEYWRD,'DEBUG').NE.0)
         PRNT2=(INDEX(KEYWRD,'MECI').NE.0)
         DEBUG=(DEBUG.AND.PRNT2)
         LARGE=(INDEX(KEYWRD,'LARGE').NE.0)
         LROOT=1
         IF(INDEX(KEYWRD,'EXCI').NE.0)LROOT=2
         I=INDEX(KEYWRD,'ROOT')
         IF(I.NE.0)LROOT=READA(KEYWRD,I)
C#         WRITE(6,'('' NCLOSE, NOPEN'',2I6)')NCLOSE,NOPEN
         J=MAX(MIN((NCLOSE+NOPEN+1)/2-(NMOS-1)/2,NORBS-NMOS+1),1)
         L=0
         DO 10 I=J,NCLOSE
            L=L+1
   10    OCCA(L)=1
         DO 20 I=NCLOSE+1,NOPEN
            L=L+1
   20    OCCA(L)=FRACT*0.5D0
         DO 30 I=NOPEN+1,J+NMOS-1
            L=L+1
   30    OCCA(L)=0.D0
C#         WRITE(6,'('' INITIAL ORBITAL OCCUPANCIES'')')
C#         WRITE(6,'(6F12.6)')(OCCA(L),L=1,NMOS)
         SING=(INDEX(KEYWRD,'SINGL')+
     1         INDEX(KEYWRD,'EXCI')+
     2         INDEX(KEYWRD,'BIRAD').NE.0)
         DOUB=(INDEX(KEYWRD,'DOUBL').NE.0)
         TRIP=(INDEX(KEYWRD,'TRIPL').NE.0)
         QUAR=(INDEX(KEYWRD,'QUART').NE.0)
         QUIN=(INDEX(KEYWRD,'QUINT').NE.0)
         SEXT=(INDEX(KEYWRD,'SEXTE').NE.0)
         SMULT=-.5D0
         IF(SING) SMULT=0.00D0
         IF(DOUB) SMULT=0.75D0
         IF(TRIP) SMULT=2.00D0
         IF(QUAR) SMULT=3.75D0
         IF(QUIN) SMULT=6.00D0
         IF(SEXT) SMULT=8.75D0
C#      WRITE(6,'('' ORBITAL COUNTERS, PER ATOM, FIRST LAST'')')
C#      WRITE(6,'(I40,I6)')(NFIRST(I),NLAST(I),I=1,NUMAT)
         X=0.D0
         DO 40 J=1,NMOS
   40    X=X+OCCA(J)
         XX=X+X
         NE=XX+0.5
         NELEC=(NELECS-NE+1)/2
         NLEFT=NORBS-NMOS-NELEC
      ENDIF
      IF(IRESET.EQ.1)THEN
         ONE=-1.D0
         GOTO 520
      ELSE
         ONE=1.D0
      ENDIF
      PRNT=(DEBUG.OR.FINISH.AND.PRNT2)
      BIGPRT=(PRNT.AND.LARGE)
      LAST1=(LAST1.OR.FINISH)
C
C    TEST TO SEE IF THE SET OF ENERGY LEVELS USED IN MECI IS COMPLETE,
C    I.E., ALL COMPONENTS OF DEGENERATE IRREDUCIBLE REPRESENTATIONS
C    ARE USED.  IF NOT, THEN RESULTS WILL BE NONSENSE.  GIVE USERS A
C    CHANCE TO REALLY FOUL THINGS UP BY ALLOWING JOB TO CONTINUE IF
C    'GEO-OK' IS SPECIFIED.
C
      DO 60 I=1,NMOS
         IN=I+NELEC
         DO 50 J=1,NORBS
   50    COEFFS(J,I)=COEFF(J,IN)
   60 EIGA(I)=EIGS(IN)
      LSPIN=(LSPIN1.AND. FINISH)
      IF(BIGPRT)THEN
         WRITE(6,'(''  INITIAL EIGENVALUES'')')
         WRITE(6,'(5F12.6)')(EIGA(I),I=1,NMOS)
         WRITE(6,'(//10X,''NUMBER OF ELECTRONS IN C.I. ='',F5.1)')XX
      ENDIF
      IF(.NOT.GEOOK.AND.NELEC.GT.0)THEN
         IF(ABS(EIGS(NELEC+1)-EIGS(NELEC)).LT.1.D-1.OR.
     1ABS(EIGS(NELEC+1+NMOS)-EIGS(NELEC+NMOS)).LT.1.D-1)THEN
            WRITE(6,'(///10X,A)')'DEGENERATE ENERGY LEVELS DETECTED IN M
     1ECI'
            WRITE(6,'(10X,A)')'SOME OF THESE LEVELS WOULD BE TREATED BY'
     1//'MECI,'
            WRITE(6,'(10X,A)')'WHILE OTHERS WOULD NOT.  THIS WOULD RESUL
     1T IN'
            WRITE(6,'(10X,A)')'NON-REPRODUCIBLE ELECTRONIC ENERGIES.'
            WRITE(6,'(10X,A)')'  JOB STOPPED.  TO CONTINUE, SPECIFY "GEO
     1-OK"'
            CALL WRAPUP()
         ENDIF
      ENDIF
      KALPHA=(NE+1)/2
      KBETA=NE-KALPHA
C
C   FOR DEBUGGING PURPOSES, UNCOMMENT THE FOLLOWING LINES
C   THEY LOCK THE PHASE-FACTOR
C
C#      DO 55 I=1,NMOS
C#      SUM=0.D0
C#      DO 56 J=1,NORBS
C#  56  IF(ABS(SUM).LT.ABS(COEFFS(J,I)))SUM=COEFFS(J,I)
C#      IF(SUM.LT.0.D0)THEN
C#      DO 57 J=1,NORBS
C#  57  COEFFS(J,I)=-COEFFS(J,I)
C#      ENDIF
C#  55  CONTINUE
C
C   FOR DEBUGGING PURPOSES, UNCOMMENT THE PRECEEDING LINES
C
      IF( BIGPRT ) THEN
         WRITE(6,'(//10X,''EIGENVECTORS'',/)')
         DO 70 I=1,NORBS
   70    WRITE(6,'(6F12.6)')(COEFFS(I,J),J=1,NMOS)
      ENDIF
      DO 80 I=1,NMOS
         DO 80 J=1,NMOS
            DO 80 K=1,NMOS
               DO 80 L=1,NMOS
   80 XY(I,J,K,L)=100.0D0
      NFA(2)=1
      NFA(1)=1
      DO 90 I=3,NMECI+1
   90 NFA(I)=NFA(I-1)*(I-1)
      DO 100 I=1,NMOS
         DO 100 J=1,NMOS
            DO 100 K=1,NMOS
               DO 100 L=1,NMOS
  100 XY(I,J,K,L)=100.0D0
      DO 110 I=1,NMOS
         I1=I
         DO 110 J=1,I
            J1=J
            DO 110 K=1,NMOS
               K1=K
               DO 110 L=1,K
                  L1=L
  110 CALL IJKL(I1,K1,J1,L1,X,COEFFS,NORBS)
      DO 120 I=1,NMOS
         DO 120 J=1,NMOS
            RJKAA(I,J)=XY(I,I,J,J)-XY(I,J,I,J)
  120 RJKAB(I,J)=XY(I,I,J,J)
      DO 140 I=1,NMOS
         X=0.0
         DO 130 J=1,NMOS
            X=X+(RJKAA(I,J)+RJKAB(I,J))*OCCA(J)
  130    CONTINUE
         EIGA(I)=EIGA(I)-X
C#      IF(ABS(OCCA(I)-0.5).LT.1.D-4)EIGA(I)=EIGA(I)+XY(I,I,I,I)*0.25D0
  140 CONTINUE
      IF(BIGPRT) THEN
         WRITE(6,150)
  150    FORMAT(/,5X,'EIGENVALUES AFTER REMOVAL OF INTER-ELECTRONIC INTE
     1RACTIONS',/)
         WRITE(6,'(6F12.6)')(EIGA(I),I=1,NMOS)
         WRITE(6,'(///10X,''TWO-ELECTRON J-INTEGRALS'',/)')
         DO 160 I1=1,NMOS
  160    WRITE(6,'(10F10.4)')(RJKAB(I1,J1),J1=1,NMOS)
         WRITE(6,'(///10X,''TWO-ELECTRON K-INTEGRALS'',/)')
         DO 170 I1=1,NMOS
  170    WRITE(6,'(10F10.4)')(RJKAB(I1,J1)-RJKAA(I1,J1),J1=1,NMOS)
      ENDIF
      NATOMS=NUMAT
      DO 180 I=1,NMOS
         DO 180 J=1,NMOS
            RJKAA(I,J)=RJKAA(I,J)*0.5D0
  180 CONTINUE
      IF(FIRST1) THEN
         I=INDEX(KEYWRD,'MICROS')
         IF(I.NE.0)THEN
            K=READA(KEYWRD,I)
            LAB=K
            IF(PRNT)WRITE(6,'(''    MICROSTATES READ IN'')')
            NTOT=XX+0.5
CDEP
C-old            OPEN(UNIT=5,FILE='FOR005',STATUS='OLD',BLANK='ZERO')
C-old            REWIND 5
            DO 190 I=1,3
  190       READ(5,'(A)')LINE
            DO 200 I=1,1000
               READ(5,'(A)')LINE
  200       IF(INDEX(LINE,'MICRO').NE.0)GOTO 210
  210       DO 240 I=1,LAB
               READ(5,'(A)')LINE
               IZERO=MAX(0,MIN(INDEX(LINE,'0'),INDEX(LINE,'1'))-1)
               DO 220 J=1,NMOS
                  IF(LINE(J+IZERO:J+IZERO).NE.'1')
     1            LINE(J+IZERO:J+IZERO)='0'
                  IF(LINE(J+NMOS+IZERO:J+NMOS+IZERO).NE.'1')
     1            LINE(J+NMOS+IZERO:J+NMOS+IZERO)='0'
                  MICROA(J,I)=ICHAR(LINE(J+IZERO:J+IZERO))-
     1          ICHAR('0')
                  MICROB(J,I)=ICHAR(LINE(J+NMOS+IZERO:J+NMOS+IZERO))-
     1          ICHAR('0')
  220          CONTINUE
               IF(PRNT)WRITE(6,'(20I6)')(MICROA(J,I),J=1,NMOS),
     1        (MICROB(J,I),J=1,NMOS)
               K=0
               DO 230 J=1,NMOS
  230          K=K+MICROA(J,I)+MICROB(J,I)
               IF(K.NE.NTOT)THEN
                  NTOT=K
                  XX=K
                  WRITE(6,'(/,''NUMBER OF ELECTRONS IN C.I. REDEFINED TO
     1:'',I4,/)')K
               ENDIF
  240       CONTINUE
            FIRST1=.FALSE.
            GOTO 310
         ENDIF
         NUPP=KALPHA
         NDOWN=KBETA
         AMS=(NUPP-NDOWN)*0.5D0
         IF(PRNT)WRITE(6,250) AMS
  250    FORMAT(10X,'COMPONENT OF SPIN  = ',F4.1)
         IF(NUPP*NDOWN.GE.0) GOTO 270
         WRITE(6,260)
  260    FORMAT(/10X,28H IMPOSSIBLE VALUE OF DELTA S/)
         CALL WRAPUP()
  270    LIMA=NFA(NMOS+1)/(NFA(NUPP+1)*NFA(NMOS-NUPP+1))
         LIMB=NFA(NMOS+1)/(NFA(NDOWN+1)*NFA(NMOS-NDOWN+1))
         LAB=LIMA*LIMB
         IF(PRNT)WRITE(6,280) LAB
  280    FORMAT(//10X,35H NO OF CONFIGURATIONS CONSIDERED = ,I4)
C#      IF(LAB.LT.101) GOTO 240
C#      WRITE(6,230)
C#  230 FORMAT(10X,24H TOO MANY CONFIGURATIONS/)
C#      GOTO 160
C#  240 CONTINUE
         CALL PERM(NPERMA, NUPP, NMOS, NMECI, LIMA)
         CALL PERM(NPERMB, NDOWN, NMOS, NMECI, LIMB)
         K=0
         DO 290 I=1,LIMA
            DO 290 J=1,LIMB
               K=K+1
               DO 290 L=1,NMOS
                  MICROA(L,K)=NPERMA(L,I)
  290    MICROB(L,K)=NPERMB(L,J)
  300    FORMAT(10I1)
  310    CONTINUE
         LIMA=LAB
         LIMB=LAB
      ENDIF
      GSE=0.0D0
      DO 320 I=1,NMOS
C#         IF(ABS(OCCA(I)-0.5).LT.0.01)GSE=GSE-0.25D0*XY(I,I,I,I)
         GSE=GSE+EIGA(I)*OCCA(I)*2.D0
         GSE=GSE+XY(I,I,I,I)*OCCA(I)*OCCA(I)
         DO 320 J=I+1,NMOS
  320 GSE=GSE+2.D0*(2.D0*XY(I,I,J,J) - XY(I,J,I,J))*OCCA(I)*OCCA(J)
C#    IF(PRNT)WRITE(6,'('' GROUND STATE ENERGY:'',F13.6,'' E.V.'')')GSE
C     ..........
      IF( PRNT )
     1WRITE(6,'(//10X,''CONFIGURATIONS CONSIDERED IN C.I.'',//)')
      J=0
      DO 330 I=1,LAB
         DIAG(I)=DIAGI(MICROA(1,I),MICROB(1,I),EIGA,XY,NMOS)-GSE
  330 CONTINUE
  340 CONTINUE
      IF(LAB.LE.MDIM) GOTO 380
      X=-100.D0
      DO 350 I=1,LAB
         IF(DIAG(I).GT.X)THEN
            X=DIAG(I)
            J=I
         ENDIF
  350 CONTINUE
      IF(J.NE.LAB) THEN
         DO 370 I=J,LAB
            I1=I+1
            DO 360 K=1,NMOS
               MICROA(K,I)=MICROA(K,I1)
  360       MICROB(K,I)=MICROB(K,I1)
  370    DIAG(I)=DIAG(I1)
      ENDIF
      LAB=LAB-1
      GOTO 340
  380 CONTINUE
C
C   BEFORE STARTING, CHECK THAT THE ROOT WANTED CAN EXIST
C
      IF(LAB.LT.LROOT)THEN
         WRITE(6,'(//10X,''C.I. IS OF SIZE LESS THAN ROOT SPECIFIED'')')
         WRITE(6,'(10X,''MODIFY SIZE OF C.I. OR ROOT NUMBER'')')
         CALL WRAPUP()
      ENDIF
C
C  MAIN LOOP TO FILL SECULAR DETERMINANT
C
      IK=0
      DO 430 I=1,LAB
         K=0
         DO 390 J=1,NMOS
            IOCCB1(J)=MICROB(J,I)
            IOCCA1(J)=MICROA(J,I)
  390    K=K+IOCCA1(J)
         NALPHA(I)=K
         IF(PRNT)  THEN
            WRITE(6,'(/10X,I4,6X,10I4)') I,(IOCCA1(K),K=1,NMOS)
            WRITE(6,'(20X,10I4)')(IOCCB1(K),K=1,NMOS)
         ENDIF
         IS=2
C
C   INNER LOOP TO FILL SECULAR DETERMINANT
C
         DO 420 K=1,I
            IK=IK+1
            CIMAT(IK)=I*1.D-15+J*.1D-17
            IX=0
            IY=0
            DO 400 J=1,NMOS
               IOCCB2(J)=MICROB(J,K)
               IOCCA2(J)=MICROA(J,K)
               IX=IX+ABS(IOCCA1(J)-IOCCA2(J))
  400       IY=IY+ABS(IOCCB1(J)-IOCCB2(J))
C
C                              CHECK IF MATRIX ELEMENT HAS TO BE ZERO
C
            IF(IX+IY.GT.4 .OR. NALPHA(I).NE.NALPHA(K))  GOTO 420
            IF(IX+IY.EQ.4) THEN
               IF(IX.EQ.0)THEN
                  CIMAT(IK)=BABBCD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
               ELSEIF(IX.EQ.2)THEN
                  CIMAT(IK)=AABBCD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
               ELSE
                  CIMAT(IK)=AABACD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
               ENDIF
            ELSEIF(IX.EQ.2)THEN
               CIMAT(IK)=AABABC(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
            ELSEIF(IY.EQ.2)THEN
               CIMAT(IK)=BABBBC(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
            ELSE
               CIMAT(IK)=DIAG(I)
               X=0.0D0
               DO 410 J=1,NMOS
  410          X=X+IOCCA1(J)*IOCCB1(J)
               SPIN(I)=(-(XX-2*NALPHA(I))*(XX-2*NALPHA(I))+X*4.D0)
            ENDIF
  420    CONTINUE
         ISPQR(I,1)=IS-1
  430 CONTINUE
      IF(BIGPRT)THEN
         WRITE(6,'(//,'' C.I. MATRIX'')')
         CALL VECPRT(CIMAT,-LAB)
      ELSE
         IF(PRNT)WRITE(6,'(//,'' DIAGONAL OF C.I. MATRIX'')')
         IF(PRNT)WRITE(6,'(5F13.6)')(CIMAT((I*(I+1))/2),I=1,LAB)
      ENDIF
      CALL RSP(CIMAT,LAB,LAB,EIG,CONF)
C
C   DECIDE WHICH ROOT TO EXTRACT
C
      KROOT=0
      IF(SMULT.LT.-0.1D0)THEN
         MECI=EIG(LROOT)
         KROOT=LROOT
      ENDIF
      IF(BIGPRT)  THEN
         WRITE(6,'(//20X,''STATE VECTORS'',//)')
         CALL MATOUT(CONF,EIG,LAB,LAB,LAB)
      ENDIF
      IF(PRNT)THEN
         WRITE(6,440)
  440    FORMAT(///,' STATE ENERGIES '
     1,' EXPECTATION VALUE OF S**2  S FROM S**2=S(S+1)',//)
      ENDIF
      IROOT=0
      DO 450 I=1,9
  450 CIMAT(I)=0.1D0
      DO 490 I=1,LAB
         X=0.5D0*XX
         II=(I-1)*LAB
         DO 480 J=1,LAB
            JI=J+II
            X=X-CONF(JI)*CONF(JI)*SPIN(J)*0.25D0
            K=ISPQR(J,1)
            IF(K.EQ.1)  GOTO  470
            DO 460 K=2,K
               LI=ISPQR(J,K)+II
  460       X=X+CONF(JI)*CONF(LI)*2.D0
  470       CONTINUE
  480    CONTINUE
         Y=(-1.D0+SQRT(1.D0+4.D0*X))*0.5D0
         IF(ABS(SMULT-X).LT.0.01)THEN
            IROOT=IROOT+1
            IF(IROOT.EQ.LROOT) THEN
               KROOT=I
               MECI=EIG(I)
            ENDIF
         ENDIF
         J=Y*2.D0+1.5D0
         CIMAT(J)=CIMAT(J)+1
  490 IF(PRNT)WRITE(6,510) I,EIG(I),TSPIN(J),X,Y
      IF(KROOT.EQ.0)THEN
         WRITE(6,'(//10X,''THE STATE REQUIRED IS NOT PRESENT IN THE'')')
         WRITE(6,'(10X,  ''    SET OF CONFIGURATIONS AVAILABLE'')')
         WRITE(6,'(/ 4X,''NUMBER OF STATES ACCESSIBLE USING CURRENT KEY-
     1WORDS'',/)')
         DO 500 I=1,7
  500    IF(CIMAT(I).GT.0.5D0)
     1WRITE(6,'((24X,A8,I4))')TSPIN(I),NINT(CIMAT(I))
         CALL WRAPUP()
      ENDIF
  510 FORMAT(I5,F12.6,3X,A8,F15.5,F10.5)
C#      M=0
C#      DO 440 I=1,NMOS
C#         WRITE(6,*)
C#         DO 440 J=1,NMOS
C#            WRITE(6,*)
C#            DO 440 K=1,NMOS
C#  440 WRITE(6,'(4I2,8F12.6)')I,J,K,M,(XY(I,J,K,L),L=1,NMOS)
  520 CONTINUE
      IF(FORCE.OR.LAST1)THEN
C
C   REFORM DENSITY MATRIX
C
         K=(KROOT-1)*LAB
         DO 540 I=1,NMOS
            SUM=0.D0
            DO 530 J=1,LAB
  530       SUM=SUM+(MICROA(I,J)+MICROB(I,J))*CONF(J+K)**2
  540    EIGA(I)=SUM-OCCA(I)*2.D0
         L=0
         DO 560 I=1,NORBS
            DO 560 J=1,I
               SUM=0.D0
               DO 550 K=1,NMOS
  550          SUM=SUM+EIGA(K)*COEFFS(I,K)*COEFFS(J,K)
               L=L+1
  560    P(L)=P(L)+SUM*ONE
      ENDIF
      MAXVEC=0
      IF(LSPIN)MAXVEC=MIN(4,LAB)
      IF(LSPIN.AND.(NE/2)*2.EQ.NE) THEN
         WRITE(6,'(''   ESR SPECIFIED FOR AN EVEN-ELECTRON SYSTEM'')')
      ENDIF
      DO 570 I=1,NMOS
         DO 570 J=1,NORBS
  570 COEFFS(J,I)=COEFFS(J,I)**2
      DO 640 IUJ=1,MAXVEC
         IOFSET=(IUJ-1)*LAB
         WRITE(6,'(//,''      MICROSTATE CONTRIBUTIONS TO '',
     1''STATE EIGENFUNCTION'',I3)')IUJ
         WRITE(6,'(5F13.6)')(CONF(I+IOFSET),I=1,LAB)
         DO 580 I=1,LAB
  580    CONF(I)=CONF(I+IOFSET)**2
C                                             SECOND VECTOR!
         DO 600 I=1,NMOS
            SUM=0.D0
            DO 590 J=1,LAB
  590       SUM=SUM+(MICROA(I,J)-MICROB(I,J))*CONF(J)
  600    EIGA(I)=SUM
         WRITE(6,'(/,''    SPIN DENSITIES FROM EACH M.O., ENERGY:''
     1,F7.3)')EIG(IUJ)
         WRITE(6,'(5F12.6)') (EIGA(I),I=1,NMOS)
         WRITE(6,*)
         WRITE(6,*)'     SPIN DENSITIES FROM EACH ATOMIC ORBITAL'
         WRITE(6,*)'                              S        PX        '//
     1'PY        PZ        TOTAL'
         DO 630 I=1,NATOMS
            IL=NFIRST(I)
            IU=NLAST(I)
            L=0
            SUMM=0.D0
            DO 620 K=IL,IU
               L=L+1
               SUM=0.D0
               DO 610 J=1,NMOS
  610          SUM=SUM+COEFFS(K,J)*EIGA(J)
               SUMM=SUMM+SUM
  620       EIGS(L)=SUM
            IF(L.EQ.4)THEN
               WRITE(6,'(''  ATOM'',I4,''    SPIN DENSITY  '',5F10.7)')
     1I,(EIGS(K),K=1,L),SUMM
            ELSE
               WRITE(6,'(''  ATOM'',I4,''    SPIN DENSITY  '',F10.7,30X,
     1F10.7)')I,EIGS(1),SUMM
            ENDIF
  630    CONTINUE
  640 CONTINUE
      RETURN
      END

      FUNCTION CONCHK(A,X,N)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
      C=0.                                 
      DO 100 I=1,N
         C=MAX(C,DABS(A*X(I)))
 100  CONTINUE
      CONCHK=C
      END

      PROGRAM Y12M
C
C  DOUBLE PRECISION = 64 bit accuracy.
C
C     Last modification by Sami Saarinen, CSC at 26.1.1991
C
C     - packed matrix input (routine READI borrowed from INVPOWER
C       and modified. input file size is now 1.5 times smaller!!
C     - COMMON /BASE1/ and /BASE2/ included (7.2.91 on SUN-4/390S)
C
      PARAMETER (IHA = 5000, NN = 1000000, NN1 = 1000000)
C
      IMPLICIT DOUBLE PRECISION (A-B, G, P, T-V), INTEGER (C, F,
     1 H-N, R-S, Z)
C
      DOUBLE PRECISION A(NN), PIVOT(NN), B(IHA), AFLAG(8)
      INTEGER SNR(NN), RNR(NN1), HA(IHA, 11), IFLAG(10)
      COMMON /BASE1/ A,PIVOT,B,AFLAG
      COMMON /BASE2/ SNR,RNR,HA
C
C  Channel NIN for input.
C  Channel NOUT for output.
C
      DATA NIN /1/, NOUT /6/, NSCR /20/
C
C  Initialization of the parameters.
C
      CALL INITIM(0)
c
      open(NIN,file='y12m.mat',status='old')
C
      CALL INITIM(1)
C
C-old      READ(NIN, *) N, Z
      READ(NIN, *) N
      WRITE(NOUT,*) '*** MATRIX ORDER N =',N
      if (N.GT.IHA) STOP 'N > IHA'
C
C  Initialize the non-zero elements of matrix A in
C  arbitrary order.
C
C-old       READ(NIN, FMT='((3(2I4,F14.0)))') (RNR(K),SNR(K),A(K),K=1,Z)
      CALL READI(NIN,A,B,RNR,SNR,N,Z)

      open(NSCR,file='restart.dat',
     +     status='unknown',form='unformatted')
      write(NSCR) NN
      write(NSCR) N,Z
      write(NSCR) SNR,RNR
      write(NSCR) PIVOT
      write(NSCR) (A(K),K=1,Z)
      write(NSCR) (B(K),K=1,N)

      WRITE(NOUT,*) '*** NUMBER OF NON-ZEROS Z =',Z
      IF (Z.GT.NN/5 .OR. Z.GT.NN1/5) STOP 'Z > NN/5'
C
C  Initialize the components of the right-hand side vector B.
C
C-old      READ(NIN, *) (B(K), K = 1, N)

C
      CALL SHOTIM(1)
C
      CALL INITIM(2)
C
C  Call the subroutine Y12MAF.
C
      CALL Y12MAF(N, Z, A, SNR, NN, RNR, NN1, PIVOT, HA, IHA,
     1 AFLAG, IFLAG, B, IFAIL)
C
      CALL SHOTIM(2)
C
      CALL INITIM(3)
C
C  Print the results.
C
      WRITE(NOUT, 2001) IFAIL
C
      IF (IFAIL .GT. 0) GOTO 5
C
      WRITE(NOUT, 2002)
C
C-old      DO 4 I = 1, N
        WRITE(NOUT, 2003) (I, B(I), I=1,N)
C-old 4    CONTINUE
C
C  Print the auxiliary information about the solution.
C
      WRITE(NOUT, 2004) AFLAG(6)
C
      WRITE(NOUT, 2005) AFLAG(7)
C
      WRITE(NOUT, 2006) AFLAG(8)
C
      WRITE(NOUT, 2007) AFLAG(5)
C
      WRITE(NOUT, 2008) IFLAG(6)
C
      WRITE(NOUT, 2009) IFLAG(7)
C
      WRITE(NOUT, 2010) IFLAG(8)
C
 5    CONTINUE
C
      CALL SHOTIM(3)
C
      CALL SHOTIM(0)
C
      close(NSCR)
      close(NIN)
c
      STOP
C
C  FORMAT-statements.
C
 2001 FORMAT(' The error diagnostic parameter IFAIL is equal to ',
     1 I4)
C
 2002 FORMAT(' The solution vector is given below.')
C
 2003 FORMAT(1P,(4(I5,G15.7)))
C
 2004 FORMAT(/, ' The largest element in the original matrix is ',
     1 1E12.5)
C
 2005 FORMAT(' The largest element found in the elimination ',
     1 1E12.5)
C
 2006 FORMAT(' The minimal (in abs. value) pivotal element ',
     1 1E12.5)
C
 2007 FORMAT(' The growth factor is ', 1PD12.2)
C
 2008 FORMAT(' The number of collections in the row list ', 1I5)
C
 2009 FORMAT(' The number of collections in the column list ', 1I5)
C
 2010 FORMAT(' The largest number of elements found in array A ',
     1 1I9)
C
      END

      SUBROUTINE FRAME(FMAT,NUMAT,MODE,SHIFT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FMAT(*), SHIFT(6)
      INCLUDE 'mopac.inc'
      COMMON /COORD /COORD(3,NUMATM)
      COMMON /ATMASS/ ATMASS(NUMATM)
      DIMENSION VIB(6,MAXPAR), ROT(3,3), COORD1(3,NUMATM)
***********************************************************************
*
*   FRAME APPLIES AN RIGID ORIENTATION TO THE MOLECULE IN A FORCE
*         CALCULATION. THE TRANSLATIONS ARE GIVEN A 'FORCE CONSTANT'
*         OF T(X)=500 MILLIDYNES/ANGSTROM
*            T(Y)=600 MILLIDYNES/ANGSTROM
*            T(Z)=700 MILLIDYNES/ANGSTROM
*         AND THE ROTATIONS ARE GIVEN A 'FORCE CONSTANT' OF
*            R(X)=800 MILLIDYNES/ANGSTROM
*            R(Y)=900 MILLIDYNES/ANGSTROM
*            R(Z)=1000 MILLIDYNES/ANGSTROM,
*    THE ROTATIONS ARE MADE ABOUT AXES DETERMINED BY THE MOMENTS
*    OF INERTIA, WHICH IN TURN DEPEND ON THE ISOTOPIC MASSES. FOR
*    THE NORMAL FREQUENCY CALCULATION THESE ARE THE REAL MASSES,
*    FOR THE FORCE CALCULATION THEY ARE ALL UNITY.
***********************************************************************
      COMMON /EULER / TVEC(3,3), ID
      CALL AXIS(COORD,NUMAT,A,B,C,SUMW, MODE,ROT )
      DO 20 I=1,NUMAT
         DO 20 J=1,3
            SUM=0.D0
            DO 10 K=1,3
   10       SUM=SUM+COORD(K,I)*ROT(K,J)
   20 COORD1(J,I)=SUM
      N3=NUMAT*3
      J=0
      WTMASS=1.D0
      DO 30 I=1,NUMAT
         IF(MODE.EQ.1)  WTMASS=SQRT(ATMASS(I))
         J=J+1
         VIB(1,J)=WTMASS
         VIB(2,J)=0.D0
         VIB(3,J)=0.D0
         VIB(4,J)=0.D0
         VIB(5,J)=COORD1(3,I)*WTMASS
         VIB(6,J)=COORD1(2,I)*WTMASS
         J=J+1
         VIB(1,J)=0.D0
         VIB(2,J)=WTMASS
         VIB(3,J)=0.D0
         VIB(4,J)=COORD1(3,I)*WTMASS
         VIB(5,J)=0.D0
         VIB(6,J)=-COORD1(1,I)*WTMASS
         J=J+1
         VIB(1,J)=0.D0
         VIB(2,J)=0.D0
         VIB(3,J)=WTMASS
         VIB(4,J)=-COORD1(2,I)*WTMASS
         VIB(5,J)=-COORD1(1,I)*WTMASS
         VIB(6,J)=0.D0
   30 CONTINUE
      J=1
      DO 50 I=1,NUMAT
         DO 40 K=4,6
            X=VIB(K,J)
            Y=VIB(K,J+1)
            Z=VIB(K,J+2)
            VIB(K,J  )=X*ROT(1,1)+Y*ROT(1,2)+Z*ROT(1,3)
            VIB(K,J+1)=X*ROT(2,1)+Y*ROT(2,2)+Z*ROT(2,3)
            VIB(K,J+2)=X*ROT(3,1)+Y*ROT(3,2)+Z*ROT(3,3)
   40    CONTINUE
         J=J+3
   50 CONTINUE
      SUM1=0.D0
      SUM2=0.D0
      SUM3=0.D0
      SUM4=0.D0
      SUM5=0.D0
      SUM6=0.D0
      DO 60 I=1,N3
         SUM1=SUM1+VIB(1,I)**2
         SUM2=SUM2+VIB(2,I)**2
         SUM3=SUM3+VIB(3,I)**2
         SUM4=SUM4+VIB(4,I)**2
         SUM5=SUM5+VIB(5,I)**2
   60 SUM6=SUM6+VIB(6,I)**2
      IF(SUM1.GT.1.D-5)SUM1=SQRT(1.D0/SUM1)
      IF(SUM2.GT.1.D-5)SUM2=SQRT(1.D0/SUM2)
      IF(SUM3.GT.1.D-5)SUM3=SQRT(1.D0/SUM3)
      IF(SUM4.GT.1.D-5)SUM4=SQRT(1.D0/SUM4)
      IF(SUM5.GT.1.D-5)SUM5=SQRT(1.D0/SUM5)
      IF(SUM6.GT.1.D-5)SUM6=SQRT(1.D0/SUM6)
      IF(ID.NE.0)THEN
         SUM4=0.D0
         SUM5=0.D0
         SUM6=0.D0
      ENDIF
      DO 70 I=1,N3
         VIB(1,I)=VIB(1,I)*SUM1
         VIB(2,I)=VIB(2,I)*SUM2
         VIB(3,I)=VIB(3,I)*SUM3
         VIB(4,I)=VIB(4,I)*SUM4
         VIB(5,I)=VIB(5,I)*SUM5
   70 VIB(6,I)=VIB(6,I)*SUM6
      DO 80 I=1,6
   80 SHIFT(I)=400.D0+I*100.D0
      L=0
      DO 100 I=1,N3
         DO 100 J=1,I
            L=L+1
            SUM1=0.D0
            DO 90 K=1,6
   90       SUM1=SUM1+VIB(K,I)*SHIFT(K)*VIB(K,J)
  100 FMAT(L)=FMAT(L)+SUM1
      END

C***********************************************************************
C file: FVPTR.FOR
C
C history: 15/2/90: COPIED FROM FVPGB.FOR, NEW SUBROUTINE-NAME
C          15/2/90: unused parameters removed by BH
C          15/2/90: wrong comments removed by BH
C          22/2/90: TRICLINIC GEOMETRY
C
C          18/7/90: ICHARG (valence charge) added
C                   DACOUL replaced ENCOUL
C          18/7/90: ARGSC=NPSPTS/PSGMAX is changed into 
C                   ARGSC=(NPSPTS-1)/PSGMAX, to be constant with the 
C                   grid of pseudopotential
C***********************************************************************
      SUBROUTINE FVPTR(NGX,NGY,NGZ,NPSPTS,RECC,VOLC,PSP,PSGMAX,VPS,
     &                 DVPS,LPCTX,LPCTY,LPCTZ,ICHARG,IVPTYP)
C=======================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FVPTR "}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE PSEUDOPOTENTIAL ON THE GRID OF
C RECIPROCAL LATTICE VECTORS.
C THIS SUBROUTINE MUST BE CALLED WHENEVER RECC(i,j) HAS CHANGED
C
C=======================================================================
      IMPLICIT COMPLEX (C)
      DIMENSION RECC(3,*)
      DIMENSION PSP(*)
      DIMENSION VPS(*)
      DIMENSION DVPS(*)
      DIMENSION LPCTX(*),LPCTY(*),LPCTZ(*)
C=======================================================================
      DATA TPI,HALF,SIXTH / 6.2831853072,0.5,0.166666666667 /
      DATA DACOUL /180.95283/
C      COMMON /PCONST/PI,EV,EPSLON0
C
C     DACOUL=EV/EPSLON0 = 180.95270
C           
C     1EV=1.6021892E-12 erg 
C     EPSLON0(PERMITTIVITY OF VACUUM) = 8.85418782E-12 F m-1  
C                                     = 8.85418782E-2  F (Angstrom)-1  
C
C     DATA ENCOUL /324299.886/
C=======================================================================
      VOLINV=1.0/VOLC
      ZEFFG2=PSP(NPSPTS)*PSGMAX**2
C=======================================================================
C CALCULATE THE SCALING FACTOR ARGSC THAT CONVERTS THE MAGNITUDE OF A
C RECIPROCAL LATTICE VECTOR TO THE CORREPONDING POSITION IN THE
C PSEUDOPOTENTIAL ARRAYS
C=======================================================================
      IF (IVPTYP.EQ.0) THEN
        ARGSC=NPSPTS/PSGMAX
      ELSE
        ARGSC=(NPSPTS-1)/PSGMAX
      END IF
C
C      ENCOUL=ICHARG*DACOUL/(ARGSC**2)
C
      ENCOUL=ICHARG*DACOUL*(ARGSC**2)
      NPSPT2=NPSPTS-2
      NI=1
      DO 9100 N=1,NGZ
      GZX=RECC(3,1)*LPCTZ(N)
      GZY=RECC(3,2)*LPCTZ(N)
      GZZ=RECC(3,3)*LPCTZ(N)
      DO 9101 NN=1,NGY
      GYX=RECC(2,1)*LPCTY(NN)
      GYY=RECC(2,2)*LPCTY(NN)
      GYZ=RECC(2,3)*LPCTY(NN)
      DO 9102 NNN=1,NGX
      GXSQ=(RECC(1,1)*LPCTX(NNN)+GYX+GZX)**2
      GYSQ=(RECC(1,2)*LPCTX(NNN)+GYY+GZY)**2
      GZSQ=(RECC(1,3)*LPCTX(NNN)+GYZ+GZZ)**2
C=======================================================================
C CALCULATE THE MAGNITUDE OF THE RECIPROCAL LATTICE VECTOR (SINCE WE ARE
C USING A LOCAL PSEUDOPOTENTIAL THE VALUE OF THE POTENTIAL DEPENDS ONLY
C ON THE MAGNITUDE OF G)
C=======================================================================
      G=SQRT(GXSQ+GYSQ+GZSQ)
      IF(G.GT.GMAX) GMAX=G
C=======================================================================
C CONVERT THE MAGNITUDE OF THE RECIPROCAL LATTTICE VECTOR TO A POSITION
C IN THE PSEUDOPOTENTIAL ARRAYS AND INTERPOLATE THE PSEUDOPOTENTIAL AND
C ITS DERIVATIVE
C=======================================================================
      ARG=(G*ARGSC)+1.0
      NADDR=INT(ARG)
      REM=ARG-NADDR
C
      IF(NADDR.LT.3) THEN
      VPS(NI) = 0.0
      DVPS(NI)= 0.0
      GO TO 9103
      END IF
C
C     Vps = Zeff/G**2,  dVps/dG = -2 Zeff/G**3 = -2*Vps/G
C
      IF(NADDR.GE.NPSPT2) THEN
      VPS(NI)=  ZEFFG2/G**2
      DVPS(NI)=-2.0*VPS(NI)/G
      GO TO 9103
      END IF
C
      V1=PSP(NADDR-1)+(ENCOUL/((NADDR-2)**2))
      V2=PSP(NADDR)+(ENCOUL/((NADDR-1)**2))
      V3=PSP(NADDR+1)+(ENCOUL/((NADDR)**2))
      V4=PSP(NADDR+2)+(ENCOUL/((NADDR+1)**2))
      T0=V2
      T1=((6.0*V3)-(2.0*V1)-(3.0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.0*V2))*HALF
      T3=(V4-V1+(3.0*(V2-V3)))*SIXTH
      VPS(NI)=((-ENCOUL/((ARG-1.0)**2))+T0+
     &         REM*(T1+REM*(T2+REM*T3)))*VOLINV
      DVPS(NI)=((2.0*ENCOUL/(((ARG-1.0)**2)*G))+
     &         (ARGSC*(T1+REM*((2.0*T2)+(3.0*REM*T3)))))*VOLINV
      IF(VPS(NI).GT.10.0) WRITE(*,*) VPS(NI),NI,NADDR
 9103 CONTINUE
      NI=NI+1
 9102 CONTINUE
 9101 CONTINUE
 9100 CONTINUE
      IF(GMAX.GT.PSGMAX) WRITE(*,9999) GMAX,PSGMAX
 9999 FORMAT(/,' WARNING IN FVP_TR:',
     &/,' THE LARGEST G VALUE OF THE FFT GRID (GMAX)=',F12.4,
     &/,' EXCEEDS THE UPLIMIT OF THE POTENTIAL DATASET (PSGMAX)=',F12.4,
     &/,' WE USE EXTRAPOLATION ASSUMING COULOMBLISH BEHAVIOR (Z/G**2):',
     &/,'   V(G)    =  V(PSGMAX)*(PSGMAX**2/G**2)   FOR  G > PSGMAX',
     &/,'  dV(G)/dG = -2 V(G)/G',/)
      RETURN
      END

C----------------------------------------------------------------------
C
C  A S 7
C
C  INTEGRATE EQUATIONS OF MOTIONS WITH THE SEVENTH ORDER
C  ADAMS-STOERMER DIFFERENCE METHOD
C  D1 AND D2 ARE THE DAY NUMBERS OF THE FIRST AND LAST DAY TO BE WRITTEN
C  H IS THE INTEGRATION STEP IN DAYS AND OUTP IS THE INTERVAL BETWEEN
C  SUCCESSIVE OUTPUTS
C
C----------------------------------------------------------------------
      SUBROUTINE AS7 (D1, H, D2, OUTP)
      INTEGER
     .    D1,        
     .    D2         
      REAL
     .    H,         
     .    OUTP       
C
      INTEGER
     .    ITERS,
     .    INTEGS
C
      CALL INTINI
      CALL START(H, 1.0D-25, ITERS)
      CALL INTEG(D1,H,D2, OUTP, INTEGS)
      WRITE (*,'(/'' PLANETARY EPHEMERIS COMPUTED''/
     .            '' NUMBER OF INITIAL ITERATIONS '',I2/
     .            '' NUMBER OF INTEGRATION STEPS '',I5/
     .            '' TIME INTERVAL DN = '',I5,'' .. '',I5/)')
     .       ITERS, INTEGS, D1, D2
      RETURN
      END

      SUBROUTINE DERIV(GEO,GRAD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION GRAD(*), GEO(3,*)
      COMMON / EULER/ TVEC(3,3), ID
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, DUMMY(MAXPAR)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GRAVEC/ COSINE
      COMMON /GEOSYM/ NDEP, IDUMYS(MAXPAR,3)
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /UCELL / L1L,L2L,L3L,L1U,L2U,L3U
      COMMON /XYZGRA/ DXYZ(3,NUMATM*27)
      COMMON /ENUCLR/ ENUCLR
      COMMON /NUMCAL/ NUMCAL
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /WMATRX/ WJ(N2ELEC), WK(N2ELEC)
      COMMON /HMATRX/ H(MPACK)
      COMMON /ATHEAT/ ATHEAT
C***********************************************************************
C
C    DERIV CALCULATES THE DERIVATIVES OF THE ENERGY WITH RESPECT TO THE
C          INTERNAL COORDINATES. THIS IS DONE BY FINITE DIFFERENCES.
C
C    THE MAIN ARRAYS IN DERIV ARE:
C        LOC    INTEGER ARRAY, LOC(1,I) CONTAINS THE ADDRESS OF THE ATOM
C               INTERNAL COORDINATE LOC(2,I) IS TO BE USED IN THE
C               DERIVATIVE CALCULATION.
C        GEO    ARRAY \GEO\ HOLDS THE INTERNAL COORDINATES.
C        GRAD   ON EXIT, CONTAINS THE DERIVATIVES
C
C***********************************************************************
      COMMON /KEYWRD / KEYWRD
      COMMON /ERRFN  / ERRFN(MAXPAR)
      CHARACTER*80 KEYWRD
      DIMENSION CHANGE(3), COORD(3,NUMATM), COLD(3,NUMATM*27)
     1,         XDERIV(3), XPARAM(MAXPAR), XJUC(3), W(N2ELEC)
      REAL WJ, WK
      LOGICAL DEBUG, TIMES, HALFE, FAST, SCF1, CI, PRECIS
      EQUIVALENCE (W,WJ)
      DATA ICALCN /0/
      IF(ICALCN.NE.NUMCAL) THEN
         I = INDEX(KEYWRD,'PRESS')
         PRESS=0.D0
         IF(I.NE.0) PRESS=READA(KEYWRD,I)*1476.8992D0
         IDLO=NATOMS+1
         IF(LABELS(NATOMS) .EQ. 107) THEN
            IDLO=NATOMS
            IF(LABELS(NATOMS-1) .EQ. 107)THEN
               IDLO=NATOMS-1
               IF(LABELS(NATOMS-2) .EQ. 107)THEN
                  IDLO=NATOMS-2
               ENDIF
            ENDIF
         ENDIF
         GRLIM=0.01D0
         DEBUG = (INDEX(KEYWRD,'DERIV') .NE. 0)
         PRECIS= (INDEX(KEYWRD,'PRECIS') .NE. 0)
         TIMES = (INDEX(KEYWRD,'TIME') .NE. 0)
         CI    = (INDEX(KEYWRD,'C.I.') .NE. 0)
         SCF1  = (INDEX(KEYWRD,'1SCF') .NE. 0)
         ICALCN=NUMCAL
         IF(INDEX(KEYWRD,'RESTART') .EQ. 0) THEN
            DO 10 I=1,NVAR
   10       ERRFN(I)=0.D0
         ENDIF
         GRLIM=0.01D0
         IF(PRECIS)GRLIM=0.0001D0
         IF(INDEX(KEYWRD,'FULSCF') .GT.0) GRLIM=1.D9
         HALFE = (NOPEN.GT.NCLOSE .OR. CI)
         IDELTA=-7
*
*   IDELTA IS A MACHINE-PRECISION DEPENDANT INTEGER
*
         IF(HALFE.AND.PRECIS) IDELTA=-3
         IF(HALFE.AND..NOT.PRECIS) IDELTA=-3
         FAST=.TRUE.
         CHANGE(1)= 10.D0**IDELTA
         CHANGE(2)= 10.D0**IDELTA
         CHANGE(3)= 10.D0**IDELTA
C
C    CHANGE(I) IS THE STEP SIZE USED IN CALCULATING THE DERIVATIVES.
C    FOR "CARTESIAN" DERIVATIVES, CALCULATED USING DCART,AN
C    INFINITESIMAL STEP, HERE 0.000001, IS ACCEPTABLE. IN THE
C    HALF-ELECTRON METHOD A QUITE LARGE STEP IS NEEDED AS FULL SCF
C    CALCULATIONS ARE NEEDED, AND THE DIFFERENCE BETWEEN THE TOTAL
C    ENERGIES IS USED. THE STEP CANNOT BE VERY LARGE, AS THE SECOND
C    DERIVITIVE IN FLEPO IS CALCULATED FROM THE DIFFERENCES OF TWO
C    FIRST DERIVATIVES. CHANGE(1) IS FOR CHANGE IN BOND LENGTH,
C    (2) FOR ANGLE, AND (3) FOR DIHEDRAL.
C
         XDERIV(1)= 0.5D0/CHANGE(1)
         XDERIV(2)= 0.5D0/CHANGE(2)
         XDERIV(3)= 0.5D0/CHANGE(3)
      ENDIF
      GNORM=0.D0
      IF(NVAR.EQ.0) RETURN
      IF(DEBUG)THEN
         WRITE(6,'('' GEO AT START OF DERIV'')')
         WRITE(6,'(F19.5,2F12.5)')((GEO(J,I),J=1,3),I=1,NATOMS)
      ENDIF
      DO 20 I=1,NVAR
         XPARAM(I)=GEO(LOC(2,I),LOC(1,I))
   20 GNORM=GNORM+GRAD(I)**2
      GNORM=SQRT(GNORM)
      FAST=(GNORM .GT. GRLIM .AND. .NOT. SCF1 .OR. .NOT. HALFE)
      TIME1=ZECOND()
      IF(NDEP.NE.0) CALL SYMTRY
      CALL GMETRY(GEO,COORD)
      IF( .NOT. FAST ) THEN
         IF(DEBUG)WRITE(6,'('' DOING FULL SCF''''S IN DERIV'')')
         CALL HCORE(COORD,H,W, WJ, WK, ENUCLR)
         IF(NORBS*NELECS.GT.0)THEN
            CALL ITER(H, W, WJ, WK, AA,.TRUE.,.FALSE.)
         ELSE
            AA=0.D0
         ENDIF
         LINEAR=(NORBS*(NORBS+1))/2
         DO 30 I=1,LINEAR
   30    P(I)=PA(I)*2.D0
         AA=(AA+ENUCLR)
      ENDIF
      CALL DCART(COORD,DXYZ)
      IF(NDEP.NE.0) CALL SYMTRY
      CALL GMETRY(GEO,COORD)
      IJ=0
      DO 70 II=1,NUMAT
         DO 60 IL=L1L,L1U
            DO 60 JL=L2L,L2U
               DO 60 KL=L3L,L3U
                  DO 40 LL=1,3
   40             XJUC(LL)=COORD(LL,II)+TVEC(LL,1)*IL+TVEC(LL,2)*JL+TVEC
     1(LL,3)*KL
                  IJ=IJ+1
                  DO 50 KK=1,3
                     COLD(KK,IJ)=XJUC(KK)
   50             CONTINUE
   60    CONTINUE
   70 CONTINUE
      SUM11=1.D-9
      SUM22=1.D-9
      SUM12=1.D-9
      DO 150 I=1,NVAR
         K=LOC(1,I)
         L=LOC(2,I)
         XSTORE=XPARAM(I)
         DO 80 J=1,NVAR
   80    GEO(LOC(2,J),LOC(1,J))=XPARAM(J)
         GEO(L,K)=XSTORE-CHANGE(L)
         IF(NDEP.NE.0) CALL SYMTRY
         CALL GMETRY(GEO,COORD)
C#         CALL GEOUT
C
C    USE LOOKUP TABLE OF CARTESIAN DERIVATIVES TO WORK OUT INTERNAL
C    COORDINATE DERIVATIVE.
C
         TOTL=0.D0
         IJ=0
         DO 130 II=1,NUMAT
            IF(ID.EQ.0) THEN
               DO 90 LL=1,3
   90          TOTL=TOTL+DXYZ(LL,II)*(COORD(LL,II)-COLD(LL,II))
            ELSE
               DO 120 IL=L1L,L1U
                  DO 120 JL=L2L,L2U
                     DO 120 KL=L3L,L3U
                        DO 100 LL=1,3
  100                   XJUC(LL)=COORD(LL,II)+TVEC(LL,1)*IL+TVEC(LL,2)*J
     1L+TVEC(LL,3)*KL
                        IJ=IJ+1
                        DO 110 KK=1,3
                           TOTL=TOTL+DXYZ(KK,IJ)*(XJUC(KK)-COLD(KK,IJ))
  110                   CONTINUE
  120          CONTINUE
            ENDIF
  130    CONTINUE
         TOTL=TOTL*XDERIV(L)
C
C   IF NEEDED, CALCULATE "EXACT" DERIVITIVES.
C
         IF( .NOT. FAST ) THEN
            CALL HCORE(COORD,H,W, WJ, WK,ENUCLR)
            IF(NORBS*NELECS.GT.0)THEN
               CALL ITER(H,W, WJ, WK,EE,.TRUE.,.FALSE.)
            ELSE
               EE=0.D0
            ENDIF
            DO 140 II=1,LINEAR
  140       P(II)=PA(II)*2.D0
            EE=(EE+ENUCLR)
            TOTL1=(AA-EE)*23.061D0*XDERIV(L)*2.D0
C#            WRITE(6,*)AA-EE
            ERRFN(I)=TOTL1-TOTL
         ENDIF
         GEO(L,K)=XSTORE
         SUM11=SUM11+GRAD(I)**2
         SUM22=SUM22+TOTL**2
         SUM12=SUM12+TOTL*GRAD(I)
         GRAD(I)=TOTL+ERRFN(I)
  150 CONTINUE
      IF(DEBUG) THEN
         WRITE(6,'('' GRADIENTS'')')
         WRITE(6,'(10F8.3)')(GRAD(I),I=1,NVAR)
         WRITE(6,'('' ERROR FUNCTION'')')
         WRITE(6,'(10F8.3)')(ERRFN(I),I=1,NVAR)
      ENDIF
      COSINE=SUM12/SQRT(SUM11*SUM22)
      IF(DEBUG)
     1WRITE(6,'('' COSINE OF SEARCH DIRECTION ='',F30.6)')COSINE
      IF( .NOT. FAST ) COSINE=1.D0
      IF(TIMES)
     1WRITE(6,'('' TIME FOR DERIVATIVES'',F12.6)')ZECOND()-TIME1
      RETURN
      END

      SUBROUTINE TQLRAT(N,D,E2,IERR,EPS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION D(N), E2(N)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TQLRAT,
C     ALGORITHM 464, COMM. ACM 16, 689(1973) BY REINSCH.
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES OF A SYMMETRIC
C     TRIDIAGONAL MATRIX BY THE RATIONAL QL METHOD.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E2 CONTAINS THE SQUARES OF THE SUBDIAGONAL ELEMENTS OF THE
C          INPUT MATRIX IN ITS LAST N-1 POSITIONS.  E2(1) IS ARBITRARY.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT AND
C          ORDERED FOR INDICES 1,2,...IERR-1, BUT MAY NOT BE
C          THE SMALLEST EIGENVALUES,
C
C        E2 HAS BEEN DESTROYED,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C
      IERR = 0
      IF (N .EQ. 1) GO TO 140
C
      DO 10   I = 2, N
   10 E2(I-1) = E2(I)
C
      F=0.0D0
      B=0.0D0
      E2(N)=0.0D0
C
      DO 120   L = 1, N
         J = 0
         H=EPS*(ABS (D(L))+SQRT (E2(L)))
         IF (B .GT. H) GO TO 20
         B = H
         C = B * B
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
   20    DO 30   M = L, N
            IF (E2(M) .LE. C) GO TO 40
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
   30    CONTINUE
C
   40    IF (M .EQ. L) GO TO 80
   50    IF (J .EQ. 30) GO TO 130
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         S=SQRT (E2(L))
         G = D(L)
         P=(D(L1)-G)/(2.0D0*S)
         R=SQRT (P*P+1.0D0)
         D(L)=S/(P+SIGN (R,P))
         H = G - D(L)
C
         DO 60   I = L1, N
   60    D(I) = D(I) - H
C
         F = F + H
C     ********** RATIONAL QL TRANSFORMATION **********
         G = D(M)
         IF (G.EQ.0.0D0) G=B
         H = G
         S=0.0D0
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 70   II = 1, MML
            I = M - II
            P = G * H
            R = P + E2(I)
            E2(I+1) = S * R
            S = E2(I) / R
            D(I+1) = H + S * (H + D(I))
            G = D(I) - E2(I) / G
            IF (G.EQ.0.0D0) G=B
            H = G * P / R
   70    CONTINUE
C
         E2(L) = S * G
         D(L) = H
C     ********** GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST **********
         IF (H.EQ.0.0D0)  GO TO 80
         IF (ABS (E2(L)).LE.ABS (C/H))  GO TO 80
         E2(L) = H * E2(L)
         IF (E2(L).NE.0.0D0)  GO TO 50
   80    P = D(L) + F
C     ********** ORDER EIGENVALUES **********
         IF (L .EQ. 1) GO TO 100
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
         DO 90   II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 110
            D(I) = D(I-1)
   90    CONTINUE
C
  100    I = 1
  110    D(I) = P
  120 CONTINUE
C
      GO TO 140
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
  130 IERR = L
  140 RETURN
C     ********** LAST CARD OF TQLRAT **********
      END

      SUBROUTINE Y12MBF(N, Z, A, SNR, NN, RNR, NN1, HA, IHA, AFLAG,
     1 IFLAG,IFAIL)
C
C
C  THE NON-ZERO ELEMENTS OF A SPARSE MATRIX A ARE PREPARED  IN ORDER TO
C  SOLVE THE SYSTEM AX=B BY USE OF SPARSE MATRIX TECHNIQUE/
C
C
      IMPLICIT DOUBLE PRECISION(A-B,G,P,T-Y),INTEGER(C,F,H-N,R-S,Z)
      DOUBLE PRECISION A(NN), AFLAG(8)
      INTEGER SNR(NN), RNR(NN1), HA(IHA,11), IFLAG(10)
      MODE=IFLAG(4)
      IFAIL=0
      IF(N.LT.2)IFAIL=12
      IF(Z.LE.0)IFAIL=13
      IF(NN.LT.2*Z)IFAIL=5
      IF(NN1.LT.Z)IFAIL=6
      IF(IFAIL.EQ.0.AND.N.GT.Z)IFAIL=14
      IF(IHA.LT.N)IFAIL=15
      IF(MODE.LT.0)IFAIL=16
      IF(MODE.GT.2)IFAIL=16
      IF(IFAIL.NE.0) GO TO 22
      GT1=0.0D0
      DO 10 I=1,N
      HA(I,2)=0
      HA(I,3)=0
   10 HA(I,6)=0
C
C  FIND THE NUMBER OF THE NON-ZERO ELEMENTS IN EACH ROW AND COLUMN;MOVE
C  THE NON-ZERO ELEMENTS IN THE END OF THE ARRAYS A AND SNR;FIND THE
C  LARGEST NON-ZERO ELEMENT IN A(IN ABSOLUTE VALUE).
C
      DO 20 I=1,Z
      T=DABS(A(I))
      L3=RNR(I)
      L4=SNR(I)
      IF(L4.GT.N.OR.L4.LT.1)IFAIL=24
      IF(L3.GT.N.OR.L3.LT.1)IFAIL=25
      HA(L3,3)=HA(L3,3)+1
      HA(L4,6)=HA(L4,6)+1
      IF(T.GT.GT1)GT1=T
      A(Z+I)=A(I)
   20 SNR(Z+I)=SNR(I)
      IF(IFAIL.GT.0)GO TO 22
C
C  STORE THE INFORMATION OF THE ROW STARTS(IN HA(I,1))AND OF THE COLUMN
C  STARTS(IN HA(I,4)).
C
      L1=1
      L2=1
      DO 40 I=1,N
      L3=HA(I,3)
      L4=HA(I,6)
      IF(L3.GT.0)GO TO 21
      IFAIL=17
      GO TO 22
   21 IF(L4.GT.0)GO TO 23
      IFAIL=18
      GO TO 22
   23 IF(MODE.EQ.2)GO TO 30
      HA(I,9)=L3
      HA(I,10)=L4
      HA(I,11)=0
      HA(L3,2)=HA(L3,2)+1
      HA(I,5)=L3
   30 HA(I,1)=L1
      HA(I,4)=L2
      L1=L1+L3
      L2=L2+L4
      HA(I,3)=0
   40 HA(I,6)=0
C
C  STORE THE NON-ZERO ELEMENTS OF MATRIX A(ORDERED IN ROWS) IN THE
C  FIRST Z LOCATIONS OF THE ARRAY A.DO THE SAME FOR THEIR COLUMN NUMBERS
C
      DO 50 I=1,Z
      L1=Z+I
      L3=RNR(I)
      L2=HA(L3,1)+HA(L3,3)
      A(L2)=A(L1)
      SNR(L2)=SNR(L1)
   50 HA(L3,3)=HA(L3,3)+1
C
C  STORE THE ROW NUMBERS OF THE NON-ZERO ELEMENTS ORDERED BY COLUMNS IN
C  THE FIRST Z LOCATIONS OF THE ARRAY RNR. STORE INFORMATION ABOUT ROW
C  ENDS(IN HA(I,3)).
C
      L4=1
      DO 70 I=1,N
      IF(MODE.EQ.2)GO TO 60
      IF(HA(I,2).EQ.0)GO TO 60
      HA(I,11)=L4
      L4=L4+HA(I,2)
      HA(I,2)=HA(I,11)
   60 HA(I,3)=HA(I,1)+HA(I,3)-1
      L1=HA(I,1)
      L2=HA(I,3)
      DO 70 J=L1,L2
      L3=SNR(J)
      R=HA(L3,6)
      INDEX=HA(L3,4)+R
      RNR(INDEX)=I
      IF(R.EQ.0)GO TO 70
      IF(J.EQ.L1)GO TO 70
      IF(RNR(INDEX-1).NE.I)GO TO 70
      IFAIL=11
      GO TO 22
   70 HA(L3,6)=R+1
      DO 90 I=1,N
      IF(MODE.EQ.2)GO TO 80
      L3=HA(I,5)
      L5=HA(L3,2)
      HA(L5,8)=I
      HA(I,7)=L5
      HA(L3,2)=HA(L3,2)+1
   80 CONTINUE
   90 HA(I,6)=HA(I,4)+HA(I,6)-1
      AFLAG(6)=GT1
      IFLAG(6)=0
      IFLAG(7)=0
      IFLAG(8)=Z
      IFLAG(1)=-1
22    RETURN
      END

      SUBROUTINE PRTDRC(ESCF,DELTT,XPARAM,REF,EKIN,GTOT,ETOT,VELO0,NVAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XPARAM(*), VELO0(*), REF(*)
*********************************************************************
*
*    PRTDRC PREPARES TO PRINT THE GEOMETRY ETC. FOR POINTS IN A DRC
*    OR IRC
*    CALCULATION.
*    ON INPUT  ESCF   = HEAT OF FORMATION FOR THE CURRENT POINT
*              DELTT  = CHANGE IN TIME, PREVIOUS TO CURRENT POINT
*              XPARAM = CURRENT CARTESIAN GEOMETRY
*              EKIN   = CURRENT KINETIC ENERGY
*              GTOT   = TOTAL GRADIENT NORM IN IRC CALC'N.
*              VELO0  = CURRENT VELOCITY
*              NVAR   = NUMBER OF VARIABLES = 3 * NUMBER OF ATOMS.
*
********************************************************************
      INCLUDE 'mopac.inc'
      COMMON /KEYWRD/ KEYWRD
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,XRACT
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /DRCCOM/  MCOPRT(2,MAXPAR), NCOPRT, PARMAX
      COMMON /CORE  / CORE(107)
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /DENSTY/ P(MPACK),PA(MPACK),PB(MPACK)
      COMMON /FMATRX/ ALLXYZ(3,MAXPAR),ALLVEL(3,MAXPAR),PARREF(MAXPAR),
     1XYZ3(3,MAXPAR),VEL3(3,MAXPAR), ALLGEO(3,MAXPAR), GEO3(3,MAXPAR),
     2 DUMMY(MAXHES-19*MAXPAR)
      DIMENSION ESCF3(3),EKIN3(3), GTOT3(3), CHARGE(NUMATM), XOLD3(3),
     1GEO(3*NUMATM), VREF(MAXPAR), VREF0(MAXPAR), TSTEPS(100), ETOT3(3),
     2XTOT3(3)
      LOGICAL FIRST, FIRST1, TURN, PARMAX, LDRC, GOTURN
      CHARACTER*80 KEYWRD, TEXT1*3, TEXT2*2,  COTYPE(3)*2
      DATA FIRST1,FIRST/2*.TRUE./,REFSCF/0.D0/
      DATA COTYPE/'BL','BA','DI'/
      IF (FIRST) THEN
         SQRT2=SQRT(2.D0)
         DO 10 I=1,NVAR
   10    PARREF(I)=XPARAM(I)
         ETOT=ESCF+EKIN
         TLAST=0.D0
         GOTURN=.FALSE.
         SUM=0.D0
         DO 20 I=1,NVAR
            SUM=SUM+VELO0(I)**2
            VREF0(I)=VELO0(I)
   20    VREF(I)=VELO0(I)
         IONE=1
         LDRC=(SUM.GT.1.D0)
         FIRST=.FALSE.
         ILOOP=1
         OLDT=-100.D0
         TOLD1=0.0D0
C
C       DETERMINE TYPE OF PRINT: TIME, ENERGY OR GEOMETRY PRIORITY
C       OR PRINT ALL POINTS
C
         STEPT=0.D0
         STEPH=0.D0
         STEPX=0.D0
         IF(INDEX(KEYWRD,' T-PRIO').NE.0)THEN
            IF(INDEX(KEYWRD,' T-PRIORITY=').NE.0)THEN
               STEPT=READA(KEYWRD,INDEX(KEYWRD,'T-PRIO')+5)
            ELSE
               STEPT=0.1D0
            ENDIF
            TREF=-1.D-6
            WRITE(6,'(/,'' TIME PRIORITY, INTERVAL ='',F4.1,
     1'' FEMTOSECONDS'',/)')STEPT
         ELSEIF(INDEX(KEYWRD,' H-PRIO').NE.0)THEN
            IF(INDEX(KEYWRD,' H-PRIORITY=').NE.0)THEN
               STEPH=READA(KEYWRD,INDEX(KEYWRD,'H-PRIO')+5)
            ELSE
               STEPH=0.1D0
            ENDIF
            WRITE(6,'(/,'' KINETIC ENERGY PRIORITY, STEP ='',F5.2,
     1'' KCAL/MOLE'',/)')STEPH
         ELSEIF(INDEX(KEYWRD,' X-PRIO').NE.0)THEN
            IF(INDEX(KEYWRD,' X-PRIORITY=').NE.0)THEN
               STEPX=READA(KEYWRD,INDEX(KEYWRD,'X-PRIO')+5)
            ELSE
               STEPX=0.05D0
            ENDIF
            WRITE(6,'(/,'' GEOMETRY PRIORITY, STEP ='',F5.2,
     1'' ANGSTROMS'',/)')STEPX
         ENDIF
         IF(INDEX(KEYWRD,' REST').NE.0.AND.INDEX(KEYWRD,'IRC=').EQ.0) TH
     1EN
            READ(9,*)(PARREF(I),I=1,NVAR)
            READ(9,*)(VREF0(I),I=1,NVAR)
            READ(9,*)(VREF(I),I=1,NVAR)
            READ(9,*)(ALLGEO(3,I),I=1,NVAR)
            READ(9,*)(ALLGEO(2,I),I=1,NVAR)
            READ(9,*)(ALLGEO(1,I),I=1,NVAR)
            READ(9,*)(ALLVEL(3,I),I=1,NVAR)
            READ(9,*)(ALLVEL(2,I),I=1,NVAR)
            READ(9,*)(ALLVEL(1,I),I=1,NVAR)
            READ(9,*)(ALLXYZ(3,I),I=1,NVAR)
            READ(9,*)(ALLXYZ(2,I),I=1,NVAR)
            READ(9,*)(ALLXYZ(1,I),I=1,NVAR)
            READ(9,*)ILOOP,LDRC,IONE,ETOT1,ETOT0,ESCF1,ESCF0,EKIN1,EKIN0
     1,TOLD2,TOLD1,GTOT1,GTOT0,XOLD2,XOLD1,XOLD0,TOTIME,JLOOP,ETOT,REFX
         ENDIF
      ENDIF
      IF(ESCF.LT.-1.D8) THEN
         WRITE(9,*)(PARREF(I),I=1,NVAR)
         WRITE(9,*)(VREF0(I),I=1,NVAR)
         WRITE(9,*)(VREF(I),I=1,NVAR)
         WRITE(9,*)(ALLGEO(3,I),I=1,NVAR)
         WRITE(9,*)(ALLGEO(2,I),I=1,NVAR)
         WRITE(9,*)(ALLGEO(1,I),I=1,NVAR)
         WRITE(9,*)(ALLVEL(3,I),I=1,NVAR)
         WRITE(9,*)(ALLVEL(2,I),I=1,NVAR)
         WRITE(9,*)(ALLVEL(1,I),I=1,NVAR)
         WRITE(9,*)(ALLXYZ(3,I),I=1,NVAR)
         WRITE(9,*)(ALLXYZ(2,I),I=1,NVAR)
         WRITE(9,*)(ALLXYZ(1,I),I=1,NVAR)
         WRITE(9,*)ILOOP,LDRC,IONE,ETOT1,ETOT0,ESCF1,ESCF0,EKIN1,EKIN0,
     1TOLD2,TOLD1,GTOT1,GTOT0,XOLD2,XOLD1,XOLD0,TOTIME,JLOOP,ETOT,REFX
         RETURN
      ENDIF
      CALL CHRGE(P,CHARGE)
      DO 30 I=1,NUMAT
         L=NAT(I)
   30 CHARGE(I)=CORE(L) - CHARGE(I)
      DELTAT=DELTT*1.D15
      NA(2)=-1
      CALL XYZINT(XPARAM,NUMAT,NA,NB,NC,57.29577951D0,GEO)
      NA(1)=99
      IF(ILOOP.EQ.1)THEN
         ETOT1=ETOT0
         ETOT0=ETOT
         ESCF1=ESCF
         ESCF0=ESCF
         EKIN1=EKIN
         EKIN0=EKIN
         DO 40 J=1,3
            DO 40 I=1,NVAR
               ALLGEO(J,I)=GEO(I)
               ALLXYZ(J,I)=XPARAM(I)
   40    ALLVEL(J,I)=VELO0(I)
      ELSE
         DO 50 I=1,NVAR
            ALLGEO(3,I)=ALLGEO(2,I)
            ALLGEO(2,I)=ALLGEO(1,I)
            ALLGEO(1,I)=GEO(I)
            ALLXYZ(3,I)=ALLXYZ(2,I)
            ALLXYZ(2,I)=ALLXYZ(1,I)
            ALLXYZ(1,I)=XPARAM(I)
            ALLVEL(3,I)=ALLVEL(2,I)
            ALLVEL(2,I)=ALLVEL(1,I)
   50    ALLVEL(1,I)=VELO0(I)
      ENDIF
C
C  FORM QUADRATIC EXPRESSION FOR POSITION AND VELOCITY W.R.T. TIME.
C
      T1=MAX(TOLD2,0.02D0)
      T2=MAX(TOLD1,0.02D0)+T1
      DO 60 I=1,NVAR
         CALL QUADR(ALLGEO(3,I),ALLGEO(2,I),ALLGEO(1,I),T1,T2,
     1GEO3(1,I),GEO3(2,I),GEO3(3,I))
C
****************************************************
*                                                  *
*    QUADR CALCULATES THE A, B AND C IN THE EQUNS. *
*                                                  *
*     A                   =   F0                   *
*     A + B.X0 + C.X0**2  =   F1                   *
*     A + B.X2 + C.X2**2  =   F2                   *
* GIVEN THE ARGUMENT LIST (F0,F1,F2, X1,X2, A,B,C) *
*                                                  *
****************************************************
         CALL QUADR(ALLXYZ(3,I),ALLXYZ(2,I),ALLXYZ(1,I),T1,T2,
     1XYZ3(1,I),XYZ3(2,I),XYZ3(3,I))
         CALL QUADR(ALLVEL(3,I),ALLVEL(2,I),ALLVEL(1,I),T1,T2,
     1VEL3(1,I),VEL3(2,I),VEL3(3,I))
   60 CONTINUE
      ETOT2=ETOT1
      ETOT1=ETOT0
      ETOT0=ETOT
      CALL QUADR(ETOT2,ETOT1,ETOT0,T1,T2,ETOT3(1),ETOT3(2),
     1ETOT3(3))
      EKIN2=EKIN1
      EKIN1=EKIN0
      EKIN0=EKIN
      CALL QUADR(EKIN2,EKIN1,EKIN0,T1,T2,EKIN3(1),EKIN3(2),
     1EKIN3(3))
      ESCF2=ESCF1
      ESCF1=ESCF0
      ESCF0=ESCF
      CALL QUADR(ESCF2,ESCF1,ESCF0,T1,T2,ESCF3(1),ESCF3(2),
     1ESCF3(3))
      GTOT2=GTOT1
      GTOT1=GTOT0
      GTOT0=GTOT
      CALL QUADR(GTOT2,GTOT1,GTOT0,T1,T2,GTOT3(1),GTOT3(2),
     1GTOT3(3))
      XTOT2=XTOT1
      XTOT1=XTOT0
      XOLD2=XOLD2+XOLD1
      XOLD1=XOLD0
C
C   CALCULATE CHANGE IN GEOMETRY
C
      XOLD0=0.D0
      L=0
      XTOT0=0.D0
      SUM1=0.D0
      DO 80 I=1,NUMAT
         SUM=0.D0
         DO 70 J=1,3
            L=L+1
            SUM1=SUM1+(ALLXYZ(1,L)-REF(L))**2*ATMASS(I)
   70    SUM=SUM+(ALLXYZ(2,L)-ALLXYZ(1,L))**2
   80 XOLD0=XOLD0+SQRT(SUM)
      XTOT0=XTOT0+SQRT(SUM1)/SQRT2
      CALL QUADR(XTOT2,XTOT1,XTOT0,T1,T2,
     1XTOT3(1),XTOT3(2),XTOT3(3))
      CALL QUADR(XOLD2,XOLD2+XOLD1,XOLD2+XOLD1+XOLD0,T1,T2,
     1XOLD3(1),XOLD3(2),XOLD3(3))
***********************************************************************
*   GO THROUGH THE CRITERIA FOR DECIDING WHETHER OR NOT TO PRINT THIS *
*   POINT.  IF YES, THEN ALSO CALCULATE THE EXACT POINT AS A FRACTION *
*   BETWEEN THE LAST POINT AND THE CURRENT POINT                      *
***********************************************************************
C   NFRACT IS THE NUMBER OF POINTS TO BE PRINTED IN THE CURRENT DOMAIN
***********************************************************************
      IF(ILOOP.LT.3) GOTO 170
      FRACT=-10
      NFRACT=1
      IF(STEPH.NE.0) THEN
C
C   CRITERION FOR PRINTING RESULTS  IS A CHANGE IN HEAT OF FORMATION =
C   -CHANGE IN KINETIC ENERGY
C
         IF(REFSCF.EQ.0.D0) THEN
            I=ESCF2/STEPH
            REFSCF=I*STEPH
         ENDIF
         DH=ABS(ESCF1-REFSCF)
         IF(DH.GT.STEPH)THEN
            STEPH=SIGN(STEPH,ESCF1-REFSCF)
            NFRACT=ABS(DH/STEPH)
            CC=ESCF3(1)
            BB=ESCF3(2)
            AA=ESCF3(3)
************************************************
* PROGRAMMERS! - BE VERY CAREFUL IF YOU CHANGE *
* THIS FOLLOWING SECTION.  THERE IS NUMERICAL  *
* INSTABILITY IF ABS(BB/AA) IS VERY LARGE. NEAR*
* INFLECTION POINTS AA CHANGES SIGN.       JJPS*
************************************************
            IF(ABS(BB/AA).GT.30)THEN
C
C   USE LINEAR INTERPOLATION
C
               DO 90 I=1,NFRACT
   90          TSTEPS(I)=-(CC-(REFSCF+I*STEPH))/BB
            ELSE
C
C  USE QUADRATIC INTERPOLATION
C
               DO 100 I=1,NFRACT
                  C1=CC-(REFSCF+I*STEPH)
  100          TSTEPS(I)=(-BB+SIGN(SQRT(BB*BB-4.D0*(AA*C1)),BB))/(2.D0*A
     1A)
            ENDIF
            FRACT=-.1
            REFSCF=REFSCF+NFRACT*STEPH
         ENDIF
      ELSEIF(STEPT.NE.0.D0) THEN
C
C   CRITERION FOR PRINTING RESULTS IS A CHANGE IN TIME.
C
         IF(ABS(TOTIME+TOLD2-TREF).GT.STEPT)THEN
            FINCR=STEPT
            I=TOTIME/STEPT
            FRACT=I*STEPT-TOTIME
            I=(TOLD2+TOTIME)/STEPT
            J=TOTIME/STEPT
            NFRACT=I-J+ IONE
            IONE=0
            DO 110 I=1,NFRACT
  110       TSTEPS(I)=FRACT+I*STEPT
            TREF=TREF+NFRACT*STEPT
         ENDIF
      ELSEIF(STEPX.NE.0.D0) THEN
C
C   CRITERION FOR PRINTING RESULTS IS A CHANGE IN GEOMETRY.
C
         IF(XOLD2+XOLD1-REFX.GT.STEPX)THEN
            NFRACT=(XOLD2+XOLD1-REFX)/STEPX
            CC=XOLD3(1)
            BB=XOLD3(2)
            AA=XOLD3(3)
            IF(ABS(BB/AA).GT.30)THEN
C
C   USE LINEAR INTERPOLATION
C
               DO 120 I=1,NFRACT
  120          TSTEPS(I)=-(CC-(REFX+I*STEPX))/BB
            ELSE
C
C  USE QUADRATIC INTERPOLATION
C
               DO 130 I=1,NFRACT
                  C1=CC-(REFX+I*STEPX)
  130          TSTEPS(I)=(-BB+SIGN(SQRT(BB*BB-4.D0*(AA*C1)),BB))/(2.D0*A
     1A)
            ENDIF
            REFX=REFX+NFRACT*STEPX
            FRACT=-.1
         ENDIF
      ELSE
C
C   PRINT EVERY POINT.
C
         FRACT=0.0
      ENDIF
      IF(FRACT.LT.-9.D0)GOTO 170
      TURN=(TURN.OR.ABS(FRACT-1.D0).GT.1.D-6)
C
C  LOOP OVER ALL POINTS IN CURRENT DOMAIN
C
      IF(FRACT.EQ.0.D0.AND.NFRACT.EQ.1)THEN
         TEXT1=' '
         TEXT2=' '
         II=0
         CALL DRCOUT(XYZ3,GEO3,VEL3,NVAR,TOTIME,ESCF3,EKIN3,
     1GTOT3,ETOT3,XTOT3,ILOOP,CHARGE,FRACT,TEXT1,TEXT2,II,JLOOP)
         N=0
         DO 140 I=1,NCOPRT
            K=MCOPRT(1,I)
            J=MCOPRT(2,I)
            L=K*3-3+J
            IF(ABS(GEO3(3,L)).GT.1.D-20)FRACT=-GEO3(2,L)/(GEO3(3,L)*2.D0
     1)
            IF(FRACT.GT.0.D0.AND.FRACT.LT.TOLD2) THEN
               IF(GEO3(3,L).GT.0.D0)TEXT1='MIN'
               IF(GEO3(3,L).LT.0.D0)TEXT1='MAX'
               TEXT2=COTYPE(J)
               IF(N.EQ.0)THEN
                  N=N+1
                  WRITE(6,'(/,20(''****''))')
               ENDIF
               TIME=TOTIME+FRACT
               CALL DRCOUT(XYZ3,GEO3,VEL3,NVAR,TIME,ESCF3,EKIN3,
     1GTOT3,ETOT3,XTOT3,ILOOP,CHARGE,FRACT,TEXT1,TEXT2,K,JLOOP)
            ENDIF
  140    CONTINUE
         IF(N.NE.0)WRITE(6,'(/,20(''****''))')
         IF(ABS(ESCF3(3)).GT.1.D-20)FRACT=-ESCF3(2)/(ESCF3(3)*2.D0)
         IF(.NOT.GOTURN.AND.FRACT.GT.0.D0.AND.FRACT.LT.TOLD2*1.04D0
     1.AND. PARMAX) THEN
            GOTURN=.TRUE.
            TIME=FRACT+TOTIME
            IF(ESCF3(3).GT.0.D0) THEN
               TEXT1='MIN'
               IF(LDRC) THEN
                  SUM=DOT(VELO0,VREF,NVAR)**2/(DOT(VELO0,VELO0,NVAR)*
     1DOT(VREF,VREF,NVAR)+1.D-10)
                  SUM1=DOT(VELO0,VREF0,NVAR)**2/(DOT(VELO0,VELO0,NVAR)*
     1DOT(VREF0,VREF0,NVAR)+1.D-10)
                  IF(SUM1.GT.0.1D0)
     1WRITE(6,'(/,A,F8.5,A,F8.5,A,F8.1,A)')' COEF. OF V(0)
     2=',SUM1,'   LAST V(0)',SUM,'   HALF-LIFE =',
     3-0.6931472D0*TIME/LOG(SUM1),' FEMTOSECS'
               ENDIF
               WRITE(6,'(//,A,F11.3,A)')' HALF-CYCLE TIME ='
     1,TIME-TLAST,' FEMTOSECONDS'
               TLAST=TIME
               DO 150 I=1,NVAR
  150          VREF(I)=VELO0(I)
            ENDIF
            IF(ESCF3(3).LT.0.D0)TEXT1='MAX'
            TEXT2=' '
            CALL DRCOUT(XYZ3,GEO3,VEL3,NVAR,TIME,ESCF3,EKIN3,
     1GTOT3,ETOT3,XTOT3,ILOOP,CHARGE,FRACT,TEXT1,TEXT2,0,JLOOP)
         ELSE
            GOTURN=.FALSE.
         ENDIF
      ELSE
         DO 160 I=1,NFRACT
            TIME=TOTIME+TSTEPS(I)
            TEXT1=' '
            TEXT2=' '
C#           WRITE(6,'(A,4F12.4)')' KINETIC ENERGY, POINT',EKIN3,TSTEPS(
            CALL DRCOUT(XYZ3,GEO3,VEL3,NVAR,TIME,ESCF3,EKIN3,
     1GTOT3,ETOT3,XTOT3,ILOOP,CHARGE,TSTEPS(I),TEXT1,TEXT2,0,JLOOP)
  160    CONTINUE
      ENDIF
  170 CONTINUE
C
C BUFFER TOTAL TIME TO 3 POINTS BACK!
C
      TOTIME=TOTIME+TOLD2
      TOLD2=TOLD1
      TOLD1=DELTAT
      ILOOP=ILOOP+1
      RETURN
      END

      SUBROUTINE RESIL2(JDIM,KDIM,S,NRES)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION S(JDIM,KDIM,4)
C
C       COMPUTE L2  NORM OF DENSITY  RESIDUAL ( RIGHT HAND SIDE )
C
         RESID = 0.
         DO 5 K=KLOW,KUP
         DO 5 J=JLOW,JUP
            RESID = RESID + S(J,K,NRES)**2
5        CONTINUE
         RESID = RESID/( (JUP-JLOW+1)*(KUP-KLOW+1))
         RESID = SQRT( RESID ) / DT
6     CONTINUE

         RETURN
         END

      PROGRAM GRSOS
        IMPLICIT   NONE
        INTEGER    KDIM,N,M,NRUN,KRC,IN,I,J,IMK,KK,KK250
c--        PARAMETER  (NRUN=1,KDIM=800,M=1,N=10,KRC=KDIM/2)
        PARAMETER  (NRUN=1,KDIM=1000,M=1,N=5,KRC=KDIM/2)
        REAL*8     SHR(KRC,N)
        PARAMETER  (KK=KDIM**2,KK250=KDIM**2+250)
        INTEGER    JJ1,JJ2,II,JJ
        INTEGER    IJKL
        INTEGER    KP1,KM1,KP2,KM2
        INTEGER    K1,K2,LMAX,IND,L
        INTEGER    KP(KDIM+1),KM(KDIM)
        INTEGER    KPH1,KMH1,KPH2,KMH2
        REAL       RKRN
        REAL*8     DSEED
        INTEGER    IZ(KDIM,KDIM),INSEED(KK250),INDUM(KK250)
        INTEGER    IZI
        REAL       R1(KK),R2(KK),Y
        REAL*8     SMX,SMM(N),RHE,RKK,SNRR,SWW(N),SCX,SHH
        INTEGER    KCHECK(KDIM+1)
c
        common /area1/ IZ,INSEED,INDUM
        common /area2/ r1,r2
                                            
        EXTERNAL R250,RKRN,HTWD,CORR1   

        call initim()
c     open files
        OPEN(UNIT=11, FILE='d1000.dat',STATUS='unknown')
        OPEN(UNIT=12, FILE='c1000.dat',STATUS='unknown')

C       NORMALIZATION FACTORS
C
        SNRR=1.D0/DFLOAT(NRUN)
        RKK=1.D0/DFLOAT(KK)
C
C       RKK = INVERSE NUMBER OF CO-ORDINATES
C      
C====================================================================
C        INITIALIZE FIRST 250 SEEDS FOR R250 RANDOM                  
C        NUMBER GENERATOR                                            
C--------------------------------------------------------------------
C                              
                                                 
        DSEED = 128071.
C                                                                               
C     **INITIALIZE THE SEED ARRAY FOR R250 USING SUBROUTINE RKRN     
C     **LARGEST INTEGER IN CRAY XM-P IS 2**46 - 1, BUT IN CONVEX
C     ** 2**36 - 1
                                                                                
       DO 1 I=1,KK250
       INDUM(I)=INT(2147483647.D0 * RKRN(DSEED)) 
       IF(INDUM(I).LT.0.0) THEN
            WRITE(6,*)'ERROR IN RKRN: ',DSEED,INDUM(I)          
            STOP
       ENDIF 
1      CONTINUE                                                                 
C                             
C      SET UP TO SHUFFLE THE SEED ARRAY AND PUT THE RESULTS TO INSEED
C
       LMAX = KK250
       IND = 0

88     Y = RKRN(DSEED)
       L = Y*KK250 + 1
       IF ( L .GT. LMAX ) GOTO 88

       IND = IND + 1
       INSEED(IND) = INDUM(L)
       INDUM(L) = INDUM(LMAX)
       LMAX = LMAX - 1
       IF ( LMAX .EQ. 1 ) THEN
                          INSEED(KK250) = INDUM(1)
                          GOTO 888
       ENDIF
       GOTO 88

888     CONTINUE
C
C      *******************************************************
C
C  SET VECTORS FOR PERIODIC BOUNDARY CONDITIONS
C
        call shotim()
         DO 3 I=1,KDIM
         KP(I)=I+1
         KM(I)=I-1
         KCHECK(I)=I
3        CONTINUE
         KP(KDIM)=1
         KP(KDIM+1)=1
         KM(1)=KDIM    
C
         DO 7 I=1,N
         SMM(I)=0.D0
         SWW(I)=0.D0
7        CONTINUE                                                      
C
         DO 9876 IJKL=1,NRUN

C====================================================================
C   INITIALIZE THE LATTICE

         DO 5 JJ1=1,KDIM
         DO 5 JJ2=1,KDIM
         IZ(JJ1,JJ2)=0  
5        CONTINUE
C====================================================================
C
C====================================================================
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C          MONTE CARLO -LOOPS STARTS
C
C   SAMPLING LOOP; N=NUMBER OF SAMPLES:
C
          DO 70 IN=1,N     
C                      
C   SAMPLING INTERVAL LOOP; M=SAMPLING INTERVAL:
C
          DO 80 IMK=1,M
C
C   GENERATION OF RANDOM NUMBERS; ALTOGETHER KK NUMBERS
C
C     *******************************************
          CALL R250(INSEED,R1,KK) 
          CALL R250(INSEED,R2,KK) 
C     *******************************************
C
          DO 80 JJ2=1,KK 

C
C     LATTICE LOOP :
C
C--------------------------------------------------------------------
C   RANDOMLY CHOSEN CO-ORDINATES
C
          K1=KDIM*R1(JJ2)+1
          K2=KDIM*R2(JJ2)+1
          K1=KCHECK(K1)
          K2=KCHECK(K2)        

C--------------------------------------------------------------------
C   AND ITS NEIGHBORS
C
        KP1=KP(K1)
        KM1=KM(K1)
        KP2=KP(K2)
        KM2=KM(K2)

        IZI=IZ(K1,K2)+1

        KPH1=IABS(IZ(KP1,K2)-IZI)
        IF(KPH1.LE.1)THEN
          KMH1=IABS(IZ(KM1,K2)-IZI)
          IF(KMH1.LE.1)THEN
             KPH2=IABS(IZ(K1,KP2)-IZI)
             IF(KPH2.LE.1)THEN          
                KMH2=IABS(IZ(K1,KM2)-IZI)
                IF(KMH2.LE.1)THEN
                         IZ(K1,K2)=IZI
                        ENDIF
                      ENDIF
                    ENDIF               
                  ENDIF

C====================================================================
80      CONTINUE
   
        CALL HTWD(IZ,SMM,SWW,IN,RKK,KDIM)
        CALL CORR1(IZ,SHR,IN,KDIM,KRC)

        call shotim()
70      CONTINUE
        WRITE(6,*)IJKL
9876    CONTINUE
C
C====================================================================
C          MONTE CARLO -LOOP ENDS
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C       
C
C  * CALCULATE THE AVERAGES AND WRITE THE DATA INTO FILES
C
        
        DO 168 I=1,N
        SMM(I)=SMM(I)*SNRR
        SWW(I)=SWW(I)*SNRR
        WRITE(11,*)I*M,SWW(I),SMM(I)
 168    CONTINUE

        CLOSE(11)

        WRITE(6,*)'FINAL N'
        WRITE(6,*)N

        DO 169 J=1,N
        DO 169 I=1,KRC
        SHR(I,J)=SHR(I,J)*SNRR
        WRITE(12,*)I,SHR(I,J)
169     CONTINUE       
        CLOSE(12)

        STOP
        END

      SUBROUTINE RGTBL(NVH,NVL,WK1,NV,TBL,IRAND)
C
C
      DOUBLE PRECISION WK1(NVH,18),
     >                 TBL(NV ,18)
C
      INTEGER          IRAND(NVH)
C
C

C     ***********
      CALL VDRAND( NVL, WK1(1,1) )
C     ***********
C
C
      DO 10 IVL = 1,NVL

      ITMP = INT(  DBLE(NV) * WK1(IVL,1) ) + 1

      IF( ITMP .GT. NV .OR. ITMP .LT. 1 ) THEN
          PRINT *,'ERROR IN RGTBL'
          PRINT *,'LATTICE POINT: ',IVL
          PRINT *,'RANDOM NUMBER: ',WK1(IVL,1)
          PRINT *,'INTEGER INDEX: ',ITMP
          STOP
      ENDIF

      IRAND(IVL) = ITMP

   10 CONTINUE


C     ***********
      CALL GATHER(NVH,NVL,WK1,NV,TBL,IRAND,0)
C     ***********


      END

      PROGRAM RESPON
C     
C..   A PROGRAM TO FORMULATE COMPLEX TRANSFER FUNCTION MATRIX H IN
C     EQUATION:  X(OMEGA) = H(OMEGA)*F(OMEGA)
C     AND TO CALCULATE THE MAXIMUM X-MAGNITUDE PER GIVEN EXCITATION
C     FREQUENCY UNDER UNIT LOADING
C
C     Original version by Sami Saarinen, CSC/1988
C
C     Version 2 for OPMVAX Replacement Project 1991 by Sami Saarinen
C
C     - I/O to 20-unit removed
C     - source code reformatted using emacs 'indent-region'
C     - modified to SINGLE PRECISION (32-bit)
C     
CDEP  
      IMPLICIT REAL (A-H,O-Z)
      parameter (nproc=4)
      PARAMETER (NDIM=882,NMODES=10,MAXSAM=200)
      DIMENSION FREQR(NMODES),XSIIR(NMODES),TABLE(MAXSAM,2)
c-old      DIMENSION FREQS(MAXSAM),XRESP(NDIM)
      DIMENSION FREQS(MAXSAM)
      dimension jfreq(nproc+1),idof(maxsam)
C-old:DEP  --- NOTE: ALL COMPLEX*16 MEANS A 64-BIT REAL AND IMAGINARY PART
C-old      COMPLEX*16 H,XRESP
      COMPLEX H,XRESP
c-old      COMMON /FSCC1/ H(NDIM,NDIM)
      COMMON /FSCC1/ H(NDIM,NDIM,nproc)
      COMMON /FSCC2/ FII(NDIM,NMODES)
      common /fscc3/ xresp(ndim,maxsam)
c-old      CHARACTER*40 FILNAM
C     
      call mesage('** JOB STARTED **   ',1,1)
C
      write(6,*)'Enter number of processors to be used:'
      read(5,*) kproc
      kproc = max(1,min(kproc,nproc))
      write(6,*) 'Actual number of processors equals to ',kproc
      WRITE(6,*)'ENTER NUMBER OF EXCITATION FREQUENCY POINTS:'
      READ(5,*) NFREQ
      NFREQ=MIN(NFREQ,MAXSAM)
      WRITE(6,*) 'NFREQ=',NFREQ
      WRITE(6,*)'ENTER LIST OF FREQUENCY VALUES:'
      READ(5,*) (FREQS(I),I=1,NFREQ)                      
      WRITE(6,*)'** LIST OF FREQUENCIES TO BE USED:'
      WRITE(6,FMT='(1P,(1X,6G13.5))') (FREQS(I),I=1,NFREQ)
      WRITE(6,*)'ENTER SAMPLE DEGREE OF FREEDOM:'
      READ(5,*) KDOF
      WRITE(6,*)'KDOF=',KDOF
C     WRITE(6,*)'ENTER FILENAME FOR MODAL DATA INPUT:'
C     READ(5,'(A)') FILNAM
C     WRITE(6,*)'FILENAME='//FILNAM
CDEP  
      OPEN(UNIT=1,file='fort.1',STATUS='OLD')
      READ(1,*) KDIM,KMODES
      KDIM=MIN(KDIM,NDIM)
      KMODES=MIN(KMODES,NMODES)
      WRITE(6,*)'KDIM=',KDIM,' KMODES=',KMODES
      call mesage('**READ MODES BEGIN  ',2,1)
      CALL READI(FII,FREQR,XSIIR,KDIM,KMODES)
      call mesage('**READ MODES DONE   ',2,0)
      CLOSE(1)
C     
      call mesage('**SCALING MODES     ',4,1)
      CALL SCALE(FII,KDIM,KMODES)
      call mesage('**SCALING DONE      ',4,0)
C     
C..   FORMULATE H-MATRIX IN EVERY FREQUENCY POINTS AND CALCULATE RESPONSE
C     
CDEP  
C-old      OPEN(20,STATUS='UNKNOWN')
      call mesage('CALCULATING RESPONSE',3,1)          
      PII180=57.29577951

      jinc = (nfreq+1) / kproc
      jfreq(1) = 1
      do 120 ii=2,nproc
         jfreq(ii) = jfreq(ii-1) + jinc
 120  continue
      jfreq(kproc+1) = nfreq

c---  candidate for 'do parallel' by using nproc's

      do 110 ii=1,kproc

c-old         DO 100 IFREQ=1,NFREQ
         DO 100 IFREQ=jfreq(ii),jfreq(ii+1)

            CALL HMATRX(
     +           FREQS(IFREQ),FREQR,XSIIR,FII,H(1,1,ii),KDIM,KMODES)
            CALL FINDMX(H(1,1,ii),KDIM,XRESP(1,ifreq),FREQS(IFREQ),
     +           IDOF(ifreq))

 100     CONTINUE
 110  continue

      DO 200 IFREQ=1,NFREQ
         FREQ=FREQS(IFREQ)
         RREAL=REAL(XRESP(IDOF(ifreq),ifreq))
C-old RIMAG=DIMAG(XRESP(IDOF))
C-old RMAGN=DSQRT(RREAL**2+RIMAG**2)
C-old ANGLE=DATAN2(RREAL,RIMAG)*PII180               
         RIMAG=AIMAG(XRESP(IDOF(ifreq),ifreq))
         RMAGN=SQRT(RREAL**2+RIMAG**2)
         ANGLE=ATAN2(RREAL,RIMAG)*PII180               
         WRITE(6,1000) IFREQ,FREQ,RMAGN,ANGLE,IDOF(ifreq)
C-old WRITE(20,1000) IFREQ,FREQ,RMAGN,ANGLE,IDOF(ifreq)
 1000    FORMAT(5X,I5,': ',1P,3(G13.5,2X),' AT DOF ',I5)
         RREAL=REAL(XRESP(KDOF,ifreq))
C-old RIMAG=DIMAG(XRESP(KDOF))
         RIMAG=AIMAG(XRESP(KDOF,ifreq))
C-old TABLE(IFREQ,1)=DSQRT(RREAL**2+RIMAG**2)
C-old TABLE(IFREQ,2)=DATAN2(RREAL,RIMAG)*PII180               
         TABLE(IFREQ,1)=SQRT(RREAL**2+RIMAG**2)
         TABLE(IFREQ,2)=ATAN2(RREAL,RIMAG)*PII180               
C-old call mesage('**INTERMEDIATE TIME ',3,0)
 200  continue

      call mesage('CALCULATION DONE    ',3,0)
C     
      RMAX=0.0
      DO 300 I=1,NFREQ
         RMAX=MAX(RMAX,TABLE(I,1))
 300  CONTINUE
      WRITE(6,1101) 
     +     KDOF,'#','FREQ [Hz]',
     +     'Magnitude','Phase Angle','   Plot Bar'

      DO 310 I=1,NFREQ
         NUMSTR=INT(30.0*TABLE(I,1)/RMAX+0.5)
         WRITE(6,1100) I, FREQS(I),TABLE(I,1),TABLE(I,2),
     +        ('*',J=1,NUMSTR)
 310  CONTINUE         
 1100 FORMAT(1X,I5,F12.2,2X,E13.5,2X,F12.2,2X,40A1)
 1101 FORMAT(//1X,'*** RESULTS AT SAMPLE DEGREE OF FREEDOM ',I5,' :'//
     +       1X,A5,A12,2X,A13,2X,A12,2X,A/)
C     
      call mesage('** END OF JOB **    ',1,0)
      STOP 
      END

      SUBROUTINE TKINV(JDIM,KDIM,Q,SNDSP,S,XYJ,XY,IX,IY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  IX = 1, IY = 2  XI  METRICS
C  IX = 3, IY = 4  ETA METRICS
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),S(JDIM,KDIM,4),SNDSP(JDIM,KDIM)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
C
      BT = 1./SQRT(2.)
C
C  T INVERSE MATRIX MULTIPLY FOR DIAGONAL ALGORITHM
C   K
C
      DO 1 K = KLOW, KUP
       DO 1 J = JLOW,JUP
         RX        = XY(J,K,IX)
         RY        = XY(J,K,IY)
         RRXY      = 1./SQRT(RX**2+RY**2)
         RX        = RX*RRXY
         RY        = RY*RRXY
            RHO       = Q(J,K,1)*XYJ(J,K)
            RHOINV    = 1./RHO
            RHOINR   = RHOINV*XYJ(J,K)
            U = Q(J,K,2)*RHOINR
            V = Q(J,K,3)*RHOINR
            SNR   = 1./SNDSP(J, K)
            BET0  = BT*RHOINV*SNR
C
               TERM1 = GAMI*( U*S(J,K,2) + V*S(J,K,3) - S(J,K,4) 
     +                 - 0.5*(U**2+V**2)*S(J,K,1) )
C
               S1    =  S(J,K,1) + TERM1*SNR**2
               S2    = ( (- RY*U + RX*V)*S(J,K,1) 
     +                 + RY*S(J,K,2) - RX*S(J,K,3) )*RHOINV
C
               TERM1 =  TERM1*BET0
               TERM2 =  ((RX*U + RY*V)*S(J,K,1)
     +                 - RX*S(J,K,2) - RY*S(J,K,3) )*BT*RHOINV
C
               S(J,K,1) = S1
               S(J,K,2) = S2
               S(J,K,3) = -(TERM1 + TERM2)
               S(J,K,4) = -(TERM1 - TERM2)
C
1       CONTINUE
C
        RETURN
        END

      SUBROUTINE SCLOCK
C-------------------------------------------------------------
C  Start a clock - CONTAINS MACHINE-DEPENDENT CALL
C-------------------------------------------------------------
      COMMON /CLOCKC/ STIME, SWALL
      DOUBLE PRECISION CPUTIM
      EXTERNAL CPUTIM
C--------------
c  Any
      STIME = REAL(CPUTIM())
C  Cray
c      STIME = SECOND(XXX)
C  Vax
C      STIME = SECNDS(0.0)
C  FPS464
C     CALL SYS$GETTIME(STIME,SWALL)
C  RS6000
C      I1 = MCLOCK() * 0.01
C      STIME = I1
C--------------
      WRITE(*,1000)
1000  FORMAT (//'****** Clock started'//)
      RETURN
      END
C 
      SUBROUTINE PCLOCK(LABEL)
C-----------------------------------------------------------------------
C  Read the clock and print the result - CONTAINS MACHINE-DEPENDENT CALL
C-----------------------------------------------------------------------
      COMMON /CLOCKC/ STIME, SWALL
      DOUBLE PRECISION CPUTIM
      EXTERNAL CPUTIM
C---------------
c     Any
      WRITE (*,1000) LABEL, REAL(CPUTIM())-STIME
C  Cray
c      WRITE (*,1000) LABEL, SECOND(XXX)-STIME
C  Vax
C      WRITE (*,1000) LABEL, SECNDS(STIME)
C  FPS464
C     CALL SYS$GETTIME(TIME,WALL)
C     WRITE (*,1000) TIME-STIME, WALL-SWALL
C  RS6000
C      WRITE (*,1000) LABEL, MCLOCK() * 0.01 - STIME
C---------------
1000  FORMAT (' AT clock No.',I4,'  CPU time since clock started =',
     *         F14.6,' seconds ')
      RETURN
      END
C
      FUNCTION MINFO(I)
C-----------------------------------------------------------------------
C  Provide machine-dependent information
C  I=1: Machine type: 3 for Cray
C  I=2: Length of a real in record-length units: 8 for Cray
C-----------------------------------------------------------------------
      IF (I.EQ.1) MINFO = 3
      IF (I.EQ.2) MINFO = 8
      RETURN
      END

      DOUBLE PRECISION FUNCTION SSUM (N,X,INCX)
      INTEGER N, INCX
      DOUBLE PRECISION X(*)
      INTEGER I, IX
      SSUM = 0.0D0
      IX = 1
      DO 100 I=1,N
         SSUM = SSUM + X(IX)
         IX = IX + INCX
 100  CONTINUE
      RETURN
      END

      SUBROUTINE DENSIT( C,MDIM, NORBS,NDUBL, NSINGL, FRACT, P, MODE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(*), C(MDIM,*)
C***********************************************************************
C
C   DENSIT COMPUTES THE DENSITY MATRIX GIVEN THE EIGENVECTOR MATRIX, AND
C          INFORMATION ABOUT THE M.O. OCCUPANCY.
C
C  INPUT:  C     = SQUARE EIGENVECTOR MATRIX, C IS OF SIZE MDIM BY MDIM
C                  AND THE EIGENVECTORS ARE STORED IN THE TOP LEFT-HAND
C                  CORNER.
C          NORBS = NUMBER OF ORBITALS
C          NDUBL = NUMBER OF DOUBLY-OCCUPIED M.O.S ( =0 IF UHF)
C          NSINGL= NUMBER OF SINGLY OR FRACTIONALLY OCCUPIED M.O.S.
C
C   ON EXIT: P   = DENSITY MATRIX
C
C***********************************************************************
C
C SET UP LIMITS FOR SUMS
C  NL1 = BEGINING OF ONE ELECTRON SUM
C  NU1 = END OF SAME
C  NL2 = BEGINING OF TWO ELECTRON SUM
C  NU2 = END OF SAME
C
      NORBS2=NORBS/2
      NSINGL=MAX(NDUBL,NSINGL)
      IF(NSINGL .GT. NORBS2 .AND. MODE .EQ. 1) THEN
C
C    TAKE POSITRON EQUIVALENT
C
         SIGN=-1.D0
         FRAC=2.D0-FRACT
         IF(NDUBL.EQ.0)THEN
            CONST=1.D0
            NL2=2
            NU2=0
            NL1=NSINGL+1
            NU1=NORBS
         ELSE
            CONST=2.D0
            NL2=NSINGL+1
            NU2=NORBS
            NL1=NDUBL+1
            NU1=NSINGL
         ENDIF
      ELSE
C
C    TAKE ELECTRON EQUIVALENT
C
         SIGN=1.D0
         FRAC=FRACT
         CONST=0.D0
         NL2=1
         NU2=NDUBL
         NL1=NDUBL+1
         NU1=NSINGL
      ENDIF
      L=0
      DO 40 I=1,NORBS
         DO 30 J=1,I
            L=L+1
            SUM2=0.D0
            SUM1=0.D0
            DO 10 K=NL2,NU2
   10       SUM2=SUM2+C(I,K)*C(J,K)
            SUM2=SUM2*2.D0
            DO 20 K=NL1,NU1
   20       SUM1=SUM1+C(I,K)*C(J,K)
   30    P(L)=(SUM2+SUM1*FRAC)*SIGN
   40 P(L)=CONST+P(L)
      RETURN
      END

      SUBROUTINE VWRITE(TIME0,FUNCT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      CHARACTER*80 KEYWRD,KOMENT,TITLE
      DOUBLE PRECISION MECI
      COMMON /KEYWRD/ KEYWRD
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /HMATRX/ H(MPACK)
      COMMON /FOKMAT/ F(MPACK), FB(MPACK)
      COMMON /VECTOR/ C(MORB2),EIGS(MAXORB),CBETA(MORB2),EIGB(MAXORB)
      COMMON /DENSTY/ P(MPACK),PA(MPACK),PB(MPACK)
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1                    LOCDEP(MAXPAR)
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /NUMSCF/ NSCF
      COMMON /WMATRX/ WJ(N2ELEC), WK(N2ELEC)
      COMMON /ATHEAT/ ATHEAT
      COMMON /CORE  / CORE(107)
      COMMON /SCRACH/ RXYZ(MPACK), XDUMY(MAXPAR**2-MPACK)
      COMMON /CIMATS/ ENGYCI(3),VECTCI(9),ECI(6)
      COMMON /MESAGE/ IFLEPO,IITER
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /ENUCLR/ ENUCLR
      COMMON /ELECT / ELECT
      COMMON /XYZGRA/ DXYZ(3,NUMATM*27)
      COMMON /GRADNT/ GRAD(MAXPAR), GNORM
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /GEOVAR/ NVAR, LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
************************************************************************
*
*   WRITE PRINTS OUT MOST OF THE RESULTS.
*         IT SHOULD NOT ALTER ANY PARAMETERS, SO THAT IT CAN BE CALLED
*         AT ANY CONVENIENT TIME.
*
************************************************************************
      DIMENSION Q(MAXORB), Q2(MAXORB), COORD(3,NUMATM)
     1,IEL1(107), NELEMT(107), IEL2(107)
      DIMENSION W(N2ELEC), DUMY(3)
      LOGICAL UHF, CI, SINGLT, TRIPLT, EXCITD, PRTGRA, XYZ, FIRST
      CHARACTER TYPE(3)*11, IDATE*24, CALCN(2)*5, GTYPE*13, GRTYPE*14,
     1          FLEPO(13)*58, ITER(2)*58, NUMBRS(11)*1
      CHARACTER*2 ELEMNT, IELEMT(20), SPNTYP*7, CALTYP*7
      EQUIVALENCE (W,WJ)
      REAL WJ, WK
      DATA TYPE/'BOND       ','ANGLE      ','DIHEDRAL   '/
      DATA CALCN /'     ','ALPHA'/
      DATA NUMBRS /'0','1','2','3','4','5','6','7','8','9',' '/
      DATA FIRST /.TRUE./
      DATA FLEPO(1),FLEPO(2),FLEPO(3)/
     1' 1SCF WAS SPECIFIED, SO BFGS WAS NOT USED                 ',
     2' GRADIENTS WERE INITIALLY ACCEPTABLY SMALL                ',
     3' HERBERTS TEST WAS SATISFIED IN BFGS                      '/
      DATA FLEPO(4),FLEPO(5),FLEPO(6)/
     1' THE LINE MINIMIZATION FAILED TWICE IN A ROW.   TAKE CARE!',
     2' BFGS FAILED DUE TO COUNTS EXCEEDED. TAKE CARE!           ',
     3' PETERS TEST WAS SATISFIED IN BFGS OPTIMIZATION           '/
      DATA FLEPO(7),FLEPO(8),FLEPO(9)/
     1' THIS MESSAGE SHOULD NEVER APPEAR, CONSULT A PROGRAMMER!! ',
     2' GRADIENT TEST NOT PASSED, BUT FURTHER WORK NOT JUSTIFIED ',
     3' A FAILURE HAS OCCURRED, TREAT RESULTS WITH CAUTION!!     '/
      DATA FLEPO(10),FLEPO(11),FLEPO(12)/
     1' GEOMETRY OPTIMIZED USING NLLSQ. GRADIENT NORM MINIMIZED  ',
     2' GEOMETRY OPTIMIZED USING POWSQ. GRADIENT NORM MINIMIZED  ',
     3' CYCLES EXCEEDED, GRADIENT NOT FULLY MINIMIZED IN NLLSQ   '/
      DATA FLEPO(13)/
     1'                                                          '/
      DATA ITER/
     1' SCF FIELD WAS ACHIEVED                                   ',
     2'  ++++----**** FAILED TO ACHIEVE SCF. ****----++++        '/
C
C SUMMARY OF RESULTS (NOTE: THIS IS IN A SUBROUTINE SO IT
C          CAN BE USED BY THE PATH OPTION)
      PI=3.141592653589D0
      IDATE=' '
      IF(IFLEPO.EQ.0) IFLEPO=7
      IUHF=MIN(INDEX(KEYWRD,'UHF'),1)+1
      PRTGRA=(INDEX(KEYWRD,'GRADI').NE.0)
      LINEAR=(NORBS*(NORBS+1))/2
      XYZ=(INDEX(KEYWRD,' XYZ') .NE. 0)
      SINGLT=(INDEX(KEYWRD,'SINGLET') .NE. 0)
      TRIPLT=(INDEX(KEYWRD,'TRIPLET') .NE. 0)
      EXCITD=(INDEX(KEYWRD,'EXCITED') .NE. 0)
      SPNTYP='GROUND '
      IF(SINGLT) SPNTYP='SINGLET'
      IF(TRIPLT) SPNTYP='TRIPLET'
      IF(EXCITD) SPNTYP='EXCITED'
      CI=(INDEX(KEYWRD,'C.I.') .NE. 0)
      IF(INDEX(KEYWRD,'MINDO') .NE. 0) THEN
         CALTYP='MINDO/3'
      ELSEIF(INDEX(KEYWRD,'AM1') .NE. 0) THEN
         CALTYP='  AM1  '
      ELSEIF(INDEX(KEYWRD,'PM3') .NE. 0) THEN
         CALTYP='  PM3  '
      ELSE
         CALTYP=' MNDO  '
      ENDIF
      UHF=(IUHF.EQ.2)
C-old      CALL DATE(IDATE)
      DEGREE=57.29577951D0
      IF(NA(1).EQ.99)THEN
         DEGREE=1.D0
         TYPE(1)='           '
         TYPE(2)='           '
         TYPE(3)='           '
      ENDIF
      GNORM=0.D0
      IF(NVAR.NE.0)GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
      WRITE(6,'(/,'' ----'',15(''-----''))')
      WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
      WRITE(6,'(//4X,A58)')FLEPO(IFLEPO)
      IITER=MAX(1,IITER)
      WRITE(6,'(4X,A58)')ITER(IITER)
      WRITE(6,'(//30X,A7,''  CALCULATION'')')CALTYP
      WRITE(6,'(55X,''VERSION '',F5.2)')VERSON
      WRITE(6,'(55X,A24)')IDATE
      IF(IITER.EQ.2)THEN
C
C   RESULTS ARE MEANINGLESS. DON'T PRINT ANYTHING!
C
         WRITE(6,'(//,'' FOR SOME REASON THE SCF CALCULATION FAILED.'',/
     1,'' THE RESULTS WOULD BE MEANINGLESS, SO WILL NOT BE PRINTED.'')')
         WRITE(6,'('' TRY TO FIND THE REASON FOR THE FAILURE BY USING ''
     1,''"PL".'',/,
     2'' CHECK YOUR GEOMETRY AND ALSO TRY USING SHIFT OR PULAY. '')')
         CALL GEOUT
         CALL WRAPUP()
      ENDIF
      WRITE(6,'(////10X,''FINAL HEAT OF FORMATION ='',F17.5,'' KCAL''
     1)')FUNCT
      IF(LATOM.EQ.0) WRITE(6,'(/)')
      WRITE(6,'(    10X,''TOTAL ENERGY            ='',F17.5,'' EV''
     1)')ELECT+ENUCLR
      WRITE(6,'(    10X,''ELECTRONIC ENERGY       ='',F17.5,'' EV''
     1)')ELECT
      WRITE(6,'(    10X,''CORE-CORE REPULSION     ='',F17.5,'' EV''
     1)')ENUCLR
      IF(LATOM.EQ.0) WRITE(6,'(1X)')
      PRTGRA=(PRTGRA .OR. GNORM .GT. 2.D0)
      IF(PRTGRA)
     1WRITE(6,'(    10X,''GRADIENT NORM           ='',F17.5)')GNORM
      IF(LATOM.NE.0) THEN
C
C   WE NEED TO CALCULATE THE REACTION COORDINATE GRADIENT.
C
         MVAR=NVAR
         LOC11=LOC(1,1)
         LOC21=LOC(2,1)
         NVAR=1
         LOC(1,1)=LATOM
         LOC(2,1)=LPARAM
         XREACT=GEO(LPARAM,LATOM)
         CALL DERIV(GEO,GCOORD)
         NVAR=MVAR
         LOC(1,1)=LOC11
         LOC(2,1)=LOC21
         GRTYPE=' KCAL/ANGSTROM'
         IF(LPARAM.EQ.1)THEN
            WRITE(6,'(    10X,''FOR REACTION COORDINATE ='',F17.5
     1        ,'' ANGSTROMS'')')XREACT
         ELSE
            IF(NA(1).NE.99)GRTYPE=' KCAL/RADIAN  '
            WRITE(6,'(    10X,''FOR REACTION COORDINATE ='',F17.5
     1        ,'' DEGREES'')')XREACT*DEGREE
         ENDIF
         WRITE(6,'(    10X,''REACTION GRADIENT       ='',F17.5,A14
     1    )')GCOORD,GRTYPE
      ENDIF
      IF(NALPHA.GT.0)THEN
         EIONIS=-MAX(EIGS(NALPHA), EIGB(NBETA))
      ELSEIF(NELECS.EQ.1)THEN
         EIONIS=-EIGS(1)
      ELSEIF(NELECS.GT.1) THEN
         EIONIS=-MAX(EIGS(NCLOSE), EIGS(NOPEN))
      ELSE
         EIONIS=0.D0
      ENDIF
      NOPN=NOPEN-NCLOSE
C   CORRECTION TO I.P. OF DOUBLETS
      IF(NOPN.EQ.1)THEN
         I=NCLOSE*NORBS+1
         XIIII= SPCG(C(I),C(I),C(I),C(I),W,WJ)
         EIONIS=EIONIS+0.5D0*XIIII
      ENDIF
      WRITE(6,'(       10X,''IONIZATION POTENTIAL    ='',F17.5)')EIONIS
      IF( UHF ) THEN
         WRITE(6,'(      10X,''NO. OF ALPHA ELECTRONS  ='',I11)')NALPHA
         WRITE(6,'(      10X,''NO. OF BETA  ELECTRONS  ='',I11)')NBETA
      ELSE
         WRITE(6,'(      10X,''NO. OF FILLED LEVELS    ='',I11)')NCLOSE
         IF(NOPN.NE.0) THEN
            WRITE(6,'(   10X,''AND NO. OF OPEN LEVELS  ='',I11)')NOPN
         ENDIF
      ENDIF
      SUMW=0
      DO 10 I=1,NUMAT
   10 SUMW=SUMW+ATMASS(I)
      IF(SUMW.GT.0.1D0)
     1WRITE(6,'(    10X,''MOLECULAR WEIGHT        ='',F11.3)')SUMW
      IF(LATOM.EQ.0) WRITE(6,'(/)')
      WRITE(6,'(10X,''SCF CALCULATIONS  =   '',I14 )') NSCF
      TIM=ZECOND()-TIME0
      I=TIM*0.000001D0
      TIM=TIM-I*1000000
      CALL TIMOUT(6,TIM)
      IF( NDEP .NE. 0 )CALL SYMTRY
      IF(NA(1).NE.99) THEN
         DO 50 J=1,NATOMS
            DO 50 I=1,3
               X=GEO(I,J)
               GOTO (40, 30, 20) I
   20          X=X - AINT(X/(2.D0*PI)+SIGN(0.4999D0,X)-0.0001D0)*PI*2.D0
               GEO(3,J)=X
               GOTO 40
   30          X=X - AINT(X/(2.D0*PI))*PI*2.D0
               IF(X.LT.0)X=X+PI*2.D0
               IF(X .GT. PI) THEN
                  GEO(3,J)=GEO(3,J)+PI
                  X=2.D0*PI-X
               ENDIF
               GEO(2,J)=X
   40          CONTINUE
   50    CONTINUE
      ENDIF
      DO 60 I=1,NVAR
   60 XPARAM(I)=GEO(LOC(2,I),LOC(1,I))
      CALL GMETRY(GEO,COORD)
      IF(PRTGRA)THEN
         WRITE(6,'(///7X,''FINAL  POINT  AND  DERIVATIVES'',/)')
         WRITE(6,'(''   PARAMETER     ATOM    TYPE  ''
     1    ,''          VALUE       GRADIENT'')')
      ENDIF
      SUM=0.5D0
      DO 70 I=1,NUMAT
   70 SUM=SUM+CORE(NAT(I))
      I=SUM
      KCHRGE=I-NCLOSE-NOPEN-NALPHA-NBETA
C
C    WRITE OUT THE GEOMETRIC VARIABLES
C
      IF(PRTGRA) THEN
         DO 80 I=1,NVAR
            J=LOC(2,I)
            K=LOC(1,I)
            L=LABELS(K)
            XI=XPARAM(I)
            IF(J.NE.1) XI=XI*DEGREE
            IF(J.EQ.1.OR.NA(1).EQ.99)THEN
               GTYPE='KCAL/ANGSTROM'
            ELSE
               GTYPE='KCAL/RADIAN  '
            ENDIF
   80    WRITE(6,'(I7,I11,1X,A2,4X,A11,F13.6,F13.6,2X,A13)')
     1I,K,ELEMNT(L),TYPE(J),XI,GRAD(I),GTYPE
      ENDIF
C
C     WRITE OUT THE GEOMETRY
C
      WRITE(6,'(///)')
      CALL GEOUT
      IF (INDEX(KEYWRD,'NOINTER') .EQ. 0) THEN
C
C   WRITE OUT THE INTERATOMIC DISTANCES
C
         L=0
         DO 90 I=1,NUMAT
            DO 90 J=1,I
               L=L+1
   90    RXYZ(L)=SQRT((COORD(1,I)-COORD(1,J))**2+
     1                         (COORD(2,I)-COORD(2,J))**2+
     2                         (COORD(3,I)-COORD(3,J))**2)
         WRITE(6,'(//10X,''  INTERATOMIC DISTANCES'')')
         CALL VECPRT(RXYZ,NUMAT)
      ENDIF
      DO 100 I=1,NORBS
  100 IF(EIGS(I).LT.-999.D0.OR.EIGS(I).GT.1000.D0)EIGS(I)=0.D0
      DO 110 I=1,NORBS
  110 IF(EIGB(I).LT.-999.D0.OR.EIGB(I).GT.1000.D0)EIGS(I)=0.D0
      IF(NORBS.GT.0)THEN
         IF (INDEX(KEYWRD,'VECT') .NE. 0) THEN
            WRITE(6,'(//10X,A5,'' EIGENVECTORS  '')')CALCN(IUHF)
            CALL MATOUT (C,EIGS,NORBS,NORBS,NORBS)
            IF(UHF) THEN
               WRITE(6,'(//10X,'' BETA EIGENVECTORS  '')')
               CALL MATOUT (CBETA,EIGB,NORBS,NORBS,NORBS)
            ENDIF
         ELSE
            WRITE(6,'(//10X,A5,''   EIGENVALUES'',/)')CALCN(IUHF)
            WRITE(6,'(8F10.5)')(EIGS(I),I=1,NORBS)
            IF(UHF) THEN
               WRITE(6,'(//10X,'' BETA EIGENVALUES '')')
               WRITE(6,'(8F10.5)')(EIGB(I),I=1,NORBS)
            ENDIF
         ENDIF
      ENDIF
      WRITE(6,'(//13X,'' NET ATOMIC CHARGES AND DIPOLE '',
     1''CONTRIBUTIONS'',/)')
      WRITE(6,'(8X,'' ATOM NO.   TYPE          CHARGE        ATOM''
     1,''  ELECTRON DENSITY'')')
      CALL CHRGE(P,Q)
      DO 120 I=1,NUMAT
         L=NAT(I)
         Q2(I)=CORE(L) - Q(I)
  120 WRITE(6,'(I12,9X,A2,4X,F13.4,F16.4)')
     1I,ELEMNT(L),Q2(I),Q(I)
      DIP= DIPOLE(P,Q2,COORD,DUMY)
      IF (INDEX(KEYWRD,'NOXYZ') .EQ. 0) THEN
         WRITE(6,'(//10X,''CARTESIAN COORDINATES '',/)')
         WRITE(6,'(4X,''NO.'',7X,''ATOM'',15X,''X'',
     1  9X,''Y'',9X,''Z'',/)')
         WRITE(6,'(I6,8X,A2,14X,3F10.4)')
     1  (I,ELEMNT(NAT(I)),(COORD(J,I),J=1,3),I=1,NUMAT)
      ENDIF
      IF(NORBS.GT.0) THEN
         IF (INDEX(KEYWRD,'FOCK') .NE. 0) THEN
            WRITE(6,'('' FOCK MATRIX IS '')')
            CALL VECPRT(F,NORBS)
         ENDIF
         IF (INDEX(KEYWRD,'DENSI') .NE. 0) THEN
            WRITE(6,'(//,20X,'' DENSITY MATRIX IS '')')
            CALL VECPRT(P,NORBS)
         ELSE
            WRITE(6,'(//10X,''ATOMIC ORBITAL ELECTRON POPULATIONS'',/)')
            WRITE(6,'(8F10.5)')(P((I*(I+1))/2),I=1,NORBS)
         ENDIF
         IF(INDEX(KEYWRD,' PI') .NE. 0) THEN
            WRITE(6,'(//10X,''SIGMA-PI BOND-ORDER MATRIX'')')
            CALL DENROT
         ENDIF
         IF(UHF) THEN
            SZ=ABS(NALPHA-NBETA)*0.5D0
            SS2=SZ*SZ
            L=0
            DO 140 I=1,NORBS
               DO 130 J=1,I
                  L=L+1
                  PA(L)=PA(L)-PB(L)
  130          SS2=SS2+PA(L)**2
  140       SS2=SS2-0.5D0*PA(L)**2
            WRITE(6,'(//20X,''(SZ)    ='',F10.6)')SZ
            WRITE(6,'(  20X,''(S**2)  ='',F10.6)')SS2
            IF(INDEX(KEYWRD,'SPIN') .NE. 0) THEN
               WRITE(6,'(//10X,''SPIN DENSITY MATRIX'')')
               CALL VECPRT(PA,NORBS)
            ELSE
               WRITE(6,'(//10X,''ATOMIC ORBITAL SPIN POPULATIONS'',/)')
               WRITE(6,'(8F10.5)')(PA((I*(I+1))/2),I=1,NORBS)
            ENDIF
            IF(INDEX(KEYWRD,'HYPERFINE') .NE. 0) THEN
C
C  WORK OUT THE HYPERFINE COUPLING CONSTANTS.
C
               WRITE(6,'(//10X,''    HYPERFINE COUPLING COEFFICIENTS'',/
     1)')
               J=(NALPHA-1)*NORBS
               DO 150 K=1,NUMAT
                  I=NFIRST(K)
C#          WRITE(6,'('' PA:'',F13.6,'' C('',I2,''+'',I3,''):'',
C#     +F13.5)')PA((I*(I+1))/2),I,J,C(I+J)
  150          Q(K)=PA((I*(I+1))/2)*0.3333333D0+C(I+J)**2*0.66666666D0
               WRITE(6,'(5(2X,A2,I2,F9.5,1X))')
     1    (ELEMNT(NAT(I)),I,Q(I),I=1,NUMAT)
            ENDIF
            DO 160 I=1,LINEAR
  160       PA(I)=P(I)-PB(I)
         ENDIF
         IF (INDEX(KEYWRD,'BONDS') .NE. 0) THEN
            IF(NBETA.EQ.0)THEN
               WRITE(6,'(/10X,''BONDING CONTRIBUTION OF EACH M.O.'',/)')
               CALL MOLVAL(C,NORBS,P,NORBS,2.D0)
            ELSE
               WRITE(6,
     +  '(/10X,''BONDING CONTRIBUTION OF EACH ALPHA M.O.'',/)')
               CALL MOLVAL(C,NORBS,P,NORBS,1.D0)
               WRITE(6,
     +  '(/10X,''BONDING CONTRIBUTION OF EACH BETA  M.O.'',/)')
               CALL MOLVAL(C,NORBS,P,NORBS,1.D0)
            ENDIF
            CALL BONDS(P)
         ENDIF
         I=NCLOSE+NALPHA
         IF (INDEX(KEYWRD,'LOCAL') .NE. 0) THEN
            CALL LOCAL(C,NORBS,I,EIGS)
            IF(NBETA.NE.0)THEN
               WRITE(6,'(//10X,'' LOCALIZED BETA MOLECULAR ORBITALS'')')
               CALL LOCAL(CBETA,NORBS,NBETA,EIGB)
            ENDIF
         ENDIF
         IF (INDEX(KEYWRD,'1ELE') .NE. 0) THEN
            WRITE(6,'('' FINAL ONE-ELECTRON MATRIX '')')
            CALL VECPRT(H,NORBS)
         ENDIF
         IF(INDEX(KEYWRD,'ENPART') .NE. 0)
     1CALL ENPART(UHF,H,PA,PB,P,Q,COORD)
      ENDIF
      DO 170 I=1,107
  170 NELEMT(I)=0
      DO 180 I=1,NUMAT
         IGO=NAT(I)
         IF (IGO.GT.107) GO TO 180
         NELEMT(IGO)=NELEMT(IGO)+1
  180 CONTINUE
      ICHFOR=0
      IF (NELEMT(6).EQ.0) GO TO 190
      ICHFOR=1
      IELEMT(1)=ELEMNT(6)
      NZS=NELEMT(6)
      IF (NZS.LT.10) THEN
         IF (NZS.EQ.1) THEN
            IEL1(1)=11
         ELSE
            IEL1(1)=NZS+1
         ENDIF
         IEL2(1)=11
      ELSE
         KFRST=NZS/10
         KSEC=NZS-(10*KFRST)
         IEL1(1)=KFRST+1
         IEL2(1)=KSEC+1
      ENDIF
  190 NELEMT(6)=0
      DO 200 I=1,107
         IF (NELEMT(I).EQ.0) GO TO 200
         ICHFOR=ICHFOR+1
         IELEMT(ICHFOR)=ELEMNT(I)
         NZS=NELEMT(I)
         IF (NZS.LT.10) THEN
            IF (NZS.EQ.1) THEN
               IEL1(ICHFOR)=11
            ELSE
               IEL1(ICHFOR)=NZS+1
            ENDIF
            IEL2(ICHFOR)=11
         ELSE
            KFRST=NZS/10
            KSEC=NZS-(10*KFRST)
            IEL1(ICHFOR)=KFRST+1
            IEL2(ICHFOR)=KSEC+1
         ENDIF
  200 CONTINUE
      IF(INDEX(KEYWRD,'DENOUT') .NE. 0) THEN
CDEP
         OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old         OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old         REWIND 10
         WRITE(10)(PA(I),I=1,LINEAR)
         IF(UHF)WRITE(10)(PB(I),I=1,LINEAR)
         CLOSE (10)
      ENDIF
      IF((CI.OR.NOPEN.NE.NCLOSE.OR.INDEX(KEYWRD,'SIZE').NE.0)
     1 .AND. INDEX(KEYWRD,'MECI')+INDEX(KEYWRD,'ESR').NE.0)THEN
         WRITE(6,'(//10X,
     1''MULTI-ELECTRON CONFIGURATION INTERACTION CALCULATION'',//)')
         NMOS=0
         NCIS=0
         IF(INDEX(KEYWRD,'C.I.=').NE.0)
     1      NMOS=READA(KEYWRD,INDEX(KEYWRD,'C.I.=')+5)
C
C   SET UP C.I. PARAMETERS
C   NMOS IS NO. OF M.O.S USED IN C.I.
C   NCIS IS CHANGE IN SPIN, OR NUMBER OF STATES
C
         IF(NMOS.EQ.0) NMOS=NOPEN-NCLOSE
         IF(NCIS.EQ.0) THEN
            IF(TRIPLT.OR.INDEX(KEYWRD,'QUAR').NE.0)NCIS=1
            IF(INDEX(KEYWRD,'QUIN')+INDEX(KEYWRD,'SEXT').NE.0)NCIS=2
         ENDIF
         X=MECI(EIGS,C,CBETA,EIGB, NORBS,NMOS,NCIS, .TRUE.)
      ENDIF
      IF (INDEX(KEYWRD,'MULLIK') +INDEX(KEYWRD,'GRAPH') .NE. 0) THEN
         IF (INDEX(KEYWRD,'MULLIK') .NE. 0)
     1   WRITE(6,'(/10X,'' MULLIKEN POPULATION ANALYSIS'')')
         IF (INDEX(KEYWRD,'GRAPH') .NE. 0)
     1   WRITE(6,'(/10X,'' DATA FOR GRAPH WRITTEN TO DISK'')')
         CALL MULLIK(C,CBETA,UHF,H,F,NORBS,P,RXYZ)
      ENDIF
C
C  NOTE THAT THE DENSITY, H AND F MATRICES ARE CORRUPTED BY A
C  CALL TO MULLIK.
      IF(FIRST)THEN
CDEP
         OPEN(UNIT=12,STATUS='UNKNOWN')
C-old         OPEN(UNIT=12,FILE='FOR012',STATUS='NEW')
C-old         REWIND 12
         FIRST=.FALSE.
      ENDIF
      IWRITE=12
      WRITE(IWRITE,'(//20X,'' SUMMARY OF '',A7,
     1'' CALCULATION'',/)')CALTYP
      WRITE(IWRITE,'(60X,''VERSION '',F5.2)')VERSON
      WRITE (IWRITE,210) (IELEMT(I),NUMBRS(IEL1(I)),NUMBRS(IEL2(I))
     1,I=1,ICHFOR)
  210 FORMAT (//,1X,17(A2,A1,A1))
      WRITE(IWRITE,'(55X,A24)')IDATE
      DO 220 IK=80,3,-1
  220 IF(KOMENT(IK:IK).NE.' ')GOTO 230
  230 WRITE(IWRITE,'(A)')KOMENT(:IK)
      DO 240 IT=80,3,-1
  240 IF(TITLE(IT:IT).NE.' ')GOTO 250
  250 WRITE(IWRITE,'(A)')TITLE(:IT)
      WRITE(IWRITE,'(//4X,A58)')FLEPO(IFLEPO)
      WRITE(IWRITE,'(4X,A58)')ITER(IITER)
      WRITE(IWRITE,'(//10X,''HEAT OF FORMATION       =''
     1,F17.6,'' KCAL'')')FUNCT
      WRITE(IWRITE,'(  10X,''ELECTRONIC ENERGY       =''
     1,F17.6,'' EV'')')ELECT
      WRITE(IWRITE,'(  10X,''CORE-CORE REPULSION     =''
     1,F17.6,'' EV'')')ENUCLR
      IF(PRTGRA)
     1WRITE(IWRITE,'(  10X,''GRADIENT NORM           =''
     2,F17.6)')GNORM
      IF(LATOM.NE.0) THEN
         GRTYPE=' KCAL/ANGSTROM'
         IF(LPARAM.EQ.1)THEN
            WRITE(IWRITE,'(    10X,''FOR REACTION COORDINATE ='',F17.4
     1        ,'' ANGSTROMS'')')XREACT
         ELSE
            IF(NA(1).NE.99)GRTYPE=' KCAL/RADIAN  '
            WRITE(IWRITE,'(    10X,''FOR REACTION COORDINATE ='',F17.4
     1        ,'' DEGREES'')')XREACT*DEGREE
         ENDIF
         WRITE(IWRITE,'(    10X,''REACTION GRADIENT       ='',F17.6,A14
     1    )')GCOORD,GRTYPE
      ENDIF
      WRITE(IWRITE,'(  10X,''DIPOLE                  =''
     1,F16.5, '' DEBYE'')')DIP
      IF(UHF) THEN
         WRITE(IWRITE,'(  10X,''(SZ)                    ='',F17.6)')SZ
         WRITE(IWRITE,'(  10X,''(S**2)                  ='',F17.6)')SS2
         WRITE(IWRITE,'(  10X,''NO. OF ALPHA ELECTRONS  ='',I10)')NALPHA
         WRITE(IWRITE,'(  10X,''NO. OF BETA  ELECTRONS  ='',I10)')NBETA
      ELSE
         WRITE(IWRITE,'(  10X,''NO. OF FILLED LEVELS    ='',I10)')NCLOSE
         NOPN=NOPEN-NCLOSE
         IF(NOPN.NE.0)
     1WRITE(IWRITE,'(  10X,''AND NO. OF OPEN LEVELS  ='',I10)')NOPN
      ENDIF
      IF(CI)
     1WRITE(IWRITE,'(  10X,''CONFIGURATION INTERACTION WAS USED'')')
      IF(KCHRGE.NE.0)
     1WRITE(IWRITE,'(  10X,''CHARGE ON SYSTEM        ='',I10)')KCHRGE
      WRITE(IWRITE,'(  10X,''IONIZATION POTENTIAL    =''
     1,F17.6,'' EV'')')EIONIS
      WRITE(IWRITE,'(  10X,''MOLECULAR WEIGHT        ='',F14.3)')SUMW
      WRITE(IWRITE,'(  10X,''SCF CALCULATIONS        =''
     1,I10)') NSCF
      TIM=ZECOND()-TIME0
      CALL TIMOUT(IWRITE,TIM)
      WRITE(IWRITE,'(//10X,''FINAL GEOMETRY OBTAINED'',36X,''CHARGE'')')
      DO 260 I=80,3,-1
  260 IF(KEYWRD(I:I).NE.' ')GOTO 270
  270 WRITE(IWRITE,'(A)')KEYWRD(:I)
      WRITE(IWRITE,'(A)')KOMENT(:IK)
      WRITE(IWRITE,'(A)')TITLE(:IT)
      NA1=NA(1)
      IF(XYZ) CALL XYZINT(GEO,NATOMS,NA,NB,NC,1.D0,COORD)
      DEGREE=57.29577951D0
      COORD(2,1)=0.D0
      COORD(3,1)=0.D0
      COORD(1,1)=0.D0
      COORD(2,2)=0.D0
      COORD(3,2)=0.D0
      COORD(3,3)=0.D0
      IVAR=1
      NA(1)=0
      L=0
      DO 300 I=1,NATOMS
         DO 280 J=1,3
            IF(.NOT.XYZ)COORD(J,I)=GEO(J,I)
  280    IEL1(J)=0
  290    CONTINUE
         IF(LOC(1,IVAR).EQ.I) THEN
            IEL1(LOC(2,IVAR))=1
            IVAR=IVAR+1
            GOTO 290
         ENDIF
         IF(I.LT.4) THEN
            IEL1(3)=0
            IF(I.LT.3) THEN
               IEL1(2)=0
               IF(I.LT.2) THEN
                  IEL1(1)=0
               ENDIF
            ENDIF
         ENDIF
         IF(I.EQ.LATOM)IEL1(LPARAM)=-1
         Q(1)=COORD(1,I)
         Q(2)=COORD(2,I)*DEGREE
         Q(3)=COORD(3,I)*DEGREE
         IF(LABELS(I).NE.107.AND.LABELS(I).NE.99)THEN
            L=L+1
            WRITE(IWRITE,'(1X,A2,3(F12.6,I3),I5,2I5,F13.4)')
     1    ELEMNT(LABELS(I)),(Q(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I),Q2(L)
         ELSE
            WRITE(IWRITE,'(1X,A2,3(F12.6,I3),I5,2I5,F13.4)')
     1    ELEMNT(LABELS(I)),(Q(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I)
         ENDIF
  300 CONTINUE
      NA(1)=NA1
      I=0
      X=0.D0
      WRITE(IWRITE,'(I3,3(F12.6,I3),I5,2I5)')
     1    I,X,I,X,I,X,I,I,I,I
      DO 310 I=1,NDEP
  310 WRITE(IWRITE,'(3(I4,'',''))')LOCPAR(I),IDEPFN(I),LOCDEP(I)
      WRITE(IWRITE,'(///)')
      NSCF=0
      RETURN
      END

      SUBROUTINE C2LELL (ELM,ELF,SIDNUM,GEOM,NODEL,KSW,ALFA,UEXT,DT)
      INTEGER SIDNUM, NODEL, KSW
      DOUBLE PRECISION ELM(NODEL,*),ELF(*),GEOM(NODEL,*),ALFA,UEXT,DT 

      DOUBLE PRECISION ZERO, PII2, SQRT2
      PARAMETER (ZERO = 0.D0, PII2 = 2.0D0*3.141592653589793D0)
      PARAMETER (SQRT2 = 1.4142135623731D0)
      INTEGER DIM, DOFNOD, MNODEL, MNQP, MDOFEL
      PARAMETER (DIM = 2, DOFNOD = 1)
      PARAMETER (MNODEL = 16, MNQP = 4, MDOFEL = MNODEL*DOFNOD)
      DOUBLE PRECISION JAC(DIM,DIM)
      DOUBLE PRECISION SFUN(MNODEL), LDER(DIM*MNODEL), XK(DIM)
      DOUBLE PRECISION WG(MNQP), ZETA(MNQP), GG(8)
      DOUBLE PRECISION DETK, AMUL, CXK, GXK, XI, ETA
      INTEGER DOFEL, NQP, I, K
      INTEGER NN(4), NODSID, II, JJ, J, NODEL2
      DOFEL = DOFNOD*NODEL
      NODEL2 = NODEL
      CALL VFILL (DOFEL,ELF,ZERO)
      CALL VFILL (DOFEL*DOFEL,ELM,ZERO)
      CALL GAUSL3 (WG,ZETA,NQP)
      NODSID = 3
      NN(1) = 2*SIDNUM-1
      NN(2) = NN(1) + 1
      NN(3) = NN(2) + 1
      IF (NN(3).GT.NODEL2) NN(3)=1
      DO 10 J=1,DIM
         DO 20 I=1,NODSID
            GG((J-1)*NODSID+I) = GEOM(NN(I),J)
20       CONTINUE
10    CONTINUE
      DO 100 K=1,NQP
         XI   = ZETA(K)
         ETA  = -1.D0
         DETK = 1.D0
         CALL SQUAD8(SFUN,LDER,XI,ETA)
         CALL MXM (SFUN,1,GG,NODSID,XK,DIM)
         CALL MXM (LDER,DIM,GG,NODSID,JAC,DIM)

         CXK=ALFA
         GXK=ALFA*UEXT
         DETK = DETK*SQRT(JAC(1,1)**2+JAC(1,2)**2)
         IF (KSW.EQ.1) THEN
            AMUL = WG(K)*DETK*DT
         ELSE
            AMUL = WG(K)*PII2*XK(1)*DETK*DT
         ENDIF
         DO 30 I=1,NODSID
            II = NN(I)
            DO 40 J=1,NODSID
               JJ = NN(J)
               ELM(II,JJ)=ELM(II,JJ)+AMUL*CXK*SFUN(I)*SFUN(J)
  40        CONTINUE
            ELF(II) = ELF(II) + AMUL*GXK*SFUN(I)
  30     CONTINUE
 100  CONTINUE
      RETURN
      END

      SUBROUTINE FFTTST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   2-D FFT TEST PROGRAM
C
      PARAMETER (M=128, N=256, M1=128, F7=78125., T30=1073741824.)
      COMPLEX X, Y, CT
      COMMON /ARRAYS/ X(M1,N), W1(M), W2(N), IP(2*N)
      DATA IT/100/, ANS/0.894799941219277/
C
C   INITIALIZE
C
      AMN = M * N
      RMN = 1. / AMN
      T2 = F7 / T30
      DO 100 J = 1, N
        DO 100 I = 1, M
          T1 = MOD (F7 * T2, 1.0D0)
          T2 = MOD (F7 * T1, 1.0D0)
          X(I,J) = CMPLX (T1, T2)
100   CONTINUE
      CALL CFFT2D1 (0, M, M1, N, X, W1, IP)
      CALL CFFT2D2 (0, M, M1, N, X, W2, IP)
      TM = CPTIME ()
C
C   TEST ITERATIONS
C
      DO 120 K = 1, IT
        DO 110 J = 1, N
          DO 110 I = 1, M
            X(I,J) = RMN * X(I,J)
110     CONTINUE
C
        CALL CFFT2D1 (1, M, M1, N, X, W1, IP)
        CALL CFFT2D2 (1, M, M1, N, X, W2, IP)
        CALL CFFT2D2 (-1, M, M1, N, X, W2, IP)
        CALL CFFT2D1 (-1, M, M1, N, X, W1, IP)
120   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((REAL(X(19,19)) - ANS) / ANS)
      FP = IT * AMN * (2.  +  10. * LOG (AMN)/LOG (2.))
C
      RETURN
      END

      SUBROUTINE SPAXPY (N,ALFA,X,Y,INDEX)
      INTEGER N, INDEX(*)
      DOUBLE PRECISION ALFA, X(*), Y(*)
      INTEGER I, II
      DO 100 I=1,N
         II = INDEX(I)
         Y(II) = Y(II) + ALFA*X(I)
 100  CONTINUE
      RETURN
      END

      SUBROUTINE F01BCE(N,TOL,Z,IZ,W,IW,D,E,C,S)
C
C     TRECX2
C     F01BCE REDUCES A COMPLEX HERMITIAN MATRIX TO REAL
C     TRIDIAGONAL FORM FROM WHICH THE EIGENVALUES AND EIGENVECTORS
C     CAN BE FOUND USING SUBROUTINE F02AYE,(CXTQL2). THE HERMITIAN
C     MATRIX A=A(1) IS REDUCED TO THE TRIDIAGONAL MATRIX A(N-1) BY
C     N-2 UNITARY TRANSFORMATIONS. THE HOUSEHOLDER REDUCTION ITSELF
C     DOES NOT GIVE A REAL TRIDIAGONAL MATRIX, THE OFF-DIAGONAL
C     ELEMENTS ARE COMPLEX. THEY ARE SUBSEQUENTLY MADE REAL BY A
C     DIAGONAL TRANSFORMATION.
C
C     REVISED TO INTRODUCE SCALING INTO
C     THE GENERATION OF HOUSEHOLDER MATRICES AS PROPOSED BY
C     G.W. STEWART, INTRODUCTION TO MATRIX COMPUTATIONS, CHAPTER 7.
C     TOL IS NOW A DUMMY PARAMETER.
C
C     .. Scalar Arguments ..
      INTEGER           IW, IZ, N
      REAL              TOL
C     .. Array Arguments ..
      DIMENSION C(N), D(N), E(N), S(N), W(IW,N), Z(IZ,N)
C     .. Local Scalars ..
      REAL              CO, F, FI, FR, G, GI, GR, H, HH, R, SCALE, SI
      INTEGER           I, II, J, K, KD, KE, L
C     .. External Functions ..
      REAL              DDOT
      INTEGER           IDAMAX
      EXTERNAL          DDOT, IDAMAX
C     .. External Subroutines ..
      EXTERNAL          F01BCY, F01BCZ, DSCAL
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SQRT
C     .. Executable Statements ..
      DO 20 I = 1, N
         D(I) = Z(N,I)
         E(I) = -W(N,I)
   20 CONTINUE
      IF (N.EQ.1) GO TO 500
      DO 320 II = 2, N
         I = N - II + 2
         L = I - 1
         FR = D(I-1)
         FI = E(I-1)
         IF (ABS(FR)+ABS(FI).NE.0.0E0) GO TO 40
         R = 0.0E0
         CO = 1.0E0
         C(I) = 1.0E0
         SI = 0.0E0
         S(I) = 0.0E0
         GO TO 100
   40    IF (ABS(FR).LT.ABS(FI)) GO TO 60
         R = ABS(FR)*SQRT(1.0E0+(FI/FR)**2)
         GO TO 80
   60    R = ABS(FI)*SQRT(1.0E0+(FR/FI)**2)
   80    SI = FI/R
         S(I) = -SI
         CO = FR/R
         C(I) = CO
  100    IF (L.EQ.1) GO TO 240
C        FIND THE ELEMENTS OF LARGEST ABSOLUTE VALUE IN D AND E
         KD = IDAMAX(L,D,1)
         KE = IDAMAX(L,E,1)
         SCALE = MAX(ABS(D(KD)),ABS(E(KE)))
C        IF (D,E) IS A NULL VECTOR THEN SKIP THE TRANSFORMATION
         IF (SCALE.EQ.0.0E0) GO TO 240
         CALL DSCAL(L,1.0E0/SCALE,D,1)
         CALL DSCAL(L,1.0E0/SCALE,E,1)
         H = DDOT(L,D,1,D,1) + DDOT(L,E,1,E,1)
         G = -SQRT(H)
         E(I) = G*SCALE
C        E(I) HAS ITS FINAL REAL VALUE
         R = R/SCALE
         H = H - R*G
C        S*S + SR
         D(I-1) = (R-G)*CO
         E(I-1) = (R-G)*SI
         DO 120 J = 1, L
            Z(J,I) = D(J)
            W(J,I) = E(J)
  120    CONTINUE
         CALL F01BCZ(Z,IZ,W,IW,L,D,E,C,S)
C        FORM P
         DO 140 J = 1, L
            C(J) = C(J)/H
            S(J) = S(J)/H
  140    CONTINUE
         FR = 0.0D0
         DO 160 J = 1, L
            FR = FR + C(J)*D(J) + S(J)*E(J)
  160    CONTINUE
C        FORM K
         HH = FR/(H+H)
C        FORM Q
         DO 180 J = 1, L
            C(J) = C(J) - HH*D(J)
            S(J) = S(J) - HH*E(J)
  180    CONTINUE
C        NOW FORM REDUCED A
         DO 220 J = 1, L
            FR = D(J)
            FI = E(J)
            GR = C(J)
            GI = S(J)
            DO 200 K = J, L
               Z(K,J) = (((Z(K,J)-GR*D(K))-GI*E(K))-FR*C(K)) - FI*S(K)
               W(K,J) = (((W(K,J)-GR*E(K))+GI*D(K))-FR*S(K)) + FI*C(K)
  200       CONTINUE
            D(J) = Z(L,J)
            Z(I,J) = 0.0E0
            E(J) = -W(L,J)
            W(I,J) = 0.0E0
            W(J,J) = 0.0E0
  220    CONTINUE
         GO TO 300
  240    E(I) = R
         H = 0.0E0
         DO 260 J = 1, L
            Z(J,I) = D(J)
            W(J,I) = E(J)
  260    CONTINUE
         DO 280 J = 1, L
            Z(I,J) = 0.0E0
            D(J) = Z(I-1,J)
            W(I,J) = 0.0E0
            E(J) = -W(I-1,J)
  280    CONTINUE
  300    D(I) = H
  320 CONTINUE
C     WE NOW FORM THE PRODUCT OF THE
C     HOUSEHOLDER MATRICES, OVERWRITING
C     ON Z AND W
      DO 460 I = 2, N
         L = I - 1
         Z(N,L) = Z(L,L)
         Z(L,L) = 1.0E0
         W(N,L) = E(L)
         W(L,L) = 0.0E0
         H = D(I)
         IF (H.EQ.0.0E0) GO TO 420
         DO 340 K = 1, L
            D(K) = 0.0E0
            E(K) = 0.0E0
  340    CONTINUE
         CALL F01BCY(Z,IZ,W,IW,L,L,Z(1,I),W(1,I),D,E)
         DO 360 K = 1, L
            D(K) = D(K)/H
            E(K) = -E(K)/H
  360    CONTINUE
         DO 400 J = 1, L
            DO 380 K = 1, L
               Z(K,J) = Z(K,J) - Z(K,I)*D(J) + W(K,I)*E(J)
               W(K,J) = W(K,J) - Z(K,I)*E(J) - W(K,I)*D(J)
  380       CONTINUE
  400    CONTINUE
  420    DO 440 J = 1, L
            Z(J,I) = 0.0E0
            W(J,I) = 0.0E0
  440    CONTINUE
  460 CONTINUE
      W(N,N) = E(N)
      DO 480 I = 1, N
         D(I) = Z(N,I)
         Z(N,I) = 0.0E0
         E(I) = W(N,I)
         W(N,I) = 0.0E0
  480 CONTINUE
  500 Z(N,N) = 1.0E0
      W(N,N) = 0.0E0
      E(1) = 0.0E0
C     NOW WE MULTIPLY BY THE
C     COSTHETA + I SINTHETA COLUMN
C     FACTORS
      CO = 1.0E0
      SI = 0.0E0
      IF (N.EQ.1) RETURN
      DO 540 I = 2, N
         F = CO*C(I) - SI*S(I)
         SI = CO*S(I) + SI*C(I)
         CO = F
         DO 520 J = 1, N
            F = Z(J,I)*CO - W(J,I)*SI
            W(J,I) = Z(J,I)*SI + W(J,I)*CO
            Z(J,I) = F
  520    CONTINUE
  540 CONTINUE
      RETURN
      END
C
      SUBROUTINE F01BCY(AR,IAR,AI,IAI,M,N,BR,BI,CR,CI)
C
C     COMPUTES  C = C +  (A**H)*B  (COMPLEX) WHERE
C     A IS RECTANGULAR M BY N.
C     C MUST BE DISTINCT FROM B.
C
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, M, N
C     .. Array Arguments ..
      DIMENSION AI(IAI,N), AR(IAR,N), BI(M), BR(M), CI(N), CR(N)
C     .. Local Scalars ..
      REAL XI, XR
      INTEGER           I, J
C     .. Executable Statements ..
      DO 40 I = 1, N
         XR = CR(I)
         XI = CI(I)
         DO 20 J = 1, M
            XR = XR + AR(J,I)*BR(J) + AI(J,I)*BI(J)
            XI = XI + AR(J,I)*BI(J) - AI(J,I)*BR(J)
   20    CONTINUE
         CR(I) = XR
         CI(I) = XI
   40 CONTINUE
      RETURN
      END
C
      SUBROUTINE F01BCZ(AR,IAR,AI,IAI,N,BR,BI,CR,CI)
C
C     COMPUTES  C = A*B  (COMPLEX) WHERE
C     A IS A HERMITIAN N-BY-N MATRIX,
C     WHOSE LOWER TRIANGLE IS STORED IN A.
C     C MUST BE DISTINCT FROM B.
C
C
C     .. Scalar Arguments ..
      INTEGER           IAI, IAR, N
C     .. Array Arguments ..
      DIMENSION AI(IAI,N), AR(IAR,N), BI(N), BR(N), CI(N), CR(N)
C     .. Local Scalars ..
      REAL              YI, YR
      INTEGER           I, IP1, J, NM1
C     .. Executable Statements ..
      DO 20 I = 1, N
         CR(I) = 0.0E0
         CI(I) = 0.0E0
   20 CONTINUE
      IF (N.EQ.1) GO TO 100
      NM1 = N - 1
      DO 80 I = 1, NM1
         DO 40 J = I, N
            CR(J) = CR(J) + AR(J,I)*BR(I) - AI(J,I)*BI(I)
            CI(J) = CI(J) + AR(J,I)*BI(I) + AI(J,I)*BR(I)
   40    CONTINUE
         YR = CR(I)
         YI = CI(I)
         IP1 = I + 1
         DO 60 J = IP1, N
            YR = YR + AR(J,I)*BR(J) + AI(J,I)*BI(J)
            YI = YI + AR(J,I)*BI(J) - AI(J,I)*BR(J)
   60    CONTINUE
         CR(I) = YR
         CI(I) = YI
   80 CONTINUE
  100 CR(N) = CR(N) + AR(N,N)*BR(N) - AI(N,N)*BI(N)
      CI(N) = CI(N) + AR(N,N)*BI(N) + AI(N,N)*BR(N)
      RETURN
      END
C
      SUBROUTINE F06QXF( SIDE, PIVOT, DIRECT, M, N, K1, K2, C, S, A,
     $                   LDA )
C
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, M, N
      CHARACTER*1        DIRECT, PIVOT, SIDE
C     .. Array Arguments ..
      DIMENSION A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QXF  performs the transformation
C
C     A := P*A,   when   SIDE = 'L' or 'l'  (  Left-hand side )
C
C     A := A*P',  when   SIDE = 'R' or 'r'  ( Right-hand side )
C
C  where A is an m by n matrix and P is an orthogonal matrix, consisting
C  of a  sequence  of  plane  rotations,  applied  in  planes  k1 to k2,
C  determined by the parameters PIVOT and DIRECT as follows:
C
C     When  PIVOT  = 'V' or 'v'  ( Variable pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C        where  P( k )  is a plane rotation matrix for the  ( k, k + 1 )
C        plane.
C
C     When  PIVOT  = 'V' or 'v'  ( Variable pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a plane rotation matrix for the  ( k, k + 1 )
C        plane.
C
C     When  PIVOT  = 'T' or 't'  ( Top pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*P( k2 - 2 )*...*P( k1 ),
C
C        where  P( k )  is a plane rotation matrix for the ( k1, k + 1 )
C        plane.
C
C     When  PIVOT  = 'T' or 't'  ( Top pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a plane rotation matrix for the ( k1, k + 1 )
C        plane.
C
C     When  PIVOT  = 'B' or 'b'  ( Bottom pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*P( k2 - 2 )*...*P( k1 ),
C
C        where  P( k )  is a  plane rotation  matrix  for the  ( k, k2 )
C        plane.
C
C     When  PIVOT  = 'B' or 'b'  ( Bottom pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a  plane rotation  matrix  for the  ( k, k2 )
C        plane.
C
C  c( k ) and s( k )  must contain the  cosine and sine  that define the
C  matrix  P( k ).  The  two by two  plane rotation  part of the  matrix
C  P( k ), R( k ), is assumed to be of the form
C
C     R( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  If m, n or k1 are less than unity,  or k2 is not greater than k1,  or
C  SIDE = 'L' or 'l'  and  k2  is greater than  m, or  SIDE = 'R' or 'r'
C  and  k2  is greater than  n,  then an  immediate return  is effected.
C
C     .. Parameters ..
      REAL ONE, ZERO
      PARAMETER          ( ONE = 1.0E+0, ZERO = 0.0E+0 )
C     .. Local Scalars ..
      REAL AIJ, CTEMP, STEMP, TEMP
      INTEGER            I, J
      LOGICAL            LEFT, RIGHT
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      LEFT = ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' )
      RIGHT = ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' )
      IF( ( MIN( M, N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $    ( ( LEFT ).AND.( K2.GT.M ) ).OR.
     $    ( ( RIGHT ).AND.( K2.GT.N ) ) )RETURN
      IF( LEFT )THEN
         IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 20 J = 1, N
                  AIJ = A( K1, J )
                  DO 10 I = K1, K2 - 1
                     TEMP = A( I + 1, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     AIJ = C( I )*TEMP - S( I )*AIJ
   10             CONTINUE
                  A( K2, J ) = AIJ
   20          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 40 J = 1, N
                  AIJ = A( K2, J )
                  DO 30 I = K2 - 1, K1, -1
                     TEMP = A( I, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     AIJ = S( I )*AIJ + C( I )*TEMP
   30             CONTINUE
                  A( K1, J ) = AIJ
   40          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'T' ).OR.( PIVOT.EQ.'t' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 60 J = 1, N
                  TEMP = A( K1, J )
                  DO 50 I = K1, K2 - 1
                     AIJ = A( I + 1, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     TEMP = S( I )*AIJ + C( I )*TEMP
   50             CONTINUE
                  A( K1, J ) = TEMP
   60          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 80 J = 1, N
                  TEMP = A( K1, J )
                  DO 70 I = K2 - 1, K1, -1
                     AIJ = A( I + 1, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     TEMP = S( I )*AIJ + C( I )*TEMP
   70             CONTINUE
                  A( K1, J ) = TEMP
   80          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'B' ).OR.( PIVOT.EQ.'b' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 100 J = 1, N
                  TEMP = A( K2, J )
                  DO 90 I = K1, K2 - 1
                     AIJ = A( I, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     TEMP = C( I )*TEMP - S( I )*AIJ
   90             CONTINUE
                  A( K2, J ) = TEMP
  100          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 120 J = 1, N
                  TEMP = A( K2, J )
                  DO 110 I = K2 - 1, K1, -1
                     AIJ = A( I, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     TEMP = C( I )*TEMP - S( I )*AIJ
  110             CONTINUE
                  A( K2, J ) = TEMP
  120          CONTINUE
            END IF
         END IF
      ELSE IF( RIGHT )THEN
         IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 140 J = K1, K2 - 1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 130 I = 1, M
                        TEMP = A( I, J + 1 )
                        A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  130                CONTINUE
                  END IF
  140          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 160 J = K2 - 1, K1, -1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 150 I = M, 1, -1
                        TEMP = A( I, J + 1 )
                        A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  150                CONTINUE
                  END IF
  160          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'T' ).OR.( PIVOT.EQ.'t' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 180 J = K1 + 1, K2
                  CTEMP = C( J - 1 )
                  STEMP = S( J - 1 )
                  IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
                     DO 170 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, K1 )
                        A( I, K1 ) = STEMP*TEMP + CTEMP*A( I, K1 )
  170                CONTINUE
                  END IF
  180          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 200 J = K2, K1 + 1, -1
                  CTEMP = C( J - 1 )
                  STEMP = S( J - 1 )
                  IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
                     DO 190 I = M, 1, -1
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, K1 )
                        A( I, K1 ) = STEMP*TEMP + CTEMP*A( I, K1 )
  190                CONTINUE
                  END IF
  200          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'B' ).OR.( PIVOT.EQ.'b' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 220 J = K1, K2 - 1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 210 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, K2 ) + CTEMP*TEMP
                        A( I, K2 ) = CTEMP*A( I, K2 ) - STEMP*TEMP
  210                CONTINUE
                  END IF
  220          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 240 J = K2 - 1, K1, -1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 230 I = M, 1, -1
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, K2 ) + CTEMP*TEMP
                        A( I, K2 ) = CTEMP*A( I, K2 ) - STEMP*TEMP
  230                CONTINUE
                  END IF
  240          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
      END
C
      SUBROUTINE P01ABZ
C
C     Terminates execution when a hard failure occurs.
C
C     ******************** IMPLEMENTATION NOTE ********************
C     The following STOP statement may be replaced by a call to an
C     implementation-dependent routine to display a message and/or
C     to abort the program.
C     *************************************************************
C     .. Executable Statements ..
      STOP
      END
C
      SUBROUTINE X04AAF(I,NERR)
C
C     IF I = 0, SETS NERR TO CURRENT ERROR MESSAGE UNIT NUMBER
C     (STORED IN NERR1).
C     IF I = 1, CHANGES CURRENT ERROR MESSAGE UNIT NUMBER TO
C     VALUE SPECIFIED BY NERR.
C
C     .. Scalar Arguments ..
      INTEGER           I, NERR
C     .. Local Scalars ..
      INTEGER           NERR1
C     .. Save statement ..
      SAVE              NERR1
C     .. Data statements ..
      DATA              NERR1/6/
C     .. Executable Statements ..
      IF (I.EQ.0) NERR = NERR1
      IF (I.EQ.1) NERR1 = NERR
      RETURN
      END
C
      SUBROUTINE X04BAF(NOUT,REC)
C
C     X04BAF writes the contents of REC to the unit defined by NOUT.
C
C     Trailing blanks are not output, except that if REC is entirely
C     blank, a single blank character is output.
C     If NOUT.lt.0, i.e. if NOUT is not a valid Fortran unit identifier,
C     then no output occurs.
C
C     .. Scalar Arguments ..
      INTEGER           NOUT
      CHARACTER*(*)     REC
C     .. Local Scalars ..
      INTEGER           I
C     .. Intrinsic Functions ..
      INTRINSIC         LEN
C     .. Executable Statements ..
      IF (NOUT.GE.0) THEN
C        Remove trailing blanks
         DO 20 I = LEN(REC), 2, -1
            IF (REC(I:I).NE.' ') GO TO 40
   20    CONTINUE
C        Write record to external file
   40    WRITE (NOUT,FMT=99999) REC(1:I)
      END IF
      RETURN
C
99999 FORMAT (A)
      END
C
      FUNCTION F06EAF( N, X, INCX, Y, INCY )
C
C     .. Entry Points ..
      REAL                      DDOT
      ENTRY                     DDOT  ( N, X, INCX, Y, INCY )
C     .. Scalar Arguments ..
      INTEGER                           INCX, INCY, N
C     .. Array Arguments ..
      DIMENSION                         X( * ), Y( * )
C     ..
C
C  F06EAF returns the value
C
C     F06EAF = x'y
C
C     .. Parameters ..
      REAL                  ZERO
      PARAMETER           ( ZERO = 0.0E+0 )
C     .. Local Scalars ..
      REAL                  SUM
      INTEGER               I, IX, IY
C     ..
C     .. Executable Statements ..
      SUM = ZERO
      IF( N.GT.0 )THEN
         IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               SUM = SUM + X( IX )*Y( IX )
   10       CONTINUE
         ELSE
            IF( INCY.GE.0 )THEN
               IY = 1
            ELSE
               IY = 1 - ( N - 1 )*INCY
            END IF
            IF( INCX.GT.0 )THEN
               DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
                  SUM = SUM + X( IX )*Y( IY )
                  IY  = IY  + INCY
   20          CONTINUE
            ELSE
               IX = 1 - ( N - 1 )*INCX
               DO 30, I = 1, N
                  SUM = SUM + X( IX )*Y( IY )
                  IX  = IX  + INCX
                  IY  = IY  + INCY
   30          CONTINUE
            END IF
         END IF
      END IF
C
      F06EAF = SUM
      RETURN
      END
C
      INTEGER FUNCTION IDAMAX( N, X, INCX )
C     .. Scalar Arguments ..
      INTEGER                  INCX, N
C     .. Array Arguments ..
      DIMENSION                X( * )
C     ..
C
C  F06JLF returns the smallest value of i such that
C
C     abs( x( i ) ) = max( abs( x( j ) ) )
C                      j
C
C     .. Local Scalars ..
      REAL                     XMAX
      INTEGER                  I, IMAX, IX
C     .. Intrinsic Functions ..
      INTRINSIC                ABS
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IMAX = 1
         IF( N.GT.1 )THEN
            XMAX = ABS( X( 1 ) )
            IX   = 1
            DO 10, I = 2, N
               IX = IX + INCX
               IF( XMAX.LT.ABS( X( IX ) ) )THEN
                  XMAX = ABS( X( IX ) )
                  IMAX = I
               END IF
   10       CONTINUE
         END IF
      ELSE
         IMAX = 0
      END IF
C
      IDAMAX = IMAX
      RETURN
      END
C
      INTEGER FUNCTION P01ABF(IFAIL,IERROR,SRNAME,NREC,REC)
C
C     P01ABF either returns the value of IERROR through the routine
C     name (soft failure), or terminates execution of the program
C     (hard failure). Diagnostic messages may be output.
C
C     If IERROR = 0 (successful exit from the calling routine),
C     the value 0 is returned through the routine name, and no
C     message is output
C
C     If IERROR is non-zero (abnormal exit from the calling routine),
C     the action taken depends on the value of IFAIL.
C
C     IFAIL =  1: soft failure, silent exit (i.e. no messages are
C                 output)
C     IFAIL = -1: soft failure, noisy exit (i.e. messages are output)
C     IFAIL =-13: soft failure, noisy exit but standard messages from
C                 P01ABF are suppressed
C     IFAIL =  0: hard failure, noisy exit
C
C     P01ABF also allows an alternative specification of IFAIL in which
C     it is regarded as a decimal integer with least significant digits
C     cba. Then
C
C     a = 0: hard failure  a = 1: soft failure
C     b = 0: silent exit   b = 1: noisy exit
C
C     except that hard failure now always implies a noisy exit.
C
C     .. Scalar Arguments ..
      INTEGER                 IERROR, IFAIL, NREC
      CHARACTER*(*)           SRNAME
C     .. Array Arguments ..
      CHARACTER*(*)           REC(*)
C     .. Local Scalars ..
      INTEGER                 I, NERR
      CHARACTER*72            MESS
C     .. External Subroutines ..
      EXTERNAL                P01ABZ, X04AAF, X04BAF
C     .. Intrinsic Functions ..
      INTRINSIC               ABS, MOD
C     .. Executable Statements ..
      IF (IERROR.NE.0) THEN
C        Abnormal exit from calling routine
         IF (IFAIL.EQ.-1 .OR. IFAIL.EQ.0 .OR. IFAIL.EQ.-13 .OR.
     *       (IFAIL.GT.0 .AND. MOD(IFAIL/10,10).NE.0)) THEN
C           Noisy exit
            CALL X04AAF(0,NERR)
            DO 20 I = 1, NREC
               CALL X04BAF(NERR,REC(I))
   20       CONTINUE
            IF (IFAIL.NE.-13) THEN
               WRITE (MESS,FMT=99999) SRNAME, IERROR
               CALL X04BAF(NERR,MESS)
               IF (ABS(MOD(IFAIL,10)).NE.1) THEN
C                 Hard failure
                  CALL X04BAF(NERR,
     *                     ' ** NAG hard failure - execution terminated'
     *                        )
                  CALL P01ABZ
               ELSE
C                 Soft failure
                  CALL X04BAF(NERR,
     *                        ' ** NAG soft failure - control returned')
               END IF
            END IF
         END IF
      END IF
      P01ABF = IERROR
      RETURN
C
99999 FORMAT (' ** ABNORMAL EXIT from Library routine ',A,': IFAIL',
     *  ' =',I6)
      END
C
      FUNCTION X02AJE()
C
C     RETURNS  (1/2)*B**(1-P)  IF ROUNDS IS .TRUE.
C     RETURNS  B**(1-P)  OTHERWISE
C
C     .. Constants ..
      DOUBLE PRECISION Z
      DATA Z/1.1102230246251568D-16/
C
C     Z has been derived from (2**(-53))+2**(-105)
C
C     .. Executable Statements ..
      X02AJE = Z   
      RETURN
      END
C
      SUBROUTINE F02AYE(N,EPS,D,E,Z,IZ,W,IW,IFAIL)
C
C     CXTQL2
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS OF A
C     HERMITIAN MATRIX, WHICH HAS BEEN REDUCED TO A REAL
C     TRIDIAGONAL MATRIX, T, GIVEN WITH ITS DIAGONAL ELEMENTS IN
C     THE ARRAY D(N) AND ITS SUB-DIAGONAL ELEMENTS IN THE LAST N
C     - 1 STORES OF THE ARRAY E(N), USING QL TRANSFORMATIONS. THE
C     EIGENVALUES ARE OVERWRITTEN ON THE DIAGONAL ELEMENTS IN THE
C     ARRAY D IN ASCENDING ORDER. THE REAL AND IMAGINARY PARTS OF
C     THE EIGENVECTORS ARE FORMED IN THE ARRAYS Z,W(N,N)
C     RESPECTIVELY, OVERWRITING THE ACCUMULATED TRANSFORMATIONS AS
C     SUPPLIED BY THE SUBROUTINE F01BCE. THE SUBROUTINE WILL FAIL
C     IF ALL EIGENVALUES TAKE MORE THAN 30*N ITERATIONS
C
C     .. Parameters ..
      INTEGER           VLEN
      PARAMETER         (VLEN=128)
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02AYE')
C     .. Scalar Arguments ..
      REAL              EPS
      INTEGER           IFAIL, IW, IZ, N
C     .. Array Arguments ..
      DIMENSION         D(N), E(N), W(IW,N), Z(IZ,N)
C     .. Local Scalars ..
      REAL              B, C, F, G, H, P, R, S
      INTEGER           I, I1, IPOS, ISAVE, ISEG, J, K, L, M
C     .. Local Arrays ..
      DIMENSION         CC(VLEN), SS(VLEN)
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          F06QXF
C     .. Intrinsic Functions ..
      INTRINSIC         ABS, MAX, SQRT
C     .. Executable Statements ..
      ISAVE = IFAIL
      IF (N.EQ.1) GO TO 40
      DO 20 I = 2, N
         E(I-1) = E(I)
   20 CONTINUE
   40 E(N) = 0.0E0
      B = 0.0E0
      F = 0.0E0
      J = 30*N
      DO 300 L = 1, N
         H = EPS*(ABS(D(L))+ABS(E(L)))
         IF (B.LT.H) B = H
C        LOOK FOR SMALL SUB-DIAG ELEMENT
         DO 60 M = L, N
            IF (ABS(E(M)).LE.B) GO TO 80
   60    CONTINUE
   80    IF (M.EQ.L) GO TO 280
  100    IF (J.LE.0) GO TO 400
         J = J - 1
C        FORM SHIFT
         G = D(L)
         H = D(L+1) - G
         IF (ABS(H).GE.ABS(E(L))) GO TO 120
         P = H*0.5E0/E(L)
         R = SQRT(P*P+1.0E0)
         H = P + R
         IF (P.LT.0.0E0) H = P - R
         D(L) = E(L)/H
         GO TO 140
  120    P = 2.0E0*E(L)/H
         R = SQRT(P*P+1.0E0)
         D(L) = E(L)*P/(1.0E0+R)
  140    H = G - D(L)
         I1 = L + 1
         IF (I1.GT.N) GO TO 180
         DO 160 I = I1, N
            D(I) = D(I) - H
  160    CONTINUE
  180    F = F + H
C        QL TRANSFORMATION
         P = D(M)
         C = 1.0E0
         S = 0.0E0
         DO 260 K = M - 1, L, -VLEN
            ISEG = MAX(K-VLEN+1,L)
            DO 240 I = K, ISEG, -1
               G = C*E(I)
               H = C*P
               IF (ABS(P).LT.ABS(E(I))) GO TO 200
               C = E(I)/P
               R = SQRT(C*C+1.0E0)
               E(I+1) = S*P*R
               S = C/R
               C = 1.0E0/R
               GO TO 220
  200          C = P/E(I)
               R = SQRT(C*C+1.0E0)
               E(I+1) = S*E(I)*R
               S = 1.0E0/R
               C = C/R
  220          P = C*D(I) - S*G
               D(I+1) = H + S*(C*G+S*D(I))
C           STORE ROTATIONS
               CC(VLEN-K+I) = C
               SS(VLEN-K+I) = -S
  240       CONTINUE
C        UPDATE VECTORS
            IPOS = VLEN - K + ISEG
            CALL F06QXF('Right','Variable','Backward',N,K-ISEG+2,1,
     *                  K-ISEG+2,CC(IPOS),SS(IPOS),Z(1,ISEG),IZ)
            CALL F06QXF('Right','Variable','Backward',N,K-ISEG+2,1,
     *                  K-ISEG+2,CC(IPOS),SS(IPOS),W(1,ISEG),IW)
  260    CONTINUE
         E(L) = S*P
         D(L) = C*P
         IF (ABS(E(L)).GT.B) GO TO 100
  280    D(L) = D(L) + F
  300 CONTINUE
C     ORDER EIGENVALUES AND EIGENVECTORS
      DO 380 I = 1, N
         K = I
         P = D(I)
         I1 = I + 1
         IF (I1.GT.N) GO TO 340
         DO 320 J = I1, N
            IF (D(J).GE.P) GO TO 320
            K = J
            P = D(J)
  320    CONTINUE
  340    IF (K.EQ.I) GO TO 380
         D(K) = D(I)
         D(I) = P
         DO 360 J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
            P = W(J,I)
            W(J,I) = W(J,K)
            W(J,K) = P
  360    CONTINUE
  380 CONTINUE
      IFAIL = 0
      RETURN
  400 IFAIL = P01ABF(ISAVE,1,SRNAME,0,P01REC)
      RETURN
      END
C
      SUBROUTINE DSCAL( N, ALPHA, X, INCX )
C     .. Scalar Arguments ..
      REAL               ALPHA
      INTEGER            INCX, N
C     .. Array Arguments ..
      DIMENSION          X( * )
C     ..
C
C  F06EDF performs the operation
C
C     x := alpha*x
C
C     .. Parameters ..
      REAL               ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
C     .. Local Scalars ..
      INTEGER            IX
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ALPHA.EQ.ZERO )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ZERO
   10       CONTINUE
         ELSE IF( ALPHA.EQ.( -ONE ) )THEN
            DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = -X( IX )
   20       CONTINUE
         ELSE IF( ALPHA.NE.ONE )THEN
            DO 30, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ALPHA*X( IX )
   30       CONTINUE
         END IF
      END IF
C
      RETURN
      END

      SUBROUTINE TESTA(U,F,NX,NY,NZ,ITER,NW1)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NX,NY,NZ), F(NX,NY,NZ)
C
        H=1./(NX-1)
        CALL INIT(U,F,NX,NY,NZ)
        RES1=RES(U,F,NX,NY,NZ,H)
C----------------> TIMER IN SECONDS
c--        CALL TIMER(SEC1)
        DO 2 NREL=1,ITER
          CALL RELAXA(U,F,NX,NY,NZ,H)
2       CONTINUE
c--        CALL TIMER(SEC2)
C----------------> TIMER IN SECONDS (IN SEC2)
        RES2=RES(U,F,NX,NY,NZ,H)
        CONVR=(RES2/RES1)**(0.1)
        WRITE(NW1,91100)
        WRITE(NW1,9100)NX,NY,NZ,NX*NY*NZ, ITER, CONVR
C
        NOP = (NX-2)*(NY-2)*(NZ-2)*8
C
c--        RMFLOP = (NOP/1000000.)/(SEC2-SEC1)*ITER
c--        WRITE(NW1,900) (SEC2-SEC1)/ITER,NOP, RMFLOP
        WRITE(NW1,91100)
91100 FORMAT(' +++++++++   STANDARD IMPLEMENTATION  ++++++++++++++++ '/
     *     )
 9100 FORMAT (/' NUMBER OF POINTS PER DIRECTION = ', 3I12 /
     *        ' GRIDSIZE OF CUBIC  GRID =        ', I12/
     *        ' AVERAGE CONV. RATE (', I6, 'ITER.)  = ', D12.4/)
900    FORMAT(/' TIME FOR 1 RELAX (SEC.):', E15.8/
     *           ' NUMBER OF OPERATIONS:   ',I15/
     *           ' PERFORMANCE IN MFLOP/S: ',F15.5/)
      END

      FUNCTION BABBCD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION IOCCA1(NMOS), IOCCB1(NMOS), IOCCA2(NMOS), IOCCB2(NMOS)
***********************************************************************
*
* BABBCD EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
*       BY TWO BETA MOS. ONE MICROSTATE HAS BETA ELECTRONS IN
*       M.O.S PSI(I) AND PSI(J) FOR WHICH THE OTHER MICROSTATE HAS
*       ELECTRONS IN PSI(K) AND PSI(L)
*
***********************************************************************
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      IJ=0
      DO 10 I=1,NMOS
   10 IF(IOCCB1(I) .LT. IOCCB2(I)) GOTO 20
   20 DO 30 J=I+1,NMOS
         IF(IOCCB1(J) .LT. IOCCB2(J)) GOTO 40
   30 IJ=IJ+IOCCA2(J)+IOCCB2(J)
   40 IJ=IJ+IOCCA2(J)
      DO 50 K=1,NMOS
   50 IF(IOCCB1(K) .GT. IOCCB2(K)) GOTO 60
   60 DO 70 L=K+1,NMOS
         IF(IOCCB1(L) .GT. IOCCB2(L)) GOTO 80
   70 IJ=IJ+IOCCA1(L)+IOCCB1(L)
   80 IJ=IJ+IOCCA1(L)
      IF((IJ/2)*2.EQ.IJ) THEN
         ONE=1.D0
      ELSE
         ONE=-1.D0
      ENDIF
      BABBCD=(XY(I,K,J,L)-XY(I,L,J,K))*ONE
      RETURN
      END

      SUBROUTINE MESHG(FREEB,COORD,ICOORD,NELEXC,NELEXM,NELEYC,NELEYM,
     +     XLEN,YLEN,RELXC,RELXM,RELYM,RELYC,RO,ROGAS,SIGMA,ALFA,
     +     RADCRY,RADCRU)
      INTEGER ICOORD,NELEXC,NELEXM,NELEYC,NELEYM
      DOUBLE PRECISION FREEB(*),COORD(ICOORD,*),XLEN,YLEN,
     +     RELXC,RELXM,RELYM,RELYC,RO,ROGAS,SIGMA,ALFA,RADCRY,RADCRU

      INTEGER NNODX
      INTEGER NPOINT,NXMAX,KK,NY,J
      PARAMETER(NXMAX=100)
      DOUBLE PRECISION XCOORD(NXMAX),YCOORD(NXMAX),YTOP(NXMAX),
     +     YBOT(NXMAX),YBOUND(NXMAX),YAPU(NXMAX),B(NXMAX),YMID(NXMAX)
      DOUBLE PRECISION RODIF,G,BETA,DIMEN,YSTEP,Y,X,YTPP,YSCL,SINIT,
     +     THETA,CX,CX0,A,XORIG,RR,X0

      PARAMETER(THETA=1.0D-6)

      DOUBLE PRECISION LIQINF,densit

************************************
      densit=2.49d3
************************************



      NNODX=NELEXC+NELEXM+1

      DO 10 I=1,NELEXC+1
        YBOUND(I)=FREEB(2*I-1)
        YBOT(I)=0.0D0
        YTOP(I)=YLEN
 10   CONTINUE


      SINIT=YBOUND(NELEXC+1)
      RODIF=densit-ROGAS
      G=9.82D0
      BETA=2.0D4*SIGMA/(RODIF*G)
      DIMEN=DSQRT(2.0D0/BETA)


         RR=RADCRY*DIMEN*1.0D2

         Y=1.0D-18
         X0=1.0D12
         YSTEP=0.1d0
         NY=0
         NPOINT=100

         J=1
         DO 220 I=1,NPOINT
            X=LIQINF(ALFA,RR,BETA,Y,NY)
            IF ((NY .EQ. 1) .OR. (X .GT. X0) .OR. (X .LT. RR)) GOTO 221
            XCOORD(J)=X/(DIMEN*1.0D2)
            YCOORD(J)=Y/(DIMEN*1.0D2)
            Y=Y+YSTEP
            J=J+1
            X0=X
 220     CONTINUE
 221     CONTINUE
         NPOINT=J-1

         IF (XCOORD(1) .LT. RADCRY+RADCRU) THEN
            print *,'Length of meniscus insufficient'
            STOP
         ENDIF

         YTPP=YCOORD(NPOINT)+(YCOORD(NPOINT)-YCOORD(NPOINT-1))/
     +        (XCOORD(NPOINT)-XCOORD(NPOINT-1))*(RADCRY-XCOORD(NPOINT))

         YSCL=SINIT-YTPP
         XCOORD(NPOINT+1)=RADCRY
         YCOORD(NPOINT+1)=SINIT

         DO 225 I=1,NPOINT
            YCOORD(I)=YCOORD(I)+YSCL
 225     CONTINUE

      CX=RADCRY
      DO 20 I=NELEXC+2,NNODX
         IF (ABS(RELXM-1.0D0) .LT. THETA) THEN	
            CX=CX+RADCRU/DBLE(NELEXM)
         ELSE IF (I .EQ. NELEXC+2) THEN
            A=RADCRU*(1.0D0-RELXM)/(1.0D0-RELXM**DBLE(NELEXM))	
            CX=CX+A
         ELSE
            CX=CX+RELXM*A
            A=RELXM*A	
         ENDIF		
         
         DO 25 J=NPOINT+1,2,-1
            
            IF ((XCOORD(J) .LT. CX) .AND. 
     +           (CX .LT. XCOORD(J-1))) THEN
               YBOUND(I)=(YCOORD(J-1)-YCOORD(J))/
     +              (XCOORD(J-1)-XCOORD(J))*(CX-XCOORD(J-1))+
     +              YCOORD(J-1)
               GOTO 26
            ENDIF
            
 25      CONTINUE
 26      CONTINUE
         YBOT(I)=0.0D0
         YTOP(I)=YLEN
 20   CONTINUE
      
      XORIG=0.0D0
      CX=0.0D0
      KK=1
      
      DO 140 I=1,2*NELEYM+1


         DO 150 J=1,NELEXC+1
            IF (MOD(I-1,2) .EQ. 0) THEN
               COORD(1,KK)=CX
               COORD(2,KK)=YBOT(J)
            ELSE
               COORD(1,KK)=CX
               COORD(2,KK)=(YBOT(J)+YAPU(J))/2.0D0
            ENDIF

            CX0=CX
            YAPU(J)=YBOT(J)

            IF (J .LT. NELEXC+1) THEN
               IF (ABS(RELXC-1.0D0) .LT. THETA) THEN	
                  CX=CX+RADCRY/DBLE(NELEXC)
               ELSE IF (J .EQ. 1) THEN
                  A=RADCRY*(1.0D0-RELXC)/(1.0D0-RELXC**DBLE(NELEXC))
                  CX=CX+A
               ELSE
                  CX=CX+RELXC*A
                  A=RELXC*A	
               ENDIF		
            ENDIF

            IF (MOD(I-1,2) .EQ. 0) THEN
               IF (J .LT. NELEXC+1) THEN
                  KK=KK+1
                  COORD(1,KK)=(CX+CX0)/2.0D0
                  COORD(2,KK)=(YBOT(J)+YBOT(J+1))/2.0D0
               ENDIF
            ENDIF
            KK=KK+1

 150     CONTINUE

         DO 155 J=NELEXC+2,NNODX
            CX0=CX


	    IF (ABS(RELXM-1.0D0) .LT. THETA) THEN	
               CX=CX+RADCRU/DBLE(NELEXM)

	    ELSE IF (J .EQ. NELEXC+2) THEN
	       A=RADCRU*(1.0D0-RELXM)/(1.0D0-RELXM**DBLE(NELEXM))	
	       CX=CX+A
	    ELSE
	       CX=CX+RELXM*A
	       A=RELXM*A	
	    ENDIF		

            IF (MOD(I-1,2) .EQ. 0) THEN
               COORD(1,KK)=(CX+CX0)/2.0D0
               COORD(2,KK)=(YBOT(J-1)+YBOT(J))/2.0D0
               KK=KK+1
            ENDIF

            IF (MOD(I-1,2) .EQ. 0) THEN
               COORD(1,KK)=CX
               COORD(2,KK)=YBOT(J)
            ELSE
               COORD(1,KK)=CX
               COORD(2,KK)=(YBOT(J)+YAPU(J))/2.0D0
            ENDIF

            KK=KK+1

            YAPU(J)=YBOT(J)
 155     CONTINUE


         CX=XORIG

         IF (MOD(I-1,2) .EQ. 0) THEN
            DO 160 K=1,NNODX
               IF (ABS(RELYM-1.0D0) .LT. THETA) THEN	
                  YBOT(K)=YBOT(K)+YBOUND(K)/DBLE(NELEYM)
               ELSE IF (I .EQ. 1) THEN
                  B(K)=YBOUND(K)*(1.0D0-RELYM)/
     +                 (1.0D0-RELYM**DBLE(NELEYM))	
                  YBOT(K)=YBOT(K)+B(K)
               ELSE
                  YBOT(K)=YBOT(K)+RELYM*B(K)
                  B(K)=RELYM*B(K)	
               ENDIF		

 160        CONTINUE   
         ENDIF
 140  CONTINUE


         DO 165 I=1,NELEXC+1
            YMID(I)=YBOUND(I)
 165     CONTINUE

      DO 170 I=1,2*NELEYC
 
         IF (MOD(I-1,2) .EQ. 0) THEN
            DO 180 K=1,NELEXC+1

               IF (ABS(RELYC-1.0D0) .LT. THETA) THEN	
                  YAPU(K)=YAPU(K)+(YTOP(K)-YBOUND(K))/DBLE(NELEYC)
               ELSE IF (I .EQ. 1) THEN
                  B(K)=(YTOP(K)-YBOUND(K))*(1.0D0-RELYC)/
     +                 (1.0D0-RELYC**DBLE(NELEYC))	
                  YAPU(K)=YAPU(K)+B(K)
               ELSE
                  YAPU(K)=YAPU(K)+RELYC*B(K)
                  B(K)=RELYC*B(K)	
               ENDIF		

 180        CONTINUE   
         ENDIF
         DO 190 J=1,NELEXC+1

            IF (MOD(I,2) .EQ. 0) THEN
               COORD(1,KK)=CX
               COORD(2,KK)=YAPU(J)
            ELSE
               COORD(1,KK)=CX
               COORD(2,KK)=(YAPU(J)+YMID(J))/2.0D0
            ENDIF

            KK=KK+1
            CX0=CX
            YMID(J)=YAPU(J)

            IF (ABS(RELXC-1.0D0) .LT. THETA) THEN	
               CX=CX+RADCRY/DBLE(NELEXC)
            ELSE IF (J .EQ. 1) THEN
               A=RADCRY*(1.0D0-RELXC)/(1.0D0-RELXC**DBLE(NELEXC))	
               CX=CX+A
            ELSE
               CX=CX+RELXC*A
               A=RELXC*A	
            ENDIF		
            IF ((MOD(I,2) .EQ. 0) .AND. (J .LT. NELEXC+1)) THEN
               COORD(1,KK)=(CX+CX0)/2.0D0
               COORD(2,KK)=(YAPU(J)+YAPU(J+1))/2.0D0
               KK=KK+1
            ENDIF

 190     CONTINUE
         CX=XORIG
 170  CONTINUE

      RETURN
      END

      FUNCTION DOTVEC(X,Y,N)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N),Y(N)
      SUM=0.
      DO 100 I=1,N
         SUM=SUM+X(I)*Y(I)
 100  CONTINUE
      DOTVEC=SUM
      END

      SUBROUTINE LOCAL(C,MDIM,NOCC,EIG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION C(MDIM,MDIM), EIG(MAXORB)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
C**********************************************************************
C
C   LOCALISATION SUBROUTINE
C ON INPUT
C        C = EIGENVECTORS IN AN MDIM*MDIM MATRIX
C        NOCC = NUMBER OF FILLED LEVELS
C        NORBS = NUMBER OF ORBITALS
C        NUMAT = NUMBER OF ATOMS
C        NLAST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
C        NFIRST   = INTEGER ARRAY OF ATOM ORBITAL COUNTERS
C
C       SUBROUTINE MAXIMIZES (PSI)**4
C       REFERENCE_
C       A NEW RAPID METHOD FOR ORBITAL LOCALISATION, P.G. PERKINS AND
C       J.J.P. STEWART, J.C.S. FARADAY (II) 77, 000, (1981).
C
C       MODIFIED AND CORRECTED TO AVOID SIGMA-PI ORBITAL MIXING BY
C       JUAN CARLOS PANIAGUA, UNIVERSITY OF BARCELONA, MAY 1983.
C
C**********************************************************************
      COMMON /SCRACH/ COLD(MAXORB,MAXORB),XDUMY(MAXPAR**2-MAXORB*MAXORB)
      DIMENSION EIG1(MAXORB),PSI1(MAXORB),PSI2(MAXORB),
     1          CII(MAXORB), REFEIG(MAXORB),IEL(20)
      CHARACTER*2 ELEMNT(99)
      DATA ELEMNT/'H','HE',
     1 'LI','BE','B','C','N','O','F','NE',
     2 'NA','MG','AL','SI','P','S','CL','AR',
     3 'K','CA','SC','TI','V','CR','MN','FE','CO','NI','CU',
     4 'ZN','GA','GE','AS','SE','BR','KR',
     5 'RB','SR','Y','ZR','NB','MO','TC','RU','RH','PD','AG',
     6 'CD','IN','SN','SB','TE','I','XE',
     7 'CS','BA','LA','CE','PR','ND','PM','SM','EU','GD','TB','DY',
     8 'HO','ER','TM','YB','LU','HF','TA','W','RE','OS','IR','PT',
     9 'AU','HG','TL','PB','BI','PO','AT','RN',
     1 'FR','RA','AC','TH','PA','U','NP','PU','AM','CM','BK','CF','XX'/
      NITER=100
      EPS=1.0D-7
      DO 10 I=1,NORBS
         REFEIG(I)=EIG(I)
         DO 10 J=1,NORBS
   10 COLD(I,J)=C(I,J)
      ITER=0
   20 CONTINUE
      SUM=0.D0
      ITER=ITER+1
      DO 80 I=1,NOCC
         DO 70 J=1,NOCC
            IF(J.EQ.I) GOTO 70
            XIJJJ=0.0D0
            XJIII=0.0D0
            XIIII=0.0D0
            XJJJJ=0.0D0
            XIJIJ=0.0D0
            XIIJJ=0.0D0
            DO 30 K=1,NORBS
               PSI1(K)=C(K,I)
   30       PSI2(K)=C(K,J)
C NOW FOLLOWS THE RATE-DETERMINING STEP FOR THE CALCULATION
            DO 50 K1=1,NUMAT
               KL=NFIRST(K1)
               KU=NLAST(K1)
               DIJ=0.D0
               DII=0.D0
               DJJ=0.D0
               DO 40 K=KL,KU
                  DIJ=DIJ+PSI1(K)*PSI2(K)
                  DII=DII+PSI1(K)*PSI1(K)
                  DJJ=DJJ+PSI2(K)*PSI2(K)
   40          CONTINUE
               XIJJJ=XIJJJ+DIJ*DJJ
               XJIII=XJIII+DIJ*DII
               XIIII=XIIII+DII*DII
               XJJJJ=XJJJJ+DJJ*DJJ
               XIJIJ=XIJIJ+DIJ*DIJ
               XIIJJ=XIIJJ+DII*DJJ
   50       CONTINUE
            AIJ=XIJIJ-(XIIII+XJJJJ-2.0D0*XIIJJ)/4.0D0
            BIJ=XJIII-XIJJJ
            CA=SQRT(AIJ*AIJ+BIJ*BIJ)
            SA=AIJ+CA
            IF(SA.LT.1.0D-14) GO TO 70
            SUM=SUM+SA
            CA=-AIJ/CA
            CA=(1.0D0+SQRT((1.0D0+CA)/2.0D0))/2.0D0
            IF((2.0D0*CA-1.0D0)*BIJ.LT.0.0D0)CA=1.0D0-CA
            SA=SQRT(1.0D0-CA)
            CA=SQRT(CA)
            DO 60 K=1,NORBS
               C(K,I)=CA*PSI1(K)+SA*PSI2(K)
   60       C(K,J)=-SA*PSI1(K)+CA*PSI2(K)
   70    CONTINUE
   80 CONTINUE
      SUM1=0.D0
      DO 100 I=1,NOCC
         DO 100 J=1,NUMAT
            IL=NFIRST(J)
            IU=NLAST(J)
            X=0.0
            DO 90 K=IL,IU
   90       X=X+C(K,I)**2
  100 SUM1=SUM1+X*X
      IF(SUM.GT.EPS.AND.ITER.LT.NITER) GO TO 20
      WRITE(6,110)ITER,SUM1
  110 FORMAT(/10X,'NUMBER OF ITERATIONS =',I4/
     110X,'LOCALISATION VALUE =',F14.9,/)
      WRITE(6,120)
  120 FORMAT(3X,'NUMBER OF CENTERS',14X,'(COMPOSITION OF ORBITALS)'//)
      DO 150 I=1,NOCC
         SUM=0.D0
         DO 140 J=1,NOCC
            CO=0.D0
            DO 130 K=1,NORBS
  130       CO=CO+COLD(K,J)*C(K,I)
  140    SUM=SUM+CO*CO*EIG(J)
  150 EIG1(I)=SUM
      DO 180 I=1,NOCC
         X=100.D0
         DO 160 J=I,NOCC
            IF (X.LT.EIG1(J))  GOTO  160
            X=EIG1(J)
            I1=J
  160    CONTINUE
         EIG(I)=EIG1(I1)
         X=EIG1(I1)
         EIG1(I1)=EIG1(I)
         EIG1(I)=X
         DO 170 J=1,NORBS
            X=C(J,I1)
            C(J,I1)=C(J,I)
  170    C(J,I)=X
  180 CONTINUE
      DO 250 I=1,NOCC
         X=0.D0
         DO 200 K1=1,NUMAT
            KL=NFIRST(K1)
            KU=NLAST(K1)
            DII=0.D0
            DO 190 K=KL,KU
  190       DII=DII+C(K,I)**2
            X=X+DII*DII
  200    PSI1(K1)=DII*100.D0
         X=1/X
         DO 220 II=1,NUMAT
            SUM=0.D0
            DO 210 J=1,NUMAT
               IF(PSI1(J).LT.SUM) GOTO 210
               SUM=PSI1(J)
               K=J
  210       CONTINUE
            PSI1(K)=0.D0
            CII(II)=SUM
            IEL(II)=K
            IF(SUM.LT.1.D0) GOTO 230
  220    CONTINUE
  230    CONTINUE
         II=II-1
         WRITE(6,240)X,(ELEMNT(NAT(IEL(K))),IEL(K),CII(K),K=1,II)
  240    FORMAT(F10.4,4(5(3X,A2,I3,F6.2),/10X))
  250 CONTINUE
  260 FORMAT(//20X,20H LOCALIZED ORBITALS   ,//)
      WRITE(6,260)
      CALL MATOUT(C,EIG,NOCC,NORBS,MDIM)
  270 FORMAT(10F12.6)
      DO 280 I=1,NOCC
         EIG(I)=REFEIG(I)
         DO 280 J=1,NORBS
  280 C(J,I)=COLD(J,I)
      RETURN
      END

      SUBROUTINE INPARS

      IMPLICIT CHARACTER ( A-Z )

      COMMON/ATOMS/NATM
      COMMON/STEPS/DT
      COMMON/CUTOFF/RCUT
      COMMON/LJPAR/SIGMA
      COMMON/TEMPER/EQTEMP
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/CONTRL/NSTEP,NEQUIL,ISAVE

C    *******************************************************************
C    ** SUBROUTINE TO READ IN L-J PARAMETERS, INITIALISE COUNTERS ETC **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL         DT, RCUT, SIGMA, EQTEMP
      REAL         SR6,VRCUT,DVRCUT,DVRC12
      REAL         SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER      HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ),MX,MY,MZ
      INTEGER      NATM
      INTEGER      NSTEP,NEQUIL,ISAVE

C**   CALCULATE DIMENSIONS OF PROCESSORS LINK-CELL STRUCTURE

      MX    = MIN(MMX,INT(1.0/RCUT)+2)
      MY    = MIN(MMY,INT(1.0/RCUT)+2)
      MZ    = MIN(MMZ,INT(1.0/RCUT)+2)

C**   CALCULATE SCALE FACTORS TO ENSURE EDGE CELLS ARE INCLUDED
C**   IN LINKED LIST

      SFX = (REAL(MX)-2.)/REAL(MX)
      SFY = (REAL(MY)-2.)/REAL(MY)
      SFZ = (REAL(MZ)-2.)/REAL(MZ)

C**   REAL VALUES OF NUMBER OF CELLS IN EACH COORDINATE DIRECTION

      CELLIX = REAL(MX)
      CELLIY = REAL(MY)
      CELLIZ = REAL(MZ)

C**   CALL SUBROUTINE TO CALCULATE NEIGHBOUR LIST OF NEIGHBOURING
C**   CELLS THAT WE WISH TO CONSIDER IN FORCE LOOP

      CALL MAPS

C**   CALCULATE VALUES FOR SHIFTED FORCE POTENTIAL

      SR6    = (SIGMA/RCUT)**6
      VRCUT  = SR6*(SR6-1.0)
      DVRCUT = -1.0*SR6*(SR6-0.5)/RCUT
      DVRC12 = 12.0*DVRCUT

      RETURN
      END

      SUBROUTINE FORSYM (NAT,NC,IB,F0,R,NDIM9,FORCE,FORCWK,
     *                   NIONS,NSPEC,NIONSP,FORCESYM)
C
C     APPLY POINT GROUP OPERATIONS TO THE FORCES CALCULATED BY
C     SUMMING OVER SPECIAL POINTS.
C     WRITTEN 12-MAY-82 BY OLE HOLM NIELSEN
C     INPUT: SEE SUBROUTINE ROSYM2.
C     FORCE ..... THE FORCES TO BE SYMMETRIZED. ON RETURN FORCE
C                 CONTAINS THE CORRECT FORCES
C
      INTEGER IB(48),F0(48,NDIM9),NIONSP(NSPEC)       
      REAL R(49,3,3),FORCE(3,NIONS*NSPEC),FORCWK(3,NIONS*NSPEC)
      REAL FORCESYM(3,NIONS,NSPEC)
C-----------------------------------------------------------------------
      ICOUNT = 0
      DO 90 L = 1 , NSPEC
        DO 90 M = 1 , NIONSP(L)
          ICOUNT = ICOUNT + 1
          DO 90 N = 1 , 3
            FORCE(N,ICOUNT) = FORCESYM(N,M,L)
90    CONTINUE
      IZERO = 0
C     KEEP FORCE IN WORKING ARRAY
      DO 100 KAPA = 1 , NAT
        DO 100 J = 1 , 3
          IF (ABS(FORCE(J,KAPA)) .LT. 1.0E-10) IZERO = IZERO + 1
C         DIVIDE BY THE NUMBER OF GROUP OPERATIONS
          FORCWK(J,KAPA) = FORCE(J,KAPA) / FLOAT(NC)
          FORCE(J,KAPA) = 0.0
100   CONTINUE
C
      IF (IZERO .GT. 0) THEN
        WRITE (6,110) IZERO
110     FORMAT(' SUBROUTINE FORSYM - WARNING - ',I3,' FORCES ARE ZERO')
      ENDIF
C
C     LOOP OVER ATOMS
      DO 190 KAPA = 1 , NAT
C     SUM OVER ROTATIONS
        DO 190 IROT = 1 , NC
C     NOTE THAT FROM K290, THE ARRAYS F0 AND V ARE ARRANGED
C     DIFFERENTLY FROM THE ROTATION MATRICES.
          KAPAP = F0(IROT,KAPA)
C     ROTATE THE FORCE VECTOR BY R**(-1)
          IC = IB(IROT)
          DO 190 I = 1 , 3
            DO 190 J = 1 , 3
              FORCE(I,KAPA) = FORCE(I,KAPA) + 
     &                        R(IC,J,I) * FORCWK(J,KAPAP)
190   CONTINUE
      ICOUNT = 0
      DO 91 L = 1 , NSPEC
        DO 91 M = 1 , NIONSP(L)
          ICOUNT = ICOUNT + 1
          DO 91 N = 1 , 3
            FORCESYM(N,M,L) = FORCE(N,ICOUNT)
91    CONTINUE
      RETURN
      END

      SUBROUTINE AM1
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      CHARACTER NUMBRS(0:9)*1, PARTYP(25)*5, FILES*64, DUMMY*50,
     1          KEYWRD*80, TEXT*50, TXTNEW*50, ELEMNT(107)*2
      COMMON /ATHEAT/ ATHEAT
     1       /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     2                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     3                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /ATOMIC/ EISOL(107),EHEAT(107)
      COMMON /KEYWRD/ KEYWRD
      DIMENSION  IJPARS(5,500), PARSIJ(500)
      DATA NUMBRS/' ','1','2','3','4','5','6','7','8','9'/
      DATA PARTYP/'USS  ','UPP  ','UDD  ','ZS   ','ZP   ','ZD   ',
     1    'BETAS','BETAP','BETAD','GSS  ','GSP  ','GPP  ','GP2  ',
     2    'HSP  ','AM1  ','EXPC ','GAUSS','ALP  ','GSD  ','GPD  ',
     3    'GDD  ','FN1  ','FN2  ','FN3  ','ORB  '/
      DATA (ELEMNT(I),I=1,107)/'H ','HE',
     1 'LI','BE','B ','C ','N ','O ','F ','NE',
     2 'NA','MG','AL','SI','P ','S ','CL','AR',
     3 'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI','CU',
     4 'ZN','GA','GE','AS','SE','BR','KR',
     5 'RB','SR','Y ','ZR','NB','MO','TC','RU','RH','PD','AG',
     6 'CD','IN','SN','SB','TE','I ','XE',
     7 'CS','BA','LA','CE','PR','ND','PM','SM','EU','GD','TB','DY',
     8 'HO','ER','TM','YB','LU','HF','TA','W ','RE','OS','IR','PT',
     9 'AU','HG','TL','PB','BI','PO','AT','RN',
     1 'FR','RA','AC','TH','PA','U ','NP','PU','AM','CM','BK','CF','XX',
     2 'FM','MD','CB','++','+','--','-','TV'/
      I=INDEX(KEYWRD,'EXTERNAL=')+9
      J=INDEX(KEYWRD(I:),' ')+I-1
      FILES=KEYWRD(I:J)
      WRITE(6,'(//5X,'' PARAMETER TYPE      ELEMENT    PARAMETER'')')
CDEP
      OPEN(14,STATUS='OLD',FILE=FILES)
      I=0
   10 READ(14,'(A40)',ERR=90,IOSTAT=IOS)TEXT
      IF(TEXT.EQ.' ')GOTO 90
      IF(INDEX(TEXT,'END').NE.0)GOTO 90
      ILOWA = ICHAR('a')
      ILOWZ = ICHAR('z')
      ICAPA = ICHAR('A')
************************************************************************
      DO 20 I=1,50
         ILINE=ICHAR(TEXT(I:I))
         IF(ILINE.GE.ILOWA.AND.ILINE.LE.ILOWZ) THEN
            TEXT(I:I)=CHAR(ILINE+ICAPA-ILOWA)
         ENDIF
   20 CONTINUE
************************************************************************
      IF(INDEX(TEXT,'END') .NE. 0) GOTO 90
      DO 30 J=1,25
         IF(J.GT.21) THEN
            IT=INDEX(TEXT,'FN')
            TXTNEW = TEXT(1:IT+2)
            IF(INDEX(TXTNEW,PARTYP(J)) .NE. 0) GOTO 40
         ENDIF
         IF(INDEX(TEXT,PARTYP(J)) .NE. 0) GOTO 40
   30 CONTINUE
      WRITE(6,'(''  FAULTY LINE:'',A)')TXTNEW
      WRITE(6,'(''  FAULTY LINE:'',A)')TEXT
      WRITE(6,'(''   NAME NOT FOUND'')')
      CALL WRAPUP()
   40 IPARAM=J
      IF(IPARAM.GT.21) THEN
         I=INDEX(TEXT,'FN')
         KFN=READA(TEXT,I+3)
      ELSE
         KFN=0
         I=INDEX(TEXT,PARTYP(J))
      ENDIF
      K=INDEX(TEXT(I:),' ')+1
      DUMMY=TEXT(K:)
      TEXT=DUMMY
      DO 50 J=1,107
   50 IF(INDEX(TEXT,' '//ELEMNT(J)) .NE. 0) GOTO 60
      WRITE(6,'('' ELEMENT NOT FOUND '')')
      WRITE(6,*)' FAULTY LINE: "'//TEXT//'"'
      CALL WRAPUP()
   60 IELMNT=J
      PARAM=READA(TEXT,INDEX(TEXT,ELEMNT(J)))
      DO 70 I=1,LPARS
         IF(IJPARS(1,I).EQ.KFN.AND.IJPARS(2,I).EQ.IELMNT.AND.
     1IJPARS(3,I).EQ.IPARAM) GOTO 80
   70 CONTINUE
      LPARS=LPARS+1
      I=LPARS
   80 IJPARS(1,I)=KFN
      IJPARS(2,I)=IELMNT
      IJPARS(3,I)=IPARAM
      PARSIJ(I)=PARAM
      GOTO 10
   90 CONTINUE
      CLOSE(14)
      DO 120 J=1,107
         DO 110 K=1,25
            DO 100 I=1,LPARS
               IPARAM=IJPARS(3,I)
               KFN=IJPARS(1,I)
               IELMNT=IJPARS(2,I)
               IF(IPARAM.NE.K) GOTO 100
               IF(IELMNT.NE.J) GOTO 100
               PARAM=PARSIJ(I)
               IF(KFN.NE.0)THEN
                  WRITE(6,'(10X,A6,11X,A2,F17.6)')
     1PARTYP(IPARAM)(:3)//NUMBRS(KFN)//'  ',
     2ELEMNT(IELMNT),PARAM
               ELSE
                  WRITE(6,'(10X,A6,11X,A2,F17.6)')
     1PARTYP(IPARAM)//NUMBRS(KFN),
     2ELEMNT(IELMNT),PARAM
               ENDIF
               CALL UPDATE(IPARAM,IELMNT,PARAM,1,KFN)
  100       CONTINUE
  110    CONTINUE
  120 CONTINUE
      CALL MOLDAT
      CALL CALPAR
      ATHEAT=0.D0
      ETH=0.D0
      DO 130 I=1,NUMAT
         NI=NAT(I)
         ATHEAT=ATHEAT+EHEAT(NI)
  130 ETH=ETH+EISOL(NI)
      ATHEAT=ATHEAT-ETH*23.061D0
      RETURN
      END

      SUBROUTINE ENPART(UHF,H,ALPHA,BETA,P,Q,COORD)
C----------------------------------------------------------*
C
C     NEW SUB. ENPART,  MODIFIED BY TSUNEO HIRANO 1986/6/3/
C
C---------------------------------------------------------*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      PARAMETER (NATMS2 = (NUMATM*(NUMATM+1))/2)
      DIMENSION H(*), ALPHA(*), BETA(*), P(*), Q(*), COORD(3,*)
C--- DEFINED HERE, AND TO BE USED FOR ENPART-PRINT ONLY ---*
      DIMENSION EX(NATMS2,3), EMAT(NUMATM,NUMATM)
C--- END OF DIMENSION DEFINITION ----------------- BY TH --*
      LOGICAL UHF, MINDO3, AM1
      CHARACTER*80 KEYWRD
      CHARACTER*2 ENAME(NUMATM),ELEMNT
C***********************************************************************
C
C *** ENERGY PARTITIONING WITHIN THE UMINDO/3 AND UMNDO SCHEME
C     ROUTINE WRITTEN BY S.OLIVELLA, BARCELONA NOV. 1979.
C     EXTENDED TO AM1 AND PM3 BY JJPS.
C
C   ON INPUT UHF     = .TRUE. IF A U.H.F. CALCULATION.
C            H       = ONE-ELECTRON MATRIX.
C            ALPHA   = ALPHA ELECTRON DENSITY.
C            BETA    = BETA ELECTRON DENSITY.
C            P       = TOTAL ELECTRON DENSITY.
C            Q       = ATOM ELECTRON DENSITIES.
C
C    NOTHING IS CHANGED ON EXIT.
C
C@***        ENAME   = ELEMENT NAME OF ATOM, I.E. C, CL, SI ETC.
C@
C***********************************************************************
      COMMON /ONELEC/ USS(107), UPP(107), UDD(107)
      COMMON /CORE  / CORE(107)
      COMMON /IDEAS / FN1(107,10),FN2(107,10),FN3(107,10)
      COMMON /ALPHA3/ ALP3(153)
      COMMON /TWOEL3/ F03(107)
      COMMON /ALPHA / ALP(107)
      COMMON /TWOELE/ GSS(107),GSP(107),GPP(107),GP2(107),HSP(107)
     1                ,GSD(107),GPD(107),GDD(107)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM)
     1               ,NLAST(NUMATM),NORBS,NELECS,
     2                NALPHA,NBETA,NCLOSE,NOPEN,NDUMY,FRACT
C@
      COMMON/ELEMTS/ELEMNT(107)
C@
      COMMON /WMATRX/ W(N2ELEC)
      COMMON /KEYWRD/ KEYWRD
      PARAMETER (MDUMY=MAXPAR*MAXPAR-NUMATM*3-NATMS2*4)
      COMMON /SCRACH/ EA(NUMATM,2),EAT(NUMATM), E(NATMS2,4),
     1XDUMY(MDUMY)
      MINDO3=(INDEX(KEYWRD,'MINDO').NE.0)
C@ --------------------------*
C@    ASSIGN ENAME(I)
      DO 10 I=1,NUMAT
         IA=NAT(I)
   10 ENAME(I)=ELEMNT(IA)
C@    CLEAR EMAT(I,I)
      DO 20 I=1,NUMAT
   20 EMAT(I,I)=0.0D0
C@ --------------------------*
C *** RECALCULATE THE DENSITY MATRICES IN THE UHF SCHEME
C
      LINEAR=NORBS*(NORBS+1)/2
      IF( .NOT. UHF) THEN
         DO 30 I=1,LINEAR
   30    BETA(I)=ALPHA(I)
      ENDIF
C
C *** ONE-CENTER ENERGIES
      K=0
      DO 50 I=1,NUMAT
         IA=NFIRST(I)
         IB=NLAST(I)
         NI=NAT(I)
         EA(I,1)=0.0D0
         DO 40 J=IA,IB
            K=K+J
            T=UPP(NI)
            IF(J.EQ.IA) T=USS(NI)
   40    EA(I,1)=EA(I,1)+P(K)*T
         ISS=(IA*(IA+1))/2
         EA(I,2)=0.5D0*GSS(NI)*P(ISS)*P(ISS)
     1  -0.5D0*GSS(NI)*(ALPHA(ISS)*ALPHA(ISS)+BETA(ISS)*BETA(ISS))
         IF(IA.EQ.IB) GO TO 50
         IA1=IA+1
         IA2=IA+2
         IXX=IA1*IA2/2
         IYY=IA2*IB/2
         IZZ=(IB*(IB+1))/2
         IXY=IA1+IA2*IA1/2
         IXZ=IA1+IB*IA2/2
         IYZ=IA2+IB*IA2/2
         ISX=IA+IA1*IA/2
         ISY=IA+IA2*IA1/2
         ISZ=IA+IB*IA2/2
         SS1=P(IXX)*P(IXX)+P(IYY)*P(IYY)+P(IZZ)*P(IZZ)
         SS2=P(ISS)*(P(IXX)+P(IYY)+P(IZZ))
         SS3=P(IXX)*P(IYY)+P(IXX)*P(IZZ)+P(IYY)*P(IZZ)
         SS4=P(ISX)*P(ISX)+P(ISY)*P(ISY)+P(ISZ)*P(ISZ)
         SS5=P(IXY)*P(IXY)+P(IXZ)*P(IXZ)+P(IYZ)*P(IYZ)
         TT1=ALPHA(IXX)*ALPHA(IXX)+ALPHA(IYY)*ALPHA(IYY)
     1+ALPHA(IZZ)*ALPHA(IZZ)+BETA(IXX)*BETA(IXX)
     2+BETA(IYY)*BETA(IYY)+BETA(IZZ)*BETA(IZZ)
         TT2=ALPHA(ISS)*(ALPHA(IXX)+ALPHA(IYY)+ALPHA(IZZ))
     1   +BETA(ISS)*(BETA(IXX)+BETA(IYY)+BETA(IZZ))
         TT3=ALPHA(IXX)*ALPHA(IYY)+ALPHA(IXX)*ALPHA(IZZ)
     1+ALPHA(IYY)*ALPHA(IZZ)+BETA(IXX)*BETA(IYY)
     2+BETA(IXX)*BETA(IZZ)+BETA(IYY)*BETA(IZZ)
         TT4=ALPHA(ISX)*ALPHA(ISX)+ALPHA(ISY)*ALPHA(ISY)
     1+ALPHA(ISZ)*ALPHA(ISZ)+BETA(ISX)*BETA(ISX)
     2+BETA(ISY)*BETA(ISY)+BETA(ISZ)*BETA(ISZ)
         TT5=ALPHA(IXY)*ALPHA(IXY)+ALPHA(IXZ)*ALPHA(IXZ)
     1+ALPHA(IYZ)*ALPHA(IYZ)+BETA(IXY)*BETA(IXY)
     2+BETA(IXZ)*BETA(IXZ)+BETA(IYZ)*BETA(IYZ)
         EA(I,2)=EA(I,2)+0.5D0*GPP(NI)*SS1+GSP(NI)*SS2
     1+GP2(NI)*SS3+HSP(NI)*SS4*2.0D0+0.5D0*(GPP(NI)-GP2(NI))*SS5*2.0D0
     2                -0.5D0*GPP(NI)*TT1-GSP(NI)*TT4-GP2(NI)*TT5-
     3        HSP(NI)*(TT2+TT4)-0.5D0*(GPP(NI)-GP2(NI))*(TT3+TT5)
   50 CONTINUE
      AM1=(INDEX(KEYWRD,'AM1')+INDEX(KEYWRD,'PM3').NE.0)
      IF(MINDO3) THEN
         WRITE(6,'(///,10X,''TOTAL ENERGY PARTITIONING IN MINDO/3'')')
      ELSEIF( INDEX(KEYWRD,'PM3').NE.0 ) THEN
         WRITE(6,'(///,10X,''TOTAL ENERGY PARTITIONING IN PM3'')')
      ELSEIF( INDEX(KEYWRD,'AM1').NE.0 ) THEN
         WRITE(6,'(///,10X,''TOTAL ENERGY PARTITIONING IN AM1'')')
      ELSE
         WRITE(6,'(///,10X,''TOTAL ENERGY PARTITIONING IN MNDO'')')
      ENDIF
      KL=0
   60 K=KL+1
      KL=KL+10
      KL=MIN0(KL,NUMAT)
      DO 70 I=K,KL
   70 EAT(I)=EA(I,1)+EA(I,2)
      IF(NUMAT.GT.KL) GO TO 60
   80 EAU=0.0D0
      EAE=0.0D0
      DO 90 I=1,NUMAT
         EAU=EAU+EA(I,1)
   90 EAE=EAE+EA(I,2)
      TONE=EAU+EAE
C *** TWO-CENTER ENERGIES
C     RESONANCE (E(N,1)) TERMS
      N=1
      DO 110 II=2,NUMAT
         E(N,1)=0.0D0
         IA=NFIRST(II)
         IB=NLAST(II)
         IMINUS=II-1
         ONEII=1.D0
         IF(NAT(II).EQ.102)ONEII=0.D0
         DO 100 JJ=1,IMINUS
            N=N+1
            JA=NFIRST(JJ)
            JB=NLAST(JJ)
            ONEJJ=1.D0
            IF(NAT(JJ).EQ.102)ONEJJ=0.D0
            E(N,1)=0.0D0
            DO 100 I=IA,IB
               KA=(I*(I-1))/2
               DO 100 K=JA,JB
                  IK=KA+K
  100    E(N,1)=E(N,1)+2.0D0*P(IK)*H(IK)*ONEII*ONEJJ
  110 N=N+1
C
C     THE CODE THAT FOLLOWS APPLIES ONLY TO MNDO
C
      IF(.NOT.MINDO3) THEN
C     CORE-CORE REPULSION (E(N,2)) AND CORE-ELEC. ATTRACTION (E(N,3)).
         N=1
         KK=0
         DO 190 II=2,NUMAT
            E(N,2)=0.0D0
            E(N,3)=0.0D0
            IA=NFIRST(II)
            IB=NLAST(II)
            NI=NAT(II)
            ISS=(IA*(IA+1))/2
            IMINUS=II-1
            DO 180 JJ=1,IMINUS
               N=N+1
               JA=NFIRST(JJ)
               JB=NLAST(JJ)
               NJ=NAT(JJ)
               JSS=(JA*(JA+1))/2
               KK=KK+1
               G=W(KK)
               R=SQRT((COORD(1,II)-COORD(1,JJ))**2+(COORD(2,II)-COORD(2,
     1JJ))**2+  (COORD(3,II)-COORD(3,JJ))**2)
               SCALE=1.0D0+EXP(-ALP(NI)*R)+EXP(-ALP(NJ)*R)
               NT=NI+NJ
               IF(NT.LT.8.OR.NT.GT.9) GO TO 120
               IF(NI.EQ.7.OR.NI.EQ.8) SCALE=SCALE+(R-1.0D0)*EXP(-ALP(NI)
     1*R)
               IF(NJ.EQ.7.OR.NJ.EQ.8) SCALE=SCALE+(R-1.0D0)*EXP(-ALP(NJ)
     1*R)
  120          E(N,2)=CORE(NI)*CORE(NJ)*G*SCALE
               IF( AM1 )THEN
                  SCALE=0.0D0
                  DO 130 IG=1,10
                     IF(ABS(FN1(NI,IG)).GT.0.D0)
     1SCALE=SCALE +CORE(NI)*CORE(NJ)/R*
     2FN1(NI,IG)*EXP(-FN2(NI,IG)*(R-FN3(NI,IG))**2)
                     IF(ABS(FN1(NJ,IG)).GT.0.D0)
     1SCALE=SCALE +CORE(NI)*CORE(NJ)/R*
     2FN1(NJ,IG)*EXP(-FN2(NJ,IG)*(R-FN3(NJ,IG))**2)
  130             CONTINUE
                  E(N,2)=E(N,2)+SCALE
               ENDIF
               E(N,3)=-(P(ISS)*CORE(NJ)+P(JSS)*CORE(NI))*G
               IF(NJ.LT.3) GO TO 150
               KINC=9
               JAP1=JA+1
               DO 140 K=JAP1,JB
                  KC=(K*(K-1))/2
                  DO 140 L=JA,K
                     KL=KC+L
                     BB=2.0D0
                     IF(K.EQ.L) BB=1.0D0
                     KK=KK+1
  140          E(N,3)=E(N,3)-P(KL)*CORE(NI)*BB*W(KK)
               GO TO 160
  150          KINC=0
  160          IF(NI.LT.3) GO TO 180
               IAP1=IA+1
               DO 170 I=IAP1,IB
                  KA=(I*(I-1))/2
                  DO 170 J=IA,I
                     IJ=KA+J
                     AA=2.0D0
                     IF(I.EQ.J) AA=1.0D0
                     KK=KK+1
                     E(N,3)=E(N,3)-P(IJ)*CORE(NJ)*AA*W(KK)
  170          KK=KK+KINC
  180       CONTINUE
  190    N=N+1
C     COULOMB (E(N,4)) AND EXCHANGE (EX(N)) TERMS
         N=1
         KK=0
         DO 210 II=2,NUMAT
            E(N,4)=0.0D0
            EX(N,1)=0.0D0
            IA=NFIRST(II)
            IB=NLAST(II)
            IMINUS=II-1
            DO 200 JJ=1,IMINUS
               JA=NFIRST(JJ)
               JB=NLAST(JJ)
               N=N+1
               E(N,4)=0.0D0
               EX(N,1)=0.0D0
               DO 200 I=IA,IB
                  KA=(I*(I-1))/2
                  DO 200 J=IA,I
                     KB=(J*(J-1))/2
                     IJ=KA+J
                     AA=2.0D0
                     IF(I.EQ.J) AA=1.0D0
                     PIJ=P(IJ)
                     DO 200 K=JA,JB
                        KC=(K*(K-1))/2
                        IK=KA+K
                        JK=KB+K
                        DO 200 L=JA,K
                           IL=KA+L
                           JL=KB+L
                           KL=KC+L
                           BB=2.0D0
                           IF(K.EQ.L) BB=1.0D0
                           KK=KK+1
                           G=W(KK)
                           E(N,4)=E(N,4)+AA*BB*G*PIJ*P(KL)
  200       EX(N,1) = EX(N,1)
     1    -0.5D0*AA*BB*G*(ALPHA(IK)*ALPHA(JL)+ALPHA(IL)*ALPHA(JK)+
     2    BETA(IK)*BETA(JL)+BETA(IL)*BETA(JK))
  210    N=N+1
      ELSE
         N=1
         DO 270 I=2,NUMAT
            E(N,2)=0.0D0
            E(N,3)=0.0D0
            E(N,4)=0.0D0
            EX(N,1)=0.0D0
            IA=NFIRST(I)
            IB=NLAST(I)
            NI=NAT(I)
            IMINUS=I-1
            DO 260 J=1,IMINUS
               N=N+1
               JA=NFIRST(J)
               JB=NLAST(J)
               NJ=NAT(J)
               RIJ=(COORD(1,I)-COORD(1,J))**2+(COORD(2,I)-COORD(2,J))**2
     1+  (COORD(3,I)-COORD(3,J))**2
               GIJ=14.399D0/SQRT(RIJ+(7.1995D0/F03(NI)+7.1995D0/F03(NJ))
     1**2)
               PAB2=0.0D0
               IJ=MAX(NI,NJ)
               NBOND=(IJ*(IJ-1))/2+NI+NJ-IJ
               RIJ=SQRT(RIJ)
               IF(NBOND.EQ.22 .OR. NBOND .EQ. 29) GO TO 220
               GO TO 230
  220          SCALE=ALP3(NBOND)*EXP(-RIJ)
               GO TO 240
  230          SCALE=EXP(-ALP3(NBOND)*RIJ)
  240          CONTINUE
               E(N,2)=CORE(NI)*CORE(NJ)*GIJ+
     1     ABS(CORE(NI)*CORE(NJ)*(14.399D0/RIJ-GIJ)*SCALE)
               E(N,3)=(-Q(I)*CORE(NJ)-Q(J)*CORE(NI))*GIJ
               E(N,4)=Q(I)*Q(J)*GIJ
               DO 250 K=IA,IB
                  KK=(K*(K-1))/2
                  DO 250 L=JA,JB
                     LK=KK+L
  250          PAB2=PAB2+ALPHA(LK)*ALPHA(LK)+BETA(LK)*BETA(LK)
  260       EX(N,1) = -PAB2*GIJ
  270    N=N+1
      ENDIF
      NUMAT1=(NUMAT*(NUMAT+1))/2
      DO 280 I=1,4
  280 E(NUMAT1,I)=0.0D0
      DO 290 I=1,3
  290 EX(NUMAT1,I)=0.0D0
C@ --------------------------*
C-----PRINT OUT ONE AND TWO CENTER ENERGIES
C
C     E(I,1):     RESONANCE ENERGY
C     E(I,2):     NUCLEAR-NUCLEAR REPULSION ENERGY
C     E(I,3):     ELECTRON-NUCLEAR ATTRACTION ENERGY
C     E(I,4):     ELECTRON-ELECTRON REPULSION ENERGY
C     EX(I,1):    EXCHANGE  ENERGY
C     EX(I,2):    EXCHANGE + RESONANCE ENERGY
      WRITE(6,'(//,''       ONE AND TWO CENTER ENERGIES (EV) '')')
C
      WRITE(6,'(/,''  [RESONANCE TERM] (EV)'')')
      CALL VECPRT(E,NUMAT)
C
      WRITE(6,'(/,''  [EXCHANGE TERM] (EV)'')')
      CALL VECPRT(EX,NUMAT)
C
      WRITE(6,'(/,''  [RESONANCE + EXCHANGE] (EV)'')')
      DO 300 N=1,NUMAT1
  300 EX(N,2) =E(N,1) + EX(N,1)
C
C   ADD IN MONOCENTRIC EXCHANGE AND COULOMBIC TERM
C
      DO 310 I=1,NUMAT
  310 EX((I*(I+1))/2,2)=EA(I,2)
      CALL VECPRT(EX(1,2),NUMAT)
C
      WRITE(6,'(/,''  [ELECTRON - ELECTRON REPULSION] (EV)'')')
      CALL VECPRT(E(1,4),NUMAT)
C
      WRITE(6,'(/,''  [ELECTRON-NUCLEAR ATTRACTION] (EV)'')')
      DO 320 I=1,NUMAT
  320 E((I*(I+1))/2,3)=EA(I,1)
      CALL VECPRT(E(1,3),NUMAT)
C
      WRITE(6,'(/,''  [NUCLEAR-NUCLEAR REPULSION] (EV)'')')
      CALL VECPRT(E(1,2),NUMAT)
C
      DO 330 N=1,NUMAT1
  330 EX(N,3) =E(N,4) + E(N,3) + E(N,2)
C     PRINT OUT OF TOTAL COULOMB TERM
      WRITE(6,'(/,''  [TOTAL COULOMB TERM (E-E, E-N, AND N-N)] (EV)'')')
      CALL VECPRT(EX(1,3),NUMAT)
C     PRINT OUT OF TWO-CENTER SUM(OFF-DIAGONAL) +
C                  ONE-CENTER SUM(DIAGONAL).
      WRITE(6,'(/,''  [TWO-CENTER SUM (OFF-DIAGONAL), AND  '',
     1''ONE-CENTER SUM (DIAGONAL)] (EV)'')')
      DO 340 N=1,NUMAT1
  340 EX(N,3)=EX(N,3)+EX(N,2)
      CALL VECPRT(EX(1,3),NUMAT)
C@    TOTAL SUM
      EABR=0.0D0
      EABX=0.0D0
      EABEE=0.0D0
      EABEN=0.0D0
      EABNN=0.0D0
      DO 350 I=1,NUMAT
  350 E((I*(I+1))/2,3)=0.D0
      DO 360 I=1,NUMAT1
         EABR=EABR+E(I,1)
         EABX=EABX+EX(I,1)
         EABEE=EABEE+E(I,4)
         EABEN=EABEN+E(I,3)
         EABNN=EABNN+E(I,2)
  360 CONTINUE
      EABRX=EABR+EABX
      EABE=EABEE+EABEN+EABNN
      TTWO=EABRX+EABE
      ET=TONE+TTWO
C@ ***************************************************************
      WRITE(6,370)
  370 FORMAT(///,'***  SUMMARY OF ENERGY PARTITION  ***')
      WRITE(6,380)
  380 FORMAT(1H ,'---------------------------------------')
      WRITE(6,'(''     ONE-CENTER TERMS'')')
      WRITE(6,390) EAU
  390 FORMAT(/,' ELECTRON-NUCLEAR  (ONE-ELECTRON) ',F17.4,' EV')
      WRITE(6,400) EAE
  400 FORMAT(' ELECTRON-ELECTRON (TWO-ELECTRON) ',F17.4,' EV')
      WRITE(6,410) TONE
  410 FORMAT(/,' TOTAL OF ONE-CENTER TERMS        ',18X,F15.4,' EV')
      WRITE(6,380)
      WRITE(6,'(''     TWO-CENTER TERMS'')')
      WRITE(6,420) EABR
  420 FORMAT(/,' RESONANCE ENERGY',8X,F15.4,' EV')
      WRITE(6,430) EABX
  430 FORMAT(' EXCHANGE ENERGY ',8X,F15.4,' EV')
      WRITE(6,440) EABRX
  440 FORMAT(/,' EXCHANGE + RESONANCE ENERGY:       ',F15.4,' EV')
      WRITE(6,450) EABEE
  450 FORMAT(/,' ELECTRON-ELECTRON REPULSION',F12.4,' EV')
      WRITE(6,460) EABEN
  460 FORMAT(  ' ELECTRON-NUCLEAR ATTRACTION',F12.4,' EV')
      WRITE(6,470) EABNN
  470 FORMAT(  ' NUCLEAR-NUCLEAR REPULSION  ',F12.4,' EV')
      WRITE(6,480) EABE
  480 FORMAT(/,' TOTAL ELECTROSTATIC INTERACTION    ',F15.4,' EV',/)
      WRITE(6,490) TTWO
  490 FORMAT(' GRAND TOTAL OF TWO-CENTER TERMS   ',17X,F15.4,' EV')
      WRITE(6,380)
      WRITE(6,500) ET
  500 FORMAT(' ETOT (EONE + ETWO)   ',30X,F15.4,' EV'//)
      RETURN
      END

C     *****************
      SUBROUTINE VDRSET(SEED)
C     *****************
C
C
      DOUBLE PRECISION DRAND,DUMMY
C
C
      INTEGER   SEED
C
C
      DUMMY = DRAND(SEED)
C
C
      RETURN
      END
C
C

      SUBROUTINE MOVEB

      IMPLICIT CHARACTER ( A-Z )

      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/ATOMS/NATM
      COMMON/ENERGY/V,K,W
      COMMON/FORCES/FX,FY,FZ

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL        DT, DT2
      REAL        V,K,W
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)

      INTEGER     I, NATM

C    *******************************************************************
C     SECOND PART OF VELOCITY VERLET ALGORITHM
C    *******************************************************************

      DT2   = DT/2.0
      K   = 0.0

      DO 100 I = 1, NATM

C**     INTEGRATE VELOCITIES HALF A TIMESTEP

        VX(I) = VX(I)+DT2*FX(I)
        VY(I) = VY(I)+DT2*FY(I)
        VZ(I) = VZ(I)+DT2*FZ(I)

C**     SUM KINETIC ENERGY

        K = K+VX(I)*VX(I)+VY(I)*VY(I)+VZ(I)*VZ(I)
100     CONTINUE

      K = 0.5*K

      RETURN
      END

      SUBROUTINE MPOINT(XP,YP,XVELO,YVELO,DT,COORD,DIM,NNODX,
     +     NODEL,DOFR,ELEMCO,FLOWEL,IP,PREV,IELTOP,ELTOP,
     +     XLEN,INDELE,SHCRU,SHLIQ,NNODM,NELEMM)
      INTEGER DIM,NNODX,NODEL,DOFR,IP,IELTOP,INDELE,NNODM,
     +     NELEMM
      INTEGER ELTOP(IELTOP,*)
      DOUBLE PRECISION XP,YP,XVELO,YVELO,DT,COORD(DIM,*),
     +     ELEMCO(2,*),FLOWEL(*),PREV(*),XLEN,SHLIQ(*),SHCRU(*)

      INTEGER INDX,INDY,NELEX,I,IND
      DOUBLE PRECISION ZERO,EPS,Y,XN,YN
      PARAMETER(ZERO=0.0D0,EPS=1.0D-12)


      XN=XP
      YN=YP
      XP=XP-XVELO*DT
      YP=YP-YVELO*DT

      CALL PCHECK(XP,YP,XN,YN,ZERO,XLEN,SHCRU,SHLIQ,COORD,DIM,NNODX)


      IF (IP .LE. NNODM) THEN
         INDELE=1
      ELSE
         INDELE=NELEMM+1
      ENDIF

      INDX=1
 100  IF ((XP .LT. COORD(1,INDX)-EPS) .OR. 
     +     (XP .GT. COORD(1,INDX+2)+EPS)) THEN
         INDX=INDX+2
         INDELE=INDELE+1
         GOTO 100
      ENDIF


      NELEX=(NNODX-1)/2

      IF (IP .LE. NNODM) THEN
         INDY=INDX
         IND=3*(NELEX+1)-1
      ELSE IF (IP .LE. (NNODM+3*NELEX+2)) THEN
         INDELE=INDELE+INDX-1
      ELSE
         INDY=NNODM+NELEX+1+INDX
         IND=3*(NELEX+1)-1
         INDELE=INDELE+NELEX
      ENDIF

      IF ((IP .LE. NNODM) .OR. (IP .GT. (NNODM+3*NELEX+2))) THEN
 200     Y=COORD(2,INDY+IND)+
     +        (COORD(2,INDY+IND+2)-COORD(2,INDY+IND))/
     +        (COORD(1,INDX+2)-COORD(1,INDX))*
     +        (XP-COORD(1,INDY+IND))

         IF (YP .GT. Y+EPS) THEN
            INDELE=INDELE+NELEX
            INDY=INDY+IND
            GOTO 200
         ENDIF
      ENDIF

      DO 300 I=1,NODEL
         ELEMCO(1,I)=COORD(1,ELTOP(2+I,INDELE))
         ELEMCO(2,I)=COORD(2,ELTOP(2+I,INDELE))
 300  CONTINUE


      IF (DOFR .EQ. NODEL) THEN

         DO 400 I=1,NODEL
            FLOWEL(I)=PREV(ELTOP(2+I,INDELE))
 400     CONTINUE
      ELSE

         DO 500 I=1,NODEL
            FLOWEL(2*I-1)=PREV(2*ELTOP(2+I,INDELE)-1)
            FLOWEL(2*I)=PREV(2*ELTOP(2+I,INDELE))
 500     CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE VREAD
      IMPLICIT DOUBLE PRECISION (A-H, O-Z)
      INCLUDE 'mopac.inc'
C
C MODULE TO READ IN GEOMETRY FILE, OUTPUT IT TO THE USER,
C AND CHECK THE DATA TO SEE IF IT IS REASONABLE.
C EXIT IF NECESSARY.
C
C
C
C  ON EXIT NATOMS    = NUMBER OF ATOMS PLUS DUMMY ATOMS (IF ANY).
C          KEYWRD    = KEYWORDS TO CONTROL CALCULATION
C          KOMENT    = COMMENT CARD
C          TITLE     = TITLE CARD
C          LABELS    = ARRAY OF ATOMIC LABELS INCLUDING DUMMY ATOMS.
C          GEO       = ARRAY OF INTERNAL COORDINATES.
C          LOPT      = FLAGS FOR OPTIMIZATION OF MOLECULE
C          NA        = ARRAY OF LABELS OF ATOMS, BOND LENGTHS.
C          NB        = ARRAY OF LABELS OF ATOMS, BOND ANGLES.
C          NC        = ARRAY OF LABELS OF ATOMS, DIHEDRAL ANGLES.
C          LATOM     = LABEL OF ATOM OF REACTION COORDINATE.
C          LPARAM    = RC: 1 FOR LENGTH, 2 FOR ANGLE, AND 3 FOR DIHEDRAL
C          REACT(200)= REACTION COORDINATE PARAMETERS
C          LOC(1,I)  = LABEL OF ATOM TO BE OPTIMIZED.
C          LOC(2,I)  = 1 FOR LENGTH, 2 FOR ANGLE, AND 3 FOR DIHEDRAL.
C          NVAR      = NUMBER OF PARAMETERS TO BE OPTIMIZED.
C          XPARAM    = STARTING VALUE OF PARAMETERS TO BE OPTIMIZED.
C
************************************************************************
C *** INPUT THE TRIAL GEOMETRY  \IE.  KGEOM=0\
C   LABEL(I) = THE ATOMIC NUMBER OF ATOM\I\.
C            = 99, THEN THE I-TH ATOM IS A DUMMY ATOM USED ONLY TO
C              SIMPLIFY THE DEFINITION OF THE MOLECULAR GEOMETRY.
C   GEO(1,I) = THE INTERNUCLEAR SEPARATION \IN ANGSTROMS\ BETWEEN ATOMS
C              NA(I) AND (I).
C   GEO(2,I) = THE ANGLE NB(I):NA(I):(I) INPUT IN DEGREES; STORED IN
C              RADIANS.
C   GEO(3,I) = THE ANGLE BETWEEN THE VECTORS NC(I):NB(I) AND NA(I):(I)
C              INPUT IN DEGREES - STORED IN RADIANS.
C  LOPT(J,I) = -1 IF GEO(J,I) IS THE REACTION COORDINATE.
C            = +1 IF GEO(J,I) IS A PARAMETER TO BE OPTIMIZED
C            =  0 OTHERWISE.
C *** NOTE:    MUCH OF THIS DATA IS NOT INCLUDED FOR THE FIRST 3 ATOMS.
C     ATOM1  INPUT LABELS(1) ONLY.
C     ATOM2  INPUT LABELS(2) AND GEO(1,2) SEPARATION BETWEEN ATOMS 1+2
C     ATOM3  INPUT LABELS(3), GEO(1,3)    SEPARATION BETWEEN ATOMS 2+3
C              AND GEO(2,3)              ANGLE ATOM1 : ATOM2 : ATOM3
C
************************************************************************
C
      DIMENSION LOPT(3,NUMATM)
      CHARACTER*80 KEYWRD,KOMENT,TITLE,LINE, BANNER
      CHARACTER KEYS(80)*1, SPACE*1, SPACE2*2, CH*1, CH2*2
      CHARACTER ELEMNT*2, IDATE*24
      COMMON /KEYWRD/ KEYWRD
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /GEOVAR/ NVAR, LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /MESH  / LATOM1, LPARA1, LATOM2, LPARA2
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /ISTOPE/ AMS(107)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1                      LOCDEP(MAXPAR)
      LOGICAL INT
      DIMENSION COORD(3,NUMATM),VALUE(40)
      EQUIVALENCE (KEYS(1),KEYWRD)
      DATA SPACE, SPACE2/' ','  '/
C
      READ(5,'(A)')KEYWRD,KOMENT,TITLE
      ILOWA = ICHAR('a')
      ILOWZ = ICHAR('z')
      ICAPA = ICHAR('A')
************************************************************************
      DO 10 I=1,80
         ILINE=ICHAR(KEYWRD(I:I))
         IF(ILINE.GE.ILOWA.AND.ILINE.LE.ILOWZ) THEN
            KEYWRD(I:I)=CHAR(ILINE+ICAPA-ILOWA)
         ENDIF
   10 CONTINUE
************************************************************************
      IF(INDEX(KEYWRD,'ECHO').NE.0)THEN
         REWIND 5
         DO 30 I=1,1000
            READ(5,'(A)',END=40)KEYWRD
            DO 20 J=80,2,-1
   20       IF(KEYWRD(J:J).NE.' ')GOTO 30
            J=1
   30    WRITE(6,'(1X,A)')KEYWRD(1:J)
      ENDIF
   40 REWIND 5
      IF(INDEX(KEYWRD,'ECHO').NE.0)WRITE(6,'(''1'')')
      READ(5,'(A)')KEYWRD,KOMENT,TITLE
************************************************************************
      DO 50 I=1,80
         ILINE=ICHAR(KEYWRD(I:I))
         IF(ILINE.GE.ILOWA.AND.ILINE.LE.ILOWZ) THEN
            KEYWRD(I:I)=CHAR(ILINE+ICAPA-ILOWA)
         ENDIF
   50 CONTINUE
************************************************************************
      IF(KEYWRD(1:1) .NE. SPACE) THEN
         CH=KEYWRD(1:1)
         KEYWRD(1:1)=SPACE
         DO 60 I=2,78
            CH2=KEYWRD(I:I)
            KEYWRD(I:I)=CH
            CH=CH2
            IF(KEYWRD(I+1:I+2) .EQ. SPACE2) THEN
               KEYWRD(I+1:I+1)=CH
               GOTO 70
            ENDIF
   60    CONTINUE
         IF(KEYWRD(80:80) .NE. SPACE)
     1WRITE(6,'(//10X,''WARNING-THE LAST KEYWORD MAY BE CORRUPTED'')')
         KEYWRD(80:80)=CH
   70    CONTINUE
      ENDIF
      IF(KOMENT(1:1) .NE. SPACE) THEN
         CH=KOMENT(1:1)
         KOMENT(1:1)=SPACE
         DO 80 I=2,78
            CH2=KOMENT(I:I)
            KOMENT(I:I)=CH
            CH=CH2
            IF(KOMENT(I+1:I+2) .EQ. SPACE2) THEN
               KOMENT(I+1:I+1)=CH
               GOTO 90
            ENDIF
   80    CONTINUE
         IF(KOMENT(80:80) .NE. SPACE)
     1WRITE(6,'(//1X,A)')'WARNING-THE LAST WORD IN FIRST COMMENT LINE'//
     2' MAY BE CORRUPTED'
         KOMENT(80:80)=CH
   90    CONTINUE
      ENDIF
      IF(TITLE(1:1) .NE. SPACE) THEN
         CH=TITLE(1:1)
         TITLE(1:1)=SPACE
         DO 100 I=2,78
            CH2=TITLE(I:I)
            TITLE(I:I)=CH
            CH=CH2
            IF(TITLE(I+1:I+2) .EQ. SPACE2) THEN
               TITLE(I+1:I+1)=CH
               GOTO 110
            ENDIF
  100    CONTINUE
         IF(TITLE(80:80) .NE. SPACE)
     1WRITE(6,'(//1X,A)')'WARNING-THE LAST WORD IN SECOND COMMENT'//
     2' LINE MAY BE CORRUPTED'
         TITLE(80:80)=CH
  110    CONTINUE
      ENDIF
      CALL GETGEO(5,LABELS,GEO,LOPT,NA,NB,NC,AMS,NATOMS,INT)
C
C
C OUTPUT FILE TO UNIT 6
C
C    WRITE HEADER
      IDATE=' '
C-old      CALL DATE(IDATE)
      WRITE(6,'(1X,15(''*****''),''****'')')
C
C     CHANGE THE FOLLOWING LINE TO SUIT LOCAL ENVIRONMENT, IF DESIRED
C
      BANNER=' ** FRANK J. SEILER RES. LAB., U.S. AIR FORCE '//
     1'ACADEMY, COLO. SPGS., CO. 80840 **'
      WRITE(6,'(A)')BANNER
C
C    THE BANNER DOES NOT APPEAR ANYWHERE ELSE.
C
      WRITE(6,'(1X,79(''*''))')
      LINE='   MNDO'
      IF(INDEX(KEYWRD,'MINDO') .NE. 0) LINE='MINDO/3'
      IF(INDEX(KEYWRD,'AM1')   .NE. 0) LINE='    AM1'
      IF(INDEX(KEYWRD,'PM3')   .NE. 0) LINE='    PM3'
      WRITE(6,'(/29X,A,'' CALCULATION RESULTS'',28X,///1X,15(''*****'')
     1,''****'' )')LINE(:7)
      WRITE(6,'('' *'',10X,''MOPAC:  VERSION '',F5.2,
     115X,''CALC''''D. '',A24)') VERSON, IDATE
C
C CHECK DATA
C
      DO 120 I=1,NATOMS
         IF (LABELS(I) .LE. 0 ) THEN
            WRITE(6,'('' ATOMIC NUMBER OF '',I3,'' ?'')') LABELS(I)
            CALL WRAPUP()
         ENDIF
         IF (  NA(I).GE.I.OR. NB(I).GE.I.OR. NC(I).GE.I
     1  .OR. (NA(I).EQ.NB(I))   .AND. I.GT.1
     2  .OR. (NA(I).EQ.NC(I).OR.NB(I).EQ.NC(I))  .AND. I.GT.2
     3  .OR.  NA(I)*NB(I)*NC(I).EQ.0  .AND. I.GT.3) THEN
            WRITE(6,'('' ATOM NUMBER '',I3,'' IS ILLDEFINED'')') I
            CALL WRAPUP()
         ENDIF
  120 CONTINUE
C
C WRITE KEYWORDS BACK TO USER AS FEEDBACK
      CALL WRTKEY(KEYWRD)
      WRITE(6,'(1X,14(''*****''),''*'',I3.3,''BY'',I3.3)')MAXHEV,MAXLIT
C
C CONVERT ANGLES TO RADIANS
      DO 130 I=1,NATOMS
         DO 130 J=2,3
            GEO(J,I) = GEO(J,I) * 2.D0*ASIN(1.D0)/180.D0
  130 CONTINUE
C
C FILL IN GEO MATRIX IF NEEDED
      NDEP=0
      IF( INDEX(KEYWRD,'SYM') .NE. 0) CALL GETSYM
      IF(NDEP.NE.0) CALL SYMTRY
C
C INITIALIZE FLAGS FOR OPTIMIZE AND PATH
      IFLAG = 0
      NVAR  = 0
      LATOM = 0
      NUMAT=0
      DO 160 I=1,NATOMS
         IF(LABELS(I).NE.99.AND.LABELS(I).NE.107)NUMAT=NUMAT+1
         DO 160 J=1,3
            IF (LOPT(J,I) ) 140, 160, 150
C    FLAG FOR PATH
  140       CONVRT=1.D0
            IF ( IFLAG .NE. 0 ) THEN
               IF(INDEX(KEYWRD,'STEP1').NE.0)THEN
                  LPARA1=LPARAM
                  LATOM1=LATOM
                  LPARA2=J
                  LATOM2=I
                  LATOM=0
                  IFLAG=0
                  GOTO 160
               ELSE
                  WRITE(6,'('' ONLY ONE REACTION COORDINATE PERMITTED'')
     1')
                  CALL WRAPUP()
               ENDIF
            ENDIF
            LATOM  = I
            LPARAM = J
            IF(J.GT.1) CONVRT=0.01745329252D00
            REACT(1)  = GEO(J,I)
            IREACT=1
            IFLAG = 1
            GO TO 160
C    FLAG FOR OPTIMIZE
  150       NVAR = NVAR + 1
            LOC(1,NVAR) = I
            LOC(2,NVAR) = J
            XPARAM(NVAR)   = GEO(J,I)
  160 CONTINUE
C READ IN PATH VALUES
      IF(IFLAG.EQ.0) GO TO 200
      IF(INDEX(KEYWRD,'NLLSQ').NE.0)THEN
         WRITE(6,'(A)')' NLLSQ USED WITH REACTION PATH; '//
     1'THIS OPTION IS NOT ALLOWED'
         CALL WRAPUP()
      ENDIF
      IF(INDEX(KEYWRD,'SIGMA').NE.0)THEN
         WRITE(6,'(A)')' SIGMA USED WITH REACTION PATH; '//
     1'THIS OPTION IS NOT ALLOWED'
         CALL WRAPUP()
      ENDIF
  170 READ(5,'(A)',END=190) LINE
      CALL NUCHAR(LINE,VALUE,NREACT)
      DO 180 I=1,NREACT
         IJ=IREACT+I
         IF(IJ.GT.200)THEN
            WRITE(6,'(///,''    ONLY TWO HUNDRED POINTS ALLOWED IN REACT
     1ION'','' COORDINATE'')')
            CALL WRAPUP()
         ENDIF
         REACT(IJ)=VALUE(I)*CONVRT
         IF(ABS(REACT(IJ)-REACT(IJ-1)).LT.1.D-5)THEN
            DUM1 = REACT(IJ)/CONVRT
            DUM2 = REACT(IJ-1)/CONVRT
            WRITE(6,'(///,'' TWO ADJACENT POINTS ARE IDENTICAL:  '',
     1 F7.3,2X,F7.3,/,'' THIS IS NOT ALLOWED IN A PATH CALCULATION'')')
     2 DUM1,DUM2
            CALL WRAPUP()
         ENDIF
  180 CONTINUE
      IREACT=IREACT+NREACT
      GO TO 170
  190 CONTINUE
      DEGREE=1.D0
      IF(LPARAM.GT.1)DEGREE=90.D0/ASIN(1.D0)
      IF(IREACT.LE.1) THEN
         WRITE(6,'(//10X,'' NO POINTS SUPPLIED FOR REACTION PATH'')')
         WRITE(6,'(//10X,'' GEOMETRY AS READ IN IS AS FOLLOWS'')')
         CALL GEOUT
         CALL WRAPUP()
      ELSE
         WRITE(6,'(//10X,'' POINTS ON REACTION COORDINATE'')')
         WRITE(6,'(10X,8F8.2)')(REACT(I)*DEGREE,I=1,IREACT)
      ENDIF
      IEND=IREACT+1
      REACT(IEND)=-1.D12
C
C OUTPUT GEOMETRY AS FEEDBACK
C
  200 WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
      CALL GEOUT
      CALL GMETRY(GEO,COORD)
      IF (INDEX(KEYWRD,'NOXYZ') .EQ. 0) THEN
         WRITE(6,'(//10X,''CARTESIAN COORDINATES '',/)')
         WRITE(6,'(4X,''NO.'',7X,''ATOM'',9X,''X'',
     1  9X,''Y'',9X,''Z'',/)')
         L=0
         DO 210 I=1,NATOMS
            IF(LABELS(I) .EQ. 99.OR.LABELS(I).EQ.107) GOTO 210
            L=L+1
            WRITE(6,'(I6,8X,A2,4X,3F10.4)')
     1  L,ELEMNT(LABELS(I)),(COORD(J,L),J=1,3)
  210    CONTINUE
      ENDIF
      IF(   INDEX(KEYWRD,' XYZ') .NE. 0 )THEN
         IF( NVAR .NE. 0 .AND.
     1 INT.AND.(NDEP .NE. 0 .OR.  NVAR.LT.3*NUMAT-6)) THEN
            IF(NDEP.NE.0)
     1WRITE(6,'(//10X,'' INTERNAL COORDINATES READ IN, AND SYMMETRY''
     2,/10X,'' SPECIFIED, BUT CALCULATION TO BE RUN IN CARTESIAN ''
     3,''COORDINATES'')')
            IF(NVAR.LT.3*NUMAT-6)
     1WRITE(6,'(//10X,'' INTERNAL COORDINATES READ IN, AND'',
     2        '' CALCULATION '',/10X,
     +        ''TO BE RUN IN CARTESIAN COORDINATES, '',/10X,
     3        ''BUT NOT ALL COORDINATES MARKED FOR OPTIMISATION'')')
            WRITE(6,
     +'(//10X,'' THIS INVOLVES A LOGICALLLY ABSURD CHOICE'',
     1/10X,'' SO THE CALCULATION IS TERMINATED AT THIS POINT'')')
            CALL WRAPUP()
         ENDIF
         SUMX=0.D0
         SUMY=0.D0
         SUMZ=0.D0
         DO 220 J=1,NUMAT
            SUMX=SUMX+COORD(1,J)
            SUMY=SUMY+COORD(2,J)
  220    SUMZ=SUMZ+COORD(3,J)
         SUMX=SUMX/NUMAT
         SUMY=SUMY/NUMAT
         SUMZ=SUMZ/NUMAT
         DO 230 J=1,NUMAT
            GEO(1,J)=COORD(1,J)-SUMX
            GEO(2,J)=COORD(2,J)-SUMY
  230    GEO(3,J)=COORD(3,J)-SUMZ
         NA(1)=99
         J=0
         MVAR=1
         NVAR=1
         DO 260 I=1,NATOMS
            IF(LABELS(I).NE.99)THEN
               J=J+1
  240          IF(LOC(1,MVAR) .EQ. I) THEN
                  XPARAM(NVAR)=GEO(LOC(2,NVAR),J)
                  LOC(1,NVAR)=J
                  MVAR=MVAR+1
                  NVAR=NVAR+1
                  GOTO 240
               ENDIF
               LABELS(J)=LABELS(I)
            ELSE
  250          IF(LOC(1,MVAR) .EQ. I)THEN
                  MVAR=MVAR+1
                  GOTO 250
               ENDIF
            ENDIF
  260    CONTINUE
         NVAR=NVAR-1
         NATOMS=NUMAT
      ELSE
         IF(NVAR.EQ.0) RETURN
         IF( .NOT. INT.AND.(NDEP .NE. 0 .OR.  NVAR.LT.3*NUMAT-6)) THEN
            IF(NDEP.NE.0)
     1WRITE(6,'(//10X,'' CARTESIAN COORDINATES READ IN, AND SYMMETRY''
     2,/10X,'' SPECIFIED, BUT CALCULATION TO BE RUN IN INTERNAL ''
     3,''COORDINATES'')')
            IF(NVAR.LT.3*NUMAT-6)
     1WRITE(6,'(//10X,'' CARTESIAN COORDINATES READ IN, AND'',
     2'' CALCULATION '',/10X,''TO BE RUN IN INTERNAL COORDINATES, '',
     3/10X,''BUT NOT ALL COORDINATES MARKED FOR OPTIMISATION'')')
            WRITE(6,'(//10X,''MOPAC, BY DEFAULT, USES INTERNAL COORDINAT
     1ES'',/10X,''TO SPECIFY CARTESIAN COORDINATES USE KEY-WORD :XYZ:'')
     2')
            WRITE(6,'(10X,''YOUR CURRENT CHOICE OF KEY-WORDS INVOLVES A
     1'',''LOGICALLLY '',
     2/10X,''ABSURD CHOICE SO THE CALCULATION IS TERMINATED AT THIS ''
     3,''POINT'')')
            CALL WRAPUP()
         ENDIF
      ENDIF
      RETURN
      END

      PROGRAM NASKER
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   NAS KERNEL BENCHMARK PROGRAM
C   12/17/84      DAVID H BAILEY
C
      CHARACTER*8 PN(8)
      DOUBLE PRECISION ER(8), FP(8), TM(8), RT(8)
      COMMON /ARRAYS/ DATA(360000)
      external MXMTST,FFTTST,CHOTST,BTRTST,GMTTST,EMITST,VPETST
      DATA PN/'MXM', 'CFFT2D', 'CHOLSKY', 'BTRIX', 'GMTRY', 'EMIT',
     $ 'VPENTA', 'TOTAL'/
C
      WRITE (6, 1)
1     FORMAT (/16X, 'THE NAS KERNEL BENCHMARK PROGRAM'//)
C
      call initim()
      do 123 i=1,7
         write(6,*) 'Running ',PN(i),' ...'
         if (i.eq.1) call runit(MXMTST,er(i),fp(i),tm(i))
         if (i.eq.2) call runit(FFTTST,er(i),fp(i),tm(i))
         if (i.eq.3) call runit(CHOTST,er(i),fp(i),tm(i))
         if (i.eq.4) call runit(BTRTST,er(i),fp(i),tm(i))
         if (i.eq.5) call runit(GMTTST,er(i),fp(i),tm(i))
         if (i.eq.6) call runit(EMITST,er(i),fp(i),tm(i))
         if (i.eq.7) call runit(VPETST,er(i),fp(i),tm(i))
         RT(I) = 1E-6 * FP(I) / TM(I)
         write(6,2000) PN(I)//': ',TM(I),' secs,',RT(I),' Mflop/s'
 2000    format(1x,a,f15.4,a,f10.2,a)
         call shotim()
 123  continue

C
      TE = 0.
      TF = 0.
      TT = 0.
      DO 100 I = 1, 7
        TE = TE + ER(I)
        TF = TF + FP(I)
        TT = TT + TM(I)
        RT(I) = 1E-6 * FP(I) / TM(I)
100   CONTINUE
      ER(8) = TE
      FP(8) = TF
      TM(8) = TT
      RT(8) = 1E-6 * TF / TT
C
      WRITE (6, 2)  (PN(I), ER(I), FP(I), TM(I), RT(I), I = 1, 8)
2     FORMAT (' PROGRAM', 8X, 'ERROR', 10X, 'FP OPS', 7X, 'SECONDS',
     $  6X, 'MFLOPS'// 7(1X, A8, 1P2E15.4, 0PF12.4, F12.2/)/
     $  1X, A8, 1P2E15.4, 0PF12.4, F12.2//)
C
      STOP
      END
c
      subroutine runit(routin,er,fp,tm)
      external routin
      DOUBLE PRECISION er,fp,tm
      call routin(er,fp,tm)
      end

      SUBROUTINE MPCRYS(XP,YP,XVELO,YVELO,DT,COORD,DIM,NODEL,ELEMCO,
     +     FLOWEL,IP,TPREV,IELTOP,ELTOP,INDELE,NNODM,NELEXC,NELE,II)

      INTEGER DIM,NODEL,IP,IELTOP,INDELE,NNODM,NELEXC,NELE,II
      INTEGER ELTOP(IELTOP,*)
      DOUBLE PRECISION XP,YP,XVELO,YVELO,DT,COORD(DIM,*),
     +     ELEMCO(2,*),FLOWEL(*),TPREV(*)

      INTEGER NSIDE
      PARAMETER(NSIDE=3)
      DOUBLE PRECISION MIN,EPS,DMIN1
      PARAMETER(EPS=1.0D-12)


      XP=XP-XVELO*DT
      YP=YP-YVELO*DT

      IF (IP .LE. NNODM+NELEXC+1) THEN
         INDELE=NELE
      ELSE IF (II .LE. NSIDE) THEN
         INDELE=NELE-NELEXC
      ELSE
         INDELE=NELE
      ENDIF

      MIN=DMIN1(COORD(1,ELTOP(5,INDELE)),COORD(1,ELTOP(7,INDELE)))
      IF (XP .GT. MIN+EPS) THEN
         XP=(YP-COORD(2,ELTOP(5,INDELE)))*
     +        (COORD(1,ELTOP(5,INDELE))-COORD(1,ELTOP(7,INDELE)))/
     +        (COORD(2,ELTOP(5,INDELE))-COORD(2,ELTOP(7,INDELE)))+
     +        COORD(1,ELTOP(5,INDELE))
      ENDIF

      DO 300 I=1,NODEL
         ELEMCO(1,I)=COORD(1,ELTOP(2+I,INDELE))
         ELEMCO(2,I)=COORD(2,ELTOP(2+I,INDELE))
 300  CONTINUE

      DO 400 I=1,NODEL
         FLOWEL(I)=TPREV(ELTOP(2+I,INDELE))
 400  CONTINUE

      RETURN
      END

      SUBROUTINE TQL2(NM,N,D,E,Z,IERR,EPS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION D(N), E(N), Z(NM,N)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TQL2,
C     NUM. MATH. 11, 293-306(1968) BY BOWDLER, MARTIN, REINSCH, AND
C     WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS
C     OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE QL METHOD.
C     THE EIGENVECTORS OF A FULL SYMMETRIC MATRIX CAN ALSO
C     BE FOUND IF  TRED2  HAS BEEN USED TO REDUCE THIS
C     FULL MATRIX TO TRIDIAGONAL FORM.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY,
C
C        Z CONTAINS THE TRANSFORMATION MATRIX PRODUCED IN THE
C          REDUCTION BY  TRED2, IF PERFORMED.  IF THE EIGENVECTORS
C          OF THE TRIDIAGONAL MATRIX ARE DESIRED, Z MUST CONTAIN
C          THE IDENTITY MATRIX.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT BUT
C          UNORDERED FOR INDICES 1,2,...,IERR-1,
C
C        E HAS BEEN DESTROYED,
C
C        Z CONTAINS ORTHONORMAL EIGENVECTORS OF THE SYMMETRIC
C          TRIDIAGONAL (OR FULL) MATRIX.  IF AN ERROR EXIT IS MADE,
C          Z CONTAINS THE EIGENVECTORS ASSOCIATED WITH THE STORED
C          EIGENVALUES,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C
      IERR = 0
      IF (N .EQ. 1) GO TO 160
C
      DO 10   I = 2, N
   10 E(I-1) = E(I)
C
      F=0.0D0
      B=0.0D0
      E(N)=0.0D0
C
      DO 110   L = 1, N
         J = 0
         H=EPS*(ABS (D(L))+ABS (E(L)))
         IF (B .LT. H) B=H
C     ********** LOOK FOR SMALL SUB-DIAGONAL ELEMENT **********
         DO 20   M = L, N
            IF (ABS (E(M)).LE.B)  GO TO 30
C     ********** E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
   20    CONTINUE
C
   30    IF (M .EQ. L) GO TO 100
   40    IF (J .EQ. 30) GO TO 150
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         G = D(L)
         P=(D(L1)-G)/(2.0D0*E(L))
         R=SQRT (P*P+1.0D0)
         D(L)=E(L)/(P+SIGN (R,P))
         H = G - D(L)
C
         DO 50   I = L1, N
   50    D(I) = D(I) - H
C
         F = F + H
C     ********** QL TRANSFORMATION **********
         P = D(M)
         C=1.0D0
         S=0.0D0
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 90   II = 1, MML
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS (P).LT.ABS (E(I)))  GO TO 60
            C = E(I) / P
            R=SQRT (C*C+1.0D0)
            E(I+1) = S * P * R
            S = C / R
            C=1.0D0/R
            GO TO 70
   60       C = P / E(I)
            R=SQRT (C*C+1.0D0)
            E(I+1) = S * E(I) * R
            S=1.0D0/R
            C = C * S
   70       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
C     ********** FORM VECTOR **********
            DO 80   K = 1, N
               H = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * H
               Z(K,I) = C * Z(K,I) - S * H
   80       CONTINUE
C
   90    CONTINUE
C
         E(L) = S * P
         D(L) = C * P
         IF (ABS (E(L)).GT.B)  GO TO 40
  100    D(L) = D(L) + F
  110 CONTINUE
C     ********** ORDER EIGENVALUES AND EIGENVECTORS **********
      DO 140   II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 120   J = II, N
            IF (D(J) .GE. P) GO TO 120
            K = J
            P = D(J)
  120    CONTINUE
C
         IF (K .EQ. I) GO TO 140
         D(K) = D(I)
         D(I) = P
C
         DO 130   J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  130    CONTINUE
C
  140 CONTINUE
C
      GO TO 160
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
  150 IERR = L
  160 RETURN
C     ********** LAST CARD OF TQL2 **********
      END

      SUBROUTINE MOLDAT
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /MOLMEC/ HTYPE(4),NHCO(4,20),NNHCO,ITYPE,USEMM
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
     3       /KEYWRD/ KEYWRD
     4       /NATORB/ NATORB(107)
      COMMON /CORE  / CORE(107)
     1       /BETAS / BETAS(107),BETAP(107),BETAD(107)
     2       /MOLORB/ USPD(MAXORB),PSPD(MAXORB)
     3       /VSIPS / VS(107),VP(107),VD(107)
     4       /ONELEC/ USS(107),UPP(107),UDD(107)
      COMMON /ATHEAT/ ATHEAT
     1       /POLVOL/ POLVOL(107)
     2       /MULTIP/ DD(107),QQ(107),AM(107),AD(107),AQ(107)
     3       /TWOELE/ GSS(107),GSP(107),GPP(107),GP2(107),HSP(107)
     4                ,GSD(107),GPD(107),GDD(107)
     5       /IDEAS / GUESS1(107,10),GUESS2(107,10),GUESS3(107,10)
     6       /IDEAP / GUESP1(107,10),GUESP2(107,10),GUESP3(107,10)
      COMMON /ALPHA / ALP(107)
     1       /REFS/ ALLREF(107,4)
      COMMON /MNDO/  USSM(107), UPPM(107), UDDM(107), ZSM(107),
     1ZPM(107), ZDM(107), BETASM(107), BETAPM(107), BETADM(107),
     2ALPM(107), EISOLM(107), DDM(107), QQM(107), AMM(107),
     3ADM(107), AQM(107), GSSM(107), GSPM(107), GPPM(107),
     4GP2M(107), HSPM(107), POLVOM(107)
      COMMON /PM3 /  USSPM3(107), UPPPM3(107), UDDPM3(107), ZSPM3(107),
     1ZPPM3(107), ZDPM3(107), BETASP(107), BETAPP(107), BETADP(107),
     2ALPPM3(107), EISOLP(107), DDPM3(107), QQPM3(107), AMPM3(107),
     3ADPM3(107), AQPM3(107) ,GSSPM3(107), GSPPM3(107), GPPPM3(107),
     4GP2PM3(107), HSPPM3(107),POLVOP(107)
      COMMON /GEOM  / GEO(3,NUMATM)
      PARAMETER (MDUMY=MAXPAR**2-MPACK)
      COMMON /SCRACH/ RXYZ(MPACK), XDUMY(MDUMY)
*
*  COMMON BLOCKS FOR MINDO/3
*
      COMMON /ONELE3 /  USS3(18),UPP3(18)
     1       /ATOMI3 /  EISOL3(18),EHEAT3(18)
     2       /EXPON3 /  ZS3(18),ZP3(18)
*
*  END OF MINDO/3 COMMON BLOCKS
*
      COMMON /EXPONT/ ZS(107),ZP(107),ZD(107)
      COMMON /ATOMIC/ EISOL(107),EHEAT(107)
      DIMENSION COORD(3,NUMATM), ISWAP(2,20)
      CHARACTER*80 KEYWRD, OLDE(20)*6, ALLREF
      LOGICAL DEBUG, UHF,EXCI, TRIP, MINDO3, BIRAD, AM1, OPEN, LPM3,
     1USEMM
      DEBUG = (INDEX(KEYWRD,'MOLDAT').NE.0)
      LPM3  = (INDEX(KEYWRD,'PM3').NE.0)
      MINDO3= (INDEX(KEYWRD,'MINDO').NE.0)
      UHF=(INDEX(KEYWRD,'UHF') .NE. 0)
      AM1= (INDEX(KEYWRD,'AM1').NE.0)
      KHARGE=0
      I=INDEX(KEYWRD,'CHARGE')
      IF(I.NE.0) KHARGE=READA(KEYWRD,I)
      ELECS=-KHARGE
      NDORBS=0
      ATHEAT=0.D0
      EAT=0.D0
      NUMAT=0
      IF (   .NOT.   AM1  .AND. .NOT. LPM3 ) THEN
*
*    SWITCH IN MNDO PARAMETERS
*
C
C       ZERO OUT GAUSSIAN 1 FOR CARBON.  THIS WILL BE USED IN
C       ROTATE TO DECIDE WHETHER OR NOT TO USE AM1-TYPE GAUSSIANS
C
         GUESS1(6,1)=0.D0
         DO 10 I=1,107
            IF(.NOT.MINDO3) POLVOL(I)=POLVOM(I)
            ZS(I)=ZSM(I)
            ZP(I)=ZPM(I)
            ZD(I)=ZDM(I)
            USS(I)=USSM(I)
            UPP(I)=UPPM(I)
            UDD(I)=UDDM(I)
            BETAS(I)=BETASM(I)
            BETAP(I)=BETAPM(I)
            BETAD(I)=BETADM(I)
            ALP(I)=ALPM(I)
            EISOL(I)=EISOLM(I)
            DD(I)=DDM(I)
            QQ(I)=QQM(I)
            AM(I)=AMM(I)
            AD(I)=ADM(I)
            AQ(I)=AQM(I)
            GSS(I)=GSSM(I)
            GPP(I)=GPPM(I)
            GSP(I)=GSPM(I)
            GP2(I)=GP2M(I)
            HSP(I)=HSPM(I)
   10    CONTINUE
      ELSEIF( .NOT. AM1 .AND. LPM3) THEN
*
*    SWITCH IN MNDO-PM3 PARAMETERS
*
         DO 30 I=1,107
            DO 20 J=1,10
               GUESS1(I,J)=GUESP1(I,J)
               GUESS2(I,J)=GUESP2(I,J)
   20       GUESS3(I,J)=GUESP3(I,J)
            POLVOL(I)=POLVOP(I)
            ZS(I)=ZSPM3(I)
            ZP(I)=ZPPM3(I)
            ZD(I)=ZDPM3(I)
            USS(I)=USSPM3(I)
            UPP(I)=UPPPM3(I)
            UDD(I)=UDDPM3(I)
            BETAS(I)=BETASP(I)
            BETAP(I)=BETAPP(I)
            BETAD(I)=BETADP(I)
            ALP(I)=ALPPM3(I)
            EISOL(I)=EISOLP(I)
            DD(I)=DDPM3(I)
            QQ(I)=QQPM3(I)
            AM(I)=AMPM3(I)
            AD(I)=ADPM3(I)
            AQ(I)=AQPM3(I)
            GSS(I)=GSSPM3(I)
            GPP(I)=GPPPM3(I)
            GSP(I)=GSPPM3(I)
            GP2(I)=GP2PM3(I)
            HSP(I)=HSPPM3(I)
   30    CONTINUE
      ENDIF
C
C        SWAP IN OLD PARAMETERS FOR ELEMENTS.  OLDE CONTAINS THE
C        CHARACTER NAME OF THE ELEMENT, AND ISWAP(1,1:NEWELE) CONTAINS
C        THE ATOMIC NUMBER OF THE ELEMENT. ISWAP(2,1:NEWELE) CONTAINS
C        THE STORAGE ADDRESS OF THE OLD SET OF PARAMETERS.
C
      NEWELE=2
      OLDE(1)=' S1978'
      ISWAP(1,1)=16
      ISWAP(2,1)=91
      OLDE(2)='SI1978'
      ISWAP(1,2)=14
      ISWAP(2,2)=90
      DO 40 K=1,NEWELE
         IF(INDEX(KEYWRD,OLDE(K)).NE.0)THEN
            I=ISWAP(1,K)
            J=ISWAP(2,K)
            ALLREF(I,3)=ALLREF(J,1)
            ALLREF(I,1)=ALLREF(J,1)
            ZS(I)=ZS(J)
            ZP(I)=ZP(J)
            ZD(I)=ZD(J)
            USS(I)=USS(J)
            UPP(I)=UPP(J)
            UDD(I)=UDD(J)
            BETAS(I)=BETAS(J)
            BETAP(I)=BETAP(J)
            BETAD(I)=BETAD(J)
            ALP(I)=ALP(J)
            EISOL(I)=EISOL(J)
            DD(I)=DD(J)
            QQ(I)=QQ(J)
            AM(I)=AM(J)
            AD(I)=AD(J)
            AQ(I)=AQ(J)
            IF(GSS(J).NE.0)GSS(I)=GSS(J)
            IF(GPP(J).NE.0)GPP(I)=GPP(J)
            IF(GSP(J).NE.0)GSP(I)=GSP(J)
            IF(GP2(J).NE.0)GP2(I)=GP2(J)
            IF(HSP(J).NE.0)HSP(I)=HSP(J)
         ENDIF
   40 CONTINUE
      IF( MINDO3 ) THEN
         DO 50 I=1,17
            IF(I.EQ.2.OR.I.EQ.10)GOTO 50
            USS(I)=USS3(I)
            UPP(I)=UPP3(I)
            EISOL(I)=EISOL3(I)
            EHEAT(I)=EHEAT3(I)
            ZS(I)=ZS3(I)
            ZP(I)=ZP3(I)
   50    CONTINUE
      ENDIF
      IF(USS(1) .GT. -1.D0) THEN
         WRITE(6,'(''  THE HAMILTONIAN REQUESTED IS NOT AVAILABLE IN''
     1,'' THIS PROGRAM'')')
         CALL WRAPUP()
      ENDIF
      IA=1
      IB=0
      NHEAVY=0
      DO 100 II=1,NATOMS
         IF(LABELS(II).EQ.99.OR.LABELS(II).EQ.107) GOTO 100
         NUMAT=NUMAT+1
         NAT(NUMAT)=LABELS(II)
         NFIRST(NUMAT)=IA
         NI=NAT(NUMAT)
         ATHEAT=ATHEAT+EHEAT(NI)
         EAT   =EAT   +EISOL(NI)
         ELECS=ELECS+CORE(NI)
         IB=IA+NATORB(NI)-1
         NMIDLE(NUMAT)=IB
         IF(NATORB(NI).EQ.9)NDORBS=NDORBS+5
         IF(NATORB(NI).EQ.9)NMIDLE(NUMAT)=IA+3
         NLAST(NUMAT)=IB
         IF(IA.GT.MAXORB) GOTO 240
         USPD(IA)=USS(NI)
         IF(IA.EQ.IB) GOTO 90
         K=IA+1
         K1=IA+3
         DO 60 J=K,K1
            IF(J.GT.MAXORB) GOTO 240
            USPD(J)=UPP(NI)
   60    CONTINUE
         NHEAVY=NHEAVY+1
   70    IF(K1.EQ.IB)GOTO 90
         K=K1+1
         DO 80 J=K,IB
   80    USPD(J)=UDD(NI)
   90    CONTINUE
  100 IA=IB+1
      CALL REFER
      ATHEAT=ATHEAT-EAT*23.061D0
      NORBS=NLAST(NUMAT)
      IF(NORBS.GT.MAXORB)THEN
         WRITE(6,'(//10X,''**** MAX. NUMBER OF ORBITALS:'',I4,/
     1            10X,''NUMBER OF ORBITALS IN SYSTEM:'',I4)')
     2MAXORB,NORBS
         CALL WRAPUP()
      ENDIF
      NLIGHT=NUMAT-NHEAVY
      N2EL=50*NHEAVY*(NHEAVY-1)+10*NHEAVY*NLIGHT+(NLIGHT*(NLIGHT-1))/2
      IF(N2EL.GT.N2ELEC)THEN
         WRITE(6,'(//10X,''**** MAX. NUMBER OF TWO-ELECTRON INTEGRALS:''
     1,I8,/
     2            10X,''NUMBER OF TWO ELECTRON INTEGRALS IN SYSTEM:'',
     3I8)')
     4N2ELEC,N2EL
         CALL WRAPUP()
      ENDIF
C
C   NOW TO CALCULATE THE NUMBER OF LEVELS OCCUPIED
      TRIP=(INDEX(KEYWRD,'TRIPLET').NE.0)
      EXCI=(INDEX(KEYWRD,'EXCITED').NE.0)
      BIRAD=(EXCI.OR.INDEX(KEYWRD,'BIRAD').NE.0)
      IF(INDEX(KEYWRD,'C.I.') .NE. 0 .AND. UHF ) THEN
         WRITE(6,'(//10X,''C.I. NOT ALLOWED WITH UHF '')')
         CALL WRAPUP()
      ENDIF
C
C NOW TO WORK OUT HOW MANY ELECTRONS ARE IN EACH TYPE OF SHELL
C
      NALPHA=0
      NBETA=0
C
C      PROTECT DUMB USERS FROM DUMB ERRORS!
C
      NELECS=MAX(ELECS+0.5D0,0.D0)
      NELECS=MIN(2*NORBS,NELECS)
      NCLOSE=0
      NOPEN=0
      IF( UHF ) THEN
         FRACT=1.D0
         NBETA=NELECS/2
         IF( TRIP ) THEN
            IF(NBETA*2 .NE. NELECS) THEN
               WRITE(6,'(//10X,''TRIPLET SPECIFIED WITH ODD NUMBER'',
     1            '' OF ELECTRONS, CORRECT FAULT '')')
               CALL WRAPUP()
            ELSE
               WRITE(6,'(//'' TRIPLET STATE CALCULATION'')')
               NBETA=NBETA-1
            ENDIF
         ENDIF
         IF(INDEX(KEYWRD,'QUART').NE.0) THEN
            IF(NBETA*2 .EQ. NELECS) THEN
               WRITE(6,'(//10X,''QUARTET SPECIFIED WITH EVEN NUMBER'',
     1            '' OF ELECTRONS, CORRECT FAULT '')')
               CALL WRAPUP()
            ELSE
               WRITE(6,'(//'' QUARTET STATE CALCULATION'')')
               NBETA=NBETA-1
            ENDIF
         ENDIF
         IF(INDEX(KEYWRD,'QUINT').NE.0) THEN
            IF(NBETA*2 .NE. NELECS) THEN
               WRITE(6,'(//10X,''QUINTET SPECIFIED WITH ODD NUMBER'',
     1            '' OF ELECTRONS, CORRECT FAULT '')')
               CALL WRAPUP()
            ELSE
               WRITE(6,'(//'' QUINTET STATE CALCULATION'')')
               NBETA=NBETA-2
            ENDIF
         ENDIF
         IF(INDEX(KEYWRD,'SEXT').NE.0) THEN
            IF(NBETA*2 .EQ. NELECS) THEN
               WRITE(6,'(//10X,''SEXTET SPECIFIED WITH EVEN NUMBER'',
     1            '' OF ELECTRONS, CORRECT FAULT '')')
               CALL WRAPUP()
            ELSE
               WRITE(6,'(//'' SEXTET STATE CALCULATION'')')
               NBETA=NBETA-1
            ENDIF
         ENDIF
         NALPHA=NELECS-NBETA
         WRITE(6,'(//10X,''UHF CALCULATION, NO. OF ALPHA ELECTRONS ='',I
     13,/27X,''NO. OF BETA  ELECTRONS ='',I3)')NALPHA,NBETA
      ELSE
C
C   NOW TO DETERMINE OPEN AND CLOSED SHELLS
C
         OPEN=.FALSE.
         IELEC=0
         ILEVEL=0
         IF( TRIP .OR. EXCI .OR. BIRAD ) THEN
            IF( (NELECS/2)*2 .NE. NELECS) THEN
               WRITE(6,'(//10X,''SYSTEM SPECIFIED WITH ODD NUMBER'',
     1            '' OF ELECTRONS, CORRECT FAULT '')')
               CALL WRAPUP()
            ENDIF
            IF(BIRAD)WRITE(6,'(//'' SYSTEM IS A BIRADICAL'')')
            IF(TRIP )WRITE(6,'(//'' TRIPLET STATE CALCULATION'')')
            IF(EXCI )WRITE(6,'(//'' EXCITED STATE CALCULATION'')')
            IELEC=2
            ILEVEL=2
         ELSEIF((NELECS/2)*2.NE.NELECS) THEN
            IELEC=1
            ILEVEL=1
         ENDIF
         IF(INDEX(KEYWRD,'QUART').NE.0) THEN
            WRITE(6,'(//'' QUARTET STATE CALCULATION'')')
            IELEC=3
            ILEVEL=3
         ENDIF
         IF(INDEX(KEYWRD,'QUINT').NE.0) THEN
            WRITE(6,'(//'' QUINTET STATE CALCULATION'')')
            IELEC=4
            ILEVEL=4
         ENDIF
         IF(INDEX(KEYWRD,'SEXT').NE.0) THEN
            WRITE(6,'(//'' SEXTET STATE CALCULATION'')')
            IELEC=5
            ILEVEL=5
         ENDIF
         I=INDEX(KEYWRD,'OPEN(')
         IF(I.NE.0)THEN
            IELEC=READA(KEYWRD,I)
            ILEVEL=READA(KEYWRD,I+7)
         ENDIF
         NCLOSE=NELECS/2
         NOPEN = NELECS-NCLOSE*2
         IF( IELEC.NE.0 )THEN
            IF((NELECS/2)*2.EQ.NELECS .NEQV.
     1                  (IELEC/2)*2.EQ.IELEC) THEN
               WRITE(6,'('' IMPOSSIBLE NUMBER OF OPEN SHELL ELECTR
     1ONS'')')
               CALL WRAPUP()
            ENDIF
            NCLOSE=NCLOSE-IELEC/2
            NOPEN=ILEVEL
            FRACT=IELEC*1.D0/ILEVEL
            WRITE(6,'('' THERE ARE'',I3,'' DOUBLY FILLED LEVELS'')
     1')NCLOSE
         ENDIF
         WRITE(6,'(//10X,''RHF CALCULATION, NO. OF '',
     1''DOUBLY OCCUPIED LEVELS ='',I3)')NCLOSE
         IF(NOPEN.NE.0.AND.ABS(FRACT-1.D0).LT.1.D-4)
     1WRITE(6,'(/27X,''NO. OF SINGLY OCCUPIED LEVELS ='',I3)')NOPEN
         IF(NOPEN.NE.0.AND.ABS(FRACT-1.D0).GT.1.D-4)
     1WRITE(6,'(/27X,''NO. OF LEVELS WITH OCCUPANCY'',F6.3,''  ='',I3)')
     2FRACT,NOPEN
         NOPEN=NOPEN+NCLOSE
      ENDIF
C#      WRITE(6,'(''  NOPEN,NCLOSE,NALPHA,NBETA,FRACT'',4I4,F12.5)')
C#     1 NOPEN, NCLOSE, NLAPHA, NBETA, FRACT
      YY=FLOAT(KHARGE)/(NORBS+1.D-10)
      L=0
      DO 130 I=1,NUMAT
         NI=NAT(I)
         XX=1.D0/(NLAST(I)-NFIRST(I)+1+1.D-10)
         W=CORE(NI)*XX-YY
         IA=NFIRST(I)
         IC=NMIDLE(I)
         IB=NLAST(I)
         DO 110 J=IA,IC
            L=L+1
  110    PSPD(L)=W
         DO 120 J=IC+1,IB
            L=L+1
  120    PSPD(L)=0.D0
  130 CONTINUE
C
C   WRITE OUT THE INTERATOMIC DISTANCES
C
      CALL GMETRY(GEO,COORD)
      RMIN=100.D0
      L=0
      DO 140 I=1,NUMAT
         DO 140 J=1,I
            L=L+1
            RXYZ(L)=SQRT((COORD(1,I)-COORD(1,J))**2+
     1                     (COORD(2,I)-COORD(2,J))**2+
     2                     (COORD(3,I)-COORD(3,J))**2)
            IF(RMIN.GT.RXYZ(L) .AND. I .NE. J .AND.
     1 (NAT(I).LT.103 .OR. NAT(J).LT.103)) THEN
               IMINR=I
               JMINR=J
               RMIN=RXYZ(L)
            ENDIF
  140 CONTINUE
      NNHCO=0
C
C   SET UP MOLECULAR-MECHANICS CORRECTION TO -(C=O)-(NH)- LINKAGE
C   THIS WILL BE USED IF MMOK HAS BEEN SPECIFIED.
C
         ITYPE=1
         IF(INDEX(KEYWRD,'AM1').NE.0)ITYPE=2
         IF(INDEX(KEYWRD,'PM3').NE.0)ITYPE=3
         IF(INDEX(KEYWRD,'MINDO').NE.0)ITYPE=4
C
C   IDENTIFY O=C-N-H SYSTEMS VIA THE INTERATOMIC DISTANCES MATRIX
         DO 190 I=1,NUMAT
            IF(NAT(I).NE.8) GOTO 190
            DO 180 J=1,NUMAT
               IF(NAT(J).NE.6) GOTO 180
               IJ=MAX(I,J)
               JI=I+J-IJ
               IF(RXYZ((IJ*(IJ-1))/2+JI).GT.1.3)GOTO 180
               DO 170 K=1,NUMAT
                  IF(NAT(K).NE.7) GOTO 170
                  JK=MAX(J,K)
                  KJ=J+K-JK
                  IF(RXYZ((JK*(JK-1))/2+KJ).GT.1.6)GOTO 170
                  DO 160 L=1,NUMAT
                     IF(NAT(L).NE.1) GOTO 160
                     KL=MAX(K,L)
                     LK=K+L-KL
                     IF(RXYZ((KL*(KL-1))/2+LK).GT.1.3)GOTO 160
C
C   WE HAVE A H-N-C=O SYSTEM.  THE ATOM NUMBERS ARE L-K-J-I
C   NOW SEARCH OUT ATOM ATTACHED TO NITROGEN, THIS SPECIFIES
C   THE SYSTEM X-N-C=O
C
                     DO 150 M=1,NUMAT
                        IF(M.EQ.K.OR.M.EQ.L.OR.M.EQ.J) GOTO 150
                        MK=MAX(M,K)
                        KM=M+K-MK
                        IF(RXYZ((MK*(MK-1))/2+KM).GT.1.7)GOTO 150
                        NNHCO=NNHCO+1
                        NHCO(1,NNHCO)=I
                        NHCO(2,NNHCO)=J
                        NHCO(3,NNHCO)=K
                        NHCO(4,NNHCO)=M
                        NNHCO=NNHCO+1
                        NHCO(1,NNHCO)=I
                        NHCO(2,NNHCO)=J
                        NHCO(3,NNHCO)=K
                        NHCO(4,NNHCO)=L
                        GOTO 160
  150                CONTINUE
  160             CONTINUE
  170          CONTINUE
  180       CONTINUE
  190    CONTINUE
      IF(NNHCO.NE.0)THEN
      IF(INDEX(KEYWRD,'MMOK').NE.0) THEN
      WRITE(6,'(A)')' MOLECULAR MECHANICS CORRECTION APPLIED TO PEPTIDE 
     +LINKAGE'
      ELSEIF(INDEX(KEYWRD,'NOMM').NE.0)THEN
      WRITE(6,'(A,I2,2A)')' THERE ARE ',NNHCO/2,' PEPTIDE LINKAGES',
     1' IDENTIFIED IN THIS SYSTEM'
      WRITE(6,'(A)')' IF YOU WANT MM CORRECTION TO THE CONH BARRIER, ADD
     + THE KEY-WORD "MMOK"'
      NNHCO=0
      ELSE
      WRITE(6,'(A)')' THIS SYSTEM CONTAINS -HNCO- GROUPS.'
      WRITE(6,'(A)')' YOU MUST SPECIFY "NOMM" OR "MMOK" REGARDING MOLECU
     +LAR MECHANICS CORRECTION'
      CALL WRAPUP()
      ENDIF
      ENDIF
      IF (INDEX(KEYWRD,'NOINTER') .EQ. 0) THEN
         WRITE(6,'(//10X,''  INTERATOMIC DISTANCES'')')
         CALL VECPRT(RXYZ,NUMAT)
      ENDIF
      IF(RMIN.LT.0.8D0.AND.INDEX(KEYWRD,'GEO-OK') .EQ.0) THEN
         WRITE(6,200)IMINR,JMINR,RMIN
  200    FORMAT(//,'   ATOMS',I3,' AND',I3,' ARE SEPARATED BY',F8.4,
     1' ANGSTROMS.',/'   TO CONTINUE CALCULATION SPECIFY "GEO-OK"')
         CALL WRAPUP()
      ENDIF
      IF(.NOT. DEBUG) RETURN
      WRITE(6,210)NUMAT,NORBS,NDORBS,NATOMS
  210 FORMAT('   NUMBER OF REAL ATOMS:',I4,/
     1      ,'   NUMBER OF ORBITALS:  ',I4,/
     2      ,'   NUMBER OF D ORBITALS:',I4,/
     3      ,'   TOTAL NO. OF ATOMS:  ',I4)
      WRITE(6,220)(USPD(I),I=1,NORBS)
  220 FORMAT('   ONE-ELECTRON DIAGONAL TERMS',/,10(/,10F8.3))
      WRITE(6,230)(PSPD(I),I=1,NORBS)
  230 FORMAT('   INITIAL P FOR ALL ATOMIC ORBITALS',/,10(/,10F8.3))
      RETURN
  240 WRITE(6,'(//10X,'' MAXIMUM NUMBER OF ATOMIC ORBITALS EXCEEDED'')')
      WRITE(6,'(  10X,'' MAXIMUM ALLOWED ='',I4)')MAXORB
      CALL WRAPUP()
      END

C     *****************
      SUBROUTINE PRFILE(
C     *****************
     >                   NV,NW1,ISU3R,
     >                   ITEMAX,METHIT)
C
C
      COMMON / PERF / RTIME(15),IPRO
C
      DOUBLE PRECISION     RTIME,
     >                     ZERO,
     >                     PFM,MFLOP,
     >                     FGP,FGP1,FGP2,
     >                     TIME
C
C
      PARAMETER( IVARM = 7       )
      PARAMETER( FGP1  = 9.936D3 )
      PARAMETER( FGP2  = 1.772D3 )
      PARAMETER( MFLOP = 1.D-6   )
      PARAMETER( ZERO  = 0.D0    )
C
C
C     -----------------------------------------------------------
C
C
C     TIME OF THE PURE LINK UPDATE (EXCLUDING MEASUREMENT ROUTINES)
C
C
      TIME  = RTIME(1) - RTIME(7)
C
C
      IF( IPRO .GE. 1 ) THEN
C
          RTIME( 8) = ( RTIME( 8) / RTIME(3) ) * 1.D2
          RTIME( 9) = ( RTIME( 9) / RTIME(4) ) * 1.D2
          RTIME(10) = ( RTIME(10) / RTIME(4) ) * 1.D2
          RTIME(11) = ( RTIME(11) / RTIME(4) ) * 1.D2
          RTIME(12) = ( RTIME(12) / RTIME(4) ) * 1.D2
          RTIME(13) = ( RTIME(13) / RTIME(4) ) * 1.D2
          RTIME(14) = ( RTIME(14) / RTIME(4) ) * 1.D2
          RTIME(15) = ( RTIME(15) / RTIME(4) ) * 1.D2
C
          DO 60 I = 2,IVARM
          RTIME(I) = ( RTIME(I) / RTIME(1) ) * 1.D2
   60     CONTINUE
C
C
C         PRINT RESULTS
C
C
C         LEVEL 1:
C
C
                                   WRITE(NW1,1000)
          IF( RTIME(1) .NE. 0.D0 ) WRITE(NW1,1010) RTIME( 1)
          IF( RTIME(2) .NE. 0.D0 ) WRITE(NW1,1020) RTIME( 2)
          IF( RTIME(3) .NE. 0.D0 ) WRITE(NW1,1030) RTIME( 3)
          IF( RTIME(4) .NE. 0.D0 ) WRITE(NW1,1040) RTIME( 4)
          IF( RTIME(5) .NE. 0.D0 ) WRITE(NW1,1050) RTIME( 5)
          IF( RTIME(6) .NE. 0.D0 ) WRITE(NW1,1060) RTIME( 6)
          IF( RTIME(7) .NE. 0.D0 ) WRITE(NW1,1070) RTIME( 7)
C
C
C         LEVEL 2:
          IF(IPRO .GE. 2) THEN
C
C
          IF( RTIME( 8) .NE. 0.D0 ) WRITE(NW1,1080) RTIME( 8)
          IF( RTIME( 9) .NE. 0.D0 ) WRITE(NW1,1090) RTIME( 9)
          IF( RTIME(10) .NE. 0.D0 ) WRITE(NW1,1100) RTIME(10)
          IF( RTIME(11) .NE. 0.D0 ) WRITE(NW1,1110) RTIME(11)
          IF( RTIME(12) .NE. 0.D0 ) WRITE(NW1,1120) RTIME(12)
          IF( RTIME(13) .NE. 0.D0 ) WRITE(NW1,1130) RTIME(13)
          IF( RTIME(14) .NE. 0.D0 ) WRITE(NW1,1140) RTIME(14)
          IF( RTIME(15) .NE. 0.D0 ) WRITE(NW1,1150) RTIME(15)
C
          ENDIF
C
      ENDIF
C
C
      WRITE( NW1,2000 ) ISU3R
C
C
C     PERFORMANCE:
C
      WRITE( NW1,2500) TIME
C
      FGP    =  FGP1  + DBLE( METHIT ) * FGP2
      PFM    =  MFLOP * FGP * DBLE( ITEMAX ) * DBLE( NV ) / TIME
      WRITE( NW1,3000) PFM
C
C
 1000 FORMAT(2(/),15X,'PROFILING INFORMATION:'/
     >        15X,'--------------------- '/)
 1010 FORMAT( 15X,'EXECUTION TIME OF THE ITERATION LOOP: '
     >        ,F12.3,' sec' /)
 1020 FORMAT( 15X,'MKTBL             :',F6.2,' %' )
 1030 FORMAT( 15X,'STAPLE            :',F6.2,' %' )
 1040 FORMAT( 15X,'METRO             :',F6.2,' %' )
 1050 FORMAT( 15X,'SU3 RENORM.       :',F6.2,' %' )
 1060 FORMAT( 15X,'SUREXC            :',F6.2,' %' )
 1070 FORMAT( 15X,'WLINE             :',F6.2,' %' )
C
 1080 FORMAT(/15X,'WITHIN STAPLE     :'/
     >        15X,'       PRO        :',F6.2,' %' )
 1090 FORMAT(/15X,'WITHIN METRO      :'/
     >        15X,'       PRO        :',F6.2,' %' )
 1100 FORMAT( 15X,'       ADD        :',F6.2,' %' )
 1110 FORMAT( 15X,'       EXP        :',F6.2,' %' )
 1120 FORMAT( 15X,'       DRAND      :',F6.2,' %' )
 1130 FORMAT( 15X,'       GATHER     :',F6.2,' %' )
 1140 FORMAT( 15X,'       TRACE      :',F6.2,' %' )
 1150 FORMAT( 15X,'       ACCEPT     :',F6.2,' %' )
C
C
 2000 FORMAT(2(/),15X,'MODUL FOR RENORMALIZING LINKS FINALLY WAS ',I4 )
C
 2500 FORMAT(2(/),15X,'EXECUTION TIME                :',F12.3,' sec'/
     >            15X,'-------------- ')
C
 3000 FORMAT(2(/),15X,'PERFORMANCE (PURE LINK UPDATE):',F8.2,' Mflop/s'/
     >            15X,'----------- ')
C
C
      END

C     ****************
      SUBROUTINE WLINE(
C     ****************
     >                 NVE,NXYZ,NXYZE,NT,
     >                 WLR,WLI,
     >                 LINKS,
     >                 GTS,
     >                 WK1,WK2,WK3)
C
C
      DOUBLE PRECISION LINKS(NVE,18,4),
     >                 WK1(NXYZ,18),WK2(NXYZ,18),WK3(NXYZ,18),
     >                 WLR,WLI,
     >                 THREE,ZERO
C
C
      INTEGER          GTS(NXYZ)
C
C
      PARAMETER( THREE = 3.D0 )
      PARAMETER( ZERO  = 0.D0 )
C
C
C     CALCULATE THE PRODUCT OF SU3 MATRICES IN T-DIRECTION
C
C
C     LOOP OVER TWO CHESS BOARD COLOURS
C
C
      WLR = ZERO
      WLI = ZERO
C
C
C     ***********
      CALL GATHER( NXYZ,NXYZ,WK1,NVE,LINKS(1,1,4),GTS(1),0 )
C     ***********
C
C
C     LOOP OVER NT T-SLICES
C
C
      DO 20 IT = 1,NT-1
C
C
C     ***********
      CALL GATHER( NXYZ,NXYZ,WK2,NVE,LINKS(1,1,4),GTS(1),IT * NXYZE )
C     ***********
C
C
C     ********
      CALL PRO(NXYZ,NXYZ,1,WK3,WK1,WK2)
C     ********
C
C
      DO 40 ISM = 1,18
      DO 40 ILP = 1,NXYZ
      WK1(ILP,ISM) = WK3(ILP,ISM)
   40 CONTINUE
C
C
   20 CONTINUE
C
C
C     CALCULATING THE TRACES
C
C
      DO 50 ILP = 1,NXYZ
C
      WLR = WLR + WK1(ILP, 1) + WK1(ILP, 5) + WK1(ILP, 9)
      WLI = WLI + WK1(ILP,10) + WK1(ILP,14) + WK1(ILP,18)
C
   50 CONTINUE
C
      WLR = WLR / THREE
      WLI = WLI / THREE
C
      END

      SUBROUTINE NEWIT (UPREV,U,DOFNOD,VERR)
      DOUBLE PRECISION UPREV(*),U(*),VERR,VENORM
      INTEGER DOFNOD
      DOUBLE PRECISION ENORM,DIFFER,EPS
      PARAMETER(EPS=1.0D-9)

      ENORM = 0.0D0
      DIFFER = 0.0D0

      DO 10 I=1,DOFNOD
         DIFFER=DIFFER+DABS(U(I)-UPREV(I))**2.0D0
         ENORM=ENORM+DABS(U(I))**2.0D0
         UPREV(I)=U(I)
 10   CONTINUE

      VENORM=DSQRT(DIFFER)

      IF (ENORM .GT. EPS) THEN
         VERR=DSQRT(DIFFER/ENORM)
      ELSE
         VERR=SQRT(DIFFER)
      ENDIF

      RETURN
      END

      SUBROUTINE VECPRT (A,NUMM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION  A(*)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /ELEMTS/ ELEMNT(107)
C**********************************************************************
C
C  VECPRT PRINTS A LOWER-HALF TRIANGLE OF A SQUARE MATRIX, THE
C         LOWER-HALF TRIANGLE BEING STORED IN PACKED FORM IN THE
C         ARRAY "A"
C
C ON INPUT:
C      A      = ARRAY TO BE PRINTED
C      NUMM   = SIZE OF ARRAY TO BE PRINTED
C(REF) NUMAT  = NUMBER OF ATOMS IN THE MOLECULE (THIS IS NEEDED TO
C               DECIDE IF AN ATOMIC ARRAY OR ATOMIC ORBITAL ARRAY IS
C               TO BE PRINTED
C(REF) NAT    = LIST OF ATOMIC NUMBERS
C(REF) NFIRST = LIST OF ORBITAL COUNTERS
C(REF) NLAST  = LIST OF ORBITAL COUNTERS
C
C  NONE OF THE ARGUMENTS ARE ALTERED BY THE CALL OF VECPRT
C
C*********************************************************************
      DIMENSION NATOM(MAXORB)
      CHARACTER * 6 LINE(21)
      CHARACTER*2 ELEMNT,ATORBS(9), ITEXT(MAXORB), JTEXT(MAXORB)
      DATA ATORBS/' S','PX','PY','PZ','X2','XZ','Z2','YZ','XY'/
      IF(NUMAT.NE.0.AND.NUMAT.EQ.NUMM) THEN
C
C    PRINT OVER ATOM COUNT
C
         DO 10 I=1,NUMAT
            ITEXT(I)='  '
            JTEXT(I)=ELEMNT(NAT(I))
            NATOM(I)=I
   10    CONTINUE
      ELSE
         IF (NUMAT.NE.0.AND.NLAST(NUMAT) .EQ. NUMM) THEN
            DO 30 I=1,NUMAT
               JLO=NFIRST(I)
               JHI=NLAST(I)
               L=NAT(I)
               K=0
               DO 20 J=JLO,JHI
                  K=K+1
                  ITEXT(J)=ATORBS(K)
                  JTEXT(J)=ELEMNT(L)
                  NATOM(J)=I
   20          CONTINUE
   30       CONTINUE
         ELSE
            NUMB=ABS(NUMM)
            DO 40 I=1,NUMB
               ITEXT(I) = '  '
               JTEXT(I) = '  '
   40       NATOM(I)=I
         ENDIF
      ENDIF
      NUMB=ABS(NUMM)
      DO 50 I=1,21
   50 LINE(I)='------'
      LIMIT=(NUMB*(NUMB+1))/2
      KK=8
      NA=1
   60 LL=0
      M=MIN0((NUMB+1-NA),6)
      MA=2*M+1
      M=NA+M-1
      WRITE(6,100)(ITEXT(I),JTEXT(I),NATOM(I),I=NA,M)
      WRITE (6,110) (LINE(K),K=1,MA)
      DO 80 I=NA,NUMB
         LL=LL+1
         K=(I*(I-1))/2
         L=MIN0((K+M),(K+I))
         K=K+NA
         IF ((KK+LL).LE.50) GO TO 70
         WRITE (6,120)
         WRITE (6,100) (ITEXT(N),JTEXT(N),NATOM(N),N=NA,M)
         WRITE (6,110) (LINE(N),N=1,MA)
         KK=4
         LL=0
   70    WRITE (6,130) ITEXT(I),JTEXT(I),NATOM(I),(A(N),N=K,L)
   80 CONTINUE
      IF (L.GE.LIMIT) GO TO 90
      KK=KK+LL+4
      NA=M+1
      IF ((KK+NUMB+1-NA).LE.50) GO TO 60
      KK=4
      WRITE (6,120)
      GO TO 60
   90 RETURN
C
  100 FORMAT (1H0/13X,10(1X,A2,1X,A2,I3,2X))
  110 FORMAT (1H ,21A6)
  120 FORMAT (1H1)
  130 FORMAT (1H ,A2,1X,A2,I5,10F11.6)
C
      END

      FUNCTION AABACD(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION IOCCA1(NMOS), IOCCB1(NMOS), IOCCA2(NMOS), IOCCB2(NMOS)
***********************************************************************
*
* AABACD EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
*       BY TWO ALPHA MOS. ONE MICROSTATE HAS ALPHA ELECTRONS IN
*       M.O.S PSI(I) AND PSI(J) FOR WHICH THE OTHER MICROSTATE HAS
*       ELECTRONS IN PSI(K) AND PSI(L)
*
***********************************************************************
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      IJ=0
      DO 10 I=1,NMOS
   10 IF(IOCCA1(I) .LT. IOCCA2(I)) GOTO 20
   20 DO 30 J=I+1,NMOS
         IF(IOCCA1(J) .LT. IOCCA2(J)) GOTO 40
   30 IJ=IJ+IOCCA2(J)+IOCCB2(J)
   40 DO 50 K=1,NMOS
   50 IF(IOCCA1(K) .GT. IOCCA2(K)) GOTO 60
   60 DO 70 L=K+1,NMOS
         IF(IOCCA1(L) .GT. IOCCA2(L)) GOTO 80
   70 IJ=IJ+IOCCA1(L)+IOCCB1(L)
   80 IJ=IJ+IOCCB2(I)+IOCCB1(K)
      AABACD=(XY(I,K,J,L)-XY(I,L,K,J))*((-1)**(IJ-(IJ/2)*2))
      RETURN
      END

      SUBROUTINE MXV (A,NROWS,X,NCOLS,Y)
      INTEGER NROWS, NCOLS
      DOUBLE PRECISION A(NROWS,NCOLS), X(*), Y(*)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      INTEGER I, J
      DO 100 I=1,NROWS
         Y(I) = ZERO
 100  CONTINUE
      DO 110 J=1,NCOLS
         CALL SAXPY (NROWS,X(J),A(1,J),1,Y,1)
 110  CONTINUE
      RETURN
      END

      SUBROUTINE TRIB(JDIM,A,B,C,X,F,NL,NU)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DIMENSION A(JDIM),B(JDIM),C(JDIM),X(JDIM),F(JDIM)
C
      X(NL)=C(NL)/B(NL)
      F(NL)=F(NL)/B(NL)
      NLP1 = NL +1
      DO 1 J=NLP1,NU
         Z=1./(B(J)-A(J)*X(J-1))
         X(J)=C(J)*Z
         F(J)=(F(J)-A(J)*F(J-1))*Z
1     CONTINUE
C
      NUPNL=NU+NL
      DO 2 J1=NLP1,NU
         J=NUPNL-J1
         F(J)=F(J)-X(J)*F(J+1)
2     CONTINUE
C
      RETURN
      END

      SUBROUTINE FILERX(JDIM,KDIM,Q,S,XYJ,COEF2,COEF4,WORK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK

C
      DIMENSION Q(JDIM,KDIM,4),S(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION COEF2(JDIM,KDIM),COEF4(JDIM,KDIM)
C
      DIMENSION WORK(JDIM,KDIM,3)
C
C   FOURTH ORDER SMOOTHING, ADDED EXPLICITLY TO RHS
C   SECOND ORDER NEAR SHOCKS WITH PRESSURE GRD COEFF.
C
C  XI DIRECTION 
C
C   START DIFFERENCES EACH VARIABLE SEPARATELY
C
      DO 15 N = 1,4
C
      DO 16 J = JLOW,JUP
      JPL = JPLUS(J)
      DO 16 K = KLOW,KUP
      WORK(J,K,1) = Q(JPL,K,N)*XYJ(JPL,K) - Q(J,K,N)*XYJ(J,K)
16    CONTINUE          
C
C   C MESH BC
C
         IF(.NOT.PERIDC  )THEN
         J1 = JBEGIN
         J2 = JEND
         DO 76 K = KLOW,KUP
         WORK(J1,K,1) = Q(J1+1,K,N)*XYJ(J1+1,K) - 
     *                    Q(J1,K,N)*XYJ(J1,K)
         WORK(J2,K,1) = WORK(J2-1,K,1)
76       CONTINUE
         ENDIF
C
C   FOR FOURTH ORDER      
C
      DO 17 J = JLOW,JUP
      JPL = JPLUS(J)
      JMI = JMINU (J)
      DO 17 K = KLOW,KUP
      WORK(J,K,2) = WORK(JPL,K,1) - 2.* WORK(J,K,1) + WORK(JMI,K,1)
17    CONTINUE
C
C   C MESH BC
C
         IF(.NOT.PERIDC  )THEN
         J1 = JBEGIN
         J2 = JEND
         DO 77 K = KLOW,KUP
         WORK(J1,K,2) = Q(J1+2,K,N)*XYJ(J1+2,K) - 
     *         2.*Q(J1+1,K,N)*XYJ(J1+1,K) + Q(J1,K,N)*XYJ(J1,K)
         WORK(J2,K,2) = 0.
77       CONTINUE
         ENDIF
C
C
C   FORM DISSIPATION TERM
C
      DO 19 J = JLOW,JUP
      DO 19 K = KLOW,KUP
      WORK(J,K,3) = (COEF2(J,K)*WORK(J,K,1) - COEF4(J,K)*WORK(J,K,2))
19    CONTINUE
C
C   C MESH BC
C
         IF(.NOT.PERIDC  )THEN
         J1 = JBEGIN
         J2 = JEND
         DO 79 K = KLOW,KUP
         WORK(J1,K,3) = (COEF2(J1,K)*WORK(J1,K,1) - 
     +                   COEF4(J1,K)*WORK(J1,K,2))
         WORK(J2,K,3) = 0.
79       CONTINUE
         ENDIF
C
C  ADD IN DISSIPATION
C
C
      DTD = DT / (1. + PHIDT)
C
      DO 20 J = JLOW,JUP
      JMI = JMINU (J)
      DO 20 K = KLOW,KUP
      S(J,K,N) = S(J,K,N) + (WORK(J,K,3) - WORK(JMI,K,3))*DTD
20    CONTINUE
C
15    CONTINUE
C
      RETURN
      END

        SUBROUTINE XPENTP(JDIM,KDIM,A,B,C,D,E,U1,U2,U3,U4,F,
     *                     JL,JU,KL,KU)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
        DOUBLE PRECISION LD,LD1,LD2,LDI,LDD,LU
        DIMENSION A(JDIM,KDIM),B(JDIM,KDIM),C(JDIM,KDIM),D(JDIM,KDIM)
        DIMENSION E(JDIM,KDIM),F(JDIM,KDIM),U1(JDIM,KDIM)
        DIMENSION U2(JDIM,KDIM),U3(JDIM,KDIM),U4(JDIM,KDIM)
C
        COMMON/WORKSP/LDA(MAXJ),LDB(MAXJ),LUS(MAXJ),
     *         LDS(MAXJ),WORK(MAXJ,88)
        DOUBLE PRECISION LDA,LDB,LUS,LDS
C
C        ! START FORWARD GENERATION PROCESS AND SWEEP
C
        I = JL
        DO 10 K = KL,KU
        LD = C(I,K)
        LDI = 1./LD
        U1(I,K) = D(I,K)*LDI
        U2(I,K) = E(I,K)*LDI
        U3(I,K) = A(I,K)*LDI
        U4(I,K) = B(I,K)*LDI
        F(I,K) = F(I,K)*LDI
10      CONTINUE
C
        I = JL+1
        DO 20 K = KL,KU
        LD1 = B(I,K)
        LD = C(I,K) - LD1*U1(I-1,K)
        LDI = 1./LD
        U1(I,K) = (D(I,K) - LD1*U2(I-1,K))*LDI
        U2(I,K) = E(I,K)*LDI
        U3(I,K) = -LD1*U3(I-1,K)*LDI
        U4(I,K) = (A(I,K) -LD1*U4(I-1,K))*LDI
        F(I,K) = (F(I,K) - LD1*F(I-1,K))*LDI
20      CONTINUE
C
          DO 1 I = JL+2,JU-4
                DO 11 K = KL,KU
                LD2 = A(I,K)
                LD1 = B(I,K) - LD2*U1(I-2,K)
                LD = C(I,K) - (LD2*U2(I-2,K) + LD1*U1(I-1,K))
                LDI = 1./LD
                U1(I,K) = (D(I,K) - LD1*U2(I-1,K))*LDI
                U2(I,K) = E(I,K)*LDI
                U3(I,K) = (-LD2*U3(I-2,K) - LD1*U3(I-1,K))*LDI
                U4(I,K) = (-LD2*U4(I-2,K) - LD1*U4(I-1,K))*LDI
                F(I,K) = (F(I,K) - LD2*F(I-2,K) - LD1*F(I-1,K))*LDI
11              CONTINUE
1           CONTINUE
C
                I = JU-3
                DO 12 K = KL,KU
                LD2 = A(I,K)
                LD1 = B(I,K) - LD2*U1(I-2,K)
                LD = C(I,K) - (LD2*U2(I-2,K) + LD1*U1(I-1,K))
                LDI = 1./LD
                U1(I,K) = (D(I,K) - LD1*U2(I-1,K))*LDI
                U3(I,K) = (E(I,K) - LD2*U3(I-2,K) - LD1*U3(I-1,K))*LDI
                U4(I,K) = (-LD2*U4(I-2,K) - LD1*U4(I-1,K))*LDI
                F(I,K) = (F(I,K) - LD2*F(I-2,K) - LD1*F(I-1,K))*LDI
12              CONTINUE
C
        I = JU-2
        DO 22 K = KL,KU
        LD2 = A(I,K)
        LD1 = B(I,K) - LD2*U1(I-2,K)
        LD = C(I,K) - (LD2*U2(I-2,K) + LD1*U1(I-1,K))
        LDI = 1./LD
        U3(I,K) = (D(I,K) - LD2*U3(I-2,K) - LD1*U3(I-1,K))*LDI
        U4(I,K) = (E(I,K) - LD2*U4(I-2,K) - LD1*U4(I-1,K))*LDI
        F(I,K) = (F(I,K) - LD2*F(I-2,K) - LD1*F(I-1,K))*LDI
22      CONTINUE
C
        I = JU-1
        DO 32 K = KL,KU
        LDA(K) = E(I,K)
        LDB(K) = -LDA(K)*U1(JL,K)
        F(I,K) = F(I,K) - LDA(K)*F(JL,K) - LDB(K)*F(JL+1,K)
        LDS(K) = LDA(K)*U3(JL,K) + LDB(K)*U3(JL+1,K)
        U4(I,K) = LDA(K)*U4(JL,K) + LDB(K)*U4(JL+1,K)
32      CONTINUE

        DO 3 M = JL+2,JU-4
           DO 14 K = KL,KU
           LDD = -LDA(K)*U2(M-2,K) - LDB(K)*U1(M-1,K)
           LDA(K) = LDB(K)
           LDB(K) = LDD
           LDS(K) = LDS(K) + LDD*U3(M,K)
           U4(I,K) = U4(I,K) + LDD*U4(M,K)
           F(I,K) = F(I,K) - LDD*F(M,K)
14         CONTINUE
3       CONTINUE
C
        M = JU-3
        DO 15 K = KL,KU
        LDD = A(I,K) - LDA(K)*U2(M-2,K) - LDB(K)*U1(M-1,K)
        LDA(K) = LDB(K)
        LDB(K) = LDD
        LDS(K) = LDS(K) + LDD*U3(M,K)
        U4(I,K) = U4(I,K) + LDD*U4(M,K)
        F(I,K) = F(I,K) - LDD*F(M,K)
15      CONTINUE
        M = JU-2
        DO 25 K = KL,KU
        LDD = B(I,K) - LDA(K)*U2(M-2,K) - LDB(K)*U1(M-1,K)
        LDA(K) = LDB(K)
        LDB(K) = LDD
        LDS(K) = LDS(K)+ LDD*U3(M,K)
        U4(I,K) = U4(I,K) + LDD*U4(M,K)
        F(I,K) = F(I,K) - LDD*F(M,K)
25      CONTINUE
C
        DO 35 K = KL,KU
        LDS(K) = C(I,K) - LDS(K)
        LDI = 1./LDS(K)
        U4(I,K) = (D(I,K) - U4(I,K))*LDI
        F(I,K) = F(I,K)*LDI
35      CONTINUE
C
C    THIS BREAKUP OF K LOOPS IS VERY IMPORTANT
C
        I = JU
        DO 16 K = KL,KU
        LDA(K) = D(I,K)
        LDB(K) = E(I,K) - LDA(K)*U1(JL,K)
        LUS(K) = LDA(K)*U3(JL,K) + LDB(K)*U3(JL+1,K)
        LDS(K) = LDA(K)*U4(JL,K) + LDB(K)*U4(JL+1,K)
        F(I,K) = F(I,K) - LDA(K)*F(JL,K) - LDB(K)*F(JL+1,K)
C
16      CONTINUE
C
        DO 4 M = JL+2,JU-3
           DO 17 K = KL,KU
           LDD = -LDA(K)*U2(M-2,K) - LDB(K)*U1(M-1,K)
           LDA(K) = LDB(K)
           LDB(K) = LDD
           LUS(K) = LUS(K) + LDD*U3(M,K)
           LDS(K) = LDS(K) + LDD*U4(M,K)
           F(I,K) = F(I,K) - LDD*F(M,K)
17         CONTINUE
4       CONTINUE
C
        M = JU-2
        DO 18 K = KL,KU
        LDD = A(I,K) - LDA(K)*U2(M-2,K) - LDB(K)*U1(M-1,K)
        LDA(K) = LDB(K)
        LDB(K) = LDD
        LUS(K) = LUS(K) + LDD*U3(M,K)
        LDS(K) = LDS(K) + LDD*U4(M,K)
        F(I,K) = F(I,K) - LDD*F(M,K)
18      CONTINUE
        M = JU-1
        DO 28 K = KL,KU
        LDD = B(I,K) - LUS(K)
        F(I,K) = F(I,K) - LDD*F(M,K)
        LDS(K) = C(I,K) - LDD*U4(M,K) - LDS(K)
        LDI = 1./LDS(K)
        F(I,K) = F(I,K)*LDI
28      CONTINUE
C
C        !  BACK SWEEP SOLUTION
C
      DO 19 K = KL,KU
      F(JU,K) = F(JU,K)
      F(JU-1,K) = F(JU-1,K) - U4(JU-1,K)*F(JU,K)
      F(JU-2,K) = F(JU-2,K) - U4(JU-2,K)*F(JU,K) - U3(JU-2,K)*F(JU-1,K)
      F(JU-3,K) = F(JU-3,K) - U4(JU-3,K)*F(JU,K) - U3(JU-3,K)*F(JU-1,K)
     *                - U1(JU-3,K)*F(JU-2,K)
19      CONTINUE
C
        DO 2 I = 4,JU-JL
        IX = JU-I
          DO 50 K = KL,KU
          F(IX,K) = F(IX,K) - U4(IX,K)*F(JU,K) - U3(IX,K)*F(JU-1,K)
     *              - U1(IX,K)*F(IX+1,K) - U2(IX,K)*F(IX+2,K)
50        CONTINUE
2       CONTINUE
C
        RETURN
        END

      SUBROUTINE WRITEO(B,N)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION B(N)
      WRITE(6,*)'SOLUTION VECTOR ='
      WRITE(6,'(/1P,(10G12.4))') (B(I),I=1,N)
      WRITE(6,*)
      END      

      FUNCTION SPCG(C1,C2,C3,C4,W,WJ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION C1(*),C2(*),C3(*),C4(*),W(*), WJ(*)
      REAL WJ
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /TWOELE/ GSS(107),GSP(107),GPP(107),GP2(107),HSP(107)
     1                ,GSD(107),GPD(107),GDD(107)
      COMMON /EULER / TVEC(3,3), ID
C********************************************************************
C
C     SPCG CALCULATES THE REPULSION BETWEEN ELECTRON 1 IN MOLECULAR
C     ORBITALS C1 AND C2 AND ELECTRON 2 IN M.O.S C3 AND C4 FOR THE
C     VALENCE SP SHELL AT AN MNDO OR MINDO/3 LEVEL.
C
C                            USAGE
C      XJ=SPCG(C(1,I),C(1,J),C(1,K),C(1,L))
C  OR, XJ=<I(1),J(1)/K(2),L(2)>
C
C    ON INPUT C1    THE FIRST COLUMN MOLECULAR ORBITAL OF ELECTRON ONE.
C             C2        SECOND
C             C3        FIRST                                      TWO.
C             C4        SECOND
C
C   ON OUTPUT SPCG   =   <C1(1)*C2(1)/C3(2)*C4(2)>
C*********************************************************************
      COMMON /KEYWRD/ KEYWRD
      CHARACTER*80 KEYWRD
      LOGICAL LID
      DATA ITYPE /1/
   10 CONTINUE
      GOTO (20,70,30) ITYPE
   20 CONTINUE
      LID=(ID.EQ.0)
      IF(INDEX(KEYWRD,'MINDO') .NE. 0) THEN
         ITYPE=2
      ELSE
         ITYPE=3
      ENDIF
      GOTO 10
*                           ******************
*                           *      MNDO      *
*                           *     OPTION     *
*                           ******************
   30 SPCG=0.0D00
      KK=0
      DO 60 II=1,NUMAT
         IA=NFIRST(II)
         IB=NLAST(II)
         IMINUS=II-1
         DO 50 JJ=1,IMINUS
            JA=NFIRST(JJ)
            JB=NLAST(JJ)
            DO 40 I=IA,IB
               DO 40 J=IA,I
                  DO 40 K=JA,JB
                     DO 40 L=JA,K
                        KK=KK+1
                        IF(LID) THEN
                           WINT=W(KK)
                        ELSE
                           WINT=WJ(KK)
                        ENDIF
                        SPCG=SPCG+WINT*(C1(I)*C2(J)*C3(K)*C4(L)
     1 + C1(K)*C2(L)*C3(I)*C4(J))
                        IF(I.NE.J)
     1SPCG=SPCG+WINT*(C1(J)*C2(I)*C3(K)*C4(L)
     2 + C1(K)*C2(L)*C3(J)*C4(I))
                        IF(K.NE.L) SPCG=SPCG+WINT*(C1(I)*C2(J)*C3(L)*C4(
     1K) + C1(L)*C2(K)*C3(I)*C4(J))
                        IF((I.NE.J).AND.(K.NE.L))SPCG=SPCG+WINT*(C1(J)*C
     12(I)*C3(L)*C4(K) +C1(L)*C2(K)*C3(J)*C4(I))
   40       CONTINUE
   50    CONTINUE
   60 CONTINUE
      GOTO 110
*                           ******************
*                           *     MINDO/3    *
*                           *     OPTION     *
*                           ******************
   70 CONTINUE
      SPCG=0.D0
      KR=0
      DO 100 II=1,NUMAT
         IA=NFIRST(II)
         IB=NLAST(II)
         IM1=II-1
         DO 90 JJ=1,IM1
            KR=KR+1
            IF(LID) THEN
               ELREP=W(KR)
            ELSE
               ELREP=WJ(KR)
            ENDIF
            JA=NFIRST(JJ)
            JB=NLAST(JJ)
            DO 80 I=IA,IB
               DO 80 K=JA,JB
   80       SPCG=SPCG+ELREP*(C1(I)*C2(I)*C3(K)*C4(K)+
     1                                 C1(K)*C2(K)*C3(I)*C4(I))
   90    CONTINUE
  100 CONTINUE
  110 CONTINUE
      ATEMP=SPCG
      IS1=0
      DO 150 I1=1,NUMAT
         IS1=IS1+1
         IZN=NAT(I1)
C
C      (SS/SS)
C
         SPCG=SPCG+C1(IS1)*C2(IS1)*C3(IS1)*C4(IS1)*GSS(IZN)
         IF(IZN.LT.3) GO TO 150
         IS=IS1
         IS1=IS1+1
         IX=IS1
         IS1=IS1+1
         IY=IS1
         IS1=IS1+1
         IZ=IS1
         SPCG=SPCG+GPP(IZN)*
     1                       (
     2           C1(IX)*C2(IX)*C3(IX)*C4(IX)+
     3           C1(IY)*C2(IY)*C3(IY)*C4(IY)+
     4           C1(IZ)*C2(IZ)*C3(IZ)*C4(IZ)
     5                       )
         SPCG=SPCG+GSP(IZN)*
     1                       (
     2           C1(IS)*C2(IS)*C3(IX)*C4(IX)+
     3           C1(IS)*C2(IS)*C3(IY)*C4(IY)+
     4           C1(IS)*C2(IS)*C3(IZ)*C4(IZ)+
     5           C1(IX)*C2(IX)*C3(IS)*C4(IS)+
     6           C1(IY)*C2(IY)*C3(IS)*C4(IS)+
     7           C1(IZ)*C2(IZ)*C3(IS)*C4(IS)
     8                       )
         SPCG=SPCG+GP2(IZN)*
     1                       (
     2           C1(IX)*C2(IX)*C3(IY)*C4(IY)+
     3           C1(IX)*C2(IX)*C3(IZ)*C4(IZ)+
     4           C1(IY)*C2(IY)*C3(IZ)*C4(IZ)+
     5           C1(IY)*C2(IY)*C3(IX)*C4(IX)+
     6           C1(IZ)*C2(IZ)*C3(IX)*C4(IX)+
     7           C1(IZ)*C2(IZ)*C3(IY)*C4(IY)
     8                       )
         TEMP1=HSP(IZN)
         DO 120 J1=IX,IZ
            SPCG=SPCG+TEMP1*
     1                       (
     2           C1(IS)*C2(J1)*C3(J1)*C4(IS)+
     3           C1(IS)*C2(J1)*C3(IS)*C4(J1)+
     4           C1(J1)*C2(IS)*C3(IS)*C4(J1)+
     5           C1(J1)*C2(IS)*C3(J1)*C4(IS)
     6                       )
  120    CONTINUE
         TEMP1=0.5D0*(GPP(IZN)-GP2(IZN))
         DO 140 J1=IX,IZ
            DO 130 K1=IX,IZ
               IF(J1.EQ.K1) GO TO 130
               SPCG=SPCG+TEMP1*
     1                       (
     2           C1(J1)*C2(K1)*C3(J1)*C4(K1)+
     3           C1(J1)*C2(K1)*C3(K1)*C4(J1)
     4                       )
  130       CONTINUE
  140    CONTINUE
  150 CONTINUE
      RETURN
      END

      SUBROUTINE MATVE2(A,B,N,AB,NC)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N),AB(NC)
C     
      DO 100 I=1,NC
         AB(I)=0.
 100  CONTINUE
C     
      DO 200 J=1,N
         BJ=B(J)
         DO 210 I=1,NC 
            IA=N-NC+I
            AB(I)=AB(I)+A(IA,J)*BJ
 210     CONTINUE
 200  CONTINUE
      END       

      SUBROUTINE DHC (P,PA,PB,XI,NAT,IF,IM,IL,JF,JM,JL,
     1NORBS,DENER)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(*), PA(*), PB(*)
      DIMENSION XI(3,*),NFIRST(2),NMIDLE(2),NLAST(2),NAT(*)
C***********************************************************************
C
C  DHC CALCULATES THE ENERGY CONTRIBUTIONS FROM THOSE PAIRS OF ATOMS
C         THAT HAVE BEEN MOVED BY SUBROUTINE DERIV.
C
C***********************************************************************
      COMMON /KEYWRD/ KEYWRD
     1       /ONELEC/ USS(107),UPP(107),UDD(107)
      COMMON /EULER / TVEC(3,3), ID
      COMMON /NUMCAL/ NUMCAL
      CHARACTER*80 KEYWRD
      LOGICAL UHF
      DIMENSION H(171), SHMAT(9,9), F(171),
     1          WJ(100), E1B(10), E2A(10), WK(100), W(100)
      DATA ICALCN /0/
      IF( ICALCN.NE.NUMCAL) THEN
         ICALCN=NUMCAL
         WLIM=4.D0
         IF(ID.EQ.0)WLIM=0.D0
         UHF=(INDEX(KEYWRD,'UHF') .NE. 0)
      ENDIF
      NFIRST(1)=1
      NMIDLE(1)=IM-IF+1
      NLAST(1)=IL-IF+1
      NFIRST(2)=NLAST(1)+1
      NMIDLE(2)=NFIRST(2)+JM-JF
      NLAST(2)=NFIRST(2)+JL-JF
      LINEAR=(NLAST(2)*(NLAST(2)+1))/2
      DO 10 I=1,LINEAR
         F(I)=0.D0
   10 H(I)=0.0D00
      DO 20 I=1,LINEAR
   20 F(I)=H(I)
      JA=NFIRST(2)
      JB=NLAST(2)
      JC=NMIDLE(2)
      IA=NFIRST(1)
      IB=NLAST(1)
      IC=NMIDLE(1)
      JT=JB*(JB+1)/2
      J=2
      I=1
      NJ=NAT(2)
      NI=NAT(1)
      CALL H1ELEC(NI,NJ,XI(1,1),XI(1,2),SHMAT)
      IF(NAT(1).EQ.102.OR.NAT(2).EQ.102) THEN
         K=(JB*(JB+1))/2
         DO 30 J=1,K
   30    H(J)=0.D0
      ELSE
         J1=0
         DO 40 J=JA,JB
            JJ=J*(J-1)/2
            J1=J1+1
            I1=0
            DO 40 I=IA,IB
               JJ=JJ+1
               I1=I1+1
               H(JJ)=SHMAT(I1,J1)
               F(JJ)=SHMAT(I1,J1)
   40    CONTINUE
      ENDIF
      KR=1
      IF(ID.EQ.0)THEN
         CALL ROTATE (NJ,NI,XI(1,2),XI(1,1),W(KR),KR,E2A,E1B,ENUCLR,100.
     1D0)
      ELSE
         CALL SOLROT (NJ,NI,XI(1,2),XI(1,1),WJ,WK,KR,E2A,E1B,ENUCLR,100.
     1D0)
      ENDIF
      IF(WJ(1).LT.WLIM)THEN
         DO 50 I=1,KR-1
   50    WK(I)=0.D0
      ENDIF
C
C    * ENUCLR IS SUMMED OVER CORE-CORE REPULSION INTEGRALS.
C
      I2=0
      DO 60 I1=IA,IC
         II=I1*(I1-1)/2+IA-1
         DO 60 J1=IA,I1
            II=II+1
            I2=I2+1
            H(II)=H(II)+E1B(I2)
   60 F(II)=F(II)+E1B(I2)
      DO  70 I1=IC+1,IB
         II=(I1*(I1+1))/2
         F(II)=F(II)+E1B(1)
   70 H(II)=H(II)+E1B(1)
      I2=0
      DO 80 I1=JA,JC
         II=I1*(I1-1)/2+JA-1
         DO 80 J1=JA,I1
            II=II+1
            I2=I2+1
            H(II)=H(II)+E2A(I2)
   80 F(II)=F(II)+E2A(I2)
      DO 90 I1=JC+1,JB
         II=(I1*(I1+1))/2
         F(II)=F(II)+E2A(1)
   90 H(II)=H(II)+E2A(1)
      CALL FOCK2D(F,P,PA,W, WJ, WK,2,NFIRST,NMIDLE,NLAST)
      EE=HELECT(NLAST(2),PA,H,F)
      IF( UHF ) THEN
         DO 100 I=1,LINEAR
  100    F(I)=H(I)
         CALL FOCK2D(F,P,PB,W, WJ, WK,2,NFIRST,NMIDLE,NLAST)
         EE=EE+HELECT(NLAST(2),PB,H,F)
      ELSE
         EE=EE*2.D0
      ENDIF
      DENER=EE+ENUCLR
      RETURN
C
      END

      SUBROUTINE MOVEA

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ
      COMMON/STEPS/DT
      COMMON/ATOMS/NATM
      COMMON/FORCES/FX,FY,FZ

C    *******************************************************************
C    ** FIRST PART OF THE VELOCITY VERLET ALGORITHM                   **
C    *******************************************************************

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL        DT, DT2, DTSQ2
      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)

      INTEGER     I, NATM

      DT2   = DT/2.0
      DTSQ2 = DT*DT2

      DO 100 I = 1, NATM

C**     INTEGRATE COORDINATES A COMPLETE TIMESTEP

         RX(I) = RX(I)+DT*VX(I)+DTSQ2*FX(I)
         RY(I) = RY(I)+DT*VY(I)+DTSQ2*FY(I)
         RZ(I) = RZ(I)+DT*VZ(I)+DTSQ2*FZ(I)

         RX(I) = RX(I)-AINT(RX(I)+RX(I))
         RY(I) = RY(I)-AINT(RY(I)+RY(I))
         RZ(I) = RZ(I)-AINT(RZ(I)+RZ(I))

C**     INTEGRATE VELOCITIES HALF A TIMESTEP

         VX(I) = VX(I)+DT2*FX(I)
         VY(I) = VY(I)+DT2*FY(I)
         VZ(I) = VZ(I)+DT2*FZ(I)
100   CONTINUE

      RETURN
      END

      SUBROUTINE BONDS(P)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      PARAMETER (NATMS2=MAXPAR*MAXPAR-MAXORB*MAXORB)
      DIMENSION P(*)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /SCRACH/ B(MAXORB,MAXORB), BONDAB(NATMS2)
C***********************************************************************
C
C   CALCULATES, AND PRINTS, THE BOND INDICES AND VALENCIES OF ATOMS
C
C  FOR REFERENCE, SEE "BOND INDICES AND VALENCY", J. C. S. DALTON,
C  ARMSTRONG, D.R., PERKINS, P.G., AND STEWART, J.J.P., 838 (1973)
C
C   ON INPUT
C            P = DENSITY MATRIX, LOWER HALF TRIANGLE, PACKED.
C            P   IS NOT ALTERED BY BONDS.
C
C***********************************************************************
      WRITE(6,10)
   10 FORMAT(//20X,'BOND ORDERS AND VALENCIES',//)
      K=0
      DO 20 I=1,NORBS
         DO 20 J=1,I
            K=K+1
            B(I,J)=P(K)
   20 B(J,I)=P(K)
      IJ = 0
      DO 60 I=1,NUMAT
         L=NFIRST(I)
         LL=NLAST(I)
         DO 40 J=1,I
            IJ = IJ + 1
            K=NFIRST(J)
            KK=NLAST(J)
            X=0.0
            DO 30 IL=L,LL
               DO 30 IH=K,KK
   30       X=X+B(IL,IH)*B(IL,IH)
   40    BONDAB(IJ)=X
         X=-BONDAB(IJ)
         DO 50 J=L,LL
   50    X=X+2.D0*B(J,J)
         BONDAB(IJ)=X
   60 CONTINUE
      CALL VECPRT( BONDAB, NUMAT)
      RETURN
      END

      DOUBLE PRECISION FUNCTION CONVT(X0,Y0,XV,YV,NODEL,ECOORD,TELEM,
     +     INDELE)
      DOUBLE PRECISION X0,Y0,XV,YV,ECOORD(2,*),TELEM(*)
      INTEGER NODEL,INDELE

      DOUBLE PRECISION SFUN(8),A,B,C

      DOUBLE PRECISION ONE,TWO,FOUR,XI,ETA,ETA1,ETA2,EPS
      PARAMETER (ONE=1.0D0,TWO=2.0D0,FOUR=4.D0,EPS=1.0D-12)

      DOUBLE PRECISION DSQRT

      XI=(2.0D0*X0-ECOORD(1,1)-ECOORD(1,3))/(ECOORD(1,3)-ECOORD(1,1))

      IF (XI .GT.  ONE) XI= ONE
      IF (XI .GT. -ONE) XI= -ONE

      A=(1.0D0-XI)*ECOORD(2,1)+(1.0D0+XI)*ECOORD(2,3)
     +     -2.0D0*(1.0D0+XI)*ECOORD(2,4)+(1.0D0+XI)*ECOORD(2,5)+
     +     (1.0D0-XI)*ECOORD(2,7)-2.0D0*(1.0D0-XI)*ECOORD(2,8)

      B=(XI-XI*XI)*ECOORD(2,1)-2.0D0*(1.0D0-XI*XI)*ECOORD(2,2)+
     +     (-XI-XI*XI)*ECOORD(2,3)+(XI+XI*XI)*ECOORD(2,5)+
     +     2.0D0*(1.0D0-XI*XI)*ECOORD(2,6)+(-XI+XI*XI)*ECOORD(2,7)

      C=(-1.0D0+XI*XI)*(ECOORD(2,1)+ECOORD(2,3)+ECOORD(2,5)+
     +     ECOORD(2,7))+2.0D0*( (1.0D0-XI*XI)*ECOORD(2,2)+
     +     (1.0D0+XI)*ECOORD(2,4)+(1.0D0-XI*XI)*ECOORD(2,6)+
     +     (1.0D0-XI)*ECOORD(2,8) ) -4.0D0*Y0

      IF (DABS(A) .LT. EPS) THEN
         IF (DABS(B) .LT. EPS) THEN
            WRITE(6,*) 'Check the value of ETA'
            STOP
         ELSE
            ETA=-C/B
         ENDIF
      ELSE
         ETA1=-B+DSQRT(B*B-4.0D0*A*C)/(2.0D0*A)
         ETA2=-B-DSQRT(B*B-4.0D0*A*C)/(2.0D0*A)

         IF (DABS(ETA1) .GT. ONE+EPS) THEN
            IF (DABS(ETA2) .GT. ONE+EPS) THEN
               WRITE(6,*) 'No root for ETA, ETA1,ETA2 = ',ETA1,ETA2    
               WRITE(6,*) 'Number of element ',INDELE
               STOP
            ELSE
               ETA=ETA2
            ENDIF
         ELSE
            ETA=ETA1
         ENDIF
      ENDIF


      IF (ETA .GT.  ONE)  ETA= ONE
      IF (ETA .LT. -ONE)  ETA=-ONE

      SFUN(1) = (ONE-XI)*(ONE-ETA)*(-XI-ETA-ONE)/FOUR
      SFUN(2) = (ONE-XI*XI)*(ONE-ETA)/TWO
      SFUN(3) = (ONE+XI)*(ONE-ETA)*(XI-ETA-ONE)/FOUR
      SFUN(4) = (ONE-ETA*ETA)*(ONE+XI)/TWO
      SFUN(5) = (ONE+XI)*(ONE+ETA)*(XI+ETA-ONE)/FOUR
      SFUN(6) = (ONE-XI*XI)*(ONE+ETA)/TWO
      SFUN(7) = (ONE-XI)*(ONE+ETA)*(-XI+ETA-ONE)/FOUR
      SFUN(8) = (ONE-ETA*ETA)*(ONE-XI)/TWO

      CONVT=0.0D0
      DO 10 I=1,NODEL
         CONVT=CONVT+SFUN(I)*TELEM(I)
 10   CONTINUE

      RETURN
      END

      SUBROUTINE GOVER(NI,NJ,XI,XJ,R,SG)
************************************************************************
*                                                                      *
*   GOVER CALCULATES THE OVERLAP INTEGRALS USING A GAUSSIAN EXPANSION  *
*         STO-6G BY R.F. STEWART, J. CHEM. PHYS., 52 431-438, 1970     *
*                                                                      *
*         ON INPUT   NI   =  ATOMIC NUMBER OF FIRST ATOM               *
*                    NJ   =  ATOMIC NUMBER OF SECOND ATOM              *
*                    R    =  INTERATOMIC DISTANCE IN ANGSTROMS         *
*         ON EXIT    S    =  9X9 ARRAY OF OVERLAPS, IN ORDER S,PX,PY,  *
*                            PZ                                        *
*                                                                      *
************************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /NATYPE/ NZTYPE(107), MTYPE(30),LTYPE
      COMMON /TEMP/  C(60,6), Z(60,6)
      COMMON /NATORB/ NATORB(107)
      DIMENSION S(6,6), XI(3),XJ(3), SG(9,9)
      DATA NGAUSS/6/
C
C    FIND START AND END OF GAUSSIAN
C
      IFA=NZTYPE(NI)*4-3
      IF(C(IFA+1,1).NE.0.D0)THEN
         ILA=IFA+3
      ELSE
         ILA=IFA
      ENDIF
      IFB=NZTYPE(NJ)*4-3
      IF(C(IFB+1,1).NE.0.D0)THEN
         ILB=IFB+3
      ELSE
         ILB=IFB
      ENDIF
C
C  CONVERT R INTO AU
C
      R=R/0.529167D0
      R = R**2
      KA=0
      DO 80 I=IFA,ILA
         KA=KA+1
         NAT=KA-1
         KB=0
         DO 80 J=IFB,ILB
            KB=KB+1
            NBT=KB-1
C
C         DECIDE IS IT AN S-S, S-P, P-S, OR P-P OVERLAP
C
            IF(NAT.GT.0.AND.NBT.GT.0) THEN
C    P-P
               IS=4
               TOMB=(XI(NAT)-XJ(NAT))*(XI(NBT)
     1-XJ(NBT))*3.5711928576D0
            ELSEIF(NAT.GT.0) THEN
C    P-S
               IS=3
               TOMB=(XI(NAT)-XJ(NAT))*1.88976D0
            ELSEIF(NBT.GT.0) THEN
C    S-P
               IS=2
               TOMB=(XI(NBT)-XJ(NBT))*1.88976D0
            ELSE
C    S-S
               IS=1
            ENDIF
            DO 60 K=1,NGAUSS
               DO 60 L=1,NGAUSS
                  S(K,L)=0.0D0
                  AMB=Z(I,K)+Z(J,L)
                  APB=Z(I,K)*Z(J,L)
                  ADB=APB/AMB
C
C           CHECK OF OVERLAP IS NON-ZERO BEFORE STARTING
C
                  IF((ADB*R).LT.90.D0) THEN
                     ABN=1.0D0
                     GO TO(50,10,20,30),IS
   10                ABN=2.*TOMB*Z(I,K)*SQRT(Z(J,L))/AMB
                     GO TO 50
   20                ABN=-2.*TOMB*Z(J,L)*SQRT(Z(I,K))/AMB
                     GO TO 50
   30                ABN=-ADB*TOMB
                     IF(NAT.EQ.NBT) ABN=ABN+0.5D0
   40                ABN=4.0D0*ABN*SQRT(APB)/AMB
   50                S(K,L)=SQRT((2.*SQRT(APB)/AMB)**3)*EXP(-ADB*R)*ABN
                  ENDIF
   60       CONTINUE
            SG(KA,KB)=0.0D0
            DO 70 K=1,NGAUSS
               DO 70 L=1,NGAUSS
   70       SG(KA,KB)=SG(KA,KB)+S(K,L)*C(I,K)*C(J,L)
   80 CONTINUE
      RETURN
      END

      SUBROUTINE SYMTRY
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1         LOCDEP(MAXPAR)
C**********************************************************************
C
C  SYMTRY COMPUTES THE BOND LENGTHS AND ANGLES THAT ARE FUNCTIONS OF
C         OTHER BOND LENGTHS AND ANGLES.
C
C ON INPUT GEO     = KNOWN INTERNAL COORDINATES
C          NDEP    = NUMBER OF DEPENDENCY FUNCTIONS.
C          IDEPFN  = ARRAY OF DEPENDENCY FUNCTIONS.
C          LOCDEP  = ARRAY OF LABELS OF DEPENDENT ATOMS.
C          LOCPAR  = ARRAY OF LABELS OF REFERENCE ATOMS.
C
C  ON OUTPUT THE ARRAY "GEO" IS FILLED
C***********************************************************************
C
C     NOW COMPUTE THE DEPENDENT PARAMETERS.
C
      DO 10 I=1,NDEP
         CALL HADDON (VALUE,LOCN,IDEPFN(I),LOCPAR(I),GEO)
         J=LOCDEP(I)
   10 GEO(LOCN,J)=VALUE
      RETURN
      END

      SUBROUTINE INIT(U,F,NX,NY,NZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ),F(NX,NY,NZ)
      DO 10 K = 1, NZ-1
        DO 20 J = 1, NY-1
          DO 30 I = 1, NX-1
            U(I,J,K) = 0.
30        CONTINUE
20      CONTINUE
10    CONTINUE
C
      DO 11 K = 2, NZ-1
        DO 21 J = 2, NY-1
          DO 31 I = 2, NX-1
            U(I,J,K) = 1000.
            F(I,J,K) = 10.
31        CONTINUE
21      CONTINUE
11    CONTINUE
C
      END

      DOUBLE PRECISION FUNCTION INTSX(X0,X1,Y1,X2,Y2)
      DOUBLE PRECISION X0,X1,Y1,X2,Y2
      double precision eps
      parameter (eps = 1.0D-12)

      if (X2 .ne. X1) then
         INTSX=(Y2-Y1)/(X2-X1)*(X0-X1)+Y1
      else
         INTSX=(Y2-Y1)/(X2-X1+eps)*(X0-X1)+Y1
      endif
      RETURN
      END

      SUBROUTINE GRID
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
************************************************************************
*
*  GRID CALCULATES THE ENERGY-SURFACE RESULTING FROM VARIATION OF
*       TWO COORDINATES. THE STEP-SIZE IS STEP1 AND STEP2, AND A 11
*       BY 11 GRID OF POINTS IS GENERATED
*
************************************************************************
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /GRAVEC/ COSINE
      COMMON /MESH  / LATOM1, LPARA1, LATOM2, LPARA2
      COMMON /KEYWRD/ KEYWRD
      DIMENSION SURFAC(11,11)
      CHARACTER*80 KEYWRD
      STEP1=READA(KEYWRD,INDEX(KEYWRD,'STEP1')+6)
      STEP2=READA(KEYWRD,INDEX(KEYWRD,'STEP2')+6)
C
C  THE CENTRAL VALUE OF THE FIRST AND SECOND DIMENSIONS ARE
C      GEO(LPARA1,LATOM1) AND GEO(LPARA2,LATOM2)
      NPTS=11
C NPTS MUST BE ODD, IN ORDER TO HAVE A CENTER POINT.
      NPTS2=NPTS/2
      DEGREE=180.D0/3.14159265359D0
      IF(LPARA1.NE.1)STEP1=STEP1/DEGREE
      IF(LPARA2.NE.1)STEP2=STEP2/DEGREE
      START1=GEO(LPARA1,LATOM1)-(NPTS2+1)*STEP1
      START2=GEO(LPARA2,LATOM2)-(NPTS2+1)*STEP2
C
C  NOW TO SWEEP THROUGH THE GRID OF POINTS LEFT TO RIGHT THEN RIGHT
C  TO LEFT. THIS SHOULD AVOID THE GEOMETRY OR SCF GETTING MESSED UP.
C
      GEO(LPARA1,LATOM1)=START1
      GEO(LPARA2,LATOM2)=START2
      IONE=-1.D0
      IF(LPARA1.NE.1) THEN
         C1=DEGREE
      ELSE
         C1=1.D0
      ENDIF
      IF(LPARA2.NE.1) THEN
         C2=DEGREE
      ELSE
         C2=1.D0
      ENDIF
      WRITE(6,'(''   FIRST VARIABLE   SECOND VARIABLE   FUNCTION'')')
      DO 20 ILOOP=1,NPTS
         GEO(LPARA1,LATOM1)=GEO(LPARA1,LATOM1)+STEP1
         IONE=-IONE
         JLOOP1=0
         IF(IONE.LT.0)JLOOP1=NPTS+1
         DO 10 JLOOP=1,NPTS
            JLOOP1=JLOOP1+IONE
            GEO(LPARA2,LATOM2)=GEO(LPARA2,LATOM2)+STEP2*IONE
            CALL FLEPO(XPARAM, NVAR, ESCF)
            SURFAC(ILOOP,JLOOP1)=ESCF
            WRITE(6,'('' :'',F16.5,F16.5,F13.6)')GEO(LPARA1,LATOM1)*C1,
     1        GEO(LPARA2,LATOM2)*C2,ESCF
   10    CONTINUE
         GEO(LPARA2,LATOM2)=GEO(LPARA2,LATOM2)+STEP2*IONE
   20 CONTINUE
      WRITE(6,'(/10X,''HORIZONTAL: VARYING SECOND PARAMETER,'',
     1          /10X,''VERTICAL:   VARYING FIRST PARAMETER'')')
      WRITE(6,'(/10X,''WHOLE OF GRID, SUITABLE FOR PLOTTING'',//)')
      DO 30 I=1,NPTS
   30 WRITE(6,'(11F7.2)')(SURFAC(J,I),J=1,NPTS)
      END

C----------------------------------------------------------------------
C
C  P R E C E S
C  INPUT: RECTANGULAR COORDINATES (X,Y,Z) AT T1
C  OUTPUT: PRECESSED COORDINATS  (XN,YN,ZN) AT T2
C
C----------------------------------------------------------------------
      SUBROUTINE PRECES(T1,T2,X,Y,Z,XN,YN,ZN)
      REAL
     .    T1,         
     .    T2,         
     .    X,Y,Z,      
     .    XN,YN,ZN    
C
      REAL
     .    ZETA,ZEE,THETA,
     .    XX,YX,ZX,
     .    XY,YY,ZY,
     .    XZ,YZ,ZZ,
     .    T0,T,
     .    STORAD
      PARAMETER(STORAD=4.848136811095D-06)
C
      T0=(T1-2415020.313E+0)/36524.22E+0
      T=(T2-T1)/36524.22E+0
      ZETA=STORAD*((2304.25E+0+1.396E+0*T0)*T+
     .      0.302E+0*T*T+0.018E+0*T*T*T)
      ZEE=ZETA+STORAD*(0.791E+0*T*T)
      THETA=STORAD*((2004.682E+0-0.853E+0*T0)*T-
     .      0.426E+0*T*T-0.042E+0*T*T*T)
      XX=COS(ZETA)*COS(THETA)*COS(ZEE)-SIN(ZETA)*SIN(ZEE)
      YX=-SIN(ZETA)*COS(THETA)*COS(ZEE)-COS(ZETA)*SIN(ZEE)
      ZX=-SIN(THETA)*COS(ZEE)
      XY=COS(ZETA)*COS(THETA)*SIN(ZEE)+SIN(ZETA)*COS(ZEE)
      YY=-SIN(ZETA)*COS(THETA)*SIN(ZEE)+COS(ZETA)*COS(ZEE)
      ZY=-SIN(THETA)*SIN(ZEE)
      XZ=COS(ZETA)*SIN(THETA)
      YZ=-SIN(ZETA)*SIN(THETA)
      ZZ=COS(THETA)
      XN=X*XX+Y*YX+Z*ZX
      YN=X*XY+Y*YY+Z*ZY
      ZN=X*XZ+Y*YZ+Z*ZZ
      RETURN
      END

C ======================================================================
C
C
      SUBROUTINE EFERMI (NEL,NBANDS,DEL,NSPPTS,NDIM8,NDIM10,
     +                   WEIGHT,OCC,EF,EIGVAL,SORT)
C
C-----------------------------------------------------------------------
C
C     WRITTEN BY RICHARD NEEDS ON 9TH DECEMBER 1983
C     GIVEN THE EIGENVALUES IN EIGVAL AND THE WEIGHTS OF THE
C     K-POINTS IN WEIGHT THIS SUBROUTINE CALCULATES THE FERMI LEVEL
C     EF AND THE OCCUPANCY OF THE STATES OCC.
C
C     METHOD: C-L FU AND K-M HO, PHYS. REV. B 28, 5480 (1983)
C     GAUSSIAN SMEARING OF EIGENVALUES WHEN COMPUTING OCCUPATION
C     NOTE: FOR SUM OF BANDS WE DO NOT SMEAR EIGENVALUES,
C     AS WAS DONE BY FU AND HO. THE DIFFERENCE IS EASILY
C     CALCULATED.
C
C     NEL ..... NUMBER OF ELECTRONS PER UNIT CELL
C     NBANDS .. NUMBER OF BANDS FOR EACH K-POINT
C     DEL ..... WIDTH OF GAUSSIAN SMEARING FUNCTION
C     NSPPTS .. NUMBER OF K-POINTS
C     NDIM8 ... MAXIMUM NUMBER OF BANDS AT A K-POINT
C     WEIGHT .. THE WEIGHT OF EACH K-POINT
C     OCC ..... THE OCCUPANCY OF EACH STATE
C     EF ...... THE FERMI ENERGY
C     SORT .... THE EIGENVALUES ARE WRITTEN INTO SORT WHICH IS
C               THEN SORTED INTO ASCENDING NUMERICAL VALUE, FROM
C               WHICH BOUNDS ON EF CAN EASILY BE OBTAINED
C     EIGVAL .. CONTAINS THE BEST EIGENVALUES AVAILABLE
C---------------------------------------------------------------------
C     12-Mar-90 Obtained from B. Hammer 
C     12-MAR-90 NBANDS changed to be the same for all k-points XW
C
C
      REAL SORT(NDIM8*NDIM10)
      REAL OCC(NDIM8,NDIM10),WEIGHT(NDIM10),EIGVAL(NDIM8,NDIM10)
      EXTERNAL SERFC
C.....WARNINGS
      COMMON /WARN/ IWARN
      PARAMETER ( NCYCLE = 20, NDIV = 9 )
C--------------------------------------------------------------------
C
      DSOR = 1.0 /FLOAT(NDIV)
      Z    = FLOAT(NEL)
C
C     COPY EIGVAL INTO SORT
      NEIG = 0
      DO 10 ISPPT = 1,NSPPTS
        DO 20  J = 1, NBANDS
          NEIG = NEIG + 1
20        SORT(NEIG) = EIGVAL(J,ISPPT)
10      CONTINUE
C
C  SORT THE ARRAY INTO ASCENDING ORDER OF EIGENVALUE
C
C  SORT THE RECORDS WITH 'STRAIGHT INSERTION'-METHOD (NOT A TOO BAD
C  CHOICE OF SORT-ALGORITHM AS THE ENERGIES ARE ALLMOST ALREADY SORTED)
C=======================================================================
      DO 26 N=2,NSPPTS*NBANDS
        EN=SORT(N)
        DO 22 NN=N-1,1,-1
          IF (SORT(NN).LE.EN) GO TO 24
          SORT(NN+1)=SORT(NN)
  22    CONTINUE
        NN=0
  24    SORT(NN+1)=EN
  26  CONTINUE
C
C     FIND AN UPPER BOUND E2 AND A LOWER BOUND E1 ON THE
C     FERMI ENERGY
      INT = NEL*NSPPTS
      IF ( MOD(INT,2) .EQ. 1) THEN
        I1 = INT/2
        I2 = INT/2 + 2
      ELSE
        I1 = INT/2 - 1
        I2 = INT/2 + 1
        ENDIF
      I1 = MAX(I1, 1)
      I2 = MIN(I2, NEIG)
C
30    E1 =  SORT(I1)
C
      Z1 = 0.0 
      DO 40 ISPPT = 1,NSPPTS
        DO 50 J = 1,NBANDS
          X = (E1 - EIGVAL(J,ISPPT))/DEL
50        Z1 = Z1 + WEIGHT(ISPPT)*( 2.0 - SERFC(X) )
40      CONTINUE
C
      IF (Z1 .GT. Z-1.0E-6) THEN
        I1 = I1 - 1
        IF (I1 .GT. 0) THEN
          GOTO 30
        ELSE
          I1 = 1
          E1 = SORT(I1) - DEL
          WRITE (*,*) 'EFERMI *** LOWER BOUND ON EF SET TO',E1
          GOTO 70
          ENDIF
        ENDIF
C
70      E2 = SORT(I2)
C
      Z2 = 0.0 
      DO 60 ISPPT = 1, NSPPTS
        DO 80 J = 1,NBANDS
          X = (E2 - EIGVAL(J,ISPPT))/DEL
80        Z2 = Z2 + WEIGHT(ISPPT)*( 2.0 - SERFC(X) )
60      CONTINUE
C
      IF (Z2 .LT. Z + 1.E-6) THEN
        I2 = I2 + 1
        IF (I2 .LE. NEIG) THEN
          GOTO 70
        ELSE
          I2 = NEIG
          E2 = SORT(I2) + DEL
          WRITE (*,1100) E2
1100      FORMAT(' EFERMI *** WARNING ***'/
     +      ' FERMI LEVEL UPPER BOUND IS > LARGEST EIGENVALUE, E2=',
     +      F12.4,' eV')
          IWARN = 1
          ENDIF
        ENDIF
C
C     FIND FERMI ENERGY ENERGY BETWEEN BOUNDS E1 AND E2
      DO 90 ILOOP = 1,NCYCLE
        DIV = (E2-E1)*DSOR
        DO 100 I = 1,NDIV
          Z2 = 0.0
          EUP = E1 + FLOAT(I)*DIV
          DO 120 ISPPT = 1,NSPPTS
            DO 110 J = 1,NBANDS
              X = (EUP - EIGVAL(J,ISPPT))/DEL
110           Z2 = Z2 + WEIGHT(ISPPT)*( 2.0 - SERFC(X) )
120         CONTINUE
          IF (Z1 .GT. Z) GOTO 1000
          IF (Z2 .GT. Z) GOTO 130
C         THIS TEST IS NEEDED TO CATCH SEMICONDUCTORS
C          IF (ABS(Z2-Z) .LT. 1.0E-10) GOTO 150
          IF (ABS(Z2-Z) .LT. 1.0E-5) GOTO 150
          Z1 = Z2
100       CONTINUE
        GOTO 1010
C130     IF ( Z2-Z1 .LT. 1.0E-10) GOTO 160
130     IF ( Z2-Z1 .LT. 1.0E-5) GOTO 160
        E1 = EUP - DIV
90      E2 = EUP
      WRITE(*,*) '***WARNING*** FERMI ENERGY MAY NOT BE ACCURATE'
      WRITE(*,140) NCYCLE
140   FORMAT(' AFTER',I6,' CYCLES, REQUIRED CONVERGENCE NOT OBTAINED')
      GOTO 160
C
C     WRITE OUT FERMI ENERGY
150   EF = EUP
      GOTO 170
160   EF = EUP - 0.5*DIV
170   WRITE (*,180) EF
180   FORMAT (' FERMI ENERGY = ',F12.8,' EV')
C
C     FORM OCCUPATIONS OCC(NBDS,NSPPTS)
      DO 190 ISPPT = 1, NSPPTS
        DO 200 J = 1,NBANDS
          X = ( EF-EIGVAL(J,ISPPT))/DEL
200       OCC(J,ISPPT) = 2.0 - SERFC(X)
190     CONTINUE
C
C     TEST WHETHER OCCUPANCY ADDS UP TO Z
      TEST = 0.0
      DO 210 ISPPT = 1,NSPPTS
        DO 215 J = 1,NBANDS
215       TEST = TEST + WEIGHT(ISPPT)*OCC(J,ISPPT)
210     CONTINUE
      IF ( ABS(TEST-Z) .GT. 1.0E-9) THEN
        WRITE(*,*) '*** WARNING ***'
        WRITE(*,220) TEST,NEL
220     FORMAT(' SUM OF OCCUPANCIES =',F15.12 ,' BUT NEL =',I5)
      ELSE
        WRITE(*,230) TEST
230     FORMAT(' TOTAL CHARGE = ',F12.8)
        ENDIF
C
C     TEST WHETHER THE MATERIAL IS A SEMICONDUCTOR
      IF ( MOD( NEL, 2) .EQ. 1) RETURN
      INEL = NEL/2
      ELOW = EIGVAL(INEL+1,1)
      DO 310 ISPPT = 2,NSPPTS
        ELOW = AMIN1( ELOW, EIGVAL(INEL+1,ISPPT))
310     CONTINUE
      DO 320 ISPPT = 1,NSPPTS
        IF (ELOW .LT. EIGVAL(INEL,ISPPT)) RETURN
320     CONTINUE
      WRITE (*,*) 'MATERIAL MAY BE A SEMICONDUCTOR'
C
      RETURN
C----------------------------------------------------------------------
C      ERROR MESSAGES
C----------------------------------------------------------------------
1000  WRITE(*,*) '***** ERROR *****'
      WRITE(*,*) 'FERMI ENERGY LESS THAN LOWER SEARCH BOUND SET'
      WRITE(*,*) EIGVAL
      CALL EXIT
      RETURN
C
1010  WRITE(*,*) '***** ERROR *****'
      WRITE(*,*) 'FERMI ENERGY GREATER THAN UPPER SEARCH BOUND SET'
      WRITE(*,*) 'EigVal: ', EIGVAL
      write(*,*) 'Weight: ', WEIGHT
      WRITE(*,*) 'Z1, Z2, Z:', Z1,Z2,Z
      WRITE(*,*) 'E1,EUP:',  E1,EUP 
      CALL EXIT
      RETURN
C
      END
C
C =========================================================================
C
C     DOUBLE PRECISION FUNCTION ERFC(XX)
      FUNCTION SERFC(XX1)
      IMPLICIT DOUBLE PRECISION (A-H,O-W,Y-Z)
C
C     COMPLEMENTARY ERROR FUNCTION
C     FROM THE SANDIA MATHEMATICAL PROGRAM LIBRARY
C
C     XMAX IS THE VALUE BEYOND WHICH ERFC(X) = 0 .
C     IT IS COMPUTED AS SQRT(LOG(RMIN)), WHERE RMIN IS THE
C     SMALLEST REAL NUMBER REPRESENTABLE ON THE MACHINE.
C     IBM VALUE: (THE INTRINSIC ERFC COULD ALSO BE USED)
C     PARAMETER ( XMAX = 13.4 )
C     VAX VALUE: (XMAX = 9.3)
C -----------------------------------  
C     12-Mar-90  Obtained from B. Hammer 
C     12-MAR-90  Changed to single precision at the end XW
C                also XX1
      REAL XMAX
      PARAMETER ( XMAX = 9.3D0)
C
      DIMENSION P1(4),Q1(4),P2(6),Q2(6),P3(4),Q3(4)
C     REAL*4 XX1, SERFC
C
      DATA P1 /242.66 79552 30531 8D0 , 21.979 26161 82941 5D0 ,
     + 6.9963 83488 61913 6D0 , -3.5609 84370 18153 9D-2/
      DATA Q1 /215.05 88758 69861 2D0 , 91.164 90540 45149 0D0,
     + 15.082 79763 04077 9D0 , 1.0D0/
      DATA P2 /22.898 99285 1659D0 , 26.094 74695 6075D0 ,
     + 14.571 89859 6926D0 , 4.2677 20107 0898D0 ,
     + 0.56437 16068 6381D0 , -6.0858 15195 9688 D-6/
      DATA Q2 /22.898 98574 9891D0 , 51.933 57068 7552D0 ,
     + 50.273 20286 3803D0 , 26.288 79575 8761D0 ,
     + 7.5688 48229 3618D0 , 1.0D0/
      DATA P3 /-1.2130 82763 89978 D-2 , -0.11990 39552 68146 0D0 ,
     + -0.24391 10294 88626D0 , -3.2431 95192 77746 D-2/
      DATA Q3 /4.3002 66434 52770 D-2 , 0.48955 24419 61437D0 ,
     + 1.4377 12279 37118D0 , 1.0D0/
C     1/SQRT(PI)
      DATA SQPI /0.56418 95835 47756D0/
C
      XX=XX1
C----------------------------------------------------------------------
      IF (XX .GT.  XMAX)    GOTO 330
      IF (XX .LT. -XMAX)    GOTO 320
      X = ABS(XX)
      X2 = X*X
      IF (X .GT. 4.0D0)     GOTO 300
      IF (X .GT. 0.46875D0) GOTO 200
C
C     -46875 < X < 0.46875
      ERFC = X*(P1(1) + X2*(P1(2) + X2*(P1(3) + X2*P1(4))))
      ERFC = ERFC/(Q1(1) + X2*(Q1(2) + X2*(Q1(3) + X2*Q1(4))))
      IF (XX .LT. 0.0) ERFC = - ERFC
      ERFC = 1.0D0 - ERFC
      GOTO 9999
C
200   ERFC = EXP( -X2)*(P2(1) + X*(P2(2) + X*(P2(3) + X*(P2(4) +
     + X*(P2(5) + X*P2(6))))))
      ERFC = ERFC/(Q2(1) + X*(Q2(2) + X*(Q2(3) + X*(Q2(4) + X*(Q2(5) +
     + X*Q2(6))))))
      IF (XX .LE. 0.0) ERFC = 2.0D0 - ERFC
      GOTO 9999
C
300   XI2 = 1.0D0/X2
      ERFC = XI2*(P3(1) + XI2*(P3(2) + XI2*(P3(3) + XI2*P3(4))))/
     + (Q3(1) + XI2*(Q3(2) + XI2*(Q3(3) + XI2*Q3(4))))
      ERFC = EXP( -X2)*(SQPI + ERFC)/X
      IF (XX .LT. 0.0) ERFC = 2.0D0 - ERFC
      GOTO 9999
C
320   ERFC = 2.0D0
      GOTO 9999
330   ERFC = 0.0D0
C
9999  SERFC=ERFC
      RETURN
      END

      SUBROUTINE TRIP(JDIM,A,B,C,F,Q,S,J1,J2)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(JDIM),B(JDIM),C(JDIM),F(JDIM),Q(JDIM),S(JDIM)
      JA = J1 + 1
      FN = F(J2)
C
C         FORWARD ELIMINATION SWEEP
C
      Q(J1) = -C(J1)/B(J1)
      F(J1) = F(J1)/B(J1)
      S(J1) = - A(J1)/B(J1)
      DO 10 J=JA,J2
         P =1./( B(J) + A(J)*Q(J-1))
         Q(J) = - C(J)*P
         F(J) = ( F(J) - A(J)*F(J-1))*P
         S(J) = - A(J)*S(J-1)*P
   10 CONTINUE
C
C         BACKWARD PASS
C
      JJ = J1 + J2
      Q(J2) = 0.
      S(J2) = 1.
      DO 11 I=JA,J2
         J = JJ - I
         S(J) = S(J) + Q(J)*S(J+1)
         Q(J) = F(J) + Q(J)*Q(J+1)
11    CONTINUE
      F(J2) = ( FN - C(J2)*Q(J1) - A(J2)*Q(J2-1))/(C(J2)*S(J1) +
     1     A(J2)*S(J2-1)  +B(J2))
C
C         BACKWARD ELIMINATION PASS
C
      DO 12 I=JA,J2
         J = JJ -I
         F(J) = F(J2)*S(J) + Q(J)
12    CONTINUE
      RETURN
      END

      SUBROUTINE HQRII(A,N,M,E,V)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION A(*), E(N), V(N,M)
*************************************************************
*
* HQRII IS A DIAGONALISATION ROUTINE, WRITTEN BY YOSHITAKA BEPPU OF
*       NAGOYA UNIVERSITY, JAPAN.
*       FOR DETAILS SEE 'COMPUTERS & CHEMISTRY' VOL.6 1982. PAGE 000.
*
* ON INPUT    A       = MATRIX TO BE DIAGONALIZED
*             N       = SIZE OF MATRIX TO BE DIAGONALIZED.
*             M       = NUMBER OF EIGENVECTORS NEEDED.
*             E       = ARRAY OF SIZE AT LEAST N
*             V       = ARRAY OF SIZE AT LEAST NMAX*M
*
* ON OUTPUT   E       = EIGENVALUES
*             V       = EIGENVECTORS IN ARRAY OF SIZE NMAX*M
*
************************************************************************
      DIMENSION W(5,MAXPAR)
      IF(N.LE.1 .OR. M .LE.1 .OR. M .GT. N) THEN
         IF(N.EQ.1 .AND. M.EQ.1) THEN
            E(1)=A(1)
            V(1,1)=1.D0
            RETURN
         ENDIF
         WRITE(6,'(////10X,''IN HQRII, N ='',I4,'' M ='',I4)')N,M
         CALL WRAPUP()
      ENDIF
*
* EPS3 AND EPS ARE MACHINE-PRECISION DEPENDENT
*
      EPS3=1.D-30
      ZERO=0.D0
      LL=(N*(N+1))/2+1
      EPS=1.D-8
      IORD=-1
      NM1=N-1
      IF(N.EQ.2) GOTO 80
      NM2=N-2
C     HOUSEHOLDER TRANSFORMATION
      DO 70 K=1,NM2
         KP1=K+1
         W(2,K)=A((K*(K+1))/2)
         SUM=0.
         DO 10 J=KP1,N
            W(2,J)=A((J*(J-1))/2+K)
   10    SUM=W(2,J)**2+SUM
         S=SIGN(SQRT(SUM),W(2,KP1))
         W(1,K)=-S
         W(2,KP1)=W(2,KP1)+S
         A(K+(KP1*(KP1-1))/2)=W(2,KP1)
         H=W(2,KP1)*S
         IF(ABS(H).LT.1.D-35) GOTO 70
C#      IF(H.EQ.0.D0) GOTO 70
         SUMM=0.D0
         DO 50 I=KP1,N
            SUM=0.D0
            DO 20 J=KP1,I
   20       SUM=SUM+A(J+(I*(I-1))/2)*W(2,J)
            IF(I.GE.N) GOTO 40
            IP1=I+1
            DO 30 J=IP1,N
   30       SUM=SUM+A(I+(J*(J-1))/2)*W(2,J)
   40       W(1,I)=SUM/H
   50    SUMM=W(1,I)*W(2,I)+SUMM
         U=SUMM*0.5D0/H
         DO 60 J=KP1,N
            W(1,J)=W(2,J)*U-W(1,J)
            DO 60 I=KP1,J
   60    A(I+(J*(J-1))/2)=W(1,I)*W(2,J)+W(1,J)*W(2,I)+A(I+(J*(J-1))/2)
   70 A((K*(K+1))/2)=H
   80 W(2,NM1)=A((NM1*(NM1+1))/2)
      W(2,N)=A((N*(N+1))/2)
      W(1,NM1)=A(NM1+(N*(N-1))/2)
      W(1,N)=0.D0
      GERSCH=ABS(W(2,1))+ABS(W(1,1))
      DO 90 I=1,NM1
   90 GERSCH=MAX(ABS(W(2,I+1))+ABS(W(1,I))+ABS(W(1,I+1)),GERSCH)
      DEL=EPS*GERSCH
      DO 100 I=1,N
         W(3,I)=W(1,I)
         E(I)=W(2,I)
  100 V(I,M)=E(I)
      IF(DEL.EQ.ZERO)  GOTO  210
C     QR-METHOD WITH ORIGIN SHIFT
      K=N
  110 L=K
  120 IF(ABS(W(3,L-1)).LT.DEL) GOTO 130
      L=L-1
      IF(L.GT.1)  GOTO 120
  130 IF(L.EQ.K)  GOTO 160
      WW=(E(K-1)+E(K))*0.5D0
      R=E(K)-WW
      Z=SIGN(SQRT(W(3,K-1)**2+R*R),R)+WW
      EE=E(L)-Z
      E(L)=EE
      FF=W(3,L)
      R=SQRT(EE*EE+FF*FF)
      J=L
      GOTO 150
  140 R=SQRT(E(J)**2+W(3,J)**2)
      W(3,J-1)=S*R
      EE=E(J)*C
      FF=W(3,J)*C
  150 R=R+1.D-15
      C=E(J)/R
      S=W(3,J)/R
      WW=E(J+1)-Z
      E(J)=(FF*C+WW*S)*S+EE+Z
      E(J+1)=C*WW-S*FF
      J=J+1
      IF(J.LT.K) GOTO 140
      W(3,K-1)=E(K)*S
      E(K)=E(K)*C+Z
      GOTO 110
  160 K=K-1
      IF(K.GT.1) GOTO 110
*    *    *    *    *    *    *    *    *    *    *    *    *
*
*   AT THIS POINT THE ARRAY 'E' CONTAINS THE UN-ORDERED EIGENVALUES
*
*    *    *    *    *    *    *    *    *    *    *    *    *
C     STRAIGHT SELECTION SORT OF EIGENVALUES
      SORTER=1.D0
      IF(IORD.LT.0) SORTER=-1.D0
      J=N
  170 L=1
      II=1
      LL=1
      DO 190 I=2,J
         IF((E(I)-E(L))*SORTER .GT. 0.D0) GOTO 180
         L=I
         GOTO 190
  180    II=I
         LL=L
  190 CONTINUE
      IF(II.EQ.LL) GOTO 200
      WW=E(LL)
      E(LL)=E(II)
      E(II)=WW
  200 J=II-1
      IF(J.GE.2) GOTO 170
  210 IF(M.EQ.0) RETURN
***************
*  ORDERING OF EIGENVALUES COMPLETE.
***************
C      INVERSE-ITERATION FOR EIGENVECTORS
      FN=FLOAT(N)
      EPS1=1.D-5
      SEPS=SQRT(EPS)
      EPS2=0.05D0
      RN=0.D0
      RA=EPS*0.6180339887485D0
C    0.618... IS THE FIBONACCI NUMBER (-1+SQRT(5))/2.
      IG=1
      DO 430 I=1,M
         IM1=I-1
         DO 220 J=1,N
            W(3,J)=0.D0
            W(4,J)=W(1,J)
            W(5,J)=V(J,M)-E(I)
            RN=RN+RA
            IF(RN.GE.EPS) RN=RN-EPS
  220    V(J,I)=RN
         DO 250 J=1,NM1
            IF(ABS(W(5,J)).GE.ABS(W(1,J))) GOTO 230
            W(2,J)=-W(5,J)/W(1,J)
            W(5,J)=W(1,J)
            T=W(5,J+1)
            W(5,J+1)=W(4,J)
            W(4,J)=T
            W(3,J)=W(4,J+1)
            IF(W(3,J).EQ.ZERO) W(3,J)=DEL
            W(4,J+1)=0.D0
            GOTO 240
  230       IF(W(5,J).EQ.ZERO) W(5,J)=DEL
            W(2,J)=-W(1,J)/W(5,J)
  240       W(4,J+1)=W(3,J)*W(2,J)+W(4,J+1)
  250    W(5,J+1)=W(4,J)*W(2,J)+W(5,J+1)
         IF(ABS(W(5,N)) .LT. EPS3) W(5,N)=DEL
         DO 310 ITERE=1,5
            IF(ITERE.EQ.1) GOTO 270
            DO 260 J=1,NM1
               IF(W(3,J).EQ.ZERO) GOTO 260
               T=V(J,I)
               V(J,I)=V(J+1,I)
               V(J+1,I)=T
  260       V(J+1,I)=V(J,I)*W(2,J)+V(J+1,I)
  270       V(N,I)=V(N,I)/W(5,N)
            V(NM1,I)=(V(NM1,I)-V(N,I)*W(4,NM1))/W(5,NM1)
            VN=MAX(ABS(V(N,I)),ABS(V(NM1,I)),1.D-20)
            IF(N.EQ.2) GOTO 290
            K=NM2
  280       V(K,I)=(V(K,I)-V(K+1,I)*W(4,K)-V(K+2,I)*W(3,K))/W(5,K)
            VN=MAX(ABS(V(K,I)),VN,1.D-20)
            K=K-1
            IF(K.GE.1) GOTO 280
  290       S=EPS1/VN
            DO 300 J=1,N
  300       V(J,I)=V(J,I)*S
            IF(ITERE.GT.1 .AND. VN.GT.1) GOTO 320
  310    CONTINUE
C     TRANSFORMATION OF EIGENVECTORS
  320    IF(N.EQ.2) GOTO 360
         DO 350 J=1,NM2
            K=N-J-1
            IF(A((K*(K+1))/2).EQ.ZERO) GOTO 350
            KP1=K+1
            SUM=0.D0
            DO 330 KK=KP1,N
  330       SUM=SUM+A(K+(KK*(KK-1))/2)*V(KK,I)
            S=-SUM/A((K*(K+1))/2)
            DO 340 KK=KP1,N
  340       V(KK,I)=A(K+(KK*(KK-1))/2)*S+V(KK,I)
  350    CONTINUE
  360    DO 370 J=IG,I
            IF(ABS(E(J)-E(I)) .LT. EPS2) GOTO 380
  370    CONTINUE
         J=I
  380    IG=J
         IF(IG .EQ. I) GOTO 410
C     RE-ORTHOGONALISATION
         DO 400 K=IG,IM1
            SUM=0.D0
            DO 390 J=1,N
  390       SUM=V(J,K)*V(J,I)+SUM
            S=-SUM
            DO 400 J=1,N
  400    V(J,I)=V(J,K)*S+V(J,I)
C     NORMALISATION
  410    SUM=1.D-24
         DO 420 J=1,N
  420    SUM=SUM+V(J,I)**2
         SINV=1.D0/SQRT(SUM)
         DO 430 J=1,N
  430 V(J,I)=V(J,I)*SINV
      RETURN
      END

C***********************************************************************
C FILE: GENBTR.FOR
C
C HISTORY: 19/2/90: COPIED FROM GENSP1.FOR
C                   RECC,RECI IMPLEMENTED BY BH
C          25/2/90: DATAKE(2,) (3,) AND (4,) NOW ENERGIES
C                   OFF-DIAGONAL ELEMENTS OF STRESS TENSOR
C          11/3/90: PRINT-MESSAGE ABOUT CUT-OFF
C          12/3/90:         -//-        HOW MANY PLANE-WAVES ACCEPTED 
C          25/5/90: REDUNDANT CAR-PARRINELLO PART REMOVED BY BH
C        05-JUN-90: DNLG AND DNLKG ADDED FOR THE USE OF NON-LOCAL
C		    PSEUDOPOTENTIAL BY X WENG
C        09-JUL-90: DNLG AND DNLKG ARE ALL IN CARTESIAN COORDINATION 
C                   BY X WENG
C***********************************************************************
      SUBROUTINE GENBTR(NRPLWV,NGX,NGY,NGZ,NKPTS,ENMAX,NINDPW,NPLWKP,
     &      VKPT,LPCTX,LPCTY,LPCTZ,DATAKE,RECC,RECI,IPRINT,
     &      DNLG,DNLKG)
C=======================================================================
C
C ]]]]]]]]]]]]]]]]]]]]]] SUBROUTINE GENSP [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
C
C SUBROUTINE GENSP PERFORMS A NUMBER OF TASKS. THE DATA ARRAYS COSDAT &
C DECDAT FOR THE ELECTRON DYNAMICS ARE INITIALISED. THE INDEXING SYSTEM
C FOR PADDING THE SPHERES OF PLANE WAVES AT EACH K POINT INTO THE BOX
C USED FOR THE FAST FOURIER TRANSFORMS IS ALSO COMPUTED AS ARE THE
C KINETIC ENERGIES OF THE PLANE WAVE BASIS STATES AT EACH K POINT AND
C THE X,Y AND Z COMPONENTS OF THE KINETIC ENERGY. THE INDEXING SYSTEM
C IS BASED ON THE INITIAL SIZE OF THE UNIT CELL THOUGH THE KINETIC
C ENERGIES OF THE PLANE WAVE BASIS STATES OBVIOUSLY CHANGES AS THE
C SIZE OF THE CELL CHANGES
C=======================================================================
      IMPLICIT COMPLEX (C)
      DIMENSION NINDPW(*)
      DIMENSION NPLWKP(*)
      DIMENSION VKPT(3,*)
      DIMENSION LPCTX(*),LPCTY(*),LPCTZ(*)
      DIMENSION DATAKE(*)
      DIMENSION RECC(3,*)
      DIMENSION RECI(3,*)
      DIMENSION DNLG(NRPLWV,3,NKPTS),DNLKG(NRPLWV,0:3,NKPTS)
C=======================================================================
C 	TPI = (NOT SURPRISINGLY) 2*PI
C 	HSQDTM = (PLANCK'S CONSTANT/(2*PI))**2/(2*ELECTRON MASS)
C======================================================================
      DATA TPI,HSQDTM /6.283185307,3.810033/
      TESTMX=0.0
C=======================================================================
C THE FINAL SECTION OF THE SUBROUTINE CALCULATES THE INDEX IN THE
C RECIPROCAL LATTICE GRID OF EACH PLANE WAVE BASIS STATES AT EACH
C K POINT. THE KINETIC ENERGIES OF THE BASIS STATES AND THE X,Y AND Z
C COMPONENTS OF THE KINETIC ENERGY ARE CALCULATED. IF THE CUT-OFF ENERGY
C ENMAX IS TOO LARGE SO THAT THERE ARE MORE THAN NRPLWV PLANE WAVE BASIS
C STATES OF ENERGY LESS THAN ENMAX AT ANY K POINT, ENMAX IS
C AUTOMATICALLY REDUCED
C=======================================================================
 10   CONTINUE
      ACCMXC=0.0
      ACCMXI=0.0
      DO 2000 N=1,NKPTS
        NLBOXI=1
        NSBOXI=1
        DO 2010 NZ=1,NGZ
          GZX=RECC(3,1)*(LPCTZ(NZ)+VKPT(3,N))
          GZY=RECC(3,2)*(LPCTZ(NZ)+VKPT(3,N))
          GZZ=RECC(3,3)*(LPCTZ(NZ)+VKPT(3,N))
          GIZX=RECI(3,1)*(LPCTZ(NZ)+VKPT(3,N))
          GIZY=RECI(3,2)*(LPCTZ(NZ)+VKPT(3,N))
          GIZZ=RECI(3,3)*(LPCTZ(NZ)+VKPT(3,N))
          DO 2011 NY=1,NGY
            GYX=RECC(2,1)*(LPCTY(NY)+VKPT(2,N))
            GYY=RECC(2,2)*(LPCTY(NY)+VKPT(2,N))
            GYZ=RECC(2,3)*(LPCTY(NY)+VKPT(2,N))
            GIYX=RECI(2,1)*(LPCTY(NY)+VKPT(2,N))
            GIYY=RECI(2,2)*(LPCTY(NY)+VKPT(2,N))
            GIYZ=RECI(2,3)*(LPCTY(NY)+VKPT(2,N))
            DO 2012 NX=1,NGX
              GXX=RECC(1,1)*(LPCTX(NX)+VKPT(1,N))
              GXY=RECC(1,2)*(LPCTX(NX)+VKPT(1,N))
              GXZ=RECC(1,3)*(LPCTX(NX)+VKPT(1,N))
              GX=GXX+GYX+GZX
              GY=GXY+GYY+GZY
              GZ=GXZ+GYZ+GZZ
              GIXX=RECI(1,1)*(LPCTX(NX)+VKPT(1,N))
              GIXY=RECI(1,2)*(LPCTX(NX)+VKPT(1,N))
              G1=GX
              G2=GY
              G3=GZ
              GIXZ=RECI(1,3)*(LPCTX(NX)+VKPT(1,N))
              ENERGX=HSQDTM*(GX**2)
              ENERGY=HSQDTM*(GY**2)
              ENERGZ=HSQDTM*(GZ**2)
              ENERG=ENERGX+ENERGY+ENERGZ
              ENERIX=HSQDTM*((GIXX+GIYX+GIZX)**2)
              ENERIY=HSQDTM*((GIXY+GIYY+GIZY)**2)
              ENERIZ=HSQDTM*((GIXZ+GIYZ+GIZZ)**2)
              ENERGI=ENERIX+ENERIY+ENERIZ
              IF(ENERGI.GT.TESTMX) TESTMX=ENERGI
C=======================================================================
C CHECK TO SEE IF THE KINETIC ENERGY OF THE PLANE WAVE IS LESS THAN
C ENMAX IN WHICH CASE THE PLANE WAVE IS INCLUDED IN THE SET OF BASIS
C STATES FOR THE K POINT
C=======================================================================
              IF(ENERGI.GE.ENMAX) GOTO 2017
                IF(ENERG.GT.ACCMXC) ACCMXC=ENERG
                IF(ENERGI.GT.ACCMXI) ACCMXI=ENERGI
                NINDPW(NSBOXI+((N-1)*NRPLWV))=NLBOXI
                NINDX=7*(NSBOXI-1+((N-1)*NRPLWV))
                DATAKE(1+NINDX)=ENERG
                DATAKE(2+NINDX)=HSQDTM*(G1**2)
                DATAKE(3+NINDX)=HSQDTM*(G2**2)
                DATAKE(4+NINDX)=HSQDTM*(G3**2)
                DATAKE(5+NINDX)=HSQDTM*G2*G3
                DATAKE(6+NINDX)=HSQDTM*G3*G1
                DATAKE(7+NINDX)=HSQDTM*G1*G2
C=======================================================================
C     FOR THE USE OF NON-LOCAL PSEUDOPOTENTIAL ONLY
C     DNLG(*,3,*) = (Gx,Gy, Gz) in cartesian co-ordination
C=======================================================================
C was            DNLG(1,NSBOXI,N)=LPCTY(NX)
C                DNLG(2,NSBOXI,N)=LPCTY(NY)    << in unit of reciprocal 
C                DNLG(3,NSBOXI,N)=LPCTZ(NZ)       vectors
C
                 DNLG(NSBOXI,1,N)=GX
                 DNLG(NSBOXI,2,N)=GY
                 DNLG(NSBOXI,3,N)=GZ
C=======================================================================
C   THIS IS IN CARTESIAN COODINATION, TOO.
C=======================================================================
                DUM=SQRT(GX**2+GY**2+GZ**2)
                DNLKG(NSBOXI,0,N)=DUM
                IF(DUM.LE.0.000001) THEN
                  DO 2015 I=1,3
                    DNLKG(NSBOXI,I,N)=0.57735027
 2015             CONTINUE
                ELSE 
                  DNLKG(NSBOXI,1,N)=GX/DUM
                  DNLKG(NSBOXI,2,N)=GY/DUM
                  DNLKG(NSBOXI,3,N)=GZ/DUM
                END IF
                NSBOXI=NSBOXI+1
 2017         CONTINUE
              NLBOXI=NLBOXI+1
 2012       CONTINUE
 2011     CONTINUE
 2010   CONTINUE
C=======================================================================
C CHECK TO SEE IF THERE ARE LESS THAN NRPLWV BASIS STATES AT THIS K POIN
C IF NOT REDUCE ENMAX AND START THE WHOLE PROCESS AGAIN
C=======================================================================
        IF(NRPLWV.LT.NSBOXI) THEN
          WRITE(*,2020) ENMAX,TESTMX,NSBOXI,NRPLWV
          ENMAX=ENMAX-1
          GOTO 10
        ENDIF
        NPLWKP(N)=NSBOXI-1
        IF(IPRINT.GE.1) WRITE(*,2050) (NSBOXI-1),N
 2000 CONTINUE
      WRITE(*,2030) ACCMXI
      WRITE(*,2040) ACCMXC
C
 2020 FORMAT(/,1X,'GENTR: ENMAX,TESTMAX,NSBOXI,NRPLWV',2F12.6,2I7)
 2030 FORMAT(2X,'PLANE-WAVES UP TO ',F8.2,' eV IN ORIGINAL CELL ',
     &            'HAVE BEEN ACCEPTED ')
 2040 FORMAT(2X,'PLANE-WAVES UP TO ',F8.2,' eV IN   N E W  CELL ',
     &            'HAVE BEEN ACCEPTED')
 2050 FORMAT(/,' GENTR:',I5,' PLANE-WAVES FOR K-POINT No',I3)
      RETURN
      END

      SUBROUTINE FREQCY(FMATRX,FREQ,CNORML,REDMAS,TRAVEL,EORC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION FMATRX(*), REDMAS(*), FREQ(*), CNORML(*), TRAVEL(*)
      LOGICAL EORC
*********************************************************************
*
*  FRCE CALCULATES THE FORCE CONSTANTS AND VIBRATIONAL FREQUENCIES
*       FOR A MOLECULE.  IT USES THE ISOTOPIC MASSES TO WEIGHT THE
*       FORCE MATRIX
*
* ON INPUT   FMATRX   =  FORCE MATRIX, OF SIZE NUMAT*3*(NUMAT*3+1)/2.
*
*********************************************************************
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /SCRACH/ OLDF(MAXHES), DUMMY(MAXPAR**2-MAXHES)
      DIMENSION WTMASS(MAXPAR), SHIFT(6)
      DATA FACT/6.023D23/
C
C    CONVERSION FACTOR FOR SPEED OF LIGHT AND 2 PI.
C
      C2PI=1.D0/(2.998D10*3.141592653598D0*2.D0)
C NOW TO CALCULATE THE VIBRATIONAL FREQUENCIES
C
C   FIND CONVERSION CONSTANTS FOR MASS WEIGHTED SYSTEM
      N3=3*NUMAT
      L=0
      DO 10 I=1,NUMAT
         WEIGHT=1.4142136D0/SQRT(ATMASS(I))
         DO 10 J=1,3
            L=L+1
   10 WTMASS(L)=WEIGHT
C    CONVERT TO MASS WEIGHTED FMATRX
      LINEAR=0
      DO 20 I=1,N3
         DO 20 J=1,I
            LINEAR=LINEAR+1
            OLDF(LINEAR)=  FMATRX(LINEAR)*1.D5
   20 FMATRX(LINEAR)=FMATRX(LINEAR)*WTMASS(I)*WTMASS(J)
C
C    1.D5 IS TO CONVERT FROM MILLIDYNES/ANGSTROM TO DYNES/CM.
C
C    DIAGONALIZE
      CALL FRAME(FMATRX,NUMAT,1, SHIFT)
      CALL RSP(FMATRX,N3,N3,FREQ,CNORML)
      DO 30 I=1,N3
         J=(FREQ(I)+50.D0)*0.01D0
   30 FREQ(I)=FREQ(I)-J*100
      DO 40 I=1,N3
   40 FREQ(I)=FREQ(I)*1.D5
C
C    CALCULATE REDUCED MASSES, STORE IN REDMAS
C
      DO 80 I=1,N3
         II=(I-1)*N3
         SUM=0.D0
         DO 70 J=1,N3
            JII=J+II
            JJ=(J*(J-1))/2
            DO 50 K=1,J
   50       SUM=SUM+CNORML(JII)*OLDF(JJ+K)*CNORML(K+II)
            DO 60 K=J+1,N3
   60       SUM=SUM+CNORML(JII)*OLDF((K*(K-1))/2+J)*CNORML(K+II)
   70    CONTINUE
         SUM1=SUM*2.D0
         IF(ABS(FREQ(I)).GT.ABS(SUM)*1.D-20) THEN
            SUM=1.D0*SUM/FREQ(I)
         ELSE
            SUM=0.D0
         ENDIF
         FREQ(I)=SIGN(SQRT(FACT*ABS(FREQ(I)))*C2PI,FREQ(I))
         IF(ABS(FREQ(I)).LT.ABS(SUM1)*1.D+20) THEN
            SUM1=SQRT(ABS(FREQ(I)/(SUM1*1.D-5)))
         ELSE
            SUM1=0.D0
         ENDIF
         IF(SUM.LT.0.D0.OR.SUM.GT.100)SUM=0.D0
C
C 0.0063024=SQRT(2*A*B*C/N) WHERE
C         A=1.196D8 = CONVERSION OF CM**(-1) TO (ERGS = DYNE.ANGSTROMS)
C         B=1000.0  = MILLIDYNES TO DYNES
C         C=1.D8    = CENTIMETERS TO ANGSTROMS
C         N=6.02205D23 = AVOGADRO'S NUMBER
         TRAVEL(I)=SUM1*0.0063024D0
         IF(TRAVEL(I).GT.1.D0)TRAVEL(I)=0.D0
C#      WRITE(6,*)TRAVEL(I)
   80 REDMAS(I)=SUM
      IF(EORC) THEN
C
C    SWITCH EIGENVALUES TO FREQUENCIES
C
C    CONVERT NORMAL VECTORS TO CARTESIAN COORDINATES
C    AND NORMALIZE SO THAT THE TOTAL MOVEMENT IS 1.0 ANGSTROM.
C
         IJ=0
         DO 120 I=1,N3
            SUM=0.D0
            J=0
            DO 100 JJ=1,NUMAT
               SUM1=0.D0
               DO 90 J1=1,3
                  J=J+1
                  IJ=IJ+1
                  CNORML(IJ)=CNORML(IJ)*WTMASS(J)
   90          SUM1=SUM1+CNORML(IJ)**2
  100       SUM=SUM+SQRT(SUM1)
            SUM=1.D0/SUM
            IJ=IJ-N3
            DO 110 J=1,N3
               IJ=IJ+1
  110       CNORML(IJ)=CNORML(IJ)*SUM
  120    CONTINUE
C
C          RETURN HESSIAN IN MILLIDYNES/ANGSTROM IN FMATRX
C
         DO 130 I=1,LINEAR
  130    FMATRX(I)=OLDF(I)*1.D-5
      ELSE
C
C  RETURN HESSIAN AS MASS-WEIGHTED FMATRIX
         LINEAR=0
C
         DO 140 I=1,N3
            DO 140 J=1,I
               LINEAR=LINEAR+1
  140    FMATRX(LINEAR)=OLDF(LINEAR)*1.D-5*WTMASS(I)*WTMASS(J)
      ENDIF
      RETURN
      END

C     *****************
      SUBROUTINE SUREXC(
C     *****************
     >                  NXYZH,NXYTH,NXZTH,NYZTH,
     >                  NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >                  ICC,ILD,
     >                  LINKS,WK1,NVE,NVH,
     >                  GX,GY,GZ,GT,
     >                  GXY,GXZ,GXT,GYZ,GYT,GZT,
     >                  LX,LY,LZ,LT,
     >                  LXY,LXZ,LXT,LYZ,LYT,LZT)
C
C
C     SUBROUTINE  SUREXC EXCHANGES THE SURFACES OF THE FOUR DIMENSIONAL
C     LATTICE AND PROVIDES PERIODIC BOUNDARY CONDITIONS
C
C
C     LATEST REVISION - NOV. 1989; E.KEHL
C
C
      DOUBLE PRECISION LINKS(NVE,18,4),
     >                 WK1(NVH,18)
C
C
      INTEGER          GX(NYZTH,2,4),GY(NXZTH,2,4),
     >                 GZ(NXYTH,2,4),GT(NXYZH,2,4)
C
      INTEGER          GXY(NZTH,2,4),GXZ(NYTH,2,4),
     >                 GXT(NYZH,2,4),GYZ(NXTH,2,4),
     >                 GYT(NXZH,2,4),GZT(NXYH,2,4)
C
      INTEGER          LX(2,4),LY(2,4),
     >                 LZ(2,4),LT(2,4)
C
      INTEGER          LXY(2,4),LXZ(2,4),
     >                 LXT(2,4),LYZ(2,4),
     >                 LYT(2,4),LZT(2,4)
C
C
C     EXCHANGE OF X-LINKS
C
C
      IF( ILD .EQ. 1 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, WK1,ICC,ILD )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GX,NYZTH,2,4, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, WK1,ICC,ILD )
C
         CALL SRLKS(
     >        LINKS,NVE,GXY, NZTH,1,3,LXY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GXZ, NYTH,1,3,LXZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GXT, NYZH,1,3,LXT, WK1,ICC,ILD )
C
      ENDIF
C
C
C     EXCHANGE OF Y-LINKS
C
C
      IF( ILD .EQ. 2 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, WK1,ICC,ILD )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GY,NXZTH,2,4, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, WK1,ICC,ILD )
C
         CALL SRLKS(
     >        LINKS,NVE,GXY, NZTH,2,4,LXY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GYZ, NXTH,1,3,LYZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GYT, NXZH,1,3,LYT, WK1,ICC,ILD )
C
      ENDIF
C
C
C     EXCHANGE OF Z-LINKS
C
C
      IF( ILD .EQ. 3 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, WK1,ICC,ILD )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GZ,NXYTH,2,4, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,2,4, LT, WK1,ICC,ILD )
C
         CALL SRLKS(
     >        LINKS,NVE,GXZ, NYTH,2,4,LXZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GYZ, NXTH,2,4,LYZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GZT, NXYH,1,3,LZT, WK1,ICC,ILD )
C
      ENDIF
C
C
C     EXCHANGE OF T-LINKS
C
C
      IF( ILD .EQ. 4 ) THEN
C
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,1,3, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GX,NYZTH,2,4, LX, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,1,3, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GY,NXZTH,2,4, LY, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,1,3, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GZ,NXYTH,2,4, LZ, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE, GT,NXYZH,1,3, LT, WK1,ICC,ILD )
CNOT     CALL SRLKS(
CNOT >        LINKS,NVE, GT,NXYZH,2,4, LT, WK1,ICC,ILD )
C
         CALL SRLKS(
     >        LINKS,NVE,GXT, NYZH,2,4,LXT, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GYT, NXZH,2,4,LYT, WK1,ICC,ILD )
         CALL SRLKS(
     >        LINKS,NVE,GZT, NXYH,2,4,LZT, WK1,ICC,ILD )
C
      ENDIF
C
C
      RETURN
      END

      FUNCTION CPTIME ()
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   RETURNS THE CPU TIME SINCE THE LAST CALL TO CPTIME.
C   THIS SUBPROGRAM MAY BE CHANGED AS NEEDED FOR A PARTICULAR COMPUTER
C   SYSTEM WITHOUT PENALTY, PROVIDED IT PERFORMS THIS FUNCTION.
C
      DOUBLE PRECISION CPUTIM,TX
      EXTERNAL CPUTIM
      SAVE TX
      DATA TX/0./
      T = CPUTIM ()
      CPTIME = T - TX
      TX = T
      RETURN
      END

      SUBROUTINE READI(INPUT,A,B,IIROW,JJCOL,N,IZ)
C..   MATRIX INPUT; BORROWED FROM INVPOWER-BENCHMARK 26.1.1991/SBS
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(*),B(N)
      DIMENSION IIROW(*),JJCOL(*)
C     
      IP=1
 100  CONTINUE
      IZ=IP-1
      READ(INPUT,1000,END=110) 
     +     JCOL,IROW,NTERMS,(B(I),I=1,NTERMS)
c--     +     JCOL,IROW,NTERMS,(A(I),I=IP,IP+NTERMS-1)
      DO 120 I=IP,IP+NTERMS-1
         A(I) = B(I-IP+1)
         IIROW(I)=IROW+I-IP
         JJCOL(I)=JCOL
 120  CONTINUE
      IP=IP+NTERMS
      GOTO 100
 110  CONTINUE
      DO 200 I=1,N
         B(I)=I
 200  CONTINUE
 1000 FORMAT(2I5,I3,5F13.0,:,/(6F13.0))
      END

      DOUBLE PRECISION FUNCTION RES(U,F,NX,NY,NZ,H)
C
C	COMPUTES THE MAXIMUM NORM OF THE DEFECT
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ), F(NX,NY,NZ)
C
      RES = 0.
      FAC=1/(H*H)
      DO 30 K=2,NZ-1
        DO 20 J=2,NY-1
          DO 10 I=2,NX-1
            D = F(I,J,K)+FAC*(-6.0*U(I,J,K)+U(I-1,J,K)+U(I+1,J,K)
     *                                     +U(I,J-1,K)+U(I,J+1,K)
     *                                     +U(I,J,K-1)+U(I,J,K+1))
               RES = MAX(ABS(D),RES)
   10     CONTINUE
   20   CONTINUE
   30 CONTINUE
      END

      PROGRAM CASTEP
       INCLUDE 'param.inc'
C========================================================================
C   
C                                CASTEP 
C
C                 CAmbridge Serial Total Energy Package
C                             Cambridge 1991
C========================================================================
C
C     THIS IS A MODIFIED VERSION OF MC PAYNE'S CONJUGATE GRADIENT PROGRAM
C     EFFORTS OF FOLLOWING COLLABORATORS WHO TOOK PART IN THE 
C     DEVELOPMENT OF THIS PACKAGE SHOULD BE MENTIONED :
C     LATE XUDONG WENG, VICTOR MILMAN, GRAHAM FRANCIS, UWE BERTRAM,
C     BJORK HAMMER ET AL.
C
C     CURRENT MAINTENANCE AND SUBSEQUENT CHANGES ARE DUE TO VICTOR MILMAN
C     E-MAIL   VYM10@UK.AC.CAM.PHX     OR
C              MILMAN@UK.AC.CAMBRIDGE.WEST.PHYSICS
C
C========================================================================
C
C                               CGION 8
C
C========================================================================
C
C     THE MAJOR CHANGES ARE:
C     1) EITHER LOCAL OR NONLOCAL PSEUDOPOTENTIALS COULD BE USED, WITH 
C        THE LATER IN THE KLEIMANN-BYLANDER FORM.
C     2) GAUSSIAN BROADENING OF BANDS ARE INCLUDED TO ACCOUNT POSSIBLE
C        PARTIAL FILLING OF BANDS AROUND THE FERMI ENERGY.
C     3) THIS VERSION ALLOWS TO PERFORM EFFICIENT STATIC IONIC RELAXATION
C     4) SYMMETRIZATION OF THE CHARGE DENSITY IS INTRODUCED THUS
C        IT IS POSSIBLE TO USE ONLY SPECIAL K-POINTS WHICH ARE
C        INEQUIALENT WITH RESPECT TO SYMMETRY OPERATIONS
C     5) CONSTRAINED IONIC RELAXATION IS ALLOWED WITH ARBITRARY
C        CONSTRAINTS SUPPLIED BY USER (IN CASE OF SYMMETRIZED 
C        VERSION SYMMETRY IS PRESERVED AUTOMATICALLY)
C      
C-------------------------------------------------------------------------
C     THE CHANGES ARE LISTED HERE FOR YOUR REFERENCE.  
C
C     16-MAR-90 COPYIED FROM GEGBSC.FOR (WENG'S LATEST VERSION OF PAYNE'S
C               LOCAL PSEUDOPTENTIAL CONJUGATE GRADIENT PROGRAM)
C     16-MAR-90 THE FOLLOWING CHANGES ARE MADE
C		-- DIMENSION STATEMENTS ADDED FOR NON-LOCAL CALCULATION
C	        -- NEW READ IN STATEMENTS, FROM UNIT 11
C		-- DNLG, DNLKG ADDED WHEN CALLING GENSP1
C		-- CALL FNLFOR ADDED (FROM 'DO 3131' TO '3130 CONTINUE')
C               -- CALL NLCV ADDED TO SET UP CVL(G,Rn)=V(G)EXP(IG.Rn)
C               -- CALL VNL ADDED TO CALCULATE <G'|Vnl|G>
C
C     31-MAR-90 TESTED ON SILICON (OK).   
C
C     14-APR-90 VNL ADDED, REPLACING THE AUX IN CONGRA
C     20-APR-90 VNL INITIALISED, NECESSARY FOR NKPTS>1
C               DO 8364 ... 
C
C     23-MAY-90 Several modifations for re-starting
C               CELEN   ( DO 35 ....) 
C               GENSP1 - > GENSP
C
C     15-JUN-90 IVPTYP = 0 using local pseudopotential     -- tested and
C	               = 1 using non-local pseudopotential -- worked
C
C     17-JUN-90 CV0, CV1, AND CV2 ARE REDUCED TO ONE K-POINT A TIME
C               TO REDUCE THE DEMAND ON MEMORY SPACE.
C               ( SEE CONGRA FOR COMMENTS )
C
C     18-JUN-90 GAUSSIAN BROADENING OF BANDS ADDED, ACTIVATED BY SETTING
C               IOCCUP=1. TEST ON AL FCC 4 ATOMUNIT CELL AGREED WITH 
C               B. HAMMER'S INDEPENDENT RESULTS.
C
C     26-JUN-90 RESTRUCTURED THE NON-LOCAL PART. THE USAGE OF CV0,CV1 AND
C               CV2 IS ABANDONED. WE NOW USE
C 	        1) CPHSGR(NRPLWV,NIONS,NSPEC) = EXP(iq.Rn)
C	        2) VGNL(RPLWV,0:2,NNSPEC) = Vnl(l,q)
C	        IN ORDER TO REDUCE THE REQUIRED SPACE. TESTED OK
C
C     03-JUN-90 NON-ORTHOGONAL UNIT CELL PART OF HAMMER'S PROGRAM IS
C		INCORPORATED.
C
C     03-JUN-90 CPU TIME COUNTER ADDED. TO ACTIVATE, SET ICLOCK=1
C
C     03-JUN-90 NEW VERSION OF NON-LOCAL POTENTIAL (STILL FOR CUBIC 
C		UNIT CELL ONLY). 
C
C     22-JUL-90 RE-START WITH DIFFERENT CUT-OFF ENERGY IS SUCESSFUL.
C               HOWEVER, MUST WITH NGX,NGY,NGZ,NRPLWV UNCHANGED.
C
C
C     14-OCT-90 PARAMETER STATEMENT IN SUBROUTINE EWALD.FOR IS MOVED
C	        INTO THE MAIN PROGRAM. 
C
C     11-JAN-91 SEVERAL CHANGES ARE MADE, MAINLY RELATED TO THE ADDITION
C               OF NON-LOCAL CONTRIBUTION OF THE STRESS 
C               AND A LITTLE RE-STRUCTURING.
C
C     13-FEB-91 IONIC RELAXATION INCLUDED. THIS VERSION DOES NOT NEED
C               IMDTR ROUTINE. NEW PARAMETER NIONCG SHOULD BE SPECIFIED
C               IN A COMMAND FILE. TESTED FOR SILICON.
C
C     26-APR-91 NONLOCAL POTENTIAL PART IS RESTRUCTURED, AND
C               ORDER OF INDICES IS CHANGED FOR CORRESPONDING ARRAYS.
C               AS A RESULT THE NUMBER OF FORMAL PARAMETERS FOR THE
C               CALL OF VNLWAV HAS BEEN CHANGED.
C
C               NITFIX VARIABLE INTRODUCED TO PERFORM NITFIX ITERATIONS
C               OF CONGRA BEFORE MOVING IONS.
C
C      1-MAY-91 RANDOM GENERATION OF INITIAL WAVE FUNCTION IS INCLUDED
C               FOR INRAND=1 (NEW PARAMETER) AND IS PROVIDED BY
C               WFINRN SUBROUTINE
C
C      1-JUL-91 UNIT NUMBERS FOR FILES WITH WAVEFUNCTIONS ARE CHANGED
C
C     16-JUL-91 NEW SCHEME FOR STATIC IONIC RELAXATION WITH THE ENERGY
C               MINIMISATION IN BOTH IONIC AND ELECTRONIC COORDINATES 
C               SPACE IS INTRODUCED. TESTED FOR SEMICONDUCTORS.
C
C     15-SEP-91 ADDITIONAL CALLS TO SUBROT AND EFERMI ARE INSERTED IN
C               THE IONIC RELAXATION PART TO ACCELERATE CONVERGENCE
C               FOR METALS (IOCCUP=1). TESTED FOR Al
C
C     10-OCT-91 MIXED LOCAL-NONLOCAL POTENTIALS ARE ENABLED. READING
C               FROM FILE 11 HAS BEEN CHANGED FOR LOCAL POTENTIAL AND
C               ARRAY DPSP HAS BEEN REMOVED.
C
C      9-NOV-91 BUG IN THE MAIN CODE IS REMOVED WHICH WAS AFFECTING
C               SIMULATIONS WITH ODD NUMBER OF ELECTRONS (LOOP 5210).
C
C               VARIABLE NPRINT HAS NOW MEANING OF THE FREQUENCY OF
C               FORCE AND STRESS CALCULATION WHICH IS PERFORMED EACH
C               NPRINT'TH ITERATION BEFORE NDELAY. AFTER NDELAY
C               IT HAS NO MEANING. DURING RELAXATION, STRESS IS
C               CALCULATED ONLY IF UNIT CELL IS SUPPOSED TO RELAX,
C               OTHERWISE IT IS CALCULATED AT THE LAST ITERATION ONLY.
C
C     10-NOV-91 CONSTRAINED IONIC RELAXATION IS ENABLED. USER DEFINED
C               SUBROUTINE "CONSTR" IS REQUIRED WHICH SPECIFIES MATRIX
C               OF DERIVATIVES OF OLD COORDINATES WITH RESPECT TO NEW
C               ONES. SAMPLE "CONSTR" CORRESPONDS TO ELIMINATION OF
C               FIXED ATOMS AND/OR TO PHONON DISPLACEMENTS.
C               
C     13-JAN-92 SYMMETRIZED SCHEME IS ENABLED. ONLY SYMMETRY
C               UNRELATED SPECIAL K-POINTS NEED TO BE USED, AND
C               PROPER CHARGE DENSITY, IONIC FORCES AND STRESSES
C               ARE CALCULATED USING SYMMETRY OPERATIONS.
C               EXTRA DATA FILE (UNIT 3) IS REQUIRED WITH
C               CRYSTALLOGRAPHIC INFORMATION. THIS FILE SHOULD
C               BE CREATED BY K290 PROGRAM (MODIFIED PROGRAM
C               BY R.J.NEEDS,K.KUNC,O.H.NIELSEN,R.M.MARTIN)
C
C***********************************************************************
C***********************************************************************
C
C  GEGBS
C
C***********************************************************************
C***********************************************************************
C=======================================================================
C THIS IS THE MAIN PROGRAM OF A SET OF PROGRAMS WRITTEN TO PERFORM TOTAL
C ENERGY CALCULATIONS USING THE MOLECULAR DYNAMICS METHOD INTRODUCED BY
C R. CAR AND M. PARRINELLO (PHYSICAL REVIEW LETTERS 55, 2471 (1985)).
C=======================================================================
C THIS VERSION OF THE PROGRAMS WAS WRITTEN FOR USE ON THE FPS-164
C COMPUTER, CALLS TO FPS SUBROUTINES WILL BE IDENTIFIED WHEREVER THEY
C APPEAR (WHICH IS ONLY IN THE MAIN PROGRAM AND THE ORTHOGONALISATION
C SUBROUTINE). THE FPS-164 IS A 64 BIT MACHINE SO THESE SINGLE PRECISION
C PROGRAMS ACTUALLY RUN AT THE ACCURACY OF FORTRAN DOUBLE PRECISION.
C FOR USE ON NON-64 BIT MACHINES THE VARIABLES SHOULD BE DECLARED DOUBLE
C PRECISION OR THE PROGRAMS COMPILED USING AN AUTO-DOUBLE COMPILER.
C=======================================================================
C THIS IS THE SIMPLEST FORM OF THE PROGRAMS. THE UNIT CELL MUST BE
C ORTHORHOMBIC AND THE WAVEFUNCTIONS MUST ALL FIT INTO CORE MEMORY. THE
C METHOD IS MEMORY INTENSIVE AND EXPERIENCE HAS SHOWN THAT CALCULATING
C THE REAL SPACE WAVEFUNCTIONS TWICE EACH TIMESTEP IS FASTER THAN
C WRITING AND READING THEM FROM DISK. IF THE COMPUTER HAS A SOLID STATE
C DISK THIS WILL PROBABLY NO LONGER BE TRUE. THE PROGRAM USES A LOCAL
C PSEUDOPOTENTIAL TO EXPLOIT THE INCREASE IN SPEED OBTAINED BY USING
C FAST FOURIER TRANSFORMS. THE PROGRAM IS WRITTEN FOR A SINGLE SPECIES
C OF ION. PROGRAMS FOR NON-ORTHORHOMBIC UNIT CELLS, FOR MORE THAN ONE
C SPECIES OF ION AND FOR HANDLING MORE WAVEFUNCTIONS THAN FIT IN CORE
C MEMORY HAVE BEEN WRITTEN AND ARE SCATTERED BETWEEN OTHER MEMBERS OF
C PROFESSOR JOHN JOANNOPOULOS'S RESEARCH GROUP AT THE MASSACHUSETTS
C INSTITUTE OF TECHNOLOGY
C=======================================================================
C THIS PROGRAM IS SET UP TO RELAX THE ELECTRONS TO THEIR GROUNDSTATE
C WHILE KEEPING THE IONS AND THE SIZE OF THE  UNIT CELL FIXED. THE
C ELECTRONIC SYSTEM MUST BE RELAXED TO ITS GROUNDSTATE BEFORE THE FORCES
C EXERTED BY THE ELECTRONS ON THE IONS AND THE UNIT CELL ARE CORRECTLY
C GIVEN BY THE HELLMANN-FEYNMAN THEOREM. THE PROGRAM FUFGMSP IS SET UP
C TO READ IN THE RELAXED WAVEFUNCTIONS AND PROCEED TO PERFORM MOLECULAR
C DYNAMICS OR SIMULATED ANNEALING ON THE IONIC SYSTEM OR TO RELAX THE
C SIZE OF THE UNIT CELL. THESE OPERATIONS MAY BE PERFORMED USING THE
C PRESENT PROGRAM BY SIMPLY REMOVING THE FORTRAN COMMENTS FROM THE
C APPROPRIATE SUBROUTINE CALLS
C=======================================================================
C THE UNITS USED IN THE PROGRAMS ARE ELECTRON-VOLTS AND ANGSTROMS
C=======================================================================
C THE STRUCTURE OF THE PROGRAM IS ALMOST TOTALLY DETERMINED BY THE USE
C OF FAST FOURIER TRANSFORMS. THE INDEXING OF THE RECIPROCAL LATTICE IS
C IMPOSED BY THE FAST FOURIER TRANSFORM. THE FFT INTRODUCES A FICTITIOUS
C PERIODICITY IN RECIPROCAL SPACE, IN THE USUAL LABELLING THE RECIPROCAL
C LATTICE POINTS WITH NEGATIVE RECIPROCAL LATTICE VECTOR ARE SHIFTED BY
C THE WAVEVECTOR OF THE ARTIFICIAL PERIODICITY TO BECOME THE COMPONENTS
C LABELLED BY LARGE POSITIVE RECIPROCAL LATTICE VECTORS. THIS EXPLAINS
C THE NEED FOR THE LOOP COUNTERS LPCTX,Y,Z WHICH KEEP TRACK OF THE
C TRUE RECIPROCAL LATTICE VECTORS REPRESENTED BY THE RECIPROCAL LATTICE
C POINTS. THE CALL TO THE FAST FOURIER TRANSFORM IS THROUGH FFT3D
C WHICH IS A SUBROUTINE THAT REORDERS THE DATA IN THE THREE DIMENSIONAL
C FOURIER TRANSFORM GRID TO MAKE OPTIMUM USE OF CFFT99 WHICH IS A
C VECTORISED FAST FOURIER TRANSFORM ROUTINE. PARAMETER STATMENTS IN
C MUST BE CHANGED BEFORE RUNNING THE PROGRAMS
C
C IN FFT3D: ISIGN = -1 : FORWARD : REAL --> RECIP : EXP(+IQR)
C           ISIGN = +1 : BACKWARD: RECIP --> REAL : EXP(-IQR)
C
C=======================================================================
C
C **************TERMS IN THE PARAMETER STATEMENT************************
C
C NGX,NGY,NGZ = THE NUMBER OF RECIPROCAL LATTICE POINTS (AND DUE TO THE
C      PROPERTIES OF THE FAST FOURIER TRANSFORM) THE NUMBER OF POINTS ON
C      THE REAL SPACE GRID IN THE X,Y AND Z DIRECTIONS, RESPECTIVELY.
C NIONS = THE NUMBER OF IONS IN THE UNIT CELL.
C NPSPTS = THE NUMBER OF VALUES IN THE ARRAY USED TO INTERPOLATE THE
C             PSEUDOPOTENTIAL.
C NBANDS = THE NUMBER OF VALENCE BANDS
C NKPTS = THE NUMBER OF SPECIAL K POINTS USED FOR AVERAGING OVER THE
C             BRILLOUIN ZONE.
C NEWPTS = THE NUMBER OF VALUES IN THE ARRAY USED TO INTERPOLATE
C             THE EWALD INTEGRALS
C NEDDPT = IS THE NUMBER OF VALUES USED TO INTERPOLATE THE DATA FOR THE
C             EQUATIONS OF MOTION OF THE ELECTRONIC STATES.
C NPLWV = THE TOTAL NUMBER OF POINTS IN THE REAL AND RECIPROCAL SPACE
C             GRIDS
C NRPLWV = THE MAXIMUM NUMBER OF PLANE WAVE COMPONENTS THAT CAN BE
C      INCLUDED AT ANY K-POINT (THIS WILL LIMIT THE CUT-OFF ENERGY USED)
C=======================================================================
C      IMPLICIT COMPLEX*8 (C)
C=======================================================================
C           Dimensional parameters and control parameters
C                 SI 8 atom unit cell
C
C      PARAMETER(NGX=8,NGY=8,NGZ=8,
C     &   NPLWV=NGX*NGY*NGZ,MPLWV=NGX*NGY*(NGZ+1),
C     &   NPSPTS=501,
C     &   NRPLWV=100,
C     &   NEWPTS=1000, NEDDPT=2000,
C     &   NIONS=8,    NSPEC=1,
C     &   NBANDS=16,   NBANOC=16,    NKPTS=1)
C      DATA NAT /8/
C      DATA ISBROT/0/
C      DATA IOCCUP,DELMIN,DELMAX,NDEL/0,0.2,0.8,3/
C      DATA IPRINT/2/
C      DATA ICLOCK/0/
C      DATA IION,IBOX/1,0/
C      DATA ISTART,NITMAX,NDELAY/0,2,15/
C      DATA NITFIX/1/
C      DATA INRAND/0/
C      DATA NMDCG/1/
C      DATA NIONCG/2/
C=======================================================================
C  THE FOLLOWING ARE PARAMETERS ORIGINALLY INSIDE SUBROUTINE EWLALTR.F
C=======================================================================
C      PARAMETER(MAXCX=3, MAXCY=3, MAXCZ=3,
C     &          MAXGPX=3,MAXGPY=3,MAXGPZ=3,
C     &   NCELLX=(2*MAXCX)+1,NCELLY=(2*MAXCY)+1,NCELLZ=(2*MAXCZ)+1,
C     &   NCELLS=NCELLX*NCELLY*NCELLZ,
C     &   NGPTX=(2*MAXGPX)+1,NGPTY=(2*MAXGPY)+1,NGPTZ=(2*MAXGPZ)+1,
C     &   NGPTS=NGPTX*NGPTY*NGPTZ)
C=====================================================================
C=======================================================================
C FOR AL 4 ATOM CELL
C=======================================================================
C      PARAMETER(NGX=16,NGY=16,NGZ=16,NIONS=4,NSPEC=1,NBANOC=12,
C     &   NPSPTS=600,NBANDS=12,NKPTS=1,NEWPTS=1000,NEDDPT=2000,
C     &   NPLWV=NGX*NGY*NGZ,MPLWV=NGX*NGY*(NGZ+1),NRPLWV=250)
C=======================================================================
C Parameters are added:
C=======================================================================
C  NITMAX: ITERATION NUMBER IN CONGRA
C  NDELAY: ITERATION NUMBER DELAYED, BEFORE ANY DYNAMICS STARTS.
C  ISTART: 0 FOR STARTING FROM BEGIN
C          1 FOR RE-START, NEED FOR013 AND FOR016
C  IVPTYP: 0 FOR LOCAL PSEUDOPOTENTIAL
C          1 FOR NON-LOCAL PSEUDOPOTENTIAL
C  ISBROT: SUB-SPACE ROTATION, 0=NO, 1=YES  (SHOULD BE 1, IF IOCCUP=1)
C  IOCCUP: USING OCCUPATION NUMBER 0=NO, 1=YES
C  IPRINT: THE EXTENT OF PRINT-OUT, 1 FOR GENERAL USE 
C=======================================================================
C      DATA ISTART,NITMAX,NDELAY/0,3,10/
C      DATA IVPTYP/0/
C      DATA ISBROT/1/
C      DATA IOCCUP,DELMIN,DELMAX,NDEL/1,0.026,0.2,4/
C      DATA IPRINT/1/
C      DATA ICLOCK/0/
C=======================================================================
C  THE FOLLOWING ARE PARAMETERS ORIGINALLY INSIDE SUBROUTINE EWLALTR.F
C							14-OCT-90
C
C             TERMS IN THE PARAMETER STATEMENT
C
C MAXCX,MAXCY,MAXCZ = THE NUMBER OF CELLS IN EACH DIRECTION FROM THE
C CENTRAL CELL INCLUDED IN THE EVALUATION OF THE REAL SPACE EWALD SUMS
C THE VALUES OF THESE PARAMETERS SHOULD BE CHOSEN SO THAT
C MAXCX(Y,Z)*SQRT(PI)*SIZEX(Y,Z)/MIN(SIZEX,SIZEY,SIZEZ) ARE ALL GREATER
C THAN 3, (THE LARGER THE VALUE THE CLOSER TO THE CORRECT COULOMB SUM)
C MAXGPX,MAXGPY,MAXGPZ = THE NUMBER OF RECIPROCAL LATTICE POINTS IN EACH
C DIRECTION FROM G=0 INCLUDED IN THE EVALUATION OF THE RECIPROCAL SPACE
C EWALD SUMS. THE VALUES OF THESE PARAMETERS SHOULD BE CHOSEN SO THAT
C NGPTX(Y,Z)*MIN(SIZEX,SIZEY,SIZEZ)/(SQRT(PI)*SIZEX(Y,X) ARE ALL GREATER
C THAN 3, (THE LARGER THE VALUE THE CLOSER TO THE CORRECT COULOMB SUM)
C ARGMRE IS THE ARGUMENT CORRESPONDING TO THE LAST ELEMENT IN THE REAL
C SPACE EWALD INTEGRAL DATA ARRAYS
C ARGMRC IS THE ARGUMENT CORRESPONDING TO THE LAST ELEMENT IN THE
C RECIPROCAL SPACE EWALD INTEGRAL DATA ARRAYS
C NEWPTS IS THE NUMBER OF VALUES IN THE EWALD INTEGRAL DATA ARRAYS
C=======================================================================
C      PARAMETER(MAXCX=4, MAXCY=4, MAXCZ=2,
C     &          MAXGPX=4,MAXGPY=4,MAXGPZ=6,
C     &   NCELLX=(2*MAXCX)+1,NCELLY=(2*MAXCY)+1,NCELLZ=(2*MAXCZ)+1,
C     &   NCELLS=NCELLX*NCELLY*NCELLZ,
C     &   NGPTX=(2*MAXGPX)+1,NGPTY=(2*MAXGPY)+1,NGPTZ=(2*MAXGPZ)+1,
C     &   NGPTS=NGPTX*NGPTY*NGPTZ)
C=======================================================================
C
C  * VARIABLES AND DIMENSION STATEMENTS FOR ARRAYS USED IN SUBROUTINES *
C
C SIZEX,SIZEY,SIZEZ = THE SIZE OF THE UNIT CELL IN X,Y,Z DIRECTIONS
C SIZELX,SIZELY,SIZELZ = THE SIZE OF THE UNIT CELL AT THE LAST TIMESTEP
C SIZEIX,SIZEIY,SIZEIZ = THE INITIAL SIZE OF THE UNIT CELL, THESE MUST
C BE USED IN THE CALL TO GENSP TO ENSURE THAT THE INDICES FOR THE
C COMPONENTS OF THE WAVEFUNCTIONS ARE CORRECT. (IF A CONSTANT CUT-OFF
C ENERGY FOR THE PLANE WAVE BASIS STATES IS REQUIRED THE WAVEFUNCTIONS
C CAN BE READ IN USING THE INDEXING SCHEME BASED ON SIZEIX,Y,Z AND THEN
C           PUT INTO A NEW ARRAY BASED ON THE PRESENT SIZE OF THE BOX).
C POSION(3,NIONS) = THE COORDINATES OF THE IONS IN THE UNIT CELL
C POSIOL(3,NIONS) = THE COORDINATES OF THE IONS AT THE LAST TIMESTEP
C CSTRF(NPLWV) = THE STRUCTURE FACTOR AT THE GRID OF RECIPROCAL LATTICE
C                POINTS
C PSP(NPSPTS) = THE ARRAY OF DATA VALUES USED TO INTERPOLATE THE
C                    PSEUDOPOTENTIAL
C PSCORE = THE G=0 COMPONENT OF THE PSEUDOPOTENTIAL REMAINING AFTER
C          SUBTRACTION OF THE COULOMB POTENTIAL. THIS CONTRIBUTES TO
C                    THE AVERAGE POTENTIAL IN THE PSEUDO-SOLID
C PSGMAX = THE G VECTOR CORRESPONDING TO THE LAST DATA VALUE IN THE
C                    PSEUDOPOTENTIAL ARRAYS
C SIGAL(6) = THE STRESS ON THE UNIT CELL DUE TO THE PSEUDOPTENTIAL CORE
C PSCENC = THE CONTRIBUTION TO THE TOTAL ENERGY DUE TO THE
C                    PSEUDOPOTENTIAL CORE
C VPS(NPLWV) = THE PSEUDOPOTENTIAL ON THE GRID OF RECIPROCAL LATTICE
C                    VECTORS
C DVPS(NPLWV) = THE DERIVATIVE OF THE PSEUDOPOTENTIAL ON THE GRID OF
C                    RECIPROCAL LATTICE VECTORS
C CV(NPLWV) = THE TOTAL POTENTIAL ON THE GRID OF RECIPROCAL LATTICE
C             VECTORS (IE PSEUDOPOTENTIAL*STRUCTURE FACTOR + HARTREE +
C                    EXCHANGE-CORRELATION POTENTIAL)
C CVD(NPLWV) = THE HARTREE POTENTIAL ON THE GRID OF RECIPROCAL LATTICE
C                    VECTORS
C CHDENR(NPLWV) = THE CHARGE DENSITY ON THE GRID OF REAL LATTICE VECTORS
C CHDENG(NPLWV) = THE CHARGE DENSITY ON THE GRID OF RECIPROCAL LATTICE
C                    VECTORS
C DSIF(3) = THE FORCE ON THE UNIT CELL DUE TO THE HARTREE ENERGY
C DENC = THE CORRECTION TO THE TOTAL ENERGY DUE TO OVERCOUNTING THE
C        HARTREE ENERGY ON SUMMING THE ENERGY EIGENVALUES OF THE
C                     ELECTRONIC STATES
C XCSIF(3) = THE FORCE ON THE BOX DUE TO THE EXCHANGE CORRELATION ENERGY
C XCENC = THE CORRECTION TO THE TOTAL ENERGY DUE TO OVERCOUNTING THE
C         EXCHANGE CORRELATION  ENERGY ON SUMMING THE ENERGY EIGENVALUES
C                     OF THE ELECTRONIC STATES
C VKPT(3,NKPTS) = THE COORDINATES OF THE SPECIAL K POINTS USED FOR
C                     BRILLOUIN ZONE AVERAGES
C WTKPT(NKPTS) = THE WEIGHT TO BE ATTACHED TO EACH SPECIAL K POINT
C CPTWFP(NRPLWV,NBANDS,NKPTS) = THE COMPONENTS OF THE ELECTRONIC
C                     WAVEFUNCTIONS AT THE PRESENT TIMESTEP
C CPTWFL(NRPLWV,NBANDS,NKPTS) = THE COMPONENTS OF THE ELECTRONIC
C                     WAVEFUNCTIONS AT THE LAST TIMESTEP
C SIKEF(3) = THE FORCE ON THE UNIT CELL DUE TO THE KINETIC ENERGY OF THE
C                     ELECTRONIC STATES
C TIME = THE TIMESTEP USED IN INTEGRATING THE EQUATIONS OF MOTION FOR
C                     THE ELECTRONIC STATES
C ELDAMP = THE DAMPING USED WHEN INTEGRATING THE EQUATIONS OF MOTION FOR
C                     THE ELECTRONIC STATES
C SIDAMP = THE DAMPIMG FACTOR USED IN INTEGRATING THE EQUATIONS OF
C                     MOTION FOR THE SIZE OF THE UNIT CELL
C SIMASS = THE MASS ASSOCIATED WITH THE SIZE OF THE UNIT CELL
C PODAMP = THE DAMPING FACTOR USED IN INTEGRATING THE EQUATIONS OF
C                     MOTION FOR THE POSITIONS OF THE IONS
C POMASS = THE MASS ASSOCIATED WITH THE IONS
C CELEN(NBANDS,NKPTS) = THE ENERGY EIGENVALUES OF THE ELECTRONIC STATES
C EIFOR(3,NIONS) = THE FORCE EXERTED ON THE IONS BY THE ELECTRONS
C EISIF(3) = THE FORCE EXERTED ON THE UNIT CELL DUE THE ELECTRON-ION
C                     ENERGY
C EWRLEN(NEWPTS),EWRCSS(NEWPTS),EWRLSS(NEWPTS),EWRCSI(NEWPTS) = THE DATA
C           ARRAYS USED TO INTERPOLATE THE VALUES OF THE EWALD INTEGRALS
C TEWEN = THE EWALD ENERGY
C EWIFOR(3,NIONS) = THE FORCE ON THE IONS DUE TO THE COULOMB FORCES
C                     FROM THE OTHER IONS
C EWSIF(3) = THE FORCE ON THE UNIT CELL DUE TO THE EWALD ENERGY
C LPCTX(NGX),LPCTY(NGY),LPCTZ(NGZ) = ARRAYS USED TO LABEL THE RECIPROCAL
C           LATTICE VECTORS. DUE TO THE PERIODICITY IMPOSED BY THE FAST
C           FOURIER TRANSFORMS THE NEGATIVE RECIPROCAL LATTICE VECTORS
C           GX=-1,-2..,N,..(2*PI/SIZEX) ARE CONTAINED IN THE NGX+1-N
C           COMPONENTS OF THE ARRAY TO BE TRANSFORMED. THESE ARRAYS GIVE
C           THE CORRECT LABELLING OF THE RECIPROCAL LATTICE VECTORS
C LPCTFX(NGX),LPCTFY(NGY),LPCTFZ(NGZ) = AS ABOVE BUT WITH THE (NGX/2)+1
C           COMPONENTS SET EQUAL TO 0 SO THAT THE ABSENCE OF A
C           -((NGX/2)+1) WAVEVECTOR COMPONENT IN THE CHARGE DENSITY
C           DOESN'T LEAD TO A SPURIOUS FORCE ON THE IONS FROM THE
C           ELECTRONS
C NGPTAR(3) = THE NUMBER OF RECIPROCAL LATTICE POINTS IN THE X,Y,Z
C             DIRECTIONS, USED IN THE CALL TO THE FAST FOURIER TRANSFORM
C NDIM = THE DIMENSION OF THE FAST FOURIER TRANSFORM
C POTIM = A VARIABLE TIMEPERIOD USED IN INTEGRATING THE EQUATIONS OF
C         MOTION OF THE IONS
C PODISP = THE LARGEST DISTANCE (AS A FRACTION OF THE UNIT CELL SIZE)
C          THAT AN ION IS ALLOWED TO MOVE DURING ONE TIMESTEP. THIS
C          MUST BE LIMITED TO A VALUE THAT ALLOWS THE ELECTRONS TO
C          FOLLOW THE IONIC MOTIONS WITHOUT GETTING TOO FAR FROM THEIR
C          GROUNDSTATE OR THE HELLMANN-FEYNMAN FORCES WILL BE INCORRECT
C ENMAX = THE KINETIC ENERGY CUTOFF FOR THE PLANE WAVE BASIS SET
C NINDPW(NRPLWV,NKPTS) = THE NUMBER INDICES IN THE RECIPROCAL LATTICE
C           GRID OF THE PLANE WAVE BASIS STATES. THIS ARRAY IS USED TO
C           PLACE THE "SPHERE" OF PLANE WAVE BASIS STATES AT EACH K
C           POINT INTO THE BOX USED FOR THE FOURIER TRANSFORMS
C NPLWKP(NKPTS) = THE NUMBER OF PLANE WAVE BASIS STATES AT EACH K POINT
C DATAKE(7,NRPLWV,NKPTS) = THE KINETIC OF THE PLANE WAVE BASIS STATES
C           AND THE X,Y AND Z COMPONENTS OF THE KINETIC ENERGY AT EACH
C           K POINT
C RMOVE(NIONS*NSPEC) = 1.0 IF ION IS ALLOWED TO MOVE OTHERWISE = 0.0
C STATZD = DISTANCE FROM THE EDGE OF THE UNIT CELL TO THE FIXED
C           LAYERS OF ATOMS
C=======================================================================
      PARAMETER (NINSP=NIONS*NSPEC)  
      DIMENSION POSION(3,NIONS,NSPEC)
      DIMENSION POSIOL(3,NIONS,NSPEC)
      DIMENSION CSTRF(NPLWV,NSPEC)
      DIMENSION PSP(NPSPTS,NSPEC)
      DIMENSION VPS(NPLWV,NSPEC), DVPS(NPLWV,NSPEC)
      DIMENSION CV(NPLWV)
      DIMENSION CVD(NPLWV)
      DIMENSION CHDENR(NPLWV), CHDENG(NPLWV)
      DIMENSION CVION(NPLWV)
      DIMENSION VKPT(3,NKPTS), WTKPT(NKPTS)
      DIMENSION CPTWFP(NRPLWV,NBANDS)
      DIMENSION CPTWFL(NRPLWV)
      DIMENSION SIKEF(3)
      DIMENSION CELEN(NBANDS,NKPTS)
      DIMENSION EIFOR(3,NIONS,NSPEC)
      DIMENSION EWRLEN(NEWPTS),EWRCSS(NEWPTS),EWRLSS(NEWPTS),
     &  EWRCSI(NEWPTS)
      DIMENSION EWIFOR(3,NIONS,NSPEC)
      DIMENSION LPCTX(NGX),LPCTY(NGY),LPCTZ(NGZ)
      DIMENSION LPCTFX(NGX),LPCTFY(NGY),LPCTFZ(NGZ)
      DIMENSION NGPTAR(3)
      DIMENSION NINDPW(NRPLWV,NKPTS)
      DIMENSION NPLWKP(NKPTS)
      DIMENSION DATAKE(7,NRPLWV,NKPTS)
      DIMENSION PSCORE(NSPEC)
      DIMENSION PSGMAX(NSPEC)
      DIMENSION ICHARG(NSPEC)
      DIMENSION NIONSP(NSPEC)
      DIMENSION POMASS(NSPEC)
      DIMENSION POSIC(3,NINSP)
      DIMENSION POSICL(3,NINSP)
      DIMENSION EWIFC(3,NINSP)
      DIMENSION EIFC(3,NINSP)
      DIMENSION POMASC(NINSP)
      DIMENSION ICHARC(NINSP)
      DIMENSION RMOVE(NINSP), RMOVEO(NINSP)
      DIMENSION IVPTYN(NSPEC),NPSPTN(NSPEC)
      DIMENSION EXCDAT(2000),XCFDAT(2000),XCPDAT(2000)
      DIMENSION DIRDAT(NPLWV)
C
C
C********************* DIMENSION STATEMENTS ****************************
C
C TIFOR(3,NIONS) = THE TOTAL FORCE ON THE IONS
C
      DIMENSION TIFOR(3,NIONS,NSPEC)
      DIMENSION TIFORC(3,NINSP)
C
C
C     DIMENSION STATEMENTS FOR WORK ARRAYS USED IN SUBROUTINES
C
C     (the dimension of NWORK1 and WORK1 is tripled for random
C     generating of initial wave functions, X.WENG) 
C
      DIMENSION NWORK1(3*NBANDS)
      DIMENSION WORK1(3*NBANDS),WORK3(3,NKPTS),WORK7(3,NIONS,NSPEC),
     &    WORK8(3,NIONS,NSPEC),WORK9(3,NIONS,NSPEC)
      DIMENSION CWORK(MPLWV),CWORK1(MPLWV),CWORK2(MPLWV)
      DIMENSION CWORK3(NGX),CWORK4(NGY),CWORK5(NGZ)
      DIMENSION CWORK6(NRPLWV),CWORK7(NRPLWV),CWORK8(NRPLWV),
     &    CWORK9(NRPLWV),CWOR10(NRPLWV),CWOR11(NRPLWV),WORK12(NPLWV)
C=======================================================================
C     SPACE USED IN REASSN                                WENG 23-JUL-90
C=======================================================================
      DIMENSION IASSGN(NRPLWV), RECO(3,3)
C=======================================================================
C     SPACE USED IN CONGRA (in SUBROT)                    WENG 27-FEB-90
C=======================================================================
      DIMENSION HR(NBANDS, NBANDS), HI(NBANDS, NBANDS), AUX(NBANDS),
     & FV1(NBANDS), FV2(NBANDS), FV3(NBANDS), CH0(NBANDS, NBANDS)
C=======================================================================
C     SPACE USED FOR OCCUPATION NUMBER                    WENG 12-MAR-90
C=======================================================================
      REAL EIGVAL(NBANDS,NKPTS),OCC(NBANDS,NKPTS),SORT(NBANDS,NKPTS)
C=======================================================================
C     DIMENSION STATEMENTS FOR THE NON-LOCAL CALCULATION
C=======================================================================
      DIMENSION PSCALE(0:2,NSPEC),PSPNL(NPSPTS,0:2,NSPEC)
      DIMENSION DNLG(NRPLWV,3,NKPTS),DNLKG(NRPLWV,0:3,NKPTS)
      DIMENSION LOCAL(NSPEC)
C========================================================================
C ARRAYS NEEDED FOR REAL SPACE PROJECTION OF THE NON-LOCAL POTENTIALS
C========================================================================
C
C VRLNL(NRLPTS,MXRLNL,NSPEC) - THE NON-LOCAL PSEUDOPOTENTIALS ON A
C                              RADIAL GRID
C NRLNL(NSPEC) - THE NUMBER OF NON-LOCAL POTENTIALS FOR EACH SPECIES
C IRLNL(MXRLNL,NSPEC) - THE L NUMBER OF EACH NON-LOCAL POTENTIAL
C RLCORE(NSPEC) - THE CORE RADIUS FOR EACH SPECIES
C RMAX(NSPEC) - THE LARGEST RADIUS IN THE NON-LOCAL POTENTIAL ARRAYS
C VRLGRD(NRGRPT,MXRLSH,NIONST) - THE NON-LOCAL POTENTIALS ON THE RADIAL
C              SPACE GRID FOR EACH SPHERICAL HARMONIC FOR EACH POTENTIAL
C              FOR EACH SPECIES
C CPHGRD(NRGRPT,NIONST) - THE PHASE FACTORS FOR MULTIPLYING THE
C              WAVEFUNCTIONS ON THE REAL SPACE GRID
C DVRLGR(NRGRPT,3,MXRLSH,NIONST) - THE X.Y.Z. DERIVATIVES OF THE NON-
C              LOCAL POTENTIALS ON THE REAL SPACE GRID
C NSHSP(NSPEC) - THE TOTAL NUMBER OF NON-LOCAL PROJECTIONS (INCLUDING
C              'M' VALUES FOR EACH SPECIES
C NADGRD(NRGRPT,NIONST) - THE ADDRESS ARRAY THAT INDEXES POINTS ON THE
C              REAL SPACE GRID WITHIN THE CORE RADIUS OF EACH ATOM
C NRLPPI(NIONST) - THE TOTAL NUMEBR OF REAL SPACE POINTS WITHIN THE
C              CORE RADIUS AROUND EACH ATOM
C FNLRL(3,NIONST) - THE FORCES ON THE IONS
C=======================================================================
      DIMENSION  VRLNL(NRLPTS,MXRLNL,NSPEC)                        
      DIMENSION  NRLNL(NSPEC),PRLSCA(MXRLNL,NSPEC)                 
      DIMENSION  IRLNL(MXRLNL,NSPEC),RLCORE(NSPEC),RMAX(NSPEC)     
      DIMENSION  VRLGRD(NRGRPT,MXRLSH,NIONST),CPHGRD(NRGRPT,NIONST)
      DIMENSION  DVRLGR(NRGRPT,3,MXRLSH,NIONST),NSHSP(NSPEC)       
      DIMENSION  NADGRD(NRGRPT,NIONST),NRLPPI(NIONST)              
      DIMENSION  FNLRL(3,NIONST)                                   
C======================================================================
      DIMENSION CPHSGR(NRPLWV,NIONS,NSPEC),VGNL(NRPLWV,0:2,NSPEC),
     &                                     DVGNL(NRPLWV,0:2,NSPEC)
      DIMENSION CELFRC(NRPLWV)
      DIMENSION FNLEIF(3,NIONS,NSPEC),FORWK(3,NIONS)
      DIMENSION CWRK20(NIONS),CWRK21(3,NIONS)
      DIMENSION CWRK22(NIONS),CWRK23(3,3,NIONS)
      DIMENSION VNL(NBANDS,NKPTS)
C========================================================================
C WORK ARRAYS FOR REAL SPACE NON-LOCAL (PARALLEL)
C=======================================================================
      DIMENSION CESAVE(NIONST,36)
C=======================================================================
C     THE WORK ARRAYS ADDED FOR THE NON-LOCAL STRESS, BY U. BERTRAM
C=======================================================================
      DIMENSION CWRK30(NBANDS,NIONS),CWRK31(NBANDS,NIONS,6)
      DIMENSION CWRK32(NBANDS,NIONS,3),CWRK33(NBANDS,NIONS,6,3)
      DIMENSION CWRK34(NBANDS,NIONS,6,3),CWRK35(NBANDS,NIONS,3,3)
      DIMENSION CWRK36(NBANDS,NIONS,6,3,3),CWRK37(NBANDS,NIONS)
      DIMENSION CWRK38(NBANDS,NIONS,6),CWRK39(NBANDS,NIONS,6,3,3)
      DIMENSION SIGWK(6)
C========================================================================
C          ** DIMENSIONS ADDED FOR TRICLINIC CELL  **
C========================================================================
C
C DIRC(3,3) = CURRENT BASIS VECTORS IN REAL SPACE FOR THE SUPER-CELL
C DIRI(3,3) = INITIAL BASIS VECTORS IN REAL SPACE FOR THE SUPER-CELL
C DIRL(3,3) = LAST BASIS VECTORS IN REAL SPACE FOR THE SUPER-CELL
C RECC(3,3) = CURRENT BASIS VECTORS IN RECIPROCAL SPACE
C RECI(3,3) = INITIAL BASIS VECTORS IN RECIPROCAL SPACE
C VOLC = CURRENT VOLUME OF THE SUPER-CELL
C VOLI = INITIAL VOLUME OF THE SUPER-CELL
C        THE INITIAL-VALUES WILL BE USED IN THE CALL TO GENSP TO ENSURE
C        THAT THE INDICES FOR THE COMPONENTS OF THE WAVEFUNCTIONS ARE
C        CORRECT. (IF A CONSTANT CUT-OFF ENERGY FOR THE PLANE WAVE BASIS
C        STATES IS REQUIRED THE WAVEFUNCTIONS CAN BE READ IN USING THE
C        INDEXING SCHEME BASED ON DIRI() AND THEN PUT INTO A NEW ARRAY
C        BASED ON THE PRESENT BASUS OF THE BOX).
C SIGKE(6) = STRESS ON UNIT CELL DUE TO THE KIN.ENERGY OF THE ELEC.STATES
C SIGHA(6) = STRESS ON UNIT CELL DUE TO THE HARTREE ENERGY
C SIGXC(6) = STRESS ON UNIT CELL DUE TO THE EXCHANGE CORRELATION ENERGY
C SIGEI(6) = STRESS ON UNIT CELL DUE THE ELECTRON-ION ENERGY
C SIGAL(6) = STRESS ON UNIT CELL DUE TO THE PSEUDOPTENTIAL CORE
C SIGEW(6) = STRESS ON UNIT CELL DUE TO THE EWALD ENERGY
C========================================================================
      DIMENSION DIRC(3,3),RECC(3,3),DIRL(3,3)
      DIMENSION DIRI(3,3),RECI(3,3)
      DIMENSION SIGKE(6),SIGEI(6),SIGHA(6),SIGNL(6)
      DIMENSION SIGXC(6),SIGAL(6),SIGEW(6),SIGTO(6)
C========================================================================
C    FOR THE USE OF SUBROUTINE "EWALD.FOR" ONLY
C========================================================================
      DIMENSION RFORCE(3,NINSP,NINSP)
      DIMENSION CFORCE(3,NINSP,NINSP)
      DIMENSION FORCEG(3,NGPTS),FORSIG(6,NGPTS),ENERG(NGPTS)
      DIMENSION CPHFX(NGPTX), CPHFY(NGPTY), CPHFZ(NGPTZ)
C========================================================================
C NEW ARRAYS NEEDED FOR CONJUGATE GRADIENTS MINIMISATION OF IONIC
C ENERGIES SUBJECT TO FIXED ELECTRONIC CONFIGURATION
C
C GRION(3,NIONS*NSPEC) ESSENTIALLY THE FORCES FOR THE PRESENT IONIC POSITIONS
C      THESE BEING THE STEEPEST DESCENTS DIRECTIONS FOR MOVING THE IONS
C GRIONP(3,NIONS*NSPEC) THE SAME BUT FOR THE PREVIOUS IONIC POSITIONS
C DIRION(3,NIONS*NSPEC) THE CONJUGATE DIRECTION FOR MOVING THE IONS
C DIPION(3,NIONS*NSPEC) THE PREVIOUS CONJUGATE DIRECTION FOR MOVING THE IONS
C POSIOT(3,NIONS,NSPEC) THE TRIAL POSITIONS FOR DETERMINING STEP LENGTH
C POSITC(3,NIONS*NSPEC) SAME INFO IN COMPACT FORM
C
C  ORIGINAL VERSION OF GRAHAM FRANCIS, IMPLEMENTED BY VICTOR MILMAN
C========================================================================
      DIMENSION CVTRUE(NPLWV)
      DIMENSION CVOLD(NPLWV)
      DIMENSION CVIONT(NPLWV)
      DIMENSION GRION(3,NINSP)
      DIMENSION GRIONP(3,NINSP)
      DIMENSION DIRION(3,NINSP)
      DIMENSION DIPION(3,NINSP)
      DIMENSION GRNEW(3*NINSP)
      DIMENSION GRNEWP(3*NINSP)
      DIMENSION DIRNEW(3*NINSP)
      DIMENSION DIPNEW(3*NINSP)
      DIMENSION POSIOT(3,NIONS,NSPEC)
      DIMENSION POSITC(3,NINSP)
      DIMENSION RCNSTR(3*NINSP,3*NINSP)
      DIMENSION VNLT(NBANDS,NKPTS)
C========================================================================
C  FOR THE USE OF SUBROUTINE "ROSYM.FOR" ONLY  (A.QTEISH)
C========================================================================
C      PARAMETER (NDIM9=10,NDIM10=10)
      DIMENSION LPCTXI(-NGX/2:NGX/2)
      DIMENSION LPCTYI(-NGY/2:NGY/2)
      DIMENSION LPCTZI(-NGZ/2:NGZ/2)
      INTEGER F0(48,NDIM9),LWGHT(NDIM10),IB(48),ITEXT(80)
      DIMENSION WVLIST(3,NDIM10),WVKO(3)
      DIMENSION V(3,48),RB(48,3,3),R(49,3,3)
      DIMENSION A1(3),A2(3),A3(3),B1(3),B2(3),B3(3)
      DIMENSION FORCEWK1(3,NINSP)
      DIMENSION FORCEWK2(3,NINSP)
C  USE MACHINE NAMES IN ALL PROGRAMS:
      COMMON /MACH1/ MACTYP             
      COMMON /MACH2/ MACHIN(0:10)       
      CHARACTER*7  MACHIN               
      DATA TWOPI /6.2831853072/
C
      MACHIN(0) = 'UNKNOWN'             
      MACHIN(1) = 'IBM'                 
      MACHIN(2) = 'CRAY'                
      MACHIN(3) = 'VAX'                 
      MACHIN(4) = 'CDC'                 
      MACHIN(5) = 'UNIVAC'              
      MACHIN(6) = 'VAX+FPS'             
      MACHIN(7) = 'CRAY-2'              
      MACHIN(8) = 'FUJITSU'             
      MACHIN(9) = 'VAX+MAP'             
C
C
      WRITE (*,*)'   ------------------------------------------------'
      WRITE (*,*)'   =             Welcome to CASTEP                ='
      WRITE (*,*)'   =     CAmbridge Serial Total Energy Package    ='
      WRITE (*,*)'   =     =====================================    ='
      WRITE (*,*)'   =     Ab initio Molecular Dynamics Program     ='
      WRITE (*,*)'   =  with Conjugate Gradient Minimisation (CG)   ='
      WRITE (*,*)'   =          for the Electronic Energy           ='
      WRITE (*,*)'   =                                              ='
      WRITE (*,*)'   =     Version of: 8 July 1992                  ='
      WRITE (*,*)'   ------------------------------------------------'
      WRITE (*,*)'  '
      WRITE (*,1859) NGX,NGY,NGZ
 1859 FORMAT(1X,' FOURIER TRANSFORM GRID: ',I3,'x',I3,'x',I3)
C
C
C
C************ THE FOLLOWING PARAMETERS ARE USER VARIABLE ***************
C
C***** THE VARIABLES ARE DEFINED IN THE COMMON BLOCK SECTION ABOVE *****
C
C UNIT 3  = CRYSTALLOGRAPHIC INFORMATION -NEEDED FOR SYMMETRIZATION ONLY
C UNIT 6  = OUTPUT FILE
C UNIT 10 = DATA FOR INTERPOLATING THE EWALD INTEGRAL
C UNIT 11 = DATA FOR INTERPOLATING THE PSEUDOPOTENTIAL
C UNIT 12 = USED TO STORE WAVEFUNCTIONS AT THE END OF THE PROGRAM AND TO
C           READ IN WAVEFUNCTIONS IF THEY ALREADY EXIST
C UNIT 13 = USED TO STORE IONIC POSITIONS, COORDINATES OF THE SPECIAL
C           K POINTS, THE SIZE OF THE UNIT CELL, THE ELECTRONIC
C           EIGENVALUES AT THE END OF PROGRAM EXECUTION, THE COORDINATES
C           OF THE SPECIAL K POINTS AND THEIR WEIGHTS  AND TO READ IN
C           THESE VALUES IF WRITTEN BY A PREVIOUSLY EXECUTED PROGRAM
C UNIT 14 = FORMATTED FILE USED TO READ THE NUMBER OF ITERATIONS, THE
C           LENGTH OF THE TIMESTEPS, DAMPING FACTORS, ETC., ETC.
C UNIT 15 = FORMATTED FILE USED TO READ IN THE SIZE OF THE UNIT CELL,
C           THE POSITIONS OF THE IONS, THE COORDINATES OF THE SPECIAL
C           K POINTS AND THE WEIGHT OF EACH K POINT
C UNIT 16 = USED TO STORE THE ELECTRONIC CHARGE DENSITY AT THE END OF
C           A SET OF ITERATIONS
C UNIT 17 = USED TO STORE WAVEFUNCTIONS AT THE END OF THE PROGRAM AND TO
C           READ IN WAVEFUNCTIONS IF THEY ALREADY EXIST
C
C
C****************** READ IN DATA FROM EXTERNAL UNITS *******************
C
C        
C=========================================================================
C     READ IN EWALD DATASET FROM UNIT 10
C=========================================================================
      OPEN (10,FORM='FORMATTED')
      REWIND 10
      READ (10,*) (EWRLEN(I),I=1,NEWPTS)
      READ (10,*) (EWRCSS(I),I=1,NEWPTS)
      READ (10,*) (EWRLSS(I),I=1,NEWPTS)
      READ (10,*) (EWRCSI(I),I=1,NEWPTS)
      CLOSE (10)
C=========================================================================
C     READ IN FROM UNIT 14
C=========================================================================
      OPEN (14,FORM='FORMATTED')
      REWIND 14
      READ (14,*) NITER
      READ (14,*) NPRINT
      READ (14,*) ENMAX
      READ (14,*) NLPOT
      READ (14,*) NITMAX
      READ (14,*) NDELAY
      READ (14,*) ISTART
      READ (14,*) ISBROT
      READ (14,*) IOCCUP
      READ (14,*) DELMIN
      READ (14,*) DELMAX
      READ (14,*) NDEL
      WRITE (*,*)' ISBROT: ',ISBROT,' IOCCUP: ',IOCCUP
      IF (IOCCUP.NE.0) THEN
        WRITE (*,*)' DELMIN, DELMAX:',DELMIN,DELMAX
        WRITE (*,*)' NDEL (FREQUENCY OF DEL HALVING): ',NDEL
      ENDIF
      READ (14,*) IION
      READ (14,*) IBOX
      WRITE (*,*)' RELAXATION: IONS= ',IION,'  UNIT CELL= ',IBOX
      READ (14,*) IPRINT
      READ (14,*) NIONCG
      WRITE (*,*)' NIONCG: ',NIONCG
      READ (14,*) NITFIX
      WRITE (*,*)' NITFIX: ',NITFIX
      READ (14,*) INRAND
      WRITE (*,*)' INRAND: ',INRAND
      READ (14,*) ICLOCK
      WRITE (*,*)' ICLOCK: ',ICLOCK,' IPRINT: ',IPRINT
      IF (ICLOCK.EQ.1) CALL SCLOCK
      READ (14,*) SITIM
      READ (14,*) SIDAMP
      READ (14,*) SIMASS
      READ (14,*) SIDISP
      READ (14,*) POTIM
      READ (14,*) PODISP
      WRITE (*,*) '  ENMAX =', ENMAX
      WRITE (*,*) '  SITIM =', SITIM
      WRITE (*,*) '  POTIM =', POTIM
      DO 452 NSP = 1 , NSPEC
        READ (14,*) IDUMMY
        ICHARG(NSP) = IDUMMY
 452  CONTINUE
      DO 454 NSP = 1 , NSPEC
        READ (14,*) DUMMY
        POMASS(NSP) = DUMMY
 454  CONTINUE
      DO 456 NSP = 1 , NSPEC
        READ (14,*) IDUMMY
        NIONSP(NSP) = IDUMMY
        IF (NIONSP(NSP).GT. NIONS) STOP
     &    'NIONSP(NSP)>NIONS! INCREASE NIONS IN THE PARAMETER STATEMENT'
 456  CONTINUE
C========================================================================
C  IVPTYP = 0 IF ALL POTENTIALS ARE LOCAL
C           1    THERE IS AT LEAST ONE NONLOCAL PSEUDOPOTENTIAL
C========================================================================
      IVPTYP=0
      DO 457 NSP=1,NSPEC
        READ(14,*) IDUMMY
        IVPTYN(NSP) = IDUMMY
        IVPTYP = IVPTYP + IDUMMY * IDUMMY
        WRITE(*,*)' IVPTYN ',IVPTYN(NSP), ' NIONSP ',NIONSP(NSP)
 457  CONTINUE
      IF (IVPTYP.GT.0) IVPTYP = 1
      IF (IVPTYP.EQ.0) NLPOT = 0
C========================================================================
C  READ DIMENSIONS OF PSEUDOPOTENTIAL ARRAYS
C========================================================================
      DO 458 NSP=1,NSPEC
        READ(14,*) IDUMMY
        NPSPTN(NSP)=IDUMMY
        WRITE(*,*)' NPSPTN',NPSPTN(NSP)
        IF (IDUMMY.GT.NPSPTS) STOP'NPSPTN>NPSPTS - INCREASE NPSPTS!'
 458  CONTINUE
      READ (14,*) SCAL
      READ (14,*) ISYMM
      READ (14,*) IBANS
      IF (IBANS.EQ.1) THEN
        ISTART = 1
        WRITE (*,*) ' IBANS=1, SO WE READ CHARGE DENSITY FROM FILE 13'
      END IF
      IF (IION.NE.0) THEN
        WRITE (*,*) ' ICNSTR = 0 (NO CONSTRAINTS) OR 1 (CONSTRAINTS)'
        ICNSTR = 0
        READ (14,*,END=459,ERR=459) IDUMMY
        ICNSTR = IDUMMY
        WRITE (*,*) ICNSTR
        GO TO 455
 459    CONTINUE
        WRITE (*,*) ' UNCONSTRAINED MINIMISATION (DEFAULT VALUE)'
 455    CONTINUE
      END IF
C=========================================================================
C  NEXTWR   -  FREQUENCY OF WRITING TO EXTERNAL FILES (13,16,17,28 ETC.)
C              DATA FOR THE MD RESTART ARE WRITTEN TO 13 FILE
C=========================================================================
      READ (14,*,ERR=8330,END=8330) NEXTWR
      GO TO 8331
 8330 NEXTWR = 5
 8331 IF (NEXTWR.EQ.0) NEXTWR = 1
      WRITE (*,*) ' NEXTWR=',NEXTWR
      CLOSE (14)
C=========================================================================
C CALCULATE THE TOTAL NUMBER OF ELECTRONS, NELECT, THE TOTAL CHARGE ON
C THE IONS, NIONCH, AND THE SUM OF THE SQUARES OF THE CHARGES ON THE
C IONS, NICHSQ, AND THE TOTAL NUMBER OF IONS, NIONST.
C=========================================================================
      NELECT = 0
      NIONCH = 0
      NICHSQ = 0
      NIONST1 = 0
      DO 3105 NSP = 1 , NSPEC
        NELECT = NELECT + ICHARG(NSP) * NIONSP(NSP)
        NIONCH = NIONCH + ICHARG(NSP) * NIONSP(NSP)
        NICHSQ = NICHSQ + ICHARG(NSP) * ICHARG(NSP) * NIONSP(NSP)
        NIONST1 = NIONST1 + NIONSP(NSP)
 3105 CONTINUE
      IF (NIONST1.NE.NIONST)STOP'CHECK NIONST!'
      IF (NBANDS*2.LT.NELECT)STOP'NBANDS*2 < NELECT, INCREASE NBANDS' 
C=========================================================================
C  READ DATA FOR SYMMETRIZATION
C=========================================================================
      IF (ISYMM.NE.0) THEN
        WRITE (*,*) ' READ INFORMATION NEEDED FOR SYMMETRIZATION'
        CALL SPPTRD(ITEXT,IHG,IHC,ISY,LI,NC,IB,V,F0,R,NIONST,NDIM9,
     &              NDIM10,NUMKPT,IQ1,IQ2,IQ3,WVKO,LWGHT,WVLIST,
     &              A1,A2,A3,B1,B2,B3)
        WRITE (*,*) ' NAT=',NIONST,' NDIM9=',NDIM9,' NDIM10=',NDIM10
        WRITE (*,*) ' IQ 1-3: ',IQ1,IQ2,IQ3
        WRITE (*,*) ' ISY,NC: ',ISY,NC
        WRITE (*,*) ' FILE CONTAINS ',NUMKPT,' SPECIAL POINTS:'
        ISUM = 0
        DO 4020 I = 1 , NUMKPT
          ISUM = ISUM + LWGHT(I)
          DO 4021 M = 1 , 3
            WORK3(M,1) = 0.0
 4021     CONTINUE
          DO 4022 M = 1 , 3
            WORK3(1,1) = WORK3(1,1) + WVLIST(M,I) * A1(M)
            WORK3(2,1) = WORK3(2,1) + WVLIST(M,I) * A2(M)
            WORK3(3,1) = WORK3(3,1) + WVLIST(M,I) * A3(M)
 4022     CONTINUE
          DO 4023 M = 1 , 3
            WVLIST(M,I) = WORK3(M,1)
 4023     CONTINUE
 4020   CONTINUE
        SUMWEI = 1.0 / FLOAT(ISUM)
        DO 4024 I = 1 , NUMKPT
          WEIGHT = FLOAT(LWGHT(I)) * SUMWEI
          WRITE (*,4025) I,WEIGHT,(WVLIST(M,I),M=1,3)
 4024   CONTINUE
        SUMWEI = 2.0 * SUMWEI
        WRITE (*,*) ' SPPTRD FINISHED'
        WRITE (*,*) ' NATURAL WEIGHT: ',SUMWEI
      END IF
 4025 FORMAT(1X,'NKP:',I3,' WEIGHT=',F10.7,' K=(',3F10.7,')')
C=========================================================================
C     READ IN PSEUDOPOTENTIAL DATASET FROM UNIT 11  (X. WENG 14-JUN-90)
C=========================================================================
      OPEN (11,FORM='FORMATTED')
      REWIND 11
      DO 10 NSP=1,NSPEC
        IF(IVPTYN(NSP).EQ.0) THEN
C=========================================================================
C     1) READ IN LOCAL PSEUDOPOTENTIAL                
C     PSCORE MUST BE STORED AS THE SECOND ELEMENT OF THE PSEUDOPOTENTIAL,
C     AND PSGMAX AS THE FIRST ELEMENT 
C=========================================================================
          READ(11,*) PSGMAX(NSP)
          READ(11,*) (PSP(I,NSP), I=1,NPSPTN(NSP))
          PSCORE(NSP)=PSP(1,NSP)
          WRITE(*,*)' PSGMAX(NSP) =',PSGMAX(NSP)
          WRITE(*,*)' PSCORE(NSP) =',PSCORE(NSP)
          PSP(1,NSP)=0.0
          PSP(2,NSP)=0.0
        ELSE
C=========================================================================
C     2) READ IN NON-LOCAL PSEUDOPOTENTIAL
C     PSCORE MUST BE STORED AS THE FIRST ELEMENT OF THE PSEUDOPOTENTIAL,
C=========================================================================
          LOCAL(NSP)=-1
          READ(11,*) PSGMAX(NSP)
          READ(11,*) (PSP(J,NSP),J=1,NPSPTN(NSP))
          DO 40 L=0,2
            READ(11,*) PSCALE(L,NSP)
            IF (ABS(PSCALE(L,NSP)).LT.0.00001) LOCAL(NSP)=L
            READ(11,*) (PSPNL(J,L,NSP),J=1,NPSPTN(NSP))
   40     CONTINUE
          PSCORE(NSP)=PSP(1,NSP)
          PSP(1,NSP)=0.0
          PSP(2,NSP)=0.0
          WRITE(*,*)' PSCORE(NSP)  =', PSCORE(NSP)
          WRITE(*,*)' PGMAX(NSP)   =', PSGMAX(NSP)
          WRITE(*,*)' PSCALE(0,NSP)=', PSCALE(0,NSP)
          WRITE(*,*)' PSCALE(1,NSP)=', PSCALE(1,NSP)
          WRITE(*,*)' PSCALE(2,NSP)=', PSCALE(2,NSP)
          WRITE(*,*)'THE LOCAL POTENTIAL IS THE ONE WITH L=',LOCAL(NSP)
C=======================================================================
C  IF NLPOT=1 WE USE REAL-SPACE IMPLEMENTATION OF NON-LOCAL POTENTIAL
C=======================================================================
          IF (NLPOT.EQ.1) THEN
            READ(18,*) RLCORE(NSP)
            READ(18,*) RMAX(NSP)
C========================================================================
C THE ROUTINE CAN HANDLE ARBITRARY NUMBERS OF NON-LOCAL POTENTIALS
C FOR L=0,1,2 SO ENHANCED KLEINMAN-BYLANDER PROJECTIONS OR VANDERBILT
C POTENTIALS SHOULD CAUSE FEW PROBLEMS
C========================================================================
C THE TOTAL NUMBER OF PROJECTIONS (INCLUDING M VALUES) IS RECORDED BY
C NSPHAR - START BY SETTING IT TO 0
C========================================================================
            NSPHAR=0
C========================================================================
C NOW START READING THE NON-LOCAL POTENTIALS, THE FIRST VALUE READ IS
C THE L VALUE, A VALUE OF 1000 SHOULD BE USED TO MARK THE END OF THE
C POTENTIAL FILE AT WHICH POINT THE PROGRAM MOVES TO THE NEXT SPECIES
C OF ION AFTER RECORDING THE VALUE OF NSPHAR AS NSHSP(NSP)
C========================================================================
            DO 31 NRLIND=1,MXRLNL
              READ(18,*) ISP
              IF(ISP.EQ.1000) GO TO 32
              IRLNL(NRLIND,NSP)=ISP
              NSPHAR=NSPHAR+(1+2*ISP)
              READ(18,*) PRLSCA(NRLIND,NSP)
              READ(18,*) (VRLNL(I,NRLIND,NSP),I=1,NRLPTS)
              WRITE (*,*) '  PRLSCA(NRLIND,NSP) =',PRLSCA(NRLIND,NSP)
              WRITE (*,*) '  IRLNL(NRLIND,NSP)  =',IRLNL(NRLIND,NSP)
              NRLNL(NSP)=NRLIND
 31         CONTINUE
 32         CONTINUE
C========================================================================
C CHECK THAT ARRAYS ARE LARGE ENOUGH TO HOLD ALL SPHERICAL HARMONICS
C========================================================================
            WRITE (*,*) '  NRLNL(NSP)  =',NRLNL(NSP)
            IF(NSPHAR.GT.MXRLSH) THEN
              WRITE(*,*) ' MXRLSH NOT LARGE ENOUGH  '
            END IF
            NSHSP(NSP)=NSPHAR
          END IF
        END IF
C========================================================================
C END OF LOOP FOR ION NSP
C========================================================================
   10 CONTINUE
      CLOSE (11)
C========================================================================
      POTIM0 = POTIM
      TIMEMD = 0.0
      EK = 0.0
C========================================================================
C INSTALL NUMBER OF CONJUGATE GRADIENTS ITERATIONS 
C========================================================================
      IF (NIONCG.EQ.0) THEN
        NIOCG1 = 3
        IF (IOCCUP.EQ.1) NIOCG1 = 2
      ELSE
        NIOCG1 = NIONCG
      END IF
      NIOCG0 = NIOCG1
C========================================================================
C     READ IN THE UNIT CELL VECTORS 
C     1.THE CURRENT ONES (DIRC) AND THE INITIAL ONES (DIRI)
C========================================================================
      OPEN (15,FORM='FORMATTED')
      REWIND 15
      READ (15,*) DIRC(1,1), DIRC(2,1), DIRC(3,1)
      READ (15,*) DIRC(1,2), DIRC(2,2), DIRC(3,2)
      READ (15,*) DIRC(1,3), DIRC(2,3), DIRC(3,3)
      CALL BASTR(DIRC,RECC,VOLC)
      READ (15,*) DIRI(1,1), DIRI(2,1), DIRI(3,1)
      READ (15,*) DIRI(1,2), DIRI(2,2), DIRI(3,2)
      READ (15,*) DIRI(1,3), DIRI(2,3), DIRI(3,3)
      CALL BASTR(DIRI,RECI,VOLI)
C
      WRITE (*,*) 'THE BASIS-SET USED WHEN PLACING ATOMS ( DIRC(I,J) ):'
      WRITE (*,101) ( (DIRC(I,J), I=1,3), J=1,3)
 101  FORMAT(1X,3F10.6)
      WRITE (*,*) 'THE RECIPROCAL SPACE BASIS ( RECC(I,J) ): '
      WRITE (*,101) ( (RECC(I,J), I=1,3), J=1,3)
      WRITE (*,*) 'THE BASIS-SET USED WHEN CUTTING OFF PLANE-WAVES ',
     &        '( DIRI(I,J) ): '
      WRITE (*,101) ( (DIRI(I,J), I=1,3), J=1,3)
 7007 FORMAT(1X,3F10.6)
      WRITE (*,*) ' VOLUME OF CURRENT UNIT CELL:', VOLC
      WRITE (*,*) ' VOLUME OF INITIAL UNIT CELL:', VOLI
C========================================================================
C     2.READ IN ATOMIC POSITIONS (SAME AS PAYNE'S ORIGINAL ONE)
C========================================================================
      NG = 1
      WRITE (*,*) ' '
      DO 7006 NSP = 1 , NSPEC
        DO 7008 NI = 1 , NIONSP(NSP)
          READ (15,*)    (POSION(I,NI,NSP), I=1,3), RMOVE(NG)
          WRITE (*,7004) NI,NSP,(POSION(I,NI,NSP), I=1,3), RMOVE(NG)
          NG = NG + 1
 7008   CONTINUE
        DO 7010 NI = 1 , NIONSP(NSP)
          READ (15,*)    (POSIOL(I,NI,NSP), I=1,3)
 7010   CONTINUE
 7006 CONTINUE
      DO 7011 NKP = 1 , NKPTS
        READ (15,*) VKPT(1,NKP),VKPT(2,NKP),VKPT(3,NKP)
 7011 CONTINUE
      WRITE (*,*) ' '
      DO 7012 NKP = 1 , NKPTS
        READ (15,*) WTKPT(NKP)
        WRITE (*,7014) VKPT(1,NKP),VKPT(2,NKP),VKPT(3,NKP), WTKPT(NKP)  
 7012 CONTINUE
      WRITE (*,*) ' '
      CLOSE (15)
C
 7004 FORMAT(2X,'ION ',I2,' TYPE ',I1,' AT (',3F9.6,')   RMOVE =',F5.2)
 7009 FORMAT(1X,4F10.6)
 7014 FORMAT('  SPECIAL K-POINT:',3F10.5,'   WEIGHT =', F10.5)
 7019 FORMAT(1X,3F10.6)
C=========================================================================
C     FOR RE-START, READ IN FROM FOR013 AND FOR016      (X.WENG 05-MAR-90)
C=========================================================================
      IF (ISTART.NE.1 .AND. IBANS.EQ.0) GO TO 6006
      WRITE (*,*)' ----------------------------------------------------'
      WRITE (*,*)'     SINCE ISTART=1, READ IN FROM FOR013,16,17,28....'
      WRITE (*,*)' ----------------------------------------------------'
      REWIND 13
      READ (13) ( (DIRC(I,J), I=1,3), J=1,3 )
      READ (13) VOLC
      READ (13) ( (RECC(I,J), I=1,3), J=1,3 )
      READ (13) ( (DIRI(I,J), I=1,3), J=1,3 )
      READ (13) ( ( (POSIOL(I,J,K), I=1,3), J=1,NIONS), K=1,NSPEC )
      READ (13) ( ( (POSION(I,J,K), I=1,3), J=1,NIONS), K=1,NSPEC )
      READ (13) (RMOVEO(J), J=1,NIONS*NSPEC)
      IF (IBANS.NE.0) THEN
        NGXO = NGX
        NGYO = NGY
        NGZO = NGZ
        NRPLWVO = NRPLWV
        GO TO 6005
      END IF
      READ (13) ( (CELEN(I,J),I=1,NBANDS), J=1,NKPTS)
      READ (13) ((VKPT(I,J),I=1,3),J=1,NKPTS)
      READ (13) (WTKPT(I),I=1,NKPTS)
      READ (13) ENMAXO
      READ (13) NGXO,NGYO,NGZO,NRPLWO
      READ (13) ( (RECO(I,J), I=1,3), J=1,3)
C
      WRITE (*,162) ( (DIRC(I,J), I=1,3), J=1,3)
      WRITE (*,162) ( (DIRI(I,J), I=1,3), J=1,3)
  162 FORMAT(2X,3F12.5)
63    FORMAT(1X,' KINETIC ENERGY IS ',2F10.6)
62    FORMAT(1X,6F10.6)
      WRITE (*,*) ' VOLC =',VOLC
      NG = 1
      DO 6000 K = 1 , NSPEC
        DO 6002 J = 1 , NIONSP(K)
          WRITE (*,62) (POSION(I,J,K), I=1,3), RMOVEO(NG)
          NG = NG + 1
 6002   CONTINUE  
        DO 6004 J = 1 , NIONSP(K)
          WRITE (*,62) (POSIOL(I,J,K),I=1,3)
 6004   CONTINUE
 6000 CONTINUE
      IF (IPRINT.GE.2)
     &           WRITE (*,63) ( (CELEN(I,J),I=1,NBANDS), J=1,NKPTS)
      WRITE (*,101) ( (VKPT(I,J),I=1,3), J=1,NKPTS)
      WRITE (*,102) (WTKPT(I),I=1,NKPTS)
 102  FORMAT(1X,F10.6)
C
 6005 CONTINUE
      REWIND 16
      NPLWVO = NGXO * NGYO * NGZO
      READ (16) (CHDENR(I),I=1,NPLWVO), (CHDENG(I),I=1,NPLWVO)
 6006 CONTINUE
C=========================================================================
C SET THE SIZE OF THE BOX AT THE LAST TIMESTEP TO THE VALUE AT THE
C PRESENT TIMESTEP AND SET THE ELECTRONIC ENERGY EIGENVALUES TO ZERO TO
C COMMENCE THE ELECTRONIC RELAXATION
C=========================================================================
      DO 446 J = 1 , 3
        DO 445 I = 1 , 3
          DIRL(I,J) = DIRC(I,J)
 445    CONTINUE
 446  CONTINUE
      IF (ISTART.EQ.0 .OR. IBANS.NE.0) THEN
        DO 35 I = 1 , NKPTS
          DO 36 II = 1 , NBANDS
            CELEN(II,I) = (0.0,0.0)
            EIGVAL(II,I) = 0.0
 36       CONTINUE
 35     CONTINUE
      END IF
C=========================================================================
C FORM PACKED ARRAYS CONTAINING THE MASSES OF THE IONS, POMASC, AND THE
C CHARGES ON THE IONS, ICHARC.
C=========================================================================
      NINDX = 1
      DO 3106 NSP = 1 , NSPEC
        DO 3107 NI = 1 , NIONSP(NSP)
          DO 3108 M = 1 , 3
            POSIC(M,NINDX) = POSION(M,NI,NSP)
 3108     CONTINUE
          POMASC(NINDX) = POMASS(NSP)
          ICHARC(NINDX) = ICHARG(NSP)
          NINDX = NINDX + 1
 3107   CONTINUE
 3106 CONTINUE
C=========================================================================
C     INITIALISE (ISTART=0) OR READ IN (ISTART=1) THE OCCUPATION NUMBER 
C=========================================================================
      IF (NELECT/2*2.NE.NELECT .AND. IOCCUP.EQ.0) WRITE (*,9988)
 9988 FORMAT(' WARNING - YOU HAVE ODD NUMBER OF ELECTRONS.'/
     &       ' THE LAST BAND WILL BE HALF-FILLED AUTOMATICALLY.'/
     &       ' CHECK YOUR RESULTS FOR PHYSICAL MEANINGNESS!!'/
     &       ' (PERHAPS IOCCUP=1 WOULD BE A BETTER CHOICE)')
C
      DO 5210 K = 1 , NKPTS
        DO 5211 I = 1 , NBANDS
          OCC(I,K) = 0.0
 5211   CONTINUE
        DO 5212 I = 1 , NELECT/2
          OCC(I,K) = 1.0                                   
 5212   CONTINUE
        IF (NELECT/2*2.NE.NELECT) OCC(NELECT/2+1,K) = 0.5      
 5210 CONTINUE 
      IF (ISTART*IOCCUP.NE.0) THEN
        REWIND 17
        DO 5240 NKP = 1 , NKPTS
          DO 5220 NBD = 1 , NBANDS
            READ (17,*) I,J,DUM
            IF (I.NE.NKP.OR.J.NE.NBD)
     &                   STOP'MISMATCH WHEN READING OCC FROM UNIT 17'
            OCC(NBD,NKP) = DUM
 5220     CONTINUE
 5240   CONTINUE
      END IF
C=========================================================================
C INITIALIZE THE LOOP COUNTERS LPCTX,LPCTY,LPCTZ AND LPCTFX,ETC THAT
C LABEL THE NUMBER OF THE RECIPROCAL LATTICE VECTORS IN THE X,Y,Z
C DIRECTIONS, RESPECTIVELY. FOR THE X DIRECTION THE RECIPROCAL LATTICE
C VECTORS CORRESPONDING TO THE FIRST,SECOND,...,NGXTH ELEMENTS IN ALL
C OF THE RECIPROCAL LATTICE ARRAYS ARE 0,1,..,(NGX/2),-((NGX/2-1),..,-1
C TIMES THE X RECIPROCAL LATTICE VECTOR RECC(1,*)
C=========================================================================
      DO 7020 NX = 1 , (NGX/2)+1
        LPCTX(NX)  = NX - 1
        LPCTFX(NX) = NX - 1
 7020 CONTINUE
      DO 7021 NX = (NGX/2)+2 , NGX
        LPCTX(NX)  = NX - 1 - NGX
        LPCTFX(NX) = NX - 1 - NGX
 7021 CONTINUE
      DO 7022 NY = 1 , (NGY/2)+1
        LPCTY(NY)  = NY - 1
        LPCTFY(NY) = NY - 1
 7022 CONTINUE
      DO 7023 NY = (NGY/2)+2 , NGY
        LPCTY(NY)  = NY - 1 - NGY
        LPCTFY(NY) = NY - 1 - NGY
 7023 CONTINUE
      DO 7024 NZ = 1 , (NGZ/2)+1
        LPCTZ(NZ)  = NZ - 1
        LPCTFZ(NZ) = NZ - 1  
 7024 CONTINUE
      DO 7025 NZ = (NGZ/2)+2 , NGZ
        LPCTZ(NZ)  = NZ - 1 - NGZ
        LPCTFZ(NZ) = NZ - 1 - NGZ
 7025 CONTINUE
C=========================================================================
C SET THE UNBALANCED RECIPROCAL LATTICE VECTOR COMPONENTS TO ZERO IN THE
C LPCTFX,ETC ARRAYS TO REMOVE THE UNPHYSICAL CONTRIBUTION TO THE
C HELLMANN-FEYNMAN FORCE FROM THE NGX/2 RECIPROCAL LATTICE VECTOR WHICH
C IS MATHEMATICALLY EQUALLY THE -NGX/2 LATTICE VECTOR DUE TO THE
C PERIODICITY INTRODUCED BY THE FAST FOURIER TRANSFORM
C=========================================================================
      LPCTFX((NGX/2)+1) = 0
      LPCTFY((NGY/2)+1) = 0
      LPCTFZ((NGZ/2)+1) = 0
C=======================================================================
C      CHECK THE GRID SIZE
C 	TPI = (NOT SURPRISINGLY) 2*PI
C 	HSQDTM = (PLANCK'S CONSTANT/(2*PI))**2/(2*ELECTRON MASS)
C              = 3.810033 EV/ANGSTROM**2
C       ENERGY=HSQDTM*(GY**2)
C   Changed by Carsten Kruse and is valid for arbitrary cells
C
C======================================================================
      HSQDTM = 3.810033
      NGX1=2*SQRT(ENMAX/HSQDTM*(DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2))
     *     /TWOPI
      NGY1=2*SQRT(ENMAX/HSQDTM*(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2))
     *     /TWOPI
      NGZ1=2*SQRT(ENMAX/HSQDTM*(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2))
     *     /TWOPI
C     NGX1=2*SQRT(ENMAX/HSQDTM/(RECC(1,1)**2+RECC(1,2)**2+RECC(1,3)**2))
C     NGY1=2*SQRT(ENMAX/HSQDTM/(RECC(2,1)**2+RECC(2,2)**2+RECC(2,3)**2))
C     NGZ1=2*SQRT(ENMAX/HSQDTM/(RECC(3,1)**2+RECC(3,2)**2+RECC(3,3)**2))
      NGX1 = 2 * NGX1
      NGY1 = 2 * NGY1
      NGZ1 = 2 * NGZ1
C======================================================================
C  Skip recommended values of NG which has simple factors other
C  than 2,3, and 5. Fast Fourier Transform can't work in its present
C  form with bigger factors.
C======================================================================
      IF (NGX1.EQ.14 .OR. NGX1.EQ.22 .OR. NGX1.EQ.28 .OR. 
     &    NGX1.EQ.34 .OR. NGX1.EQ.38 .OR. NGX1.EQ.46 .OR.
     &    NGX1.EQ.52. OR. NGX1.EQ.58 .OR. NGX1.EQ.62) NGX1 = NGX1 + 2
      IF (NGX1.EQ.26. OR. NGX1.EQ.44 .OR. NGX1.EQ.56) NGX1 = NGX1 + 4
      IF (NGX1.EQ.42) NGX1 = NGX1 + 6
C
      IF (NGY1.EQ.14 .OR. NGY1.EQ.22 .OR. NGY1.EQ.28 .OR. 
     &    NGY1.EQ.34 .OR. NGY1.EQ.38 .OR. NGY1.EQ.46 .OR.
     &    NGY1.EQ.52. OR. NGY1.EQ.58 .OR. NGY1.EQ.62) NGY1 = NGY1 + 2
      IF (NGY1.EQ.26. OR. NGY1.EQ.44 .OR. NGY1.EQ.56) NGY1 = NGY1 + 4
      IF (NGY1.EQ.42) NGY1 = NGY1 + 6
C
      IF (NGZ1.EQ.14 .OR. NGZ1.EQ.22 .OR. NGZ1.EQ.28 .OR. 
     &    NGZ1.EQ.34 .OR. NGZ1.EQ.38 .OR. NGZ1.EQ.46 .OR.
     &    NGZ1.EQ.52. OR. NGZ1.EQ.58 .OR. NGZ1.EQ.62) NGZ1 = NGZ1 + 2
      IF (NGZ1.EQ.26. OR. NGZ1.EQ.44 .OR. NGZ1.EQ.56) NGZ1 = NGZ1 + 4
      IF (NGZ1.EQ.42) NGZ1 = NGZ1 + 6
C
      WRITE (*,3810) NGX1, NGY1, NGZ1
3810  FORMAT(/,' THE MINIMUM GRID SHOULD BE',I4,' x',I4,' x',I4)
      IF (NGX.GE.NGX1 .AND. NGY.GE.NGY1 .AND. NGZ.GE.NGZ1) THEN
        WRITE (*,*)' THE CURRENT GRID IS LARGE ENOUGH FOR THIS ENMAX.'
      ELSE
        WRITE (*,*)'**> THE CURRENT GRID IS TOO SMALL FOR THIS ENMAX<**'
        WRITE (*,*)'                          ^^^^^^^^^                '
      END IF
C=========================================================================
C  INITIALIZE THE DATA USED FOR THE FAST FOURIER TRANSFORMS
C=========================================================================
      NGPTAR(1) = NGX
      NGPTAR(2) = NGY
      NGPTAR(3) = NGZ
C=========================================================================
C
C ]]]]]]]]]]]]]]]]]]]]]] SUBROUTINE GENSP [[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
C
C SUBROUTINE GENSP PERFORMS A NUMBER OF TASKS. THE DATA ARRAYS COSC AND
C DECAY FOR THE ELECTRON DYNAMICS ARE INITIALISED. THE INDEXING SYSTEM
C FOR PADDING THE SPHERES OF PLANE WAVES AT EACH K POINT INTO THE BOX
C USED FOR THE FAST FOURIER TRANSFORMS IS ALSO COMPUTED AS ARE THE
C KINETIC ENERGIES OF THE PLANE WAVE BASIS STATES AT EACH K POINT
C=========================================================================
      CALL GENBTR(NRPLWV,NGX,NGY,NGZ,NKPTS,ENMAX,NINDPW,NPLWKP,VKPT,
     &LPCTX,LPCTY,LPCTZ,DATAKE,RECC,RECI,IPRINT,DNLG,DNLKG)
      WRITE (*,*) 'NPLWKP:', NPLWKP
C=========================================================================
C     IF THE CUT-OFF ENERGY OF THE PREVIOUS CALCULATION IS DIFFERENT
C     FROM THE CURRENT ONE, WE HAVE TO RE-ASSIGN THE WAVEFUNCTION 
C     ACCORDING TO THE NEW INDEXING SEQUENCE.
C     N.B. ASSUMING THE FFT GRID (I.E. NGX, NGY, NGZ) AND THE UNIT CELL
C           ARE KEPT THE SAME
C
C     ADDED BY X. WENG 22-JUL-90
C
C     NEWOLD=0 MEANS NO REASSIGNMENT NEEDED WHEN USING O WAVEFUNCTION
C           =1 MEANS    REASSIGNMENT  "      "     "    "     "
C
C=========================================================================
      NEWOLD = 0
      IF (ISTART.NE.0 .AND. IBANS.EQ.0) THEN
        WRITE (*,*)' '
        IF (          (ENMAX.EQ.ENMAXO)
     &      .AND.      (NGX.EQ.NGXO)
     &      .AND.      (NGY.EQ.NGYO)
     &      .AND.      (NGZ.EQ.NGZO)
     &      .AND.   (NRPLWV.EQ.NRPLWO) ) THEN
          NEWOLD = 0
        ELSE 
          NEWOLD = 1
        END IF
C
        IF (NEWOLD.EQ.0) THEN
          WRITE (*,5402)
        ELSE 
          WRITE (*,5404) ENMAX,ENMAXO,NGX,NGXO,NGY,NGYO,NGZ,NGZO,
     &                  NRPLWV,NRPLWO
          CALL REASSN(NKPTS,VKPT,
     &                NRPLWV,  NGX,     NGY,     NGZ,    ENMAX,
     &                NRPLWO,  NGXO,    NGYO,    NGZO,   ENMAXO,
     &                LPCTX,   LPCTY,   LPCTZ,   RECI,   RECO,
     &                IASSGN,CWORK6,CPTWFP,NBANDS,IPRINT)
        END IF       
      END IF
C
 5402 FORMAT(/,' NO REASSIGNMENT NEEDED WHEN USING OLD WAVEFUNCTION',/)
 5404 FORMAT(/,' REASSIGNMENT NEEDED WHEN USING OLD WAVEFUNCTION',   /,
     &         '   ENMAX =', F12.5,5X,'ENMAXO =',F12.5,              /,
     &         '   NGX   =', I6,  11X,'NGXO   =',I6,                 /,
     &         '   NGY   =', I6,  11X,'NGYO   =',I6,                 /,
     &         '   NGZ   =', I6,  11X,'NGZO   =',I6,                 /,
     &         '   NRPLWV=', I6,  11X,'NRPLWO =',I6,                 /,
     &         ' WE CALL "REASSN" TO RE-ASSIGN THE WAVE FUNCTIONS',  /)
C=========================================================================
C SET THE REAL (CHDENR) AND RECIPROCAL (CHDENG) SPACE CHARGE DENSITIES 
C TO ZERO PRIOR TO INITIALISING THE ELECTRONIC WAVEFUNCTIONS AND 
C CALCULATING THE INITIAL CHARGE DENSITIES
C=========================================================================
      IF ( ISTART.NE.1 .OR. NEWOLD.NE.0 ) THEN
        DO 5200 M = 1 , NPLWV  
          CHDENG(M) = (0.0,0.0)
          CHDENR(M) = (0.0,0.0)
 5200   CONTINUE
      END IF
      IF (NLPOT.EQ.1) THEN
C=======================================================================
C CALL SUBROUTINE TO SET UP DATA ARRAYS FOR REAL SPACE NON-LOCAL
C PSEUDOPOTENTIALS
C=======================================================================
        CALL SERLNL(NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,NSPEC,       
     &              DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSION,VRLNL,
     &       NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,NGX,NGY,NGZ)
      END IF                                                             
C=========================================================================
C START THE LOOP OVER K POINTS FOR WAVEFUNCTION INITIALISATION AND
C CHARGE DENSITY GENERATION
C=========================================================================
      DO 4100 NKP = 1 , NKPTS
        IF (ISTART.EQ.1 .AND. IBANS.EQ.1) GO TO 4113
        IF (ISTART.EQ.1 .AND. (NEWOLD.EQ.0) )  GO TO 4112
        IF (ISTART.EQ.1 .AND. (NEWOLD.EQ.1) )  THEN
          NPUNIT = 19 + NKP
          REWIND NPUNIT
          READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
          GO TO 4115
        END IF
C=========================================================================
C INITIALISE THE WAVEFUNCTIONS TO ZERO
C=========================================================================
 4113   CONTINUE
        DO 4110 M = 1 , NBANDS
          DO 4111 MM = 1 , NRPLWV
            CPTWFP(MM,M) = (0.0,0.0)
 4111     CONTINUE
 4110   CONTINUE
C=========================================================================
C
C """"""""""""""""""""""""" SUBROUTINE WFINIT """"""""""""""""""""""""""
C
C THIS SUBROUTINES INITIALISES THE WAVEFUNCTIONS FOR THE MOLECULAR
C DYNAMICS BY FILLING THE BANDS AT EACH K POINT WITH THE LOWEST ENERGY
C PLANE WAVE BASIS STATES. IF THE SYSTEM HAS HIGH SYMMETRY THIS METHOD
C MAY NOT BE APPROPRIATE BECAUSE THE LOWEST ENERGY PLANE WAVES MAY NOT
C SPAN THE LOWEST BANDS.
C (NOW WORKING IN RECIPROCAL SPACE)
C=========================================================================
        IF (INRAND.NE.1 .AND. IBANS.EQ.0) THEN
          CALL WFINTR(NRPLWV,NBANDS,NKPTS,DATAKE(1,1,NKP),NBANOC,CPTWFP,
     &         NPLWKP(NKP),WORK1,NWORK1,SCAL,CELEN(1,NKP),NGX, NGY, NGZ,
     &         LPCTX,LPCTY,LPCTZ,NINDPW(1,NKP), RECC )
        ELSE
          CALL WFINRN(NRPLWV,NBANDS,NKPTS,DATAKE(1,1,NKP),NBANOC,CPTWFP,
     &         NPLWKP(NKP),WORK1,NWORK1,CELEN(1,NKP),NGX, NGY, NGZ,
     &         LPCTX,LPCTY,LPCTZ,NINDPW(1,NKP), RECC,CWOR10,CWOR11)
        END IF
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE ORSP }}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE ORTHOGONALISES THE WAVEFUNCTIONS JUST INITIALISED
C (NOW WORKING IN RECIPROCAL SPACE)
C=========================================================================
C
C        CALL ORSP(NBANDS,NKPTS,NRPLWV,NPLWKP(NKP),CPTWFP,
C     &                                        CWORK1,CWORK2)
C=========================================================================
C SUBROUTINE CHSP CONSTRUCTS THE ELECTRONIC CHARGE DENSITY AND COMPUTES
C THE REAL SPACE WAVEFUNCTIONS WHICH ARE USED AGAIN IN THE ELECTRON
C DYNAMICS SUBROUTINE (CHGBO.FOR)
C 
C (Now: CHDENG(r) CONTAINS THE CONTRIBUTION TO THE real-SPACE CHARGE-
C                 DENSITY FROM THIS K-POINT, (only once here)
C       CHDENR(r) CONTAINS THE SUM OF CONTRIBUTIONS TO THE REAL-SPACE 
C                 CHARGE-DENSITY FROM K-POINTS TREATED UP TILL NOW)
C=========================================================================
4115    CONTINUE
        IF (IBANS.EQ.0)
     &  CALL CHSP(NBANOC,NPLWV,NRPLWV,MPLWV,WTKPT(NKP)
     &      ,CPTWFP,CHDENG,CHDENR,NGPTAR,NINDPW(1,NKP),NPLWKP(NKP),
     &       CWORK1,CWORK2,OCC(1,NKP) )
C=========================================================================
C     WRITE WAVEFUNCTION TO EXTERNAL MEMORY
C=========================================================================
        IF (NKPTS.GT.1) THEN
          NPUNIT = 19 + NKP
          REWIND NPUNIT
          WRITE (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
        END IF
        WRITE (*,*) ' NPLWKP=',NPLWKP(NKP)
 4112   CONTINUE
C=========================================================================
C     IF RE-START, READ IN EXISTING WAVEFUNCTIONS
C=========================================================================
        IF (ISTART.EQ.1 .AND. IBANS.EQ.0) THEN 
          NPUNIT = 19 + NKP
          REWIND NPUNIT
          READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
        END IF
        IF (IVPTYP.EQ.0) GOTO  4100
        IF (NLPOT.EQ.0) THEN
C=========================================================================
C  FOR RECIPROCAL SPACE NONLOCAL POTENTIAL
C
C  INITIALISE ENVNL: NON-LOCAL CONTRIBUTION TO TOTAL ENERGY (XW 30-APR-90)
C  1) PHASGR SETS UP  CPHSGR(NRPLWV,NIONS,NSPEC) = EXP(iq.Rn)
C  2) SETVG  SETS UP  VGNL(NRPLWV,0:2,NSPEC) = Vnl(l,q)
C=========================================================================
          IF (ICLOCK.EQ.1) CALL PCLOCK(1)
          CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &              DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
          CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &            DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,DVGNL,
     &            NPSPTN,IVPTYN)
          DO 4121 NB = 1 , NBANDS
            CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP(NKP),
     &         DNLKG(1,0,NKP),VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,
     &         CWRK22,CWRK23,CPHSGR,VGNL,CELFRC,CWOR10,CWOR11,NB,
     &         IVPTYN)
            CVNL = (0.0,0.0)
            DO 4122 M = 1 , NPLWKP(NKP)
             CVNL = CVNL + CONJG ( CPTWFP(M,NB) ) * CELFRC(M)
 4122       CONTINUE
            VNL(NB,NKP) = REAL (CVNL)
 4121     CONTINUE          
          IF (ICLOCK.EQ.1) CALL PCLOCK(2)
        ELSE
C===================================================================
C CALL SUBROUTINE TO SET UP PHASE FACTOR ARRAY FOR THIS K POINT     
C===================================================================
          CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,       
     &          NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)
C                                                                   
          DO 4120 NB=1,NBANDS                                           
C===================================================================
C PREPARE ARRAYS FOR THE FOURIER TRANSFORM                          
C===================================================================
            DO 5345 M = 1 , MPLWV  
              CWORK1(M) = (0.0,0.0)
              CWORK2(M) = (0.0,0.0)
 5345       CONTINUE               
            NINDW = NRPLWV*(NB-1)                                           
            DO 222 M=1,NPLWKP(NKP)                                        
              CWORK1(NINDPW(M,NKP))=CPTWFP(M,NB)                        
 222        CONTINUE                                                      
C===================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE                          
C=====================================================================
            CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)                              
            CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NB,NKP,MPLWV,NRPLWV,           
     &         NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK2,CWORK1,      
     &         CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,
     &         MXRLSH,CESAVE)              
 4120     CONTINUE                                                       
C                                                                    
        END IF
        IF (IPRINT.GE.2) WRITE (*,4125) (VNL(NB,NKP),NB=1,NBANDS)
C
 4100 CONTINUE
 4125 FORMAT(' Vnl =',6F12.5)
C=========================================================================
C
C                  END OF K-POINT-LOOP
C
C NOW:  CHDENR(r)IS THE REAL SPACE CHARGE DENSITY SUMMED OVER ALL K-POINTS.
C
C=========================================================================
C      IF (IPRINT.LT.5) GOTO 4304 
      WRITE (*,4300) 
      WRITE (90,4302) CHDENR
 4304 CONTINUE
 4300 FORMAT(/,1X,20(1H-),' CHDENR (REAL SPACE CHARGE DENSITY)',20(1H-))
 4302 FORMAT(10F8.3)
C=========================================================================
C TRANSFORM THE CHARGE DENSITY TO RECIPROCAL SPACE
C=========================================================================
      DO 5348 M = 1 , MPLWV
        CWORK1(M) = (0.0,0.0)
        CWORK2(M) = (0.0,0.0)
 5348 CONTINUE
      RINPLW = 1.0 / NPLWV
      DO 5350 M = 1 , NPLWV
        CWORK1(M) = CHDENR(M) * RINPLW
 5350 CONTINUE
      CALL FFT3D(CWORK1,CWORK2,NGPTAR,-1)
      DO 5360 M = 1 , NPLWV
        CHDENG(M) = CWORK1(M)
 5360 CONTINUE
      IF (ISYMM.EQ.1) THEN
C======================================================================
C     >>>>>>>>>>>>>>>>>>> SYMMETRIZE CHARGE DENSITY  <<<<<<<<<<<<<<<<<<
C======================================================================
        CALL ROSYM4(A1,A2,A3,B1,B2,B3,ISY,NC,IB,V,R,RB,NPLWV,
     +              NGX,NGY,NGZ,CHDENG,CWORK1,LPCTX,LPCTY,
     +              LPCTZ,LPCTXI,LPCTYI,LPCTZI,IPRINT)
C======================================================================
C    TRANSFORM THE CHARGE DENSITY TO REAL SPACE                        
C======================================================================
        DO 5949 M=1,MPLWV                                     
          CWORK1(M)=(0.0,0.0)                                   
          CWORK2(M)=(0.0,0.0)                                   
 5949   CONTINUE                                              
        DO 5951 M=1,NPLWV                                     
          CWORK1(M)=CHDENG(M)                                   
 5951   CONTINUE                                              
        CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)                    
        DO 5961 M=1,NPLWV                                     
          CHDENR(M)=CWORK1(M)                                   
 5961   CONTINUE
      END IF
C
      IF (IPRINT.GE.2)
     &  WRITE (*,*)' CHDENG(G=0)=', CHDENG(1),'   NELECT =',NELECT
C=========================================================================
C
C (AGAIN:  CHDENR(r)IS CHARGE-DENSITY IN REAL-SPACE
C          CHDENG(G) IS      -//-      IN RECIPROCAL SPACE
C
C  - READY FOR CALCULATION OF THE KOHN-SHAM-POTENTIAL
C
C=========================================================================
C     SETUP LOOK-UP TABLES FOR EX-CORR ENERGY AND FORCE
C=========================================================================
      CALL XCDAT(EXCDAT, XCFDAT, XCPDAT)
C
      IF (IION.NE.0) THEN
C=========================================================================
C     SETUP CONSTRAINTS WHICH ARE SUPPOSED TO BE LINEAR WITH
C     RESPECT TO COORDINATES. THEN INSTEAD OF THE PHYSICAL COORDINATES
C     Ri,i=1,3*N, WE INTRODUCE A SET OF AUXILIARY COORDINATES, 
C     Pi,i=1,M, M < 3*N. SUBROUTINE CONSTR SETS UP THE MATRIX OF
C     DERIVATIVES RCONSTR(i,j)=dRi/dPj.     
C
C     NCNSTR - NUMBER OF CONSTRAINTS 
C     NEWCOO = M = 3 * N - NCNSTR
C=========================================================================
        IF (ICNSTR.NE.0) THEN
          CALL CONSTR(NSPEC,NIONS,NIONST,RCNSTR,DIRC,POSIC,
     &                RMOVE,NCNSTR,NEWCOO,WORK7)
          IF (NCNSTR.EQ.0) ICNSTR = 0
        ELSE
          NEWCOO = 3 * NIONST
          NCNSTR = 0
        END IF
      END IF
C=========================================================================
C
C ++++++++++++ DO 1000 N=1,REQUIRED NUMBER OF TIMESTEPS ++++++++++++++++
C
C THIS IS THE MAIN LOOP OF THE PROGRAM DURING WHICH ONE COMPLETE STEP OF
C THE ELECTRON DYNAMICS IS PERFORMED. AT THE END OF THE REQUIRED NUMBER
C OF STEPS THE ELECTRONIC WAVEFUNCTIONS, POSITIONS OF THE IONS ETC ARE
C WRITTEN TO AN EXTERNAL FILE
C=========================================================================
C
C AFTER NDELAY ITERATIONS THERE IS AN OPTION OF PERFORMING ELECTRONIC
C MINIMISATION MORE OFTEN THAN IONIC (IMDTR) OR UNIT CELL (BMDTR) 
C RELAXATION. THIS CAN BE DONE BY SETTING PARAMETER NITFIX>1 WHICH
C WILL MEAN THAT YOU PERFORM NITFIX ELECTRONIC ITERATIONS AT FIXED
C GEOMETRY. IF NITFIX IS NOT SPECIFIED, IT WILL BE SET EQUAL TO 1,
C AS IN PREVIOUS VERSION OF CGMAIN.
C=========================================================================
C
      NITFXX = NITFIX
      IF (NITFXX.EQ.0 .OR. IBANS.NE.0) NITFXX = 1
      N = 0
 1000 CONTINUE
      N = N + 1
C==================================================================
C  THIS SERVES TO CONTROL THE RUN FROM OUTSIDE                     
C==================================================================
      OPEN(UNIT=1,FILE='runinf',STATUS='OLD',ERR=1101)             
      READ(1,*,ERR=1101) NITER                                     
      READ(1,*,ERR=1101) IION                                      
      READ(1,*,ERR=1101) POTIM                                     
      READ(1,*,ERR=1101) NDELAY                                    
1101  CONTINUE                                                     
      CLOSE(1)                                                     
C
        WRITE (*,90) N
        NITFI = 0
C
        IF (IBANS.NE.0 .AND. N.GT.1) GO TO 4219
C
        IF (ICLOCK.EQ.1) CALL PCLOCK(1000)
        IF (IPRINT.EQ.5) WRITE (*,91) CHDENG
  90  FORMAT(//,1X,20(1H>),' ITERATION =',I5,1X,20(1H<),/)
  91  FORMAT(1X,9F8.4)
C========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FEWALD }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE EWALD ENERGY DUE TO COULOMB ENERGY
C BETWEEN THE IONS AND THE NEUTRALISING BACKGROUND. THE COULOMB FORCES
C ON THE IONS DUE TO COULOMB INTERACTION WITH THE OTHER IONS AND THE
C FORCE ON THE UNIT CELL THAT IS RELATED TO THE CHANGE IN THE EWALD
C ENERGY ON CHANGING THE SIZE OF THE CELL ARE ALSO CALCULATED.
C========================================================================
        NINDX = 1
        DO 3190 NSP = 1 , NSPEC
          DO 3191 NI = 1 , NIONSP(NSP)
            DO 3192 M = 1 , 3
              POSIC(M,NINDX) = POSION(M,NI,NSP)
 3192       CONTINUE
          NINDX = NINDX + 1
 3191     CONTINUE
 3190   CONTINUE
        IF ( N.EQ.1 .OR. 
     &     ( N.GT.NDELAY .AND. IBOX.EQ.1 .AND. IION.EQ.0 ) )
     &    CALL EWALTR(POSIC,EWIFC,EWRLEN,EWRCSS,EWRLSS,EWRCSI,DIRC,RECC,
     &         VOLC,SIGEW,TEWEN,NIONST,ICHARC,NIONCH,NICHSQ,CPHFX,CPHFY,
     &         CPHFZ,IPRINT,NIONST,NEWPTS,MAXCX,MAXCY,MAXCZ,MAXGPX,
     &         MAXGPY,MAXGPZ,NGPTS,RFORCE,CFORCE,FORCEG,FORSIG,ENERG)
        NINDX = 1
        DO 3193 NSP = 1 , NSPEC
          DO 3194 NI = 1 , NIONSP(NSP)
            DO 3195 M = 1 , 3
              EWIFOR(M,NI,NSP) = EWIFC(M,NINDX)
 3195       CONTINUE
            NINDX = NINDX + 1
            IF (IPRINT.GE.2) WRITE (*,49) (EWIFOR(M,NI,NSP),M=1,3)
 3194     CONTINUE
 3193   CONTINUE
   49 FORMAT('  EWALD FORCE ON ION :',3F15.6)
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FDIR16 }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE HARTREE POTENTIAL FROM THE ELECTRONIC
C CHARGE DENSITY CALCULATED IN SUBROUTINE CHSP. THE CORRECTION TO THE
C TOTAL ENERGY DUE TO OVERCOUNTING THE HARTREE ENERGY ON SUMMING THE
C ELECTRONIC EIGENVALUES IS ALSO COMPUTED (HARTREE CONTRIBUTION TO THE
C TOTAL ENERGY = 0.5*SUM (VH(G)*RHO(-G)) WHEREAS SUM OF EIGENVALUES
C GIVES SUM (VH(G)*RHO(-G)) WHERE VH(G) IS THE HARTREE POTENTIAL AT
C WAVEVECTOR G AND RHO(G) IS THE CHARGE DENSITY AT WAVEVECTOR G
C=========================================================================
 4801   CONTINUE
        NITFI = NITFI + 1
        CALL FDIRTR(NGX,NGY,NGZ,NPLWV,RECC,VOLC,CVD,CHDENG,
     &              SIGHA,DENC,LPCTX,LPCTY,LPCTZ,DIRDAT)
C=========================================================================
C ( CVD(G) IS NOW THE HARTREE-POTENTIAL IN RECIPROCAL SPACE)
C ( DIRDAT(G) IS THE 1/G**2 FACTORS FOR RECALC. OF CVD(G) FOR
C             THE SAME UNITCELL)
C=========================================================================
        IF (IPRINT.GE.2) WRITE (*,*)'HARTREE POT. IN RECIPROCAL SPACE'
        IF (IPRINT.GE.5) WRITE (*,47) CVD
  47  FORMAT(1X,10F8.4)
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FEXCTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE EXCHANGE CORRELATION POTENTIAL FROM THE
C REAL SPACE CHARGE DENSITY. THE CORRECTION TO THE TOTAL ENERGY DUE TO 
C OVERCOUNTING THE EXCHANGE CORRELATION ENERGY ON SUMMING THE ELECTRONIC
C EIGENVALUES IS ALSO COMPUTED.
C
C  FEXCTR: AT INPUT CV(r) IS THE REAL-SPACE CHARGE DENSITY 
C          AT OUPUT CV(r) IS THE REAL-SPACE XC-POTENTIAL
C
C=========================================================================
        DO 9111 M = 1 , NPLWV
          CV(M) = CHDENR(M)
 9111   CONTINUE
        CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,
     &              XCFDAT,XCPDAT)
        IF (IPRINT.GE.2) WRITE (*,*)' EX-CORR POTENTIAL IN REAL SPACE'
        IF (IPRINT.GE.5) WRITE (*,47) CV
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FSTFTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE STRUCTURE FACTOR ON THE GRID OF
C RECIPROCAL LATTICE VECTORS
C=========================================================================
        DO 3110 NSP = 1 , NSPEC
          CALL FSTFTR(NGX,NGY,NGZ,NIONSP(NSP),NPLWV,POSION(1,1,NSP),
     &                CSTRF(1,NSP),LPCTX,LPCTY,LPCTZ)
 3110   CONTINUE
        IF (IPRINT.GE.2) WRITE (*,*) ' STRUCTURE FACTOR'
        IF (IPRINT.GE.5) WRITE (*,47) CSTRF  
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FVPTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE SETS UP THE PSEUDOPOTENTIAL ON THE GRID OF RECIPROCAL
C LATTICE VECTORS. THIS SUBROUTINE MUST BE CALLED WHENEVER RECC(i,j),
C I.E. THE UNIT CELL, HAS BEEN CHANGED
C
C     calc.   V  (G)
C              alpha
C
C (NOW WORKING IN RECIPROCAL SPACE)
C
C=========================================================================
        IF (N.EQ.1 .OR. (N.GE.NDELAY.AND.IBOX.EQ.1)) THEN
          PSCENC = 0.0
          DO 3120 NSP = 1 , NSPEC
            CALL FVPTR(NGX,NGY,NGZ,NPSPTN(NSP),RECC,VOLC,PSP(1,NSP),
     &                 PSGMAX(NSP),VPS(1,NSP),DVPS(1,NSP),LPCTX,LPCTY,
     &                 LPCTZ,ICHARG(NSP),IVPTYN(NSP))
 3120     CONTINUE
        END IF
C=========================================================================
C
C CALCULATE THE CONTRIBUTION TO THE TOTAL ENERGY FROM THE NON-COULOMB
C PART OF THE G=0 COMPONENT OF THE PSEUDOPOTENTIALS AND THE FORCE ON THE
C UNIT CELL DUE TO THE CHANGE IN THIS ENERGY AS THE SIZE OF THE CELL
C CHANGES
C
C               N
C                elec   --
C     E       = -----   >   N      * v
C      core      vol    --   alpha    alpha,core
C                      alpha
C
C=========================================================================
        PSCENC = 0.0
        DO 3125 NSP = 1 , NSPEC
          PSCENC = PSCENC + PSCORE(NSP) * NIONSP(NSP)
 3125   CONTINUE
        PSCENC = PSCENC * NELECT / VOLC
        IF (IPRINT.GE.2) WRITE (*,*)' PSCENC=',PSCENC
C=========================================================================
C    STRESSES ON THE UNIT CELL DUE TO THE ALPHA*Z TERM
C
C                                --  
C     Sigma      = - delta       >    N      * v
C          ij             ij     --    alpha    alpha,core
C                               alpha
C
C     alpha loops over all species.  i,j = x,y,z
C=========================================================================
        SIGAL(1) = - PSCENC / VOLC
        SIGAL(2) = - PSCENC / VOLC
        SIGAL(3) = - PSCENC / VOLC
        SIGAL(4) = 0.0
        SIGAL(5) = 0.0
        SIGAL(6) = 0.0
C=========================================================================
C CALCULATE THE TOTAL POTENTIAL WHICH IS THE SUM OF THE HARTREE
C POTENTIAL, THE EXCHANGE-CORRELATION POTENTIAL AND THE STRUCTURE
C FACTOR*THE PSEUDOPOTENTIAL
C
C STEP 1.  CALCULATE THE TOTAL IONIC POTENTIAL IN RECIPROCAL SPACE
C
C                --
C     V   (G) =  >   S  (G) * v  (G)
C      ion       --   alpha    alpha
C               alpha
C
C (WORKING IN RECIPROCAL SPACE)
C
C=========================================================================
        DO 3126 NP = 1 , MPLWV
          CWORK1(NP) = (0.0,0.0)
          CWORK2(NP) = (0.0,0.0)
 3126   CONTINUE
        DO 3127 NSP = 1 , NSPEC
          DO 3128 NP = 1 , NPLWV
            CWORK1(NP) = CWORK1(NP) + VPS(NP,NSP) * CSTRF(NP,NSP)
 3128     CONTINUE
 3127   CONTINUE
C=========================================================================
C STEP 2. ADD THE HARTREE POTENTIAL AND TRANSFORM TO REAL SPACE
C=========================================================================
        DO 3129 NP = 1 , NPLWV
          CVD(NP) = CWORK1(NP) + CVD(NP)
 3129   CONTINUE
C=========================================================================
C CVD(g) = CONTAINS THE RECIPROCAL SPACE IONIC AND HARTREE POT)
C CVION(g) = CWORK1 (g) = SUM [VPS*CSTRF]
C
C=========================================================================
C BOTH OF THEM ARE TRANSFORMED IN TO REAL SPACE
C=========================================================================
        CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)
        DO 3124 NP = 1 , NPLWV
          CVION(NP) = CWORK1(NP)
 3124   CONTINUE
        DO 5135 M = 1 , NPLWV
          CWORK1(M) = CVD(M)
 5135   CONTINUE
        CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)
C=========================================================================
C STEP 4. ADD THE EXCHANGE-CORRELATION POTENTIAL IN REAL SPACE
C         (REMEMBER CV(r) IS XC-POTENTIAL)
C=========================================================================
        DO 5136 NP = 1 , NPLWV
          CV(NP) = CWORK1(NP) + CV(NP)
 5136   CONTINUE
C=========================================================================
C
C    CV(r) IS (HARTREE + XC + ION) POTENTIAL FOR THE Kohn-Sham-EQUATION 
C CVION(r) IS THE IONIC POTENTIAL ALONE
C
C=========================================================================
C INIT THE KINETIC-ENERGY CONTRIBUTION TO THE STRESS ON THE UNIT CELL
C=========================================================================
        DO 4210 M = 1 , 6
          SIGKE(M) = 0.0
 4210   CONTINUE
C
        IF((N.GT.NDELAY).AND.(IBOX.EQ.1 .OR. IION.EQ.1)                     
     &                  .AND.(IVPTYP.EQ.1 .AND. NLPOT.EQ.1)) THEN
C=======================================================================
C CALL SUBROUTINE TO SET UP DATA ARRAYS FOR REAL SPACE NON-LOCAL
C PSEUDOPOTENTIALS
C=======================================================================
          CALL SERLNL(NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,NSPEC,       
     &                DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSION,VRLNL,
     &                NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,
     &                NGX,NGY,NGZ)
        ENDIF                                                             
C=========================================================================
C K-POINT LOOP STARTS
C=========================================================================
 4219   CONTINUE
        DO 4220 NKP = 1 , NKPTS
C=========================================================================
C     READ WAVEFUNCTION FROM EXTERNAL MEMORY
C=========================================================================
          NPUNIT = 19 + NKP
          NUNIT  = 39 + NKP
          IF (NKPTS.GT.1) THEN
            REWIND NPUNIT
            READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
          END IF
C=========================================================================
C  CPHSGR AND VGNL ARE STORED, SO WE HAVE TO RE-CALCULATE THEM EVERY TIME.
C=========================================================================
          IF (IVPTYP.EQ.0) GO TO 4222
          IF (NLPOT.EQ.0) THEN
            IF (NKPTS.GT.1 .OR. N.GE.NDELAY) 
     &      CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                  DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
            IF (NKPTS.EQ.1 .AND. IBOX.EQ.0) GO TO 4222
            CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &           DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,DVGNL,
     &           NPSPTN,IVPTYN)
          ELSE
c===================================================================
C CALL SUBROUTINE TO SET UP PHASE FACTOR ARRAY FOR THIS K POINT     
C===================================================================
            IF (NKPTS.GT.1 .OR. N.GE.NDELAY)
     &       CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,       
     &          NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)
          END IF
 4222     CONTINUE
C
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE CONGRA }}}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE PERFORMS THE ENERGY MINIMISATION OF THE ELECTRONIC 
C SYSTEM USING THE CONJUGATE GRADIENT METHOD.
C THE SUBROUTINE ALSO CALCULATES THE ELECTRONIC EIGENVALUES AND
C THE STRESS ON THE UNIT CELL RESULTING FROM THE CHANGE IN THE KINETIC
C ENERGY OF THE PLANE WAVE BASIS STATES AS THE SIZE OF THE CELL CHANGES
C
C=========================================================================
         IF (IBANS.EQ.0) THEN
           IF (N.GT.4) THEN   
             SUMW = WTKPT(NKP)
           ELSE               
             SUMW = SUMWEI    
           END IF             
           CALL CONGRA(NGX,NGY,NGZ,NBANOC,NKPTS,NPLWV,MPLWV,
     &       NRPLWV,ENMAX,NINDPW(1,NKP),NPLWKP(NKP),WTKPT,
     &       CV,CPTWFP,CPTWFL,DIRC,RECC,VOLC,CELEN,NGPTAR,
     &       SUMW,DATAKE(1,1,NKP),CWORK1,
     &       CWORK2,CWORK,NBANOC, CWORK6,
     &       CWORK7,CWORK8,CWORK9,CWOR10, WORK12,CVION,CVD,CHDENR,
     &       DENC,XCENC,TEWEN,PSCENC,NKP,CHDENG,
     &       XCFDAT,XCPDAT,DIRDAT,CWOR11,
     &       HR, HI, AUX, FV1, FV2, FV3, CH0, NITMAX,TOTEN1,
     &       NSPEC, NIONS,NIONSP,PSCALE,
     &       DNLKG, CPHSGR,VGNL, CELFRC, CWRK20,
     &       CWRK21, CWRK22, CWRK23,VNL, IVPTYP, IPRINT,ISBROT,
     &       IOCCUP,OCC,EIGVAL, ISYMM,NLPOT,
     &       SIGKE, SIGXC,EXCDAT,ICLOCK,IVPTYN,NRGRPT,NRLPPI,
     &       CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,
     &       NADGRD,MXRLSH,CESAVE)
         ELSE
           CALL CONGRABS(NBANOC,NKPTS,NPLWV,MPLWV,
     &       NRPLWV,NINDPW(1,NKP),NPLWKP(NKP),WTKPT,
     &       CV,CPTWFP,CPTWFL,DIRC,RECC,VOLC,CELEN,NGPTAR,
     &       DATAKE(1,1,NKP),CWORK1,CWORK2, CWORK, CWORK6,CWORK7,
     &       CWORK8,CWORK9,CWOR10, WORK12,CVD,NKP,CWOR11,
     &       HR, HI, AUX, FV1, FV2, FV3, CH0, NITMAX,
     &       NSPEC, NIONS, NIONSP,PSCALE,
     &       DNLKG, CPHSGR,VGNL, CELFRC, CWRK20,
     &       CWRK21, CWRK22, CWRK23,VNL, IVPTYP, IPRINT,ISBROT,
     &       OCC,EIGVAL,NLPOT,
     &       ICLOCK,IVPTYN,NITER,N,NGX,NGY,NGZ,NRGRPT,NRLPPI, 
     &       CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,  
     &       NADGRD,MXRLSH,CESAVE)
         END IF
C=========================================================================
C     WRITE WAVEFUNCTION TO EXTERNAL MEMORY
C=========================================================================
          IF (NKPTS.GT.1) THEN
            REWIND NPUNIT
            WRITE (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
          END IF
C======================================================================
C     WAVEWR PICKS OUT THE NL(=6) MOST SIGNIFICANT PLANE WAVE
C     COMPONENTS OF EACH BAND. 
C======================================================================
C      IF (N.EQ.NITER.OR.N.EQ.NDELAY)
C     & CALL WAVEWR(NBANDS, NRPLWV, NPLWKP, NGX, NGY, NGZ,
C     & SIZEX,SIZEY,SIZEZ,CPTWFP,LPCTX,LPCTY,LPCTZ,NINDPW(1,NKP),NKP)
C
 4220   CONTINUE
C======================================================================
C     >>>>>>>>>>>>>>>>>>> K-POINT LOOP ENDS HERE <<<<<<<<<<<<<<<<<<
C======================================================================
        IF (IBANS.EQ.1) GO TO 4218
C
C======================================================================
C     UPDATE OCCUPATION NUMBER OCC ACCORDING TO THE EIGEN-ENERGY OF 
C     EACH BAND. (EF IS THE FERMI ENERGY DETERMINED)
C======================================================================
        IF (IOCCUP.EQ.0) THEN
          IF ((NELECT/2)*2.EQ.NELECT) THEN 
            GO TO 4800
          ELSE
            GO TO 4802
          END IF
        END IF
C
        IDEL = N / NDEL
        DEL = AMAX1 ( DELMAX / (2**IDEL) , DELMIN ) 
        WRITE (*,*) ' '
        WRITE (*,*) 'THE GAUSSIAN BROADENING ENERGY DEL (eV) = ', DEL
C======================================================================
C     TAKE OUT THE SPIN-DEGENERACY, FOR IT IS CONSIDERED EXPLICITLY
C     IN THIS PROGRAM. BUT NOT IN EFERMI.
C======================================================================
C
C      IN THE MAIN PROGRAM AND ALL OTHER HAMMER'S SUBROUTINE,
C      OCC INCLUDES SPIN-DEGENERACY (2.0), EXCEPT IN C2.F
C
        IF (NBANDS*2.GT.NELECT) THEN 
          CALL EFERMI(NELECT,NBANDS,DEL,NKPTS,NBANDS,NKPTS,WTKPT,
     &                OCC,EF,EIGVAL,SORT) 
          DO 4500 JKP = 1 , NKPTS
            DO 4500 JB = 1 , NBANDS
              OCC(JB,JKP) = OCC(JB,JKP) / 2.0
 4500     CONTINUE
        END IF
C======================================================================
C     CALCULATE THE NEW CHARGE DENSITY ACCORDING TO THE NEW SET OF
C     OCCUPATION NUMBER 
C     (NO NEED TO UPDATE CELEN AND VNL, BECAUSE THEY ARE NOT RELATED TO 
C      CHARGE DENSITY, THEY ARE RELATED TO WAVE FUNCTIONS ONLY.)
C======================================================================
 4802   CONTINUE
        DO 4600 M = 1 , NPLWV
          CHDENR(M) = (0.0,0.0)
          CHDENG(M) = (0.0,0.0)
 4600   CONTINUE
        DO 4602 NKP = 1 , NKPTS
          IF (NKPTS.GT.1) THEN 
            NPUNIT = 19 + NKP
            REWIND NPUNIT
            READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
          END IF
          CALL CHSP(NBANOC,NPLWV,NRPLWV,MPLWV,
     &              WTKPT(NKP),CPTWFP,CHDENG,CHDENR,NGPTAR,
     &              NINDPW(1,NKP),NPLWKP(NKP),CWORK1,CWORK2,
     &              OCC(1,NKP) )
 4602   CONTINUE
C=======================================================================
C FFT (CHDENR) TO GET THE RECIPROCAL SPACE CHARGE DENSITY: CHDENG(g)
C=======================================================================
        DO 4700 M = 1 , MPLWV
          CWORK1(M) = (0.0,0.0)
 4700   CONTINUE
        RINPLW = 1.0 / NPLWV
        DO 4702 M = 1 , NPLWV
          CWORK1(M) = CHDENR(M) * RINPLW
 4702   CONTINUE
        CALL FFT3D(CWORK1,CWORK2,NGPTAR,-1)
        DO 4704 M = 1 , NPLWV
          CHDENG(M) = CWORK1(M)
 4704   CONTINUE 
C=========================================================================
C NOW: CHDENR(r) CONTAINS THE NEW CHARGE DENSITY IN   R E A L  SPACE
C      CHDENG(g) CONTAINS THE NEW CHARGE DENSITY IN RECIPROCAL SPACE
C    -----  Change over for IOCCUP=1
C=========================================================================
C
 4800   CONTINUE
C
C======================================================================
C     >>>>>>>>>>>>>>>>>>> SYMMETRIZE CHARGE DENSITY  <<<<<<<<<<<<<<<<<<
C======================================================================
C
        IF (ISYMM.EQ.1 .AND. N.GE.1) THEN
          IF (IOCCUP.EQ.0) THEN
C=======================================================================
C FFT (CHDENR) TO GET THE RECIPROCAL SPACE CHARGE DENSITY: CHDENG(g)    
C SKIPPED FOR PARTIAL OCCUPANCIES - DONE ALREADY
C=======================================================================
        DO 4670 M = 1 , NPLWV
          CHDENR(M) = (0.0,0.0)
          CHDENG(M) = (0.0,0.0)
 4670   CONTINUE
        DO 4672 NKP = 1 , NKPTS
          IF (NKPTS.GT.1) THEN 
            NPUNIT = 19 + NKP
            REWIND NPUNIT
            READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
          END IF
          CALL CHSP(NBANOC,NPLWV,NRPLWV,MPLWV,
     &              WTKPT(NKP),CPTWFP,CHDENG,CHDENR,NGPTAR,
     &              NINDPW(1,NKP),NPLWKP(NKP),CWORK1,CWORK2,
     &              OCC(1,NKP) )
 4672   CONTINUE
c
            DO 4901 M=1,MPLWV                                      
              CWORK1(M)=(0.0,0.0)                                    
 4901       CONTINUE                                               
            RINPLW=1.0/NPLWV                                       
            DO 4902 M=1,NPLWV                                      
              CWORK1(M)=CHDENR(M)*RINPLW                             
 4902       CONTINUE                                               
            CALL FFT3D(CWORK1,CWORK2,NGPTAR,-1)                    
            DO 4904 M=1,NPLWV                                      
              CHDENG(M)=CWORK1(M)
 4904       CONTINUE          
          END IF
C
          CALL ROSYM4(A1,A2,A3,B1,B2,B3,ISY,NC,IB,V,R,RB,NPLWV,
     +                NGX,NGY,NGZ,CHDENG,CWORK1,LPCTX,LPCTY,
     +                LPCTZ,LPCTXI,LPCTYI,LPCTZI,IPRINT)
C======================================================================
C    TRANSFORM THE CHARGE DENSITY TO REAL SPACE                        
C======================================================================
          DO 5948 M=1,MPLWV                                     
            CWORK1(M)=(0.0,0.0)                                   
            CWORK2(M)=(0.0,0.0)                                   
 5948     CONTINUE                                              
          DO 5950 M=1,NPLWV                                     
            CWORK1(M)=CHDENG(M)                                   
 5950     CONTINUE                                              
          CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)                    
          DO 5960 M=1,NPLWV                                     
            CHDENR(M)=CWORK1(M)                                   
 5960     CONTINUE
        END IF
C
        IF (IPRINT.GE.2) WRITE (*,*)' CHDENG(G=0) =', CHDENG(1)
        IF (NITFI.LT.NITFXX .AND. N.GT.NDELAY) GO TO 4801
C=========================================================================
C RE-CALCULATE THE TOTAL ENERGY WHEN REQUIRED. 
C=========================================================================
C       IF (ISBROT.EQ.0) GOTO 4900
C      IF (ISBROT.EQ.1 .AND. NBANDS*2.EQ.NELECT) GOTO 4900
C======================================================================
C 1. CALC. HARTREE POTENTIAL AND ENERGY CORRECTION IN RECIPROCAL SPACE
C======================================================================
        DENC = 0.0
        DO 4810 M = 1 , NPLWV
          CVD(M) = CHDENG(M) * DIRDAT(M)
          DENC = DENC + REAL ( CVD(M) * CONJG ( CHDENG(M) ) )
 4810   CONTINUE
        DENC = - DENC / 2.0
C======================================================================
C TRANSFORM HARTREE POTENTIAL INTO REAL SPACE
C======================================================================
        DO 4820 M = 1 , MPLWV
          CWORK1(M) = (0.0,0.0)
 4820   CONTINUE
        DO 4822 M = 1 , NPLWV
          CWORK1(M) = CVD(M)
 4822   CONTINUE
        CALL FFT3D(CWORK1,CWORK,NGPTAR,1)
        DO 4824 M = 1 , NPLWV
          CVD(M) = CWORK1(M)
 4824   CONTINUE
C======================================================================
C 2. CALCULATE EXCHANGE CORRELATION ENERGY CORRECTION USING CHDENR(r)
C======================================================================
        DO 4830 M = 1 , NPLWV
          CV(M) = CHDENR(M)
 4830   CONTINUE
        CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,XCFDAT,
     &              XCPDAT)
        DO 4835 M = 1 , NPLWV
          CV(M) = CV(M) + CVION(M)
          CV(M) = CV(M) + CVD(M)
 4835   CONTINUE
C======================================================================
C CALCULATE THE TOTAL ENERGY (IN REAL SPACE)
C======================================================================
        ENPOT = 0.0
        DO 4840 M = 1 , NPLWV
          ENPOT = ENPOT + REAL ( CHDENR(M) * CV(M) )
 4840   CONTINUE
        ENPOT = ENPOT / NPLWV
C======================================================================
C THE NON-LOCAL PSEUDOPOTENTIAL ENERGY FOR EACH BAND HAS BEEN UPDATED 
C AT THE END OF SUBROUTINE CONGRA
C======================================================================
        ENKE = 0.0
        ENVNL = 0.0
        DO 4850 NK = 1 , NKPTS
          DO 4850 NB = 1 , NBANDS
            ENKE = ENKE + 2.0 * WTKPT(NK) * 
     &             REAL ( CELEN(NB,NK) ) * OCC(NB,NK)
            IF (IVPTYP.EQ.1) 
     &         ENVNL = ENVNL + 2.0 * WTKPT(NK) * VNL(NB,NK) * OCC(NB,NK)
 4850   CONTINUE
 4900   CONTINUE
C=========================================================================
C WRITE OUT THE ENERGY EIGENVALUES OF THE ELECTRONIC STATES
C=========================================================================
        IF (ISBROT.EQ.0) GO TO 304 
        IF (IPRINT.LT.1 .AND. N.NE.NITER) GO TO 304
 4218   CONTINUE
        DO 302 NK = 1 , NKPTS
          WRITE (*,4217) NK,(VKPT(K,NK),K=1,3),WTKPT(NK)
          DO 301 NB = 1 , NBANDS
            WRITE (*,300) NB,EIGVAL(NB,NK),REAL(CELEN(NB,NK)),OCC(NB,NK)
 301      CONTINUE
 302    CONTINUE
        IF (IBANS.EQ.1) GO TO 1001
 304    CONTINUE
 300  FORMAT('  BAND(',I3,'):  E=',F11.6,'  KE=',F10.6,'  OCC=',F10.6)
 4217 FORMAT(/' K-POINT (',I3,')   (',3F10.6,')  WEIGHT=',F10.6)
C=========================================================================
C      SUM THE CONTRIBUTIONS TO THE TOTAL ENERGY OF THE SYSTEM
C=========================================================================
        TOTEN = ENKE + DENC + XCENC + TEWEN + PSCENC + ENPOT + ENVNL
        TOTEN0 = TOTEN
C=========================================================================
C
C             SELF EXPLANATORY WRITE STATEMENTS
C
C=========================================================================
        WRITE (*,202) N
        WRITE (*,2600) 'TOTAL KINETIC ENERGY        ',  ENKE
        WRITE (*,2600) 'LOCAL POTENTIAL ENERGY      ',  ENPOT
        IF (IVPTYP.NE.0)
     &  WRITE (*,2600) 'NONLOCAL POTENTIAL  ENERGY  ',  ENVNL
        WRITE (*,2600) 'HARTREE ENERGY CORRECTION   ',  DENC
        WRITE (*,2600) 'EX-CORR ENERGY CORRECTION   ',  XCENC
        WRITE (*,2600) 'EWALD ENERGY                ',  TEWEN
        WRITE (*,2600) 'PSEUDOPOTENTIAL CORE ENERGY ',  PSCENC
        WRITE (*,2600) 'TOTAL ENERGY IS             ',  TOTEN
        IF (ICLOCK.EQ.1) CALL PCLOCK(0)
2600  FORMAT(1X,A28,F15.7)
 202  FORMAT(/,1X,'ITERATION',I4)
C=====================================================================
C
C   NOW WE CALCULATE FORCES ON IONS AND STRESSES ON THE UNIT CELL
C
C THE FOLLOWING IF STATEMENT SKIPS THE SECTION OF THE PROGRAM WHICH
C CALLS THE SUBROUTINES THAT PERFORM THE DYNAMICS FOR THE IONIC SYSTEM
C AND THE RELAXATION OF THE SIZE OF THE UNIT CELL. THE HELLMANN-FEYNMAN
C FORCES ARE NOT CORRECT UNTIL THE ELECTRONIC SYSTEM HAS RELAXED TO ITS
C GROUNDSTATE SO THESE SUBROUTINE CALLS SHOULD BE SKIPPED UNTIL THE
C ELECTRONIC SYSTEM IS IN ITS GROUNDSTATE
C=========================================================================
        IF (N.LE.NDELAY .AND. N.NE.(N/NPRINT)*NPRINT) GO TO 8000
C
        DO 3130 NSP = 1 , NSPEC
          CALL FELITR(NGX,NGY,NGZ,NIONSP(NSP),POSION(1,1,NSP),
     &                CHDENG,RECC,VPS(1,NSP),EIFOR(1,1,NSP),LPCTX,LPCTY,
     &                LPCTZ,LPCTFX,LPCTFY,LPCTFZ,CWORK3,CWORK4,CWORK5)
C=========================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE FEICTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE CALCULATES THE FORCE ON THE UNIT CELL WHICH RESULTS
C FROM THE CHANGE IN THE ELECTRON-ION ENERGY ON CHANGING THE SIZE OF
C THE CELL
C=========================================================================
          IF (IBOX.NE.0 .OR. N.EQ.NITER)
     &    CALL FEICTR(NGX,NGY,NGZ,NPLWV,CSTRF,RECC,VOLC,DVPS,VPS,SIGEI,
     &       CHDENG,LPCTX,LPCTY,LPCTZ,NSPEC,CWORK1,NIONSP,POSION,NIONS)
          DO 3135 MU = 1 , NIONS
            DO 3134 M = 1 , 3
              FNLEIF(M,MU,NSP) = 0.0
              FNLRL(M,MU) = 0.0
 3134       CONTINUE
 3135     CONTINUE
 3130   CONTINUE
C=========================================================================
C NEXT, WE CALCULATE FORCES AND STRESSES FROM THE NON-LOCAL PART OF 
C PSEUDOPOTENTIAL, WHICH IS GIVEN IN THE KLEINMAN-BYLANDER FORM.
C=========================================================================
        IF (IVPTYP.NE.0) THEN
C=========================================================================
C INITIALISE THE NON-LOCAL FORCE AND STRESS ARRAYS
C=========================================================================
          DO 3136 M = 1 , 6
            SIGNL(M) = 0.0
 3136     CONTINUE
C
          DO 3131 NKP = 1 , NKPTS
C
            IF (NKPTS.GT.1) THEN 
              NPUNIT = 19 + NKP
              REWIND NPUNIT
              READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
            END IF   
            IF (NLPOT.EQ.0) THEN
              CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &          DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,DVGNL,
     &          NPSPTN,IVPTYN)
              CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                  DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
C=========================================================================
C FNLFOR CALCULATES THE FORCES
C=========================================================================
              DO 3137 NSP = 1 , NSPEC
                IF (IVPTYN(NSP).EQ.0) GO TO 3137
                CALL FNLFOR(NBANDS,NRPLWV,NIONSP(NSP),NPLWKP(NKP),NIONS,
     &                  VOLC,PSCALE(0,NSP),CPHSGR(1,1,NSP),
     &                  VGNL(1,0,NSP),DNLG(1,1,NKP),DNLKG(1,0,NKP),
     &                  CPTWFP,FORWK,OCC(1,NKP),CWOR10,CWOR11 )
                DO 3133 MU = 1 , NIONSP(NSP)
                  DO 3132 M = 1 , 3
                    FNLEIF(M,MU,NSP) = FNLEIF(M,MU,NSP) + 
     &                                 FORWK(M,MU) * WTKPT(NKP)
 3132             CONTINUE
 3133           CONTINUE
 3137         CONTINUE
C=========================================================================
C FSIGNL CALCULATES THE STRESSES
C=========================================================================
C     IF (ISTRSS.NE.1) GOTO 3131
              IF (IBOX.EQ.0 .AND. N.NE.NITER) GO TO 3131
              CALL FSIGNL(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP(NKP),
     &                  DNLKG(1,0,NKP),VOLC,PSCALE,CPTWFP,CPHSGR,
     &                  VGNL,DVGNL,NBANDS,VNL(1,NKP),OCC(1,NKP),SIGWK,
     &                  CWRK30,CWRK31,CWRK32,CWRK33,CWRK34,CWRK35,
     &                  CWRK36,CWRK37,CWRK38,CWRK39,IVPTYN)
              DO 3138 M = 1 , 6
                SIGNL(M) = SIGNL(M) + SIGWK(M) * WTKPT(NKP)
 3138         CONTINUE
            ELSE
C========================================================================
C CALCULATE THE FORCES ON THE IONS FROM THE NON-LOCAL POTENTIAL USING
C THE REAL SPACE METHOD
C========================================================================
              IF (NKPTS.GT.1) 
     &          CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,
     &             NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)
              CALL FORLNL(VOLC,NGX,NGY,NGZ,CPTWFP,NKP,MPLWV,
     &             NRPLWV,NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,
     &             CWORK1,CWORK2,CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,
     &             PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &             FNLRL,DVRLGR,NINDPW,NPLWKP,OCC,IOCCUP,NGPTAR,WTKPT,
     &             CESAVE)
C========================================================================
C FSIGNL CALCULATES THE STRESSES
C========================================================================
            END IF
C
 3131     CONTINUE
          IF (NLPOT.EQ.1) THEN
            WRITE(*,*)' NON-LOCAL STRESS CONTRIBUTION NOT PROGRAMMED'
              NG = 1                              
              DO 3237 NSP = 1 , NSPEC             
                DO 3233 MU = 1 , NIONSP(NSP)      
                  DO 3232 M = 1 , 3               
                    FNLEIF(M,MU,NSP) = FNLRL(M,NG)
 3232             CONTINUE                        
                  NG = NG + 1                     
 3233           CONTINUE                          
 3237         CONTINUE                            
          END IF
        END IF
C=====================================================================
C SYMMETRIZE THE STRESS-TENSOR, I.E. SIGKE,SIGXC,SIGHA,SIGEI,SIGNL    
C=====================================================================
       IF (ISYMM.EQ.1 .AND. (IBOX.EQ.1 .OR. N.EQ.NITER)) THEN     
         CALL STRSYM(NC,IB,R,SIGKE)                                 
         CALL STRSYM(NC,IB,R,SIGXC)                                 
         CALL STRSYM(NC,IB,R,SIGHA)                                 
         CALL STRSYM(NC,IB,R,SIGEI)                                 
         CALL STRSYM(NC,IB,R,SIGNL)                                 
       ENDIF                                                          
C=====================================================================
C SUM THE TOTAL STRESS-TENSOR AND PRINT THEM OUT
C=====================================================================
        DO 2750 M = 1 , 6
          SIGTO(M) = SIGKE(M) + SIGHA(M) + SIGXC(M) + SIGEI(M) + 
     &               SIGAL(M) + SIGEW(M) + SIGNL(M)
2750    CONTINUE
        IF (N.NE.(N/NPRINT)*NPRINT) GO TO 2901 
        IF (N.NE.NITER .AND. IBOX.EQ.0) GO TO 2901
        WRITE (*,2900)
        WRITE (*,2700) 'STRESS', 'xx','yy','zz','yz','zx','xy'
        WRITE (*,2900)
        WRITE (*,2800) 'SIGKE ',SIGKE
        WRITE (*,2800) 'SIGHA ',SIGHA
        WRITE (*,2800) 'SIGXC ',SIGXC
        WRITE (*,2800) 'SIGAL ',SIGAL
        WRITE (*,2800) 'SIGEI ',SIGEI
        WRITE (*,2800) 'SIGEW ',SIGEW
        IF (IVPTYP.NE.0) WRITE (*,2800) 'SIGNL ',SIGNL
        WRITE (*,2900)
        WRITE (*,2800) 'SIGTO ',SIGTO
        WRITE (*,2900)
2901    CONTINUE
2700  FORMAT(4X,A6,4X,6(A2,9X))
2800  FORMAT(1X,A7,6F11.6)
2900  FORMAT(1X,73(1H-))
 115  FORMAT(/,'  Atom      Ewald     Elec-Ion   (Nonlocal)    Total')
C=====================================================================
C SYMMETRIZE THE FORCE,I.E. EIFOR AND FNLEIF                          
C=====================================================================
        IF (ISYMM.EQ.1) THEN                                            
          IF (IPRINT.GE.3) THEN
            WRITE(*,*)'EWIFOR:'                                           
            DO 8820 NSP=1,NSPEC                                           
              DO 8820 NI=1,NIONSP(NSP)                                    
                WRITE(*,8815) NSP, NI, (EWIFOR(M,NI,NSP), M=1,3)          
8820        CONTINUE                                                    
          END IF
          CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,FORCEWK2,
     $         NIONS,NSPEC,NIONSP,EWIFOR)                  
          IF (IPRINT.GE.2) THEN
            WRITE(*,*)'EIFOR:'                                            
            DO 8810 NSP=1,NSPEC                                           
              DO 8810 NI=1,NIONSP(NSP)                                    
                WRITE(*,8815) NSP, NI, (EIFOR(M,NI,NSP), M=1,3)           
8810        CONTINUE                                                    
          END IF
          CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,FORCEWK2,         
     *                   NIONS,NSPEC,NIONSP,EIFOR)                    
          IF (IPRINT.GE.2) THEN
            WRITE(*,*)'EIFOR AFTER SYMMETRIZATION:'                       
            DO 8819 NSP=1,NSPEC                                           
              DO 8819 NI=1,NIONSP(NSP)                                    
                WRITE(*,8815) NSP, NI, (EIFOR(M,NI,NSP), M=1,3)  
8819        CONTINUE                                           
            WRITE(*,*)'FNLEIF:'                                  
            DO 8817 NSP=1,NSPEC                                  
              DO 8817 NI=1,NIONSP(NSP)                           
                WRITE(*,8815) NSP, NI, (FNLEIF(M,NI,NSP), M=1,3) 
8817        CONTINUE                                           
          END IF
          CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,FORCEWK2,
     *                   NIONS,NSPEC,NIONSP,FNLEIF)          
          IF (IPRINT.GE.2) THEN
            WRITE(*,*)'FNLEIF AFTER SYMMETRIZATION:'             
            DO 8818 NSP=1,NSPEC                                  
              DO 8818 NI=1,NIONSP(NSP)                           
                WRITE(*,8815) NSP, NI, (FNLEIF(M,NI,NSP), M=1,3) 
8818        CONTINUE                                           
          END IF
        END IF                                                  
C=====================================================================
C SUM THE TOTAL FORCES ON THE IONS AND PRINT OUT
C=====================================================================
        NG = 1
        IF (IPRINT.GE.2) WRITE (*,115)
        DO 111 NSP = 1 , NSPEC
          DO 112 NI = 1 , NIONSP(NSP)
            DO 113 M = 1 , 3
              EIFOR(M,NI,NSP) = EIFOR(M,NI,NSP) + FNLEIF(M,NI,NSP)
              TIFOR(M,NI,NSP) = EIFOR(M,NI,NSP) + EWIFOR(M,NI,NSP)
 113        CONTINUE
            IF (IPRINT.LT.2) GOTO 112
C
            WRITE (*,116) NG, EWIFOR(1,NI,NSP),EIFOR(1,NI,NSP),
     &                   FNLEIF (1,NI,NSP),TIFOR(1,NI,NSP), 'Fx'
            WRITE (*,116) NG, EWIFOR(2,NI,NSP),EIFOR(2,NI,NSP),
     &                   FNLEIF (2,NI,NSP),TIFOR(2,NI,NSP), 'Fy'
            WRITE (*,116) NG, EWIFOR(3,NI,NSP),EIFOR(3,NI,NSP),
     &                   FNLEIF (3,NI,NSP),TIFOR(3,NI,NSP), 'Fz'
C 
            NG = NG + 1
 112      CONTINUE
 111    CONTINUE
      IF (ICLOCK.EQ.1) CALL PCLOCK(0)
 116  FORMAT(1X,I3,4F13.6,3X,A2)
C=====================================================================
C
C              *    DYNAMICS OF UNIT CELL    *
C
C RELAX THE UNIT CELL ALONG THE DIRECTIONS OF STRESSES (IF IBOX.EQ.1)
C=====================================================================
        IF (IBOX.EQ.0 .OR. N.LE.NDELAY) GOTO 7161
C=====================================================================
C
C{{{{{{{{{{{{{{{{{{{{{{{{ SUBROUTINE BMDTR }}}}}}}}}}}}}}}}}}}}}}}}}}}}
C
C THIS SUBROUTINE INTEGRATES THE EQUATIONS OF MOTION FOR THE SIZE OF THE
C UNIT CELL
C=====================================================================
        CALL BMDTR(DIRL,DIRC,RECC,VOLC,SIGTO,SITIM,SIDAMP,SIMASS,SIDISP)
        CALL BASTR(DIRC,RECC,VOLC)
C=====================================================================
C WARNING: 
C IF YOU CALL BMDTR YOU MUST CALL GENSP AGAIN TO CALCULATE THE KINETIC
C ENERGIES OF THE BASIS STATES FOR THE NEW BOX SIZE
C=====================================================================
        CALL GENBTR(NRPLWV,NGX,NGY,NGZ,NKPTS,ENMAX,NINDPW,NPLWKP,VKPT,
     &           LPCTX,LPCTY,LPCTZ,DATAKE,RECC,RECI,IPRINT,DNLG,DNLKG)
C=====================================================================
C ONE MUST ALSO CALL FVPTR AGAIN BECAUSE THE PSEUDOPOTENTIAL HAS
C NOW TO BE KNOWN ON THE CHANGED GRID IN RECIPROCAL SPACE 
C=====================================================================
        DO 2650 NSP = 1 , NSPEC
          CALL FVPTR(NGX,NGY,NGZ,NPSPTN(NSP),RECC,VOLC,PSP(1,NSP),
     &               PSGMAX(NSP),VPS(1,NSP),DVPS(1,NSP),LPCTX,LPCTY,
     &               LPCTZ,ICHARG(NSP),IVPTYN(NSP))
 2650   CONTINUE
        WRITE (*,101) ((DIRC(I,J), I=1,3), J=1,3)
7161    CONTINUE
        IF (ICLOCK.EQ.1) CALL PCLOCK(0)
C=====================================================================
C
C           *   *       DYNAMICS OF IONS       *   *
C
C IION   = 1 IF ION-POSITIONS RELAXATION IS INCLUDED
C=====================================================================
        IF (IION.EQ.0 .OR. N.LE.NDELAY) GOTO 8000
        NINDX = 1
        DO 3930 NSP = 1 , NSPEC
          DO 3931 NI = 1 , NIONSP(NSP)
            DO 3932 M = 1 , 3
              POSIC(M,NINDX) = POSION(M,NI,NSP)
              POSICL(M,NINDX) = POSIOL(M,NI,NSP)
              EWIFC(M,NINDX) = EWIFOR(M,NI,NSP)
              EIFC(M,NINDX) = EIFOR(M,NI,NSP)
 3932       CONTINUE
            NINDX = NINDX + 1
 3931     CONTINUE
 3930   CONTINUE
C=======================================================================
C
C DO A PRESET NUMBER OF CONJUGATE GRADIENTS ITERATIONS MOVING IONS FIRST
C SINCE THE CHANGE IN UNIT CELL SIZE CAN BE HANDLED IN A SINGLE STEP
C
C=======================================================================
C FIRST CALCULATE THE ENERGY IN THE LOCAL IONIC POTENTIAL
C=======================================================================
        ENION = 0.0
        ENPOT = 0.0
        DO 3929 NPW = 1 , NPLWV
          ENION = ENION + REAL ( CVION(NPW) ) * REAL ( CHDENR(NPW) )
          ENPOT = ENPOT + REAL ( CV   (NPW) ) * REAL ( CHDENR(NPW) )
          CVOLD(NPW) = CV(NPW)
 3929   CONTINUE
        ENION = ENION * RINPLW
        ENPOT = ENPOT * RINPLW
C========================================================================
C NOW START THE CONJUGATE GRADIENTS LOOP
C=======================================================================
        ENVNL1 = 0.0
        ENVNL2 = 0.0
        ENVNLT = 0.0
        PODISI = PODISP
        DO 3000 NCGI = 1 , NIOCG1
          IF (NCGI.EQ.1) GO TO 9138 
          DO 9130 NSP = 1 , NSPEC
            CALL FELITR(NGX,NGY,NGZ,NIONSP(NSP),POSION(1,1,NSP),
     &                  CHDENG,RECC,VPS(1,NSP),EIFOR(1,1,NSP),LPCTX,
     &          LPCTY,LPCTZ,LPCTFX,LPCTFY,LPCTFZ,CWORK3,CWORK4,CWORK5)
 9130     CONTINUE
C=======================================================================
C  INITIALISE NON-LOCAL FORCE ARRAY
C=======================================================================
          DO 9136 NSP = 1 , NSPEC
            DO 9135 MU = 1 , NIONS
              DO 9134 M = 1 , 3
                FNLEIF (M,MU,NSP) = 0.0
 9134         CONTINUE
 9135       CONTINUE
 9136     CONTINUE
C=======================================================================
          IF (IVPTYP.NE.0) THEN
            IF (NLPOT.EQ.1) THEN
              CALL SERLNL
     &             (NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,NSPEC, 
     &              DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSION,VRLNL,
     &              NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,       
     &              NGX,NGY,NGZ)                                    
              DO 9150 NI = 1 , NIONST
                DO 9151 M = 1 , 3    
                  FNLRL(M,NI) = 0.0  
 9151           CONTINUE             
 9150         CONTINUE               
            END IF
C
            DO 9131 NKP = 1 , NKPTS
              IF (NKPTS.GT.1) THEN
                NPUNIT = 19 + NKP
                REWIND NPUNIT
                READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV) , J=1,NBANDS)
              END IF
              IF (NLPOT.EQ.0) THEN
                CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                    DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
                CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &                 DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,
     &                 DVGNL,NPSPTN,IVPTYN)
C
                DO 9137 NSP = 1 , NSPEC
                  IF (IVPTYN(NSP).EQ.0) GO TO 9137
                  CALL FNLFOR(NBANDS,NRPLWV,NIONSP(NSP),NPLWKP(NKP),
     &                    NIONS,VOLC,PSCALE(0,NSP),CPHSGR(1,1,NSP),
     &                    VGNL(1,0,NSP),DNLG(1,1,NKP),DNLKG(1,0,NKP),
     &                    CPTWFP,FORWK,OCC(1,NKP),CWOR10,CWOR11)
                  DO 9133 MU = 1 , NIONSP(NSP)
                    DO 9132 M = 1 , 3
                      FNLEIF(M,MU,NSP) = FNLEIF(M,MU,NSP) +
     &                                  WTKPT(NKP) * FORWK(M,MU)
 9132               CONTINUE
 9133             CONTINUE
 9137           CONTINUE
              ELSE
                CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,
     &             NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)
                CALL FORLNL(VOLC,NGX,NGY,NGZ,CPTWFP,NKP,MPLWV,           
     &             NRPLWV,NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,     
     &             CWORK1,CWORK2,CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,     
     &             PRLSCA,VRLGRD,NADGRD,MXRLSH,                        
     &             FNLRL,DVRLGR,NINDPW,NPLWKP,OCC,IOCCUP,NGPTAR,WTKPT, 
     &             CESAVE)                                              
                NG = 1                              
                DO 9140 NSP = 1 , NSPEC             
                  DO 9141 MU = 1 , NIONSP(NSP)      
                    DO 9142 M = 1 , 3               
                      FNLEIF(M,MU,NSP) = FNLRL(M,NG)
 9142               CONTINUE                        
                    NG = NG + 1                     
 9141             CONTINUE                          
 9140           CONTINUE                            
              END IF
C
 9131       CONTINUE
C
          END IF
C
C=====================================================================
C SYMMETRIZE THE FORCE,I.E. EIFOR AND FNLEIF                          
C=====================================================================
          IF (ISYMM.EQ.1) THEN                                            
            IF (IPRINT.GE.3) THEN
              WRITE(*,*)'EWIFOR:'                                           
              DO 8816 NSP=1,NSPEC                                           
                DO 8816 NI=1,NIONSP(NSP)                                    
                  WRITE(*,8815) NSP, NI, (EWIFOR(M,NI,NSP), M=1,3)          
8816          CONTINUE                                                    
              CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,
     $             FORCEWK2,NIONS,NSPEC,NIONSP,EWIFOR)
              WRITE(*,*)'EIFOR:'                                            
              DO 8811 NSP=1,NSPEC                                           
                DO 8811 NI=1,NIONSP(NSP)                                    
                  WRITE(*,8815) NSP, NI, (EIFOR(M,NI,NSP), M=1,3)           
8811          CONTINUE                                                    
            END IF
            CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,FORCEWK2,         
     *                   NIONS,NSPEC,NIONSP,EIFOR)                    
            IF (IPRINT.GE.3) THEN
              WRITE(*,*)'EIFOR AFTER SYMMETRIZATION:'                       
              DO 8813 NSP=1,NSPEC                                           
                DO 8813 NI=1,NIONSP(NSP)                                    
                  WRITE(*,8815) NSP, NI, (EIFOR(M,NI,NSP), M=1,3)  
8813          CONTINUE                                           
              WRITE(*,*)'FNLEIF:'                                  
              DO 8812 NSP=1,NSPEC                                  
                DO 8812 NI=1,NIONSP(NSP)                           
                  WRITE(*,8815) NSP, NI, (FNLEIF(M,NI,NSP), M=1,3) 
8812          CONTINUE                                           
            END IF
            CALL FORSYM (NIONST,NC,IB,F0,R,NDIM9,FORCEWK1,FORCEWK2,
     *                   NIONS,NSPEC,NIONSP,FNLEIF)          
            IF (IPRINT.GE.3) THEN
              WRITE(*,*)'FNLEIF AFTER SYMMETRIZATION:'             
              DO 8814 NSP=1,NSPEC                                  
                DO 8814 NI=1,NIONSP(NSP)                           
                  WRITE(*,8815) NSP, NI, (FNLEIF(M,NI,NSP), M=1,3) 
8814          CONTINUE                                           
            END IF
          END IF                                                  
C=====================================================================
          NINDX = 1
          DO 9190 NSP = 1 , NSPEC
            DO 9191 NI = 1 , NIONSP(NSP)
              DO 9192 M = 1 , 3
                EIFC(M,NINDX)  = EIFOR(M,NI,NSP) + FNLEIF (M,NI,NSP)
                POSIC(M,NINDX) = POSION(M,NI,NSP)
 9192         CONTINUE
              NINDX = NINDX + 1
 9191       CONTINUE
 9190     CONTINUE
C=======================================================================
 9138     CONTINUE
C=======================================================================
          DO 3011 NI = 1 , NIONST
            DO 3010 M = 1 , 3
              GRION(M,NI) = RMOVE(NI) * ( EIFC(M,NI) + EWIFC(M,NI) )
              TIFORC(M,NI) = EIFC(M,NI) + EWIFC(M,NI)
 3010       CONTINUE
 3011     CONTINUE
C
          IF (ICNSTR.NE.0) THEN
            DO 3012 NI = 1 , NEWCOO
              GRNEW(NI) = 0.0
              DO 3013 NJ = 1 , NIONST
                DO 3014 K = 1 , 3
                  GRNEW(NI) = GRNEW(NI) + 
     &                        RCNSTR(K+3*(NJ-1),NI) * TIFORC(K,NJ)
 3014           CONTINUE
 3013         CONTINUE
              IF (IPRINT.GT.0) WRITE (*,*) 'NEW FORCE:',NI,GRNEW(NI)
 3012       CONTINUE
          END IF
C=======================================================================
C  CG STEP PERFORMED FOR UNCONSTRAINED SEARCH
C=======================================================================
          IF (ICNSTR.EQ.0) THEN
            IF (NCGI.EQ.1) THEN
              DO 9020 NI = 1 , NIONST
                DO 9021 M = 1 , 3
                  DIRION(M,NI) = GRION(M,NI)
 9021           CONTINUE
 9020         CONTINUE
            ELSE
              DOT1 = 0.0
              DOT2 = 0.0
              DO 9030 NI = 1 , NIONST
                DO 9031 M = 1 , 3
                  DOT1 = DOT1 + GRION(M,NI)  * GRION(M,NI)
                  DOT2 = DOT2 + GRIONP(M,NI) * GRIONP(M,NI)
 9031           CONTINUE
 9030         CONTINUE
              GAMMA = DOT1 / DOT2
              DO 9035 NI = 1 , NIONST
                DO 9036 M = 1 , 3
                  DIRION(M,NI) = GRION(M,NI) + GAMMA * DIPION(M,NI)
 9036           CONTINUE
 9035         CONTINUE
            ENDIF
C
            DIRMAX = 0.0
            FORDDI = 0.0
            DO 9037 NI = 1 , NIONST
              DO 9038 M = 1 , 3
                DIPION(M,NI) = DIRION(M,NI)
                GRIONP(M,NI) = GRION(M,NI)
                IF (ABS(DIRION(M,NI)).GT.DIRMAX) 
     &              DIRMAX = ABS (DIRION(M,NI))
 9038         CONTINUE
 9037       CONTINUE
            SCALE = PODISP / DIRMAX
C
            DO 9045 NI = 1 , NIONST
              DO 9046 M = 1 , 3
                DIRION(M,NI) = SCALE * DIRION(M,NI)
                FORDDI = FORDDI + GRION(M,NI) * DIRION(M,NI)
 9046         CONTINUE
 9045       CONTINUE
C=======================================================================
C  CG STEP PERFORMED FOR CONSTRAINED SEARCH
C=======================================================================
          ELSE
            IF (NCGI.EQ.1) THEN
              DO 6020 NI = 1 , NEWCOO
                DIRNEW(NI) = GRNEW(NI)
 6020         CONTINUE
            ELSE
              DOT1 = 0.0
              DOT2 = 0.0
              DO 6030 NI = 1 , NEWCOO
                DOT1 = DOT1 + GRNEW(NI)  * GRNEW(NI)
                DOT2 = DOT2 + GRNEWP(NI) * GRNEWP(NI)
 6030         CONTINUE
              GAMMA = DOT1 / DOT2
              DO 6035 NI = 1 , NEWCOO
                DIRNEW(NI) = GRNEW(NI) + GAMMA * DIPNEW(NI)
 6035         CONTINUE
            ENDIF
C
            DIRMAX = 0.0
            FORDDI = 0.0
            DO 6037 NI = 1 , NEWCOO
              DIPNEW(NI) = DIRNEW(NI)
              GRNEWP(NI) = GRNEW(NI)
              IF (ABS (DIRNEW(NI)).GT.DIRMAX) DIRMAX = ABS(DIRNEW(NI))
 6037       CONTINUE
            SCALE = PODISP / DIRMAX
C
            DO 6045 NI = 1 , NEWCOO
              DIRNEW(NI) = SCALE * DIRNEW(NI)
              FORDDI = FORDDI + GRNEW(NI) * DIRNEW(NI)
 6045       CONTINUE
C
C RECONSTRUCT DIRION FOR COMPATIBILITY WITH THE PREVIOUS VERSION
C
            DO 6046 NI = 1 , NIONST
              DO 6047 M = 1 , 3
                DIRION(M,NI) = 0.0
                DO 6048 NJ = 1 , NEWCOO
                  DIRION(M,NI) = DIRION(M,NI) +
     &                           DIRNEW(NJ) * RCNSTR(M+3*(NI-1),NJ)
 6048           CONTINUE
 6047         CONTINUE
 6046       CONTINUE
          END IF
C=======================================================================
C  BELOW WE TRANSFORM DISPLACEMENT (DIRION) FROM CARTESIAN COORDINATES
C  TO TRICLINIC SYSTEM DEFINED WITH DIRC-RECC VECTORS.
C  WE USE Ai x Bj = 2 x Pi x Delta(ij) RELATION, WERE Ai ARE DIRC,
C  Bj ARE RECC VECTORS. DIRION IS IN CARTESIAN AS FORCES ARE.
C=======================================================================
          DO 9050 NI = 1 , NIONST
            DO 9051 M = 1 , 3
              DUMMY = 0.0
              DO 9052 K = 1 , 3
                DUMMY = DUMMY + RECC(M,K) * DIRION(K,NI)
 9052         CONTINUE
              POSITC(M,NI) = POSIC(M,NI) + DUMMY / TWOPI
 9051       CONTINUE
 9050     CONTINUE
          NINDX = 1
          DO 9055 NSP = 1 , NSPEC
            DO 9056 NI = 1 , NIONSP(NSP)
              DO 9057 M = 1 , 3
                POSIOT(M,NI,NSP) = POSITC(M,NINDX)
 9057         CONTINUE
            NINDX = NINDX + 1
 9056       CONTINUE
 9055     CONTINUE
C=======================================================================
C COMPUTE NEW STRUCTURE FACTORS
C=======================================================================
          DO 4109 NSP = 1 , NSPEC
            CALL FSTFTR(NGX,NGY,NGZ,NIONSP(NSP),NPLWV,POSIOT(1,1,NSP),
     &                  CSTRF(1,NSP),LPCTX,LPCTY,LPCTZ)
 4109     CONTINUE
C=======================================================================
C CALCULATE THE IONIC POTENTIAL AT TRIAL CONFIGURATION
C=======================================================================
          DO 4126 NP = 1 , MPLWV
            CWORK1(NP) = (0.0,0.0)
            CWORK2(NP) = (0.0,0.0)
 4126     CONTINUE
          DO 4127 NSP = 1 , NSPEC
            DO 4128 NP = 1 , NPLWV
              CWORK1(NP) = CWORK1(NP) + VPS(NP,NSP) * CSTRF(NP,NSP)
 4128       CONTINUE
 4127     CONTINUE
          CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)
          DO 4124 NP = 1 , NPLWV
            CVIONT(NP) = CWORK1(NP)
 4124     CONTINUE
C=======================================================================
C CALCULATE NEW ELECTRON-ION ENERGY
C=======================================================================
          ENIONT = 0.0
          DO 4130 NPW = 1 , NPLWV
           ENIONT = ENIONT + REAL ( CVIONT(NPW) ) * REAL ( CHDENR(NPW) )
 4130     CONTINUE
          ENIONT = ENIONT / NPLWV
          IF (IVPTYP.EQ.0) GO TO 9203
          IF (NLPOT.EQ.1) CALL SERLNL
     &        (NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,NSPEC,
     &         DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSIOT,VRLNL,
     &         NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,NGX,NGY,NGZ)
C=======================================================================
C K-POINT LOOP STARTS
C=======================================================================
          DO 9200 NKP = 1 , NKPTS
C=======================================================================
C     READ WAVEFUNCTION FROM EXTERNAL MEMORY
C=======================================================================
            IF (NKPTS.GT.1) THEN
              NPUNIT = 19 + NKP 
              REWIND NPUNIT
              READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV) , J=1,NBANDS)
            END IF
C=======================================================================
C  WE DO NOT STORE CPHSGR AND VGNL, SO WE HAVE TO RE-CALCULATE THEM EVER
C  TIME.
C=======================================================================
            IF (NLPOT.EQ.0) THEN
              CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                  DNLG(1,1,NKP),POSIOT,DIRC, CPHSGR,IVPTYN)
              IF (NKPTS.NE.1) 
     &         CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &                 DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,
     &                 DVGNL,NPSPTN,IVPTYN)
              DO 9201 NB = 1 , NBANDS
                CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP(NKP),
     &          DNLKG(1,0,NKP),VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,
     &          CWRK22,CWRK23,CPHSGR,VGNL,CELFRC,CWOR10,CWOR11,NB,
     &          IVPTYN)
                VNL(NB,NKP) = 0.0
                DO 9202 M = 1 , NPLWKP(NKP)
                  VNL(NB,NKP) = VNL(NB,NKP) +
     &                        REAL ( CONJG (CPTWFP(M,NB)) * CELFRC(M) )
 9202           CONTINUE
 9201         CONTINUE
            ELSE
              CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSIOT,     
     &          NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)  
              DO 4123 NB=1,NBANDS                                         
                DO 5346 M = 1 , MPLWV                                     
                  CWORK1(M) = (0.0,0.0)                                   
                  CWORK2(M) = (0.0,0.0)                                   
 5346           CONTINUE                                                  
                NINDW = NRPLWV*(NB-1)                                     
                DO 223 M=1,NPLWKP(NKP)                                    
                  CWORK1(NINDPW(M,NKP))=CPTWFP(M,NB)                      
 223            CONTINUE                                                  
                CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)                        
                CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NB,NKP,MPLWV,NRPLWV,     
     &         NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK2,CWORK1, 
     &         CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD, 
     &         MXRLSH,CESAVE)                                         
 4123         CONTINUE
            END IF
 9200     CONTINUE
C=======================================================================
C ENVNLT - NONLOCAL ENERGY FOR NEW IONIC POSITIONS AND OLD WAVEFUNCTIONS
C=======================================================================
          ENVNLT = 0.0
          DO 9210 NK = 1 , NKPTS
            DO 9220 NB = 1 , NBANDS
              ENVNLT = ENVNLT + 2.0 * WTKPT(NK) * VNL(NB,NK) 
     &                                          * OCC(NB,NK)
 9220       CONTINUE
 9210     CONTINUE
C
 9203     CONTINUE
C=======================================================================
C
C CALCULATE NEW EWALD ENERGY
C
C=======================================================================
         CALL EWALTR(POSITC,EWIFC,EWRLEN,EWRCSS,EWRLSS,EWRCSI,DIRC,RECC,
     &       VOLC,SIGEW,TEWENT,NIONST,ICHARC,NIONCH,NICHSQ,CPHFX,CPHFY,
     &       CPHFZ,IPRINT,NIONST,NEWPTS,MAXCX,MAXCY,MAXCZ,MAXGPX,MAXGPY,
     &       MAXGPZ,NGPTS,RFORCE,CFORCE,FORCEG,FORSIG,ENERG)
C=======================================================================
C  UPDATE TOTAL POTENTIAL
C=======================================================================
          DO 7128 M = 1 , NPLWV
            CVTRUE(M) = CV(M) + CVIONT(M) - CVION(M)
 7128     CONTINUE   
C=======================================================================
C  UPDATE WITH A SCREENED POTENTIAL IN RECIPROCAL SPACE
C=======================================================================
          DO 7250 M = 1 , NPLWV
            CWORK(M) = CV(M)
 7250     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,1)
          DO 7251 M = 1 , NPLWV
            CV(M) = CWORK(M) * RINPLW
 7251     CONTINUE
C
          DO 7252 M = 1 , NPLWV
            CWORK(M) = CVION(M)
 7252     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,1)
          DO 7253 M = 1 , NPLWV
            CVION(M) = CWORK(M) * RINPLW
 7253     CONTINUE
C
          DO 7254 M = 1 , NPLWV
            CWORK(M) = CVIONT(M)
 7254     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,1)
          DO 7255 M = 1 , NPLWV
            CVIONT(M) = CWORK(M) * RINPLW
 7255     CONTINUE
C
          DO 7256 M = 1 , NPLWV
            CWORK(M) = CVOLD(M)
 7256     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,1)
          DO 7257 M = 1 , NPLWV
            CVOLD(M) = CWORK(M) * RINPLW
 7257     CONTINUE
C
          DO 7258 M = 1 , NPLWV
            CV(M) = CV(M) + ( CVIONT(M) - CVION(M) ) * SQRT ( MIN 
     &              ( 1.0 , ABS ( CVOLD(M) / ( CVION(M) + 1.0E-6 ) ) ) )
     &                
 7258     CONTINUE
C=======================================================================
C   BACK TO THE REAL SPACE
C=======================================================================
          DO 7350 M = 1 , NPLWV
            CWORK(M) = CV(M)
 7350     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,-1)
          DO 7351 M = 1 , NPLWV
            CV(M) = CWORK(M)
 7351     CONTINUE
C
          DO 7352 M = 1 , NPLWV
            CWORK(M) = CVION(M)
 7352     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,-1)
          DO 7353 M = 1 , NPLWV
            CVION(M) = CWORK(M)
 7353     CONTINUE
C
          DO 7354 M = 1 , NPLWV
            CWORK(M) = CVIONT(M)
 7354     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,-1)
          DO 7355 M = 1 , NPLWV
            CVIONT(M) = CWORK(M)
 7355     CONTINUE
C
          DO 7356 M = 1 , NPLWV
            CWORK(M) = CVOLD(M)
 7356     CONTINUE
          CALL FFT3D(CWORK,CWORK1,NGPTAR,-1)
          DO 7357 M = 1 , NPLWV
            CVOLD(M) = CWORK(M)
 7357     CONTINUE
C=======================================================================
C  INITIALISE ELECTRONIC GRADIENT TO ZERO AND SET ALPHA - TRIAL DISTANCE
C  FOR ELECTRONS
C=======================================================================
          ENGRSI = 0.0
          ALPHA = 0.01
          RCOSTH = COS (ALPHA)
          RSINTH = SIN (ALPHA)
C=======================================================================
C  START THE K-POINT LOOP
C=======================================================================
          IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1)
     &          CALL SERLNL (NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,       
     &                       NRGRPT,NSPEC,DIRC,RECC,RLCORE,RMAX,NRLNL,
     &                       PRLSCA,POSIOT,VRLNL,NIONSP,IRLNL,NADGRD, 
     &                       NRLPPI,DVRLGR,VRLGRD,NGX,NGY,NGZ)        
          DO 7100 NKP = 1 , NKPTS
            NPUNIT = 19 + NKP 
            NUNIT  = 39 + NKP
            REWIND NUNIT
            IF (NKPTS.GT.1) THEN
              REWIND NPUNIT
              READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV) , J=1,NBANDS)
            END IF
C=======================================================================
C  WE DO NOT STORE CPHSGR AND VGNL, SO WE HAVE TO RE-CALCULATE THEM EVER
C  TIME.
C=======================================================================
            IF (IVPTYP.NE.0) THEN
              IF (NLPOT.EQ.0) THEN
                CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                    DNLG(1,1,NKP),POSIOT,DIRC, CPHSGR,IVPTYN)
                IF (NKPTS.GT.1)
     &           CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &                 DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,
     &                 DVGNL,NPSPTN,IVPTYN)
              ELSE IF (NKPTS.GT.1) THEN
                CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,
     &                      POSIOT,NRLPPI,NIONSP,RLCORE,CPHGRD,
     &                      VKPT(1,NKP),NGX,NGY,NGZ)
              END IF
            END IF          
C=======================================================================
C
C            SUBROUTINE  WFTRI
C
C  SUBROUTINE WFTRI CALCULATES THE KINETIC ENERGY AND CHARGE DENSITY FOR
C  TOTAL WAVEFUNCTIONS AT A FIXED DISTANCE ALONG THE GRADIENT DIRECTION
C  FOR THE NEW IONIC COORDINATES
C
C=======================================================================
            CALL WFTRI(NGX,NGY,NGZ,NBANOC,NKPTS,NPLWV,
     &               MPLWV,NRPLWV,NINDPW(1,NKP),
     &               NPLWKP(NKP),WTKPT,CV,CPTWFP,CPTWFL,VOLC,CELEN,
     &               NGPTAR,DATAKE(1,1,NKP),CWORK1,CWORK2,CWORK,
     &               NUNIT,NBANOC, CWORK6,CWORK7,CWORK8,CWORK9,CWOR10,
     &               WORK12,CHDENR,NKP,CWOR11,
     &               NSPEC,NIONS,NIONSP,PSCALE,
     &               DNLKG,CPHSGR,VGNL,CELFRC,
     &               CWRK20,CWRK21,CWRK22,CWRK23,VNL,IVPTYP,OCC,
     &               ENGRSI,ALPHA,CVTRUE,IVPTYN,NLPOT,NRGRPT,NRLPPI,
     &               CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,
     &               NADGRD,MXRLSH,CESAVE)
C
            IF (IVPTYP.NE.0) THEN
C=======================================================================
C NONLOCAL ENERGY FOR OLD IONIC POSITIONS AND NEW WAVE FUNCTIONS IS
C IN ENVNL2, AND IT IS CALCULATED FROM VNLT(NB,NKP) ARRAY.
C=======================================================================
C NONLOCAL ENERGY FOR NEW IONIC POSITIONS AND NEW WAVE FUNCTIONS IS
C IN ENVNL1, AND IT IS CALCULATED FROM VNL(NB,NKP) ARRAY. VNL ARE NOT
C UPDATED AS THEY WERE RECALCULATED IN WFTRI.
C=======================================================================
              IF (NLPOT.EQ.0)
     &          CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                    DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
              REWIND NUNIT
              DO 9205 NB = 1 , NBANDS
                READ (NUNIT) (CPTWFL(I),I=1,NRPLWV)
                DO 9206 M = 1 , NRPLWV
                  CPTWFL(M) = CPTWFL(M) * RSINTH + CPTWFP(M,NB) * RCOSTH
 9206           CONTINUE
                IF (NLPOT.EQ.0) THEN
                  CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP(NKP),
     &                      DNLKG(1,0,NKP),VOLC,PSCALE,CPTWFL,
     &                      CWRK20,CWRK21,CWRK22,CWRK23,CPHSGR,VGNL,
     &                      CELFRC,CWOR10,CWOR11,1,IVPTYN)
                  VNLT(NB,NKP) = 0.0
                  DO 9106 M = 1 , NPLWKP(NKP)
                    VNLT(NB,NKP) = VNLT(NB,NKP) +
     &                           REAL ( CONJG (CPTWFL(M)) * CELFRC(M) )
 9106             CONTINUE
                END IF
 9205         CONTINUE
            END IF
 7100     CONTINUE
C
          IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN
            CALL SERLNL (NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,       
     &                    NRGRPT,NSPEC,DIRC,RECC,RLCORE,RMAX,NRLNL,
     &                    PRLSCA,POSION,VRLNL,NIONSP,IRLNL,NADGRD, 
     &                    NRLPPI,DVRLGR,VRLGRD,NGX,NGY,NGZ)        
            DO 7101 NKP = 1 , NKPTS
              NUNIT = NKP + 39
              REWIND NUNIT
              IF (NKPTS.GT.1) THEN                                     
                NPUNIT = 19 + NKP
                REWIND NPUNIT                                          
                READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV) , J=1,NBANDS)
              END IF                                                   
              CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,
     &            NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ) 
              DO 7102 NB = 1 , NBANDS
                READ (NUNIT) (CPTWFL(I),I=1,NRPLWV)
                DO 7103 M = 1 , NRPLWV
                  CPTWFL(M) = CPTWFL(M) * RSINTH + CPTWFP(M,NB) * RCOSTH
 7103           CONTINUE
                DO 7104 M = 1 , MPLWV
                  CWORK1(M) = (0.0,0.0)
                  CWORK2(M) = (0.0,0.0)
 7104           CONTINUE
                DO 224 M=1,NPLWKP(NKP)           
                  CWORK1(NINDPW(M,NKP))=CPTWFL(M)
 224            CONTINUE                         
                CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)             
                CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNLT,NB,NKP,MPLWV,
     &                      NRPLWV,NRGRPT,NIONSP,NRLPPI,NBANDS,
     &                      NKPTS,NSPEC,CWORK2,CWORK1,CPHGRD,  
     &                      NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,  
     &                      VRLGRD,NADGRD,MXRLSH,CESAVE)       
 7102         CONTINUE
 7101       CONTINUE
          END IF
C
          IF (IVPTYP.EQ.1) THEN
            ENVNL1 = 0.0
            ENVNL2 = 0.0
            DO 9103 NK = 1 , NKPTS
              DO 9104 NB = 1 , NBANDS
                ENVNL1 = ENVNL1 + 2.0 * WTKPT(NK) * VNL(NB,NK) 
     &                                            * OCC(NB,NK)
                ENVNL2 = ENVNL2 + 2.0 * WTKPT(NK) * VNLT(NB,NK) 
     &                                            * OCC(NB,NK)
 9104         CONTINUE
 9103       CONTINUE
          END IF
C=======================================================================
C  CALCULATE THE TOTAL KINETIC ENERGY FOR THE TRIAL WAVEFUNCTIONS
C=======================================================================
          ENKET = 0.0
          DO 7110 NK = 1 , NKPTS
            DO 7111 NB = 1 , NBANDS
              ENKET = ENKET + 2.0 * REAL ( CELEN(NB,NK) ) * WTKPT(NK)
     &                            * OCC(NB,NK)
 7111       CONTINUE
 7110     CONTINUE
C=======================================================================
C  TRANSFORM CHARGE DENSITY TO RECIPROCAL SPACE AND CALCULATE HARTREE
C  AND EXCHANGE-CORRELATION ENERGY AND TIDY UP POTENTIALS
C=======================================================================
C
          DO 7120 M = 1 , NPLWV
            CWORK1(M) = CHDENR(M) * RINPLW
 7120     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,-1)
C
          IF (ISYMM.EQ.1) THEN
C
C======================================================================
C     >>>>>>>>>>>>>>>>>>> SYMMETRIZE CHARGE DENSITY  <<<<<<<<<<<<<<<<<<
C======================================================================
C
            CALL ROSYM4(A1,A2,A3,B1,B2,B3,ISY,NC,IB,V,R,RB,NPLWV,
     +                  NGX,NGY,NGZ,CWORK1,CWORK,LPCTX,LPCTY,
     +                  LPCTZ,LPCTXI,LPCTYI,LPCTZI,IPRINT)
C======================================================================
C    TRANSFORM THE CHARGE DENSITY TO REAL SPACE                        
C======================================================================
            DO 4910 M = 1 , NPLWV
              CWORK(M) = CWORK1(M)
 4910       CONTINUE
            CALL FFT3D(CWORK,CWORK2,NGPTAR,1)                    
            DO 4911 M = 1 , NPLWV
              CHDENR(M) = CWORK(M)
 4911       CONTINUE
          END IF  
C======================================================================
C  END OF SYMMETRIZATION ROUTINE
C  CHARGE DENSITY IS IN CHDENR (REAL) AND CWORK1(RECIPROCAL)
C======================================================================
          DENCT = 0.0
          DO 7122 M = 1 , NPLWV
            CVD(M) = CWORK1(M) * DIRDAT(M)
            DENCT = DENCT + REAL ( CVD(M) * CONJG ( CWORK1(M) ) )
 7122     CONTINUE
          DENCT = - DENCT / 2.0
C
          DO 7130 M = 1 , NPLWV
            CWORK1(M) = CVD(M)
 7130     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,1)
          DO 7135 M = 1 , NPLWV
            CVD(M) = CWORK1(M)
 7135     CONTINUE
          DO 7140 M = 1 , NPLWV
            CV(M) = CHDENR(M)
 7140     CONTINUE
          CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENCT,XCENER,EXCDAT,XCFDAT,
     &              XCPDAT)
          DO 7150 M = 1 , NPLWV
            CV(M) = CV(M) + CVION(M)
            CV(M) = CV(M) + CVD(M)
 7150     CONTINUE
C=======================================================================
C  CALCULATE NEW TOTAL POTENTIAL ENERGY AND IONIC ENERGIES FOR THE NEW
C  CHARGE DENSITY
C=======================================================================
          ENPOTT = 0.0
          ENITEL = 0.0
          ENIELT = 0.0
          DO 7155 M = 1 , NPLWV
            ENPOTT = ENPOTT + REAL ( CV    (M) ) * REAL ( CHDENR(M) )
            ENITEL = ENITEL + REAL ( CVIONT(M) ) * REAL ( CHDENR(M) )
            ENIELT = ENIELT + REAL ( CVION (M) ) * REAL ( CHDENR(M) )
 7155     CONTINUE
          ENPOTT = ENPOTT * RINPLW
          ENITEL = ENITEL * RINPLW
          ENIELT = ENIELT * RINPLW
C
          EN1 = ENPOT + DENC + XCENC + TEWEN + ENKE + ENVNL
          EN2 = EN1 + ENIONT - ENION + TEWENT - TEWEN + ENVNLT - ENVNL
          EN3 = ENPOTT + DENCT + XCENCT + TEWEN + ENKET + ENVNL2
          EN4 = EN3 + TEWENT - TEWEN + ENITEL - ENIELT + ENVNL1 - ENVNL2
          WRITE (*,*) 'EN 1-4:',EN1,EN2,EN3,EN4
C=======================================================================
C USE RESULTS TO FIND MINIMUM IN THE TWO-DIMENSIONAL ENERGY SPACE
C=======================================================================
          E = EN4 - EN3 - EN2 + EN1
          A = 2.0 * ALPHA * ENGRSI - E
          B = EN3 - EN1 - A
          F = - FORDDI
          D = EN2 - ( EN1 + F )
C=======================================================================
C CALCULATE OPTIMUM STEPLENGTH
C=======================================================================
          STEPSI = ( 2.0 * A * D - E * F ) / ( E * E - 4.0 * B * D )
          IF (ABS(D).GT.1.E-6) THEN
            STEPIO = - ( F + E * STEPSI ) / ( 2.0 * D )
          ELSE 
            IF (ABS(E).GT.1.E-6) THEN
              STEPIO = - ( 2.0 * B * STEPSI + A ) / E
            ELSE
              STEPIO = 0.0
            END IF
          END IF
          IF (IPRINT.GE.1) THEN
            IF (IVPTYP.NE.0) THEN
              WRITE (*,*) ' ENVNL,ENVNLT  ',ENVNL,ENVNLT
              WRITE (*,*) ' ENVNL1,ENVNL2 ',ENVNL1,ENVNL2
            END IF
            WRITE (*,*) ' ENPOT,ENPOTT  ',ENPOT,ENPOTT
            WRITE (*,*) ' ENION,ENIONT  ',ENION,ENIONT
            WRITE (*,*) ' ENITEL,ENIELT ',ENITEL,ENIELT
            WRITE (*,*) ' DENC,DENCT    ',DENC,DENCT
            WRITE (*,*) ' XCENC,XCENCT  ',XCENC,XCENCT
            WRITE (*,*) ' TEWEN,TEWENT  ',TEWEN,TEWENT
            WRITE (*,*) ' ENKE,ENKET    ',ENKE,ENKET
            WRITE (*,*) ' ENGRSI,FORDDI ',ENGRSI,FORDDI
            WRITE (*,*) ' A,B,F ', A,B,F
            WRITE (*,*) ' D,E   ', D,E
            WRITE (*,*) ' STEPSI,STEPIO ',STEPSI,STEPIO
          END IF
C=======================================================================
C  SET REAL-SPACE CHARGE DENSITY TO ZERO BEFORE ELECTRONIC UPDATING
C=======================================================================
          DO 7160 M = 1 , NPLWV
            CHDENR(M) = (0.0,0.0)
            CHDENG(M) = (0.0,0.0)
 7160     CONTINUE
C=======================================================================
C  START K-POINT LOOP
C=======================================================================
          DO 7170 NKP = 1 , NKPTS
            NPUNIT = 19 + NKP
            NUNIT  = 39 + NKP
            IF (NKPTS.GT.1) THEN
              REWIND NPUNIT
              READ (NPUNIT) ((CPTWFP(I,J),I=1,NRPLWV) , J=1,NBANDS)
            END IF
            REWIND NUNIT
C=======================================================================
C  UPDATE WAVEFUNCTIONS
C=======================================================================
            DO 7171 NB = 1 , NBANDS
              READ (NUNIT) (CPTWFL(I), I = 1,NRPLWV)
              THETA = ALPHA * STEPSI
              RCOSTH = COS (THETA)
              RSINTH = SIN (THETA)
              DO 7172 M = 1 , NRPLWV
                CPTWFP(M,NB) = RCOSTH * CPTWFP(M,NB) + 
     &                         RSINTH * CPTWFL(M)
 7172         CONTINUE
 7171       CONTINUE
C=======================================================================
C  ORTHOGONALISE WAVEFUNCTIONS AND CALCULATE CHARGE DENSITY
C=======================================================================
            CALL ORSP(NBANDS,NKPTS,NRPLWV,NPLWKP(NKP),CPTWFP,
     &                                        CWORK1,CWORK2)
            CALL CHSP(NBANOC,NPLWV,NRPLWV,MPLWV,
     &                WTKPT(NKP),CPTWFP,CHDENG,CHDENR,NGPTAR,
     &                NINDPW(1,NKP),NPLWKP(NKP),CWORK1,CWORK2,
     &                OCC(1,NKP) )
C=======================================================================
C  CALCULATE NEW KINETIC ENERGIES OF WAVEFUNCTIONS
C=======================================================================
            DO 7180 NB = 1 , NBANDS
              CELEN(NB,NKP) = 0.0
              DO 7181 M = 1 , NPLWKP(NKP)
                CELEN(NB,NKP) = CELEN(NB,NKP) + DATAKE(1,M,NKP) * 
     &                          CPTWFP(M,NB) * CONJG ( CPTWFP(M,NB) )
 7181         CONTINUE
 7180       CONTINUE
C=======================================================================
C  STORE WAVEFUNCTIONS
C=======================================================================
            IF (NKPTS.GT.1) THEN
              REWIND NPUNIT
              WRITE (NPUNIT) ((CPTWFP(I,J),I=1,NRPLWV) , J=1,NBANDS)
            END IF
C=======================================================================
C  END OF K-POINT LOOP
C=======================================================================
 7170     CONTINUE
C=======================================================================
C SET NEW IONIC POSITIONS AND CALCULATE NEW STARTING ENERGIES ETC
C=======================================================================
          DO 4140 NI = 1 , NIONST
            DO 4141 M = 1 , 3
              POSIC(M,NI) = POSIC(M,NI) + STEPIO * 
     &           ( RECC(M,1) * DIRION(1,NI) + RECC(M,2) * DIRION(2,NI)
     &           + RECC(M,3) * DIRION(3,NI) ) / TWOPI
 4141       CONTINUE
 4140     CONTINUE
          PODISP = STEPIO * PODISP
          WRITE (*,*) ' PODISP,PODISI ',PODISP,PODISI
          DO 1650 NI = 1 , NIONST
            DO 1651 M = 1 , 3
              IF (POSIC(M,NI).LT.0.0) POSIC(M,NI) = POSIC(M,NI) + 1.0 -
     &                                INT ( POSIC(M,NI) )
              IF (POSIC(M,NI).GT.1.0) POSIC(M,NI) = POSIC(M,NI) -
     &                                INT ( POSIC(M,NI) )
 1651       CONTINUE
 1650     CONTINUE
          NINDX = 1
          DO 4150 NSP = 1 , NSPEC
            DO 4151 NI = 1 , NIONSP(NSP)
              DO 4152 M = 1 , 3
                POSION(M,NI,NSP) = POSIC(M,NINDX)
 4152         CONTINUE
              NINDX = NINDX + 1
 4151       CONTINUE
 4150     CONTINUE
C=======================================================================
C COMPUTE STRUCTURE FACTOR AT FINAL ION POSITIONS
C=======================================================================
          DO 5110 NSP = 1 , NSPEC
            CALL FSTFTR(NGX,NGY,NGZ,NIONSP(NSP),NPLWV,POSION(1,1,NSP),
     &                  CSTRF(1,NSP),LPCTX,LPCTY,LPCTZ)
 5110     CONTINUE
C=======================================================================
C CALCULATE THE IONIC POTENTIAL AT FINAL CONFIGURATION
C=======================================================================
          DO 5126 NP = 1 , MPLWV
            CWORK1(NP) = (0.0,0.0)
            CWORK2(NP) = (0.0,0.0)
 5126     CONTINUE
          DO 5127 NSP = 1 , NSPEC
            DO 5128 NP = 1 , NPLWV
              CWORK1(NP) = CWORK1(NP) + VPS(NP,NSP) * CSTRF(NP,NSP)
 5128       CONTINUE
 5127     CONTINUE
          CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)
          DO 5124 NP = 1 , NPLWV
            CVION(NP) = CWORK1(NP)
 5124     CONTINUE
C=======================================================================
C  TRANSFORM CHARGE DENSITY TO RECIPROCAL SPACE AND CALCULATE HARTREE
C  AND EXCHANGE-CORRELATION ENERGY AND TIDY UP POTENTIALS
C=======================================================================
          DO 5129 NP = 1 , MPLWV
            CWORK1(NP) = (0.0,0.0)
            CWORK(NP)  = (0.0,0.0)
 5129     CONTINUE
          DO 7220 M = 1 , NPLWV
            CWORK1(M) = CHDENR(M) * RINPLW
 7220     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,-1)
C
          IF (ISYMM.EQ.1) THEN
C======================================================================
C     >>>>>>>>>>>>>>>>>>> SYMMETRIZE CHARGE DENSITY  <<<<<<<<<<<<<<<<<<
C======================================================================
C
            CALL ROSYM4(A1,A2,A3,B1,B2,B3,ISY,NC,IB,V,R,RB,NPLWV,
     +                  NGX,NGY,NGZ,CWORK1,CWORK,LPCTX,LPCTY,
     +                  LPCTZ,LPCTXI,LPCTYI,LPCTZI,IPRINT)
C======================================================================
C    TRANSFORM THE CHARGE DENSITY TO REAL SPACE                        
C======================================================================
            DO 4920 M = 1 , NPLWV
              CWORK(M) = CWORK1(M)
 4920       CONTINUE
            CALL FFT3D(CWORK,CWORK2,NGPTAR,1)                    
            DO 4921 M = 1 , NPLWV
              CHDENR(M) = CWORK(M)
 4921       CONTINUE
C======================================================================
C  END OF SYMMETRIZATION ROUTINE
C  CHARGE DENSITY IS IN CHDENR (REAL) AND CWORK1(RECIPROCAL)
C======================================================================
          END IF  
C
          DENC = 0.0
          DO 7222 M = 1 , NPLWV
            CHDENG(M) = CWORK1(M)
            CVD(M) = CWORK1(M) * DIRDAT(M)
            DENC = DENC + REAL ( CVD(M) * CONJG ( CWORK1(M) ) )
 7222     CONTINUE
          DENC = - DENC / 2.0
C
          DO 7231 M = 1 , NPLWV
            CWORK1(M) = CVD(M)
 7231     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,1)
          DO 7236 M = 1 , NPLWV
            CVD(M) = CWORK1(M)
 7236     CONTINUE
          DO 7241 M = 1 , NPLWV
            CV(M) = CHDENR(M)
 7241     CONTINUE
          CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,XCFDAT,
     &              XCPDAT)
          DO 7243 M = 1 , NPLWV
            CV(M) = CV(M) + CVD(M) + CVION(M)
 7243     CONTINUE
C=======================================================================
C  CALCULATE EIGENVALUES IN CASE OF SUBSPACE ROTATION SWITCHED ON
C=======================================================================
          IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1)  CALL SERLNL
     &               (NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,
     &                NSPEC,DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSION,
     &                VRLNL,NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,       
     &                NGX,NGY,NGZ)                                    
          IF (ISBROT.EQ.1 .OR. IOCCUP.EQ.1) THEN
            DO 7190 NKP = 1 , NKPTS
              IF (NKPTS.GT.1) THEN
                NPUNIT = 19 + NKP
                REWIND NPUNIT
                READ (NPUNIT) ((CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
              END IF
              IF (IVPTYP.NE.0) THEN
                IF (NLPOT.EQ.0) THEN
                  CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                      DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
                  IF (NKPTS.NE.1) 
     &              CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,
     &                  NPLWKP(NKP),DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, 
     &                  VGNL,DVGNL,NPSPTN,IVPTYN)
                ELSE
                 CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,POSION,   
     &           NRLPPI,NIONSP,RLCORE,CPHGRD,VKPT(1,NKP),NGX,NGY,NGZ)
                END IF
              END IF
              CALL SUBROT(NBANDS,NKPTS,NPLWV,MPLWV,NRPLWV,NINDPW(1,NKP),
     &                  NPLWKP(NKP),CV,CPTWFP,CPTWFL,VOLC,CELEN,
     &                  VNL,NGPTAR,DATAKE(1,1,NKP),CWORK1,CWORK2,
     &                  CWORK,CWORK6,NKP,
     &                  HR, HI, AUX, FV1, FV2, FV3, CH0, NSPEC, NIONS, 
     &                  NIONSP,PSCALE,
     &                  DNLKG,CPHSGR,VGNL,CELFRC,CWRK20,
     &                  CWRK21, CWRK22, CWRK23,IVPTYP,IVPTYN,IPRINT,
     &                  NLPOT,NGX,NGY,NGZ,NRGRPT,NRLPPI,CPHGRD,NRLNL,
     &                  NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,
     &                  MXRLSH,CESAVE)
              DO 4502 NB = 1 , NBANDS
                EIGVAL(NB,NKP) = AUX(NB)
 4502         CONTINUE
C  STORE WAVEFUNCTIONS
C=======================================================================
              IF (NKPTS.GT.1) THEN
                REWIND NPUNIT
                WRITE (NPUNIT) ((CPTWFP(I,J),I=1,NRPLWV) , J=1,NBANDS)
              END IF
C=======================================================================
C  END OF K-POINT LOOP
C=======================================================================
 7190       CONTINUE
C======================================================================
C  RECALCULATE OCCUPATION NUMBERS AND CHARGE DENSITY
C======================================================================
            IF (NBANDS*2.GT.NELECT .AND. IOCCUP.EQ.1) THEN
              CALL EFERMI(NELECT,NBANDS,DEL,NKPTS,
     &                    NBANDS,NKPTS,WTKPT,OCC,EF,EIGVAL,SORT) 
C======================================================================
C     TAKE OUT THE SPIN-DEGENERACY, FOR IT IS CONSIDERED EXPLICITLY
C     IN THIS PROGRAM. BUT NOT IN EFERMI.
C======================================================================
              DO 4501 JKP = 1 , NKPTS
                DO 4501 JB = 1 , NBANDS
                  OCC(JB,JKP) = OCC(JB,JKP) / 2.0
 4501         CONTINUE
            END IF
C======================================================================
C     CALCULATE THE NEW CHARGE DENSITY ACCORDING TO THE NEW SET OF
C     OCCUPATION NUMBER 
C     (NO NEED TO UPDATE CELEN AND VNL, BECAUSE THEY ARE NOT RELATED TO 
C      CHARGE DENSITY, THEY ARE RELATED TO WAVE FUNCTIONS ONLY.)
C======================================================================
            DO 4601 M = 1 , NPLWV
              CHDENR(M) = (0.0,0.0)
              CHDENG(M) = (0.0,0.0)
 4601       CONTINUE
            DO 4603 NKP = 1 , NKPTS
              IF (NKPTS.GT.1) THEN 
                NPUNIT = 19 + NKP
                REWIND NPUNIT
                READ (NPUNIT) ( (CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
              END IF
              CALL CHSP(NBANOC,NPLWV,NRPLWV,MPLWV,
     &                  WTKPT(NKP),CPTWFP,CHDENG,CHDENR,NGPTAR,
     &                  NINDPW(1,NKP),NPLWKP(NKP),CWORK1,CWORK2,
     &                  OCC(1,NKP) )
 4603       CONTINUE
C=========================================================================
C NOW: CHDENR(r) CONTAINS THE NEW CHARGE DENSITY IN   R E A L  SPACE
C    -----  Change over for IOCCUP=1
C=========================================================================
          END IF
C=======================================================================
C  CALCULATE THE TOTAL KINETIC ENERGY
C=======================================================================
          ENKE = 0.0
          DO 7210 NK = 1 , NKPTS
            DO 7211 NB = 1 , NBANDS
              ENKE = ENKE + 2.0 * REAL ( CELEN(NB,NK) ) * WTKPT(NK)
     &                          * OCC(NB,NK)
 7211       CONTINUE
 7210     CONTINUE
C          IF ( (ISBROT.EQ.1 .OR. IOCCUP.EQ.1) .AND. 
C     &         NCGI.EQ.NIOCG1 ) THEN
          IF (ISBROT.EQ.1 .OR. IOCCUP.EQ.1) THEN
C=======================================================================
C  TRANSFORM CHARGE DENSITY TO RECIPROCAL SPACE AND CALCULATE HARTREE
C  AND EXCHANGE-CORRELATION ENERGY AND TIDY UP POTENTIALS
C=======================================================================
          DO 7224 M = 1 , MPLWV
            CWORK1(M) = (0.0,0.0)
            CWORK2(M) = (0.0,0.0)
 7224     CONTINUE
          DO 7221 M = 1 , NPLWV
            CWORK1(M) = CHDENR(M) * RINPLW
 7221     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,-1)
          DENC = 0.0
          DO 7223 M = 1 , NPLWV
            CHDENG(M) = CWORK1(M)
            CVD(M) = CWORK1(M) * DIRDAT(M)
            DENC = DENC + REAL ( CVD(M) * CONJG ( CWORK1(M) ) )
 7223     CONTINUE
          DENC = - DENC / 2.0
C
          DO 7230 M = 1 , NPLWV
            CWORK1(M) = CVD(M)
 7230     CONTINUE
          CALL FFT3D(CWORK1,CWORK,NGPTAR,1)
          DO 7235 M = 1 , NPLWV
            CVD(M) = CWORK1(M)
 7235     CONTINUE
          DO 7240 M = 1 , NPLWV
            CV(M) = CHDENR(M)
 7240     CONTINUE
          CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,XCFDAT,
     &              XCPDAT)
          DO 7242 M = 1 , NPLWV
            CV(M) = CV(M) + CVD(M) + CVION(M)
 7242     CONTINUE
          END IF
C=======================================================================
C CALCULATE NEW POTENTIAL ENERGY
C=======================================================================
          ENPOT = 0.0
          ENION = 0.0
          DO 5130 NPW = 1 , NPLWV
            ENION = ENION + REAL ( CVION(NPW) ) * REAL ( CHDENR(NPW) )
            ENPOT = ENPOT + REAL ( CV   (NPW) ) * REAL ( CHDENR(NPW) )
 5130     CONTINUE
          ENION = ENION * RINPLW
          ENPOT = ENPOT * RINPLW
C=======================================================================
C  NO NEED TO UPDATE VNL IF SUBROT WAS CALLED BEFORE
C=======================================================================
          IF (IVPTYP.EQ.0 .OR. ISBROT.EQ.1 .OR. IOCCUP.EQ.1) 
     &        GO TO 9303
C=======================================================================
C K-POINT LOOP STARTS
C=======================================================================
          DO 9300 NKP = 1 , NKPTS
C=======================================================================
C     READ WAVEFUNCTION FROM EXTERNAL MEMORY
C=======================================================================
            IF (NKPTS.GT.1) THEN
              NPUNIT = 19 + NKP
              REWIND NPUNIT
              READ (NPUNIT) ((CPTWFP(I,J), I=1,NRPLWV), J=1,NBANDS)
            END IF
C=======================================================================
C  WE DO NOT STORE CPHSGR AND VGNL,SO WE HAVE TO RE-CALCULATE THEM EVERY
C  TIME.
C=======================================================================
            IF (NLPOT.EQ.0) THEN
              CALL PHASGR(NRPLWV,NSPEC,NIONSP,NIONS,NPLWKP(NKP),
     &                  DNLG(1,1,NKP),POSION,DIRC, CPHSGR,IVPTYN)
              IF (NKPTS.NE.1) 
     &          CALL SETVG(NRPLWV,NSPEC,NPSPTS,NIONSP,NPLWKP(NKP),
     &                 DNLKG(1,0,NKP),PSPNL,PSCALE, PSGMAX, VGNL,
     &                 DVGNL,NPSPTN,IVPTYN)
            ELSE IF (NKPTS.NE.1) THEN
              CALL SERLPH(NIONST,NIONS,NRGRPT,NSPEC,DIRC,RECC,
     &                    POSION,NRLPPI,NIONSP,RLCORE,CPHGRD,
     &                    VKPT(1,NKP),NGX,NGY,NGZ)
            END IF
            DO 9301 NB = 1 , NBANDS
              IF (NLPOT.EQ.0) THEN
                CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP(NKP),
     &           DNLKG(1,0,NKP),VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,
     &           CWRK22,CWRK23,CPHSGR,VGNL,CELFRC,CWOR10,CWOR11,NB,
     &           IVPTYN)
                VNL(NB,NKP) = 0.0
                DO 9302 M = 1 , NPLWKP(NKP)
                  VNL(NB,NKP) = VNL(NB,NKP) +
     &                        REAL ( CONJG (CPTWFP(M,NB)) * CELFRC(M) )
 9302           CONTINUE
              ELSE
                DO 5349 M = 1 , MPLWV                          
                  CWORK1(M) = (0.0,0.0)                        
                  CWORK2(M) = (0.0,0.0)                        
 5349           CONTINUE                                       
                DO 225 M=1,NPLWKP(NKP)                         
                  CWORK1(NINDPW(M,NKP))=CPTWFP(M,NB)              
 225            CONTINUE                                       
                CALL FFT3D(CWORK1,CWORK2,NGPTAR,1)             
                CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NB,NKP,MPLWV,
     &                      NRPLWV,NRGRPT,NIONSP,NRLPPI,NBANDS,
     &                      NKPTS,NSPEC,CWORK2,CWORK1,CPHGRD,  
     &                      NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,  
     &                      VRLGRD,NADGRD,MXRLSH,CESAVE)       
              END IF      
 9301       CONTINUE
 9300     CONTINUE
C
 9303     CONTINUE
C
          ENVNL = 0.0
          DO 9310 NK = 1 , NKPTS
            DO 9320 NB = 1 , NBANDS
              ENVNL = ENVNL + 2.0 * WTKPT(NK) * VNL(NB,NK) 
     &                                        * OCC(NB,NK)
 9320       CONTINUE
 9310     CONTINUE
C
C=======================================================================
C CALCULATE NEW EWALD ENERGY
C=======================================================================
          CALL EWALTR(POSIC,EWIFC,EWRLEN,EWRCSS,EWRLSS,EWRCSI,DIRC,RECC,
     &        VOLC,SIGEW,TEWEN,NIONST,ICHARC,NIONCH,NICHSQ,CPHFX,CPHFY,
     &        CPHFZ,IPRINT,NIONST,NEWPTS,MAXCX,MAXCY,MAXCZ,MAXGPX,
     &        MAXGPY,MAXGPZ,NGPTS,RFORCE,CFORCE,FORCEG,FORSIG,ENERG)
C=======================================================================
C  CALCULATE TOTAL ENERGY
C=======================================================================
          TOTEN = ENPOT + DENC + XCENC + TEWEN + ENKE + ENVNL + PSCENC
C=======================================================================
C   END OF IONIC CONJUGATE GRADIENTS STEP
C=======================================================================
          WRITE (*,*)'At end of CG loop'
          WRITE (*,2600) 'TOTAL KINETIC ENERGY        ',  ENKE
          WRITE (*,2600) 'LOCAL POTENTIAL ENERGY      ',  ENPOT
          IF (IVPTYP.NE.0)
     &    WRITE (*,2600) 'NONLOCAL POTENTIAL  ENERGY  ',  ENVNL
          WRITE (*,2600) 'HARTREE ENERGY CORRECTION   ',  DENC
          WRITE (*,2600) 'EX-CORR ENERGY CORRECTION   ',  XCENC
          WRITE (*,2600) 'EWALD ENERGY                ',  TEWEN
          WRITE (*,2600) 'TOTAL ENERGY IS             ',  TOTEN
C========================================================================
C  END OF CONJUGATE GRADIENTS STEP
C========================================================================
 3000   CONTINUE
        PODISP = MIN (ABS(PODISP), PODISI)
        PODISP = MAX (PODISP,1.0E-3)
        RCONV = ABS ( (TOTEN - TOTEN0) / NIONS )
        IF (RCONV .LE. 1.E-5) NIOCG1 = MIN (NIOCG0 , 2) 
        IF (RCONV .LE. 1.E-6) NIOCG1 = 1 
C=======================================================================
C  RECALCULATED OCCUPATION NUMBERS AND CHARGE DENSITY
C=======================================================================
 8000   CONTINUE
C========================================================================
C
C             MORE SELF EXPLANATORY WRITE STATEMENTS
C      
C========================================================================
C PRINT OUT NEW UNIT CELL AND NEW IONIC POSITIONS
C========================================================================
        IF (N.LT.NITER .AND. NPRINT*(N/NPRINT).NE.N) GOTO 8020
        IF (IBOX.NE.0) WRITE (*,101) ((DIRC(I,J), I=1,3), J=1,3)
C
        WRITE (*,2900) 
        WRITE (*,8005) 'a1', 'a2', 'a3', 'Fx','Fy', 'Fz'
        WRITE (*,2900) 
        DO 8010 NSP = 1 , NSPEC
          DO 8010 NI = 1 , NIONSP(NSP)
            WRITE (*,8015) NSP, NI, (POSION(M,NI,NSP), M=1,3),
     &                       (TIFOR(M,NI,NSP), M=1,3)
 8010   CONTINUE
        WRITE (*,2900) 
 8020   CONTINUE
        IF (NEXTWR*(N/NEXTWR).EQ.N .OR. N.EQ.NITER) THEN
          REWIND 13
          WRITE (13) ((DIRC(I,J), I=1,3), J=1,3)
          WRITE (13) VOLC
          WRITE (13) ((RECC(I,J), I=1,3), J=1,3)
          WRITE (13) ((DIRI(I,J), I=1,3), J=1,3)
          WRITE (13) (((POSIOL(I,J,K), I=1,3), J=1,NIONS), K=1,NSPEC)
          WRITE (13) (((POSION(I,J,K), I=1,3), J=1,NIONS), K=1,NSPEC)
          WRITE (13) (RMOVE(J),J=1,NIONS*NSPEC)
          WRITE (13) ((CELEN(I,J), I=1,NBANDS), J=1,NKPTS)
          WRITE (13) ((VKPT(I,J), I=1,3), J=1,NKPTS)
          WRITE (13) (WTKPT(I),I=1,NKPTS)
          WRITE (13) ENMAX
          WRITE (13) NGX,NGY,NGZ,NRPLWV
          WRITE (13) ((RECI(I,J), I=1,3), J=1,3)
          REWIND 16
          WRITE (16) (CHDENR(I),I=1,NPLWV),(CHDENG(I),I=1,NPLWV)
          IF (NKPTS.EQ.1) THEN
            NPUNIT = 19 + NKPTS
            REWIND NPUNIT
            WRITE (NPUNIT) ((CPTWFP(I,J),I=1,NRPLWV), J=1,NBANDS)
          END IF
C========================================================================
C WRITE OUT THE OCCUPANCIES FOR EACH BAND AND K-POINT
C========================================================================
          REWIND 17
          DO 1080 NKP = 1 , NKPTS
            DO 1070 NBD = 1 , NBANDS
              WRITE (17,*) NKP,NBD,OCC(NBD,NKP)
1070        CONTINUE
1080      CONTINUE
        END IF
C========================================================================
C
C THIS IS THE END OF THE LOOP FOR ONE TIMESTEP OF THE ELECTRON DYNAMICS
C
C========================================================================
 1001 CONTINUE
      IF (N.LT.NITER) GOTO 1000
      IF (ICLOCK.EQ.1) CALL PCLOCK(0)
C========================================================================
C AT THE END OF THE REQUIRED NUMBER OF TIMESTEPS WRITE THE WAVEFUNCTIONS
C THE POSITIONS OF THE IONS, THE SIZE OF THE UNIT CELL, THE KINETIC
C ENERGY OF THE IONS, THE ELECTRONIC EIGENVALUES, THE COORDINATES OF THE
C SPECIAL K POINTS AND THEIR WEIGHTS AND THE STRING OF RANDOM NUMBERS
C TO EXTERNAL FILES.
C========================================================================
 109  FORMAT(1X,'TIME IS ', F12.6,' PICOSECOND')
 8005 FORMAT(1X,'NSP',' ATOM ',4X,6(A2,9X))
 8015 FORMAT(1X,I2,I4,1X,6F11.6)
 8815 FORMAT(1X,I2,I4,1X,3F11.6)
1090  FORMAT(1X,I3,I3,F8.4)
C========================================================================
C  FILE 18 IS USED FOR BAND STRUCTURE CALCULATIONS
C========================================================================
C      IF (IBANS.NE.1) THEN
C        NINDX = 1
C        DO 9106 NSP = 1 , NSPEC
C          DO 9107 NI = 1 , NIONSP(NSP)
C            DO 9108 M = 1 , 3
C              POSIC(M,NINDX) = POSION(M,NI,NSP)
C 9108       CONTINUE
C            NINDX = NINDX + 1
C 9107     CONTINUE
C 9106   CONTINUE
C        REWIND 18
C        WRITE (18) (CHDENR(I),I=1,NPLWV)
C        WRITE (18) (CV(I),I=1,NPLWV)
C        WRITE (18) NIONST
C        WRITE (18) NGX,NGY,NGZ
C        WRITE (18) A1,A2,A3,B1,B2,B3
C        WRITE (18) ((POSIC(I,J),I=1,3),J=1,NIONST)
C      END IF
C
C
C
C           BREATHE A SIGH OF RELIEF - YOU HAVE FINISHED
C
C
C
C
      STOP
      END

      SUBROUTINE SCOPY(N,X,INCX,Y,INCY)
      INTEGER N, INCX, INCY
      DOUBLE PRECISION X(*), Y(*)
      INTEGER I, IX, IY
      IX = 1
      IY = 1
      DO 100 I=1,N
         Y(IY) = X(IX)
         IX = IX + INCX
         IY = IY + INCY
 100  CONTINUE
      RETURN
      END

      SUBROUTINE FCC(NC)

C*********************************************************************
C**   ROUTINE TO CREATE AN FCC CONFIGUATION 
C*********************************************************************

      IMPLICIT CHARACTER ( A - Z )

      INTEGER     NMAX

      PARAMETER ( NMAX = 60000 )

      COMMON/ATOMS/NATM
      COMMON/COORS/RX,RY,RZ
      COMMON/VELOC/VX,VY,VZ

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        VX(NMAX), VY(NMAX), VZ(NMAX)

      INTEGER     IS,NC
      INTEGER     NATM
      INTEGER     LX,LY,LZ

      NATM = 0
C**   SEED FOR RANDOM NUMBER GENERATOR

      IS = 2215

C**   TRIPLE LOOP TO CREATE LATTICE

      DO 40 LZ=0,NC-1
        DO 50 LY=0,NC-1
          DO 60 LX=0,NC-1

C**   COORDINATES S.T. THEY WITHIN SIMULATION BOX
C**   RANDOM VELICITIES

            NATM = NATM+1
            RX(NATM) = REAL(LX)/REAL(NC)+1.0E-6-0.5
            RY(NATM) = REAL(LY)/REAL(NC)+1.0E-6-0.5
            RZ(NATM) = REAL(LZ)/REAL(NC)+1.0E-6-0.5

            CALL SRAND(IS,VX(NATM))
            CALL SRAND(IS,VY(NATM))
            CALL SRAND(IS,VZ(NATM))

            NATM = NATM+1
            RX(NATM) = (REAL(LX)+0.5)/REAL(NC)-1.0E-6-0.5
            RY(NATM) = REAL(LY)/REAL(NC)+1.0E-6-0.5
            RZ(NATM) = (REAL(LZ)+0.5)/REAL(NC)-1.0E-6-0.5
            VX(NATM) = 0.0-VX(NATM-1)
            VY(NATM) = 0.0-VY(NATM-1)
            VZ(NATM) = 0.0-VZ(NATM-1)

            NATM = NATM+1
            RX(NATM) = (REAL(LX)+0.5)/REAL(NC)-1.0E-6-0.5
            RY(NATM) = (REAL(LY)+0.5)/REAL(NC)-1.0E-6-0.5
            RZ(NATM) = REAL(LZ)/REAL(NC)+1.0E-6-0.5
            CALL SRAND(IS,VX(NATM))
            CALL SRAND(IS,VY(NATM))
            CALL SRAND(IS,VZ(NATM))

            NATM = NATM+1
            RX(NATM) = REAL(LX)/REAL(NC)+1.0E-6-0.5
            RY(NATM) = (REAL(LY)+0.5)/REAL(NC)-1.0E-6-0.5
            RZ(NATM) = (REAL(LZ)+0.5)/REAL(NC)-1.0E-6-0.5
            VX(NATM) = 0.0-VX(NATM-1)
            VY(NATM) = 0.0-VY(NATM-1)
            VZ(NATM) = 0.0-VZ(NATM-1)

 60         CONTINUE
 50       CONTINUE
 40     CONTINUE

      RETURN
      END

      SUBROUTINE REACT1(ESCF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /GEOM  / GEO(3,NUMATM)
      DIMENSION GEOA(3,NUMATM), GEOVEC(3,NUMATM),
     1          P1STOR(MPACK), P2STOR(MPACK),
     2          P3STOR(MPACK), XOLD(MAXPAR), GROLD(MAXPAR)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM), NB(NUMATM), NC(NUMATM)
      COMMON /DENSTY/ P(MPACK),PA(MPACK),PB(MPACK)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, XPARAM(MAXPAR)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /ISTOPE/ AMS(107)
      COMMON /GRAVEC/ COSINE
      COMMON /KEYWRD/ KEYWRD
     1       /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     2                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     3                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /REACTN/ STEP, GEOA, GEOVEC,CALCST
      LOGICAL GRADNT, FINISH, XYZ, INT, GOK(2)
************************************************************************
*
*  REACT1 DETERMINES THE TRANSITION STATE OF A CHEMICAL REACTION.
*
*   REACT WORKS BY USING TWO SYSTEMS SIMULTANEOUSLY, THE HEATS OF
*   FORMATION OF BOTH ARE CALCULATED, THEN THE MORE STABLE ONE
*   IS MOVED IN THE DIRECTION OF THE OTHER. AFTER A STEP THE
*   ENERGIES ARE COMPARED, AND THE NOW LOWER-ENERGY FORM IS MOVED
*   IN THE DIRECTION OF THE HIGHER-ENERGY FORM. THIS IS REPEATED
*   UNTIL THE SADDLE POINT IS REACHED.
*
*   IF ONE FORM IS MOVED 3 TIMES IN SUCCESSION, THEN THE HIGHER ENERGY
*   FORM IS RE-OPTIMIZED WITHOUT SHORTENING THE DISTANCE BETWEEN THE TWO
*   FORMS. THIS REDUCES THE CHANCE OF BEING CAUGHT ON THE SIDE OF A
*   TRANSITION STATE.
*
************************************************************************
      DIMENSION IDUM1(NUMATM), IDUM2(NUMATM), XSTORE(MAXPAR), 
     +IDUM3(NUMATM), COORD(3,NUMATM), IROT(2,3)
      DIMENSION IDUMMY(3*NUMATM)
      CHARACTER*80 KEYWRD
      EQUIVALENCE (IDUMMY,COORD)
      DATA IROT/1,2,1,3,2,3/
      GOLD=0.D0
      LINEAR=0
      GOK(1)=.FALSE.
      GOK(2)=.FALSE.
      XYZ=(INDEX(KEYWRD,' XYZ') .NE. 0)
      GRADNT=(INDEX(KEYWRD,'GRAD') .NE. 0)
      I=(INDEX(KEYWRD,' BAR'))
      STEPMX=0.15D0
      IF(I.NE.0) STEPMX=READA(KEYWRD,I)
      MAXSTP=1000
C
C    READ IN THE SECOND GEOMETRY.
C
      IF(XYZ) THEN
         CALL GETGEO(5,LABELS,GEOA,LOC,NA,NB,NC,AMS,NATOMS,INT)
      ELSE
         CALL GETGEO(5,IDUM1,GEOA,IDUMMY,
     1         IDUM1,IDUM2,IDUM3,AMS,NATOMS,INT)
C
C  IF INTERNAL COORDINATES ARE TO BE USED, CHECK THE CONNECTIVITY
C
      L=0
      DO 8 I=1,NATOMS
      IF(IDUM1(I).NE.NA(I))THEN
      L=L+1
      IF(L.EQ.1)WRITE(6,'(10X,''ERRORS DETECTED IN CONNECTIVITY'')')
      WRITE(6,'(A,I3,A,I3,A,I3,A)')' FOR ATOM',I,' THE BOND LABELS ARE D
     +IFFERENT:      ',IDUM1(I),' AND',NA(I)
      ENDIF
      IF(IDUM2(I).NE.NB(I))THEN
      L=L+1
      IF(L.EQ.1)WRITE(6,'(10X,''ERRORS DETECTED IN CONNECTIVITY'')')
      WRITE(6,'(A,I3,A,I3,A,I3,A)')' FOR ATOM',I,' THE BOND ANGLE LABELS
     + ARE DIFFERENT:',IDUM2(I),' AND',NB(I)
      ENDIF
      IF(IDUM3(I).NE.NC(I))THEN
      L=L+1
      IF(L.EQ.1)WRITE(6,'(10X,''ERRORS DETECTED IN CONNECTIVITY'')')
      WRITE(6,'(A,I3,A,I3,A,I3,A)')' FOR ATOM',I,' THE DIHEDRAL LABELS A
     +RE DIFFERENT:  ',IDUM3(I),' AND',NC(I)
      ENDIF
  8   CONTINUE
      IF(L.NE.0)WRITE(6,'(10X,A)')' CORRECT BEFORE RESUBMISSION'
c-old      IF(L.NE.0)STOP
      IF(L.NE.0) CALL WRAPUP()
      ENDIF
      CLOSE (5)
      TIME0= ZECOND()
C
C  SWAP FIRST AND SECOND GEOMETRIES AROUND
C  SO THAT GEOUT CAN OUTPUT DATA ON SECOND GEOMETRY.
C
      NUMAT2=0
      DO 10 I=1,NATOMS
         IF(LABELS(I).NE.99) NUMAT2=NUMAT2+1
         CONST=1.D0
         DO 10 J=1,3
            X=GEOA(J,I)*CONST
            CONST=0.0174532925D0
            GEOA(J,I)=GEO(J,I)
            GEO(J,I)=X
   10 CONTINUE
      IF(NUMAT2.NE.NUMAT) THEN
         WRITE(6,'(//10X,'' NUMBER OF ATOMS IN SECOND SYSTEM IS '',
     1''INCORRECT'',/)')
         WRITE(6,'('' NUMBER OF ATOMS IN FIRST  SYSTEM ='',I4)')NUMAT
         WRITE(6,'('' NUMBER OF ATOMS IN SECOND SYSTEM ='',I4)')NUMAT2
         GOTO 270
      ENDIF
      WRITE(6,'(//10X,'' GEOMETRY OF SECOND SYSTEM'',/)')
      IF(NDEP.NE.0) CALL SYMTRY
      CALL GEOUT
C
C     CONVERT TO CARTESIAN, IF NECESSARY
C
      IF(   XYZ   )THEN
         CALL GMETRY(GEO,COORD)
         SUMX=0.D0
         SUMY=0.D0
         SUMZ=0.D0
         DO 20 J=1,NUMAT
            SUMX=SUMX+COORD(1,J)
            SUMY=SUMY+COORD(2,J)
   20    SUMZ=SUMZ+COORD(3,J)
         SUMX=SUMX/NUMAT
         SUMY=SUMY/NUMAT
         SUMZ=SUMZ/NUMAT
         DO 30 J=1,NUMAT
            GEO(1,J)=COORD(1,J)-SUMX
            GEO(2,J)=COORD(2,J)-SUMY
   30    GEO(3,J)=COORD(3,J)-SUMZ
         WRITE(6,'(//,''  CARTESIAN GEOMETRY OF FIRST SYSTEM'',//)')
         WRITE(6,'(3F14.5)')((GEO(J,I),J=1,3),I=1,NUMAT)
         SUMX=0.D0
         SUMY=0.D0
         SUMZ=0.D0
         DO 40 J=1,NUMAT
            SUMX=SUMX+GEOA(1,J)
            SUMY=SUMY+GEOA(2,J)
   40    SUMZ=SUMZ+GEOA(3,J)
         SUM=0.D0
         SUMX=SUMX/NUMAT
         SUMY=SUMY/NUMAT
         SUMZ=SUMZ/NUMAT
         DO 50 J=1,NUMAT
            GEOA(1,J)=GEOA(1,J)-SUMX
            GEOA(2,J)=GEOA(2,J)-SUMY
            GEOA(3,J)=GEOA(3,J)-SUMZ
            SUM=SUM+(GEO(1,J)-GEOA(1,J))**2
     1           +(GEO(2,J)-GEOA(2,J))**2
     2           +(GEO(3,J)-GEOA(3,J))**2
   50    CONTINUE
         DO 100 L=3,1,-1
C
C     DOCKING IS DONE IN STEPS OF 16, 4, AND 1 DEGREES AT A TIME.
C
            CA=COS(4.D0**(L-1)*0.01745329D0)
            SA=SQRT(ABS(1.D0-CA**2))
            DO 90 J=1,3
               IR=IROT(1,J)
               JR=IROT(2,J)
               DO 80 I=1,10
                  SUMM=0.D0
                  DO 60 K=1,NUMAT
                     X         = CA*GEOA(IR,K)+SA*GEOA(JR,K)
                     GEOA(JR,K)=-SA*GEOA(IR,K)+CA*GEOA(JR,K)
                     GEOA(IR,K)=X
                     SUMM=SUMM+(GEO(1,K)-GEOA(1,K))**2
     1                         +(GEO(2,K)-GEOA(2,K))**2
     2                         +(GEO(3,K)-GEOA(3,K))**2
   60             CONTINUE
                  IF(SUMM.GT.SUM) THEN
                     IF(I.GT.1)THEN
                        SA=-SA
                        DO 70 K=1,NUMAT
                           X         = CA*GEOA(IR,K)+SA*GEOA(JR,K)
                           GEOA(JR,K)=-SA*GEOA(IR,K)+CA*GEOA(JR,K)
                           GEOA(IR,K)=X
   70                   CONTINUE
                        GOTO 90
                     ENDIF
                     SA=-SA
                  ENDIF
   80          SUM=SUMM
   90       CONTINUE
  100    CONTINUE
         WRITE(6,'(//,''  CARTESIAN GEOMETRY OF SECOND SYSTEM'',//)')
         WRITE(6,'(3F14.5)')((GEOA(J,I),J=1,3),I=1,NUMAT)
         WRITE(6,'(//,''   "DISTANCE":'',F13.6)')SUM
         WRITE(6,'(//,''  REACTION COORDINATE VECTOR'',//)')
         WRITE(6,'(3F14.5)')((GEOA(J,I)-GEO(J,I),J=1,3),I=1,NUMAT)
         NA(1)=99
         J=0
         NVAR=0
         DO 120 I=1,NATOMS
            IF(LABELS(I).NE.99)THEN
               J=J+1
               DO 110 K=1,3
                  NVAR=NVAR+1
                  LOC(2,NVAR)=K
  110          LOC(1,NVAR)=J
               LABELS(J)=LABELS(I)
            ENDIF
  120    CONTINUE
         NATOMS=NUMAT
      ENDIF
C
C   XPARAM HOLDS THE VARIABLE PARAMETERS FOR GEOMETRY IN GEO
C   XOLD   HOLDS THE VARIABLE PARAMETERS FOR GEOMETRY IN GEOA
C
      IF(NVAR.EQ.0)THEN
         WRITE(6,'(///10X,''THERE ARE NO VARIABLES IN THE SADDLE'',
     1'' CALCULATION!'')')
         CALL WRAPUP()
      ENDIF
      SUM=0.D0
      DO 130 I=1,NVAR
         GROLD(I)=1.D0
         XPARAM(I)=GEO(LOC(2,I),LOC(1,I))
         XOLD(I)=GEOA(LOC(2,I),LOC(1,I))
  130 SUM=SUM+(XPARAM(I)-XOLD(I))**2
      STEP0=SQRT(SUM)
      ONE=1.D0
      DELL=0.1D0
      EOLD=-2000.D0
      TIME1=ZECOND()
      SWAP=0
      DO 230 ILOOP=1,MAXSTP
         TIME2=ZECOND()
         WRITE(6,'('' TIME='',F9.2)')TIME2-TIME1
         TIME1=TIME2
C
C   THIS METHOD OF CALCULATING 'STEP' IS QUITE ARBITARY, AND NEEDS
C   TO BE IMPROVED BY INTELLIGENT GUESSWORK!
C
         IF (GNORM.LT.1.D-3)GNORM=1.D-3
         WRITE(6,'('' CURRENT BAR, STEPMX, GNORM'',3F12.7)')
     1STEP0,STEPMX,GNORM
         STEP=MIN(SWAP,0.5D0, 6.D0/GNORM, DELL,STEPMX*STEP0+0.005D0)
         SWAP=SWAP+1.D0
         DELL=DELL+0.1
         STEP0=STEP0-STEP
         IF(STEP0.LT.0.01D0) GOTO 240
         STEP=STEP0
         DO 150 I=1,NVAR
  150    XSTORE(I)=XPARAM(I)
         CALL FLEPO(XPARAM, NVAR, ESCF)
         IF(LINEAR.EQ.0)THEN
         LINEAR=(NORBS*(NORBS+1))/2
         DO 140 I=1,LINEAR
         P1STOR(I)=P(I)
         P2STOR(I)=PA(I)
  140 P3STOR(I)=PB(I)
         ENDIF
         DO 160 I=1,NVAR
  160    XPARAM(I)=GEO(LOC(2,I),LOC(1,I))
         WRITE(6,'(//10X,''FOR POINT'',I3)')ILOOP
         WRITE(6,'('' DISTANCE A - B  '',F12.6)')STEP
C
C   NOW TO CALCULATE THE "CORRECT" GRADIENTS, SWITCH OFF 'STEP'.
C
         STEP=0.D0
         DO 170 I=1,NVAR
  170    GRAD(I)=GROLD(I)
         CALL COMPFG (XPARAM, .TRUE., FUNCT1,.FALSE.,GRAD,.TRUE.)
         DO 180 I=1,NVAR
  180    GROLD(I)=GRAD(I)
         IF (GRADNT) THEN
            WRITE(6,'(''  ACTUAL GRADIENTS OF THIS POINT'')')
            WRITE(6,'(8F10.4)')(GRAD(I),I=1,NVAR)
         ENDIF
         WRITE(6,'('' HEAT            '',F12.6)')FUNCT1
         GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
         WRITE(6,'('' GRADIENT NORM   '',F12.6)')GNORM
         COSINE=COSINE*ONE
         WRITE(6,'('' DIRECTION COSINE'',F12.6)')COSINE
         CALL GEOUT
         IF(SWAP.GT.2.9D0 .OR. ILOOP .GT. 3 .AND. COSINE .LT. 0.D0
     1  .OR. ESCF .GT. EOLD)
     2  THEN
            IF(SWAP.GT.2.9D0)THEN
               SWAP=0.D0
            ELSE
               SWAP=0.5D0
            ENDIF
C
C   SWAP REACTANT AND PRODUCT AROUND
C
            FINISH=(GOK(1).AND.GOK(2) .AND. COSINE .LT. 0.D0)
            IF(FINISH) THEN
               WRITE(6,'(//10X,'' BOTH SYSTEMS ARE ON THE SAME SIDE OF T
     1HE '',''TRANSITION STATE -'',/10X,'' GEOMETRIES OF THE SYSTEMS'',
     2'' ON EACH SIDE OF THE T.S. ARE AS FOLLOWS'')')
               DO 190 I=1,NVAR
  190          XPARAM(I)=XSTORE(I)
               CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
               WRITE(6,'(//10X,'' GEOMETRY ON ONE SIDE OF THE TRANSITION
     1'','' STATE'')')
               CALL VWRITE(TIME0,FUNCT1)
            ENDIF
            WRITE(6,'(''  REACTANTS AND PRODUCTS SWAPPED AROUND'')')
            ONE=-1.D0
            EOLD=ESCF
            SUM=GOLD
            GOLD=GNORM
            I=1.7+ONE*0.5
            IF(GNORM.GT.10.D0)GOK(I)=.TRUE.
            GNORM=SUM
            DO 200 I=1,NUMAT
               DO 200 J=1,3
                  X=GEO(J,I)
                  GEO(J,I)=GEOA(J,I)
  200       GEOA(J,I)=X
            DO 210 I=1,NVAR
               X=XOLD(I)
               XOLD(I)=XPARAM(I)
  210       XPARAM(I)=X
C
C
C    SWAP AROUND THE DENSITY MATRICES.
C
            DO 220 I=1,LINEAR
               X=P1STOR(I)
               P1STOR(I)=P(I)
               P(I)=X
               X=P2STOR(I)
               P2STOR(I)=PA(I)
               PA(I)=X
               X=P3STOR(I)
               P3STOR(I)=PB(I)
               PB(I)=X
  220       CONTINUE
            IF(FINISH) GOTO 240
         ELSE
            ONE=1.D0
         ENDIF
  230 CONTINUE
  240 CONTINUE
      WRITE(6,'('' AT END OF REACTION'')')
      GOLD=SQRT(DOT(GRAD,GRAD,NVAR))
      CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
      GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
      DO 250 I=1,NVAR
  250 GROLD(I)=XPARAM(I)
      CALL VWRITE(TIME0,FUNCT1)
*
* THE GEOMETRIES HAVE (A) BEEN OPTIMIZED CORRECTLY, OR
*                     (B) BOTH ENDED UP ON THE SAME SIDE OF THE T.S.
*
*  TRANSITION STATE LIES BETWEEN THE TWO GEOMETRIES
*
      C1=GOLD/(GOLD+GNORM)
      C2=1.D0-C1
      WRITE(6,'('' BEST ESTIMATE GEOMETRY OF THE TRANSITION STATE'')')
      WRITE(6,'(//10X,'' C1='',F8.3,''C2='',F8.3)')C1,C2
      DO 260 I=1,NVAR
  260 XPARAM(I)=C1*GROLD(I)+C2*XOLD(I)
      STEP=0.D0
      CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
      CALL VWRITE(TIME0,FUNCT1)
  270 CALL WRAPUP()
      END

      SUBROUTINE FMAT(FMATRX, NREAL, TSCF, TDER, DELDIP, HEAT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION FMATRX(*), DELDIP(3,*)
***********************************************************************
*
*  VALUE CALCULATES THE SECOND-ORDER OF THE ENERGY WITH
*        RESPECT TO THE CARTESIAN COORDINATES I AND J AND PLACES IT
*        IN FMATRX
*
*  ON INPUT NATOMS  = NUMBER OF ATOMS IN THE SYSTEM.
*           XPARAM  = INTERNAL COORDINATES OF MOLECULE STORED LINEARLY
*
*  VARIABLES USED
*           COORDL  = ARRAY OF CARTESIAN COORDINATES, STORED LINEARLY.
*           I       = INDEX OF CARTESIAN COORDINATE.
*           J       = INDEX OF CARTESIAN COORDINATE.
*
*  ON OUTPUT FMATRX = SECOND DERIVATIVE OF THE ENERGY WITH RESPECT TO
*                    CARTESIAN COORDINATES I AND J.
***********************************************************************
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR),IDUMY, DUMY(MAXPAR)
      COMMON /DENSTY/ P(MPACK),PDUMY(2,MPACK)
      COMMON /ATMASS/ ATMASS(NUMATM)
      COMMON /TIMEMP/ TIME0
      COMMON /CORE  / CORE(107)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /COORD / COORD(3,NUMATM)
      COMMON /SCRACH/ EVECS(MAXPAR*MAXPAR)
      DIMENSION COLD(MAXPAR), GRAD(MAXPAR),
     1GROLD(MAXPAR), COORDL(MAXPAR), Q(NUMATM), DEL2(3), G2OLD(MAXPAR)
     2, EIGS(MAXPAR), G2RAD(MAXPAR),
     3 FCONST(MAXPAR)
      CHARACTER*80 KEYWRD
      LOGICAL DEBUG, DERIV, RESTRT, PRNT, RESFIL, ANALYT, PRECIS
      CHARACTER SPACE*1, DOTT*1, ZERO*1, NINE*1, CH*1
      EQUIVALENCE (COORD(1,1),COORDL(1))
      DATA SPACE,DOTT,ZERO,NINE /' ','.','0','9'/
      DATA FACT/6.95125D-3/
C
C    FACT IS THE CONVERSION FACTOR FROM KCAL/MOLE TO ERGS
C
C SET UP CONSTANTS AND FLAGS
      NA(1)=99
C
C  SET UP THE VARIABLES IN XPARAM ANDLOC,THESE ARE IN CARTESIAN COORDINA
C
      NUMAT=0
      DO 10 I=1,NATOMS
         IF(LABELS(I).NE.99.AND.LABELS(I).NE.107) THEN
            NUMAT=NUMAT+1
            LABELS(NUMAT)=LABELS(I)
         ENDIF
   10 CONTINUE
      NATOMS=NUMAT
C
C   THIS IS A QUICK, IF CLUMSY, WAY TO CALCULATE NUMAT, AND TO REMOVE TH
C   DUMMY ATOMS FROM THE ARRAY LABELS.
C
      NVAR=0
      DO 20 I=1,NUMAT
         DO 20 J=1,3
            NVAR=NVAR+1
            LOC(1,NVAR)=I
            LOC(2,NVAR)=J
   20 CONTINUE
      LIN=(NVAR*(NVAR+1))/2
      DO 30 I=1,LIN
   30 FMATRX(I)=0.D0
      PRNT   =(INDEX(KEYWRD,'IRC=') .EQ. 0)
      PRECIS =(INDEX(KEYWRD,'PRECIS') .NE. 0)
      ANALYT =(INDEX(KEYWRD,'ANALYT') .NE. 0)
      RESTRT =(INDEX(KEYWRD,'RESTART') .NE. 0)
      IF(INDEX(KEYWRD,'NLLSQ') .NE. 0) RESTRT=.FALSE.
      DEBUG =(INDEX(KEYWRD,'FMAT') .NE. 0)
      DERIV=(NCLOSE .EQ. NOPEN .AND. INDEX(KEYWRD,'C.I.') .EQ. 0)
      IF(PRNT)WRITE(6,'(//4X,''FIRST DERIVATIVES WILL BE USED IN THE''
     1,'' CALCULATION OF SECOND DERIVATIVES'')')
      TIME=MAXTIM
      I=INDEX(KEYWRD,' T=')
      IF(I.NE.0) THEN
         TIM=READA(KEYWRD,I)
         DO 40 J=I+3,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TIM=TIM*60
               IF( CH .EQ. 'H') TIM=TIM*3600
               IF( CH .EQ. 'D') TIM=TIM*86400
               GOTO 50
            ENDIF
   40    CONTINUE
   50    TIME=TIM
         IF(PRNT)WRITE(6,'(/10X,''TIME DEFINED FOR THIS STEP ='',F19.2,
     1    '' SECONDS'')')TIME
      ELSE
         IF(PRNT)WRITE(6,'(/10X,''DEFAULT TIME OF'',F8.2,
     1    '' SECONDS ALLOCATED FOR THIS STEP'')')TIME
      ENDIF
      TLEFT=TIME
      TLAST=TIME
      TDUMP=MAXDMP
      I=INDEX(KEYWRD,' DUMP')
      IF(I.NE.0) THEN
         TDUMP=READA(KEYWRD,I)
         DO 60 J=I+6,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TDUMP=TDUMP*60
               IF( CH .EQ. 'H') TDUMP=TDUMP*3600
               IF( CH .EQ. 'D') TDUMP=TDUMP*86400
               GOTO 70
            ENDIF
   60    CONTINUE
   70    CONTINUE
      ENDIF
      RESFIL=.FALSE.
      IF(RESTRT) THEN
         DO 80 I=1,NVAR
   80    COLD(I)=COORDL(I)
         ISTART = 0
         I=0
         CALL FORSAV(TOTIME,DELDIP,ISTART,I,FMATRX, COORD, NVAR,HEAT,
     1                EVECS,JSTART,FCONST)
         KOUNTF=(ISTART*(ISTART+1))/2
         ISTART=ISTART+1
         JSTART=JSTART+1
         TIME2 = ZECOND()
         IF(ISTART.GT.NVAR) GOTO 200
      ELSE
         TOTIME=0.D0
         IF (TSCF.GT.0.D0)TLEFT=TLEFT-TSCF-TDER
         ISTART=1
      ENDIF
C CALCULATE FMATRX
      IF(ISTART.GT.1) THEN
         ESTIME=(NVAR-ISTART+1)*TOTIME/(ISTART-1.D0)
      ELSE
         ESTIME=NVAR*(TSCF+TDER)*2.D0
         IF (PRECIS) ESTIME=ESTIME*2.D0
      ENDIF
      IF(TSCF.GT.0)
     1WRITE(6,'(/10X,''ESTIMATED TIME TO COMPLETE CALCULATION =''
     2,F9.2,'' SECONDS'')')ESTIME
      IF(RESTRT) THEN
         IF(ISTART.LE.NVAR)
     1    WRITE(6,'(/10X,''STARTING AGAIN AT LINE'',18X,I4)')ISTART
         WRITE(6,'(/10X,''TIME USED UP TO RESTART ='',F22.2)')TOTIME
      ENDIF
      LU=KOUNTF
      TIME1 = ZECOND()
      NUMAT=NVAR/3
      DO 160 I=ISTART,NVAR
         TIME2 = ZECOND()
         DELTA=1.D0/60.D0
         IF(PRECIS)THEN
C
C   DETERMINE A GOOD STEP SIZE
C
            G2OLD(1)=100.D0
            COORDL(I)=COORDL(I)+DELTA
            CALL COMPFG(COORDL, .TRUE., ESCF, .TRUE., G2OLD, .TRUE.)
            COORDL(I)=COORDL(I)-DELTA
            DELTA=DELTA*10.D0/SQRT(DOT(G2OLD,G2OLD,NVAR))
C#         WRITE(6,'(A,F12.5)')' DELTA :',DELTA
            G2OLD(1)=100.D0
            COORDL(I)=COORDL(I)+DELTA
            CALL COMPFG(COORDL, .TRUE., ESCF, .TRUE., G2OLD, .TRUE.)
C#         WRITE(6,*)' GNORM:',SQRT(DOT(G2OLD,G2OLD,NVAR))
            COORDL(I)=COORDL(I)-DELTA*2.D0
            G2RAD(1)=100.D0
            CALL COMPFG(COORDL, .TRUE., HEATAA, .TRUE., G2RAD, .TRUE.)
            COORDL(I)=COORDL(I)+DELTA
         ENDIF
         COORDL(I)=COORDL(I)+0.5D0*DELTA
         GROLD(1)=100.D0
         CALL COMPFG(COORDL, .TRUE., ESCF, .TRUE., GROLD, .TRUE.)
C#         WRITE(6,*)' GNORM:',SQRT(DOT(GROLD,GROLD,NVAR))
         CALL CHRGE(P,Q)
         DO 90 II=1,NUMAT
   90    Q(II)=CORE(LABELS(II))-Q(II)
         SUM = DIPOLE(P,Q,COORDL,DELDIP(1,I))
         COORDL(I)=COORDL(I)-DELTA
         GRAD(1)=100.D0
         CALL COMPFG(COORDL, .TRUE., HEATAA, .TRUE., GRAD, .TRUE.)
         COORDL(I)=COORDL(I)+DELTA*0.5D0
         CALL CHRGE(P,Q)
         DO 100 II=1,NUMAT
  100    Q(II)=CORE(LABELS(II))-Q(II)
         SUM = DIPOLE(P,Q,COORDL,DEL2)
         DO 110 II=1,3
  110    DELDIP(II,I)=(DELDIP(II,I)-DEL2(II))*0.5D0/DELTA
         LL=LU+1
         LU=LL+I-1
         L=0
         IF(PRECIS)THEN
            DO 120 KOUNTF=LL,LU
               L=L+1
               FMATRX(KOUNTF)=FMATRX(KOUNTF)+
     1         (8.D0*(GROLD(L)-GRAD(L))-(G2OLD(L)-G2RAD(L)))
     2          *0.25D0/DELTA*FACT/6.D0
  120       CONTINUE
            L=L-1
            DO 130 K=I,NVAR
               L=L+1
               KK=(K*(K-1))/2+I
               FMATRX(KK)=FMATRX(KK)+
     1         (8.D0*(GROLD(L)-GRAD(L))-(G2OLD(L)-G2RAD(L)))
     2          *0.25D0/DELTA*FACT/6.D0
  130       CONTINUE
         ELSE
            DO 140 KOUNTF=LL,LU
               L=L+1
               FMATRX(KOUNTF)=FMATRX(KOUNTF)+
     1         ((GROLD(L)-GRAD(L)))
     2          *0.25D0/DELTA*FACT
  140       CONTINUE
            L=L-1
            DO 150 K=I,NVAR
               L=L+1
               KK=(K*(K-1))/2+I
               FMATRX(KK)=FMATRX(KK)+
     1         ((GROLD(L)-GRAD(L)))
     2          *0.25D0/DELTA*FACT
  150       CONTINUE
         ENDIF
         TIME3 = ZECOND()
         TSTEP=TIME3-TIME2
         TOTIME= TOTIME+TSTEP
         TLEFT= TLEFT-TSTEP
         IF(RESFIL)THEN
            WRITE(6,
     +      '('' STEP:'',I4,'' RESTART FILE WRITTEN, INTEGRAL ='',
     +      F10.2,'' TIME LEFT:'',F10.2)')I,TOTIME,TLEFT
            RESFIL=.FALSE.
         ELSE
            WRITE(6,'('' STEP:'',I4,'' TIME ='',F9.2,'' SECS, INTEGRAL =
     1'',F10.2,'' TIME LEFT:'',F10.2)')I,TSTEP,TOTIME,TLEFT
         ENDIF
         IF(DERIV) THEN
            ESTIM = TOTIME/I
         ELSE
            ESTIM = TOTIME*2.D0/I
         ENDIF
         IF(TLAST-TLEFT.GT.TDUMP)THEN
            TLAST=TLEFT
            RESFIL=.TRUE.
            JSTART=1
            II=I
            CALL FORSAV(TOTIME,DELDIP,II,NVAR,FMATRX, COORD,NVAR,HEAT,
     1                EVECS,JSTART,FCONST)
         ENDIF
         IF(I.NE.NVAR.AND.TLEFT-10.D0 .LT. ESTIM) THEN
            WRITE(6,'(//10X,''- - - - - - - TIME UP - - - - - - -'',//)'
     1)
            WRITE(6,'(/10X,'' POINT REACHED ='',I4)')I
            WRITE(6,'(/10X,'' RESTART USING KEY-WORD "RESTART"'')')
            WRITE(6,'(10X,''ESTIMATED TIME FOR THE NEXT STEP ='',F8.2,
     1'' SECONDS'')')ESTIM
            JSTART=1
            II=I
            CALL FORSAV(TOTIME,DELDIP,II,NVAR,FMATRX, COORD,NVAR,HEAT,
     1                EVECS,JSTART,FCONST)
            WRITE(6,'(//10X,''FORCE MATRIX WRITTEN TO DISK'')')
            CALL WRAPUP()
         ENDIF
  160 CONTINUE
C#      CALL FORSAV(TOTIME,DELDIP,NVAR,NVAR,FMATRX, COORD,NVAR,HEAT,
C#     +                EVECS,JSTART,FCONST)
      IF(DERIV) GOTO 290
      WRITE(6,'(//10X,'' STARTING TO CALCULATE FORCE CONSTANTS'',/)')
      CALL FRAME(FMATRX,NUMAT,0,EIGS)
      CALL RSP(FMATRX,NVAR,NVAR,EIGS,EVECS)
      IF(DEBUG) THEN
         WRITE(6,'(''   EIGENVECTORS FROM FIRST CALCULATION'')')
         CALL MATOUT(EVECS,EIGS,NVAR,NVAR,NVAR)
      ENDIF
      L=0
      DO 180 I=1,NVAR
         DO 180 J=1,I
            L=L+1
            SUM=0.D0
            DO 170 K=1,NREAL
               K1=(K-1)*NVAR+I
               K2=(K-1)*NVAR+J
  170       SUM=SUM+EVECS(K1)*EIGS(K)*EVECS(K2)
  180 FMATRX(L)=SUM
      CALL FRAME(FMATRX,NUMAT,0,EIGS)
      CALL RSP(FMATRX,NVAR,NVAR,EIGS,EVECS)
C#      CALL MATOUT(EVECS,EIGS,NVAR,NVAR,NVAR)
      JSTART=1
      DO 190 I=1,NVAR
  190 COLD(I)=COORDL(I)
  200 IF(DERIV) GOTO 290
      L=(JSTART-1)*NVAR
      DO 250 ILOOP=JSTART,NVAR
C
C   MAKE THE STEP-SIZE ROUGHLY INVERSELY PROPORTIONAL TO THE EIGENVALUE
C
         IF(ILOOP.LE.NREAL)THEN
            DELTA=MAX(0.02D0,MIN(0.2D0,0.25D0/ABS(EIGS(ILOOP))))
         ELSEIF(ILOOP.LE.NREAL+3)THEN
            DELTA=0.2D0
         ELSE
            DELTA=0.1D0
         ENDIF
C#      WRITE(6,*)'DELTA:',DELTA
         J=L
         CALL COMPFG(COLD, .TRUE., HEAT, .TRUE., GRAD, .FALSE.)
         DO 210 I=1,NVAR
            J=J+1
  210    COORDL(I)=COLD(I)+EVECS(J)*DELTA
         CALL COMPFG(COORDL, .TRUE., HEATA, .TRUE., GRAD, .FALSE.)
         HEATA=HEATA-HEAT
         J=L
         DO 220 I=1,NVAR
            J=J+1
  220    COORDL(I)=COLD(I)-EVECS(J)*DELTA
         CALL COMPFG(COORDL, .TRUE., HEATB, .TRUE., GRAD, .FALSE.)
         HEATB=HEATB-HEAT
         J=L
         DO 230 I=1,NVAR
            J=J+1
  230    COORDL(I)=COLD(I)+EVECS(J)*DELTA*2
         CALL COMPFG(COORDL, .TRUE., HEATAA, .TRUE., GRAD, .FALSE.)
         HEATAA=HEATAA-HEAT
         J=L
         DO 240 I=1,NVAR
            J=J+1
  240    COORDL(I)=COLD(I)-EVECS(J)*DELTA*2
         CALL COMPFG(COORDL, .TRUE., HEATBB, .TRUE., GRAD, .FALSE.)
         HEATBB=HEATBB-HEAT
         SUM=( (HEATA+HEATB)*16 - (HEATAA+HEATBB) )/12.D0
     1/DELTA*FACT/DELTA*0.5D0
C#      WRITE(6,'(5F12.6)')HEATAA+HEAT,HEATA+HEAT,HEAT,HEATB+HEAT,
C#     +HEATBB+HEAT
C#      WRITE(6,'(5F12.6)')HEATAA,HEATA,0.D0,HEATB,HEATBB
         FCONST(ILOOP)=SUM*0.5D0
         L=L+NVAR
         TIME3 = ZECOND()
         TSTEP=TIME3-TIME2
         IF(TSTEP.GT.1.D5)THEN
            TSTEP=TSTEP-1000000.D0
            TIME3=TIME3-1000000.D0
            TLEFT=-1.D0
         ENDIF
         TIME2=TIME3
         TOTIME= TOTIME+TSTEP
         TLEFT= MAX(-1.D0,TLEFT-TSTEP)
         WRITE(6,'('' STEP:'',I4,'' TIME ='',F9.2,'' SECS, INTEGRAL ='',
     1F10.2,'' TIME LEFT:'',F10.2)')ILOOP,TSTEP,TOTIME,TLEFT
         ESTIM = TSTEP*5.D0
C
C    5.0 IS A SAFETY FACTOR
C
         IF(TLAST-TLEFT.GT.TDUMP)THEN
            TLAST=TLEFT
            RESFIL=.TRUE.
            IFOR=ILOOP
            IX=NVAR+2
*
* VALUE OF IX IS NOT IMPORTANT. SHOULD NOT BE 0 OR NVAR
*
            CALL FORSAV(TOTIME,DELDIP,IX,NVAR,FMATRX, COORD,NVAR,HEAT,
     1                EVECS,IFOR,FCONST)
         ENDIF
         IF(ILOOP.NE.NVAR.AND.TLEFT-10.D0 .LT. ESTIM) THEN
            WRITE(6,'(//10X,''- - - - -  TIME  LIMIT - - - - -'')')
            WRITE(6,'(/10X,'' POINT REACHED ='',I4)')ILOOP
            WRITE(6,'(/10X,'' RESTART USING KEY-WORD "RESTART"'')')
            WRITE(6,'(10X,''ESTIMATED TIME FOR THE NEXT STEP ='',F8.2,
     1'' SECONDS'')')ESTIM
            IFOR=ILOOP
            IX=NVAR+2
*
* VALUE OF IX IS NOT IMPORTANT. SHOULD NOT BE 0 OR NVAR
*
            CALL FORSAV(TOTIME,DELDIP,IX,NVAR,FMATRX, COORD,NVAR,HEAT,
     1                EVECS,IFOR,FCONST)
         ENDIF
  250 CONTINUE
      L=0
      DO 270 I=1,NVAR
         DO 270 J=1,I
            L=L+1
            SUM=0.D0
            DO 260 K=1,NVAR
               K1=(K-1)*NVAR+I
               K2=(K-1)*NVAR+J
  260       SUM=SUM+EVECS(K1)*FCONST(K)*EVECS(K2)
  270 FMATRX(L)=SUM*2.D0
      DO 280 I=1,NVAR
  280 COORDL(I)=COLD(I)
  290 CONTINUE
      DO 300 I=1,NUMAT
         IF(ATMASS(I).LT.1.D-20)THEN
            CALL FORSAV(TOTIME,DELDIP,NVAR,NVAR,FMATRX, COORD,NVAR,HEAT,
     1                EVECS,ILOOP,FCONST)
            WRITE(6,'(A)')' AT LEAST ONE ATOM HAS A ZERO MASS. A RESTART
     1'
            WRITE(6,'(A)')' FILE HAS BEEN WRITTEN AND THE JOB STOPPED'
            CALL WRAPUP()
         ENDIF
  300 CONTINUE
      IF(ISTART.LE.NVAR .AND. INDEX(KEYWRD,'ISOTOPE') .NE. 0)
     1CALL FORSAV(TOTIME,DELDIP,NVAR,NVAR,FMATRX, COORD,NVAR,HEAT,
     2                EVECS,ILOOP,FCONST)
      RETURN
      END

      LOGICAL FUNCTION WORD(KEYWRD,TESTWD)
      CHARACTER KEYWRD*80, TESTWD*(*)
      WORD=.FALSE.
   10 J=INDEX(KEYWRD,TESTWD)
      IF(J.NE.0)THEN
   20    IF(KEYWRD(J:J).NE.' ')GOTO 30
         J=J+1
         GOTO 20
   30    WORD=.TRUE.
         DO 60 K=J,80
            IF(KEYWRD(K:K).EQ.'='.OR.KEYWRD(K:K).EQ.' ') THEN
C
C     CHECK FOR ATTACHED '=' SIGN
C
               J=K
               IF(KEYWRD(J:J).EQ.'=')GOTO 50
C
C     CHECK FOR SEPARATED '=' SIGN
C
               DO 40 J=K+1,80
                  IF(KEYWRD(J:J).EQ.'=') GOTO 50
   40          IF(KEYWRD(J:J).NE.' ')GOTO 10
C
C    THERE IS NO '=' SIGN ASSOCIATED WITH THIS KEYWORD
C
               GOTO 10
   50          KEYWRD(J:J)=' '
C
C   THERE MUST BE A NUMBER AFTER THE '=' SIGN, SOMEWHERE
C
               GOTO 20
            ENDIF
   60    KEYWRD(K:K)=' '
      ENDIF
      RETURN
      END

      SUBROUTINE HCORE (COORD,H,W, WJ,WK,ENUCLR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL FLDON
      INCLUDE 'mopac.inc'
      DIMENSION COORD(3,*),H(*), WJ(N2ELEC), WK(N2ELEC), W(N2ELEC)
      REAL WJ, WK
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
     3       /MOLORB/ USPD(MAXORB),DUMY(MAXORB)
     4       /KEYWRD/ KEYWRD
      COMMON /EULER / TVEC(3,3), ID
      COMMON /MULTIP/ DD(107),QQ(107),AM(107),AD(107),AQ(107)
      COMMON /CORE  / CORE(107)
      COMMON /FIELD / EFIELD(3)
************************************************************************
C
C   HCORE GENERATES THE ONE-ELECTRON MATRIX AND TWO ELECTRON INTEGRALS
C         FOR A GIVEN MOLECULE WHOSE GEOMETRY IS DEFINED IN CARTESIAN
C         COORDINATES.
C
C  ON INPUT  COORD   = COORDINATES OF THE MOLECULE.
C
C  ON OUTPUT  H      = ONE-ELECTRON MATRIX.
C             W      = TWO-ELECTRON INTEGRALS.
C             ENUCLR = NUCLEAR ENERGY
************************************************************************
      CHARACTER*80 KEYWRD
      LOGICAL FIRST,DEBUG
      DIMENSION E1B(10),E2A(10),DI(9,9), WJD(100), WKD(100)
      DATA FIRST/.TRUE./
      IF (FIRST) THEN
         IONE=1
         CUTOFF=1.D10
         IF(ID.NE.0)CUTOFF=60.D0
         IF(ID.NE.0)IONE=0
         FIRST=.FALSE.
         DEBUG=(INDEX(KEYWRD,'HCORE') .NE. 0)
      ENDIF
      FLDON = .FALSE.
      IF ((EFIELD(1).NE.0.0D00).OR.(EFIELD(2).NE.0.0D00).OR.
     1    (EFIELD(3).NE.0.0D00)) THEN
         FLDCON = 51.4257D00
         FLDON = .TRUE.
      ENDIF
      DO 10 I=1,(NORBS*(NORBS+1))/2
   10 H(I)=0
      ENUCLR=0.D0
      KR=1
      DO 110 I=1,NUMAT
         IA=NFIRST(I)
         IB=NLAST(I)
         IC=NMIDLE(I)
         NI=NAT(I)
C
C FIRST WE FILL THE DIAGONALS, AND OFF-DIAGONALS ON THE SAME ATOM
C
         DO 30 I1=IA,IB
            I2=I1*(I1-1)/2+IA-1
            DO 20 J1=IA,I1
               I2=I2+1
               H(I2)=0.D0
               IF (FLDON) THEN
                  IO1 = I1 - IA
                  JO1 = J1 - IA
                  IF ((JO1.EQ.0).AND.(IO1.EQ.1)) THEN
                     HTERME = -0.529177D00*DD(NI)*EFIELD(1)*FLDCON
                     H(I2) = HTERME
                  ENDIF
                  IF ((JO1.EQ.0).AND.(IO1.EQ.2)) THEN
                     HTERME = -0.529177D00*DD(NI)*EFIELD(2)*FLDCON
                     H(I2) = HTERME
                  ENDIF
                  IF ((JO1.EQ.0).AND.(IO1.EQ.3)) THEN
                     HTERME = -0.529177D00*DD(NI)*EFIELD(3)*FLDCON
                     H(I2) = HTERME
                  ENDIF
               ENDIF
   20       CONTINUE
            H(I2) = USPD(I1)
            IF (FLDON) THEN
               FNUC = -(EFIELD(1)*COORD(1,I) + EFIELD(2)*COORD(2,I) +
     1              EFIELD(3)*COORD(3,I))*FLDCON
               H(I2) = H(I2) + FNUC
            ENDIF
   30    CONTINUE
C
C   FILL THE ATOM-OTHER ATOM ONE-ELECTRON MATRIX<PSI(LAMBDA)|PSI(SIGMA)>
C
         IM1=I-IONE
         DO 100 J=1,IM1
            HALF=1.D0
            IF(I.EQ.J)HALF=0.5D0
            JA=NFIRST(J)
            JB=NLAST(J)
            JC=NMIDLE(J)
            NJ=NAT(J)
            CALL H1ELEC(NI,NJ,COORD(1,I),COORD(1,J),DI)
            I2=0
            DO 40 I1=IA,IB
               II=I1*(I1-1)/2+JA-1
               I2=I2+1
               J2=0
               JJ=MIN(I1,JB)
               DO 40 J1=JA,JJ
                  II=II+1
                  J2=J2+1
   40       H(II)=H(II)+DI(I2,J2)
C
C   CALCULATE THE TWO-ELECTRON INTEGRALS, W; THE ELECTRON NUCLEAR TERMS
C   E1B AND E2A; AND THE NUCLEAR-NUCLEAR TERM ENUC.
C
            IF(ID.EQ.0) THEN
               CALL ROTATE(NI,NJ,COORD(1,I),COORD(1,J),
     1 W(KR), KR,E1B,E2A,ENUC,CUTOFF)
            ELSE
               KRO=KR
               CALL SOLROT(NI,NJ,COORD(1,I),COORD(1,J),
     1                WJD, WKD,KR,E1B,E2A,ENUC,CUTOFF)
               JJ=0
               DO 50 II=KRO,KR-1
                  JJ=JJ+1
                  WJ(II)=WJD(JJ)
   50          WK(II)=WKD(JJ)
            ENDIF
            ENUCLR = ENUCLR + ENUC
C
C   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM I.
C
            I2=0
            DO 60 I1=IA,IC
               II=I1*(I1-1)/2+IA-1
               DO 60 J1=IA,I1
                  II=II+1
                  I2=I2+1
   60       H(II)=H(II)+E1B(I2)*HALF
            DO  70 I1=IC+1,IB
               II=(I1*(I1+1))/2
   70       H(II)=H(II)+E1B(1)*HALF
C
C   ADD ON THE ELECTRON-NUCLEAR ATTRACTION TERM FOR ATOM J.
C
            I2=0
            DO 80 I1=JA,JC
               II=I1*(I1-1)/2+JA-1
               DO 80 J1=JA,I1
                  II=II+1
                  I2=I2+1
   80       H(II)=H(II)+E2A(I2)*HALF
            DO 90 I1=JC+1,JB
               II=(I1*(I1+1))/2
   90       H(II)=H(II)+E2A(1)*HALF
  100    CONTINUE
  110 CONTINUE
      IF( .NOT. DEBUG) RETURN
      WRITE(6,'(//10X,''ONE-ELECTRON MATRIX FROM HCORE'')')
      CALL VECPRT(H,NORBS)
      J=MIN(400,KR)
      IF(ID.EQ.0) THEN
         WRITE(6,'(//10X,''TWO-ELECTRON MATRIX IN HCORE''/)')
         WRITE(6,120)(W(I),I=1,J)
      ELSE
         WRITE(6,'(//10X,''TWO-ELECTRON J MATRIX IN HCORE''/)')
         WRITE(6,120)(WJ(I),I=1,J)
         WRITE(6,'(//10X,''TWO-ELECTRON K MATRIX IN HCORE''/)')
         WRITE(6,120)(WK(I),I=1,J)
      ENDIF
  120 FORMAT(10F8.4)
      RETURN
      END

      SUBROUTINE MODIF (MA,A,NODEL)
      INTEGER NODEL
      DOUBLE PRECISION A(*),MA(2,2*NODEL)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.D0)
      INTEGER DOFEL, J
      DOFEL = 2*NODEL
      CALL VFILL (2*DOFEL,MA,ZERO)
      DO 300 J=1,NODEL
         MA(1,2*J-1)= A(J)
         MA(2,2*J)= A(J)
300   CONTINUE     
      RETURN
      END

      SUBROUTINE DEFLAT(A,W,N,WORK1,WORK2,IUN)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),W(N),WORK1(N),WORK2(N)
      EXTERNAL DOTVEC
C     
      zero = 0.0
      WLEN=DSQRT(DOTVEC(W,W,N))
      W(1)=W(1)-WLEN
      RECIP=1/DSQRT(DOTVEC(W,W,N))
      DO 100 I=1,N
         W(I)=W(I)*RECIP      
 100  CONTINUE
C     
      WRITE(6,*)'**DEFLAT: HOUSEHOLDER MATRIX DONE'
C     
      DO 200 J=1,N
         PRODCT=-2.0*DOTVEC(W,A(1,J),N)
         CALL ADDVEC(A(1,J),W,N,PRODCT,A(1,J))
 200  CONTINUE  
C     
      REWIND IUN
C     
      NN=N-1 
      DO 300 J=1,N                
         CALL COPVAL(WORK1,N,zero)
         WORK1(J)=1.0       
         PRODCT=-2.0*W(J)
         CALL ADDVEC(WORK1,W,N,PRODCT,WORK1)
         NC=N-J+1         
         CALL MATVE2(A,WORK1,N,WORK2(J),NC)
         IF (J.EQ.1) THEN
            WRITE(6,*) '**DEFLAT: CHECK VALUES=',WORK2(1),WORK2(N)
         ELSE
            CALL PUTSCR(IUN,WORK2(2),NN,1,0)
c--            CALL PUTSCR(work3(1,j-1),WORK2(2),NN,1,0)
         ENDIF
 300  CONTINUE                        
C     
      CALL GETSCR(IUN,A,NN,NN)
c--      CALL GETSCR(work3,A,NN,NN)
      CALL TRANSP(A,NN,A)
C     
      CALL MATPRT(A,NN)
      RETURN
      END

      SUBROUTINE FLEPO (XPARAM,NVAR,FUNCT1)
***************************************************************
*                                                             *
* THIS SUBROUTINE USES THE BFGS UPDATE TO THE INVERSE HESSIAN *
* THE NAME FLEPO IS KEPT IN ORDER TO ALLOW COMPATABILITY WITH *
* OTHER PROGRAMS.   THE DFP FORMULA IS NOTED IN THE COMMENTS. *
*                                                             *
***************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(*)
      COMMON /KEYWRD/ KEYWRD
      COMMON /GRAVEC/ COSINE
      COMMON /LAST  / LAST
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /MESAGE/ IFLEPO,ISCF
      COMMON /NUMSCF/ NSCF
      COMMON /TIMEMP/ TIME0
      COMMON /FMATRX/ HESINV(MAXHES)
      COMMON /NUMCAL/ NUMCAL
      CHARACTER*80 KEYWRD
      CHARACTER SPACE*1, CHDOT*1, ZERO*1, NINE*1, CH*1
C
C     *
C     THIS SUBROUTINE ATTEMPTS TO MINIMIZE A REAL-VALUED FUNCTION OF
C     THE N-COMPONENT REAL VECTOR XPARAM ACCORDING TO THE
C     BFGS FORMULA. RELEVANT REFERENCES ARE
C
C     BROYDEN, C.G., JOURNAL OF THE INSTITUTE FOR MATHEMATICS AND
C                     APPLICATIONS, VOL. 6 PP 222-231, 1970.
C     FLETCHER, R., COMPUTER JOURNAL, VOL. 13, PP 317-322, 1970.
C
C     GOLDFARB, D. MATHEMATICS OF COMPUTATION, VOL. 24, PP 23-26, 1970.
C
C     SHANNO, D.F. MATHEMATICS OF COMPUTATION, VOL. 24, PP 647-656
C                    1970.
C
C   SEE ALSO SUMMARY IN
C
C    SHANNO, D.F., J. OF OPTIMIZATION THEORY AND APPLICATIONS
C          VOL.46, NO 1 PP 87-94 1985.
C     THE USER MUST SUPPLY THE SUBROUTINE
C     COMPFG(NVAR,XPARAM,FUNCT,GRAD,1)WHICH
C     COMPUTES FUNCTION VALUES  FUNCT  AND GRADIENTS  GRAD AT GIVEN
C     VALUES FOR THE VARIABLES XPARAM.  THE MINIMIZATION PROCEEDS BY ONE
C     OR MORE BINARY CHOPS WHICH FINDS AN IMPROVED VALUE OF THE
C     FUNCTION IN THE DIRECTION   XPARAM+ALPHA*PVECT,
C     WHERE XPARAM
C     IS THE VECTOR OF CURRENT VARIABLE VALUES,  ALPHA IS A SCALAR
C     VARIABLE, AND  PVECT  IS A SEARCH-DIRECTION VECTOR PROVIDED BY THE
C     BFGS ALGORITHM.  A SEQUENCE OF FUNCT VALUES CONVERGING TO SOME
C     LOCAL MINIMUM VALUE AND A SEQUENCE OF
C     XPARAM VECTORS CONVERGING TO THE CORRESPONDING MINIMUM POINT
C     ARE PRODUCED.
C                          CONVERGENCE TESTS.
C
C     HERBERTS TEST: THE ESTIMATED DISTANCE FROM THE CURRENT POINT
C                    POINT TO THE MINIMUM IS LESS THAN TOLERA.
C
C                    "HERBERTS TEST SATISFIED - GEOMETRY OPTIMIZED"
C
C     GRADIENT TEST: THE GRADIENT NORM HAS BECOME LESS THAN TOLERG
C                    TIMES THE SQUARE ROOT OF THE NUMBER OF VARIABLES.
C
C                    "TEST ON GRADIENT SATISFIED".
C
C     XPARAM TEST:  THE RELATIVE CHANGE IN XPARAM, MEASURED BY ITS NORM,
C                   OVER ANY TWO SUCCESSIVE ITERATION STEPS DROPS BELOW
C                   TOLERX.
C
C                    "TEST ON XPARAM SATISFIED".
C
C     FUNCTION TEST: THE CALCULATED VALUE OF THE HEAT OF FORMATION
C                    BETWEEN ANY TWO CYCLES IS WITHIN TOLERF OF
C                    EACH OTHER.
C
C                    "HEAT OF FORMATION TEST SATISFIED"
C
C     FOR THE GRADIENT, FUNCTION, AND XPARAM TESTS A FURTHER CONDITION,
C     THAT NO INDIVIDUAL COMPONENT OF THE GRADIENT IS GREATER
C     THAN TOLERG, MUST BE SATISFIED, IN WHICH CASE THE
C     CALCULATION EXITS WITH THE MESSAGE
C
C                     "PETERS TEST SATISFIED"
C
C     WILL BE PRINTED, AND FUNCT AND XPARAM WILL CONTAIN THE LAST
C     FUNCTION VALUE CUM VARIABLE VALUES REACHED.
C
C     SIMILAR UNSUCCESSFUL TERMINATIONS WILL TAKE PLACE IF THE COSINE OF
C     THE SEARCH DIRECTION TO GRADIENT VECTOR IS LESS THAN RST ON TWO
C     CONSECUTIVE ITERATIONS.
C
C     THE BROYDEN-FLETCHER-GOLDFARB-SHANNO ALGORITHM CHOOSES SEARCH
C     DIRECTIONS ON THE BASIS OF LOCAL PROPERTIES OF THE FUNCTION.
C     A MATRIX  H, WHICH IN FLEPO IS PRESET WITH THE IDENTITY, IS
C     MAINTAINED AND UPDATED AT EACH ITERATION STEP.
C     THE MATRIX DESCRIBES A LOCAL METRIC ON THE SURFACE OF FUNCTION
C     VALUES ABOVE THE POINT XPARAM.  THE SEARCH-DIRECTION VECTOR
C     PVECT  IS SIMPLY A TRANSFORMATION OF THE GRADIENT  GRAD
C     BY THE MATRIX H.  THE USER THROWS OUT H AND STARTS AGAIN
C     WHENEVER THE COSINE OF THE ANGLE BETWEEN  GRAD  AND PVECT BECOMES
C     LESS THAN RST.
C
      DIMENSION XD(MAXPAR), GD(MAXPAR), GLAST(MAXPAR), MDFP(9),XDFP(9),
     1          XLAST(MAXPAR), GG(MAXPAR), PVECT(MAXPAR)
      LOGICAL OKF, OKC, PRINT,  TIME, RESTRT, MINPRT, SADDLE, GEOOK
     1        ,RESET, RESFIL, DFP
      EQUIVALENCE (MDFP(1),JCYC  ),(MDFP(2),JNRST),(MDFP(3),NCOUNT),
     1            (MDFP(4),LNSTOP),(XDFP(1),ALPHA),(XDFP(2),COS   ),
     2            (XDFP(3),PNORM ),(XDFP(4),DROP ),(XDFP(5),DEL   ),
     3            (XDFP(6),FREPF ),(XDFP(7),CYCMX),(XDFP(8),TOTIME)
      DATA ICALCN /0/
      DATA SPACE,CHDOT,ZERO,NINE /' ','.','0','9'/
      IF (ICALCN.NE.NUMCAL) THEN
C
C   THE FOLLOWING CONSTANTS SHOULD BE SET BY THE USER.
C
         RST   = 0.05D0
         TDEL  = 6.D0
         SFACT=1.5
         PMSTE = 0.1D0
         DELL  = 0.01D0
         EINC  = 0.3D0
         IGG1  = 3
         DEL=DELL
C
C    THESE CONSTANTS SHOULD BE SET BY THE PROGRAM.
C
         RESTRT = (INDEX(KEYWRD,'RESTART').NE.0)
         GEOOK  = (INDEX(KEYWRD,'GEO-OK').NE.0)
         TIME   = (INDEX(KEYWRD,'TIME').NE.0)
C
C   THE DAVIDON-FLETCHER-POWELL METHOD IS NOT RECOMMENDED
C   BUT CAN BE INVOKED BY USING THE KEY-WORD 'DFP'
C
         DFP   = (INDEX(KEYWRD,'DFP').NE.0)
         TLEFT=MAXTIM
         TOLERG=1.0D0
         CONST=1.D0
         MINPRT=(INDEX(KEYWRD,'SADDLE')+INDEX(KEYWRD,'SADDLE') .EQ.0)
         SADDLE=(INDEX(KEYWRD,'SADDLE') .NE.0)
         IF( .NOT. MINPRT) MINPRT=(INDEX(KEYWRD,'DEBUG') .NE. 0)
         I=INDEX(KEYWRD,' T=')
         IF(I.NE.0) THEN
            TIM=READA(KEYWRD,I)
            DO 10 J=I+3,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TIM=TIM*60
               IF( CH .EQ. 'H') TIM=TIM*3600
               IF( CH .EQ. 'D') TIM=TIM*86400
               GOTO 20
            ENDIF
   10       CONTINUE
C
C   LIMIT JOB TIME TO MAX. OF ONE YEAR, LARGE JOBTIMES STOP
C   DUMPS WORKING CORRECTLY AS TLEFT-(CYCLE TIME) = TLEFT!
C
            TIM=MIN(31557600.D0,TIM)
   20       TLEFT=TIM
         ENDIF
         TLAST=TLEFT
         TDUMP=MAXDMP
         I=INDEX(KEYWRD,' DUMP=')
         IF(I.NE.0) THEN
            TDUMP=READA(KEYWRD,I)
            DO 30 J=I+6,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') TDUMP=TDUMP*60
               IF( CH .EQ. 'H') TDUMP=TDUMP*3600
               IF( CH .EQ. 'D') TDUMP=TDUMP*86400
                  GOTO 40
               ENDIF
   30       CONTINUE
   40       CONTINUE
         ENDIF
         TX2=ZECOND()
         TLEFT=TLEFT-TX2+TIME0
         IF(INDEX(KEYWRD,'GNORM=').NE.0) THEN
            ROOTV=1.D0
            CONST=1.D-20
         ELSE
            ROOTV=SQRT(NVAR+1.D-5)
         ENDIF
         PRINT  = (INDEX(KEYWRD,'FLEPO').NE.0)
         TOLERX = 0.0001D0*CONST
         DELHOF  = 0.0010D0*CONST
         TOLERF = 0.002D0*CONST
         TOLRG  = TOLERG
         IF (INDEX(KEYWRD,'FORCE') .NE. 0) THEN
            TOLERX = 0.00001D0
            TOLERF = 0.0002D0
            TOLERG = 0.1D0
            DELHOF  = 0.00010D0
         ENDIF
         IF(INDEX(KEYWRD,'PREC') .NE. 0) THEN
            TOLERX=TOLERX*0.01D0
            DELHOF=DELHOF*0.01D0
            TOLERF=TOLERF*0.01D0
            TOLERG=TOLERG*0.1D0
            EINC=EINC*0.01
         ENDIF
         IF(INDEX(KEYWRD,'GNORM=').NE.0) THEN
            TOLERG=READA(KEYWRD,INDEX(KEYWRD,'GNORM='))
            IF(.NOT.GEOOK.AND.INDEX(KEYWRD,'LET').EQ.0.AND.
     1TOLERG.LT.1.D-4)THEN
               WRITE(6,'(/,A)')'  GNORM HAS BEEN SET TOO LOW, RESET TO 0
     1.0001'
               TOLERG=1.D-4
               TOLRG=TOLERG
            ENDIF
         ELSE
            TOLERG=TOLERG/ROOTV
         ENDIF
      ENDIF
C
C   THE FOLLOWING CONSTANTS SHOULD BE SET TO SOME ARBITARY LARGE VALUE.
C
      DROP  = 1.D15
      FREPF = 1.D15
C
C     AND FINALLY, THE FOLLOWING CONSTANTS ARE CALCULATED.
C
      IHDIM=(NVAR*(NVAR+1))/2
      CNCADD=1.0D00/ROOTV
      IF (CNCADD.GT.0.15D00) CNCADD=0.15D00
C
C     FIRST, WE INITIALIZE THE VARIABLES.
C
      ABSMIN=1.D6
      ITRY1=0
      ITRY2=0
      OKC=.TRUE.
      OKF=.TRUE.
      JCYC=0
      LNSTOP=1
      IREPET=1
      ALPHA = 1.0D00
      PNORM=1.0D00
      JNRST=0
      CYCMX=0.D0
      COS=0.0D00
      TOTIME=0.D0
      NCOUNT=1
      RESFIL=.FALSE.
      IF( SADDLE) THEN
*
*   WE DON'T NEED HIGH PRECISION DURING A SADDLE-POINT CALCULATION.
*
         IF(NVAR.GT.0)GNORM=SQRT(DOT(GRAD,GRAD,NVAR))-3.D0
         IF(GNORM.GT.10.D0)GNORM =10.D0
         IF(GNORM.GT.1.D0) TOLERG=TOLRG*GNORM
         WRITE(6,'('' GRADIENT CRITERION IN FLEPO ='',F12.5)')TOLERG
      ENDIF
      IF (RESTRT .AND. ICALCN .NE. NUMCAL) THEN
         MDFP(9)=0
         CALL DFPSAV(TOTIME,XPARAM,GD,XLAST,FUNCT1,MDFP,XDFP)
         I=TOTIME/1000000.D0
         TOTIME=TOTIME-I*1000000
         WRITE(6,'(//10X,''TOTAL TIME USED SO FAR:'',
     1    F13.2,'' SECONDS'')')TOTIME
         NSCF=MDFP(5)
         IF(INDEX(KEYWRD,'1SCF') .NE. 0) THEN
            CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
            ICALCN=NUMCAL
            IFLEPO=1
            TIME0=TIME0-TOTIME
            TOTIME=0.D0
            RETURN
         ENDIF
      ELSE
         TOTIME=0.D0
C
C CALCULATE THE VALUE OF THE FUNCTION -> FUNCT1, AND GRADIENTS -> GRAD.
C NORMAL SET-UP OF FUNCT1 AND GRAD, DONE ONCE ONLY.
C
         CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
         DO 50 I=1,NVAR
   50    GD(I)=GRAD(I)
      ENDIF
      ICALCN=NUMCAL
      IF(NVAR.NE.0)GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
      IFLEPO=1
      IF(INDEX(KEYWRD,'1SCF') .NE. 0) RETURN
      IFLEPO=2
      IF(GNORM.LT.TOLERG.OR.NVAR.EQ.0) THEN
         LAST=1
         IF(RESTRT) THEN
            CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
         ELSE
            CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.FALSE.)
         ENDIF
         RETURN
      ENDIF
      TX1 =  ZECOND()
      TLEFT=TLEFT-TX1+TX2
C     *
C     START OF EACH ITERATION CYCLE ...
C     *
C
      RESET=.FALSE.
      GOTO 80
   60 CONTINUE
      IF(COS .LT. RST) THEN
         DO 70 I=1,NVAR
   70    GD(I)=0.5D0
      ENDIF
   80 CONTINUE
      JCYC=JCYC+1
      JNRST=JNRST+1
      IF (LNSTOP.NE.1 .AND. COS.GT.RST) GOTO 160
C
C     *
C     RESTART SECTION
C     *
C
   90 CONTINUE
      RESET=.TRUE.
      DO 100 I=1,NVAR
         XD(I)=XPARAM(I)-SIGN(DEL,GRAD(I))
  100 CONTINUE
C
C THIS CALL OF COMPFG IS USED TO CALCULATE THE SECOND-ORDER MATRIX IN H
C IF THE NEW POINT HAPPENS TO IMPROVE THE RESULT, THEN IT IS KEPT.
C OTHERWISE IT IS SCRAPPED, BUT STILL THE SECOND-ORDER MATRIX IS O.K.
C
      CALL COMPFG (XD, .TRUE., FUNCT2,.TRUE.,GD,.TRUE.)
      IF(.NOT. GEOOK .AND. SQRT(DOT(GD,GD,NVAR))/GNORM.GT.10.
     1 AND.GNORM/ROOTV.GT.20.AND.JCYC.GT.2)THEN
C
C  THE GEOMETRY IS BADLY SPECIFIED IN THAT MINOR CHANGES IN INTERNAL
C  COORDINATES LEAD TO LARGE CHANGES IN CARTESIAN COORDINATES, AND THESE
C  LARGE CHANGES ARE BETWEEN PAIRS OF ATOMS THAT ARE CHEMICALLY BONDED
C  TOGETHER.
         WRITE(6,'('' GRADIENTS OF OLD GEOMETRY, GNORM='',F13.6)')GNORM
         WRITE(6,'(6F12.6)')(GRAD(I),I=1,NVAR)
         GDNORM=SQRT(DOT(GD,GD,NVAR))
         WRITE(6,'('' GRADIENTS OF NEW GEOMETRY, GNORM='',F13.6)')GDNORM
         WRITE(6,'(6F12.6)')(GD(I),I=1,NVAR)
         WRITE(6,'(///20X,''CALCULATION ABANDONED AT THIS POINT!'')')
         WRITE(6,'(//10X,'' SMALL CHANGES IN INTERNAL COORDINATES ARE'',
     1/10X,'' CAUSING A LARGE CHANGE IN THE DISTANCE BETWEEN'')')
         WRITE(6,'(10X,'' CHEMICALLY-BOUND ATOMS. THE OPTIMISATION'',/
     110X,'' PROCEDURE WOULD LIKELY PRODUCE INCORRECT RESULTS'')')
         CALL GEOUT
         CALL WRAPUP()
      ENDIF
      NCOUNT=NCOUNT+1
      DO 110 I=1,IHDIM
  110 HESINV(I)=0.0D00
      DO 120 I=1,NVAR
         II=(I*(I+1))/2
         DELTAG=GRAD(I)-GD(I)
         IF (ABS(DELTAG).LT.1.D-10) DELTAG = 1.D-10
         GGD=ABS(GRAD(I))
         IF (FUNCT2.LT.FUNCT1) GGD=ABS(GD(I))
         HESINV(II)=SIGN(DEL,GRAD(I))/DELTAG
         IF (HESINV(II).LT.0.0D00.AND.GGD.LT.1.D-12)HESINV(II)=0.01D00
         IF (HESINV(II).LT.0.D0) HESINV(II)=6.D0*DEL/GGD
         HESINV(II)=MIN(HESINV(II),ABS(PMSTE/MAX(1.D-12,GGD)))
  120 CONTINUE
      JNRST=0
      IF(JCYC.LT.2) COSINE=1.D0
      IF(FUNCT2 .GE. FUNCT1) THEN
         IF(PRINT)WRITE (6,130) FUNCT1,FUNCT2
  130    FORMAT (' FUNCTION VALUE=',F13.7,
     1 '  WILL NOT BE REPLACED BY VALUE=',F13.7,/10X,
     2 'CALCULATED BY RESTART PROCEDURE',/)
         CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GD,.FALSE.)
         COSINE=1.D0
      ELSE
         IF( PRINT ) WRITE (6,140) FUNCT1,FUNCT2
  140    FORMAT (' FUNCTION VALUE=',F13.7,
     1' IS BEING REPLACED BY VALUE=',F13.7,/10X,
     2' FOUND IN RESTART PROCEDURE',/,6X,
     3'THE CORRESPONDING X VALUES AND GRADIENTS ARE ALSO BEING REPLACED'
     4,/)
         FUNCT1=FUNCT2
         GNORM=0.0D00
         DO 150 I=1,NVAR
            XPARAM(I)=XD(I)
            GRAD(I)=GD(I)
  150    GNORM=GNORM+GRAD(I)**2
         GNORM=SQRT(GNORM)
      ENDIF
      GO TO 210
C
C     *
C     UPDATE VARIABLE-METRIC MATRIX
C     *
C
  160 PTY=0.0D00
      JNRST=JNRST+1
      YHY=0.0D00
      DO 180 I=1,NVAR
         S=0.0D00
         DO 170 J=1,NVAR
            IF (J.GT.I) THEN
               K=(J*(J-1))/2+I
            ELSE
               K=(I*(I-1))/2+J
            ENDIF
  170    S=S+HESINV(K)*(GRAD(J)-GLAST(J))
         GG(I)=S
         Y=GRAD(I)-GLAST(I)
         YHY=YHY+GG(I)*Y
  180 PTY=PTY+(XPARAM(I)-XLAST(I))*Y
      IF(DFP)THEN
         DO 190 I=1,NVAR
            PT=XPARAM(I)-XLAST(I)
            DO 190 J=I,NVAR
               K=(J*(J-1))/2+I
               P=XPARAM(J)-XLAST(J)
C     START OF DAVIDON FLETCHER POWELL FORMULA
               HESINV(K)=HESINV(K)+PT*P/PTY-GG(I)*GG(J)/YHY
C     END OF DAVIDON FLETCHER POWELL FORMULA
  190    CONTINUE
      ELSE
C    BFGS FORMULA ON NEXT LINE
         YHY=1.D0+YHY/PTY
C    BFGS FORMULA ON LAST LINE
         DO 200 I=1,NVAR
            PT=XPARAM(I)-XLAST(I)
            DO 200 J=I,NVAR
               P=XPARAM(J)-XLAST(J)
               K=(J*(J-1))/2+I
C    START OF BFGS FORMULA ON NEXT LINE
               HESINV(K)=HESINV(K)-(GG(J)*PT+P*GG(I))/PTY+YHY*P*PT/PTY
C    END OF BFGS FORMULA
  200    CONTINUE
      ENDIF
C
C     *
C     ESTABLISH NEW SEARCH DIRECTION
C     *
  210 PNLAST=PNORM
      PNORM=0.0D00
      DOTT=0.0D00
      DO 230 K=1,NVAR
         S=0.0D00
         DO 220 I=1,NVAR
            IJ=MAX(I,K)
            S=S-HESINV((IJ*(IJ-1))/2+I+K-IJ)*GRAD(I)
  220    CONTINUE
         PVECT(K)=S
         PNORM=PNORM+PVECT(K)**2
  230 DOTT=DOTT+PVECT(K)*GRAD(K)
      PNORM=SQRT(PNORM)
      COS=-DOTT/(PNORM*GNORM)
      IF (JNRST.EQ.0) GO TO 260
      IF (COS.LE.CNCADD.AND.DROP.GT.1.0D00) GO TO 240
      IF (COS.LE.RST) GO TO 240
      GO TO 260
  240 PNORM=PNLAST
      IF( PRINT )WRITE (6,250) COS
  250 FORMAT (//,5X, 'SINCE COS=',F9.3,5X,'THE PROGRAM WILL GO TO RE',
     1'START SECTION',/)
      GO TO 90
  260 CONTINUE
      IF( PRINT )THEN
         WRITE (6,270)
  270    FORMAT ('  THE CURRENT POINT IS ...')
         NTO6=(NVAR-1)/6+1
         IINC1=-5
         DO 320 I=1,NTO6
            WRITE (6,'(/)')
            IINC1=IINC1+6
            IINC2=MIN(IINC1+5,NVAR)
            WRITE (6,280) (J,J=IINC1,IINC2)
            WRITE (6,290) (XPARAM(J),J=IINC1,IINC2)
            WRITE (6,300) (GRAD(J),J=IINC1,IINC2)
            WRITE (6,310) (ALPHA*PVECT(J),J=IINC1,IINC2)
  280       FORMAT (1H ,3X,  1HI,9X,I3,9(8X,I3))
  290       FORMAT (1H ,1X, 'XPARAM(I)',1X,F9.4,2X,9(F9.4,2X))
  300       FORMAT (1H ,1X, 'GRAD  (I)',F10.4,1X,9(F10.4,1X))
  310       FORMAT (1H ,1X, 'PVECT (I)',2X,F10.6,1X,9(F10.6,1X))
  320    CONTINUE
      ENDIF
      LNSTOP=0
      ALPHA=ALPHA*PNLAST/PNORM
      DO 330 I=1,NVAR
         GLAST(I)=GRAD(I)
  330 XLAST(I)=XPARAM(I)
      IF (JNRST.EQ.0) ALPHA=1.0D00
      DROP=ABS(ALPHA*DOTT)
      IF (JNRST.NE.0.AND.DROP.LT.DELHOF) THEN
         IF(MINPRT)WRITE (6,340)
  340    FORMAT(//,10X,'HERBERTS TEST SATISFIED - GEOMETRY OPTIMIZED')
C
C   FLEPO IS ENDING PROPERLY. THIS IS IMMEDIATELY BEFORE THE RETURN.
C
         LAST=1
         CALL COMPFG (XPARAM, .TRUE., FUNCT,.TRUE.,GRAD,.FALSE.)
         IFLEPO=3
         TIME0=TIME0-TOTIME
         TOTIME=0.D0
         RETURN
      ENDIF
      SMVAL=FUNCT1
      IF(GNORM.GT.1.D0.AND.PNORM.GT.1.D-3)THEN
         CALL LINMIN(XPARAM,ALPHA,PVECT,NVAR,FUNCT1,OKF,OKC)
      ELSE
C
C   DO A BINARY CHOP TO LOCATE THE MINIMUM
C
         ALPHA=1.D0
C
C   SOMETIMES PNORM IS TOO LARGE,  THEREFORE TRIM ALPHA BACK
C
         IF(PNORM.GT.0.1D0)ALPHA=0.1D0/PNORM
         LOOP=0
  350    CONTINUE
         DO 360 I=1,NVAR
  360    XPARAM(I)=XLAST(I)+PVECT(I)*ALPHA
         CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.FALSE.)
C
C   1.D-5 IS TO PREVENT LOOPING
C
         IF(FUNCT1.GT.SMVAL+1.D-5.AND.PNORM*ALPHA.GT.1.D-6.AND.LOOP.LT.1
     10)THEN
            LOOP=LOOP+1
            ALPHA=ALPHA*0.5D0
            GOTO 350
         ENDIF
      ENDIF
      NCOUNT=NCOUNT+1
      IF ( .NOT. OKF) THEN
         LNSTOP = 1
         IF(MINPRT)WRITE (6,370)
  370    FORMAT (1H ,///,20X, 'NO POINT LOWER IN ENERGY ',
     1    'THAN THE STARTING POINT',/,20X,'COULD BE FOUND ',
     2    'IN THE LINE MINIMIZATION')
         FUNCT1=SMVAL
         DO 380 I=1,NVAR
            GRAD(I)=GLAST(I)
            XPARAM(I)=XLAST(I)
  380    CONTINUE
         IF (JNRST.EQ.0)THEN
            WRITE (6,390)
  390       FORMAT (1H ,//,20X, 'SINCE COS WAS JUST RESET,THE SEARCH',
     1        ' IS BEING ENDED')
C
C          FLEPO IS ENDING BADLY. THIS IS IMMEDIATELY BEFORE THE RETURN.
C
            LAST=1
            CALL COMPFG (XPARAM, .TRUE., FUNCT,.TRUE.,GRAD,.TRUE.)
            IFLEPO=4
            TIME0=TIME0-TOTIME
            TOTIME=0.D0
            RETURN
         ENDIF
         IF(PRINT)WRITE (6,400)
  400    FORMAT (1H ,20X, 'COS WILL BE RESET AND ANOTHER '
     1    ,'ATTEMPT MADE')
         COS=0.0D00
         GO TO 560
      ENDIF
C   WE WANT ACCURATE DERIVATIVES AT THIS POINT
C
C   LINMIN DOES NOT GENERATE ANY DERIVATIVES, THEREFORE COMPFG MUST BE
C   CALLED TO END THE SEARCH
C
      IF(RESET) THEN
         DO 410 J=1,NVAR
  410    GRAD(J)=0.D0
         RESET=.FALSE.
      ENDIF
      CALL COMPFG (XPARAM, .TRUE., FUNCT1,.TRUE.,GRAD,.TRUE.)
      GNORM=SQRT(DOT(GRAD,GRAD,NVAR))
      IF (.NOT. OKC .AND. MINPRT)WRITE (6,420) JCYC
  420 FORMAT ( 23H0LINMIN FAILED AT CYCLE,I5/,  1H0)
      XN=0.0D00
      DO 430 K=1,NVAR
  430 XN=XN+XPARAM(K)**2
      XN=SQRT(XN)
      TX=ABS(ALPHA*PNORM)
      IF (XN.NE.0.0D00) TX=TX/XN
      TF=SMVAL-FUNCT1
      IF (ALPHA.LT.0.01D0.OR.ABSMIN-SMVAL.LT.1.D-7)THEN
         ITRY2=ITRY2+1
         IF(COS.LT.RST)ITRY2=0
         IF(ITRY2.EQ.5)THEN
C
C   RE-CALCULATE ALL DERIVATIVES IF HALF-ELECTRON USED.
C
            COS=-1.D0
         ENDIF
      ELSE
         IF(ALPHA.GT.0.1D0)ITRY2=0
      ENDIF
      IF(ABSMIN-SMVAL.LT.1.D-7)THEN
         ITRY1=ITRY1+1
         IF(ITRY1.GT.10)THEN
            WRITE(6,
     +      '(//,'' HEAT OF FORMATION IS ESSENTIALLY STATIONARY'')')
            GOTO 550
         ENDIF
      ELSE
         ITRY1=0
         ABSMIN=SMVAL
      ENDIF
      IF (PRINT) WRITE (6,440) NCOUNT,COS,TX*XN,ALPHA,-DROP,-TF,GNORM
  440 FORMAT (/,'           NUMBER OF COUNTS =',I6,
     1'         COS    =',F11.4,/,
     2        '  ABSOLUTE  CHANGE IN X     =',F13.6,
     3'  ALPHA  =',F11.4,/,
     4        '  PREDICTED CHANGE IN F     =  ',G11.4,
     5'  ACTUAL =  ',G11.4,/,
     6        '  GRADIENT NORM             =  ',G11.4,//)
  450 IF (TX.LE.TOLERX) THEN
         IF(MINPRT) WRITE (6,460)
  460    FORMAT ( 20H0TEST ON X SATISFIED)
         GO TO 490
      ENDIF
      IF (ABS(TF).LE.TOLERF) THEN
         IF(MINPRT) WRITE (6,470)
  470    FORMAT (' HEAT OF FORMATION TEST SATISFIED')
         GO TO 490
      ENDIF
      IF (GNORM.LE.TOLERG*ROOTV) THEN
         IF(MINPRT) WRITE (6,480)
  480    FORMAT ( 27H0TEST ON GRADIENT SATISFIED)
         GOTO 490
      ENDIF
      GOTO 560
  490 DO 530 I=1,NVAR
         IF (ABS(GRAD(I)).GT.TOLERG)THEN
            IREPET=IREPET+1
            IF (IREPET.GT.1) GO TO 500
            FREPF=FUNCT1
            COS=0.0D00
  500       CONTINUE
            IF(MINPRT) WRITE (6,510)TOLERG
  510       FORMAT (20X,'HOWEVER, A COMPONENT OF GRADIENT IS ',
     1     'LARGER THAN',F6.2 ,/)
            IF (ABS(FUNCT1-FREPF).GT.EINC) IREPET=0
            IF (IREPET.GT.IGG1) THEN
               WRITE (6,520)IGG1,EINC
  520          FORMAT ( 7X,' THERE HAVE BEEN',I2,' ATTEMPTS TO REDUCE TH
     1E ',' GRADIENT.',/7X,' DURING THESE ATTEMPTS THE ENERGY DROPPED',
     2' BY LESS THAN',F7.4,' KCAL/MOLE',/
     310X,' FURTHER CALCULATION IS NOT JUSTIFIED AT THIS POINT.')
               LAST=1
               CALL COMPFG (XPARAM, .TRUE., FUNCT,.TRUE.,GRAD,.FALSE.)
               IFLEPO=8
               TIME0=TIME0-TOTIME
               TOTIME=0.D0
               RETURN
            ELSE
               GOTO 560
            ENDIF
         ENDIF
  530 CONTINUE
      IF(MINPRT) WRITE (6,540)
  540 FORMAT ( 23H PETERS TEST SATISFIED )
  550 LAST=1
      CALL COMPFG (XPARAM, .TRUE., FUNCT,.TRUE.,GRAD,.FALSE.)
      IFLEPO=6
      TIME0=TIME0-TOTIME
      TOTIME=0.D0
      RETURN
C
C   ALL TESTS HAVE FAILED, WE NEED TO DO ANOTHER CYCLE.
C
  560 CONTINUE
      BSMVF=ABS(SMVAL-FUNCT1)
      IF (BSMVF.GT.10.D00) COS = 0.0D00
      DEL=0.002D00
      IF (BSMVF.GT.1.0D00) DEL=DELL/2.0D00
      IF (BSMVF.GT.5.0D00) DEL=DELL
      TX2 = ZECOND()
      TCYCLE=TX2-TX1
      TX1=TX2
C
C END OF ITERATION LOOP, EVERYTHING IS STILL O.K. SO GO TO
C NEXT ITERATION, IF THERE IS ENOUGH TIME LEFT.
C
      IF(TCYCLE.LT.100000.D0)CYCMX=MAX(CYCMX*0.8D0,TCYCLE)
      TLEFT=TLEFT-TCYCLE
      IF(TLEFT.LT.0)TLEFT=-0.1D0
      IF(TCYCLE.GT.1.D5)TCYCLE=0.D0
      IF(TLAST-TLEFT.GT.TDUMP)THEN
         TOTIM=TOTIME   +   ZECOND()-TIME0
         TLAST=TLEFT
         MDFP(9)=2
         RESFIL=.TRUE.
         MDFP(5)=NSCF
         CALL DFPSAV(TOTIM,XPARAM,GD,XLAST,FUNCT1,MDFP,XDFP)
      ENDIF
      IF(RESFIL)THEN
         IF(MINPRT) WRITE(6,570)MIN(TLEFT,9999999.9D0),
     1MIN(GNORM,999999.999D0),FUNCT1
  570    FORMAT(' RESTART FILE WRITTEN,   TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G13.7)
         RESFIL=.FALSE.
      ELSE
         IF(MINPRT) WRITE(6,580)JCYC,MIN(TCYCLE,9999.99D0),
     1MIN(TLEFT,9999999.9D0),MIN(GNORM,999999.999D0),FUNCT1
  580    FORMAT(' CYCLE:',I4,' TIME:',F7.2,' TIME LEFT:',F9.1,
     1' GRAD.:',F10.3,' HEAT:',G13.7)
      ENDIF
      IF (TLEFT.GT.SFACT*CYCMX) GO TO 60
      WRITE(6,590)
  590 FORMAT (20X, 42HTHERE IS NOT ENOUGH TIME FOR ANOTHER CYCLE,/,30X,
     118HNOW GOING TO FINAL)
      TOTIME=TOTIME   +   ZECOND()-TIME0
      MDFP(9)=1
      MDFP(5)=NSCF
      CALL DFPSAV(TOTIME,XPARAM,GD,XLAST,FUNCT1,MDFP,XDFP)
      CALL WRAPUP()
C
C
      END

      SUBROUTINE DIPIND (DIPVEC)
C...............................................................
C  MODIFICATION OF DIPOLE SUBROUTINE FOR USE IN THE CALUCLATION
C  OF THE INDUCED DIPOLES FOR POLARIZABILITIES.
C...............................................................
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /CORE  / CORE(107)
      COMMON /DENSTY/ P(MPACK),PA(MPACK),PB(MPACK)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM),NORBS,NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /KEYWRD/ KEYWRD
      COMMON /ISTOPE/ AMS(107)
      COMMON /MULTIP/ DD(107), QQ(107), AM(107), AD(107), AQ(107)
      DIMENSION Q(MAXORB),Q2(MAXORB),DIPVEC(3),CENTER(3),
     1          COORD(3,NUMATM)
      CHARACTER*80 KEYWRD
C
C***********************************************************************
C     DIPOLE CALCULATES DIPOLE MOMENTS
C
C  ON INPUT P     = DENSITY MATRIX
C           Q     = TOTAL ATOMIC CHARGES, (NUCLEAR + ELECTRONIC)
C           NUMAT = NUMBER OF ATOMS IN MOLECULE
C           NAT   = ATOMIC NUMBERS OF ATOMS
C           NFIRST= START OF ATOM ORBITAL COUNTERS
C           COORD = COORDINATES OF ATOMS
C
C  OUTPUT  DIPOLE = DIPOLE MOMENT
C***********************************************************************
C
C     IN THE ZDO APPROXIMATION, ONLY TWO TERMS ARE RETAINED IN THE
C     CALCULATION OF DIPOLE MOMENTS.
C     1. THE POINT CHARGE TERM (INDEPENDENT OF PARAMETERIZATION).
C     2. THE ONE-CENTER HYBRIDIZATION TERM, WHICH ARISES FROM MATRIX
C     ELEMENTS OF THE FORM <NS/R/NP>. THIS TERM IS A FUNCTION OF
C     THE SLATER EXPONENTS (ZS,ZP) AND IS THUS DEPENDENT ON PARAMETER-
C     IZATION. THE HYBRIDIZATION FACTORS (HYF(I)) USED IN THIS SUB-
C     ROUTINE ARE CALCULATED FROM THE FOLLOWING FORMULAE.
C     FOR SECOND ROW ELEMENTS <2S/R/2P>
C     HYF(I)= 469.56193322*(SQRT(((ZS(I)**5)*(ZP(I)**5)))/
C           ((ZS(I) + ZP(I))**6))
C     FOR THIRD ROW ELEMENTS <3S/R/3P>
C     HYF(I)=2629.107682607*(SQRT(((ZS(I)**7)*(ZP(I)**7)))/
C           ((ZS(I) + ZP(I))**8))
C     FOR FOURTH ROW ELEMENTS AND UP :
C     HYF(I)=2*(2.10716)*DD(I)
C     WHERE DD(I) IS THE CHARGE SEPARATION IN ATOMIC UNITS
C
C
C     REFERENCES:
C     J.A.POPLE & D.L.BEVERIDGE: APPROXIMATE M.O. THEORY
C     S.P.MCGLYNN, ET AL: APPLIED QUANTUM CHEMISTRY
C
      DIMENSION DIP(4,3)
      DIMENSION HYF(107,2)
      LOGICAL FIRST, FORCE, CHARGD
      DATA HYF(1,1)     / 0.0D00           /
      DATA   HYF(1,2) /0.0D0     /
      DATA   HYF(5,2) /6.520587D0/
      DATA   HYF(6,2) /4.253676D0/
      DATA   HYF(7,2) /2.947501D0/
      DATA   HYF(8,2) /2.139793D0/
      DATA   HYF(9,2) /2.2210719D0/
      DATA   HYF(14,2)/6.663059D0/
      DATA   HYF(15,2)/5.657623D0/
      DATA   HYF(16,2)/6.345552D0/
      DATA   HYF(17,2)/2.522964D0/
      DATA FIRST /.TRUE./
C
C  SETUP FOR DIPOLE CALCULATION
C
      CALL CHRGE (P,Q2)
      DO 10 I = 1,NUMAT
         L = NAT(I)
         Q(I) = CORE(L) - Q2(I)
   10 CONTINUE
      CALL GMETRY (GEO,COORD)
C
      IF (FIRST) THEN
         DO 20 I=2,107
   20    HYF(I,1)= 5.0832*DD(I)
         WTMOL=0.D0
         SUM=0.D0
         DO 30 I=1,NUMAT
            WTMOL=WTMOL+AMS(NAT(I))
   30    SUM=SUM+Q(I)
         CHARGD=(ABS(SUM).GT.0.5D0)
         FIRST=.FALSE.
         FORCE=(INDEX(KEYWRD,'FORCE') +INDEX(KEYWRD,'IRC').NE. 0)
         ITYPE=1
         IF(INDEX(KEYWRD,'MINDO') .NE. 0)ITYPE=2
      ENDIF
      IF(CHARGD)THEN
C
C   NEED TO RESET ION'S POSITION SO THAT THE CENTER OF MASS IS AT THE
C   ORIGIN.
C
         DO 40 I=1,3
   40    CENTER(I)=0.D0
         DO 50 I=1,3
            DO 50 J=1,NUMAT
   50    CENTER(I)=CENTER(I)+AMS(NAT(J))*COORD(I,J)
         DO 60 I=1,3
   60    CENTER(I)=CENTER(I)/WTMOL
         DO 70 I=1,3
            DO 70 J=1,NUMAT
   70    COORD(I,J)=COORD(I,J)-CENTER(I)
      ENDIF
      DO 80 I=1,4
         DO 80 J=1,3
   80 DIP(I,J)=0.0D00
      DO 100 I=1,NUMAT
         NI=NAT(I)
         IA=NFIRST(I)
         L=NLAST(I)-IA
         DO 90 J=1,L
            K=((IA+J)*(IA+J-1))/2+IA
   90    DIP(J,2)=DIP(J,2)-HYF(NI,ITYPE)*P(K)
         DO 100 J=1,3
  100 DIP(J,1)=DIP(J,1)+4.803D00*Q(I)*COORD(J,I)
      DO 110 J=1,3
  110 DIP(J,3)=DIP(J,2)+DIP(J,1)
      DO 120 J=1,3
  120 DIP(4,J)=SQRT(DIP(1,J)**2+DIP(2,J)**2+DIP(3,J)**2)
      DIPVEC(1)= -DIP(1,3)
      DIPVEC(2)= -DIP(2,3)
      DIPVEC(3)= -DIP(3,3)
      DIPCOM = DIP(4,3)
C      WRITE (6,60) ((DIP(I,J),I=1,4),J=1,3)
C   60 FORMAT (3(4F10.3))
      RETURN
C
      END

      SUBROUTINE SCALE(FII,NDIM,NMODES)
CDEP  
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION FII(NDIM,NMODES)
      EXTERNAL DOTVEC
C     
      WRITE(6,*)'NORMALIZING MODES TO A UNIT LENGTH...'
      DO 210 J=1,NMODES
         RECIP=1/SQRT(DOTVEC(FII(1,J),FII(1,J),NDIM))
         DO 200 I=1,NDIM
            FII(I,J)=FII(I,J)*RECIP
 200     CONTINUE
 210  CONTINUE
C     
      WRITE(6,*)'CHECKING ORTHOGONALITY OF THE MODES...'
      DO 110 I=1,NMODES
         DO 100 J=I,NMODES
            PRODCT=DOTVEC(FII(1,I),FII(1,J),NDIM)
            WRITE(6,1000)I,J,PRODCT
 100     CONTINUE
 110  CONTINUE
 1000 FORMAT(5X,'MODE ',I5,' BY MODE ',I5,' = ',1P,G13.5)
      END          

      SUBROUTINE REPP(NI,NJ,RIJ,RI,CORE)
C***********************************************************************
C
C..VECTOR VERSION WRITTEN BY ERNEST R. DAVIDSON, INDIANA UNIVERSITY
C
C
C  REPP CALCULATES THE TWO-ELECTRON REPULSION INTEGRALS AND THE
C       NUCLEAR ATTRACTION INTEGRALS.
C
C     ON INPUT RIJ     = INTERATOMIC DISTANCE
C              NI      = ATOM NUMBER OF FIRST ATOM
C              NJ      = ATOM NUMBER OF SECOND ATOM
C    (REF)     ADD     = ARRAY OF GAMMA, OR TWO-ELECTRON ONE-CENTER,
C                        INTEGRALS.
C    (REF)     TORE    = ARRAY OF NUCLEAR CHARGES OF THE ELEMENTS
C    (REF)     DD      = ARRAY OF DIPOLE CHARGE SEPARATIONS
C    (REF)     QQ      = ARRAY OF QUADRUPOLE CHARGE SEPARATIONS
C
C     THE COMMON BLOCKS ARE INITIALIZED IN BLOCK-DATA, AND NEVER CHANGED
C
C    ON OUTPUT RI      = ARRAY OF TWO-ELECTRON REPULSION INTEGRALS
C              CORE    = 4 X 2 ARRAY OF ELECTRON-CORE ATTRACTION
C                        INTEGRALS
C
C
C *** THIS ROUTINE COMPUTES THE TWO-CENTRE REPULSION INTEGRALS AND THE
C *** NUCLEAR ATTRACTION INTEGRALS.
C *** THE TWO-CENTRE REPULSION INTEGRALS (OVER LOCAL COORDINATES) ARE
C *** STORED AS FOLLOWS (WHERE P-SIGMA = O,  AND P-PI = P AND P* )
C     (SS/SS)=1,   (SO/SS)=2,   (OO/SS)=3,   (PP/SS)=4,   (SS/OS)=5,
C     (SO/SO)=6,   (SP/SP)=7,   (OO/SO)=8,   (PP/SO)=9,   (PO/SP)=10,
C     (SS/OO)=11,  (SS/PP)=12,  (SO/OO)=13,  (SO/PP)=14,  (SP/OP)=15,
C     (OO/OO)=16,  (PP/OO)=17,  (OO/PP)=18,  (PP/PP)=19,  (PO/PO)=20,
C     (PP/P*P*)=21,   (P*P/P*P)=22.
C *** THE STORAGE OF THE NUCLEAR ATTRACTION INTEGRALS  CORE(KL/IJ) IS
C     (SS/)=1,   (SO/)=2,   (OO/)=3,   (PP/)=4
C     WHERE IJ=1 IF THE ORBITALS CENTRED ON ATOM I,  =2 IF ON ATOM J.
C *** NI AND NJ ARE THE ATOMIC NUMBERS OF THE TWO ELEMENTS.
C
C***********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL SI,SJ
      COMMON /MULTIP/ DD(107),QQ(107),ADD(107,3)
      COMMON /CORE/ TORE(107)
      COMMON /NATORB/ NATORB(107)
      DIMENSION RI(22),CORE(4,2)
      DIMENSION ARG(72),SQR(72)
      DATA  OD/1.D00/, TD/2.D00/, FD/4.D00/, ED/8.D0/
      DATA PP/0.5D00/, P2/0.25D00/, P3/0.125D00/, P4/0.0625D00/
      DATA A0/0.529167D0/ ,EV/27.21D0/, EV1/13.605D0/, EV2/6.8025D0/,
     1 EV3/3.40125D0/, EV4/1.700625D0/
C
C     ATOMIC UNITS ARE USED IN THE CALCULATION,
C     FINAL RESULTS ARE CONVERTED TO EV
C
      R=RIJ/A0
C
      SI = (NATORB(NI).GE.3)
      SJ = (NATORB(NJ).GE.3)
C
      IF ((.NOT.SI) .AND. (.NOT.SJ)) THEN
C
C     HYDROGEN - HYDROGEN  (SS/SS)
C
         AEE = PP/ADD(NI,1) + PP/ADD(NJ,1)
         AEE = AEE * AEE
         RI(1) = EV/SQRT(R*R+AEE)
         CORE(1,1 )= TORE(NJ)*RI(1)
         CORE(1,2) = TORE(NI)*RI(1)
C
      ELSE IF (SI .AND. (.NOT.SJ)) THEN
C
C     HEAVY ATOM - HYDROGEN
C
         AEE = PP/ADD(NI,1) + PP/ADD(NJ,1)
         AEE = AEE * AEE
         DA=DD(NI)
         QA=QQ(NI) * TD
         ADE = PP/ADD(NI,2) + PP/ADD(NJ,1)
         ADE = ADE * ADE
         AQE = PP/ADD(NI,3) + PP/ADD(NJ,1)
         AQE = AQE * AQE
         RSQ = R*R
         ARG(1) = RSQ + AEE
         XXX = R+DA
         ARG(2) = XXX*XXX + ADE
         XXX = R-DA
         ARG(3) = XXX*XXX + ADE
         XXX = R+QA
         ARG(4) = XXX*XXX + AQE
         XXX = R-QA
         ARG(5) = XXX*XXX + AQE
         ARG(6) = RSQ + AQE
         ARG(7) = ARG(6) + QA*QA
         DO 10 I = 1,7
            SQR(I) = SQRT(ARG(I))
   10    CONTINUE
         EE = EV/SQR(1)
         RI(1) = EE
         RI(2) = EV1/SQR(2) - EV1/SQR(3)
         RI(3) = EE + EV2/SQR(4) + EV2/SQR(5) - EV1/SQR(6)
         RI(4) = EE + EV1/SQR(7) - EV1/SQR(6)
         CORE(1,1) = TORE(NJ)*RI(1)
         CORE(1,2) = TORE(NI)*RI(1)
         CORE(2,1) = TORE(NJ)*RI(2)
         CORE(3,1) = TORE(NJ)*RI(3)
         CORE(4,1) = TORE(NJ)*RI(4)
C
      ELSE IF ((.NOT.SI).AND.SJ) THEN
C
C     HYDROGEN - HEAVY ATOM
C
         AEE = PP/ADD(NI,1) + PP/ADD(NJ,1)
         AEE = AEE * AEE
         DB=DD(NJ)
         QB=QQ(NJ) * TD
         AED = PP/ADD(NI,1) + PP/ADD(NJ,2)
         AED = AED * AED
         AEQ = PP/ADD(NI,1) + PP/ADD(NJ,3)
         AEQ = AEQ * AEQ
         RSQ = R*R
         ARG(1) = RSQ + AEE
         XXX = R-DB
         ARG(2) = XXX*XXX + AED
         XXX = R+DB
         ARG(3) = XXX*XXX + AED
         XXX = R-QB
         ARG(4) = XXX*XXX + AEQ
         XXX = R+QB
         ARG(5) = XXX*XXX + AEQ
         ARG(6) = RSQ + AEQ
         ARG(7) = ARG(6) + QB*QB
         DO 20 I = 1,7
            SQR(I) = SQRT(ARG(I))
   20    CONTINUE
         EE = EV/SQR(1)
         RI(1) = EE
         RI(5) = EV1/SQR(2)  - EV1/SQR(3)
         RI(11) = EE + EV2/SQR(4) + EV2/SQR(5) - EV1/SQR(6)
         RI(12) = EE + EV1/SQR(7) - EV1/SQR(6)
         CORE(1,1) = TORE(NJ)*RI(1)
         CORE(1,2) = TORE(NI)*RI(1)
         CORE(2,2) = TORE(NI)*RI(5)
         CORE(3,2) = TORE(NI)*RI(11)
         CORE(4,2) = TORE(NI)*RI(12)
C
      ELSE
C
C     HEAVY ATOM - HEAVY ATOM
C
C     DEFINE CHARGE SEPARATIONS.
         DA=DD(NI)
         DB=DD(NJ)
         QA=QQ(NI) * TD
         QB=QQ(NJ) * TD
C
         AEE = PP/ADD(NI,1) + PP/ADD(NJ,1)
         AEE = AEE * AEE
C
         ADE = PP/ADD(NI,2) + PP/ADD(NJ,1)
         ADE = ADE * ADE
         AQE = PP/ADD(NI,3) + PP/ADD(NJ,1)
         AQE = AQE * AQE
         AED = PP/ADD(NI,1) + PP/ADD(NJ,2)
         AED = AED * AED
         AEQ = PP/ADD(NI,1) + PP/ADD(NJ,3)
         AEQ = AEQ * AEQ
         AXX = PP/ADD(NI,2) + PP/ADD(NJ,2)
         AXX = AXX * AXX
         ADQ = PP/ADD(NI,2) + PP/ADD(NJ,3)
         ADQ = ADQ * ADQ
         AQD = PP/ADD(NI,3) + PP/ADD(NJ,2)
         AQD = AQD * AQD
         AQQ = PP/ADD(NI,3) + PP/ADD(NJ,3)
         AQQ = AQQ * AQQ
         RSQ = R * R
         ARG(1) = RSQ + AEE
         XXX = R + DA
         ARG(2) = XXX * XXX + ADE
         XXX = R - DA
         ARG(3) = XXX*XXX + ADE
         XXX = R - QA
         ARG(4) = XXX*XXX + AQE
         XXX = R + QA
         ARG(5) = XXX*XXX + AQE
         ARG(6) = RSQ + AQE
         ARG(7) = ARG(6) + QA*QA
         XXX = R-DB
         ARG(8) = XXX*XXX + AED
         XXX = R+DB
         ARG(9) = XXX*XXX + AED
         XXX = R - QB
         ARG(10) = XXX*XXX + AEQ
         XXX = R + QB
         ARG(11) = XXX*XXX + AEQ
         ARG(12) = RSQ + AEQ
         ARG(13) = ARG(12) + QB*QB
         XXX = DA-DB
         ARG(14) = RSQ + AXX + XXX*XXX
         XXX = DA+DB
         ARG(15) = RSQ + AXX + XXX*XXX
         XXX = R + DA - DB
         ARG(16) = XXX*XXX + AXX
         XXX = R - DA + DB
         ARG(17) = XXX*XXX + AXX
         XXX = R - DA - DB
         ARG(18) = XXX*XXX + AXX
         XXX = R + DA + DB
         ARG(19) = XXX*XXX + AXX
         XXX = R + DA
         ARG(20) = XXX*XXX + ADQ
         ARG(21) = ARG(20) + QB*QB
         XXX = R - DA
         ARG(22) = XXX*XXX + ADQ
         ARG(23) = ARG(22) + QB*QB
         XXX = R - DB
         ARG(24) = XXX*XXX + AQD
         ARG(25) = ARG(24) + QA*QA
         XXX = R + DB
         ARG(26) = XXX*XXX + AQD
         ARG(27) = ARG(26) + QA*QA
         XXX = R + DA - QB
         ARG(28) = XXX*XXX + ADQ
         XXX = R - DA - QB
         ARG(29) = XXX*XXX + ADQ
         XXX = R + DA + QB
         ARG(30) = XXX*XXX + ADQ
         XXX = R - DA + QB
         ARG(31) = XXX*XXX + ADQ
         XXX = R + QA - DB
         ARG(32) = XXX*XXX + AQD
         XXX = R + QA + DB
         ARG(33) = XXX*XXX + AQD
         XXX = R - QA - DB
         ARG(34) = XXX*XXX + AQD
         XXX = R - QA + DB
         ARG(35) = XXX*XXX + AQD
         ARG(36) = RSQ + AQQ
         XXX = QA - QB
         ARG(37) = ARG(36) + XXX*XXX
         XXX = QA + QB
         ARG(38) = ARG(36) + XXX*XXX
         ARG(39) = ARG(36) + QA*QA
         ARG(40) = ARG(36) + QB*QB
         ARG(41) = ARG(39) + QB*QB
         XXX = R - QB
         ARG(42) = XXX*XXX + AQQ
         ARG(43) = ARG(42) + QA*QA
         XXX = R + QB
         ARG(44) = XXX*XXX + AQQ
         ARG(45) = ARG(44) + QA*QA
         XXX = R + QA
         ARG(46) = XXX*XXX + AQQ
         ARG(47) = ARG(46) + QB*QB
         XXX = R - QA
         ARG(48) = XXX*XXX + AQQ
         ARG(49) = ARG(48) + QB*QB
         XXX = R + QA - QB
         ARG(50) = XXX*XXX + AQQ
         XXX = R + QA + QB
         ARG(51) = XXX*XXX + AQQ
         XXX = R - QA - QB
         ARG(52) = XXX*XXX + AQQ
         XXX = R - QA + QB
         ARG(53) = XXX*XXX + AQQ
         QA=QQ(NI)
         QB=QQ(NJ)
         XXX = DA - QB
         XXX = XXX*XXX
         YYY = R - QB
         YYY = YYY*YYY
         ZZZ = DA + QB
         ZZZ = ZZZ*ZZZ
         WWW = R + QB
         WWW = WWW*WWW
         ARG(54) = XXX + YYY + ADQ
         ARG(55) = XXX + WWW + ADQ
         ARG(56) = ZZZ + YYY + ADQ
         ARG(57) = ZZZ + WWW + ADQ
         XXX = QA - DB
         XXX = XXX*XXX
         YYY = QA + DB
         YYY = YYY*YYY
         ZZZ = R + QA
         ZZZ = ZZZ*ZZZ
         WWW = R - QA
         WWW = WWW*WWW
         ARG(58) = ZZZ + XXX + AQD
         ARG(59) = WWW + XXX + AQD
         ARG(60) = ZZZ + YYY + AQD
         ARG(61) = WWW + YYY + AQD
         XXX = QA - QB
         XXX = XXX*XXX
         ARG(62) = ARG(36) + TD*XXX
         YYY = QA + QB
         YYY = YYY*YYY
         ARG(63) = ARG(36) + TD*YYY
         ARG(64) = ARG(36) + TD*(QA*QA+QB*QB)
         ZZZ = R + QA - QB
         ZZZ = ZZZ*ZZZ
         ARG(65) = ZZZ + XXX + AQQ
         ARG(66) = ZZZ + YYY + AQQ
         ZZZ = R + QA + QB
         ZZZ = ZZZ*ZZZ
         ARG(67) = ZZZ + XXX + AQQ
         ARG(68) = ZZZ + YYY + AQQ
         ZZZ = R - QA - QB
         ZZZ = ZZZ*ZZZ
         ARG(69) = ZZZ + XXX + AQQ
         ARG(70) = ZZZ + YYY + AQQ
         ZZZ = R - QA + QB
         ZZZ = ZZZ*ZZZ
         ARG(71) = ZZZ + XXX + AQQ
         ARG(72) = ZZZ + YYY + AQQ
         DO 30 I = 1,72
            SQR(I) = SQRT(ARG(I))
   30    CONTINUE
         EE = EV/SQR(1)
         DZE = -EV1/SQR(2) + EV1/SQR(3)
         QZZE = EV2/SQR(4) + EV2/SQR(5) - EV1/SQR(6)
         QXXE = EV1/SQR(7) - EV1/SQR(6)
         EDZ = - EV1/SQR(8) + EV1/SQR(9)
         EQZZ  = EV2/SQR(10) + EV2/SQR(11) - EV1/SQR(12)
         EQXX  = EV1/SQR(13) - EV1/SQR(12)
         DXDX  = EV1/SQR(14) - EV1/SQR(15)
         DZDZ  = EV2/SQR(16) + EV2/SQR(17) - EV2/SQR(18) - EV2/SQR(19)
         DZQXX =  EV2/SQR(20) - EV2/SQR(21) - EV2/SQR(22) + EV2/SQR(23)
         QXXDZ =  EV2/SQR(24) - EV2/SQR(25) - EV2/SQR(26) + EV2/SQR(27)
         DZQZZ = -EV3/SQR(28) + EV3/SQR(29) - EV3/SQR(30) + EV3/SQR(31)
     1       - EV2/SQR(22) + EV2/SQR(20)
         QZZDZ = -EV3/SQR(32) + EV3/SQR(33) - EV3/SQR(34) + EV3/SQR(35)
     1       + EV2/SQR(24) - EV2/SQR(26)
         QXXQXX = EV3/SQR(37) + EV3/SQR(38) - EV2/SQR(39) - EV2/SQR(40)
     1       + EV2/SQR(36)
         QXXQYY = EV2/SQR(41) - EV2/SQR(39) - EV2/SQR(40) + EV2/SQR(36)
         QXXQZZ = EV3/SQR(43) + EV3/SQR(45) - EV3/SQR(42) - EV3/SQR(44)
     1       - EV2/SQR(39) + EV2/SQR(36)
         QZZQXX = EV3/SQR(47) + EV3/SQR(49) - EV3/SQR(46) - EV3/SQR(48)
     1       - EV2/SQR(40) + EV2/SQR(36)
         QZZQZZ = EV4/SQR(50) + EV4/SQR(51) + EV4/SQR(52) + EV4/SQR(53)
     1       - EV3/SQR(48) - EV3/SQR(46) - EV3/SQR(42) - EV3/SQR(44)
     2       + EV2/SQR(36)
         DXQXZ = -EV2/SQR(54) + EV2/SQR(55) + EV2/SQR(56) - EV2/SQR(57)
         QXZDX = -EV2/SQR(58) + EV2/SQR(59) + EV2/SQR(60) - EV2/SQR(61)
         QXYQXY = EV2/SQR(62) + EV2/SQR(63) - EV1/SQR(64)
         QXZQXZ = EV3/SQR(65) - EV3/SQR(67) - EV3/SQR(69) + EV3/SQR(71)
     1       - EV3/SQR(66) + EV3/SQR(68) + EV3/SQR(70) - EV3/SQR(72)
         RI(1) = EE
         RI(2) = -DZE
         RI(3) = EE + QZZE
         RI(4) = EE + QXXE
         RI(5) = -EDZ
         RI(6) = DZDZ
         RI(7) = DXDX
         RI(8) = -EDZ -QZZDZ
         RI(9) = -EDZ -QXXDZ
         RI(10) = -QXZDX
         RI(11) =  EE + EQZZ
         RI(12) =  EE + EQXX
         RI(13) = -DZE -DZQZZ
         RI(14) = -DZE -DZQXX
         RI(15) = -DXQXZ
         RI(16) = EE +EQZZ +QZZE +QZZQZZ
         RI(17) = EE +EQZZ +QXXE +QXXQZZ
         RI(18) = EE +EQXX +QZZE +QZZQXX
         RI(19) = EE +EQXX +QXXE +QXXQXX
         RI(20) = QXZQXZ
         RI(21) = EE +EQXX +QXXE +QXXQYY
         RI(22) = PP * (QXXQXX -QXXQYY)
C
C     CALCULATE CORE-ELECTRON ATTRACTIONS.
C
         CORE(1,1) = TORE(NJ)*RI(1)
         CORE(2,1) = TORE(NJ)*RI(2)
         CORE(3,1) = TORE(NJ)*RI(3)
         CORE(4,1) = TORE(NJ)*RI(4)
         CORE(1,2) = TORE(NI)*RI(1)
         CORE(2,2) = TORE(NI)*RI(5)
         CORE(3,2) = TORE(NI)*RI(11)
         CORE(4,2) = TORE(NI)*RI(12)
C
      END IF
C
      RETURN
C
      END

      SUBROUTINE PERM(IPERM,NELS,NMOS,MAXMOS,NPERMS)
      DIMENSION IPERM(MAXMOS,60), IADD(20), NEL(20)
************************************************************************
*
*  PERM PERMUTES NELS ENTITIES AMONG NMOS LOCATIONS. THE ENTITIES AND
*       LOCATIONS ARE EACH INDISTINGUISHABLE. THE PAULI EXCLUSION
*       PRINCIPLE IS FOLLOWED. THE NUMBER OF STATES PRODUCED IS GIVEN
*       BY NMOS!/(NELS!*(NMOS-NELS)!).
* ON INPUT: NELS  = NUMBER OF INDISTINGUISHABLE ENTITIES
*           NMOS  = NUMBER OF INDISTINGUISHABLE LOCATIONS
*
* ON OUTPUT IPERM = ARRAY OF PERMUTATIONS, A 0 INDICATES NO ENTITY,
*                   A 1 INDICATES AN ENTITY.
*           NPERM = NUMBER OF PERMUTATIONS.
*
************************************************************************
      IF(NELS.GT.NMOS)THEN
         WRITE(6,'('' NUMBER OF PARTICLES,'',I3,'' GREATER THAN NO. '',
     1''OF STATES,'',I3)')NELS,NMOS
         NPERMS=0
         RETURN
      ENDIF
      NPERMS=1
      DO 10 I=1,20
   10 NEL(I)=1000
      DO 20 I=1,NELS
   20 NEL(I)=1
      DO 50 I12=1-12+NELS,NMOS,NEL(12)
         IADD(12)=I12
         DO 50 I11=I12+1,NMOS,NEL(11)
            IADD(11)=I11
            DO 50 I10=I11+1,NMOS,NEL(10)
               IADD(10)=I10
               DO 50 I9=I10+1,NMOS,NEL(9)
                  IADD(9)=I9
                  DO 50 I8=I9+1,NMOS,NEL(8)
                     IADD(8)=I8
                     DO 50 I7=I8+1,NMOS,NEL(7)
                        IADD(7)=I7
                        DO 50 I6=I7+1,NMOS,NEL(6)
                           IADD(6)=I6
                           DO 50 I5=I6+1,NMOS,NEL(5)
                              IADD(5)=I5
                              DO 50 I4=I5+1,NMOS,NEL(4)
                                 IADD(4)=I4
                                 DO 50 I3=I4+1,NMOS,NEL(3)
                                    IADD(3)=I3
                                    DO 50 I2=I3+1,NMOS,NEL(2)
                                       IADD(2)=I2
                                       DO 50 I1=I2+1,NMOS,NEL(1)
                                          IADD(1)=I1
                                          DO 30 J=1,NMOS
   30                                     IPERM(J,NPERMS)=0
                                          DO 40 J=1,NELS
   40                                     IPERM(IADD(J),NPERMS)=1
                                          NPERMS=NPERMS+1
                                          IF(NPERMS.GT.61)THEN
                                             WRITE(6,'('' NUMBER OF PERM
     1UTATIONS TOO GREAT, LIMIT 60'')')
                                             GOTO 60
                                          ENDIF
   50 CONTINUE
   60 NPERMS=NPERMS-1
      RETURN
      END

C     ************
      PROGRAM QCD1
C     ************
C
C
C     THIS PROGRAM PERFORMS A MONTE-CARLO-SIMULATION OF THE (3+1)-DIMENSIONAL
C     SU3 LATTICE GAUGE THEORIE. THE  GAUGE VARIABLES ARE UPDATED  USING THE
C     METROPOLIS ALGORITHM.
C
C
C     LATEST REVISION NOV. 1989; E.KEHL
C
C
C     NAMING OF PARAMETERS:
C
C
C     NX    : NUMBER OF LATTICE POINTS I X-DIMENSION
C     NY    : NUMBER OF LATTICE POINTS I X-DIMENSION
C     NZ    : NUMBER OF LATTICE POINTS I Z-DIMENSION
C     NT    : NUMBER OF LATTICE POINTS I T-DIMENSION
C     NV    : TOTAL NUMBER OF LATTICE POINTS OF THE INTERIOR LATTICE
C     NVH   : HALF THE NUMBER OF LATTICE POINTS (ONE CHESS BOARD COLOUR)
C     NXYZ  : NUMBER OF LATTICE POINTS OF THE 3-D HYPERPLANE T=C
C     NXYT  : NUMBER OF LATTICE POINTS OF THE 3-D HYPERPLANE Z=C
C     NXZT  : NUMBER OF LATTICE POINTS OF THE 3-D HYPERPLANE Y=C
C     NYZT  : NUMBER OF LATTICE POINTS OF THE 3-D HYPERPLANE X=C
C     NXY   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE Z=C, T=C
C     NXZ   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE Y=C, T=C
C     NXT   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE Y=C, Z=C
C     NYZ   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE X=C, T=C
C     NYT   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE X=C, Z=C
C     NZT   : NUMBER OF LATTICE POINTS OF THE 2-D HYPERPLANE X=C, Y=C
C     NXE   : NUMBER OF LATTICE POINTS IN X-DIMENSION PLUS TWO
C     NYE   : NUMBER OF LATTICE POINTS IN Y-DIMENSION PLUS TWO
C     NZE   : NUMBER OF LATTICE POINTS IN Z-DIMENSION PLUS TWO
C     NTE   : NUMBER OF LATTICE POINTS IN T-DIMENSION PLUS TWO
C     NXYE  : NUMBER OF LATTICE POINTS OF THE 2-HYP. Z=C,T=C EXTENDED
C     NXYZE : NUMBER OF LATTICE POINTS OF THE 3-HYP.T=C EXTENDED
C     NVE   : NUMBER OF LATTICE POINTS OF THE EXTENDED LATTICE
C
C
C     NAMING OF LOOP VARIABLES:
C
C
C     ISD   : SEND DIRECTION             ;  1,2,3,4 (X,Y,Z,T)
C     IBF   : SEND BACKWARD OR FORWARD   ;  1,2     (B,F)
C     ILD   : LINK DIRECTION             ;  1,2,3,4 (X,Y,Z,T)
C     ICC   : CHESS BOARD COLOUR         ;  1,2     (BLACK,WHITE)
C     ISM   : COMPONENT OF SU(3) MATRIX  ;  1,...,18
C
C
C     NAMING OF ARRAYS AND VARIABLES
C
C
C     LINKS     : SU3 LINK VARIABLES OF THE LATTICE
C     WKI       : WORK ARRAYS FOR TEMPORARY RESULTS
C     TBL       : TABLE OF SU3 MATRICES CLOSE TO THE UNIT MATRIX
C     GCB       : INDEX LIST FOR GATHERING ONE CHESS  BOARD COLOUR
C     IRAND     : ARRAY OF INTEGER RANDOM NUMBERS
C
C
      PARAMETER( NR1   =   10                         )
      PARAMETER( NW1   =   6                         )
C
      INCLUDE 'qcd1.inc'
C
      PARAMETER( NX    =   NS                         )
      PARAMETER( NY    =   NS                         )
      PARAMETER( NZ    =   NS                         )
      PARAMETER( NV    =   NX  * NY * NZ * NT         )
      PARAMETER( NXYZ  =   NX  * NY * NZ              )
      PARAMETER( NVH   = ( NV            + 1 ) / 2    )
      PARAMETER( NXYZH = ( NX  * NY * NZ + 1 ) / 2    )
      PARAMETER( NXYTH = ( NX  * NY * NT + 1 ) / 2    )
      PARAMETER( NXZTH = ( NX  * NZ * NT + 1 ) / 2    )
      PARAMETER( NYZTH = ( NY  * NZ * NT + 1 ) / 2    )
      PARAMETER( NXYH  = ( NX  * NY      + 1 ) / 2    )
      PARAMETER( NXZH  = ( NX  * NZ      + 1 ) / 2    )
      PARAMETER( NXTH  = ( NX  * NT      + 1 ) / 2    )
      PARAMETER( NYZH  = ( NY  * NZ      + 1 ) / 2    )
      PARAMETER( NYTH  = ( NY  * NT      + 1 ) / 2    )
      PARAMETER( NZTH  = ( NZ  * NT      + 1 ) / 2    )
      PARAMETER( NXE   =   NX  + 2                    )
      PARAMETER( NYE   =   NY  + 2                    )
      PARAMETER( NZE   =   NZ  + 2                    )
      PARAMETER( NTE   =   NT  + 2                    )
      PARAMETER( NXYE  =   NXE * NYE                  )
      PARAMETER( NXYZE =   NXE * NYE * NZE            )
      PARAMETER( NVE   =   NXE * NYE * NZE * NTE      )
C
C
      DOUBLE PRECISION  LINKS( 1:NVE, 1:18, 1:4 )
C
      DOUBLE PRECISION  WK1( 1:NVH, 1:18 )
      DOUBLE PRECISION  WK2( 1:NVH, 1:18 )
      DOUBLE PRECISION  WK3( 1:NVH, 1:18 )
      DOUBLE PRECISION  WK4( 1:NVH, 1:18 )
      DOUBLE PRECISION  WK5( 1:NVH, 1:18 )
C
      DOUBLE PRECISION  TBL  ( 1:NVH, 1:2, 1:18 )
C
      DOUBLE PRECISION  BETA,SIGMA,
     >                  WLR,WLI,
     >                  WLSUMR,WLSUMI,
     >                  ZERO,RTIME,TSTART,TEND
C
C
      INTEGER  GCB  ( 1:NVH, 1:2  )
      INTEGER  GTS  ( 1:NXYZ      )
      INTEGER  IRAND( 1:NVH       )
C
      INTEGER  GX( 1:NYZTH, 1:2, 1:4 )
      INTEGER  GY( 1:NXZTH, 1:2, 1:4 )
      INTEGER  GZ( 1:NXYTH, 1:2, 1:4 )
      INTEGER  GT( 1:NXYZH, 1:2, 1:4 )
C
      INTEGER  GXY( 1:NZTH, 1:2, 1:4 )
      INTEGER  GXZ( 1:NYTH, 1:2, 1:4 )
      INTEGER  GXT( 1:NYZH, 1:2, 1:4 )
      INTEGER  GYZ( 1:NXTH, 1:2, 1:4 )
      INTEGER  GYT( 1:NXZH, 1:2, 1:4 )
      INTEGER  GZT( 1:NXYH, 1:2, 1:4 )
C
C
      INTEGER  LX(2,4),LY(2,4),
     >         LZ(2,4),LT(2,4)
C
      INTEGER  LXY(2,4),LXZ(2,4),
     >         LXT(2,4),LYZ(2,4),
     >         LYT(2,4),LZT(2,4)
C
      INTEGER  LCB(2)
      INTEGER  SHT(4)
      INTEGER  SEED,START,ORDEXP
C
C
      LOGICAL     RESULT
C
C
      PARAMETER( ZERO = 0.D0 )
C
      COMMON / PERF / RTIME(15),IPRO
C
      DATA ISU3 / 10 /
C
C
C     READ AND CHECK INPUT PARAMETERS
C
C
      iccos = 0
c
      OPEN( NR1, FILE = 'qcd1.dat' )
c--      OPEN( NW1, FILE = 'result' )
      REWIND( NR1 )
c--      REWIND( NW1 )
C
C
      READ( NR1, 1000 ) START,IAVG,IAVGDD,SEED,ITEMAX,
     >                  METHIT,ITBLUP,ORDEXP,BETA,SIGMA,
     >                  IPRO
 1000 FORMAT(7(1X/),8(57X,I6/),2(57X,F13.6/),57X,I6)
C
C
C     **********
      CALL CHKIN(
C     **********
     >           NS,NT,NW1,
     >           START,IAVG,IAVGDD,SEED,ITEMAX,
     >           METHIT,ITBLUP,ORDEXP,BETA,SIGMA)
C
C
C     **********
      CALL HEAD(
C     **********
     >          NS,NT,NW1,
     >          START,IAVG,IAVGDD,SEED,ITEMAX,
     >          METHIT,ITBLUP,ORDEXP,BETA,SIGMA )
C
C
      SHT(1) = 1
      SHT(2) = NXE
      SHT(3) = NXYE
      SHT(4) = NXYZE
C
C
C     INITIALIZATION
C
C
C     *********
      CALL INIT(
C     *********
     >          NX,NY,NZ,NT,
     >          NXYZH,NXYTH,NXZTH,NYZTH,
     >          NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >          NXE,NXYE,NXYZE,
     >          NVH,NVE,NXYZ,
     >          SEED,START,
     >          LINKS,WK1,
     >          GCB,GTS,LCB,
     >          GX,GY,GZ,GT,
     >          GXY,GXZ,GXT,GYZ,GYT,GZT,
     >          LX,LY,LZ,LT,
     >          LXY,LXZ,LXT,LYZ,LYT,LZT)
C
C
C     **********
      CALL MKTBL(NVH,ORDEXP,SIGMA,TBL,WK1,WK2,WK3,WK4)
C     **********
C
C
C     EXCHANGING SURFACE VARIABLES
C
C
      DO 20 JCC = 1,2
C
         ICC = JCC + ICCOS
         IF( ICC .EQ. 3 ) ICC = 1
         ICCOS = ICC - 1
C
      DO 20 ILD = 1,4
C
C
C     ***********
      CALL SUREXC(
C     ***********
     >            NXYZH,NXYTH,NXZTH,NYZTH,
     >            NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >            ICC,ILD,
     >            LINKS,WK1,NVE,NVH,
     >            GX,GY,GZ,GT,
     >            GXY,GXZ,GXT,GYZ,GYT,GZT,
     >            LX,LY,LZ,LT,
     >            LXY,LXZ,LXT,LYZ,LYT,LZT)
C
C
   20 CONTINUE
C
C
C     INITIALIZATION
C
C
      ITSAVG = 0
      WLSUMR = ZERO
      WLSUMI = ZERO
      ISU3M  = ISU3
      ISU3R  = ISU3
C
C
C     THE ITERATION SWEEP
C
C
      DO 15 I1 = 1,15
         RTIME(I1) = 0.0D0
 15   CONTINUE
C
C
      CALL TIMER(RTIME(1))
C
C
      DO 30 ITS = 1,ITEMAX
C
      IACPT = 0
C
C
C     UPDATEING  THE TABLE OF RANDOM SU3 MATRICES
C
C
      IF( MOD(ITS,ITBLUP) .EQ. 0 ) THEN
C
          CALL TIMER(TSTART)
C
C
C         **********
          CALL MKTBL(NVH,ORDEXP,SIGMA,TBL,WK1,WK2,WK3,WK4)
C         **********
C
C
          CALL TIMER(TEND)
          RTIME(2) = RTIME(2) + TEND - TSTART
C
      ENDIF
C
C
C     UPDATE OF LINK VARIABLES
C
C
C     LOOP OVER TWO CHESS-BOARD COLOURS
C
C
      DO 40 JCC = 1,2
C
C
      ICC = JCC + ICCOS
      IF( ICC .EQ. 3 ) ICC = 1
      ICCOS = ICC - 1
      NVL = LCB( ICC )
C
C
      DO 50 ILD = 1,4
C
C
      CALL TIMER(TSTART)
C     ***********
      CALL STAPLE(
C     ***********
     >            NVH,NVL,NVE,ICC,ILD,
     >            SHT,GCB,LINKS,
     >            WK1,WK2,WK3,WK4 )
      CALL TIMER(TEND)
      RTIME(3) = RTIME(3) + TEND - TSTART
C
C
C     ***********
      CALL GATHER( NVH,NVL,WK1,NVE,LINKS(1,1,ILD),GCB(1,ICC),0 )
C     ***********
C
C
      CALL TIMER(TSTART)
C     **********
      CALL METRO(
C     **********
     >           NVH,NVL,NV,
     >           METHIT,IACPT,BETA,
     >           TBL,
     >           WK1,WK2,WK3,WK4,WK5,
     >           IRAND)
      CALL TIMER(TEND)
      RTIME(4) = RTIME(4) + TEND - TSTART
C
C
C     CHECK LINK VARIABLES ON SU3 CHARACTERISTICS
C
C
      IF( MOD( ITS, ISU3R ) .EQ. 0 ) THEN
C
C
          CALL TIMER(TSTART)
C         ***********
          CALL SU3TST( NVH,NVL,WK1,RESULT,ITS )
C         ***********
C
C
          IF( RESULT ) THEN
C
C
C             ***********
              CALL RENORM( NVH,WK1 )
C             ***********
C
C
              ISU3M = MAX( 1, ISU3M - ISU3 )
          ELSE
              ISU3M = ISU3M + ISU3
C
          ENDIF
          ISU3R = ISU3R + ISU3M
          CALL TIMER(TEND)
          RTIME(5) = RTIME(5) + TEND - TSTART
C
C
      ENDIF
C
C
C     ***********
      CALL SCATER( NVE,NVL,LINKS(1,1,ILD),NVH,WK1,GCB(1,ICC),0 )
C     ***********
C
C
      CALL TIMER(TSTART)
C     ***********
      CALL SUREXC(
C     ***********
     >            NXYZH,NXYTH,NXZTH,NYZTH,
     >            NXYH,NXZH,NXTH,NYZH,NYTH,NZTH,
     >            ICC,ILD,
     >            LINKS,WK1,NVE,NVH,
     >            GX,GY,GZ,GT,
     >            GXY,GXZ,GXT,GYZ,GYT,GZT,
     >            LX,LY,LZ,LT,
     >            LXY,LXZ,LXT,LYZ,LYT,LZT)
      CALL TIMER(TEND)
      RTIME(6) = RTIME(6) + TEND - TSTART
C
C
   50 CONTINUE
   40 CONTINUE
C
C
C     CALCULATION OF EXPECTION VALUES
C
C
      CALL TIMER(TSTART)
      IF( MOD(ITS,IAVG) .EQ. 0 .AND.
     >        ITS .GT. IAVGDD ) THEN
C
C
C         **********
          CALL WLINE(
C         **********
     >               NVE,NXYZ,NXYZE,NT,
     >               WLR,WLI,
     >               LINKS,
     >               GTS,
     >               WK1,WK2,WK3)
C
C
          ITSAVG = ITSAVG + 1
C
C         ***********
          CALL EXPVAL(
C         ***********
     >                NV,NXYZ,METHIT,
     >                ITS,ITSAVG,NW1,
     >                WLR,WLI,IACPT,
     >                WLSUMR,WLSUMI)
C
      ENDIF
      CALL TIMER(TEND)
      RTIME(7) = RTIME(7) + TEND - TSTART
C
C
   30 CONTINUE
C
C
      CALL TIMER(TEND)
      RTIME(1) = TEND - RTIME(1)
C
C
C     PROVIDE PROFILING INFORMATION
C
C
C     ***********
      CALL PRFILE(
C     ***********
     >             NV,NW1,ISU3M,
     >             ITEMAX,METHIT)
C
C
      CLOSE( NR1 )
c--      CLOSE( NW1 )
      STOP
C
C
      END

      PROGRAM ARC2D
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C*************************************************************************
C*************************************************************************
C*************************************************************************
C                                                        *****************
C   ARC2D :  EULER VERSION FOR BENCHMARK  USE.           *****************
C            11/05/86  THOMAS H. PULLIAM                 *****************
C            NASA AMES RESEARCH CENTER                   *****************
C                                                        *****************
C*************************************************************************
C  ARC2D SOLVES THE  EULER EQUATIONS IN GENERALIZED CURVILINEAR COORDINATES
C  USING AN IMPLICIT FINITE DIFFERENCE ALGORITHM WITH APPROXIMATED 
C  FACTORIZATION AND A DIAGONALIZATION OF THE IMPLICIT OPERATORS.
C
C
C  EULER EQUATIONS :   Q_T + E_XI + F_ETA = 0
C
C      -1 | RHO |       -1|     RHO U     |      -1|    RHO V        |
C Q = J   |RHO U|, E = J  |RHO UU + XI_X P|, F = J |RHO U V + ETA_X P|
C         |RHO V|         |RHO VU + XI_Y P|        |RHO V V + ETA_Y P|
C         |  E  |         |U(E+P) - XI_T P|        |V(E+P)  - ETA_T P|
C
C    U = XI_T + XI_X U + XI_Y V,    V = ETA_T + ETA_X U + ETA_Y V
C    
C     -1
C    J   = (X_XI Y_ETA - X_ETA Y_XI)
C
C    XI_X  =  J Y_ETA, XI_Y  = -J X_ETA,  XI_T  = -X_T  XI_X - Y_T XI_Y
C   ETA_X = -J Y_XI,  ETA_Y =  J X_XI,   ETA_T = -X_T ETA_X - Y_T ETA_Y
C
C    P = (GAMMA-1) (E - 0.5 RHO (U^2 + V^2))  PRESSURE
C    U IS X COMPONENT OF VELOCITY,  V IS Y COMPONENT OF VELOCITY
C    E IS TOTAL ENERGY,  RHO IS DENSITY
C    GAMMA IS THE RATIO OF SPECIFIC HEATS (USUALLY 1.4)
C
C    NONDIMENSIONALIZATION :   RHO_INFINITY FOR RHO
C                              A_INFINITY (SPEED OF SOUND) FOR U AND V
C                              RHO_INFINITY A_INFINITY^2 FOR E
C                              REFERENCE LENGTH IS L 
C                                      (USUALLY CHORD FOR AN AIRFOIL)
C   NOTE THIS GIVES P AT INFINITY = 1./GAMMA
C
C
C   THE NUMERICAL ALGORITHM IS THE CLASS OF TWO TIME LEVEL 1ST OR 2ND
C   ORDER ACCURATE TIME IMPLICIT SCHEMES WITH SECOND ORDER CENTRAL
C   DIFFERENCES IN COMPUTATIONAL SPACE.
C   THE IMPLICIT SIDE IS APPROXIMATELY FACTORED AND DIAGONALIZED.
C   SEE: PULLIAM T. H. AND CHAUSSEE D. S. , 
C        "A DIAGONAL FORM OF AN IMPLICIT APPROXIMATE FACTORIZATION 
C         ALGORITHM", JCP 39, 1981, P347.
C
C   THE BENCHMARK TEST CASE SET UP HERE IS FOR THE UPPER HALF OF A
C   BICONVEX AIRFOIL SITTING IN A STRETCH RECTANGULAR DOMAIN.
C   THE GRID IS GENERATED INTERNALLY, SEE BICONG.
C   THE BOUNDARY CONDITIONS ARE THIN AIRFOIL TANGENCY CONDITIONS ON THE
C   AIRFOIL SURFACE,  QUASI-ONE-DIMENSIONAL RIEMANN INVARIANT CONDITIONS
C   AT INFLOW, OUTFLOW AND THE TOP OF THE DOMAIN, SEE BC.
C
C   INPUT IS HANDLED IN INPUT AND INITIA.
C   OUPUT IS HANDLED IN IOALL.
C   CONDITIONS FOR THE SUPPLIED TEST CASES ARE VARIOUS GRID SIZES AT
C   A MACH NUMBER = 0.8.  THIS GIVES TRANSONIC FLOW AND A SHOCK FOR 
C   A THICKNESS OF THE BICONVEX = 0.1
C
C   THE CODE IS SELF DOCUMENTED, SEE THE DEFINITIONS GIVEN BELOW FOR MORE 
C   DETAIL.  CONTACT THOMAS H. PULLIAM, MS 202A-1 NASA AMES RESEARCH CENTER,
C   MOFFETT FIELD, CA.,  (415-694-6417) (EMAIL: PULLIAM@PRANDTL.NAS.NASA.GOV)
C   TO REPORT PROBLEMS OR FOR QUESTIONS.
C
C*************************************************************************
C*************************************************************************
C
C     COMMON/BASE/
C
C------------------------------------------------------------------------
C                       INDICES  J,K
C------------------------------------------------------------------------
C       JMAX:   TOTAL NUMBER OF POINTS IN XI DIRECTION   (DEFAULT=193)
C       KMAX:   TOTAL NUMBER OF POINTS IN ETA DIRECTION  (DEFAULT=33 )
C       JM:     JMAX - 1
C       KM:     KMAX - 1
C       JBEGIN, JEND : ABSOLUTE LOWER AND UPPER LIMITS ON J
C                      TYPICALLY 1 AND JMAX
C       KBEGIN, KEND : ABSOLUTE LOWER AND UPPER LIMITS ON K
C                      TYPICALLY 1 AND KMAX
C------------------------------------------------------------------------
C     AUTOMATIC PERIODIC AND NONPERIODIC LOGIC IS AVAILABLE.
C
C       PERIODIC    SWITCH FOR NONPERIODIC VRS PERIODIC CODING
C               PERIODIC = F  NONPERIODIC OPTION
C               PERIODIC = T   PERIODIC OPTION           (DEFAULT=FALSE)
C       JPLUS   INDEX ARRAY FOR J DIFFERENCING
C               JPLUS(J) = J+1   
C                 JPLUS(JMAX) = JMAX FOR PERIODIC = F
C                 JPLUS(JMAX) = 1    FOR PERIODIC = T
C       JMINU   INDEX ARRAY FOR J DIFFERENCING
C               JMINU (J) = J+1
C                 JMINU (1) = 1    FOR PERIODIC = F
C                 JMINU (1) = JMAX FOR PERIODIC = T
C       JLOW    LOWER DO LOOP LIMIT IN J DIRECTION
C                  JLOW = 2  FOR PERIODIC = F
C                  JLOW = 1  FOR PERIODIC = T
C       JUP     UPPER DO LOOP LIMIT IN J DIRECTION
C                  JUP = JMAX-1  FOR PERIODIC = F
C                  JUP = JMAX    FOR PERIODIC = T
C       KLOW    LOWER DO LOOP LIMIT IN K DIRECTION
C                  KLOW = 2  TYPICALLY
C       KUP     UPPER DO LOOP LIMIT IN K DIRECTION
C                  KUP = KMAX-1  TYPICALLY
C------------------------------------------------------------------------
C
C      NP:      CALLS IOALL(15) TO SHOW RHO, U, V, E, P, CP, MACH, X, Y
C               (DEFAULT=10000)
C
C       DT:     TIME STEP            (DEFAULT=5.0)
C               EITHER A TRUE DT FOR TIME ACCURATE COMPUTATION
C               OR A SCALING FACTOR FOR THE SPATIALLY VARIABLE TIME STEP
C               [ IN STEADY STATE CALCULATION DT IS ORDER(1.0) ]
C
C       CP2TIM:  ELAPSED CPU TIME OF THE RUN.  
C                 NOTE CHECK FUNCTION SECOND FOR INSTRUCTIONS FOR 
C                 MACHINE DEPENDENT CHANGES.
C------------------------------------------------------------------------
C       FSMACH: FREE STREAM MACH NUMBER                (DEFAULT=0.397)
C               READ IN IN IOALL(1)
C       ALPHA:  ANGLE OF ATTACK OF AIRFOIL             (DEFAULT=0.0 )
C               READ IN IN IOALL(1)
C       GAMMA:  GAS CONSTANT ( 1.4 )
C       GAMI:   GAMMA - 1
C       PI  :   4.*ATAN(1.0)
C------------------------------------------------------------------------
C                 DISSIPATION PARAMETERS
C------------------------------------------------------------------------
C
C       DIS2X:  SECOND ORDER X COEFFICIENT FOR FILTER       (DEFAULT=0.0)
C       DIS2Y:  SECOND ORDER Y COEFFICIENT FOR FILTER       (DEFAULT=0.0)
C               READ IN IN IOALL(1) ONLY USED FOR METH = 2,3  
C               USED IN FILERX, FILERY, STEPFX, STEPFY 
C       DIS4X:  FOURTH ORDER X COEFFICIENT FOR FILTER       (DEFAULT=0.64)
C       DIS4Y:  FOURTH ORDER Y COEFFICIENT FOR FILTER       (DEFAULT=0.64)
C               READ IN IN IOALL(1) ONLY USED FOR METH = 2,3  
C               USED IN FILERX, FILERY,  STEPFX, STEPFY 
C------------------------------------------------------------------------
C       JACDT:  SWITCH TO TURN ON VARIABLE TIME STEP.    (DEFAULT = 1)
C                      FOR UNSTEADY PROBLEMS USE CONSTANT TIME STEP.
C                      FOR STEADY - STATE USE VARIABLE TIME STEP.
C               READ IN IN IOALL(1)
C                       =0 : CONSTANT TIME STEP
C                       =1 : TIME STEP SCALED BY JACOBIAN
C                       =2 : TIME STEP BASED ON MINIMUM 1/EIGENVALUES
C                       =3 : TIME STEP BASED CONSTANT CFL AT EACH POINT
C
C------------------------------------------------------------------------
C------------------------------------------------------------------------
C       RESID:  ASSIGNED TO IN RESIL2 OUTPUT IN IOALL(8) ONTO TAPE7
C                       OUTPUT IN IOALL(5) TO TAPE6
C                       ZEROED IN INITIA
C                       2-NORM OF RESIDUAL
C
C       IPRINT: OUTPUT SWITCH FOR FREQUENCY OF RESIDUAL HISTORY OUTPUT
C               ON UNIT 6 ( MAIN )                      (DEFAULT=1)
C
C------------------------------------------------------------------------
C                     GRID PARAMETERS
C------------------------------------------------------------------------
C      DYM:    MINIMUM SPACING AT BODY FOR BICONVEX AIRFOIL
C      YMAX:      UPPER DIMENSION IN CORD LENGTHS FOR BICONVEX GRID
C      XMIN:      LEFT DIMENSION IN CORD LENGTHS FOR BICONVEX GRID
C      XMAX:      RIGHT DIMENSION IN CORD LENGTHS FOR BICONVEX GRID
C      THICK:      THICKNESS RATIO FOR BICONVEX AIRFOIL 
C      JTAIL1:      FIRST SOLID BODY POINT 
C      JTAIL2: LAST SOLID BODY POINT 
C       SLOPE:  SLOPE OF THE AIRFOIL, USED FOR  BICONVEX CASE 
C               SET IN INITIA, USED IN BC
C
C------------------------------------------------------------------------
C                    TIME ACCURACY PARAMETERS
C------------------------------------------------------------------------
C      A CLASS OF THREE STEP FIRST OR SECOND ORDER TIME ACCURACTE SCHEMES 
C      CAN BE EMPLOYED.  FOR STEADY STATE EULER IMPLICIT PERFORMS THE BEST.
C      FOR UNSTEADY, 3PT IMPLICIT IS A GOOD CHOICE.
C
C       PHIDT         TIME INTEGRATION PARAMETERS : 
C       THETAD        PHIDT = 0   THETAD  = 1    EULER IMPLICIT (DEFAULT)
C                     PHIDT = 0   THETAD  = 1/2  TRAP. IMPLICIT
C                     PHIDT = 1/2 THETAD  = 1    3PT   IMPLICIT
C
C------------------------------------------------------------------------
C      NUMITE :      ITERATION COUNTER FOR MAIN STEPS
C       ISTART:         THE STARTING ITERATION,
C                               READ IN FROM THE RESTART
C       NSTEPS:          TOTAL NUMBER OF ITERATION STEPS
C----------------------------------------------------------------------
C-----------------------   VARIABLES   --------------------------------
C----------------------------------------------------------------------
C      Q:      CONSERVATIVE VARIABLES
C            Q(I,J, 1)     DENSITY / DETERMINANT OF METRIC JACOBIAN
C            Q(I,J, 2)     DENSITY * U / DETERMINANT OF METRIC JACOBIAN
C            Q(I,J, 3)     DENSITY * V / DETERMINANT OF METRIC JACOBIAN
C            Q(I,J, 4)     ENERGY / DETERMINANT OF METRIC JACOBIAN
C
C       PRESS :  PRESSURE = GAMI*(Q(4) - 0.5*(Q(2)**2+Q(3)**2)/Q(1))
C                NOTE:  HAS JACOBIAN IN IT
C       SNDSP :  A = SQRT(GAMMA*PRESS/Q(1))
C                NOTE:  DOESN'T HAVE JACOBIAN IN IT
C      S:      
C          USED FOR EXPLICIT RIGHT HAND SIDE IN RHS,
C           ALTERED IN VISRHS,
C          SMOOTHED IN SMOOTH,FILTER 
C           USED FOR INTERMEDIATE QUANTITIES IN THE AF SCHEME IN STEP, ETC. 
C           AND ULTIMATELY HOLDS THE CHANGE IN Q.
C      XY:      METRIC TRANSFORMATIONS
C            XY(I,J, 1)     D XI / DX
C            XY(I,J, 2)     D XI / DY
C            XY(I,J, 3)     D ETA / DX
C            XY(I,J, 4)     D ETA / DY
C      XYJ:      JACOBIANS OF METRIC TRANSFORMATIONS
C            = ( DXI/DX * DETA/DY ) - ( DXI/DY * DETA/DX )
C      XIT:      D XI / DT
C      ETT:      D ETA / DT
C      DS:      SPATIALLY VARIABLE TIME STEP, SCALED ON METRIC JACOBIAN,
C                  SET IN INITIA, USED IN STEP, STEPF, 
C                                         EIGEN, FLMATX2, FLMATY2
C      X:      CARTESIAN X COORDINATES OF THE GRID.
C      Y:      CARTESIAN Y COORDINATES OF THE GRID.
C
C
C   TO CHANGE DIMENSIONS:::  MODIFY ALL THE PARAMETRER STATEMENTS
C                            MAXJ = MAXIMUM J DIMENSION
C                            MAXK = MAXIMUM K DIMENSION
C                            MAXJK = PRODUCT MAXJ*MAXK
C                            
      PARAMETER (MAXJ=165, MAXK=48, MAXJK=MAXJ*MAXK  )
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(MAXJK*4)
      DIMENSION PRESS(MAXJK),SNDSP(MAXJK)
      DIMENSION S(MAXJK*4),XY(MAXJK*4),XYJ(MAXJK)
      DIMENSION XIT(MAXJK),ETT(MAXJK),DS(MAXJK)
      DIMENSION X(MAXJK),Y(MAXJK)
      DIMENSION DELTQN(MAXJK*4),SLOPE(MAXJ)
      DIMENSION UU(MAXJK),VV(MAXJK),CCX(MAXJK),CCY(MAXJK)
      DIMENSION COEF4X(MAXJK),COEF4Y(MAXJK)
      DIMENSION COEF2X(MAXJK),COEF2Y(MAXJK)
C
C
      COMMON/WORKSP/WORK2(MAXJ,92)
      COMMON/WORK/WORK1(MAXJK*10)
C
      EXTERNAL ZECOND
C      
      CALL INITIM()
C
C  INPUT DATA 
C
       CALL INPUT(MAXJ,MAXJK)
C
C           INITIALIZE CPU TIME COUNTER
C
       CPTIM0 = ZECOND(DUMMY)
C
          PRINT *, '--------------------------------------------'
          PRINT *,'        CPUTIM AT START = ',CPTIM0
          PRINT *, '--------------------------------------------'
C
C
C  INITIALIZE VARIABLES
C
C   SET JDIMEN,KDIMEN
C
      JDIMEN  = JMAX
      KDIMEN  = KMAX
C
C
      CALL INITIA(JDIMEN,KDIMEN,Q,PRESS,SNDSP,S,XY,XYJ,
     *                  XIT,ETT,DS,X,Y,SLOPE)
C
C
C  PERFORM INTEGRATION
C
         ISTART = 1
         IEND   = NSTEPS
         DO 10 NUMITE  = ISTART,IEND
       
         CALL INTEGR(JDIMEN,KDIMEN,Q,S,PRESS,SNDSP,SLOPE,
     +           X,Y,XY,XYJ,XIT,ETT,DS,DELTQN,
     +           UU,VV,CCX,CCY,COEF2X,COEF2Y,COEF4X,COEF4Y)

C
C  COMPUTE CPUTIM
C
         CP2TIM = ZECOND(DUMMY) - CPTIM0
C
C*********************************************************************
C***  RESIDUAL, SS PTS,                                            ***
C*********************************************************************
      IP = 5
         IF( MOD( NUMITE  - ISTART + 1, IPRINT) .EQ. 0 ) 
     * CALL IOALL(IP,JDIMEN,KDIMEN,Q,PRESS,SNDSP,XY,XYJ,X,Y)
C*********************************************************************
C***            WRITE OUT RHO, U, V, E, P, CP, MACH, X, Y          ***
C***                     ONTO TAPE6 EVERY NP ITERATIONS            ***
C*********************************************************************
      IP = 15
         IF ( MOD( NUMITE  - ISTART + 1, NP) .EQ. 0 ) 
     * CALL IOALL(IP,JDIMEN,KDIMEN,Q,PRESS,SNDSP,XY,XYJ,X,Y)
C
C*********************************************************************
10       CONTINUE
C*********************************************************************
C
C
C  FINAL OUTPUT
C
C          Q SOLUTION FILE FOR PLOTTING
      CALL  IOALL(10,JDIMEN,KDIMEN,Q,PRESS,SNDSP,XY,XYJ,X,Y)
C          XY GRID FILE FOR PLOTTING
      CALL  IOALL(16,JDIMEN,KDIMEN,Q,PRESS,SNDSP,XY,XYJ,X,Y)
C          CP VRS X
      CALL  IOALL(6,JDIMEN,KDIMEN,Q,PRESS,SNDSP,XY,XYJ,X,Y)
C***********************************************************************
      CALL SHOTIM()
      STOP
      END

      PROGRAM INVPOW
C     
C.. THISPROGRAM WILL EXTRACT NUMEIG LOWEST EIGENVALUES AND EIGENVECTORS
C     OF SYMMETRIC POSITIVE DEFINITE MATRIX A USING INVERSE POWER METHOD
C     
C     Original version by Sami Saarinen, CSC for Finnish Supercomputer
C     Evaluation Project (1988)
C     
C     Version 2 by Sami Saarinen, CSC for OPMVAX Replacement Project
C     (1991). Major changes in release:
C     
C     - ABS -> DABS, SQRT -> DSQRT
C     - source code indenting for better understanding
C     - matrix input file read in packed format (subr. READI)
C     - removal of I/O -operations and introdution of tmp-tables
c
c     Version 3
c     - I/O added back (in PUTSCR) and atmp(,) removed
C     
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (N=605)
c--      PARAMETER (N=2015)
      DIMENSION A(N,N),ZK(N),YK(N),WORK2(N),WORK1(1),EIGV(N)
c--      dimension atmp(n,n)
c--      common /base/ a,zk,atmp
      common /base/ a,zk
      CHARACTER*40 FILNAM                           
      EQUIVALENCE (WORK1(1),YK(1))
C     
      CALL MESAGE('** JOB STARTED **   ',1,1)
C     
      WRITE(6,*)'ENTER NUMBER OF EIGENVALUES TO BE FOUND:'
      READ(5,*) NUMEIG
      WRITE(6,*)'NUMEIG=',NUMEIG
      WRITE(6,*)'ENTER CONVERGENCE TOLERANCE:'
      READ(5,*) CTOL
      CTOL=DABS(CTOL)
      WRITE(6,*)'CTOL=',CTOL
      WRITE(6,*)'ENTER NUMBER OF ITERATIONS ALLOWED:'
      READ(5,*) MAXIT  
      WRITE(6,*)'MAXIT=',MAXIT
C     WRITE(6,*)'ENTER INPUT MATRIX FILE NAME:'
C     READ(5,FMT='(A)') FILNAM
C     WRITE(6,*)'FILENAME='//FILNAM
CDEP  
      OPEN(1,file='invpow.mat',STATUS='OLD')
C     
      CALL MESAGE('** READ MATRIX A    ',6,1)
C     
      READ(1,*) NN      
      WRITE(6,*)'MATRIX SIZE=',NN
      CALL READI(1,A,ZK,NN)
C     
      CALL MESAGE('** READ MATRIX DONE ',6,0)
C     
      CLOSE(1)     
C     
C.. FINDNUMEIG EIGENVALUES AND -VECTORS
C     
CDEP  
      OPEN(20,STATUS='UNKNOWN',FORM='UNFORMATTED')
C     
      NDOF=NN
      DO 100 IEIG=1,NUMEIG
         WRITE(6,*)'----- EIGENVALUE NUMBER ',IEIG,' -----'
C     
         CALL MESAGE('** MAIN LOOP 100 ** ',2,1)
C     
C.. WRITEMATRIX A TO A SCRATCH FILE
         CALL PUTSCR(20,A,NN,NN,1)
c--         CALL PUTSCR(atmp,A,NN,NN,1)
C.. COPYDIAGONALS TO INITIAL GUESS EIGENVECTOR
         CALL COPDIA(A,NN,ZK)                   
C.. FINDTHE MOST SUITABLE SHIFT VALUE
         CALL PUTSHF(A,YK,NN,ESHIFT)
C.. DECOMPOSEMATRIX  A-ESHIFT*I  ONCE PER EIGENVALUE
C     
         CALL MESAGE('** LU-DECOMP STARTED',4,1)
C     
         CALL DECOM3(1,A,YK,NN)            
C     
         CALL MESAGE('** LU-DECOMP DONE   ',4,0)
C     
C.. EXTRACTEIGENVALUE BY USING INVERSE POWER METHOD
C     
         CALL MESAGE('** EIGV. EXTRACTION ',5,1)
C     
         CALL EIGENV(A,ZK,YK,NN,CTOL,MAXIT,IEIG,ESHIFT,EIGV(IEIG))
C     
         CALL MESAGE('** EXTRACTION DONE  ',5,0)
C     
C.. PRINTOUT THE SOLUTION VECTOR
C     CALL WRITEO(ZK,NN)
C.. GETMATRIX A FROM AUXILIARY STORAGE
         CALL GETSCR(20,A,NN,NN)      
c--         CALL GETSCR(atmp,A,NN,NN)      
C.. PERFORMSOLUTION ERROR CHECK
         CALL ECHECK(A,ZK,YK,NN,EIGV(IEIG))
         IF (IEIG.EQ.NUMEIG) GOTO 105
         IF (IEIG.EQ.1)                               
     +        OPEN(21,STATUS='UNKNOWN',FORM='UNFORMATTED') 
C.. DO DEFLATION
C     
         CALL MESAGE('** DEFLATION STARTED',3,1)
C     
         CALL DEFLAT(A,ZK,NN,WORK1,WORK2,21)
c--         CALL DEFLAT(A,ZK,NN,WORK1,WORK2)
C.. REDUCETHE ORDER OF PROBLEM
         NN=NN-1
         WRITE(6,*)
     +        '** THE ORDER OF PROBLEM HAS BEEN REDUCED TO ',NN
C     
         CALL MESAGE('** DEFLATION DONE   ',3,0)
C     
 105     CONTINUE
C     
         CALL MESAGE('** MAIN LOOP 100 ** ',2,0)
C     
 100  CONTINUE                             
C     
      WRITE(6,2010)'NUMBER','EIGENVALUE'
 2010 FORMAT(5X,A12,5X,A15)
      DO 200 IEIG=1,NUMEIG
         WRITE(6,2000) IEIG,EIGV(IEIG)
 200  CONTINUE
 2000 FORMAT(5X,I12,5X,1P,G20.10)            
C     
      CALL MESAGE('** END OF JOB **    ',1,0)
C     
      STOP 'OK EXIT'
      END

      SUBROUTINE INTERP(N,NP,NQ,MODE,E,FP,CP,VEC,FOCK,P,H,VECL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION FP(MPACK), CP(N,N)
      DIMENSION VEC(N,N), FOCK(N,N),
     1          P(N,N), H(N*N), VECL(N*N)
**********************************************************************
*
* INTERP: AN INTERPOLATION PROCEDURE FOR FORCING SCF CONVERGANCE
*         ORIGINAL THEORY AND FORTRAN WRITTEN BY R.N. CAMP AND
*         H.F. KING, J. CHEM. PHYS. 75, 268 (1981)
**********************************************************************
*
* ON INPUT N     = NUMBER OF ORBITALS
*          NP    = NUMBER OF FILLED LEVELS
*          NQ    = NUMBER OF EMPTY LEVELS
*          MODE  = 1, DO NOT RESET.
*          E     = ENERGY
*          FP    = FOCK MATRIX, AS LOWER HALF TRIANGLE, PACKED
*          CP    = EIGENVECTORS OF FOCK MATRIX OF ITERATION -1
*                  AS PACKED ARRAY OF N*N COEFFICIENTS
*
* ON OUTPUT CP   = BEST GUESSED SET OF EIGENVECTORS
*           MODE = 2 OR 3 - USED BY CALLING PROGRAM
**********************************************************************
      DIMENSION THETA(MAXORB), IA(MAXORB)
      COMMON /KEYWRD/ KEYWRD
      COMMON/FIT/NPNTS,IDUM2,XLOW,XHIGH,XMIN,EMIN,DEMIN,X(12),F(12),
     1 DF(12)
      LOGICAL FIRST, DEBUG, DEBUG1
      CHARACTER*80 KEYWRD
      DATA ZERO,FF,RADMAX/0.0,0.9,1.5708/,FIRST/.TRUE./
      IF(FIRST)THEN
         DEBUG=(INDEX(KEYWRD,'INTERP').NE.0)
         DEBUG1=(INDEX(KEYWRD,'DEBUG').NE.0.AND.DEBUG)
         FIRST=.FALSE.
         DO 10 I=1,MAXORB
   10    IA(I)=(I*I-I)/2
      ENDIF
C
C     RADMAX=MAXIMUM ROTATION ANGLE (RADIANS).  1.5708 = 90 DEGREES.
C         FF=FACTOR FOR CONVERGENCE TEST FOR 1D SEARCH.
C
      MINPQ=MIN0(NP,NQ)
      MAXPQ=MAX0(NP,NQ)
      NP1=NP+1
      NP2=MAX0(1,NP/2)
      IF(MODE.EQ.2) GO TO 110
C
C     (MODE=1 OR 3 ENTRY)
C     TRANSFORM FOCK MATRIX TO CURRENT MO BASIS.
C     ONLY THE OFF DIAGONAL OCC-VIRT BLOCK IS COMPUTED.
C     STORE IN FOCK ARRAY
C
      II=0
      DO 50 I=1,N
         I1=I+1
         DO 40 J=1,NQ
            DUM=ZERO
            DO 20 K=1,I
   20       DUM=DUM+FP(II+K)*CP(K,J+NP)
            IF(I.EQ.N) GO TO 40
            IK=II+I+I
            DO 30 K=I1,N
               DUM=DUM+FP(IK)*CP(K,J+NP)
   30       IK=IK+K
   40    P(I,J)=DUM
   50 II=II+I
      DO 80 I=1,NP
         DO 70 J=1,NQ
            DUM=ZERO
            DO 60 K=1,N
   60       DUM=DUM+CP(K,I)*P(K,J)
            FOCK(I,J)=DUM
   70    CONTINUE
   80 CONTINUE
      IF(MODE.EQ.3) GO TO 100
C
C     CURRENT POINT BECOMES OLD POINT (MODE=1 ENTRY)
C
      DO 90 I=1,N
         DO 90 J=1,N
   90 VEC(I,J)=CP(I,J)
      EOLD=E
      XOLD=1.0
      MODE=2
      RETURN
C
C     (MODE=3 ENTRY)
C     FOCK CORRESPONDS TO CURRENT POINT IN CORRESPONDING REPRESENTATION.
C     VEC DOES NOT HOLD CURRENT VECTORS. VEC SET IN LAST MODE=2 ENTRY.
C
  100 NPNTS=NPNTS+1
      IF(DEBUG)WRITE(6,'(''   INTERPOLATED ENERGY:'',F13.6)')E*23.061D0
      IPOINT=NPNTS
      GO TO 500
C
C    (MODE=2 ENTRY) CALCULATE THETA, AND U, V, W MATRICES.
C                   U ROTATES CURRENT INTO OLD MO.
C                   V ROTATES CURRENT INTO CORRESPONDING CURRENT MO.
C                   W ROTATES OLD INTO CORRESPONDING OLD MO.
C
  110 J1=1
      DO 140 I=1,N
         IF(I.EQ.NP1) J1=NP1
         DO 130 J=J1,N
            P(I,J)=ZERO
            DO 120 K=1,N
  120       P(I,J)=P(I,J)+CP(K,I)*VEC(K,J)
  130    CONTINUE
  140 CONTINUE
C
C     U = CP(DAGGER)*VEC IS NOW IN P ARRAY.
C     VEC IS NOW AVAILABLE FOR TEMPORARY STORAGE.
C
      IJ=0
      DO 170 I=1,NP
         DO 160 J=1,I
            IJ=IJ+1
            H(IJ)=0.D0
            DO 150 K=NP1,N
  150       H(IJ)=H(IJ)+P(I,K)*P(J,K)
  160    CONTINUE
  170 CONTINUE
      CALL HQRII(H,NP,NP,THETA,VECL)
      DO 180 I=NP,1,-1
         IL=I*NP-NP
         DO 180 J=NP,1,-1
  180 VEC(J,I)=VECL(J+IL)
      DO 200 I=1,NP2
         DUM=THETA(NP1-I)
         THETA(NP1-I)=THETA(I)
         THETA(I)=DUM
         DO 190 J=1,NP
            DUM=VEC(J,NP1-I)
            VEC(J,NP1-I)=VEC(J,I)
  190    VEC(J,I)=DUM
  200 CONTINUE
      DO 210 I=1,MINPQ
         THETA(I)=MAX(THETA(I),ZERO)
         THETA(I)=MIN(THETA(I),1.D0)
  210 THETA(I)=ASIN(SQRT(THETA(I)))
C
C     THETA MATRIX HAS NOW BEEN CALCULATED, ALSO UNITARY VP MATRIX
C     HAS BEEN CALCULATED AND STORED IN FIRST NP COLUMNS OF VEC MATRIX.
C     NOW COMPUTE WQ
C
      DO 240 I=1,NQ
         DO 230 J=1,MINPQ
            VEC(I,NP+J)=ZERO
            DO 220 K=1,NP
  220       VEC(I,NP+J)=VEC(I,NP+J)+P(K,NP+I)*VEC(K,J)
  230    CONTINUE
  240 CONTINUE
      CALL SCHMIT(VEC(1,NP1),NQ,N)
C
C     UNITARY WQ MATRIX NOW IN LAST NQ COLUMNS OF VEC MATRIX.
C     TRANSPOSE NP BY NP BLOCK OF U STORED IN P
C
      DO 260 I=1,NP
         DO 250 J=1,I
            DUM=P(I,J)
            P(I,J)=P(J,I)
  250    P(J,I)=DUM
  260 CONTINUE
C
C     CALCULATE WP MATRIX AND HOLD IN FIRST NP COLUMNS OF P
C
      DO 300 I=1,NP
         DO 270 K=1,NP
  270    H(K)=P(I,K)
         DO 290 J=1,NP
            P(I,J)=ZERO
            DO 280 K=1,NP
  280       P(I,J)=P(I,J)+H(K)*VEC(K,J)
  290    CONTINUE
  300 CONTINUE
      CALL SCHMIB(P,NP,N)
C
C     CALCULATE VQ MATRIX AND HOLD IN LAST NQ COLUMNS OF P MATRIX.
C
      DO 340 I=1,NQ
         DO 310 K=1,NQ
  310    H(K)=P(NP+I,NP+K)
         DO 330 J=NP1,N
            P(I,J)=ZERO
            DO 320 K=1,NQ
  320       P(I,J)=P(I,J)+H(K)*VEC(K,J)
  330    CONTINUE
  340 CONTINUE
      CALL SCHMIB(P(1,NP1),NQ,N)
C
C     CALCULATE (DE/DX) AT OLD POINT
C
      DEDX=ZERO
      DO 370 I=1,NP
         DO 360 J=1,NQ
            DUM=ZERO
            DO 350 K=1,MINPQ
  350       DUM=DUM+THETA(K)*P(I,K)*VEC(J,NP+K)
  360    DEDX=DEDX+DUM*FOCK(I,J)
  370 CONTINUE
C
C     STORE OLD POINT INFORMATION FOR SPLINE FIT
C
      DEOLD=-4.0*DEDX
      X(2)=XOLD
      F(2)=EOLD
      DF(2)=DEOLD
C
C     MOVE VP OUT OF VEC ARRAY INTO FIRST NP COLUMNS OF P MATRIX.
C
      DO 380 I=1,NP
         DO 380 J=1,NP
  380 P(I,J)=VEC(I,J)
      K1=0
      K2=NP
      DO 410 J=1,N
         IF(J.EQ.NP1) K1=NP
         IF(J.EQ.NP1) K2=NQ
         DO 400 I=1,N
            DUM=ZERO
            DO 390 K=1,K2
  390       DUM=DUM+CP(I,K1+K)*P(K,J)
  400    VEC(I,J)=DUM
  410 CONTINUE
C
C     CORRESPONDING CURRENT MO VECTORS NOW HELD IN VEC.
C     COMPUTE VEC(DAGGER)*FP*VEC
C     STORE OFF-DIAGONAL BLOCK IN FOCK ARRAY.
C
  420 II=0
      DO 460 I=1,N
         I1=I+1
         DO 450 J=1,NQ
            DUM=ZERO
            DO 430 K=1,I
  430       DUM=DUM+FP(II+K)*VEC(K,J+NP)
            IF(I.EQ.N) GO TO 450
            IK=II+I+I
            DO 440 K=I1,N
               DUM=DUM+FP(IK)*VEC(K,J+NP)
  440       IK=IK+K
  450    P(I,J)=DUM
  460 II=II+I
      DO 490 I=1,NP
         DO 480 J=1,NQ
            DUM=ZERO
            DO 470 K=1,N
  470       DUM=DUM+VEC(K,I)*P(K,J)
            FOCK(I,J)=DUM
  480    CONTINUE
  490 CONTINUE
C
C     SET LIMITS ON RANGE OF 1-D SEARCH
C
      NPNTS=2
      IPOINT=1
      XNOW=ZERO
      XHIGH=RADMAX/THETA(1)
      XLOW=-0.5*XHIGH
C
C     CALCULATE (DE/DX) AT CURRENT POINT AND
C     STORE INFORMATION FOR SPLINE FIT
C     ***** JUMP POINT FOR MODE=3 ENTRY *****
C
  500 DEDX=ZERO
      DO 510 K=1,MINPQ
  510 DEDX=DEDX+THETA(K)*FOCK(K,K)
      DENOW=-4.0*DEDX
      ENOW=E
      IF(IPOINT.LE.12) GO TO 530
  520 FORMAT(//' EXCESSIVE DATA PNTS FOR SPLINE.'/
     1,' IPOINT =',I3,' MAXIMUM IS 12.')
C
C     PERFORM 1-D SEARCH AND DETERMINE EXIT MODE.
C
  530 X(IPOINT)=XNOW
      F(IPOINT)=ENOW
      DF(IPOINT)=DENOW
      CALL SPLINE
      IF((EOLD-ENOW).GT.FF*(EOLD-EMIN).OR.IPOINT.GT.10) GO TO 560
C
C     (MODE=3 EXIT) RECOMPUTE CP VECTORS AT PREDICTED MINIMUM.
C
      XNOW=XMIN
      DO 550 K=1,MINPQ
         CK=COS(XNOW*THETA(K))
         SK=SIN(XNOW*THETA(K))
         IF(DEBUG)WRITE(6,'('' ROTATION ANGLE:'',F12.4)')SK*57.29578
         DO 540 I=1,N
            CP(I,K)   =CK*VEC(I,K)-SK*VEC(I,NP+K)
  540    CP(I,NP+K)=SK*VEC(I,K)+CK*VEC(I,NP+K)
  550 CONTINUE
      MODE=3
      RETURN
C
C     (MODE=2 EXIT) CURRENT VECTORS GIVE SATISFACTORY ENERGY IMPROVEMENT
C     CURRENT POINT BECOMES OLD POINT FOR THE NEXT 1-D SEARCH.
C
  560 IF(MODE.EQ.2) GO TO 580
      DO 570 I=1,N
         DO 570 J=1,N
  570 VEC(I,J)=CP(I,J)
      MODE=2
  580 ROLD=XOLD*THETA(1)*57.29578
      RNOW=XNOW*THETA(1)*57.29578
      RMIN=XMIN*THETA(1)*57.29578
      IF(DEBUG)WRITE(6,600) XOLD,EOLD*23.061,DEOLD,ROLD
     1,             XNOW,ENOW*23.061,DENOW,RNOW
     2,             XMIN,EMIN*23.061,DEMIN,RMIN
      EOLD=ENOW
      IF(NPNTS.LE.200) RETURN
      WRITE(6,610)
      DO 590 K=1,NPNTS
  590 WRITE(6,620) K,X(K),F(K),DF(K)
      WRITE(6,630)
      RETURN
  600 FORMAT(
     1/14X,3H X ,10X,6H F(X) ,9X,7H DF/DX ,21H   ROTATION (DEGREES),
     2/10H      OLD ,F10.5,3F15.10,
     3/10H  CURRENT ,F10.5,3F15.10,
     4/10H PREDICTED,F10.5,3F15.10/)
  610 FORMAT(3H  K,10H     X(K) ,15H       F(K)    ,10H     DF(K))
  620 FORMAT(I3,F10.5,2F15.10)
  630 FORMAT(10X)
      END

      SUBROUTINE SWAP(C,N,MDIM,NOCC,IFILL)
      IMPLICIT  DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION C(MDIM,MDIM)
C******************************************************************
C
C        SWAP ENSURES THAT A NAMED MOLECULAR ORBITAL IFILL IS FILLED
C ON INPUT
C          C = EIGENVECTORS IN A MDIM*MDIM MATRIX
C          N = NUMBER OF ORBITALS
C          NOCC = NUMBER OF OCCUPIED ORBITALS
C          IFILL = FILLED ORBITAL
C******************************************************************
      COMMON /SWAP0/ PSI(MAXORB), STDPSI(MAXORB)
      IF(IFILL.GT.0) GOTO 20
C
C     WE NOW DEFINE THE FILLED ORBITAL
C
      IFILL=-IFILL
      DO 10 I=1,N
         STDPSI(I)=C(I,IFILL)
   10 PSI(I)=C(I,IFILL)
      RETURN
   20 CONTINUE
C
C     FIRST FIND THE LOCATION OF IFILL
C
      SUM=0.D0
      DO 30 I=1,N
   30 SUM=SUM+PSI(I)*C(I,IFILL)
      IF(ABS(SUM).GT.0.7071D0) GOTO 90
C
C     IFILL HAS MOVED!
C
      SUMMAX=0.D0
      DO 50 IFILL=1,N
         SUM=0.D0
         DO 40 I=1,N
   40    SUM=SUM+STDPSI(I)*C(I,IFILL)
         SUM=ABS(SUM)
         IF(SUM.GT.SUMMAX)JFILL=IFILL
         IF(SUM.GT.SUMMAX)SUMMAX=SUM
         IF(SUM.GT.0.7071D0) GOTO 90
   50 CONTINUE
      DO 70 IFILL=1,N
         SUM=0.D0
         DO 60 I=1,N
   60    SUM=SUM+PSI(I)*C(I,IFILL)
         SUM=ABS(SUM)
         IF(SUM.GT.SUMMAX)JFILL=IFILL
         IF(SUM.GT.SUMMAX)SUMMAX=SUM
         IF(SUM.GT.0.7071D0) GOTO 90
   70 CONTINUE
      WRITE(6,80)SUMMAX,JFILL
   80 FORMAT(/,' CAUTION !!! SUM IN SWAP VERY SMALL, SUMMAX =',F10.5,
     1' JFILL=',I3)
      IFILL=JFILL
   90 CONTINUE
      IF(IFILL.LE.NOCC) RETURN
C
C    ITS EMPTY, SO SWAP IT WITH THE HIGHEST FILLED
C
      DO 100 I=1,N
         X=C(I,NOCC)
         C(I,NOCC)=C(I,IFILL)
         C(I,IFILL)=X
  100 CONTINUE
      RETURN
      END

C     *****************
      SUBROUTINE SCATER(NVH3,NVL,WK3,NVH2,WK2,IW1,IWOSET)
C     *****************

C     SPECIAL PURPOSE SCATTER ROUTINE FOR SU3 LATTICE GAUGE THEORY
C     FUNCTION: WK3( IW1(1:NVL) + IWOSET, 1:18 ) = WK2( 1:NVL, 1:18 )

      INTEGER           IW1(  NVH2       )
      DOUBLE PRECISION  WK3(  NVH3,   18 ) , WK2( NVH2, 18 ) 


      DO 10 ISM = 1,18
      DO 20 IVL = 1,NVL
      WK3( IW1(IVL) + IWOSET, ISM ) = WK2( IVL, ISM )
   20 CONTINUE
   10 CONTINUE


        END

C----------------------------------------------------------------------
C
C  R A D E C
C
C  COMPUTE RIGHT ASCENSION AND DECLINATION FROM RECTANGULAR
C  HELIOCENTRIC ECLIPTIC COORDINATES
C
C----------------------------------------------------------------------
      SUBROUTINE RADEC(
     .             X,Y,Z, X0,Y0,Z0,
     .             OLDRA,OLDDEC,DAYS,J,T,
     .             RA,DEC,DIST)
      INTEGER J  
      REAL
     .    X,Y,Z ,
     .    X0,Y0,Z0, 
     .    OLDRA,OLDDEC, 
     .    DAYS, 
     .    T,    
     .    RA,   
     .    DEC,  
     .    DIST  
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C 
C  LOCAL VARIABLES
C
      REAL
     .    U,K,D,G,  
     .    DRA,DDEC,TAU,
     .    DPSI,DEPS,
     .    XL,YL,ZL  
C
      XL=X-X0
      YL=Y-Y0
      ZL=Z-Z0
      DIST=SQRT(XL*XL+YL*YL+ZL*ZL)
      DEC=ASIN(ZL/DIST)
      RA=ATAN2(YL,XL)
      IF (RA .LT. 0.0) RA=RA+PI2
C
C  ANNUAL  ABERRATION CORRECTION
C
      IF (J .NE. 1) THEN
         D=ZL/DIST
         G=SQRT(1-D*D)
         U=-X0/SQRT(X0*X0+Y0*Y0+Z0*Z0)
         K=SQRT(1.0E+0-U*U)
         DRA=1.363*(U*COS(OBLIQ)*COS(RA)+K*SIN(RA))/G
         DDEC=20.445*(U*(G*SIN(OBLIQ)-D*COS(OBLIQ)*SIN(RA))
     .        +D*K*COS(RA))
         RA=RA-DRA*15/3600*DTORAD
         DEC=DEC-DDEC/3600*DTORAD
      ENDIF
C
C  PLANETARY ABERRATION 
C
      D=DIST/173.1446577 
      OLDRA=OLDRA*DTORAD*15
      OLDDEC=OLDDEC*DTORAD
      IF ((OLDRA .NE. 0.0) .OR. (OLDDEC .NE. 0.0)) THEN
         DRA=RA-OLDRA
         IF (DRA/DTORAD/15 .LT. -12.0)  DRA=DRA+PI2
         IF (DRA/DTORAD/15 .GT. +12.0)  DRA=DRA-PI2
         DRA=(DRA)*D/DAYS
         DDEC=(DEC-OLDDEC)*D/DAYS
         RA=RA-DRA
         DEC=DEC-DDEC
      ENDIF
C
C  NUTATION
C  AE S.B20 (1982)
C
      D=T+(2415020.0E+0-2444969.5E+0)
      DPSI=(-0.0048*SIN((113.2-0.053*D)*DTORAD)
     .          -0.0004*SIN((198.7+1.971*D)*DTORAD))*DTORAD
      DEPS=( 0.0026*COS((113.2-0.053*D)*DTORAD)
     .         +0.0002*COS((198.7+1.971*D)*DTORAD))*DTORAD
      DRA=(COS(OBLIQ)+SIN(OBLIQ)*SIN(RA)*TAN(DEC))*DPSI
     .     -COS(RA)*TAN(DEC)*DEPS
      DDEC=SIN(OBLIQ)*COS(RA)*DPSI+SIN(RA)*DEPS
      RA=RA+DRA
      DEC=DEC+DDEC
C
      RA=RA*RTODEG/15   
      DEC=DEC*RTODEG    
      RETURN
      END

      SUBROUTINE MXM (A, B, C, L, M, N)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(L,M), B(M,N), C(L,N)
C
C   4-WAY UNROLLED MATRIX MULTIPLY ROUTINE FOR VECTOR COMPUTERS.
C   M MUST BE A MULTIPLE OF 4.  CONTIGUOUS DATA ASSUMED.
C   D H BAILEY  11/15/84
C
      DO 100 K = 1, N
        DO 100 I = 1, L
          C(I,K) = 0.
100     CONTINUE
      DO 110 J = 1, M, 4
        DO 110 K = 1, N
          DO 110 I = 1, L
            C(I,K) = C(I,K) + A(I,J) * B(J,K)
     $             + A(I,J+1) * B(J+1,K) + A(I,J+2) * B(J+2,K)
     $             + A(I,J+3) * B(J+3,K)
110   CONTINUE
C
      RETURN
      END

      SUBROUTINE TRED3(N,NV,A,D,E,E2,EPS,ETA)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION A(NV), D(N), E(N), E2(N)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TRED3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS SUBROUTINE REDUCES A REAL SYMMETRIC MATRIX, STORED AS
C     A ONE-DIMENSIONAL ARRAY, TO A SYMMETRIC TRIDIAGONAL MATRIX
C     USING ORTHOGONAL SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
C          INPUT MATRIX, STORED ROW-WISE AS A ONE-DIMENSIONAL
C          ARRAY, IN ITS FIRST N*(N+1)/2 POSITIONS.
C
C     ON OUTPUT-
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL
C          TRANSFORMATIONS USED IN THE REDUCTION,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL
C          MATRIX IN ITS LAST N-1 POSITIONS.  E(1) IS SET TO ZERO,
C
C        E2 CONTAINS THE SQUARES OF THE CORRESPONDING ELEMENTS OF E.
C          E2 MAY COINCIDE WITH E IF THE SQUARES ARE NOT NEEDED.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C     ********** FOR I=N STEP -1 UNTIL 1 DO -- **********
      TOL=ETA/EPS
      DO 100   II = 1, N
         I = N + 1 - II
         L = I - 1
         IZ = ( I * L ) / 2
         H=0.0D0
         SCALE=0.0D0
         DO 10   K = 1, L
            IZ = IZ + 1
            D(K) = A(IZ)
            SCALE=SCALE+ABS( D(K) )
   10    CONTINUE
C
         IF ( SCALE.NE.0.D0 ) GO TO 20
         E(I)=0.0D0
         E2(I)=0.0D0
         GO TO 90
C
   20    DO 30   K = 1, L
            D(K) = D(K) / SCALE
            H = H + D(K) * D(K)
   30    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = D(L)
         G=-SIGN (SQRT (H),F)
         E(I) = SCALE * G
         H = H - F * G
         D(L) = F - G
         A(IZ) = SCALE * D(L)
         IF (L .EQ. 1) GO TO 90
         F=0.0D0
C
         DO 70   J = 1, L
            G=0.0D0
            JK = (J * (J-1)) / 2
C     ********** FORM ELEMENT OF A*U **********
            K = 0
   40       K = K + 1
            JK = JK + 1
            G = G + A(JK) * D(K)
            IF ( K .LT. J ) GO TO 40
            IF ( K .EQ. L ) GO TO 60
   50       JK = JK + K
            K = K + 1
            G = G + A(JK) * D(K)
            IF ( K .LT. L ) GO TO 50
C     ********** FORM ELEMENT OF P **********
   60       CONTINUE
            E(J) = G / H
            F = F + E(J) * D(J)
   70    CONTINUE
C
         HH = F / (H + H)
         JK = 0
C     ********** FORM REDUCED A **********
         DO 80   J = 1, L
            F = D(J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 80   K = 1, J
               JK = JK + 1
               A(JK) = A(JK) - F * E(K) - G * D(K)
   80    CONTINUE
C
   90    D(I) = A(IZ+1)
         A(IZ+1)=SCALE*SQRT (H)
  100 CONTINUE
C
      RETURN
C     ********** LAST CARD OF TRED3 **********
      END

      SUBROUTINE COMPFG(XPARAM,INT,ESCF,FULSCF,GRAD,LGRAD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(MAXPAR),GRAD(MAXPAR)
      LOGICAL LGRAD, FULSCF
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR),IDUMY,DUMY(MAXPAR)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),LOCDEP(MAXPAR)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /ATHEAT/ ATHEAT
      COMMON /WMATRX/ WJ(N2ELEC), WK(N2ELEC)
      COMMON /ENUCLR/ ENUCLR
      COMMON /NATYPE/ NZTYPE(107),MTYPE(30),LTYPE
      COMMON /ELECT / ELECT
      PARAMETER (MDUMY=MAXPAR**2-MPACK)
      COMMON /SCRACH/ RXYZ(MPACK), XDUMY(MDUMY)
      COMMON /HMATRX/ H(MPACK)
      COMMON /MOLMEC/ HTYPE(4),NHCO(4,20),NNHCO,ITYPE,USEMM
     1       /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     2                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     3                NCLOSE,NOPEN,NDUMY,FRACT
C***********************************************************************
C
C   COMPFG CALCULATES (A) THE HEAT OF FORMATION OF THE SYSTEM, AND
C                     (B) THE GRADIENTS, IF LGRAD IS .TRUE.
C
C   ON INPUT  XPARAM = ARRAY OF PARAMETERS TO BE USED IN INTERNAL COORDS
C             LGRAD  = .TRUE. IF GRADIENTS ARE NEEDED, .FALSE. OTHERWISE
C             INT    = NEVER USED, RESERVED FOR FUTURE USE
C             FULSCF = .TRUE. IF FULL SCF TO BE DONE, .FALSE. OTHERWISE.
C
C   ON OUTPUT ESCF  = HEAT OF FORMATION.
C             GRAD   = ARRAY OF GRADIENTS, IF LGRAD = .TRUE.
C
C***********************************************************************
      COMMON /KEYWRD/KEYWRD
      CHARACTER*80 KEYWRD
      REAL WJ, WK
      LOGICAL FIRST, DEBUG, INT, PRINT, ANALYT, LARGE, USEMM
      DIMENSION COORD(3,NUMATM), W(N2ELEC), DEGREE(3)
      EQUIVALENCE (W,WJ)
      DATA FIRST /.TRUE./
C                 MNDO     AM1      PM3      MINDO/3
      IF (FIRST) THEN
      HTYPE(1)=6.1737D0
      HTYPE(2)=3.3191D0
      HTYPE(3)=7.1853D0
      HTYPE(4)=1.7712D0
C
C INT IS 'TOUCHED' SO AS TO GET AROUND SOME COMPILERS WHICH OBJECT
C TO ARGUMENTS NOT BEING USED
      IF(INT)DUMMY=0.D0
C
         FIRST=.FALSE.
C#         WRITE(6,'(A,F12.4)')' MM CORRECTION:',HTYPE(ITYPE)
         LTYPE=0
         DO 30 I=1,NUMAT
            IF(NAT(I).LT.99)THEN
               DO 10 J=1,LTYPE
   10          IF(NAT(I).EQ.MTYPE(J)) GOTO 20
               LTYPE=LTYPE+1
               MTYPE(LTYPE)=NAT(I)
               NZTYPE(NAT(I))=LTYPE
C
C       LTYPE = NUMBER OF TYPES OF REAL ATOM PRESENT
C       MTYPE = TYPES OF REAL ATOMS PRESENT
               J=LTYPE
   20          CONTINUE
            ENDIF
   30    CONTINUE
         ANALYT=(INDEX(KEYWRD,'ANALYT').NE.0)
         IF(ANALYT)CALL SETUPG
         DEGREE(1)=1.D0
         IF(INDEX(KEYWRD,' XYZ').NE.0)THEN
            DEGREE(2)=1.D0
         ELSE
            DEGREE(2)=180.D0/3.141592652589D0
         ENDIF
         DEGREE(3)=DEGREE(2)
         LARGE=(INDEX(KEYWRD,'LARGE') .NE. 0)
         PRINT=(INDEX(KEYWRD,'COMPFG') .NE. 0)
         DEBUG=(INDEX(KEYWRD,'DEBUG') .NE. 0 .AND. PRINT)
      ENDIF
C
C SET UP COORDINATES FOR CURRENT CALCULATION
C
C       PLACE THE NEW VALUES OF THE VARIABLES IN THE ARRAY GEO.
C       MAKE CHANGES IN THE GEOMETRY.
      DO 40 I=1,NVAR
         K=LOC(1,I)
         L=LOC(2,I)
   40 GEO(L,K)=XPARAM(I)
C#      WRITE(6,'(3F18.11)')(XPARAM(I),I=1,3)
C      IMPOSE THE SYMMETRY CONDITIONS + COMPUTE THE DEPENDENT-PARAMETERS
      IF(NDEP.NE.0) CALL SYMTRY
C      NOW COMPUTE THE ATOMIC COORDINATES.
      IF( DEBUG ) THEN
         IF( LARGE ) THEN
            K=NUMAT
         ELSE
            K=MIN(5,NUMAT)
         ENDIF
         WRITE(6,FMT='('' INTERNAL COORDS'',/100(/,3F12.6))')
     1            ((GEO(J,I)*DEGREE(J),J=1,3),I=1,K)
      END IF
      CALL GMETRY(GEO,COORD)
      IF( DEBUG ) THEN
         IF( LARGE ) THEN
            K=NUMAT
         ELSE
            K=MIN(5,NUMAT)
         ENDIF
         WRITE(6,FMT='('' CARTESIAN COORDS'',/100(/,3F12.6))')
     1            ((COORD(J,I),J=1,3),I=1,K)
      END IF
      IF(ANALYT)REWIND 2
      CALL HCORE(COORD, H, W, WJ, WK, ENUCLR)
C
C COMPUTE THE HEAT OF FORMATION.
C
      IF(NORBS.GT.0.AND.NELECS.GT.0) THEN
         CALL ITER(H, W, WJ, WK, ELECT, FULSCF,.TRUE.)
      ELSE
         ELECT=0.D0
      ENDIF
      ESCF=(ELECT+ENUCLR)*23.061D0+ATHEAT
      DO 50 I=1,NNHCO
         CALL DIHED(COORD,NHCO(1,I),NHCO(2,I),NHCO(3,I),NHCO(4,I),ANGLE)
         ESCF=ESCF+HTYPE(ITYPE)*SIN(ANGLE)**2
   50 CONTINUE
      IF(PRINT) WRITE(6,'(/10X,'' HEAT OF FORMATION'',G30.17)')ESCF
C
C FIND DERIVATIVES IF DESIRED
C
      IF(LGRAD) CALL DERIV(GEO,GRAD)
      RETURN
      END

      SUBROUTINE NINVER(JDIM,KDIM,S,XY,IXX,IXY,IYX,IYY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   IXX = 1, IXY = 2, IYX = 3, IYY = 4
C               -1
C   N  =  T    T
C          XI   ETA
C
C   IXX = 3, IXY = 4, IYX = 1, IYY = 2
C               -1
C   N  =  T    T
C          ETA  XI
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION S(JDIM,KDIM,4),XY(JDIM,KDIM,4)
C
      DIMENSION RG(4,4),SR(4)
C
C  PARAMETERS FOR DIAGONALIZATION
C
      BT = 1./SQRT(2.)
      BT2 = 0.5
C
        DO 1 K = KLOW,KUP
          DO 1 J = JLOW,JUP
           RR1   = XY(J,K,IXX)**2+XY(J,K,IXY)**2
           RR2   = XY(J,K,IYX)**2+XY(J,K,IYY)**2
           RR1   = 1./SQRT(RR1)
           RR2   = 1./SQRT(RR2)
           RM1   = (XY(J,K,IXX)*XY(J,K,IYX)+XY(J,K,IXY)*XY(J,K,IYY))
     *                                          *RR1*RR2
           RM2   = (XY(J,K,IXX)*XY(J,K,IYY)-XY(J,K,IXY)*XY(J,K,IYX))
     *                                          *RR1*RR2
               S34M  = S(J,K,3) - S(J,K,4)
               S34P  = S(J,K,3) + S(J,K,4)
               S2 =  RM1*S(J,K,2)    + BT*S34M*RM2
               S3 = -BT*S(J,K,2)*RM2 + BT2*(S34P+RM1*S34M)
               S4 =  BT*RM2*S(J,K,2) + BT2*(S34P-RM1*S34M)
               S(J,K,2) = S2
               S(J,K,3) = S3
               S(J,K,4) = S4
1      CONTINUE
C
         RETURN
         END

      SUBROUTINE RSP(A,N,MATZ,W,Z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION A(*),  W(N), Z(N,N)
*******************************************************************
*
*   EISPACK DIAGONALIZATION ROUTINES: TO FIND THE EIGENVALUES AND
*           EIGENVECTORS (IF DESIRED) OF A REAL SYMMETRIC PACKED MATRIX.
* ON INPUT-      N  IS THE ORDER OF THE MATRIX  A,
*                A  CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
*                   PACKED MATRIX STORED ROW-WISE,
*             MATZ  IS AN INTEGER VARIABLE SET EQUAL TO ZERO IF ONLY
*                   EIGENVALUES ARE DESIRED,  OTHERWISE IT IS SET TO
*                   ANY NON-ZERO INTEGER FOR BOTH EIGENVALUES AND
*                   EIGENVECTORS.
* ON OUTPUT-     W  CONTAINS THE EIGENVALUES IN ASCENDING ORDER,
*                Z  CONTAINS THE EIGENVECTORS IF MATZ IS NOT ZERO,
*
*******************************************************************
* THIS SUBROUTINE WAS CHOSEN AS BEING THE MOST RELIABLE. (JJPS)
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      DIMENSION FV1(MAXORB),FV2(MAXORB)
      LOGICAL FIRST
      DATA FIRST /.TRUE./
      IF (FIRST) THEN
         FIRST=.FALSE.
         CALL EPSETA(EPS,ETA)
         NV=(MAXORB*(MAXORB+1))/2
      ENDIF
      NM=N
      IF (N .LE. NM) GO TO 10
      IERR = 10 * N
      GO TO 60
   10 IF (NV .GE. (N * (N + 1)) / 2) GO TO 20
      IERR = 20 * N
      GO TO 60
C
   20 CALL  TRED3(N,NV,A,W,FV1,FV2,EPS,EPS)
      IF (MATZ .NE. 0) GO TO 30
C     ********** FIND EIGENVALUES ONLY **********
      CALL  TQLRAT(N,W,FV2,IERR,EPS)
      GO TO 60
C     ********** FIND BOTH EIGENVALUES AND EIGENVECTORS **********
   30 DO 50    I = 1, N
C
         DO 40    J = 1, N
            Z(J,I)=0.0D0
   40    CONTINUE
C
         Z(I,I)=1.0D0
   50 CONTINUE
C
      CALL  TQL2(NM,N,W,FV1,Z,IERR,EPS)
      IF (IERR .NE. 0) GO TO 60
      CALL  TRBAK3(NM,N,NV,A,N,Z,EPS)
C     ********** LAST CARD OF RSP **********
   60 RETURN
      END

      SUBROUTINE SQUAD8 (SFUN,LDER,XI,ETA)
      DOUBLE PRECISION SFUN(8), LDER(2,8), XI, ETA
      DOUBLE PRECISION ONE, TWO, FOUR
      PARAMETER (ONE=1.D0, TWO=2.D0, FOUR=4.D0)
      SFUN(1) = (ONE-XI)*(ONE-ETA)*(-XI-ETA-ONE)/FOUR
      SFUN(2) = (ONE-XI*XI)*(ONE-ETA)/TWO
      SFUN(3) = (ONE+XI)*(ONE-ETA)*(XI-ETA-ONE)/FOUR
      SFUN(4) = (ONE-ETA*ETA)*(ONE+XI)/TWO
      SFUN(5) = (ONE+XI)*(ONE+ETA)*(XI+ETA-ONE)/FOUR
      SFUN(6) = (ONE-XI*XI)*(ONE+ETA)/TWO
      SFUN(7) = (ONE-XI)*(ONE+ETA)*(-XI+ETA-ONE)/FOUR
      SFUN(8) = (ONE-ETA*ETA)*(ONE-XI)/TWO
      LDER(1,1) = (ETA+TWO*XI-TWO*XI*ETA-ETA*ETA)/FOUR
      LDER(2,1) = (XI+TWO*ETA-TWO*XI*ETA-XI*XI)/FOUR
      LDER(1,2) = -XI+XI*ETA
      LDER(2,2) = (-ONE+XI*XI)/TWO
      LDER(1,3) = (-ETA+TWO*XI-TWO*XI*ETA+ETA*ETA)/FOUR
      LDER(2,3) = (-XI+TWO*ETA-XI*XI+TWO*XI*ETA)/FOUR
      LDER(1,4) = (ONE-ETA*ETA)/TWO
      LDER(2,4) = -ETA-XI*ETA
      LDER(1,5) = (ETA+TWO*XI+TWO*XI*ETA+ETA*ETA)/FOUR 
      LDER(2,5) = (XI+TWO*ETA+XI*XI+TWO*XI*ETA)/FOUR
      LDER(1,6) = -XI-XI*ETA
      LDER(2,6) = (ONE-XI*XI)/TWO
      LDER(1,7) = (-ETA+TWO*XI+TWO*XI*ETA-ETA*ETA)/FOUR
      LDER(2,7) = (-XI+TWO*ETA+XI*XI-TWO*XI*ETA)/FOUR
      LDER(1,8) = (-ONE+ETA*ETA)/TWO
      LDER(2,8) = -ETA+XI*ETA
      RETURN
      END

      SUBROUTINE UPDATE(JDIM,KDIM,Q,S,DELTQN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
C
      DIMENSION Q(JDIM,KDIM,4),S(JDIM,KDIM,4),DELTQN(JDIM,KDIM,4)
C
C
         PHIC = PHIDT/(1.+PHIDT)
C
C  UPDATE SOLUTION
C
         DO 600 N = 1,4
         DO 600 K = KLOW,KUP
         DO 600 J = JLOW,JUP
C  DELTA Q N  
            DELTQN(J,K,N) = S(J,K,N)
C  UPDATE
            Q(J,K,N) = Q(J,K,N)+S(J,K,N)
C  START NEXT
            S(J,K,N) = PHIC * S(J,K,N)
600      CONTINUE
C
C
        RETURN
        END

      SUBROUTINE SCHMIT(U,N,NDIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION U(NDIM,NDIM)
      DATA ZERO,SMALL,ONE/0.0,0.01,1.0/
      II=0
      DO 110 K=1,N
         K1=K-1
C
C     NORMALIZE KTH COLUMN VECTOR
C
         DOT = ZERO
         DO 10 I=1,N
   10    DOT=DOT+U(I,K)*U(I,K)
         IF(DOT.EQ.ZERO) GO TO 100
         SCALE=ONE/SQRT(DOT)
         DO 20 I=1,N
   20    U(I,K)=SCALE*U(I,K)
   30    IF(K1.EQ.0) GO TO 110
         NPASS=0
C
C     PROJECT OUT K-1 PREVIOUS ORTHONORMAL VECTORS FROM KTH VECTOR
C
   40    NPASS=NPASS+1
         DO 70 J=1,K1
            DOT=ZERO
            DO 50 I=1,N
   50       DOT=DOT+U(I,J)*U(I,K)
            DO 60 I=1,N
   60       U(I,K)=U(I,K)-DOT*U(I,J)
   70    CONTINUE
C
C     SECOND NORMALIZATION (AFTER PROJECTION)
C     IF KTH VECTOR IS SMALL BUT NOT ZERO THEN NORMALIZE
C     AND PROJECT AGAIN TO CONTROL ROUND-OFF ERRORS.
C
         DOT=ZERO
         DO 80 I=1,N
   80    DOT=DOT+U(I,K)*U(I,K)
         IF(DOT.EQ.ZERO) GO TO 100
         IF(DOT.LT.SMALL.AND.NPASS.GT.2) GO TO 100
         SCALE=ONE/SQRT(DOT)
         DO 90 I=1,N
   90    U(I,K)=SCALE*U(I,K)
         IF(DOT.LT.SMALL) GO TO 40
         GO TO 110
C
C     REPLACE LINEARLY DEPENDENT KTH VECTOR BY A UNIT VECTOR.
C
  100    II=II+1
C     IF(II.GT.N) CALL WRAPUP()
         U(II,K)=ONE
         GO TO 30
  110 CONTINUE
      RETURN
      END

      SUBROUTINE CLUSTR(JDIM,YMAX,YMIN,DYM,LMAX,R)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION R(JDIM)
C
C
C
      EPS = EPSIL(YMAX,YMIN,DYM,LMAX,0.001,100,1,2)
      K = -1
      R(1) = YMIN
      DO 5 L = 2,LMAX
      K = K+1
      GN = (1.0 +EPS/SQRT(FLOAT(K+4)))**K
      R(L) = R(L-1)+DYM*GN
    5 CONTINUE
C
      RETURN
      END

      SUBROUTINE CALCME(JDIM,KDIM,XY,XIT,ETT,XYJ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION XIT(JDIM,KDIM),ETT(JDIM,KDIM)
C
C  FORM JACOBIAN
C
      DO 30 K=KBEGIN,KEND
      DO 30 J=JBEGIN,JEND
         DINV = 1./ ( XY(J,K,4) * XY(J,K,1) - XY(J,K,3) * XY(J,K,2) )
         IF(DINV .LE. 0.0)PRINT *,'JACOBIAN( ',J,K,' )= ',DINV
         XYJ(J,K) = DINV
   30 CONTINUE
C
C  CALCULATE METRICS
C
      DO 32 K=KBEGIN,KEND
      DO 32 J=JBEGIN,JEND
         DINV = XYJ(J,K)
C
C XIX = XY1, XIY=XY2,ETAX=XY3, ETAY = XY4
C
         XY(J,K,1) =   XY(J,K,1)*DINV
         XY(J,K,2) = - XY(J,K,2)*DINV
         XY(J,K,3) = - XY(J,K,3)*DINV
         XY(J,K,4) =   XY(J,K,4)*DINV
32    CONTINUE
C
      RETURN
      END

      FUNCTION EPSIL(FMX,FMIN,DFM,NPT,FPCC,ICC,NCALL,KEY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C
      FMXL = FMX
      FMINL = FMIN
      DFML = DFM
      FPCCL = FPCC
      ICCL = ICC
C
C  SLOWER STRETCHING IF KEY = 2
C
      IF(KEY.EQ.2) GO TO 50
C
      FNPTM2 = NPT-2
      IF(NCALL.EQ.1) EPS = (FMXL/DFML)**(1./FNPTM2)-1.0
C
      DO 3 NIT = 1,ICCL
      EP1 = EPS+1.
      EP1TN = EP1**FNPTM2
      DFMOE = DFML/EPS
      F = FMXL-FMINL-DFMOE*(EP1TN*EP1-1.0)
      IF(ABS(F).LT.FPCCL) GO TO 4
      FPN = DFMOE*FNPTM2*EP1TN
      EPS = EPS+F/FPN
    3 CONTINUE
      GO TO 5
   50 CONTINUE
      IF(NCALL.EQ.1) EPS=20.
      DO 11 NIT=1,ICCL
      SUMG = 0.0
      SUMGP = 0.0
      DO 12 M = 2,NPT
      N = M-2
      GN = (1.0+EPS/SQRT(FLOAT(N+4)))**N
      GPN = N*(1.0+EPS/SQRT(FLOAT(N+4)))**(N-1)*(1.0/SQRT(FLOAT(N+4)))
      SUMG = SUMG+GN
   12 SUMGP = SUMGP+GPN
      F = FMXL-FMINL-DFML*SUMG
      IF(ABS(F).LT.FPCCL) GO TO 4
      FP=-DFML*SUMGP
   11 EPS = EPS-F/FP
C
    5 CONTINUE
      EPSIL = EPS
      WRITE(*,100)
      RETURN
    4 EPSIL = EPS
      WRITE(*,101) EPSIL,F,NIT
      RETURN
C
  100 FORMAT(/40HEXCEEDED MAX NO. OF ITERATIONS IN EPSIL.)
  101 FORMAT(/6HEPSIL=,F12.5,5X,7H AND F=,F12.5,5X,6HAFTER ,I3,
     * 12H ITERATIONS.)
C
      END

      SUBROUTINE DIRECT (NELE,ELTOP,IELTOP,STEER)
      INTEGER NELE, IELTOP, ELTOP(IELTOP,*),STEER(*)
      INTEGER I

      DO 10 I=1,ELTOP(2,NELE)
         STEER(I) = ELTOP(2+I,NELE)
 10   CONTINUE
      RETURN
      END 

C     *****************
      SUBROUTINE EXPVAL(
C     *****************
     >                  NV,NS3,METHIT,
     >                  ITS,ITSAVG,NW1,
     >                  WLR,WLI,IACPT,
     >                  WLSUMR,WLSUMI)
C
C
      DOUBLE PRECISION     ACPT,
     >                     WLR,WLI,PHR,PHI,WLPHR,WLPHI,
     >                     WLSUMR,WLSUMI,WLEXCR,WLEXCI,
     >                     WLITSR,WLITSI,ZERO
C
C
      PARAMETER( ZERO =   0.0D0                     )
      PARAMETER( PHR  = - 0.5D0                     )
      PARAMETER( PHI  =   0.866025403784438646763D0 )
C
C
C     -----------------------------------------------
C
C
C
C     ACCEPTANCE MEASURING
C
C
      ACPT = IACPT / DBLE( 4 * NV * METHIT )
C
C
C     WILSON LINE MEASURING
C
C
C     CALCULATING THE PHASE FACTOR
C
C
      IF( WLR .GE. ZERO ) THEN
          WLPHR = WLR
          WLPHI = WLI
          GOTO 25
      ENDIF
C
      IF( WLI .LT. ZERO ) THEN
          WLPHR = ( WLR * PHR - WLI * PHI )
          WLPHI = ( WLR * PHI + WLI * PHR )
      ELSE
          WLPHR = ( WLR * PHR + WLI * PHI )
          WLPHI = ( WLI * PHR - WLR * PHI )
      ENDIF
C
C
C     ITERATION SUM
C
C
   25 CONTINUE
C
      WLITSR = WLPHR  / NS3
      WLITSI = WLPHI  / NS3
C
      WLSUMR = WLSUMR + WLITSR
      WLSUMI = WLSUMI + WLITSI
C
      WLEXCR = WLSUMR / ITSAVG
      WLEXCI = WLSUMI / ITSAVG
C
C
C     PRINT RESULTS
C
C
      IF( ITS .EQ. 1 ) WRITE(NW1,1000)
      WRITE(NW1,1010 ) ITS,WLITSR,WLITSI,WLEXCR,WLEXCI,ACPT
C
C
 1000 FORMAT(8X,'  ITS    RE(WL)      IM(WL)   ',
     >                 '  <RE(WL)>    <IM(WL)>      ACPT.   '/)
C
 1010 FORMAT(6X,I6,5F12.6)
C
C
      END

      DOUBLE PRECISION FUNCTION READA(STRING,ISTART)
C     FORTRAN FUNCTION TO EXTRACT NUMBER FROM STRING
C
      CHARACTER STRING*(*)
      DOUBLE PRECISION DIGIT
      LOGICAL DEFALT,EXPNNT
C
C     DEFINE ASCII VALUES OF NUMERIC FIELD CHARACTERS
      I0=ICHAR('0')
      I9=ICHAR('9')
      IDOT=ICHAR('.')
      INEG=ICHAR('-')
      IPOS=ICHAR('+')
      ICAPD=ICHAR('D')
      ICAPE=ICHAR('E')
      ISMLD=ICHAR('d')
      ISMLE=ICHAR('e')
C
      L=LEN(STRING)
C
C     FIND THE START OF THE NUMERIC FIELD
      DO 10 I=ISTART,L
         IADD=0
         N=ICHAR(STRING(I:I))
C
C       SIGNAL START OF NUMERIC FIELD IF DIGIT FOUND
         IF(N.GE.I0.AND.N.LE.I9)GOTO 20
C
C       ACCOUNT FOR CONSECUTIVE SIGNS [- AND(OR) +]
         IF(N.EQ.INEG.OR.N.EQ.IPOS)THEN
            IADD=IADD+1
            IF(I+IADD.GT.L)GOTO 50
            N=ICHAR(STRING(I+IADD:I+IADD))
            IF(N.GE.I0.AND.N.LE.I9)GOTO 20
         ENDIF
C
C       ACCOUNT FOR CONSECUTIVE DECIMAL POINTS (.)
         IF(N.EQ.IDOT)THEN
            IADD=IADD+1
            IF(I+IADD.GT.L)GOTO 50
            N=ICHAR(STRING(I+IADD:I+IADD))
            IF(N.GE.I0.AND.N.LE.I9)GOTO 20
         ENDIF
   10 CONTINUE
      GOTO 50
C
C     FIND THE END OF THE NUMERIC FIELD
   20 EXPNNT=.FALSE.
      DO 30 J=I+1,L
         IADD=0
         N=ICHAR(STRING(J:J))
C
C       CONTINUE SEARCH FOR END IF DIGIT FOUND
         IF(N.GE.I0.AND.N.LE.I9)GOTO 30
C
C       CONTINUE SEARCH FOR END IF SIGN FOUND AND EXPNNT TRUE
         IF(N.EQ.INEG.OR.N.EQ.IPOS)THEN
            IF(.NOT.EXPNNT)GOTO 40
            IADD=IADD+1
            IF(J+IADD.GT.L)GOTO 40
            N=ICHAR(STRING(J+IADD:J+IADD))
            IF(N.GE.I0.AND.N.LE.I9)GOTO 30
         ENDIF
         IF(N.EQ.IDOT)THEN
            IADD=IADD+1
            IF(J+IADD.GT.L)GOTO 40
            N=ICHAR(STRING(J+IADD:J+IADD))
            IF(N.GE.I0.AND.N.LE.I9)GOTO 30
            IF(N.EQ.ICAPE.OR.N.EQ.ISMLE.OR.N.EQ.ICAPD.OR.N.EQ.ISMLD)
     1    GOTO 30
         ENDIF
         IF(N.EQ.ICAPE.OR.N.EQ.ISMLE.OR.N.EQ.ICAPD.OR.N.EQ.ISMLD)THEN
            IF(EXPNNT)GOTO 40
            EXPNNT=.TRUE.
            GOTO 30
         ENDIF
         GOTO 40
   30 CONTINUE
      J=L+1
   40 N=ICHAR(STRING(J-1:J-1))
      IF(N.EQ.ICAPE.OR.N.EQ.ISMLE.OR.N.EQ.ICAPD.OR.N.EQ.ISMLD)J=J-1
C
C     FOUND THE END OF THE NUMERIC FIELD (IT RUNS 'I' THRU 'J-1')
      N=0
      N=N+INDEX(STRING(I:J-1),'e')
      N=N+INDEX(STRING(I:J-1),'E')
      N=N+INDEX(STRING(I:J-1),'d')
      N=N+INDEX(STRING(I:J-1),'D')
      IF(N.EQ.0)THEN
         READA=DIGIT(STRING(I:J-1),1)
      ELSE
         READA=DIGIT(STRING(:I+N-2),I)*1.D1**DIGIT(STRING(:J-1),I+N)
      ENDIF
      DEFALT=.FALSE.
      RETURN
C
C     DEFAULT VALUE RETURNED BECAUSE NO NUMERIC FIELD FOUND
   50 READA=0.D0
      DEFALT=.TRUE.
      RETURN
      END

      SUBROUTINE FOCK1(F, PTOT, PA, PB)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION F(*), PTOT(*), PA(*), PB(*)
C *********************************************************************
C
C *** COMPUTE THE REMAINING CONTRIBUTIONS TO THE ONE-CENTRE ELEMENTS.
C
C *********************************************************************
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /GAUSS / FN1(107),FN2(107)
     1       /MOLORB/ USPD(MAXORB),DUMY(MAXORB)
      COMMON /TWOELE/ GSS(107),GSP(107),GPP(107),GP2(107),HSP(107)
     1                ,GSD(107),GPD(107),GDD(107)
      DIMENSION QTOT(NUMATM), QA(NUMATM), QB(NUMATM)
      COMMON /KEYWRD/ KEYWRD
      CHARACTER*80 KEYWRD
      LOGICAL FIRST
      DATA FIRST /.TRUE./
      IF(FIRST)THEN
         FIRST=.FALSE.
      ENDIF
      CALL CHRGE(PTOT,QTOT)
      CALL CHRGE(PA,QA)
      DO 10 I=1,NUMAT
   10 QB(I)=QTOT(I)-QA(I)
      DO 100 II=1,NUMAT
         IA=NFIRST(II)
         IB=NMIDLE(II)
         IC=NLAST(II)
         NI=NAT(II)
         DTPOP=0.D0
         DAPOP=0.D0
         PTPOP=0.D0
         PAPOP=0.D0
         GOTO (100,40,30,30,30,20,20,20,20,20)IC-IA+2
   20    DTPOP=PTOT((IC*(IC+1))/2)+PTOT(((IC-1)*(IC))/2)
     1        +PTOT(((IC-2)*(IC-1))/2)+PTOT(((IC-3)*(IC-2))/2)
     2        +PTOT(((IC-4)*(IC-3))/2)
         DAPOP=PA((IC*(IC+1))/2)+PA(((IC-1)*(IC))/2)
     1        +PA(((IC-2)*(IC-1))/2)+PA(((IC-3)*(IC-2))/2)
     2        +PA(((IC-4)*(IC-3))/2)
   30    PTPOP=PTOT((IB*(IB+1))/2)+PTOT(((IB-1)*(IB))/2)
     1        +PTOT(((IB-2)*(IB-1))/2)
         PAPOP=PA((IB*(IB+1))/2)+PA(((IB-1)*(IB))/2)
     1        +PA(((IB-2)*(IB-1))/2)
   40    DBPOP=DTPOP-DAPOP
         PBPOP=PTPOP-PAPOP
         IF(NI.EQ.1)THEN
            SUM=0.D0
         ELSE
            SUM2=0.D0
            SUM1=0.D0
            DO 60 I=IA,IB
               IM1=I-1
               DO 50 J=IA,IM1
   50          SUM1=SUM1+PTOT(J+(I*(I-1))/2)**2
   60       SUM2=SUM2+PTOT((I*(I+1))/2)**2
            SUM=SUM1*2.D0+SUM2
            SUM=SQRT(SUM)-QTOT(II)*0.5D0
         ENDIF
         SUM=SUM*FN1(NI)
C
C     F(S,S)
C
         KA=(IA*(IA+1))/2
         F(KA)=F(KA)+PB(KA)*GSS(NI)+PTPOP*GSP(NI)
     1         -PAPOP*HSP(NI) + DTPOP*GSD(NI)
         IF (NI.LT.3) GO TO 100
         IPLUS=IA+1
         L=KA
         DO 70 J=IPLUS,IB
            M=L+IA
            L=L+J
C
C     F(P,P)
C
            F(L)=F(L)+PTOT(KA)*GSP(NI)-PA(KA)*HSP(NI)+
     1      PB(L)*GPP(NI)+(PTPOP-PTOT(L))*GP2(NI)
     2      -0.5D0*(PAPOP-PA(L))*(GPP(NI)-GP2(NI))
     3      +DTPOP*GPD(NI)
C
C     F(S,P)
C
   70    F(M)=F(M)+2.D0*PTOT(M)*HSP(NI)-PA(M)*(HSP(NI)+GSP(NI))
C
C     F(P,P*)
C
         IMINUS=IB-1
         DO 80 J=IPLUS,IMINUS
            ICC=J+1
            DO 80 L=ICC,IB
               M=(L*(L-1))/2+J
   80    F(M)=F(M)+PTOT(M)*(GPP(NI)-GP2(NI))
     1      -0.5D0*PA  (M)*(GPP(NI)+GP2(NI))
         DO 90 J=IB+1,IC
            M=(J*(J+1))/2
   90    F(M)=F(M)+PTOT(KA)*GSD(NI)
     1         +PTPOP*GPD(NI)
     2         +(DTPOP-PA(M))*GDD(NI)
  100 CONTINUE
      RETURN
      END

      SUBROUTINE FFT3D(A,WORK,MF,ISIGN)
C     ****************************************************************
C=======================================================================
C THIS SUBROUTINE WAS WRITTEN BY PROFESSOR DAVID H. VANDERBILT (NOW AT
C HARVARD). THE SUBROUTINE BASICALLY PERFORMS A SERIES OF PERMUTATIONS
C OF A THREE DIMENSIONAL DATA ARRAY TO MAKE OPTIMUM USE OF THE MULTI-
C ONE DIMENSIONAL ARRAY CAPABILITY OF THE VECTORISED FAST FOURIER
C TRANSFORM ROUTINE CFFT99. THIS SUBROUTINE PUTS THE DATA INTO A LARGER
C ARRAY THAN THE NGX*NGY*NGZ GRID USED IN THE BASIC PROGRAMS FOR SOME
C ESOTERIC REASON RELATED TO THE WAY THAT THE CRAY WORKS. BASICALLY, IF
C YOU HAVE A BETTER, CLEARER THREE DIMENSIONAL FAST FOURIER TRANSFORM
C SUBROUTINE YOU MAY BE BETTER OFF USING IT.
C=======================================================================
C AS MENTIONED ABOVE THE ARRAY FOR THE FOURIER TRANSFORMS IS BIGGER THAN
C THE GRID USED IN THE PROGRAMS SO THE PARAMETERS MNBX,MNBY AND MNBZ
C MUST BE CHOSEN SO THAT MNBX*MNBY*MNBZ IS GREATER THAN NGX*NGY*NGZ+
C MAX(NGX,NGY,NGZ). ALSO WITH THE PRESENT ROUTINE MNBX MUST EQUAL NGX
C AND MNBY MUST EQUAL NGY FOR THE PERMUTATIONS TO WORK
C=======================================================================
C
C                        PARAMETER STATEMENT
C
C GENERALLY MNBX=NGX,MNGY=NGY AND MNBZ=NGZ+1 SHOULD BE USED BUT SEE
C ABOVE
C=======================================================================
      COMPLEX A(*),WORK(*)
      COMPLEX TRIGX(100),TRIGY(100),TRIGZ(200)
      DIMENSION IFACX(13),IFACY(13),IFACZ(13),MF(3)
      DATA KEY/0/
C
C     3-D FAST FOURIER TRANSFORM
C
C     ISIGN = +1 : FORWARD : REAL --> RECIP : EXP(-IQR)
C     ISIGN = -1 : BACKWARD: RECIP --> REAL : EXP(+IQR)
C
C     MF SHOULD BE SAME FOR ALL CALLS
C
C     MNBX,Y,Z SHOULD BE CHOSEN SO THAT THE PRODUCT EXCEEDS
C       NX*NY*NZ BY AT LEAST MAX(NX,NY,NZ)
C     USUALLY CAN BE DONE BY INCREMENTING MNBX BY 1
C
      IF (KEY.EQ.1) GO TO 60
C
      NX=MF(1)
      NY=MF(2)
      NZ=MF(3)
      MNBX=NX
      MNBY=NY
      MNBZ=NZ+1
      NXY=NX*NY
      NYZ=NY*NZ
      NZX=NZ*NX
      NXY1=NX*NY+1
      NYZ1=NY*NZ+1
      NZX1=NZ*NX+1
      IF (NX.GT.MNBX) GO TO 900
      IF (NY.GT.MNBY) GO TO 900
      IF (NZ.GT.MNBZ) GO TO 900
      NDIM=NX*NY*NZ+MAX0(NX,NY,NZ)*4
      IF (NDIM.GT.MNBX*MNBY*MNBZ) GO TO 900
      CALL CFTFAX(NX,IFACX,TRIGX)
      CALL CFTFAX(NY,IFACY,TRIGY)
      CALL CFTFAX(NZ,IFACZ,TRIGZ)
      IF (IFACX(1).LE.0) STOP 44
      IF (IFACY(1).LE.0) STOP 44
      IF (IFACZ(1).LE.0) STOP 44
   60 KEY=1
C
      IF (ISIGN.LT.0) GO TO 100
  100 CONTINUE
C
      MI=-ISIGN
C     CFFT99 HAS DIFFERENT CONVENTION : ISIGN=-1 --> FORWARD
C
      CALL FPACK(A,WORK,NX,NY,NZ,NDIM)
      CALL CFFT99(WORK,A,TRIGZ,IFACZ,NXY1,1,NZ,NXY,MI)
      CALL FPERM(WORK,A,NX,NY,NZ,NDIM)
      CALL CFFT99(A,WORK,TRIGX,IFACX,NYZ1,1,NX,NYZ,MI)
      CALL FPERM(A,WORK,NY,NZ,NX,NDIM)
      CALL CFFT99(WORK,A,TRIGY,IFACY,NZX1,1,NY,NZX,MI)
      CALL FUNPK(WORK,A,NX,NY,NZ,NDIM)
 751  FORMAT(1X,E12.6)
C
      RETURN
C
  900 WRITE (*,5) NX,NY,NZ,MNBX,MNBY,MNBZ
    5 FORMAT (' === MNBX,Y,Z TOO SMALL ==='
     1    /' NX,Y,Z   =',3I5/
     2    /' MNBX,Y,Z =',3I5)
      STOP 43
      END
C     ****************************************************************
      SUBROUTINE FPACK(A,B,NX,NY,NZ,NDIM)
C     ****************************************************************
      COMPLEX A(NDIM),B(NDIM)
      MNBX=NX
      MNBY=NY
      MNBZ=NZ
      MXY=MNBX*MNBY
      NXY1=NX*NY+1
      DO 100 IZ=1,NZ
      IA2=MXY*IZ-MXY-MNBX
      IB2=NXY1*IZ-NXY1-NX
      DO 100 IY=1,NY
      IA=MNBX*IY+IA2
      IB=NX*IY+IB2
      DO 90 IX=1,NX
   90 B(IB+IX)=A(IA+IX)
  100 CONTINUE
      RETURN
      END
C     ****************************************************************
      SUBROUTINE FUNPK(A,B,NX,NY,NZ,NDIM)
C     ****************************************************************
      COMPLEX A(NDIM),B(NDIM)
      MNBX=NX
      MNBY=NY
      MNBZ=NZ
      MXY=MNBX*MNBY
      NZX1=NZ*NX+1
      DO 100 IZ=1,NZ
      IA2=IZ-NZX1-NZ
      IB2=MXY*IZ-MXY-MNBX
      DO 100 IY=1,NY
      IA=NZX1*IY+IA2
      IB=MNBX*IY+IB2
      DO 90 IX=1,NX
   90 B(IB+IX)=A(IA+IX*NZ)
  100 CONTINUE
      RETURN
      END
C     ****************************************************************
      SUBROUTINE FPERM(A,B,NX,NY,NZ,NDIM)
C     ****************************************************************
      COMPLEX A(NDIM),B(NDIM)
      NXY1=NX*NY+1
      NYZ1=NY*NZ+1
      DO 100 IZ=1,NZ
      IA2=NXY1*IZ-NXY1-NX
      IB2=NY*IZ-NYZ1-NY
      DO 100 IY=1,NY
      IA=NX*IY+IA2
      IB=IY+IB2
      DO 90 IX=1,NX
   90 B(IB+IX*NYZ1)=A(IA+IX)
  100 CONTINUE
      RETURN
      END
C***********************************************************************
C***********************************************************************
C!SEC CFFT99
C CFFT99     FROM XLIB                                     05/13/82
      SUBROUTINE CFFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C PURPOSE      PERFORMS MULTIPLE FAST FOURIER TRANSFORMS.  THIS PACKAGE
C              WILL PERFORM A NUMBER OF SIMULTANEOUS COMPLEX PERIODIC
C              FOURIER TRANSFORMS OR CORRESPONDING INVERSE TRANSFORMS.
C              THAT IS, GIVEN A SET OF COMPLEX GRIDPOINT VECTORS, THE
C              PACKAGE RETURNS A SET OF COMPLEX FOURIER
C              COEFFICIENT VECTORS, OR VICE VERSA.  THE LENGTH OF THE
C              TRANSFORMS MUST BE A NUMBER GREATER THAN 1 THAT HAS
C              NO PRIME FACTORS OTHER THAN 2, 3, AND 5.
C
C              THE PACKAGE CFFT99 CONTAINS SEVERAL USER-LEVEL ROUTINES:
C
C            SUBROUTINE CFTFAX
C                AN INITIALIZATION ROUTINE THAT MUST BE CALLED ONCE
C                BEFORE A SEQUENCE OF CALLS TO CFFT99
C                (PROVIDED THAT N IS NOT CHANGED).
C
C            SUBROUTINE CFFT99
C                THE ACTUAL TRANSFORM ROUTINE ROUTINE, CABABLE OF
C                PERFORMING BOTH THE TRANSFORM AND ITS INVERSE.
C                HOWEVER, AS THE TRANSFORMS ARE NOT NORMALIZED,
C                THE APPLICATION OF A TRANSFORM FOLLOWED BY ITS
C                INVERSE WILL YIELD THE ORIGINAL VALUES MULTIPLIED
C                BY N.
C
C
C ACCESS       *FORTRAN,P=XLIB,SN=CFFT99
C
C
C USAGE        LET N BE OF THE FORM 2**P * 3**Q * 5**R, WHERE P .GE. 0,
C              Q .GE. 0, AND R .GE. 0.  THEN A TYPICAL SEQUENCE OF
C              CALLS TO TRANSFORM A GIVEN SET OF COMPLEX VECTORS OF
C              LENGTH N TO A SET OF (UNSCALED) COMPLEX FOURIER
C              COEFFICIENT VECTORS OF LENGTH N IS
C
C                   DIMENSION IFAX(13),TRIGS(2*N)
C                   COMPLEX A(...), WORK(...)
C
C                   CALL CFTFAX (N, IFAX, TRIGS)
C                   CALL CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C              THE OUTPUT VECTORS OVERWRITE THE INPUT VECTORS, AND
C              THESE ARE STORED IN A.  WITH APPROPRIATE CHOICES FOR
C              THE OTHER ARGUMENTS, THESE VECTORS MAY BE CONSIDERED
C              EITHER THE ROWS OR THE COLUMNS OF THE ARRAY A.
C              SEE THE INDIVIDUAL WRITE-UPS FOR CFTFAX AND
C              CFFT99 BELOW, FOR A DETAILED DESCRIPTION OF THE
C              ARGUMENTS.
C
C HISTORY      THE PACKAGE WAS WRITTEN BY CLIVE TEMPERTON AT ECMWF IN
C              NOVEMBER, 1978.  IT WAS MODIFIED, DOCUMENTED, AND TESTED
C              FOR NCAR BY RUSS REW IN SEPTEMBER, 1980.  IT WAS
C              FURTHER MODIFIED FOR THE FULLY COMPLEX CASE BY DAVE
C              FULKER IN NOVEMBER, 1980.
C
C-----------------------------------------------------------------------
C
C SUBROUTINE CFTFAX (N,IFAX,TRIGS)
C
C PURPOSE      A SET-UP ROUTINE FOR CFFT99.  IT NEED ONLY BE
C              CALLED ONCE BEFORE A SEQUENCE OF CALLS TO CFFT99,
C              PROVIDED THAT N IS NOT CHANGED.
C
C ARGUMENT     IFAX(13),TRIGS(2*N)
C DIMENSIONS
C
C ARGUMENTS
C
C ON INPUT     N
C               AN EVEN NUMBER GREATER THAN 1 THAT HAS NO PRIME FACTOR
C               GREATER THAN 5.  N IS THE LENGTH OF THE TRANSFORMS (SEE
C               THE DOCUMENTATION FOR CFFT99 FOR THE DEFINITION OF
C               THE TRANSFORMS).
C
C              IFAX
C               AN INTEGER ARRAY.  THE NUMBER OF ELEMENTS ACTUALLY USED
C               WILL DEPEND ON THE FACTORIZATION OF N.  DIMENSIONING
C               IFAX FOR 13 SUFFICES FOR ALL N LESS THAN 1 MILLION.
C
C              TRIGS
C               A REAL ARRAY OF DIMENSION 2*N
C
C ON OUTPUT    IFAX
C               CONTAINS THE FACTORIZATION OF N.  IFAX(1) IS THE
C               NUMBER OF FACTORS, AND THE FACTORS THEMSELVES ARE STORED
C               IN IFAX(2),IFAX(3),...  IF N HAS ANY PRIME FACTORS
C               GREATER THAN 5, IFAX(1) IS SET TO -99.
C
C              TRIGS
C               AN ARRAY OF TRIGONOMETRIC FUNCTION VALUES SUBSEQUENTLY
C               USED BY THE CFT ROUTINES.
C
C-----------------------------------------------------------------------
C
C SUBROUTINE CFFT99 (A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C PURPOSE      PERFORM A NUMBER OF SIMULTANEOUS (UNNORMALIZED) COMPLEX
C              PERIODIC FOURIER TRANSFORMS OR CORRESPONDING INVERSE
C              TRANSFORMS.  GIVEN A SET OF COMPLEX GRIDPOINT
C              VECTORS, THE PACKAGE RETURNS A SET OF
C              COMPLEX FOURIER COEFFICIENT VECTORS, OR VICE
C              VERSA.  THE LENGTH OF THE TRANSFORMS MUST BE A
C              NUMBER HAVING NO PRIME FACTORS OTHER THAN
C              2, 3, AND 5.  THIS ROUTINE IS
C              OPTIMIZED FOR USE ON THE CRAY-1.
C
C ARGUMENT     COMPLEX A(N*INC+(LOT-1)*JUMP), WORK(N*LOT)
C DIMENSIONS   REAL TRIGS(2*N), INTEGER IFAX(13)
C
C ARGUMENTS
C
C ON INPUT     A
C               A COMPLEX ARRAY OF LENGTH N*INC+(LOT-1)*JUMP CONTAINING
C               THE INPUT GRIDPOINT OR COEFFICIENT VECTORS.  THIS ARRAY
C               OVERWRITTEN BY THE RESULTS.
C
C               N.B. ALTHOUGH THE ARRAY A IS USUALLY CONSIDERED TO BE OF
C               TYPE COMPLEX IN THE CALLING PROGRAM, IT IS TREATED AS
C               REAL WITHIN THE TRANSFORM PACKAGE.  THIS REQUIRES THAT
C               SUCH TYPE CONFLICTS ARE PERMITTED IN THE USER'S
C               ENVIRONMENT, AND THAT THE STORAGE OF COMPLEX NUMBERS
C               MATCHES THE ASSUMPTIONS OF THIS ROUTINE.  THIS ROUTINE
C               ASSUMES THAT THE REAL AND IMAGINARY PORTIONS OF A
C               COMPLEX NUMBER OCCUPY ADJACENT ELEMENTS OF MEMORY.  IF
C               THESE CONDITIONS ARE NOT MET, THE USER MUST TREAT THE
C               ARRAY A AS REAL (AND OF TWICE THE ABOVE LENGTH), AND
C               WRITE THE CALLING PROGRAM TO TREAT THE REAL AND
C               IMAGINARY PORTIONS EXPLICITLY.
C
C              WORK
C               A COMPLEX WORK ARRAY OF LENGTH N*LOT OR A REAL ARRAY
C               OF LENGTH 2*N*LOT.  SEE N.B. ABOVE.
C
C              TRIGS
C               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST.
C
C              IFAX
C               AN ARRAY SET UP BY CFTFAX, WHICH MUST BE CALLED FIRST.
C
C
C               N.B. IN THE FOLLOWING ARGUMENTS, INCREMENTS ARE MEASURED
C               IN WORD PAIRS, BECAUSE EACH COMPLEX ELEMENT IS ASSUMED
C               TO OCCUPY AN ADJACENT PAIR OF WORDS IN MEMORY.
C
C              INC
C               THE INCREMENT (IN WORD PAIRS) BETWEEN SUCCESSIVE ELEMENT
C               OF EACH (COMPLEX) GRIDPOINT OR COEFFICIENT VECTOR
C               (E.G.  INC=1 FOR CONSECUTIVELY STORED DATA).
C
C              JUMP
C               THE INCREMENT (IN WORD PAIRS) BETWEEN THE FIRST ELEMENTS
C               OF SUCCESSIVE DATA OR COEFFICIENT VECTORS.  ON THE CRAY-
C               TRY TO ARRANGE DATA SO THAT JUMP IS NOT A MULTIPLE OF 8
C               (TO AVOID MEMORY BANK CONFLICTS).  FOR CLARIFICATION OF
C               INC AND JUMP, SEE THE EXAMPLES BELOW.
C
C              N
C               THE LENGTH OF EACH TRANSFORM (SEE DEFINITION OF
C               TRANSFORMS, BELOW).
C
C              LOT
C               THE NUMBER OF TRANSFORMS TO BE DONE SIMULTANEOUSLY.
C
C              ISIGN
C               = -1 FOR A TRANSFORM FROM GRIDPOINT VALUES TO FOURIER
C                    COEFFICIENTS.
C               = +1 FOR A TRANSFORM FROM FOURIER COEFFICIENTS TO
C                    GRIDPOINT VALUES.
C
C ON OUTPUT    A
C               IF ISIGN = -1, AND LOT GRIDPOINT VECTORS ARE SUPPLIED,
C               EACH CONTAINING THE COMPLEX SEQUENCE:
C
C               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES)
C
C               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH
C               CONTAINING THE CORRESPONDING N COEFFICIENT VALUES:
C
C               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES)
C
C               DEFINED BY:
C                 C(K) = SUM(J=0,...,N-1)( G(J)*EXP(-2*I*J*K*PI/N) )
C                 WHERE I = SQRT(-1)
C
C
C               IF ISIGN = +1, AND LOT COEFFICIENT VECTORS ARE SUPPLIED,
C               EACH CONTAINING THE COMPLEX SEQUENCE:
C
C               C(0),C(1), ... ,C(N-1)  (N COMPLEX VALUES)
C
C               THEN THE RESULT CONSISTS OF LOT COMPLEX VECTORS EACH
C               CONTAINING THE CORRESPONDING N GRIDPOINT VALUES:
C
C               G(0),G(1), ... ,G(N-1)  (N COMPLEX VALUES)
C
C               DEFINED BY:
C                 G(J) = SUM(K=0,...,N-1)( G(K)*EXP(+2*I*J*K*PI/N) )
C                 WHERE I = SQRT(-1)
C
C
C               A CALL WITH ISIGN=-1 FOLLOWED BY A CALL WITH ISIGN=+1
C               (OR VICE VERSA) RETURNS THE ORIGINAL DATA, MULTIPLIED
C               BY THE FACTOR N.
C
C
C EXAMPLE       GIVEN A 64 BY 9 GRID OF COMPLEX VALUES, STORED IN
C               A 66 BY 9 COMPLEX ARRAY, A, COMPUTE THE TWO DIMENSIONAL
C               FOURIER TRANSFORM OF THE GRID.  FROM TRANSFORM THEORY,
C               IT IS KNOWN THAT A TWO DIMENSIONAL TRANSFORM CAN BE
C               OBTAINED BY FIRST TRANSFORMING THE GRID ALONG ONE
C               DIRECTION, THEN TRANSFORMING THESE RESULTS ALONG THE
C               ORTHOGONAL DIRECTION.
C
C               COMPLEX A(66,9), WORK(64,9)
C               REAL TRIGS1(128), TRIGS2(18)
C               INTEGER IFAX1(13), IFAX2(13)
C
C               SET UP THE IFAX AND TRIGS ARRAYS FOR EACH DIRECTION:
C
C               CALL CFTFAX(64, IFAX1, TRIGS1)
C               CALL CFTFAX( 9, IFAX2, TRIGS2)
C
C               IN THIS CASE, THE COMPLEX VALUES OF THE GRID ARE
C               STORED IN MEMORY AS FOLLOWS (USING U AND V TO
C               DENOTE THE REAL AND IMAGINARY COMPONENTS, AND
C               ASSUMING CONVENTIONAL FORTRAN STORAGE):
C
C   U(1,1), V(1,1), U(2,1), V(2,1),  ...  U(64,1), V(64,1), 4 NULLS,
C
C   U(1,2), V(1,2), U(2,2), V(2,2),  ...  U(64,2), V(64,2), 4 NULLS,
C
C   .       .       .       .         .   .        .        .
C   .       .       .       .         .   .        .        .
C   .       .       .       .         .   .        .        .
C
C   U(1,9), V(1,9), U(2,9), V(2,9),  ...  U(64,9), V(64,9), 4 NULLS.
C
C               WE CHOOSE (ARBITRARILY) TO TRANSORM FIRST ALONG THE
C               DIRECTION OF THE FIRST SUBSCRIPT.  THUS WE DEFINE
C               THE LENGTH OF THE TRANSFORMS, N, TO BE 64, THE
C               NUMBER OF TRANSFORMS, LOT, TO BE 9, THE INCREMENT
C               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 1,
C               AND THE INCREMENT BETWEEN THE STARTING POINTS
C               FOR EACH TRANSFORM, JUMP, TO BE 66 (THE FIRST
C               DIMENSION OF A).
C
C               CALL CFFT99( A, WORK, TRIGS1, IFAX1, 1, 66, 64, 9, -1)
C
C               TO TRANSFORM ALONG THE DIRECTION OF THE SECOND SUBSCRIPT
C               THE ROLES OF THE INCREMENTS ARE REVERSED.  THUS WE DEFIN
C               THE LENGTH OF THE TRANSFORMS, N, TO BE 9, THE
C               NUMBER OF TRANSFORMS, LOT, TO BE 64, THE INCREMENT
C               BETWEEN ELEMENTS OF EACH TRANSFORM, INC, TO BE 66,
C               AND THE INCREMENT BETWEEN THE STARTING POINTS
C               FOR EACH TRANSFORM, JUMP, TO BE 1
C
C               CALL CFFT99( A, WORK, TRIGS2, IFAX2, 66, 1, 9, 64, -1)
C
C               THESE TWO SEQUENTIAL STEPS RESULTS IN THE TWO-DIMENSIONA
C               FOURIER COEFFICIENT ARRAY OVERWRITING THE INPUT
C               GRIDPOINT ARRAY, A.  THE SAME TWO STEPS APPLIED AGAIN
C               WITH ISIGN = +1 WOULD RESULT IN THE RECONSTRUCTION OF
C               THE GRIDPOINT ARRAY (MULTIPLIED BY A FACTOR OF 64*9).
C
C
C-----------------------------------------------------------------------
c--      DIMENSION A(1),WORK(1),TRIGS(1),IFAX(1)
      DIMENSION A(*),WORK(*),TRIGS(*),IFAX(*)
C
C     SUBROUTINE 'CFFT99' - MULTIPLE FAST COMPLEX FOURIER TRANSFORM
C
C     A IS THE ARRAY CONTAINING INPUT AND OUTPUT DATA
C     WORK IS AN AREA OF SIZE N*LOT
C     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
C     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N
C     INC IS THE INCREMENT WITHIN EACH DATA "VECTOR"
C         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
C     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
C     N IS THE LENGTH OF THE DATA VECTORS
C     LOT IS THE NUMBER OF DATA VECTORS
C     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
C           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
C
C
C     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS IN
C     PARALLEL.
C
C
C THE FOLLOWING CALL IS FOR MONITORING LIBRARY USE AT NCAR
C     CALL Q8QST4 ( 4HXLIB, 6HCFFT99, 6HCFFT99, 10HVERSION 01)
C
      NN = N+N
      INK=INC+INC
      JUM = JUMP+JUMP
      NFAX=IFAX(1)
      JNK = 2
      JST = 2
      IF (ISIGN.GE.0) GO TO 30
C
C     THE INNERMOST TEMPERTON ROUTINES HAVE NO FACILITY FOR THE
C     FORWARD (ISIGN = -1) TRANSFORM.  THEREFORE, THE INPUT MUST BE
C     REARRANGED AS FOLLOWS:
C
C     THE ORDER OF EACH INPUT VECTOR,
C
C     G(0), G(1), G(2), ... , G(N-2), G(N-1)
C
C     IS REVERSED (EXCLUDING G(0)) TO YIELD
C
C     G(0), G(N-1), G(N-2), ... , G(2), G(1).
C
C     WITHIN THE TRANSFORM, THE CORRESPONDING EXPONENTIAL MULTIPLIER
C     IS THEN PRECISELY THE CONJUGATE OF THAT FOR THE NORMAL
C     ORDERING.  THUS THE FORWARD (ISIGN = -1) TRANSFORM IS
C     ACCOMPLISHED
C
C     FOR NFAX ODD, THE INPUT MUST BE TRANSFERRED TO THE WORK ARRAY,
C     AND THE REARRANGEMENT CAN BE DONE DURING THE MOVE.
C
      JNK = -2
      JST = NN-2
      IF (MOD(NFAX,2).EQ.1) GOTO 40
C
C     FOR NFAX EVEN, THE REARRANGEMENT MUST BE APPLIED DIRECTLY TO
C     THE INPUT ARRAY.  THIS CAN BE DONE BY SWAPPING ELEMENTS.
C
      IBASE = 1
      ILAST = (N-1)*INK
      NH = N/2
      DO 20 L=1,LOT
      I1 = IBASE+INK
      I2 = IBASE+ILAST
CDIR$ IVDEP
      DO 10 M=1,NH
C     SWAP REAL AND IMAGINARY PORTIONS
      HREAL = A(I1)
      HIMAG = A(I1+1)
      A(I1) = A(I2)
      A(I1+1) = A(I2+1)
      A(I2) = HREAL
      A(I2+1) = HIMAG
      I1 = I1+INK
      I2 = I2-INK
   10 CONTINUE
      IBASE = IBASE+JUM
   20 CONTINUE
      GOTO 100
C
   30 CONTINUE
      IF (MOD(NFAX,2).EQ.0) GOTO 100
C
   40 CONTINUE
C
C     DURING THE TRANSFORM PROCESS, NFAX STEPS ARE TAKEN, AND THE
C     RESULTS ARE STORED ALTERNATELY IN WORK AND IN A.  IF NFAX IS
C     ODD, THE INPUT DATA ARE FIRST MOVED TO WORK SO THAT THE FINAL
C     RESULT (AFTER NFAX STEPS) IS STORED IN ARRAY A.
C
      IBASE=1
      JBASE=1
      DO 60 L=1,LOT
C     MOVE REAL AND IMAGINARY PORTIONS OF ELEMENT ZERO
      WORK(JBASE) = A(IBASE)
      WORK(JBASE+1) = A(IBASE+1)
      I=IBASE+INK
      J=JBASE+JST
CDIR$ IVDEP
      DO 50 M=2,N
C     MOVE REAL AND IMAGINARY PORTIONS OF OTHER ELEMENTS (POSSIBLY IN
C     REVERSE ORDER, DEPENDING ON JST AND JNK)
      WORK(J) = A(I)
      WORK(J+1) = A(I+1)
      I=I+INK
      J=J+JNK
   50 CONTINUE
      IBASE=IBASE+JUM
      JBASE=JBASE+NN
   60 CONTINUE
C
  100 CONTINUE
C
C     PERFORM THE TRANSFORM PASSES, ONE PASS FOR EACH FACTOR.  DURING
C     EACH PASS THE DATA ARE MOVED FROM A TO WORK OR FROM WORK TO A.
C
C     FOR NFAX EVEN, THE FIRST PASS MOVES FROM A TO WORK
      IGO = 110
C     FOR NFAX ODD, THE FIRST PASS MOVES FROM WORK TO A
      IF (MOD(NFAX,2).EQ.1) IGO = 120
      LA=1
      DO 140 K=1,NFAX
      IF (IGO.EQ.120) GO TO 120
  110 CONTINUE
      CALL VPASSM(A(1),A(2),WORK(1),WORK(2),TRIGS,
     *   INK,2,JUM,NN,LOT,N,IFAX(K+1),LA)
      IGO=120
      GO TO 130
  120 CONTINUE
      CALL VPASSM(WORK(1),WORK(2),A(1),A(2),TRIGS,
     *    2,INK,NN,JUM,LOT,N,IFAX(K+1),LA)
      IGO=110
  130 CONTINUE
      LA=LA*IFAX(K+1)
  140 CONTINUE
C
C     AT THIS POINT THE FINAL TRANSFORM RESULT IS STORED IN A.
C
      RETURN
      END
      SUBROUTINE CFTFAX(N,IFAX,TRIGS)
      DIMENSION IFAX(13),TRIGS(*)
C
C     THIS ROUTINE WAS MODIFIED FROM TEMPERTON'S ORIGINAL
C     BY DAVE FULKER.  IT NO LONGER PRODUCES FACTORS IN ASCENDING
C     ORDER, AND THERE ARE NONE OF THE ORIGINAL "MODE" OPTIONS.
C
C ON INPUT     N
C               THE LENGTH OF EACH COMPLEX TRANSFORM TO BE PERFORMED
C
C               N MUST BE GREATER THAN 1 AND CONTAIN NO PRIME
C               FACTORS GREATER THAN 5.
C
C ON OUTPUT    IFAX
C               IFAX(1)
C                 THE NUMBER OF FACTORS CHOSEN OR -99 IN CASE OF ERROR
C               IFAX(2) THRU IFAX( IFAX(1)+1 )
C                 THE FACTORS OF N IN THE FOLLOWIN ORDER:  APPEARING
C                 FIRST ARE AS MANY FACTORS OF 4 AS CAN BE OBTAINED.
C                 SUBSEQUENT FACTORS ARE PRIMES, AND APPEAR IN
C                 ASCENDING ORDER, EXCEPT FOR MULTIPLE FACTORS.
C
C              TRIGS
C               2N SIN AND COS VALUES FOR USE BY THE TRANSFORM ROUTINE
C
      CALL FACT(N,IFAX)
      K = IFAX(1)
      IF (K .LT. 1 .OR. IFAX(K+1) .GT. 5) IFAX(1) = -99
      IF (IFAX(1) .LE. 0 ) WRITE (*,991) IFAX(1)
      IF (IFAX(1) .LE. 0 ) CALL EXIT
  991 FORMAT (' FFTFAX -- INVALID N',I5)
      CALL CFTRIG (N, TRIGS)
      RETURN
      END
      SUBROUTINE FACT(N,IFAX)
C     FACTORIZATION ROUTINE THAT FIRST EXTRACTS ALL FACTORS OF 4
      DIMENSION IFAX(13)
      IF (N.GT.1) GO TO 10
      IFAX(1) = 0
      IF (N.LT.1) IFAX(1) = -99
      RETURN
   10 NN=N
      K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD(NN,4).NE.0) GO TO 30
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD(NN,2).NE.0) GO TO 40
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
C     TEST FOR FACTORS OF 3
   40 IF (MOD(NN,3).NE.0) GO TO 50
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
C     NOW FIND REMAINING FACTORS
   50 L=5
      MAX = SQRT(FLOAT(NN))
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD(NN,L).NE.0) GO TO 70
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
   70 IF (L.GT.MAX) GO TO 75
      L=L+INC
      INC=6-INC
      GO TO 60
   75 K = K+1
      IFAX(K) = NN
   80 IFAX(1)=K-1
C     IFAX(1) NOW CONTAINS NUMBER OF FACTORS
      RETURN
      END
      SUBROUTINE CFTRIG(N,TRIGS)
      DIMENSION TRIGS(*)
      PI=2.0*ASIN(1.0)
      DEL=(PI+PI)/FLOAT(N)
      L=N+N
      DO 10 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(I)=COS(ANGLE)
      TRIGS(I+1)=SIN(ANGLE)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE VPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,LA)
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)
C
C     SUBROUTINE 'VPASSM' - MULTIPLE VERSION OF 'VPASSA'
C     PERFORMS ONE PASS THROUGH DATA
C     AS PART OF MULTIPLE COMPLEX (INVERSE) FFT ROUTINE
C     A IS FIRST REAL INPUT VECTOR
C     B IS FIRST IMAGINARY INPUT VECTOR
C     C IS FIRST REAL OUTPUT VECTOR
C     D IS FIRST IMAGINARY OUTPUT VECTOR
C     TRIGS IS PRECALCULATED TABLE OF SINES & COSINES
C     INC1 IS ADDRESSING INCREMENT FOR A AND B
C     INC2 IS ADDRESSING INCREMENT FOR C AND D
C     INC3 IS ADDRESSING INCREMENT BETWEEN A'S & B'S
C     INC4 IS ADDRESSING INCREMENT BETWEEN C'S & D'S
C     LOT IS THE NUMBER OF VECTORS
C     N IS LENGTH OF VECTORS
C     IFAC IS CURRENT FACTOR OF N
C     LA IS PRODUCT OF PREVIOUS FACTORS
C
      DATA SIN36/0.587785252292473/,COS36/0.809016994374947/,
     *     SIN72/0.951056516295154/,COS72/0.309016994374947/,
     *     SIN60/0.866025403784437/
C
      M=N/IFAC
      IINK=M*INC1
      JINK=LA*INC2
      JUMP=(IFAC-1)*JINK
      IBASE=0
      JBASE=0
      IGO=IFAC-1
      IF (IGO.GT.4) RETURN
      GO TO (10,50,90,130),IGO
C
C     CODING FOR FACTOR 2
C
   10 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      DO 20 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 15 IJK=1,LOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)+B(IB+I)
      C(JB+J)=A(IA+I)-A(IB+I)
      D(JB+J)=B(IA+I)-B(IB+I)
      I=I+INC3
      J=J+INC4
   15 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   20 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 40 K=LA1,M,LA
      KB=K+K-2
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      DO 30 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 25 IJK=1,LOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)+B(IB+I)
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)-B(IB+I))
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)-B(IB+I))
      I=I+INC3
      J=J+INC4
   25 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   30 CONTINUE
      JBASE=JBASE+JUMP
   40 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 3
C
   50 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      DO 60 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 55 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IC+I))
      C(JB+J)=(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I)))
      C(JC+J)=(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I)))
      D(JB+J)=(B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I)))
      D(JC+J)=(B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I)))
      I=I+INC3
      J=J+INC4
   55 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   60 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 80 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      DO 70 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 65 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IC+I))
      C(JB+J)=
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      D(JB+J)=
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)-B(IC+I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      C(JC+J)=
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      D(JC+J)=
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)-B(IC+I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)+B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      I=I+INC3
      J=J+INC4
   65 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
   70 CONTINUE
      JBASE=JBASE+JUMP
   80 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 4
C
   90 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      DO 100 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 95 IJK=1,LOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      C(JC+J)=(A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)+B(IC+I))+(B(IB+I)+B(ID+I))
      D(JC+J)=(B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I))
      C(JB+J)=(A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I))
      C(JD+J)=(A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I))
      D(JB+J)=(B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I))
      D(JD+J)=(B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I))
      I=I+INC3
      J=J+INC4
   95 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  100 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 120 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      KD=KC+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      DO 110 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 105 IJK=1,LOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)+B(IC+I))+(B(IB+I)+B(ID+I))
      C(JC+J)=
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   -S2*((B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I)))
      D(JC+J)=
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   +C2*((B(IA+I)+B(IC+I))-(B(IB+I)+B(ID+I)))
      C(JB+J)=
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I)))
     *   -S1*((B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I)))
      D(JB+J)=
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)-B(ID+I)))
     *   +C1*((B(IA+I)-B(IC+I))+(A(IB+I)-A(ID+I)))
      C(JD+J)=
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I)))
     *   -S3*((B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I)))
      D(JD+J)=
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)-B(ID+I)))
     *   +C3*((B(IA+I)-B(IC+I))-(A(IB+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  105 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  110 CONTINUE
      JBASE=JBASE+JUMP
  120 CONTINUE
      RETURN
C
C     CODING FOR FACTOR 5
C
  130 IA=1
      JA=1
      IB=IA+IINK
      JB=JA+JINK
      IC=IB+IINK
      JC=JB+JINK
      ID=IC+IINK
      JD=JC+JINK
      IE=ID+IINK
      JE=JD+JINK
      DO 140 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 135 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IE+I))+(B(IC+I)+B(ID+I))
      C(JB+J)=(A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *  -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I)))
      C(JE+J)=(A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *  +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I)))
      D(JB+J)=(B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *  +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I)))
      D(JE+J)=(B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *  -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I)))
      C(JC+J)=(A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *  -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I)))
      C(JD+J)=(A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *  +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I)))
      D(JC+J)=(B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *  +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I)))
      D(JD+J)=(B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *  -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  135 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  140 CONTINUE
      IF (LA.EQ.M) RETURN
      LA1=LA+1
      JBASE=JBASE+JUMP
      DO 160 K=LA1,M,LA
      KB=K+K-2
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      DO 150 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 145 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))
      D(JA+J)=B(IA+I)+(B(IB+I)+B(IE+I))+(B(IC+I)+B(ID+I))
      C(JB+J)=
     *    C1*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   -S1*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      D(JB+J)=
     *    S1*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      -(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   +C1*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      +(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      C(JE+J)=
     *    C4*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   -S4*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      D(JE+J)=
     *    S4*((A(IA+I)+COS72*(A(IB+I)+A(IE+I))-COS36*(A(IC+I)+A(ID+I)))
     *      +(SIN72*(B(IB+I)-B(IE+I))+SIN36*(B(IC+I)-B(ID+I))))
     *   +C4*((B(IA+I)+COS72*(B(IB+I)+B(IE+I))-COS36*(B(IC+I)+B(ID+I)))
     *      -(SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))))
      C(JC+J)=
     *    C2*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   -S2*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      D(JC+J)=
     *    S2*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      -(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   +C2*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      +(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      C(JD+J)=
     *    C3*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   -S3*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      D(JD+J)=
     *    S3*((A(IA+I)-COS36*(A(IB+I)+A(IE+I))+COS72*(A(IC+I)+A(ID+I)))
     *      +(SIN36*(B(IB+I)-B(IE+I))-SIN72*(B(IC+I)-B(ID+I))))
     *   +C3*((B(IA+I)-COS36*(B(IB+I)+B(IE+I))+COS72*(B(IC+I)+B(ID+I)))
     *      -(SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))))
      I=I+INC3
      J=J+INC4
  145 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  150 CONTINUE
      JBASE=JBASE+JUMP
  160 CONTINUE
      RETURN
      END

      SUBROUTINE XYZINT(XYZ,NUMAT,NA,NB,NC,DEGREE,GEO)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XYZ(3,*), NA(*), NB(*), NC(*), GEO(3,*)
***********************************************************************
*
* XYZINT WORKS OUT THE INTERNAL COORDINATES OF A MOLECULE.
*        THE "RULES" FOR THE CONNECTIVITY ARE AS FOLLOWS:
*        ATOM I IS DEFINED AS BEING AT A DISTANCE FROM THE NEAREST
*        ATOM J, ATOM J ALREADY HAVING BEEN DEFINED.
*        ATOM I MAKES AN ANGLE WITH ATOM J AND THE ATOM K, WHICH HAS
*        ALREADY BEEN DEFINED, AND IS THE NEAREST ATOM TO J
*        ATOM I MAKES A DIHEDRAL ANGLE WITH ATOMS J, K, AND L. L HAVING
*        BEEN DEFINED AND IS THE NEAREST ATOM TO K, AND J, K AND L
*        HAVE A CONTAINED ANGLE IN THE RANGE 15 TO 165 DEGREES,
*        IF POSSIBLE.
*
*        IF(NA(2).EQ.1 THEN THE ORIGINAL CONNECTIVITY IS USED.
*
*        NOTE THAT GEO AND XYZ MUST NOT BE THE SAME IN THE CALL.
*
*   ON INPUT XYZ    = CARTESIAN ARRAY OF NUMAT ATOMS
*            DEGREE = 1 IF ANGLES ARE TO BE IN RADIANS
*            DEGREE = 57.29578 IF ANGLES ARE TO BE IN DEGREES
*
***********************************************************************
      COMMON /GEOOK/ IGEOOK
      LOGICAL FIRST
      DATA FIRST/.TRUE./
      IGEOOK=99
      NAI1=0
      NAI2=0
      IF(.NOT.FIRST.AND.NA(2).EQ.-1)THEN
         NA(2)=1
         DO 10 I=2,NUMAT
            J=NA(I)
            IF(I.GT.3)CALL DIHED(XYZ,I,J,NB(I),NC(I),GEO(3,I))
            IF(I.GT.2)CALL BANGLE(XYZ,I,J,NB(I),GEO(2,I))
            GEO(1,I)=SQRT((XYZ(1,I)-XYZ(1,J))**2+
     1          (XYZ(2,I)-XYZ(2,J))**2+
     2          (XYZ(3,I)-XYZ(3,J))**2)
   10    CONTINUE
      ELSE
         IF(NA(2).EQ.-1)FIRST=.FALSE.
         DO 30 I=1,NUMAT
            NA(I)=2
            NB(I)=3
            NC(I)=4
            IM1=I-1
            IF(IM1.EQ.0)GOTO 30
            SUM=1.D30
            DO 20 J=1,IM1
               R=(XYZ(1,I)-XYZ(1,J))**2+
     1          (XYZ(2,I)-XYZ(2,J))**2+
     2          (XYZ(3,I)-XYZ(3,J))**2
               IF(R.LT.SUM.AND.NA(J).NE.J.AND.NB(J).NE.J) THEN
                  SUM=R
                  K=J
               ENDIF
   20       CONTINUE
C
C   ATOM I IS NEAREST TO ATOM K
C
            NA(I)=K
            IF(I.GT.2)NB(I)=NA(K)
            IF(I.GT.3)NC(I)=NB(K)
C
C   FIND ANY ATOM TO RELATE TO NA(I)
C
   30    CONTINUE
      ENDIF
      NA(1)=0
      NB(1)=0
      NC(1)=0
      NB(2)=0
      NC(2)=0
      NC(3)=0
      CALL XYZGEO(XYZ,NUMAT,NA,NB,NC,DEGREE,GEO)
      RETURN
      END

      SUBROUTINE DFPSAV(TOTIME,XPARAM,GD,XLAST,FUNCT1,MDFP,XDFP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION XPARAM(*), GD(*), XLAST(*), MDFP(9),XDFP(9)
**********************************************************************
*
* DFPSAV STORES AND RESTORES DATA USED IN THE D-F-P GEOMETRY
*        OPTIMISATION.
*
*  ON INPUT TOTIME = TOTAL CPU TIME ELAPSED DURING THE CALCULATION.
*           XPARAM = CURRENT VALUE OF PARAMETERS.
*           GD     = OLD GRADIENT.
*           XLAST  = OLD VALUE OF PARAMETERS.
*           FUNCT1 = CURRENT VALUE OF HEAT OF FORMATION.
*           MDFP   = INTEGER CONSTANTS USED IN D-F-P.
*           XDFP   = REAL CONSTANTS USED IN D-F-P.
*           MDFP(9)= 1 FOR DUMP, 0 FOR RESTORE.
**********************************************************************
      COMMON /KEYWRD/ KEYWRD
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /GRADNT/ GRAD(MAXPAR),GNORM
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), IDUMY, DUMY(MAXPAR)
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /ALPARM/ ALPARM(3,MAXPAR),X0, X1, X2, ILOOP
      COMMON /REACTN/ STEP, GEOA(3,NUMATM), GEOVEC(3,NUMATM),CALCST
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /PATH  / LATOM,LPARAM,REACT(200)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /FMATRX/ HESINV(MAXHES)
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                     LOCDEP(MAXPAR)
      COMMON /ERRFN / ERRFN(MAXPAR)
      DIMENSION IEL1(3),Q(3), COORD(3,NUMATM)
      CHARACTER ELEMNT*2, KEYWRD*80,KOMENT*80, TITLE*80
      LOGICAL FIRST, INTXYZ
      DATA FIRST /.TRUE./
CDEP
      OPEN(UNIT=9,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=9,FILE='FOR009',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 9
CDEP
      OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 10
      DEGREE=57.29577951D0
      IR=9
      IF(MDFP(9) .NE. 0) THEN
         IF(MDFP(9) .EQ. 1) THEN
            WRITE(6,'(//10X,''- - - - - - - TIME UP - - - - - - -'',//)'
     1)
            IF(INDEX(KEYWRD,'SADDLE') .NE. 0) THEN
               WRITE(6,'(//10X,'' NO RESTART EXISTS FOR SADDLE'',//
     1  10X,'' HERE IS A DATA-FILE FILES THAT MIGHT BE SUITABLE'',/
     2  10X,'' FOR RESTARTING THE CALCULATION'',///)')
               WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
               INTXYZ=(NA(1).EQ.0)
               DO 60 ILOOP=1,2
                  IF(INTXYZ)THEN
                     GEO(2,1)=0.D0
                     GEO(3,1)=0.D0
                     GEO(1,1)=0.D0
                     GEO(2,2)=0.D0
                     GEO(3,2)=0.D0
                     GEO(3,3)=0.D0
                     DO 10 I=1,NATOMS
                        DO 10 J=1,3
   10                COORD(J,I)=GEO(J,I)
                  ELSE
                     CALL XYZINT(GEO,NUMAT,NA,NB,NC,1.D0,COORD)
                  ENDIF
                  IVAR=1
                  NA(1)=0
                  DO 40 I=1,NATOMS
                     DO 20 J=1,3
   20                IEL1(J)=0
   30                CONTINUE
                     IF(LOC(1,IVAR).EQ.I) THEN
                        IEL1(LOC(2,IVAR))=1
                        IVAR=IVAR+1
                        GOTO 30
                     ENDIF
                     IF(I.LT.4) THEN
                        IEL1(3)=0
                        IF(I.LT.3) THEN
                           IEL1(2)=0
                           IF(I.LT.2) THEN
                              IEL1(1)=0
                           ENDIF
                        ENDIF
                     ENDIF
                     IF(I.EQ.LATOM)IEL1(LPARAM)=-1
                     Q(1)=COORD(1,I)
                     Q(2)=COORD(2,I)*DEGREE
                     Q(3)=COORD(3,I)*DEGREE
   40             WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3)')
     1    ELEMNT(LABELS(I)),(Q(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I)
                  I=0
                  X=0.D0
                  WRITE(6,'(I4,3(F12.6,I3),I4,2I3)')
     1    I,X,I,X,I,X,I,I,I,I
                  DO 50 I=1,NATOMS
                     DO 50 J=1,3
   50             GEO(J,I)=GEOA(J,I)
                  NA(1)=99
   60          CONTINUE
               WRITE(6,'(///10X,''CALCULATION TERMINATED HERE'')')
               CALL WRAPUP()
            ENDIF
            WRITE(6,'(//10X,'' - THE CALCULATION IS BEING DUMPED TO DISK
     1'',  /10X,''   RESTART IT USING THE MAGIC WORD "RESTART"'')')
            WRITE(6,'(//10X,''CURRENT VALUE OF HEAT OF FORMATION =''
     1  ,F12.6)')FUNCT1
         ENDIF
         IF(MDFP(9) .EQ. 1)THEN
            IF(NA(1) .EQ. 99) THEN
C
C  CONVERT FROM CARTESIAN COORDINATES TO INTERNAL
C
               DO 70 I=1,NATOMS
                  DO 70 J=1,3
   70          COORD(J,I)=GEO(J,I)
               CALL XYZINT(COORD,NUMAT,NA,NB,NC,1.D0,GEO)
            ENDIF
            GEO(2,1)=0.D0
            GEO(3,1)=0.D0
            GEO(1,1)=0.D0
            GEO(2,2)=0.D0
            GEO(3,2)=0.D0
            GEO(3,3)=0.D0
            IVAR=1
            NA(1)=0
            WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
            DO 100 I=1,NATOMS
               DO 80 J=1,3
   80          IEL1(J)=0
   90          CONTINUE
               IF(LOC(1,IVAR).EQ.I) THEN
                  IEL1(LOC(2,IVAR))=1
                  IVAR=IVAR+1
                  GOTO 90
               ENDIF
               IF(I.LT.4) THEN
                  IEL1(3)=0
                  IF(I.LT.3) THEN
                     IEL1(2)=0
                     IF(I.LT.2) THEN
                        IEL1(1)=0
                     ENDIF
                  ENDIF
               ENDIF
               IF(I.EQ.LATOM)IEL1(LPARAM)=-1
               Q(1)=GEO(1,I)
               Q(2)=GEO(2,I)*DEGREE
               Q(3)=GEO(3,I)*DEGREE
  100       WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3)')
     1ELEMNT(LABELS(I)),(Q(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I)
            I=0
            X=0.D0
            WRITE(6,'(I4,3(F12.6,I3),I4,2I3)')
     1I,X,I,X,I,X,I,I,I,I
            IF(NDEP.NE.0)THEN
               DO 110 I=1,NDEP
  110          WRITE(6,'(3(I4,'',''))')LOCPAR(I),IDEPFN(I),LOCDEP(I)
               WRITE(6,*)
            ENDIF
         ENDIF
         WRITE(IR)MDFP,XDFP,TOTIME,FUNCT1
         WRITE(IR)(XPARAM(I),I=1,NVAR),(GD(I),I=1,NVAR)
         WRITE(IR)(XLAST(I),I=1,NVAR),(GRAD(I),I=1,NVAR)
         LINEAR=(NVAR*(NVAR+1))/2
         WRITE(IR)(HESINV(I),I=1,LINEAR)
         LINEAR=(NORBS*(NORBS+1))/2
         WRITE(10)(PA(I),I=1,LINEAR)
         IF(NALPHA.NE.0)WRITE(10)(PB(I),I=1,LINEAR)
         IF(LATOM .NE. 0) THEN
            WRITE(IR)((ALPARM(J,I),J=1,3),I=1,NVAR)
            WRITE(IR)ILOOP,X0, X1, X2
         ENDIF
         WRITE(IR)(ERRFN(I),I=1,NVAR)
         CLOSE (9)
         CLOSE (10)
      ELSE
         IF (FIRST) WRITE(6,'(//10X,'' RESTORING DATA FROM DISK''/)')
         READ(IR,END=130,ERR=130)MDFP,XDFP,TOTIME,FUNCT1
         IF (FIRST) WRITE(6,'(10X,''FUNCTION ='',F13.6//)')FUNCT1
         READ(IR)(XPARAM(I),I=1,NVAR),(GD(I),I=1,NVAR)
         READ(IR)(XLAST(I),I=1,NVAR),(GRAD(I),I=1,NVAR)
         LINEAR=(NVAR*(NVAR+1))/2
         READ(IR)(HESINV(I),I=1,LINEAR)
         LINEAR=(NORBS*(NORBS+1))/2
         READ(10)(PA(I),I=1,LINEAR)
         IF(NALPHA.NE.0)READ(10)(PB(I),I=1,LINEAR)
         IF(LATOM.NE.0) THEN
            READ(IR)((ALPARM(J,I),J=1,3),I=1,NVAR)
            READ(IR)ILOOP,X0, X1, X2
         ENDIF
         READ(IR)(ERRFN(I),I=1,NVAR)
  120    FIRST=.FALSE.
         RETURN
  130    WRITE(6,'(//10X,''NO RESTART FILE EXISTS!'')')
         CALL WRAPUP()
      ENDIF
      END

      SUBROUTINE SCALET

      IMPLICIT CHARACTER ( A-Z )

      COMMON/VELOC/VX,VY,VZ
      COMMON/TEMPER/EQTEMP
      COMMON/ENERGY/V,K,W
      COMMON/ATOMS/NATM

      INTEGER     NMAX
      PARAMETER ( NMAX = 60000 )

      REAL         VX(NMAX), VY(NMAX), VZ(NMAX)
      REAL         EQTEMP,V,K,W
      REAL         SCALEF

      INTEGER      NATM, I

      SCALEF = SQRT(EQTEMP/(2.0*K/(3.0*REAL(NATM-1))))

C**   SCALE VELOCITIES

      DO 10 I = 1,NATM
        VX(I) = VX(I)*SCALEF
        VY(I) = VY(I)*SCALEF
        VZ(I) = VZ(I)*SCALEF
 10     CONTINUE

      RETURN
      END

C     **************
      SUBROUTINE ADD(NVH,NVL,IPM,WK3,WK2,WK1)
C     **************
C
C
      DOUBLE PRECISION WK1(NVH,18),WK2(NVH,18),WK3(NVH,18)
C
C
      IF( IPM .EQ. 1 ) THEN
C
C
C         IN THIS CASE THE PRAEFACTOR IS EQUAL TO (-I)
C
C
          DO 10 J = 1,18
C
          JM = MOD(J+8,18) + 1
C
          DO 1 IVL = 1,NVL
    1     WK3(IVL,J) = WK2(IVL,J) - WK1(IVL,JM)
C
   10     CONTINUE
C
      ENDIF
C
      IF( IPM .EQ. 2 ) THEN
C
C
C         IN THIS CASE THE PRAEFACTOR IS EQUAL TO (-1)
C
C
          DO 20 J = 1,18
C
          DO 2 IVL = 1,NVL
    2     WK3(IVL,J) = WK2(IVL,J) - WK1(IVL,J)
C
   20     CONTINUE
C
      ENDIF
C
      IF( IPM .EQ. 3 ) THEN
C
C
C         IN THIS CASE THE PRAEFACTOR IS EQUAL TO (+I)
C
C
          DO 30 J = 1,18
C
          JM = MOD(J+8,18) + 1
C
          DO 3 IVL = 1,NVL
    3   WK3(IVL,J) = WK2(IVL,J) + WK1(IVL,JM)
C
   30     CONTINUE
C
      ENDIF
C
      IF( IPM .EQ. 4 ) THEN
C
C
C         IN THIS CASE THE PRAEFACTOR IS EQUAL TO (+1)
C
C
          DO 40 J = 1,18
C
          DO 4 IVL = 1,NVL
    4     WK3(IVL,J) = WK2(IVL,J) + WK1(IVL,J)
C
   40     CONTINUE
C
      ENDIF
C
C
      RETURN
      END

      SUBROUTINE PUTSCR(IUN,A,N,M,IREW)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c--      DIMENSION A(N,M),atmp(n,m)
      DIMENSION A(N,M)

c--version 3
      IF (IREW.EQ.1) REWIND IUN
      DO 100 J=1,M
         WRITE(IUN) (A(I,J),I=1,N)
 100  CONTINUE
c--      do 100 j=1,m
c--         do 110 i=1,n
c--            atmp(i,j)=a(i,j)
c-- 110     continue
c-- 100  continue
      END

      SUBROUTINE CHOLSKY (IDA, NMAT, M, N, A, NRHS, IDB, B)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   CHOLESKY DECOMPOSITION/SUBSTITUTION SUBROUTINE.
C
C   11/28/84  D H BAILEY  MODIFIED FOR NAS KERNEL TEST
C
      DIMENSION A(0:IDA, -M:0, 0:N), 
     $     B(0:NRHS, 0:IDB, 0:N), EPSS(0:256)
      DATA EPS/1E-13/
C
C  CHOLESKY DECOMPOSITION
C
      DO 1 J = 0, N
        I0 = MAX ( -M, -J )
C
C  OFF DIAGONAL ELEMENTS
C
        DO 2 I = I0, -1
          DO 3 JJ = I0 - I, -1
            DO 3 L = 0, NMAT
3             A(L,I,J) = A(L,I,J) - A(L,JJ,I+J) * A(L,I+JJ,J)
          DO 2 L = 0, NMAT
2           A(L,I,J) = A(L,I,J) * A(L,0,I+J)
C
C  STORE INVERSE OF DIAGONAL ELEMENTS
C
        DO 4 L = 0, NMAT
4         EPSS(L) = EPS * A(L,0,J)
        DO 5 JJ = I0, -1
          DO 5 L = 0, NMAT
5           A(L,0,J) = A(L,0,J) - A(L,JJ,J) ** 2
        DO 1 L = 0, NMAT
1         A(L,0,J) = 1. / SQRT ( ABS (EPSS(L) + A(L,0,J)) )
C
C  SOLUTION
C
      DO 6 I = 0, NRHS
        DO 7 K = 0, N
          DO 8 L = 0, NMAT
8           B(I,L,K) = B(I,L,K) * A(L,0,K)
          DO 7 JJ = 1, MIN (M, N-K)
            DO 7 L = 0, NMAT
7             B(I,L,K+JJ) = B(I,L,K+JJ) -  A(L,-JJ,K+JJ) * B(I,L,K)
C
        DO 6 K = N, 0, -1
          DO 9 L = 0, NMAT
9           B(I,L,K) = B(I,L,K) * A(L,0,K)
          DO 6 JJ = 1, MIN (M, K)
            DO 6 L = 0, NMAT
6             B(I,L,K-JJ) = B(I,L,K-JJ) - A(L,-JJ,K) * B(I,L,K)
C
      RETURN
      END

      SUBROUTINE INPUT(JLARGE,JKLARG)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
C
C         SET PARAMETER DEFAULTS
C
      MMAXJ = JLARGE
      MMAXK = JKLARG/JLARGE
      JMAX       = MMAXJ
      KMAX       = MMAXK  
C-old      JMAX       = 65
C-old      KMAX       = 21    
      NP         = 10000  
      NPCP       = 1
      IPRINT     = 1
      JTAIL1     = 0.20*JMAX
      JTAIL2     = 0.80*KMAX
      JACDT      = 1     
      THETAD     = 1.    
      PHIDT      = 0.
      PERIDC     = .FALSE.
      FSMACH     = 0.8
      ALPHA      = 0.    
      DIS2X      = 0.0
      DIS4X      = 0.64    
      DIS2Y      = 0.0
      DIS4Y      = 0.64    
      DYM        = 0.02
      XMIN       = 2.0
      XMAX       = 3.0
      YMAX       = 3.0
      THICK      = 0.1
      NSTEPS     = 100
      DT         = 1.0
C
      PRINT *,'             ',
     +   '       *         ******        ****     *****     *****  '
      PRINT *,'             ',
     +   '      * *        *     *      *        *     *    *    * '   
      PRINT *,'             ',
     +   '     *   *       *      *    *              *     *     *' 
      PRINT *,'             ',
     +   '    *******      ******      *             *      *     *'
      PRINT *,'             ',
     +   '   *       *     *     *      *          *        *    * '
      PRINT *,'             ',
     +   '  *         *    *      *      ****     ******    *****  '
      PRINT *, ' '
C
      PRINT *,'ARC2D : AN IMPLICIT FINITE DIFFERENCE CODE FOR AIRFOILS'
      PRINT *,'FOR FURTHER DETAILS SEE SELF DOCUMENTATION OR CONTACT '
      PRINT *,'THOMAS H. PULLIAM, MS 202A-1, NASA AMES RESEARCH CENTER'
      PRINT *,'MOFFETT FIELD, CA., 94035,   PHONE : 415 - 694 - 6417 '
C
C               READ IN THE DATA FOR THE RUN FROM STANDARD INPUT
C  *1*
         PRINT *, 'ENTER NSTEPS, DT DEFAULTS ARE ', NSTEPS,DT
         READ(5,*)  NSTEPS,DT
C  *2*
         PRINT *, 'ENTER JMAX, KMAX  DEFAULTS ARE ', JMAX, KMAX
         READ(5,*)  JMAX, KMAX
C  *3*
         PRINT *, 'ENTER FSMACH, ALPHA  DEFAULTS ARE ', FSMACH, ALPHA
         READ(5,*)  FSMACH, ALPHA
C  *4*
         PRINT *, 'ENTER DIS2X, DIS2X  DEFAULTS ARE ', DIS2X, DIS4X
         READ(5,*)  DIS2X, DIS4X
         PRINT *, 'ENTER DIS2Y, DIS4Y  DEFAULTS ARE ', DIS2Y, DIS4Y
         READ(5,*)  DIS2Y, DIS4Y
C  *5*
         PRINT *, 'ENTER PERIDC    DEFAULT IS ',  PERIDC  
         READ(5,*)  PERIDC  
             IF(.NOT.PERIDC  )THEN
                 PRINT *, 'ENTER JTAIL1, JTAIL2  DEFAULTS ARE ', 
     +                           JTAIL1, JTAIL2
                 READ(5,*)  JTAIL1, JTAIL2
             ELSE
                 JTAIL1 = 1
                 JTAIL2 = JMAX
             ENDIF
C  *6*
         PRINT *, 'ENTER GRID SPECIFICATIONS: '
         PRINT *,'ENTER XMIN, XMAX, YMAX  DEFAULTS ARE ',XMIN,XMAX,YMAX
         READ(5,*)  XMIN, XMAX, YMAX
         PRINT *,'ENTER DYM, THICK  DEFAULTS ARE ',DYM, THICK
         READ(5,*)  DYM, THICK
C  *7*
         PRINT *, 'ENTER PHIDT, THETAD   DEFAULTS ARE ', PHIDT, THETAD 
         READ(5,*)  PHIDT, THETAD 
C  *8*
         PRINT *, 'ENTER JACDT  DEFAULT  ', JACDT
         READ(5,*)  JACDT
C  *9*
         PRINT *, 'ENTER IPRINT  DEFAULT  ', IPRINT
         READ(5,*)  IPRINT
C  *10*
         PRINT *, 'ENTER NP, NPCP  DEFAULTS ARE ',NP,'  ',NPCP
         READ(5,*)  NP, NPCP
C  *11*
C
C
C  CHECK MESH SIZES
C
      IF ( JMAX .GT. JLARGE ) THEN
         WRITE(*, 36) JMAX, JLARGE
36       FORMAT( 1X, 'JMAX IS ', I5, 5X, 'ONLY DIMENSIONED FOR ', I5)
         STOP 'ERROR 1 IN IOALL'
      ENDIF
      IF ( JMAX*KMAX .GT. JKLARG ) THEN
         WRITE(*, 37) JMAX*KMAX, JKLARG
37       FORMAT( 1X,'JMAX*KMAX IS ',I5,5X,'ONLY DIMENSIONED FOR ',I5)
         STOP 'ERROR 1 IN IOALL'
      ENDIF
      IF ( JMAX .GT. 999 .OR. KMAX .GT. 999 ) THEN
         WRITE(*, 38) JMAX,KMAX
38       FORMAT( 1X, 'JMAX,KMAX ARE ', 2I5, 5X, 
     *    'BIGGER THAN 999 ', I5)
         STOP 'ERROR 1 IN IOALL'
      ENDIF
C
      PRINT *, ' '
C
      PRINT *,'    '
      PRINT *,'...............FLOW FIELD CONDITIONS...............'
      PRINT *,' FSMACH = ',FSMACH,' ALPHA = ',ALPHA
C
      PRINT *,'    '
      PRINT *,'...............GRID SPECIFICATIONS...............'
        PRINT *,' BICONVEX AIRFOIL GRID IS BEING INTERNALLY GENERATED'
        PRINT *,'...............................................'
        PRINT *,'  MINIMUM SPACING AT BODY'
        PRINT *,'                DYM = ',DYM
        PRINT *,' UPPER DIMENSION IN CHORDS (C=1) '
        PRINT *,'                 YMAX = ',YMAX
        PRINT *,' LEFT XMIN = ',XMIN,'  RIGHT  XMAX = ',XMAX
        PRINT *,' THICKNESS OF BICONVEX THICK = ',THICK
        PRINT *,'...............................................'

      IF(PERIDC  )THEN
        PRINT *,' THIS IS A PERIDC   GRID',
     +   ' JMAX = ',JMAX,' KMAX = ',KMAX
      ELSE
        PRINT *,' THIS IS A NONPERIDC   GRID',
     +   ' JMAX = ',JMAX,' KMAX = ',KMAX,
     +   ' JTAIL1 = ',JTAIL1,' JTAIL2 = ',JTAIL2
      ENDIF
C
C
      PRINT *,'    '
      PRINT *,'...............I/O SPECIFICATIONS...............'
      PRINT *,' NP = ',NP,'  IPRINT = ',IPRINT
      PRINT *,'...............ALGORITHM PARAMETERS...............'
      PRINT *,' THETAD  = ',THETAD ,' PHIDT = ',PHIDT
      PRINT *,' JACDT = ',JACDT
C
C
      IF(JACDT.EQ.0)PRINT *,
     *     ' <<<<<<<<<<<<  TIME ACCURATE  >>>>>>>>>>>>>>>>>>'
      IF(JACDT.EQ.1)PRINT *,
     *     ' <<<<  VARIABLE DT = 1./(1+SQRT(J)) >>>>>>>>>>>>>'
      IF(JACDT.EQ.2)PRINT *,
     *       ' <<<<  VARIABLE DT : MIN. EIGEN. >>>>>>>>>>>>>>>'
      IF(JACDT.EQ.3)PRINT *,
     *      ' <<<<  VARIABLE DT : CONST. CFL  >>>>>>>>>>>>>>>'
      PRINT *,'   ********  NUMBER OF TIME STEPS == ',NSTEPS
      PRINT *,'   ********  TIME STEP            == ',DT
C
      PRINT *,'****************************************************'
      PRINT *,'......   PENTADIAGONAL ALGORITHM         ...........'
      PRINT *,'****************************************************'
      PRINT *,' DIS2X = ',DIS2X,' DIS4X = ',DIS4X
      PRINT *,' DIS2Y = ',DIS2Y,' DIS4Y = ',DIS4Y

C
C
      RETURN
      END

      SUBROUTINE FLOPS(IO,NC,TSTEPS,RCUT,TIME)

      INTEGER     IO, NC, NTOT, TSTEPS
      REAL        RCUT
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ
      DOUBLE PRECISION TIME
      INTEGER     MX, MY, MZ

      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ

      PARAMETER(PIRED = 88/21)

      NTOT = 4*NC*NC*NC

      MULT = (MX-2)*(MY-2)*(MZ-2)
      MXRED = MX-4
      MYRED = MY-4
      MZRED = MZ-4

      NCMARK = NTOT/MULT
      FORCE1 = (PIRED*MULT*RCUT**3)/27
      FORCE2 = (8+4*(MXRED+MYRED+MZRED)+
     1        2*(MXRED*MYRED+MXRED*MZRED+MYRED*MZRED))/MULT
      FORCE3 = (FORCE1*5*13*NCMARK*MXRED*MYRED*MZRED)/MULT
     
      FCOUNT = 30*NTOT+13.5*NTOT*NCMARK*((9+35*FORCE1)*
     1         (FORCE2+1)+5*FORCE1*FORCE3)

      BENCH=TSTEPS*FCOUNT/TIME/1E6
      SIMBEN=0.03*TSTEPS/TIME

      WRITE(IO,*)
      WRITE(IO,*)'CALCULATION FINISHED.'
      WRITE(IO,*)
      WRITE(IO,*)'Data type - REAL*4'
      WRITE(IO,*)'TOTAL NUMBER OF NOMINAL FLOPS  = ',INT(FCOUNT),' flop'
      WRITE(IO,*)'NUMBER OF TIME-STEPS           = ',TSTEPS,' tstep'
      WRITE(IO,*)
      WRITE(IO,*)'********************************************'
      WRITE(IO,*)
      WRITE(IO,'( 4(A, F7.3, A/))')
     *     'ELAPSED TIME            =',TIME,' s' ,
     *     'TEMPORAL PERFORMANCE    =',TSTEPS/TIME,' tstep/s',
     *     'SIMULATION PERFORMANCE  =',SIMBEN,' sim-ps/s',
     *     'BENCHMARK PERFORMANCE   =',BENCH,' Mflop/s'
      WRITE(IO,*)
      WRITE(IO,*)'********************************************'

      END

      SUBROUTINE MAPS

      IMPLICIT CHARACTER ( A-Z )

      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ

C    *******************************************************************
C    ** ROUTINE TO SET UP A LIST OF NEIGHBOURING CELLS                **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ
      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL )

      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      INTEGER     LIST(NMAX), HEAD(NCELL), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     IX, IY, IZ, IMAP, ICELL

C    ** STATEMENT FUNCTION TO GIVE CELL INDEX **
      ICELL(IX,IY,IZ) = 1+MOD(IX-1+MX,MX)+MOD(IY-1+MY,MY)*MX
     &                   +MOD(IZ-1+MZ,MZ)*MX*MY

C    ** FIND HALF THE NEAREST NEIGHBOURS OF EACH CELL **
      DO 40 IX = 1, MX
        DO 40 IY = 1, MY
          DO 40 IZ = 1, MZ
            IMAP = (ICELL(IX,IY,IZ)-1)*13
            MAP(IMAP+1 ) = ICELL(IX+1,IY  ,IZ)
            MAP(IMAP+2 ) = ICELL(IX+1,IY+1,IZ)
            MAP(IMAP+3 ) = ICELL(IX  ,IY+1,IZ)
            MAP(IMAP+4 ) = ICELL(IX-1,IY+1,IZ)
            MAP(IMAP+5 ) = ICELL(IX+1,IY  ,IZ-1)
            MAP(IMAP+6 ) = ICELL(IX+1,IY+1,IZ-1)
            MAP(IMAP+7 ) = ICELL(IX  ,IY+1,IZ-1)
            MAP(IMAP+8 ) = ICELL(IX-1,IY+1,IZ-1)
            MAP(IMAP+9 ) = ICELL(IX+1,IY  ,IZ+1)
            MAP(IMAP+10) = ICELL(IX+1,IY+1,IZ+1)
            MAP(IMAP+11) = ICELL(IX  ,IY+1,IZ+1)
            MAP(IMAP+12) = ICELL(IX-1,IY+1,IZ+1)
            MAP(IMAP+13) = ICELL(IX  ,IY  ,IZ+1)
40          CONTINUE

      RETURN
      END

      SUBROUTINE BCONDT(A,F,MXNOD,NNODX,NNODXC,NNODES,NNODM,
     +     TGAMIN,TGAMOU,IDIAG)

      INTEGER MXNOD,NNODX,NNODXC,NNODES,NNODM,IDIAG
      DOUBLE PRECISION A(MXNOD,*),F(*)
      DOUBLE PRECISION TGAMIN,TGAMOU

      INTEGER NX
      DOUBLE PRECISION BIG
      PARAMETER(BIG=1.0D12)


      DO 10 I=1,NNODX
         A(I,IDIAG)=BIG
         F(I)=BIG*TGAMIN
 10   CONTINUE


      NX=(NNODX-1)/2+1

      DO 20 I=NNODX,NNODM,3*NX-1
         A(I,IDIAG)=BIG
         F(I)=BIG*TGAMIN
 20   CONTINUE

      DO 25 I=NNODX+NX,NNODM-NNODX,3*NX-1
         A(I,IDIAG)=BIG
         F(I)=BIG*TGAMIN
 25   CONTINUE


      DO 30 I=NNODES,(NNODES-NNODXC+1),-1
         A(I,IDIAG)=BIG
         F(I)=BIG*TGAMOU
 30   CONTINUE

      RETURN
      END

      SUBROUTINE MATOUT (A,B,NC,NR,NDIM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION A(NDIM,NDIM), B(NDIM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /ELEMTS/ ELEMNT(107)
C**********************************************************************
C
C      MATOUT PRINTS A SQUARE MATRIX OF EIGENVECTORS AND EIGENVALUES
C
C    ON INPUT A CONTAINS THE MATRIX TO BE PRINTED.
C             B CONTAINS THE EIGENVALUES.
C             NC NUMBER OF MOLECULAR ORBITALS TO BE PRINTED.
C             NR IS THE SIZE OF THE SQUARE ARRAY TO BE PRINTED.
C             NDIM IS THE ACTUAL SIZE OF THE SQUARE ARRAY "A".
C             NFIRST AND NLAST CONTAIN ATOM ORBITAL COUNTERS.
C             NAT = ARRAY OF ATOMIC NUMBERS OF ATOMS.
C
C
C***********************************************************************
      CHARACTER*2 ELEMNT, ATORBS(9), ITEXT(MAXORB), JTEXT(MAXORB)
      DIMENSION NATOM(MAXORB)
      DATA ATORBS/' S','PX','PY','PZ','X2','XZ','Z2','YZ','XY'/
      IF(NUMAT.EQ.0)GOTO 30
      IF(NLAST(NUMAT).NE.NR) GOTO 30
      DO 20 I=1,NUMAT
         JLO=NFIRST(I)
         JHI=NLAST(I)
         L=NAT(I)
         K=0
         DO 10 J=JLO,JHI
            K=K+1
            ITEXT(J)=ATORBS(K)
            JTEXT(J)=ELEMNT(L)
            NATOM(J)=I
   10    CONTINUE
   20 CONTINUE
      GOTO 50
   30 CONTINUE
      NR=ABS(NR)
      DO 40 I=1,NR
         ITEXT(I)='  '
         JTEXT(I)='  '
   40 NATOM(I)=I
   50 CONTINUE
      KA=1
      KC=6
   60 KB=MIN0(KC,NC)
      WRITE (6,100) (I,I=KA,KB)
      IF(B(1).NE.0.D0)WRITE (6,110) (B(I),I=KA,KB)
      WRITE (6,120)
      LA=1
      LC=40
   70 LB=MIN0(LC,NR)
      DO 80 I=LA,LB
         IF(ITEXT(I).EQ.' S')WRITE(6,120)
         WRITE (6,130) ITEXT(I),JTEXT(I),NATOM(I),(A(I,J),J=KA,KB)
   80 CONTINUE
      IF (LB.EQ.NR) GO TO 90
      LA=LC+1
      LC=LC+40
      WRITE (6,140)
      GO TO 70
   90 IF (KB.EQ.NC) RETURN
      KA=KC+1
      KC=KC+6
      IF (NR.GT.25) WRITE (6,140)
      GO TO 60
C
  100 FORMAT (////,3X,9H ROOT NO.,I5,9I12)
  110 FORMAT (/8X,10F12.5)
  120 FORMAT (2H  )
  130 FORMAT (2(1X,A2),I4,F10.5,10F12.5)
  140 FORMAT (1H1)
C
      END

      SUBROUTINE FFHPOL (HEAT0,ATPOL,DIPVEC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*1 AXIS(3)
      CHARACTER*80 KEYWRD
      LOGICAL LARGE,POLDIP,DEBUG
      INCLUDE 'mopac.inc'
C***********************************************************************
C  SUBROUTINE FOR THE FINITE FIELD CALCULATION OF ELECTRIC RESPONSE
C  PROPERTIES (DIPOLE MOMENT, POLARIZABILITY, AND 1ST AND 2ND
C  HYPERPOLARIZABILITY.
C
C  HENRY A. KURTZ, DEPARTMENT OF CHEMISTRY
C                  MEMPHIS STATE UNIVERSITY
C                  MEMPHIS, TN   38152
C
C***********************************************************************
      COMMON /CORE  / CORE(107)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM),NORS,NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /COORD / COORD(3,NUMATM)
      COMMON /KEYWRD/ KEYWRD
      COMMON /FIELD / EFIELD(3)
      COMMON /EULER / TVEC(3,3),IDTVEC
C
C
C     DIPE4 AND DIPDP HOLD THE CALCULATED DIPOLE MOMENTS
C
C     APOLE4 AND APOLDP HOLD THE POLARIZABILITY TENSOR AS
C                                A PACKED ARRAY XX,XY,YY,XZ,YZ,ZZ
C
C     BETAE4 AND BETAEP HOLD THE FIRST HYPERPOLARIZABILITY
C                                1. XXX
C                                2. YYY     6. YXX
C                                3. ZZZ     7. YZZ
C                                4. XYY     8. ZXX
C                                5. XZZ     9. ZYY
C
      DIMENSION HEATE(3,2),DIPVEC(3),EIGS(3),VECTRS(9),
     1          DIPE4(3),APOLE4(6),BETAE4(9),GAMME4(6),
     2          DIPDP(3),APOLDP(6),BETADP(9),GAMMDP(6),
     3          DIP1P(3),DIP1M(3),DIP2P(3),DIP2M(3)
      DIMENSION IPTBD(6)
      DATA HEAT3M/0.0D0/,HEAT3P/0.D0/
      DATA IPTBD /5,7,4,9,6,8/
C Energy: a.u. to kcal/mole
      AUTOKC = 23.061D+00*27.2107D+00
C Length: a.u. to Angstrom
      AUTOA  = 0.529177D+00
C Dipole: a.u. to debye
      AUTODB = 2.541563D+00
C Electric Field: a.u. to volt/meter
      AUTOVM = 51.4257D+00
      NBDIP = 1
      NGDIP = 4
      NBCNT = 4
      NGCNT = 4
C
      DATA AXIS/'X','Y','Z'/
      LARGE = (INDEX(KEYWRD,'LARGE').NE.0)
      DEBUG = (INDEX(KEYWRD,'DEBUG').NE.0)
C
C  FIELD STRENGTH IN A.U.
C
      EFVAL=0.001D0
      IDIP=1
C#      READ (7,10) EFVAL,IDIP
   10 FORMAT (F10.5,I5)
      WRITE (6,20) EFVAL
   20 FORMAT (//' APPLIED ELECTRIC FIELD MAGNITUDE: ',F15.5)
      POLDIP = .FALSE.
      IF (IDIP.NE.0) POLDIP = .TRUE.
      SFE = 1.D00/EFVAL
      WRITE (6,30) 6.74834*ATPOL
   30 FORMAT (//' ATOMIC CONTRIBUTION TO THE POLARIZABILITY: ',F15.6)
C.......................................................................
C  CALCULATE THE POLARIZABILITY AND HYPERPOLARIZABILITIES ALONG
C  THE THREE PRINCIPLE AXES.  (THESE AXES DEPEND ON YOUR ARBITRARY
C  ORIENTATION AND MAY NOT BE THE TRUE PRINCIPLE AXES.)
C.......................................................................
      DO 160 ID = 1,3
         IF (DEBUG) THEN
            WRITE (6,40) AXIS(ID)
   40       FORMAT (//,' ****** ',A1,' DIRECTION *****',/)
         ENDIF
C
C ZERO THE FIELD
C
         DO 50 I = 1,3
            EFIELD(I) = 0.0D00
   50    CONTINUE
         HNUC = 0.0D00
         DO 60 I = 1,NUMAT
            HNUC = HNUC + EFVAL*GEO(ID,I)*CORE(NAT(I))*AUTOVM
   60    CONTINUE
         HNUC = HNUC*23.061D00
C +E(ID)
         EFIELD(ID) = EFVAL
         CALL COMPFG(GEO,.TRUE.,HEAT1P,.TRUE.,GRAD,.FALSE.)
         CALL DIPIND (DIP1P)
         DIIP = DIP1P(ID)
C -E(ID)
         EFIELD(ID) = -EFVAL
         CALL COMPFG(GEO,.TRUE.,HEAT1M,.TRUE.,GRAD,.FALSE.)
         CALL DIPIND (DIP1M)
         DIIM = DIP1M(ID)
C +2E(ID)
         EFIELD(ID) = 2.0D00*EFVAL
         CALL COMPFG(GEO,.TRUE.,HEAT2P,.TRUE.,GRAD,.FALSE.)
         CALL DIPIND (DIP2P)
C -2E(ID)
         EFIELD(ID) = -2.0D00*EFVAL
         CALL COMPFG(GEO,.TRUE.,HEAT2M,.TRUE.,GRAD,.FALSE.)
         CALL DIPIND (DIP2M)
C
C  CORRECT FOR ELECTRIC FIELD - NUCLEAR INTERACTIONS
C
         HEAT1P = HEAT1P + HNUC
         HEATE(ID,1) = HEAT1P
         HEAT1M = HEAT1M - HNUC
         HEATE(ID,2) = HEAT1M
         HEAT2P = HEAT2P + HNUC*2.D00
         HEAT2M = HEAT2M - HNUC*2.D00
C
         IF (DEBUG) THEN
            WRITE (6,70)
   70       FORMAT (' ENERGIES AT: ',5X,'F',21X,'2F',21X,'3F',/)
            WRITE (6,80) HEAT1P,HEAT2P,HEAT3P,HEAT1M,HEAT2M,HEAT3M
   80       FORMAT ('   + ',3(F20.10,3X),/,'   - ',3(F20.10,3X))
         ENDIF
C
C DIPOLE
C
         ETERM = (1.0D00/12.D00)*(HEAT2P - HEAT2M)
     1        - (2.0D00/3.0D00)*(HEAT1P - HEAT1M)
         DIPE4(ID) = ETERM*SFE/AUTOKC
C
C ALPHA
C
         IVL = (ID*(ID+1))/2
         ETERM = 2.5D00*HEAT0 - (4.D00/3.D00)*(HEAT1P + HEAT1M)
     1        + (1.D00/12.0D00)*(HEAT2P + HEAT2M)
         APOLE4(IVL) = ETERM*SFE*SFE/AUTOKC + ATPOL*6.74834
C
C BETA
C
         ETERM = (HEAT1P - HEAT1M) - 0.5D00*(HEAT2P - HEAT2M)
         BETAE4(ID) = ETERM*SFE*SFE*SFE/AUTOKC
C
C GAMMA
C
         ETERM = 4.0D00*(HEAT1P + HEAT1M) - (HEAT2P + HEAT2M)
     1        - 6.0D00*HEAT0
         GAMME4(ID) = ETERM*SFE*SFE*SFE*SFE/AUTOKC
C
C DIPOLE CALCULATIONS
C
         DMU = (2.0D00/3.0D00)*(DIP1P(ID) + DIP1M(ID))
     1      - (1.D00/6.0D00)*(DIP2P(ID) + DIP2M(ID))
         DIPDP(ID) = DMU/AUTODB
         AE = (2.0D00/3.0D00)*(DIP1P(ID) - DIP1M(ID))
     1     - (1.0D00/12.D00)*(DIP2P(ID) - DIP2M(ID))
         APOLDP(IVL) = AE*SFE/AUTODB
         BE = (1.D00/3.0D00)*(DIP2P(ID) + DIP2M(ID)
     1                     - DIP1P(ID) - DIP1M(ID))
         BETADP(ID) = BE*SFE*SFE/AUTODB
         GE = 0.5D00*(DIP2P(ID) - DIP2M(ID))
     1     - (DIP1P(ID) - DIP1M(ID))
         GAMMDP(ID) = GE*SFE*SFE*SFE/AUTODB
         DO 90 KD = 1,3
            IF (KD.LT.ID) THEN
               KVL = (ID*(ID-1))/2 + KD
               AKI = (2.0D00/3.0D00)*(DIP1P(KD) - DIP1M(KD))
     1         - (1.0D00/12.0D00)*(DIP2P(KD) - DIP2M(KD))
               APOLDP(KVL) = AKI*SFE/AUTODB
            ENDIF
            IF (KD.NE.ID) THEN
               BKII = (1.0D00/3.0D00)*(DIP2P(KD) + DIP2M(KD)
     1                           - DIP1P(KD) - DIP1M(KD))
               NBD = IPTBD(NBDIP)
               BETADP(NBD) = BKII*SFE*SFE/AUTODB
               NBDIP = NBDIP + 1
            ENDIF
   90    CONTINUE
C.......................................................................
C
C  NOW CALCULATE THE OFF AXIS RESULTS.
C
C.......................................................................
         IDM1 = ID - 1
         DO 150 JD = 1,IDM1
            HNUCJ = 0.0D00
            DO 100 I = 1,NUMAT
               HNUCJ = HNUCJ + EFVAL*GEO(JD,I)*CORE(NAT(I))*51.4257
  100       CONTINUE
            HNUCJ = HNUCJ*23.061
            DO 110 I = 1,3
               EFIELD(I) = 0.0D00
  110       CONTINUE
C
C DIAGONAL FIELDS WITH COMPONENTS EQUAL TO EFVAL
C
            EFIELD(ID) = EFVAL
            EFIELD(JD) = EFVAL
            CALL COMPFG(GEO,.TRUE.,HPP,.TRUE.,GRAD,.FALSE.)
            CALL DIPIND (DIP1P)
            DPP = DIP1P(ID)
            EFIELD(JD) = -EFVAL
            CALL COMPFG(GEO,.TRUE.,HPM,.TRUE.,GRAD,.FALSE.)
            CALL DIPIND (DIP1P)
            DPM = DIP1P(ID)
            EFIELD(ID) = -EFVAL
            CALL COMPFG(GEO,.TRUE.,HMM,.TRUE.,GRAD,.FALSE.)
            CALL DIPIND (DIP1P)
            DMM = DIP1P(ID)
            EFIELD(JD) = EFVAL
            CALL COMPFG(GEO,.TRUE.,HMP,.TRUE.,GRAD,.FALSE.)
            CALL DIPIND (DIP1P)
            DMP = DIP1P(ID)
            HPP = HPP + HNUC + HNUCJ
            HPM = HPM + HNUC - HNUCJ
            HMM = HMM - HNUC - HNUCJ
            HMP = HMP - HNUC + HNUCJ
            IF (DEBUG) THEN
               WRITE (6,120)
  120          FORMAT (/,' ',12X,'+,+',15X,'+,-',15X,'-,+',15X,'-,-')
               WRITE (6,130) HPP,HPM,HMP,HMM
  130          FORMAT ('  E ',4F15.6)
            ENDIF
C
C  DIAGONAL FIELDS WITH COMPONENTS EQUAL TO 2*EFVAL
C
            EFIELD(ID) = EFVAL*2.D00
            EFIELD(JD) = EFVAL*2.D00
            CALL COMPFG(GEO,.TRUE.,H2PP,.TRUE.,GRAD,.FALSE.)
            EFIELD(JD) = -EFVAL*2.D00
            CALL COMPFG(GEO,.TRUE.,H2PM,.TRUE.,GRAD,.FALSE.)
            EFIELD(ID) = -EFVAL*2.D00
            CALL COMPFG(GEO,.TRUE.,H2MM,.TRUE.,GRAD,.FALSE.)
            EFIELD(JD) = EFVAL*2.D00
            CALL COMPFG(GEO,.TRUE.,H2MP,.TRUE.,GRAD,.FALSE.)
            H2PP = H2PP + 2.0D00*(HNUC + HNUCJ)
            H2PM = H2PM + 2.0D00*(HNUC - HNUCJ)
            H2MM = H2MM - 2.0D00*(HNUC + HNUCJ)
            H2MP = H2MP - 2.0D00*(HNUC - HNUCJ)
            IF (DEBUG) THEN
               WRITE (6,140) H2PP,H2PM,H2MP,H2MM
  140          FORMAT (' 2E ',4F15.6)
            ENDIF
C
            ATERM = (1.0D00/48.0D00)*(H2PP - H2PM - H2MP + H2MM)
     1          - (1.0D00/3.0D00)*(HPP - HPM - HMP + HMM)
            AIJ = ATERM*SFE*SFE/AUTOKC
            IVL = (ID*(ID-1))/2 + JD
            APOLE4(IVL) = AIJ
            BTERM = 0.5D00*(HMM - HPP + HPM - HMP)
     1          + HEATE(JD,1) - HEATE(JD,2)
            BJII = BTERM*SFE*SFE*SFE/AUTOKC
            BETAE4(NBCNT) = BJII
            NBCNT = NBCNT + 1
            BTERM = 0.5D00*(HMM - HPP + HMP - HPM)
     1          + HEATE(ID,1) - HEATE(ID,2)
            BIJJ = BTERM*SFE*SFE*SFE/AUTOKC
            BETAE4(NBCNT) = BIJJ
            NBCNT = NBCNT + 1
C
            GTERM = -(HPP + HMM + HPM + HMP) - 4.0D00*HEAT0
     1           + 2.0D00*(HEATE(ID,1) + HEATE(ID,2))
     2           + 2.0D00*(HEATE(JD,1) + HEATE(JD,2))
            GIIJJ = GTERM*SFE*SFE*SFE*SFE/AUTOKC
            GAMME4(NGCNT) = GIIJJ
            GDIP = 0.5D00*(DPP - DMP + DPM - DMM) - (DIIP - DIIM)
            GAMMDP(NGCNT) = GDIP*SFE*SFE*SFE/AUTODB
            NGCNT = NGCNT + 1
  150    CONTINUE
C
  160 CONTINUE
C-----------------------------------------------------------------------
C  SUMMARIZE THE RESULTS
C-----------------------------------------------------------------------
      WRITE (6,170)
  170 FORMAT (//,' ',30('*'),' DIPOLE ',30('*'),//)
      DIPE4T = SQRT(DIPE4(1)*DIPE4(1) + DIPE4(2)*DIPE4(2)
     1              + DIPE4(3)*DIPE4(3))
      DIPE4D = DIPE4T*AUTODB
      DIPDPT = SQRT(DIPDP(1)*DIPDP(1) + DIPDP(2)*DIPDP(2)
     1              + DIPDP(3)*DIPDP(3))
      DIPDPD = DIPDPT*AUTODB
      WRITE (6,180)
  180 FORMAT (21X,'E4',13X,'DIP',/)
      WRITE (6,190) 'X',DIPE4(1),DIPDP(1)
      WRITE (6,190) 'Y',DIPE4(2),DIPDP(2)
      WRITE (6,190) 'X',DIPE4(3),DIPDP(3)
  190 FORMAT (5X,A1,7X,2F15.6)
      WRITE (6,200) DIPE4T,DIPDPT,
     1               DIPE4D,DIPDPD
  200 FORMAT (//' MAGNITUDE:  ',2F15.6,'  (A.U.)',/,
     1          ' ',12X,2F15.6,'  (DEBYE)')
C
C FIND EIGENVALUES AND EIGENVECTORS OF POLARIZATION MATRIX.
C
      WRITE (6,210)
  210 FORMAT (//,' ',30('*'),' POLARIZABILITY ',20('*'),//)
      WRITE (6,220)
  220 FORMAT (/' E4 POLARIZABILITY TENSOR:')
      I3 = 3
      CALL VECPRT (APOLE4,-I3)
      CALL RSP (APOLE4,I3,I3,EIGS,VECTRS)
      CALL MATOUT (VECTRS,EIGS,I3,I3,I3)
      AVGPE4 = (EIGS(1)+EIGS(2)+EIGS(3))/3.D0
      AVGA3 = AVGPE4*0.14818D00
      AVGESU = AVGPE4*0.296352D-24
      WRITE (6,230)
  230 FORMAT (/' DIP POLARIZABILITY TENSOR:')
      CALL VECPRT (APOLDP,-I3)
      CALL RSP (APOLDP,I3,I3,EIGS,VECTRS)
      CALL MATOUT (VECTRS,EIGS,I3,I3,I3)
      AVGPDP = (EIGS(1)+EIGS(2)+EIGS(3))/3.D0
      AVGA3D = AVGPDP*0.14818D00
      AVGESD = AVGPDP*0.296352D-24
      WRITE (6,240) AVGPE4,AVGPDP,AVGA3,AVGA3D,AVGESU,AVGESD
  240 FORMAT (//,' AVERAGE POLARIZABILITY:',8X,'E4',13X,'DIP',/,
     1           ' ',24X,2F15.6,'  A.U.',/,
     2           ' ',24X,2F15.6,'  ANG.**3',/,
     3           ' ',24X,2(1PD15.6),'  ESU')
C
C  CALCULATE "EXPERIMENTAL" HYPERPOLARIZABILITIES
C
C   8.65710D-33 is a.u. to e.s.u. conversion
      WRITE (6,250)
  250 FORMAT (//,' ',30('*'),' SECOND-ORDER ',25('*'),//)
      BX4 = 0.6D00*(BETAE4(1) + BETAE4(4) + BETAE4(6))
      BY4 = 0.6D00*(BETAE4(2) + BETAE4(5) + BETAE4(8))
      BZ4 = 0.6D00*(BETAE4(3) + BETAE4(7) + BETAE4(9))
      B4MU = (BX4*DIPE4(1) + BY4*DIPE4(2) + BZ4*DIPE4(3))/DIPE4T
      B4ESU = B4MU*8.65710D-03
      BXD = 0.6D00*(BETADP(1) + BETADP(4) + BETADP(6))
      BYD = 0.6D00*(BETADP(2) + BETADP(5) + BETADP(8))
      BZD = 0.6D00*(BETADP(3) + BETADP(7) + BETADP(9))
      BDMU = (BXD*DIPDP(1) + BYD*DIPDP(2) + BZD*DIPDP(3))/DIPDPT
      BDESU = BDMU*8.65710D-03
C
      WRITE (6,260)
  260 FORMAT ('  COMPONENT',12X,'E4',13X,'DIP',/)
      WRITE (6,270) 'XXX',BETAE4(1),BETADP(1)
      WRITE (6,270) 'XYY',BETAE4(4),BETADP(4)
      WRITE (6,270) 'XZZ',BETAE4(6),BETADP(6)
      WRITE (6,270) 'YYY',BETAE4(2),BETADP(2)
      WRITE (6,270) 'YXX',BETAE4(5),BETADP(5)
      WRITE (6,270) 'YZZ',BETAE4(8),BETADP(8)
      WRITE (6,270) 'ZZZ',BETAE4(3),BETADP(3)
      WRITE (6,270) 'ZXX',BETAE4(7),BETADP(7)
      WRITE (6,270) 'ZYY',BETAE4(9),BETADP(9)
  270 FORMAT (' ',5X,A4,5X,2F15.6)
      WRITE (6,280)
  280 FORMAT (/)
      WRITE (6,290) 'BX',BX4,BXD
      WRITE (6,290) 'BY',BY4,BYD
      WRITE (6,290) 'BZ',BZ4,BZD
  290 FORMAT (' ',6X,A2,6X,2F15.6)
      WRITE (6,280)
      WRITE (6,300) B4MU,BDMU,B4ESU,BDESU
  300 FORMAT (' ',4X,'B(AU)',5X,2F15.6,/,
     1        ' ',4X,'B(ESU)',4X,2F15.6,3X,'(X10-30)')
C
      WRITE (6,310)
  310 FORMAT (//' ',30('*'),' THIRD-ORDER ',25('*'),//)
      GAMVAL = (GAMME4(1) + GAMME4(2) + GAMME4(3))
      GAMVAL = GAMVAL + 2.0D00*(GAMME4(4) + GAMME4(5) + GAMME4(6))
      GAMVAL = GAMVAL/5.0D00
C  5.05116D-40 is the a.u. to e.s.u. conversion
      GAMESU = GAMVAL*5.05116D-04
      GAMDIP = (GAMMDP(1) + GAMMDP(2) + GAMMDP(3))
      GAMDIP = GAMDIP + 2.0D00*(GAMMDP(4) + GAMMDP(5) + GAMMDP(6))
      GAMDIP = GAMDIP/5.0D00
      GAMDES = GAMDIP*5.05116D-04
      WRITE (6,320)
  320 FORMAT (' ',17X,'E4',13X,'DIP',/)
      WRITE (6,330) 'XXXX',GAMME4(1),GAMMDP(1)
      WRITE (6,330) 'YYYY',GAMME4(2),GAMMDP(2)
      WRITE (6,330) 'ZZZZ',GAMME4(3),GAMMDP(3)
      WRITE (6,330) 'XXYY',GAMME4(4),GAMMDP(4)
      WRITE (6,330) 'XXZZ',GAMME4(5),GAMMDP(5)
      WRITE (6,330) 'YYZZ',GAMME4(6),GAMMDP(6)
  330 FORMAT (5X,A4,2F15.6)
      WRITE (6,340) GAMVAL,GAMDIP,GAMESU,GAMDES
  340 FORMAT (//' GAMMA = ',1PD15.6,1PD15.6,'  A.U.'/,
     1       ' ',8X,1PD15.6,1PD15.6,'  ESU (X10-36)')
C
      RETURN
      END

C----------------------------------------------------------------------
C
C  E Q C
C
C  COORDINATES IN THE ARRAY PLANET ARE CONVERTED INTO EQUATORIAL
C  COORDINATES AND STORED INTO OUTBUF
C
C----------------------------------------------------------------------
      SUBROUTINE EQC(T)
      REAL T
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)
C
C  
C
      REAL
     .    PLANET(3,MAXOBJ),      
     .    OLDPL(2,MAXOBJ)    
      INTEGER
     .    TODAY
      REAL
     .    OUTBUF(MAXDAY,3,MAXOBJ)      
C
      COMMON /OUT/ OUTBUF, PLANET, OLDPL, TODAY
C
C  LOCAL VARIABLES 
C 
      INTEGER
     .    I             
      REAL
     .    RA,DEC,DIST,  
     .    X0,Y0,Z0,DA
C
      X0=PLANET(1,2)
      Y0=PLANET(2,2)
      Z0=PLANET(3,2)

      CALL ANTIB(X0, Y0, Z0, T)

      DO 10 I=1,MAXOBJ
         IF (I. NE. 2) THEN
            CALL RADEC (
     .              PLANET(1,I), PLANET(2,I), PLANET(3,I),
     .              X0, Y0, Z0,
     .              OLDPL(1,I), OLDPL(2,I),
     .              1.0E+0, I, T,
     .              RA, DEC, DIST)
            IF (RA .LT. 0.0)  RA=RA+24
            OLDPL(1,I)=RA
            OLDPL(2,I)=DEC
            OUTBUF(TODAY,1,I) =RA
            OUTBUF(TODAY,2,I) =DEC
            OUTBUF(TODAY,3,I) =DIST
         ENDIF
 10   CONTINUE
C
C
      TODAY  = TODAY+1
      RETURN
      END

      SUBROUTINE TRBAK3(NM,N,NV,A,M,Z,EPS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION A(NV), Z(NM,M)
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TRBAK3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS SUBROUTINE FORMS THE EIGENVECTORS OF A REAL SYMMETRIC
C     MATRIX BY BACK TRANSFORMING THOSE OF THE CORRESPONDING
C     SYMMETRIC TRIDIAGONAL MATRIX DETERMINED BY  TRED3.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL TRANSFORMATIONS
C          USED IN THE REDUCTION BY  TRED3  IN ITS FIRST
C          N*(N+1)/2 POSITIONS,
C
C        M IS THE NUMBER OF EIGENVECTORS TO BE BACK TRANSFORMED,
C
C        Z CONTAINS THE EIGENVECTORS TO BE BACK TRANSFORMED
C          IN ITS FIRST M COLUMNS.
C
C     ON OUTPUT-
C
C        Z CONTAINS THE TRANSFORMED EIGENVECTORS
C          IN ITS FIRST M COLUMNS.
C
C     NOTE THAT TRBAK3 PRESERVES VECTOR EUCLIDEAN NORMS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      IF (M .EQ. 0) GO TO 50
      IF (N .EQ. 1) GO TO 50
C
      DO 40   I = 2, N
         L = I - 1
         IZ = (I * L) / 2
         IK = IZ + I
         H = A(IK)
         IF (H.EQ.0.0D0)  GO TO 40
C
         DO 30   J = 1, M
            S=0.0D0
            IK = IZ
C
            DO 10   K = 1, L
               IK = IK + 1
               S = S + A(IK) * Z(K,J)
   10       CONTINUE
C     ********** DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW **********
            S = (S / H) / H
            IK = IZ
C
            DO 20   K = 1, L
               IK = IK + 1
               Z(K,J) = Z(K,J) - S * A(IK)
   20       CONTINUE
C
   30    CONTINUE
C
   40 CONTINUE
C
   50 RETURN
C     ********** LAST CARD OF TRBAK3 **********
      END

C=======================================================================
C     THIS PROGRAM RE-ASSIGN THE WAVE FUNCTION COMPONENTS FOR THE CASE
C     OF RE-STARTING WITH A DIFFERENT GRID OR CUTOFF.
C=======================================================================
      SUBROUTINE REASSN(NKPTS,VKPT,
     &              NRPLWV,  NGX,     NGY,     NGZ,    ENMAX,
     &              NRPLWO,  NGXO,    NGYO,    NGZO,   ENMAXO,
     &              LPCTX,   LPCTY,   LPCTZ,   RECC,   RECO,
     &              IASSGN,  CWORK,   CPTWFP,  NBANDS, IPRINT)
      IMPLICIT COMPLEX (C)
      DIMENSION VKPT(3,*)
      DIMENSION RECC(3,*),RECO(3,*)
      DIMENSION LPCTX(*),LPCTY(*),LPCTZ(*)
      DIMENSION IASSGN(*),CWORK(*)
      DIMENSION CPTWFP(NRPLWV,NBANDS)
C=======================================================================
C                       THE DATA STATEMENTS
C TPI = (NOT SURPRISINGLY) 2*PI
C HSQDTM = (PLANCK'S CONSTANT/(2*PI))**2/(2*ELECTRON MASS)
C=======================================================================
      DATA TPI,HSQDTM /6.283185307,3.810033/
      DO 2000 N=1,NKPTS
C=======================================================================
C FIRST, WE FIND FOR EVERY G-POINTS IN TNE NEW GRID, ITS CORRESPONDING 
C POINT AT THE OLD GRID
C=======================================================================
        NBOX=0
        NBOXO=0
        DO 2010 NZ=1,NGZ
          GZX =RECC(3,1)*(LPCTZ(NZ)+VKPT(3,N))
          GZY =RECC(3,2)*(LPCTZ(NZ)+VKPT(3,N))
          GZZ =RECC(3,3)*(LPCTZ(NZ)+VKPT(3,N))
          GZXO=RECO(3,1)*(LPCTZ(NZ)+VKPT(3,N))
          GZYO=RECO(3,2)*(LPCTZ(NZ)+VKPT(3,N))
          GZZO=RECO(3,3)*(LPCTZ(NZ)+VKPT(3,N))
          DO 2011 NY=1,NGY
            GYX =RECC(2,1)*(LPCTY(NY)+VKPT(2,N))
            GYY =RECC(2,2)*(LPCTY(NY)+VKPT(2,N))
            GYZ =RECC(2,3)*(LPCTY(NY)+VKPT(2,N))
            GYXO=RECO(2,1)*(LPCTY(NY)+VKPT(2,N))
            GYYO=RECO(2,2)*(LPCTY(NY)+VKPT(2,N))
            GYZO=RECO(2,3)*(LPCTY(NY)+VKPT(2,N))
            DO 2012 NX=1,NGX
              GXX =RECC(1,1)*(LPCTX(NX)+VKPT(1,N))
              GXY =RECC(1,2)*(LPCTX(NX)+VKPT(1,N))
              GXZ =RECC(1,3)*(LPCTX(NX)+VKPT(1,N))
              GXXO=RECO(1,1)*(LPCTX(NX)+VKPT(1,N))
              GXYO=RECO(1,2)*(LPCTX(NX)+VKPT(1,N))
              GXZO=RECO(1,3)*(LPCTX(NX)+VKPT(1,N))
              GX=GXX+GYX+GZX
              GY=GXY+GYY+GZY
              GZ=GXZ+GYZ+GZZ
              GXO=GXXO+GYXO+GZXO
              GYO=GXYO+GYYO+GZYO
              GZO=GXZO+GYZO+GZZO
C
              ENERG =HSQDTM*(GX**2+GY**2+GZ**2)
              ENERGO=HSQDTM*(GXO**2+GYO**2+GZO**2)
C
              IF(ENERG.LT.ENMAX) NBOX=NBOX+1
              IF(ENERGO.LT.ENMAXO) NBOXO=NBOXO+1
C
              IF(ENERG.GE.ENMAX) GOTO 2012
C
              IF(ENERGO.LT.ENMAXO) THEN
                IASSGN(NBOX)=NBOXO
              ELSE
                IASSGN(NBOX)=0
              END IF
C
 2012       CONTINUE
 2011     CONTINUE
 2010   CONTINUE
      WRITE(*,100) N,NBOX,NBOXO
  100 FORMAT(/,' IN REASSN: NKP=',I2,'  NBOX=',I5,'  NBOXold=',I5)
C      WRITE(*,101) (I,IASSGN(I),I=1,NBOX)
  101 FORMAT(2I6)
C=======================================================================
C NOW READ IN THE OLD WAVE FUNCTIONS, AND RE-WRITE THEM ACCORDING TO THE
C NEW SEQUENCE
C=======================================================================
      NPUNIT=19+N
      REWIND NPUNIT
      READ(NPUNIT) ((CPTWFP(I,J),I=1,NRPLWO),J=1,NBANDS)
      DO 60 NB=1,NBANDS
      DO 70 M=1,NRPLWO
      CWORK(M)=CPTWFP(M,NB)
      CPTWFP(M,NB)=CMPLX(0.0,0.0)
   70 CONTINUE
C
      DO 80 M=1,NRPLWV
      IF(IASSGN(M).EQ.0) THEN
         CPTWFP(M,NB)=CMPLX(0.0,0.0)
      ELSE
         CPTWFP(M,NB)=CWORK(IASSGN(M))
      END IF
   80 CONTINUE
   60 CONTINUE
      REWIND NPUNIT
      WRITE(NPUNIT) ((CPTWFP(I,J),I=1,NRPLWV),J=1,NBANDS)
C
 2000 CONTINUE
      RETURN
      END

C     *****************
      SUBROUTINE GATHER(NVH3,NVL,WK3,NVH2,WK2,IW1,IWOSET)
C     *****************


C     FUNCTION: WK3( 1:NVL, 1:18 ) = WK2( IW1(1:NVL) + IWOSET, 1:18 )


      INTEGER                 IW1(  NVH2 )
      DOUBLE PRECISION  WK3(  NVH3,   18 ) , WK2( NVH2, 18 )

      DO 10 ISM = 1,18
      DO 20 IVL = 1,NVL

      WK3(IVL,ISM) = WK2( IW1(IVL) + IWOSET, ISM )

   20 CONTINUE
   10 CONTINUE

      END

      SUBROUTINE EMITST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   EMIT TEST SUBROUTINE
C
      PARAMETER (NW=100, NB=5, NV=1000, NVM=1500, F7=78125.,
     $ T30=1073741824.)
      COMPLEX Z, WALL, ZCR, REFPT,  EXPWKL, EXPMWK, FORCE,
     & UUPSTR, DUM3, EXPZ, EXPMZ
      COMMON /ARRAYS/ NWALL(NB), IALIGN,
     $     WALL(NW,NB), RMATRX(NW*NB,NW*NB),
     $ ZCR(NW,NB), Z(NVM), GAMMA(NVM), REFPT(NB), RHS(NW*NB),
     $ FORCE(NB), RMOM(NB), CP(NW,NB), DPDS(NW,NB), EXPZ(NVM),
     $ EXPMZ(NVM), PSI(NW), PS(NVM)
      DATA IT/10/, ANS/6.0088546832072/
C
      T2 = F7 / T30
      DO 100 J = 1, NB
        NWALL(J) = NW
        REFPT(J) = 0.
        FORCE(J) = 0.
        RMOM(J) = 0.
        DO 100 I = 1, NW
          T1 = MOD (F7 * T2, 1.0D0)
          T2 = MOD (F7 * T1, 1.0D0)
          WALL(I,J) = CMPLX (T1, T2)
          T1 = MOD (F7 * T2, 1.0D0)
          T2 = MOD (F7 * T1, 1.0D0)
          ZCR(I,J) = CMPLX (T1, T2)
          DPDS(I,J) = 0.
100   CONTINUE
      DO 110 J = 1, NW*NB
        RMATRX(J,J) = 1.
        DO 110 I = 1, J-1
          T2 = MOD (F7 * T2, 1.0D0)
          RMATRX(I,J) = .001 * T2
          RMATRX(J,I) = .001 * T2
110   CONTINUE
      DO 120 I = 1, NVM
        T1 = MOD (F7 * T2, 1.0D0)
        T2 = MOD (F7 * T1, 1.0D0)
        Z(I) = CMPLX (T1, T2)
        T2 = MOD (F7 * T2, 1.0D0)
        GAMMA(I) = T2
120   CONTINUE
      TM = CPTIME ()
C
C   TIMING TEST
C
      DO 130 I = 1, IT
        CALL EMIT
130   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((RHS(19) - ANS) / ANS)
      FP = IT * (56.*NV + NB*NW * (97. + 44.*NV + 2.*NB*NW))
C
      RETURN
      END

      SUBROUTINE FILERY(JDIM,KDIM,Q,S,XYJ,COEF2,COEF4,WORK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),S(JDIM,KDIM,4),XYJ(JDIM,KDIM)
      DIMENSION COEF2(JDIM,KDIM),COEF4(JDIM,KDIM)
C
      DIMENSION WORK(JDIM,KDIM,3)
C
C   FOURTH ORDER SMOOTHING, ADDED EXPLICITLY TO RHS
C   SECOND ORDER NEAR SHOCKS WITH PRESSURE GRD COEFF.
C
C  ETA DIRECTION
C
C   START DIFFERENCES EACH VARIABLE SEPARATLY
C
      DO 39 N = 1,4
C
      DO 35 K = KBEGIN,KUP
      KPL = K+1
      DO 35 J = JLOW,JUP
      WORK(J,K,1) = Q(J,KPL,N)*XYJ(J,KPL) - Q(J,K,N)*XYJ(J,K)
35    CONTINUE          
C
C   FOR FOURTH ORDER      
C
      DO 36 K = KLOW,KUP-1
      KPL = K+1
      KMI = K-1
      DO 36 J = JLOW,JUP
      WORK(J,K,2) = WORK(J,KPL,1) - 2.* WORK(J,K,1) + WORK(J,KMI,1)
36    CONTINUE
C
C  BOUNDARY
C
      DO 37 J = JLOW,JUP
      WORK(J,KBEGIN,2) = 0.
      WORK(J,KUP,2) = WORK(J,KUP-1,1) - WORK(J,KUP,1)
37    CONTINUE
C
C
C   FORM DISSIPATION TERM
C
      DO 38 K = KBEGIN,KUP
      DO 38 J = JLOW,JUP
       WORK(J,K,3) = (COEF2(J,K)*WORK(J,K,1) - COEF4(J,K)*WORK(J,K,2))
38    CONTINUE
C
C  ADD IN DISSIPATION
C
C
      DTD = DT / (1. + PHIDT)
C
      DO 40 K = KLOW,KUP
      DO 40 J = JLOW,JUP
      S(J,K,N) = S(J,K,N) + (WORK(J,K,3) - WORK(J,K-1,3))*DTD
40    CONTINUE
C
39    CONTINUE
C
      RETURN
      END

      SUBROUTINE MULLIK(C,CBETA,UHF,H,F,NORBS,VECS,STORE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      LOGICAL UHF
      DIMENSION C(*), CBETA(*), H(*), VECS(*), STORE(*), F(*)
**********************************************************************
*
*  MULLIK DOES A MULLIKEN POPULATION ANALYSIS
* ON INPUT     C      =  SQUARE ARRAY OF EIGENVECTORS.
*              H      =  PACKED ARRAY OF ONE-ELECTRON MATRIX
*              F      =  WORKSTORE OF SIZE AT LEAST NORBS*NORBS
*              VECS   =  WORKSTORE OF SIZE AT LEAST NORBS*NORBS
*              STORE  =  WORKSTORE OF SIZE AT LEAST (NORBS*(NORBS+1))/2
*
**********************************************************************
      COMMON
     1       /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     2                NLAST(NUMATM), NORBX, NELECS,NALPHA,NBETA,
     3                NCLOSE,NOPEN,NDUMY,FRACT
     4       /KEYWRD/ KEYWRD
     5       /BETAS / BETAS(107),BETAP(107),BETAD(107)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /EXPONT/ ZS(107),ZP(107),ZD(107)
      CHARACTER KEYWRD*80
      LOGICAL GRAPH
**********************************************************************
*
*  FIRST, RE-CALCULATE THE OVERLAP MATRIX
*
**********************************************************************
      DIMENSION EIGS(MAXORB), IFACT(MAXORB), XYZ(3,NUMATM)
      GRAPH=(INDEX(KEYWRD,'GRAPH').NE.0)
      DO 10 I=1,NORBS
   10 IFACT(I)=(I*(I-1))/2
      IFACT(NORBS+1)=(NORBS*(NORBS+1))/2
      DO 50 I=1,NUMAT
         IF=NFIRST(I)
         IL=NLAST(I)
         IM1=I-1
         BI=BETAS(NAT(I))
         DO 50 K=IF,IL
            II=(K*(K-1))/2
            DO 30 J=1,IM1
               JF=NFIRST(J)
               JL=NLAST(J)
               BJ=BETAS(NAT(J))
               DO 20 JJ=JF,JL
                  IJ=II+JJ
                  H(IJ)=2.D0*H(IJ)/(BI+BJ)     +1.D-14
C  THE  +1.D-14 IS TO PREVENT POSSIBLE ERRORS IN THE DIAGONALIZATION.
                  STORE(IJ)=H(IJ)
   20          BJ=BETAP(NAT(J))
   30       CONTINUE
            DO 40 JJ=IF,K
               IJ=II+JJ
               STORE(IJ)=0.D0
   40       H(IJ)=0.D0
   50 BI=BETAP(NAT(I))
      DO 60 I=1,NORBS
         STORE(IFACT(I+1))=1.D0
   60 H(IFACT(I+1))=1.D0
      CALL RSP(H,NORBS,NORBS,EIGS,VECS)
      DO 70 I=1,NORBS
   70 EIGS(I)=1.D0/SQRT(ABS(EIGS(I)))
      IJ=0
      DO 90 I=1,NORBS
         DO 90 J=1,I
            IJ=IJ+1
            SUM=0.D0
            DO 80 K=1,NORBS
   80       SUM=SUM+VECS(I+(K-1)*NORBS)*EIGS(K)
     1                *VECS(J+(K-1)*NORBS)
            F(I+(J-1)*NORBS)=SUM
   90 F(J+(I-1)*NORBS)=SUM
      IF (GRAPH) THEN
         CALL GMETRY(GEO,XYZ)
*
* WRITE TO DISK THE FOLLOWING DATA FOR GRAPHICS CALCULATION, IN ORDER:
*
*      NUMBER OF ATOMS, ORBITAL, ELECTRONS
*      ALL ATOMIC COORDINATES
*      ORBITAL COUNTERS
*      ORBITAL EXPONENTS, S, P, AND D, AND ATOMIC NUMBERS
*      EIGENVECTORS (M.O.S NOT RE-NORMALIZED)
*      INVERSE-SQUARE ROOT OF THE OVERLAP MATRIX.
*
         WRITE(13)NUMAT,NORBS,NELECS,((XYZ(I,J),J=1,NUMAT),I=1,3)
         WRITE(13)(NLAST(I),NFIRST(I),I=1,NUMAT)
         WRITE(13)(ZS(NAT(I)),I=1,NUMAT),(ZP(NAT(I)),I=1,NUMAT),
     1         (ZD(NAT(I)),I=1,NUMAT),(NAT(I),I=1,NUMAT)
         LINEAR=NORBS*NORBS
         WRITE(13)(C(I),I=1,LINEAR)
         WRITE(13)(F(I),I=1,LINEAR)
         IF(INDEX(KEYWRD,'MULLIK').EQ.0)RETURN
      ENDIF
*
* OTHERWISE PERFORM MULLIKEN ANALYSIS
*
      CALL MULT(C,F,VECS,NORBS)
      I=-1
      CALL DENSIT(VECS,NORBS,NORBS,NCLOSE,NOPEN,FRACT,C,2)
      LINEAR=(NORBS*(NORBS+1))/2
      DO 100 I=1,LINEAR
  100 C(I)=C(I)*STORE(I)
      SUMM=0.D0
      DO 130 I=1,NORBS
         SUM=0
         DO 110 J=1,I
  110    SUM=SUM+C(IFACT(I)+J)
         DO 120 J=I+1,NORBS
  120    SUM=SUM+C(IFACT(J)+I)
         SUMM=SUMM+SUM
  130 C(IFACT(I+1))=SUM
      CALL VECPRT(C,NORBS)
      RETURN
      END

      SUBROUTINE GMTTST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      PARAMETER (NW=100, NB=5, F7=78125., T30=1073741824.)
      COMPLEX WALL, ZCR, PROJ, ZI, Z1, ZZ
      COMMON /ARRAYS/ NWALL(NB), IALIGN,
     $     WALL(NW,NB), RMATRX(NW*NB,NW*NB),
     $ ZCR(NW,NB), PROJ(NW,NB), XMAX(NB)
      DATA IT/2/, ANS/-2.57754233214174/
C
C   INITIALIZATION
C
      LW = 2 * NW * NB
      T2 = F7 / T30
      DO 100 J = 1, NB
        NWALL(J) = NW
100   CONTINUE
      DO 110 J = 1, NB
        DO 110 I = 1, NW
          T1 = MOD (F7 * T2, 1.0D0)
          T2 = MOD (F7 * T1, 1.0D0)
          WALL(I,J) = CMPLX (T1, T2)
110   CONTINUE
      TM = CPTIME ()
C
C   TIMING TEST
C
      DO 120 I = 1, IT
        CALL GMTRY
120   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((RMATRX(19,19) - ANS) / ANS)
      FP = IT * (120. * (NB*NW) ** 2  +  0.666 * (NB*NW) ** 3)
C
      RETURN
      END

C**************************************************************************
C     CONJUGATE GRADIENT METHOD FOR TOTAL ENERGY MINIMISATION 
C     WITH REGARD TO ELECTRONIC BAND COEFFICIENTS
C
C     M.P. TETER, M.C. PAYNE, AND D.C. ALLAN, PHYS. REV. B40, 12255 (1989)
C
C     VERSION OF 27-FEB-1990
C    
C     MODIFICATIONS MADE BY X WENG:    
C
C     28-Feb-90  Tested on Si 8 atoms unit cell. Seems work.
C     05-Mar-90  Correction made as suggested by MC Payne (/PRECON)
C                ORTHOGONALISE GRADIENT TO *ALL* BAND VECTORS 
C     16-Mar-90  Non-Local pseudoptenial used
C     31-MAR-90  Tested on Si and MgO
C     14-APR-90  VNL replaces AUX ( for NKPTS.GT.1)
C     11-JUN-90  PRECON PART IS CHANGED,
C                was: ENKE.LE.10   etc.
C                now: ENBAKE.LE.1  etc.
C     11-JUN-90  was: GAMMA = CORGR*CONJG(CORGR)/ COGRPI*CONJG(COGRPI)  
C                now: GAMMA = CORGR*CONJG(CDUM(M)) / COGRPI*CONJG(COGRPI)     
C
C     14-JUN-90  IVPTYP for local/nonlocal Vps added  
C                IPRINT for print-out added  
C
C     16-JUN-90  Subspace rotation attached (ISBROT=0 skip it)
C
C     17-JUN-90  CV0, CV1, AND CV2 ARE REDUCED TO ONE K-POINT A TIME
C                TO REDUCE THE DEMAND ON MEMORY SPACE. THIS WILL NOT 
C                RESULT AN INCREASE IN COMPTUTIONAL TIME FOR DYNAMIC 
C                SIMULATION, BUT WILL DO SO FOR THE STATIC CALCULATION,
C                WHERE CV0 ETC REMAIN THE SAME.
C
C     26-JUN-90  RESTRUCTURED THE NON-LOCAL PART. THE USAGE OF CV0,CV1 AND
C                CV2 IS ABANDONED. WE NOW USE
C 	         1) CPHSGR(NRPLWV,NIONS,NSPEC) = EXP(iq.Rn)
C	         2) VGNL(NRPLWV,0:2,NSPEC) = Vnl(l,q)
C	         IN ORDER TO REDUCE THE REQUIRED SPACE. TESTED OK
C
C
C     18-JUL-90  TIME STATEMENTS ADDED. TO PRINT OUT TIME, SET ICLOCK=1
C
C
C***********************************************************************
C IN VALUES
C
C CV(r)    ... THE REAL SPACE TOTAL KOHN-SHAM POTENTIAL
C CHDENR(r) .. THE REAL SPACE CHARGE DENSITY
C CVION(r) ... THE REAL SPACE IONIC POTENTIAL
C DIRDAT(G) .. THE RECIPROCAL SPACE GRID OF 1/G**2 USED FOR HARTREE POT 
C CHDENG() ... EMPTY
C CVD()   .... EMPTY
C CDUM    .... EMPTY
C CDIR    .... EMPTY
C CPTWFP  .... WAVE FUNCTIONS FOR CURRENT K-POINT
C CPTWFL  .... EMPTY
C CPTOWR,CPTNWR,CWORK,CGRA,CORGR,COGRPI,CDIRPI,PRECON : EMPTY
C
C CELEN(1)   . THE KINETIC ENERGY FOR 1ST BAND OF K-POINT 1
C EIGEN() ... EMPTY 
C DENC   .... THE HARTREE ENERGY CORRECTION
C XCENC  ..... THE EXCHANGE CORRELATION ENERGY CORRECTION
C PSCENC  ..... THE CORE ENERGY
C TEWEN   .... THE EWALD ENERGY
C WTKPT(1) ... WEIGHT OF K-POINT NO 1
C OCC(N,1) ... WEIGHT OF Nth BAND FOR K-POINT NO 1
C
C OUT VALUES
C
C EIGEN(1)... EIGENVALUE FOR 1ST BAND OF K-POINT NKP 
C=======================================================================
      SUBROUTINE CONGRA(NGX,NGY,NGZ,NBANDS,NKPTS,NPLWV,MPLWV,
     &    NRPLWV,ENMAX,NINDPW,NPLWKP,WTKPT,CV, CPTWFP,
     &    CPTWFL,DIRC,RECC,VOLC,CELEN,NGPTAR,SUMWEI,DATAKE,
     &    CPTOWR,CPTNWR,CWORK,
     &    NBANOC,CGRA,CORGR,CDIR,COGRPI,CDIRPI,
     &    PRECON,CVION,CVD,CHDENR,DENC,
     &    XCENC,TEWEN,PSCENC,NPKPT,CHDENG,XCFDAT,XCPDAT,DIRDAT,CDUM,
     &    HR, HI, AUX, FV1, FV2, FV3, CH0, NITMAX, TOTEN1,
     &    NSPEC, NIONS, NIONSP,PSCALE, 
     &    DNLKG, CPHSGR,VGNL, CELFRC, CWRK20,
     &    CWRK21,CWRK22,CWRK23,VNL,IVPTYP,IPRINT,ISBROT,
     &    IOCCUP,OCC,EIGVAL, ISYMM,NLPOT,
     &    SIGKE, SIGXC,EXCDAT, ICLOCK,IVPTYN,NRGRPT,NRLPPI,
     &    CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,
     &    NADGRD,MXRLSH,CESAVE)
      IMPLICIT COMPLEX (C)
      DIMENSION NINDPW(*)
      DIMENSION CV(*)
      DIMENSION CPTWFP(*)
      DIMENSION CPTWFL(*)
      DIMENSION CELEN(*)
      DIMENSION NGPTAR(*)
      DIMENSION DATAKE(*)
      DIMENSION CVION(*)
      DIMENSION CHDENR(*)
      DIMENSION CVD(*)
      DIMENSION CHDENG(*)
      DIMENSION WTKPT(*)
      DIMENSION DIRDAT(*)
      DIMENSION NIONSP(*)
      DIMENSION OCC(NBANDS,NKPTS), EIGVAL(NBANDS,NKPTS)
      DIMENSION EXCDAT(*), XCFDAT(*), XCPDAT(*)
      DIMENSION DIRC(3,3),RECC(3,3) 
C=======================================================================
C
C                      DIMENSION STATEMENTS
C
C CPTACC(MPLWV) = THE PRODUCT OF THE TOTAL POTENTIAL AND THE REAL SPACE
C          WAVEFUNCTION, THIS IS THEN FOURIER TRANSFORMED TO RECIPROCAL
C          SPACE
C
C CWORK(MPLWV) = A WORK ARRAY USED IN THE FOURIER TRANSFORM
C
C SIGKE(6,NKPTS) = THE FORCE ON THE UNIT CELL DUE TO THE CHANGE IN THE
C          KINETIC ENERGY ON CHANGING THE SIZE OF THE CELL FOR EACH
C          K POINT
C
C=======================================================================
      DIMENSION CPTOWR(*)
      DIMENSION CPTNWR(*)
      DIMENSION CWORK(*)
      DIMENSION PRECON(*)
      DIMENSION CGRA(*),CORGR(*),CDIR(*),COGRPI(*),CDIRPI(*)
      DIMENSION CDUM (*)
C======================================================================
C ARRAYS NEEDED FOR REAL SPACE PROJECTION OF THE NON-LOCAL POTENTIALS  
C======================================================================
      DIMENSION  NRLNL(NSPEC),PRLSCA(MXRLNL,NSPEC)                     
      DIMENSION  IRLNL(MXRLNL,NSPEC)                                   
      DIMENSION  VRLGRD(NRGRPT,MXRLSH,NIONST),CPHGRD(NRGRPT,NIONST)    
      DIMENSION  NADGRD(NRGRPT,NIONST),NRLPPI(NIONST)                  
      DIMENSION CESAVE(NIONST,20)
C=======================================================================
C     DIMENSION FOR SUBROUTINE ROTATION (WENG, 27-FEB-90)
C=======================================================================
      DIMENSION HR(NBANDS,NBANDS),HI(NBANDS,NBANDS),AUX(NBANDS),
     &     FV1(NBANDS),FV2(NBANDS),FV3(NBANDS),CH0(NBANDS,NBANDS)
C=======================================================================
C     DIMENSION STATEMENTS FOR THE NON-LOCAL CALCULATION
C=======================================================================
      DIMENSION PSCALE(0:2,NSPEC)
      DIMENSION DNLKG(NRPLWV,0:3,NKPTS)
      DIMENSION CPHSGR(NRPLWV,NIONS,NSPEC),VGNL(NRPLWV,0:2,NSPEC)
      DIMENSION CELFRC(NRPLWV)
      DIMENSION CWRK20(NIONS),CWRK21(3,NIONS)
      DIMENSION CWRK22(NIONS),CWRK23(3,3,NIONS)
      DIMENSION VNL(NBANDS, NKPTS)
      DIMENSION IVPTYN(NSPEC)
C=======================================================================
C     HAMMER'S
C=======================================================================
      DIMENSION TAU(6), SIGKE(6), SIGXC(6)
C
      DATA ALPHA0/0.05/
C
      WTKPTT = WTKPT(NPKPT)
      IF (ISYMM.EQ.1) THEN
        WTKPT(NPKPT) = SUMWEI
        IF (IPRINT.GE.1) WRITE (*,*) 'SYMM:',WTKPTT, 'NATURAL:',SUMWEI
      END IF
C
      RINPLW = 1.0 / NPLWV
C======================================================================
C CALCULATE THE TOTAL ENERGY
C=========================================================================
      ENPOT=0.0
      DO 1000 M=1,NPLWV
        ENPOT=ENPOT+REAL(CHDENR(M)*CV(M))
 1000 CONTINUE
      ENPOT=ENPOT*RINPLW
C=========================================================================
C     THE CONTRIBUTION TO TOTAL ENERGY DUE TO THE NON-LOCAL PARTS
C     OF PSEUDOPOTENTAIL, STORED IN VNL(NBANDS,NKPTS)
C     CPTWFP IS IN THE RECIPROCAL SPACE NOW.
C
C     ENVNL: IS TOTAL ENERGY OF DUE TO NON-LOCAL POTENTIAL, SUM OVER ALL  
C     BANDS.
C=========================================================================
      IF (ICLOCK.EQ.1) CALL PCLOCK(201)
      IF (IVPTYP.EQ.0 .OR. NLPOT.EQ.1) GOTO 1003
      DO 1001 NB=1,NBANDS
        CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &              VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,CWRK22,
     &              CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,NB,
     &              IVPTYN)
        VNL(NB,NPKPT)=0.0
        NINDW=(NB-1)*NRPLWV
        DO 1002 M=1,NPLWKP
          VNL(NB,NPKPT)=VNL(NB,NPKPT)+
     &                  REAL(CONJG(CPTWFP(M+NINDW))*CELFRC(M))
1002    CONTINUE
1001  CONTINUE 
      IF (IPRINT.GE.3) WRITE(*,4000) (VNL(NB,NPKPT),NB=1,NBANDS)
      IF(ICLOCK.EQ.1) CALL PCLOCK(202)
C
1003  CONTINUE
      ENKE=0.0
      ENVNL=0.0
      DO 1010 NK=1,NKPTS
        IF (NK.EQ.NPKPT) GO TO 1010
        DO 1020 NB=1,NBANDS
          ENKE =ENKE +(2.0*WTKPT(NK)*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &          OCC(NB,NK)
          IF(IVPTYP.EQ.1)ENVNL=ENVNL+2.0*WTKPT(NK)*VNL(NB,NK)*OCC(NB,NK)
 1020   CONTINUE
 1010 CONTINUE
C
      NK = NPKPT
      ENKE1 = ENKE
      ENVNL1 = ENVNL
      DO 1021 NB=1,NBANDS
        ENKE1 =ENKE1 +(2.0*WTKPTT*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &        OCC(NB,NK)
        ENKE =ENKE +(2.0*WTKPT(NK)*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &        OCC(NB,NK)
        IF(IVPTYP.EQ.1) THEN
          ENVNL1=ENVNL1+2.0*WTKPTT*VNL(NB,NK)*OCC(NB,NK)
          ENVNL =ENVNL +2.0*WTKPT(NK)*VNL(NB,NK)*OCC(NB,NK)
        END IF
 1021 CONTINUE
C
      TOTEN=ENPOT+ENKE+DENC+XCENC+TEWEN+PSCENC + ENVNL
      TOTEN1 = TOTEN
      TOTEN2=ENPOT+ENKE1+DENC+XCENC+TEWEN+PSCENC + ENVNL1
      IF (IPRINT.GE.1) THEN
        WRITE(*,*)' Welcome to CONGRA: NITMAX =', NITMAX
        IF (IPRINT.GE.2) THEN
          WRITE(*,4001) ENKE1,ENPOT
          IF (IVPTYP.NE.0) WRITE(*,4002) ENVNL1
          WRITE(*,4003) DENC,XCENC,TEWEN,PSCENC
        END IF
        IF (ISYMM.NE.0) WRITE(*,1) TOTEN2
        WRITE(*,1) TOTEN
      END IF
 4000 FORMAT(' Vnl',6F12.6)
 4001 FORMAT('  ENKE  = ', F16.7, /, '  ENPOT = ', F16.7)
 4002 FORMAT('  ENVNL = ', F16.7)
 4003 FORMAT('  DENC  = ', F16.7,
     &   /,  '  XCENC = ', F16.7, /, '  TEWEN = ', F16.7,
     &   /,  '  PSCENC= ', F16.7)
C=======================================================================
C CALCULATE THE STRESS ON THE UNIT CELL
C
C                                                      2
C                  [   h**2]  --  !           i(k+G)r !
C  Sigma      = -2 [2*-----]  >   ! c(n,k+G) e        !  (k+G)  (k+G)
C       Ai,Aj    ! [   2 m ]  --  !                   !       Ai     Aj
C                !           k,G,n
C               spin
C=======================================================================
      DO 2009 NN=1,NBANOC
        NINDW=NRPLWV*(NN-1)
        NINDKE=0
        DO 2005 M=1,6
          TAU(M)=0.0
 2005   CONTINUE
        DO 2008 N=1,NPLWKP
          NINDKE=7*(N-1)
          WFMAG=REAL(CPTWFP(NINDW+N)*CONJG(CPTWFP(NINDW+N)))
          TAU(1)=TAU(1)+DATAKE(2+NINDKE)*WFMAG
          TAU(2)=TAU(2)+DATAKE(3+NINDKE)*WFMAG
          TAU(3)=TAU(3)+DATAKE(4+NINDKE)*WFMAG
          TAU(4)=TAU(4)+DATAKE(5+NINDKE)*WFMAG
          TAU(5)=TAU(5)+DATAKE(6+NINDKE)*WFMAG
          TAU(6)=TAU(6)+DATAKE(7+NINDKE)*WFMAG
 2008   CONTINUE
C=======================================================================
C SUM THE CONTRIBUTIONS TO THE FORCE ON THE UNIT CELL FROM EACH K POINT
C SCALING THE STRESSES BY 2/VOLC, MULTIPLYING BY THE K POINT WEIGHT
C AND BY OCC FOR ELECTRON SPINS AND OCCUPANCIES
C=======================================================================
        WGHT=WTKPTT*4.0/VOLC*OCC(NN,NPKPT) 
        SIGKE(1)=SIGKE(1)-TAU(1)*WGHT
        SIGKE(2)=SIGKE(2)-TAU(2)*WGHT
        SIGKE(3)=SIGKE(3)-TAU(3)*WGHT
        SIGKE(5)=SIGKE(5)-TAU(5)*WGHT
        SIGKE(4)=SIGKE(4)-TAU(4)*WGHT
        SIGKE(6)=SIGKE(6)-TAU(6)*WGHT
 2009 CONTINUE
C=======================================================================
C
C START CONJUGATE GRADIENTS LOOP
C
C=======================================================================
       IF(ICLOCK.EQ.1) CALL PCLOCK(203)
       DO 2001 NN=1,NBANDS
        NINDEN=NN
        NINDKE=0
        NINDW=NRPLWV*(NN-1)
        OCCNN=OCC(NN,NPKPT)
        FACTOR=2.0*WTKPT(NPKPT)*OCCNN
C 
C ......................................................................
C    CALCULATE THE PRODUCT OF HAMILTONIAN AND WAVEFUNCTION
C    
C    H SI
C
C ......................................................................
C
C=======================================================================
C    1 ) CALCULATE THE PRODUCT OF THE POTENTIAL AND THE WAVEFUNCTION IN
C         real SPACE AND FOURIER TRANSFORM TO reciprocal SPACE
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
        DO 5561 M=1,MPLWV
          CPTOWR(M)=(0.0,0.0)
          CWORK(M)=(0.0,0.0)
 5561   CONTINUE
        DO 5510 M=1,NPLWKP
          CPTOWR(NINDPW(M))=CPTWFP(M+NINDW)
 5510   CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
        CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)
        DO 5000 NIT=1,NITMAX
          IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN
C=======================================================================
C CALL THE ROUTINE THAT CALCULATES THE PRODUCT OF THE NON-LOCAL
C POTENTIAL AND THE WAVEFUNCTION IN REAL SPACE
C=======================================================================
            CALL VSINL(VOLC,NGX,NGY,NGZ,MPLWV,NRPLWV,          
     &   NRGRPT,NIONSP,NRLPPI,NSPEC,CWORK,CPTOWR,CPTNWR, 
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &   CESAVE)                    
            DO 2002 NNN=1,NPLWV
              CPTNWR(NNN)=(CPTNWR(NNN)+CV(NNN)*CPTOWR(NNN))*RINPLW
 2002       CONTINUE
          ELSE 
            DO 2003 NNN=1,NPLWV                                   
              CPTNWR(NNN)=CV(NNN)*CPTOWR(NNN)*RINPLW
 2003       CONTINUE                                              
          END IF
C=======================================================================
C TRANSFORM (WAVEFUNCTION*POTENTIAL) INTO RECIPROCAL SPACE
C=======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C=======================================================================
C    2) ADDED THE KINETIC ENERGY TERM, WE OBTAIN THE GRADIENT       
C=======================================================================
          DO 2010 M=1,NPLWKP
            CGRA(M)=CPTNWR(NINDPW(M))+CPTWFP(M+NINDW)*
     &              DATAKE(1+(7*(M-1)))
 2010     CONTINUE
C=======================================================================
C    IF THE PSEUDOPOTENTIAL IS NON-LOCAL, WE ADD THE NON-LOCAL 
C    CONTRIBUTION. (MUST BE IN THE KLEIMAN-BYLANDER FORM)
C    THIS IS DONE IN SUBROUTINE VNLWAV (Vnl*WAV)     16-MAR-90 X.WENG
C=======================================================================
          IF(IVPTYP.EQ.0 .OR. NLPOT.EQ.1) GOTO 2016
C          IF(ICLOCK.EQ.1) CALL PCLOCK(203)
          CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &                VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,CWRK22,
     &                CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,NN,
     &                IVPTYN)
          DO 2015 M=1,NPLWKP
            CGRA(M)=CGRA(M) +  CELFRC(M) 
 2015     CONTINUE
C          IF(ICLOCK.EQ.1) CALL PCLOCK(204)
C
 2016     CONTINUE
          DO 2017 M=1,NPLWKP
            CGRA(M)=-CGRA(M)
            CORGR(M)=CGRA(M)
 2017     CONTINUE
C=======================================================================
C    3) ORTHOGONALISE GRADIENT TO PRESENT BAND VECTOR
C       changed ->>         ** TO ALL BAND VECTORS **    X.WENG 05-MAR-90
C=======================================================================
          DO 2022 NB=1,NBANDS
            NINDD=NRPLWV*(NB-1)
            COVERL=(0.0,0.0)
            DO 2023 M=1,NPLWKP
              COVERL=COVERL+CORGR(M)*CONJG(CPTWFP(M+NINDD))
 2023       CONTINUE
            COVERL=-COVERL
            DO 2024 M=1,NPLWKP
              CORGR(M)=CORGR(M)+COVERL*CPTWFP(M+NINDD)
 2024       CONTINUE
 2022     CONTINUE 
C=======================================================================
C    4) PRE-CONDITION THE GRADIENT
C=======================================================================
          NCELIN=NN+NBANDS*(NPKPT-1)
          ENBAKE=REAL(CELEN(NCELIN))
          IF(ENBAKE.LT.1.0) THEN
            ENKEIN=1.0
          ELSE
            ENKEIN=1.0/ENBAKE
          ENDIF
          DO 2031 M=1,NPLWKP
            X=DATAKE(1+7*(M-1))*ENKEIN
            PCNUM=27.0+(18.0+(12.0+8.0*X)*X)*X 
            PCDEN=PCNUM+16.0*(X*X)**2
            PRECON(M)=PCNUM/PCDEN
C           PRECON(M)=(1.0,0.0)
            CDUM(M)=CORGR(M)*PRECON(M)
 2031     CONTINUE
C=======================================================================
C     5) ORTHOGONALISE PRECONDITIONED RESIDUAL TO ALL BANDS
C=======================================================================
          DO 2032 NB=1,NBANDS
            NINDD=NRPLWV*(NB-1)
C
C     COVERL=CDOTC(NPLWKP,CPTWFP(NINDD+1),1,CORGR,1)
C     COVERL=-COVERL
C     CALL CAXPY(NPLWKP,COVERL,CPTWFP(NINDD+1),1,CORGR,1)
C
            COVERL=(0.0,0.0)
            DO 2033 M=1,NPLWKP
              COVERL=COVERL+CDUM(M)*CONJG(CPTWFP(NINDD+M))
 2033       CONTINUE
            DO 2034 M=1,NPLWKP
              CDUM(M)=CDUM(M)-COVERL*CPTWFP(NINDD+M)
 2034       CONTINUE
 2032     CONTINUE
C=======================================================================
C AFTER FIRST ITERATION USE CONJUGATE DIRECTIONS
C=======================================================================
          IF(NIT.EQ.1) THEN
            DO 2035 M=1,NPLWKP
              CDIR(M)=CDUM(M)
 2035       CONTINUE
          ELSE
            CDOT1=(0.0,0.0)
            CDOT2=(0.0,0.0)
            DO 2040 M=1,NPLWKP
C
C     From Numerical Recipes p304, eq(10.6.5):
C     1) Fletcher-Reeves method  GAMMA = G(i+1)*G(i+1)/G(i)*G(i)
C     2) Poloak-Ribiere method   GAMMA = [G(i+1)-G(i)]*G(i+1)/G(i)*G(i)
C 
              CDOT1=CDOT1+CORGR(M) *CONJG(CDUM(M))
C             CDOT1=CDOT1+(CORGR(M)-COGRPI(M)) *CONJG(CDUM(M))
C
C             CDOT2=CDOT2+COGRPI(M)*CONJG(COGRPI(M))
              CDOT2=CDOT2+COGRPI(M)*CONJG(COGRPI(M))*PRECON(M)
 2040       CONTINUE
            CGAMMA=CDOT1/CDOT2
            DO 2050 M=1,NPLWKP
              CDIR(M)=CDUM(M)+CGAMMA*CDIRPI(M)
 2050       CONTINUE
          ENDIF
          DO 2060 M=1,NPLWKP
            CDIRPI(M)=CDIR(M)
            COGRPI(M)=CORGR(M)
 2060     CONTINUE
C=======================================================================
C FINALLY ORTHOGONALISE SEARCH DIRECTION TO PRESENT BAND AND NORMALISE
C=======================================================================
          COVERL=(0.0,0.0)
          DO 2070 M=1,NPLWKP
            COVERL=COVERL+CDIR(M)*CONJG(CPTWFP(M+NINDW))
 2070     CONTINUE
          DO 2080 M=1,NPLWKP
            CDIR(M)=CDIR(M)-COVERL*CPTWFP(M+NINDW)
 2080     CONTINUE
          ANORM=0.0
          DO 2090 M=1,NPLWKP
            ANORM=ANORM+REAL(CDIR(M)*CONJG(CDIR(M)))
 2090     CONTINUE
          FNORM=1.0/(SQRT(ANORM))
          DO 2095 M=1,NPLWKP
            CDIR(M)=CDIR(M)*FNORM
 2095     CONTINUE
C=======================================================================
C NOW DETERMINE OPTIMUM STEP LENGTH ALONG SEARCH DIRECTION
C STEP 1 DETERMINE THE COEFFICIENT OF THE 'SIN' TERM IN THE ENERGY
C EXPRESSION E = E(AV) + ES SIN(2*THETA) + EC COS(2*THETA)
C=======================================================================
          EN1=0.0
          DO 2100 M=1,NPLWKP
            EN1=EN1+REAL(CDIR(M)*CONJG(CGRA(M)))
 2100     CONTINUE
          ESIN=-EN1*2.0*WTKPT(NPKPT)*OCCNN
C=======================================================================
C CALCULATE ENERY AT THE BEGINNING OF THE STEP
C=======================================================================
          EN2=TOTEN
C=======================================================================
C CALCULATE A NEW VECTOR AT A TRIAL DISTANCE ALONG THE SEARCH DIRECTION
C=======================================================================
          ALPHA=ALPHA0
          ALCOS=COS(ALPHA)
          ALSIN=SIN(ALPHA)
          TALCOS=COS(2.0*ALPHA)
          TALSIN=SIN(2.0*ALPHA)
          DO 2110 M=1,NPLWKP
            CPTWFL(M)=ALCOS*CPTWFP(M+NINDW)+ALSIN*CDIR(M)
 2110     CONTINUE
C=======================================================================
C REPEAT PROCESS OF CALCULATING THE ENERGY BUT WITH THE NEW VECTOR
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
          DO 2112 M=1,MPLWV
            CPTNWR(M)=(0.0,0.0)
            CWORK(M)=(0.0,0.0)
 2112     CONTINUE
          DO 2113 M=1,NPLWKP
            CPTNWR(NINDPW(M))=CPTWFL(M)
 2113     CONTINUE
          NCELIN=NN+(NBANDS*(NPKPT-1))
          CELEN(NCELIN)=(0.0,0.0)
          DO 2114 M=1,NPLWKP
            CELEN(NCELIN)=CELEN(NCELIN)+DATAKE(1+7*(M-1))*CPTWFL(M)*
     &                    CONJG(CPTWFL(M))
 2114     CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE, AND FIND THE NEW CHDENR(r)
C=======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,1)
          DO 3000 M=1,NPLWV
            CHDENR(M)=CHDENR(M)+FACTOR*
     &         (CPTNWR(M)*CONJG(CPTNWR(M))-CPTOWR(M)*CONJG(CPTOWR(M)))
 3000     CONTINUE
          DO 3010 M=1,NPLWV
            CPTOWR(M)=CPTNWR(M)
 3010     CONTINUE
C=======================================================================
C CALL ROUTINE TO CALCULATE NON-LOCAL ENERGY IN REAL SPACE
C=======================================================================
          IF(IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN
            CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NN,NPKPT,MPLWV,NRPLWV,
     &       NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK,CPTNWR,          
     &       CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,
     &       MXRLSH,CESAVE)                      
          ENDIF                                                             
          DO 3020 M=1,NPLWV
            CPTNWR(M)=CHDENR(M)*RINPLW
 3020     CONTINUE
C=======================================================================
C TRANSFORM THE NEW CHARGE DENSITY INTO RECIPROCAL SPACE
C=======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C======================================================================
C CALC. HARTREE POTENTIAL AND ENERGY CORRECTION IN RECIPROCAL SPACE
C======================================================================
          DENC=0.0
          DO 9122 M=1,NPLWV
            CVD(M)=CPTNWR(M)*DIRDAT(M)
            DENC=DENC+REAL(CVD(M)*CONJG(CPTNWR(M)))
 9122     CONTINUE
          DENC=-DENC/2
          DO 3030 M=1,NPLWV
            CPTNWR(M)=CVD(M)
 3030     CONTINUE
C======================================================================
C TRANSFORM HARTREE POTENTIAL INTO REAL SPACE
C======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,1)
          DO 3035 M=1,NPLWV
            CVD(M)=CPTNWR(M)
 3035     CONTINUE
          DO 3040 M=1,NPLWV
            CV(M)=CHDENR(M)
 3040     CONTINUE
C======================================================================
C CALC. EXCHANGE CORRELATION ENERGY CORRECTION USING CHDENR(r)
C======================================================================
          CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,XCFDAT,
     &                XCPDAT)
          DO 3050 M=1,NPLWV
            CV(M)=CV(M)+CVION(M)
            CV(M)=CV(M)+CVD(M)
 3050     CONTINUE
C======================================================================
C CALCULATE THE TOTAL ENERGY (IN REAL SPACE)
C======================================================================
          ENPOT=0.0
          DO 1100 M=1,NPLWV
            ENPOT=ENPOT+REAL(CHDENR(M)*CV(M))
 1100     CONTINUE
          ENPOT=ENPOT*RINPLW
C======================================================================
C     THE CONTRIBUTION TO TOTAL ENERGY FROM THE NON-LOCAL PSEUDOPOTENTIAL.
C     THIS TIME, ONLY THAT OF THE NNth BAND NEED TO BE CALCULATED
C     THE TRIAL WAVE FUNCTION IS IN CPTWPL, IT IS IN THE RECIPROCAL SPACE
C======================================================================
          IF(IVPTYP.EQ.0 .OR. NLPOT.EQ.1) GOTO 1103 
C          IF(ICLOCK.EQ.1) CALL PCLOCK(205)
          CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &                VOLC, PSCALE,CPTWFL,CWRK20,CWRK21,CWRK22,
     &                CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,1,
     &                IVPTYN)
          VNL(NN,NPKPT)=0.0
          DO 1102 M=1,NPLWKP
            VNL(NN,NPKPT)=VNL(NN,NPKPT)+REAL(CONJG(CPTWFL(M))*CELFRC(M))
 1102     CONTINUE
C          IF(ICLOCK.EQ.1) CALL PCLOCK(206)
C
1103      CONTINUE
          ENKE=0.0
          ENVNL=0.0
          DO 1110 NK=1,NKPTS
            DO 1120 NB=1,NBANDS
              ENKE=ENKE+(2.0*WTKPT(NK)*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &             OCC(NB,NK)
              IF(IVPTYP.EQ.1) ENVNL=ENVNL+ 2.0*WTKPT(NK)*VNL(NB,NK)*
     &                              OCC(NB,NK)
 1120       CONTINUE
 1110     CONTINUE
C
          IF(IPRINT.GE.3) THEN 
            WRITE(*,4000) (VNL(NB,NPKPT),NB=1,NBANDS)
            WRITE(*,4001) ENKE,ENPOT
            IF (IVPTYP.EQ.1) WRITE(*,4002) ENVNL
            WRITE(*,4003) DENC,XCENC,TEWEN,PSCENC
          END IF
          TOTEN=ENPOT+ENKE+DENC+XCENC+TEWEN+PSCENC +ENVNL
          EN3=TOTEN
          ECOS=(EN2-EN3+ESIN*TALSIN)/(1.0-TALCOS)
          EAVE=EN2-ECOS
          IF(IPRINT.GE.3) THEN 
            WRITE(*,*)' EN2, EN3:', EN2, EN3
            WRITE(*,*)' ESIN, ECOS, EAVE:', ESIN, ECOS, EAVE
          END IF
C=======================================================================
C CALCULATE STEPLENGTH
C=======================================================================
          IF(ECOS.EQ.0.0) THEN
            TTHETA=0.0
          ELSE
            TTHETA=ATAN(ESIN/ECOS)
          END IF
          THETA=TTHETA/2.0
          IF(THETA.LT.-0.1) THETA=THETA+1.570796327
          IF(IPRINT.GE.3) WRITE(*,*)' THETA:', THETA
C=======================================================================
C UPDATE WAVEFUNCTION
C=======================================================================
          THCOS=COS(THETA)
          THSIN=SIN(THETA)
          DO 2200 M=1,NPLWKP
            CPTWFP(M+NINDW)=THCOS*CPTWFP(M+NINDW)+THSIN*CDIR(M)
 2200     CONTINUE
          DO 3012 M=1,MPLWV
            CPTNWR(M)=(0.0,0.0)
            CWORK(M)=(0.0,0.0)
 3012     CONTINUE
          DO 3013 M=1,NPLWKP
            CPTNWR(NINDPW(M))=CPTWFP(M+NINDW)
 3013     CONTINUE
          NCELIN=NN+(NBANDS*(NPKPT-1))
          CELEN(NCELIN)=(0.0,0.0)
          DO 3014 M=1,NPLWKP
            CELEN(NCELIN)=CELEN(NCELIN)+DATAKE(1+7*(M-1))*
     &                    CPTWFP(M+NINDW)*CONJG(CPTWFP(M+NINDW))
 3014     CONTINUE
C======================================================================
C     UPDATE THE NON-LOCAL ENERGY OF NNth BAND
C======================================================================
          IF(IVPTYP.EQ.0 .OR. NLPOT.EQ.1) GOTO 3016
C          IF(ICLOCK.EQ.1) CALL PCLOCK(207)
          CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,DNLKG(1,0,NPKPT),
     &                VOLC,PSCALE,CPTWFP,CWRK20,CWRK21,CWRK22,
     &                CWRK23,CPHSGR,VGNL,CELFRC,CDUM,CORGR,NN,
     &                IVPTYN)
          VNL(NN,NPKPT)=0.0
          DO 3015 M=1,NPLWKP
            VNL(NN,NPKPT)=VNL(NN,NPKPT)+REAL(CONJG(CPTWFP(M+NINDW))*
     &                    CELFRC(M))
 3015    CONTINUE
C          IF(ICLOCK.EQ.1) CALL PCLOCK(208)
C======================================================================
C     UPDATE THE TOTAL CHARGE DENSITY
C======================================================================
3016      CONTINUE
C======================================================================
C     TRANSFORM WAVEFUNCTION INTO REAL SPACE
C======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,1)
C======================================================================
C     CALCULATE NEW CHARGE DENSITY
C======================================================================
          DO 3100 M=1,NPLWV
            CHDENR(M)=CHDENR(M)+FACTOR*
     +        ( CPTNWR(M)*CONJG(CPTNWR(M))-CPTOWR(M)*CONJG(CPTOWR(M)) )
 3100     CONTINUE
          DO 3110 M=1,NPLWV
            CPTOWR(M)=CPTNWR(M)
 3110     CONTINUE
C=======================================================================
C CALL ROUTINE TO CALCULATE NON-LOCAL ENERGY IN REAL SPACE
C=======================================================================
         IF(IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN                         
            CALL ENRLNL(VOLC,NGX,NGY,NGZ,VNL,NN,NPKPT,MPLWV,NRPLWV,
     &       NRGRPT,NIONSP,NRLPPI,NBANDS,NKPTS,NSPEC,CWORK,CPTNWR,      
     &       CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,
     &       MXRLSH,CESAVE)                                             
          ENDIF
C======================================================================
C     TRANSFORM CHARGE DENSITY INTO RECIPROCAL SPACE
C======================================================================
          DO 3120 M=1,NPLWV
            CPTNWR(M)=CHDENR(M)*RINPLW
 3120     CONTINUE
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
          DO 3121 M=1,NPLWV
            CHDENG(M)=CPTNWR(M)
 3121     CONTINUE
C======================================================================
C     CALCULATE COULOMB POTENTIAL AND CORRECTION TO TOTAL ENERGY 
C     IN RECIPROCAL SPACE
C======================================================================
          DENC=0.0
          DO 9123 M=1,NPLWV
            CVD(M)=CPTNWR(M)*DIRDAT(M)
            DENC=DENC+REAL(CVD(M)*CONJG(CPTNWR(M)))
 9123     CONTINUE
          DENC=-DENC/2
C======================================================================
C     FFT THE HARTREE POTENTIAL INTO REAL SPACE
C======================================================================
          DO 3130 M=1,NPLWV
            CPTNWR(M)=CVD(M)
 3130     CONTINUE
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,1)
          DO 3135 M=1,NPLWV
            CVD(M)=CPTNWR(M)
 3135     CONTINUE
C======================================================================
C     CALCULATE EXCHANGE-CORRELATION ENERGY IN REAL SPACE
C======================================================================
          DO 3140 M=1,NPLWV
            CV(M)=CHDENR(M)
 3140     CONTINUE
          CALL FEXCTR(NPLWV,CV,VOLC,SIGXC,XCENC,XCENER,EXCDAT,
     &                                             XCFDAT,XCPDAT)
          DO 3150 M=1,NPLWV
            CV(M)=CV(M)+CVION(M)
            CV(M)=CV(M)+CVD(M)
 3150     CONTINUE
C======================================================================
C
C     CV(M) IS THE CHARGE DENSITY IN REAL SPACE
C
C======================================================================
C CALCULATE THE TOTAL ENERGY
C======================================================================
          ENPOT=0.0
          ENKE=0.0
          ENVNL=0.0
          DO 1200 M=1,NPLWV
            ENPOT=ENPOT+REAL(CHDENR(M)*CV(M))
 1200     CONTINUE
          ENPOT=ENPOT*RINPLW
          DO 1210 NK=1,NKPTS
            DO 1220 NB=1,NBANDS
            ENKE=ENKE+(2.0*WTKPT(NK)*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &           OCC(NB,NK)
            IF(IVPTYP.EQ.1) ENVNL=ENVNL+ 2.0*WTKPT(NK)*VNL(NB,NK)*
     &                      OCC(NB,NK)
 1220       CONTINUE
 1210     CONTINUE
          TOTEN=ENPOT+ENKE+DENC+XCENC+TEWEN+PSCENC +ENVNL
C======================================================================
C     MOVE ONTO THE NEXT ITERATION
C======================================================================
 5000   CONTINUE
C======================================================================
C     MOVE ONTO THE NEXT BAND
C======================================================================
 2001 CONTINUE
      IF(ICLOCK.EQ.1) CALL PCLOCK(203)
      IF(IPRINT.GE.3) WRITE (*,4000) (VNL(NB,NPKPT),NB=1,NBANDS)
      IF (IPRINT.GE.2) THEN
        WRITE (*,4001) ENKE,ENPOT
        IF (IVPTYP.EQ.1) WRITE (*,4002) ENVNL
        WRITE (*,4003) DENC,XCENC,TEWEN,PSCENC
      END IF
      TOTEN=ENPOT+ENKE+DENC+XCENC+TEWEN+PSCENC +ENVNL
      IF(IPRINT.GE.1) WRITE(*,1) TOTEN
      IF (ISYMM.NE.0) THEN
        ENVNL1=0.0
        ENKE1 =0.0
        NK = NPKPT
        DO 6011 NB=1,NBANDS
          ENKE1=ENKE1+(2.0*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &         OCC(NB,NK)*(WTKPTT-WTKPT(NK))
          IF(IVPTYP.EQ.1) ENVNL1=ENVNL1+ 2.0*VNL(NB,NK)*
     &                    OCC(NB,NK)*(WTKPTT-WTKPT(NK))
 6011   CONTINUE
        TOTEN2 = TOTEN + ENKE1 + ENVNL1
        IF(IPRINT.GE.1) WRITE(*,1) TOTEN2
      END IF
 1    FORMAT(1X,'THE TOTAL ENERGY IS   ',F16.8)
C=======================================================================
C SUB-SPACE ROTATION (FINDS OUT EIGEN STATES AND EIGEN VALUES) 
C THE CELEN AND VNL ARE UPDATED
C=======================================================================
      IF(ISBROT.EQ.0) GOTO 9999
         CALL SUBROT(NBANDS,NKPTS,NPLWV,MPLWV,NRPLWV,NINDPW,
     &       NPLWKP,CV,CPTWFP,CPTWFL,VOLC,CELEN,        
     &       VNL,NGPTAR,DATAKE,CPTOWR,CPTNWR,
     &       CWORK,CGRA,NPKPT,                               
     &       HR, HI, AUX, FV1, FV2, FV3, CH0, NSPEC, NIONS,
     &       NIONSP,PSCALE,                                  
     &       DNLKG,CPHSGR,VGNL,CELFRC,CWRK20,
     &       CWRK21, CWRK22, CWRK23,IVPTYP,IVPTYN,IPRINT,NLPOT,
     &       NGX,NGY,NGZ,NRGRPT,NRLPPI,CPHGRD,NRLNL,NIONST,MXRLNL,
     &       IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,CESAVE)            
      DO 6006 NB=1,NBANDS
        EIGVAL(NB,NPKPT)=AUX(NB)
 6006 CONTINUE
      ENVNL=0.0
      ENKE =0.0
      DO 6010 NK=1,NKPTS
        DO 6010 NB=1,NBANDS
          ENKE=ENKE+(2.0*WTKPT(NK)*REAL(CELEN((NK-1)*NBANDS+NB)))*
     &         OCC(NB,NK)
          IF(IVPTYP.EQ.1) ENVNL=ENVNL+ 2.0*WTKPT(NK)*VNL(NB,NK)*
     &                    OCC(NB,NK)
 6010 CONTINUE
      IF (IPRINT.GE.1) THEN
        WRITE(*,*)' AFTER SUBROT: ENKE =', ENKE
        IF (IVPTYP.EQ.1) WRITE(*,*)'               ENVNL=', ENVNL
        TOTEN=ENPOT+ENKE+DENC+XCENC+TEWEN+PSCENC +ENVNL
        WRITE (*,1) TOTEN 
      END IF
C======================================================================
C
C======================================================================
 9999 CONTINUE
      IF(IPRINT.GE.2)WRITE(*,*)' BYE FROM CONGRA, VERSION OF 16-JUN-92'
      IF (ISYMM.NE.0) WTKPT(NPKPT)=WTKPTT
      RETURN
      END 

      SUBROUTINE GETSYM
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOSYM/ NDEP, LOCPAR(MAXPAR), IDEPFN(MAXPAR),
     1                LOCDEP(MAXPAR)
C***********************************************************************
C
C   GETSYM READS IN THE SYMMETRY DEPENDENCE RELATIONSHIPS.
C
C   ON EXIT     NDEP    = NUMBER OF SYMMETRY RELATIONS.
C               LOCPAR  = ARRAY OF REFERENCE FUNCTION INDICES.
C               IDEPFN  = ARRAY OF REFERENCE ATOM LOCATIONS.
C               LOCDEP  = ARRAY OF DEPENDENT ATOM LOCATIONS.
C
C***********************************************************************
C
C     LOCDEP IS THE ATOM WHOSE COORDINATES DEPEND ON THE COORDINATES OF
C     LOCPAR.
C     LOCPAR IS THE ATOM WHOSE COORDINATES ARE USED TO CALCULATE THOSE
C     OF LOCDEP
C     IDEPFN POINTS TO THE PARTICULAR FUNCTION TO BE USED (SEE NDDO)
C
C***********************************************************************
      DIMENSION IVALUE(40),VALUE(40)
      CHARACTER  TEXT(18)*60, KEYWRD*80, LINE*80
      DATA TEXT/
     1' BOND LENGTH    IS SET EQUAL TO THE REFERENCE BOND LENGTH   ',
     2' BOND ANGLE     IS SET EQUAL TO THE REFERENCE BOND ANGLE    ',
     3' DIHEDRAL ANGLE IS SET EQUAL TO THE REFERENCE DIHEDRAL ANGLE',
     4' DIHEDRAL ANGLE VARIES AS  90 DEGREES - REFERENCE DIHEDRAL  ',
     5' DIHEDRAL ANGLE VARIES AS  90 DEGREES + REFERENCE DIHEDRAL  ',
     6' DIHEDRAL ANGLE VARIES AS 120 DEGREES - REFERENCE DIHEDRAL  ',
     7' DIHEDRAL ANGLE VARIES AS 120 DEGREES + REFERENCE DIHEDRAL  ',
     8' DIHEDRAL ANGLE VARIES AS 180 DEGREES - REFERENCE DIHEDRAL  ',
     9' DIHEDRAL ANGLE VARIES AS 180 DEGREES + REFERENCE DIHEDRAL  ',
     1' DIHEDRAL ANGLE VARIES AS 240 DEGREES - REFERENCE DIHEDRAL  ',
     2' DIHEDRAL ANGLE VARIES AS 240 DEGREES + REFERENCE DIHEDRAL  ',
     3' DIHEDRAL ANGLE VARIES AS 270 DEGREES - REFERENCE DIHEDRAL  ',
     4' DIHEDRAL ANGLE VARIES AS 270 DEGREES - REFERENCE DIHEDRAL  ',
     5' DIHEDRAL ANGLE VARIES AS - REFERENCE DIHEDRAL              ',
     6' BOND LENGTH VARIES AS HALF THE REFERENCE BOND LENGTH       ',
     7' BOND ANGLE VARIES AS HALF THE REFERENCE BOND ANGLE         ',
     8' BOND ANGLE VARIES AS 180 DEGREES - REFERENCE BOND ANGLE    ',
     9' THE USER HAS TO SUPPLY THIS FUNCTION IN DEPVAR             '/
C
C TITLE OUTPUT
      WRITE (6,10)
   10 FORMAT (///5X,25HPARAMETER DEPENDENCE DATA//
     1'        REFERENCE ATOM      FUNCTION NO.    DEPENDENT ATOM(S)')
C
C INPUT SYMMETRY : FUNCTION, REFERANCE PARAMETER, AND DEPENDENT ATOMS
C
      NDEP=0
   20 READ(5,'(A)',END=70) LINE
      CALL NUCHAR(LINE,VALUE,NVALUE)
C   INTEGER VALUES
      DO 30 I=1,NVALUE
   30 IVALUE(I)=VALUE(I)
C   FILL THE LOCDEP ARRAY
      IF(NVALUE.EQ.0.OR.IVALUE(3).EQ.0) GO TO 70
      DO 40 I=3,NVALUE
         IF(IVALUE(I).EQ.0) GOTO 50
         NDEP=NDEP+1
         LOCDEP(NDEP)=IVALUE(I)
         LOCPAR(NDEP)=IVALUE(1)
         IDEPFN(NDEP)=IVALUE(2)
   40 CONTINUE
   50 LL=I-1
      WRITE(6,60)IVALUE(1),IVALUE(2),(IVALUE(J),J=3,LL)
   60 FORMAT(I13,I19,I14,20I3)
      GO TO 20
C
C CLEAN UP
   70 CONTINUE
      WRITE(6,80)
   80 FORMAT(/10X,'   DESCRIPTIONS OF THE FUNCTIONS USED',/)
      DO 120 J=1,18
         DO 90 I=1,NDEP
            IF(IDEPFN(I).EQ.J) GOTO 100
   90    CONTINUE
         GOTO 120
  100    WRITE(6,110)J,TEXT(J)
  110    FORMAT(I4,5X,A)
  120 CONTINUE
      RETURN
      END

      SUBROUTINE SOLVE(M,U,F,MAXN,NDOFS,LO,IDIAG,UP)
                              
      INTEGER MAXN,NDOFS,I,J,K,LO,UP,IDIAG,IMAX,JMAX
      DOUBLE PRECISION M(2*MAXN,*),U(*),F(*),AMUL


        DO 1200 I=1,NDOFS                             
1200      U(I)=F(I)
          

        DO 1250 K=1,NDOFS-1

          IF((K+LO).GT.NDOFS) THEN
            IMAX=NDOFS
          ELSE
            IMAX=K+LO
          ENDIF

          DO 1240 I=K+1,IMAX
            AMUL=-M(I,IDIAG+K-I)/M(K,IDIAG)
            M(I,IDIAG+K-I)=0.0

            IF((K+UP).GT.NDOFS) THEN
              JMAX=NDOFS
            ELSE
              JMAX=K+UP
            ENDIF

            DO 1230 J=K+1,JMAX 
              M(I,IDIAG+J-I)=M(I,IDIAG+J-I)+AMUL*M(K,IDIAG+J-K)
1230        CONTINUE
            U(I)=U(I)+AMUL*U(K)
1240      CONTINUE
1250    CONTINUE
      

        U(NDOFS)=U(NDOFS)/M(NDOFS,IDIAG)
      
        DO 1270 K=NDOFS-1,1,-1
          IF((K+UP).GT.NDOFS) THEN
            JMAX=NDOFS
          ELSE
            JMAX=K+UP
          ENDIF
          DO 1260 J=K+1,JMAX
            U(K)=U(K)-M(K,IDIAG+J-K)*U(J)
1260      CONTINUE
          U(K)=U(K)/M(K,IDIAG)
1270    CONTINUE

      RETURN         
      END 

C     ***************
      SUBROUTINE HEAD(
C     ***************
     >                NS,NT,NW1,
     >                START,IAVG,IAVGDD,SEED,ITEMAX,
     >                METHIT,ITBLUP,ORDEXP,BETA,SIGMA )
C
C
C     SUBROUTINE HEAD PRINTS THE HEADING OF THE OUTPUT FILE
C
C
C     REVISION - NOV. 1989; E.KEHL
C
C     LATEST REVISION - April, 1992, V.Getov
C
      DOUBLE PRECISION    BETA,SIGMA
C
C
      INTEGER  ORDEXP,SEED,START
C
C
      CHARACTER*10 PST(0:1)
C
C
      DATA PST /'DISORDERED',
     >          '   ORDERED'/
      CALL HEADER(NW1)
C
C
      WRITE( NW1, 1010)
      WRITE( NW1, 1020) NS,NT
      WRITE( NW1, 1040) PST(START)
      WRITE( NW1, 1050) ITEMAX
      WRITE( NW1, 1055) METHIT
      WRITE( NW1, 1060) IAVGDD
      WRITE( NW1, 1070) IAVG
      WRITE( NW1, 1080) SEED
      WRITE( NW1, 1090) ITBLUP
      WRITE( NW1, 1100) SIGMA
      WRITE( NW1, 1110) BETA
C
      WRITE( NW1, 1120)
C
C
 1010 FORMAT(2(/),10X,
     >'INPUT PARAMETERS:'/10X,
     >'---------------- '     )
C
 1020 FORMAT(//10X,
     >'Lattice Size                            :'
     >,I3,' CUBED TIMES ',I3)
C
 1040 FORMAT(10X,
     >'Start Configuration                     :',9X,A10)
C
 1050 FORMAT(10X,
     >'Total Number of Iterations              :',9X,I10)
C
 1055 FORMAT(10X,
     >'Number of Metropolis-hits               :',9X,I10)
C
 1060 FORMAT(10X,
     >'Discarded Iterations for Thermalization :',9X,I10)
C
 1070 FORMAT(10X,
     >'Modul for Taking Averages               :',9X,I10)
C
 1080 FORMAT(10X,
     >'Start Value of Random Number Generator  :',9X,I10)
C
 1090 FORMAT(10X,
     >'SU3 Matrix Table Update Modul           :',9X,I10)
C
 1100 FORMAT(10X,
     >'Standard Deviation of Gaussian Rand. NO.:',4X,E15.6)
C
 1110 FORMAT(10X,
     >'Bare Coupling Constant                  :',4X,E15.6)
C
 1120 FORMAT(2(/),10X,
     >'RESULTS:'/10X,
     >'------- '     )
C
C
      END

      SUBROUTINE LTIMST(DT,COORD,DIM,UPREV,NELEMS,NNODES,ELTOP,IELTOP,
     +     DIMENS,MODULE)
      INTEGER DIM,NELEMS,NNODES,IELTOP
      INTEGER ELTOP(IELTOP,*)
      DOUBLE PRECISION DT,COORD(DIM,*),UPREV(*)
      CHARACTER*(*) DIMENS, MODULE
      INTEGER NELE,I
      DOUBLE PRECISION DX1,DX2,DY1,DY2,YMIN,MN,MIN,REQ,RE,VELOX,VELOY,
     +     DMIN1,DMAX1,XMIN,DLEN

      MIN=+1.0D+10
      DO 10 NELE=1,NELEMS
         DX1=DLEN(COORD(1,ELTOP(3,NELE)),COORD(2,ELTOP(3,NELE)),
     +        COORD(1,ELTOP(4,NELE)),COORD(2,ELTOP(4,NELE)))
         DX2=DLEN(COORD(1,ELTOP(8,NELE)),COORD(2,ELTOP(8,NELE)),
     +        COORD(1,ELTOP(9,NELE)),COORD(2,ELTOP(9,NELE)))

         DY1=DLEN(COORD(1,ELTOP(3,NELE)),COORD(2,ELTOP(3,NELE)),
     +        COORD(1,ELTOP(10,NELE)),COORD(2,ELTOP(10,NELE)))
         DY2=DLEN(COORD(1,ELTOP(5,NELE)),COORD(2,ELTOP(5,NELE)),
     +        COORD(1,ELTOP(6,NELE)),COORD(2,ELTOP(6,NELE)))

         XMIN=DMIN1(DX1,DX2)
         YMIN=DMIN1(DY1,DY2)
         MN=DMIN1(XMIN,YMIN)
         IF (MN .LT. MIN) MIN=MN
 10   CONTINUE
 
      REQ=-1.0D+10
      DO 20 I=1,NNODES
         VELOX=UPREV(2*I-1)
         VELOY=UPREV(2*I)
         RE=DMAX1(VELOX,VELOY)
         IF (RE .GT. REQ) REQ=RE
 20   CONTINUE

      DT=MIN/REQ

      eps = 0.0
      IF (REQ .LT. EPS) THEN
         WRITE(6,*) 'Velocities under ',EPS
      ELSE 
         IF (DT .GT. (MIN/REQ)) THEN
            WRITE(6,100) MODULE
            WRITE(6,110) DIMENS,DT,MIN/REQ
            WRITE(6,120)
            STOP
         ENDIF
      ENDIF
 100  FORMAT(1X,'*** Too large time step in --',A6,'--')
 110  FORMAT(1X,'   ',A6,'=',F10.4,'  It should be at most ',F10.4)
 120  FORMAT(1X,'    Cannot continue ... Bye!')

      RETURN
      END

      SUBROUTINE SPLINE
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      LOGICAL SKIP1,SKIP2
C
C     FIT F(X) BY A CUBIC SPLINE GIVEN VALUES OF THE FUNCTION
C     AND ITS FIRST DERIVATIVE AT N PNTS.
C     SUBROUTINE RETURNS VALUES OF XMIN,FMIN, AND DFMIN
C     AND MAY REORDER THE DATA.
C     CALLING PROGRAM SUPPLIES ALL OTHER VALUES IN THE
C     COMMON BLOCK.
C     XLOW AND XHIGH SET LIMITS ON THE INTERVAL WITHIN WHICH
C     TO SEARCH.  SUBROUTINE MAY FURTHER REDUCE THIS INTERVAL.
C
      COMMON/FIT/N,IDUM2,XLOW,XHIGH,XMIN,FMIN,DFMIN,X(12),F(12),DF(12)
      DATA CLOSE, BIG, HUGE, USTEP, DSTEP/1.0E-8,500.0,1.0E+10,1.0,2.0/
C
C     SUBROUTINE ASSUMES THAT THE FIRST N-1 DATA PNTS HAVE BEEN
C     PREVIOUSLY ORDERED,  X(I).LT.X(I+1) FOR I=1,2,...,N-2
C     NOW MOVE NTH POINT TO ITS PROPER PLACE.
C
      XMIN=X(N)
      FMIN=F(N)
      DFMIN=DF(N)
      N1=N-1
      K=N1
   10 IF(X(K).LT.XMIN) GO TO 20
      X(K+1)=X(K)
      F(K+1)=F(K)
      DF(K+1)=DF(K)
      K=K-1
      IF(K.GT.0) GO TO 10
   20 X(K+1)=XMIN
      F(K+1)=FMIN
      DF(K+1)=DFMIN
C
C     DEFINE THE INTERVAL WITHIN WHICH WE TRUST THE SPLINE FIT.
C     USTEP =  UP HILL STEP SIZE FACTOR
C     DSTEP = DOWN HILL STEP SIZE FACTOR
C
      IF(DF(1).GT.0.0) STEP=DSTEP
      IF(DF(1).LE.0.0) STEP=USTEP
      XSTART=X(1)-STEP*(X(2)-X(1))
      XSTART=MAX(XSTART,XLOW)
      IF(DF(N).GT.0.0) STEP=USTEP
      IF(DF(N).LE.0.0) STEP=DSTEP
      XSTOP=X(N)+STEP*(X(N)-X(N1))
      XSTOP=MIN(XSTOP,XHIGH)
C
C     SEARCH FOR MINIMUM
C
      DO 110 K=1,N1
         SKIP1=K.NE.1
         SKIP2=K.NE.N1
         IF(F(K).GE.FMIN) GO TO 30
         XMIN=X(K)
         FMIN=F(K)
         DFMIN=DF(K)
   30    DX=X(K+1)-X(K)
C
C     SKIP INTERVAL IF PNTS ARE TOO CLOSE TOGETHER
C
         IF(DX.LE.CLOSE) GO TO 110
         X1=0.0
         IF(K.EQ.1) X1=XSTART-X(1)
         X2=DX
         IF(K.EQ.N1) X2=XSTOP-X(N1)
C
C     (A,B,C)=COEF OF (CUBIC,QUADRATIC,LINEAR) TERMS
C
         DUM=(F(K+1)-F(K))/DX
         A=(DF(K)+DF(K+1)-DUM-DUM)/(DX*DX)
         B=(DUM+DUM+DUM-DF(K)-DF(K)-DF(K+1))/DX
         C=DF(K)
C
C     XK = X-X(K) AT THE MINIMUM WITHIN THE KTH SUBINTERVAL
C     TEST FOR PATHOLOGICAL CASES.
C
         BB=B*B
         AC3=(A+A+A)*C
         IF(BB.LT.AC3) GO TO 90
         IF( B.GT.0.0) GO TO 40
         IF(ABS(B).GT.HUGE*ABS(A)) GO TO 90
         GO TO 50
   40    IF(BB.GT.BIG*ABS(AC3)) GO TO 60
C
C     WELL BEHAVED CUBIC
C
   50    XK=(-B+SQRT(BB-AC3))/(A+A+A)
         GO TO 70
C
C     CUBIC IS DOMINATED BY QUADRATIC TERM
C
   60    R=AC3/BB
         XK=-(((0.039063*R+0.0625)*R+0.125)*R+0.5)*C/B
   70    IF(XK.LT.X1.OR.XK.GT.X2) GO TO 90
   80    FM=((A*XK+B)*XK+C)*XK+F(K)
         IF(FM.GT.FMIN) GO TO 90
         XMIN=XK+X(K)
         FMIN=FM
         DFMIN=((A+A+A)*XK+B+B)*XK+C
C
C     EXTRAPOLATE TO END OF INTERVAL IF K=1 AND/OR K=N1
C
   90    IF(SKIP1) GO TO 100
         SKIP1=.TRUE.
         XK=X1
         GO TO 80
  100    IF(SKIP2) GO TO 110
         SKIP2=.TRUE.
         XK=X2
         GO TO 80
  110 CONTINUE
      RETURN
      END

C=========================================================================
C     SETUP CONSTRAINTS WHICH ARE SUPPOSED TO BE LINEAR WITH
C     RESPECT TO COORDINATES. THEN INSTEAD OF THE PHYSICAL COORDINATES
C     Ri,i=1,3*N, WE INTRODUCE A SET OF AUXILIARY COORDINATES, 
C     Pi,i=1,M, M < 3*N. SUBROUTINE CONSTR SETS UP THE MATRIX OF
C     DERIVATIVES RCONSTR(i,j)=dRi/dPj.     
C
C     NCNSTR - NUMBER OF CONSTRAINTS 
C     NEWCOO = M = 3 * N - NCNSTR
C            __
C      dRi = >  RCNSTR(i,j) * dPj ,  i=1,3*NIONST
C            --
C          j=1,M
C
C     THIS RELATION IS WRITTEN IN CARTESIAN COORDINATES FOR 
C     DISPLACEMENTS (dR and dP).
C     FOR ARBITRARY BASIS VECTORS THE SYMMETRY WE ARE LOOKING FOR 
C     WILL BE BETTER SEEN IN THE CARTESIANS THAN IN UNITS OF 
C     BASIS VECTORS.
C=========================================================================
C
      SUBROUTINE CONSTR(NSPEC,NIONS,NIONST,RCNSTR,DIRC,POSIC,
     &                  RMOVE,NCNSTR,NEWCOO,WORK)
C
      IMPLICIT COMPLEX (C)
      DIMENSION RCNSTR(3*NSPEC*NIONS,3*NSPEC*NIONS)
      DIMENSION DIRC(3,3)
      DIMENSION POSIC(3,NSPEC*NIONS)
      DIMENSION WORK(3,*)
      DIMENSION RMOVE(NSPEC*NIONS)
C
      NDIM = 3 * NSPEC * NIONS
      NCOO = 3 * NIONST
C
C=========================================================================
C  EXAMPLE - NO CONSTRAINT WHATSOEVER (EVEN RMOVE)
C=========================================================================
C
C      NEWCOO = NCOO
C      NCNSTR = 0
C      DO 100 I = 1 , NDIM
C        DO 101 J = 1 , NDIM
C          RCNSTR(I,J) = 0.0
C 101    CONTINUE
C 100  CONTINUE
C      DO 102 I = 1 , NCOO
C        RCNSTR(I,I) = 1.0
C 102  CONTINUE
C
C=========================================================================
C  EXAMPLE - CONSTRAINT ONLY IN RMOVE
C=========================================================================
C
      DO 200 I = 1 , NDIM
        DO 201 J = 1 , NDIM
          RCNSTR(I,J) = 0.0
 201    CONTINUE
 200  CONTINUE
C
      NCNSTR = 0 
      NINDP = 1
      DO 204 NI = 1 , NIONST
        IF (RMOVE(NI).NE.0.0) THEN
          DO 202 K =  1 , 3      
            RCNSTR(K+3*(NI-1),NINDP) = 1.0
            NINDP = NINDP + 1
 202      CONTINUE
        ELSE
          NCNSTR = NCNSTR + 3
        END IF
 204  CONTINUE
      NEWCOO = NCOO - NCNSTR
      WRITE (*,*) ' CONSTR in action'
      WRITE (*,1000) NCOO,NEWCOO,NCNSTR,NIONST
      DO 210 J = 1 , NDIM
        DO 211 I = 1 , NDIM
          IF (RCNSTR(I,J).NE.0.0) WRITE (*,1001) I,J,RCNSTR(I,J)
 211    CONTINUE
 210  CONTINUE
 1000 FORMAT(' Old coord:   ',I3,' New coord: ',I3/
     1       ' Constraints: ',I3,' Ions     : ',I3/
     2       '   CONSTRAINTS MATRIX (Rij)')
 1001 FORMAT(1X,'RCNSTR(',I3,',',I3,')=',F6.2)
 1002 FORMAT(' DCNSTR(',I3,')=',3F12.5)
      RETURN 
      END

      SUBROUTINE PARSAV(MODE,N,M)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
**********************************************************************
*
*   PARSAV SAVES AND RESTORES DATA USED IN NLLSQ GRADIENT MINIMIZATION.
*
*    IF MODE IS 0 DATA ARE RESTORED, IF 1 THEN SAVED.
*
**********************************************************************
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
      COMMON /ALPARM/ ALPARM(3,MAXPAR),X0, X1, X2, ILOOP
      COMMON /ELEMTS/ ELEMNT(107)
      COMMON /KEYWRD/ KEYWRD
      COMMON /GEOSYM/ NDEP,LOCPAR(MAXPAR),IDEPFN(MAXPAR),
     1                     LOCDEP(MAXPAR)
      COMMON /TITLES/ KOMENT,TITLE
      COMMON /GEOKST/ NATOMS,LABELS(NUMATM),
     1                NA(NUMATM),NB(NUMATM),NC(NUMATM)
      COMMON /GEOM  / GEO(3,NUMATM)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /NLLCOM/ DDDUM(6),EFSLST(MAXPAR),Q(MAXPAR,MAXPAR),
     1                R(MAXPAR,MAXPAR),XLAST(MAXPAR),
     2                IIIUM(7),IDUMY(2*MAXPAR*MAXPAR-19-MAXPAR*4)
      COMMON /GEOVAR/ NVAR,LOC(2,MAXPAR), JDUMY, DUMY(MAXPAR)
      COMMON /LOCVAR/ LOCVAR(2,MAXPAR)
      COMMON /VALVAR/ VALVAR(MAXPAR),NUMVAR
      DIMENSION IEL1(3),QQ(3), COORD(3,NUMATM)
      CHARACTER ELEMNT*2, KEYWRD*80,KOMENT*80, TITLE*80
      LATOM=0
      LPARAM=0
CDEP
      OPEN(UNIT=9,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=9,FILE='FOR009',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 9
      OPEN(UNIT=10,STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      OPEN(UNIT=10,FILE='FOR010',STATUS='UNKNOWN',FORM='UNFORMATTED')
C-old      REWIND 10
      IF(MODE.NE.0) GOTO 10
*
*  MODE=0: RETRIEVE DATA FROM DISK.
*
      READ(9,END=70,ERR=70)IIIUM,DDDUM,EFSLST,N,(XLAST(I),I=1,N),M
      READ(9)((Q(J,I),J=1,M),I=1,M)
      READ(9)((R(J,I),J=1,N),I=1,N)
      READ(9)(VALVAR(I),I=1,N)
      RETURN
   10 CONTINUE
      IF(MODE.EQ.1)THEN
         WRITE(6,'(//10X,'' **** TIME UP ****'')')
         WRITE(6,'(//10X,'' CURRENT VALUES OF GEOMETRIC VARIABLES'',//)'
     1)
         IF(NA(1) .EQ. 99) THEN
C
C  CONVERT FROM CARTESIAN COORDINATES TO INTERNAL
C
            DO 20 I=1,NATOMS
               DO 20 J=1,3
   20       COORD(J,I)=GEO(J,I)
            CALL XYZINT(COORD,NUMAT,NA,NB,NC,1.D0,GEO)
         ENDIF
         DEGREE=57.29577951D0
         GEO(2,1)=0.D0
         GEO(3,1)=0.D0
         GEO(1,1)=0.D0
         GEO(2,2)=0.D0
         GEO(3,2)=0.D0
         GEO(3,3)=0.D0
         IVAR=1
         NA(1)=0
         WRITE(6,'(A)')KEYWRD,KOMENT,TITLE
         DO 50 I=1,NATOMS
            DO 30 J=1,3
   30       IEL1(J)=0
   40       CONTINUE
            IF(LOC(1,IVAR).EQ.I) THEN
               IEL1(LOC(2,IVAR))=1
               IVAR=IVAR+1
               GOTO 40
            ENDIF
            IF(I.LT.4) THEN
               IEL1(3)=0
               IF(I.LT.3) THEN
                  IEL1(2)=0
                  IF(I.LT.2) THEN
                     IEL1(1)=0
                  ENDIF
               ENDIF
            ENDIF
            QQ(1)=GEO(1,I)
            QQ(2)=GEO(2,I)*DEGREE
            QQ(3)=GEO(3,I)*DEGREE
   50    WRITE(6,'(2X,A2,3(F12.6,I3),I4,2I3)')
     1    ELEMNT(LABELS(I)),(QQ(K),IEL1(K),K=1,3),NA(I),NB(I),NC(I)
         I=0
         X=0.D0
         WRITE(6,'(I4,3(F12.6,I3),I4,2I3)')
     1    I,X,I,X,I,X,I,I,I,I
         IF(NDEP.NE.0)THEN
            DO 60 I=1,NDEP
   60       WRITE(6,'(3(I4,'',''))')LOCPAR(I),IDEPFN(I),LOCDEP(I)
            WRITE(6,*)
         ENDIF
         WRITE(6,'(//10X,
     1''TO RESTART CALCULATION USE THE KEYWORD "RESTART".'')')
      ENDIF
      WRITE(9)IIIUM,DDDUM,EFSLST,N,(XLAST(I),I=1,N),M
      WRITE(9)((Q(J,I),J=1,M),I=1,M)
      WRITE(9)((R(J,I),J=1,N),I=1,N)
      WRITE(9)(VALVAR(I),I=1,N)
C*****
C     The density matrix is required by ITER upon restart .
C
      LINEAR=(NORBS*(NORBS+1))/2
      WRITE(10)(PA(I),I=1,LINEAR)
      IF(NALPHA.NE.0)WRITE(10)(PB(I),I=1,LINEAR)
C*****
      CLOSE(9)
      CLOSE(10)
      RETURN
   70 WRITE(6,'(//10X,''NO RESTART FILE EXISTS!'')')
      CALL WRAPUP()
      END

      SUBROUTINE RHSX(JDIM,KDIM,Q,S,PRESS,XY,XYJ,XIT,FLUX)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION Q(JDIM,KDIM,4),PRESS(JDIM,KDIM),S(JDIM,KDIM,4)
      DIMENSION XY(JDIM,KDIM,4),XYJ(JDIM,KDIM),XIT(JDIM,KDIM)
      DIMENSION FLUX(JDIM,KDIM,4)
C
C      CENTRAL DIFFERENCING USED IN XI
C     COMPUTE FLUX VECTORS 
C
      DO 200 K=KLOW,KUP
      DO 200 J=JBEGIN,JEND
         R1 = XY(J,K,1)
         R2 = XY(J,K,2)
         R0 = XIT(J,K)
C       RR IS J/RHO
         RR = 1./Q(J,K,1)
         U = Q(J,K,2)*RR
         V = Q(J,K,3)*RR
C
C      R1, R2 ARE EITHER D XI /DX, D ETA/DX, OR D XI /DY, D ETA/DY
C      QS IS EITHER CAP-U OR CAP-V ( CONTRAVARIANT VELOCITIES )
C
         QS = R0 +R1*U + R2*V
C
C      PRESSJ IS PRESSURE / J
C
         PRESSJ= PRESS(J,K)
C
         FLUX(J,K,1)= Q(J,K,1)*QS
         FLUX(J,K,2)= Q(J,K,2)*QS + R1*PRESSJ
         FLUX(J,K,3)= Q(J,K,3)*QS + R2*PRESSJ
         FLUX(J,K,4) = QS*( Q(J,K,4) + PRESSJ) - PRESSJ*R0
C
200   CONTINUE
C
C
      RT0 = - .5*DT / (1. + PHIDT)
      DO 400 N=1,4
      DO 400 J=JLOW,JUP
         JP1 = JPLUS(J)
         JM1 = JMINU (J)
         DO 400 K = KLOW,KUP
            S(J,K,N) = S(J,K,N) + 
     *          RT0*( FLUX(JP1,K,N) - FLUX(JM1,K,N))
400   CONTINUE
C
C
      RETURN
      END

      SUBROUTINE LENTST (LREQ,LDIM,DIMENS,MODULE)
      INTEGER LREQ, LDIM
      CHARACTER*(*) DIMENS, MODULE
      IF (LREQ.GT.LDIM) THEN
         WRITE(6,100) MODULE
         WRITE(6,110) DIMENS, LDIM, LREQ
         WRITE(6,120)
         STOP
      ENDIF
 100  FORMAT(1X,'*** Insufficient space allocation in --',A6,'--')
 110  FORMAT(1X,'   ',A6,'=',I7,'  It should be at least ',I7)
 120  FORMAT(1X,'    Cannot continue ... Bye!')
      END

C     ****************
      SUBROUTINE SRLKS(
C     ****************
     >                 LINKS,NVE,
     >                 G,N,ISD,IRD,
     >                 L,WK1,
     >                 ICC,ILD )
C
C
      DOUBLE PRECISION LINKS(NVE,18,4),
     >                 WK1  (N  ,18  )
C
C
      INTEGER   G(N,2,4),L(2,4)
C
C
      ISN = ISD
      IF( IRD .EQ. 3 ) IRN = 2
      IF( IRD .EQ. 4 ) IRN = 1
      NS = L(ICC,ISD)
      NR = L(ICC,IRD)
C
C
C     ***********
      CALL GATHER( N,NS,WK1,NVE,LINKS(1,1,ILD),G(1,ICC,ISD),0 )
C     ***********
C
C     ***********
      CALL SCATER( NVE,NR,LINKS(1,1,ILD),N,WK1,G(1,ICC,IRD),0 )
C     ***********
C
      END

      SUBROUTINE RELAXA(U,F,NX,NY,NZ,H)
C
C     3D RED BLACK RELAXATION    STANDARD IMLEMENTATION
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DOUBLE PRECISION U(NX,NY,NZ),F(NX,NY,NZ)
      H2 = H*H
      FACTOR = 1.0D0/6.0D0
C
C     RELAXATION OF THE RED POINTS
C
      IA = 0
      DO 10 K = 2, NZ-1
        DO 20 J = 2, NY-1
          DO 30 I = 2 + IA, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
30        CONTINUE
        IA = MOD (IA+1,2)
20      CONTINUE
10    CONTINUE
C
C     RELAXATION OF THE BLACK POINTS
C
      IA = 1
      DO 11 K = 2, NZ-1
        DO 21 J = 2, NY-1
          DO 31 I = 2 + IA, NX-1, 2
            U(I,J,K) = FACTOR*(H2*F(I,J,K) +
     *                    (U(I-1,J,K) + U(I+1,J,K) +
     *                     U(I,J-1,K) + U(I,J+1,K) +
     *                     U(I,J,K-1) + U(I,J,K+1)))
31        CONTINUE
        IA = MOD (IA+1,2)
21      CONTINUE
11    CONTINUE
      END

      SUBROUTINE FINDMX(H,NDIM,XRESP,FREQ,IDOF)
CDEP  
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION H(NDIM,NDIM),XRESP(NDIM)
C-old:DEP  --- NOTE: ALL COMPLEX*16 MEANS A 64-BIT REAL AND IMAGINARY PART
C-old      COMPLEX*16 H,XRESP
      COMPLEX H,XRESP
CDEP  
C-old      RLEN(X,Y)=DSQRT(X**2+Y**2)
      RLEN(X,Y)=SQRT(X*X+Y*Y)
C     
      DO 100 I=1,NDIM
         XRESP(I)=(0.,0.)
 100  CONTINUE
C     
      DO 210 J=1,NDIM
         DO 200 I=1,NDIM
            XRESP(I)=XRESP(I)+H(I,J)
 200     CONTINUE
 210  CONTINUE
C     
      IDOF=0
      RMAGN=0.
      OMEGA2=(6.283185307*FREQ)**2
      DO 300 I=1,NDIM
         XRESP(I)=XRESP(I)*OMEGA2
         RREAL=REAL(XRESP(I))
C-old         RIMAG=DIMAG(XRESP(I))
         RIMAG=AIMAG(XRESP(I))
         T=RLEN(RREAL,RIMAG)
         IF (T.GT.RMAGN) THEN
            RMAGN=T
            IDOF=I
         ENDIF
 300  CONTINUE
      END

      SUBROUTINE READI(FII,FREQR,XSIIR,NDIM,NMODES)
CDEP  
      IMPLICIT REAL (A-H,O-Z)
      DIMENSION FII(NDIM,NMODES),FREQR(NMODES),XSIIR(NMODES)
C     
 1000 FORMAT(5X,'MODE: ',I3,' FREQUENCY=',1P,G13.5,' DAMPING=',G13.5)
C     
      DO 200 I=1,NMODES
         READ(1,*) K,FREQ,XSII
         WRITE(6,1000) K,FREQ,XSII
         FREQR(K)=FREQ
         XSIIR(K)=XSII
         READ(1,'((6F13.0))') (FII(J,K),J=1,NDIM)
 200  CONTINUE
      END   

      SUBROUTINE GAUSQ4 (WG,XI,ETA,NQP)
      DOUBLE PRECISION WG(*), XI(*), ETA(*)
      INTEGER NQP
      DOUBLE PRECISION SQ
      PARAMETER (SQ = 0.5773502691896256D0)
      NQP = 4
      WG(1) = 1.D0
      WG(2) = 1.D0
      WG(3) = 1.D0
      WG(4) = 1.D0
      XI(1)  = SQ
      ETA(1) = SQ
      XI(2)  = -SQ
      ETA(2) = SQ
      XI(3)  = -SQ
      ETA(3) = -SQ
      XI(4)  = SQ
      ETA(4) = -SQ
      RETURN
      END

      FUNCTION AABABC(IOCCA1, IOCCB1, IOCCA2, IOCCB2, NMOS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION IOCCA1(NMOS), IOCCB1(NMOS), IOCCA2(NMOS), IOCCB2(NMOS)
***********************************************************************
*
* AABABC EVALUATES THE C.I. MATRIX ELEMENT FOR TWO MICROSTATES DIFFERING
*       BY BETA ELECTRON. THAT IS, ONE MICROSTATE HAS A BETA ELECTRON
*       IN PSI(I) WHICH, IN THE OTHER MICROSTATE IS IN PSI(J)
*
***********************************************************************
      COMMON /XYIJKL/ XY(NMECI,NMECI,NMECI,NMECI)
      COMMON /BASEOC/ OCCA(NMECI)
      DO 10 I=1,NMOS
   10 IF(IOCCA1(I).NE.IOCCA2(I)) GOTO 20
   20 IJ=IOCCB1(I)
      DO 30 J=I+1,NMOS
         IF(IOCCA1(J).NE.IOCCA2(J)) GOTO 40
   30 IJ=IJ+IOCCA1(J)+IOCCB1(J)
   40 SUM=0.D0
      DO 50 K=1,NMOS
   50 SUM=SUM+ (XY(I,J,K,K)-XY(I,K,J,K))*(IOCCA1(K)-OCCA(K)) +
     1          XY(I,J,K,K)             *(IOCCB1(K)-OCCA(K))
      AABABC=SUM*((-1)**(IJ-(IJ/2)*2))
      RETURN
      END

      SUBROUTINE TRANSP(A,N,AT)
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),AT(N,N)
      N1=N-1
      DO 100 J=1,N1
         DO 110 I=J+1,N
            AT(J,I)=A(I,J)
 110     CONTINUE
 100  CONTINUE
      END       

      SUBROUTINE PCHECK(XP,YP,XN,YN,ZAXIS,XLEN,SHDOWN,SHUP,
     +     COORD,DIM,NNODX)
      INTEGER DIM,NNODX
      DOUBLE PRECISION XP,YP,XN,YN,ZAXIS,XLEN,SHDOWN(*),SHUP(*),
     +     COORD(DIM,*)

      INTEGER I,IND,IND0
      DOUBLE PRECISION EPS,YDOWNX,YUPX,INTSEC
      DOUBLE PRECISION INTSX,INTX
      PARAMETER(EPS=1.0D-12)
      IF (XP .LT. ZAXIS) THEN
         YP=INTSX(ZAXIS,XN,YN,XP,YP)
         XP=ZAXIS
      ENDIF

      IF (XP .GT. XLEN) THEN
         YP=INTSX(XLEN,XN,YN,XP,YP)
         XP=XLEN
      ENDIF

      IF ((YP .LT. SHDOWN(NNODX)) .OR. 
     +     (YP .GT. SHUP(NNODX))) THEN

         DO 10 I=1,NNODX-1
            IF ((XP .GT. COORD(1,I)-EPS) .AND. 
     +           (XP .LT. COORD(1,I+1)+EPS)) GOTO 20
 10      CONTINUE
 20      CONTINUE

         IF (YP .LT. SHDOWN(NNODX)) THEN
            YDOWNX=INTSX(XP,COORD(1,I),SHDOWN(I),
     +           COORD(1,I+1),SHDOWN(I+1))

            IF (YP .GT. YDOWNX) THEN
               GOTO 50
            ELSE
               IF (DABS(XP-XN) .LT. EPS) THEN
                  YP=YDOWNX
               ELSE
                  IND=1
                  IF (XN .LT. XP) THEN
                     IND0=-1
                  ELSE
                     IND0=1
                  ENDIF

 30               INTSEC=INTX(XN,YN,XP,YP,COORD(1,I+IND),
     +                 SHDOWN(I+IND),COORD(1,I+IND-1),SHDOWN(I+IND-1))

                  IF ((INTSEC .GT. COORD(1,I+IND-1)-EPS) .AND.
     +                 (INTSEC .LT. COORD(1,I+IND)+EPS)) THEN
                     YP=INTSX(INTSEC,XN,YN,XP,YP)
                     XP=INTSEC
                  ELSE
                     IND=IND+IND0
                     GOTO 30
                  ENDIF
               ENDIF
            ENDIF
         ENDIF

         IF (YP .GT. SHUP(NNODX)) THEN
            YUPX=INTSX(XP,COORD(1,I),SHUP(I),
     +           COORD(1,I+1),SHUP(I+1))

            IF (YUPX .GT. YP) THEN
               GOTO 50
            ELSE
               IF (DABS(XP-XN) .LT. EPS) THEN
                  YP=YUPX
               ELSE
                  IND=1
                  IF (XN .LT. XP) THEN
                     IND0=-1
                  ELSE
                     IND0=1
                  ENDIF

 40               INTSEC=INTX(XN,YN,XP,YP,COORD(1,I+IND-1),
     +                 SHUP(I+IND-1),COORD(1,I+IND),SHUP(I+IND))

                  IF ((INTSEC .GT. COORD(1,I+IND-1)-EPS) .AND.
     +                 (INTSEC .LT. COORD(1,I+IND)+EPS)) THEN
                     YP=INTSX(INTSEC,XN,YN,XP,YP)
                     XP=INTSEC
                  ELSE
                     IND=IND+IND0
                     GOTO 40
                  ENDIF
               ENDIF
            ENDIF
         ENDIF


      ENDIF
 50   CONTINUE

      RETURN
      END

      SUBROUTINE OSINV (A,N,D)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION A(*)
************************************************************************
*
*    OSINV INVERTS A GENERAL SQUARE MATRIX OF ORDER UP TO MAXORB. SEE
*          DIMENSION STATEMENTS BELOW.
*
*   ON INPUT       A = GENERAL SQUARE MATRIX STORED LINEARLY.
*                  N = DIMENSION OF MATRIX A.
*                  D = VARIABLE, NOT DEFINED ON INPUT.
*
*   ON OUTPUT      A = INVERSE OF ORIGINAL A.
*                  D = DETERMINANT OF ORIGINAL A, UNLESS A WAS SINGULAR,
*                      IN WHICH CASE D = 0.0
*
************************************************************************
      DIMENSION L(MAXORB), M(MAXORB)
************************************************************************
*
*    IF THE VALUE OF TOL GIVEN HERE IS UNSUITABLE, IT CAN BE CHANGED.
      TOL=1.D-8
*
*
************************************************************************
      D=1.0
      NK=-N
      DO 180 K=1,N
         NK=NK+N
         L(K)=K
         M(K)=K
         KK=NK+K
         BIGA=A(KK)
         DO 20 J=K,N
            IZ=N*(J-1)
            DO 20 I=K,N
               IJ=IZ+I
C
C     10 FOLLOWS
C
               IF (ABS(BIGA)-ABS(A(IJ))) 10,20,20
   10          BIGA=A(IJ)
               L(K)=I
               M(K)=J
   20    CONTINUE
         J=L(K)
         IF (J-K) 50,50,30
   30    KI=K-N
         DO 40 I=1,N
            KI=KI+N
            HOLO=-A(KI)
            JI=KI-K+J
            A(KI)=A(JI)
   40    A(JI)=HOLO
   50    I=M(K)
         IF (I-K) 80,80,60
   60    JP=N*(I-1)
         DO 70 J=1,N
            JK=NK+J
            JI=JP+J
            HOLO=-A(JK)
            A(JK)=A(JI)
   70    A(JI)=HOLO
   80    IF (ABS(BIGA)-TOL) 90,100,100
   90    D=0.0
         RETURN
  100    DO 120 I=1,N
            IF (I-K) 110,120,110
  110       IK=NK+I
            A(IK)=A(IK)/(-BIGA)
  120    CONTINUE
         DO 150 I=1,N
            IK=NK+I
            IJ=I-N
            DO 150 J=1,N
               IJ=IJ+N
               IF (I-K) 130,150,130
  130          IF (J-K) 140,150,140
  140          KJ=IJ-I+K
               A(IJ)=A(IK)*A(KJ)+A(IJ)
  150    CONTINUE
         KJ=K-N
         DO 170 J=1,N
            KJ=KJ+N
            IF (J-K) 160,170,160
  160       A(KJ)=A(KJ)/BIGA
  170    CONTINUE
         D=D*BIGA
         A(KK)=1.0/BIGA
  180 CONTINUE
      K=N
  190 K=K-1
      IF (K) 260,260,200
  200 I=L(K)
      IF (I-K) 230,230,210
  210 JQ=N*(K-1)
      JR=N*(I-1)
      DO 220 J=1,N
         JK=JQ+J
         HOLO=A(JK)
         JI=JR+J
         A(JK)=-A(JI)
  220 A(JI)=HOLO
  230 J=M(K)
      IF (J-K) 190,190,240
  240 KI=K-N
      DO 250 I=1,N
         KI=KI+N
         HOLO=A(KI)
         JI=KI+J-K
         A(KI)=-A(JI)
  250 A(JI)=HOLO
      GO TO 190
  260 RETURN
C
      END

      SUBROUTINE XYMETS(JDIM,KDIM,X,Y,XY,XIT,ETT,XYJ,WORK)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION XY(JDIM*KDIM*4),XYJ(JDIM*KDIM)
      DIMENSION XIT(JDIM*KDIM),ETT(JDIM*KDIM)
      DIMENSION X(JDIM*KDIM),Y(JDIM*KDIM)
      DIMENSION WORK(JDIM*KDIM*4)
C
C
C    COMPUTE XI DERIVATIVES OF X, Y
C
       CALL XIDIF(JDIM,KDIM,X,Y,XY)
C
C   COMPUTE  ETA DERIVATIVES OF X, Y
C
       CALL ETADIF(JDIM,KDIM,X,Y,XY)
C
C   FORM METRICS AND JACOBIAN
C
       CALL CALCME(JDIM,KDIM,XY,XIT,ETT,XYJ)
C  
      RETURN
      END

      SUBROUTINE SPECT(JDIM,KDIM,UU,VV,CCX,CCY,XYJ,XY,SPECTX,SPECTY)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C
C  FORM SPECTX AND SPECTY INDEPENDENTLY
C
C     SPECTX = (ABS(UU) + CCX)/XYJ
C     SPECTY = (ABS(VV) + CCY)/XYJ
C
      COMMON/BASE/
     1  JMAX,       KMAX,     JM,          KM,          JBEGIN,   JEND,
     1  KBEGIN,     KEND,     JPLUS(999),  JMINU (999), JLOW,     JUP,
     1  KLOW,       KUP,      PERIDC  ,    NP,          DT,   CP2TIM,
     1  FSMACH,     ALPHA,    GAMMA,       GAMI,        PI,
     1  DIS2X,      DIS2Y,    DIS4X,       DIS4Y,       PHIDT,    
     1  THETAD ,    RESID,    JACDT,       IPRINT,      NPCP,
     1  JTAIL1,     JTAIL2,   NUMITE ,     ISTART,      NSTEPS
      LOGICAL PERIDC  
      COMMON/GRID/DYM,YMAX,XMIN,XMAX,THICK
C
      DIMENSION XYJ(JDIM,KDIM),XY(JDIM,KDIM,4)
      DIMENSION SPECTX(JDIM,KDIM),UU(JDIM,KDIM),CCX(JDIM,KDIM)
      DIMENSION SPECTY(JDIM,KDIM),VV(JDIM,KDIM),CCY(JDIM,KDIM)
C
C   COMPUTE DISSIPATION SCALING
C
C
C  SPECTRAL RADIUS
C
           DO 100 K=KBEGIN,KEND
           DO 100 J=JBEGIN,JEND
C
           SIGX = ABS(UU(J,K)) + CCX(J,K)
           SIGY = ABS(VV(J,K)) + CCY(J,K)
C
           RJ = 1./XYJ(J,K)
           SPECTX(J,K) = SIGX*RJ
           SPECTY(J,K) = SIGY*RJ
C
100        CONTINUE
C
                RETURN
                END

      SUBROUTINE DECOM3(IOPT,A,B,N)
C     
C     IOPT=0 => DO DECOMPOSITION AND FORWARD-BACKWARD SUBSTITUTION
C     1 => DO ONLY DECOMPOSITION
C     2 => DO ONLY FBS
C     
C     A PROGRAM TO PERFORM LU-DECOMPOSITION OF SYMMETRIC POSITIVE DEFINITE
C     MATRIX
C     
CDEP  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(N,N),B(N)
C     
C..    PERFORM DECOMPOSITION A TO L*U IN EQUATION: A*X=B <=> L*U*X=B
C     
 100  CONTINUE
      IF (IOPT.EQ.2) GOTO 200
      DO 1 K=1,N-1
         RECIP=1/A(K,K)
         DO 11 I=K+1,N
            T=A(I,K)*RECIP
            DO 111 J=I,N
               A(J,I)=A(J,I)-T*A(J,K)
 111        CONTINUE
 11      CONTINUE
 1    CONTINUE
 200  CONTINUE
C     
      IF (IOPT.EQ.1) RETURN
C     
C..    SOLVE: L*Y=B
C     
      DO 22 I=2,N
         T=B(I)
         DO 2 K=1,I-1
            T=T-A(I,K)*B(K)/A(K,K)
 2       CONTINUE
         B(I)=T
 22   CONTINUE
      B(N)=B(N)/A(N,N)
C     
C..    SOLVE: U*X=Y
C     
      DO 4 I=N-1,1,-1
         T=B(I)
         DO 3 K=I+1,N
            T=T-A(K,I)*B(K)
 3       CONTINUE
         B(I)=T/A(I,I)
 4    CONTINUE
C..   END  
      RETURN
      END   

      SUBROUTINE CNVG(PNEW, P, P1,NORBS, NITER, PL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P1(*), P(*), PNEW(*)
      LOGICAL EXTRAP, FIRST
C***********************************************************************
C
C  CNVG IS A TWO-POINT INTERPOLATION ROUTINE FOR SPEEDING CONVERGENCE
C       OF THE DENSITY MATRIX.
C
C ON OUTPUT P      = NEW DENSITY MATRIX
C           P1     = DIAGONAL OF OLD DENSITY MATRIX
C           PL     = LARGEST DIFFERENCE BETWEEN OLD AND NEW DENSITY
C                    MATRIX DIAGONAL ELEMENTS
C***********************************************************************
      COMMON/KEYWRD/ KEYWRD
      CHARACTER*80 KEYWRD
      DATA FIRST/.TRUE./
      IF(FIRST) THEN
         FIRST=.FALSE.
         IF(INDEX(KEYWRD,'UHF').NE.0)THEN
            RHFUHF=1.D0
         ELSE
            RHFUHF=2.D0
         ENDIF
      ENDIF
      PL=0.0D00
      FACA=0.0D00
      DAMP=1.D10
      IF(NITER.GT.3)DAMP=0.05D0
      FACB=0.0D00
      FAC=0.0D00
      II=MOD(NITER,3)
      EXTRAP=II.NE.0
      SUM1=0.D0
      K=0
      DO 20 I=1,NORBS
         K=K+I
         A=PNEW(K)
         SUM1=SUM1+A
         SA=ABS(A-P(K))
         IF (SA.GT.PL) PL=SA
         IF (EXTRAP) GO TO 10
         FACA=FACA+SA**2
         FACB=FACB+(A-2.D00*P(K)+P1(I))**2
   10    P1(I)=P(K)
   20 P(K)=A
      IF (FACB.LE.0.0D00) GO TO 30
      IF (FACA.LT.(100.D00*FACB)) FAC=SQRT(FACA/FACB)
   30 IE=0
      SUM2=0.D0
      DO 50 I=1,NORBS
         II=I-1
         DO 40 J=1,II
            IE=IE+1
            A=PNEW(IE)
            P(IE)=A+FAC*(A-P(IE))
            PNEW(IE)=P(IE)
   40    CONTINUE
         IE=IE+1
         IF(ABS(P(IE)-P1(I)) .GT. DAMP) THEN
            P(IE)=P1(I)+SIGN(DAMP,P(IE)-P1(I))
         ELSE
            P(IE)=P(IE)+FAC*(P(IE)-P1(I))
         ENDIF
         P(IE)=MIN(RHFUHF,MAX(P(IE),0.D0))
         SUM2=SUM2+P(IE)
   50 PNEW(IE)=P(IE)
C
C   RE-NORMALIZE IF ANY DENSITY MATRIX ELEMENTS HAVE BEEN TRUNCATED
C
      SUM0=SUM1
   60 SUM=SUM1/SUM2
      SUM1=SUM0
      IF(ABS(SUM-1.D0).GT.1.D-5)THEN
C#      WRITE(6,'(6F12.6)')(P((I*(I+1))/2),I=1,NORBS)
         SUM2=0.D0
         DO 70 I=1,NORBS
            J=(I*(I+1))/2
C
C   ADD ON A SMALL NUMBER IN CASE AN OCCUPANCY IS EXACTLY ZERO
C
            P(J)=P(J)*SUM+1.D-20
            P(J)=MAX(P(J),0.D0)
C
C  SET UP RENORMALIZATION OVER PARTLY OCCUPIED M.O.'S ONLY.  FULL M.O.'S
C  CAN'T BE FILLED ANY MORE
C
            IF(P(J).GT.RHFUHF)THEN
               P(J)=RHFUHF
               SUM1=SUM1-RHFUHF
            ELSE
               SUM2=SUM2+P(J)
            ENDIF
   70    PNEW(J)=P(J)
         GOTO 60
      ENDIF
      RETURN
      END

      SUBROUTINE Y12MAF(N, Z, A, SNR, NN, RNR, NN1, PIVOT, HA,
     1IHA,AFLAG,IFLAG,B,IFAIL)
      IMPLICIT DOUBLE PRECISION (A-B,G,P,T-Y), INTEGER (C,F,H-N,R-S,Z)
      DOUBLE PRECISION A(NN), PIVOT(N), AFLAG(8),B(N)
      INTEGER SNR(NN), RNR(NN1), HA(IHA,11), IFLAG(10)
      AFLAG(1)=16.0D0
      AFLAG(2)=1.D-12
      AFLAG(3)=1.D+16
      AFLAG(4)=1.D-12
      IFLAG(2)=2
      IFLAG(3)=1
      IFLAG(4)=0
      IFLAG(5)=1
      CALL Y12MBF(N,Z,A,SNR,NN,RNR,NN1,HA,IHA,AFLAG,IFLAG,IFAIL)
      IF(IFAIL.NE.0)GO TO 1
      CALL Y12MCF(N,Z,A,SNR,NN,RNR,NN1,PIVOT,B,HA,IHA,AFLAG,IFLAG,
     1 IFAIL)
      IF(IFAIL.NE.0)GO TO 1
      CALL Y12MDF(N,A,NN,B,PIVOT,SNR,HA,IHA,IFLAG,IFAIL)
1     RETURN
      END

      SUBROUTINE PULAY(F,P,N,FPPF,FOCK,EMAT,LFOCK,NFOCK,MSIZE,START,PL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION F(*), P(*), FPPF(*), FOCK(*)
      LOGICAL START
************************************************************************
*
*   PULAY USES DR. PETER PULAY'S METHOD FOR CONVERGENCE.
*         A MATHEMATICAL DESCRIPTION CAN BE FOUND IN
*         "P. PULAY, J. COMP. CHEM. 3, 556 (1982).
*
* ARGUMENTS:-
*         ON INPUT F      = FOCK MATRIX, PACKED, LOWER HALF TRIANGLE.
*                  P      = DENSITY MATRIX, PACKED, LOWER HALF TRIANGLE.
*                  N      = NUMBER OF ORBITALS.
*                  FPPF   = WORKSTORE OF SIZE MSIZE, CONTENTS WILL BE
*                           OVERWRITTEN.
*                  FOCK   =      "       "              "         "
*                  EMAT   = WORKSTORE OF AT LEAST 15**2 ELEMENTS.
*                  START  = LOGICAL, = TRUE TO START PULAY.
*                  PL     = UNDEFINED ELEMENT.
*      ON OUTPUT   F      = "BEST" FOCK MATRIX, = LINEAR COMBINATION
*                           OF KNOWN FOCK MATRICES.
*                  START  = FALSE
*                  PL     = MEASURE OF NON-SELF-CONSISTENCY
*                         = [F*P] = F*P - P*F.
*
************************************************************************
      COMMON /KEYWRD/ KEYWRD
      DIMENSION EMAT(20,20), EVEC(1000), COEFFS(20)
      CHARACTER*80 KEYWRD
      LOGICAL FIRST, DEBUG
      DATA FIRST/.TRUE./
      IF(FIRST) THEN
         FIRST=.FALSE.
         MAXLIM=6
         DEBUG=(INDEX(KEYWRD,'DEBUGPULAY') .NE.0)
      ENDIF
      IF(START) THEN
         LINEAR=(N*(N+1))/2
         MFOCK=MSIZE/LINEAR
         IF(MFOCK.GT.MAXLIM)MFOCK=MAXLIM
         IF(DEBUG)
     1    WRITE(6,'('' MAXIMUM SIZE:'',I5)')MFOCK
         NFOCK=1
         LFOCK=1
         START=.FALSE.
      ELSE
         IF(NFOCK.LT.MFOCK)      NFOCK=NFOCK+1
         IF(LFOCK.NE.MFOCK)THEN
            LFOCK=LFOCK+1
         ELSE
            LFOCK=1
         ENDIF
      ENDIF
      LBASE=(LFOCK-1)*LINEAR
*
*   FIRST, STORE FOCK MATRIX FOR FUTURE REFERENCE.
*
      DO 10 I=1,LINEAR
   10 FOCK((I-1)*MFOCK+LFOCK)=F(I)
*
*   NOW FORM /FOCK*DENSITY-DENSITY*FOCK/, AND STORE THIS IN FPPF
*
      CALL MAMULT(P,F,FPPF(LBASE+1),N,0.D0)
      CALL MAMULT(F,P,FPPF(LBASE+1),N,-1.D0)
*
*   FPPF NOW CONTAINS THE RESULT OF FP - PF.
*
      NFOCK1=NFOCK+1
      DO 20 I=1,NFOCK
         EMAT(NFOCK1,I)=-1.D0
         EMAT(I,NFOCK1)=-1.D0
         EMAT(LFOCK,I)=DOT(FPPF((I-1)*LINEAR+1),FPPF(LBASE+1),LINEAR)
   20 EMAT(I,LFOCK)=EMAT(LFOCK,I)
      PL=EMAT(LFOCK,LFOCK)/LINEAR
      EMAT(NFOCK1,NFOCK1)=0.D0
      CONST=1.D0/EMAT(LFOCK,LFOCK)
      DO 30 I=1,NFOCK
         DO 30 J=1,NFOCK
   30 EMAT(I,J)=EMAT(I,J)*CONST
      IF(DEBUG) THEN
         WRITE(6,'('' EMAT'')')
         DO 40 I=1,NFOCK1
   40    WRITE(6,'(6E13.6)')(EMAT(J,I),J=1,NFOCK1)
      ENDIF
      L=0
      DO 50 I=1,NFOCK1
         DO 50 J=1,NFOCK1
            L=L+1
   50 EVEC(L)=EMAT(I,J)
      CONST=1.D0/CONST
      DO 60 I=1,NFOCK
         DO 60 J=1,NFOCK
   60 EMAT(I,J)=EMAT(I,J)*CONST
*********************************************************************
*   THE MATRIX EMAT SHOULD HAVE FORM
*
*      |<E(1)*E(1)>  <E(1)*E(2)> ...   -1.0|
*      |<E(2)*E(1)>  <E(2)*E(2)> ...   -1.0|
*      |<E(3)*E(1)>  <E(3)*E(2)> ...   -1.0|
*      |<E(4)*E(1)>  <E(4)*E(2)> ...   -1.0|
*      |     .            .      ...     . |
*      |   -1.0         -1.0     ...    0. |
*
*   WHERE <E(I)*E(J)> IS THE SCALAR PRODUCT OF [F*P] FOR ITERATION I
*   TIMES [F*P] FOR ITERATION J.
*
*********************************************************************
      CALL OSINV(EVEC,NFOCK1,D)
      IF(ABS(D).LT.1.D-6)THEN
         START=.TRUE.
         RETURN
      ENDIF
      IF(NFOCK.LT.2) RETURN
      IL=NFOCK*NFOCK1
      DO 70 I=1,NFOCK
   70 COEFFS(I)=-EVEC(I+IL)
      IF(DEBUG) THEN
         WRITE(6,'('' EVEC'')')
         WRITE(6,'(6F12.6)')(COEFFS(I),I=1,NFOCK)
         WRITE(6,'(''    LAGRANGIAN MULTIPLIER (ERROR) =''
     1             ,F13.6)')EVEC(NFOCK1*NFOCK1)
      ENDIF
      DO 90 I=1,LINEAR
         SUM=0
         L=0
         II=(I-1)*MFOCK
         DO 80 J=1,NFOCK
   80    SUM=SUM+COEFFS(J)*FOCK(J+II)
   90 F(I)=SUM
      RETURN
      END

      SUBROUTINE DCART (COORD,DXYZ)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION COORD(3,*), DXYZ(3,*)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
      COMMON /DENSTY/ P(MPACK), PA(MPACK), PB(MPACK)
C***********************************************************************
C
C    DCART CALCULATES THE DERIVATIVES OF THE ENERGY WITH RESPECT TO THE
C          CARTESIAN COORDINATES. THIS IS DONE BY FINITE DIFFERENCES.
C
C    THE MAIN ARRAYS IN DCART ARE:
C        DXYZ   ON EXIT CONTAINS THE CARTESIAN DERIVATIVES.
C
C***********************************************************************
      COMMON /KEYWRD/ KEYWRD
      COMMON /EULER / TVEC(3,3), ID
      COMMON /MOLMEC/ HTYPE(4),NHCO(4,20),NNHCO,ITYPE,USEMM
      COMMON /UCELL / L1L,L2L,L3L,L1U,L2U,L3U
      COMMON /DCARTC/ K1L,K2L,K3L,K1U,K2U,K3U
      CHARACTER*80 KEYWRD
      DIMENSION PDI(171),PADI(171),PBDI(171),
     1CDI(3,2),NDI(2),LSTOR1(6), LSTOR2(6), ENG(3)
      LOGICAL DEBUG, FIRST, FORCE, MAKEP, ANADER, USEMM
      EQUIVALENCE (LSTOR1(1),L1L), (LSTOR2(1), K1L)
      DATA CHNGE,CHNGE2 /1.D-4,5.D-5/
*
* CHNGE IS A MACHINE-PRECISION DEPENDENT CONSTANT
* CHNGE2=CHNGE/2
*
      DATA FIRST/.TRUE./
      IF (FIRST) THEN
         ANADER= (INDEX(KEYWRD,'ANALYT') .NE. 0)
         DEBUG = (INDEX(KEYWRD,'DCART') .NE. 0)
         FORCE = (INDEX(KEYWRD,'PRECISE')+INDEX(KEYWRD,'FORCE') .NE. 0)
         FIRST = .FALSE.
      ENDIF
      NCELLS=(L1U-L1L+1)*(L2U-L2L+1)*(L3U-L3L+1)
      DO 10 I=1,6
         LSTOR2(I)=LSTOR1(I)
   10 LSTOR1(I)=0
      IOFSET=(NCELLS+1)/2
      NUMTOT=NUMAT*NCELLS
      DO 20 I=1,NUMTOT
         DO 20 J=1,3
   20 DXYZ(J,I)=0.D0
      IF(ANADER) REWIND 2
      KREP=0
      DO 130 II=1,NUMAT
         III=NCELLS*(II-1)+IOFSET
         IM1=II
         IF=NFIRST(II)
         IM=NMIDLE(II)
         IL=NLAST(II)
         NDI(2)=NAT(II)
         DO 30 I=1,3
   30    CDI(I,2)=COORD(I,II)
         DO 130 JJ=1,IM1
            JJJ=NCELLS*(JJ-1)
C  FORM DIATOMIC MATRICES
            JF=NFIRST(JJ)
            JM=NMIDLE(JJ)
            JL=NLAST(JJ)
C   GET FIRST ATOM
            NDI(1)=NAT(JJ)
            MAKEP=.TRUE.
            DO 120 IK=K1L,K1U
               DO 120 JK=K2L,K2U
                  DO 120 KL=K3L,K3U
                     JJJ=JJJ+1
                     DO 40 L=1,3
   40                CDI(L,1)=COORD(L,JJ)+TVEC(L,1)*IK+TVEC(L,2)*JK+TVEC
     1(L,3)*KL
                     IF(.NOT. MAKEP) GOTO 90
                     MAKEP=.FALSE.
                     IJ=0
                     DO 50 I=JF,JL
                        K=I*(I-1)/2+JF-1
                        DO 50 J=JF,I
                           IJ=IJ+1
                           K=K+1
                           PADI(IJ)=PA(K)
                           PBDI(IJ)=PB(K)
   50                PDI(IJ)=P(K)
C GET SECOND ATOM FIRST ATOM INTERSECTION
                     DO 80 I=IF,IL
                        L=I*(I-1)/2
                        K=L+JF-1
                        DO 60 J=JF,JL
                           IJ=IJ+1
                           K=K+1
                           PADI(IJ)=PA(K)
                           PBDI(IJ)=PB(K)
   60                   PDI(IJ)=P(K)
                        K=L+IF-1
                        DO 70 L=IF,I
                           K=K+1
                           IJ=IJ+1
                           PADI(IJ)=PA(K)
                           PBDI(IJ)=PB(K)
   70                   PDI(IJ)=P(K)
   80                CONTINUE
   90                CONTINUE
                     IF(II.EQ.JJ) GOTO  120
                     IF(ANADER)THEN
                        CALL ANALYT(PDI,PADI,PBDI,CDI,NDI,JF,JL,IF,IL
     1,                 NORBS,ENG,KREP)
                        DO 100 K=1,3
                           DXYZ(K,III)=DXYZ(K,III)+ENG(K)
  100                   DXYZ(K,JJJ)=DXYZ(K,JJJ)-ENG(K)
                     ELSE
                        IF( .NOT. FORCE) THEN
                           CDI(1,1)=CDI(1,1)+CHNGE2
                           CDI(2,1)=CDI(2,1)+CHNGE2
                           CDI(3,1)=CDI(3,1)+CHNGE2
                           CALL DHC(PDI,PADI,PBDI,CDI,NDI,JF,JM,JL,IF,IM
     1,IL,                 NORBS,AA)
                        ENDIF
                        DO 110 K=1,3
                           IF( FORCE )THEN
                              CDI(K,2)=CDI(K,2)-CHNGE2
                              CALL DHC(PDI,PADI,PBDI,CDI,NDI,JF,JM,JL,IF
     1,IM,IL,                 NORBS,AA)
                           ENDIF
                           CDI(K,2)=CDI(K,2)+CHNGE
                           CALL DHC(PDI,PADI,PBDI,CDI,NDI,JF,JM,JL,IF,IM
     1,IL,                 NORBS,EE)
                           CDI(K,2)=CDI(K,2)-CHNGE2
                           IF( .NOT. FORCE) CDI(K,2)=CDI(K,2)-CHNGE2
                           DERIV=(AA-EE)*46.122D0/CHNGE
                           DXYZ(K,III)=DXYZ(K,III)+DERIV
                           DXYZ(K,JJJ)=DXYZ(K,JJJ)-DERIV
  110                   CONTINUE
                     ENDIF
  120       CONTINUE
  130 CONTINUE
      IF(USEMM)THEN
C
C   NOW ADD IN MOLECULAR-MECHANICS CORRECTION TO THE H-N-C=O TORSION
C
         DEL=1.D-5
         DO 160 I=1,NNHCO
            DO 150 J=1,4
               DO 140 K=1,3
                  COORD(K,NHCO(J,I))=COORD(K,NHCO(J,I))-DEL
                  CALL DIHED(COORD,NHCO(1,I),NHCO(2,I),NHCO(3,I),NHCO(4,
     1I),ANGLE)
                  REFH=HTYPE(ITYPE)*SIN(ANGLE)**2
                  COORD(K,NHCO(J,I))=COORD(K,NHCO(J,I))+DEL*2.D0
                  CALL DIHED(COORD,NHCO(1,I),NHCO(2,I),NHCO(3,I),NHCO(4,
     1I),ANGLE)
                  COORD(K,NHCO(J,I))=COORD(K,NHCO(J,I))-DEL
                  HEAT=HTYPE(ITYPE)*SIN(ANGLE)**2
                  SUM=(REFH-HEAT)/DEL
                  DXYZ(K,NHCO(J,I))=DXYZ(K,NHCO(J,I))+SUM
  140          CONTINUE
  150       CONTINUE
  160    CONTINUE
      ENDIF
      DO 170 I=1,6
  170 LSTOR1(I)=LSTOR2(I)
      IF (  .NOT. DEBUG) RETURN
      WRITE(6,'(//10X,''CARTESIAN COORDINATE DERIVATIVES'',//3X,
     1''ATOM  AT. NO.'',5X,''X'',12X,''Y'',12X,''Z'',/)')
      WRITE(6,'(2I6,F13.6,2F13.6)')
     1 (I,NAT((I-1)/NCELLS+1),(DXYZ(J,I),J=1,3),I=1,NUMTOT)
      IF (ANADER) REWIND 2
      RETURN
      END

      SUBROUTINE BTRTST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   BTRIX TEST PROGRAM
C
      PARAMETER (JD=30, KD=30, LD=30, MD=30, F7=78125., T30=1073741824.)
      COMMON /ARRAYS/ S(JD,KD,LD,5), A(5,5,MD,MD), B(5,5,MD,MD),
     $     C(5,5,MD,MD), SX(JD,KD,LD,5), BX(5,5,MD,MD)
      DATA JS/2/, JE/29/, LS/2/, LE/29/, IT/20/, ANS/-0.286282658663962/
C
C   INITIALIZATION
C
      NB = 25 * MD * MD
      NS = JD * KD * LD * 5
      T = F7 / T30
      DO 100 L = 1, MD
        DO 100 K = 1, MD
          DO 100 J = 1, 5
            DO 100 I = 1, 5
              T = MOD (F7 * T, 1.0D0)
              A(I,J,K,L) = T
              T = MOD (F7 * T, 1.0D0)
              BX(I,J,K,L) = T
              T = MOD (F7 * T, 1.0D0)
              C(I,J,K,L) = T
100   CONTINUE
      DO 110 L = 1, 5
        DO 110 K = 1, LD
          DO 110 J = 1, KD
            DO 110 I = 1, JD
              T = MOD (F7 * T, 1.0D0)
              SX(I,J,K,L) = T
110   CONTINUE
      TM = CPTIME ()
C
C   TIMING TEST
C
      DO 120 II = 1, IT
        CALL COPY (NS, SX, S)
        DO 120 K = 1, KD
          CALL COPY (NB, BX, B)
          CALL BTRIX (JS, JE, LS, LE, K)
120   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((S(19,19,19,1) - ANS) / ANS)
      FP = IT * MD * (LE - 1) * 19165.
C
      RETURN
      END

C----------------------------------------------------------------------C   
C File : serlnl.f                                                      C   
C Created: 08/05/91 IS                                                 C   
C History: See below                                                   C   
C----------------------------------------------------------------------C   
C                                                                       
C   02-JUN-91  PERIODIC BOUNDARY CONDITIONS APPLIED TO IONIC POSITIONS  
C              AND TO RXDIS,RYDIS,RZDIS.   (IS)                         
C
C   10-DEC-91  PERIODIC BOUNDARY CONDITIONS ELIMINATED FROM THE SEARCH
C              OVER REAL-SPACE GRID POINTS. THE OLD VERSION WAS
C              INCORRECT IF RLCORE WAS LARGER THAN HALF THE BOX SIDE.
C              (IS)
C---------------------------------------------------------------------- 
      SUBROUTINE SERLNL(NIONST,MXRLNL,MXRLSH,NIONS,NRLPTS,NRGRPT,NSPEC,
     &       DIRC,RECC,RLCORE,RMAX,NRLNL,PRLSCA,POSION,VRLNL,
     &       NIONSP,IRLNL,NADGRD,NRLPPI,DVRLGR,VRLGRD,NGX,NGY,NGZ)
C
      IMPLICIT REAL*8 (A,B,D-H,O-Z)  
      IMPLICIT COMPLEX*16 (C)        
      LOGICAL WRDIM
C                            
C
C========================================================================
C THIS SUBROUTINE SETS UP THE POTENTIAL AND DERIVATIVES ON THE REAL SPACE
C GRID AROUND EACH ATOM IN PREPARATION FOR CALCULATING H*PSI AND THE
C FORCES ON THE ATOMS - IN FUTURE TO ALLOW MAXIMUM FELXIBILTY THESE TWO
C PROCESSES COULD BE PERFORMED IN SEPARATE SUBROUTINES TO ALLOW THE CHOICE
C OF REAL SPACE PROJECTIONS FOR H*PSI AND RECIPROCAL SPACE FOR THE FORCES
C THE PHASE FACTORS ARE CALCULATED IN A SEPARATE BUT SIMILAR SUBROUTINE
C SINCE ONLY THE PHASE FACTORS CHANGE BETWEEN K-POINTS
C========================================================================
      DIMENSION DIRC(3,3),RECC(3,3)
      DIMENSION RLCORE(NSPEC),RMAX(NSPEC),NRLNL(NSPEC)
      DIMENSION PRLSCA(MXRLNL,NSPEC)
      DIMENSION POSION(3,NIONS,NSPEC),VRLNL(NRLPTS,MXRLNL,NSPEC)
      DIMENSION IRLNL(MXRLNL,NSPEC),NADGRD(NRGRPT,NIONST),NRLPPI(NIONST)
      DIMENSION DVRLGR(NRGRPT,3,MXRLSH,NIONST)
      DIMENSION NIONSP(NSPEC),VRLGRD(NRGRPT,MXRLSH,NIONST)
      DIMENSION POSTMP(3)
C======================================================================== 
C                                                                         
      DATA TPI,HALF,SIXTH / 6.283185307179,0.5,0.166666666667 /
      DATA RTH,RFIV,RFIF / 1.732050807568,2.236067977499,3.872983346207/
      DATA WRDIM /.FALSE./
C
C========================================================================
C INITIALISE THE INDEX FOR THE IONS, NPION, AND CONSTANTS, AND
C START THE LOOP OVER SPECIES OF IONS
C========================================================================
      RLENV1=DSQRT(DIRC(1,1)**2+DIRC(1,2)**2+DIRC(1,3)**2)
      RLENV2=DSQRT(DIRC(2,1)**2+DIRC(2,2)**2+DIRC(2,3)**2)
      RLENV3=DSQRT(DIRC(3,1)**2+DIRC(3,2)**2+DIRC(3,3)**2)
      RLENG1=DSQRT(RECC(1,1)**2+RECC(1,2)**2+RECC(1,3)**2)
      RLENG2=DSQRT(RECC(2,1)**2+RECC(2,2)**2+RECC(2,3)**2)
      RLENG3=DSQRT(RECC(3,1)**2+RECC(3,2)**2+RECC(3,3)**2)
      NPION=1
      DO 1000 NSP=1,NSPEC
C========================================================================
C START BY DETERMINING THE SIZE OF THE REAL SPACE GRID TO BE SEARCHED
C FOR THIS SPECIES OF ION THE ENSURE THAT ALL THE REAL SPACE POINTS
C WITHIN RLCORE(NSP) ARE SAMPLED - THE TRICK TO THIS PROCESS IS TO GO
C ALONG EACH LATTICE VECTOR UNTIL IT HITS THE PLANE DEFINED BY THE OTHER
C LATTICE VECTORS THAT IS TANGENTIAL TO A SPHERE OF RADIUS RLCORE AND
C THEN ADD HALF A LATTICE VECTOR TO ALLOW FOR THE CENTRE OF THE ION
C BEING UP TO HALF A LATTICE VECTOR FROM THE NEAREST GRID POINT
C
C TPI/RLENV1*RLENG1 IS THE ANGLE BETWEEN THE FIRST LATTICE VECTOR AND THE
C NORMAL TO THE PLANE DEFINED BY THE OTHER LATTICE VECTORS
C USE THIS TO DETERMINE SIZE OF GRID TO BE SEARCHED
C========================================================================
      NUMXPT=INT(5.D-1+RLCORE(NSP)*NGX*RLENV1*RLENG1/(TPI*RLENV1))
      NUMYPT=INT(5.D-1+RLCORE(NSP)*NGY*RLENV2*RLENG2/(TPI*RLENV2))
      NUMZPT=INT(5.D-1+RLCORE(NSP)*NGZ*RLENV3*RLENG3/(TPI*RLENV3))
C========================================================================
C CALCULATE THE SCALING FACTOR FOR INTERPOLATING POTENTIALS
C========================================================================
      ARGSC=DFLOAT(NRLPTS-1)/RMAX(NSP)
C========================================================================
C START LOOP OVER THE IONS FOR THIS SPECIES
C========================================================================
      DO 1100 NI=1,NIONSP(NSP)
C========================================================================
      DO 1101 IM=1,3
      POSTMP(IM)=MOD(POSION(IM,NI,NSP),1.D0)  
      POSTMP(IM)=POSTMP(IM)-INT(2.D0*POSTMP(IM))
 1101 CONTINUE
C========================================================================
C FIRST IDENTIFY THE NEAREST GRID POINT TO THE CURRENT ION
C========================================================================
      NGRPX=1+MOD(INT(5.D-1+NGX*POSTMP(1)),NGX)
      NGRPY=1+MOD(INT(5.D-1+NGY*POSTMP(2)),NGY)
      NGRPZ=1+MOD(INT(5.D-1+NGZ*POSTMP(3)),NGZ)
C========================================================================
C START SEARCH OVER GRID TO FIND POINTS WITHIN RLCORE OF THE ION
C INDAD INDICATES THE NUMBER OF GRID POINTS THAT HAVE BEEN FOUND
C WITHIN RLCORE AND IS USED AS THE ADDRESS INDEX FOR PUTTING THE
C POTENTIALS ETC INTO THE DATA ARRAYS
C========================================================================
      INDAD=1
      DO 1200 NZ=-NUMZPT,NUMZPT
      RZDIS=((1.D0*(NGRPZ+NZ-1))/(1.D0*NGZ)) - POSTMP(3)
      RZDIS=MOD(RZDIS,1.D0)
      RZDIS=RZDIS-INT(2.D0*RZDIS)
      DO 1201 NY=-NUMYPT,NUMYPT
      RYDIS=((1.D0*(NGRPY+NY-1))/(1.D0*NGY)) - POSTMP(2)
      RYDIS=MOD(RYDIS,1.D0)
      RYDIS=RYDIS-INT(2.D0*RYDIS)
      DO 1202 NX=-NUMXPT,NUMXPT
      RXDIS=((1.D0*(NGRPX+NX-1))/(1.D0*NGX)) - POSTMP(1)
      RXDIS=MOD(RXDIS,1.D0)
      RXDIS=RXDIS-INT(2.D0*RXDIS)
      XCOR=DIRC(1,1)*RXDIS+DIRC(2,1)*RYDIS+DIRC(3,1)*RZDIS
      YCOR=DIRC(1,2)*RXDIS+DIRC(2,2)*RYDIS+DIRC(3,2)*RZDIS
      ZCOR=DIRC(1,3)*RXDIS+DIRC(2,3)*RYDIS+DIRC(3,3)*RZDIS
      RAD=DSQRT(XCOR**2+YCOR**2+ZCOR**2)
C========================================================================
C CHECK TO SEE WHETHER GRID POINT IS WITHIN RANGE OF NON-LOCAL POTENTIAL
C========================================================================
      IF(RAD.GT.RLCORE(NSP)) GO TO 1202
C========================================================================
C FIND AND STORE ADDRESS OF THIS POINT IN THE REAL SPACE WAVEFUNCTION
C GRID
C========================================================================
      INDDX=1+MOD(NGRPX+NGX+NX-1,NGX)    
      INDDY=1+MOD(NGRPY+NGY+NY-1,NGY)
      INDDZ=1+MOD(NGRPZ+NGZ+NZ-1,NGZ)
      NADGRD(INDAD,NPION)=(INDDZ-1)*NGY*NGX+(INDDY-1)*NGX+INDDX
C========================================================================
C START LOOP OVER NON-LOCAL POTENTIAL COMPONENTS
C========================================================================
      NIND=1
      DO 1210 NNL=1,NRLNL(NSP)
C========================================================================
C INTERPOLATE POTENTIALS AND CALCULATE SPHERICAL HARMONICS ETC
C FOR THIS REAL SPACE DATA POINT
C========================================================================
C INTERPOLATE POTENTIAL AND DERIVATIVE
C========================================================================
      ADDR=1 + RAD*ARGSC
      NADDR=INT(ADDR)
      REM=ADDR-NADDR
      IF(NADDR.EQ.1) THEN
      V1=VRLNL(1,NNL,NSP)
      V2=VRLNL(2,NNL,NSP)
      V3=VRLNL(3,NNL,NSP)
      T0=V1
      T1=(4.D0*V2-3.D0*V1-V3)*HALF
      T2=(V3+V1-2.D0*V2)*HALF
      VRLPR=T0+REM*T1+REM*REM*T2
      DVRLPR=(T1+2.D0*REM*T2)*ARGSC
      ELSE
      V1=VRLNL(NADDR-1,NNL,NSP)
      V2=VRLNL(NADDR,NNL,NSP)
      V3=VRLNL(NADDR+1,NNL,NSP)
      V4=VRLNL(NADDR+2,NNL,NSP)
      T0=V2
      T1=((6.D0*V3)-(2.D0*V1)-(3.D0*V2)-V4)*SIXTH
      T2=(V1+V3-(2.D0*V2))*HALF
      T3=(V4-V1+(3.D0*(V2-V3)))*SIXTH
      VRLPR=T0+REM*(T1+REM*(T2+REM*T3))
      DVRLPR=ARGSC*(T1+REM*((2.D0*T2)+(3.D0*REM*T3)))
      ENDIF
C========================================================================
C 'S' POTENTIAL
C========================================================================
      IF(IRLNL(NNL,NSP).EQ.0) THEN
      VRLGRD(INDAD,NIND,NPION)=VRLPR
      IF(RAD.LE.1.D-6) THEN
      DVRLGR(INDAD,1,NIND,NPION)=0.D0
      DVRLGR(INDAD,2,NIND,NPION)=0.D0
      DVRLGR(INDAD,3,NIND,NPION)=0.D0
      NIND=NIND+1
      GO TO 1210
      ENDIF
      DVRLGR(INDAD,1,NIND,NPION)=-DVRLPR*XCOR/RAD
      DVRLGR(INDAD,2,NIND,NPION)=-DVRLPR*YCOR/RAD
      DVRLGR(INDAD,3,NIND,NPION)=-DVRLPR*ZCOR/RAD
      NIND=NIND+1
      GO TO 1210
      ENDIF
C========================================================================
C 'P' POTENTIAL
C========================================================================
      IF(IRLNL(NNL,NSP).EQ.1) THEN
      IF(RAD.LE.1.D-6) THEN
      VRLGRD(INDAD,NIND,NPION)=0.D0
      VRLGRD(INDAD,NIND+1,NPION)=0.D0
      VRLGRD(INDAD,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,1,NIND,NPION)=-RTH*DVRLPR
      DVRLGR(INDAD,2,NIND,NPION)=0.D0
      DVRLGR(INDAD,3,NIND,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+1,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+1,NPION)=-RTH*DVRLPR
      DVRLGR(INDAD,3,NIND+1,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,3,NIND+2,NPION)=-RTH*DVRLPR
      NIND=NIND+3
      GO TO 1210
      ENDIF
      VRLGRD(INDAD,NIND,NPION)=VRLPR*RTH*XCOR/RAD
      VRLGRD(INDAD,NIND+1,NPION)=VRLPR*RTH*YCOR/RAD
      VRLGRD(INDAD,NIND+2,NPION)=VRLPR*RTH*ZCOR/RAD
      DVRLGR(INDAD,1,NIND,NPION)=-RTH*(DVRLPR*(XCOR/RAD)**2 +
     &          (1.D0 - (XCOR/RAD)**2)*VRLPR/RAD)
      DVRLGR(INDAD,2,NIND,NPION)=-(RTH*XCOR*YCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,3,NIND,NPION)=-(RTH*XCOR*ZCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,1,NIND+1,NPION)=-(RTH*YCOR*XCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,2,NIND+1,NPION)=-RTH*(DVRLPR*(YCOR/RAD)**2 +
     &          (1.D0 - (YCOR/RAD)**2)*VRLPR/RAD)
      DVRLGR(INDAD,3,NIND+1,NPION)=-(RTH*YCOR*ZCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,1,NIND+2,NPION)=-(RTH*ZCOR*XCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,2,NIND+2,NPION)=-(RTH*ZCOR*YCOR/RAD**2) *
     &        (DVRLPR - VRLPR/RAD)
      DVRLGR(INDAD,3,NIND+2,NPION)=-RTH*(DVRLPR*(ZCOR/RAD)**2 +
     &          (1.D0 - (ZCOR/RAD)**2)*VRLPR/RAD)
      NIND=NIND+3
      GO TO 1210
      ENDIF
C========================================================================
C 'D' POTENTIAL
C========================================================================
      IF(IRLNL(NNL,NSP).EQ.2) THEN
      IF(RAD.LE.1.D-6) THEN
      VRLGRD(INDAD,NIND,NPION)=0.D0
      VRLGRD(INDAD,NIND+1,NPION)=0.D0
      VRLGRD(INDAD,NIND+2,NPION)=0.D0
      VRLGRD(INDAD,NIND+3,NPION)=0.D0
      VRLGRD(INDAD,NIND+4,NPION)=0.D0
      DVRLGR(INDAD,1,NIND,NPION)=0.D0
      DVRLGR(INDAD,2,NIND,NPION)=0.D0
      DVRLGR(INDAD,3,NIND,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+1,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+1,NPION)=0.D0
      DVRLGR(INDAD,3,NIND+1,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,3,NIND+2,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+3,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+3,NPION)=0.D0
      DVRLGR(INDAD,3,NIND+3,NPION)=0.D0
      DVRLGR(INDAD,1,NIND+4,NPION)=0.D0
      DVRLGR(INDAD,2,NIND+4,NPION)=0.D0
      DVRLGR(INDAD,3,NIND+4,NPION)=0.D0
      NIND=NIND+5
      GO TO 1210
      ENDIF
      VRLGRD(INDAD,NIND,NPION)=(RFIF/2.D0)*VRLPR*
     &       (XCOR**2-YCOR**2)/RAD**2
      VRLGRD(INDAD,NIND+1,NPION)=(RFIV/2.D0)*VRLPR*
     &       (2.D0*ZCOR**2-XCOR**2-YCOR**2)/RAD**2
      VRLGRD(INDAD,NIND+2,NPION)=RFIF*VRLPR*XCOR*YCOR/RAD**2
      VRLGRD(INDAD,NIND+3,NPION)=RFIF*VRLPR*XCOR*ZCOR/RAD**2
      VRLGRD(INDAD,NIND+4,NPION)=RFIF*VRLPR*YCOR*ZCOR/RAD**2
      XYRSQ=(XCOR**2 - YCOR**2)/RAD**2
      DVRLGR(INDAD,1,NIND,NPION)=
     &          -(RFIF/2.D0)*(DVRLPR*XCOR*XYRSQ/RAD +
     &          VRLPR*2.D0*XCOR*(1.D0-XYRSQ)/RAD**2)
      DVRLGR(INDAD,2,NIND,NPION)=
     &          -(RFIF/2.D0)*(DVRLPR*YCOR*XYRSQ/RAD -
     &          VRLPR*2.D0*YCOR*(XYRSQ+1.D0)/RAD**2)
      DVRLGR(INDAD,3,NIND,NPION)=
     &         -(RFIF/2.D0)*(DVRLPR*ZCOR*XYRSQ/RAD -
     &         VRLPR*2.D0*ZCOR*XYRSQ/RAD**2)
      ZXYRSQ=(2.D0*ZCOR**2 - XCOR**2 - YCOR**2)/RAD**2
      DVRLGR(INDAD,1,NIND+1,NPION)=
     &         -(RFIV/2.D0)*(DVRLPR*XCOR*ZXYRSQ/RAD -
     &         VRLPR*2.D0*XCOR*(1.D0+ZXYRSQ)/RAD**2)
      DVRLGR(INDAD,2,NIND+1,NPION)=
     &         -(RFIV/2.D0)*(DVRLPR*YCOR*ZXYRSQ/RAD -
     &         VRLPR*2.D0*YCOR*(1.D0+ZXYRSQ)/RAD**2)
      DVRLGR(INDAD,3,NIND+1,NPION)=
     &         -(RFIV/2.D0)*(DVRLPR*ZCOR*ZXYRSQ/RAD +
     &         VRLPR*2.D0*ZCOR*(2.D0-ZXYRSQ)/RAD**2)
      XTYDRS=XCOR*YCOR/RAD**2
      DVRLGR(INDAD,1,NIND+2,NPION)=
     &         -RFIF*(DVRLPR*XCOR*XTYDRS/RAD +
     &         VRLPR*(YCOR-2.D0*XCOR*XTYDRS)/RAD**2)
      DVRLGR(INDAD,2,NIND+2,NPION)=
     &         -RFIF*(DVRLPR*YCOR*XTYDRS/RAD +
     &         VRLPR*(XCOR-2.D0*YCOR*XTYDRS)/RAD**2)
      DVRLGR(INDAD,3,NIND+2,NPION)=
     &         -RFIF*(DVRLPR*ZCOR*XTYDRS/RAD -
     &         VRLPR*2.D0*ZCOR*XTYDRS/RAD**2)
      XTZDRS=XCOR*ZCOR/RAD**2
      DVRLGR(INDAD,1,NIND+3,NPION)=
     &         -RFIF*(DVRLPR*XCOR*XTZDRS/RAD +
     &         VRLPR*(ZCOR-2.D0*XCOR*XTZDRS)/RAD**2)
      DVRLGR(INDAD,2,NIND+3,NPION)=
     &         -RFIF*(DVRLPR*YCOR*XTZDRS/RAD -
     &         VRLPR*2.D0*YCOR*XTZDRS/RAD**2)
      DVRLGR(INDAD,3,NIND+3,NPION)=
     &         -RFIF*(DVRLPR*ZCOR*XTZDRS/RAD +
     &         VRLPR*(XCOR-2.D0*ZCOR*XTZDRS)/RAD**2)
      YTZDRS=YCOR*ZCOR/RAD**2
      DVRLGR(INDAD,1,NIND+4,NPION)=
     &         -RFIF*(DVRLPR*XCOR*YTZDRS/RAD -
     &         VRLPR*2.D0*XCOR*YTZDRS/RAD**2)
      DVRLGR(INDAD,2,NIND+4,NPION)=
     &         -RFIF*(DVRLPR*YCOR*YTZDRS/RAD +
     &         VRLPR*(ZCOR-2.D0*YCOR*YTZDRS)/RAD**2)
      DVRLGR(INDAD,3,NIND+4,NPION)=
     &         -RFIF*(DVRLPR*ZCOR*YTZDRS/RAD +
     &         VRLPR*(YCOR-2.D0*ZCOR*YTZDRS)/RAD**2)
      NIND=NIND+5
      ENDIF
C========================================================================
C MOVE ONTO NEXT NON-LOCAL COMPONENT
C========================================================================
 1210 CONTINUE
C========================================================================
C INCREMENT ADDRESS COUNTER
C========================================================================
      INDAD=INDAD+1
C========================================================================
C END LOOPS OVER X,Y,Z RESPECTIVELY
C========================================================================
 1202 CONTINUE
 1201 CONTINUE
 1200 CONTINUE
C========================================================================
C CHECK THAT NRGRPT IS LARGE ENOUGH TO STORE DATA
C========================================================================
      IF(INDAD-1.GT.NRGRPT) THEN
      WRITE(*,1500) INDAD-1
      WRDIM=.TRUE.
 1500 FORMAT(' NRGRPT NOT BIG ENOUGH SHOULD BE:',I5)
      ENDIF
C========================================================================
C RECORD NUMBER OF REAL SPACE GRID POINTS TO BE SAMPLED FOR PRESENT ION
C========================================================================
      NRLPPI(NPION)=INDAD-1
C========================================================================
C INCREMENT ION COUNTER BY ONE
C========================================================================
      NPION=NPION+1
C========================================================================
C END ION LOOP
C========================================================================
 1100 CONTINUE
C========================================================================
C END SPECIES LOOP
C========================================================================
 1000 CONTINUE
C========================================================================
C CHECK THAT TOTAL NUMBER OF IONS HAS BEEN CORRECTLY SET
C========================================================================
      IF(NPION-1.GT.NIONST) THEN
      WRITE(*,1600) NPION-1
      WRDIM=.TRUE.
 1600 FORMAT(' WRONG VALUE FOR NIONST, SHOULD BE:',I3)
      ENDIF
      IF(WRDIM) STOP
      RETURN
      END

      PROGRAM PDE1
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     MAIN PROGRAM FOR PDE1 BENCHMARK - SIMD/VECTOR VERSION
C
C     SUPPLIED BY   PALLAS GmbH
C
C     AUTHOR:  GENESIS BENCHMARK VERSION:
C		  M. LEMKE (1989, PALLAS GMBH)
C
C     FOR NUMERICAL VERIFICATION:
C	 THE AVERAGE CONVERGENCE RATE SHOULD BE SOMEWHERE BETWEEN
C	 0.7 AND 0.98
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C     THE TIMER (DOUBLE PRECISION IN SECONDS) IS CALLED IN MAIN PROGRAM.
C     THE MACHINE DEPENDENT TIMING ROUTINE HAS TO BE INCLUDED.
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      INCLUDE 'pde1.inc'
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PARAMETER (NPMAX=2**(MMAX+6)+1)
      PARAMETER (NPMIN=2**(MMAX-3)+1)
      PARAMETER (IDIM=NPMAX*NPMIN**2)
      PARAMETER(NW1=6)

      DOUBLE PRECISION U(IDIM),F(IDIM)
      COMMON U,F
      ITER = MAXIT

c--      OPEN(NW1,FILE='result')
      CALL HEADER(NW1)
      WRITE(NW1,91000)
91000 FORMAT(' ***** 3D RED BLACK RELAXATION BENCHMARK ************* '/
     *    )
C
C---> LOOP OVER THE FINEST GRIDS IN ORDER TO GET RESULTS FOR DIFFERENT
C     PROBLEM SIZES
      DO 1 N=3,MMAX
        NP=2**N+1
        CALL TESTA(U,F,NP,NP,NP,ITER,NW1)
c--        CALL TESTB(U,F,NP,NP,NP,ITER,NW1)
c--        CALL TESTC(U,F,NP,NP,NP,ITER,NW1)
        ITER = MAX(ITER/8,5)
C
1     CONTINUE
      NX = NP-1
      NY = NP-1
      NZ = NP-1
      DO 2 N=1,3
         NX = NX * 4
         NY = NY / 2
         NZ = NZ / 2
         IF (NY.GE.3.AND.NZ.GE.3) THEN
            CALL TESTA(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
c--            CALL TESTB(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
c--            CALL TESTC(U,F,NX+1,NY+1,NZ+1,ITER,NW1)
         ENDIF
2     CONTINUE
C
c--      CLOSE(NW1)

      STOP
      END

      SUBROUTINE Y12MDF(N,A,NN,B,PIVOT,SNR,HA,IHA,IFLAG,IFAIL)
      IMPLICIT DOUBLE PRECISION(A-B,G,P,T-Y),INTEGER (C,F,H-N,R-S,Z)
      DOUBLE PRECISION A(NN), PIVOT(N), B(N)
      INTEGER SNR(NN), HA(IHA,11), IFLAG(10)
      IFAIL=0
      IF(IFLAG(1).EQ.-2)GO TO 1000
      IFAIL=1
      GO TO 1110
1000  MODE=IFLAG(4)
      IPIV=IFLAG(3)
      N8=N+1
      N7=N-1
      STATE=IFLAG(5)
C
C  SOLVE THE SYSTEM WITH LOWER TRIANGULAR MATRIX  L  (IF THE
C  LU-FACTORIZATION IS AVAILABLE).
C
      IF(STATE.NE.3)GO TO 1051
      IF(IPIV.EQ.0)GO TO 1020
      DO 1010 I=1,N7
      L1=HA(I,7)
      T=B(L1)
      B(L1)=B(I)
      B(I)=T
1010  CONTINUE
1020  CONTINUE
      DO 1050 I=1,N
      RR1=HA(I,1)
      RR2=HA(I,2)-1
      IF(RR1.GT.RR2)GO TO 1040
      DO 1030 J=RR1,RR2
      L1=SNR(J)
 1030 B(I)=B(I)-A(J)*B(L1)
 1040 CONTINUE
 1050 CONTINUE
C
C  SOLVE THE SYSTEM WITH UPPER TRIAGULAR MATRIX.
C
 1051 CONTINUE
      DO 1090 I=1,N
      R1=N8-I
      RR1=HA(R1,2)
      RR2=HA(R1,3)
      IF(RR2.LT.RR1)   GO TO 1080
      DO 1070 J=RR1,RR2
      R2=SNR(J)
 1070 B(R1)=B(R1)-A(J)*B(R2)
 1080 CONTINUE
 1090 B(R1)=B(R1)/PIVOT(R1)
C
C IF INTERCHANGES WERE USED DURING THE  ELIMINATION THEN A REORDERING IN
C LUTION VECTOR IS MADE.
C
      IF(IPIV.EQ.0)GO TO 1110
      DO 1100 I=1,N7
      R1=N-I
      R2=HA(R1,8)
      T=B(R2)
      B(R2)=B(R1)
 1100 B(R1)=T
 1110 RETURN
      END

**********************************************************************
C IN VALUES
C
C CV(r)    ... THE REAL SPACE TOTAL KOHN-SHAM POTENTIAL
C CVD()   .... EMPTY
C CDUM    .... EMPTY
C CDIR    .... EMPTY
C CPTWFP  .... WAVE FUNCTIONS FOR CURRENT K-POINT
C CPTWFL  .... EMPTY
C CPTOWR,CPTNWR,CWORK,CGRA,CORGR,COGRPI,CDIRPI,PRECON : EMPTY
C
C CELEN(1)   . THE KINETIC ENERGY FOR 1ST BAND OF K-POINT 1
C EIGEN() ... EMPTY
C WTKPT(1) ... WEIGHT OF K-POINT NO 1
C OCC(N,1) ... WEIGHT OF Nth BAND FOR K-POINT NO 1
C
C OUT VALUES
C
C EIGEN(1)... EIGENVALUE FOR 1ST BAND OF K-POINT NKP
C=======================================================================
      SUBROUTINE CONGRABS(NBANDS,NKPTS,NPLWV,MPLWV,         
     &    NRPLWV,NINDPW,NPLWKP,WTKPT,CV,CPTWFP,             
     &    CPTWFL,DIRC,RECC,VOLC,CELEN,NGPTAR,DATAKE,        
     &    CPTOWR,CPTNWR,CWORK,CGRA,CORGR,CDIR,COGRPI,CDIRPI,
     &    PRECON,CVD,NPKPT,CDUM,
     &    HR, HI, AUX, FV1, FV2, FV3, CH0, NITMAX,          
     &    NSPEC, NIONS, NIONSP,PSCALE,                      
     &    DNLKG, CPHSGR,VGNL, CELFRC, CWRK20,               
     &    CWRK21,CWRK22,CWRK23,VNL,IVPTYP,IPRINT,ISBROT,    
     &    OCC,EIGVAL,NLPOT,ICLOCK,IVPTYN,NITER,N,NGX,NGY,NGZ,
     &    NRGRPT,NRLPPI,CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,   
     &    PRLSCA,VRLGRD,NADGRD,MXRLSH,CESAVE)
      IMPLICIT COMPLEX (C)
      DIMENSION NINDPW(*)
      DIMENSION CV(*)
      DIMENSION CPTWFP(*)
      DIMENSION CPTWFL(*)
      DIMENSION CELEN(*)
      DIMENSION NGPTAR(*)
      DIMENSION DATAKE(*)
      DIMENSION CVD(*)
      DIMENSION WTKPT(*)
      DIMENSION NIONSP(*)
      DIMENSION OCC(NBANDS,NKPTS), EIGVAL(NBANDS,NKPTS)
      DIMENSION DIRC(3,3),RECC(3,3)
C======================================================================
C ARRAYS NEEDED FOR REAL SPACE PROJECTION OF THE NON-LOCAL POTENTIALS
C======================================================================
      DIMENSION  NRLNL(NSPEC),PRLSCA(MXRLNL,NSPEC)                 
      DIMENSION  IRLNL(MXRLNL,NSPEC)
      DIMENSION  VRLGRD(NRGRPT,MXRLSH,NIONST),CPHGRD(NRGRPT,NIONST)
      DIMENSION  NADGRD(NRGRPT,NIONST),NRLPPI(NIONST)              
      DIMENSION CESAVE(NIONST,20) 
C
C=======================================================================
      DIMENSION CPTOWR(*)
      DIMENSION CPTNWR(*)
      DIMENSION CWORK(*)
      DIMENSION PRECON(*)
      DIMENSION CGRA(*),CORGR(*),CDIR(*),COGRPI(*),CDIRPI(*)
      DIMENSION CDUM (*)
C=======================================================================
      DIMENSION HR(NBANDS,NBANDS),HI(NBANDS,NBANDS),AUX(NBANDS),
     &     FV1(NBANDS),FV2(NBANDS),FV3(NBANDS),CH0(NBANDS,NBANDS)
C=======================================================================
C     DIMENSION STATEMENTS FOR THE NON-LOCAL CALCULATION
C=======================================================================
      DIMENSION PSCALE(0:2,NSPEC)
      DIMENSION DNLKG(NRPLWV,0:3,NKPTS)
      DIMENSION IVPTYN(NSPEC)
      DIMENSION CPHSGR(NRPLWV,NIONS,NSPEC),VGNL(NRPLWV,0:2,NSPEC)
      DIMENSION CELFRC(NRPLWV)
      DIMENSION CWRK20(NIONS),CWRK21(3,NIONS)
      DIMENSION CWRK22(NIONS),CWRK23(3,3,NIONS)
      DIMENSION VNL(NBANDS, NKPTS)
C=======================================================================
C     HAMMER'S
C=======================================================================
C
      RINPLW=1.0/NPLWV
C=======================================================================
C
C START CONJUGATE GRADIENTS LOOP
C
C=======================================================================
      DO 2001 NN = 1 , NBANDS
        NINDW = NRPLWV * ( NN - 1 )
        IF (NN.LE.1) GO TO 7026
C=======================================================================
C    ORTHOGONALISE PRESENT WAVEFUNCTION TO LOWER BAND VECTORS
C=======================================================================
        DO 7022 NB = 1 , NN - 1
          NINDD = NRPLWV * ( NB - 1 )
          COVERL = (0.0,0.0)
          DO 7023 M = 1 , NPLWKP
            COVERL = COVERL + CPTWFP(M+NINDW) * CONJG (CPTWFP(M+NINDD))
 7023     CONTINUE
          COVERL =  - COVERL
          DO 7024 M = 1 , NPLWKP
            CPTWFP(M+NINDW) = CPTWFP(M+NINDW) + COVERL * CPTWFP(M+NINDD)
 7024     CONTINUE
 7022   CONTINUE
C=======================================================================
C  NORMALIZE PRESENT WAVEFUNCTION
C=======================================================================
        ANORM = 0.0
        DO 7027 M = 1 , NPLWKP
          ANORM = ANORM +  CPTWFP(M+NINDW) * CONJG (CPTWFP(M+NINDW))
 7027   CONTINUE
        ANORM = 1.0 / SQRT(ANORM)
        DO 7028 M = 1 , NPLWKP
          CPTWFP(M+NINDW) = ANORM * CPTWFP(M+NINDW)
 7028   CONTINUE
C
 7026   CONTINUE
C=======================================================================
C  START ITERATIONS FOR THE PRESENT BAND.
C
C  WE ARE LOOKING FOR THE WAVEFUNCTION WHICH WILL MINIMIZE
C  CORRESPONDING EIGENVALUE UNDER CONSTRAINT OF BEING ORTHOGONAL
C  TO ALL LOWER BANDS.
C  START WITH |Fo> AND ADD TRIAL FUNCTION |W>,
C  THEN MINIMIZE:
C
C      <Fo+W|H|Fo+W>
C  E = -------------
C       <Fo+W|Fo+W>
C=======================================================================
C
C       WRITE(*,*)' BANDS CYCLE EIGEN EIGENNEW XL1 XL2 R1 R2 XLAMDA'
        DO 5000 NIT = 1 , NITMAX
C ......................................................................
C    CALCULATE THE PRODUCT OF HAMILTONIAN AND WAVEFUNCTION
C    H|Fo> WHICH WILL GIVE ALSO AFTER PRECONDITIONING AND 
C    CONJUGATION THE SEARCH DIRECTION, |W>.
C ......................................................................
C
C=======================================================================
C    1 ) CALCULATE THE PRODUCT OF THE POTENTIAL AND THE WAVEFUNCTION IN
C         real SPACE AND FOURIER TRANSFORM TO reciprocal SPACE
C=======================================================================
C INITIALISE THE ARRAYS USED IN THE FOURIER TRANSFORM TO ZERO. THIS STEP
C MUST BE PERFORMED TO ENSURE THAT THE COEFFICIENTS OF THE PLANE WAVES
C BEYOND THE CUT-OFF ENERGY ARE ZERO.
C=======================================================================
          DO 5561 M = 1 , MPLWV
            CPTOWR(M) = (0.0,0.0)
            CPTNWR(M)=(0.0,0.0)
            CWORK(M) = (0.0,0.0)
 5561     CONTINUE
          DO 5510 M = 1 , NPLWKP
            CPTOWR(NINDPW(M)) = CPTWFP(M+NINDW)
 5510     CONTINUE
C=======================================================================
C TRANSFORM THE WAVEFUNCTION INTO REAL SPACE
C=======================================================================
          CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)
        IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN                        
C=====================================================================
C CALL THE ROUTINE THAT CALCULATES THE PRODUCT OF THE NON-LOCAL       
C POTENTIAL AND THE WAVEFUNCTION IN REAL SPACE                        
C=====================================================================
          CALL VSINL(VOLC,NGX,NGY,NGZ,MPLWV,NRPLWV,      
     &   NRGRPT,NIONSP,NRLPPI,NSPEC,CWORK,CPTOWR,CPTNWR, 
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &   CESAVE)                                                      
        ENDIF                                                         
          DO 2002 NNN = 1 , NPLWV
            CPTNWR(NNN)=(CPTNWR(NNN)+CV(NNN)*CPTOWR(NNN))*RINPLW
 2002     CONTINUE
C=======================================================================
C TRANSFORM (WAVEFUNCTION*POTENTIAL) INTO RECIPROCAL SPACE
C=======================================================================
          CALL FFT3D(CPTNWR,CWORK,NGPTAR,-1)
C=======================================================================
C    2) ADDED THE KINETIC ENERGY TERM, WE OBTAIN THE GRADIENT
C=======================================================================
          DO 2010 M=1,NPLWKP
            CGRA(M) = CPTNWR(NINDPW(M)) + 
     &                CPTWFP(M+NINDW) * DATAKE(1+(7*(M-1)))
 2010     CONTINUE
C=======================================================================
C    IF THE PSEUDOPOTENTIAL IS NON-LOCAL, WE ADD THE NON-LOCAL
C    CONTRIBUTION. (MUST BE IN THE KLEIMAN-BYLANDER FORM)
C    THIS IS DONE IN SUBROUTINE VNLWAV (Vnl*WAV)     16-MAR-90 X.WENG
C=======================================================================
          IF (IVPTYP.NE.0 .AND.NLPOT.EQ.0) THEN
            IF (ICLOCK.EQ.1) CALL PCLOCK(203)
            CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,
     &                  DNLKG(1,0,NPKPT),VOLC,PSCALE,CPTWFP,
     &                  CWRK20,CWRK21,CWRK22,CWRK23,CPHSGR,VGNL,CELFRC,
     &                  CDUM,CORGR,NN,IVPTYN)
            DO 2015 M = 1 , NPLWKP
              CGRA(M) = CGRA(M) +  CELFRC(M)
 2015       CONTINUE
            IF (ICLOCK.EQ.1) CALL PCLOCK(204)
          END IF
C
          DO 2017 M = 1 , NPLWKP
            CGRA(M)  = - CGRA(M)
            CORGR(M) = CGRA(M)
 2017     CONTINUE
C=======================================================================
C    3) ORTHOGONALISE GRADIENT TO PRESENT BAND VECTOR
C       changed ->>         ** LOWER AND PRESENT BANDS ONLY **
C=======================================================================
          DO 2022 NB = 1 , NN
            NINDD = NRPLWV * ( NB - 1 )
            COVERL = (0.0,0.0)
            DO 2023 M = 1 , NPLWKP
              COVERL = COVERL + CORGR(M) * CONJG (CPTWFP(M+NINDD))
 2023       CONTINUE
            COVERL = - COVERL
            DO 2024 M = 1 , NPLWKP
              CORGR(M) = CORGR(M) + COVERL * CPTWFP(M+NINDD)
 2024       CONTINUE
 2022     CONTINUE
C=======================================================================
C    4) PRE-CONDITION THE GRADIENT
C=======================================================================
          NCELIN = NN + NBANDS * ( NPKPT - 1 )
          ENBAKE = REAL (CELEN(NCELIN))
          IF (ENBAKE.LT.1.0) THEN
            ENKEIN = 1.0
          ELSE
            ENKEIN = 1.0 / ENBAKE
          ENDIF
          DO 2031 M = 1 , NPLWKP
            X = DATAKE(1+7*(M-1)) * ENKEIN
            PCNUM = 27.0 + ( 18.0 + ( 12.0 + 8.0 * X ) * X ) * X
            PCDEN = PCNUM + 16.0 * ( X * X )**2
            PRECON(M) = PCNUM / PCDEN
C            PRECON(M) = (1.0,0.0)
            CDUM(M) = CORGR(M) * PRECON(M)
 2031     CONTINUE
C=======================================================================
C    5) ORTHOGONALISE PRECONDITIONED RESIDUAL TO LOWER AND PRESENT BANDS
C=======================================================================
          DO 2032 NB = 1 , NN
            NINDD = NRPLWV * ( NB - 1 )
C
C     COVERL=CDOTC(NPLWKP,CPTWFP(NINDD+1),1,CORGR,1)
C     COVERL=-COVERL
C     CALL CAXPY(NPLWKP,COVERL,CPTWFP(NINDD+1),1,CORGR,1)
C
            COVERL = (0.0,0.0)
            DO 2033 M = 1 , NPLWKP
              COVERL = COVERL + CDUM(M) * CONJG (CPTWFP(NINDD+M))
 2033       CONTINUE
            DO 2034 M = 1 , NPLWKP
              CDUM(M) = CDUM(M) - COVERL * CPTWFP(NINDD+M)
 2034       CONTINUE
 2032     CONTINUE
C=======================================================================
C AFTER FIRST ITERATION USE CONJUGATE DIRECTIONS
C=======================================================================
          IF (NIT.EQ.1) THEN
            DO 2035 M = 1 , NPLWKP
C              CDIR(M)=CORGR(M)
              CDIR(M) = CDUM(M)
 2035       CONTINUE
          ELSE
            CDOT1 = (0.0,0.0)
            CDOT2 = (0.0,0.0)
            DO 2040 M = 1 , NPLWKP
C
C     From Numerical Recipes p304, eq(10.6.5):
C     1) Fletcher-Reeves method  GAMMA = G(i+1)*G(i+1)/G(i)*G(i)
C     2) Poloak-Ribiere method   GAMMA = [G(i+1)-G(i)]*G(i+1)/G(i)*G(i)
C
              CDOT1 = CDOT1 + CORGR(M) * CONJG (CDUM(M))
              CDOT2 = CDOT2 + COGRPI(M) * CONJG (COGRPI(M)) * PRECON(M)
C
C      CDOT1=CDOT1+(CORGR(M)-COGRPI(M)) *CONJG(CDUM(M))
C      CDOT2=CDOT2+COGRPI(M)*CONJG(COGRPI(M))
 2040       CONTINUE
            CGAMMA = CDOT1 / CDOT2
            DO 2050 M = 1 , NPLWKP
              CDIR(M) = CDUM(M) + CGAMMA * CDIRPI(M)
 2050       CONTINUE
          ENDIF
          DO 2060 M = 1 , NPLWKP
            CDIRPI(M) = CDIR(M)
            COGRPI(M) = CORGR(M)
 2060     CONTINUE
C=======================================================================
C FINALLY ORTHOGONALISE SEARCH DIRECTION TO PRESENT BAND 
C=======================================================================
          DO 2071 NB = 1 , NN
            NINDD = NRPLWV * ( NB - 1 )
          COVERL = (0.0,0.0)
          DO 2070 M = 1 , NPLWKP
            COVERL = COVERL + CDIR(M) * CONJG (CPTWFP(M+NINDD))
 2070     CONTINUE
          DO 2080 M = 1 , NPLWKP
            CDIR(M) = CDIR(M) - COVERL * CPTWFP(M+NINDD)
 2080     CONTINUE
 2071     CONTINUE
C=======================================================================
C CALCULATE THE PRODUCT OF THE HAMILTONIAN MATRIX WITH THE NEW DIRECTION
C IN REAL SPACE, H|W>
C=======================================================================
          DO 3000 M = 1 , NPLWV
            CPTOWR(M) = (0.0,0.0) 
            CVD(M) = (0.0,0.0) 
 3000     CONTINUE
          DO 3010 M = 1 , NPLWKP
            CPTOWR(NINDPW(M)) = CDIR(M)
 3010     CONTINUE
C=======================================================================
C TRANSFORM THE DIRECTION INTO REAL SPACE
C=======================================================================
          CALL FFT3D(CPTOWR,CWORK,NGPTAR,1)
          IF (IVPTYP.EQ.1 .AND. NLPOT.EQ.1) THEN                        
C=====================================================================
C CALL THE ROUTINE THAT CALCULATES THE PRODUCT OF THE NON-LOCAL       
C POTENTIAL AND THE WAVEFUNCTION IN REAL SPACE                        
C=====================================================================
            CALL VSINL(VOLC,NGX,NGY,NGZ,MPLWV,NRPLWV,      
     &   NRGRPT,NIONSP,NRLPPI,NSPEC,CWORK,CPTOWR,CPTNWR, 
     &   CPHGRD,NRLNL,NIONST,MXRLNL,IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,
     &   CESAVE)                                                      
            DO 3020 NNN = 1 , NPLWV
              CPTOWR(NNN) = ( CPTNWR(NNN) + CV(NNN) * CPTOWR(NNN) )
     &                      * RINPLW
 3020       CONTINUE
          ELSE
            DO 3021 NNN = 1 , NPLWV                                
              CPTOWR(NNN) = CV(NNN) * CPTOWR(NNN) * RINPLW
 3021       CONTINUE                                               
          ENDIF                                                         
C=======================================================================
C TRANSFORM (WAVEFUNCTION*POTENTIAL) INTO RECIPROCAL SPACE
C=======================================================================
          CALL FFT3D(CPTOWR,CWORK,NGPTAR,-1)
C=======================================================================
C    2) ADDED THE KINETIC ENERGY TERM, WE OBTAIN THE GRADIENT
C=======================================================================
          DO 3030 M = 1 , NPLWKP
            CVD(M) = CPTOWR(NINDPW(M)) + CDIR(M) * DATAKE(1+(7*(M-1)))
 3030     CONTINUE
C=======================================================================
C    IF THE PSEUDOPOTENTIAL IS NON-LOCAL, WE ADD THE NON-LOCAL
C    CONTRIBUTION. (MUST BE IN THE KLEIMAN-BYLANDER FORM)
C    THIS IS DONE IN SUBROUTINE VNLWAV (Vnl*WAV)     16-MAR-90 X.WENG
C=======================================================================
          IF (IVPTYP.NE.0 .AND. NLPOT.EQ.0) THEN
            IF (ICLOCK.EQ.1) CALL PCLOCK(203)
            CALL VNLWAV(NRPLWV,NIONS,NSPEC,NIONSP,NPLWKP,
     &                  DNLKG(1,0,NPKPT),VOLC,PSCALE,CDIR,
     &                  CWRK20,CWRK21,CWRK22,CWRK23,CPHSGR,VGNL,CELFRC,
     &                  CDUM,CORGR,1,IVPTYP)
            DO 3040 M = 1 , NPLWKP
              CVD(M) = CVD(M) + CELFRC(M)
 3040       CONTINUE
          END IF
C=======================================================================
C  CALCULATE A NEW STEP ALONG THE SEARCH DIRECTION:
C  |F> = |Fo> + Lambda |W>, WHERE LAMBDA COMES FROM THE
C  MINIMIZATION OF EIGENVALUE - SECOND ORDER EQUATION.
C
C   XA = <Fo|H|Fo>
C   XB = <W|H|Fo> + c.c.
C   XC = <W|H|W>
C   XD = <W|W>
C
C (ASSUME THAT <W|Fo>=0)
C
C                    XA + Lambda * XB + Lambda**2 * XC
C   eigenvalue = min ---------------------------------
C                          1  + Lambda**2 * XD
C=======================================================================
          XA = 0.0
          XB = 0.0
          XC = 0.0
          XD = 0.0
          DO 3060 M = 1 , NPLWKP
            XA = XA - CPTWFP(M+NINDW) * CONJG (CGRA(M))
            XB = XB + CPTWFP(M+NINDW) * CONJG (CVD(M)) 
     &              - CDIR(M) * CONJG (CGRA(M))
            XC = XC + CDIR(M) * CONJG (CVD(M))
            XD = XD +  CDIR(M) * CONJG (CDIR(M))
 3060     CONTINUE
          A1 = XB * XD
          A2 = XA * XD - XC 
          A3 = - XB
          IF (ABS(A1).GT.1.E-8) THEN
            R1 = - (  A2 + SQRT ( A2**2 - A3 * A1 ) ) / A1
            R2 = - (  A2 - SQRT ( A2**2 - A3 * A1 ) ) / A1
          ELSE
            R1 = - A3 / ( 2.0 * A2 )
            R2 = R1
          END IF
C
          XL1 = ( XA + XB * R1 + XC * R1**2 ) / 
     &         ( 1.0 + XD * R1**2 )
          XL2 = ( XA + XB * R2 + XC * R2**2 ) / 
     &         ( 1.0 + XD * R2**2 )
C
          AANEW = MIN(XL1,XL2)
          IF (XL1.LT.XL2) THEN
            XLAMDA = R1
          ELSE
            XLAMDA = R2
          END IF
C         WRITE(6,101) NN,NIT,XA,AANEW,A1,A2,A3,XLAMDA
101    FORMAT(1X,2I3,7F10.5)
C=======================================================================
C UPDATE THE WAVEFUNCTION AND NORMALIZE IT
C=======================================================================
          ANORM = 0.0
          DO 3070 M = 1 , NPLWKP
            CPTWFP(M+NINDW) = CPTWFP(M+NINDW) + XLAMDA * CDIR(M)
            ANORM = ANORM +  CPTWFP(M+NINDW) * CONJG (CPTWFP(M+NINDW))
 3070     CONTINUE
          ANORM = 1.0 / SQRT(ANORM)
          DO 3080 M = 1 , NPLWKP
            CPTWFP(M+NINDW) = ANORM * CPTWFP(M+NINDW)
 3080     CONTINUE
C======================================================================
C     MOVE ONTO THE NEXT ITERATION
C======================================================================
 5000   CONTINUE
        EIGVAL(NN,NPKPT) = AANEW      
C======================================================================
C     MOVE ONTO THE NEXT BAND
C======================================================================
 2001 CONTINUE
C=======================================================================
C SUB-SPACE ROTATION (FINDS OUT EIGEN STATES AND EIGEN VALUES)
C THE CELEN AND VNL ARE UPDATED
C=======================================================================
      DO 2800 NN = 1,NBANDS 
        NINDX = NRPLWV * ( NN - 1 )
        NNN = NN + NBANDS * ( NPKPT - 1 )
        CELEN(NNN) = (0.0,0.0)
        DO 2810 M = 1,NPLWKP
          CELEN(NNN) = CELEN(NNN) +
     &    DATAKE(1+7*(M-1)) * CPTWFP(M+NINDX) * CONJG(CPTWFP(M+NINDX))
 2810   CONTINUE
C        WRITE(*,*)'  KINETIC ENERGY IS: ', CELEN(NN)
 2800 CONTINUE
C
      IF (ISBROT.NE.0 .AND. N.GE.NITER) THEN
        CALL SUBROT(NBANDS,NKPTS,NPLWV,MPLWV, NRPLWV,NINDPW,NPLWKP,CV,
     &       CPTWFP,CPTWFL,VOLC, CELEN,VNL,NGPTAR,DATAKE,
     &       CPTOWR,CPTNWR,CWORK,CGRA,NPKPT,HR,HI,AUX, FV1,FV2,
     &       FV3,CH0,NSPEC,NIONS,NIONSP,PSCALE,
     &       DNLKG,CPHSGR,VGNL,CELFRC,CWRK20,
     &       CWRK21,CWRK22,CWRK23,IVPTYP,IVPTYN,IPRINT,NLPOT,
     &       NGX,NGY,NGZ,NRGRPT,NRLPPI,CPHGRD,NRLNL,NIONST,MXRLNL,
     &       IRLNL,PRLSCA,VRLGRD,NADGRD,MXRLSH,CESAVE)            
        DO 6006 NB = 1 , NBANDS
          EIGVAL(NB,NPKPT) = AUX(NB)
 6006   CONTINUE
      END IF
C
      IF (IPRINT.GE.1) WRITE(*,*)' BYE FROM CONGRA-BS'
      RETURN
      END

      SUBROUTINE CHRGE(P,Q)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION P(*),Q(*)
      COMMON /MOLKST/ NUMAT,NAT(NUMATM),NFIRST(NUMATM),NMIDLE(NUMATM),
     1                NLAST(NUMATM), NORBS, NELECS,NALPHA,NBETA,
     2                NCLOSE,NOPEN,NDUMY,FRACT
C***********************************************************************
C
C      CHRGE STORES IN Q THE TOTAL ELECTRON DENSITIES ON THE ATOMS
C
C      ON INPUT P      = DENSITY MATRIX
C
C      ON OUTPUT Q     = ATOM ELECTRON DENSITIES
C
C***********************************************************************
      K=0
      DO 10 I=1,NUMAT
         IA=NFIRST(I)
         IB=NLAST(I)
         Q(I)=0.D0
         DO 10 J=IA,IB
            K=K+J
   10 Q(I)=Q(I)+P(K)
      RETURN
      END

      SUBROUTINE WRTKEY(KEYWRD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      CHARACTER*80 KEYWRD, ALLKEY
***********************************************************************
*
*  WRTKEY CHECKS ALL KEY-WORDS AND PRINTS THOSE IT RECOGNIZES.  IF IT
*  FINDS A WORD IT DOES NOT RECOGNIZE THE PROGRAM WILL BE STOPPED.
*
***********************************************************************
      LOGICAL UHF, TRIP, BIRAD, EXCI, CI, WORD
      LOGICAL AM1, MNDO, MINDO3, PM3
      CHARACTER SPACE*1, DOT*1, ZERO*1, NINE*1, CH*1, CHRONO*7
      DATA SPACE,DOT,ZERO,NINE /' ','.','0','9'/
      DATA AM1, MNDO, MINDO3, PM3 /4*.FALSE./
      ALLKEY=KEYWRD
      IF(WORD(ALLKEY,'AUTHOR')) THEN
         WRITE(6,'(10X,'' MOPAC - A GENERAL MOLECULAR ORBITAL PACKAGE'',
     1/         ,10X,''   ORIGINAL VERSION WRITTEN IN 1983'')')
         WRITE(6,'(10X,''     BY JAMES J. P. STEWART AT THE'',/
     1         ,10X,''     UNIVERSITY OF TEXAS AT AUSTIN'',/
     2         ,10X,''          AUSTIN, TEXAS, 78712'')')
      ENDIF
      IF (WORD(ALLKEY,'VECT') ) WRITE(6,70)
      IF (WORD(ALLKEY,' EXTE') ) THEN
         I=INDEX(KEYWRD,' EXTE')
         J=INDEX(KEYWRD(I:),'=')+I
         I=INDEX(KEYWRD(J:),' ')+J-1
         WRITE(6,80)KEYWRD(J:I)
      ENDIF
      MAXGEO=0
      IF (WORD(ALLKEY,' DENS') ) WRITE(6,90)
      IF (WORD(ALLKEY,'SPIN') ) WRITE(6,100)
      IF (WORD(ALLKEY,' DEPVAR') )
     1WRITE(6,110)READA(KEYWRD,INDEX(KEYWRD,'DEPVAR'))
      IF (WORD(ALLKEY,' DEP ') )WRITE(6,120)
      IF (WORD(ALLKEY,'VELO') )WRITE(6,130)
      IF (WORD(ALLKEY,'TIMES') )WRITE(6,140)
      IF (WORD(ALLKEY,'PARASOK') ) WRITE(6,150)
      IF (WORD(ALLKEY,'FLEPO') ) WRITE(6,160)
      IF (WORD(ALLKEY,'BONDS') ) WRITE(6,170)
      IF (WORD(ALLKEY,'GEO-OK') ) WRITE(6,180)
      IF (WORD(ALLKEY,'FOCK') ) WRITE(6,190)
      IF (WORD(ALLKEY,'LARGE') ) WRITE(6,200)
      IF (WORD(ALLKEY,' S1978') ) WRITE(6,210)
      IF (WORD(ALLKEY,' SI1978') ) WRITE(6,220)
      IF (WORD(ALLKEY,' GRAP') ) WRITE(6,230)
      IF (WORD(ALLKEY,'1ELEC') ) WRITE(6,240)
      IF (WORD(ALLKEY,' NOMM') ) WRITE(6,260)
      IF (WORD(ALLKEY,' MMOK') ) WRITE(6,265)
      IF (WORD(ALLKEY,'INTERP') ) WRITE(6,270)
      IF (WORD(ALLKEY,' ESR') ) WRITE(6,250)
      IF (WORD(ALLKEY,'DFP') ) WRITE(6,280)
      IF (WORD(ALLKEY,'ANALYT') ) WRITE(6,290)
      IF (WORD(ALLKEY,' MECI') ) WRITE(6,300)
      IF (WORD(ALLKEY,'LOCAL') ) WRITE(6,340)
      IF (WORD(ALLKEY,'MULLIK') ) WRITE(6,350)
      IF (WORD(ALLKEY,' XYZ') ) WRITE(6,360)
      IF (WORD(ALLKEY,' PI') ) WRITE(6,370)
      IF (WORD(ALLKEY,'ECHO') ) WRITE(6,380)
      IF (WORD(ALLKEY, 'SING') ) WRITE(6,540)
      IF (WORD(ALLKEY, 'DOUB') ) WRITE(6,550)
      IF (WORD(ALLKEY, 'QUAR') ) WRITE(6,570)
      IF (WORD(ALLKEY, 'QUIN') ) WRITE(6,580)
      IF (WORD(ALLKEY, 'SEXT') ) WRITE(6,590)
      IF (WORD(ALLKEY,'H-PRIO') ) WRITE(6,390)
      IF (WORD(ALLKEY,'X-PRIO') ) WRITE(6,400)
      IF (WORD(ALLKEY,'T-PRIO') ) WRITE(6,410)
      IF (WORD(ALLKEY,'POWSQ') ) WRITE(6,420)
      IF (WORD(ALLKEY,'POLAR') ) WRITE(6,430)
      IF (WORD(ALLKEY,'DEBUG ') ) WRITE(6,440)
      IF (WORD(ALLKEY,'RESTART') ) WRITE(6,450)
      IF (WORD(ALLKEY,'IRC=') ) THEN
         MAXGEO=1
         WRITE(6,460)NINT(READA(KEYWRD,INDEX(KEYWRD,'IRC=')))
      ELSEIF (WORD(ALLKEY,'IRC') ) THEN
         MAXGEO=1
         WRITE(6,470)
      ENDIF
      IF (WORD(ALLKEY,'CHARGE') )
     1 WRITE(6,480)NINT(READA(KEYWRD,INDEX(KEYWRD,'CHARGE')))
      IF (WORD(ALLKEY,'GRAD') ) WRITE(6,490)
      UHF=(WORD(ALLKEY,'UHF') )
      IF(UHF)WRITE(6,500)
      BIRAD=(WORD(ALLKEY,'BIRAD') )
      IF(BIRAD)WRITE(6,520)
      EXCI=(WORD(ALLKEY,'EXCITED') )
      IF(EXCI) WRITE(6,530)
      TRIP=(WORD(ALLKEY,'TRIPLET') )
      IF(TRIP)WRITE(6,560)
      IF (WORD(ALLKEY,'SYM') ) WRITE(6,600)
      IF(WORD(ALLKEY,'OPEN('))THEN
         I=INDEX(KEYWRD,'OPEN(')
         IELEC=READA(KEYWRD,I)
         ILEVEL=READA(KEYWRD,I+7)
         WRITE(6,620)IELEC,ILEVEL
      ENDIF
      IF(WORD(ALLKEY,'MICROS'))
     1WRITE(6,610)INT(READA(KEYWRD,INDEX(KEYWRD,'MICROS')))
      IF(WORD(ALLKEY,'DRC='))THEN
         MAXGEO=1
         WRITE(6,320)READA(KEYWRD,INDEX(KEYWRD,'DRC='))
      ELSEIF (WORD(ALLKEY,' DRC') ) THEN
         MAXGEO=1
         WRITE(6,310)
      ENDIF
      IF(WORD(ALLKEY,'KINE'))
     1WRITE(6,330)READA(KEYWRD,INDEX(KEYWRD,'KINE'))
      CHRONO='SECONDS'
      IF(WORD(ALLKEY,' T=')) THEN
         I=INDEX(KEYWRD,' T=')
         TIME=READA(KEYWRD,I)
         DO 10 J=I+3,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') CHRONO='MINUTES'
               IF( CH .EQ. 'H') CHRONO='HOURS'
               IF( CH .EQ. 'D') CHRONO='DAYS'
               GOTO 20
            ENDIF
   10    CONTINUE
   20    CONTINUE
         IF(TIME.LT.99999.9D0)THEN
            WRITE(6,630)TIME,CHRONO
         ELSE
            WRITE(6,640)TIME,CHRONO
         ENDIF
      ELSE
         WRITE(6,630)MAXTIM*1.D0,CHRONO
      ENDIF
               CHRONO='SECONDS'
      IF(WORD(ALLKEY,' DUMP')) THEN
         TDUMP=READA(KEYWRD,INDEX(KEYWRD,' DUMP'))
         DO 30 J=I+6,80
            IF( KEYWRD(J+1:J+1).EQ.' ') THEN
               CH=KEYWRD(J:J)
               IF( CH .EQ. 'M') CHRONO='MINUTES'
               IF( CH .EQ. 'H') CHRONO='HOURS'
               IF( CH .EQ. 'D') CHRONO='DAYS'
               GOTO 40
            ENDIF
   30    CONTINUE
   40    CONTINUE
         IF(TDUMP.LT.99999.9D0)THEN
            WRITE(6,650)TDUMP,CHRONO
         ELSE
            WRITE(6,660)TDUMP,CHRONO
         ENDIF
      ELSE
         WRITE(6,650)MAXDMP*1.D0,CHRONO
      ENDIF
      IF (WORD(ALLKEY,'1SCF') ) THEN
         WRITE(6,670)
         IF(INDEX(KEYWRD,'RESTART').EQ.0)MAXGEO=MAXGEO+1
      ENDIF
      IF(INDEX(ALLKEY,'C.I.').NE.0)
     1WRITE(6,680)INT(READA(KEYWRD,INDEX(KEYWRD,'C.I.')+5))
      CI=WORD(ALLKEY,'C.I.')
      IF (WORD(ALLKEY,'DFORCE') ) THEN
         WRITE(6,690)
         MAXGEO=MAXGEO+1
      ELSEIF (WORD(ALLKEY,'FORCE') ) THEN
         WRITE(6,700)
         MAXGEO=MAXGEO+1
      ENDIF
      METHOD=0
      IF (WORD(ALLKEY,'MINDO') ) THEN
         WRITE(6,710)
         MINDO3=.TRUE.
         METHOD=1
      ENDIF
      IF (WORD(ALLKEY,'AM1') ) THEN
         WRITE(6,720)
         AM1=.TRUE.
         METHOD=METHOD+1
      ENDIF
      IF (WORD(ALLKEY,'PM3') ) THEN
         WRITE(6,730)
         PM3=.TRUE.
         METHOD=METHOD+1
      ENDIF
      IF (WORD(ALLKEY,'MNDO') ) THEN
         MNDO=.TRUE.
         METHOD=METHOD+1
      ENDIF
      IF (WORD(ALLKEY,'PREC') ) WRITE(6,740)
      IF (WORD(ALLKEY,'NOINTER') ) WRITE(6,750)
      IF (WORD(ALLKEY,'ISOTOPE') ) WRITE(6,760)
      IF (WORD(ALLKEY,'DENOUT') ) WRITE(6,770)
      IF (WORD(ALLKEY,'SHIFT') ) WRITE(6,780)
     1 READA(KEYWRD,INDEX(KEYWRD,'SHIFT'))
      IF (WORD(ALLKEY,'OLDENS') ) WRITE(6,790)
      IF (WORD(ALLKEY,'SCFCRT') ) WRITE(6,800)
     1 READA(KEYWRD,INDEX(KEYWRD,'SCFCRT'))
      IF (WORD(ALLKEY,'ENPART') ) WRITE(6,810)
      IF (WORD(ALLKEY,'NOXYZ') ) WRITE(6,820)
      IF (WORD(ALLKEY,'SIGMA') ) THEN
         WRITE(6,830)
         MAXGEO=MAXGEO+1
      ENDIF
      IF (WORD(ALLKEY,'NLLSQ') ) THEN
         WRITE(6,840)
         MAXGEO=MAXGEO+1
      ENDIF
      IF (WORD(ALLKEY,'ROOT') ) WRITE(6,850)
     1 NINT(READA(KEYWRD,INDEX(KEYWRD,'ROOT')))
      IF (WORD(ALLKEY,'TRANS=') ) THEN
         WRITE(6,870)NINT(READA(KEYWRD,INDEX(KEYWRD,'TRANS=')))
      ELSEIF (WORD(ALLKEY,'TRANS') ) THEN
         WRITE(6,860)
      ENDIF
      IF (WORD(ALLKEY,'SADDLE') ) THEN
         WRITE(6,880)
         MAXGEO=MAXGEO+1
      ENDIF
      IF (WORD(ALLKEY,' LET') ) WRITE(6,890)
      IF (WORD(ALLKEY,'COMPFG') ) WRITE(6,900)
      IF (WORD(ALLKEY,'DERIV') ) WRITE(6,910)
      IF (WORD(ALLKEY,'FULSCF') ) WRITE(6,920)
      IF (WORD(ALLKEY,'DCART') ) WRITE(6,930)
      IF (WORD(ALLKEY,'GNORM') ) WRITE(6,940)
     1 READA(KEYWRD,INDEX(KEYWRD,'GNORM'))
      IF (WORD(ALLKEY,'FMAT') ) WRITE(6,950)
      IF (WORD(ALLKEY,'HCORE') ) WRITE(6,960)
      IF (WORD(ALLKEY,'ITER') ) WRITE(6,970)
      IF (WORD(ALLKEY,'PULAY') ) WRITE(6,980)
      IF (WORD(ALLKEY,'LINMIN') ) WRITE(6,990)
      IF (WORD(ALLKEY,'LOCMIN') ) THEN
         WRITE(6,1000)
         I=INDEX(KEYWRD,'LOCMIN')
         KEYWRD(I:I+5)='LINMIN'
      ENDIF
      IF (WORD(ALLKEY,' STEP1')  )WRITE(6,1010)
     1 READA(KEYWRD,INDEX(KEYWRD,'STEP1')+6)
      IF (WORD(ALLKEY,' STEP2')  )WRITE(6,1020)
     1 READA(KEYWRD,INDEX(KEYWRD,'STEP2')+6)
      IF (WORD(ALLKEY,'BAR') ) WRITE(6,1030)
     1 READA(KEYWRD,INDEX(KEYWRD,'BAR'))
      IF (WORD(ALLKEY,'DEBUGPULAY') ) WRITE(6,1040)
      IF (WORD(ALLKEY,'CAMP') ) WRITE(6,1050)
      IF (WORD(ALLKEY,'KING') ) WRITE(6,1050)
      IF (WORD(ALLKEY,'EIGS') ) WRITE(6,1060)
      IF (WORD(ALLKEY,'MOLDAT') ) WRITE(6,1070)
      IF (WORD(ALLKEY,'HYPERF') ) WRITE(6,1080)
      IF (WORD(ALLKEY,'OPCI') ) WRITE(6,1090)
      IF (WORD(ALLKEY,' PL') ) WRITE(6,1100)
      IF (WORD(ALLKEY,'SEARCH') ) THEN
         WRITE(6,1110)
         I=INDEX(KEYWRD,'SEARCH')
         KEYWRD(I:I+5)='LINMIN'
      ENDIF
      IF (WORD(ALLKEY,'CYCLES') ) WRITE(6,1130)
     1 NINT(READA(KEYWRD,INDEX(KEYWRD,'CYCLES')))
      IF (WORD(ALLKEY,'FILL') ) WRITE(6,1120)
     1 NINT(READA(KEYWRD,INDEX(KEYWRD,'FILL')))
      IF (WORD(ALLKEY,'ITRY') ) WRITE(6,1160)
     1 NINT(READA(KEYWRD,INDEX(KEYWRD,'ITRY')))
      IF (WORD(ALLKEY,'0SCF') ) WRITE(6,1180)
      IF(UHF)THEN
         IF(BIRAD.OR.EXCI.OR.CI)THEN
            WRITE(6,'(//10X,
     1'' UHF USED WITH EITHER BIRAD, EXCITED OR C.I. '')')
            WRITE(6,1170)
            GOTO 60
         ENDIF
      ELSE
         IF(EXCI.AND. TRIP) THEN
            WRITE(6,'(//10X,'' EXCITED USED WITH TRIPLET'')')
            WRITE(6,1170)
            GOTO 60
         ENDIF
      ENDIF
      IF (INDEX(KEYWRD,'T-PRIO').NE.0.AND.
     1INDEX(KEYWRD,'DRC').EQ.0) THEN
         WRITE (6,'(//10X,''T-PRIO AND NO DRC'')')
         WRITE (6,1170)
         GOTO 60
      ENDIF
      IF ( METHOD .GT. 1) THEN
         WRITE(6,'(//10X,
     1'' ONLY ONE OF MINDO, MNDO, AM1 AND PM3 ALLOWED'')')
         WRITE (6,1170)
         GOTO 60
      ENDIF
      IF (WORD(ALLKEY,'THERMO') )THEN
         WRITE(6,1140)
         IF(WORD(ALLKEY,' ROT')) THEN
            WRITE(6,1150)NINT(READA(KEYWRD,INDEX(KEYWRD,' ROT')))
         ELSE
            WRITE(6,'
     1    (//10X,'' YOU MUST SUPPLY THE SYMMETRY NUMBER "ROT"'')')
            CALL WRAPUP()
         ENDIF
      ENDIF
      IF(MAXGEO.GT.1)THEN
         WRITE(6,'(//10X,''MORE THAN ONE GEOMETRY OPTION HAS BEEN '',
     1''SPECIFIED'',/10X,
     2''CONFLICT MUST BE RESOLVED BEFORE JOB WILL RUN'')')
         CALL WRAPUP()
      ENDIF
      IF(ALLKEY.NE.' ')THEN
C
C  AN UNRECOGNIZED KEY-WORD HAS BEEN USED. FIND IT AND THEN ABANDON THE
C  RUN
         J=0
         DO 50 I=1,79
            IF(ALLKEY(I:I).NE.' '.OR.ALLKEY(I:I+1).NE.'  ')THEN
               J=J+1
               KEYWRD(J:J)=ALLKEY(I:I)
            ENDIF
   50    CONTINUE
         IF(ALLKEY(80:80).NE.' ')THEN
            J=J+1
            KEYWRD(J:J)=ALLKEY(80:80)
         ENDIF
         J=MAX(1,J)
         WRITE(6,'(///10X,''UNRECOGNIZED KEY-WORDS: ('',A,'')'')')
     1KEYWRD(:J)
         WRITE(6,'(///10X,''CALCULATION STOPPED TO AVOID WASTING TIME.''
     1)')
         CALL WRAPUP()
      ENDIF
      RETURN
   60 WRITE(6,'(//10X,'' CALCULATION ABANDONED, SORRY!'')')
      CALL WRAPUP()
   70 FORMAT(' *  VECTORS  - FINAL EIGENVECTORS TO BE PRINTED')
   80 FORMAT(' *  EXTERNAL - USE ATOMIC PARAMETERS FROM THE FOLLOWING '
     1,'FILE',/15X,A)
   90 FORMAT(' *  DENSITY  - FINAL DENSITY MATRIX TO BE PRINTED')
  100 FORMAT(' *  SPIN     - FINAL UHF SPIN MATRIX TO BE PRINTED')
  110 FORMAT(' *  DEPVAR=N - SPECIFIED DISTANCE IS',F7.4,
     1' TIMES BOND LENGTH')
  120 FORMAT(' *  DEP      - OUTPUT FORTRAN CODE FOR BLOCK-DATA')
  130 FORMAT(' *  VELOCITY - INPUT STARTING VELOCITIES FOR DRC')
  140 FORMAT(' *  TIMES    - TIMES OF VARIOUS STAGES TO BE PRINTED')
  150 FORMAT(' *  PARASOK  - USE SOME MNDO PARAMETERS IN AN AM1 CALCULA'
     1,'TION')
  160 FORMAT(' *  FLEPO    - PRINT DETAILS OF GEOMETRY OPTIMISATION')
  170 FORMAT(' *  BONDS    - FINAL BOND-ORDER MATRIX TO BE PRINTED')
  180 FORMAT(' *  GEO-OK   - OVERRIDE INTERATOMIC DISTANCE CHECK')
  190 FORMAT(' *  FOCK     - LAST FOCK MATRIX TO BE PRINTED')
  200 FORMAT(' *  LARGE    - EXPANDED OUTPUT TO BE PRINTED')
  210 FORMAT(' *  S1978    - 1978 SULFUR PARAMETERS TO BE USED')
  220 FORMAT(' *  SI1978   - 1978 SILICON PARAMETERS TO BE USED')
  230 FORMAT(' *  GRAPH    - GENERATE FILE FOR GRAPHICS')
  240 FORMAT(' *  1ELECTRON- FINAL ONE-ELECTRON MATRIX TO BE PRINTED')
  250 FORMAT(' *  ESR      - RHF SPIN DENSITY CALCULATION REQUESTED')
  260 FORMAT(' *  NOMM     - DO NOT MAKE MM CORRECTION TO CONH BARRIER')
  265 FORMAT(' *  MMOK     - APPLY MM CORRECTION TO CONH BARRIER')
  270 FORMAT(' *  INTERP   - PRINT DETAILS OF CAMP-KING CONVERGER')
  280 FORMAT(' *  DFP      - USE DAVIDON FLETCHER POWELL OPTIMIZER')
  290 FORMAT(' *  ANALYT   - USE ANALYTIC DERIVATIVES ')
  300 FORMAT(' *  MECI     - M.E.C.I. WORKING TO BE PRINTED')
  310 FORMAT(' *  DRC      - DYNAMIC REACTION COORDINATE CALCULATION')
  320 FORMAT(' *  DRC=     - HALF-LIFE FOR KINETIC ENERGY LOSS =',F9.2,
     1' * 10**(-14) SECONDS')
  330 FORMAT(' *  KINETIC= - ',F7.3,' KCAL KINETIC ENERGY ADDED TO DRC')
  340 FORMAT(' *  LOCALIZE - LOCALIZED ORBITALS TO BE PRINTED')
  350 FORMAT(' *  MULLIK   - THE MULLIKEN ANALYSIS TO BE PERFORMED')
  360 FORMAT(' *   XYZ     - CARTESIAN COORDINATE SYSTEM TO BE USED')
  370 FORMAT(' *   PI      - BONDS MATRIX, SPLIT INTO SIGMA-PI-DELL',
     1' COMPONENTS, TO BE PRINTED')
  380 FORMAT(' *  ECHO     - ALL INPUT DATA TO BE ECHOED BEFORE RUN')
  390 FORMAT(' *  H-PRIOR  - HEAT OF FORMATION TAKES PRIORITY IN DRC')
  400 FORMAT(' *  X-PRIOR  - GEOMETRY CHANGES TAKE PRIORITY IN DRC')
  410 FORMAT(' *  T-PRIOR  - TIME TAKES PRIORITY IN DRC')
  420 FORMAT(' *  POWSQ    - PRINT DETAILS OF WORKING IN POWSQ')
  430 FORMAT(' *  POLAR    - CALCULATE FIRST, SECOND AND THIRD-ORDER'
     1,' POLARIZABILITIES')
  440 FORMAT(' *  DEBUG    - DEBUG OPTION TURNED ON')
  450 FORMAT(' *  RESTART  - CALCULATION RESTARTED')
  460 FORMAT(' *  IRC=N    - INTRINSIC REACTION COORDINATE',I3,
     1' DEFINED')
  470 FORMAT(' *  IRC      - INTRINSIC REACTION COORDINATE CALCULATION')
  480 FORMAT(3(' *',/),' *',15X,'  CHARGE ON SYSTEM =',I3,3(/,' *'))
  490 FORMAT(' *  GRADIENTS- ALL GRADIENTS TO BE PRINTED')
  500 FORMAT(' *  UHF      - UNRESTRICTED HARTREE-FOCK CALCULATION')
  510 FORMAT(' *  SINGLET  - STATE REQUIRED MUST BE A SINGLET')
  520 FORMAT(' *  BIRADICAL- SYSTEM HAS TWO UNPAIRED ELECTRONS')
  530 FORMAT(' *  EXCITED  - FIRST EXCITED STATE IS TO BE OPTIMIZED')
  540 FORMAT(' *  SINGLET  - SPIN STATE DEFINED AS A SINGLET')
  550 FORMAT(' *  DOUBLET  - SPIN STATE DEFINED AS A DOUBLET')
  560 FORMAT(' *  TRIPLET  - SPIN STATE DEFINED AS A TRIPLET')
  570 FORMAT(' *  QUARTET  - SPIN STATE DEFINED AS A QUARTET')
  580 FORMAT(' *  QUINTET  - SPIN STATE DEFINED AS A QUINTET')
  590 FORMAT(' *  SEXTET   - SPIN STATE DEFINED AS A SEXTET')
  600 FORMAT(' *  SYMMETRY - SYMMETRY CONDITIONS TO BE IMPOSED')
  610 FORMAT(' *  MICROS=N -',I4,' MICROSTATES TO BE SUPPLIED FOR C.I.')
  620 FORMAT(' *  OPEN(N,N)- THERE ARE',I2,' ELECTRONS IN',I2,' LEVELS')
  630 FORMAT(' *   T=      - A TIME OF',F8.1,' ',A7,' REQUESTED')
  640 FORMAT(' *   T=      - A TIME OF',G11.3,' ',A7,' REQUESTED')
  650 FORMAT(' *  DUMP=N   - RESTART FILE WRITTEN EVERY',F8.1,
     1' ',A7)
  660 FORMAT(' *  DUMP=N   - RESTART FILE WRITTEN EVERY',G11.3,
     1' ',A7)
  670 FORMAT(' *  1SCF     - DO 1 SCF AND THEN STOP ')
  680 FORMAT(' *  C.I.=N   -',I2,' M.O.S TO BE USED IN C.I.')
  690 FORMAT(' *  DFORCE   - PRINT HESSIAN MATRIX IN FORCE')
  700 FORMAT(' *  FORCE    - FORCE CALCULATION SPECIFIED')
  710 FORMAT(' *  MINDO/3  - THE MINDO/3 HAMILTONIAN TO BE USED')
  720 FORMAT(' *  AM1      - THE AM1 HAMILTONIAN TO BE USED')
  730 FORMAT(' *  PM3      - THE PM3 HAMILTONIAN TO BE USED')
  740 FORMAT(' *  PRECISE  - CRITERIA TO BE INCREASED BY 100 TIMES')
  750 FORMAT(' *  NOINTER  - INTERATOMIC DISTANCES NOT TO BE PRINTED')
  760 FORMAT(' *  ISOTOPE  - FORCE MATRIX WRITTEN TO DISK (CHAN. 9 )')
  770 FORMAT(' *  DENOUT   - DENSITY MATRIX OUTPUT ON CHANNEL 10')
  780 FORMAT(' *  SHIFT    - A DAMPING FACTOR OF',F8.2,' DEFINED')
  790 FORMAT(' *  OLDENS   - INITIAL DENSITY MATRIX READ OF DISK')
  800 FORMAT(' *  SCFCRT   - DEFAULT SCF CRITERION REPLACED BY',G12.3)
  810 FORMAT(' *  ENPART   - ENERGY TO BE PARTITIONED INTO COMPONENTS')
  820 FORMAT(' *  NOXYZ    - CARTESIAN COORDINATES NOT TO BE PRINTED')
  830 FORMAT(' *  SIGMA    - GEOMETRY TO BE OPTIMIZED USING SIGMA.')
  840 FORMAT(' *  NLLSQ    - GRADIENTS TO BE MINIMIZED USING NLLSQ.')
  850 FORMAT(' *  ROOT     - IN A C.I. CALCULATION, ROOT',I2,
     1                       ' TO BE OPTIMIZED.')
  860 FORMAT(' *  TRANS    - THE REACTION VIBRATION TO BE DELETED FROM',
     1' THE THERMO CALCULATION')
  870 FORMAT(' *  TRANS=   - ',I4,' VIBRATIONS ARE TO BE DELETED FROM',
     1' THE THERMO CALCULATION')
  880 FORMAT(' *  SADDLE   - TRANSITION STATE TO BE OPTIMIZED')
  890 FORMAT(' *   LET     - OVERRIDE SOME SAFETY CHECKS')
  900 FORMAT(' *  COMPFG   - PRINT HEAT OF FORMATION CALC''D IN COMPFG')
  910 FORMAT(' *  DERIV    - PRINT PART OF WORKING IN SUB. DERIV')
  920 FORMAT(' *  FULSCF   - IN SEARCHES, FULL SCF CALCN''S TO BE DONE')
  930 FORMAT(' *  DCART    - PRINT DETAILS OF WORKING IN DCART')
  940 FORMAT(' *  GNORM=   - EXIT WHEN GRADIENT NORM DROPS BELOW ',G8.3)
  950 FORMAT(' *  FMAT     - PRINT DETAILS OF WORKING IN FMAT')
  960 FORMAT(' *  HCORE    - PRINT DETAILS OF WORKING IN HCORE')
  970 FORMAT(' *  ITER     - PRINT DETAILS OF WORKING IN ITER')
  980 FORMAT(' *  PULAY    - PULAY''S METHOD TO BE USED IN SCF')
  990 FORMAT(' *  LINMIN   - PRINT DETAILS OF LINE MINIMIZATION')
 1000 FORMAT(' *  LOCMIN   - USE LINMIN INSTEAD OF THIS KEYWORD')
 1010 FORMAT(' *  STEP1    - FIRST  STEP-SIZE IN GRID =',F7.2)
 1020 FORMAT(' *  STEP2    - SECOND STEP-SIZE IN GRID =',F7.2)
 1030 FORMAT(' *  BAR=     - REDUCE BAR LENGTH BY A MAX. OF',F7.2)
 1040 FORMAT(' *  DEBUGPULAY-PRINT DETAILS OF WORKING IN PULAY')
 1050 FORMAT(' *  CAMP,KING- THE CAMP-KING CONVERGER TO BE USED')
 1060 FORMAT(' *  EIGS     - PRINT ALL EIGENVALUES IN ITER')
 1070 FORMAT(' *  MOLDAT   - PRINT DETAILS OF WORKING IN MOLDAT')
 1080 FORMAT(' *  HYPERFINE- HYPERFINE COUPLING CONSTANTS TO BE'
     1,' PRINTED')
 1090 FORMAT(' *  OPCI     - PRINT DETAILS OF WORKING IN OPCI')
 1100 FORMAT(' *   PL      - MONITOR CONVERGANCE IN DENSITY MATRIX')
 1110 FORMAT(' *  SEARCH   - USE LINMIN INSTEAD OF THIS KEYWORD')
 1120 FORMAT(' *  FILL=    - IN RHF CLOSED SHELL, FORCE M.O.',I3,' TO BE
     1 FILLED')
 1130 FORMAT(' *  CYCLES=  - DO A MAXIMUM OF ',I4,' CYCLES IN NLLSQ')
 1140 FORMAT(' *  THERMO   - THERMODYNAMIC QUANTITIES TO BE CALCULATED')
 1150 FORMAT(' *  ROT      - SYMMETRY NUMBER OF',I3,' SPECIFIED')
 1160 FORMAT(' *  ITRY=    - DO A MAXIMUM OF',I6,' ITERATIONS FOR SCF')
 1170 FORMAT( //10X,' IMPOSSIBLE OPTION REQUESTED,')
 1180 FORMAT(' *  0SCF     - AFTER READING AND PRINTING DATA, STOP')
      END

      DOUBLE PRECISION FUNCTION LIQINF(ALFA,RR,BETA,Y,NY)
      DOUBLE PRECISION ALFA,RR,BETA,Y
      INTEGER NY

      DOUBLE PRECISION PI,HH,A,XX,ALFAR
      DOUBLE PRECISION DSQRT,DLOG
      PARAMETER(PI=3.141592653589793D0)

      ALFAR=PI/180.0D0*ALFA
      HH=DSQRT(2.0D0*(1.0D0-DCOS(ALFAR))+
     +     (DSIN(ALFAR)/(2.0D0*RR))**2.0D0)-
     +     DSIN(ALFAR)/(2.0D0*RR)
      A=0.5D0*(1.0D0+DSIN(ALFAR)/(RR*HH))

      IF (Y**2.0D0 .GT. 2.0D0/A) THEN
         NY=1
         LIQINF=0.0D0
         GOTO 100
      ENDIF

      XX=RR+DSQRT(2.0D0/A-HH**2.0D0)-DSQRT(2.0D0/A-Y**2.0D0)-
     +     1.0D0/DSQRT(2.0D0*A)*DLOG(DABS(Y/HH*
     +     (DSQRT(2.0D0)+DSQRT(2.0D0-A*HH**2.0D0))/
     +     (DSQRT(2.0D0)+DSQRT(2.0D0-A*Y**2.0D0))))

      LIQINF=XX
 100  CONTINUE
      RETURN
      END

C--------------------------------------------------------------------
C
C   S  T  A  R  T  
C
C   START COMPUTES A SEQUENCE OF POINTS NEEDED BY THE INTEGRATION
C   PROCEDURE; THE INTERVAL BETWEEN SUCCESSIVE POINTS IS H DAYS.
C   THE POINTS ARE IMPROVED BY ITERATION UNTIL THE MAXIMUM DIFFERENCE
C   OF ACCELERATIONS OBTAINED IN TWO SUCCESSIVE ITERS IS LESS
C   THAN LIMIT (AU/D**2).
C
C----------------------------------------------------------------------
      SUBROUTINE START(H, LIMIT, ITERS)
      INTEGER
     .    ITERS  
      REAL
     .    H,          
     .    LIMIT     
C
C  CONSTANTS
C
      REAL  PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
      COMMON /CONST/    PI,PI2,CPI,DTORAD,RTODEG,
     .                  GRAVIT,OBLIQ
C
C  
C
      INTEGER MAXOBJ, MAXDAY, MMM, ORDER
      PARAMETER (MAXOBJ=10, MAXDAY=10000, ORDER=7, MMM=3)
      REAL
     .    EPOCH,
     .    SBINC(0:ORDER,0:ORDER),
     .    DD(0:ORDER),
     .    KK(-MMM:MMM,-MMM:MMM),
     .    MASS(MAXOBJ),
     .    COORD(3,MAXOBJ),
     .    VELOC(3,MAXOBJ),
     .    XDIFF(3,MAXOBJ),      
     .    ACCEL(-MMM:MMM,3,MAXOBJ,0:1),
     .    ADIFF(maxobj,0:ORDER,3),  
     .    DISTNC(MAXOBJ,MAXOBJ)        
      INTEGER SWAP
C
      COMMON /INTTAB/    SBINC,DD,KK,
     .                   COORD,VELOC,MASS,
     .                   XDIFF,ACCEL,ADIFF,DISTNC,SWAP,
     .                   EPOCH
C
C  LOCAL VARIABLES
C
      INTEGER I,J,K,T,COUNT
      REAL
     .    SUM,X0,X1,X2,
     .    XX(-MMM:MMM,3,MAXOBJ)
      LOGICAL ITER , OK 
C
C  COMPUTE MUTUAL DISTANCES AT THE INITIAL EPOCH
C
      SWAP=0
      DO 11 I=1,MAXOBJ
         DO 10 J=I+1,MAXOBJ
            X0=COORD(1,I)-COORD(1,J)
            X1=COORD(2,I)-COORD(2,J)
            X2=COORD(3,I)-COORD(3,J)
            DISTNC(I,J)=SQRT(X0*X0+X1*X1+X2*X2)
            DISTNC(J,I)=DISTNC(I,J)
 10      CONTINUE
 11   CONTINUE
C
C  COMPUTE ACCELERATIONS FROM EQUATIONS OF MOTION
C
      DO 22 K=1,3
         DO 21 I=1,MAXOBJ
            SUM=0.0 
            DO 20 J=1,MAXOBJ
               IF (I .NE. J) THEN
                  SUM=SUM+MASS(J)*(COORD(K,J)-COORD(K,I))/
     .                            (DISTNC(I,J)**3)
               ENDIF
 20         CONTINUE
            ACCEL(0,K,I,SWAP)= GRAVIT*SUM
            ACCEL(0,K,I,1-SWAP)= ACCEL(0,K,I,SWAP)
 21      CONTINUE
 22   CONTINUE
C
C  FIRST GUESS OF COORDINATES
C
      DO 32 T=-MMM,MMM
         DO 31 K=1,3
            DO 30 I=1,MAXOBJ
              XX(T,K,I)=COORD(K,I)+H*T*VELOC(K,I)+
     .                             H*H*T*T*ACCEL(0,K,I,SWAP)/2
 30         CONTINUE
 31      CONTINUE
 32   CONTINUE
C
C  ITERATION LOOP BEGINS AT LABEL 40
C  ITERATE UNTIL THE REQUIRED ACCURACY IS OBTAINED 
C
      COUNT=1 
      ITER=.TRUE. 
 40   CONTINUE
C
C  REPEAT THE CALCULATIONS FOR EACH POINT T=-MMM .. -1, +1 .. +MMM
C
         DO 100 T=-MMM,MMM
            IF (T .NE. 0) THEN
C
C  FIND DISTANCES
C
               DO 51 I=1,MAXOBJ
                  DO 50 J=I+1,MAXOBJ
                     X0=XX(T,1,I)-XX(T,1,J)
                     X1=XX(T,2,I)-XX(T,2,J)
                     X2=XX(T,3,I)-XX(T,3,J)
                     DISTNC(I,J)=SQRT(X0*X0+X1*X1+X2*X2) 
                     DISTNC(J,I)=DISTNC(I,J)
 50               CONTINUE
 51            CONTINUE   
C
C  ACCELERATIONS FROM EQUATIONS OF MOTION
C
               DO 62 K=1,3
                  DO 61 I=1,MAXOBJ
                     SUM=0.0
                     DO 60 J=1,MAXOBJ
                        IF (J .NE. I) THEN
                           SUM=SUM+MASS(J)*
     .                         (XX(T,K,J)-XX(T,K,I))/
     .                         (DISTNC(I,J)**3)
                        ENDIF
 60                  CONTINUE 
                     ACCEL(T,K,I,SWAP)=GRAVIT*SUM
 61               CONTINUE
 62            CONTINUE   
            ENDIF
 100     CONTINUE
C
C  UNLESS WE ARE IN THE FIRST ITERATION, COMPUTE DIFFERENCES 
C  OF ACCELERATIONS BETWEEN SUCCESSIVE ITERS
C
         IF (COUNT .GT. 1) THEN
            OK=.TRUE.
            DO 111 T=-MMM,MMM
               DO 110 I=1,MAXOBJ 
                  OK=ABS(ACCEL(T,1,I,SWAP)-ACCEL(T,1,I,1-SWAP))
     .              +ABS(ACCEL(T,2,I,SWAP)-ACCEL(T,2,I,1-SWAP))
     .              +ABS(ACCEL(T,3,I,SWAP)-ACCEL(T,3,I,1-SWAP))
     .              .LE. LIMIT
                  IF (.NOT. OK) GOTO 120
  110          CONTINUE
  111       CONTINUE
  120       ITER=.NOT. OK
         ENDIF 
C
C  CONTINUE ITERATION IF ANY OF THE DIFFERENCES IS TOO LARGE
C
         IF (ITER) THEN
            DO 133 T=-MMM,MMM
               DO 132 K=1,3
                  DO 131 I=1,MAXOBJ
                     SUM=0.0
                     DO 130 J=-MMM,MMM
                        SUM=SUM+KK(T,J)*ACCEL(J,K,I,SWAP)
 130                 CONTINUE
                     XX(T,K,I)=COORD(K,I)+H*T*VELOC(K,I)+H*H*SUM
 131              CONTINUE
 132           CONTINUE 
 133        CONTINUE
            COUNT=COUNT+1
         ENDIF
C 
C
         SWAP = 1-SWAP
      IF (ITER) GOTO 40
      SWAP = 1-SWAP
C
C  ITERATION FINISHED 
C  COMPUTE FINAL DIFFERENCES
C
      DO 142 K=1,3
         DO 141 I=1,MAXOBJ
            COORD(K,I)=XX(MMM,K,I) 
            SUM=0.0
            DO 140 J=-MMM,MMM
               SUM=SUM+(KK(MMM,J)-KK(MMM-1,J))*ACCEL(J,K,I,SWAP)
 140        CONTINUE
            XDIFF(K,I)=H*(VELOC(K,I) + H*SUM) 
 141     CONTINUE
 142  CONTINUE 
      ITERS=COUNT 
      RETURN
      END

      SUBROUTINE FORCE

      IMPLICIT CHARACTER ( A-Z )

      COMMON/COORS/RX,RY,RZ
      COMMON/LSTDAT/LIST,HEAD,MAP
      COMMON/LSTDT2/SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ,MX,MY,MZ
      COMMON/ENERGY/V,K,W
      COMMON/ATOMS/NATM
      COMMON/LJPAR/SIGMA
      COMMON/ESHIFT/VRCUT,DVRCUT,DVRC12
      COMMON/CUTOFF/RCUT
      COMMON/FORCES/FX,FY,FZ

C    *******************************************************************
C    ** ROUTINE TO COMPUTE FORCS AND POTENTIAL USING A LINK LIST     **
C    *******************************************************************

      INTEGER     NMAX, MMX, MMY, MMZ, NCELL, MAPSIZ

      PARAMETER ( NMAX = 60000 )
      PARAMETER ( MMX=50, MMY=50, MMZ=50, NCELL=MMX*MMY*MMZ )
      PARAMETER ( MAPSIZ = 13*NCELL)

      REAL        RX(NMAX), RY(NMAX), RZ(NMAX)
      REAL        FX(NMAX), FY(NMAX), FZ(NMAX)
      REAL        RCUT, SIGMA
      REAL        VRCUT,DVRCUT,DVRC12
      REAL        V,K,W
      REAL        RXI, RYI, RZI, FXIJ, FYIJ, FZIJ, FIJ, RCUTSQ
      REAL        SIGSQ, FXI, FYI, FZI, SR2, SR6, VIJ, WIJ
      REAL        RIJ, RIJSQ, RXIJ, RYIJ, RZIJ
      REAL        SFX,SFY,SFZ,CELLIX,CELLIY,CELLIZ

      LOGICAL     EDGEI, EDGEJ

      INTEGER     HEAD(NCELL), LIST(NMAX), MAP(MAPSIZ), MX, MY,MZ
      INTEGER     ICELL, JCELL0, JCELL, I, J, NABOR, NATM

      SIGSQ  = SIGMA**2
      RCUTSQ = RCUT**2

C    ** ZERO FORCS AND POTENTIAL **
      DO 10 I = 1, NATM
        FX(I) = 0.0
        FY(I) = 0.0
        FZ(I) = 0.0
10      CONTINUE

      V = 0.0
      W = 0.0

C    ** LOOP OVER ALL CELLS **

      DO 5000 ICELL = 1 , MX*MY*MZ

        I = HEAD(ICELL)

C**     TEST TO SEE IF CURRENT CELL IS AN EDGE CELL

        EDGEI=(I.GT.NATM)

C       ** LOOP OVER ALL MOLECULES IN THE CELL **

1000    IF ( I .GT. 0 ) THEN
          RXI = RX(I)
          RYI = RY(I)
          RZI = RZ(I)

C**       IF AN EDGE CELL OMIT FORCE CALCULATIONS BETWEEN ATOMS WITHIN
C**       CURRENT CELL

          IF (EDGEI) GOTO 2200
          FXI = FX(I)
          FYI = FY(I)
          FZI = FZ(I)
C          ** LOOP OVER ALL MOLECULES BELOW I IN THE CURRENT CELL **
          J = LIST(I)
2000      IF ( J .GT. 0 ) THEN
            RXIJ  = RXI-RX(J)
            RYIJ  = RYI-RY(J)
            RZIJ  = RZI-RZ(J)
            RIJSQ = RXIJ*RXIJ+RYIJ*RYIJ+RZIJ*RZIJ
            IF (RIJSQ.LT.RCUTSQ) THEN
              RIJ   = SQRT(RIJSQ)
              SR2   = SIGSQ/RIJSQ
              SR6   = SR2*SR2*SR2
              VIJ   = SR6*(SR6-1.0)-VRCUT-DVRC12*(RIJ-RCUT)
              WIJ   = SR6*(SR6-0.5)+DVRCUT*RIJ
              V     = V+VIJ
              W     = W+WIJ
              FIJ   = WIJ/RIJSQ
              FXIJ  = FIJ*RXIJ
              FYIJ  = FIJ*RYIJ
              FZIJ  = FIJ*RZIJ
              FXI   = FXI+FXIJ
              FYI   = FYI+FYIJ
              FZI   = FZI+FZIJ
              FX(J) = FX(J)-FXIJ
              FY(J) = FY(J)-FYIJ
              FZ(J) = FZ(J)-FZIJ
              ENDIF
            J = LIST(J)
            GO TO 2000
            ENDIF
 2200     CONTINUE

C          ** LOOP OVER NEIGHBOURING CELLS **

        JCELL0 = 13*(ICELL-1)
        DO 4000 NABOR = 1, 13

C             ** LOOP OVER ALL MOLECULES IN NEIGHBOURING CELLS **

          JCELL = MAP(JCELL0+NABOR)
          J = HEAD(JCELL)

C**     TEST TO SEE IF NEIGHBOURING CELL IS AN EDGE CELL

          EDGEJ=(J.GT.NATM)

C**       IF BOTH EDGE CELLS OMIT FORCE CALCULATIONS BETWEEN PAIRS
C**       OF EDGE CELLS

          IF ((EDGEI).AND.(EDGEJ)) GOTO 4000
3000      IF (J.NE.0) THEN
            RXIJ  = RXI-RX(J)
            RYIJ  = RYI-RY(J)
            RZIJ  = RZI-RZ(J)
            RIJSQ = RXIJ*RXIJ+RYIJ*RYIJ+RZIJ*RZIJ
            IF (RIJSQ.LT.RCUTSQ) THEN
              RIJ   = SQRT(RIJSQ)
              SR2   = SIGSQ/RIJSQ
              SR6   = SR2*SR2*SR2
              VIJ   = (SR6*(SR6-1.0)-VRCUT-DVRC12*(RIJ-RCUT))*0.5
              WIJ   = SR6*(SR6-0.5)+DVRCUT*RIJ
              FIJ   = WIJ/RIJSQ
              WIJ   = 0.5*WIJ
              FXIJ  = FIJ*RXIJ
              FYIJ  = FIJ*RYIJ
              FZIJ  = FIJ*RZIJ

C**   IF CURRENT CELL IS NOT AN EDGE CELL SUM FORCES AND POTENTIAL

              IF (.NOT.(EDGEI)) THEN
                V     = V+VIJ
                W     = W+WIJ
                FXI   = FXI+FXIJ
                FYI   = FYI+FYIJ
                FZI   = FZI+FZIJ
                ENDIF

C**   IF NEIGBOURING CELL IS NOT AN EDGE CELL SUM FORCES AND POTENTIAL

              IF (.NOT.(EDGEJ)) THEN
                V     = V+VIJ
                W     = W+WIJ
                FX(J) = FX(J)-FXIJ
                FY(J) = FY(J)-FYIJ
                FZ(J) = FZ(J)-FZIJ
                ENDIF
              ENDIF
            J = LIST(J)
            GO TO 3000
            ENDIF
4000      CONTINUE

C**   IF CURRENT CELL IS NOT AN EDGE CELL RETURN SUMMED FORCES TO ARRAYS

          IF(.NOT.EDGEI)THEN
            FX(I) = FXI
            FY(I) = FYI
            FZ(I) = FZI
            ENDIF
          I = LIST(I)
          GO TO 1000
          ENDIF
5000    CONTINUE

C    ** INCORPORATE ENERGY FACTORS **

      V = 4.0 *V
      W = 48.0*W/3.0

      DO 50 I = 1, NATM
        FX(I) = 48.0*FX(I)
        FY(I) = 48.0*FY(I)
        FZ(I) = 48.0*FZ(I)
50      CONTINUE

      RETURN
      END

      SUBROUTINE FOCK2(F, PTOT, P, W, WJ, WK, NUMAT, NFIRST,
     1NMIDLE, NLAST)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'mopac.inc'
      DIMENSION F(*), PTOT(*), WJ(*), WK(*), NFIRST(*), NMIDLE(*),
     1          NLAST(*), P(*), W(*)
      REAL WJ,WK
C***********************************************************************
C
C FOCK2 FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
C MATRIX
C ON INPUT  PTOT = TOTAL DENSITY MATRIX.
C           P    = ALPHA OR BETA DENSITY MATRIX.
C           W    = TWO-ELECTRON INTEGRAL MATRIX.
C
C  ON OUTPUT F   = PARTIAL FOCK MATRIX
C***********************************************************************
      COMMON /EULER / TVEC(3,3), ID
      COMMON /KEYWRD/ KEYWRD
      DIMENSION SPPOP(NUMATM), DPOP(NUMATM), IFACT(MAXORB),
     1I1FACT(MAXORB)
      CHARACTER*80 KEYWRD
      LOGICAL LID
      DATA ITYPE /1/
   10 CONTINUE
      GOTO (20,170,40) ITYPE
   20 CONTINUE
C
C   SET UP ARRAY OF (I*(I-1))/2
C
      DO 30 I=1,MAXORB
         IFACT(I)=(I*(I-1))/2
   30 I1FACT(I)=IFACT(I)+I
      LID=(ID.EQ.0)
      IONE=1
      IF(ID.NE.0)IONE=0
      IF(INDEX(KEYWRD,'MINDO') .NE. 0) THEN
         ITYPE=2
      ELSE
         ITYPE=3
      ENDIF
      GOTO 10
   40 KK=0
      DO 160 II=1,NUMAT
         IA=NFIRST(II)
         IB=NLAST(II)
         IC=NMIDLE(II)
         SUM=0.D0
         DO 50 I=IA,IC
   50    SUM=SUM+PTOT(I1FACT(I))
         SPPOP(II)=SUM
         SUM=0.D0
         DO 60 I=IC+1,IB
   60    SUM=SUM+PTOT(I1FACT(I))
         DPOP(II)=SUM
         IMINUS=II-IONE
         DO 150 JJ=1,IMINUS
            JA=NFIRST(JJ)
            JB=NLAST(JJ)
            JC=NMIDLE(JJ)
            IF(LID) THEN
               DREP=W(KK+1)
               DO 70 I=IA,IC
                  KA=IFACT(I)
                  DO 70 J=IA,I
                     KB=IFACT(J)
                     IJ=KA+J
                     AA=2.0D00
                     IF (I.EQ.J) AA=1.0D00
                     DO 70 K=JA,JC
                        KC=IFACT(K)
                        IK=KA+K
                        JK=KB+K
                        DO 70 L=JA,K
                           IL=KA+L
                           JL=KB+L
                           KL=KC+L
                           BB=2.0D00
                           IF (K.EQ.L) BB=1.0D00
                           KK=KK+1
                           A=W(KK)
C
C     A  IS THE REPULSION INTEGRAL (I,J/K,L) WHERE ORBITALS I AND J ARE
C     ON ATOM II, AND ORBITALS K AND L ARE ON ATOM JJ.
C     AA AND BB ARE CORRECTION FACTORS SINCE
C     (I,J/K,L)=(J,I/K,L)=(I,J/L,K)=(J,I/L,K)
C     IJ IS THE LOCATION OF THE MATRIX ELEMENTS BETWEEN ATOMIC ORBITALS
C     I AND J.  SIMILARLY FOR IK ETC.
C
C THIS FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
C MATRIX.  THE CODE HERE IS HARD TO FOLLOW, AND IMPOSSIBLE TO MODIFY!,
C BUT IT WORKS,
                           F(IJ)=F(IJ)+BB*A*PTOT(KL)
                           F(KL)=F(KL)+AA*A*PTOT(IJ)
                           A=A*AA*BB*0.25D0
                           F(IK)=F(IK)-A*P(JL)
                           F(IL)=F(IL)-A*P(JK)
                           F(JK)=F(JK)-A*P(IL)
                           F(JL)=F(JL)-A*P(IK)
   70          CONTINUE
            ELSE
               DREP=WJ(KK+1)
               DO 80 I=IA,IC
                  KA=IFACT(I)
                  DO 80 J=IA,I
                     KB=IFACT(J)
                     IJ=KA+J
                     AA=2.0D00
                     IF (I.EQ.J) AA=1.0D00
                     DO 80 K=JA,JC
                        KC=IFACT(K)
                        IF(I.GE.K) THEN
                           IK=KA+K
                        ELSE
                           IK=0
                        ENDIF
                        IF(J.GE.K) THEN
                           JK=KB+K
                        ELSE
                           JK=0
                        ENDIF
                        DO 80 L=JA,K
                           IF(I.GE.L) THEN
                              IL=KA+L
                           ELSE
                              IL=0
                           ENDIF
                           IF(J.GE.L) THEN
                              JL=KB+L
                           ELSE
                              JL=0
                           ENDIF
                           KL=KC+L
                           BB=2.0D00
                           IF (K.EQ.L) BB=1.0D00
                           KK=KK+1
                           AJ=WJ(KK)
                           AK=WK(KK)
C
C     A  IS THE REPULSION INTEGRAL (I,J/K,L) WHERE ORBITALS I AND J ARE
C     ON ATOM II, AND ORBITALS K AND L ARE ON ATOM JJ.
C     AA AND BB ARE CORRECTION FACTORS SINCE
C     (I,J/K,L)=(J,I/K,L)=(I,J/L,K)=(J,I/L,K)
C     IJ IS THE LOCATION OF THE MATRIX ELEMENTS BETWEEN ATOMIC ORBITALS
C     I AND J.  SIMILARLY FOR IK ETC.
C
C THIS FORMS THE TWO-ELECTRON TWO-CENTER REPULSION PART OF THE FOCK
C MATRIX.  THE CODE HERE IS HARD TO FOLLOW, AND IMPOSSIBLE TO MODIFY!,
C BUT IT WORKS,
                           IF(KL.LE.IJ)THEN
                              IF(I.EQ.K.AND.AA+BB.LT.2.1D0)THEN
                                 BB=BB*0.5D0
                                 AA=AA*0.5D0
                                 F(IJ)=F(IJ)+BB*AJ*PTOT(KL)
                                 F(KL)=F(KL)+AA*AJ*PTOT(IJ)
                              ELSE
                                 F(IJ)=F(IJ)+BB*AJ*PTOT(KL)
                                 F(KL)=F(KL)+AA*AJ*PTOT(IJ)
                                 A=AK*AA*BB*0.25D0
                                 F(IK)=F(IK)-A*P(JL)
                                 F(IL)=F(IL)-A*P(JK)
                                 F(JK)=F(JK)-A*P(IL)
                                 F(JL)=F(JL)-A*P(IK)
                              ENDIF
                           ENDIF
   80          CONTINUE
            ENDIF
C
C   D-ORBITAL CORRECTION
C
            DO 90 I=IC+1,IB
               KA=IFACT(I)
               DO 90 J=JA,JB
                  IJ=KA+J
C
C   ATOM J (S, P, AND D (IF PRESENT)) EXCHANGE WITH ATOM I (D ONLY)
C
   90       F(IJ)=F(IJ)-0.5D0*DREP*P(IJ)
            DO 100 I=IA,IC
               KA=IFACT(I)
               DO 100 J=JC+1,JB
                  IJ=KA+J
C
C    ATOM J (D(IF PRESENT)) EXCHANGE WITH ATOM I (S AND P ONLY)
C
  100       F(IJ)=F(IJ)-0.5D0*DREP*P(IJ)
C
C                      THE COULOMB REPULSION TERMS.
C
C     FIRST, ATOM J (S, P AND D SHELLS) BEING REPELLED BY ATOM I(DSHELL)
C
            DO 110 J=JA,JB
               J2=I1FACT(J)
  110       F(J2)=F(J2)+DREP*DPOP(II)
C
C     ATOM J (D SHELL) BEING REPELLED BY ATOM I (S AND P SHELLS)
C
            DO 120 J=JC+1,JB
               J2=I1FACT(J)
  120       F(J2)=F(J2)+DREP*SPPOP(II)
C
C     ATOM I (S, P AND D SHELLS) BEING REPELLED BY ATOM J (D SHELL)
C
            DO 130 I=IA,IB
               I2=I1FACT(I)
  130       F(I2)=F(I2)+DREP*DPOP(JJ)
C
C    ATOM I (D SHELL) BEING REPELLED BY ATOM J (S AND P SHELLS)
C
            DO 140 I=IC+1,IB
               I2=I1FACT(I)
  140       F(I2)=F(I2)+DREP*SPPOP(JJ)
  150    CONTINUE
  160 CONTINUE
C
      RETURN
  170 KR=0
      DO 200 II=1,NUMAT
         IA=NFIRST(II)
         IB=NLAST(II)
         IM1=II-IONE
         DO 190 JJ=1,IM1
            KR=KR+1
            IF(LID)THEN
               ELREP=W(KR)
               ELEXC=ELREP
            ELSE
               ELREP=WJ(KR)
               ELEXC=WK(KR)
            ENDIF
            JA=NFIRST(JJ)
            JB=NLAST(JJ)
            DO 180 I=IA,IB
               KA=IFACT(I)
               KK=KA+I
               DO 180 K=JA,JB
                  LL=I1FACT(K)
                  IK=KA+K
                  F(KK)=F(KK)+PTOT(LL)*ELREP
                  F(LL)=F(LL)+PTOT(KK)*ELREP
  180       F(IK)=F(IK)-P(IK)*ELEXC
  190    CONTINUE
  200 CONTINUE
      RETURN
      END

      SUBROUTINE SOLROT (NI,NJ,XI,XJ,WJ,WK,KR,E1B,E2A,ENUC,CUTOFF)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION XI(3), XJ(3), WJ(100), WK(100), E1B(10), E2A(10)
************************************************************************
*
*   SOLROT FORMS THE TWO-ELECTRON TWO-ATOM J AND K INTEGRAL STRINGS.
*          ON EXIT WJ = "J"-TYPE INTEGRALS
*                  WK = "K"-TYPE INTEGRALS
*
*      FOR MOLECULES, WJ = WK.
************************************************************************
      COMMON /EULER / TVEC(3,3), ID
      COMMON /UCELL / L1L,L2L,L3L,L1U,L2U,L3U
      DIMENSION WSUM(100), WBITS(100), LIMS(3,2), XJUC(3), E1BITS(10),
     1E2BITS(10), WMAX(100)
      LOGICAL FIRST
      EQUIVALENCE (L1L,LIMS(1,1))
      DATA FIRST/.TRUE./
      IF(FIRST)THEN
         FIRST=.FALSE.
         DO 10 I=1,ID
            LIMS(I,1)=-1
   10    LIMS(I,2)= 1
         DO 20 I=ID+1,3
            LIMS(I,1)=0
   20    LIMS(I,2)=0
      ENDIF
      ONE=1.D0
      IF(XI(1).EQ.XJ(1) .AND. XI(2).EQ.XJ(2) .AND. XI(3).EQ. XJ(3))
     1ONE=0.5D0
      DO 30 I=1,100
         WMAX(I)=0.D0
         WSUM(I)=0.D0
   30 WBITS(I)=0.D0
      NEQUAL=1
      DO 40 I=1,10
         E1B(I)=0.D0
   40 E2A(I)=0.D0
      ENUC=0.D0
      DO 90 I=L1L,L1U
         DO 90 J=L2L,L2U
            DO 90 K=L3L,L3U
               DO 50 L=1,3
   50          XJUC(L)=XJ(L)+TVEC(L,1)*I+TVEC(L,2)*J+TVEC(L,3)*K
               KB=1
               CALL ROTATE (NI,NJ,XI,XJUC,WBITS,KB,E1BITS,E2BITS,
     1ENUBIT,CUTOFF)
               KB=KB-1
               DO 60 II=1,KB
   60          WSUM(II)=WSUM(II)+WBITS(II)
               IF(WMAX(1).LT.WBITS(1))THEN
                  DO 70 II=1,KB
   70             WMAX(II)=WBITS(II)
               ENDIF
               DO 80 II=1,10
                  E1B(II)=E1B(II)+E1BITS(II)
   80          E2A(II)=E2A(II)+E2BITS(II)
               ENUC=ENUC+ENUBIT*ONE
   90 CONTINUE
      IF(ONE.LT.0.9D0) THEN
         DO 100 I=1,KB
  100    WMAX(I)=0.D0
      ENDIF
      DO 110 I=1,KB
         WK(I)=WMAX(I)
  110 WJ(I)=WSUM(I)
      KR=KB+KR
      RETURN
      END

      SUBROUTINE CHOTST (ER, FP, TM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C   CHOLSKY TEST PROGRAM
C
      PARAMETER (IDA=250, NMAT=250, M=4, N=40, NRHS=3, F7=78125.,
     $ T30=1073741824.)
      COMMON /ARRAYS/ A(0:IDA, -M:0, 0:N), B(0:NRHS, 0:NMAT, 0:N),
     $   AX(0:IDA, -M:0, 0:N), BX(0:NRHS, 0:NMAT, 0:N)
      DATA  IT/200/, ANS/5177.88531774562/
C
C   INITIALIZE
C
      LA = (IDA+1) * (M+1) * (N+1)
      LB = (NRHS+1) * (NMAT+1) * (N+1)
      T = F7 / T30
      DO 100 K = 0, N
        DO 100 J = -M, 0
          DO 100 I = 0, IDA
            T = MOD (F7 * T, 1.0D0)
            AX(I,J,K) = T
100     CONTINUE
      DO 110 K = 0, N
        DO 110 J = 0, NMAT
          DO 110 I = 0, NRHS
            T = MOD (F7 * T, 1.0D0)
            BX(I,J,K) = T
110   CONTINUE
      TM = CPTIME ()
C
C   BEGIN TIMING TEST
C
      DO 120 J = 1, IT
        CALL COPY (LA, AX, A)
        CALL COPY (LB, BX, B)
        CALL CHOLSKY (IDA, NMAT, M, N, A, NRHS, IDA, B)
120   CONTINUE
C
      TM = CPTIME ()
      ER = ABS ((B(1,19,19) - ANS) / ANS)
      FP = IT * (NMAT + 1) * 4403.
C
      RETURN
      END

#!/bin/sh
# Run script for FREQUENCY
# Date generated:  Thu Dec  8 13:49:19 EET 1994
# For cypress (IRIX64 cypress 6.0 08241804 IP21 mips)
exec > FREQUENCY.out 2>&1
MP_SET_NUMTHREADS=1; export MP_SET_NUMTHREADS
MPC_NUM_THREADS=1; export MPC_NUM_THREADS
CMD=timex
echo 'FREQUENCY'
date
$CMD ./FREQUENCY.exe < FREQUENCY.in
exit $?
